import { TelescopeGeneratedType } from "../../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgSignProviderAttributes, MsgDeleteProviderAttributes } from "./audit";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        signProviderAttributes(value: MsgSignProviderAttributes): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        deleteProviderAttributes(value: MsgDeleteProviderAttributes): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        signProviderAttributes(value: MsgSignProviderAttributes): {
            typeUrl: string;
            value: MsgSignProviderAttributes;
        };
        deleteProviderAttributes(value: MsgDeleteProviderAttributes): {
            typeUrl: string;
            value: MsgDeleteProviderAttributes;
        };
    };
    toJSON: {
        signProviderAttributes(value: MsgSignProviderAttributes): {
            typeUrl: string;
            value: {
                owner: string;
                auditor: string;
                attributes: {
                    key: string;
                    value: string;
                }[];
            };
        };
        deleteProviderAttributes(value: MsgDeleteProviderAttributes): {
            typeUrl: string;
            value: {
                owner: string;
                auditor: string;
                keys: string[];
            };
        };
    };
    fromJSON: {
        signProviderAttributes(value: any): {
            typeUrl: string;
            value: MsgSignProviderAttributes;
        };
        deleteProviderAttributes(value: any): {
            typeUrl: string;
            value: MsgDeleteProviderAttributes;
        };
    };
    fromPartial: {
        signProviderAttributes(value: MsgSignProviderAttributes): {
            typeUrl: string;
            value: MsgSignProviderAttributes;
        };
        deleteProviderAttributes(value: MsgDeleteProviderAttributes): {
            typeUrl: string;
            value: MsgDeleteProviderAttributes;
        };
    };
};
