import { DeliverTxResponse, StdFee, TxRpc } from "../../../types";
import { MsgSignProviderAttributes, MsgDeleteProviderAttributes } from "./audit";
/** Msg defines the provider Msg service */
export interface Msg {
    /** SignProviderAttributes defines a method that signs provider attributes */
    signProviderAttributes(signerAddress: string, message: MsgSignProviderAttributes, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    /** DeleteProviderAttributes defines a method that deletes provider attributes */
    deleteProviderAttributes(signerAddress: string, message: MsgDeleteProviderAttributes, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
}
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    constructor(rpc: TxRpc);
    signProviderAttributes: (signerAddress: string, message: MsgSignProviderAttributes, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    deleteProviderAttributes: (signerAddress: string, message: MsgDeleteProviderAttributes, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
}
export declare const createClientImpl: (rpc: TxRpc) => MsgClientImpl;
