import { Attribute, AttributeAmino, AttributeSDKType } from "../../base/v1beta2/attribute";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.audit.v1beta2";
/** Provider stores owner auditor and attributes details */
export interface Provider {
    owner: string;
    auditor: string;
    attributes: Attribute[];
}
export interface ProviderProtoMsg {
    typeUrl: "/akash.audit.v1beta2.Provider";
    value: Uint8Array;
}
/** Provider stores owner auditor and attributes details */
export interface ProviderAmino {
    owner: string;
    auditor: string;
    attributes: AttributeAmino[];
}
export interface ProviderAminoMsg {
    type: "akash/audit/v1beta2/provider";
    value: ProviderAmino;
}
/** Provider stores owner auditor and attributes details */
export interface ProviderSDKType {
    owner: string;
    auditor: string;
    attributes: AttributeSDKType[];
}
/** Attributes */
export interface AuditedAttributes {
    owner: string;
    auditor: string;
    attributes: Attribute[];
}
export interface AuditedAttributesProtoMsg {
    typeUrl: "/akash.audit.v1beta2.AuditedAttributes";
    value: Uint8Array;
}
/** Attributes */
export interface AuditedAttributesAmino {
    owner: string;
    auditor: string;
    attributes: AttributeAmino[];
}
export interface AuditedAttributesAminoMsg {
    type: "akash/audit/v1beta2/audited-attributes";
    value: AuditedAttributesAmino;
}
/** Attributes */
export interface AuditedAttributesSDKType {
    owner: string;
    auditor: string;
    attributes: AttributeSDKType[];
}
/** AttributesResponse represents details of deployment along with group details */
export interface AttributesResponse {
    attributes: AuditedAttributes[];
}
export interface AttributesResponseProtoMsg {
    typeUrl: "/akash.audit.v1beta2.AttributesResponse";
    value: Uint8Array;
}
/** AttributesResponse represents details of deployment along with group details */
export interface AttributesResponseAmino {
    attributes: AuditedAttributesAmino[];
}
export interface AttributesResponseAminoMsg {
    type: "akash/audit/v1beta2/attributes-response";
    value: AttributesResponseAmino;
}
/** AttributesResponse represents details of deployment along with group details */
export interface AttributesResponseSDKType {
    attributes: AuditedAttributesSDKType[];
}
/** AttributesFilters defines filters used to filter deployments */
export interface AttributesFilters {
    auditors: string[];
    owners: string[];
}
export interface AttributesFiltersProtoMsg {
    typeUrl: "/akash.audit.v1beta2.AttributesFilters";
    value: Uint8Array;
}
/** AttributesFilters defines filters used to filter deployments */
export interface AttributesFiltersAmino {
    auditors: string[];
    owners: string[];
}
export interface AttributesFiltersAminoMsg {
    type: "akash/audit/v1beta2/attributes-filters";
    value: AttributesFiltersAmino;
}
/** AttributesFilters defines filters used to filter deployments */
export interface AttributesFiltersSDKType {
    auditors: string[];
    owners: string[];
}
/** MsgSignProviderAttributes defines an SDK message for signing a provider attributes */
export interface MsgSignProviderAttributes {
    owner: string;
    auditor: string;
    attributes: Attribute[];
}
export interface MsgSignProviderAttributesProtoMsg {
    typeUrl: "/akash.audit.v1beta2.MsgSignProviderAttributes";
    value: Uint8Array;
}
/** MsgSignProviderAttributes defines an SDK message for signing a provider attributes */
export interface MsgSignProviderAttributesAmino {
    owner: string;
    auditor: string;
    attributes: AttributeAmino[];
}
export interface MsgSignProviderAttributesAminoMsg {
    type: "mymessage-testonly";
    value: MsgSignProviderAttributesAmino;
}
/** MsgSignProviderAttributes defines an SDK message for signing a provider attributes */
export interface MsgSignProviderAttributesSDKType {
    owner: string;
    auditor: string;
    attributes: AttributeSDKType[];
}
/** MsgSignProviderAttributesResponse defines the Msg/CreateProvider response type. */
export interface MsgSignProviderAttributesResponse {
}
export interface MsgSignProviderAttributesResponseProtoMsg {
    typeUrl: "/akash.audit.v1beta2.MsgSignProviderAttributesResponse";
    value: Uint8Array;
}
/** MsgSignProviderAttributesResponse defines the Msg/CreateProvider response type. */
export interface MsgSignProviderAttributesResponseAmino {
}
export interface MsgSignProviderAttributesResponseAminoMsg {
    type: "akash/audit/v1beta2/testonly-sign-provider-attributes-response";
    value: MsgSignProviderAttributesResponseAmino;
}
/** MsgSignProviderAttributesResponse defines the Msg/CreateProvider response type. */
export interface MsgSignProviderAttributesResponseSDKType {
}
/** MsgDeleteProviderAttributes defined the Msg/DeleteProviderAttributes */
export interface MsgDeleteProviderAttributes {
    owner: string;
    auditor: string;
    keys: string[];
}
export interface MsgDeleteProviderAttributesProtoMsg {
    typeUrl: "/akash.audit.v1beta2.MsgDeleteProviderAttributes";
    value: Uint8Array;
}
/** MsgDeleteProviderAttributes defined the Msg/DeleteProviderAttributes */
export interface MsgDeleteProviderAttributesAmino {
    owner: string;
    auditor: string;
    keys: string[];
}
export interface MsgDeleteProviderAttributesAminoMsg {
    type: "akash/audit/v1beta2/testonly-delete-provider-attributes";
    value: MsgDeleteProviderAttributesAmino;
}
/** MsgDeleteProviderAttributes defined the Msg/DeleteProviderAttributes */
export interface MsgDeleteProviderAttributesSDKType {
    owner: string;
    auditor: string;
    keys: string[];
}
/** MsgDeleteProviderAttributesResponse defines the Msg/ProviderAttributes response type. */
export interface MsgDeleteProviderAttributesResponse {
}
export interface MsgDeleteProviderAttributesResponseProtoMsg {
    typeUrl: "/akash.audit.v1beta2.MsgDeleteProviderAttributesResponse";
    value: Uint8Array;
}
/** MsgDeleteProviderAttributesResponse defines the Msg/ProviderAttributes response type. */
export interface MsgDeleteProviderAttributesResponseAmino {
}
export interface MsgDeleteProviderAttributesResponseAminoMsg {
    type: "akash/audit/v1beta2/testonly-delete-provider-attributes-response";
    value: MsgDeleteProviderAttributesResponseAmino;
}
/** MsgDeleteProviderAttributesResponse defines the Msg/ProviderAttributes response type. */
export interface MsgDeleteProviderAttributesResponseSDKType {
}
export declare const Provider: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is Provider;
    isSDK(o: any): o is ProviderSDKType;
    isAmino(o: any): o is ProviderAmino;
    encode(message: Provider, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Provider;
    fromJSON(object: any): Provider;
    toJSON(message: Provider): JsonSafe<Provider>;
    fromPartial<I extends Exact<DeepPartial<Provider>, I>>(object: I): Provider;
    fromSDK(object: ProviderSDKType): Provider;
    fromSDKJSON(object: any): ProviderSDKType;
    toSDK(message: Provider): ProviderSDKType;
    fromAmino(object: ProviderAmino): Provider;
    toAmino(message: Provider): ProviderAmino;
    fromAminoMsg(object: ProviderAminoMsg): Provider;
    toAminoMsg(message: Provider): ProviderAminoMsg;
    fromProtoMsg(message: ProviderProtoMsg): Provider;
    toProto(message: Provider): Uint8Array;
    toProtoMsg(message: Provider): ProviderProtoMsg;
    registerTypeUrl(): void;
};
export declare const AuditedAttributes: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is AuditedAttributes;
    isSDK(o: any): o is AuditedAttributesSDKType;
    isAmino(o: any): o is AuditedAttributesAmino;
    encode(message: AuditedAttributes, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): AuditedAttributes;
    fromJSON(object: any): AuditedAttributes;
    toJSON(message: AuditedAttributes): JsonSafe<AuditedAttributes>;
    fromPartial<I extends Exact<DeepPartial<AuditedAttributes>, I>>(object: I): AuditedAttributes;
    fromSDK(object: AuditedAttributesSDKType): AuditedAttributes;
    fromSDKJSON(object: any): AuditedAttributesSDKType;
    toSDK(message: AuditedAttributes): AuditedAttributesSDKType;
    fromAmino(object: AuditedAttributesAmino): AuditedAttributes;
    toAmino(message: AuditedAttributes): AuditedAttributesAmino;
    fromAminoMsg(object: AuditedAttributesAminoMsg): AuditedAttributes;
    toAminoMsg(message: AuditedAttributes): AuditedAttributesAminoMsg;
    fromProtoMsg(message: AuditedAttributesProtoMsg): AuditedAttributes;
    toProto(message: AuditedAttributes): Uint8Array;
    toProtoMsg(message: AuditedAttributes): AuditedAttributesProtoMsg;
    registerTypeUrl(): void;
};
export declare const AttributesResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is AttributesResponse;
    isSDK(o: any): o is AttributesResponseSDKType;
    isAmino(o: any): o is AttributesResponseAmino;
    encode(message: AttributesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): AttributesResponse;
    fromJSON(object: any): AttributesResponse;
    toJSON(message: AttributesResponse): JsonSafe<AttributesResponse>;
    fromPartial<I extends Exact<DeepPartial<AttributesResponse>, I>>(object: I): AttributesResponse;
    fromSDK(object: AttributesResponseSDKType): AttributesResponse;
    fromSDKJSON(object: any): AttributesResponseSDKType;
    toSDK(message: AttributesResponse): AttributesResponseSDKType;
    fromAmino(object: AttributesResponseAmino): AttributesResponse;
    toAmino(message: AttributesResponse): AttributesResponseAmino;
    fromAminoMsg(object: AttributesResponseAminoMsg): AttributesResponse;
    toAminoMsg(message: AttributesResponse): AttributesResponseAminoMsg;
    fromProtoMsg(message: AttributesResponseProtoMsg): AttributesResponse;
    toProto(message: AttributesResponse): Uint8Array;
    toProtoMsg(message: AttributesResponse): AttributesResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const AttributesFilters: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is AttributesFilters;
    isSDK(o: any): o is AttributesFiltersSDKType;
    isAmino(o: any): o is AttributesFiltersAmino;
    encode(message: AttributesFilters, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): AttributesFilters;
    fromJSON(object: any): AttributesFilters;
    toJSON(message: AttributesFilters): JsonSafe<AttributesFilters>;
    fromPartial<I extends Exact<DeepPartial<AttributesFilters>, I>>(object: I): AttributesFilters;
    fromSDK(object: AttributesFiltersSDKType): AttributesFilters;
    fromSDKJSON(object: any): AttributesFiltersSDKType;
    toSDK(message: AttributesFilters): AttributesFiltersSDKType;
    fromAmino(object: AttributesFiltersAmino): AttributesFilters;
    toAmino(message: AttributesFilters): AttributesFiltersAmino;
    fromAminoMsg(object: AttributesFiltersAminoMsg): AttributesFilters;
    toAminoMsg(message: AttributesFilters): AttributesFiltersAminoMsg;
    fromProtoMsg(message: AttributesFiltersProtoMsg): AttributesFilters;
    toProto(message: AttributesFilters): Uint8Array;
    toProtoMsg(message: AttributesFilters): AttributesFiltersProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgSignProviderAttributes: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgSignProviderAttributes;
    isSDK(o: any): o is MsgSignProviderAttributesSDKType;
    isAmino(o: any): o is MsgSignProviderAttributesAmino;
    encode(message: MsgSignProviderAttributes, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgSignProviderAttributes;
    fromJSON(object: any): MsgSignProviderAttributes;
    toJSON(message: MsgSignProviderAttributes): JsonSafe<MsgSignProviderAttributes>;
    fromPartial<I extends Exact<DeepPartial<MsgSignProviderAttributes>, I>>(object: I): MsgSignProviderAttributes;
    fromSDK(object: MsgSignProviderAttributesSDKType): MsgSignProviderAttributes;
    fromSDKJSON(object: any): MsgSignProviderAttributesSDKType;
    toSDK(message: MsgSignProviderAttributes): MsgSignProviderAttributesSDKType;
    fromAmino(object: MsgSignProviderAttributesAmino): MsgSignProviderAttributes;
    toAmino(message: MsgSignProviderAttributes): MsgSignProviderAttributesAmino;
    fromAminoMsg(object: MsgSignProviderAttributesAminoMsg): MsgSignProviderAttributes;
    toAminoMsg(message: MsgSignProviderAttributes): MsgSignProviderAttributesAminoMsg;
    fromProtoMsg(message: MsgSignProviderAttributesProtoMsg): MsgSignProviderAttributes;
    toProto(message: MsgSignProviderAttributes): Uint8Array;
    toProtoMsg(message: MsgSignProviderAttributes): MsgSignProviderAttributesProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgSignProviderAttributesResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgSignProviderAttributesResponse;
    isSDK(o: any): o is MsgSignProviderAttributesResponseSDKType;
    isAmino(o: any): o is MsgSignProviderAttributesResponseAmino;
    encode(_: MsgSignProviderAttributesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgSignProviderAttributesResponse;
    fromJSON(_: any): MsgSignProviderAttributesResponse;
    toJSON(_: MsgSignProviderAttributesResponse): JsonSafe<MsgSignProviderAttributesResponse>;
    fromPartial<I extends Exact<DeepPartial<MsgSignProviderAttributesResponse>, I>>(_: I): MsgSignProviderAttributesResponse;
    fromSDK(_: MsgSignProviderAttributesResponseSDKType): MsgSignProviderAttributesResponse;
    fromSDKJSON(_: any): MsgSignProviderAttributesResponseSDKType;
    toSDK(_: MsgSignProviderAttributesResponse): MsgSignProviderAttributesResponseSDKType;
    fromAmino(_: MsgSignProviderAttributesResponseAmino): MsgSignProviderAttributesResponse;
    toAmino(_: MsgSignProviderAttributesResponse): MsgSignProviderAttributesResponseAmino;
    fromAminoMsg(object: MsgSignProviderAttributesResponseAminoMsg): MsgSignProviderAttributesResponse;
    toAminoMsg(message: MsgSignProviderAttributesResponse): MsgSignProviderAttributesResponseAminoMsg;
    fromProtoMsg(message: MsgSignProviderAttributesResponseProtoMsg): MsgSignProviderAttributesResponse;
    toProto(message: MsgSignProviderAttributesResponse): Uint8Array;
    toProtoMsg(message: MsgSignProviderAttributesResponse): MsgSignProviderAttributesResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgDeleteProviderAttributes: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgDeleteProviderAttributes;
    isSDK(o: any): o is MsgDeleteProviderAttributesSDKType;
    isAmino(o: any): o is MsgDeleteProviderAttributesAmino;
    encode(message: MsgDeleteProviderAttributes, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgDeleteProviderAttributes;
    fromJSON(object: any): MsgDeleteProviderAttributes;
    toJSON(message: MsgDeleteProviderAttributes): JsonSafe<MsgDeleteProviderAttributes>;
    fromPartial<I extends Exact<DeepPartial<MsgDeleteProviderAttributes>, I>>(object: I): MsgDeleteProviderAttributes;
    fromSDK(object: MsgDeleteProviderAttributesSDKType): MsgDeleteProviderAttributes;
    fromSDKJSON(object: any): MsgDeleteProviderAttributesSDKType;
    toSDK(message: MsgDeleteProviderAttributes): MsgDeleteProviderAttributesSDKType;
    fromAmino(object: MsgDeleteProviderAttributesAmino): MsgDeleteProviderAttributes;
    toAmino(message: MsgDeleteProviderAttributes): MsgDeleteProviderAttributesAmino;
    fromAminoMsg(object: MsgDeleteProviderAttributesAminoMsg): MsgDeleteProviderAttributes;
    toAminoMsg(message: MsgDeleteProviderAttributes): MsgDeleteProviderAttributesAminoMsg;
    fromProtoMsg(message: MsgDeleteProviderAttributesProtoMsg): MsgDeleteProviderAttributes;
    toProto(message: MsgDeleteProviderAttributes): Uint8Array;
    toProtoMsg(message: MsgDeleteProviderAttributes): MsgDeleteProviderAttributesProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgDeleteProviderAttributesResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgDeleteProviderAttributesResponse;
    isSDK(o: any): o is MsgDeleteProviderAttributesResponseSDKType;
    isAmino(o: any): o is MsgDeleteProviderAttributesResponseAmino;
    encode(_: MsgDeleteProviderAttributesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgDeleteProviderAttributesResponse;
    fromJSON(_: any): MsgDeleteProviderAttributesResponse;
    toJSON(_: MsgDeleteProviderAttributesResponse): JsonSafe<MsgDeleteProviderAttributesResponse>;
    fromPartial<I extends Exact<DeepPartial<MsgDeleteProviderAttributesResponse>, I>>(_: I): MsgDeleteProviderAttributesResponse;
    fromSDK(_: MsgDeleteProviderAttributesResponseSDKType): MsgDeleteProviderAttributesResponse;
    fromSDKJSON(_: any): MsgDeleteProviderAttributesResponseSDKType;
    toSDK(_: MsgDeleteProviderAttributesResponse): MsgDeleteProviderAttributesResponseSDKType;
    fromAmino(_: MsgDeleteProviderAttributesResponseAmino): MsgDeleteProviderAttributesResponse;
    toAmino(_: MsgDeleteProviderAttributesResponse): MsgDeleteProviderAttributesResponseAmino;
    fromAminoMsg(object: MsgDeleteProviderAttributesResponseAminoMsg): MsgDeleteProviderAttributesResponse;
    toAminoMsg(message: MsgDeleteProviderAttributesResponse): MsgDeleteProviderAttributesResponseAminoMsg;
    fromProtoMsg(message: MsgDeleteProviderAttributesResponseProtoMsg): MsgDeleteProviderAttributesResponse;
    toProto(message: MsgDeleteProviderAttributesResponse): Uint8Array;
    toProtoMsg(message: MsgDeleteProviderAttributesResponse): MsgDeleteProviderAttributesResponseProtoMsg;
    registerTypeUrl(): void;
};
