import { MsgSignProviderAttributes, MsgDeleteProviderAttributes } from "./audit";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* SignProviderAttributes defines a method that signs provider attributes */
    signProviderAttributes = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgSignProviderAttributes.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* DeleteProviderAttributes defines a method that deletes provider attributes */
    deleteProviderAttributes = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgDeleteProviderAttributes.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
