import { PageRequest, PageRequestAmino, PageRequestSDKType, PageResponse, PageResponseAmino, PageResponseSDKType } from "../../../cosmos/base/query/v1beta1/pagination";
import { Provider, ProviderAmino, ProviderSDKType } from "./audit";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.audit.v1beta2";
/** QueryProvidersResponse is response type for the Query/Providers RPC method */
export interface QueryProvidersResponse {
    providers: Provider[];
    pagination?: PageResponse;
}
export interface QueryProvidersResponseProtoMsg {
    typeUrl: "/akash.audit.v1beta2.QueryProvidersResponse";
    value: Uint8Array;
}
/** QueryProvidersResponse is response type for the Query/Providers RPC method */
export interface QueryProvidersResponseAmino {
    providers?: ProviderAmino[];
    pagination?: PageResponseAmino;
}
export interface QueryProvidersResponseAminoMsg {
    type: "akash/audit/v1beta2/query-providers-response";
    value: QueryProvidersResponseAmino;
}
/** QueryProvidersResponse is response type for the Query/Providers RPC method */
export interface QueryProvidersResponseSDKType {
    providers: ProviderSDKType[];
    pagination?: PageResponseSDKType;
}
/** QueryProviderRequest is request type for the Query/Provider RPC method */
export interface QueryProviderRequest {
    auditor: string;
    owner: string;
}
export interface QueryProviderRequestProtoMsg {
    typeUrl: "/akash.audit.v1beta2.QueryProviderRequest";
    value: Uint8Array;
}
/** QueryProviderRequest is request type for the Query/Provider RPC method */
export interface QueryProviderRequestAmino {
    auditor?: string;
    owner?: string;
}
export interface QueryProviderRequestAminoMsg {
    type: "akash/audit/v1beta2/query-provider-request";
    value: QueryProviderRequestAmino;
}
/** QueryProviderRequest is request type for the Query/Provider RPC method */
export interface QueryProviderRequestSDKType {
    auditor: string;
    owner: string;
}
/** QueryAllProvidersAttributesRequest is request type for the Query/All Providers RPC method */
export interface QueryAllProvidersAttributesRequest {
    pagination?: PageRequest;
}
export interface QueryAllProvidersAttributesRequestProtoMsg {
    typeUrl: "/akash.audit.v1beta2.QueryAllProvidersAttributesRequest";
    value: Uint8Array;
}
/** QueryAllProvidersAttributesRequest is request type for the Query/All Providers RPC method */
export interface QueryAllProvidersAttributesRequestAmino {
    pagination?: PageRequestAmino;
}
export interface QueryAllProvidersAttributesRequestAminoMsg {
    type: "akash/audit/v1beta2/query-all-providers-attributes-request";
    value: QueryAllProvidersAttributesRequestAmino;
}
/** QueryAllProvidersAttributesRequest is request type for the Query/All Providers RPC method */
export interface QueryAllProvidersAttributesRequestSDKType {
    pagination?: PageRequestSDKType;
}
/** QueryProviderAttributesRequest is request type for the Query/Provider RPC method */
export interface QueryProviderAttributesRequest {
    owner: string;
    pagination?: PageRequest;
}
export interface QueryProviderAttributesRequestProtoMsg {
    typeUrl: "/akash.audit.v1beta2.QueryProviderAttributesRequest";
    value: Uint8Array;
}
/** QueryProviderAttributesRequest is request type for the Query/Provider RPC method */
export interface QueryProviderAttributesRequestAmino {
    owner?: string;
    pagination?: PageRequestAmino;
}
export interface QueryProviderAttributesRequestAminoMsg {
    type: "akash/audit/v1beta2/query-provider-attributes-request";
    value: QueryProviderAttributesRequestAmino;
}
/** QueryProviderAttributesRequest is request type for the Query/Provider RPC method */
export interface QueryProviderAttributesRequestSDKType {
    owner: string;
    pagination?: PageRequestSDKType;
}
/** QueryProviderAuditorRequest is request type for the Query/Providers RPC method */
export interface QueryProviderAuditorRequest {
    auditor: string;
    owner: string;
}
export interface QueryProviderAuditorRequestProtoMsg {
    typeUrl: "/akash.audit.v1beta2.QueryProviderAuditorRequest";
    value: Uint8Array;
}
/** QueryProviderAuditorRequest is request type for the Query/Providers RPC method */
export interface QueryProviderAuditorRequestAmino {
    auditor?: string;
    owner?: string;
}
export interface QueryProviderAuditorRequestAminoMsg {
    type: "akash/audit/v1beta2/query-provider-auditor-request";
    value: QueryProviderAuditorRequestAmino;
}
/** QueryProviderAuditorRequest is request type for the Query/Providers RPC method */
export interface QueryProviderAuditorRequestSDKType {
    auditor: string;
    owner: string;
}
/** QueryAuditorAttributesRequest is request type for the Query/Providers RPC method */
export interface QueryAuditorAttributesRequest {
    auditor: string;
    pagination?: PageRequest;
}
export interface QueryAuditorAttributesRequestProtoMsg {
    typeUrl: "/akash.audit.v1beta2.QueryAuditorAttributesRequest";
    value: Uint8Array;
}
/** QueryAuditorAttributesRequest is request type for the Query/Providers RPC method */
export interface QueryAuditorAttributesRequestAmino {
    auditor?: string;
    pagination?: PageRequestAmino;
}
export interface QueryAuditorAttributesRequestAminoMsg {
    type: "akash/audit/v1beta2/query-auditor-attributes-request";
    value: QueryAuditorAttributesRequestAmino;
}
/** QueryAuditorAttributesRequest is request type for the Query/Providers RPC method */
export interface QueryAuditorAttributesRequestSDKType {
    auditor: string;
    pagination?: PageRequestSDKType;
}
export declare const QueryProvidersResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryProvidersResponse;
    isSDK(o: any): o is QueryProvidersResponseSDKType;
    isAmino(o: any): o is QueryProvidersResponseAmino;
    encode(message: QueryProvidersResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryProvidersResponse;
    fromJSON(object: any): QueryProvidersResponse;
    toJSON(message: QueryProvidersResponse): JsonSafe<QueryProvidersResponse>;
    fromPartial<I extends Exact<DeepPartial<QueryProvidersResponse>, I>>(object: I): QueryProvidersResponse;
    fromSDK(object: QueryProvidersResponseSDKType): QueryProvidersResponse;
    fromSDKJSON(object: any): QueryProvidersResponseSDKType;
    toSDK(message: QueryProvidersResponse): QueryProvidersResponseSDKType;
    fromAmino(object: QueryProvidersResponseAmino): QueryProvidersResponse;
    toAmino(message: QueryProvidersResponse): QueryProvidersResponseAmino;
    fromAminoMsg(object: QueryProvidersResponseAminoMsg): QueryProvidersResponse;
    toAminoMsg(message: QueryProvidersResponse): QueryProvidersResponseAminoMsg;
    fromProtoMsg(message: QueryProvidersResponseProtoMsg): QueryProvidersResponse;
    toProto(message: QueryProvidersResponse): Uint8Array;
    toProtoMsg(message: QueryProvidersResponse): QueryProvidersResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryProviderRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryProviderRequest;
    isSDK(o: any): o is QueryProviderRequestSDKType;
    isAmino(o: any): o is QueryProviderRequestAmino;
    encode(message: QueryProviderRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryProviderRequest;
    fromJSON(object: any): QueryProviderRequest;
    toJSON(message: QueryProviderRequest): JsonSafe<QueryProviderRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryProviderRequest>, I>>(object: I): QueryProviderRequest;
    fromSDK(object: QueryProviderRequestSDKType): QueryProviderRequest;
    fromSDKJSON(object: any): QueryProviderRequestSDKType;
    toSDK(message: QueryProviderRequest): QueryProviderRequestSDKType;
    fromAmino(object: QueryProviderRequestAmino): QueryProviderRequest;
    toAmino(message: QueryProviderRequest): QueryProviderRequestAmino;
    fromAminoMsg(object: QueryProviderRequestAminoMsg): QueryProviderRequest;
    toAminoMsg(message: QueryProviderRequest): QueryProviderRequestAminoMsg;
    fromProtoMsg(message: QueryProviderRequestProtoMsg): QueryProviderRequest;
    toProto(message: QueryProviderRequest): Uint8Array;
    toProtoMsg(message: QueryProviderRequest): QueryProviderRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryAllProvidersAttributesRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryAllProvidersAttributesRequest;
    isSDK(o: any): o is QueryAllProvidersAttributesRequestSDKType;
    isAmino(o: any): o is QueryAllProvidersAttributesRequestAmino;
    encode(message: QueryAllProvidersAttributesRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryAllProvidersAttributesRequest;
    fromJSON(object: any): QueryAllProvidersAttributesRequest;
    toJSON(message: QueryAllProvidersAttributesRequest): JsonSafe<QueryAllProvidersAttributesRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryAllProvidersAttributesRequest>, I>>(object: I): QueryAllProvidersAttributesRequest;
    fromSDK(object: QueryAllProvidersAttributesRequestSDKType): QueryAllProvidersAttributesRequest;
    fromSDKJSON(object: any): QueryAllProvidersAttributesRequestSDKType;
    toSDK(message: QueryAllProvidersAttributesRequest): QueryAllProvidersAttributesRequestSDKType;
    fromAmino(object: QueryAllProvidersAttributesRequestAmino): QueryAllProvidersAttributesRequest;
    toAmino(message: QueryAllProvidersAttributesRequest): QueryAllProvidersAttributesRequestAmino;
    fromAminoMsg(object: QueryAllProvidersAttributesRequestAminoMsg): QueryAllProvidersAttributesRequest;
    toAminoMsg(message: QueryAllProvidersAttributesRequest): QueryAllProvidersAttributesRequestAminoMsg;
    fromProtoMsg(message: QueryAllProvidersAttributesRequestProtoMsg): QueryAllProvidersAttributesRequest;
    toProto(message: QueryAllProvidersAttributesRequest): Uint8Array;
    toProtoMsg(message: QueryAllProvidersAttributesRequest): QueryAllProvidersAttributesRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryProviderAttributesRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryProviderAttributesRequest;
    isSDK(o: any): o is QueryProviderAttributesRequestSDKType;
    isAmino(o: any): o is QueryProviderAttributesRequestAmino;
    encode(message: QueryProviderAttributesRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryProviderAttributesRequest;
    fromJSON(object: any): QueryProviderAttributesRequest;
    toJSON(message: QueryProviderAttributesRequest): JsonSafe<QueryProviderAttributesRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryProviderAttributesRequest>, I>>(object: I): QueryProviderAttributesRequest;
    fromSDK(object: QueryProviderAttributesRequestSDKType): QueryProviderAttributesRequest;
    fromSDKJSON(object: any): QueryProviderAttributesRequestSDKType;
    toSDK(message: QueryProviderAttributesRequest): QueryProviderAttributesRequestSDKType;
    fromAmino(object: QueryProviderAttributesRequestAmino): QueryProviderAttributesRequest;
    toAmino(message: QueryProviderAttributesRequest): QueryProviderAttributesRequestAmino;
    fromAminoMsg(object: QueryProviderAttributesRequestAminoMsg): QueryProviderAttributesRequest;
    toAminoMsg(message: QueryProviderAttributesRequest): QueryProviderAttributesRequestAminoMsg;
    fromProtoMsg(message: QueryProviderAttributesRequestProtoMsg): QueryProviderAttributesRequest;
    toProto(message: QueryProviderAttributesRequest): Uint8Array;
    toProtoMsg(message: QueryProviderAttributesRequest): QueryProviderAttributesRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryProviderAuditorRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryProviderAuditorRequest;
    isSDK(o: any): o is QueryProviderAuditorRequestSDKType;
    isAmino(o: any): o is QueryProviderAuditorRequestAmino;
    encode(message: QueryProviderAuditorRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryProviderAuditorRequest;
    fromJSON(object: any): QueryProviderAuditorRequest;
    toJSON(message: QueryProviderAuditorRequest): JsonSafe<QueryProviderAuditorRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryProviderAuditorRequest>, I>>(object: I): QueryProviderAuditorRequest;
    fromSDK(object: QueryProviderAuditorRequestSDKType): QueryProviderAuditorRequest;
    fromSDKJSON(object: any): QueryProviderAuditorRequestSDKType;
    toSDK(message: QueryProviderAuditorRequest): QueryProviderAuditorRequestSDKType;
    fromAmino(object: QueryProviderAuditorRequestAmino): QueryProviderAuditorRequest;
    toAmino(message: QueryProviderAuditorRequest): QueryProviderAuditorRequestAmino;
    fromAminoMsg(object: QueryProviderAuditorRequestAminoMsg): QueryProviderAuditorRequest;
    toAminoMsg(message: QueryProviderAuditorRequest): QueryProviderAuditorRequestAminoMsg;
    fromProtoMsg(message: QueryProviderAuditorRequestProtoMsg): QueryProviderAuditorRequest;
    toProto(message: QueryProviderAuditorRequest): Uint8Array;
    toProtoMsg(message: QueryProviderAuditorRequest): QueryProviderAuditorRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryAuditorAttributesRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryAuditorAttributesRequest;
    isSDK(o: any): o is QueryAuditorAttributesRequestSDKType;
    isAmino(o: any): o is QueryAuditorAttributesRequestAmino;
    encode(message: QueryAuditorAttributesRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryAuditorAttributesRequest;
    fromJSON(object: any): QueryAuditorAttributesRequest;
    toJSON(message: QueryAuditorAttributesRequest): JsonSafe<QueryAuditorAttributesRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryAuditorAttributesRequest>, I>>(object: I): QueryAuditorAttributesRequest;
    fromSDK(object: QueryAuditorAttributesRequestSDKType): QueryAuditorAttributesRequest;
    fromSDKJSON(object: any): QueryAuditorAttributesRequestSDKType;
    toSDK(message: QueryAuditorAttributesRequest): QueryAuditorAttributesRequestSDKType;
    fromAmino(object: QueryAuditorAttributesRequestAmino): QueryAuditorAttributesRequest;
    toAmino(message: QueryAuditorAttributesRequest): QueryAuditorAttributesRequestAmino;
    fromAminoMsg(object: QueryAuditorAttributesRequestAminoMsg): QueryAuditorAttributesRequest;
    toAminoMsg(message: QueryAuditorAttributesRequest): QueryAuditorAttributesRequestAminoMsg;
    fromProtoMsg(message: QueryAuditorAttributesRequestProtoMsg): QueryAuditorAttributesRequest;
    toProto(message: QueryAuditorAttributesRequest): Uint8Array;
    toProtoMsg(message: QueryAuditorAttributesRequest): QueryAuditorAttributesRequestProtoMsg;
    registerTypeUrl(): void;
};
