import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import { Provider } from "./audit";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.audit.v1beta2";
function createBaseQueryProvidersResponse() {
    return {
        providers: [],
        pagination: undefined
    };
}
export const QueryProvidersResponse = {
    typeUrl: "/akash.audit.v1beta2.QueryProvidersResponse",
    aminoType: "akash/audit/v1beta2/query-providers-response",
    is(o) {
        return o && (o.$typeUrl === QueryProvidersResponse.typeUrl || Array.isArray(o.providers) && (!o.providers.length || Provider.is(o.providers[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryProvidersResponse.typeUrl || Array.isArray(o.providers) && (!o.providers.length || Provider.isSDK(o.providers[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryProvidersResponse.typeUrl || Array.isArray(o.providers) && (!o.providers.length || Provider.isAmino(o.providers[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.providers) {
            Provider.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryProvidersResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.providers.push(Provider.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryProvidersResponse();
        if (Array.isArray(object?.providers))
            obj.providers = object.providers.map((e) => Provider.fromJSON(e));
        if (isSet(object.pagination))
            obj.pagination = PageResponse.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.providers) {
            obj.providers = message.providers.map(e => e ? Provider.toJSON(e) : undefined);
        }
        else {
            obj.providers = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryProvidersResponse();
        message.providers = object.providers?.map(e => Provider.fromPartial(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            providers: Array.isArray(object?.providers) ? object.providers.map((e) => Provider.fromSDK(e)) : [],
            pagination: object.pagination ? PageResponse.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            providers: Array.isArray(object?.providers) ? object.providers.map((e) => Provider.fromSDKJSON(e)) : [],
            pagination: isSet(object.pagination) ? PageResponse.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.providers) {
            obj.providers = message.providers.map(e => e ? Provider.toSDK(e) : undefined);
        }
        else {
            obj.providers = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryProvidersResponse();
        message.providers = object.providers?.map(e => Provider.fromAmino(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.providers) {
            obj.providers = message.providers.map(e => e ? Provider.toAmino(e) : undefined);
        }
        else {
            obj.providers = message.providers;
        }
        obj.pagination = message.pagination ? PageResponse.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryProvidersResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/audit/v1beta2/query-providers-response",
            value: QueryProvidersResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return QueryProvidersResponse.decode(message.value);
    },
    toProto(message) {
        return QueryProvidersResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.audit.v1beta2.QueryProvidersResponse",
            value: QueryProvidersResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Provider.registerTypeUrl();
        PageResponse.registerTypeUrl();
    }
};
function createBaseQueryProviderRequest() {
    return {
        auditor: "",
        owner: ""
    };
}
export const QueryProviderRequest = {
    typeUrl: "/akash.audit.v1beta2.QueryProviderRequest",
    aminoType: "akash/audit/v1beta2/query-provider-request",
    is(o) {
        return o && (o.$typeUrl === QueryProviderRequest.typeUrl || typeof o.auditor === "string" && typeof o.owner === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryProviderRequest.typeUrl || typeof o.auditor === "string" && typeof o.owner === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryProviderRequest.typeUrl || typeof o.auditor === "string" && typeof o.owner === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.auditor !== undefined) {
            writer.uint32(10).string(message.auditor);
        }
        if (message.owner !== undefined) {
            writer.uint32(18).string(message.owner);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryProviderRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auditor = reader.string();
                    break;
                case 2:
                    message.owner = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryProviderRequest();
        if (isSet(object.auditor))
            obj.auditor = String(object.auditor);
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.auditor !== undefined && (obj.auditor = message.auditor);
        message.owner !== undefined && (obj.owner = message.owner);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryProviderRequest();
        message.auditor = object.auditor ?? "";
        message.owner = object.owner ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            auditor: object?.auditor,
            owner: object?.owner
        };
    },
    fromSDKJSON(object) {
        return {
            auditor: isSet(object.auditor) ? String(object.auditor) : "",
            owner: isSet(object.owner) ? String(object.owner) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.auditor = message.auditor;
        obj.owner = message.owner;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryProviderRequest();
        if (object.auditor !== undefined && object.auditor !== null) {
            message.auditor = object.auditor;
        }
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.auditor = message.auditor === "" ? undefined : message.auditor;
        obj.owner = message.owner === "" ? undefined : message.owner;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryProviderRequest.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/audit/v1beta2/query-provider-request",
            value: QueryProviderRequest.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return QueryProviderRequest.decode(message.value);
    },
    toProto(message) {
        return QueryProviderRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.audit.v1beta2.QueryProviderRequest",
            value: QueryProviderRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryAllProvidersAttributesRequest() {
    return {
        pagination: undefined
    };
}
export const QueryAllProvidersAttributesRequest = {
    typeUrl: "/akash.audit.v1beta2.QueryAllProvidersAttributesRequest",
    aminoType: "akash/audit/v1beta2/query-all-providers-attributes-request",
    is(o) {
        return o && o.$typeUrl === QueryAllProvidersAttributesRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryAllProvidersAttributesRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryAllProvidersAttributesRequest.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryAllProvidersAttributesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryAllProvidersAttributesRequest();
        if (isSet(object.pagination))
            obj.pagination = PageRequest.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryAllProvidersAttributesRequest();
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            pagination: object.pagination ? PageRequest.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            pagination: isSet(object.pagination) ? PageRequest.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryAllProvidersAttributesRequest();
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.pagination = message.pagination ? PageRequest.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryAllProvidersAttributesRequest.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/audit/v1beta2/query-all-providers-attributes-request",
            value: QueryAllProvidersAttributesRequest.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return QueryAllProvidersAttributesRequest.decode(message.value);
    },
    toProto(message) {
        return QueryAllProvidersAttributesRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.audit.v1beta2.QueryAllProvidersAttributesRequest",
            value: QueryAllProvidersAttributesRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        PageRequest.registerTypeUrl();
    }
};
function createBaseQueryProviderAttributesRequest() {
    return {
        owner: "",
        pagination: undefined
    };
}
export const QueryProviderAttributesRequest = {
    typeUrl: "/akash.audit.v1beta2.QueryProviderAttributesRequest",
    aminoType: "akash/audit/v1beta2/query-provider-attributes-request",
    is(o) {
        return o && (o.$typeUrl === QueryProviderAttributesRequest.typeUrl || typeof o.owner === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryProviderAttributesRequest.typeUrl || typeof o.owner === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryProviderAttributesRequest.typeUrl || typeof o.owner === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryProviderAttributesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryProviderAttributesRequest();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.pagination))
            obj.pagination = PageRequest.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryProviderAttributesRequest();
        message.owner = object.owner ?? "";
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            pagination: object.pagination ? PageRequest.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            pagination: isSet(object.pagination) ? PageRequest.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryProviderAttributesRequest();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner === "" ? undefined : message.owner;
        obj.pagination = message.pagination ? PageRequest.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryProviderAttributesRequest.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/audit/v1beta2/query-provider-attributes-request",
            value: QueryProviderAttributesRequest.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return QueryProviderAttributesRequest.decode(message.value);
    },
    toProto(message) {
        return QueryProviderAttributesRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.audit.v1beta2.QueryProviderAttributesRequest",
            value: QueryProviderAttributesRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        PageRequest.registerTypeUrl();
    }
};
function createBaseQueryProviderAuditorRequest() {
    return {
        auditor: "",
        owner: ""
    };
}
export const QueryProviderAuditorRequest = {
    typeUrl: "/akash.audit.v1beta2.QueryProviderAuditorRequest",
    aminoType: "akash/audit/v1beta2/query-provider-auditor-request",
    is(o) {
        return o && (o.$typeUrl === QueryProviderAuditorRequest.typeUrl || typeof o.auditor === "string" && typeof o.owner === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryProviderAuditorRequest.typeUrl || typeof o.auditor === "string" && typeof o.owner === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryProviderAuditorRequest.typeUrl || typeof o.auditor === "string" && typeof o.owner === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.auditor !== undefined) {
            writer.uint32(10).string(message.auditor);
        }
        if (message.owner !== undefined) {
            writer.uint32(18).string(message.owner);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryProviderAuditorRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auditor = reader.string();
                    break;
                case 2:
                    message.owner = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryProviderAuditorRequest();
        if (isSet(object.auditor))
            obj.auditor = String(object.auditor);
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.auditor !== undefined && (obj.auditor = message.auditor);
        message.owner !== undefined && (obj.owner = message.owner);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryProviderAuditorRequest();
        message.auditor = object.auditor ?? "";
        message.owner = object.owner ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            auditor: object?.auditor,
            owner: object?.owner
        };
    },
    fromSDKJSON(object) {
        return {
            auditor: isSet(object.auditor) ? String(object.auditor) : "",
            owner: isSet(object.owner) ? String(object.owner) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.auditor = message.auditor;
        obj.owner = message.owner;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryProviderAuditorRequest();
        if (object.auditor !== undefined && object.auditor !== null) {
            message.auditor = object.auditor;
        }
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.auditor = message.auditor === "" ? undefined : message.auditor;
        obj.owner = message.owner === "" ? undefined : message.owner;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryProviderAuditorRequest.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/audit/v1beta2/query-provider-auditor-request",
            value: QueryProviderAuditorRequest.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return QueryProviderAuditorRequest.decode(message.value);
    },
    toProto(message) {
        return QueryProviderAuditorRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.audit.v1beta2.QueryProviderAuditorRequest",
            value: QueryProviderAuditorRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryAuditorAttributesRequest() {
    return {
        auditor: "",
        pagination: undefined
    };
}
export const QueryAuditorAttributesRequest = {
    typeUrl: "/akash.audit.v1beta2.QueryAuditorAttributesRequest",
    aminoType: "akash/audit/v1beta2/query-auditor-attributes-request",
    is(o) {
        return o && (o.$typeUrl === QueryAuditorAttributesRequest.typeUrl || typeof o.auditor === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryAuditorAttributesRequest.typeUrl || typeof o.auditor === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryAuditorAttributesRequest.typeUrl || typeof o.auditor === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.auditor !== undefined) {
            writer.uint32(10).string(message.auditor);
        }
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryAuditorAttributesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auditor = reader.string();
                    break;
                case 2:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryAuditorAttributesRequest();
        if (isSet(object.auditor))
            obj.auditor = String(object.auditor);
        if (isSet(object.pagination))
            obj.pagination = PageRequest.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.auditor !== undefined && (obj.auditor = message.auditor);
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryAuditorAttributesRequest();
        message.auditor = object.auditor ?? "";
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            auditor: object?.auditor,
            pagination: object.pagination ? PageRequest.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            auditor: isSet(object.auditor) ? String(object.auditor) : "",
            pagination: isSet(object.pagination) ? PageRequest.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.auditor = message.auditor;
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryAuditorAttributesRequest();
        if (object.auditor !== undefined && object.auditor !== null) {
            message.auditor = object.auditor;
        }
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.auditor = message.auditor === "" ? undefined : message.auditor;
        obj.pagination = message.pagination ? PageRequest.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryAuditorAttributesRequest.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/audit/v1beta2/query-auditor-attributes-request",
            value: QueryAuditorAttributesRequest.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return QueryAuditorAttributesRequest.decode(message.value);
    },
    toProto(message) {
        return QueryAuditorAttributesRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.audit.v1beta2.QueryAuditorAttributesRequest",
            value: QueryAuditorAttributesRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        PageRequest.registerTypeUrl();
    }
};
