import { DeepPartial, Exact } from "../../../helpers";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.base.v1beta1";
/** This describes how the endpoint is implemented when the lease is deployed */
export declare enum Endpoint_Kind {
    /** SHARED_HTTP - Describes an endpoint that becomes a Kubernetes Ingress */
    SHARED_HTTP = 0,
    /** RANDOM_PORT - Describes an endpoint that becomes a Kubernetes NodePort */
    RANDOM_PORT = 1,
    UNRECOGNIZED = -1
}
export declare const Endpoint_KindSDKType: typeof Endpoint_Kind;
export declare const Endpoint_KindAmino: typeof Endpoint_Kind;
export declare function endpoint_KindFromJSON(object: any): Endpoint_Kind;
export declare function endpoint_KindToJSON(object: Endpoint_Kind): string;
/** Endpoint describes a publicly accessible IP service */
export interface Endpoint {
    kind: Endpoint_Kind;
}
export interface EndpointProtoMsg {
    typeUrl: "/akash.base.v1beta1.Endpoint";
    value: Uint8Array;
}
/** Endpoint describes a publicly accessible IP service */
export interface EndpointAmino {
    kind?: Endpoint_Kind;
}
export interface EndpointAminoMsg {
    type: "akash/base/endpoint";
    value: EndpointAmino;
}
/** Endpoint describes a publicly accessible IP service */
export interface EndpointSDKType {
    kind: Endpoint_Kind;
}
export declare const Endpoint: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is Endpoint;
    isSDK(o: any): o is EndpointSDKType;
    isAmino(o: any): o is EndpointAmino;
    encode(message: Endpoint, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Endpoint;
    fromJSON(object: any): Endpoint;
    toJSON(message: Endpoint): JsonSafe<Endpoint>;
    fromPartial<I extends Exact<DeepPartial<Endpoint>, I>>(object: I): Endpoint;
    fromSDK(object: EndpointSDKType): Endpoint;
    fromSDKJSON(object: any): EndpointSDKType;
    toSDK(message: Endpoint): EndpointSDKType;
    fromAmino(object: EndpointAmino): Endpoint;
    toAmino(message: Endpoint): EndpointAmino;
    fromAminoMsg(object: EndpointAminoMsg): Endpoint;
    toAminoMsg(message: Endpoint): EndpointAminoMsg;
    fromProtoMsg(message: EndpointProtoMsg): Endpoint;
    toProto(message: Endpoint): Uint8Array;
    toProtoMsg(message: Endpoint): EndpointProtoMsg;
    registerTypeUrl(): void;
};
