import { ResourceValue, ResourceValueAmino, ResourceValueSDKType } from "./resourcevalue";
import { Attribute, AttributeAmino, AttributeSDKType } from "./attribute";
import { Endpoint, EndpointAmino, EndpointSDKType } from "./endpoint";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.base.v1beta1";
/** CPU stores resource units and cpu config attributes */
export interface CPU {
    units: ResourceValue;
    attributes: Attribute[];
}
export interface CPUProtoMsg {
    typeUrl: "/akash.base.v1beta1.CPU";
    value: Uint8Array;
}
/** CPU stores resource units and cpu config attributes */
export interface CPUAmino {
    units?: ResourceValueAmino;
    attributes?: AttributeAmino[];
}
export interface CPUAminoMsg {
    type: "akash/base/cpu";
    value: CPUAmino;
}
/** CPU stores resource units and cpu config attributes */
export interface CPUSDKType {
    units: ResourceValueSDKType;
    attributes: AttributeSDKType[];
}
/** Memory stores resource quantity and memory attributes */
export interface Memory {
    quantity: ResourceValue;
    attributes: Attribute[];
}
export interface MemoryProtoMsg {
    typeUrl: "/akash.base.v1beta1.Memory";
    value: Uint8Array;
}
/** Memory stores resource quantity and memory attributes */
export interface MemoryAmino {
    quantity: ResourceValueAmino;
    attributes?: AttributeAmino[];
}
export interface MemoryAminoMsg {
    type: "akash/base/memory";
    value: MemoryAmino;
}
/** Memory stores resource quantity and memory attributes */
export interface MemorySDKType {
    quantity: ResourceValueSDKType;
    attributes: AttributeSDKType[];
}
/** Storage stores resource quantity and storage attributes */
export interface Storage {
    quantity: ResourceValue;
    attributes: Attribute[];
}
export interface StorageProtoMsg {
    typeUrl: "/akash.base.v1beta1.Storage";
    value: Uint8Array;
}
/** Storage stores resource quantity and storage attributes */
export interface StorageAmino {
    quantity: ResourceValueAmino;
    attributes?: AttributeAmino[];
}
export interface StorageAminoMsg {
    type: "akash/base/storage";
    value: StorageAmino;
}
/** Storage stores resource quantity and storage attributes */
export interface StorageSDKType {
    quantity: ResourceValueSDKType;
    attributes: AttributeSDKType[];
}
/**
 * ResourceUnits describes all available resources types for deployment/node etc
 * if field is nil resource is not present in the given data-structure
 */
export interface ResourceUnits {
    cpu?: CPU;
    memory?: Memory;
    storage?: Storage;
    endpoints: Endpoint[];
}
export interface ResourceUnitsProtoMsg {
    typeUrl: "/akash.base.v1beta1.ResourceUnits";
    value: Uint8Array;
}
/**
 * ResourceUnits describes all available resources types for deployment/node etc
 * if field is nil resource is not present in the given data-structure
 */
export interface ResourceUnitsAmino {
    cpu?: CPUAmino;
    memory?: MemoryAmino;
    storage?: StorageAmino;
    endpoints: EndpointAmino[];
}
export interface ResourceUnitsAminoMsg {
    type: "akash/base/resource-units";
    value: ResourceUnitsAmino;
}
/**
 * ResourceUnits describes all available resources types for deployment/node etc
 * if field is nil resource is not present in the given data-structure
 */
export interface ResourceUnitsSDKType {
    cpu?: CPUSDKType;
    memory?: MemorySDKType;
    storage?: StorageSDKType;
    endpoints: EndpointSDKType[];
}
export declare const CPU: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is CPU;
    isSDK(o: any): o is CPUSDKType;
    isAmino(o: any): o is CPUAmino;
    encode(message: CPU, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): CPU;
    fromJSON(object: any): CPU;
    toJSON(message: CPU): JsonSafe<CPU>;
    fromPartial<I extends Exact<DeepPartial<CPU>, I>>(object: I): CPU;
    fromSDK(object: CPUSDKType): CPU;
    fromSDKJSON(object: any): CPUSDKType;
    toSDK(message: CPU): CPUSDKType;
    fromAmino(object: CPUAmino): CPU;
    toAmino(message: CPU): CPUAmino;
    fromAminoMsg(object: CPUAminoMsg): CPU;
    toAminoMsg(message: CPU): CPUAminoMsg;
    fromProtoMsg(message: CPUProtoMsg): CPU;
    toProto(message: CPU): Uint8Array;
    toProtoMsg(message: CPU): CPUProtoMsg;
    registerTypeUrl(): void;
};
export declare const Memory: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is Memory;
    isSDK(o: any): o is MemorySDKType;
    isAmino(o: any): o is MemoryAmino;
    encode(message: Memory, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Memory;
    fromJSON(object: any): Memory;
    toJSON(message: Memory): JsonSafe<Memory>;
    fromPartial<I extends Exact<DeepPartial<Memory>, I>>(object: I): Memory;
    fromSDK(object: MemorySDKType): Memory;
    fromSDKJSON(object: any): MemorySDKType;
    toSDK(message: Memory): MemorySDKType;
    fromAmino(object: MemoryAmino): Memory;
    toAmino(message: Memory): MemoryAmino;
    fromAminoMsg(object: MemoryAminoMsg): Memory;
    toAminoMsg(message: Memory): MemoryAminoMsg;
    fromProtoMsg(message: MemoryProtoMsg): Memory;
    toProto(message: Memory): Uint8Array;
    toProtoMsg(message: Memory): MemoryProtoMsg;
    registerTypeUrl(): void;
};
export declare const Storage: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is Storage;
    isSDK(o: any): o is StorageSDKType;
    isAmino(o: any): o is StorageAmino;
    encode(message: Storage, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Storage;
    fromJSON(object: any): Storage;
    toJSON(message: Storage): JsonSafe<Storage>;
    fromPartial<I extends Exact<DeepPartial<Storage>, I>>(object: I): Storage;
    fromSDK(object: StorageSDKType): Storage;
    fromSDKJSON(object: any): StorageSDKType;
    toSDK(message: Storage): StorageSDKType;
    fromAmino(object: StorageAmino): Storage;
    toAmino(message: Storage): StorageAmino;
    fromAminoMsg(object: StorageAminoMsg): Storage;
    toAminoMsg(message: Storage): StorageAminoMsg;
    fromProtoMsg(message: StorageProtoMsg): Storage;
    toProto(message: Storage): Uint8Array;
    toProtoMsg(message: Storage): StorageProtoMsg;
    registerTypeUrl(): void;
};
export declare const ResourceUnits: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is ResourceUnits;
    isSDK(o: any): o is ResourceUnitsSDKType;
    isAmino(o: any): o is ResourceUnitsAmino;
    encode(message: ResourceUnits, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ResourceUnits;
    fromJSON(object: any): ResourceUnits;
    toJSON(message: ResourceUnits): JsonSafe<ResourceUnits>;
    fromPartial<I extends Exact<DeepPartial<ResourceUnits>, I>>(object: I): ResourceUnits;
    fromSDK(object: ResourceUnitsSDKType): ResourceUnits;
    fromSDKJSON(object: any): ResourceUnitsSDKType;
    toSDK(message: ResourceUnits): ResourceUnitsSDKType;
    fromAmino(object: ResourceUnitsAmino): ResourceUnits;
    toAmino(message: ResourceUnits): ResourceUnitsAmino;
    fromAminoMsg(object: ResourceUnitsAminoMsg): ResourceUnits;
    toAminoMsg(message: ResourceUnits): ResourceUnitsAminoMsg;
    fromProtoMsg(message: ResourceUnitsProtoMsg): ResourceUnits;
    toProto(message: ResourceUnits): Uint8Array;
    toProtoMsg(message: ResourceUnits): ResourceUnitsProtoMsg;
    registerTypeUrl(): void;
};
