import { ResourceValue } from "./resourcevalue";
import { Attribute } from "./attribute";
import { Endpoint } from "./endpoint";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.base.v1beta1";
function createBaseCPU() {
    return {
        units: ResourceValue.fromPartial({}),
        attributes: []
    };
}
export const CPU = {
    typeUrl: "/akash.base.v1beta1.CPU",
    aminoType: "akash/base/cpu",
    is(o) {
        return o && (o.$typeUrl === CPU.typeUrl || ResourceValue.is(o.units) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.is(o.attributes[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === CPU.typeUrl || ResourceValue.isSDK(o.units) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isSDK(o.attributes[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === CPU.typeUrl || ResourceValue.isAmino(o.units) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isAmino(o.attributes[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.units !== undefined) {
            ResourceValue.encode(message.units, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.attributes) {
            Attribute.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCPU();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.units = ResourceValue.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.attributes.push(Attribute.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCPU();
        if (isSet(object.units))
            obj.units = ResourceValue.fromJSON(object.units);
        if (Array.isArray(object?.attributes))
            obj.attributes = object.attributes.map((e) => Attribute.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.units !== undefined && (obj.units = message.units ? ResourceValue.toJSON(message.units) : undefined);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toJSON(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCPU();
        if (object.units !== undefined && object.units !== null) {
            message.units = ResourceValue.fromPartial(object.units);
        }
        message.attributes = object.attributes?.map(e => Attribute.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            units: object.units ? ResourceValue.fromSDK(object.units) : undefined,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            units: isSet(object.units) ? ResourceValue.fromSDKJSON(object.units) : undefined,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        message.units !== undefined && (obj.units = message.units ? ResourceValue.toSDK(message.units) : undefined);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toSDK(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCPU();
        if (object.units !== undefined && object.units !== null) {
            message.units = ResourceValue.fromAmino(object.units);
        }
        message.attributes = object.attributes?.map(e => Attribute.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.units = message.units ? ResourceValue.toAmino(message.units) : undefined;
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toAmino(e) : undefined);
        }
        else {
            obj.attributes = message.attributes;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return CPU.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/base/cpu",
            value: CPU.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return CPU.decode(message.value);
    },
    toProto(message) {
        return CPU.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.base.v1beta1.CPU",
            value: CPU.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ResourceValue.registerTypeUrl();
        Attribute.registerTypeUrl();
    }
};
function createBaseMemory() {
    return {
        quantity: ResourceValue.fromPartial({}),
        attributes: []
    };
}
export const Memory = {
    typeUrl: "/akash.base.v1beta1.Memory",
    aminoType: "akash/base/memory",
    is(o) {
        return o && (o.$typeUrl === Memory.typeUrl || ResourceValue.is(o.quantity) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.is(o.attributes[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Memory.typeUrl || ResourceValue.isSDK(o.quantity) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isSDK(o.attributes[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Memory.typeUrl || ResourceValue.isAmino(o.quantity) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isAmino(o.attributes[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.quantity !== undefined) {
            ResourceValue.encode(message.quantity, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.attributes) {
            Attribute.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMemory();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.quantity = ResourceValue.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.attributes.push(Attribute.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMemory();
        if (isSet(object.quantity))
            obj.quantity = ResourceValue.fromJSON(object.quantity);
        if (Array.isArray(object?.attributes))
            obj.attributes = object.attributes.map((e) => Attribute.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.quantity !== undefined && (obj.quantity = message.quantity ? ResourceValue.toJSON(message.quantity) : undefined);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toJSON(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMemory();
        if (object.quantity !== undefined && object.quantity !== null) {
            message.quantity = ResourceValue.fromPartial(object.quantity);
        }
        message.attributes = object.attributes?.map(e => Attribute.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            quantity: object.quantity ? ResourceValue.fromSDK(object.quantity) : undefined,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            quantity: isSet(object.quantity) ? ResourceValue.fromSDKJSON(object.quantity) : undefined,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        message.quantity !== undefined && (obj.quantity = message.quantity ? ResourceValue.toSDK(message.quantity) : undefined);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toSDK(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMemory();
        if (object.quantity !== undefined && object.quantity !== null) {
            message.quantity = ResourceValue.fromAmino(object.quantity);
        }
        message.attributes = object.attributes?.map(e => Attribute.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.quantity = message.quantity ? ResourceValue.toAmino(message.quantity) : ResourceValue.toAmino(ResourceValue.fromPartial({}));
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toAmino(e) : undefined);
        }
        else {
            obj.attributes = message.attributes;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Memory.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/base/memory",
            value: Memory.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Memory.decode(message.value);
    },
    toProto(message) {
        return Memory.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.base.v1beta1.Memory",
            value: Memory.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ResourceValue.registerTypeUrl();
        Attribute.registerTypeUrl();
    }
};
function createBaseStorage() {
    return {
        quantity: ResourceValue.fromPartial({}),
        attributes: []
    };
}
export const Storage = {
    typeUrl: "/akash.base.v1beta1.Storage",
    aminoType: "akash/base/storage",
    is(o) {
        return o && (o.$typeUrl === Storage.typeUrl || ResourceValue.is(o.quantity) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.is(o.attributes[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Storage.typeUrl || ResourceValue.isSDK(o.quantity) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isSDK(o.attributes[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Storage.typeUrl || ResourceValue.isAmino(o.quantity) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isAmino(o.attributes[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.quantity !== undefined) {
            ResourceValue.encode(message.quantity, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.attributes) {
            Attribute.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseStorage();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.quantity = ResourceValue.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.attributes.push(Attribute.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseStorage();
        if (isSet(object.quantity))
            obj.quantity = ResourceValue.fromJSON(object.quantity);
        if (Array.isArray(object?.attributes))
            obj.attributes = object.attributes.map((e) => Attribute.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.quantity !== undefined && (obj.quantity = message.quantity ? ResourceValue.toJSON(message.quantity) : undefined);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toJSON(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseStorage();
        if (object.quantity !== undefined && object.quantity !== null) {
            message.quantity = ResourceValue.fromPartial(object.quantity);
        }
        message.attributes = object.attributes?.map(e => Attribute.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            quantity: object.quantity ? ResourceValue.fromSDK(object.quantity) : undefined,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            quantity: isSet(object.quantity) ? ResourceValue.fromSDKJSON(object.quantity) : undefined,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        message.quantity !== undefined && (obj.quantity = message.quantity ? ResourceValue.toSDK(message.quantity) : undefined);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toSDK(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseStorage();
        if (object.quantity !== undefined && object.quantity !== null) {
            message.quantity = ResourceValue.fromAmino(object.quantity);
        }
        message.attributes = object.attributes?.map(e => Attribute.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.quantity = message.quantity ? ResourceValue.toAmino(message.quantity) : ResourceValue.toAmino(ResourceValue.fromPartial({}));
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toAmino(e) : undefined);
        }
        else {
            obj.attributes = message.attributes;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Storage.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/base/storage",
            value: Storage.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Storage.decode(message.value);
    },
    toProto(message) {
        return Storage.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.base.v1beta1.Storage",
            value: Storage.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ResourceValue.registerTypeUrl();
        Attribute.registerTypeUrl();
    }
};
function createBaseResourceUnits() {
    return {
        cpu: undefined,
        memory: undefined,
        storage: undefined,
        endpoints: []
    };
}
export const ResourceUnits = {
    typeUrl: "/akash.base.v1beta1.ResourceUnits",
    aminoType: "akash/base/resource-units",
    is(o) {
        return o && (o.$typeUrl === ResourceUnits.typeUrl || Array.isArray(o.endpoints) && (!o.endpoints.length || Endpoint.is(o.endpoints[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === ResourceUnits.typeUrl || Array.isArray(o.endpoints) && (!o.endpoints.length || Endpoint.isSDK(o.endpoints[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === ResourceUnits.typeUrl || Array.isArray(o.endpoints) && (!o.endpoints.length || Endpoint.isAmino(o.endpoints[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.cpu !== undefined) {
            CPU.encode(message.cpu, writer.uint32(10).fork()).ldelim();
        }
        if (message.memory !== undefined) {
            Memory.encode(message.memory, writer.uint32(18).fork()).ldelim();
        }
        if (message.storage !== undefined) {
            Storage.encode(message.storage, writer.uint32(26).fork()).ldelim();
        }
        for (const v of message.endpoints) {
            Endpoint.encode(v, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseResourceUnits();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.cpu = CPU.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.memory = Memory.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.storage = Storage.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.endpoints.push(Endpoint.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseResourceUnits();
        if (isSet(object.cpu))
            obj.cpu = CPU.fromJSON(object.cpu);
        if (isSet(object.memory))
            obj.memory = Memory.fromJSON(object.memory);
        if (isSet(object.storage))
            obj.storage = Storage.fromJSON(object.storage);
        if (Array.isArray(object?.endpoints))
            obj.endpoints = object.endpoints.map((e) => Endpoint.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.cpu !== undefined && (obj.cpu = message.cpu ? CPU.toJSON(message.cpu) : undefined);
        message.memory !== undefined && (obj.memory = message.memory ? Memory.toJSON(message.memory) : undefined);
        message.storage !== undefined && (obj.storage = message.storage ? Storage.toJSON(message.storage) : undefined);
        if (message.endpoints) {
            obj.endpoints = message.endpoints.map(e => e ? Endpoint.toJSON(e) : undefined);
        }
        else {
            obj.endpoints = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseResourceUnits();
        if (object.cpu !== undefined && object.cpu !== null) {
            message.cpu = CPU.fromPartial(object.cpu);
        }
        if (object.memory !== undefined && object.memory !== null) {
            message.memory = Memory.fromPartial(object.memory);
        }
        if (object.storage !== undefined && object.storage !== null) {
            message.storage = Storage.fromPartial(object.storage);
        }
        message.endpoints = object.endpoints?.map(e => Endpoint.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            cpu: object.cpu ? CPU.fromSDK(object.cpu) : undefined,
            memory: object.memory ? Memory.fromSDK(object.memory) : undefined,
            storage: object.storage ? Storage.fromSDK(object.storage) : undefined,
            endpoints: Array.isArray(object?.endpoints) ? object.endpoints.map((e) => Endpoint.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            cpu: isSet(object.cpu) ? CPU.fromSDKJSON(object.cpu) : undefined,
            memory: isSet(object.memory) ? Memory.fromSDKJSON(object.memory) : undefined,
            storage: isSet(object.storage) ? Storage.fromSDKJSON(object.storage) : undefined,
            endpoints: Array.isArray(object?.endpoints) ? object.endpoints.map((e) => Endpoint.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        message.cpu !== undefined && (obj.cpu = message.cpu ? CPU.toSDK(message.cpu) : undefined);
        message.memory !== undefined && (obj.memory = message.memory ? Memory.toSDK(message.memory) : undefined);
        message.storage !== undefined && (obj.storage = message.storage ? Storage.toSDK(message.storage) : undefined);
        if (message.endpoints) {
            obj.endpoints = message.endpoints.map(e => e ? Endpoint.toSDK(e) : undefined);
        }
        else {
            obj.endpoints = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseResourceUnits();
        if (object.cpu !== undefined && object.cpu !== null) {
            message.cpu = CPU.fromAmino(object.cpu);
        }
        if (object.memory !== undefined && object.memory !== null) {
            message.memory = Memory.fromAmino(object.memory);
        }
        if (object.storage !== undefined && object.storage !== null) {
            message.storage = Storage.fromAmino(object.storage);
        }
        message.endpoints = object.endpoints?.map(e => Endpoint.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.cpu = message.cpu ? CPU.toAmino(message.cpu) : undefined;
        obj.memory = message.memory ? Memory.toAmino(message.memory) : undefined;
        obj.storage = message.storage ? Storage.toAmino(message.storage) : undefined;
        if (message.endpoints) {
            obj.endpoints = message.endpoints.map(e => e ? Endpoint.toAmino(e) : undefined);
        }
        else {
            obj.endpoints = message.endpoints;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return ResourceUnits.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/base/resource-units",
            value: ResourceUnits.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return ResourceUnits.decode(message.value);
    },
    toProto(message) {
        return ResourceUnits.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.base.v1beta1.ResourceUnits",
            value: ResourceUnits.encode(message).finish()
        };
    },
    registerTypeUrl() {
        CPU.registerTypeUrl();
        Memory.registerTypeUrl();
        Storage.registerTypeUrl();
        Endpoint.registerTypeUrl();
    }
};
