import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.base.v1beta1";
/** Unit stores cpu, memory and storage metrics */
export interface ResourceValue {
    val: Uint8Array;
}
export interface ResourceValueProtoMsg {
    typeUrl: "/akash.base.v1beta1.ResourceValue";
    value: Uint8Array;
}
/** Unit stores cpu, memory and storage metrics */
export interface ResourceValueAmino {
    val?: string;
}
export interface ResourceValueAminoMsg {
    type: "akash/base/resource-value";
    value: ResourceValueAmino;
}
/** Unit stores cpu, memory and storage metrics */
export interface ResourceValueSDKType {
    val: Uint8Array;
}
export declare const ResourceValue: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is ResourceValue;
    isSDK(o: any): o is ResourceValueSDKType;
    isAmino(o: any): o is ResourceValueAmino;
    encode(message: ResourceValue, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ResourceValue;
    fromJSON(object: any): ResourceValue;
    toJSON(message: ResourceValue): JsonSafe<ResourceValue>;
    fromPartial<I extends Exact<DeepPartial<ResourceValue>, I>>(object: I): ResourceValue;
    fromSDK(object: ResourceValueSDKType): ResourceValue;
    fromSDKJSON(object: any): ResourceValueSDKType;
    toSDK(message: ResourceValue): ResourceValueSDKType;
    fromAmino(object: ResourceValueAmino): ResourceValue;
    toAmino(message: ResourceValue): ResourceValueAmino;
    fromAminoMsg(object: ResourceValueAminoMsg): ResourceValue;
    toAminoMsg(message: ResourceValue): ResourceValueAminoMsg;
    fromProtoMsg(message: ResourceValueProtoMsg): ResourceValue;
    toProto(message: ResourceValue): Uint8Array;
    toProtoMsg(message: ResourceValue): ResourceValueProtoMsg;
    registerTypeUrl(): void;
};
