import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.base.v1beta2";
function createBaseAttribute() {
    return {
        key: "",
        value: ""
    };
}
export const Attribute = {
    typeUrl: "/akash.base.v1beta2.Attribute",
    aminoType: "akash/base/v1beta2/attribute",
    is(o) {
        return o && (o.$typeUrl === Attribute.typeUrl || typeof o.key === "string" && typeof o.value === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Attribute.typeUrl || typeof o.key === "string" && typeof o.value === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Attribute.typeUrl || typeof o.key === "string" && typeof o.value === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(18).string(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAttribute();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAttribute();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = String(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = message.value);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAttribute();
        message.key = object.key ?? "";
        message.value = object.value ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? String(object.value) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAttribute();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value === "" ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return Attribute.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/base/v1beta2/attribute",
            value: Attribute.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Attribute.decode(message.value);
    },
    toProto(message) {
        return Attribute.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.base.v1beta2.Attribute",
            value: Attribute.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseSignedBy() {
    return {
        allOf: [],
        anyOf: []
    };
}
export const SignedBy = {
    typeUrl: "/akash.base.v1beta2.SignedBy",
    aminoType: "akash/base/v1beta2/signed-by",
    is(o) {
        return o && (o.$typeUrl === SignedBy.typeUrl || Array.isArray(o.allOf) && (!o.allOf.length || typeof o.allOf[0] === "string") && Array.isArray(o.anyOf) && (!o.anyOf.length || typeof o.anyOf[0] === "string"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === SignedBy.typeUrl || Array.isArray(o.all_of) && (!o.all_of.length || typeof o.all_of[0] === "string") && Array.isArray(o.any_of) && (!o.any_of.length || typeof o.any_of[0] === "string"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === SignedBy.typeUrl || Array.isArray(o.all_of) && (!o.all_of.length || typeof o.all_of[0] === "string") && Array.isArray(o.any_of) && (!o.any_of.length || typeof o.any_of[0] === "string"));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.allOf) {
            writer.uint32(10).string(v);
        }
        for (const v of message.anyOf) {
            writer.uint32(18).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSignedBy();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.allOf.push(reader.string());
                    break;
                case 2:
                    message.anyOf.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseSignedBy();
        if (Array.isArray(object?.allOf))
            obj.allOf = object.allOf.map((e) => String(e));
        if (Array.isArray(object?.anyOf))
            obj.anyOf = object.anyOf.map((e) => String(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.allOf) {
            obj.allOf = message.allOf.map(e => e);
        }
        else {
            obj.allOf = [];
        }
        if (message.anyOf) {
            obj.anyOf = message.anyOf.map(e => e);
        }
        else {
            obj.anyOf = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseSignedBy();
        message.allOf = object.allOf?.map(e => e) || [];
        message.anyOf = object.anyOf?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            allOf: Array.isArray(object?.all_of) ? object.all_of.map((e) => e) : [],
            anyOf: Array.isArray(object?.any_of) ? object.any_of.map((e) => e) : []
        };
    },
    fromSDKJSON(object) {
        return {
            all_of: Array.isArray(object?.all_of) ? object.all_of.map((e) => String(e)) : [],
            any_of: Array.isArray(object?.any_of) ? object.any_of.map((e) => String(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.allOf) {
            obj.all_of = message.allOf.map(e => e);
        }
        else {
            obj.all_of = [];
        }
        if (message.anyOf) {
            obj.any_of = message.anyOf.map(e => e);
        }
        else {
            obj.any_of = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseSignedBy();
        message.allOf = object.all_of?.map(e => e) || [];
        message.anyOf = object.any_of?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.allOf) {
            obj.all_of = message.allOf.map(e => e);
        }
        else {
            obj.all_of = message.allOf;
        }
        if (message.anyOf) {
            obj.any_of = message.anyOf.map(e => e);
        }
        else {
            obj.any_of = message.anyOf;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return SignedBy.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/base/v1beta2/signed-by",
            value: SignedBy.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return SignedBy.decode(message.value);
    },
    toProto(message) {
        return SignedBy.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.base.v1beta2.SignedBy",
            value: SignedBy.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBasePlacementRequirements() {
    return {
        signedBy: SignedBy.fromPartial({}),
        attributes: []
    };
}
export const PlacementRequirements = {
    typeUrl: "/akash.base.v1beta2.PlacementRequirements",
    aminoType: "akash/base/v1beta2/placement-requirements",
    is(o) {
        return o && (o.$typeUrl === PlacementRequirements.typeUrl || SignedBy.is(o.signedBy) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.is(o.attributes[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === PlacementRequirements.typeUrl || SignedBy.isSDK(o.signed_by) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isSDK(o.attributes[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === PlacementRequirements.typeUrl || SignedBy.isAmino(o.signed_by) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isAmino(o.attributes[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.signedBy !== undefined) {
            SignedBy.encode(message.signedBy, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.attributes) {
            Attribute.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePlacementRequirements();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.signedBy = SignedBy.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.attributes.push(Attribute.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBasePlacementRequirements();
        if (isSet(object.signedBy))
            obj.signedBy = SignedBy.fromJSON(object.signedBy);
        if (Array.isArray(object?.attributes))
            obj.attributes = object.attributes.map((e) => Attribute.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.signedBy !== undefined && (obj.signedBy = message.signedBy ? SignedBy.toJSON(message.signedBy) : undefined);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toJSON(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBasePlacementRequirements();
        if (object.signedBy !== undefined && object.signedBy !== null) {
            message.signedBy = SignedBy.fromPartial(object.signedBy);
        }
        message.attributes = object.attributes?.map(e => Attribute.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            signedBy: object.signed_by ? SignedBy.fromSDK(object.signed_by) : undefined,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            signed_by: isSet(object.signed_by) ? SignedBy.fromSDKJSON(object.signed_by) : undefined,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        message.signedBy !== undefined && (obj.signed_by = message.signedBy ? SignedBy.toSDK(message.signedBy) : undefined);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toSDK(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBasePlacementRequirements();
        if (object.signed_by !== undefined && object.signed_by !== null) {
            message.signedBy = SignedBy.fromAmino(object.signed_by);
        }
        message.attributes = object.attributes?.map(e => Attribute.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.signed_by = message.signedBy ? SignedBy.toAmino(message.signedBy) : SignedBy.toAmino(SignedBy.fromPartial({}));
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toAmino(e) : undefined);
        }
        else {
            obj.attributes = message.attributes;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return PlacementRequirements.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/base/v1beta2/placement-requirements",
            value: PlacementRequirements.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return PlacementRequirements.decode(message.value);
    },
    toProto(message) {
        return PlacementRequirements.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.base.v1beta2.PlacementRequirements",
            value: PlacementRequirements.encode(message).finish()
        };
    },
    registerTypeUrl() {
        SignedBy.registerTypeUrl();
        Attribute.registerTypeUrl();
    }
};
