import { ResourceValue } from "./resourcevalue";
import { Attribute } from "./attribute";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.base.v1beta2";
function createBaseCPU() {
    return {
        units: ResourceValue.fromPartial({}),
        attributes: []
    };
}
export const CPU = {
    typeUrl: "/akash.base.v1beta2.CPU",
    aminoType: "akash/base/v1beta2/cpu",
    is(o) {
        return o && (o.$typeUrl === CPU.typeUrl || ResourceValue.is(o.units) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.is(o.attributes[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === CPU.typeUrl || ResourceValue.isSDK(o.units) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isSDK(o.attributes[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === CPU.typeUrl || ResourceValue.isAmino(o.units) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isAmino(o.attributes[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.units !== undefined) {
            ResourceValue.encode(message.units, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.attributes) {
            Attribute.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCPU();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.units = ResourceValue.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.attributes.push(Attribute.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCPU();
        if (isSet(object.units))
            obj.units = ResourceValue.fromJSON(object.units);
        if (Array.isArray(object?.attributes))
            obj.attributes = object.attributes.map((e) => Attribute.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.units !== undefined && (obj.units = message.units ? ResourceValue.toJSON(message.units) : undefined);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toJSON(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCPU();
        if (object.units !== undefined && object.units !== null) {
            message.units = ResourceValue.fromPartial(object.units);
        }
        message.attributes = object.attributes?.map(e => Attribute.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            units: object.units ? ResourceValue.fromSDK(object.units) : undefined,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            units: isSet(object.units) ? ResourceValue.fromSDKJSON(object.units) : undefined,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        message.units !== undefined && (obj.units = message.units ? ResourceValue.toSDK(message.units) : undefined);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toSDK(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCPU();
        if (object.units !== undefined && object.units !== null) {
            message.units = ResourceValue.fromAmino(object.units);
        }
        message.attributes = object.attributes?.map(e => Attribute.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.units = message.units ? ResourceValue.toAmino(message.units) : undefined;
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toAmino(e) : undefined);
        }
        else {
            obj.attributes = message.attributes;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return CPU.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/base/v1beta2/cpu",
            value: CPU.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return CPU.decode(message.value);
    },
    toProto(message) {
        return CPU.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.base.v1beta2.CPU",
            value: CPU.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ResourceValue.registerTypeUrl();
        Attribute.registerTypeUrl();
    }
};
function createBaseMemory() {
    return {
        quantity: ResourceValue.fromPartial({}),
        attributes: []
    };
}
export const Memory = {
    typeUrl: "/akash.base.v1beta2.Memory",
    aminoType: "akash/base/v1beta2/memory",
    is(o) {
        return o && (o.$typeUrl === Memory.typeUrl || ResourceValue.is(o.quantity) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.is(o.attributes[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Memory.typeUrl || ResourceValue.isSDK(o.quantity) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isSDK(o.attributes[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Memory.typeUrl || ResourceValue.isAmino(o.quantity) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isAmino(o.attributes[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.quantity !== undefined) {
            ResourceValue.encode(message.quantity, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.attributes) {
            Attribute.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMemory();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.quantity = ResourceValue.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.attributes.push(Attribute.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMemory();
        if (isSet(object.quantity))
            obj.quantity = ResourceValue.fromJSON(object.quantity);
        if (Array.isArray(object?.attributes))
            obj.attributes = object.attributes.map((e) => Attribute.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.quantity !== undefined && (obj.quantity = message.quantity ? ResourceValue.toJSON(message.quantity) : undefined);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toJSON(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMemory();
        if (object.quantity !== undefined && object.quantity !== null) {
            message.quantity = ResourceValue.fromPartial(object.quantity);
        }
        message.attributes = object.attributes?.map(e => Attribute.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            quantity: object.quantity ? ResourceValue.fromSDK(object.quantity) : undefined,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            quantity: isSet(object.quantity) ? ResourceValue.fromSDKJSON(object.quantity) : undefined,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        message.quantity !== undefined && (obj.quantity = message.quantity ? ResourceValue.toSDK(message.quantity) : undefined);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toSDK(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMemory();
        if (object.quantity !== undefined && object.quantity !== null) {
            message.quantity = ResourceValue.fromAmino(object.quantity);
        }
        message.attributes = object.attributes?.map(e => Attribute.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.quantity = message.quantity ? ResourceValue.toAmino(message.quantity) : ResourceValue.toAmino(ResourceValue.fromPartial({}));
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toAmino(e) : undefined);
        }
        else {
            obj.attributes = message.attributes;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Memory.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/base/v1beta2/memory",
            value: Memory.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Memory.decode(message.value);
    },
    toProto(message) {
        return Memory.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.base.v1beta2.Memory",
            value: Memory.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ResourceValue.registerTypeUrl();
        Attribute.registerTypeUrl();
    }
};
function createBaseStorage() {
    return {
        name: "",
        quantity: ResourceValue.fromPartial({}),
        attributes: []
    };
}
export const Storage = {
    typeUrl: "/akash.base.v1beta2.Storage",
    aminoType: "akash/base/v1beta2/storage",
    is(o) {
        return o && (o.$typeUrl === Storage.typeUrl || typeof o.name === "string" && ResourceValue.is(o.quantity) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.is(o.attributes[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Storage.typeUrl || typeof o.name === "string" && ResourceValue.isSDK(o.quantity) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isSDK(o.attributes[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Storage.typeUrl || typeof o.name === "string" && ResourceValue.isAmino(o.quantity) && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isAmino(o.attributes[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.quantity !== undefined) {
            ResourceValue.encode(message.quantity, writer.uint32(18).fork()).ldelim();
        }
        for (const v of message.attributes) {
            Attribute.encode(v, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseStorage();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.quantity = ResourceValue.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.attributes.push(Attribute.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseStorage();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.quantity))
            obj.quantity = ResourceValue.fromJSON(object.quantity);
        if (Array.isArray(object?.attributes))
            obj.attributes = object.attributes.map((e) => Attribute.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.quantity !== undefined && (obj.quantity = message.quantity ? ResourceValue.toJSON(message.quantity) : undefined);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toJSON(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseStorage();
        message.name = object.name ?? "";
        if (object.quantity !== undefined && object.quantity !== null) {
            message.quantity = ResourceValue.fromPartial(object.quantity);
        }
        message.attributes = object.attributes?.map(e => Attribute.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            quantity: object.quantity ? ResourceValue.fromSDK(object.quantity) : undefined,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            quantity: isSet(object.quantity) ? ResourceValue.fromSDKJSON(object.quantity) : undefined,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        message.quantity !== undefined && (obj.quantity = message.quantity ? ResourceValue.toSDK(message.quantity) : undefined);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toSDK(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseStorage();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.quantity !== undefined && object.quantity !== null) {
            message.quantity = ResourceValue.fromAmino(object.quantity);
        }
        message.attributes = object.attributes?.map(e => Attribute.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name ?? "";
        obj.quantity = message.quantity ? ResourceValue.toAmino(message.quantity) : ResourceValue.toAmino(ResourceValue.fromPartial({}));
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toAmino(e) : undefined);
        }
        else {
            obj.attributes = message.attributes;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Storage.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/base/v1beta2/storage",
            value: Storage.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Storage.decode(message.value);
    },
    toProto(message) {
        return Storage.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.base.v1beta2.Storage",
            value: Storage.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ResourceValue.registerTypeUrl();
        Attribute.registerTypeUrl();
    }
};
