import { CPU, CPUAmino, CPUSDKType, Memory, MemoryAmino, MemorySDKType, Storage, StorageAmino, StorageSDKType } from "./resource";
import { Endpoint, EndpointAmino, EndpointSDKType } from "./endpoint";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.base.v1beta2";
/**
 * ResourceUnits describes all available resources types for deployment/node etc
 * if field is nil resource is not present in the given data-structure
 */
export interface ResourceUnits {
    cpu?: CPU;
    memory?: Memory;
    storage: Storage[];
    endpoints: Endpoint[];
}
export interface ResourceUnitsProtoMsg {
    typeUrl: "/akash.base.v1beta2.ResourceUnits";
    value: Uint8Array;
}
/**
 * ResourceUnits describes all available resources types for deployment/node etc
 * if field is nil resource is not present in the given data-structure
 */
export interface ResourceUnitsAmino {
    cpu?: CPUAmino;
    memory?: MemoryAmino;
    storage?: StorageAmino[];
    endpoints: EndpointAmino[];
}
export interface ResourceUnitsAminoMsg {
    type: "akash/base/v1beta2/resource-units";
    value: ResourceUnitsAmino;
}
/**
 * ResourceUnits describes all available resources types for deployment/node etc
 * if field is nil resource is not present in the given data-structure
 */
export interface ResourceUnitsSDKType {
    cpu?: CPUSDKType;
    memory?: MemorySDKType;
    storage: StorageSDKType[];
    endpoints: EndpointSDKType[];
}
export declare const ResourceUnits: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is ResourceUnits;
    isSDK(o: any): o is ResourceUnitsSDKType;
    isAmino(o: any): o is ResourceUnitsAmino;
    encode(message: ResourceUnits, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ResourceUnits;
    fromJSON(object: any): ResourceUnits;
    toJSON(message: ResourceUnits): JsonSafe<ResourceUnits>;
    fromPartial<I extends Exact<DeepPartial<ResourceUnits>, I>>(object: I): ResourceUnits;
    fromSDK(object: ResourceUnitsSDKType): ResourceUnits;
    fromSDKJSON(object: any): ResourceUnitsSDKType;
    toSDK(message: ResourceUnits): ResourceUnitsSDKType;
    fromAmino(object: ResourceUnitsAmino): ResourceUnits;
    toAmino(message: ResourceUnits): ResourceUnitsAmino;
    fromAminoMsg(object: ResourceUnitsAminoMsg): ResourceUnits;
    toAminoMsg(message: ResourceUnits): ResourceUnitsAminoMsg;
    fromProtoMsg(message: ResourceUnitsProtoMsg): ResourceUnits;
    toProto(message: ResourceUnits): Uint8Array;
    toProtoMsg(message: ResourceUnits): ResourceUnitsProtoMsg;
    registerTypeUrl(): void;
};
