import { TelescopeGeneratedType } from "../../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgCreateCertificate, MsgRevokeCertificate } from "./cert";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        createCertificate(value: MsgCreateCertificate): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        revokeCertificate(value: MsgRevokeCertificate): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        createCertificate(value: MsgCreateCertificate): {
            typeUrl: string;
            value: MsgCreateCertificate;
        };
        revokeCertificate(value: MsgRevokeCertificate): {
            typeUrl: string;
            value: MsgRevokeCertificate;
        };
    };
    toJSON: {
        createCertificate(value: MsgCreateCertificate): {
            typeUrl: string;
            value: {
                owner: string;
                cert: string;
                pubkey: string;
            };
        };
        revokeCertificate(value: MsgRevokeCertificate): {
            typeUrl: string;
            value: {
                id: {
                    owner: string;
                    serial: string;
                };
            };
        };
    };
    fromJSON: {
        createCertificate(value: any): {
            typeUrl: string;
            value: MsgCreateCertificate;
        };
        revokeCertificate(value: any): {
            typeUrl: string;
            value: MsgRevokeCertificate;
        };
    };
    fromPartial: {
        createCertificate(value: MsgCreateCertificate): {
            typeUrl: string;
            value: MsgCreateCertificate;
        };
        revokeCertificate(value: MsgRevokeCertificate): {
            typeUrl: string;
            value: MsgRevokeCertificate;
        };
    };
};
