import { DeliverTxResponse, StdFee, TxRpc } from "../../../types";
import { MsgCreateCertificate, MsgRevokeCertificate } from "./cert";
/** Msg defines the provider Msg service */
export interface Msg {
    /** CreateCertificate defines a method to create new certificate given proper inputs. */
    createCertificate(signerAddress: string, message: MsgCreateCertificate, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    /** RevokeCertificate defines a method to revoke the certificate */
    revokeCertificate(signerAddress: string, message: MsgRevokeCertificate, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
}
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    constructor(rpc: TxRpc);
    createCertificate: (signerAddress: string, message: MsgCreateCertificate, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    revokeCertificate: (signerAddress: string, message: MsgRevokeCertificate, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
}
export declare const createClientImpl: (rpc: TxRpc) => MsgClientImpl;
