import { MsgCreateCertificate, MsgRevokeCertificate } from "./cert";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* CreateCertificate defines a method to create new certificate given proper inputs. */
    createCertificate = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgCreateCertificate.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* RevokeCertificate defines a method to revoke the certificate */
    revokeCertificate = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgRevokeCertificate.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
