import { Certificate, CertificateAmino, CertificateSDKType } from "./cert";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.cert.v1beta2";
/** GenesisCertificate defines certificate entry at genesis */
export interface GenesisCertificate {
    owner: string;
    certificate: Certificate;
}
export interface GenesisCertificateProtoMsg {
    typeUrl: "/akash.cert.v1beta2.GenesisCertificate";
    value: Uint8Array;
}
/** GenesisCertificate defines certificate entry at genesis */
export interface GenesisCertificateAmino {
    owner: string;
    certificate: CertificateAmino;
}
export interface GenesisCertificateAminoMsg {
    type: "akash/cert/v1beta2/genesis-certificate";
    value: GenesisCertificateAmino;
}
/** GenesisCertificate defines certificate entry at genesis */
export interface GenesisCertificateSDKType {
    owner: string;
    certificate: CertificateSDKType;
}
/** GenesisState defines the basic genesis state used by cert module */
export interface GenesisState {
    certificates: GenesisCertificate[];
}
export interface GenesisStateProtoMsg {
    typeUrl: "/akash.cert.v1beta2.GenesisState";
    value: Uint8Array;
}
/** GenesisState defines the basic genesis state used by cert module */
export interface GenesisStateAmino {
    certificates: GenesisCertificateAmino[];
}
export interface GenesisStateAminoMsg {
    type: "akash/cert/v1beta2/genesis-state";
    value: GenesisStateAmino;
}
/** GenesisState defines the basic genesis state used by cert module */
export interface GenesisStateSDKType {
    certificates: GenesisCertificateSDKType[];
}
export declare const GenesisCertificate: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is GenesisCertificate;
    isSDK(o: any): o is GenesisCertificateSDKType;
    isAmino(o: any): o is GenesisCertificateAmino;
    encode(message: GenesisCertificate, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GenesisCertificate;
    fromJSON(object: any): GenesisCertificate;
    toJSON(message: GenesisCertificate): JsonSafe<GenesisCertificate>;
    fromPartial<I extends Exact<DeepPartial<GenesisCertificate>, I>>(object: I): GenesisCertificate;
    fromSDK(object: GenesisCertificateSDKType): GenesisCertificate;
    fromSDKJSON(object: any): GenesisCertificateSDKType;
    toSDK(message: GenesisCertificate): GenesisCertificateSDKType;
    fromAmino(object: GenesisCertificateAmino): GenesisCertificate;
    toAmino(message: GenesisCertificate): GenesisCertificateAmino;
    fromAminoMsg(object: GenesisCertificateAminoMsg): GenesisCertificate;
    toAminoMsg(message: GenesisCertificate): GenesisCertificateAminoMsg;
    fromProtoMsg(message: GenesisCertificateProtoMsg): GenesisCertificate;
    toProto(message: GenesisCertificate): Uint8Array;
    toProtoMsg(message: GenesisCertificate): GenesisCertificateProtoMsg;
    registerTypeUrl(): void;
};
export declare const GenesisState: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is GenesisState;
    isSDK(o: any): o is GenesisStateSDKType;
    isAmino(o: any): o is GenesisStateAmino;
    encode(message: GenesisState, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GenesisState;
    fromJSON(object: any): GenesisState;
    toJSON(message: GenesisState): JsonSafe<GenesisState>;
    fromPartial<I extends Exact<DeepPartial<GenesisState>, I>>(object: I): GenesisState;
    fromSDK(object: GenesisStateSDKType): GenesisState;
    fromSDKJSON(object: any): GenesisStateSDKType;
    toSDK(message: GenesisState): GenesisStateSDKType;
    fromAmino(object: GenesisStateAmino): GenesisState;
    toAmino(message: GenesisState): GenesisStateAmino;
    fromAminoMsg(object: GenesisStateAminoMsg): GenesisState;
    toAminoMsg(message: GenesisState): GenesisStateAminoMsg;
    fromProtoMsg(message: GenesisStateProtoMsg): GenesisState;
    toProto(message: GenesisState): Uint8Array;
    toProtoMsg(message: GenesisState): GenesisStateProtoMsg;
    registerTypeUrl(): void;
};
