import { CertificateFilter, CertificateFilterAmino, CertificateFilterSDKType, Certificate, CertificateAmino, CertificateSDKType } from "./cert";
import { PageRequest, PageRequestAmino, PageRequestSDKType, PageResponse, PageResponseAmino, PageResponseSDKType } from "../../../cosmos/base/query/v1beta1/pagination";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.cert.v1beta2";
/** CertificateResponse contains a single X509 certificate and its serial number */
export interface CertificateResponse {
    certificate: Certificate;
    serial: string;
}
export interface CertificateResponseProtoMsg {
    typeUrl: "/akash.cert.v1beta2.CertificateResponse";
    value: Uint8Array;
}
/** CertificateResponse contains a single X509 certificate and its serial number */
export interface CertificateResponseAmino {
    certificate: CertificateAmino;
    serial: string;
}
export interface CertificateResponseAminoMsg {
    type: "akash/cert/v1beta2/certificate-response";
    value: CertificateResponseAmino;
}
/** CertificateResponse contains a single X509 certificate and its serial number */
export interface CertificateResponseSDKType {
    certificate: CertificateSDKType;
    serial: string;
}
/** QueryDeploymentsRequest is request type for the Query/Deployments RPC method */
export interface QueryCertificatesRequest {
    filter: CertificateFilter;
    pagination?: PageRequest;
}
export interface QueryCertificatesRequestProtoMsg {
    typeUrl: "/akash.cert.v1beta2.QueryCertificatesRequest";
    value: Uint8Array;
}
/** QueryDeploymentsRequest is request type for the Query/Deployments RPC method */
export interface QueryCertificatesRequestAmino {
    filter?: CertificateFilterAmino;
    pagination?: PageRequestAmino;
}
export interface QueryCertificatesRequestAminoMsg {
    type: "akash/cert/v1beta2/query-certificates-request";
    value: QueryCertificatesRequestAmino;
}
/** QueryDeploymentsRequest is request type for the Query/Deployments RPC method */
export interface QueryCertificatesRequestSDKType {
    filter: CertificateFilterSDKType;
    pagination?: PageRequestSDKType;
}
/** QueryCertificatesResponse is response type for the Query/Certificates RPC method */
export interface QueryCertificatesResponse {
    certificates: CertificateResponse[];
    pagination?: PageResponse;
}
export interface QueryCertificatesResponseProtoMsg {
    typeUrl: "/akash.cert.v1beta2.QueryCertificatesResponse";
    value: Uint8Array;
}
/** QueryCertificatesResponse is response type for the Query/Certificates RPC method */
export interface QueryCertificatesResponseAmino {
    certificates?: CertificateResponseAmino[];
    pagination?: PageResponseAmino;
}
export interface QueryCertificatesResponseAminoMsg {
    type: "akash/cert/v1beta2/query-certificates-response";
    value: QueryCertificatesResponseAmino;
}
/** QueryCertificatesResponse is response type for the Query/Certificates RPC method */
export interface QueryCertificatesResponseSDKType {
    certificates: CertificateResponseSDKType[];
    pagination?: PageResponseSDKType;
}
export declare const CertificateResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is CertificateResponse;
    isSDK(o: any): o is CertificateResponseSDKType;
    isAmino(o: any): o is CertificateResponseAmino;
    encode(message: CertificateResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): CertificateResponse;
    fromJSON(object: any): CertificateResponse;
    toJSON(message: CertificateResponse): JsonSafe<CertificateResponse>;
    fromPartial<I extends Exact<DeepPartial<CertificateResponse>, I>>(object: I): CertificateResponse;
    fromSDK(object: CertificateResponseSDKType): CertificateResponse;
    fromSDKJSON(object: any): CertificateResponseSDKType;
    toSDK(message: CertificateResponse): CertificateResponseSDKType;
    fromAmino(object: CertificateResponseAmino): CertificateResponse;
    toAmino(message: CertificateResponse): CertificateResponseAmino;
    fromAminoMsg(object: CertificateResponseAminoMsg): CertificateResponse;
    toAminoMsg(message: CertificateResponse): CertificateResponseAminoMsg;
    fromProtoMsg(message: CertificateResponseProtoMsg): CertificateResponse;
    toProto(message: CertificateResponse): Uint8Array;
    toProtoMsg(message: CertificateResponse): CertificateResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryCertificatesRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryCertificatesRequest;
    isSDK(o: any): o is QueryCertificatesRequestSDKType;
    isAmino(o: any): o is QueryCertificatesRequestAmino;
    encode(message: QueryCertificatesRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryCertificatesRequest;
    fromJSON(object: any): QueryCertificatesRequest;
    toJSON(message: QueryCertificatesRequest): JsonSafe<QueryCertificatesRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryCertificatesRequest>, I>>(object: I): QueryCertificatesRequest;
    fromSDK(object: QueryCertificatesRequestSDKType): QueryCertificatesRequest;
    fromSDKJSON(object: any): QueryCertificatesRequestSDKType;
    toSDK(message: QueryCertificatesRequest): QueryCertificatesRequestSDKType;
    fromAmino(object: QueryCertificatesRequestAmino): QueryCertificatesRequest;
    toAmino(message: QueryCertificatesRequest): QueryCertificatesRequestAmino;
    fromAminoMsg(object: QueryCertificatesRequestAminoMsg): QueryCertificatesRequest;
    toAminoMsg(message: QueryCertificatesRequest): QueryCertificatesRequestAminoMsg;
    fromProtoMsg(message: QueryCertificatesRequestProtoMsg): QueryCertificatesRequest;
    toProto(message: QueryCertificatesRequest): Uint8Array;
    toProtoMsg(message: QueryCertificatesRequest): QueryCertificatesRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryCertificatesResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryCertificatesResponse;
    isSDK(o: any): o is QueryCertificatesResponseSDKType;
    isAmino(o: any): o is QueryCertificatesResponseAmino;
    encode(message: QueryCertificatesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryCertificatesResponse;
    fromJSON(object: any): QueryCertificatesResponse;
    toJSON(message: QueryCertificatesResponse): JsonSafe<QueryCertificatesResponse>;
    fromPartial<I extends Exact<DeepPartial<QueryCertificatesResponse>, I>>(object: I): QueryCertificatesResponse;
    fromSDK(object: QueryCertificatesResponseSDKType): QueryCertificatesResponse;
    fromSDKJSON(object: any): QueryCertificatesResponseSDKType;
    toSDK(message: QueryCertificatesResponse): QueryCertificatesResponseSDKType;
    fromAmino(object: QueryCertificatesResponseAmino): QueryCertificatesResponse;
    toAmino(message: QueryCertificatesResponse): QueryCertificatesResponseAmino;
    fromAminoMsg(object: QueryCertificatesResponseAminoMsg): QueryCertificatesResponse;
    toAminoMsg(message: QueryCertificatesResponse): QueryCertificatesResponseAminoMsg;
    fromProtoMsg(message: QueryCertificatesResponseProtoMsg): QueryCertificatesResponse;
    toProto(message: QueryCertificatesResponse): Uint8Array;
    toProtoMsg(message: QueryCertificatesResponse): QueryCertificatesResponseProtoMsg;
    registerTypeUrl(): void;
};
