import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { GlobalDecoderRegistry } from "../../../registry";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.deployment.v1beta1";
function createBaseDepositDeploymentAuthorization() {
    return {
        $typeUrl: "/akash.deployment.v1beta1.DepositDeploymentAuthorization",
        spendLimit: Coin.fromPartial({})
    };
}
export const DepositDeploymentAuthorization = {
    typeUrl: "/akash.deployment.v1beta1.DepositDeploymentAuthorization",
    aminoType: "akash/deployment/deposit-deployment-authorization",
    is(o) {
        return o && (o.$typeUrl === DepositDeploymentAuthorization.typeUrl || Coin.is(o.spendLimit));
    },
    isSDK(o) {
        return o && (o.$typeUrl === DepositDeploymentAuthorization.typeUrl || Coin.isSDK(o.spend_limit));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.spendLimit !== undefined) {
            Coin.encode(message.spendLimit, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDepositDeploymentAuthorization();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.spendLimit = Coin.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDepositDeploymentAuthorization();
        if (isSet(object.spendLimit))
            obj.spendLimit = Coin.fromJSON(object.spendLimit);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.spendLimit !== undefined && (obj.spendLimit = message.spendLimit ? Coin.toJSON(message.spendLimit) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDepositDeploymentAuthorization();
        if (object.spendLimit !== undefined && object.spendLimit !== null) {
            message.spendLimit = Coin.fromPartial(object.spendLimit);
        }
        return message;
    },
    fromSDK(object) {
        return {
            spendLimit: object.spend_limit ? Coin.fromSDK(object.spend_limit) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            spend_limit: isSet(object.spend_limit) ? Coin.fromSDKJSON(object.spend_limit) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.spendLimit !== undefined && (obj.spend_limit = message.spendLimit ? Coin.toSDK(message.spendLimit) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDepositDeploymentAuthorization();
        if (object.spend_limit !== undefined && object.spend_limit !== null) {
            message.spendLimit = Coin.fromAmino(object.spend_limit);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.spend_limit = message.spendLimit ? Coin.toAmino(message.spendLimit) : Coin.toAmino(Coin.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return DepositDeploymentAuthorization.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/deposit-deployment-authorization",
            value: DepositDeploymentAuthorization.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return DepositDeploymentAuthorization.decode(message.value);
    },
    toProto(message) {
        return DepositDeploymentAuthorization.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.DepositDeploymentAuthorization",
            value: DepositDeploymentAuthorization.encode(message).finish()
        };
    },
    registerTypeUrl() {
        GlobalDecoderRegistry.register(DepositDeploymentAuthorization.typeUrl, DepositDeploymentAuthorization);
        GlobalDecoderRegistry.registerAminoProtoMapping(DepositDeploymentAuthorization.aminoType, DepositDeploymentAuthorization.typeUrl);
        Coin.registerTypeUrl();
    }
};
