import { GroupSpec, GroupSpecAmino, GroupSpecSDKType } from "./group";
import { Coin, CoinAmino, CoinSDKType } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
import { DeliverTxResponse, StdFee, TxRpc } from "../../../types";
export declare const protobufPackage = "akash.deployment.v1beta1";
/** State is an enum which refers to state of deployment */
export declare enum Deployment_State {
    /** invalid - Prefix should start with 0 in enum. So declaring dummy state */
    invalid = 0,
    /** active - DeploymentActive denotes state for deployment active */
    active = 1,
    /** closed - DeploymentClosed denotes state for deployment closed */
    closed = 2,
    UNRECOGNIZED = -1
}
export declare const Deployment_StateSDKType: typeof Deployment_State;
export declare const Deployment_StateAmino: typeof Deployment_State;
export declare function deployment_StateFromJSON(object: any): Deployment_State;
export declare function deployment_StateToJSON(object: Deployment_State): string;
/** MsgCreateDeployment defines an SDK message for creating deployment */
export interface MsgCreateDeployment {
    id: DeploymentID | undefined;
    groups: GroupSpec[];
    version: Uint8Array;
    deposit: Coin | undefined;
}
export interface MsgCreateDeploymentProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.MsgCreateDeployment";
    value: Uint8Array;
}
/** MsgCreateDeployment defines an SDK message for creating deployment */
export interface MsgCreateDeploymentAmino {
    id: DeploymentIDAmino | undefined;
    groups: GroupSpecAmino[];
    version: string;
    deposit: CoinAmino | undefined;
}
export interface MsgCreateDeploymentAminoMsg {
    type: "akash/deployment/testonly-create-deployment";
    value: MsgCreateDeploymentAmino;
}
/** MsgCreateDeployment defines an SDK message for creating deployment */
export interface MsgCreateDeploymentSDKType {
    id: DeploymentIDSDKType | undefined;
    groups: GroupSpecSDKType[];
    version: Uint8Array;
    deposit: CoinSDKType | undefined;
}
/** MsgCreateDeploymentResponse defines the Msg/CreateDeployment response type. */
export interface MsgCreateDeploymentResponse {
}
export interface MsgCreateDeploymentResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.MsgCreateDeploymentResponse";
    value: Uint8Array;
}
/** MsgCreateDeploymentResponse defines the Msg/CreateDeployment response type. */
export interface MsgCreateDeploymentResponseAmino {
}
export interface MsgCreateDeploymentResponseAminoMsg {
    type: "akash/deployment/testonly-create-deployment-response";
    value: MsgCreateDeploymentResponseAmino;
}
/** MsgCreateDeploymentResponse defines the Msg/CreateDeployment response type. */
export interface MsgCreateDeploymentResponseSDKType {
}
/** MsgDepositDeployment deposits more funds into the deposit account */
export interface MsgDepositDeployment {
    id: DeploymentID | undefined;
    amount: Coin | undefined;
}
export interface MsgDepositDeploymentProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.MsgDepositDeployment";
    value: Uint8Array;
}
/** MsgDepositDeployment deposits more funds into the deposit account */
export interface MsgDepositDeploymentAmino {
    id: DeploymentIDAmino | undefined;
    amount: CoinAmino | undefined;
}
export interface MsgDepositDeploymentAminoMsg {
    type: "akash/deployment/testonly-deposit-deployment";
    value: MsgDepositDeploymentAmino;
}
/** MsgDepositDeployment deposits more funds into the deposit account */
export interface MsgDepositDeploymentSDKType {
    id: DeploymentIDSDKType | undefined;
    amount: CoinSDKType | undefined;
}
/** MsgCreateDeploymentResponse defines the Msg/CreateDeployment response type. */
export interface MsgDepositDeploymentResponse {
}
export interface MsgDepositDeploymentResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.MsgDepositDeploymentResponse";
    value: Uint8Array;
}
/** MsgCreateDeploymentResponse defines the Msg/CreateDeployment response type. */
export interface MsgDepositDeploymentResponseAmino {
}
export interface MsgDepositDeploymentResponseAminoMsg {
    type: "akash/deployment/testonly-deposit-deployment-response";
    value: MsgDepositDeploymentResponseAmino;
}
/** MsgCreateDeploymentResponse defines the Msg/CreateDeployment response type. */
export interface MsgDepositDeploymentResponseSDKType {
}
/** MsgUpdateDeployment defines an SDK message for updating deployment */
export interface MsgUpdateDeployment {
    id: DeploymentID | undefined;
    groups: GroupSpec[];
    version: Uint8Array;
}
export interface MsgUpdateDeploymentProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.MsgUpdateDeployment";
    value: Uint8Array;
}
/** MsgUpdateDeployment defines an SDK message for updating deployment */
export interface MsgUpdateDeploymentAmino {
    id: DeploymentIDAmino | undefined;
    groups: GroupSpecAmino[];
    version: string;
}
export interface MsgUpdateDeploymentAminoMsg {
    type: "akash/deployment/testonly-update-deployment";
    value: MsgUpdateDeploymentAmino;
}
/** MsgUpdateDeployment defines an SDK message for updating deployment */
export interface MsgUpdateDeploymentSDKType {
    id: DeploymentIDSDKType | undefined;
    groups: GroupSpecSDKType[];
    version: Uint8Array;
}
/** MsgUpdateDeploymentResponse defines the Msg/UpdateDeployment response type. */
export interface MsgUpdateDeploymentResponse {
}
export interface MsgUpdateDeploymentResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.MsgUpdateDeploymentResponse";
    value: Uint8Array;
}
/** MsgUpdateDeploymentResponse defines the Msg/UpdateDeployment response type. */
export interface MsgUpdateDeploymentResponseAmino {
}
export interface MsgUpdateDeploymentResponseAminoMsg {
    type: "akash/deployment/testonly-update-deployment-response";
    value: MsgUpdateDeploymentResponseAmino;
}
/** MsgUpdateDeploymentResponse defines the Msg/UpdateDeployment response type. */
export interface MsgUpdateDeploymentResponseSDKType {
}
/** MsgCloseDeployment defines an SDK message for closing deployment */
export interface MsgCloseDeployment {
    id: DeploymentID | undefined;
}
export interface MsgCloseDeploymentProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.MsgCloseDeployment";
    value: Uint8Array;
}
/** MsgCloseDeployment defines an SDK message for closing deployment */
export interface MsgCloseDeploymentAmino {
    id: DeploymentIDAmino | undefined;
}
export interface MsgCloseDeploymentAminoMsg {
    type: "akash/deployment/testonly-close-deployment";
    value: MsgCloseDeploymentAmino;
}
/** MsgCloseDeployment defines an SDK message for closing deployment */
export interface MsgCloseDeploymentSDKType {
    id: DeploymentIDSDKType | undefined;
}
/** MsgCloseDeploymentResponse defines the Msg/CloseDeployment response type. */
export interface MsgCloseDeploymentResponse {
}
export interface MsgCloseDeploymentResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.MsgCloseDeploymentResponse";
    value: Uint8Array;
}
/** MsgCloseDeploymentResponse defines the Msg/CloseDeployment response type. */
export interface MsgCloseDeploymentResponseAmino {
}
export interface MsgCloseDeploymentResponseAminoMsg {
    type: "akash/deployment/testonly-close-deployment-response";
    value: MsgCloseDeploymentResponseAmino;
}
/** MsgCloseDeploymentResponse defines the Msg/CloseDeployment response type. */
export interface MsgCloseDeploymentResponseSDKType {
}
/** DeploymentID stores owner and sequence number */
export interface DeploymentID {
    owner: string;
    dseq: bigint;
}
export interface DeploymentIDProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.DeploymentID";
    value: Uint8Array;
}
/** DeploymentID stores owner and sequence number */
export interface DeploymentIDAmino {
    owner: string;
    dseq: string;
}
export interface DeploymentIDAminoMsg {
    type: "akash/deployment/deployment-i-d";
    value: DeploymentIDAmino;
}
/** DeploymentID stores owner and sequence number */
export interface DeploymentIDSDKType {
    owner: string;
    dseq: bigint;
}
/** Deployment stores deploymentID, state and version details */
export interface Deployment {
    deploymentId: DeploymentID | undefined;
    state: Deployment_State;
    version: Uint8Array;
    createdAt: bigint;
}
export interface DeploymentProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.Deployment";
    value: Uint8Array;
}
/** Deployment stores deploymentID, state and version details */
export interface DeploymentAmino {
    deployment_id: DeploymentIDAmino | undefined;
    state: Deployment_State;
    version: string;
    created_at?: string;
}
export interface DeploymentAminoMsg {
    type: "akash/deployment/deployment";
    value: DeploymentAmino;
}
/** Deployment stores deploymentID, state and version details */
export interface DeploymentSDKType {
    deployment_id: DeploymentIDSDKType | undefined;
    state: Deployment_State;
    version: Uint8Array;
    created_at: bigint;
}
/** DeploymentFilters defines filters used to filter deployments */
export interface DeploymentFilters {
    owner: string;
    dseq: bigint;
    state: string;
}
export interface DeploymentFiltersProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.DeploymentFilters";
    value: Uint8Array;
}
/** DeploymentFilters defines filters used to filter deployments */
export interface DeploymentFiltersAmino {
    owner: string;
    dseq: string;
    state: string;
}
export interface DeploymentFiltersAminoMsg {
    type: "akash/deployment/deployment-filters";
    value: DeploymentFiltersAmino;
}
/** DeploymentFilters defines filters used to filter deployments */
export interface DeploymentFiltersSDKType {
    owner: string;
    dseq: bigint;
    state: string;
}
export declare const MsgCreateDeployment: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCreateDeployment;
    isSDK(o: any): o is MsgCreateDeploymentSDKType;
    encode(message: MsgCreateDeployment, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCreateDeployment;
    fromJSON(object: any): MsgCreateDeployment;
    toJSON(message: MsgCreateDeployment): JsonSafe<MsgCreateDeployment>;
    fromPartial<I extends Exact<Partial<MsgCreateDeployment>, I>>(object: I): MsgCreateDeployment;
    fromSDK(object: MsgCreateDeploymentSDKType): MsgCreateDeployment;
    fromSDKJSON(object: any): MsgCreateDeploymentSDKType;
    toSDK(message: MsgCreateDeployment): MsgCreateDeploymentSDKType;
    fromAmino(object: MsgCreateDeploymentAmino): MsgCreateDeployment;
    toAmino(message: MsgCreateDeployment): MsgCreateDeploymentAmino;
    fromAminoMsg(object: MsgCreateDeploymentAminoMsg): MsgCreateDeployment;
    toAminoMsg(message: MsgCreateDeployment): MsgCreateDeploymentAminoMsg;
    fromProtoMsg(message: MsgCreateDeploymentProtoMsg): MsgCreateDeployment;
    toProto(message: MsgCreateDeployment): Uint8Array;
    toProtoMsg(message: MsgCreateDeployment): MsgCreateDeploymentProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgCreateDeploymentResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCreateDeploymentResponse;
    isSDK(o: any): o is MsgCreateDeploymentResponseSDKType;
    encode(_: MsgCreateDeploymentResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCreateDeploymentResponse;
    fromJSON(_: any): MsgCreateDeploymentResponse;
    toJSON(_: MsgCreateDeploymentResponse): JsonSafe<MsgCreateDeploymentResponse>;
    fromPartial<I extends Exact<Partial<MsgCreateDeploymentResponse>, I>>(_: I): MsgCreateDeploymentResponse;
    fromSDK(_: MsgCreateDeploymentResponseSDKType): MsgCreateDeploymentResponse;
    fromSDKJSON(_: any): MsgCreateDeploymentResponseSDKType;
    toSDK(_: MsgCreateDeploymentResponse): MsgCreateDeploymentResponseSDKType;
    fromAmino(_: MsgCreateDeploymentResponseAmino): MsgCreateDeploymentResponse;
    toAmino(_: MsgCreateDeploymentResponse): MsgCreateDeploymentResponseAmino;
    fromAminoMsg(object: MsgCreateDeploymentResponseAminoMsg): MsgCreateDeploymentResponse;
    toAminoMsg(message: MsgCreateDeploymentResponse): MsgCreateDeploymentResponseAminoMsg;
    fromProtoMsg(message: MsgCreateDeploymentResponseProtoMsg): MsgCreateDeploymentResponse;
    toProto(message: MsgCreateDeploymentResponse): Uint8Array;
    toProtoMsg(message: MsgCreateDeploymentResponse): MsgCreateDeploymentResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgDepositDeployment: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgDepositDeployment;
    isSDK(o: any): o is MsgDepositDeploymentSDKType;
    encode(message: MsgDepositDeployment, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgDepositDeployment;
    fromJSON(object: any): MsgDepositDeployment;
    toJSON(message: MsgDepositDeployment): JsonSafe<MsgDepositDeployment>;
    fromPartial<I extends Exact<Partial<MsgDepositDeployment>, I>>(object: I): MsgDepositDeployment;
    fromSDK(object: MsgDepositDeploymentSDKType): MsgDepositDeployment;
    fromSDKJSON(object: any): MsgDepositDeploymentSDKType;
    toSDK(message: MsgDepositDeployment): MsgDepositDeploymentSDKType;
    fromAmino(object: MsgDepositDeploymentAmino): MsgDepositDeployment;
    toAmino(message: MsgDepositDeployment): MsgDepositDeploymentAmino;
    fromAminoMsg(object: MsgDepositDeploymentAminoMsg): MsgDepositDeployment;
    toAminoMsg(message: MsgDepositDeployment): MsgDepositDeploymentAminoMsg;
    fromProtoMsg(message: MsgDepositDeploymentProtoMsg): MsgDepositDeployment;
    toProto(message: MsgDepositDeployment): Uint8Array;
    toProtoMsg(message: MsgDepositDeployment): MsgDepositDeploymentProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgDepositDeploymentResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgDepositDeploymentResponse;
    isSDK(o: any): o is MsgDepositDeploymentResponseSDKType;
    encode(_: MsgDepositDeploymentResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgDepositDeploymentResponse;
    fromJSON(_: any): MsgDepositDeploymentResponse;
    toJSON(_: MsgDepositDeploymentResponse): JsonSafe<MsgDepositDeploymentResponse>;
    fromPartial<I extends Exact<Partial<MsgDepositDeploymentResponse>, I>>(_: I): MsgDepositDeploymentResponse;
    fromSDK(_: MsgDepositDeploymentResponseSDKType): MsgDepositDeploymentResponse;
    fromSDKJSON(_: any): MsgDepositDeploymentResponseSDKType;
    toSDK(_: MsgDepositDeploymentResponse): MsgDepositDeploymentResponseSDKType;
    fromAmino(_: MsgDepositDeploymentResponseAmino): MsgDepositDeploymentResponse;
    toAmino(_: MsgDepositDeploymentResponse): MsgDepositDeploymentResponseAmino;
    fromAminoMsg(object: MsgDepositDeploymentResponseAminoMsg): MsgDepositDeploymentResponse;
    toAminoMsg(message: MsgDepositDeploymentResponse): MsgDepositDeploymentResponseAminoMsg;
    fromProtoMsg(message: MsgDepositDeploymentResponseProtoMsg): MsgDepositDeploymentResponse;
    toProto(message: MsgDepositDeploymentResponse): Uint8Array;
    toProtoMsg(message: MsgDepositDeploymentResponse): MsgDepositDeploymentResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgUpdateDeployment: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgUpdateDeployment;
    isSDK(o: any): o is MsgUpdateDeploymentSDKType;
    encode(message: MsgUpdateDeployment, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgUpdateDeployment;
    fromJSON(object: any): MsgUpdateDeployment;
    toJSON(message: MsgUpdateDeployment): JsonSafe<MsgUpdateDeployment>;
    fromPartial<I extends Exact<Partial<MsgUpdateDeployment>, I>>(object: I): MsgUpdateDeployment;
    fromSDK(object: MsgUpdateDeploymentSDKType): MsgUpdateDeployment;
    fromSDKJSON(object: any): MsgUpdateDeploymentSDKType;
    toSDK(message: MsgUpdateDeployment): MsgUpdateDeploymentSDKType;
    fromAmino(object: MsgUpdateDeploymentAmino): MsgUpdateDeployment;
    toAmino(message: MsgUpdateDeployment): MsgUpdateDeploymentAmino;
    fromAminoMsg(object: MsgUpdateDeploymentAminoMsg): MsgUpdateDeployment;
    toAminoMsg(message: MsgUpdateDeployment): MsgUpdateDeploymentAminoMsg;
    fromProtoMsg(message: MsgUpdateDeploymentProtoMsg): MsgUpdateDeployment;
    toProto(message: MsgUpdateDeployment): Uint8Array;
    toProtoMsg(message: MsgUpdateDeployment): MsgUpdateDeploymentProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgUpdateDeploymentResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgUpdateDeploymentResponse;
    isSDK(o: any): o is MsgUpdateDeploymentResponseSDKType;
    encode(_: MsgUpdateDeploymentResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgUpdateDeploymentResponse;
    fromJSON(_: any): MsgUpdateDeploymentResponse;
    toJSON(_: MsgUpdateDeploymentResponse): JsonSafe<MsgUpdateDeploymentResponse>;
    fromPartial<I extends Exact<Partial<MsgUpdateDeploymentResponse>, I>>(_: I): MsgUpdateDeploymentResponse;
    fromSDK(_: MsgUpdateDeploymentResponseSDKType): MsgUpdateDeploymentResponse;
    fromSDKJSON(_: any): MsgUpdateDeploymentResponseSDKType;
    toSDK(_: MsgUpdateDeploymentResponse): MsgUpdateDeploymentResponseSDKType;
    fromAmino(_: MsgUpdateDeploymentResponseAmino): MsgUpdateDeploymentResponse;
    toAmino(_: MsgUpdateDeploymentResponse): MsgUpdateDeploymentResponseAmino;
    fromAminoMsg(object: MsgUpdateDeploymentResponseAminoMsg): MsgUpdateDeploymentResponse;
    toAminoMsg(message: MsgUpdateDeploymentResponse): MsgUpdateDeploymentResponseAminoMsg;
    fromProtoMsg(message: MsgUpdateDeploymentResponseProtoMsg): MsgUpdateDeploymentResponse;
    toProto(message: MsgUpdateDeploymentResponse): Uint8Array;
    toProtoMsg(message: MsgUpdateDeploymentResponse): MsgUpdateDeploymentResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgCloseDeployment: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCloseDeployment;
    isSDK(o: any): o is MsgCloseDeploymentSDKType;
    encode(message: MsgCloseDeployment, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCloseDeployment;
    fromJSON(object: any): MsgCloseDeployment;
    toJSON(message: MsgCloseDeployment): JsonSafe<MsgCloseDeployment>;
    fromPartial<I extends Exact<Partial<MsgCloseDeployment>, I>>(object: I): MsgCloseDeployment;
    fromSDK(object: MsgCloseDeploymentSDKType): MsgCloseDeployment;
    fromSDKJSON(object: any): MsgCloseDeploymentSDKType;
    toSDK(message: MsgCloseDeployment): MsgCloseDeploymentSDKType;
    fromAmino(object: MsgCloseDeploymentAmino): MsgCloseDeployment;
    toAmino(message: MsgCloseDeployment): MsgCloseDeploymentAmino;
    fromAminoMsg(object: MsgCloseDeploymentAminoMsg): MsgCloseDeployment;
    toAminoMsg(message: MsgCloseDeployment): MsgCloseDeploymentAminoMsg;
    fromProtoMsg(message: MsgCloseDeploymentProtoMsg): MsgCloseDeployment;
    toProto(message: MsgCloseDeployment): Uint8Array;
    toProtoMsg(message: MsgCloseDeployment): MsgCloseDeploymentProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgCloseDeploymentResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCloseDeploymentResponse;
    isSDK(o: any): o is MsgCloseDeploymentResponseSDKType;
    encode(_: MsgCloseDeploymentResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCloseDeploymentResponse;
    fromJSON(_: any): MsgCloseDeploymentResponse;
    toJSON(_: MsgCloseDeploymentResponse): JsonSafe<MsgCloseDeploymentResponse>;
    fromPartial<I extends Exact<Partial<MsgCloseDeploymentResponse>, I>>(_: I): MsgCloseDeploymentResponse;
    fromSDK(_: MsgCloseDeploymentResponseSDKType): MsgCloseDeploymentResponse;
    fromSDKJSON(_: any): MsgCloseDeploymentResponseSDKType;
    toSDK(_: MsgCloseDeploymentResponse): MsgCloseDeploymentResponseSDKType;
    fromAmino(_: MsgCloseDeploymentResponseAmino): MsgCloseDeploymentResponse;
    toAmino(_: MsgCloseDeploymentResponse): MsgCloseDeploymentResponseAmino;
    fromAminoMsg(object: MsgCloseDeploymentResponseAminoMsg): MsgCloseDeploymentResponse;
    toAminoMsg(message: MsgCloseDeploymentResponse): MsgCloseDeploymentResponseAminoMsg;
    fromProtoMsg(message: MsgCloseDeploymentResponseProtoMsg): MsgCloseDeploymentResponse;
    toProto(message: MsgCloseDeploymentResponse): Uint8Array;
    toProtoMsg(message: MsgCloseDeploymentResponse): MsgCloseDeploymentResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const DeploymentID: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is DeploymentID;
    isSDK(o: any): o is DeploymentIDSDKType;
    encode(message: DeploymentID, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): DeploymentID;
    fromJSON(object: any): DeploymentID;
    toJSON(message: DeploymentID): JsonSafe<DeploymentID>;
    fromPartial<I extends Exact<Partial<DeploymentID>, I>>(object: I): DeploymentID;
    fromSDK(object: DeploymentIDSDKType): DeploymentID;
    fromSDKJSON(object: any): DeploymentIDSDKType;
    toSDK(message: DeploymentID): DeploymentIDSDKType;
    fromAmino(object: DeploymentIDAmino): DeploymentID;
    toAmino(message: DeploymentID): DeploymentIDAmino;
    fromAminoMsg(object: DeploymentIDAminoMsg): DeploymentID;
    toAminoMsg(message: DeploymentID): DeploymentIDAminoMsg;
    fromProtoMsg(message: DeploymentIDProtoMsg): DeploymentID;
    toProto(message: DeploymentID): Uint8Array;
    toProtoMsg(message: DeploymentID): DeploymentIDProtoMsg;
    registerTypeUrl(): void;
};
export declare const Deployment: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is Deployment;
    isSDK(o: any): o is DeploymentSDKType;
    encode(message: Deployment, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Deployment;
    fromJSON(object: any): Deployment;
    toJSON(message: Deployment): JsonSafe<Deployment>;
    fromPartial<I extends Exact<Partial<Deployment>, I>>(object: I): Deployment;
    fromSDK(object: DeploymentSDKType): Deployment;
    fromSDKJSON(object: any): DeploymentSDKType;
    toSDK(message: Deployment): DeploymentSDKType;
    fromAmino(object: DeploymentAmino): Deployment;
    toAmino(message: Deployment): DeploymentAmino;
    fromAminoMsg(object: DeploymentAminoMsg): Deployment;
    toAminoMsg(message: Deployment): DeploymentAminoMsg;
    fromProtoMsg(message: DeploymentProtoMsg): Deployment;
    toProto(message: Deployment): Uint8Array;
    toProtoMsg(message: Deployment): DeploymentProtoMsg;
    registerTypeUrl(): void;
};
export declare const DeploymentFilters: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is DeploymentFilters;
    isSDK(o: any): o is DeploymentFiltersSDKType;
    encode(message: DeploymentFilters, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): DeploymentFilters;
    fromJSON(object: any): DeploymentFilters;
    toJSON(message: DeploymentFilters): JsonSafe<DeploymentFilters>;
    fromPartial<I extends Exact<Partial<DeploymentFilters>, I>>(object: I): DeploymentFilters;
    fromSDK(object: DeploymentFiltersSDKType): DeploymentFilters;
    fromSDKJSON(object: any): DeploymentFiltersSDKType;
    toSDK(message: DeploymentFilters): DeploymentFiltersSDKType;
    fromAmino(object: DeploymentFiltersAmino): DeploymentFilters;
    toAmino(message: DeploymentFilters): DeploymentFiltersAmino;
    fromAminoMsg(object: DeploymentFiltersAminoMsg): DeploymentFilters;
    toAminoMsg(message: DeploymentFilters): DeploymentFiltersAminoMsg;
    fromProtoMsg(message: DeploymentFiltersProtoMsg): DeploymentFilters;
    toProto(message: DeploymentFilters): Uint8Array;
    toProtoMsg(message: DeploymentFilters): DeploymentFiltersProtoMsg;
    registerTypeUrl(): void;
};
/** Msg defines the deployment Msg service. */
export interface Msg {
    /** CreateDeployment defines a method to create new deployment given proper inputs. */
    createDeployment(signerAddress: string, message: MsgCreateDeployment, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    /** DepositDeployment deposits more funds into the deployment account */
    depositDeployment(signerAddress: string, message: MsgDepositDeployment, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    /** UpdateDeployment defines a method to update a deployment given proper inputs. */
    updateDeployment(signerAddress: string, message: MsgUpdateDeployment, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    /** CloseDeployment defines a method to close a deployment given proper inputs. */
    closeDeployment(signerAddress: string, message: MsgCloseDeployment, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    /** CloseGroup defines a method to close a group of a deployment given proper inputs. */
    closeGroup(signerAddress: string, message: MsgCloseGroup, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    /** PauseGroup defines a method to close a group of a deployment given proper inputs. */
    pauseGroup(signerAddress: string, message: MsgPauseGroup, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    /** StartGroup defines a method to close a group of a deployment given proper inputs. */
    startGroup(signerAddress: string, message: MsgStartGroup, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
}
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    constructor(rpc: TxRpc);
    createDeployment: (signerAddress: string, message: MsgCreateDeployment, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    depositDeployment: (signerAddress: string, message: MsgDepositDeployment, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    updateDeployment: (signerAddress: string, message: MsgUpdateDeployment, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    closeDeployment: (signerAddress: string, message: MsgCloseDeployment, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    closeGroup: (signerAddress: string, message: MsgCloseGroup, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    pauseGroup: (signerAddress: string, message: MsgPauseGroup, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    startGroup: (signerAddress: string, message: MsgStartGroup, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
}
export declare const createClientImpl: (rpc: TxRpc) => MsgClientImpl;
