import { PlacementRequirements, PlacementRequirementsAmino, PlacementRequirementsSDKType } from "../../base/v1beta1/attribute";
import { ResourceUnits, ResourceUnitsAmino, ResourceUnitsSDKType } from "../../base/v1beta1/resource";
import { Coin, CoinAmino, CoinSDKType } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.deployment.v1beta1";
/** State is an enum which refers to state of group */
export declare enum Group_State {
    /** invalid - Prefix should start with 0 in enum. So declaring dummy state */
    invalid = 0,
    /** open - GroupOpen denotes state for group open */
    open = 1,
    /** paused - GroupOrdered denotes state for group ordered */
    paused = 2,
    /** insufficient_funds - GroupInsufficientFunds denotes state for group insufficient_funds */
    insufficient_funds = 3,
    /** closed - GroupClosed denotes state for group closed */
    closed = 4,
    UNRECOGNIZED = -1
}
export declare const Group_StateSDKType: typeof Group_State;
export declare const Group_StateAmino: typeof Group_State;
export declare function group_StateFromJSON(object: any): Group_State;
export declare function group_StateToJSON(object: Group_State): string;
/** MsgCloseGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgCloseGroup {
    id: GroupID | undefined;
}
export interface MsgCloseGroupProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.MsgCloseGroup";
    value: Uint8Array;
}
/** MsgCloseGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgCloseGroupAmino {
    id: GroupIDAmino | undefined;
}
export interface MsgCloseGroupAminoMsg {
    type: "akash/deployment/testonly-close-group";
    value: MsgCloseGroupAmino;
}
/** MsgCloseGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgCloseGroupSDKType {
    id: GroupIDSDKType | undefined;
}
/** MsgCloseGroupResponse defines the Msg/CloseGroup response type. */
export interface MsgCloseGroupResponse {
}
export interface MsgCloseGroupResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.MsgCloseGroupResponse";
    value: Uint8Array;
}
/** MsgCloseGroupResponse defines the Msg/CloseGroup response type. */
export interface MsgCloseGroupResponseAmino {
}
export interface MsgCloseGroupResponseAminoMsg {
    type: "akash/deployment/testonly-close-group-response";
    value: MsgCloseGroupResponseAmino;
}
/** MsgCloseGroupResponse defines the Msg/CloseGroup response type. */
export interface MsgCloseGroupResponseSDKType {
}
/** MsgPauseGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgPauseGroup {
    id: GroupID | undefined;
}
export interface MsgPauseGroupProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.MsgPauseGroup";
    value: Uint8Array;
}
/** MsgPauseGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgPauseGroupAmino {
    id: GroupIDAmino | undefined;
}
export interface MsgPauseGroupAminoMsg {
    type: "akash/deployment/testonly-pause-group";
    value: MsgPauseGroupAmino;
}
/** MsgPauseGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgPauseGroupSDKType {
    id: GroupIDSDKType | undefined;
}
/** MsgPauseGroupResponse defines the Msg/PauseGroup response type. */
export interface MsgPauseGroupResponse {
}
export interface MsgPauseGroupResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.MsgPauseGroupResponse";
    value: Uint8Array;
}
/** MsgPauseGroupResponse defines the Msg/PauseGroup response type. */
export interface MsgPauseGroupResponseAmino {
}
export interface MsgPauseGroupResponseAminoMsg {
    type: "akash/deployment/testonly-pause-group-response";
    value: MsgPauseGroupResponseAmino;
}
/** MsgPauseGroupResponse defines the Msg/PauseGroup response type. */
export interface MsgPauseGroupResponseSDKType {
}
/** MsgStartGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgStartGroup {
    id: GroupID | undefined;
}
export interface MsgStartGroupProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.MsgStartGroup";
    value: Uint8Array;
}
/** MsgStartGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgStartGroupAmino {
    id: GroupIDAmino | undefined;
}
export interface MsgStartGroupAminoMsg {
    type: "akash/deployment/testonly-start-group";
    value: MsgStartGroupAmino;
}
/** MsgStartGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgStartGroupSDKType {
    id: GroupIDSDKType | undefined;
}
/** MsgStartGroupResponse defines the Msg/StartGroup response type. */
export interface MsgStartGroupResponse {
}
export interface MsgStartGroupResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.MsgStartGroupResponse";
    value: Uint8Array;
}
/** MsgStartGroupResponse defines the Msg/StartGroup response type. */
export interface MsgStartGroupResponseAmino {
}
export interface MsgStartGroupResponseAminoMsg {
    type: "akash/deployment/testonly-start-group-response";
    value: MsgStartGroupResponseAmino;
}
/** MsgStartGroupResponse defines the Msg/StartGroup response type. */
export interface MsgStartGroupResponseSDKType {
}
/** GroupID stores owner, deployment sequence number and group sequence number */
export interface GroupID {
    owner: string;
    dseq: bigint;
    gseq: number;
}
export interface GroupIDProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.GroupID";
    value: Uint8Array;
}
/** GroupID stores owner, deployment sequence number and group sequence number */
export interface GroupIDAmino {
    owner: string;
    dseq: string;
    gseq: number;
}
export interface GroupIDAminoMsg {
    type: "akash/deployment/group-i-d";
    value: GroupIDAmino;
}
/** GroupID stores owner, deployment sequence number and group sequence number */
export interface GroupIDSDKType {
    owner: string;
    dseq: bigint;
    gseq: number;
}
/** GroupSpec stores group specifications */
export interface GroupSpec {
    name: string;
    requirements: PlacementRequirements | undefined;
    resources: Resource[];
}
export interface GroupSpecProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.GroupSpec";
    value: Uint8Array;
}
/** GroupSpec stores group specifications */
export interface GroupSpecAmino {
    name: string;
    requirements: PlacementRequirementsAmino | undefined;
    resources: ResourceAmino[];
}
export interface GroupSpecAminoMsg {
    type: "akash/deployment/group-spec";
    value: GroupSpecAmino;
}
/** GroupSpec stores group specifications */
export interface GroupSpecSDKType {
    name: string;
    requirements: PlacementRequirementsSDKType | undefined;
    resources: ResourceSDKType[];
}
/** Group stores group id, state and specifications of group */
export interface Group {
    groupId: GroupID | undefined;
    state: Group_State;
    groupSpec: GroupSpec | undefined;
    createdAt: bigint;
}
export interface GroupProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.Group";
    value: Uint8Array;
}
/** Group stores group id, state and specifications of group */
export interface GroupAmino {
    group_id: GroupIDAmino | undefined;
    state: Group_State;
    group_spec: GroupSpecAmino | undefined;
    created_at?: string;
}
export interface GroupAminoMsg {
    type: "akash/deployment/group";
    value: GroupAmino;
}
/** Group stores group id, state and specifications of group */
export interface GroupSDKType {
    group_id: GroupIDSDKType | undefined;
    state: Group_State;
    group_spec: GroupSpecSDKType | undefined;
    created_at: bigint;
}
/** Resource stores unit, total count and price of resource */
export interface Resource {
    resources: ResourceUnits | undefined;
    count: number;
    price: Coin | undefined;
}
export interface ResourceProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.Resource";
    value: Uint8Array;
}
/** Resource stores unit, total count and price of resource */
export interface ResourceAmino {
    resources: ResourceUnitsAmino | undefined;
    count: number;
    price: CoinAmino | undefined;
}
export interface ResourceAminoMsg {
    type: "akash/deployment/resource";
    value: ResourceAmino;
}
/** Resource stores unit, total count and price of resource */
export interface ResourceSDKType {
    resources: ResourceUnitsSDKType | undefined;
    count: number;
    price: CoinSDKType | undefined;
}
export declare const MsgCloseGroup: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCloseGroup;
    isSDK(o: any): o is MsgCloseGroupSDKType;
    encode(message: MsgCloseGroup, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCloseGroup;
    fromJSON(object: any): MsgCloseGroup;
    toJSON(message: MsgCloseGroup): JsonSafe<MsgCloseGroup>;
    fromPartial<I extends Exact<Partial<MsgCloseGroup>, I>>(object: I): MsgCloseGroup;
    fromSDK(object: MsgCloseGroupSDKType): MsgCloseGroup;
    fromSDKJSON(object: any): MsgCloseGroupSDKType;
    toSDK(message: MsgCloseGroup): MsgCloseGroupSDKType;
    fromAmino(object: MsgCloseGroupAmino): MsgCloseGroup;
    toAmino(message: MsgCloseGroup): MsgCloseGroupAmino;
    fromAminoMsg(object: MsgCloseGroupAminoMsg): MsgCloseGroup;
    toAminoMsg(message: MsgCloseGroup): MsgCloseGroupAminoMsg;
    fromProtoMsg(message: MsgCloseGroupProtoMsg): MsgCloseGroup;
    toProto(message: MsgCloseGroup): Uint8Array;
    toProtoMsg(message: MsgCloseGroup): MsgCloseGroupProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgCloseGroupResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCloseGroupResponse;
    isSDK(o: any): o is MsgCloseGroupResponseSDKType;
    encode(_: MsgCloseGroupResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCloseGroupResponse;
    fromJSON(_: any): MsgCloseGroupResponse;
    toJSON(_: MsgCloseGroupResponse): JsonSafe<MsgCloseGroupResponse>;
    fromPartial<I extends Exact<Partial<MsgCloseGroupResponse>, I>>(_: I): MsgCloseGroupResponse;
    fromSDK(_: MsgCloseGroupResponseSDKType): MsgCloseGroupResponse;
    fromSDKJSON(_: any): MsgCloseGroupResponseSDKType;
    toSDK(_: MsgCloseGroupResponse): MsgCloseGroupResponseSDKType;
    fromAmino(_: MsgCloseGroupResponseAmino): MsgCloseGroupResponse;
    toAmino(_: MsgCloseGroupResponse): MsgCloseGroupResponseAmino;
    fromAminoMsg(object: MsgCloseGroupResponseAminoMsg): MsgCloseGroupResponse;
    toAminoMsg(message: MsgCloseGroupResponse): MsgCloseGroupResponseAminoMsg;
    fromProtoMsg(message: MsgCloseGroupResponseProtoMsg): MsgCloseGroupResponse;
    toProto(message: MsgCloseGroupResponse): Uint8Array;
    toProtoMsg(message: MsgCloseGroupResponse): MsgCloseGroupResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgPauseGroup: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgPauseGroup;
    isSDK(o: any): o is MsgPauseGroupSDKType;
    encode(message: MsgPauseGroup, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgPauseGroup;
    fromJSON(object: any): MsgPauseGroup;
    toJSON(message: MsgPauseGroup): JsonSafe<MsgPauseGroup>;
    fromPartial<I extends Exact<Partial<MsgPauseGroup>, I>>(object: I): MsgPauseGroup;
    fromSDK(object: MsgPauseGroupSDKType): MsgPauseGroup;
    fromSDKJSON(object: any): MsgPauseGroupSDKType;
    toSDK(message: MsgPauseGroup): MsgPauseGroupSDKType;
    fromAmino(object: MsgPauseGroupAmino): MsgPauseGroup;
    toAmino(message: MsgPauseGroup): MsgPauseGroupAmino;
    fromAminoMsg(object: MsgPauseGroupAminoMsg): MsgPauseGroup;
    toAminoMsg(message: MsgPauseGroup): MsgPauseGroupAminoMsg;
    fromProtoMsg(message: MsgPauseGroupProtoMsg): MsgPauseGroup;
    toProto(message: MsgPauseGroup): Uint8Array;
    toProtoMsg(message: MsgPauseGroup): MsgPauseGroupProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgPauseGroupResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgPauseGroupResponse;
    isSDK(o: any): o is MsgPauseGroupResponseSDKType;
    encode(_: MsgPauseGroupResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgPauseGroupResponse;
    fromJSON(_: any): MsgPauseGroupResponse;
    toJSON(_: MsgPauseGroupResponse): JsonSafe<MsgPauseGroupResponse>;
    fromPartial<I extends Exact<Partial<MsgPauseGroupResponse>, I>>(_: I): MsgPauseGroupResponse;
    fromSDK(_: MsgPauseGroupResponseSDKType): MsgPauseGroupResponse;
    fromSDKJSON(_: any): MsgPauseGroupResponseSDKType;
    toSDK(_: MsgPauseGroupResponse): MsgPauseGroupResponseSDKType;
    fromAmino(_: MsgPauseGroupResponseAmino): MsgPauseGroupResponse;
    toAmino(_: MsgPauseGroupResponse): MsgPauseGroupResponseAmino;
    fromAminoMsg(object: MsgPauseGroupResponseAminoMsg): MsgPauseGroupResponse;
    toAminoMsg(message: MsgPauseGroupResponse): MsgPauseGroupResponseAminoMsg;
    fromProtoMsg(message: MsgPauseGroupResponseProtoMsg): MsgPauseGroupResponse;
    toProto(message: MsgPauseGroupResponse): Uint8Array;
    toProtoMsg(message: MsgPauseGroupResponse): MsgPauseGroupResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgStartGroup: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgStartGroup;
    isSDK(o: any): o is MsgStartGroupSDKType;
    encode(message: MsgStartGroup, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgStartGroup;
    fromJSON(object: any): MsgStartGroup;
    toJSON(message: MsgStartGroup): JsonSafe<MsgStartGroup>;
    fromPartial<I extends Exact<Partial<MsgStartGroup>, I>>(object: I): MsgStartGroup;
    fromSDK(object: MsgStartGroupSDKType): MsgStartGroup;
    fromSDKJSON(object: any): MsgStartGroupSDKType;
    toSDK(message: MsgStartGroup): MsgStartGroupSDKType;
    fromAmino(object: MsgStartGroupAmino): MsgStartGroup;
    toAmino(message: MsgStartGroup): MsgStartGroupAmino;
    fromAminoMsg(object: MsgStartGroupAminoMsg): MsgStartGroup;
    toAminoMsg(message: MsgStartGroup): MsgStartGroupAminoMsg;
    fromProtoMsg(message: MsgStartGroupProtoMsg): MsgStartGroup;
    toProto(message: MsgStartGroup): Uint8Array;
    toProtoMsg(message: MsgStartGroup): MsgStartGroupProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgStartGroupResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgStartGroupResponse;
    isSDK(o: any): o is MsgStartGroupResponseSDKType;
    encode(_: MsgStartGroupResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgStartGroupResponse;
    fromJSON(_: any): MsgStartGroupResponse;
    toJSON(_: MsgStartGroupResponse): JsonSafe<MsgStartGroupResponse>;
    fromPartial<I extends Exact<Partial<MsgStartGroupResponse>, I>>(_: I): MsgStartGroupResponse;
    fromSDK(_: MsgStartGroupResponseSDKType): MsgStartGroupResponse;
    fromSDKJSON(_: any): MsgStartGroupResponseSDKType;
    toSDK(_: MsgStartGroupResponse): MsgStartGroupResponseSDKType;
    fromAmino(_: MsgStartGroupResponseAmino): MsgStartGroupResponse;
    toAmino(_: MsgStartGroupResponse): MsgStartGroupResponseAmino;
    fromAminoMsg(object: MsgStartGroupResponseAminoMsg): MsgStartGroupResponse;
    toAminoMsg(message: MsgStartGroupResponse): MsgStartGroupResponseAminoMsg;
    fromProtoMsg(message: MsgStartGroupResponseProtoMsg): MsgStartGroupResponse;
    toProto(message: MsgStartGroupResponse): Uint8Array;
    toProtoMsg(message: MsgStartGroupResponse): MsgStartGroupResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const GroupID: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is GroupID;
    isSDK(o: any): o is GroupIDSDKType;
    encode(message: GroupID, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GroupID;
    fromJSON(object: any): GroupID;
    toJSON(message: GroupID): JsonSafe<GroupID>;
    fromPartial<I extends Exact<Partial<GroupID>, I>>(object: I): GroupID;
    fromSDK(object: GroupIDSDKType): GroupID;
    fromSDKJSON(object: any): GroupIDSDKType;
    toSDK(message: GroupID): GroupIDSDKType;
    fromAmino(object: GroupIDAmino): GroupID;
    toAmino(message: GroupID): GroupIDAmino;
    fromAminoMsg(object: GroupIDAminoMsg): GroupID;
    toAminoMsg(message: GroupID): GroupIDAminoMsg;
    fromProtoMsg(message: GroupIDProtoMsg): GroupID;
    toProto(message: GroupID): Uint8Array;
    toProtoMsg(message: GroupID): GroupIDProtoMsg;
    registerTypeUrl(): void;
};
export declare const GroupSpec: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is GroupSpec;
    isSDK(o: any): o is GroupSpecSDKType;
    encode(message: GroupSpec, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GroupSpec;
    fromJSON(object: any): GroupSpec;
    toJSON(message: GroupSpec): JsonSafe<GroupSpec>;
    fromPartial<I extends Exact<Partial<GroupSpec>, I>>(object: I): GroupSpec;
    fromSDK(object: GroupSpecSDKType): GroupSpec;
    fromSDKJSON(object: any): GroupSpecSDKType;
    toSDK(message: GroupSpec): GroupSpecSDKType;
    fromAmino(object: GroupSpecAmino): GroupSpec;
    toAmino(message: GroupSpec): GroupSpecAmino;
    fromAminoMsg(object: GroupSpecAminoMsg): GroupSpec;
    toAminoMsg(message: GroupSpec): GroupSpecAminoMsg;
    fromProtoMsg(message: GroupSpecProtoMsg): GroupSpec;
    toProto(message: GroupSpec): Uint8Array;
    toProtoMsg(message: GroupSpec): GroupSpecProtoMsg;
    registerTypeUrl(): void;
};
export declare const Group: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is Group;
    isSDK(o: any): o is GroupSDKType;
    encode(message: Group, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Group;
    fromJSON(object: any): Group;
    toJSON(message: Group): JsonSafe<Group>;
    fromPartial<I extends Exact<Partial<Group>, I>>(object: I): Group;
    fromSDK(object: GroupSDKType): Group;
    fromSDKJSON(object: any): GroupSDKType;
    toSDK(message: Group): GroupSDKType;
    fromAmino(object: GroupAmino): Group;
    toAmino(message: Group): GroupAmino;
    fromAminoMsg(object: GroupAminoMsg): Group;
    toAminoMsg(message: Group): GroupAminoMsg;
    fromProtoMsg(message: GroupProtoMsg): Group;
    toProto(message: Group): Uint8Array;
    toProtoMsg(message: Group): GroupProtoMsg;
    registerTypeUrl(): void;
};
export declare const Resource: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is Resource;
    isSDK(o: any): o is ResourceSDKType;
    encode(message: Resource, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Resource;
    fromJSON(object: any): Resource;
    toJSON(message: Resource): JsonSafe<Resource>;
    fromPartial<I extends Exact<Partial<Resource>, I>>(object: I): Resource;
    fromSDK(object: ResourceSDKType): Resource;
    fromSDKJSON(object: any): ResourceSDKType;
    toSDK(message: Resource): ResourceSDKType;
    fromAmino(object: ResourceAmino): Resource;
    toAmino(message: Resource): ResourceAmino;
    fromAminoMsg(object: ResourceAminoMsg): Resource;
    toAminoMsg(message: Resource): ResourceAminoMsg;
    fromProtoMsg(message: ResourceProtoMsg): Resource;
    toProto(message: Resource): Uint8Array;
    toProtoMsg(message: Resource): ResourceProtoMsg;
    registerTypeUrl(): void;
};
