import { DeploymentFilters, DeploymentFiltersAmino, DeploymentFiltersSDKType, DeploymentID, DeploymentIDAmino, DeploymentIDSDKType, Deployment, DeploymentAmino, DeploymentSDKType } from "./deployment";
import { PageRequest, PageRequestAmino, PageRequestSDKType, PageResponse, PageResponseAmino, PageResponseSDKType } from "../../../cosmos/base/query/v1beta1/pagination";
import { GroupID, GroupIDAmino, GroupIDSDKType, Group, GroupAmino, GroupSDKType } from "./group";
import { Account, AccountAmino, AccountSDKType } from "../../escrow/v1beta1/types";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
import { TxRpc } from "../../../types";
export declare const protobufPackage = "akash.deployment.v1beta1";
/** QueryDeploymentsRequest is request type for the Query/Deployments RPC method */
export interface QueryDeploymentsRequest {
    filters: DeploymentFilters | undefined;
    pagination?: PageRequest | undefined;
}
export interface QueryDeploymentsRequestProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.QueryDeploymentsRequest";
    value: Uint8Array;
}
/** QueryDeploymentsRequest is request type for the Query/Deployments RPC method */
export interface QueryDeploymentsRequestAmino {
    filters?: DeploymentFiltersAmino | undefined;
    pagination?: PageRequestAmino | undefined;
}
export interface QueryDeploymentsRequestAminoMsg {
    type: "akash/deployment/query-deployments-request";
    value: QueryDeploymentsRequestAmino;
}
/** QueryDeploymentsRequest is request type for the Query/Deployments RPC method */
export interface QueryDeploymentsRequestSDKType {
    filters: DeploymentFiltersSDKType | undefined;
    pagination?: PageRequestSDKType | undefined;
}
/** QueryDeploymentsResponse is response type for the Query/Deployments RPC method */
export interface QueryDeploymentsResponse {
    deployments: QueryDeploymentResponse[];
    pagination?: PageResponse | undefined;
}
export interface QueryDeploymentsResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.QueryDeploymentsResponse";
    value: Uint8Array;
}
/** QueryDeploymentsResponse is response type for the Query/Deployments RPC method */
export interface QueryDeploymentsResponseAmino {
    deployments?: QueryDeploymentResponseAmino[];
    pagination?: PageResponseAmino | undefined;
}
export interface QueryDeploymentsResponseAminoMsg {
    type: "akash/deployment/query-deployments-response";
    value: QueryDeploymentsResponseAmino;
}
/** QueryDeploymentsResponse is response type for the Query/Deployments RPC method */
export interface QueryDeploymentsResponseSDKType {
    deployments: QueryDeploymentResponseSDKType[];
    pagination?: PageResponseSDKType | undefined;
}
/** QueryDeploymentRequest is request type for the Query/Deployment RPC method */
export interface QueryDeploymentRequest {
    id: DeploymentID | undefined;
}
export interface QueryDeploymentRequestProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.QueryDeploymentRequest";
    value: Uint8Array;
}
/** QueryDeploymentRequest is request type for the Query/Deployment RPC method */
export interface QueryDeploymentRequestAmino {
    id?: DeploymentIDAmino | undefined;
}
export interface QueryDeploymentRequestAminoMsg {
    type: "akash/deployment/query-deployment-request";
    value: QueryDeploymentRequestAmino;
}
/** QueryDeploymentRequest is request type for the Query/Deployment RPC method */
export interface QueryDeploymentRequestSDKType {
    id: DeploymentIDSDKType | undefined;
}
/** QueryDeploymentResponse is response type for the Query/Deployment RPC method */
export interface QueryDeploymentResponse {
    deployment: Deployment | undefined;
    groups: Group[];
    escrowAccount: Account | undefined;
}
export interface QueryDeploymentResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.QueryDeploymentResponse";
    value: Uint8Array;
}
/** QueryDeploymentResponse is response type for the Query/Deployment RPC method */
export interface QueryDeploymentResponseAmino {
    deployment: DeploymentAmino | undefined;
    groups: GroupAmino[];
    escrow_account?: AccountAmino | undefined;
}
export interface QueryDeploymentResponseAminoMsg {
    type: "akash/deployment/query-deployment-response";
    value: QueryDeploymentResponseAmino;
}
/** QueryDeploymentResponse is response type for the Query/Deployment RPC method */
export interface QueryDeploymentResponseSDKType {
    deployment: DeploymentSDKType | undefined;
    groups: GroupSDKType[];
    escrow_account: AccountSDKType | undefined;
}
/** QueryGroupRequest is request type for the Query/Group RPC method */
export interface QueryGroupRequest {
    id: GroupID | undefined;
}
export interface QueryGroupRequestProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.QueryGroupRequest";
    value: Uint8Array;
}
/** QueryGroupRequest is request type for the Query/Group RPC method */
export interface QueryGroupRequestAmino {
    id?: GroupIDAmino | undefined;
}
export interface QueryGroupRequestAminoMsg {
    type: "akash/deployment/query-group-request";
    value: QueryGroupRequestAmino;
}
/** QueryGroupRequest is request type for the Query/Group RPC method */
export interface QueryGroupRequestSDKType {
    id: GroupIDSDKType | undefined;
}
/** QueryGroupResponse is response type for the Query/Group RPC method */
export interface QueryGroupResponse {
    group: Group | undefined;
}
export interface QueryGroupResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta1.QueryGroupResponse";
    value: Uint8Array;
}
/** QueryGroupResponse is response type for the Query/Group RPC method */
export interface QueryGroupResponseAmino {
    group?: GroupAmino | undefined;
}
export interface QueryGroupResponseAminoMsg {
    type: "akash/deployment/query-group-response";
    value: QueryGroupResponseAmino;
}
/** QueryGroupResponse is response type for the Query/Group RPC method */
export interface QueryGroupResponseSDKType {
    group: GroupSDKType | undefined;
}
export declare const QueryDeploymentsRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryDeploymentsRequest;
    isSDK(o: any): o is QueryDeploymentsRequestSDKType;
    encode(message: QueryDeploymentsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryDeploymentsRequest;
    fromJSON(object: any): QueryDeploymentsRequest;
    toJSON(message: QueryDeploymentsRequest): JsonSafe<QueryDeploymentsRequest>;
    fromPartial<I extends Exact<Partial<QueryDeploymentsRequest>, I>>(object: I): QueryDeploymentsRequest;
    fromSDK(object: QueryDeploymentsRequestSDKType): QueryDeploymentsRequest;
    fromSDKJSON(object: any): QueryDeploymentsRequestSDKType;
    toSDK(message: QueryDeploymentsRequest): QueryDeploymentsRequestSDKType;
    fromAmino(object: QueryDeploymentsRequestAmino): QueryDeploymentsRequest;
    toAmino(message: QueryDeploymentsRequest): QueryDeploymentsRequestAmino;
    fromAminoMsg(object: QueryDeploymentsRequestAminoMsg): QueryDeploymentsRequest;
    toAminoMsg(message: QueryDeploymentsRequest): QueryDeploymentsRequestAminoMsg;
    fromProtoMsg(message: QueryDeploymentsRequestProtoMsg): QueryDeploymentsRequest;
    toProto(message: QueryDeploymentsRequest): Uint8Array;
    toProtoMsg(message: QueryDeploymentsRequest): QueryDeploymentsRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryDeploymentsResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryDeploymentsResponse;
    isSDK(o: any): o is QueryDeploymentsResponseSDKType;
    encode(message: QueryDeploymentsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryDeploymentsResponse;
    fromJSON(object: any): QueryDeploymentsResponse;
    toJSON(message: QueryDeploymentsResponse): JsonSafe<QueryDeploymentsResponse>;
    fromPartial<I extends Exact<Partial<QueryDeploymentsResponse>, I>>(object: I): QueryDeploymentsResponse;
    fromSDK(object: QueryDeploymentsResponseSDKType): QueryDeploymentsResponse;
    fromSDKJSON(object: any): QueryDeploymentsResponseSDKType;
    toSDK(message: QueryDeploymentsResponse): QueryDeploymentsResponseSDKType;
    fromAmino(object: QueryDeploymentsResponseAmino): QueryDeploymentsResponse;
    toAmino(message: QueryDeploymentsResponse): QueryDeploymentsResponseAmino;
    fromAminoMsg(object: QueryDeploymentsResponseAminoMsg): QueryDeploymentsResponse;
    toAminoMsg(message: QueryDeploymentsResponse): QueryDeploymentsResponseAminoMsg;
    fromProtoMsg(message: QueryDeploymentsResponseProtoMsg): QueryDeploymentsResponse;
    toProto(message: QueryDeploymentsResponse): Uint8Array;
    toProtoMsg(message: QueryDeploymentsResponse): QueryDeploymentsResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryDeploymentRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryDeploymentRequest;
    isSDK(o: any): o is QueryDeploymentRequestSDKType;
    encode(message: QueryDeploymentRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryDeploymentRequest;
    fromJSON(object: any): QueryDeploymentRequest;
    toJSON(message: QueryDeploymentRequest): JsonSafe<QueryDeploymentRequest>;
    fromPartial<I extends Exact<Partial<QueryDeploymentRequest>, I>>(object: I): QueryDeploymentRequest;
    fromSDK(object: QueryDeploymentRequestSDKType): QueryDeploymentRequest;
    fromSDKJSON(object: any): QueryDeploymentRequestSDKType;
    toSDK(message: QueryDeploymentRequest): QueryDeploymentRequestSDKType;
    fromAmino(object: QueryDeploymentRequestAmino): QueryDeploymentRequest;
    toAmino(message: QueryDeploymentRequest): QueryDeploymentRequestAmino;
    fromAminoMsg(object: QueryDeploymentRequestAminoMsg): QueryDeploymentRequest;
    toAminoMsg(message: QueryDeploymentRequest): QueryDeploymentRequestAminoMsg;
    fromProtoMsg(message: QueryDeploymentRequestProtoMsg): QueryDeploymentRequest;
    toProto(message: QueryDeploymentRequest): Uint8Array;
    toProtoMsg(message: QueryDeploymentRequest): QueryDeploymentRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryDeploymentResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryDeploymentResponse;
    isSDK(o: any): o is QueryDeploymentResponseSDKType;
    encode(message: QueryDeploymentResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryDeploymentResponse;
    fromJSON(object: any): QueryDeploymentResponse;
    toJSON(message: QueryDeploymentResponse): JsonSafe<QueryDeploymentResponse>;
    fromPartial<I extends Exact<Partial<QueryDeploymentResponse>, I>>(object: I): QueryDeploymentResponse;
    fromSDK(object: QueryDeploymentResponseSDKType): QueryDeploymentResponse;
    fromSDKJSON(object: any): QueryDeploymentResponseSDKType;
    toSDK(message: QueryDeploymentResponse): QueryDeploymentResponseSDKType;
    fromAmino(object: QueryDeploymentResponseAmino): QueryDeploymentResponse;
    toAmino(message: QueryDeploymentResponse): QueryDeploymentResponseAmino;
    fromAminoMsg(object: QueryDeploymentResponseAminoMsg): QueryDeploymentResponse;
    toAminoMsg(message: QueryDeploymentResponse): QueryDeploymentResponseAminoMsg;
    fromProtoMsg(message: QueryDeploymentResponseProtoMsg): QueryDeploymentResponse;
    toProto(message: QueryDeploymentResponse): Uint8Array;
    toProtoMsg(message: QueryDeploymentResponse): QueryDeploymentResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryGroupRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryGroupRequest;
    isSDK(o: any): o is QueryGroupRequestSDKType;
    encode(message: QueryGroupRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryGroupRequest;
    fromJSON(object: any): QueryGroupRequest;
    toJSON(message: QueryGroupRequest): JsonSafe<QueryGroupRequest>;
    fromPartial<I extends Exact<Partial<QueryGroupRequest>, I>>(object: I): QueryGroupRequest;
    fromSDK(object: QueryGroupRequestSDKType): QueryGroupRequest;
    fromSDKJSON(object: any): QueryGroupRequestSDKType;
    toSDK(message: QueryGroupRequest): QueryGroupRequestSDKType;
    fromAmino(object: QueryGroupRequestAmino): QueryGroupRequest;
    toAmino(message: QueryGroupRequest): QueryGroupRequestAmino;
    fromAminoMsg(object: QueryGroupRequestAminoMsg): QueryGroupRequest;
    toAminoMsg(message: QueryGroupRequest): QueryGroupRequestAminoMsg;
    fromProtoMsg(message: QueryGroupRequestProtoMsg): QueryGroupRequest;
    toProto(message: QueryGroupRequest): Uint8Array;
    toProtoMsg(message: QueryGroupRequest): QueryGroupRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryGroupResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryGroupResponse;
    isSDK(o: any): o is QueryGroupResponseSDKType;
    encode(message: QueryGroupResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryGroupResponse;
    fromJSON(object: any): QueryGroupResponse;
    toJSON(message: QueryGroupResponse): JsonSafe<QueryGroupResponse>;
    fromPartial<I extends Exact<Partial<QueryGroupResponse>, I>>(object: I): QueryGroupResponse;
    fromSDK(object: QueryGroupResponseSDKType): QueryGroupResponse;
    fromSDKJSON(object: any): QueryGroupResponseSDKType;
    toSDK(message: QueryGroupResponse): QueryGroupResponseSDKType;
    fromAmino(object: QueryGroupResponseAmino): QueryGroupResponse;
    toAmino(message: QueryGroupResponse): QueryGroupResponseAmino;
    fromAminoMsg(object: QueryGroupResponseAminoMsg): QueryGroupResponse;
    toAminoMsg(message: QueryGroupResponse): QueryGroupResponseAminoMsg;
    fromProtoMsg(message: QueryGroupResponseProtoMsg): QueryGroupResponse;
    toProto(message: QueryGroupResponse): Uint8Array;
    toProtoMsg(message: QueryGroupResponse): QueryGroupResponseProtoMsg;
    registerTypeUrl(): void;
};
/** Query defines the gRPC querier service */
export interface Query {
    /** Deployments queries deployments */
    deployments(request: QueryDeploymentsRequest): Promise<QueryDeploymentsResponse>;
    /** Deployment queries deployment details */
    deployment(request: QueryDeploymentRequest): Promise<QueryDeploymentResponse>;
    /** Group queries group details */
    group(request: QueryGroupRequest): Promise<QueryGroupResponse>;
}
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    constructor(rpc: TxRpc);
    deployments: (request: QueryDeploymentsRequest) => Promise<QueryDeploymentsResponse>;
    deployment: (request: QueryDeploymentRequest) => Promise<QueryDeploymentResponse>;
    group: (request: QueryGroupRequest) => Promise<QueryGroupResponse>;
}
export declare const createClientImpl: (rpc: TxRpc) => QueryClientImpl;
