import { Coin, CoinAmino, CoinSDKType } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.deployment.v1beta2";
/**
 * DepositDeploymentAuthorization allows the grantee to deposit up to spend_limit coins from
 * the granter's account for a deployment.
 */
export interface DepositDeploymentAuthorization {
    $typeUrl?: "/akash.deployment.v1beta2.DepositDeploymentAuthorization";
    /**
     * SpendLimit is the amount the grantee is authorized to spend from the granter's account for
     * the purpose of deployment.
     */
    spendLimit: Coin;
}
export interface DepositDeploymentAuthorizationProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.DepositDeploymentAuthorization";
    value: Uint8Array;
}
/**
 * DepositDeploymentAuthorization allows the grantee to deposit up to spend_limit coins from
 * the granter's account for a deployment.
 */
export interface DepositDeploymentAuthorizationAmino {
    /**
     * SpendLimit is the amount the grantee is authorized to spend from the granter's account for
     * the purpose of deployment.
     */
    spend_limit: CoinAmino;
}
export interface DepositDeploymentAuthorizationAminoMsg {
    type: "akash/deployment/v1beta2/deposit-deployment-authorization";
    value: DepositDeploymentAuthorizationAmino;
}
/**
 * DepositDeploymentAuthorization allows the grantee to deposit up to spend_limit coins from
 * the granter's account for a deployment.
 */
export interface DepositDeploymentAuthorizationSDKType {
    $typeUrl?: "/akash.deployment.v1beta2.DepositDeploymentAuthorization";
    spend_limit: CoinSDKType;
}
export declare const DepositDeploymentAuthorization: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is DepositDeploymentAuthorization;
    isSDK(o: any): o is DepositDeploymentAuthorizationSDKType;
    isAmino(o: any): o is DepositDeploymentAuthorizationAmino;
    encode(message: DepositDeploymentAuthorization, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): DepositDeploymentAuthorization;
    fromJSON(object: any): DepositDeploymentAuthorization;
    toJSON(message: DepositDeploymentAuthorization): JsonSafe<DepositDeploymentAuthorization>;
    fromPartial<I extends Exact<DeepPartial<DepositDeploymentAuthorization>, I>>(object: I): DepositDeploymentAuthorization;
    fromSDK(object: DepositDeploymentAuthorizationSDKType): DepositDeploymentAuthorization;
    fromSDKJSON(object: any): DepositDeploymentAuthorizationSDKType;
    toSDK(message: DepositDeploymentAuthorization): DepositDeploymentAuthorizationSDKType;
    fromAmino(object: DepositDeploymentAuthorizationAmino): DepositDeploymentAuthorization;
    toAmino(message: DepositDeploymentAuthorization): DepositDeploymentAuthorizationAmino;
    fromAminoMsg(object: DepositDeploymentAuthorizationAminoMsg): DepositDeploymentAuthorization;
    toAminoMsg(message: DepositDeploymentAuthorization): DepositDeploymentAuthorizationAminoMsg;
    fromProtoMsg(message: DepositDeploymentAuthorizationProtoMsg): DepositDeploymentAuthorization;
    toProto(message: DepositDeploymentAuthorization): Uint8Array;
    toProtoMsg(message: DepositDeploymentAuthorization): DepositDeploymentAuthorizationProtoMsg;
    registerTypeUrl(): void;
};
