import { DeploymentID, DeploymentIDAmino, DeploymentIDSDKType } from "./deployment";
import { GroupSpec, GroupSpecAmino, GroupSpecSDKType } from "./groupspec";
import { Coin, CoinAmino, CoinSDKType } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.deployment.v1beta2";
/** MsgCreateDeployment defines an SDK message for creating deployment */
export interface MsgCreateDeployment {
    id: DeploymentID;
    groups: GroupSpec[];
    version: Uint8Array;
    deposit: Coin;
    /** Depositor pays for the deposit */
    depositor: string;
}
export interface MsgCreateDeploymentProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.MsgCreateDeployment";
    value: Uint8Array;
}
/** MsgCreateDeployment defines an SDK message for creating deployment */
export interface MsgCreateDeploymentAmino {
    id: DeploymentIDAmino;
    groups: GroupSpecAmino[];
    version: string;
    deposit: CoinAmino;
    /** Depositor pays for the deposit */
    depositor: string;
}
export interface MsgCreateDeploymentAminoMsg {
    type: "akash/deployment/v1beta2/testonly-create-deployment";
    value: MsgCreateDeploymentAmino;
}
/** MsgCreateDeployment defines an SDK message for creating deployment */
export interface MsgCreateDeploymentSDKType {
    id: DeploymentIDSDKType;
    groups: GroupSpecSDKType[];
    version: Uint8Array;
    deposit: CoinSDKType;
    depositor: string;
}
/** MsgCreateDeploymentResponse defines the Msg/CreateDeployment response type. */
export interface MsgCreateDeploymentResponse {
}
export interface MsgCreateDeploymentResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.MsgCreateDeploymentResponse";
    value: Uint8Array;
}
/** MsgCreateDeploymentResponse defines the Msg/CreateDeployment response type. */
export interface MsgCreateDeploymentResponseAmino {
}
export interface MsgCreateDeploymentResponseAminoMsg {
    type: "akash/deployment/v1beta2/testonly-create-deployment-response";
    value: MsgCreateDeploymentResponseAmino;
}
/** MsgCreateDeploymentResponse defines the Msg/CreateDeployment response type. */
export interface MsgCreateDeploymentResponseSDKType {
}
/** MsgDepositDeployment deposits more funds into the deposit account */
export interface MsgDepositDeployment {
    id: DeploymentID;
    amount: Coin;
    /** Depositor pays for the deposit */
    depositor: string;
}
export interface MsgDepositDeploymentProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.MsgDepositDeployment";
    value: Uint8Array;
}
/** MsgDepositDeployment deposits more funds into the deposit account */
export interface MsgDepositDeploymentAmino {
    id: DeploymentIDAmino;
    amount: CoinAmino;
    /** Depositor pays for the deposit */
    depositor: string;
}
export interface MsgDepositDeploymentAminoMsg {
    type: "akash/deployment/v1beta2/testonly-deposit-deployment";
    value: MsgDepositDeploymentAmino;
}
/** MsgDepositDeployment deposits more funds into the deposit account */
export interface MsgDepositDeploymentSDKType {
    id: DeploymentIDSDKType;
    amount: CoinSDKType;
    depositor: string;
}
/** MsgCreateDeploymentResponse defines the Msg/CreateDeployment response type. */
export interface MsgDepositDeploymentResponse {
}
export interface MsgDepositDeploymentResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.MsgDepositDeploymentResponse";
    value: Uint8Array;
}
/** MsgCreateDeploymentResponse defines the Msg/CreateDeployment response type. */
export interface MsgDepositDeploymentResponseAmino {
}
export interface MsgDepositDeploymentResponseAminoMsg {
    type: "akash/deployment/v1beta2/testonly-deposit-deployment-response";
    value: MsgDepositDeploymentResponseAmino;
}
/** MsgCreateDeploymentResponse defines the Msg/CreateDeployment response type. */
export interface MsgDepositDeploymentResponseSDKType {
}
/** MsgUpdateDeployment defines an SDK message for updating deployment */
export interface MsgUpdateDeployment {
    id: DeploymentID;
    version: Uint8Array;
}
export interface MsgUpdateDeploymentProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.MsgUpdateDeployment";
    value: Uint8Array;
}
/** MsgUpdateDeployment defines an SDK message for updating deployment */
export interface MsgUpdateDeploymentAmino {
    id: DeploymentIDAmino;
    version: string;
}
export interface MsgUpdateDeploymentAminoMsg {
    type: "akash/deployment/v1beta2/testonly-update-deployment";
    value: MsgUpdateDeploymentAmino;
}
/** MsgUpdateDeployment defines an SDK message for updating deployment */
export interface MsgUpdateDeploymentSDKType {
    id: DeploymentIDSDKType;
    version: Uint8Array;
}
/** MsgUpdateDeploymentResponse defines the Msg/UpdateDeployment response type. */
export interface MsgUpdateDeploymentResponse {
}
export interface MsgUpdateDeploymentResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.MsgUpdateDeploymentResponse";
    value: Uint8Array;
}
/** MsgUpdateDeploymentResponse defines the Msg/UpdateDeployment response type. */
export interface MsgUpdateDeploymentResponseAmino {
}
export interface MsgUpdateDeploymentResponseAminoMsg {
    type: "akash/deployment/v1beta2/testonly-update-deployment-response";
    value: MsgUpdateDeploymentResponseAmino;
}
/** MsgUpdateDeploymentResponse defines the Msg/UpdateDeployment response type. */
export interface MsgUpdateDeploymentResponseSDKType {
}
/** MsgCloseDeployment defines an SDK message for closing deployment */
export interface MsgCloseDeployment {
    id: DeploymentID;
}
export interface MsgCloseDeploymentProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.MsgCloseDeployment";
    value: Uint8Array;
}
/** MsgCloseDeployment defines an SDK message for closing deployment */
export interface MsgCloseDeploymentAmino {
    id: DeploymentIDAmino;
}
export interface MsgCloseDeploymentAminoMsg {
    type: "akash/deployment/v1beta2/testonly-close-deployment";
    value: MsgCloseDeploymentAmino;
}
/** MsgCloseDeployment defines an SDK message for closing deployment */
export interface MsgCloseDeploymentSDKType {
    id: DeploymentIDSDKType;
}
/** MsgCloseDeploymentResponse defines the Msg/CloseDeployment response type. */
export interface MsgCloseDeploymentResponse {
}
export interface MsgCloseDeploymentResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.MsgCloseDeploymentResponse";
    value: Uint8Array;
}
/** MsgCloseDeploymentResponse defines the Msg/CloseDeployment response type. */
export interface MsgCloseDeploymentResponseAmino {
}
export interface MsgCloseDeploymentResponseAminoMsg {
    type: "akash/deployment/v1beta2/testonly-close-deployment-response";
    value: MsgCloseDeploymentResponseAmino;
}
/** MsgCloseDeploymentResponse defines the Msg/CloseDeployment response type. */
export interface MsgCloseDeploymentResponseSDKType {
}
export declare const MsgCreateDeployment: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCreateDeployment;
    isSDK(o: any): o is MsgCreateDeploymentSDKType;
    isAmino(o: any): o is MsgCreateDeploymentAmino;
    encode(message: MsgCreateDeployment, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCreateDeployment;
    fromJSON(object: any): MsgCreateDeployment;
    toJSON(message: MsgCreateDeployment): JsonSafe<MsgCreateDeployment>;
    fromPartial<I extends Exact<DeepPartial<MsgCreateDeployment>, I>>(object: I): MsgCreateDeployment;
    fromSDK(object: MsgCreateDeploymentSDKType): MsgCreateDeployment;
    fromSDKJSON(object: any): MsgCreateDeploymentSDKType;
    toSDK(message: MsgCreateDeployment): MsgCreateDeploymentSDKType;
    fromAmino(object: MsgCreateDeploymentAmino): MsgCreateDeployment;
    toAmino(message: MsgCreateDeployment): MsgCreateDeploymentAmino;
    fromAminoMsg(object: MsgCreateDeploymentAminoMsg): MsgCreateDeployment;
    toAminoMsg(message: MsgCreateDeployment): MsgCreateDeploymentAminoMsg;
    fromProtoMsg(message: MsgCreateDeploymentProtoMsg): MsgCreateDeployment;
    toProto(message: MsgCreateDeployment): Uint8Array;
    toProtoMsg(message: MsgCreateDeployment): MsgCreateDeploymentProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgCreateDeploymentResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCreateDeploymentResponse;
    isSDK(o: any): o is MsgCreateDeploymentResponseSDKType;
    isAmino(o: any): o is MsgCreateDeploymentResponseAmino;
    encode(_: MsgCreateDeploymentResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCreateDeploymentResponse;
    fromJSON(_: any): MsgCreateDeploymentResponse;
    toJSON(_: MsgCreateDeploymentResponse): JsonSafe<MsgCreateDeploymentResponse>;
    fromPartial<I extends Exact<DeepPartial<MsgCreateDeploymentResponse>, I>>(_: I): MsgCreateDeploymentResponse;
    fromSDK(_: MsgCreateDeploymentResponseSDKType): MsgCreateDeploymentResponse;
    fromSDKJSON(_: any): MsgCreateDeploymentResponseSDKType;
    toSDK(_: MsgCreateDeploymentResponse): MsgCreateDeploymentResponseSDKType;
    fromAmino(_: MsgCreateDeploymentResponseAmino): MsgCreateDeploymentResponse;
    toAmino(_: MsgCreateDeploymentResponse): MsgCreateDeploymentResponseAmino;
    fromAminoMsg(object: MsgCreateDeploymentResponseAminoMsg): MsgCreateDeploymentResponse;
    toAminoMsg(message: MsgCreateDeploymentResponse): MsgCreateDeploymentResponseAminoMsg;
    fromProtoMsg(message: MsgCreateDeploymentResponseProtoMsg): MsgCreateDeploymentResponse;
    toProto(message: MsgCreateDeploymentResponse): Uint8Array;
    toProtoMsg(message: MsgCreateDeploymentResponse): MsgCreateDeploymentResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgDepositDeployment: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgDepositDeployment;
    isSDK(o: any): o is MsgDepositDeploymentSDKType;
    isAmino(o: any): o is MsgDepositDeploymentAmino;
    encode(message: MsgDepositDeployment, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgDepositDeployment;
    fromJSON(object: any): MsgDepositDeployment;
    toJSON(message: MsgDepositDeployment): JsonSafe<MsgDepositDeployment>;
    fromPartial<I extends Exact<DeepPartial<MsgDepositDeployment>, I>>(object: I): MsgDepositDeployment;
    fromSDK(object: MsgDepositDeploymentSDKType): MsgDepositDeployment;
    fromSDKJSON(object: any): MsgDepositDeploymentSDKType;
    toSDK(message: MsgDepositDeployment): MsgDepositDeploymentSDKType;
    fromAmino(object: MsgDepositDeploymentAmino): MsgDepositDeployment;
    toAmino(message: MsgDepositDeployment): MsgDepositDeploymentAmino;
    fromAminoMsg(object: MsgDepositDeploymentAminoMsg): MsgDepositDeployment;
    toAminoMsg(message: MsgDepositDeployment): MsgDepositDeploymentAminoMsg;
    fromProtoMsg(message: MsgDepositDeploymentProtoMsg): MsgDepositDeployment;
    toProto(message: MsgDepositDeployment): Uint8Array;
    toProtoMsg(message: MsgDepositDeployment): MsgDepositDeploymentProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgDepositDeploymentResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgDepositDeploymentResponse;
    isSDK(o: any): o is MsgDepositDeploymentResponseSDKType;
    isAmino(o: any): o is MsgDepositDeploymentResponseAmino;
    encode(_: MsgDepositDeploymentResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgDepositDeploymentResponse;
    fromJSON(_: any): MsgDepositDeploymentResponse;
    toJSON(_: MsgDepositDeploymentResponse): JsonSafe<MsgDepositDeploymentResponse>;
    fromPartial<I extends Exact<DeepPartial<MsgDepositDeploymentResponse>, I>>(_: I): MsgDepositDeploymentResponse;
    fromSDK(_: MsgDepositDeploymentResponseSDKType): MsgDepositDeploymentResponse;
    fromSDKJSON(_: any): MsgDepositDeploymentResponseSDKType;
    toSDK(_: MsgDepositDeploymentResponse): MsgDepositDeploymentResponseSDKType;
    fromAmino(_: MsgDepositDeploymentResponseAmino): MsgDepositDeploymentResponse;
    toAmino(_: MsgDepositDeploymentResponse): MsgDepositDeploymentResponseAmino;
    fromAminoMsg(object: MsgDepositDeploymentResponseAminoMsg): MsgDepositDeploymentResponse;
    toAminoMsg(message: MsgDepositDeploymentResponse): MsgDepositDeploymentResponseAminoMsg;
    fromProtoMsg(message: MsgDepositDeploymentResponseProtoMsg): MsgDepositDeploymentResponse;
    toProto(message: MsgDepositDeploymentResponse): Uint8Array;
    toProtoMsg(message: MsgDepositDeploymentResponse): MsgDepositDeploymentResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgUpdateDeployment: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgUpdateDeployment;
    isSDK(o: any): o is MsgUpdateDeploymentSDKType;
    isAmino(o: any): o is MsgUpdateDeploymentAmino;
    encode(message: MsgUpdateDeployment, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgUpdateDeployment;
    fromJSON(object: any): MsgUpdateDeployment;
    toJSON(message: MsgUpdateDeployment): JsonSafe<MsgUpdateDeployment>;
    fromPartial<I extends Exact<DeepPartial<MsgUpdateDeployment>, I>>(object: I): MsgUpdateDeployment;
    fromSDK(object: MsgUpdateDeploymentSDKType): MsgUpdateDeployment;
    fromSDKJSON(object: any): MsgUpdateDeploymentSDKType;
    toSDK(message: MsgUpdateDeployment): MsgUpdateDeploymentSDKType;
    fromAmino(object: MsgUpdateDeploymentAmino): MsgUpdateDeployment;
    toAmino(message: MsgUpdateDeployment): MsgUpdateDeploymentAmino;
    fromAminoMsg(object: MsgUpdateDeploymentAminoMsg): MsgUpdateDeployment;
    toAminoMsg(message: MsgUpdateDeployment): MsgUpdateDeploymentAminoMsg;
    fromProtoMsg(message: MsgUpdateDeploymentProtoMsg): MsgUpdateDeployment;
    toProto(message: MsgUpdateDeployment): Uint8Array;
    toProtoMsg(message: MsgUpdateDeployment): MsgUpdateDeploymentProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgUpdateDeploymentResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgUpdateDeploymentResponse;
    isSDK(o: any): o is MsgUpdateDeploymentResponseSDKType;
    isAmino(o: any): o is MsgUpdateDeploymentResponseAmino;
    encode(_: MsgUpdateDeploymentResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgUpdateDeploymentResponse;
    fromJSON(_: any): MsgUpdateDeploymentResponse;
    toJSON(_: MsgUpdateDeploymentResponse): JsonSafe<MsgUpdateDeploymentResponse>;
    fromPartial<I extends Exact<DeepPartial<MsgUpdateDeploymentResponse>, I>>(_: I): MsgUpdateDeploymentResponse;
    fromSDK(_: MsgUpdateDeploymentResponseSDKType): MsgUpdateDeploymentResponse;
    fromSDKJSON(_: any): MsgUpdateDeploymentResponseSDKType;
    toSDK(_: MsgUpdateDeploymentResponse): MsgUpdateDeploymentResponseSDKType;
    fromAmino(_: MsgUpdateDeploymentResponseAmino): MsgUpdateDeploymentResponse;
    toAmino(_: MsgUpdateDeploymentResponse): MsgUpdateDeploymentResponseAmino;
    fromAminoMsg(object: MsgUpdateDeploymentResponseAminoMsg): MsgUpdateDeploymentResponse;
    toAminoMsg(message: MsgUpdateDeploymentResponse): MsgUpdateDeploymentResponseAminoMsg;
    fromProtoMsg(message: MsgUpdateDeploymentResponseProtoMsg): MsgUpdateDeploymentResponse;
    toProto(message: MsgUpdateDeploymentResponse): Uint8Array;
    toProtoMsg(message: MsgUpdateDeploymentResponse): MsgUpdateDeploymentResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgCloseDeployment: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCloseDeployment;
    isSDK(o: any): o is MsgCloseDeploymentSDKType;
    isAmino(o: any): o is MsgCloseDeploymentAmino;
    encode(message: MsgCloseDeployment, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCloseDeployment;
    fromJSON(object: any): MsgCloseDeployment;
    toJSON(message: MsgCloseDeployment): JsonSafe<MsgCloseDeployment>;
    fromPartial<I extends Exact<DeepPartial<MsgCloseDeployment>, I>>(object: I): MsgCloseDeployment;
    fromSDK(object: MsgCloseDeploymentSDKType): MsgCloseDeployment;
    fromSDKJSON(object: any): MsgCloseDeploymentSDKType;
    toSDK(message: MsgCloseDeployment): MsgCloseDeploymentSDKType;
    fromAmino(object: MsgCloseDeploymentAmino): MsgCloseDeployment;
    toAmino(message: MsgCloseDeployment): MsgCloseDeploymentAmino;
    fromAminoMsg(object: MsgCloseDeploymentAminoMsg): MsgCloseDeployment;
    toAminoMsg(message: MsgCloseDeployment): MsgCloseDeploymentAminoMsg;
    fromProtoMsg(message: MsgCloseDeploymentProtoMsg): MsgCloseDeployment;
    toProto(message: MsgCloseDeployment): Uint8Array;
    toProtoMsg(message: MsgCloseDeployment): MsgCloseDeploymentProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgCloseDeploymentResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCloseDeploymentResponse;
    isSDK(o: any): o is MsgCloseDeploymentResponseSDKType;
    isAmino(o: any): o is MsgCloseDeploymentResponseAmino;
    encode(_: MsgCloseDeploymentResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCloseDeploymentResponse;
    fromJSON(_: any): MsgCloseDeploymentResponse;
    toJSON(_: MsgCloseDeploymentResponse): JsonSafe<MsgCloseDeploymentResponse>;
    fromPartial<I extends Exact<DeepPartial<MsgCloseDeploymentResponse>, I>>(_: I): MsgCloseDeploymentResponse;
    fromSDK(_: MsgCloseDeploymentResponseSDKType): MsgCloseDeploymentResponse;
    fromSDKJSON(_: any): MsgCloseDeploymentResponseSDKType;
    toSDK(_: MsgCloseDeploymentResponse): MsgCloseDeploymentResponseSDKType;
    fromAmino(_: MsgCloseDeploymentResponseAmino): MsgCloseDeploymentResponse;
    toAmino(_: MsgCloseDeploymentResponse): MsgCloseDeploymentResponseAmino;
    fromAminoMsg(object: MsgCloseDeploymentResponseAminoMsg): MsgCloseDeploymentResponse;
    toAminoMsg(message: MsgCloseDeploymentResponse): MsgCloseDeploymentResponseAminoMsg;
    fromProtoMsg(message: MsgCloseDeploymentResponseProtoMsg): MsgCloseDeploymentResponse;
    toProto(message: MsgCloseDeploymentResponse): Uint8Array;
    toProtoMsg(message: MsgCloseDeploymentResponse): MsgCloseDeploymentResponseProtoMsg;
    registerTypeUrl(): void;
};
