import { Deployment, DeploymentAmino, DeploymentSDKType } from "./deployment";
import { Group, GroupAmino, GroupSDKType } from "./group";
import { Params, ParamsAmino, ParamsSDKType } from "./params";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.deployment.v1beta2";
/** GenesisDeployment defines the basic genesis state used by deployment module */
export interface GenesisDeployment {
    deployment: Deployment;
    groups: Group[];
}
export interface GenesisDeploymentProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.GenesisDeployment";
    value: Uint8Array;
}
/** GenesisDeployment defines the basic genesis state used by deployment module */
export interface GenesisDeploymentAmino {
    deployment: DeploymentAmino;
    groups: GroupAmino[];
}
export interface GenesisDeploymentAminoMsg {
    type: "akash/deployment/v1beta2/genesis-deployment";
    value: GenesisDeploymentAmino;
}
/** GenesisDeployment defines the basic genesis state used by deployment module */
export interface GenesisDeploymentSDKType {
    deployment: DeploymentSDKType;
    groups: GroupSDKType[];
}
/** GenesisState stores slice of genesis deployment instance */
export interface GenesisState {
    deployments: GenesisDeployment[];
    params: Params;
}
export interface GenesisStateProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.GenesisState";
    value: Uint8Array;
}
/** GenesisState stores slice of genesis deployment instance */
export interface GenesisStateAmino {
    deployments: GenesisDeploymentAmino[];
    params: ParamsAmino;
}
export interface GenesisStateAminoMsg {
    type: "akash/deployment/v1beta2/genesis-state";
    value: GenesisStateAmino;
}
/** GenesisState stores slice of genesis deployment instance */
export interface GenesisStateSDKType {
    deployments: GenesisDeploymentSDKType[];
    params: ParamsSDKType;
}
export declare const GenesisDeployment: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is GenesisDeployment;
    isSDK(o: any): o is GenesisDeploymentSDKType;
    isAmino(o: any): o is GenesisDeploymentAmino;
    encode(message: GenesisDeployment, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GenesisDeployment;
    fromJSON(object: any): GenesisDeployment;
    toJSON(message: GenesisDeployment): JsonSafe<GenesisDeployment>;
    fromPartial<I extends Exact<DeepPartial<GenesisDeployment>, I>>(object: I): GenesisDeployment;
    fromSDK(object: GenesisDeploymentSDKType): GenesisDeployment;
    fromSDKJSON(object: any): GenesisDeploymentSDKType;
    toSDK(message: GenesisDeployment): GenesisDeploymentSDKType;
    fromAmino(object: GenesisDeploymentAmino): GenesisDeployment;
    toAmino(message: GenesisDeployment): GenesisDeploymentAmino;
    fromAminoMsg(object: GenesisDeploymentAminoMsg): GenesisDeployment;
    toAminoMsg(message: GenesisDeployment): GenesisDeploymentAminoMsg;
    fromProtoMsg(message: GenesisDeploymentProtoMsg): GenesisDeployment;
    toProto(message: GenesisDeployment): Uint8Array;
    toProtoMsg(message: GenesisDeployment): GenesisDeploymentProtoMsg;
    registerTypeUrl(): void;
};
export declare const GenesisState: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is GenesisState;
    isSDK(o: any): o is GenesisStateSDKType;
    isAmino(o: any): o is GenesisStateAmino;
    encode(message: GenesisState, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GenesisState;
    fromJSON(object: any): GenesisState;
    toJSON(message: GenesisState): JsonSafe<GenesisState>;
    fromPartial<I extends Exact<DeepPartial<GenesisState>, I>>(object: I): GenesisState;
    fromSDK(object: GenesisStateSDKType): GenesisState;
    fromSDKJSON(object: any): GenesisStateSDKType;
    toSDK(message: GenesisState): GenesisStateSDKType;
    fromAmino(object: GenesisStateAmino): GenesisState;
    toAmino(message: GenesisState): GenesisStateAmino;
    fromAminoMsg(object: GenesisStateAminoMsg): GenesisState;
    toAminoMsg(message: GenesisState): GenesisStateAminoMsg;
    fromProtoMsg(message: GenesisStateProtoMsg): GenesisState;
    toProto(message: GenesisState): Uint8Array;
    toProtoMsg(message: GenesisState): GenesisStateProtoMsg;
    registerTypeUrl(): void;
};
