import { GroupID, GroupIDAmino, GroupIDSDKType } from "./groupid";
import { GroupSpec, GroupSpecAmino, GroupSpecSDKType } from "./groupspec";
import { DeepPartial, Exact } from "../../../helpers";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.deployment.v1beta2";
/** State is an enum which refers to state of group */
export declare enum Group_State {
    /** invalid - Prefix should start with 0 in enum. So declaring dummy state */
    invalid = 0,
    /** open - GroupOpen denotes state for group open */
    open = 1,
    /** paused - GroupOrdered denotes state for group ordered */
    paused = 2,
    /** insufficient_funds - GroupInsufficientFunds denotes state for group insufficient_funds */
    insufficient_funds = 3,
    /** closed - GroupClosed denotes state for group closed */
    closed = 4,
    UNRECOGNIZED = -1
}
export declare const Group_StateSDKType: typeof Group_State;
export declare const Group_StateAmino: typeof Group_State;
export declare function group_StateFromJSON(object: any): Group_State;
export declare function group_StateToJSON(object: Group_State): string;
/** Group stores group id, state and specifications of group */
export interface Group {
    groupId: GroupID;
    state: Group_State;
    groupSpec: GroupSpec;
    createdAt: bigint;
}
export interface GroupProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.Group";
    value: Uint8Array;
}
/** Group stores group id, state and specifications of group */
export interface GroupAmino {
    group_id: GroupIDAmino;
    state: Group_State;
    group_spec: GroupSpecAmino;
    created_at?: string;
}
export interface GroupAminoMsg {
    type: "akash/deployment/v1beta2/group";
    value: GroupAmino;
}
/** Group stores group id, state and specifications of group */
export interface GroupSDKType {
    group_id: GroupIDSDKType;
    state: Group_State;
    group_spec: GroupSpecSDKType;
    created_at: bigint;
}
export declare const Group: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is Group;
    isSDK(o: any): o is GroupSDKType;
    isAmino(o: any): o is GroupAmino;
    encode(message: Group, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Group;
    fromJSON(object: any): Group;
    toJSON(message: Group): JsonSafe<Group>;
    fromPartial<I extends Exact<DeepPartial<Group>, I>>(object: I): Group;
    fromSDK(object: GroupSDKType): Group;
    fromSDKJSON(object: any): GroupSDKType;
    toSDK(message: Group): GroupSDKType;
    fromAmino(object: GroupAmino): Group;
    toAmino(message: Group): GroupAmino;
    fromAminoMsg(object: GroupAminoMsg): Group;
    toAminoMsg(message: Group): GroupAminoMsg;
    fromProtoMsg(message: GroupProtoMsg): Group;
    toProto(message: Group): Uint8Array;
    toProtoMsg(message: Group): GroupProtoMsg;
    registerTypeUrl(): void;
};
