import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.deployment.v1beta2";
/** GroupID stores owner, deployment sequence number and group sequence number */
export interface GroupID {
    owner: string;
    dseq: bigint;
    gseq: number;
}
export interface GroupIDProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.GroupID";
    value: Uint8Array;
}
/** GroupID stores owner, deployment sequence number and group sequence number */
export interface GroupIDAmino {
    owner: string;
    dseq: string;
    gseq: number;
}
export interface GroupIDAminoMsg {
    type: "akash/deployment/v1beta2/group-i-d";
    value: GroupIDAmino;
}
/** GroupID stores owner, deployment sequence number and group sequence number */
export interface GroupIDSDKType {
    owner: string;
    dseq: bigint;
    gseq: number;
}
export declare const GroupID: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is GroupID;
    isSDK(o: any): o is GroupIDSDKType;
    isAmino(o: any): o is GroupIDAmino;
    encode(message: GroupID, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GroupID;
    fromJSON(object: any): GroupID;
    toJSON(message: GroupID): JsonSafe<GroupID>;
    fromPartial<I extends Exact<DeepPartial<GroupID>, I>>(object: I): GroupID;
    fromSDK(object: GroupIDSDKType): GroupID;
    fromSDKJSON(object: any): GroupIDSDKType;
    toSDK(message: GroupID): GroupIDSDKType;
    fromAmino(object: GroupIDAmino): GroupID;
    toAmino(message: GroupID): GroupIDAmino;
    fromAminoMsg(object: GroupIDAminoMsg): GroupID;
    toAminoMsg(message: GroupID): GroupIDAminoMsg;
    fromProtoMsg(message: GroupIDProtoMsg): GroupID;
    toProto(message: GroupID): Uint8Array;
    toProtoMsg(message: GroupID): GroupIDProtoMsg;
    registerTypeUrl(): void;
};
