import { GroupID, GroupIDAmino, GroupIDSDKType } from "./groupid";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.deployment.v1beta2";
/** MsgCloseGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgCloseGroup {
    id: GroupID;
}
export interface MsgCloseGroupProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.MsgCloseGroup";
    value: Uint8Array;
}
/** MsgCloseGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgCloseGroupAmino {
    id: GroupIDAmino;
}
export interface MsgCloseGroupAminoMsg {
    type: "akash/deployment/v1beta2/testonly-close-group";
    value: MsgCloseGroupAmino;
}
/** MsgCloseGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgCloseGroupSDKType {
    id: GroupIDSDKType;
}
/** MsgCloseGroupResponse defines the Msg/CloseGroup response type. */
export interface MsgCloseGroupResponse {
}
export interface MsgCloseGroupResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.MsgCloseGroupResponse";
    value: Uint8Array;
}
/** MsgCloseGroupResponse defines the Msg/CloseGroup response type. */
export interface MsgCloseGroupResponseAmino {
}
export interface MsgCloseGroupResponseAminoMsg {
    type: "akash/deployment/v1beta2/testonly-close-group-response";
    value: MsgCloseGroupResponseAmino;
}
/** MsgCloseGroupResponse defines the Msg/CloseGroup response type. */
export interface MsgCloseGroupResponseSDKType {
}
/** MsgPauseGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgPauseGroup {
    id: GroupID;
}
export interface MsgPauseGroupProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.MsgPauseGroup";
    value: Uint8Array;
}
/** MsgPauseGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgPauseGroupAmino {
    id: GroupIDAmino;
}
export interface MsgPauseGroupAminoMsg {
    type: "akash/deployment/v1beta2/testonly-pause-group";
    value: MsgPauseGroupAmino;
}
/** MsgPauseGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgPauseGroupSDKType {
    id: GroupIDSDKType;
}
/** MsgPauseGroupResponse defines the Msg/PauseGroup response type. */
export interface MsgPauseGroupResponse {
}
export interface MsgPauseGroupResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.MsgPauseGroupResponse";
    value: Uint8Array;
}
/** MsgPauseGroupResponse defines the Msg/PauseGroup response type. */
export interface MsgPauseGroupResponseAmino {
}
export interface MsgPauseGroupResponseAminoMsg {
    type: "akash/deployment/v1beta2/testonly-pause-group-response";
    value: MsgPauseGroupResponseAmino;
}
/** MsgPauseGroupResponse defines the Msg/PauseGroup response type. */
export interface MsgPauseGroupResponseSDKType {
}
/** MsgStartGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgStartGroup {
    id: GroupID;
}
export interface MsgStartGroupProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.MsgStartGroup";
    value: Uint8Array;
}
/** MsgStartGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgStartGroupAmino {
    id: GroupIDAmino;
}
export interface MsgStartGroupAminoMsg {
    type: "akash/deployment/v1beta2/testonly-start-group";
    value: MsgStartGroupAmino;
}
/** MsgStartGroup defines SDK message to close a single Group within a Deployment. */
export interface MsgStartGroupSDKType {
    id: GroupIDSDKType;
}
/** MsgStartGroupResponse defines the Msg/StartGroup response type. */
export interface MsgStartGroupResponse {
}
export interface MsgStartGroupResponseProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.MsgStartGroupResponse";
    value: Uint8Array;
}
/** MsgStartGroupResponse defines the Msg/StartGroup response type. */
export interface MsgStartGroupResponseAmino {
}
export interface MsgStartGroupResponseAminoMsg {
    type: "akash/deployment/v1beta2/testonly-start-group-response";
    value: MsgStartGroupResponseAmino;
}
/** MsgStartGroupResponse defines the Msg/StartGroup response type. */
export interface MsgStartGroupResponseSDKType {
}
export declare const MsgCloseGroup: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCloseGroup;
    isSDK(o: any): o is MsgCloseGroupSDKType;
    isAmino(o: any): o is MsgCloseGroupAmino;
    encode(message: MsgCloseGroup, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCloseGroup;
    fromJSON(object: any): MsgCloseGroup;
    toJSON(message: MsgCloseGroup): JsonSafe<MsgCloseGroup>;
    fromPartial<I extends Exact<DeepPartial<MsgCloseGroup>, I>>(object: I): MsgCloseGroup;
    fromSDK(object: MsgCloseGroupSDKType): MsgCloseGroup;
    fromSDKJSON(object: any): MsgCloseGroupSDKType;
    toSDK(message: MsgCloseGroup): MsgCloseGroupSDKType;
    fromAmino(object: MsgCloseGroupAmino): MsgCloseGroup;
    toAmino(message: MsgCloseGroup): MsgCloseGroupAmino;
    fromAminoMsg(object: MsgCloseGroupAminoMsg): MsgCloseGroup;
    toAminoMsg(message: MsgCloseGroup): MsgCloseGroupAminoMsg;
    fromProtoMsg(message: MsgCloseGroupProtoMsg): MsgCloseGroup;
    toProto(message: MsgCloseGroup): Uint8Array;
    toProtoMsg(message: MsgCloseGroup): MsgCloseGroupProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgCloseGroupResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCloseGroupResponse;
    isSDK(o: any): o is MsgCloseGroupResponseSDKType;
    isAmino(o: any): o is MsgCloseGroupResponseAmino;
    encode(_: MsgCloseGroupResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCloseGroupResponse;
    fromJSON(_: any): MsgCloseGroupResponse;
    toJSON(_: MsgCloseGroupResponse): JsonSafe<MsgCloseGroupResponse>;
    fromPartial<I extends Exact<DeepPartial<MsgCloseGroupResponse>, I>>(_: I): MsgCloseGroupResponse;
    fromSDK(_: MsgCloseGroupResponseSDKType): MsgCloseGroupResponse;
    fromSDKJSON(_: any): MsgCloseGroupResponseSDKType;
    toSDK(_: MsgCloseGroupResponse): MsgCloseGroupResponseSDKType;
    fromAmino(_: MsgCloseGroupResponseAmino): MsgCloseGroupResponse;
    toAmino(_: MsgCloseGroupResponse): MsgCloseGroupResponseAmino;
    fromAminoMsg(object: MsgCloseGroupResponseAminoMsg): MsgCloseGroupResponse;
    toAminoMsg(message: MsgCloseGroupResponse): MsgCloseGroupResponseAminoMsg;
    fromProtoMsg(message: MsgCloseGroupResponseProtoMsg): MsgCloseGroupResponse;
    toProto(message: MsgCloseGroupResponse): Uint8Array;
    toProtoMsg(message: MsgCloseGroupResponse): MsgCloseGroupResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgPauseGroup: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgPauseGroup;
    isSDK(o: any): o is MsgPauseGroupSDKType;
    isAmino(o: any): o is MsgPauseGroupAmino;
    encode(message: MsgPauseGroup, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgPauseGroup;
    fromJSON(object: any): MsgPauseGroup;
    toJSON(message: MsgPauseGroup): JsonSafe<MsgPauseGroup>;
    fromPartial<I extends Exact<DeepPartial<MsgPauseGroup>, I>>(object: I): MsgPauseGroup;
    fromSDK(object: MsgPauseGroupSDKType): MsgPauseGroup;
    fromSDKJSON(object: any): MsgPauseGroupSDKType;
    toSDK(message: MsgPauseGroup): MsgPauseGroupSDKType;
    fromAmino(object: MsgPauseGroupAmino): MsgPauseGroup;
    toAmino(message: MsgPauseGroup): MsgPauseGroupAmino;
    fromAminoMsg(object: MsgPauseGroupAminoMsg): MsgPauseGroup;
    toAminoMsg(message: MsgPauseGroup): MsgPauseGroupAminoMsg;
    fromProtoMsg(message: MsgPauseGroupProtoMsg): MsgPauseGroup;
    toProto(message: MsgPauseGroup): Uint8Array;
    toProtoMsg(message: MsgPauseGroup): MsgPauseGroupProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgPauseGroupResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgPauseGroupResponse;
    isSDK(o: any): o is MsgPauseGroupResponseSDKType;
    isAmino(o: any): o is MsgPauseGroupResponseAmino;
    encode(_: MsgPauseGroupResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgPauseGroupResponse;
    fromJSON(_: any): MsgPauseGroupResponse;
    toJSON(_: MsgPauseGroupResponse): JsonSafe<MsgPauseGroupResponse>;
    fromPartial<I extends Exact<DeepPartial<MsgPauseGroupResponse>, I>>(_: I): MsgPauseGroupResponse;
    fromSDK(_: MsgPauseGroupResponseSDKType): MsgPauseGroupResponse;
    fromSDKJSON(_: any): MsgPauseGroupResponseSDKType;
    toSDK(_: MsgPauseGroupResponse): MsgPauseGroupResponseSDKType;
    fromAmino(_: MsgPauseGroupResponseAmino): MsgPauseGroupResponse;
    toAmino(_: MsgPauseGroupResponse): MsgPauseGroupResponseAmino;
    fromAminoMsg(object: MsgPauseGroupResponseAminoMsg): MsgPauseGroupResponse;
    toAminoMsg(message: MsgPauseGroupResponse): MsgPauseGroupResponseAminoMsg;
    fromProtoMsg(message: MsgPauseGroupResponseProtoMsg): MsgPauseGroupResponse;
    toProto(message: MsgPauseGroupResponse): Uint8Array;
    toProtoMsg(message: MsgPauseGroupResponse): MsgPauseGroupResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgStartGroup: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgStartGroup;
    isSDK(o: any): o is MsgStartGroupSDKType;
    isAmino(o: any): o is MsgStartGroupAmino;
    encode(message: MsgStartGroup, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgStartGroup;
    fromJSON(object: any): MsgStartGroup;
    toJSON(message: MsgStartGroup): JsonSafe<MsgStartGroup>;
    fromPartial<I extends Exact<DeepPartial<MsgStartGroup>, I>>(object: I): MsgStartGroup;
    fromSDK(object: MsgStartGroupSDKType): MsgStartGroup;
    fromSDKJSON(object: any): MsgStartGroupSDKType;
    toSDK(message: MsgStartGroup): MsgStartGroupSDKType;
    fromAmino(object: MsgStartGroupAmino): MsgStartGroup;
    toAmino(message: MsgStartGroup): MsgStartGroupAmino;
    fromAminoMsg(object: MsgStartGroupAminoMsg): MsgStartGroup;
    toAminoMsg(message: MsgStartGroup): MsgStartGroupAminoMsg;
    fromProtoMsg(message: MsgStartGroupProtoMsg): MsgStartGroup;
    toProto(message: MsgStartGroup): Uint8Array;
    toProtoMsg(message: MsgStartGroup): MsgStartGroupProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgStartGroupResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgStartGroupResponse;
    isSDK(o: any): o is MsgStartGroupResponseSDKType;
    isAmino(o: any): o is MsgStartGroupResponseAmino;
    encode(_: MsgStartGroupResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgStartGroupResponse;
    fromJSON(_: any): MsgStartGroupResponse;
    toJSON(_: MsgStartGroupResponse): JsonSafe<MsgStartGroupResponse>;
    fromPartial<I extends Exact<DeepPartial<MsgStartGroupResponse>, I>>(_: I): MsgStartGroupResponse;
    fromSDK(_: MsgStartGroupResponseSDKType): MsgStartGroupResponse;
    fromSDKJSON(_: any): MsgStartGroupResponseSDKType;
    toSDK(_: MsgStartGroupResponse): MsgStartGroupResponseSDKType;
    fromAmino(_: MsgStartGroupResponseAmino): MsgStartGroupResponse;
    toAmino(_: MsgStartGroupResponse): MsgStartGroupResponseAmino;
    fromAminoMsg(object: MsgStartGroupResponseAminoMsg): MsgStartGroupResponse;
    toAminoMsg(message: MsgStartGroupResponse): MsgStartGroupResponseAminoMsg;
    fromProtoMsg(message: MsgStartGroupResponseProtoMsg): MsgStartGroupResponse;
    toProto(message: MsgStartGroupResponse): Uint8Array;
    toProtoMsg(message: MsgStartGroupResponse): MsgStartGroupResponseProtoMsg;
    registerTypeUrl(): void;
};
