import { GroupID } from "./groupid";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.deployment.v1beta2";
function createBaseMsgCloseGroup() {
    return {
        id: GroupID.fromPartial({})
    };
}
export const MsgCloseGroup = {
    typeUrl: "/akash.deployment.v1beta2.MsgCloseGroup",
    aminoType: "akash/deployment/v1beta2/testonly-close-group",
    is(o) {
        return o && (o.$typeUrl === MsgCloseGroup.typeUrl || GroupID.is(o.id));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgCloseGroup.typeUrl || GroupID.isSDK(o.id));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgCloseGroup.typeUrl || GroupID.isAmino(o.id));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            GroupID.encode(message.id, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCloseGroup();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = GroupID.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgCloseGroup();
        if (isSet(object.id))
            obj.id = GroupID.fromJSON(object.id);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? GroupID.toJSON(message.id) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgCloseGroup();
        if (object.id !== undefined && object.id !== null) {
            message.id = GroupID.fromPartial(object.id);
        }
        return message;
    },
    fromSDK(object) {
        return {
            id: object.id ? GroupID.fromSDK(object.id) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? GroupID.fromSDKJSON(object.id) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? GroupID.toSDK(message.id) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgCloseGroup();
        if (object.id !== undefined && object.id !== null) {
            message.id = GroupID.fromAmino(object.id);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id ? GroupID.toAmino(message.id) : GroupID.toAmino(GroupID.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCloseGroup.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/v1beta2/testonly-close-group",
            value: MsgCloseGroup.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgCloseGroup.decode(message.value);
    },
    toProto(message) {
        return MsgCloseGroup.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta2.MsgCloseGroup",
            value: MsgCloseGroup.encode(message).finish()
        };
    },
    registerTypeUrl() {
        GroupID.registerTypeUrl();
    }
};
function createBaseMsgCloseGroupResponse() {
    return {};
}
export const MsgCloseGroupResponse = {
    typeUrl: "/akash.deployment.v1beta2.MsgCloseGroupResponse",
    aminoType: "akash/deployment/v1beta2/testonly-close-group-response",
    is(o) {
        return o && o.$typeUrl === MsgCloseGroupResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgCloseGroupResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgCloseGroupResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCloseGroupResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgCloseGroupResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgCloseGroupResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgCloseGroupResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCloseGroupResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/v1beta2/testonly-close-group-response",
            value: MsgCloseGroupResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgCloseGroupResponse.decode(message.value);
    },
    toProto(message) {
        return MsgCloseGroupResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta2.MsgCloseGroupResponse",
            value: MsgCloseGroupResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgPauseGroup() {
    return {
        id: GroupID.fromPartial({})
    };
}
export const MsgPauseGroup = {
    typeUrl: "/akash.deployment.v1beta2.MsgPauseGroup",
    aminoType: "akash/deployment/v1beta2/testonly-pause-group",
    is(o) {
        return o && (o.$typeUrl === MsgPauseGroup.typeUrl || GroupID.is(o.id));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgPauseGroup.typeUrl || GroupID.isSDK(o.id));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgPauseGroup.typeUrl || GroupID.isAmino(o.id));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            GroupID.encode(message.id, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgPauseGroup();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = GroupID.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgPauseGroup();
        if (isSet(object.id))
            obj.id = GroupID.fromJSON(object.id);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? GroupID.toJSON(message.id) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgPauseGroup();
        if (object.id !== undefined && object.id !== null) {
            message.id = GroupID.fromPartial(object.id);
        }
        return message;
    },
    fromSDK(object) {
        return {
            id: object.id ? GroupID.fromSDK(object.id) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? GroupID.fromSDKJSON(object.id) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? GroupID.toSDK(message.id) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgPauseGroup();
        if (object.id !== undefined && object.id !== null) {
            message.id = GroupID.fromAmino(object.id);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id ? GroupID.toAmino(message.id) : GroupID.toAmino(GroupID.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return MsgPauseGroup.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/v1beta2/testonly-pause-group",
            value: MsgPauseGroup.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgPauseGroup.decode(message.value);
    },
    toProto(message) {
        return MsgPauseGroup.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta2.MsgPauseGroup",
            value: MsgPauseGroup.encode(message).finish()
        };
    },
    registerTypeUrl() {
        GroupID.registerTypeUrl();
    }
};
function createBaseMsgPauseGroupResponse() {
    return {};
}
export const MsgPauseGroupResponse = {
    typeUrl: "/akash.deployment.v1beta2.MsgPauseGroupResponse",
    aminoType: "akash/deployment/v1beta2/testonly-pause-group-response",
    is(o) {
        return o && o.$typeUrl === MsgPauseGroupResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgPauseGroupResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgPauseGroupResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgPauseGroupResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgPauseGroupResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgPauseGroupResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgPauseGroupResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgPauseGroupResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/v1beta2/testonly-pause-group-response",
            value: MsgPauseGroupResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgPauseGroupResponse.decode(message.value);
    },
    toProto(message) {
        return MsgPauseGroupResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta2.MsgPauseGroupResponse",
            value: MsgPauseGroupResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgStartGroup() {
    return {
        id: GroupID.fromPartial({})
    };
}
export const MsgStartGroup = {
    typeUrl: "/akash.deployment.v1beta2.MsgStartGroup",
    aminoType: "akash/deployment/v1beta2/testonly-start-group",
    is(o) {
        return o && (o.$typeUrl === MsgStartGroup.typeUrl || GroupID.is(o.id));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgStartGroup.typeUrl || GroupID.isSDK(o.id));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgStartGroup.typeUrl || GroupID.isAmino(o.id));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            GroupID.encode(message.id, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgStartGroup();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = GroupID.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgStartGroup();
        if (isSet(object.id))
            obj.id = GroupID.fromJSON(object.id);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? GroupID.toJSON(message.id) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgStartGroup();
        if (object.id !== undefined && object.id !== null) {
            message.id = GroupID.fromPartial(object.id);
        }
        return message;
    },
    fromSDK(object) {
        return {
            id: object.id ? GroupID.fromSDK(object.id) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? GroupID.fromSDKJSON(object.id) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? GroupID.toSDK(message.id) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgStartGroup();
        if (object.id !== undefined && object.id !== null) {
            message.id = GroupID.fromAmino(object.id);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id ? GroupID.toAmino(message.id) : GroupID.toAmino(GroupID.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return MsgStartGroup.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/v1beta2/testonly-start-group",
            value: MsgStartGroup.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgStartGroup.decode(message.value);
    },
    toProto(message) {
        return MsgStartGroup.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta2.MsgStartGroup",
            value: MsgStartGroup.encode(message).finish()
        };
    },
    registerTypeUrl() {
        GroupID.registerTypeUrl();
    }
};
function createBaseMsgStartGroupResponse() {
    return {};
}
export const MsgStartGroupResponse = {
    typeUrl: "/akash.deployment.v1beta2.MsgStartGroupResponse",
    aminoType: "akash/deployment/v1beta2/testonly-start-group-response",
    is(o) {
        return o && o.$typeUrl === MsgStartGroupResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgStartGroupResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgStartGroupResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgStartGroupResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgStartGroupResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgStartGroupResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgStartGroupResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgStartGroupResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/v1beta2/testonly-start-group-response",
            value: MsgStartGroupResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgStartGroupResponse.decode(message.value);
    },
    toProto(message) {
        return MsgStartGroupResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta2.MsgStartGroupResponse",
            value: MsgStartGroupResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
