import { PlacementRequirements, PlacementRequirementsAmino, PlacementRequirementsSDKType } from "../../base/v1beta2/attribute";
import { Resource, ResourceAmino, ResourceSDKType } from "./resource";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.deployment.v1beta2";
/** GroupSpec stores group specifications */
export interface GroupSpec {
    name: string;
    requirements: PlacementRequirements;
    resources: Resource[];
}
export interface GroupSpecProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.GroupSpec";
    value: Uint8Array;
}
/** GroupSpec stores group specifications */
export interface GroupSpecAmino {
    name: string;
    requirements: PlacementRequirementsAmino;
    resources: ResourceAmino[];
}
export interface GroupSpecAminoMsg {
    type: "akash/deployment/v1beta2/group-spec";
    value: GroupSpecAmino;
}
/** GroupSpec stores group specifications */
export interface GroupSpecSDKType {
    name: string;
    requirements: PlacementRequirementsSDKType;
    resources: ResourceSDKType[];
}
export declare const GroupSpec: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is GroupSpec;
    isSDK(o: any): o is GroupSpecSDKType;
    isAmino(o: any): o is GroupSpecAmino;
    encode(message: GroupSpec, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GroupSpec;
    fromJSON(object: any): GroupSpec;
    toJSON(message: GroupSpec): JsonSafe<GroupSpec>;
    fromPartial<I extends Exact<DeepPartial<GroupSpec>, I>>(object: I): GroupSpec;
    fromSDK(object: GroupSpecSDKType): GroupSpec;
    fromSDKJSON(object: any): GroupSpecSDKType;
    toSDK(message: GroupSpec): GroupSpecSDKType;
    fromAmino(object: GroupSpecAmino): GroupSpec;
    toAmino(message: GroupSpec): GroupSpecAmino;
    fromAminoMsg(object: GroupSpecAminoMsg): GroupSpec;
    toAminoMsg(message: GroupSpec): GroupSpecAminoMsg;
    fromProtoMsg(message: GroupSpecProtoMsg): GroupSpec;
    toProto(message: GroupSpec): Uint8Array;
    toProtoMsg(message: GroupSpec): GroupSpecProtoMsg;
    registerTypeUrl(): void;
};
