import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.deployment.v1beta2";
function createBaseParams() {
    return {
        deploymentMinDeposit: Coin.fromPartial({})
    };
}
export const Params = {
    typeUrl: "/akash.deployment.v1beta2.Params",
    aminoType: "akash/deployment/v1beta2/params",
    is(o) {
        return o && (o.$typeUrl === Params.typeUrl || Coin.is(o.deploymentMinDeposit));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Params.typeUrl || Coin.isSDK(o.deployment_min_deposit));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Params.typeUrl || Coin.isAmino(o.deployment_min_deposit));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.deploymentMinDeposit !== undefined) {
            Coin.encode(message.deploymentMinDeposit, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseParams();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.deploymentMinDeposit = Coin.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseParams();
        if (isSet(object.deploymentMinDeposit))
            obj.deploymentMinDeposit = Coin.fromJSON(object.deploymentMinDeposit);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.deploymentMinDeposit !== undefined && (obj.deploymentMinDeposit = message.deploymentMinDeposit ? Coin.toJSON(message.deploymentMinDeposit) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseParams();
        if (object.deploymentMinDeposit !== undefined && object.deploymentMinDeposit !== null) {
            message.deploymentMinDeposit = Coin.fromPartial(object.deploymentMinDeposit);
        }
        return message;
    },
    fromSDK(object) {
        return {
            deploymentMinDeposit: object.deployment_min_deposit ? Coin.fromSDK(object.deployment_min_deposit) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            deployment_min_deposit: isSet(object.deployment_min_deposit) ? Coin.fromSDKJSON(object.deployment_min_deposit) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.deploymentMinDeposit !== undefined && (obj.deployment_min_deposit = message.deploymentMinDeposit ? Coin.toSDK(message.deploymentMinDeposit) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseParams();
        if (object.deployment_min_deposit !== undefined && object.deployment_min_deposit !== null) {
            message.deploymentMinDeposit = Coin.fromAmino(object.deployment_min_deposit);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.deployment_min_deposit = message.deploymentMinDeposit ? Coin.toAmino(message.deploymentMinDeposit) : Coin.toAmino(Coin.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return Params.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/v1beta2/params",
            value: Params.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Params.decode(message.value);
    },
    toProto(message) {
        return Params.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta2.Params",
            value: Params.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Coin.registerTypeUrl();
    }
};
