import { BinaryReader } from "../../../binary";
import { QueryDeploymentsRequest, QueryDeploymentsResponse, QueryDeploymentRequest, QueryDeploymentResponse, QueryGroupRequest, QueryGroupResponse } from "./query";
export class QueryClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* Deployments queries deployments */
    deployments = async (request) => {
        const data = QueryDeploymentsRequest.encode(request).finish();
        const promise = this.rpc.request("akash.deployment.v1beta2.Query", "Deployments", data);
        return promise.then(data => QueryDeploymentsResponse.decode(new BinaryReader(data)));
    };
    /* Deployment queries deployment details */
    deployment = async (request) => {
        const data = QueryDeploymentRequest.encode(request).finish();
        const promise = this.rpc.request("akash.deployment.v1beta2.Query", "Deployment", data);
        return promise.then(data => QueryDeploymentResponse.decode(new BinaryReader(data)));
    };
    /* Group queries group details */
    group = async (request) => {
        const data = QueryGroupRequest.encode(request).finish();
        const promise = this.rpc.request("akash.deployment.v1beta2.Query", "Group", data);
        return promise.then(data => QueryGroupResponse.decode(new BinaryReader(data)));
    };
}
export const createClientImpl = (rpc) => {
    return new QueryClientImpl(rpc);
};
