import { ResourceUnits, ResourceUnitsAmino, ResourceUnitsSDKType } from "../../base/v1beta2/resourceunits";
import { DecCoin, DecCoinAmino, DecCoinSDKType } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.deployment.v1beta2";
/** Resource stores unit, total count and price of resource */
export interface Resource {
    resources: ResourceUnits;
    count: number;
    price: DecCoin;
}
export interface ResourceProtoMsg {
    typeUrl: "/akash.deployment.v1beta2.Resource";
    value: Uint8Array;
}
/** Resource stores unit, total count and price of resource */
export interface ResourceAmino {
    resources: ResourceUnitsAmino;
    count: number;
    price: DecCoinAmino;
}
export interface ResourceAminoMsg {
    type: "akash/deployment/v1beta2/resource";
    value: ResourceAmino;
}
/** Resource stores unit, total count and price of resource */
export interface ResourceSDKType {
    resources: ResourceUnitsSDKType;
    count: number;
    price: DecCoinSDKType;
}
export declare const Resource: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is Resource;
    isSDK(o: any): o is ResourceSDKType;
    isAmino(o: any): o is ResourceAmino;
    encode(message: Resource, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Resource;
    fromJSON(object: any): Resource;
    toJSON(message: Resource): JsonSafe<Resource>;
    fromPartial<I extends Exact<DeepPartial<Resource>, I>>(object: I): Resource;
    fromSDK(object: ResourceSDKType): Resource;
    fromSDKJSON(object: any): ResourceSDKType;
    toSDK(message: Resource): ResourceSDKType;
    fromAmino(object: ResourceAmino): Resource;
    toAmino(message: Resource): ResourceAmino;
    fromAminoMsg(object: ResourceAminoMsg): Resource;
    toAminoMsg(message: Resource): ResourceAminoMsg;
    fromProtoMsg(message: ResourceProtoMsg): Resource;
    toProto(message: Resource): Uint8Array;
    toProtoMsg(message: Resource): ResourceProtoMsg;
    registerTypeUrl(): void;
};
