import { ResourceUnits } from "../../base/v1beta2/resourceunits";
import { DecCoin } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.deployment.v1beta2";
function createBaseResource() {
    return {
        resources: ResourceUnits.fromPartial({}),
        count: 0,
        price: DecCoin.fromPartial({})
    };
}
export const Resource = {
    typeUrl: "/akash.deployment.v1beta2.Resource",
    aminoType: "akash/deployment/v1beta2/resource",
    is(o) {
        return o && (o.$typeUrl === Resource.typeUrl || ResourceUnits.is(o.resources) && typeof o.count === "number" && DecCoin.is(o.price));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Resource.typeUrl || ResourceUnits.isSDK(o.resources) && typeof o.count === "number" && DecCoin.isSDK(o.price));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Resource.typeUrl || ResourceUnits.isAmino(o.resources) && typeof o.count === "number" && DecCoin.isAmino(o.price));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.resources !== undefined) {
            ResourceUnits.encode(message.resources, writer.uint32(10).fork()).ldelim();
        }
        if (message.count !== undefined) {
            writer.uint32(16).uint32(message.count);
        }
        if (message.price !== undefined) {
            DecCoin.encode(message.price, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseResource();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.resources = ResourceUnits.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.count = reader.uint32();
                    break;
                case 3:
                    message.price = DecCoin.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseResource();
        if (isSet(object.resources))
            obj.resources = ResourceUnits.fromJSON(object.resources);
        if (isSet(object.count))
            obj.count = Number(object.count);
        if (isSet(object.price))
            obj.price = DecCoin.fromJSON(object.price);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.resources !== undefined && (obj.resources = message.resources ? ResourceUnits.toJSON(message.resources) : undefined);
        message.count !== undefined && (obj.count = Math.round(message.count));
        message.price !== undefined && (obj.price = message.price ? DecCoin.toJSON(message.price) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseResource();
        if (object.resources !== undefined && object.resources !== null) {
            message.resources = ResourceUnits.fromPartial(object.resources);
        }
        message.count = object.count ?? 0;
        if (object.price !== undefined && object.price !== null) {
            message.price = DecCoin.fromPartial(object.price);
        }
        return message;
    },
    fromSDK(object) {
        return {
            resources: object.resources ? ResourceUnits.fromSDK(object.resources) : undefined,
            count: object?.count,
            price: object.price ? DecCoin.fromSDK(object.price) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            resources: isSet(object.resources) ? ResourceUnits.fromSDKJSON(object.resources) : undefined,
            count: isSet(object.count) ? Number(object.count) : 0,
            price: isSet(object.price) ? DecCoin.fromSDKJSON(object.price) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.resources !== undefined && (obj.resources = message.resources ? ResourceUnits.toSDK(message.resources) : undefined);
        obj.count = message.count;
        message.price !== undefined && (obj.price = message.price ? DecCoin.toSDK(message.price) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseResource();
        if (object.resources !== undefined && object.resources !== null) {
            message.resources = ResourceUnits.fromAmino(object.resources);
        }
        if (object.count !== undefined && object.count !== null) {
            message.count = object.count;
        }
        if (object.price !== undefined && object.price !== null) {
            message.price = DecCoin.fromAmino(object.price);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.resources = message.resources ? ResourceUnits.toAmino(message.resources) : ResourceUnits.toAmino(ResourceUnits.fromPartial({}));
        obj.count = message.count ?? 0;
        obj.price = message.price ? DecCoin.toAmino(message.price) : DecCoin.toAmino(DecCoin.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return Resource.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/v1beta2/resource",
            value: Resource.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Resource.decode(message.value);
    },
    toProto(message) {
        return Resource.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta2.Resource",
            value: Resource.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ResourceUnits.registerTypeUrl();
        DecCoin.registerTypeUrl();
    }
};
