import { PageRequest, PageRequestAmino, PageRequestSDKType, PageResponse, PageResponseAmino, PageResponseSDKType } from "../../../cosmos/base/query/v1beta1/pagination";
import { Account, AccountAmino, AccountSDKType, FractionalPayment, FractionalPaymentAmino, FractionalPaymentSDKType } from "./types";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.escrow.v1beta2";
/** QueryAccountRequest is request type for the Query/Account RPC method */
export interface QueryAccountsRequest {
    scope: string;
    xid: string;
    owner: string;
    state: string;
    pagination?: PageRequest;
}
export interface QueryAccountsRequestProtoMsg {
    typeUrl: "/akash.escrow.v1beta2.QueryAccountsRequest";
    value: Uint8Array;
}
/** QueryAccountRequest is request type for the Query/Account RPC method */
export interface QueryAccountsRequestAmino {
    scope?: string;
    xid?: string;
    owner?: string;
    state?: string;
    pagination?: PageRequestAmino;
}
export interface QueryAccountsRequestAminoMsg {
    type: "akash/escrow/v1beta2/query-accounts-request";
    value: QueryAccountsRequestAmino;
}
/** QueryAccountRequest is request type for the Query/Account RPC method */
export interface QueryAccountsRequestSDKType {
    scope: string;
    xid: string;
    owner: string;
    state: string;
    pagination?: PageRequestSDKType;
}
/** QueryProvidersResponse is response type for the Query/Providers RPC method */
export interface QueryAccountsResponse {
    accounts: Account[];
    pagination?: PageResponse;
}
export interface QueryAccountsResponseProtoMsg {
    typeUrl: "/akash.escrow.v1beta2.QueryAccountsResponse";
    value: Uint8Array;
}
/** QueryProvidersResponse is response type for the Query/Providers RPC method */
export interface QueryAccountsResponseAmino {
    accounts?: AccountAmino[];
    pagination?: PageResponseAmino;
}
export interface QueryAccountsResponseAminoMsg {
    type: "akash/escrow/v1beta2/query-accounts-response";
    value: QueryAccountsResponseAmino;
}
/** QueryProvidersResponse is response type for the Query/Providers RPC method */
export interface QueryAccountsResponseSDKType {
    accounts: AccountSDKType[];
    pagination?: PageResponseSDKType;
}
/** QueryPaymentRequest is request type for the Query/Payment RPC method */
export interface QueryPaymentsRequest {
    scope: string;
    xid: string;
    id: string;
    owner: string;
    state: string;
    pagination?: PageRequest;
}
export interface QueryPaymentsRequestProtoMsg {
    typeUrl: "/akash.escrow.v1beta2.QueryPaymentsRequest";
    value: Uint8Array;
}
/** QueryPaymentRequest is request type for the Query/Payment RPC method */
export interface QueryPaymentsRequestAmino {
    scope?: string;
    xid?: string;
    id?: string;
    owner?: string;
    state?: string;
    pagination?: PageRequestAmino;
}
export interface QueryPaymentsRequestAminoMsg {
    type: "akash/escrow/v1beta2/query-payments-request";
    value: QueryPaymentsRequestAmino;
}
/** QueryPaymentRequest is request type for the Query/Payment RPC method */
export interface QueryPaymentsRequestSDKType {
    scope: string;
    xid: string;
    id: string;
    owner: string;
    state: string;
    pagination?: PageRequestSDKType;
}
/** QueryProvidersResponse is response type for the Query/Providers RPC method */
export interface QueryPaymentsResponse {
    payments: FractionalPayment[];
    pagination?: PageResponse;
}
export interface QueryPaymentsResponseProtoMsg {
    typeUrl: "/akash.escrow.v1beta2.QueryPaymentsResponse";
    value: Uint8Array;
}
/** QueryProvidersResponse is response type for the Query/Providers RPC method */
export interface QueryPaymentsResponseAmino {
    payments?: FractionalPaymentAmino[];
    pagination?: PageResponseAmino;
}
export interface QueryPaymentsResponseAminoMsg {
    type: "akash/escrow/v1beta2/query-payments-response";
    value: QueryPaymentsResponseAmino;
}
/** QueryProvidersResponse is response type for the Query/Providers RPC method */
export interface QueryPaymentsResponseSDKType {
    payments: FractionalPaymentSDKType[];
    pagination?: PageResponseSDKType;
}
export declare const QueryAccountsRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryAccountsRequest;
    isSDK(o: any): o is QueryAccountsRequestSDKType;
    isAmino(o: any): o is QueryAccountsRequestAmino;
    encode(message: QueryAccountsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryAccountsRequest;
    fromJSON(object: any): QueryAccountsRequest;
    toJSON(message: QueryAccountsRequest): JsonSafe<QueryAccountsRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryAccountsRequest>, I>>(object: I): QueryAccountsRequest;
    fromSDK(object: QueryAccountsRequestSDKType): QueryAccountsRequest;
    fromSDKJSON(object: any): QueryAccountsRequestSDKType;
    toSDK(message: QueryAccountsRequest): QueryAccountsRequestSDKType;
    fromAmino(object: QueryAccountsRequestAmino): QueryAccountsRequest;
    toAmino(message: QueryAccountsRequest): QueryAccountsRequestAmino;
    fromAminoMsg(object: QueryAccountsRequestAminoMsg): QueryAccountsRequest;
    toAminoMsg(message: QueryAccountsRequest): QueryAccountsRequestAminoMsg;
    fromProtoMsg(message: QueryAccountsRequestProtoMsg): QueryAccountsRequest;
    toProto(message: QueryAccountsRequest): Uint8Array;
    toProtoMsg(message: QueryAccountsRequest): QueryAccountsRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryAccountsResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryAccountsResponse;
    isSDK(o: any): o is QueryAccountsResponseSDKType;
    isAmino(o: any): o is QueryAccountsResponseAmino;
    encode(message: QueryAccountsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryAccountsResponse;
    fromJSON(object: any): QueryAccountsResponse;
    toJSON(message: QueryAccountsResponse): JsonSafe<QueryAccountsResponse>;
    fromPartial<I extends Exact<DeepPartial<QueryAccountsResponse>, I>>(object: I): QueryAccountsResponse;
    fromSDK(object: QueryAccountsResponseSDKType): QueryAccountsResponse;
    fromSDKJSON(object: any): QueryAccountsResponseSDKType;
    toSDK(message: QueryAccountsResponse): QueryAccountsResponseSDKType;
    fromAmino(object: QueryAccountsResponseAmino): QueryAccountsResponse;
    toAmino(message: QueryAccountsResponse): QueryAccountsResponseAmino;
    fromAminoMsg(object: QueryAccountsResponseAminoMsg): QueryAccountsResponse;
    toAminoMsg(message: QueryAccountsResponse): QueryAccountsResponseAminoMsg;
    fromProtoMsg(message: QueryAccountsResponseProtoMsg): QueryAccountsResponse;
    toProto(message: QueryAccountsResponse): Uint8Array;
    toProtoMsg(message: QueryAccountsResponse): QueryAccountsResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryPaymentsRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryPaymentsRequest;
    isSDK(o: any): o is QueryPaymentsRequestSDKType;
    isAmino(o: any): o is QueryPaymentsRequestAmino;
    encode(message: QueryPaymentsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryPaymentsRequest;
    fromJSON(object: any): QueryPaymentsRequest;
    toJSON(message: QueryPaymentsRequest): JsonSafe<QueryPaymentsRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryPaymentsRequest>, I>>(object: I): QueryPaymentsRequest;
    fromSDK(object: QueryPaymentsRequestSDKType): QueryPaymentsRequest;
    fromSDKJSON(object: any): QueryPaymentsRequestSDKType;
    toSDK(message: QueryPaymentsRequest): QueryPaymentsRequestSDKType;
    fromAmino(object: QueryPaymentsRequestAmino): QueryPaymentsRequest;
    toAmino(message: QueryPaymentsRequest): QueryPaymentsRequestAmino;
    fromAminoMsg(object: QueryPaymentsRequestAminoMsg): QueryPaymentsRequest;
    toAminoMsg(message: QueryPaymentsRequest): QueryPaymentsRequestAminoMsg;
    fromProtoMsg(message: QueryPaymentsRequestProtoMsg): QueryPaymentsRequest;
    toProto(message: QueryPaymentsRequest): Uint8Array;
    toProtoMsg(message: QueryPaymentsRequest): QueryPaymentsRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryPaymentsResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryPaymentsResponse;
    isSDK(o: any): o is QueryPaymentsResponseSDKType;
    isAmino(o: any): o is QueryPaymentsResponseAmino;
    encode(message: QueryPaymentsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryPaymentsResponse;
    fromJSON(object: any): QueryPaymentsResponse;
    toJSON(message: QueryPaymentsResponse): JsonSafe<QueryPaymentsResponse>;
    fromPartial<I extends Exact<DeepPartial<QueryPaymentsResponse>, I>>(object: I): QueryPaymentsResponse;
    fromSDK(object: QueryPaymentsResponseSDKType): QueryPaymentsResponse;
    fromSDKJSON(object: any): QueryPaymentsResponseSDKType;
    toSDK(message: QueryPaymentsResponse): QueryPaymentsResponseSDKType;
    fromAmino(object: QueryPaymentsResponseAmino): QueryPaymentsResponse;
    toAmino(message: QueryPaymentsResponse): QueryPaymentsResponseAmino;
    fromAminoMsg(object: QueryPaymentsResponseAminoMsg): QueryPaymentsResponse;
    toAminoMsg(message: QueryPaymentsResponse): QueryPaymentsResponseAminoMsg;
    fromProtoMsg(message: QueryPaymentsResponseProtoMsg): QueryPaymentsResponse;
    toProto(message: QueryPaymentsResponse): Uint8Array;
    toProtoMsg(message: QueryPaymentsResponse): QueryPaymentsResponseProtoMsg;
    registerTypeUrl(): void;
};
