import { BinaryReader } from "../../../binary";
import { QueryAccountsRequest, QueryAccountsResponse, QueryPaymentsRequest, QueryPaymentsResponse } from "./query";
export class QueryClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* buf:lint:ignore RPC_REQUEST_RESPONSE_UNIQUE
     buf:lint:ignore RPC_RESPONSE_STANDARD_NAME
     Accounts queries all accounts */
    accounts = async (request) => {
        const data = QueryAccountsRequest.encode(request).finish();
        const promise = this.rpc.request("akash.escrow.v1beta2.Query", "Accounts", data);
        return promise.then(data => QueryAccountsResponse.decode(new BinaryReader(data)));
    };
    /* buf:lint:ignore RPC_REQUEST_RESPONSE_UNIQUE
     buf:lint:ignore RPC_RESPONSE_STANDARD_NAME
     Payments queries all payments */
    payments = async (request) => {
        const data = QueryPaymentsRequest.encode(request).finish();
        const promise = this.rpc.request("akash.escrow.v1beta2.Query", "Payments", data);
        return promise.then(data => QueryPaymentsResponse.decode(new BinaryReader(data)));
    };
}
export const createClientImpl = (rpc) => {
    return new QueryClientImpl(rpc);
};
