import { OrderID, OrderIDAmino, OrderIDSDKType } from "./order";
import { DecCoin, DecCoinAmino, DecCoinSDKType, Coin, CoinAmino, CoinSDKType } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.market.v1beta2";
/** State is an enum which refers to state of bid */
export declare enum Bid_State {
    /** invalid - Prefix should start with 0 in enum. So declaring dummy state */
    invalid = 0,
    /** open - BidOpen denotes state for bid open */
    open = 1,
    /** active - BidMatched denotes state for bid open */
    active = 2,
    /** lost - BidLost denotes state for bid lost */
    lost = 3,
    /** closed - BidClosed denotes state for bid closed */
    closed = 4,
    UNRECOGNIZED = -1
}
export declare const Bid_StateSDKType: typeof Bid_State;
export declare const Bid_StateAmino: typeof Bid_State;
export declare function bid_StateFromJSON(object: any): Bid_State;
export declare function bid_StateToJSON(object: Bid_State): string;
/** MsgCreateBid defines an SDK message for creating Bid */
export interface MsgCreateBid {
    order: OrderID;
    provider: string;
    price: DecCoin;
    deposit: Coin;
}
export interface MsgCreateBidProtoMsg {
    typeUrl: "/akash.market.v1beta2.MsgCreateBid";
    value: Uint8Array;
}
/** MsgCreateBid defines an SDK message for creating Bid */
export interface MsgCreateBidAmino {
    order: OrderIDAmino;
    provider: string;
    price: DecCoinAmino;
    deposit: CoinAmino;
}
export interface MsgCreateBidAminoMsg {
    type: "akash/market/v1beta2/testonly-create-bid";
    value: MsgCreateBidAmino;
}
/** MsgCreateBid defines an SDK message for creating Bid */
export interface MsgCreateBidSDKType {
    order: OrderIDSDKType;
    provider: string;
    price: DecCoinSDKType;
    deposit: CoinSDKType;
}
/** MsgCreateBidResponse defines the Msg/CreateBid response type. */
export interface MsgCreateBidResponse {
}
export interface MsgCreateBidResponseProtoMsg {
    typeUrl: "/akash.market.v1beta2.MsgCreateBidResponse";
    value: Uint8Array;
}
/** MsgCreateBidResponse defines the Msg/CreateBid response type. */
export interface MsgCreateBidResponseAmino {
}
export interface MsgCreateBidResponseAminoMsg {
    type: "akash/market/v1beta2/testonly-create-bid-response";
    value: MsgCreateBidResponseAmino;
}
/** MsgCreateBidResponse defines the Msg/CreateBid response type. */
export interface MsgCreateBidResponseSDKType {
}
/** MsgCloseBid defines an SDK message for closing bid */
export interface MsgCloseBid {
    bidId: BidID;
}
export interface MsgCloseBidProtoMsg {
    typeUrl: "/akash.market.v1beta2.MsgCloseBid";
    value: Uint8Array;
}
/** MsgCloseBid defines an SDK message for closing bid */
export interface MsgCloseBidAmino {
    bid_id: BidIDAmino;
}
export interface MsgCloseBidAminoMsg {
    type: "akash/market/v1beta2/testonly-close-bid";
    value: MsgCloseBidAmino;
}
/** MsgCloseBid defines an SDK message for closing bid */
export interface MsgCloseBidSDKType {
    bid_id: BidIDSDKType;
}
/** MsgCloseBidResponse defines the Msg/CloseBid response type. */
export interface MsgCloseBidResponse {
}
export interface MsgCloseBidResponseProtoMsg {
    typeUrl: "/akash.market.v1beta2.MsgCloseBidResponse";
    value: Uint8Array;
}
/** MsgCloseBidResponse defines the Msg/CloseBid response type. */
export interface MsgCloseBidResponseAmino {
}
export interface MsgCloseBidResponseAminoMsg {
    type: "akash/market/v1beta2/testonly-close-bid-response";
    value: MsgCloseBidResponseAmino;
}
/** MsgCloseBidResponse defines the Msg/CloseBid response type. */
export interface MsgCloseBidResponseSDKType {
}
/**
 * BidID stores owner and all other seq numbers
 * A successful bid becomes a Lease(ID).
 */
export interface BidID {
    owner: string;
    dseq: bigint;
    gseq: number;
    oseq: number;
    provider: string;
}
export interface BidIDProtoMsg {
    typeUrl: "/akash.market.v1beta2.BidID";
    value: Uint8Array;
}
/**
 * BidID stores owner and all other seq numbers
 * A successful bid becomes a Lease(ID).
 */
export interface BidIDAmino {
    owner: string;
    dseq: string;
    gseq: number;
    oseq: number;
    provider: string;
}
export interface BidIDAminoMsg {
    type: "akash/market/v1beta2/bid-i-d";
    value: BidIDAmino;
}
/**
 * BidID stores owner and all other seq numbers
 * A successful bid becomes a Lease(ID).
 */
export interface BidIDSDKType {
    owner: string;
    dseq: bigint;
    gseq: number;
    oseq: number;
    provider: string;
}
/** Bid stores BidID, state of bid and price */
export interface Bid {
    bidId: BidID;
    state: Bid_State;
    price: DecCoin;
    createdAt: bigint;
}
export interface BidProtoMsg {
    typeUrl: "/akash.market.v1beta2.Bid";
    value: Uint8Array;
}
/** Bid stores BidID, state of bid and price */
export interface BidAmino {
    bid_id: BidIDAmino;
    state: Bid_State;
    price: DecCoinAmino;
    created_at?: string;
}
export interface BidAminoMsg {
    type: "akash/market/v1beta2/bid";
    value: BidAmino;
}
/** Bid stores BidID, state of bid and price */
export interface BidSDKType {
    bid_id: BidIDSDKType;
    state: Bid_State;
    price: DecCoinSDKType;
    created_at: bigint;
}
/** BidFilters defines flags for bid list filter */
export interface BidFilters {
    owner: string;
    dseq: bigint;
    gseq: number;
    oseq: number;
    provider: string;
    state: string;
}
export interface BidFiltersProtoMsg {
    typeUrl: "/akash.market.v1beta2.BidFilters";
    value: Uint8Array;
}
/** BidFilters defines flags for bid list filter */
export interface BidFiltersAmino {
    owner: string;
    dseq: string;
    gseq: number;
    oseq: number;
    provider: string;
    state: string;
}
export interface BidFiltersAminoMsg {
    type: "akash/market/v1beta2/bid-filters";
    value: BidFiltersAmino;
}
/** BidFilters defines flags for bid list filter */
export interface BidFiltersSDKType {
    owner: string;
    dseq: bigint;
    gseq: number;
    oseq: number;
    provider: string;
    state: string;
}
export declare const MsgCreateBid: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCreateBid;
    isSDK(o: any): o is MsgCreateBidSDKType;
    isAmino(o: any): o is MsgCreateBidAmino;
    encode(message: MsgCreateBid, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCreateBid;
    fromJSON(object: any): MsgCreateBid;
    toJSON(message: MsgCreateBid): JsonSafe<MsgCreateBid>;
    fromPartial<I extends Exact<DeepPartial<MsgCreateBid>, I>>(object: I): MsgCreateBid;
    fromSDK(object: MsgCreateBidSDKType): MsgCreateBid;
    fromSDKJSON(object: any): MsgCreateBidSDKType;
    toSDK(message: MsgCreateBid): MsgCreateBidSDKType;
    fromAmino(object: MsgCreateBidAmino): MsgCreateBid;
    toAmino(message: MsgCreateBid): MsgCreateBidAmino;
    fromAminoMsg(object: MsgCreateBidAminoMsg): MsgCreateBid;
    toAminoMsg(message: MsgCreateBid): MsgCreateBidAminoMsg;
    fromProtoMsg(message: MsgCreateBidProtoMsg): MsgCreateBid;
    toProto(message: MsgCreateBid): Uint8Array;
    toProtoMsg(message: MsgCreateBid): MsgCreateBidProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgCreateBidResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCreateBidResponse;
    isSDK(o: any): o is MsgCreateBidResponseSDKType;
    isAmino(o: any): o is MsgCreateBidResponseAmino;
    encode(_: MsgCreateBidResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCreateBidResponse;
    fromJSON(_: any): MsgCreateBidResponse;
    toJSON(_: MsgCreateBidResponse): JsonSafe<MsgCreateBidResponse>;
    fromPartial<I extends Exact<DeepPartial<MsgCreateBidResponse>, I>>(_: I): MsgCreateBidResponse;
    fromSDK(_: MsgCreateBidResponseSDKType): MsgCreateBidResponse;
    fromSDKJSON(_: any): MsgCreateBidResponseSDKType;
    toSDK(_: MsgCreateBidResponse): MsgCreateBidResponseSDKType;
    fromAmino(_: MsgCreateBidResponseAmino): MsgCreateBidResponse;
    toAmino(_: MsgCreateBidResponse): MsgCreateBidResponseAmino;
    fromAminoMsg(object: MsgCreateBidResponseAminoMsg): MsgCreateBidResponse;
    toAminoMsg(message: MsgCreateBidResponse): MsgCreateBidResponseAminoMsg;
    fromProtoMsg(message: MsgCreateBidResponseProtoMsg): MsgCreateBidResponse;
    toProto(message: MsgCreateBidResponse): Uint8Array;
    toProtoMsg(message: MsgCreateBidResponse): MsgCreateBidResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgCloseBid: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCloseBid;
    isSDK(o: any): o is MsgCloseBidSDKType;
    isAmino(o: any): o is MsgCloseBidAmino;
    encode(message: MsgCloseBid, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCloseBid;
    fromJSON(object: any): MsgCloseBid;
    toJSON(message: MsgCloseBid): JsonSafe<MsgCloseBid>;
    fromPartial<I extends Exact<DeepPartial<MsgCloseBid>, I>>(object: I): MsgCloseBid;
    fromSDK(object: MsgCloseBidSDKType): MsgCloseBid;
    fromSDKJSON(object: any): MsgCloseBidSDKType;
    toSDK(message: MsgCloseBid): MsgCloseBidSDKType;
    fromAmino(object: MsgCloseBidAmino): MsgCloseBid;
    toAmino(message: MsgCloseBid): MsgCloseBidAmino;
    fromAminoMsg(object: MsgCloseBidAminoMsg): MsgCloseBid;
    toAminoMsg(message: MsgCloseBid): MsgCloseBidAminoMsg;
    fromProtoMsg(message: MsgCloseBidProtoMsg): MsgCloseBid;
    toProto(message: MsgCloseBid): Uint8Array;
    toProtoMsg(message: MsgCloseBid): MsgCloseBidProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgCloseBidResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCloseBidResponse;
    isSDK(o: any): o is MsgCloseBidResponseSDKType;
    isAmino(o: any): o is MsgCloseBidResponseAmino;
    encode(_: MsgCloseBidResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCloseBidResponse;
    fromJSON(_: any): MsgCloseBidResponse;
    toJSON(_: MsgCloseBidResponse): JsonSafe<MsgCloseBidResponse>;
    fromPartial<I extends Exact<DeepPartial<MsgCloseBidResponse>, I>>(_: I): MsgCloseBidResponse;
    fromSDK(_: MsgCloseBidResponseSDKType): MsgCloseBidResponse;
    fromSDKJSON(_: any): MsgCloseBidResponseSDKType;
    toSDK(_: MsgCloseBidResponse): MsgCloseBidResponseSDKType;
    fromAmino(_: MsgCloseBidResponseAmino): MsgCloseBidResponse;
    toAmino(_: MsgCloseBidResponse): MsgCloseBidResponseAmino;
    fromAminoMsg(object: MsgCloseBidResponseAminoMsg): MsgCloseBidResponse;
    toAminoMsg(message: MsgCloseBidResponse): MsgCloseBidResponseAminoMsg;
    fromProtoMsg(message: MsgCloseBidResponseProtoMsg): MsgCloseBidResponse;
    toProto(message: MsgCloseBidResponse): Uint8Array;
    toProtoMsg(message: MsgCloseBidResponse): MsgCloseBidResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const BidID: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is BidID;
    isSDK(o: any): o is BidIDSDKType;
    isAmino(o: any): o is BidIDAmino;
    encode(message: BidID, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): BidID;
    fromJSON(object: any): BidID;
    toJSON(message: BidID): JsonSafe<BidID>;
    fromPartial<I extends Exact<DeepPartial<BidID>, I>>(object: I): BidID;
    fromSDK(object: BidIDSDKType): BidID;
    fromSDKJSON(object: any): BidIDSDKType;
    toSDK(message: BidID): BidIDSDKType;
    fromAmino(object: BidIDAmino): BidID;
    toAmino(message: BidID): BidIDAmino;
    fromAminoMsg(object: BidIDAminoMsg): BidID;
    toAminoMsg(message: BidID): BidIDAminoMsg;
    fromProtoMsg(message: BidIDProtoMsg): BidID;
    toProto(message: BidID): Uint8Array;
    toProtoMsg(message: BidID): BidIDProtoMsg;
    registerTypeUrl(): void;
};
export declare const Bid: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is Bid;
    isSDK(o: any): o is BidSDKType;
    isAmino(o: any): o is BidAmino;
    encode(message: Bid, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Bid;
    fromJSON(object: any): Bid;
    toJSON(message: Bid): JsonSafe<Bid>;
    fromPartial<I extends Exact<DeepPartial<Bid>, I>>(object: I): Bid;
    fromSDK(object: BidSDKType): Bid;
    fromSDKJSON(object: any): BidSDKType;
    toSDK(message: Bid): BidSDKType;
    fromAmino(object: BidAmino): Bid;
    toAmino(message: Bid): BidAmino;
    fromAminoMsg(object: BidAminoMsg): Bid;
    toAminoMsg(message: Bid): BidAminoMsg;
    fromProtoMsg(message: BidProtoMsg): Bid;
    toProto(message: Bid): Uint8Array;
    toProtoMsg(message: Bid): BidProtoMsg;
    registerTypeUrl(): void;
};
export declare const BidFilters: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is BidFilters;
    isSDK(o: any): o is BidFiltersSDKType;
    isAmino(o: any): o is BidFiltersAmino;
    encode(message: BidFilters, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): BidFilters;
    fromJSON(object: any): BidFilters;
    toJSON(message: BidFilters): JsonSafe<BidFilters>;
    fromPartial<I extends Exact<DeepPartial<BidFilters>, I>>(object: I): BidFilters;
    fromSDK(object: BidFiltersSDKType): BidFilters;
    fromSDKJSON(object: any): BidFiltersSDKType;
    toSDK(message: BidFilters): BidFiltersSDKType;
    fromAmino(object: BidFiltersAmino): BidFilters;
    toAmino(message: BidFilters): BidFiltersAmino;
    fromAminoMsg(object: BidFiltersAminoMsg): BidFilters;
    toAminoMsg(message: BidFilters): BidFiltersAminoMsg;
    fromProtoMsg(message: BidFiltersProtoMsg): BidFilters;
    toProto(message: BidFilters): Uint8Array;
    toProtoMsg(message: BidFilters): BidFiltersProtoMsg;
    registerTypeUrl(): void;
};
