import { DecCoin } from "../../../cosmos/base/v1beta1/coin";
import { BidID } from "./bid";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.market.v1beta2";
/** State is an enum which refers to state of lease */
export var Lease_State;
(function (Lease_State) {
    /** invalid - Prefix should start with 0 in enum. So declaring dummy state */
    Lease_State[Lease_State["invalid"] = 0] = "invalid";
    /** active - LeaseActive denotes state for lease active */
    Lease_State[Lease_State["active"] = 1] = "active";
    /** insufficient_funds - LeaseInsufficientFunds denotes state for lease insufficient_funds */
    Lease_State[Lease_State["insufficient_funds"] = 2] = "insufficient_funds";
    /** closed - LeaseClosed denotes state for lease closed */
    Lease_State[Lease_State["closed"] = 3] = "closed";
    Lease_State[Lease_State["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(Lease_State || (Lease_State = {}));
export const Lease_StateSDKType = Lease_State;
export const Lease_StateAmino = Lease_State;
export function lease_StateFromJSON(object) {
    switch (object) {
        case 0:
        case "invalid":
            return Lease_State.invalid;
        case 1:
        case "active":
            return Lease_State.active;
        case 2:
        case "insufficient_funds":
            return Lease_State.insufficient_funds;
        case 3:
        case "closed":
            return Lease_State.closed;
        case -1:
        case "UNRECOGNIZED":
        default:
            return Lease_State.UNRECOGNIZED;
    }
}
export function lease_StateToJSON(object) {
    switch (object) {
        case Lease_State.invalid:
            return "invalid";
        case Lease_State.active:
            return "active";
        case Lease_State.insufficient_funds:
            return "insufficient_funds";
        case Lease_State.closed:
            return "closed";
        case Lease_State.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
function createBaseLeaseID() {
    return {
        owner: "",
        dseq: BigInt(0),
        gseq: 0,
        oseq: 0,
        provider: ""
    };
}
export const LeaseID = {
    typeUrl: "/akash.market.v1beta2.LeaseID",
    aminoType: "akash/market/v1beta2/lease-i-d",
    is(o) {
        return o && (o.$typeUrl === LeaseID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number" && typeof o.oseq === "number" && typeof o.provider === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === LeaseID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number" && typeof o.oseq === "number" && typeof o.provider === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === LeaseID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number" && typeof o.oseq === "number" && typeof o.provider === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.dseq !== undefined) {
            writer.uint32(16).uint64(message.dseq);
        }
        if (message.gseq !== undefined) {
            writer.uint32(24).uint32(message.gseq);
        }
        if (message.oseq !== undefined) {
            writer.uint32(32).uint32(message.oseq);
        }
        if (message.provider !== undefined) {
            writer.uint32(42).string(message.provider);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLeaseID();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.dseq = reader.uint64();
                    break;
                case 3:
                    message.gseq = reader.uint32();
                    break;
                case 4:
                    message.oseq = reader.uint32();
                    break;
                case 5:
                    message.provider = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLeaseID();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.dseq))
            obj.dseq = BigInt(object.dseq.toString());
        if (isSet(object.gseq))
            obj.gseq = Number(object.gseq);
        if (isSet(object.oseq))
            obj.oseq = Number(object.oseq);
        if (isSet(object.provider))
            obj.provider = String(object.provider);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.dseq !== undefined && (obj.dseq = (message.dseq || BigInt(0)).toString());
        message.gseq !== undefined && (obj.gseq = Math.round(message.gseq));
        message.oseq !== undefined && (obj.oseq = Math.round(message.oseq));
        message.provider !== undefined && (obj.provider = message.provider);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLeaseID();
        message.owner = object.owner ?? "";
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq.toString());
        }
        message.gseq = object.gseq ?? 0;
        message.oseq = object.oseq ?? 0;
        message.provider = object.provider ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            dseq: object?.dseq,
            gseq: object?.gseq,
            oseq: object?.oseq,
            provider: object?.provider
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            dseq: isSet(object.dseq) ? BigInt(object.dseq.toString()) : BigInt(0),
            gseq: isSet(object.gseq) ? Number(object.gseq) : 0,
            oseq: isSet(object.oseq) ? Number(object.oseq) : 0,
            provider: isSet(object.provider) ? String(object.provider) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.dseq = message.dseq;
        obj.gseq = message.gseq;
        obj.oseq = message.oseq;
        obj.provider = message.provider;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLeaseID();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq);
        }
        if (object.gseq !== undefined && object.gseq !== null) {
            message.gseq = object.gseq;
        }
        if (object.oseq !== undefined && object.oseq !== null) {
            message.oseq = object.oseq;
        }
        if (object.provider !== undefined && object.provider !== null) {
            message.provider = object.provider;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.dseq = message.dseq ? message.dseq?.toString() : "0";
        obj.gseq = message.gseq ?? 0;
        obj.oseq = message.oseq ?? 0;
        obj.provider = message.provider ?? "";
        return obj;
    },
    fromAminoMsg(object) {
        return LeaseID.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/market/v1beta2/lease-i-d",
            value: LeaseID.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return LeaseID.decode(message.value);
    },
    toProto(message) {
        return LeaseID.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.market.v1beta2.LeaseID",
            value: LeaseID.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseLease() {
    return {
        leaseId: LeaseID.fromPartial({}),
        state: 0,
        price: DecCoin.fromPartial({}),
        createdAt: BigInt(0),
        closedOn: BigInt(0)
    };
}
export const Lease = {
    typeUrl: "/akash.market.v1beta2.Lease",
    aminoType: "akash/market/v1beta2/lease",
    is(o) {
        return o && (o.$typeUrl === Lease.typeUrl || LeaseID.is(o.leaseId) && isSet(o.state) && DecCoin.is(o.price) && typeof o.createdAt === "bigint" && typeof o.closedOn === "bigint");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Lease.typeUrl || LeaseID.isSDK(o.lease_id) && isSet(o.state) && DecCoin.isSDK(o.price) && typeof o.created_at === "bigint" && typeof o.closed_on === "bigint");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Lease.typeUrl || LeaseID.isAmino(o.lease_id) && isSet(o.state) && DecCoin.isAmino(o.price) && typeof o.created_at === "bigint" && typeof o.closed_on === "bigint");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.leaseId !== undefined) {
            LeaseID.encode(message.leaseId, writer.uint32(10).fork()).ldelim();
        }
        if (message.state !== 0) {
            writer.uint32(16).int32(message.state);
        }
        if (message.price !== undefined) {
            DecCoin.encode(message.price, writer.uint32(26).fork()).ldelim();
        }
        if (message.createdAt !== undefined) {
            writer.uint32(32).int64(message.createdAt);
        }
        if (message.closedOn !== undefined) {
            writer.uint32(40).int64(message.closedOn);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLease();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.leaseId = LeaseID.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.state = reader.int32();
                    break;
                case 3:
                    message.price = DecCoin.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.createdAt = reader.int64();
                    break;
                case 5:
                    message.closedOn = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLease();
        if (isSet(object.leaseId))
            obj.leaseId = LeaseID.fromJSON(object.leaseId);
        if (isSet(object.state))
            obj.state = lease_StateFromJSON(object.state);
        if (isSet(object.price))
            obj.price = DecCoin.fromJSON(object.price);
        if (isSet(object.createdAt))
            obj.createdAt = BigInt(object.createdAt.toString());
        if (isSet(object.closedOn))
            obj.closedOn = BigInt(object.closedOn.toString());
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.leaseId !== undefined && (obj.leaseId = message.leaseId ? LeaseID.toJSON(message.leaseId) : undefined);
        message.state !== undefined && (obj.state = lease_StateToJSON(message.state));
        message.price !== undefined && (obj.price = message.price ? DecCoin.toJSON(message.price) : undefined);
        message.createdAt !== undefined && (obj.createdAt = (message.createdAt || BigInt(0)).toString());
        message.closedOn !== undefined && (obj.closedOn = (message.closedOn || BigInt(0)).toString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLease();
        if (object.leaseId !== undefined && object.leaseId !== null) {
            message.leaseId = LeaseID.fromPartial(object.leaseId);
        }
        message.state = object.state ?? 0;
        if (object.price !== undefined && object.price !== null) {
            message.price = DecCoin.fromPartial(object.price);
        }
        if (object.createdAt !== undefined && object.createdAt !== null) {
            message.createdAt = BigInt(object.createdAt.toString());
        }
        if (object.closedOn !== undefined && object.closedOn !== null) {
            message.closedOn = BigInt(object.closedOn.toString());
        }
        return message;
    },
    fromSDK(object) {
        return {
            leaseId: object.lease_id ? LeaseID.fromSDK(object.lease_id) : undefined,
            state: isSet(object.state) ? lease_StateFromJSON(object.state) : -1,
            price: object.price ? DecCoin.fromSDK(object.price) : undefined,
            createdAt: object?.created_at,
            closedOn: object?.closed_on
        };
    },
    fromSDKJSON(object) {
        return {
            lease_id: isSet(object.lease_id) ? LeaseID.fromSDKJSON(object.lease_id) : undefined,
            state: isSet(object.state) ? lease_StateFromJSON(object.state) : -1,
            price: isSet(object.price) ? DecCoin.fromSDKJSON(object.price) : undefined,
            created_at: isSet(object.created_at) ? BigInt(object.created_at.toString()) : BigInt(0),
            closed_on: isSet(object.closed_on) ? BigInt(object.closed_on.toString()) : BigInt(0)
        };
    },
    toSDK(message) {
        const obj = {};
        message.leaseId !== undefined && (obj.lease_id = message.leaseId ? LeaseID.toSDK(message.leaseId) : undefined);
        message.state !== undefined && (obj.state = lease_StateToJSON(message.state));
        message.price !== undefined && (obj.price = message.price ? DecCoin.toSDK(message.price) : undefined);
        obj.created_at = message.createdAt;
        obj.closed_on = message.closedOn;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLease();
        if (object.lease_id !== undefined && object.lease_id !== null) {
            message.leaseId = LeaseID.fromAmino(object.lease_id);
        }
        if (object.state !== undefined && object.state !== null) {
            message.state = object.state;
        }
        if (object.price !== undefined && object.price !== null) {
            message.price = DecCoin.fromAmino(object.price);
        }
        if (object.created_at !== undefined && object.created_at !== null) {
            message.createdAt = BigInt(object.created_at);
        }
        if (object.closed_on !== undefined && object.closed_on !== null) {
            message.closedOn = BigInt(object.closed_on);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.lease_id = message.leaseId ? LeaseID.toAmino(message.leaseId) : LeaseID.toAmino(LeaseID.fromPartial({}));
        obj.state = message.state ?? 0;
        obj.price = message.price ? DecCoin.toAmino(message.price) : DecCoin.toAmino(DecCoin.fromPartial({}));
        obj.created_at = message.createdAt !== BigInt(0) ? message.createdAt?.toString() : undefined;
        obj.closed_on = message.closedOn !== BigInt(0) ? message.closedOn?.toString() : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return Lease.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/market/v1beta2/lease",
            value: Lease.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Lease.decode(message.value);
    },
    toProto(message) {
        return Lease.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.market.v1beta2.Lease",
            value: Lease.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LeaseID.registerTypeUrl();
        DecCoin.registerTypeUrl();
    }
};
function createBaseLeaseFilters() {
    return {
        owner: "",
        dseq: BigInt(0),
        gseq: 0,
        oseq: 0,
        provider: "",
        state: ""
    };
}
export const LeaseFilters = {
    typeUrl: "/akash.market.v1beta2.LeaseFilters",
    aminoType: "akash/market/v1beta2/lease-filters",
    is(o) {
        return o && (o.$typeUrl === LeaseFilters.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number" && typeof o.oseq === "number" && typeof o.provider === "string" && typeof o.state === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === LeaseFilters.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number" && typeof o.oseq === "number" && typeof o.provider === "string" && typeof o.state === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === LeaseFilters.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number" && typeof o.oseq === "number" && typeof o.provider === "string" && typeof o.state === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.dseq !== undefined) {
            writer.uint32(16).uint64(message.dseq);
        }
        if (message.gseq !== undefined) {
            writer.uint32(24).uint32(message.gseq);
        }
        if (message.oseq !== undefined) {
            writer.uint32(32).uint32(message.oseq);
        }
        if (message.provider !== undefined) {
            writer.uint32(42).string(message.provider);
        }
        if (message.state !== undefined) {
            writer.uint32(50).string(message.state);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLeaseFilters();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.dseq = reader.uint64();
                    break;
                case 3:
                    message.gseq = reader.uint32();
                    break;
                case 4:
                    message.oseq = reader.uint32();
                    break;
                case 5:
                    message.provider = reader.string();
                    break;
                case 6:
                    message.state = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLeaseFilters();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.dseq))
            obj.dseq = BigInt(object.dseq.toString());
        if (isSet(object.gseq))
            obj.gseq = Number(object.gseq);
        if (isSet(object.oseq))
            obj.oseq = Number(object.oseq);
        if (isSet(object.provider))
            obj.provider = String(object.provider);
        if (isSet(object.state))
            obj.state = String(object.state);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.dseq !== undefined && (obj.dseq = (message.dseq || BigInt(0)).toString());
        message.gseq !== undefined && (obj.gseq = Math.round(message.gseq));
        message.oseq !== undefined && (obj.oseq = Math.round(message.oseq));
        message.provider !== undefined && (obj.provider = message.provider);
        message.state !== undefined && (obj.state = message.state);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLeaseFilters();
        message.owner = object.owner ?? "";
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq.toString());
        }
        message.gseq = object.gseq ?? 0;
        message.oseq = object.oseq ?? 0;
        message.provider = object.provider ?? "";
        message.state = object.state ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            dseq: object?.dseq,
            gseq: object?.gseq,
            oseq: object?.oseq,
            provider: object?.provider,
            state: object?.state
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            dseq: isSet(object.dseq) ? BigInt(object.dseq.toString()) : BigInt(0),
            gseq: isSet(object.gseq) ? Number(object.gseq) : 0,
            oseq: isSet(object.oseq) ? Number(object.oseq) : 0,
            provider: isSet(object.provider) ? String(object.provider) : "",
            state: isSet(object.state) ? String(object.state) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.dseq = message.dseq;
        obj.gseq = message.gseq;
        obj.oseq = message.oseq;
        obj.provider = message.provider;
        obj.state = message.state;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLeaseFilters();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq);
        }
        if (object.gseq !== undefined && object.gseq !== null) {
            message.gseq = object.gseq;
        }
        if (object.oseq !== undefined && object.oseq !== null) {
            message.oseq = object.oseq;
        }
        if (object.provider !== undefined && object.provider !== null) {
            message.provider = object.provider;
        }
        if (object.state !== undefined && object.state !== null) {
            message.state = object.state;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.dseq = message.dseq ? message.dseq?.toString() : "0";
        obj.gseq = message.gseq ?? 0;
        obj.oseq = message.oseq ?? 0;
        obj.provider = message.provider ?? "";
        obj.state = message.state ?? "";
        return obj;
    },
    fromAminoMsg(object) {
        return LeaseFilters.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/market/v1beta2/lease-filters",
            value: LeaseFilters.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return LeaseFilters.decode(message.value);
    },
    toProto(message) {
        return LeaseFilters.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.market.v1beta2.LeaseFilters",
            value: LeaseFilters.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgCreateLease() {
    return {
        bidId: BidID.fromPartial({})
    };
}
export const MsgCreateLease = {
    typeUrl: "/akash.market.v1beta2.MsgCreateLease",
    aminoType: "akash/market/v1beta2/testonly-create-lease",
    is(o) {
        return o && (o.$typeUrl === MsgCreateLease.typeUrl || BidID.is(o.bidId));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgCreateLease.typeUrl || BidID.isSDK(o.bid_id));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgCreateLease.typeUrl || BidID.isAmino(o.bid_id));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.bidId !== undefined) {
            BidID.encode(message.bidId, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCreateLease();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.bidId = BidID.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgCreateLease();
        if (isSet(object.bidId))
            obj.bidId = BidID.fromJSON(object.bidId);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.bidId !== undefined && (obj.bidId = message.bidId ? BidID.toJSON(message.bidId) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgCreateLease();
        if (object.bidId !== undefined && object.bidId !== null) {
            message.bidId = BidID.fromPartial(object.bidId);
        }
        return message;
    },
    fromSDK(object) {
        return {
            bidId: object.bid_id ? BidID.fromSDK(object.bid_id) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            bid_id: isSet(object.bid_id) ? BidID.fromSDKJSON(object.bid_id) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.bidId !== undefined && (obj.bid_id = message.bidId ? BidID.toSDK(message.bidId) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgCreateLease();
        if (object.bid_id !== undefined && object.bid_id !== null) {
            message.bidId = BidID.fromAmino(object.bid_id);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.bid_id = message.bidId ? BidID.toAmino(message.bidId) : BidID.toAmino(BidID.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCreateLease.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/market/v1beta2/testonly-create-lease",
            value: MsgCreateLease.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgCreateLease.decode(message.value);
    },
    toProto(message) {
        return MsgCreateLease.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.market.v1beta2.MsgCreateLease",
            value: MsgCreateLease.encode(message).finish()
        };
    },
    registerTypeUrl() {
        BidID.registerTypeUrl();
    }
};
function createBaseMsgCreateLeaseResponse() {
    return {};
}
export const MsgCreateLeaseResponse = {
    typeUrl: "/akash.market.v1beta2.MsgCreateLeaseResponse",
    aminoType: "akash/market/v1beta2/testonly-create-lease-response",
    is(o) {
        return o && o.$typeUrl === MsgCreateLeaseResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgCreateLeaseResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgCreateLeaseResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCreateLeaseResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgCreateLeaseResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgCreateLeaseResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgCreateLeaseResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCreateLeaseResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/market/v1beta2/testonly-create-lease-response",
            value: MsgCreateLeaseResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgCreateLeaseResponse.decode(message.value);
    },
    toProto(message) {
        return MsgCreateLeaseResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.market.v1beta2.MsgCreateLeaseResponse",
            value: MsgCreateLeaseResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgWithdrawLease() {
    return {
        bidId: LeaseID.fromPartial({})
    };
}
export const MsgWithdrawLease = {
    typeUrl: "/akash.market.v1beta2.MsgWithdrawLease",
    aminoType: "akash/market/v1beta2/testonly-withdraw-lease",
    is(o) {
        return o && (o.$typeUrl === MsgWithdrawLease.typeUrl || LeaseID.is(o.bidId));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgWithdrawLease.typeUrl || LeaseID.isSDK(o.bid_id));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgWithdrawLease.typeUrl || LeaseID.isAmino(o.bid_id));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.bidId !== undefined) {
            LeaseID.encode(message.bidId, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgWithdrawLease();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.bidId = LeaseID.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgWithdrawLease();
        if (isSet(object.bidId))
            obj.bidId = LeaseID.fromJSON(object.bidId);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.bidId !== undefined && (obj.bidId = message.bidId ? LeaseID.toJSON(message.bidId) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgWithdrawLease();
        if (object.bidId !== undefined && object.bidId !== null) {
            message.bidId = LeaseID.fromPartial(object.bidId);
        }
        return message;
    },
    fromSDK(object) {
        return {
            bidId: object.bid_id ? LeaseID.fromSDK(object.bid_id) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            bid_id: isSet(object.bid_id) ? LeaseID.fromSDKJSON(object.bid_id) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.bidId !== undefined && (obj.bid_id = message.bidId ? LeaseID.toSDK(message.bidId) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgWithdrawLease();
        if (object.bid_id !== undefined && object.bid_id !== null) {
            message.bidId = LeaseID.fromAmino(object.bid_id);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.bid_id = message.bidId ? LeaseID.toAmino(message.bidId) : LeaseID.toAmino(LeaseID.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return MsgWithdrawLease.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/market/v1beta2/testonly-withdraw-lease",
            value: MsgWithdrawLease.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgWithdrawLease.decode(message.value);
    },
    toProto(message) {
        return MsgWithdrawLease.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.market.v1beta2.MsgWithdrawLease",
            value: MsgWithdrawLease.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LeaseID.registerTypeUrl();
    }
};
function createBaseMsgWithdrawLeaseResponse() {
    return {};
}
export const MsgWithdrawLeaseResponse = {
    typeUrl: "/akash.market.v1beta2.MsgWithdrawLeaseResponse",
    aminoType: "akash/market/v1beta2/testonly-withdraw-lease-response",
    is(o) {
        return o && o.$typeUrl === MsgWithdrawLeaseResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgWithdrawLeaseResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgWithdrawLeaseResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgWithdrawLeaseResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgWithdrawLeaseResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgWithdrawLeaseResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgWithdrawLeaseResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgWithdrawLeaseResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/market/v1beta2/testonly-withdraw-lease-response",
            value: MsgWithdrawLeaseResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgWithdrawLeaseResponse.decode(message.value);
    },
    toProto(message) {
        return MsgWithdrawLeaseResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.market.v1beta2.MsgWithdrawLeaseResponse",
            value: MsgWithdrawLeaseResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgCloseLease() {
    return {
        leaseId: LeaseID.fromPartial({})
    };
}
export const MsgCloseLease = {
    typeUrl: "/akash.market.v1beta2.MsgCloseLease",
    aminoType: "akash/market/v1beta2/testonly-close-lease",
    is(o) {
        return o && (o.$typeUrl === MsgCloseLease.typeUrl || LeaseID.is(o.leaseId));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgCloseLease.typeUrl || LeaseID.isSDK(o.lease_id));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgCloseLease.typeUrl || LeaseID.isAmino(o.lease_id));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.leaseId !== undefined) {
            LeaseID.encode(message.leaseId, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCloseLease();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.leaseId = LeaseID.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgCloseLease();
        if (isSet(object.leaseId))
            obj.leaseId = LeaseID.fromJSON(object.leaseId);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.leaseId !== undefined && (obj.leaseId = message.leaseId ? LeaseID.toJSON(message.leaseId) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgCloseLease();
        if (object.leaseId !== undefined && object.leaseId !== null) {
            message.leaseId = LeaseID.fromPartial(object.leaseId);
        }
        return message;
    },
    fromSDK(object) {
        return {
            leaseId: object.lease_id ? LeaseID.fromSDK(object.lease_id) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            lease_id: isSet(object.lease_id) ? LeaseID.fromSDKJSON(object.lease_id) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.leaseId !== undefined && (obj.lease_id = message.leaseId ? LeaseID.toSDK(message.leaseId) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgCloseLease();
        if (object.lease_id !== undefined && object.lease_id !== null) {
            message.leaseId = LeaseID.fromAmino(object.lease_id);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.lease_id = message.leaseId ? LeaseID.toAmino(message.leaseId) : LeaseID.toAmino(LeaseID.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCloseLease.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/market/v1beta2/testonly-close-lease",
            value: MsgCloseLease.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgCloseLease.decode(message.value);
    },
    toProto(message) {
        return MsgCloseLease.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.market.v1beta2.MsgCloseLease",
            value: MsgCloseLease.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LeaseID.registerTypeUrl();
    }
};
function createBaseMsgCloseLeaseResponse() {
    return {};
}
export const MsgCloseLeaseResponse = {
    typeUrl: "/akash.market.v1beta2.MsgCloseLeaseResponse",
    aminoType: "akash/market/v1beta2/testonly-close-lease-response",
    is(o) {
        return o && o.$typeUrl === MsgCloseLeaseResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgCloseLeaseResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgCloseLeaseResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCloseLeaseResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgCloseLeaseResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgCloseLeaseResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgCloseLeaseResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCloseLeaseResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/market/v1beta2/testonly-close-lease-response",
            value: MsgCloseLeaseResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgCloseLeaseResponse.decode(message.value);
    },
    toProto(message) {
        return MsgCloseLeaseResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.market.v1beta2.MsgCloseLeaseResponse",
            value: MsgCloseLeaseResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
