import { GroupSpec } from "../../deployment/v1beta2/groupspec";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.market.v1beta2";
/** State is an enum which refers to state of order */
export var Order_State;
(function (Order_State) {
    /** invalid - Prefix should start with 0 in enum. So declaring dummy state */
    Order_State[Order_State["invalid"] = 0] = "invalid";
    /** open - OrderOpen denotes state for order open */
    Order_State[Order_State["open"] = 1] = "open";
    /** active - OrderMatched denotes state for order matched */
    Order_State[Order_State["active"] = 2] = "active";
    /** closed - OrderClosed denotes state for order lost */
    Order_State[Order_State["closed"] = 3] = "closed";
    Order_State[Order_State["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(Order_State || (Order_State = {}));
export const Order_StateSDKType = Order_State;
export const Order_StateAmino = Order_State;
export function order_StateFromJSON(object) {
    switch (object) {
        case 0:
        case "invalid":
            return Order_State.invalid;
        case 1:
        case "open":
            return Order_State.open;
        case 2:
        case "active":
            return Order_State.active;
        case 3:
        case "closed":
            return Order_State.closed;
        case -1:
        case "UNRECOGNIZED":
        default:
            return Order_State.UNRECOGNIZED;
    }
}
export function order_StateToJSON(object) {
    switch (object) {
        case Order_State.invalid:
            return "invalid";
        case Order_State.open:
            return "open";
        case Order_State.active:
            return "active";
        case Order_State.closed:
            return "closed";
        case Order_State.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
function createBaseOrderID() {
    return {
        owner: "",
        dseq: BigInt(0),
        gseq: 0,
        oseq: 0
    };
}
export const OrderID = {
    typeUrl: "/akash.market.v1beta2.OrderID",
    aminoType: "akash/market/v1beta2/order-i-d",
    is(o) {
        return o && (o.$typeUrl === OrderID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number" && typeof o.oseq === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === OrderID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number" && typeof o.oseq === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === OrderID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number" && typeof o.oseq === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.dseq !== undefined) {
            writer.uint32(16).uint64(message.dseq);
        }
        if (message.gseq !== undefined) {
            writer.uint32(24).uint32(message.gseq);
        }
        if (message.oseq !== undefined) {
            writer.uint32(32).uint32(message.oseq);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseOrderID();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.dseq = reader.uint64();
                    break;
                case 3:
                    message.gseq = reader.uint32();
                    break;
                case 4:
                    message.oseq = reader.uint32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseOrderID();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.dseq))
            obj.dseq = BigInt(object.dseq.toString());
        if (isSet(object.gseq))
            obj.gseq = Number(object.gseq);
        if (isSet(object.oseq))
            obj.oseq = Number(object.oseq);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.dseq !== undefined && (obj.dseq = (message.dseq || BigInt(0)).toString());
        message.gseq !== undefined && (obj.gseq = Math.round(message.gseq));
        message.oseq !== undefined && (obj.oseq = Math.round(message.oseq));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseOrderID();
        message.owner = object.owner ?? "";
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq.toString());
        }
        message.gseq = object.gseq ?? 0;
        message.oseq = object.oseq ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            dseq: object?.dseq,
            gseq: object?.gseq,
            oseq: object?.oseq
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            dseq: isSet(object.dseq) ? BigInt(object.dseq.toString()) : BigInt(0),
            gseq: isSet(object.gseq) ? Number(object.gseq) : 0,
            oseq: isSet(object.oseq) ? Number(object.oseq) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.dseq = message.dseq;
        obj.gseq = message.gseq;
        obj.oseq = message.oseq;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseOrderID();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq);
        }
        if (object.gseq !== undefined && object.gseq !== null) {
            message.gseq = object.gseq;
        }
        if (object.oseq !== undefined && object.oseq !== null) {
            message.oseq = object.oseq;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.dseq = message.dseq ? message.dseq?.toString() : "0";
        obj.gseq = message.gseq ?? 0;
        obj.oseq = message.oseq ?? 0;
        return obj;
    },
    fromAminoMsg(object) {
        return OrderID.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/market/v1beta2/order-i-d",
            value: OrderID.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return OrderID.decode(message.value);
    },
    toProto(message) {
        return OrderID.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.market.v1beta2.OrderID",
            value: OrderID.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseOrder() {
    return {
        orderId: OrderID.fromPartial({}),
        state: 0,
        spec: GroupSpec.fromPartial({}),
        createdAt: BigInt(0)
    };
}
export const Order = {
    typeUrl: "/akash.market.v1beta2.Order",
    aminoType: "akash/market/v1beta2/order",
    is(o) {
        return o && (o.$typeUrl === Order.typeUrl || OrderID.is(o.orderId) && isSet(o.state) && GroupSpec.is(o.spec) && typeof o.createdAt === "bigint");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Order.typeUrl || OrderID.isSDK(o.order_id) && isSet(o.state) && GroupSpec.isSDK(o.spec) && typeof o.created_at === "bigint");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Order.typeUrl || OrderID.isAmino(o.order_id) && isSet(o.state) && GroupSpec.isAmino(o.spec) && typeof o.created_at === "bigint");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.orderId !== undefined) {
            OrderID.encode(message.orderId, writer.uint32(10).fork()).ldelim();
        }
        if (message.state !== 0) {
            writer.uint32(16).int32(message.state);
        }
        if (message.spec !== undefined) {
            GroupSpec.encode(message.spec, writer.uint32(26).fork()).ldelim();
        }
        if (message.createdAt !== undefined) {
            writer.uint32(32).int64(message.createdAt);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseOrder();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.orderId = OrderID.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.state = reader.int32();
                    break;
                case 3:
                    message.spec = GroupSpec.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.createdAt = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseOrder();
        if (isSet(object.orderId))
            obj.orderId = OrderID.fromJSON(object.orderId);
        if (isSet(object.state))
            obj.state = order_StateFromJSON(object.state);
        if (isSet(object.spec))
            obj.spec = GroupSpec.fromJSON(object.spec);
        if (isSet(object.createdAt))
            obj.createdAt = BigInt(object.createdAt.toString());
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.orderId !== undefined && (obj.orderId = message.orderId ? OrderID.toJSON(message.orderId) : undefined);
        message.state !== undefined && (obj.state = order_StateToJSON(message.state));
        message.spec !== undefined && (obj.spec = message.spec ? GroupSpec.toJSON(message.spec) : undefined);
        message.createdAt !== undefined && (obj.createdAt = (message.createdAt || BigInt(0)).toString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseOrder();
        if (object.orderId !== undefined && object.orderId !== null) {
            message.orderId = OrderID.fromPartial(object.orderId);
        }
        message.state = object.state ?? 0;
        if (object.spec !== undefined && object.spec !== null) {
            message.spec = GroupSpec.fromPartial(object.spec);
        }
        if (object.createdAt !== undefined && object.createdAt !== null) {
            message.createdAt = BigInt(object.createdAt.toString());
        }
        return message;
    },
    fromSDK(object) {
        return {
            orderId: object.order_id ? OrderID.fromSDK(object.order_id) : undefined,
            state: isSet(object.state) ? order_StateFromJSON(object.state) : -1,
            spec: object.spec ? GroupSpec.fromSDK(object.spec) : undefined,
            createdAt: object?.created_at
        };
    },
    fromSDKJSON(object) {
        return {
            order_id: isSet(object.order_id) ? OrderID.fromSDKJSON(object.order_id) : undefined,
            state: isSet(object.state) ? order_StateFromJSON(object.state) : -1,
            spec: isSet(object.spec) ? GroupSpec.fromSDKJSON(object.spec) : undefined,
            created_at: isSet(object.created_at) ? BigInt(object.created_at.toString()) : BigInt(0)
        };
    },
    toSDK(message) {
        const obj = {};
        message.orderId !== undefined && (obj.order_id = message.orderId ? OrderID.toSDK(message.orderId) : undefined);
        message.state !== undefined && (obj.state = order_StateToJSON(message.state));
        message.spec !== undefined && (obj.spec = message.spec ? GroupSpec.toSDK(message.spec) : undefined);
        obj.created_at = message.createdAt;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseOrder();
        if (object.order_id !== undefined && object.order_id !== null) {
            message.orderId = OrderID.fromAmino(object.order_id);
        }
        if (object.state !== undefined && object.state !== null) {
            message.state = object.state;
        }
        if (object.spec !== undefined && object.spec !== null) {
            message.spec = GroupSpec.fromAmino(object.spec);
        }
        if (object.created_at !== undefined && object.created_at !== null) {
            message.createdAt = BigInt(object.created_at);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.order_id = message.orderId ? OrderID.toAmino(message.orderId) : OrderID.toAmino(OrderID.fromPartial({}));
        obj.state = message.state ?? 0;
        obj.spec = message.spec ? GroupSpec.toAmino(message.spec) : GroupSpec.toAmino(GroupSpec.fromPartial({}));
        obj.created_at = message.createdAt !== BigInt(0) ? message.createdAt?.toString() : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return Order.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/market/v1beta2/order",
            value: Order.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Order.decode(message.value);
    },
    toProto(message) {
        return Order.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.market.v1beta2.Order",
            value: Order.encode(message).finish()
        };
    },
    registerTypeUrl() {
        OrderID.registerTypeUrl();
        GroupSpec.registerTypeUrl();
    }
};
function createBaseOrderFilters() {
    return {
        owner: "",
        dseq: BigInt(0),
        gseq: 0,
        oseq: 0,
        state: ""
    };
}
export const OrderFilters = {
    typeUrl: "/akash.market.v1beta2.OrderFilters",
    aminoType: "akash/market/v1beta2/order-filters",
    is(o) {
        return o && (o.$typeUrl === OrderFilters.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number" && typeof o.oseq === "number" && typeof o.state === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === OrderFilters.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number" && typeof o.oseq === "number" && typeof o.state === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === OrderFilters.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number" && typeof o.oseq === "number" && typeof o.state === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.dseq !== undefined) {
            writer.uint32(16).uint64(message.dseq);
        }
        if (message.gseq !== undefined) {
            writer.uint32(24).uint32(message.gseq);
        }
        if (message.oseq !== undefined) {
            writer.uint32(32).uint32(message.oseq);
        }
        if (message.state !== undefined) {
            writer.uint32(42).string(message.state);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseOrderFilters();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.dseq = reader.uint64();
                    break;
                case 3:
                    message.gseq = reader.uint32();
                    break;
                case 4:
                    message.oseq = reader.uint32();
                    break;
                case 5:
                    message.state = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseOrderFilters();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.dseq))
            obj.dseq = BigInt(object.dseq.toString());
        if (isSet(object.gseq))
            obj.gseq = Number(object.gseq);
        if (isSet(object.oseq))
            obj.oseq = Number(object.oseq);
        if (isSet(object.state))
            obj.state = String(object.state);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.dseq !== undefined && (obj.dseq = (message.dseq || BigInt(0)).toString());
        message.gseq !== undefined && (obj.gseq = Math.round(message.gseq));
        message.oseq !== undefined && (obj.oseq = Math.round(message.oseq));
        message.state !== undefined && (obj.state = message.state);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseOrderFilters();
        message.owner = object.owner ?? "";
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq.toString());
        }
        message.gseq = object.gseq ?? 0;
        message.oseq = object.oseq ?? 0;
        message.state = object.state ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            dseq: object?.dseq,
            gseq: object?.gseq,
            oseq: object?.oseq,
            state: object?.state
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            dseq: isSet(object.dseq) ? BigInt(object.dseq.toString()) : BigInt(0),
            gseq: isSet(object.gseq) ? Number(object.gseq) : 0,
            oseq: isSet(object.oseq) ? Number(object.oseq) : 0,
            state: isSet(object.state) ? String(object.state) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.dseq = message.dseq;
        obj.gseq = message.gseq;
        obj.oseq = message.oseq;
        obj.state = message.state;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseOrderFilters();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq);
        }
        if (object.gseq !== undefined && object.gseq !== null) {
            message.gseq = object.gseq;
        }
        if (object.oseq !== undefined && object.oseq !== null) {
            message.oseq = object.oseq;
        }
        if (object.state !== undefined && object.state !== null) {
            message.state = object.state;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.dseq = message.dseq ? message.dseq?.toString() : "0";
        obj.gseq = message.gseq ?? 0;
        obj.oseq = message.oseq ?? 0;
        obj.state = message.state ?? "";
        return obj;
    },
    fromAminoMsg(object) {
        return OrderFilters.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/market/v1beta2/order-filters",
            value: OrderFilters.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return OrderFilters.decode(message.value);
    },
    toProto(message) {
        return OrderFilters.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.market.v1beta2.OrderFilters",
            value: OrderFilters.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
