import { Coin, CoinAmino, CoinSDKType } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.market.v1beta2";
/** Params is the params for the x/market module */
export interface Params {
    bidMinDeposit: Coin;
    orderMaxBids: number;
}
export interface ParamsProtoMsg {
    typeUrl: "/akash.market.v1beta2.Params";
    value: Uint8Array;
}
/** Params is the params for the x/market module */
export interface ParamsAmino {
    bid_min_deposit: CoinAmino;
    order_max_bids: number;
}
export interface ParamsAminoMsg {
    type: "akash/market/v1beta2/params";
    value: ParamsAmino;
}
/** Params is the params for the x/market module */
export interface ParamsSDKType {
    bid_min_deposit: CoinSDKType;
    order_max_bids: number;
}
export declare const Params: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is Params;
    isSDK(o: any): o is ParamsSDKType;
    isAmino(o: any): o is ParamsAmino;
    encode(message: Params, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Params;
    fromJSON(object: any): Params;
    toJSON(message: Params): JsonSafe<Params>;
    fromPartial<I extends Exact<DeepPartial<Params>, I>>(object: I): Params;
    fromSDK(object: ParamsSDKType): Params;
    fromSDKJSON(object: any): ParamsSDKType;
    toSDK(message: Params): ParamsSDKType;
    fromAmino(object: ParamsAmino): Params;
    toAmino(message: Params): ParamsAmino;
    fromAminoMsg(object: ParamsAminoMsg): Params;
    toAminoMsg(message: Params): ParamsAminoMsg;
    fromProtoMsg(message: ParamsProtoMsg): Params;
    toProto(message: Params): Uint8Array;
    toProtoMsg(message: Params): ParamsProtoMsg;
    registerTypeUrl(): void;
};
