import { OrderFilters, OrderFiltersAmino, OrderFiltersSDKType, OrderID, OrderIDAmino, OrderIDSDKType, Order, OrderAmino, OrderSDKType } from "./order";
import { PageRequest, PageRequestAmino, PageRequestSDKType, PageResponse, PageResponseAmino, PageResponseSDKType } from "../../../cosmos/base/query/v1beta1/pagination";
import { BidFilters, BidFiltersAmino, BidFiltersSDKType, BidID, BidIDAmino, BidIDSDKType, Bid, BidAmino, BidSDKType } from "./bid";
import { LeaseFilters, LeaseFiltersAmino, LeaseFiltersSDKType, LeaseID, LeaseIDAmino, LeaseIDSDKType, Lease, LeaseAmino, LeaseSDKType } from "./lease";
import { Account, AccountAmino, AccountSDKType, FractionalPayment, FractionalPaymentAmino, FractionalPaymentSDKType } from "../../escrow/v1beta2/types";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.market.v1beta2";
/** QueryOrdersRequest is request type for the Query/Orders RPC method */
export interface QueryOrdersRequest {
    filters: OrderFilters;
    pagination?: PageRequest;
}
export interface QueryOrdersRequestProtoMsg {
    typeUrl: "/akash.market.v1beta2.QueryOrdersRequest";
    value: Uint8Array;
}
/** QueryOrdersRequest is request type for the Query/Orders RPC method */
export interface QueryOrdersRequestAmino {
    filters?: OrderFiltersAmino;
    pagination?: PageRequestAmino;
}
export interface QueryOrdersRequestAminoMsg {
    type: "akash/market/v1beta2/query-orders-request";
    value: QueryOrdersRequestAmino;
}
/** QueryOrdersRequest is request type for the Query/Orders RPC method */
export interface QueryOrdersRequestSDKType {
    filters: OrderFiltersSDKType;
    pagination?: PageRequestSDKType;
}
/** QueryOrdersResponse is response type for the Query/Orders RPC method */
export interface QueryOrdersResponse {
    orders: Order[];
    pagination?: PageResponse;
}
export interface QueryOrdersResponseProtoMsg {
    typeUrl: "/akash.market.v1beta2.QueryOrdersResponse";
    value: Uint8Array;
}
/** QueryOrdersResponse is response type for the Query/Orders RPC method */
export interface QueryOrdersResponseAmino {
    orders?: OrderAmino[];
    pagination?: PageResponseAmino;
}
export interface QueryOrdersResponseAminoMsg {
    type: "akash/market/v1beta2/query-orders-response";
    value: QueryOrdersResponseAmino;
}
/** QueryOrdersResponse is response type for the Query/Orders RPC method */
export interface QueryOrdersResponseSDKType {
    orders: OrderSDKType[];
    pagination?: PageResponseSDKType;
}
/** QueryOrderRequest is request type for the Query/Order RPC method */
export interface QueryOrderRequest {
    id: OrderID;
}
export interface QueryOrderRequestProtoMsg {
    typeUrl: "/akash.market.v1beta2.QueryOrderRequest";
    value: Uint8Array;
}
/** QueryOrderRequest is request type for the Query/Order RPC method */
export interface QueryOrderRequestAmino {
    id?: OrderIDAmino;
}
export interface QueryOrderRequestAminoMsg {
    type: "akash/market/v1beta2/query-order-request";
    value: QueryOrderRequestAmino;
}
/** QueryOrderRequest is request type for the Query/Order RPC method */
export interface QueryOrderRequestSDKType {
    id: OrderIDSDKType;
}
/** QueryOrderResponse is response type for the Query/Order RPC method */
export interface QueryOrderResponse {
    order: Order;
}
export interface QueryOrderResponseProtoMsg {
    typeUrl: "/akash.market.v1beta2.QueryOrderResponse";
    value: Uint8Array;
}
/** QueryOrderResponse is response type for the Query/Order RPC method */
export interface QueryOrderResponseAmino {
    order?: OrderAmino;
}
export interface QueryOrderResponseAminoMsg {
    type: "akash/market/v1beta2/query-order-response";
    value: QueryOrderResponseAmino;
}
/** QueryOrderResponse is response type for the Query/Order RPC method */
export interface QueryOrderResponseSDKType {
    order: OrderSDKType;
}
/** QueryBidsRequest is request type for the Query/Bids RPC method */
export interface QueryBidsRequest {
    filters: BidFilters;
    pagination?: PageRequest;
}
export interface QueryBidsRequestProtoMsg {
    typeUrl: "/akash.market.v1beta2.QueryBidsRequest";
    value: Uint8Array;
}
/** QueryBidsRequest is request type for the Query/Bids RPC method */
export interface QueryBidsRequestAmino {
    filters?: BidFiltersAmino;
    pagination?: PageRequestAmino;
}
export interface QueryBidsRequestAminoMsg {
    type: "akash/market/v1beta2/query-bids-request";
    value: QueryBidsRequestAmino;
}
/** QueryBidsRequest is request type for the Query/Bids RPC method */
export interface QueryBidsRequestSDKType {
    filters: BidFiltersSDKType;
    pagination?: PageRequestSDKType;
}
/** QueryBidsResponse is response type for the Query/Bids RPC method */
export interface QueryBidsResponse {
    bids: QueryBidResponse[];
    pagination?: PageResponse;
}
export interface QueryBidsResponseProtoMsg {
    typeUrl: "/akash.market.v1beta2.QueryBidsResponse";
    value: Uint8Array;
}
/** QueryBidsResponse is response type for the Query/Bids RPC method */
export interface QueryBidsResponseAmino {
    bids?: QueryBidResponseAmino[];
    pagination?: PageResponseAmino;
}
export interface QueryBidsResponseAminoMsg {
    type: "akash/market/v1beta2/query-bids-response";
    value: QueryBidsResponseAmino;
}
/** QueryBidsResponse is response type for the Query/Bids RPC method */
export interface QueryBidsResponseSDKType {
    bids: QueryBidResponseSDKType[];
    pagination?: PageResponseSDKType;
}
/** QueryBidRequest is request type for the Query/Bid RPC method */
export interface QueryBidRequest {
    id: BidID;
}
export interface QueryBidRequestProtoMsg {
    typeUrl: "/akash.market.v1beta2.QueryBidRequest";
    value: Uint8Array;
}
/** QueryBidRequest is request type for the Query/Bid RPC method */
export interface QueryBidRequestAmino {
    id?: BidIDAmino;
}
export interface QueryBidRequestAminoMsg {
    type: "akash/market/v1beta2/query-bid-request";
    value: QueryBidRequestAmino;
}
/** QueryBidRequest is request type for the Query/Bid RPC method */
export interface QueryBidRequestSDKType {
    id: BidIDSDKType;
}
/** QueryBidResponse is response type for the Query/Bid RPC method */
export interface QueryBidResponse {
    bid: Bid;
    escrowAccount: Account;
}
export interface QueryBidResponseProtoMsg {
    typeUrl: "/akash.market.v1beta2.QueryBidResponse";
    value: Uint8Array;
}
/** QueryBidResponse is response type for the Query/Bid RPC method */
export interface QueryBidResponseAmino {
    bid?: BidAmino;
    escrow_account?: AccountAmino;
}
export interface QueryBidResponseAminoMsg {
    type: "akash/market/v1beta2/query-bid-response";
    value: QueryBidResponseAmino;
}
/** QueryBidResponse is response type for the Query/Bid RPC method */
export interface QueryBidResponseSDKType {
    bid: BidSDKType;
    escrow_account: AccountSDKType;
}
/** QueryLeasesRequest is request type for the Query/Leases RPC method */
export interface QueryLeasesRequest {
    filters: LeaseFilters;
    pagination?: PageRequest;
}
export interface QueryLeasesRequestProtoMsg {
    typeUrl: "/akash.market.v1beta2.QueryLeasesRequest";
    value: Uint8Array;
}
/** QueryLeasesRequest is request type for the Query/Leases RPC method */
export interface QueryLeasesRequestAmino {
    filters?: LeaseFiltersAmino;
    pagination?: PageRequestAmino;
}
export interface QueryLeasesRequestAminoMsg {
    type: "akash/market/v1beta2/query-leases-request";
    value: QueryLeasesRequestAmino;
}
/** QueryLeasesRequest is request type for the Query/Leases RPC method */
export interface QueryLeasesRequestSDKType {
    filters: LeaseFiltersSDKType;
    pagination?: PageRequestSDKType;
}
/** QueryLeasesResponse is response type for the Query/Leases RPC method */
export interface QueryLeasesResponse {
    leases: QueryLeaseResponse[];
    pagination?: PageResponse;
}
export interface QueryLeasesResponseProtoMsg {
    typeUrl: "/akash.market.v1beta2.QueryLeasesResponse";
    value: Uint8Array;
}
/** QueryLeasesResponse is response type for the Query/Leases RPC method */
export interface QueryLeasesResponseAmino {
    leases?: QueryLeaseResponseAmino[];
    pagination?: PageResponseAmino;
}
export interface QueryLeasesResponseAminoMsg {
    type: "akash/market/v1beta2/query-leases-response";
    value: QueryLeasesResponseAmino;
}
/** QueryLeasesResponse is response type for the Query/Leases RPC method */
export interface QueryLeasesResponseSDKType {
    leases: QueryLeaseResponseSDKType[];
    pagination?: PageResponseSDKType;
}
/** QueryLeaseRequest is request type for the Query/Lease RPC method */
export interface QueryLeaseRequest {
    id: LeaseID;
}
export interface QueryLeaseRequestProtoMsg {
    typeUrl: "/akash.market.v1beta2.QueryLeaseRequest";
    value: Uint8Array;
}
/** QueryLeaseRequest is request type for the Query/Lease RPC method */
export interface QueryLeaseRequestAmino {
    id?: LeaseIDAmino;
}
export interface QueryLeaseRequestAminoMsg {
    type: "akash/market/v1beta2/query-lease-request";
    value: QueryLeaseRequestAmino;
}
/** QueryLeaseRequest is request type for the Query/Lease RPC method */
export interface QueryLeaseRequestSDKType {
    id: LeaseIDSDKType;
}
/** QueryLeaseResponse is response type for the Query/Lease RPC method */
export interface QueryLeaseResponse {
    lease: Lease;
    escrowPayment: FractionalPayment;
}
export interface QueryLeaseResponseProtoMsg {
    typeUrl: "/akash.market.v1beta2.QueryLeaseResponse";
    value: Uint8Array;
}
/** QueryLeaseResponse is response type for the Query/Lease RPC method */
export interface QueryLeaseResponseAmino {
    lease?: LeaseAmino;
    escrow_payment?: FractionalPaymentAmino;
}
export interface QueryLeaseResponseAminoMsg {
    type: "akash/market/v1beta2/query-lease-response";
    value: QueryLeaseResponseAmino;
}
/** QueryLeaseResponse is response type for the Query/Lease RPC method */
export interface QueryLeaseResponseSDKType {
    lease: LeaseSDKType;
    escrow_payment: FractionalPaymentSDKType;
}
export declare const QueryOrdersRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryOrdersRequest;
    isSDK(o: any): o is QueryOrdersRequestSDKType;
    isAmino(o: any): o is QueryOrdersRequestAmino;
    encode(message: QueryOrdersRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryOrdersRequest;
    fromJSON(object: any): QueryOrdersRequest;
    toJSON(message: QueryOrdersRequest): JsonSafe<QueryOrdersRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryOrdersRequest>, I>>(object: I): QueryOrdersRequest;
    fromSDK(object: QueryOrdersRequestSDKType): QueryOrdersRequest;
    fromSDKJSON(object: any): QueryOrdersRequestSDKType;
    toSDK(message: QueryOrdersRequest): QueryOrdersRequestSDKType;
    fromAmino(object: QueryOrdersRequestAmino): QueryOrdersRequest;
    toAmino(message: QueryOrdersRequest): QueryOrdersRequestAmino;
    fromAminoMsg(object: QueryOrdersRequestAminoMsg): QueryOrdersRequest;
    toAminoMsg(message: QueryOrdersRequest): QueryOrdersRequestAminoMsg;
    fromProtoMsg(message: QueryOrdersRequestProtoMsg): QueryOrdersRequest;
    toProto(message: QueryOrdersRequest): Uint8Array;
    toProtoMsg(message: QueryOrdersRequest): QueryOrdersRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryOrdersResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryOrdersResponse;
    isSDK(o: any): o is QueryOrdersResponseSDKType;
    isAmino(o: any): o is QueryOrdersResponseAmino;
    encode(message: QueryOrdersResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryOrdersResponse;
    fromJSON(object: any): QueryOrdersResponse;
    toJSON(message: QueryOrdersResponse): JsonSafe<QueryOrdersResponse>;
    fromPartial<I extends Exact<DeepPartial<QueryOrdersResponse>, I>>(object: I): QueryOrdersResponse;
    fromSDK(object: QueryOrdersResponseSDKType): QueryOrdersResponse;
    fromSDKJSON(object: any): QueryOrdersResponseSDKType;
    toSDK(message: QueryOrdersResponse): QueryOrdersResponseSDKType;
    fromAmino(object: QueryOrdersResponseAmino): QueryOrdersResponse;
    toAmino(message: QueryOrdersResponse): QueryOrdersResponseAmino;
    fromAminoMsg(object: QueryOrdersResponseAminoMsg): QueryOrdersResponse;
    toAminoMsg(message: QueryOrdersResponse): QueryOrdersResponseAminoMsg;
    fromProtoMsg(message: QueryOrdersResponseProtoMsg): QueryOrdersResponse;
    toProto(message: QueryOrdersResponse): Uint8Array;
    toProtoMsg(message: QueryOrdersResponse): QueryOrdersResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryOrderRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryOrderRequest;
    isSDK(o: any): o is QueryOrderRequestSDKType;
    isAmino(o: any): o is QueryOrderRequestAmino;
    encode(message: QueryOrderRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryOrderRequest;
    fromJSON(object: any): QueryOrderRequest;
    toJSON(message: QueryOrderRequest): JsonSafe<QueryOrderRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryOrderRequest>, I>>(object: I): QueryOrderRequest;
    fromSDK(object: QueryOrderRequestSDKType): QueryOrderRequest;
    fromSDKJSON(object: any): QueryOrderRequestSDKType;
    toSDK(message: QueryOrderRequest): QueryOrderRequestSDKType;
    fromAmino(object: QueryOrderRequestAmino): QueryOrderRequest;
    toAmino(message: QueryOrderRequest): QueryOrderRequestAmino;
    fromAminoMsg(object: QueryOrderRequestAminoMsg): QueryOrderRequest;
    toAminoMsg(message: QueryOrderRequest): QueryOrderRequestAminoMsg;
    fromProtoMsg(message: QueryOrderRequestProtoMsg): QueryOrderRequest;
    toProto(message: QueryOrderRequest): Uint8Array;
    toProtoMsg(message: QueryOrderRequest): QueryOrderRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryOrderResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryOrderResponse;
    isSDK(o: any): o is QueryOrderResponseSDKType;
    isAmino(o: any): o is QueryOrderResponseAmino;
    encode(message: QueryOrderResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryOrderResponse;
    fromJSON(object: any): QueryOrderResponse;
    toJSON(message: QueryOrderResponse): JsonSafe<QueryOrderResponse>;
    fromPartial<I extends Exact<DeepPartial<QueryOrderResponse>, I>>(object: I): QueryOrderResponse;
    fromSDK(object: QueryOrderResponseSDKType): QueryOrderResponse;
    fromSDKJSON(object: any): QueryOrderResponseSDKType;
    toSDK(message: QueryOrderResponse): QueryOrderResponseSDKType;
    fromAmino(object: QueryOrderResponseAmino): QueryOrderResponse;
    toAmino(message: QueryOrderResponse): QueryOrderResponseAmino;
    fromAminoMsg(object: QueryOrderResponseAminoMsg): QueryOrderResponse;
    toAminoMsg(message: QueryOrderResponse): QueryOrderResponseAminoMsg;
    fromProtoMsg(message: QueryOrderResponseProtoMsg): QueryOrderResponse;
    toProto(message: QueryOrderResponse): Uint8Array;
    toProtoMsg(message: QueryOrderResponse): QueryOrderResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryBidsRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryBidsRequest;
    isSDK(o: any): o is QueryBidsRequestSDKType;
    isAmino(o: any): o is QueryBidsRequestAmino;
    encode(message: QueryBidsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryBidsRequest;
    fromJSON(object: any): QueryBidsRequest;
    toJSON(message: QueryBidsRequest): JsonSafe<QueryBidsRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryBidsRequest>, I>>(object: I): QueryBidsRequest;
    fromSDK(object: QueryBidsRequestSDKType): QueryBidsRequest;
    fromSDKJSON(object: any): QueryBidsRequestSDKType;
    toSDK(message: QueryBidsRequest): QueryBidsRequestSDKType;
    fromAmino(object: QueryBidsRequestAmino): QueryBidsRequest;
    toAmino(message: QueryBidsRequest): QueryBidsRequestAmino;
    fromAminoMsg(object: QueryBidsRequestAminoMsg): QueryBidsRequest;
    toAminoMsg(message: QueryBidsRequest): QueryBidsRequestAminoMsg;
    fromProtoMsg(message: QueryBidsRequestProtoMsg): QueryBidsRequest;
    toProto(message: QueryBidsRequest): Uint8Array;
    toProtoMsg(message: QueryBidsRequest): QueryBidsRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryBidsResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryBidsResponse;
    isSDK(o: any): o is QueryBidsResponseSDKType;
    isAmino(o: any): o is QueryBidsResponseAmino;
    encode(message: QueryBidsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryBidsResponse;
    fromJSON(object: any): QueryBidsResponse;
    toJSON(message: QueryBidsResponse): JsonSafe<QueryBidsResponse>;
    fromPartial<I extends Exact<DeepPartial<QueryBidsResponse>, I>>(object: I): QueryBidsResponse;
    fromSDK(object: QueryBidsResponseSDKType): QueryBidsResponse;
    fromSDKJSON(object: any): QueryBidsResponseSDKType;
    toSDK(message: QueryBidsResponse): QueryBidsResponseSDKType;
    fromAmino(object: QueryBidsResponseAmino): QueryBidsResponse;
    toAmino(message: QueryBidsResponse): QueryBidsResponseAmino;
    fromAminoMsg(object: QueryBidsResponseAminoMsg): QueryBidsResponse;
    toAminoMsg(message: QueryBidsResponse): QueryBidsResponseAminoMsg;
    fromProtoMsg(message: QueryBidsResponseProtoMsg): QueryBidsResponse;
    toProto(message: QueryBidsResponse): Uint8Array;
    toProtoMsg(message: QueryBidsResponse): QueryBidsResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryBidRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryBidRequest;
    isSDK(o: any): o is QueryBidRequestSDKType;
    isAmino(o: any): o is QueryBidRequestAmino;
    encode(message: QueryBidRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryBidRequest;
    fromJSON(object: any): QueryBidRequest;
    toJSON(message: QueryBidRequest): JsonSafe<QueryBidRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryBidRequest>, I>>(object: I): QueryBidRequest;
    fromSDK(object: QueryBidRequestSDKType): QueryBidRequest;
    fromSDKJSON(object: any): QueryBidRequestSDKType;
    toSDK(message: QueryBidRequest): QueryBidRequestSDKType;
    fromAmino(object: QueryBidRequestAmino): QueryBidRequest;
    toAmino(message: QueryBidRequest): QueryBidRequestAmino;
    fromAminoMsg(object: QueryBidRequestAminoMsg): QueryBidRequest;
    toAminoMsg(message: QueryBidRequest): QueryBidRequestAminoMsg;
    fromProtoMsg(message: QueryBidRequestProtoMsg): QueryBidRequest;
    toProto(message: QueryBidRequest): Uint8Array;
    toProtoMsg(message: QueryBidRequest): QueryBidRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryBidResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryBidResponse;
    isSDK(o: any): o is QueryBidResponseSDKType;
    isAmino(o: any): o is QueryBidResponseAmino;
    encode(message: QueryBidResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryBidResponse;
    fromJSON(object: any): QueryBidResponse;
    toJSON(message: QueryBidResponse): JsonSafe<QueryBidResponse>;
    fromPartial<I extends Exact<DeepPartial<QueryBidResponse>, I>>(object: I): QueryBidResponse;
    fromSDK(object: QueryBidResponseSDKType): QueryBidResponse;
    fromSDKJSON(object: any): QueryBidResponseSDKType;
    toSDK(message: QueryBidResponse): QueryBidResponseSDKType;
    fromAmino(object: QueryBidResponseAmino): QueryBidResponse;
    toAmino(message: QueryBidResponse): QueryBidResponseAmino;
    fromAminoMsg(object: QueryBidResponseAminoMsg): QueryBidResponse;
    toAminoMsg(message: QueryBidResponse): QueryBidResponseAminoMsg;
    fromProtoMsg(message: QueryBidResponseProtoMsg): QueryBidResponse;
    toProto(message: QueryBidResponse): Uint8Array;
    toProtoMsg(message: QueryBidResponse): QueryBidResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryLeasesRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryLeasesRequest;
    isSDK(o: any): o is QueryLeasesRequestSDKType;
    isAmino(o: any): o is QueryLeasesRequestAmino;
    encode(message: QueryLeasesRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryLeasesRequest;
    fromJSON(object: any): QueryLeasesRequest;
    toJSON(message: QueryLeasesRequest): JsonSafe<QueryLeasesRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryLeasesRequest>, I>>(object: I): QueryLeasesRequest;
    fromSDK(object: QueryLeasesRequestSDKType): QueryLeasesRequest;
    fromSDKJSON(object: any): QueryLeasesRequestSDKType;
    toSDK(message: QueryLeasesRequest): QueryLeasesRequestSDKType;
    fromAmino(object: QueryLeasesRequestAmino): QueryLeasesRequest;
    toAmino(message: QueryLeasesRequest): QueryLeasesRequestAmino;
    fromAminoMsg(object: QueryLeasesRequestAminoMsg): QueryLeasesRequest;
    toAminoMsg(message: QueryLeasesRequest): QueryLeasesRequestAminoMsg;
    fromProtoMsg(message: QueryLeasesRequestProtoMsg): QueryLeasesRequest;
    toProto(message: QueryLeasesRequest): Uint8Array;
    toProtoMsg(message: QueryLeasesRequest): QueryLeasesRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryLeasesResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryLeasesResponse;
    isSDK(o: any): o is QueryLeasesResponseSDKType;
    isAmino(o: any): o is QueryLeasesResponseAmino;
    encode(message: QueryLeasesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryLeasesResponse;
    fromJSON(object: any): QueryLeasesResponse;
    toJSON(message: QueryLeasesResponse): JsonSafe<QueryLeasesResponse>;
    fromPartial<I extends Exact<DeepPartial<QueryLeasesResponse>, I>>(object: I): QueryLeasesResponse;
    fromSDK(object: QueryLeasesResponseSDKType): QueryLeasesResponse;
    fromSDKJSON(object: any): QueryLeasesResponseSDKType;
    toSDK(message: QueryLeasesResponse): QueryLeasesResponseSDKType;
    fromAmino(object: QueryLeasesResponseAmino): QueryLeasesResponse;
    toAmino(message: QueryLeasesResponse): QueryLeasesResponseAmino;
    fromAminoMsg(object: QueryLeasesResponseAminoMsg): QueryLeasesResponse;
    toAminoMsg(message: QueryLeasesResponse): QueryLeasesResponseAminoMsg;
    fromProtoMsg(message: QueryLeasesResponseProtoMsg): QueryLeasesResponse;
    toProto(message: QueryLeasesResponse): Uint8Array;
    toProtoMsg(message: QueryLeasesResponse): QueryLeasesResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryLeaseRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryLeaseRequest;
    isSDK(o: any): o is QueryLeaseRequestSDKType;
    isAmino(o: any): o is QueryLeaseRequestAmino;
    encode(message: QueryLeaseRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryLeaseRequest;
    fromJSON(object: any): QueryLeaseRequest;
    toJSON(message: QueryLeaseRequest): JsonSafe<QueryLeaseRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryLeaseRequest>, I>>(object: I): QueryLeaseRequest;
    fromSDK(object: QueryLeaseRequestSDKType): QueryLeaseRequest;
    fromSDKJSON(object: any): QueryLeaseRequestSDKType;
    toSDK(message: QueryLeaseRequest): QueryLeaseRequestSDKType;
    fromAmino(object: QueryLeaseRequestAmino): QueryLeaseRequest;
    toAmino(message: QueryLeaseRequest): QueryLeaseRequestAmino;
    fromAminoMsg(object: QueryLeaseRequestAminoMsg): QueryLeaseRequest;
    toAminoMsg(message: QueryLeaseRequest): QueryLeaseRequestAminoMsg;
    fromProtoMsg(message: QueryLeaseRequestProtoMsg): QueryLeaseRequest;
    toProto(message: QueryLeaseRequest): Uint8Array;
    toProtoMsg(message: QueryLeaseRequest): QueryLeaseRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryLeaseResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryLeaseResponse;
    isSDK(o: any): o is QueryLeaseResponseSDKType;
    isAmino(o: any): o is QueryLeaseResponseAmino;
    encode(message: QueryLeaseResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryLeaseResponse;
    fromJSON(object: any): QueryLeaseResponse;
    toJSON(message: QueryLeaseResponse): JsonSafe<QueryLeaseResponse>;
    fromPartial<I extends Exact<DeepPartial<QueryLeaseResponse>, I>>(object: I): QueryLeaseResponse;
    fromSDK(object: QueryLeaseResponseSDKType): QueryLeaseResponse;
    fromSDKJSON(object: any): QueryLeaseResponseSDKType;
    toSDK(message: QueryLeaseResponse): QueryLeaseResponseSDKType;
    fromAmino(object: QueryLeaseResponseAmino): QueryLeaseResponse;
    toAmino(message: QueryLeaseResponse): QueryLeaseResponseAmino;
    fromAminoMsg(object: QueryLeaseResponseAminoMsg): QueryLeaseResponse;
    toAminoMsg(message: QueryLeaseResponse): QueryLeaseResponseAminoMsg;
    fromProtoMsg(message: QueryLeaseResponseProtoMsg): QueryLeaseResponse;
    toProto(message: QueryLeaseResponse): Uint8Array;
    toProtoMsg(message: QueryLeaseResponse): QueryLeaseResponseProtoMsg;
    registerTypeUrl(): void;
};
