import { setPaginationParams } from "../../../helpers";
import { QueryOrdersResponse, QueryOrderResponse, QueryBidsResponse, QueryBidResponse, QueryLeasesResponse, QueryLeaseResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* Orders queries orders with filters */
    orders = async (params) => {
        const options = {
            params: {}
        };
        if (typeof params?.filters !== "undefined") {
            options.params.filters = params.filters;
        }
        if (typeof params?.pagination !== "undefined") {
            setPaginationParams(options, params.pagination);
        }
        const endpoint = `akash/market/v1beta2/orders/list`;
        return QueryOrdersResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
    /* Order queries order details */
    order = async (params) => {
        const options = {
            params: {}
        };
        if (typeof params?.id !== "undefined") {
            options.params.id = params.id;
        }
        const endpoint = `akash/market/v1beta2/orders/info`;
        return QueryOrderResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
    /* Bids queries bids with filters */
    bids = async (params) => {
        const options = {
            params: {}
        };
        if (typeof params?.filters !== "undefined") {
            options.params.filters = params.filters;
        }
        if (typeof params?.pagination !== "undefined") {
            setPaginationParams(options, params.pagination);
        }
        const endpoint = `akash/market/v1beta2/bids/list`;
        return QueryBidsResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
    /* Bid queries bid details */
    bid = async (params) => {
        const options = {
            params: {}
        };
        if (typeof params?.id !== "undefined") {
            options.params.id = params.id;
        }
        const endpoint = `akash/market/v1beta2/bids/info`;
        return QueryBidResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
    /* Leases queries leases with filters */
    leases = async (params) => {
        const options = {
            params: {}
        };
        if (typeof params?.filters !== "undefined") {
            options.params.filters = params.filters;
        }
        if (typeof params?.pagination !== "undefined") {
            setPaginationParams(options, params.pagination);
        }
        const endpoint = `akash/market/v1beta2/leases/list`;
        return QueryLeasesResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
    /* Lease queries lease details */
    lease = async (params) => {
        const options = {
            params: {}
        };
        if (typeof params?.id !== "undefined") {
            options.params.id = params.id;
        }
        const endpoint = `akash/market/v1beta2/leases/info`;
        return QueryLeaseResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
}
