import { MsgCreateBid, MsgCloseBid } from "./bid";
import { MsgWithdrawLease, MsgCreateLease, MsgCloseLease } from "./lease";
import { TelescopeGeneratedType } from "../../../types";
import { Registry } from "@cosmjs/proto-signing";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        createBid(value: MsgCreateBid): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        closeBid(value: MsgCloseBid): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        withdrawLease(value: MsgWithdrawLease): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        createLease(value: MsgCreateLease): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        closeLease(value: MsgCloseLease): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        createBid(value: MsgCreateBid): {
            typeUrl: string;
            value: MsgCreateBid;
        };
        closeBid(value: MsgCloseBid): {
            typeUrl: string;
            value: MsgCloseBid;
        };
        withdrawLease(value: MsgWithdrawLease): {
            typeUrl: string;
            value: MsgWithdrawLease;
        };
        createLease(value: MsgCreateLease): {
            typeUrl: string;
            value: MsgCreateLease;
        };
        closeLease(value: MsgCloseLease): {
            typeUrl: string;
            value: MsgCloseLease;
        };
    };
    toJSON: {
        createBid(value: MsgCreateBid): {
            typeUrl: string;
            value: {
                order: {
                    owner: string;
                    dseq: string;
                    gseq: number;
                    oseq: number;
                };
                provider: string;
                price: {
                    denom: string;
                    amount: string;
                };
                deposit: {
                    denom: string;
                    amount: string;
                };
            };
        };
        closeBid(value: MsgCloseBid): {
            typeUrl: string;
            value: {
                bidId: {
                    owner: string;
                    dseq: string;
                    gseq: number;
                    oseq: number;
                    provider: string;
                };
            };
        };
        withdrawLease(value: MsgWithdrawLease): {
            typeUrl: string;
            value: {
                bidId: {
                    owner: string;
                    dseq: string;
                    gseq: number;
                    oseq: number;
                    provider: string;
                };
            };
        };
        createLease(value: MsgCreateLease): {
            typeUrl: string;
            value: {
                bidId: {
                    owner: string;
                    dseq: string;
                    gseq: number;
                    oseq: number;
                    provider: string;
                };
            };
        };
        closeLease(value: MsgCloseLease): {
            typeUrl: string;
            value: {
                leaseId: {
                    owner: string;
                    dseq: string;
                    gseq: number;
                    oseq: number;
                    provider: string;
                };
            };
        };
    };
    fromJSON: {
        createBid(value: any): {
            typeUrl: string;
            value: MsgCreateBid;
        };
        closeBid(value: any): {
            typeUrl: string;
            value: MsgCloseBid;
        };
        withdrawLease(value: any): {
            typeUrl: string;
            value: MsgWithdrawLease;
        };
        createLease(value: any): {
            typeUrl: string;
            value: MsgCreateLease;
        };
        closeLease(value: any): {
            typeUrl: string;
            value: MsgCloseLease;
        };
    };
    fromPartial: {
        createBid(value: MsgCreateBid): {
            typeUrl: string;
            value: MsgCreateBid;
        };
        closeBid(value: MsgCloseBid): {
            typeUrl: string;
            value: MsgCloseBid;
        };
        withdrawLease(value: MsgWithdrawLease): {
            typeUrl: string;
            value: MsgWithdrawLease;
        };
        createLease(value: MsgCreateLease): {
            typeUrl: string;
            value: MsgCreateLease;
        };
        closeLease(value: MsgCloseLease): {
            typeUrl: string;
            value: MsgCloseLease;
        };
    };
};
