import { Attribute } from "../../base/v1beta1/attribute";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.provider.v1beta1";
function createBaseProviderInfo() {
    return {
        email: "",
        website: ""
    };
}
export const ProviderInfo = {
    typeUrl: "/akash.provider.v1beta1.ProviderInfo",
    aminoType: "akash/provider/provider-info",
    is(o) {
        return o && (o.$typeUrl === ProviderInfo.typeUrl || typeof o.email === "string" && typeof o.website === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ProviderInfo.typeUrl || typeof o.email === "string" && typeof o.website === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ProviderInfo.typeUrl || typeof o.email === "string" && typeof o.website === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.email !== undefined) {
            writer.uint32(10).string(message.email);
        }
        if (message.website !== undefined) {
            writer.uint32(18).string(message.website);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseProviderInfo();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.email = reader.string();
                    break;
                case 2:
                    message.website = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseProviderInfo();
        if (isSet(object.email))
            obj.email = String(object.email);
        if (isSet(object.website))
            obj.website = String(object.website);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.email !== undefined && (obj.email = message.email);
        message.website !== undefined && (obj.website = message.website);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseProviderInfo();
        message.email = object.email ?? "";
        message.website = object.website ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            email: object?.email,
            website: object?.website
        };
    },
    fromSDKJSON(object) {
        return {
            email: isSet(object.email) ? String(object.email) : "",
            website: isSet(object.website) ? String(object.website) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.email = message.email;
        obj.website = message.website;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseProviderInfo();
        if (object.email !== undefined && object.email !== null) {
            message.email = object.email;
        }
        if (object.website !== undefined && object.website !== null) {
            message.website = object.website;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.email = message.email ?? "";
        obj.website = message.website ?? "";
        return obj;
    },
    fromAminoMsg(object) {
        return ProviderInfo.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/provider/provider-info",
            value: ProviderInfo.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return ProviderInfo.decode(message.value);
    },
    toProto(message) {
        return ProviderInfo.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.provider.v1beta1.ProviderInfo",
            value: ProviderInfo.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgCreateProvider() {
    return {
        owner: "",
        hostUri: "",
        attributes: [],
        info: ProviderInfo.fromPartial({})
    };
}
export const MsgCreateProvider = {
    typeUrl: "/akash.provider.v1beta1.MsgCreateProvider",
    aminoType: "akash/provider/testonly-create-provider",
    is(o) {
        return o && (o.$typeUrl === MsgCreateProvider.typeUrl || typeof o.owner === "string" && typeof o.hostUri === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.is(o.attributes[0])) && ProviderInfo.is(o.info));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgCreateProvider.typeUrl || typeof o.owner === "string" && typeof o.host_uri === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isSDK(o.attributes[0])) && ProviderInfo.isSDK(o.info));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgCreateProvider.typeUrl || typeof o.owner === "string" && typeof o.host_uri === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isAmino(o.attributes[0])) && ProviderInfo.isAmino(o.info));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.hostUri !== undefined) {
            writer.uint32(18).string(message.hostUri);
        }
        for (const v of message.attributes) {
            Attribute.encode(v, writer.uint32(26).fork()).ldelim();
        }
        if (message.info !== undefined) {
            ProviderInfo.encode(message.info, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCreateProvider();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.hostUri = reader.string();
                    break;
                case 3:
                    message.attributes.push(Attribute.decode(reader, reader.uint32()));
                    break;
                case 4:
                    message.info = ProviderInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgCreateProvider();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.hostUri))
            obj.hostUri = String(object.hostUri);
        if (Array.isArray(object?.attributes))
            obj.attributes = object.attributes.map((e) => Attribute.fromJSON(e));
        if (isSet(object.info))
            obj.info = ProviderInfo.fromJSON(object.info);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.hostUri !== undefined && (obj.hostUri = message.hostUri);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toJSON(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        message.info !== undefined && (obj.info = message.info ? ProviderInfo.toJSON(message.info) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgCreateProvider();
        message.owner = object.owner ?? "";
        message.hostUri = object.hostUri ?? "";
        message.attributes = object.attributes?.map(e => Attribute.fromPartial(e)) || [];
        if (object.info !== undefined && object.info !== null) {
            message.info = ProviderInfo.fromPartial(object.info);
        }
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            hostUri: object?.host_uri,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDK(e)) : [],
            info: object.info ? ProviderInfo.fromSDK(object.info) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            host_uri: isSet(object.host_uri) ? String(object.host_uri) : "",
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDKJSON(e)) : [],
            info: isSet(object.info) ? ProviderInfo.fromSDKJSON(object.info) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.host_uri = message.hostUri;
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toSDK(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        message.info !== undefined && (obj.info = message.info ? ProviderInfo.toSDK(message.info) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgCreateProvider();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.host_uri !== undefined && object.host_uri !== null) {
            message.hostUri = object.host_uri;
        }
        message.attributes = object.attributes?.map(e => Attribute.fromAmino(e)) || [];
        if (object.info !== undefined && object.info !== null) {
            message.info = ProviderInfo.fromAmino(object.info);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.host_uri = message.hostUri ?? "";
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toAmino(e) : undefined);
        }
        else {
            obj.attributes = message.attributes;
        }
        obj.info = message.info ? ProviderInfo.toAmino(message.info) : ProviderInfo.toAmino(ProviderInfo.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCreateProvider.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/provider/testonly-create-provider",
            value: MsgCreateProvider.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgCreateProvider.decode(message.value);
    },
    toProto(message) {
        return MsgCreateProvider.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.provider.v1beta1.MsgCreateProvider",
            value: MsgCreateProvider.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Attribute.registerTypeUrl();
        ProviderInfo.registerTypeUrl();
    }
};
function createBaseMsgCreateProviderResponse() {
    return {};
}
export const MsgCreateProviderResponse = {
    typeUrl: "/akash.provider.v1beta1.MsgCreateProviderResponse",
    aminoType: "akash/provider/testonly-create-provider-response",
    is(o) {
        return o && o.$typeUrl === MsgCreateProviderResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgCreateProviderResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgCreateProviderResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCreateProviderResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgCreateProviderResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgCreateProviderResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgCreateProviderResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCreateProviderResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/provider/testonly-create-provider-response",
            value: MsgCreateProviderResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgCreateProviderResponse.decode(message.value);
    },
    toProto(message) {
        return MsgCreateProviderResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.provider.v1beta1.MsgCreateProviderResponse",
            value: MsgCreateProviderResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgUpdateProvider() {
    return {
        owner: "",
        hostUri: "",
        attributes: [],
        info: ProviderInfo.fromPartial({})
    };
}
export const MsgUpdateProvider = {
    typeUrl: "/akash.provider.v1beta1.MsgUpdateProvider",
    aminoType: "akash/provider/testonly-update-provider",
    is(o) {
        return o && (o.$typeUrl === MsgUpdateProvider.typeUrl || typeof o.owner === "string" && typeof o.hostUri === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.is(o.attributes[0])) && ProviderInfo.is(o.info));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgUpdateProvider.typeUrl || typeof o.owner === "string" && typeof o.host_uri === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isSDK(o.attributes[0])) && ProviderInfo.isSDK(o.info));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgUpdateProvider.typeUrl || typeof o.owner === "string" && typeof o.host_uri === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isAmino(o.attributes[0])) && ProviderInfo.isAmino(o.info));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.hostUri !== undefined) {
            writer.uint32(18).string(message.hostUri);
        }
        for (const v of message.attributes) {
            Attribute.encode(v, writer.uint32(26).fork()).ldelim();
        }
        if (message.info !== undefined) {
            ProviderInfo.encode(message.info, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgUpdateProvider();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.hostUri = reader.string();
                    break;
                case 3:
                    message.attributes.push(Attribute.decode(reader, reader.uint32()));
                    break;
                case 4:
                    message.info = ProviderInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgUpdateProvider();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.hostUri))
            obj.hostUri = String(object.hostUri);
        if (Array.isArray(object?.attributes))
            obj.attributes = object.attributes.map((e) => Attribute.fromJSON(e));
        if (isSet(object.info))
            obj.info = ProviderInfo.fromJSON(object.info);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.hostUri !== undefined && (obj.hostUri = message.hostUri);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toJSON(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        message.info !== undefined && (obj.info = message.info ? ProviderInfo.toJSON(message.info) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgUpdateProvider();
        message.owner = object.owner ?? "";
        message.hostUri = object.hostUri ?? "";
        message.attributes = object.attributes?.map(e => Attribute.fromPartial(e)) || [];
        if (object.info !== undefined && object.info !== null) {
            message.info = ProviderInfo.fromPartial(object.info);
        }
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            hostUri: object?.host_uri,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDK(e)) : [],
            info: object.info ? ProviderInfo.fromSDK(object.info) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            host_uri: isSet(object.host_uri) ? String(object.host_uri) : "",
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDKJSON(e)) : [],
            info: isSet(object.info) ? ProviderInfo.fromSDKJSON(object.info) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.host_uri = message.hostUri;
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toSDK(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        message.info !== undefined && (obj.info = message.info ? ProviderInfo.toSDK(message.info) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgUpdateProvider();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.host_uri !== undefined && object.host_uri !== null) {
            message.hostUri = object.host_uri;
        }
        message.attributes = object.attributes?.map(e => Attribute.fromAmino(e)) || [];
        if (object.info !== undefined && object.info !== null) {
            message.info = ProviderInfo.fromAmino(object.info);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.host_uri = message.hostUri ?? "";
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toAmino(e) : undefined);
        }
        else {
            obj.attributes = message.attributes;
        }
        obj.info = message.info ? ProviderInfo.toAmino(message.info) : ProviderInfo.toAmino(ProviderInfo.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return MsgUpdateProvider.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/provider/testonly-update-provider",
            value: MsgUpdateProvider.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgUpdateProvider.decode(message.value);
    },
    toProto(message) {
        return MsgUpdateProvider.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.provider.v1beta1.MsgUpdateProvider",
            value: MsgUpdateProvider.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Attribute.registerTypeUrl();
        ProviderInfo.registerTypeUrl();
    }
};
function createBaseMsgUpdateProviderResponse() {
    return {};
}
export const MsgUpdateProviderResponse = {
    typeUrl: "/akash.provider.v1beta1.MsgUpdateProviderResponse",
    aminoType: "akash/provider/testonly-update-provider-response",
    is(o) {
        return o && o.$typeUrl === MsgUpdateProviderResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgUpdateProviderResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgUpdateProviderResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgUpdateProviderResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgUpdateProviderResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgUpdateProviderResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgUpdateProviderResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgUpdateProviderResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/provider/testonly-update-provider-response",
            value: MsgUpdateProviderResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgUpdateProviderResponse.decode(message.value);
    },
    toProto(message) {
        return MsgUpdateProviderResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.provider.v1beta1.MsgUpdateProviderResponse",
            value: MsgUpdateProviderResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgDeleteProvider() {
    return {
        owner: ""
    };
}
export const MsgDeleteProvider = {
    typeUrl: "/akash.provider.v1beta1.MsgDeleteProvider",
    aminoType: "akash/provider/testonly-delete-provider",
    is(o) {
        return o && (o.$typeUrl === MsgDeleteProvider.typeUrl || typeof o.owner === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgDeleteProvider.typeUrl || typeof o.owner === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgDeleteProvider.typeUrl || typeof o.owner === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgDeleteProvider();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgDeleteProvider();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgDeleteProvider();
        message.owner = object.owner ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgDeleteProvider();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        return obj;
    },
    fromAminoMsg(object) {
        return MsgDeleteProvider.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/provider/testonly-delete-provider",
            value: MsgDeleteProvider.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgDeleteProvider.decode(message.value);
    },
    toProto(message) {
        return MsgDeleteProvider.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.provider.v1beta1.MsgDeleteProvider",
            value: MsgDeleteProvider.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgDeleteProviderResponse() {
    return {};
}
export const MsgDeleteProviderResponse = {
    typeUrl: "/akash.provider.v1beta1.MsgDeleteProviderResponse",
    aminoType: "akash/provider/testonly-delete-provider-response",
    is(o) {
        return o && o.$typeUrl === MsgDeleteProviderResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgDeleteProviderResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgDeleteProviderResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgDeleteProviderResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgDeleteProviderResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgDeleteProviderResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgDeleteProviderResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgDeleteProviderResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/provider/testonly-delete-provider-response",
            value: MsgDeleteProviderResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgDeleteProviderResponse.decode(message.value);
    },
    toProto(message) {
        return MsgDeleteProviderResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.provider.v1beta1.MsgDeleteProviderResponse",
            value: MsgDeleteProviderResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseProvider() {
    return {
        owner: "",
        hostUri: "",
        attributes: [],
        info: ProviderInfo.fromPartial({})
    };
}
export const Provider = {
    typeUrl: "/akash.provider.v1beta1.Provider",
    aminoType: "akash/provider/provider",
    is(o) {
        return o && (o.$typeUrl === Provider.typeUrl || typeof o.owner === "string" && typeof o.hostUri === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.is(o.attributes[0])) && ProviderInfo.is(o.info));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Provider.typeUrl || typeof o.owner === "string" && typeof o.host_uri === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isSDK(o.attributes[0])) && ProviderInfo.isSDK(o.info));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Provider.typeUrl || typeof o.owner === "string" && typeof o.host_uri === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isAmino(o.attributes[0])) && ProviderInfo.isAmino(o.info));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.hostUri !== undefined) {
            writer.uint32(18).string(message.hostUri);
        }
        for (const v of message.attributes) {
            Attribute.encode(v, writer.uint32(26).fork()).ldelim();
        }
        if (message.info !== undefined) {
            ProviderInfo.encode(message.info, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseProvider();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.hostUri = reader.string();
                    break;
                case 3:
                    message.attributes.push(Attribute.decode(reader, reader.uint32()));
                    break;
                case 4:
                    message.info = ProviderInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseProvider();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.hostUri))
            obj.hostUri = String(object.hostUri);
        if (Array.isArray(object?.attributes))
            obj.attributes = object.attributes.map((e) => Attribute.fromJSON(e));
        if (isSet(object.info))
            obj.info = ProviderInfo.fromJSON(object.info);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.hostUri !== undefined && (obj.hostUri = message.hostUri);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toJSON(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        message.info !== undefined && (obj.info = message.info ? ProviderInfo.toJSON(message.info) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseProvider();
        message.owner = object.owner ?? "";
        message.hostUri = object.hostUri ?? "";
        message.attributes = object.attributes?.map(e => Attribute.fromPartial(e)) || [];
        if (object.info !== undefined && object.info !== null) {
            message.info = ProviderInfo.fromPartial(object.info);
        }
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            hostUri: object?.host_uri,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDK(e)) : [],
            info: object.info ? ProviderInfo.fromSDK(object.info) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            host_uri: isSet(object.host_uri) ? String(object.host_uri) : "",
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDKJSON(e)) : [],
            info: isSet(object.info) ? ProviderInfo.fromSDKJSON(object.info) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.host_uri = message.hostUri;
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toSDK(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        message.info !== undefined && (obj.info = message.info ? ProviderInfo.toSDK(message.info) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseProvider();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.host_uri !== undefined && object.host_uri !== null) {
            message.hostUri = object.host_uri;
        }
        message.attributes = object.attributes?.map(e => Attribute.fromAmino(e)) || [];
        if (object.info !== undefined && object.info !== null) {
            message.info = ProviderInfo.fromAmino(object.info);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.host_uri = message.hostUri ?? "";
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toAmino(e) : undefined);
        }
        else {
            obj.attributes = message.attributes;
        }
        obj.info = message.info ? ProviderInfo.toAmino(message.info) : ProviderInfo.toAmino(ProviderInfo.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return Provider.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/provider/provider",
            value: Provider.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Provider.decode(message.value);
    },
    toProto(message) {
        return Provider.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.provider.v1beta1.Provider",
            value: Provider.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Attribute.registerTypeUrl();
        ProviderInfo.registerTypeUrl();
    }
};
