import { TelescopeGeneratedType } from "../../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgCreateProvider, MsgUpdateProvider, MsgDeleteProvider } from "./provider";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        createProvider(value: MsgCreateProvider): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        updateProvider(value: MsgUpdateProvider): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        deleteProvider(value: MsgDeleteProvider): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        createProvider(value: MsgCreateProvider): {
            typeUrl: string;
            value: MsgCreateProvider;
        };
        updateProvider(value: MsgUpdateProvider): {
            typeUrl: string;
            value: MsgUpdateProvider;
        };
        deleteProvider(value: MsgDeleteProvider): {
            typeUrl: string;
            value: MsgDeleteProvider;
        };
    };
    toJSON: {
        createProvider(value: MsgCreateProvider): {
            typeUrl: string;
            value: {
                owner: string;
                hostUri: string;
                attributes: {
                    key: string;
                    value: string;
                }[];
                info: {
                    email: string;
                    website: string;
                };
            };
        };
        updateProvider(value: MsgUpdateProvider): {
            typeUrl: string;
            value: {
                owner: string;
                hostUri: string;
                attributes: {
                    key: string;
                    value: string;
                }[];
                info: {
                    email: string;
                    website: string;
                };
            };
        };
        deleteProvider(value: MsgDeleteProvider): {
            typeUrl: string;
            value: {
                owner: string;
            };
        };
    };
    fromJSON: {
        createProvider(value: any): {
            typeUrl: string;
            value: MsgCreateProvider;
        };
        updateProvider(value: any): {
            typeUrl: string;
            value: MsgUpdateProvider;
        };
        deleteProvider(value: any): {
            typeUrl: string;
            value: MsgDeleteProvider;
        };
    };
    fromPartial: {
        createProvider(value: MsgCreateProvider): {
            typeUrl: string;
            value: MsgCreateProvider;
        };
        updateProvider(value: MsgUpdateProvider): {
            typeUrl: string;
            value: MsgUpdateProvider;
        };
        deleteProvider(value: MsgDeleteProvider): {
            typeUrl: string;
            value: MsgDeleteProvider;
        };
    };
};
