import { Provider } from "./provider";
import { BinaryReader, BinaryWriter } from "../../../binary";
export const protobufPackage = "akash.provider.v1beta2";
function createBaseGenesisState() {
    return {
        providers: []
    };
}
export const GenesisState = {
    typeUrl: "/akash.provider.v1beta2.GenesisState",
    aminoType: "akash/provider/v1beta2/genesis-state",
    is(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Array.isArray(o.providers) && (!o.providers.length || Provider.is(o.providers[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Array.isArray(o.providers) && (!o.providers.length || Provider.isSDK(o.providers[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Array.isArray(o.providers) && (!o.providers.length || Provider.isAmino(o.providers[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.providers) {
            Provider.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGenesisState();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.providers.push(Provider.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGenesisState();
        if (Array.isArray(object?.providers))
            obj.providers = object.providers.map((e) => Provider.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.providers) {
            obj.providers = message.providers.map(e => e ? Provider.toJSON(e) : undefined);
        }
        else {
            obj.providers = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGenesisState();
        message.providers = object.providers?.map(e => Provider.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            providers: Array.isArray(object?.providers) ? object.providers.map((e) => Provider.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            providers: Array.isArray(object?.providers) ? object.providers.map((e) => Provider.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.providers) {
            obj.providers = message.providers.map(e => e ? Provider.toSDK(e) : undefined);
        }
        else {
            obj.providers = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGenesisState();
        message.providers = object.providers?.map(e => Provider.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.providers) {
            obj.providers = message.providers.map(e => e ? Provider.toAmino(e) : undefined);
        }
        else {
            obj.providers = message.providers;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return GenesisState.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/provider/v1beta2/genesis-state",
            value: GenesisState.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return GenesisState.decode(message.value);
    },
    toProto(message) {
        return GenesisState.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.provider.v1beta2.GenesisState",
            value: GenesisState.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Provider.registerTypeUrl();
    }
};
