import { Attribute, AttributeAmino, AttributeSDKType } from "../../base/v1beta2/attribute";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.provider.v1beta2";
/** ProviderInfo */
export interface ProviderInfo {
    email: string;
    website: string;
}
export interface ProviderInfoProtoMsg {
    typeUrl: "/akash.provider.v1beta2.ProviderInfo";
    value: Uint8Array;
}
/** ProviderInfo */
export interface ProviderInfoAmino {
    email: string;
    website: string;
}
export interface ProviderInfoAminoMsg {
    type: "akash/provider/v1beta2/provider-info";
    value: ProviderInfoAmino;
}
/** ProviderInfo */
export interface ProviderInfoSDKType {
    email: string;
    website: string;
}
/** MsgCreateProvider defines an SDK message for creating a provider */
export interface MsgCreateProvider {
    owner: string;
    hostUri: string;
    attributes: Attribute[];
    info: ProviderInfo;
}
export interface MsgCreateProviderProtoMsg {
    typeUrl: "/akash.provider.v1beta2.MsgCreateProvider";
    value: Uint8Array;
}
/** MsgCreateProvider defines an SDK message for creating a provider */
export interface MsgCreateProviderAmino {
    owner: string;
    host_uri: string;
    attributes: AttributeAmino[];
    info: ProviderInfoAmino;
}
export interface MsgCreateProviderAminoMsg {
    type: "akash/provider/v1beta2/testonly-create-provider";
    value: MsgCreateProviderAmino;
}
/** MsgCreateProvider defines an SDK message for creating a provider */
export interface MsgCreateProviderSDKType {
    owner: string;
    host_uri: string;
    attributes: AttributeSDKType[];
    info: ProviderInfoSDKType;
}
/** MsgCreateProviderResponse defines the Msg/CreateProvider response type. */
export interface MsgCreateProviderResponse {
}
export interface MsgCreateProviderResponseProtoMsg {
    typeUrl: "/akash.provider.v1beta2.MsgCreateProviderResponse";
    value: Uint8Array;
}
/** MsgCreateProviderResponse defines the Msg/CreateProvider response type. */
export interface MsgCreateProviderResponseAmino {
}
export interface MsgCreateProviderResponseAminoMsg {
    type: "akash/provider/v1beta2/testonly-create-provider-response";
    value: MsgCreateProviderResponseAmino;
}
/** MsgCreateProviderResponse defines the Msg/CreateProvider response type. */
export interface MsgCreateProviderResponseSDKType {
}
/** MsgUpdateProvider defines an SDK message for updating a provider */
export interface MsgUpdateProvider {
    owner: string;
    hostUri: string;
    attributes: Attribute[];
    info: ProviderInfo;
}
export interface MsgUpdateProviderProtoMsg {
    typeUrl: "/akash.provider.v1beta2.MsgUpdateProvider";
    value: Uint8Array;
}
/** MsgUpdateProvider defines an SDK message for updating a provider */
export interface MsgUpdateProviderAmino {
    owner: string;
    host_uri: string;
    attributes: AttributeAmino[];
    info: ProviderInfoAmino;
}
export interface MsgUpdateProviderAminoMsg {
    type: "akash/provider/v1beta2/testonly-update-provider";
    value: MsgUpdateProviderAmino;
}
/** MsgUpdateProvider defines an SDK message for updating a provider */
export interface MsgUpdateProviderSDKType {
    owner: string;
    host_uri: string;
    attributes: AttributeSDKType[];
    info: ProviderInfoSDKType;
}
/** MsgUpdateProviderResponse defines the Msg/UpdateProvider response type. */
export interface MsgUpdateProviderResponse {
}
export interface MsgUpdateProviderResponseProtoMsg {
    typeUrl: "/akash.provider.v1beta2.MsgUpdateProviderResponse";
    value: Uint8Array;
}
/** MsgUpdateProviderResponse defines the Msg/UpdateProvider response type. */
export interface MsgUpdateProviderResponseAmino {
}
export interface MsgUpdateProviderResponseAminoMsg {
    type: "akash/provider/v1beta2/testonly-update-provider-response";
    value: MsgUpdateProviderResponseAmino;
}
/** MsgUpdateProviderResponse defines the Msg/UpdateProvider response type. */
export interface MsgUpdateProviderResponseSDKType {
}
/** MsgDeleteProvider defines an SDK message for deleting a provider */
export interface MsgDeleteProvider {
    owner: string;
}
export interface MsgDeleteProviderProtoMsg {
    typeUrl: "/akash.provider.v1beta2.MsgDeleteProvider";
    value: Uint8Array;
}
/** MsgDeleteProvider defines an SDK message for deleting a provider */
export interface MsgDeleteProviderAmino {
    owner: string;
}
export interface MsgDeleteProviderAminoMsg {
    type: "akash/provider/v1beta2/testonly-delete-provider";
    value: MsgDeleteProviderAmino;
}
/** MsgDeleteProvider defines an SDK message for deleting a provider */
export interface MsgDeleteProviderSDKType {
    owner: string;
}
/** MsgDeleteProviderResponse defines the Msg/DeleteProvider response type. */
export interface MsgDeleteProviderResponse {
}
export interface MsgDeleteProviderResponseProtoMsg {
    typeUrl: "/akash.provider.v1beta2.MsgDeleteProviderResponse";
    value: Uint8Array;
}
/** MsgDeleteProviderResponse defines the Msg/DeleteProvider response type. */
export interface MsgDeleteProviderResponseAmino {
}
export interface MsgDeleteProviderResponseAminoMsg {
    type: "akash/provider/v1beta2/testonly-delete-provider-response";
    value: MsgDeleteProviderResponseAmino;
}
/** MsgDeleteProviderResponse defines the Msg/DeleteProvider response type. */
export interface MsgDeleteProviderResponseSDKType {
}
/** Provider stores owner and host details */
export interface Provider {
    owner: string;
    hostUri: string;
    attributes: Attribute[];
    info: ProviderInfo;
}
export interface ProviderProtoMsg {
    typeUrl: "/akash.provider.v1beta2.Provider";
    value: Uint8Array;
}
/** Provider stores owner and host details */
export interface ProviderAmino {
    owner: string;
    host_uri: string;
    attributes: AttributeAmino[];
    info: ProviderInfoAmino;
}
export interface ProviderAminoMsg {
    type: "akash/provider/v1beta2/provider";
    value: ProviderAmino;
}
/** Provider stores owner and host details */
export interface ProviderSDKType {
    owner: string;
    host_uri: string;
    attributes: AttributeSDKType[];
    info: ProviderInfoSDKType;
}
export declare const ProviderInfo: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is ProviderInfo;
    isSDK(o: any): o is ProviderInfoSDKType;
    isAmino(o: any): o is ProviderInfoAmino;
    encode(message: ProviderInfo, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ProviderInfo;
    fromJSON(object: any): ProviderInfo;
    toJSON(message: ProviderInfo): JsonSafe<ProviderInfo>;
    fromPartial<I extends Exact<DeepPartial<ProviderInfo>, I>>(object: I): ProviderInfo;
    fromSDK(object: ProviderInfoSDKType): ProviderInfo;
    fromSDKJSON(object: any): ProviderInfoSDKType;
    toSDK(message: ProviderInfo): ProviderInfoSDKType;
    fromAmino(object: ProviderInfoAmino): ProviderInfo;
    toAmino(message: ProviderInfo): ProviderInfoAmino;
    fromAminoMsg(object: ProviderInfoAminoMsg): ProviderInfo;
    toAminoMsg(message: ProviderInfo): ProviderInfoAminoMsg;
    fromProtoMsg(message: ProviderInfoProtoMsg): ProviderInfo;
    toProto(message: ProviderInfo): Uint8Array;
    toProtoMsg(message: ProviderInfo): ProviderInfoProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgCreateProvider: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCreateProvider;
    isSDK(o: any): o is MsgCreateProviderSDKType;
    isAmino(o: any): o is MsgCreateProviderAmino;
    encode(message: MsgCreateProvider, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCreateProvider;
    fromJSON(object: any): MsgCreateProvider;
    toJSON(message: MsgCreateProvider): JsonSafe<MsgCreateProvider>;
    fromPartial<I extends Exact<DeepPartial<MsgCreateProvider>, I>>(object: I): MsgCreateProvider;
    fromSDK(object: MsgCreateProviderSDKType): MsgCreateProvider;
    fromSDKJSON(object: any): MsgCreateProviderSDKType;
    toSDK(message: MsgCreateProvider): MsgCreateProviderSDKType;
    fromAmino(object: MsgCreateProviderAmino): MsgCreateProvider;
    toAmino(message: MsgCreateProvider): MsgCreateProviderAmino;
    fromAminoMsg(object: MsgCreateProviderAminoMsg): MsgCreateProvider;
    toAminoMsg(message: MsgCreateProvider): MsgCreateProviderAminoMsg;
    fromProtoMsg(message: MsgCreateProviderProtoMsg): MsgCreateProvider;
    toProto(message: MsgCreateProvider): Uint8Array;
    toProtoMsg(message: MsgCreateProvider): MsgCreateProviderProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgCreateProviderResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgCreateProviderResponse;
    isSDK(o: any): o is MsgCreateProviderResponseSDKType;
    isAmino(o: any): o is MsgCreateProviderResponseAmino;
    encode(_: MsgCreateProviderResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCreateProviderResponse;
    fromJSON(_: any): MsgCreateProviderResponse;
    toJSON(_: MsgCreateProviderResponse): JsonSafe<MsgCreateProviderResponse>;
    fromPartial<I extends Exact<DeepPartial<MsgCreateProviderResponse>, I>>(_: I): MsgCreateProviderResponse;
    fromSDK(_: MsgCreateProviderResponseSDKType): MsgCreateProviderResponse;
    fromSDKJSON(_: any): MsgCreateProviderResponseSDKType;
    toSDK(_: MsgCreateProviderResponse): MsgCreateProviderResponseSDKType;
    fromAmino(_: MsgCreateProviderResponseAmino): MsgCreateProviderResponse;
    toAmino(_: MsgCreateProviderResponse): MsgCreateProviderResponseAmino;
    fromAminoMsg(object: MsgCreateProviderResponseAminoMsg): MsgCreateProviderResponse;
    toAminoMsg(message: MsgCreateProviderResponse): MsgCreateProviderResponseAminoMsg;
    fromProtoMsg(message: MsgCreateProviderResponseProtoMsg): MsgCreateProviderResponse;
    toProto(message: MsgCreateProviderResponse): Uint8Array;
    toProtoMsg(message: MsgCreateProviderResponse): MsgCreateProviderResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgUpdateProvider: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgUpdateProvider;
    isSDK(o: any): o is MsgUpdateProviderSDKType;
    isAmino(o: any): o is MsgUpdateProviderAmino;
    encode(message: MsgUpdateProvider, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgUpdateProvider;
    fromJSON(object: any): MsgUpdateProvider;
    toJSON(message: MsgUpdateProvider): JsonSafe<MsgUpdateProvider>;
    fromPartial<I extends Exact<DeepPartial<MsgUpdateProvider>, I>>(object: I): MsgUpdateProvider;
    fromSDK(object: MsgUpdateProviderSDKType): MsgUpdateProvider;
    fromSDKJSON(object: any): MsgUpdateProviderSDKType;
    toSDK(message: MsgUpdateProvider): MsgUpdateProviderSDKType;
    fromAmino(object: MsgUpdateProviderAmino): MsgUpdateProvider;
    toAmino(message: MsgUpdateProvider): MsgUpdateProviderAmino;
    fromAminoMsg(object: MsgUpdateProviderAminoMsg): MsgUpdateProvider;
    toAminoMsg(message: MsgUpdateProvider): MsgUpdateProviderAminoMsg;
    fromProtoMsg(message: MsgUpdateProviderProtoMsg): MsgUpdateProvider;
    toProto(message: MsgUpdateProvider): Uint8Array;
    toProtoMsg(message: MsgUpdateProvider): MsgUpdateProviderProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgUpdateProviderResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgUpdateProviderResponse;
    isSDK(o: any): o is MsgUpdateProviderResponseSDKType;
    isAmino(o: any): o is MsgUpdateProviderResponseAmino;
    encode(_: MsgUpdateProviderResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgUpdateProviderResponse;
    fromJSON(_: any): MsgUpdateProviderResponse;
    toJSON(_: MsgUpdateProviderResponse): JsonSafe<MsgUpdateProviderResponse>;
    fromPartial<I extends Exact<DeepPartial<MsgUpdateProviderResponse>, I>>(_: I): MsgUpdateProviderResponse;
    fromSDK(_: MsgUpdateProviderResponseSDKType): MsgUpdateProviderResponse;
    fromSDKJSON(_: any): MsgUpdateProviderResponseSDKType;
    toSDK(_: MsgUpdateProviderResponse): MsgUpdateProviderResponseSDKType;
    fromAmino(_: MsgUpdateProviderResponseAmino): MsgUpdateProviderResponse;
    toAmino(_: MsgUpdateProviderResponse): MsgUpdateProviderResponseAmino;
    fromAminoMsg(object: MsgUpdateProviderResponseAminoMsg): MsgUpdateProviderResponse;
    toAminoMsg(message: MsgUpdateProviderResponse): MsgUpdateProviderResponseAminoMsg;
    fromProtoMsg(message: MsgUpdateProviderResponseProtoMsg): MsgUpdateProviderResponse;
    toProto(message: MsgUpdateProviderResponse): Uint8Array;
    toProtoMsg(message: MsgUpdateProviderResponse): MsgUpdateProviderResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgDeleteProvider: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgDeleteProvider;
    isSDK(o: any): o is MsgDeleteProviderSDKType;
    isAmino(o: any): o is MsgDeleteProviderAmino;
    encode(message: MsgDeleteProvider, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgDeleteProvider;
    fromJSON(object: any): MsgDeleteProvider;
    toJSON(message: MsgDeleteProvider): JsonSafe<MsgDeleteProvider>;
    fromPartial<I extends Exact<DeepPartial<MsgDeleteProvider>, I>>(object: I): MsgDeleteProvider;
    fromSDK(object: MsgDeleteProviderSDKType): MsgDeleteProvider;
    fromSDKJSON(object: any): MsgDeleteProviderSDKType;
    toSDK(message: MsgDeleteProvider): MsgDeleteProviderSDKType;
    fromAmino(object: MsgDeleteProviderAmino): MsgDeleteProvider;
    toAmino(message: MsgDeleteProvider): MsgDeleteProviderAmino;
    fromAminoMsg(object: MsgDeleteProviderAminoMsg): MsgDeleteProvider;
    toAminoMsg(message: MsgDeleteProvider): MsgDeleteProviderAminoMsg;
    fromProtoMsg(message: MsgDeleteProviderProtoMsg): MsgDeleteProvider;
    toProto(message: MsgDeleteProvider): Uint8Array;
    toProtoMsg(message: MsgDeleteProvider): MsgDeleteProviderProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgDeleteProviderResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is MsgDeleteProviderResponse;
    isSDK(o: any): o is MsgDeleteProviderResponseSDKType;
    isAmino(o: any): o is MsgDeleteProviderResponseAmino;
    encode(_: MsgDeleteProviderResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgDeleteProviderResponse;
    fromJSON(_: any): MsgDeleteProviderResponse;
    toJSON(_: MsgDeleteProviderResponse): JsonSafe<MsgDeleteProviderResponse>;
    fromPartial<I extends Exact<DeepPartial<MsgDeleteProviderResponse>, I>>(_: I): MsgDeleteProviderResponse;
    fromSDK(_: MsgDeleteProviderResponseSDKType): MsgDeleteProviderResponse;
    fromSDKJSON(_: any): MsgDeleteProviderResponseSDKType;
    toSDK(_: MsgDeleteProviderResponse): MsgDeleteProviderResponseSDKType;
    fromAmino(_: MsgDeleteProviderResponseAmino): MsgDeleteProviderResponse;
    toAmino(_: MsgDeleteProviderResponse): MsgDeleteProviderResponseAmino;
    fromAminoMsg(object: MsgDeleteProviderResponseAminoMsg): MsgDeleteProviderResponse;
    toAminoMsg(message: MsgDeleteProviderResponse): MsgDeleteProviderResponseAminoMsg;
    fromProtoMsg(message: MsgDeleteProviderResponseProtoMsg): MsgDeleteProviderResponse;
    toProto(message: MsgDeleteProviderResponse): Uint8Array;
    toProtoMsg(message: MsgDeleteProviderResponse): MsgDeleteProviderResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const Provider: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is Provider;
    isSDK(o: any): o is ProviderSDKType;
    isAmino(o: any): o is ProviderAmino;
    encode(message: Provider, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Provider;
    fromJSON(object: any): Provider;
    toJSON(message: Provider): JsonSafe<Provider>;
    fromPartial<I extends Exact<DeepPartial<Provider>, I>>(object: I): Provider;
    fromSDK(object: ProviderSDKType): Provider;
    fromSDKJSON(object: any): ProviderSDKType;
    toSDK(message: Provider): ProviderSDKType;
    fromAmino(object: ProviderAmino): Provider;
    toAmino(message: Provider): ProviderAmino;
    fromAminoMsg(object: ProviderAminoMsg): Provider;
    toAminoMsg(message: Provider): ProviderAminoMsg;
    fromProtoMsg(message: ProviderProtoMsg): Provider;
    toProto(message: Provider): Uint8Array;
    toProtoMsg(message: Provider): ProviderProtoMsg;
    registerTypeUrl(): void;
};
