import { MsgCreateProvider, MsgUpdateProvider, MsgDeleteProvider } from "./provider";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* CreateProvider defines a method that creates a provider given the proper inputs */
    createProvider = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgCreateProvider.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* UpdateProvider defines a method that updates a provider given the proper inputs */
    updateProvider = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgUpdateProvider.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* DeleteProvider defines a method that deletes a provider given the proper inputs */
    deleteProvider = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgDeleteProvider.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
