import { PageRequest, PageRequestAmino, PageRequestSDKType, PageResponse, PageResponseAmino, PageResponseSDKType } from "../../../cosmos/base/query/v1beta1/pagination";
import { Provider, ProviderAmino, ProviderSDKType } from "./provider";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial, Exact } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "akash.provider.v1beta2";
/** QueryProvidersRequest is request type for the Query/Providers RPC method */
export interface QueryProvidersRequest {
    pagination?: PageRequest;
}
export interface QueryProvidersRequestProtoMsg {
    typeUrl: "/akash.provider.v1beta2.QueryProvidersRequest";
    value: Uint8Array;
}
/** QueryProvidersRequest is request type for the Query/Providers RPC method */
export interface QueryProvidersRequestAmino {
    pagination?: PageRequestAmino;
}
export interface QueryProvidersRequestAminoMsg {
    type: "akash/provider/v1beta2/query-providers-request";
    value: QueryProvidersRequestAmino;
}
/** QueryProvidersRequest is request type for the Query/Providers RPC method */
export interface QueryProvidersRequestSDKType {
    pagination?: PageRequestSDKType;
}
/** QueryProvidersResponse is response type for the Query/Providers RPC method */
export interface QueryProvidersResponse {
    providers: Provider[];
    pagination?: PageResponse;
}
export interface QueryProvidersResponseProtoMsg {
    typeUrl: "/akash.provider.v1beta2.QueryProvidersResponse";
    value: Uint8Array;
}
/** QueryProvidersResponse is response type for the Query/Providers RPC method */
export interface QueryProvidersResponseAmino {
    providers?: ProviderAmino[];
    pagination?: PageResponseAmino;
}
export interface QueryProvidersResponseAminoMsg {
    type: "akash/provider/v1beta2/query-providers-response";
    value: QueryProvidersResponseAmino;
}
/** QueryProvidersResponse is response type for the Query/Providers RPC method */
export interface QueryProvidersResponseSDKType {
    providers: ProviderSDKType[];
    pagination?: PageResponseSDKType;
}
/** QueryProviderRequest is request type for the Query/Provider RPC method */
export interface QueryProviderRequest {
    owner: string;
}
export interface QueryProviderRequestProtoMsg {
    typeUrl: "/akash.provider.v1beta2.QueryProviderRequest";
    value: Uint8Array;
}
/** QueryProviderRequest is request type for the Query/Provider RPC method */
export interface QueryProviderRequestAmino {
    owner?: string;
}
export interface QueryProviderRequestAminoMsg {
    type: "akash/provider/v1beta2/query-provider-request";
    value: QueryProviderRequestAmino;
}
/** QueryProviderRequest is request type for the Query/Provider RPC method */
export interface QueryProviderRequestSDKType {
    owner: string;
}
/** QueryProviderResponse is response type for the Query/Provider RPC method */
export interface QueryProviderResponse {
    provider: Provider;
}
export interface QueryProviderResponseProtoMsg {
    typeUrl: "/akash.provider.v1beta2.QueryProviderResponse";
    value: Uint8Array;
}
/** QueryProviderResponse is response type for the Query/Provider RPC method */
export interface QueryProviderResponseAmino {
    provider?: ProviderAmino;
}
export interface QueryProviderResponseAminoMsg {
    type: "akash/provider/v1beta2/query-provider-response";
    value: QueryProviderResponseAmino;
}
/** QueryProviderResponse is response type for the Query/Provider RPC method */
export interface QueryProviderResponseSDKType {
    provider: ProviderSDKType;
}
export declare const QueryProvidersRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryProvidersRequest;
    isSDK(o: any): o is QueryProvidersRequestSDKType;
    isAmino(o: any): o is QueryProvidersRequestAmino;
    encode(message: QueryProvidersRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryProvidersRequest;
    fromJSON(object: any): QueryProvidersRequest;
    toJSON(message: QueryProvidersRequest): JsonSafe<QueryProvidersRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryProvidersRequest>, I>>(object: I): QueryProvidersRequest;
    fromSDK(object: QueryProvidersRequestSDKType): QueryProvidersRequest;
    fromSDKJSON(object: any): QueryProvidersRequestSDKType;
    toSDK(message: QueryProvidersRequest): QueryProvidersRequestSDKType;
    fromAmino(object: QueryProvidersRequestAmino): QueryProvidersRequest;
    toAmino(message: QueryProvidersRequest): QueryProvidersRequestAmino;
    fromAminoMsg(object: QueryProvidersRequestAminoMsg): QueryProvidersRequest;
    toAminoMsg(message: QueryProvidersRequest): QueryProvidersRequestAminoMsg;
    fromProtoMsg(message: QueryProvidersRequestProtoMsg): QueryProvidersRequest;
    toProto(message: QueryProvidersRequest): Uint8Array;
    toProtoMsg(message: QueryProvidersRequest): QueryProvidersRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryProvidersResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryProvidersResponse;
    isSDK(o: any): o is QueryProvidersResponseSDKType;
    isAmino(o: any): o is QueryProvidersResponseAmino;
    encode(message: QueryProvidersResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryProvidersResponse;
    fromJSON(object: any): QueryProvidersResponse;
    toJSON(message: QueryProvidersResponse): JsonSafe<QueryProvidersResponse>;
    fromPartial<I extends Exact<DeepPartial<QueryProvidersResponse>, I>>(object: I): QueryProvidersResponse;
    fromSDK(object: QueryProvidersResponseSDKType): QueryProvidersResponse;
    fromSDKJSON(object: any): QueryProvidersResponseSDKType;
    toSDK(message: QueryProvidersResponse): QueryProvidersResponseSDKType;
    fromAmino(object: QueryProvidersResponseAmino): QueryProvidersResponse;
    toAmino(message: QueryProvidersResponse): QueryProvidersResponseAmino;
    fromAminoMsg(object: QueryProvidersResponseAminoMsg): QueryProvidersResponse;
    toAminoMsg(message: QueryProvidersResponse): QueryProvidersResponseAminoMsg;
    fromProtoMsg(message: QueryProvidersResponseProtoMsg): QueryProvidersResponse;
    toProto(message: QueryProvidersResponse): Uint8Array;
    toProtoMsg(message: QueryProvidersResponse): QueryProvidersResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryProviderRequest: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryProviderRequest;
    isSDK(o: any): o is QueryProviderRequestSDKType;
    isAmino(o: any): o is QueryProviderRequestAmino;
    encode(message: QueryProviderRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryProviderRequest;
    fromJSON(object: any): QueryProviderRequest;
    toJSON(message: QueryProviderRequest): JsonSafe<QueryProviderRequest>;
    fromPartial<I extends Exact<DeepPartial<QueryProviderRequest>, I>>(object: I): QueryProviderRequest;
    fromSDK(object: QueryProviderRequestSDKType): QueryProviderRequest;
    fromSDKJSON(object: any): QueryProviderRequestSDKType;
    toSDK(message: QueryProviderRequest): QueryProviderRequestSDKType;
    fromAmino(object: QueryProviderRequestAmino): QueryProviderRequest;
    toAmino(message: QueryProviderRequest): QueryProviderRequestAmino;
    fromAminoMsg(object: QueryProviderRequestAminoMsg): QueryProviderRequest;
    toAminoMsg(message: QueryProviderRequest): QueryProviderRequestAminoMsg;
    fromProtoMsg(message: QueryProviderRequestProtoMsg): QueryProviderRequest;
    toProto(message: QueryProviderRequest): Uint8Array;
    toProtoMsg(message: QueryProviderRequest): QueryProviderRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryProviderResponse: {
    typeUrl: string;
    aminoType: string;
    is(o: any): o is QueryProviderResponse;
    isSDK(o: any): o is QueryProviderResponseSDKType;
    isAmino(o: any): o is QueryProviderResponseAmino;
    encode(message: QueryProviderResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryProviderResponse;
    fromJSON(object: any): QueryProviderResponse;
    toJSON(message: QueryProviderResponse): JsonSafe<QueryProviderResponse>;
    fromPartial<I extends Exact<DeepPartial<QueryProviderResponse>, I>>(object: I): QueryProviderResponse;
    fromSDK(object: QueryProviderResponseSDKType): QueryProviderResponse;
    fromSDKJSON(object: any): QueryProviderResponseSDKType;
    toSDK(message: QueryProviderResponse): QueryProviderResponseSDKType;
    fromAmino(object: QueryProviderResponseAmino): QueryProviderResponse;
    toAmino(message: QueryProviderResponse): QueryProviderResponseAmino;
    fromAminoMsg(object: QueryProviderResponseAminoMsg): QueryProviderResponse;
    toAminoMsg(message: QueryProviderResponse): QueryProviderResponseAminoMsg;
    fromProtoMsg(message: QueryProviderResponseProtoMsg): QueryProviderResponse;
    toProto(message: QueryProviderResponse): Uint8Array;
    toProtoMsg(message: QueryProviderResponse): QueryProviderResponseProtoMsg;
    registerTypeUrl(): void;
};
