import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import { Provider } from "./provider";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.provider.v1beta2";
function createBaseQueryProvidersRequest() {
    return {
        pagination: undefined
    };
}
export const QueryProvidersRequest = {
    typeUrl: "/akash.provider.v1beta2.QueryProvidersRequest",
    aminoType: "akash/provider/v1beta2/query-providers-request",
    is(o) {
        return o && o.$typeUrl === QueryProvidersRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryProvidersRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryProvidersRequest.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryProvidersRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryProvidersRequest();
        if (isSet(object.pagination))
            obj.pagination = PageRequest.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryProvidersRequest();
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            pagination: object.pagination ? PageRequest.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            pagination: isSet(object.pagination) ? PageRequest.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryProvidersRequest();
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.pagination = message.pagination ? PageRequest.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryProvidersRequest.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/provider/v1beta2/query-providers-request",
            value: QueryProvidersRequest.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return QueryProvidersRequest.decode(message.value);
    },
    toProto(message) {
        return QueryProvidersRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.provider.v1beta2.QueryProvidersRequest",
            value: QueryProvidersRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        PageRequest.registerTypeUrl();
    }
};
function createBaseQueryProvidersResponse() {
    return {
        providers: [],
        pagination: undefined
    };
}
export const QueryProvidersResponse = {
    typeUrl: "/akash.provider.v1beta2.QueryProvidersResponse",
    aminoType: "akash/provider/v1beta2/query-providers-response",
    is(o) {
        return o && (o.$typeUrl === QueryProvidersResponse.typeUrl || Array.isArray(o.providers) && (!o.providers.length || Provider.is(o.providers[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryProvidersResponse.typeUrl || Array.isArray(o.providers) && (!o.providers.length || Provider.isSDK(o.providers[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryProvidersResponse.typeUrl || Array.isArray(o.providers) && (!o.providers.length || Provider.isAmino(o.providers[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.providers) {
            Provider.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryProvidersResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.providers.push(Provider.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryProvidersResponse();
        if (Array.isArray(object?.providers))
            obj.providers = object.providers.map((e) => Provider.fromJSON(e));
        if (isSet(object.pagination))
            obj.pagination = PageResponse.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.providers) {
            obj.providers = message.providers.map(e => e ? Provider.toJSON(e) : undefined);
        }
        else {
            obj.providers = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryProvidersResponse();
        message.providers = object.providers?.map(e => Provider.fromPartial(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            providers: Array.isArray(object?.providers) ? object.providers.map((e) => Provider.fromSDK(e)) : [],
            pagination: object.pagination ? PageResponse.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            providers: Array.isArray(object?.providers) ? object.providers.map((e) => Provider.fromSDKJSON(e)) : [],
            pagination: isSet(object.pagination) ? PageResponse.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.providers) {
            obj.providers = message.providers.map(e => e ? Provider.toSDK(e) : undefined);
        }
        else {
            obj.providers = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryProvidersResponse();
        message.providers = object.providers?.map(e => Provider.fromAmino(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.providers) {
            obj.providers = message.providers.map(e => e ? Provider.toAmino(e) : undefined);
        }
        else {
            obj.providers = message.providers;
        }
        obj.pagination = message.pagination ? PageResponse.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryProvidersResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/provider/v1beta2/query-providers-response",
            value: QueryProvidersResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return QueryProvidersResponse.decode(message.value);
    },
    toProto(message) {
        return QueryProvidersResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.provider.v1beta2.QueryProvidersResponse",
            value: QueryProvidersResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Provider.registerTypeUrl();
        PageResponse.registerTypeUrl();
    }
};
function createBaseQueryProviderRequest() {
    return {
        owner: ""
    };
}
export const QueryProviderRequest = {
    typeUrl: "/akash.provider.v1beta2.QueryProviderRequest",
    aminoType: "akash/provider/v1beta2/query-provider-request",
    is(o) {
        return o && (o.$typeUrl === QueryProviderRequest.typeUrl || typeof o.owner === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryProviderRequest.typeUrl || typeof o.owner === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryProviderRequest.typeUrl || typeof o.owner === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryProviderRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryProviderRequest();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryProviderRequest();
        message.owner = object.owner ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryProviderRequest();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner === "" ? undefined : message.owner;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryProviderRequest.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/provider/v1beta2/query-provider-request",
            value: QueryProviderRequest.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return QueryProviderRequest.decode(message.value);
    },
    toProto(message) {
        return QueryProviderRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.provider.v1beta2.QueryProviderRequest",
            value: QueryProviderRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryProviderResponse() {
    return {
        provider: Provider.fromPartial({})
    };
}
export const QueryProviderResponse = {
    typeUrl: "/akash.provider.v1beta2.QueryProviderResponse",
    aminoType: "akash/provider/v1beta2/query-provider-response",
    is(o) {
        return o && (o.$typeUrl === QueryProviderResponse.typeUrl || Provider.is(o.provider));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryProviderResponse.typeUrl || Provider.isSDK(o.provider));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryProviderResponse.typeUrl || Provider.isAmino(o.provider));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.provider !== undefined) {
            Provider.encode(message.provider, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryProviderResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.provider = Provider.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryProviderResponse();
        if (isSet(object.provider))
            obj.provider = Provider.fromJSON(object.provider);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.provider !== undefined && (obj.provider = message.provider ? Provider.toJSON(message.provider) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryProviderResponse();
        if (object.provider !== undefined && object.provider !== null) {
            message.provider = Provider.fromPartial(object.provider);
        }
        return message;
    },
    fromSDK(object) {
        return {
            provider: object.provider ? Provider.fromSDK(object.provider) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            provider: isSet(object.provider) ? Provider.fromSDKJSON(object.provider) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.provider !== undefined && (obj.provider = message.provider ? Provider.toSDK(message.provider) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryProviderResponse();
        if (object.provider !== undefined && object.provider !== null) {
            message.provider = Provider.fromAmino(object.provider);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.provider = message.provider ? Provider.toAmino(message.provider) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryProviderResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/provider/v1beta2/query-provider-response",
            value: QueryProviderResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return QueryProviderResponse.decode(message.value);
    },
    toProto(message) {
        return QueryProviderResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.provider.v1beta2.QueryProviderResponse",
            value: QueryProviderResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Provider.registerTypeUrl();
    }
};
