import { PageRequest } from "../../../cosmos/base/query/v1beta1/pagination";
import { setPaginationParams } from "../../../helpers";
import { QueryProvidersResponse, QueryProviderResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* Providers queries providers */
    providers = async (params = {
        pagination: PageRequest.fromPartial({})
    }) => {
        const options = {
            params: {}
        };
        if (typeof params?.pagination !== "undefined") {
            setPaginationParams(options, params.pagination);
        }
        const endpoint = `akash/provider/v1beta2/providers`;
        return QueryProvidersResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
    /* Provider queries provider details */
    provider = async (params) => {
        const endpoint = `akash/provider/v1beta2/providers/${params.owner}`;
        return QueryProviderResponse.fromSDKJSON(await this.req.get(endpoint));
    };
}
