import { TxRpc } from "../../../types";
import { QueryProvidersRequest, QueryProvidersResponse, QueryProviderRequest, QueryProviderResponse } from "./query";
/** Query defines the gRPC querier service */
export interface Query {
    /** Providers queries providers */
    providers(request?: QueryProvidersRequest): Promise<QueryProvidersResponse>;
    /** Provider queries provider details */
    provider(request: QueryProviderRequest): Promise<QueryProviderResponse>;
}
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    constructor(rpc: TxRpc);
    providers: (request?: QueryProvidersRequest) => Promise<QueryProvidersResponse>;
    provider: (request: QueryProviderRequest) => Promise<QueryProviderResponse>;
}
export declare const createClientImpl: (rpc: TxRpc) => QueryClientImpl;
