import { TelescopeGeneratedType } from "../../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgGrant, MsgExec, MsgRevoke } from "./tx";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        grant(value: MsgGrant): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        exec(value: MsgExec): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        revoke(value: MsgRevoke): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        grant(value: MsgGrant): {
            typeUrl: string;
            value: MsgGrant;
        };
        exec(value: MsgExec): {
            typeUrl: string;
            value: MsgExec;
        };
        revoke(value: MsgRevoke): {
            typeUrl: string;
            value: MsgRevoke;
        };
    };
    toJSON: {
        grant(value: MsgGrant): {
            typeUrl: string;
            value: {
                granter: string;
                grantee: string;
                grant: {
                    authorization?: {
                        $typeUrl?: "/google.protobuf.Any" | string;
                        typeUrl: string;
                        value: string;
                    } | {
                        $typeUrl?: "/akash.deployment.v1beta1.DepositDeploymentAuthorization";
                        spendLimit: {
                            denom: string;
                            amount: string;
                        };
                    } | {
                        $typeUrl?: "/akash.deployment.v1beta2.DepositDeploymentAuthorization";
                        spendLimit: {
                            denom: string;
                            amount: string;
                        };
                    } | {
                        $typeUrl?: "/cosmos.bank.v1beta1.SendAuthorization";
                        spendLimit: {
                            denom: string;
                            amount: string;
                        }[];
                    } | {
                        $typeUrl?: "/cosmos.staking.v1beta1.StakeAuthorization";
                        maxTokens?: {
                            denom: string;
                            amount: string;
                        };
                        allowList?: {
                            address: string[];
                        };
                        denyList?: {
                            address: string[];
                        };
                        authorizationType: import("../../staking/v1beta1/authz").AuthorizationType;
                    } | {
                        $typeUrl?: "/cosmos.authz.v1beta1.GenericAuthorization";
                        msg: string;
                    };
                    expiration?: string;
                };
            };
        };
        exec(value: MsgExec): {
            typeUrl: string;
            value: {
                grantee: string;
                msgs: {
                    $typeUrl?: "/google.protobuf.Any" | string;
                    typeUrl: string;
                    value: string;
                }[];
            };
        };
        revoke(value: MsgRevoke): {
            typeUrl: string;
            value: {
                granter: string;
                grantee: string;
                msgTypeUrl: string;
            };
        };
    };
    fromJSON: {
        grant(value: any): {
            typeUrl: string;
            value: MsgGrant;
        };
        exec(value: any): {
            typeUrl: string;
            value: MsgExec;
        };
        revoke(value: any): {
            typeUrl: string;
            value: MsgRevoke;
        };
    };
    fromPartial: {
        grant(value: MsgGrant): {
            typeUrl: string;
            value: MsgGrant;
        };
        exec(value: MsgExec): {
            typeUrl: string;
            value: MsgExec;
        };
        revoke(value: MsgRevoke): {
            typeUrl: string;
            value: MsgRevoke;
        };
    };
};
