import { buildQuery } from "../../../helper-func-types";
import { QueryBalanceRequest, QueryBalanceResponse, QueryAllBalancesRequest, QueryAllBalancesResponse, QuerySpendableBalancesRequest, QuerySpendableBalancesResponse, QueryTotalSupplyRequest, QueryTotalSupplyResponse, QuerySupplyOfRequest, QuerySupplyOfResponse, QueryParamsRequest, QueryParamsResponse, QueryDenomMetadataRequest, QueryDenomMetadataResponse, QueryDenomsMetadataRequest, QueryDenomsMetadataResponse, QueryDenomOwnersRequest, QueryDenomOwnersResponse } from "./query";
export const createGetBalance = (clientResolver) => buildQuery({
    encode: QueryBalanceRequest.encode,
    decode: QueryBalanceResponse.decode,
    service: "cosmos.bank.v1beta1.Query",
    method: "Balance",
    clientResolver,
    deps: [QueryBalanceRequest, QueryBalanceResponse]
});
export const createGetAllBalances = (clientResolver) => buildQuery({
    encode: QueryAllBalancesRequest.encode,
    decode: QueryAllBalancesResponse.decode,
    service: "cosmos.bank.v1beta1.Query",
    method: "AllBalances",
    clientResolver,
    deps: [QueryAllBalancesRequest, QueryAllBalancesResponse]
});
export const createGetSpendableBalances = (clientResolver) => buildQuery({
    encode: QuerySpendableBalancesRequest.encode,
    decode: QuerySpendableBalancesResponse.decode,
    service: "cosmos.bank.v1beta1.Query",
    method: "SpendableBalances",
    clientResolver,
    deps: [QuerySpendableBalancesRequest, QuerySpendableBalancesResponse]
});
export const createGetTotalSupply = (clientResolver) => buildQuery({
    encode: QueryTotalSupplyRequest.encode,
    decode: QueryTotalSupplyResponse.decode,
    service: "cosmos.bank.v1beta1.Query",
    method: "TotalSupply",
    clientResolver,
    deps: [QueryTotalSupplyRequest, QueryTotalSupplyResponse]
});
export const createGetSupplyOf = (clientResolver) => buildQuery({
    encode: QuerySupplyOfRequest.encode,
    decode: QuerySupplyOfResponse.decode,
    service: "cosmos.bank.v1beta1.Query",
    method: "SupplyOf",
    clientResolver,
    deps: [QuerySupplyOfRequest, QuerySupplyOfResponse]
});
export const createGetParams = (clientResolver) => buildQuery({
    encode: QueryParamsRequest.encode,
    decode: QueryParamsResponse.decode,
    service: "cosmos.bank.v1beta1.Query",
    method: "Params",
    clientResolver,
    deps: [QueryParamsRequest, QueryParamsResponse]
});
export const createGetDenomMetadata = (clientResolver) => buildQuery({
    encode: QueryDenomMetadataRequest.encode,
    decode: QueryDenomMetadataResponse.decode,
    service: "cosmos.bank.v1beta1.Query",
    method: "DenomMetadata",
    clientResolver,
    deps: [QueryDenomMetadataRequest, QueryDenomMetadataResponse]
});
export const createGetDenomsMetadata = (clientResolver) => buildQuery({
    encode: QueryDenomsMetadataRequest.encode,
    decode: QueryDenomsMetadataResponse.decode,
    service: "cosmos.bank.v1beta1.Query",
    method: "DenomsMetadata",
    clientResolver,
    deps: [QueryDenomsMetadataRequest, QueryDenomsMetadataResponse]
});
export const createGetDenomOwners = (clientResolver) => buildQuery({
    encode: QueryDenomOwnersRequest.encode,
    decode: QueryDenomOwnersResponse.decode,
    service: "cosmos.bank.v1beta1.Query",
    method: "DenomOwners",
    clientResolver,
    deps: [QueryDenomOwnersRequest, QueryDenomOwnersResponse]
});
