import { TelescopeGeneratedType } from "../../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgSend, MsgMultiSend } from "./tx";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        send(value: MsgSend): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        multiSend(value: MsgMultiSend): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        send(value: MsgSend): {
            typeUrl: string;
            value: MsgSend;
        };
        multiSend(value: MsgMultiSend): {
            typeUrl: string;
            value: MsgMultiSend;
        };
    };
    toJSON: {
        send(value: MsgSend): {
            typeUrl: string;
            value: {
                fromAddress: string;
                toAddress: string;
                amount: {
                    denom: string;
                    amount: string;
                }[];
            };
        };
        multiSend(value: MsgMultiSend): {
            typeUrl: string;
            value: {
                inputs: {
                    address: string;
                    coins: {
                        denom: string;
                        amount: string;
                    }[];
                }[];
                outputs: {
                    address: string;
                    coins: {
                        denom: string;
                        amount: string;
                    }[];
                }[];
            };
        };
    };
    fromJSON: {
        send(value: any): {
            typeUrl: string;
            value: MsgSend;
        };
        multiSend(value: any): {
            typeUrl: string;
            value: MsgMultiSend;
        };
    };
    fromPartial: {
        send(value: MsgSend): {
            typeUrl: string;
            value: MsgSend;
        };
        multiSend(value: MsgMultiSend): {
            typeUrl: string;
            value: MsgMultiSend;
        };
    };
};
