import { TxRpc } from "../../../../types";
import { ListAllInterfacesRequest, ListAllInterfacesResponse, ListImplementationsRequest, ListImplementationsResponse } from "./reflection";
/** ReflectionService defines a service for interface reflection. */
export interface ReflectionService {
    /**
     * ListAllInterfaces lists all the interfaces registered in the interface
     * registry.
     */
    listAllInterfaces(request?: ListAllInterfacesRequest): Promise<ListAllInterfacesResponse>;
    /**
     * ListImplementations list all the concrete types that implement a given
     * interface.
     */
    listImplementations(request: ListImplementationsRequest): Promise<ListImplementationsResponse>;
}
export declare class ReflectionServiceClientImpl implements ReflectionService {
    private readonly rpc;
    constructor(rpc: TxRpc);
    listAllInterfaces: (request?: ListAllInterfacesRequest) => Promise<ListAllInterfacesResponse>;
    listImplementations: (request: ListImplementationsRequest) => Promise<ListImplementationsResponse>;
}
export declare const createClientImpl: (rpc: TxRpc) => ReflectionServiceClientImpl;
