import { BinaryReader } from "../../../../binary";
import { ListAllInterfacesRequest, ListAllInterfacesResponse, ListImplementationsRequest, ListImplementationsResponse } from "./reflection";
export class ReflectionServiceClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* ListAllInterfaces lists all the interfaces registered in the interface
     registry. */
    listAllInterfaces = async (request = {}) => {
        const data = ListAllInterfacesRequest.encode(request).finish();
        const promise = this.rpc.request("cosmos.base.reflection.v1beta1.ReflectionService", "ListAllInterfaces", data);
        return promise.then(data => ListAllInterfacesResponse.decode(new BinaryReader(data)));
    };
    /* ListImplementations list all the concrete types that implement a given
     interface. */
    listImplementations = async (request) => {
        const data = ListImplementationsRequest.encode(request).finish();
        const promise = this.rpc.request("cosmos.base.reflection.v1beta1.ReflectionService", "ListImplementations", data);
        return promise.then(data => ListImplementationsResponse.decode(new BinaryReader(data)));
    };
}
export const createClientImpl = (rpc) => {
    return new ReflectionServiceClientImpl(rpc);
};
