import { Coin } from "../../base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "cosmos.crisis.v1beta1";
function createBaseGenesisState() {
    return {
        constantFee: Coin.fromPartial({})
    };
}
export const GenesisState = {
    typeUrl: "/cosmos.crisis.v1beta1.GenesisState",
    aminoType: "cosmos-sdk/GenesisState",
    is(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Coin.is(o.constantFee));
    },
    isSDK(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Coin.isSDK(o.constant_fee));
    },
    isAmino(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Coin.isAmino(o.constant_fee));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.constantFee !== undefined) {
            Coin.encode(message.constantFee, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGenesisState();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 3:
                    message.constantFee = Coin.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGenesisState();
        if (isSet(object.constantFee))
            obj.constantFee = Coin.fromJSON(object.constantFee);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.constantFee !== undefined && (obj.constantFee = message.constantFee ? Coin.toJSON(message.constantFee) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGenesisState();
        if (object.constantFee !== undefined && object.constantFee !== null) {
            message.constantFee = Coin.fromPartial(object.constantFee);
        }
        return message;
    },
    fromSDK(object) {
        return {
            constantFee: object.constant_fee ? Coin.fromSDK(object.constant_fee) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            constant_fee: isSet(object.constant_fee) ? Coin.fromSDKJSON(object.constant_fee) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.constantFee !== undefined && (obj.constant_fee = message.constantFee ? Coin.toSDK(message.constantFee) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGenesisState();
        if (object.constant_fee !== undefined && object.constant_fee !== null) {
            message.constantFee = Coin.fromAmino(object.constant_fee);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.constant_fee = message.constantFee ? Coin.toAmino(message.constantFee) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return GenesisState.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "cosmos-sdk/GenesisState",
            value: GenesisState.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return GenesisState.decode(message.value);
    },
    toProto(message) {
        return GenesisState.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/cosmos.crisis.v1beta1.GenesisState",
            value: GenesisState.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Coin.registerTypeUrl();
    }
};
