import { PageRequest } from "../../base/query/v1beta1/pagination";
import { setPaginationParams } from "../../../helpers";
import { QueryEvidenceResponse, QueryAllEvidenceResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* Evidence queries evidence based on evidence hash. */
    evidence = async (params) => {
        const endpoint = `cosmos/evidence/v1beta1/evidence/${params.evidenceHash}`;
        return QueryEvidenceResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* AllEvidence queries all evidence. */
    allEvidence = async (params = {
        pagination: PageRequest.fromPartial({})
    }) => {
        const options = {
            params: {}
        };
        if (typeof params?.pagination !== "undefined") {
            setPaginationParams(options, params.pagination);
        }
        const endpoint = `cosmos/evidence/v1beta1/evidence`;
        return QueryAllEvidenceResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
}
