import { setPaginationParams } from "../../../helpers";
import { QueryAllowanceResponse, QueryAllowancesResponse, QueryAllowancesByGranterResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* Allowance returns fee granted to the grantee by the granter. */
    allowance = async (params) => {
        const endpoint = `cosmos/feegrant/v1beta1/allowance/${params.granter}/${params.grantee}`;
        return QueryAllowanceResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* Allowances returns all the grants for address. */
    allowances = async (params) => {
        const options = {
            params: {}
        };
        if (typeof params?.pagination !== "undefined") {
            setPaginationParams(options, params.pagination);
        }
        const endpoint = `cosmos/feegrant/v1beta1/allowances/${params.grantee}`;
        return QueryAllowancesResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
    /* AllowancesByGranter returns all the grants given by an address
     Since v0.46 */
    allowancesByGranter = async (params) => {
        const options = {
            params: {}
        };
        if (typeof params?.pagination !== "undefined") {
            setPaginationParams(options, params.pagination);
        }
        const endpoint = `cosmos/feegrant/v1beta1/issued/${params.granter}`;
        return QueryAllowancesByGranterResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
}
