import { TelescopeGeneratedType } from "../../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgGrantAllowance, MsgRevokeAllowance } from "./tx";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        grantAllowance(value: MsgGrantAllowance): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        revokeAllowance(value: MsgRevokeAllowance): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        grantAllowance(value: MsgGrantAllowance): {
            typeUrl: string;
            value: MsgGrantAllowance;
        };
        revokeAllowance(value: MsgRevokeAllowance): {
            typeUrl: string;
            value: MsgRevokeAllowance;
        };
    };
    toJSON: {
        grantAllowance(value: MsgGrantAllowance): {
            typeUrl: string;
            value: {
                granter: string;
                grantee: string;
                allowance?: {
                    $typeUrl?: "/google.protobuf.Any" | string;
                    typeUrl: string;
                    value: string;
                } | {
                    $typeUrl?: "/cosmos.feegrant.v1beta1.BasicAllowance";
                    spendLimit: {
                        denom: string;
                        amount: string;
                    }[];
                    expiration?: string;
                } | {
                    $typeUrl?: "/cosmos.feegrant.v1beta1.PeriodicAllowance";
                    basic: {
                        $typeUrl?: "/cosmos.feegrant.v1beta1.BasicAllowance";
                        spendLimit: {
                            denom: string;
                            amount: string;
                        }[];
                        expiration?: string;
                    };
                    period: {
                        seconds: string;
                        nanos: number;
                    };
                    periodSpendLimit: {
                        denom: string;
                        amount: string;
                    }[];
                    periodCanSpend: {
                        denom: string;
                        amount: string;
                    }[];
                    periodReset: string;
                } | {
                    $typeUrl?: "/cosmos.feegrant.v1beta1.AllowedMsgAllowance";
                    allowance?: {
                        $typeUrl?: "/google.protobuf.Any" | string;
                        typeUrl: string;
                        value: string;
                    } | {
                        $typeUrl?: "/cosmos.feegrant.v1beta1.BasicAllowance";
                        spendLimit: {
                            denom: string;
                            amount: string;
                        }[];
                        expiration?: string;
                    } | {
                        $typeUrl?: "/cosmos.feegrant.v1beta1.PeriodicAllowance";
                        basic: {
                            $typeUrl?: "/cosmos.feegrant.v1beta1.BasicAllowance";
                            spendLimit: {
                                denom: string;
                                amount: string;
                            }[];
                            expiration?: string;
                        };
                        period: {
                            seconds: string;
                            nanos: number;
                        };
                        periodSpendLimit: {
                            denom: string;
                            amount: string;
                        }[];
                        periodCanSpend: {
                            denom: string;
                            amount: string;
                        }[];
                        periodReset: string;
                    } | /*elided*/ any;
                    allowedMessages: string[];
                };
            };
        };
        revokeAllowance(value: MsgRevokeAllowance): {
            typeUrl: string;
            value: {
                granter: string;
                grantee: string;
            };
        };
    };
    fromJSON: {
        grantAllowance(value: any): {
            typeUrl: string;
            value: MsgGrantAllowance;
        };
        revokeAllowance(value: any): {
            typeUrl: string;
            value: MsgRevokeAllowance;
        };
    };
    fromPartial: {
        grantAllowance(value: MsgGrantAllowance): {
            typeUrl: string;
            value: MsgGrantAllowance;
        };
        revokeAllowance(value: MsgRevokeAllowance): {
            typeUrl: string;
            value: MsgRevokeAllowance;
        };
    };
};
