import { MsgGrantAllowance, MsgRevokeAllowance } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* GrantAllowance grants fee allowance to the grantee on the granter's
     account with the provided expiration time. */
    grantAllowance = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgGrantAllowance.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* RevokeAllowance revokes any fee allowance of granter's account that
     has been granted to the grantee. */
    revokeAllowance = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgRevokeAllowance.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
