import { buildQuery } from "../../../helper-func-types";
import { QueryProposalRequest, QueryProposalResponse, QueryProposalsRequest, QueryProposalsResponse, QueryVoteRequest, QueryVoteResponse, QueryVotesRequest, QueryVotesResponse, QueryParamsRequest, QueryParamsResponse, QueryDepositRequest, QueryDepositResponse, QueryDepositsRequest, QueryDepositsResponse, QueryTallyResultRequest, QueryTallyResultResponse } from "./query";
export const createGetProposal = (clientResolver) => buildQuery({
    encode: QueryProposalRequest.encode,
    decode: QueryProposalResponse.decode,
    service: "cosmos.gov.v1beta1.Query",
    method: "Proposal",
    clientResolver,
    deps: [QueryProposalRequest, QueryProposalResponse]
});
export const createGetProposals = (clientResolver) => buildQuery({
    encode: QueryProposalsRequest.encode,
    decode: QueryProposalsResponse.decode,
    service: "cosmos.gov.v1beta1.Query",
    method: "Proposals",
    clientResolver,
    deps: [QueryProposalsRequest, QueryProposalsResponse]
});
export const buildHelperVote = (clientResolver) => buildQuery({
    encode: QueryVoteRequest.encode,
    decode: QueryVoteResponse.decode,
    service: "cosmos.gov.v1beta1.Query",
    method: "Vote",
    clientResolver,
    deps: [QueryVoteRequest, QueryVoteResponse]
});
export const buildHelperVotes = (clientResolver) => buildQuery({
    encode: QueryVotesRequest.encode,
    decode: QueryVotesResponse.decode,
    service: "cosmos.gov.v1beta1.Query",
    method: "Votes",
    clientResolver,
    deps: [QueryVotesRequest, QueryVotesResponse]
});
export const createGetParams = (clientResolver) => buildQuery({
    encode: QueryParamsRequest.encode,
    decode: QueryParamsResponse.decode,
    service: "cosmos.gov.v1beta1.Query",
    method: "Params",
    clientResolver,
    deps: [QueryParamsRequest, QueryParamsResponse]
});
export const createCheckDeposit = (clientResolver) => buildQuery({
    encode: QueryDepositRequest.encode,
    decode: QueryDepositResponse.decode,
    service: "cosmos.gov.v1beta1.Query",
    method: "Deposit",
    clientResolver,
    deps: [QueryDepositRequest, QueryDepositResponse]
});
export const createGoOverDeposits = (clientResolver) => buildQuery({
    encode: QueryDepositsRequest.encode,
    decode: QueryDepositsResponse.decode,
    service: "cosmos.gov.v1beta1.Query",
    method: "Deposits",
    clientResolver,
    deps: [QueryDepositsRequest, QueryDepositsResponse]
});
export const createGetTallyResult = (clientResolver) => buildQuery({
    encode: QueryTallyResultRequest.encode,
    decode: QueryTallyResultResponse.decode,
    service: "cosmos.gov.v1beta1.Query",
    method: "TallyResult",
    clientResolver,
    deps: [QueryTallyResultRequest, QueryTallyResultResponse]
});
