import { buildUseQuery } from "../../../react-query";
import { createGetProposal, createGetProposals, buildHelperVote, buildHelperVotes, createGetParams, createCheckDeposit, createGoOverDeposits, createGetTallyResult } from "./query.rpc.func";
export const useGetProposal = buildUseQuery({
    builderQueryFn: createGetProposal,
    queryKeyPrefix: "ProposalQuery"
});
export const useGetProposals = buildUseQuery({
    builderQueryFn: createGetProposals,
    queryKeyPrefix: "ProposalsQuery"
});
export const useHelperVote = buildUseQuery({
    builderQueryFn: buildHelperVote,
    queryKeyPrefix: "VoteQuery"
});
export const useHelperVotes = buildUseQuery({
    builderQueryFn: buildHelperVotes,
    queryKeyPrefix: "VotesQuery"
});
export const useGetParams = buildUseQuery({
    builderQueryFn: createGetParams,
    queryKeyPrefix: "ParamsQuery"
});
export const useCheckDeposit = buildUseQuery({
    builderQueryFn: createCheckDeposit,
    queryKeyPrefix: "DepositQuery"
});
export const useGoOverDeposits = buildUseQuery({
    builderQueryFn: createGoOverDeposits,
    queryKeyPrefix: "DepositsQuery"
});
export const useGetTallyResult = buildUseQuery({
    builderQueryFn: createGetTallyResult,
    queryKeyPrefix: "TallyResultQuery"
});
