import { buildTx } from "../../../helper-func-types";
import { toEncoders, toConverters } from "@interchainjs/cosmos/utils";
import { MsgSubmitProposal, MsgVote, MsgVoteWeighted, MsgDeposit } from "./tx";
export const createSubmitProposal = (clientResolver) => buildTx({
    clientResolver,
    typeUrl: MsgSubmitProposal.typeUrl,
    encoders: toEncoders(MsgSubmitProposal),
    converters: toConverters(MsgSubmitProposal),
    deps: [MsgSubmitProposal]
});
export const buildHelperVote = (clientResolver) => buildTx({
    clientResolver,
    typeUrl: MsgVote.typeUrl,
    encoders: toEncoders(MsgVote),
    converters: toConverters(MsgVote),
    deps: [MsgVote]
});
export const constructLetsVoteWeighted = (clientResolver) => buildTx({
    clientResolver,
    typeUrl: MsgVoteWeighted.typeUrl,
    encoders: toEncoders(MsgVoteWeighted),
    converters: toConverters(MsgVoteWeighted),
    deps: [MsgVoteWeighted]
});
export const createToDeposit = (clientResolver) => buildTx({
    clientResolver,
    typeUrl: MsgDeposit.typeUrl,
    encoders: toEncoders(MsgDeposit),
    converters: toConverters(MsgDeposit),
    deps: [MsgDeposit]
});
