import { QueryParamsResponse, QueryInflationResponse, QueryAnnualProvisionsResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* Params returns the total set of minting parameters. */
    params = async (_params = {}) => {
        const endpoint = `cosmos/mint/v1beta1/params`;
        return QueryParamsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* Inflation returns the current minting inflation value. */
    inflation = async (_params = {}) => {
        const endpoint = `cosmos/mint/v1beta1/inflation`;
        return QueryInflationResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* AnnualProvisions current minting annual provisions value. */
    annualProvisions = async (_params = {}) => {
        const endpoint = `cosmos/mint/v1beta1/annual_provisions`;
        return QueryAnnualProvisionsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
}
