import { MsgUnjail } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* Unjail defines a method for unjailing a jailed validator, thus returning
     them into the bonded validator set, so they can begin receiving provisions
     and rewards again. */
    unjail = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgUnjail.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
