import { buildUseQuery } from "../../../react-query";
import { createGetValidators, createGetValidator, createGetValidatorDelegations, createGetValidatorUnbondingDelegations, createGetDelegation, createGetUnbondingDelegation, createGetDelegatorDelegations, createGetDelegatorUnbondingDelegations, createGetRedelegations, createGetDelegatorValidators, createGetDelegatorValidator, createGetHistoricalInfo, createGetPool, createGetParams } from "./query.rpc.func";
export const useGetValidators = buildUseQuery({
    builderQueryFn: createGetValidators,
    queryKeyPrefix: "ValidatorsQuery"
});
export const useGetValidator = buildUseQuery({
    builderQueryFn: createGetValidator,
    queryKeyPrefix: "ValidatorQuery"
});
export const useGetValidatorDelegations = buildUseQuery({
    builderQueryFn: createGetValidatorDelegations,
    queryKeyPrefix: "ValidatorDelegationsQuery"
});
export const useGetValidatorUnbondingDelegations = buildUseQuery({
    builderQueryFn: createGetValidatorUnbondingDelegations,
    queryKeyPrefix: "ValidatorUnbondingDelegationsQuery"
});
export const useGetDelegation = buildUseQuery({
    builderQueryFn: createGetDelegation,
    queryKeyPrefix: "DelegationQuery"
});
export const useGetUnbondingDelegation = buildUseQuery({
    builderQueryFn: createGetUnbondingDelegation,
    queryKeyPrefix: "UnbondingDelegationQuery"
});
export const useGetDelegatorDelegations = buildUseQuery({
    builderQueryFn: createGetDelegatorDelegations,
    queryKeyPrefix: "DelegatorDelegationsQuery"
});
export const useGetDelegatorUnbondingDelegations = buildUseQuery({
    builderQueryFn: createGetDelegatorUnbondingDelegations,
    queryKeyPrefix: "DelegatorUnbondingDelegationsQuery"
});
export const useGetRedelegations = buildUseQuery({
    builderQueryFn: createGetRedelegations,
    queryKeyPrefix: "RedelegationsQuery"
});
export const useGetDelegatorValidators = buildUseQuery({
    builderQueryFn: createGetDelegatorValidators,
    queryKeyPrefix: "DelegatorValidatorsQuery"
});
export const useGetDelegatorValidator = buildUseQuery({
    builderQueryFn: createGetDelegatorValidator,
    queryKeyPrefix: "DelegatorValidatorQuery"
});
export const useGetHistoricalInfo = buildUseQuery({
    builderQueryFn: createGetHistoricalInfo,
    queryKeyPrefix: "HistoricalInfoQuery"
});
export const useGetPool = buildUseQuery({
    builderQueryFn: createGetPool,
    queryKeyPrefix: "PoolQuery"
});
export const useGetParams = buildUseQuery({
    builderQueryFn: createGetParams,
    queryKeyPrefix: "ParamsQuery"
});
