import * as _147 from "./wasm/v1/genesis";
import * as _148 from "./wasm/v1/ibc";
import * as _149 from "./wasm/v1/proposal";
import * as _150 from "./wasm/v1/query";
import * as _151 from "./wasm/v1/tx";
import * as _152 from "./wasm/v1/types";
import * as _441 from "./wasm/v1/query.lcd";
import * as _442 from "./wasm/v1/query.rpc.Query";
import * as _443 from "./wasm/v1/tx.rpc.msg";
export declare namespace cosmwasm {
    namespace wasm {
        const v1: {
            MsgClientImpl: typeof _443.MsgClientImpl;
            createClientImpl: (rpc: import("..").TxRpc) => _443.MsgClientImpl;
            QueryClientImpl: typeof _442.QueryClientImpl;
            LCDQueryClient: typeof _441.LCDQueryClient;
            registry: ReadonlyArray<[string, import("..").TelescopeGeneratedType<any, any, any>]>;
            load: (protoRegistry: import("@cosmjs/proto-signing").Registry) => void;
            MessageComposer: {
                encoded: {
                    storeCode(value: _151.MsgStoreCode): {
                        typeUrl: string;
                        value: Uint8Array<ArrayBufferLike>;
                    };
                    instantiateContract(value: _151.MsgInstantiateContract): {
                        typeUrl: string;
                        value: Uint8Array<ArrayBufferLike>;
                    };
                    executeContract(value: _151.MsgExecuteContract): {
                        typeUrl: string;
                        value: Uint8Array<ArrayBufferLike>;
                    };
                    migrateContract(value: _151.MsgMigrateContract): {
                        typeUrl: string;
                        value: Uint8Array<ArrayBufferLike>;
                    };
                    updateAdmin(value: _151.MsgUpdateAdmin): {
                        typeUrl: string;
                        value: Uint8Array<ArrayBufferLike>;
                    };
                    clearAdmin(value: _151.MsgClearAdmin): {
                        typeUrl: string;
                        value: Uint8Array<ArrayBufferLike>;
                    };
                };
                withTypeUrl: {
                    storeCode(value: _151.MsgStoreCode): {
                        typeUrl: string;
                        value: _151.MsgStoreCode;
                    };
                    instantiateContract(value: _151.MsgInstantiateContract): {
                        typeUrl: string;
                        value: _151.MsgInstantiateContract;
                    };
                    executeContract(value: _151.MsgExecuteContract): {
                        typeUrl: string;
                        value: _151.MsgExecuteContract;
                    };
                    migrateContract(value: _151.MsgMigrateContract): {
                        typeUrl: string;
                        value: _151.MsgMigrateContract;
                    };
                    updateAdmin(value: _151.MsgUpdateAdmin): {
                        typeUrl: string;
                        value: _151.MsgUpdateAdmin;
                    };
                    clearAdmin(value: _151.MsgClearAdmin): {
                        typeUrl: string;
                        value: _151.MsgClearAdmin;
                    };
                };
                toJSON: {
                    storeCode(value: _151.MsgStoreCode): {
                        typeUrl: string;
                        value: {
                            sender: string;
                            wasmByteCode: string;
                            instantiatePermission?: {
                                permission: _152.AccessType;
                                address: string;
                            };
                        };
                    };
                    instantiateContract(value: _151.MsgInstantiateContract): {
                        typeUrl: string;
                        value: {
                            sender: string;
                            admin: string;
                            codeId: string;
                            label: string;
                            msg: string;
                            funds: {
                                denom: string;
                                amount: string;
                            }[];
                        };
                    };
                    executeContract(value: _151.MsgExecuteContract): {
                        typeUrl: string;
                        value: {
                            sender: string;
                            contract: string;
                            msg: string;
                            funds: {
                                denom: string;
                                amount: string;
                            }[];
                        };
                    };
                    migrateContract(value: _151.MsgMigrateContract): {
                        typeUrl: string;
                        value: {
                            sender: string;
                            contract: string;
                            codeId: string;
                            msg: string;
                        };
                    };
                    updateAdmin(value: _151.MsgUpdateAdmin): {
                        typeUrl: string;
                        value: {
                            sender: string;
                            newAdmin: string;
                            contract: string;
                        };
                    };
                    clearAdmin(value: _151.MsgClearAdmin): {
                        typeUrl: string;
                        value: {
                            sender: string;
                            contract: string;
                        };
                    };
                };
                fromJSON: {
                    storeCode(value: any): {
                        typeUrl: string;
                        value: _151.MsgStoreCode;
                    };
                    instantiateContract(value: any): {
                        typeUrl: string;
                        value: _151.MsgInstantiateContract;
                    };
                    executeContract(value: any): {
                        typeUrl: string;
                        value: _151.MsgExecuteContract;
                    };
                    migrateContract(value: any): {
                        typeUrl: string;
                        value: _151.MsgMigrateContract;
                    };
                    updateAdmin(value: any): {
                        typeUrl: string;
                        value: _151.MsgUpdateAdmin;
                    };
                    clearAdmin(value: any): {
                        typeUrl: string;
                        value: _151.MsgClearAdmin;
                    };
                };
                fromPartial: {
                    storeCode(value: _151.MsgStoreCode): {
                        typeUrl: string;
                        value: _151.MsgStoreCode;
                    };
                    instantiateContract(value: _151.MsgInstantiateContract): {
                        typeUrl: string;
                        value: _151.MsgInstantiateContract;
                    };
                    executeContract(value: _151.MsgExecuteContract): {
                        typeUrl: string;
                        value: _151.MsgExecuteContract;
                    };
                    migrateContract(value: _151.MsgMigrateContract): {
                        typeUrl: string;
                        value: _151.MsgMigrateContract;
                    };
                    updateAdmin(value: _151.MsgUpdateAdmin): {
                        typeUrl: string;
                        value: _151.MsgUpdateAdmin;
                    };
                    clearAdmin(value: _151.MsgClearAdmin): {
                        typeUrl: string;
                        value: _151.MsgClearAdmin;
                    };
                };
            };
            AminoConverter: {
                "/cosmwasm.wasm.v1.MsgStoreCode": {
                    aminoType: string;
                    toAmino: (message: _151.MsgStoreCode) => _151.MsgStoreCodeAmino;
                    fromAmino: (object: _151.MsgStoreCodeAmino) => _151.MsgStoreCode;
                };
                "/cosmwasm.wasm.v1.MsgInstantiateContract": {
                    aminoType: string;
                    toAmino: (message: _151.MsgInstantiateContract) => _151.MsgInstantiateContractAmino;
                    fromAmino: (object: _151.MsgInstantiateContractAmino) => _151.MsgInstantiateContract;
                };
                "/cosmwasm.wasm.v1.MsgExecuteContract": {
                    aminoType: string;
                    toAmino: (message: _151.MsgExecuteContract) => _151.MsgExecuteContractAmino;
                    fromAmino: (object: _151.MsgExecuteContractAmino) => _151.MsgExecuteContract;
                };
                "/cosmwasm.wasm.v1.MsgMigrateContract": {
                    aminoType: string;
                    toAmino: (message: _151.MsgMigrateContract) => _151.MsgMigrateContractAmino;
                    fromAmino: (object: _151.MsgMigrateContractAmino) => _151.MsgMigrateContract;
                };
                "/cosmwasm.wasm.v1.MsgUpdateAdmin": {
                    aminoType: string;
                    toAmino: (message: _151.MsgUpdateAdmin) => _151.MsgUpdateAdminAmino;
                    fromAmino: (object: _151.MsgUpdateAdminAmino) => _151.MsgUpdateAdmin;
                };
                "/cosmwasm.wasm.v1.MsgClearAdmin": {
                    aminoType: string;
                    toAmino: (message: _151.MsgClearAdmin) => _151.MsgClearAdminAmino;
                    fromAmino: (object: _151.MsgClearAdminAmino) => _151.MsgClearAdmin;
                };
            };
            accessTypeFromJSON(object: any): _152.AccessType;
            accessTypeToJSON(object: _152.AccessType): string;
            contractCodeHistoryOperationTypeFromJSON(object: any): _152.ContractCodeHistoryOperationType;
            contractCodeHistoryOperationTypeToJSON(object: _152.ContractCodeHistoryOperationType): string;
            protobufPackage: "cosmwasm.wasm.v1";
            AccessType: typeof _152.AccessType;
            AccessTypeSDKType: typeof _152.AccessType;
            AccessTypeAmino: typeof _152.AccessType;
            ContractCodeHistoryOperationType: typeof _152.ContractCodeHistoryOperationType;
            ContractCodeHistoryOperationTypeSDKType: typeof _152.ContractCodeHistoryOperationType;
            ContractCodeHistoryOperationTypeAmino: typeof _152.ContractCodeHistoryOperationType;
            AccessTypeParam: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _152.AccessTypeParam;
                isSDK(o: any): o is _152.AccessTypeParamSDKType;
                isAmino(o: any): o is _152.AccessTypeParamAmino;
                encode(message: _152.AccessTypeParam, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _152.AccessTypeParam;
                fromJSON(object: any): _152.AccessTypeParam;
                toJSON(message: _152.AccessTypeParam): import("..").JsonSafe<_152.AccessTypeParam>;
                fromPartial(object: import("../helpers").DeepPartial<_152.AccessTypeParam>): _152.AccessTypeParam;
                fromSDK(object: _152.AccessTypeParamSDKType): _152.AccessTypeParam;
                fromSDKJSON(object: any): _152.AccessTypeParamSDKType;
                toSDK(message: _152.AccessTypeParam): _152.AccessTypeParamSDKType;
                fromAmino(object: _152.AccessTypeParamAmino): _152.AccessTypeParam;
                toAmino(message: _152.AccessTypeParam): _152.AccessTypeParamAmino;
                fromAminoMsg(object: _152.AccessTypeParamAminoMsg): _152.AccessTypeParam;
                toAminoMsg(message: _152.AccessTypeParam): _152.AccessTypeParamAminoMsg;
                fromProtoMsg(message: _152.AccessTypeParamProtoMsg): _152.AccessTypeParam;
                toProto(message: _152.AccessTypeParam): Uint8Array;
                toProtoMsg(message: _152.AccessTypeParam): _152.AccessTypeParamProtoMsg;
                registerTypeUrl(): void;
            };
            AccessConfig: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _152.AccessConfig;
                isSDK(o: any): o is _152.AccessConfigSDKType;
                isAmino(o: any): o is _152.AccessConfigAmino;
                encode(message: _152.AccessConfig, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _152.AccessConfig;
                fromJSON(object: any): _152.AccessConfig;
                toJSON(message: _152.AccessConfig): import("..").JsonSafe<_152.AccessConfig>;
                fromPartial(object: import("../helpers").DeepPartial<_152.AccessConfig>): _152.AccessConfig;
                fromSDK(object: _152.AccessConfigSDKType): _152.AccessConfig;
                fromSDKJSON(object: any): _152.AccessConfigSDKType;
                toSDK(message: _152.AccessConfig): _152.AccessConfigSDKType;
                fromAmino(object: _152.AccessConfigAmino): _152.AccessConfig;
                toAmino(message: _152.AccessConfig): _152.AccessConfigAmino;
                fromAminoMsg(object: _152.AccessConfigAminoMsg): _152.AccessConfig;
                toAminoMsg(message: _152.AccessConfig): _152.AccessConfigAminoMsg;
                fromProtoMsg(message: _152.AccessConfigProtoMsg): _152.AccessConfig;
                toProto(message: _152.AccessConfig): Uint8Array;
                toProtoMsg(message: _152.AccessConfig): _152.AccessConfigProtoMsg;
                registerTypeUrl(): void;
            };
            Params: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _152.Params;
                isSDK(o: any): o is _152.ParamsSDKType;
                isAmino(o: any): o is _152.ParamsAmino;
                encode(message: _152.Params, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _152.Params;
                fromJSON(object: any): _152.Params;
                toJSON(message: _152.Params): import("..").JsonSafe<_152.Params>;
                fromPartial(object: import("../helpers").DeepPartial<_152.Params>): _152.Params;
                fromSDK(object: _152.ParamsSDKType): _152.Params;
                fromSDKJSON(object: any): _152.ParamsSDKType;
                toSDK(message: _152.Params): _152.ParamsSDKType;
                fromAmino(object: _152.ParamsAmino): _152.Params;
                toAmino(message: _152.Params): _152.ParamsAmino;
                fromAminoMsg(object: _152.ParamsAminoMsg): _152.Params;
                toAminoMsg(message: _152.Params): _152.ParamsAminoMsg;
                fromProtoMsg(message: _152.ParamsProtoMsg): _152.Params;
                toProto(message: _152.Params): Uint8Array;
                toProtoMsg(message: _152.Params): _152.ParamsProtoMsg;
                registerTypeUrl(): void;
            };
            CodeInfo: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _152.CodeInfo;
                isSDK(o: any): o is _152.CodeInfoSDKType;
                isAmino(o: any): o is _152.CodeInfoAmino;
                encode(message: _152.CodeInfo, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _152.CodeInfo;
                fromJSON(object: any): _152.CodeInfo;
                toJSON(message: _152.CodeInfo): import("..").JsonSafe<_152.CodeInfo>;
                fromPartial(object: import("../helpers").DeepPartial<_152.CodeInfo>): _152.CodeInfo;
                fromSDK(object: _152.CodeInfoSDKType): _152.CodeInfo;
                fromSDKJSON(object: any): _152.CodeInfoSDKType;
                toSDK(message: _152.CodeInfo): _152.CodeInfoSDKType;
                fromAmino(object: _152.CodeInfoAmino): _152.CodeInfo;
                toAmino(message: _152.CodeInfo): _152.CodeInfoAmino;
                fromAminoMsg(object: _152.CodeInfoAminoMsg): _152.CodeInfo;
                toAminoMsg(message: _152.CodeInfo): _152.CodeInfoAminoMsg;
                fromProtoMsg(message: _152.CodeInfoProtoMsg): _152.CodeInfo;
                toProto(message: _152.CodeInfo): Uint8Array;
                toProtoMsg(message: _152.CodeInfo): _152.CodeInfoProtoMsg;
                registerTypeUrl(): void;
            };
            ContractInfo: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _152.ContractInfo;
                isSDK(o: any): o is _152.ContractInfoSDKType;
                isAmino(o: any): o is _152.ContractInfoAmino;
                encode(message: _152.ContractInfo, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _152.ContractInfo;
                fromJSON(object: any): _152.ContractInfo;
                toJSON(message: _152.ContractInfo): import("..").JsonSafe<_152.ContractInfo>;
                fromPartial(object: import("../helpers").DeepPartial<_152.ContractInfo>): _152.ContractInfo;
                fromSDK(object: _152.ContractInfoSDKType): _152.ContractInfo;
                fromSDKJSON(object: any): _152.ContractInfoSDKType;
                toSDK(message: _152.ContractInfo): _152.ContractInfoSDKType;
                fromAmino(object: _152.ContractInfoAmino): _152.ContractInfo;
                toAmino(message: _152.ContractInfo): _152.ContractInfoAmino;
                fromAminoMsg(object: _152.ContractInfoAminoMsg): _152.ContractInfo;
                toAminoMsg(message: _152.ContractInfo): _152.ContractInfoAminoMsg;
                fromProtoMsg(message: _152.ContractInfoProtoMsg): _152.ContractInfo;
                toProto(message: _152.ContractInfo): Uint8Array;
                toProtoMsg(message: _152.ContractInfo): _152.ContractInfoProtoMsg;
                registerTypeUrl(): void;
            };
            ContractCodeHistoryEntry: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _152.ContractCodeHistoryEntry;
                isSDK(o: any): o is _152.ContractCodeHistoryEntrySDKType;
                isAmino(o: any): o is _152.ContractCodeHistoryEntryAmino;
                encode(message: _152.ContractCodeHistoryEntry, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _152.ContractCodeHistoryEntry;
                fromJSON(object: any): _152.ContractCodeHistoryEntry;
                toJSON(message: _152.ContractCodeHistoryEntry): import("..").JsonSafe<_152.ContractCodeHistoryEntry>;
                fromPartial(object: import("../helpers").DeepPartial<_152.ContractCodeHistoryEntry>): _152.ContractCodeHistoryEntry;
                fromSDK(object: _152.ContractCodeHistoryEntrySDKType): _152.ContractCodeHistoryEntry;
                fromSDKJSON(object: any): _152.ContractCodeHistoryEntrySDKType;
                toSDK(message: _152.ContractCodeHistoryEntry): _152.ContractCodeHistoryEntrySDKType;
                fromAmino(object: _152.ContractCodeHistoryEntryAmino): _152.ContractCodeHistoryEntry;
                toAmino(message: _152.ContractCodeHistoryEntry): _152.ContractCodeHistoryEntryAmino;
                fromAminoMsg(object: _152.ContractCodeHistoryEntryAminoMsg): _152.ContractCodeHistoryEntry;
                toAminoMsg(message: _152.ContractCodeHistoryEntry): _152.ContractCodeHistoryEntryAminoMsg;
                fromProtoMsg(message: _152.ContractCodeHistoryEntryProtoMsg): _152.ContractCodeHistoryEntry;
                toProto(message: _152.ContractCodeHistoryEntry): Uint8Array;
                toProtoMsg(message: _152.ContractCodeHistoryEntry): _152.ContractCodeHistoryEntryProtoMsg;
                registerTypeUrl(): void;
            };
            AbsoluteTxPosition: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _152.AbsoluteTxPosition;
                isSDK(o: any): o is _152.AbsoluteTxPositionSDKType;
                isAmino(o: any): o is _152.AbsoluteTxPositionAmino;
                encode(message: _152.AbsoluteTxPosition, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _152.AbsoluteTxPosition;
                fromJSON(object: any): _152.AbsoluteTxPosition;
                toJSON(message: _152.AbsoluteTxPosition): import("..").JsonSafe<_152.AbsoluteTxPosition>;
                fromPartial(object: import("../helpers").DeepPartial<_152.AbsoluteTxPosition>): _152.AbsoluteTxPosition;
                fromSDK(object: _152.AbsoluteTxPositionSDKType): _152.AbsoluteTxPosition;
                fromSDKJSON(object: any): _152.AbsoluteTxPositionSDKType;
                toSDK(message: _152.AbsoluteTxPosition): _152.AbsoluteTxPositionSDKType;
                fromAmino(object: _152.AbsoluteTxPositionAmino): _152.AbsoluteTxPosition;
                toAmino(message: _152.AbsoluteTxPosition): _152.AbsoluteTxPositionAmino;
                fromAminoMsg(object: _152.AbsoluteTxPositionAminoMsg): _152.AbsoluteTxPosition;
                toAminoMsg(message: _152.AbsoluteTxPosition): _152.AbsoluteTxPositionAminoMsg;
                fromProtoMsg(message: _152.AbsoluteTxPositionProtoMsg): _152.AbsoluteTxPosition;
                toProto(message: _152.AbsoluteTxPosition): Uint8Array;
                toProtoMsg(message: _152.AbsoluteTxPosition): _152.AbsoluteTxPositionProtoMsg;
                registerTypeUrl(): void;
            };
            Model: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _152.Model;
                isSDK(o: any): o is _152.ModelSDKType;
                isAmino(o: any): o is _152.ModelAmino;
                encode(message: _152.Model, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _152.Model;
                fromJSON(object: any): _152.Model;
                toJSON(message: _152.Model): import("..").JsonSafe<_152.Model>;
                fromPartial(object: import("../helpers").DeepPartial<_152.Model>): _152.Model;
                fromSDK(object: _152.ModelSDKType): _152.Model;
                fromSDKJSON(object: any): _152.ModelSDKType;
                toSDK(message: _152.Model): _152.ModelSDKType;
                fromAmino(object: _152.ModelAmino): _152.Model;
                toAmino(message: _152.Model): _152.ModelAmino;
                fromAminoMsg(object: _152.ModelAminoMsg): _152.Model;
                toAminoMsg(message: _152.Model): _152.ModelAminoMsg;
                fromProtoMsg(message: _152.ModelProtoMsg): _152.Model;
                toProto(message: _152.Model): Uint8Array;
                toProtoMsg(message: _152.Model): _152.ModelProtoMsg;
                registerTypeUrl(): void;
            };
            MsgStoreCode: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _151.MsgStoreCode;
                isSDK(o: any): o is _151.MsgStoreCodeSDKType;
                isAmino(o: any): o is _151.MsgStoreCodeAmino;
                encode(message: _151.MsgStoreCode, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _151.MsgStoreCode;
                fromJSON(object: any): _151.MsgStoreCode;
                toJSON(message: _151.MsgStoreCode): import("..").JsonSafe<_151.MsgStoreCode>;
                fromPartial(object: import("../helpers").DeepPartial<_151.MsgStoreCode>): _151.MsgStoreCode;
                fromSDK(object: _151.MsgStoreCodeSDKType): _151.MsgStoreCode;
                fromSDKJSON(object: any): _151.MsgStoreCodeSDKType;
                toSDK(message: _151.MsgStoreCode): _151.MsgStoreCodeSDKType;
                fromAmino(object: _151.MsgStoreCodeAmino): _151.MsgStoreCode;
                toAmino(message: _151.MsgStoreCode): _151.MsgStoreCodeAmino;
                fromAminoMsg(object: _151.MsgStoreCodeAminoMsg): _151.MsgStoreCode;
                toAminoMsg(message: _151.MsgStoreCode): _151.MsgStoreCodeAminoMsg;
                fromProtoMsg(message: _151.MsgStoreCodeProtoMsg): _151.MsgStoreCode;
                toProto(message: _151.MsgStoreCode): Uint8Array;
                toProtoMsg(message: _151.MsgStoreCode): _151.MsgStoreCodeProtoMsg;
                registerTypeUrl(): void;
            };
            MsgStoreCodeResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _151.MsgStoreCodeResponse;
                isSDK(o: any): o is _151.MsgStoreCodeResponseSDKType;
                isAmino(o: any): o is _151.MsgStoreCodeResponseAmino;
                encode(message: _151.MsgStoreCodeResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _151.MsgStoreCodeResponse;
                fromJSON(object: any): _151.MsgStoreCodeResponse;
                toJSON(message: _151.MsgStoreCodeResponse): import("..").JsonSafe<_151.MsgStoreCodeResponse>;
                fromPartial(object: import("../helpers").DeepPartial<_151.MsgStoreCodeResponse>): _151.MsgStoreCodeResponse;
                fromSDK(object: _151.MsgStoreCodeResponseSDKType): _151.MsgStoreCodeResponse;
                fromSDKJSON(object: any): _151.MsgStoreCodeResponseSDKType;
                toSDK(message: _151.MsgStoreCodeResponse): _151.MsgStoreCodeResponseSDKType;
                fromAmino(object: _151.MsgStoreCodeResponseAmino): _151.MsgStoreCodeResponse;
                toAmino(message: _151.MsgStoreCodeResponse): _151.MsgStoreCodeResponseAmino;
                fromAminoMsg(object: _151.MsgStoreCodeResponseAminoMsg): _151.MsgStoreCodeResponse;
                toAminoMsg(message: _151.MsgStoreCodeResponse): _151.MsgStoreCodeResponseAminoMsg;
                fromProtoMsg(message: _151.MsgStoreCodeResponseProtoMsg): _151.MsgStoreCodeResponse;
                toProto(message: _151.MsgStoreCodeResponse): Uint8Array;
                toProtoMsg(message: _151.MsgStoreCodeResponse): _151.MsgStoreCodeResponseProtoMsg;
                registerTypeUrl(): void;
            };
            MsgInstantiateContract: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _151.MsgInstantiateContract;
                isSDK(o: any): o is _151.MsgInstantiateContractSDKType;
                isAmino(o: any): o is _151.MsgInstantiateContractAmino;
                encode(message: _151.MsgInstantiateContract, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _151.MsgInstantiateContract;
                fromJSON(object: any): _151.MsgInstantiateContract;
                toJSON(message: _151.MsgInstantiateContract): import("..").JsonSafe<_151.MsgInstantiateContract>;
                fromPartial(object: import("../helpers").DeepPartial<_151.MsgInstantiateContract>): _151.MsgInstantiateContract;
                fromSDK(object: _151.MsgInstantiateContractSDKType): _151.MsgInstantiateContract;
                fromSDKJSON(object: any): _151.MsgInstantiateContractSDKType;
                toSDK(message: _151.MsgInstantiateContract): _151.MsgInstantiateContractSDKType;
                fromAmino(object: _151.MsgInstantiateContractAmino): _151.MsgInstantiateContract;
                toAmino(message: _151.MsgInstantiateContract): _151.MsgInstantiateContractAmino;
                fromAminoMsg(object: _151.MsgInstantiateContractAminoMsg): _151.MsgInstantiateContract;
                toAminoMsg(message: _151.MsgInstantiateContract): _151.MsgInstantiateContractAminoMsg;
                fromProtoMsg(message: _151.MsgInstantiateContractProtoMsg): _151.MsgInstantiateContract;
                toProto(message: _151.MsgInstantiateContract): Uint8Array;
                toProtoMsg(message: _151.MsgInstantiateContract): _151.MsgInstantiateContractProtoMsg;
                registerTypeUrl(): void;
            };
            MsgInstantiateContractResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _151.MsgInstantiateContractResponse;
                isSDK(o: any): o is _151.MsgInstantiateContractResponseSDKType;
                isAmino(o: any): o is _151.MsgInstantiateContractResponseAmino;
                encode(message: _151.MsgInstantiateContractResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _151.MsgInstantiateContractResponse;
                fromJSON(object: any): _151.MsgInstantiateContractResponse;
                toJSON(message: _151.MsgInstantiateContractResponse): import("..").JsonSafe<_151.MsgInstantiateContractResponse>;
                fromPartial(object: import("../helpers").DeepPartial<_151.MsgInstantiateContractResponse>): _151.MsgInstantiateContractResponse;
                fromSDK(object: _151.MsgInstantiateContractResponseSDKType): _151.MsgInstantiateContractResponse;
                fromSDKJSON(object: any): _151.MsgInstantiateContractResponseSDKType;
                toSDK(message: _151.MsgInstantiateContractResponse): _151.MsgInstantiateContractResponseSDKType;
                fromAmino(object: _151.MsgInstantiateContractResponseAmino): _151.MsgInstantiateContractResponse;
                toAmino(message: _151.MsgInstantiateContractResponse): _151.MsgInstantiateContractResponseAmino;
                fromAminoMsg(object: _151.MsgInstantiateContractResponseAminoMsg): _151.MsgInstantiateContractResponse;
                toAminoMsg(message: _151.MsgInstantiateContractResponse): _151.MsgInstantiateContractResponseAminoMsg;
                fromProtoMsg(message: _151.MsgInstantiateContractResponseProtoMsg): _151.MsgInstantiateContractResponse;
                toProto(message: _151.MsgInstantiateContractResponse): Uint8Array;
                toProtoMsg(message: _151.MsgInstantiateContractResponse): _151.MsgInstantiateContractResponseProtoMsg;
                registerTypeUrl(): void;
            };
            MsgExecuteContract: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _151.MsgExecuteContract;
                isSDK(o: any): o is _151.MsgExecuteContractSDKType;
                isAmino(o: any): o is _151.MsgExecuteContractAmino;
                encode(message: _151.MsgExecuteContract, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _151.MsgExecuteContract;
                fromJSON(object: any): _151.MsgExecuteContract;
                toJSON(message: _151.MsgExecuteContract): import("..").JsonSafe<_151.MsgExecuteContract>;
                fromPartial(object: import("../helpers").DeepPartial<_151.MsgExecuteContract>): _151.MsgExecuteContract;
                fromSDK(object: _151.MsgExecuteContractSDKType): _151.MsgExecuteContract;
                fromSDKJSON(object: any): _151.MsgExecuteContractSDKType;
                toSDK(message: _151.MsgExecuteContract): _151.MsgExecuteContractSDKType;
                fromAmino(object: _151.MsgExecuteContractAmino): _151.MsgExecuteContract;
                toAmino(message: _151.MsgExecuteContract): _151.MsgExecuteContractAmino;
                fromAminoMsg(object: _151.MsgExecuteContractAminoMsg): _151.MsgExecuteContract;
                toAminoMsg(message: _151.MsgExecuteContract): _151.MsgExecuteContractAminoMsg;
                fromProtoMsg(message: _151.MsgExecuteContractProtoMsg): _151.MsgExecuteContract;
                toProto(message: _151.MsgExecuteContract): Uint8Array;
                toProtoMsg(message: _151.MsgExecuteContract): _151.MsgExecuteContractProtoMsg;
                registerTypeUrl(): void;
            };
            MsgExecuteContractResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _151.MsgExecuteContractResponse;
                isSDK(o: any): o is _151.MsgExecuteContractResponseSDKType;
                isAmino(o: any): o is _151.MsgExecuteContractResponseAmino;
                encode(message: _151.MsgExecuteContractResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _151.MsgExecuteContractResponse;
                fromJSON(object: any): _151.MsgExecuteContractResponse;
                toJSON(message: _151.MsgExecuteContractResponse): import("..").JsonSafe<_151.MsgExecuteContractResponse>;
                fromPartial(object: import("../helpers").DeepPartial<_151.MsgExecuteContractResponse>): _151.MsgExecuteContractResponse;
                fromSDK(object: _151.MsgExecuteContractResponseSDKType): _151.MsgExecuteContractResponse;
                fromSDKJSON(object: any): _151.MsgExecuteContractResponseSDKType;
                toSDK(message: _151.MsgExecuteContractResponse): _151.MsgExecuteContractResponseSDKType;
                fromAmino(object: _151.MsgExecuteContractResponseAmino): _151.MsgExecuteContractResponse;
                toAmino(message: _151.MsgExecuteContractResponse): _151.MsgExecuteContractResponseAmino;
                fromAminoMsg(object: _151.MsgExecuteContractResponseAminoMsg): _151.MsgExecuteContractResponse;
                toAminoMsg(message: _151.MsgExecuteContractResponse): _151.MsgExecuteContractResponseAminoMsg;
                fromProtoMsg(message: _151.MsgExecuteContractResponseProtoMsg): _151.MsgExecuteContractResponse;
                toProto(message: _151.MsgExecuteContractResponse): Uint8Array;
                toProtoMsg(message: _151.MsgExecuteContractResponse): _151.MsgExecuteContractResponseProtoMsg;
                registerTypeUrl(): void;
            };
            MsgMigrateContract: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _151.MsgMigrateContract;
                isSDK(o: any): o is _151.MsgMigrateContractSDKType;
                isAmino(o: any): o is _151.MsgMigrateContractAmino;
                encode(message: _151.MsgMigrateContract, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _151.MsgMigrateContract;
                fromJSON(object: any): _151.MsgMigrateContract;
                toJSON(message: _151.MsgMigrateContract): import("..").JsonSafe<_151.MsgMigrateContract>;
                fromPartial(object: import("../helpers").DeepPartial<_151.MsgMigrateContract>): _151.MsgMigrateContract;
                fromSDK(object: _151.MsgMigrateContractSDKType): _151.MsgMigrateContract;
                fromSDKJSON(object: any): _151.MsgMigrateContractSDKType;
                toSDK(message: _151.MsgMigrateContract): _151.MsgMigrateContractSDKType;
                fromAmino(object: _151.MsgMigrateContractAmino): _151.MsgMigrateContract;
                toAmino(message: _151.MsgMigrateContract): _151.MsgMigrateContractAmino;
                fromAminoMsg(object: _151.MsgMigrateContractAminoMsg): _151.MsgMigrateContract;
                toAminoMsg(message: _151.MsgMigrateContract): _151.MsgMigrateContractAminoMsg;
                fromProtoMsg(message: _151.MsgMigrateContractProtoMsg): _151.MsgMigrateContract;
                toProto(message: _151.MsgMigrateContract): Uint8Array;
                toProtoMsg(message: _151.MsgMigrateContract): _151.MsgMigrateContractProtoMsg;
                registerTypeUrl(): void;
            };
            MsgMigrateContractResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _151.MsgMigrateContractResponse;
                isSDK(o: any): o is _151.MsgMigrateContractResponseSDKType;
                isAmino(o: any): o is _151.MsgMigrateContractResponseAmino;
                encode(message: _151.MsgMigrateContractResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _151.MsgMigrateContractResponse;
                fromJSON(object: any): _151.MsgMigrateContractResponse;
                toJSON(message: _151.MsgMigrateContractResponse): import("..").JsonSafe<_151.MsgMigrateContractResponse>;
                fromPartial(object: import("../helpers").DeepPartial<_151.MsgMigrateContractResponse>): _151.MsgMigrateContractResponse;
                fromSDK(object: _151.MsgMigrateContractResponseSDKType): _151.MsgMigrateContractResponse;
                fromSDKJSON(object: any): _151.MsgMigrateContractResponseSDKType;
                toSDK(message: _151.MsgMigrateContractResponse): _151.MsgMigrateContractResponseSDKType;
                fromAmino(object: _151.MsgMigrateContractResponseAmino): _151.MsgMigrateContractResponse;
                toAmino(message: _151.MsgMigrateContractResponse): _151.MsgMigrateContractResponseAmino;
                fromAminoMsg(object: _151.MsgMigrateContractResponseAminoMsg): _151.MsgMigrateContractResponse;
                toAminoMsg(message: _151.MsgMigrateContractResponse): _151.MsgMigrateContractResponseAminoMsg;
                fromProtoMsg(message: _151.MsgMigrateContractResponseProtoMsg): _151.MsgMigrateContractResponse;
                toProto(message: _151.MsgMigrateContractResponse): Uint8Array;
                toProtoMsg(message: _151.MsgMigrateContractResponse): _151.MsgMigrateContractResponseProtoMsg;
                registerTypeUrl(): void;
            };
            MsgUpdateAdmin: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _151.MsgUpdateAdmin;
                isSDK(o: any): o is _151.MsgUpdateAdminSDKType;
                isAmino(o: any): o is _151.MsgUpdateAdminAmino;
                encode(message: _151.MsgUpdateAdmin, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _151.MsgUpdateAdmin;
                fromJSON(object: any): _151.MsgUpdateAdmin;
                toJSON(message: _151.MsgUpdateAdmin): import("..").JsonSafe<_151.MsgUpdateAdmin>;
                fromPartial(object: import("../helpers").DeepPartial<_151.MsgUpdateAdmin>): _151.MsgUpdateAdmin;
                fromSDK(object: _151.MsgUpdateAdminSDKType): _151.MsgUpdateAdmin;
                fromSDKJSON(object: any): _151.MsgUpdateAdminSDKType;
                toSDK(message: _151.MsgUpdateAdmin): _151.MsgUpdateAdminSDKType;
                fromAmino(object: _151.MsgUpdateAdminAmino): _151.MsgUpdateAdmin;
                toAmino(message: _151.MsgUpdateAdmin): _151.MsgUpdateAdminAmino;
                fromAminoMsg(object: _151.MsgUpdateAdminAminoMsg): _151.MsgUpdateAdmin;
                toAminoMsg(message: _151.MsgUpdateAdmin): _151.MsgUpdateAdminAminoMsg;
                fromProtoMsg(message: _151.MsgUpdateAdminProtoMsg): _151.MsgUpdateAdmin;
                toProto(message: _151.MsgUpdateAdmin): Uint8Array;
                toProtoMsg(message: _151.MsgUpdateAdmin): _151.MsgUpdateAdminProtoMsg;
                registerTypeUrl(): void;
            };
            MsgUpdateAdminResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _151.MsgUpdateAdminResponse;
                isSDK(o: any): o is _151.MsgUpdateAdminResponseSDKType;
                isAmino(o: any): o is _151.MsgUpdateAdminResponseAmino;
                encode(_: _151.MsgUpdateAdminResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _151.MsgUpdateAdminResponse;
                fromJSON(_: any): _151.MsgUpdateAdminResponse;
                toJSON(_: _151.MsgUpdateAdminResponse): import("..").JsonSafe<_151.MsgUpdateAdminResponse>;
                fromPartial(_: import("../helpers").DeepPartial<_151.MsgUpdateAdminResponse>): _151.MsgUpdateAdminResponse;
                fromSDK(_: _151.MsgUpdateAdminResponseSDKType): _151.MsgUpdateAdminResponse;
                fromSDKJSON(_: any): _151.MsgUpdateAdminResponseSDKType;
                toSDK(_: _151.MsgUpdateAdminResponse): _151.MsgUpdateAdminResponseSDKType;
                fromAmino(_: _151.MsgUpdateAdminResponseAmino): _151.MsgUpdateAdminResponse;
                toAmino(_: _151.MsgUpdateAdminResponse): _151.MsgUpdateAdminResponseAmino;
                fromAminoMsg(object: _151.MsgUpdateAdminResponseAminoMsg): _151.MsgUpdateAdminResponse;
                toAminoMsg(message: _151.MsgUpdateAdminResponse): _151.MsgUpdateAdminResponseAminoMsg;
                fromProtoMsg(message: _151.MsgUpdateAdminResponseProtoMsg): _151.MsgUpdateAdminResponse;
                toProto(message: _151.MsgUpdateAdminResponse): Uint8Array;
                toProtoMsg(message: _151.MsgUpdateAdminResponse): _151.MsgUpdateAdminResponseProtoMsg;
                registerTypeUrl(): void;
            };
            MsgClearAdmin: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _151.MsgClearAdmin;
                isSDK(o: any): o is _151.MsgClearAdminSDKType;
                isAmino(o: any): o is _151.MsgClearAdminAmino;
                encode(message: _151.MsgClearAdmin, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _151.MsgClearAdmin;
                fromJSON(object: any): _151.MsgClearAdmin;
                toJSON(message: _151.MsgClearAdmin): import("..").JsonSafe<_151.MsgClearAdmin>;
                fromPartial(object: import("../helpers").DeepPartial<_151.MsgClearAdmin>): _151.MsgClearAdmin;
                fromSDK(object: _151.MsgClearAdminSDKType): _151.MsgClearAdmin;
                fromSDKJSON(object: any): _151.MsgClearAdminSDKType;
                toSDK(message: _151.MsgClearAdmin): _151.MsgClearAdminSDKType;
                fromAmino(object: _151.MsgClearAdminAmino): _151.MsgClearAdmin;
                toAmino(message: _151.MsgClearAdmin): _151.MsgClearAdminAmino;
                fromAminoMsg(object: _151.MsgClearAdminAminoMsg): _151.MsgClearAdmin;
                toAminoMsg(message: _151.MsgClearAdmin): _151.MsgClearAdminAminoMsg;
                fromProtoMsg(message: _151.MsgClearAdminProtoMsg): _151.MsgClearAdmin;
                toProto(message: _151.MsgClearAdmin): Uint8Array;
                toProtoMsg(message: _151.MsgClearAdmin): _151.MsgClearAdminProtoMsg;
                registerTypeUrl(): void;
            };
            MsgClearAdminResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _151.MsgClearAdminResponse;
                isSDK(o: any): o is _151.MsgClearAdminResponseSDKType;
                isAmino(o: any): o is _151.MsgClearAdminResponseAmino;
                encode(_: _151.MsgClearAdminResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _151.MsgClearAdminResponse;
                fromJSON(_: any): _151.MsgClearAdminResponse;
                toJSON(_: _151.MsgClearAdminResponse): import("..").JsonSafe<_151.MsgClearAdminResponse>;
                fromPartial(_: import("../helpers").DeepPartial<_151.MsgClearAdminResponse>): _151.MsgClearAdminResponse;
                fromSDK(_: _151.MsgClearAdminResponseSDKType): _151.MsgClearAdminResponse;
                fromSDKJSON(_: any): _151.MsgClearAdminResponseSDKType;
                toSDK(_: _151.MsgClearAdminResponse): _151.MsgClearAdminResponseSDKType;
                fromAmino(_: _151.MsgClearAdminResponseAmino): _151.MsgClearAdminResponse;
                toAmino(_: _151.MsgClearAdminResponse): _151.MsgClearAdminResponseAmino;
                fromAminoMsg(object: _151.MsgClearAdminResponseAminoMsg): _151.MsgClearAdminResponse;
                toAminoMsg(message: _151.MsgClearAdminResponse): _151.MsgClearAdminResponseAminoMsg;
                fromProtoMsg(message: _151.MsgClearAdminResponseProtoMsg): _151.MsgClearAdminResponse;
                toProto(message: _151.MsgClearAdminResponse): Uint8Array;
                toProtoMsg(message: _151.MsgClearAdminResponse): _151.MsgClearAdminResponseProtoMsg;
                registerTypeUrl(): void;
            };
            QueryContractInfoRequest: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryContractInfoRequest;
                isSDK(o: any): o is _150.QueryContractInfoRequestSDKType;
                isAmino(o: any): o is _150.QueryContractInfoRequestAmino;
                encode(message: _150.QueryContractInfoRequest, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryContractInfoRequest;
                fromJSON(object: any): _150.QueryContractInfoRequest;
                toJSON(message: _150.QueryContractInfoRequest): import("..").JsonSafe<_150.QueryContractInfoRequest>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryContractInfoRequest>): _150.QueryContractInfoRequest;
                fromSDK(object: _150.QueryContractInfoRequestSDKType): _150.QueryContractInfoRequest;
                fromSDKJSON(object: any): _150.QueryContractInfoRequestSDKType;
                toSDK(message: _150.QueryContractInfoRequest): _150.QueryContractInfoRequestSDKType;
                fromAmino(object: _150.QueryContractInfoRequestAmino): _150.QueryContractInfoRequest;
                toAmino(message: _150.QueryContractInfoRequest): _150.QueryContractInfoRequestAmino;
                fromAminoMsg(object: _150.QueryContractInfoRequestAminoMsg): _150.QueryContractInfoRequest;
                toAminoMsg(message: _150.QueryContractInfoRequest): _150.QueryContractInfoRequestAminoMsg;
                fromProtoMsg(message: _150.QueryContractInfoRequestProtoMsg): _150.QueryContractInfoRequest;
                toProto(message: _150.QueryContractInfoRequest): Uint8Array;
                toProtoMsg(message: _150.QueryContractInfoRequest): _150.QueryContractInfoRequestProtoMsg;
                registerTypeUrl(): void;
            };
            QueryContractInfoResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryContractInfoResponse;
                isSDK(o: any): o is _150.QueryContractInfoResponseSDKType;
                isAmino(o: any): o is _150.QueryContractInfoResponseAmino;
                encode(message: _150.QueryContractInfoResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryContractInfoResponse;
                fromJSON(object: any): _150.QueryContractInfoResponse;
                toJSON(message: _150.QueryContractInfoResponse): import("..").JsonSafe<_150.QueryContractInfoResponse>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryContractInfoResponse>): _150.QueryContractInfoResponse;
                fromSDK(object: _150.QueryContractInfoResponseSDKType): _150.QueryContractInfoResponse;
                fromSDKJSON(object: any): _150.QueryContractInfoResponseSDKType;
                toSDK(message: _150.QueryContractInfoResponse): _150.QueryContractInfoResponseSDKType;
                fromAmino(object: _150.QueryContractInfoResponseAmino): _150.QueryContractInfoResponse;
                toAmino(message: _150.QueryContractInfoResponse): _150.QueryContractInfoResponseAmino;
                fromAminoMsg(object: _150.QueryContractInfoResponseAminoMsg): _150.QueryContractInfoResponse;
                toAminoMsg(message: _150.QueryContractInfoResponse): _150.QueryContractInfoResponseAminoMsg;
                fromProtoMsg(message: _150.QueryContractInfoResponseProtoMsg): _150.QueryContractInfoResponse;
                toProto(message: _150.QueryContractInfoResponse): Uint8Array;
                toProtoMsg(message: _150.QueryContractInfoResponse): _150.QueryContractInfoResponseProtoMsg;
                registerTypeUrl(): void;
            };
            QueryContractHistoryRequest: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryContractHistoryRequest;
                isSDK(o: any): o is _150.QueryContractHistoryRequestSDKType;
                isAmino(o: any): o is _150.QueryContractHistoryRequestAmino;
                encode(message: _150.QueryContractHistoryRequest, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryContractHistoryRequest;
                fromJSON(object: any): _150.QueryContractHistoryRequest;
                toJSON(message: _150.QueryContractHistoryRequest): import("..").JsonSafe<_150.QueryContractHistoryRequest>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryContractHistoryRequest>): _150.QueryContractHistoryRequest;
                fromSDK(object: _150.QueryContractHistoryRequestSDKType): _150.QueryContractHistoryRequest;
                fromSDKJSON(object: any): _150.QueryContractHistoryRequestSDKType;
                toSDK(message: _150.QueryContractHistoryRequest): _150.QueryContractHistoryRequestSDKType;
                fromAmino(object: _150.QueryContractHistoryRequestAmino): _150.QueryContractHistoryRequest;
                toAmino(message: _150.QueryContractHistoryRequest): _150.QueryContractHistoryRequestAmino;
                fromAminoMsg(object: _150.QueryContractHistoryRequestAminoMsg): _150.QueryContractHistoryRequest;
                toAminoMsg(message: _150.QueryContractHistoryRequest): _150.QueryContractHistoryRequestAminoMsg;
                fromProtoMsg(message: _150.QueryContractHistoryRequestProtoMsg): _150.QueryContractHistoryRequest;
                toProto(message: _150.QueryContractHistoryRequest): Uint8Array;
                toProtoMsg(message: _150.QueryContractHistoryRequest): _150.QueryContractHistoryRequestProtoMsg;
                registerTypeUrl(): void;
            };
            QueryContractHistoryResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryContractHistoryResponse;
                isSDK(o: any): o is _150.QueryContractHistoryResponseSDKType;
                isAmino(o: any): o is _150.QueryContractHistoryResponseAmino;
                encode(message: _150.QueryContractHistoryResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryContractHistoryResponse;
                fromJSON(object: any): _150.QueryContractHistoryResponse;
                toJSON(message: _150.QueryContractHistoryResponse): import("..").JsonSafe<_150.QueryContractHistoryResponse>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryContractHistoryResponse>): _150.QueryContractHistoryResponse;
                fromSDK(object: _150.QueryContractHistoryResponseSDKType): _150.QueryContractHistoryResponse;
                fromSDKJSON(object: any): _150.QueryContractHistoryResponseSDKType;
                toSDK(message: _150.QueryContractHistoryResponse): _150.QueryContractHistoryResponseSDKType;
                fromAmino(object: _150.QueryContractHistoryResponseAmino): _150.QueryContractHistoryResponse;
                toAmino(message: _150.QueryContractHistoryResponse): _150.QueryContractHistoryResponseAmino;
                fromAminoMsg(object: _150.QueryContractHistoryResponseAminoMsg): _150.QueryContractHistoryResponse;
                toAminoMsg(message: _150.QueryContractHistoryResponse): _150.QueryContractHistoryResponseAminoMsg;
                fromProtoMsg(message: _150.QueryContractHistoryResponseProtoMsg): _150.QueryContractHistoryResponse;
                toProto(message: _150.QueryContractHistoryResponse): Uint8Array;
                toProtoMsg(message: _150.QueryContractHistoryResponse): _150.QueryContractHistoryResponseProtoMsg;
                registerTypeUrl(): void;
            };
            QueryContractsByCodeRequest: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryContractsByCodeRequest;
                isSDK(o: any): o is _150.QueryContractsByCodeRequestSDKType;
                isAmino(o: any): o is _150.QueryContractsByCodeRequestAmino;
                encode(message: _150.QueryContractsByCodeRequest, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryContractsByCodeRequest;
                fromJSON(object: any): _150.QueryContractsByCodeRequest;
                toJSON(message: _150.QueryContractsByCodeRequest): import("..").JsonSafe<_150.QueryContractsByCodeRequest>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryContractsByCodeRequest>): _150.QueryContractsByCodeRequest;
                fromSDK(object: _150.QueryContractsByCodeRequestSDKType): _150.QueryContractsByCodeRequest;
                fromSDKJSON(object: any): _150.QueryContractsByCodeRequestSDKType;
                toSDK(message: _150.QueryContractsByCodeRequest): _150.QueryContractsByCodeRequestSDKType;
                fromAmino(object: _150.QueryContractsByCodeRequestAmino): _150.QueryContractsByCodeRequest;
                toAmino(message: _150.QueryContractsByCodeRequest): _150.QueryContractsByCodeRequestAmino;
                fromAminoMsg(object: _150.QueryContractsByCodeRequestAminoMsg): _150.QueryContractsByCodeRequest;
                toAminoMsg(message: _150.QueryContractsByCodeRequest): _150.QueryContractsByCodeRequestAminoMsg;
                fromProtoMsg(message: _150.QueryContractsByCodeRequestProtoMsg): _150.QueryContractsByCodeRequest;
                toProto(message: _150.QueryContractsByCodeRequest): Uint8Array;
                toProtoMsg(message: _150.QueryContractsByCodeRequest): _150.QueryContractsByCodeRequestProtoMsg;
                registerTypeUrl(): void;
            };
            QueryContractsByCodeResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryContractsByCodeResponse;
                isSDK(o: any): o is _150.QueryContractsByCodeResponseSDKType;
                isAmino(o: any): o is _150.QueryContractsByCodeResponseAmino;
                encode(message: _150.QueryContractsByCodeResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryContractsByCodeResponse;
                fromJSON(object: any): _150.QueryContractsByCodeResponse;
                toJSON(message: _150.QueryContractsByCodeResponse): import("..").JsonSafe<_150.QueryContractsByCodeResponse>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryContractsByCodeResponse>): _150.QueryContractsByCodeResponse;
                fromSDK(object: _150.QueryContractsByCodeResponseSDKType): _150.QueryContractsByCodeResponse;
                fromSDKJSON(object: any): _150.QueryContractsByCodeResponseSDKType;
                toSDK(message: _150.QueryContractsByCodeResponse): _150.QueryContractsByCodeResponseSDKType;
                fromAmino(object: _150.QueryContractsByCodeResponseAmino): _150.QueryContractsByCodeResponse;
                toAmino(message: _150.QueryContractsByCodeResponse): _150.QueryContractsByCodeResponseAmino;
                fromAminoMsg(object: _150.QueryContractsByCodeResponseAminoMsg): _150.QueryContractsByCodeResponse;
                toAminoMsg(message: _150.QueryContractsByCodeResponse): _150.QueryContractsByCodeResponseAminoMsg;
                fromProtoMsg(message: _150.QueryContractsByCodeResponseProtoMsg): _150.QueryContractsByCodeResponse;
                toProto(message: _150.QueryContractsByCodeResponse): Uint8Array;
                toProtoMsg(message: _150.QueryContractsByCodeResponse): _150.QueryContractsByCodeResponseProtoMsg;
                registerTypeUrl(): void;
            };
            QueryAllContractStateRequest: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryAllContractStateRequest;
                isSDK(o: any): o is _150.QueryAllContractStateRequestSDKType;
                isAmino(o: any): o is _150.QueryAllContractStateRequestAmino;
                encode(message: _150.QueryAllContractStateRequest, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryAllContractStateRequest;
                fromJSON(object: any): _150.QueryAllContractStateRequest;
                toJSON(message: _150.QueryAllContractStateRequest): import("..").JsonSafe<_150.QueryAllContractStateRequest>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryAllContractStateRequest>): _150.QueryAllContractStateRequest;
                fromSDK(object: _150.QueryAllContractStateRequestSDKType): _150.QueryAllContractStateRequest;
                fromSDKJSON(object: any): _150.QueryAllContractStateRequestSDKType;
                toSDK(message: _150.QueryAllContractStateRequest): _150.QueryAllContractStateRequestSDKType;
                fromAmino(object: _150.QueryAllContractStateRequestAmino): _150.QueryAllContractStateRequest;
                toAmino(message: _150.QueryAllContractStateRequest): _150.QueryAllContractStateRequestAmino;
                fromAminoMsg(object: _150.QueryAllContractStateRequestAminoMsg): _150.QueryAllContractStateRequest;
                toAminoMsg(message: _150.QueryAllContractStateRequest): _150.QueryAllContractStateRequestAminoMsg;
                fromProtoMsg(message: _150.QueryAllContractStateRequestProtoMsg): _150.QueryAllContractStateRequest;
                toProto(message: _150.QueryAllContractStateRequest): Uint8Array;
                toProtoMsg(message: _150.QueryAllContractStateRequest): _150.QueryAllContractStateRequestProtoMsg;
                registerTypeUrl(): void;
            };
            QueryAllContractStateResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryAllContractStateResponse;
                isSDK(o: any): o is _150.QueryAllContractStateResponseSDKType;
                isAmino(o: any): o is _150.QueryAllContractStateResponseAmino;
                encode(message: _150.QueryAllContractStateResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryAllContractStateResponse;
                fromJSON(object: any): _150.QueryAllContractStateResponse;
                toJSON(message: _150.QueryAllContractStateResponse): import("..").JsonSafe<_150.QueryAllContractStateResponse>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryAllContractStateResponse>): _150.QueryAllContractStateResponse;
                fromSDK(object: _150.QueryAllContractStateResponseSDKType): _150.QueryAllContractStateResponse;
                fromSDKJSON(object: any): _150.QueryAllContractStateResponseSDKType;
                toSDK(message: _150.QueryAllContractStateResponse): _150.QueryAllContractStateResponseSDKType;
                fromAmino(object: _150.QueryAllContractStateResponseAmino): _150.QueryAllContractStateResponse;
                toAmino(message: _150.QueryAllContractStateResponse): _150.QueryAllContractStateResponseAmino;
                fromAminoMsg(object: _150.QueryAllContractStateResponseAminoMsg): _150.QueryAllContractStateResponse;
                toAminoMsg(message: _150.QueryAllContractStateResponse): _150.QueryAllContractStateResponseAminoMsg;
                fromProtoMsg(message: _150.QueryAllContractStateResponseProtoMsg): _150.QueryAllContractStateResponse;
                toProto(message: _150.QueryAllContractStateResponse): Uint8Array;
                toProtoMsg(message: _150.QueryAllContractStateResponse): _150.QueryAllContractStateResponseProtoMsg;
                registerTypeUrl(): void;
            };
            QueryRawContractStateRequest: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryRawContractStateRequest;
                isSDK(o: any): o is _150.QueryRawContractStateRequestSDKType;
                isAmino(o: any): o is _150.QueryRawContractStateRequestAmino;
                encode(message: _150.QueryRawContractStateRequest, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryRawContractStateRequest;
                fromJSON(object: any): _150.QueryRawContractStateRequest;
                toJSON(message: _150.QueryRawContractStateRequest): import("..").JsonSafe<_150.QueryRawContractStateRequest>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryRawContractStateRequest>): _150.QueryRawContractStateRequest;
                fromSDK(object: _150.QueryRawContractStateRequestSDKType): _150.QueryRawContractStateRequest;
                fromSDKJSON(object: any): _150.QueryRawContractStateRequestSDKType;
                toSDK(message: _150.QueryRawContractStateRequest): _150.QueryRawContractStateRequestSDKType;
                fromAmino(object: _150.QueryRawContractStateRequestAmino): _150.QueryRawContractStateRequest;
                toAmino(message: _150.QueryRawContractStateRequest): _150.QueryRawContractStateRequestAmino;
                fromAminoMsg(object: _150.QueryRawContractStateRequestAminoMsg): _150.QueryRawContractStateRequest;
                toAminoMsg(message: _150.QueryRawContractStateRequest): _150.QueryRawContractStateRequestAminoMsg;
                fromProtoMsg(message: _150.QueryRawContractStateRequestProtoMsg): _150.QueryRawContractStateRequest;
                toProto(message: _150.QueryRawContractStateRequest): Uint8Array;
                toProtoMsg(message: _150.QueryRawContractStateRequest): _150.QueryRawContractStateRequestProtoMsg;
                registerTypeUrl(): void;
            };
            QueryRawContractStateResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryRawContractStateResponse;
                isSDK(o: any): o is _150.QueryRawContractStateResponseSDKType;
                isAmino(o: any): o is _150.QueryRawContractStateResponseAmino;
                encode(message: _150.QueryRawContractStateResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryRawContractStateResponse;
                fromJSON(object: any): _150.QueryRawContractStateResponse;
                toJSON(message: _150.QueryRawContractStateResponse): import("..").JsonSafe<_150.QueryRawContractStateResponse>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryRawContractStateResponse>): _150.QueryRawContractStateResponse;
                fromSDK(object: _150.QueryRawContractStateResponseSDKType): _150.QueryRawContractStateResponse;
                fromSDKJSON(object: any): _150.QueryRawContractStateResponseSDKType;
                toSDK(message: _150.QueryRawContractStateResponse): _150.QueryRawContractStateResponseSDKType;
                fromAmino(object: _150.QueryRawContractStateResponseAmino): _150.QueryRawContractStateResponse;
                toAmino(message: _150.QueryRawContractStateResponse): _150.QueryRawContractStateResponseAmino;
                fromAminoMsg(object: _150.QueryRawContractStateResponseAminoMsg): _150.QueryRawContractStateResponse;
                toAminoMsg(message: _150.QueryRawContractStateResponse): _150.QueryRawContractStateResponseAminoMsg;
                fromProtoMsg(message: _150.QueryRawContractStateResponseProtoMsg): _150.QueryRawContractStateResponse;
                toProto(message: _150.QueryRawContractStateResponse): Uint8Array;
                toProtoMsg(message: _150.QueryRawContractStateResponse): _150.QueryRawContractStateResponseProtoMsg;
                registerTypeUrl(): void;
            };
            QuerySmartContractStateRequest: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QuerySmartContractStateRequest;
                isSDK(o: any): o is _150.QuerySmartContractStateRequestSDKType;
                isAmino(o: any): o is _150.QuerySmartContractStateRequestAmino;
                encode(message: _150.QuerySmartContractStateRequest, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QuerySmartContractStateRequest;
                fromJSON(object: any): _150.QuerySmartContractStateRequest;
                toJSON(message: _150.QuerySmartContractStateRequest): import("..").JsonSafe<_150.QuerySmartContractStateRequest>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QuerySmartContractStateRequest>): _150.QuerySmartContractStateRequest;
                fromSDK(object: _150.QuerySmartContractStateRequestSDKType): _150.QuerySmartContractStateRequest;
                fromSDKJSON(object: any): _150.QuerySmartContractStateRequestSDKType;
                toSDK(message: _150.QuerySmartContractStateRequest): _150.QuerySmartContractStateRequestSDKType;
                fromAmino(object: _150.QuerySmartContractStateRequestAmino): _150.QuerySmartContractStateRequest;
                toAmino(message: _150.QuerySmartContractStateRequest): _150.QuerySmartContractStateRequestAmino;
                fromAminoMsg(object: _150.QuerySmartContractStateRequestAminoMsg): _150.QuerySmartContractStateRequest;
                toAminoMsg(message: _150.QuerySmartContractStateRequest): _150.QuerySmartContractStateRequestAminoMsg;
                fromProtoMsg(message: _150.QuerySmartContractStateRequestProtoMsg): _150.QuerySmartContractStateRequest;
                toProto(message: _150.QuerySmartContractStateRequest): Uint8Array;
                toProtoMsg(message: _150.QuerySmartContractStateRequest): _150.QuerySmartContractStateRequestProtoMsg;
                registerTypeUrl(): void;
            };
            QuerySmartContractStateResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QuerySmartContractStateResponse;
                isSDK(o: any): o is _150.QuerySmartContractStateResponseSDKType;
                isAmino(o: any): o is _150.QuerySmartContractStateResponseAmino;
                encode(message: _150.QuerySmartContractStateResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QuerySmartContractStateResponse;
                fromJSON(object: any): _150.QuerySmartContractStateResponse;
                toJSON(message: _150.QuerySmartContractStateResponse): import("..").JsonSafe<_150.QuerySmartContractStateResponse>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QuerySmartContractStateResponse>): _150.QuerySmartContractStateResponse;
                fromSDK(object: _150.QuerySmartContractStateResponseSDKType): _150.QuerySmartContractStateResponse;
                fromSDKJSON(object: any): _150.QuerySmartContractStateResponseSDKType;
                toSDK(message: _150.QuerySmartContractStateResponse): _150.QuerySmartContractStateResponseSDKType;
                fromAmino(object: _150.QuerySmartContractStateResponseAmino): _150.QuerySmartContractStateResponse;
                toAmino(message: _150.QuerySmartContractStateResponse): _150.QuerySmartContractStateResponseAmino;
                fromAminoMsg(object: _150.QuerySmartContractStateResponseAminoMsg): _150.QuerySmartContractStateResponse;
                toAminoMsg(message: _150.QuerySmartContractStateResponse): _150.QuerySmartContractStateResponseAminoMsg;
                fromProtoMsg(message: _150.QuerySmartContractStateResponseProtoMsg): _150.QuerySmartContractStateResponse;
                toProto(message: _150.QuerySmartContractStateResponse): Uint8Array;
                toProtoMsg(message: _150.QuerySmartContractStateResponse): _150.QuerySmartContractStateResponseProtoMsg;
                registerTypeUrl(): void;
            };
            QueryCodeRequest: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryCodeRequest;
                isSDK(o: any): o is _150.QueryCodeRequestSDKType;
                isAmino(o: any): o is _150.QueryCodeRequestAmino;
                encode(message: _150.QueryCodeRequest, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryCodeRequest;
                fromJSON(object: any): _150.QueryCodeRequest;
                toJSON(message: _150.QueryCodeRequest): import("..").JsonSafe<_150.QueryCodeRequest>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryCodeRequest>): _150.QueryCodeRequest;
                fromSDK(object: _150.QueryCodeRequestSDKType): _150.QueryCodeRequest;
                fromSDKJSON(object: any): _150.QueryCodeRequestSDKType;
                toSDK(message: _150.QueryCodeRequest): _150.QueryCodeRequestSDKType;
                fromAmino(object: _150.QueryCodeRequestAmino): _150.QueryCodeRequest;
                toAmino(message: _150.QueryCodeRequest): _150.QueryCodeRequestAmino;
                fromAminoMsg(object: _150.QueryCodeRequestAminoMsg): _150.QueryCodeRequest;
                toAminoMsg(message: _150.QueryCodeRequest): _150.QueryCodeRequestAminoMsg;
                fromProtoMsg(message: _150.QueryCodeRequestProtoMsg): _150.QueryCodeRequest;
                toProto(message: _150.QueryCodeRequest): Uint8Array;
                toProtoMsg(message: _150.QueryCodeRequest): _150.QueryCodeRequestProtoMsg;
                registerTypeUrl(): void;
            };
            CodeInfoResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.CodeInfoResponse;
                isSDK(o: any): o is _150.CodeInfoResponseSDKType;
                isAmino(o: any): o is _150.CodeInfoResponseAmino;
                encode(message: _150.CodeInfoResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.CodeInfoResponse;
                fromJSON(object: any): _150.CodeInfoResponse;
                toJSON(message: _150.CodeInfoResponse): import("..").JsonSafe<_150.CodeInfoResponse>;
                fromPartial(object: import("../helpers").DeepPartial<_150.CodeInfoResponse>): _150.CodeInfoResponse;
                fromSDK(object: _150.CodeInfoResponseSDKType): _150.CodeInfoResponse;
                fromSDKJSON(object: any): _150.CodeInfoResponseSDKType;
                toSDK(message: _150.CodeInfoResponse): _150.CodeInfoResponseSDKType;
                fromAmino(object: _150.CodeInfoResponseAmino): _150.CodeInfoResponse;
                toAmino(message: _150.CodeInfoResponse): _150.CodeInfoResponseAmino;
                fromAminoMsg(object: _150.CodeInfoResponseAminoMsg): _150.CodeInfoResponse;
                toAminoMsg(message: _150.CodeInfoResponse): _150.CodeInfoResponseAminoMsg;
                fromProtoMsg(message: _150.CodeInfoResponseProtoMsg): _150.CodeInfoResponse;
                toProto(message: _150.CodeInfoResponse): Uint8Array;
                toProtoMsg(message: _150.CodeInfoResponse): _150.CodeInfoResponseProtoMsg;
                registerTypeUrl(): void;
            };
            QueryCodeResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryCodeResponse;
                isSDK(o: any): o is _150.QueryCodeResponseSDKType;
                isAmino(o: any): o is _150.QueryCodeResponseAmino;
                encode(message: _150.QueryCodeResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryCodeResponse;
                fromJSON(object: any): _150.QueryCodeResponse;
                toJSON(message: _150.QueryCodeResponse): import("..").JsonSafe<_150.QueryCodeResponse>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryCodeResponse>): _150.QueryCodeResponse;
                fromSDK(object: _150.QueryCodeResponseSDKType): _150.QueryCodeResponse;
                fromSDKJSON(object: any): _150.QueryCodeResponseSDKType;
                toSDK(message: _150.QueryCodeResponse): _150.QueryCodeResponseSDKType;
                fromAmino(object: _150.QueryCodeResponseAmino): _150.QueryCodeResponse;
                toAmino(message: _150.QueryCodeResponse): _150.QueryCodeResponseAmino;
                fromAminoMsg(object: _150.QueryCodeResponseAminoMsg): _150.QueryCodeResponse;
                toAminoMsg(message: _150.QueryCodeResponse): _150.QueryCodeResponseAminoMsg;
                fromProtoMsg(message: _150.QueryCodeResponseProtoMsg): _150.QueryCodeResponse;
                toProto(message: _150.QueryCodeResponse): Uint8Array;
                toProtoMsg(message: _150.QueryCodeResponse): _150.QueryCodeResponseProtoMsg;
                registerTypeUrl(): void;
            };
            QueryCodesRequest: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryCodesRequest;
                isSDK(o: any): o is _150.QueryCodesRequestSDKType;
                isAmino(o: any): o is _150.QueryCodesRequestAmino;
                encode(message: _150.QueryCodesRequest, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryCodesRequest;
                fromJSON(object: any): _150.QueryCodesRequest;
                toJSON(message: _150.QueryCodesRequest): import("..").JsonSafe<_150.QueryCodesRequest>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryCodesRequest>): _150.QueryCodesRequest;
                fromSDK(object: _150.QueryCodesRequestSDKType): _150.QueryCodesRequest;
                fromSDKJSON(object: any): _150.QueryCodesRequestSDKType;
                toSDK(message: _150.QueryCodesRequest): _150.QueryCodesRequestSDKType;
                fromAmino(object: _150.QueryCodesRequestAmino): _150.QueryCodesRequest;
                toAmino(message: _150.QueryCodesRequest): _150.QueryCodesRequestAmino;
                fromAminoMsg(object: _150.QueryCodesRequestAminoMsg): _150.QueryCodesRequest;
                toAminoMsg(message: _150.QueryCodesRequest): _150.QueryCodesRequestAminoMsg;
                fromProtoMsg(message: _150.QueryCodesRequestProtoMsg): _150.QueryCodesRequest;
                toProto(message: _150.QueryCodesRequest): Uint8Array;
                toProtoMsg(message: _150.QueryCodesRequest): _150.QueryCodesRequestProtoMsg;
                registerTypeUrl(): void;
            };
            QueryCodesResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryCodesResponse;
                isSDK(o: any): o is _150.QueryCodesResponseSDKType;
                isAmino(o: any): o is _150.QueryCodesResponseAmino;
                encode(message: _150.QueryCodesResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryCodesResponse;
                fromJSON(object: any): _150.QueryCodesResponse;
                toJSON(message: _150.QueryCodesResponse): import("..").JsonSafe<_150.QueryCodesResponse>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryCodesResponse>): _150.QueryCodesResponse;
                fromSDK(object: _150.QueryCodesResponseSDKType): _150.QueryCodesResponse;
                fromSDKJSON(object: any): _150.QueryCodesResponseSDKType;
                toSDK(message: _150.QueryCodesResponse): _150.QueryCodesResponseSDKType;
                fromAmino(object: _150.QueryCodesResponseAmino): _150.QueryCodesResponse;
                toAmino(message: _150.QueryCodesResponse): _150.QueryCodesResponseAmino;
                fromAminoMsg(object: _150.QueryCodesResponseAminoMsg): _150.QueryCodesResponse;
                toAminoMsg(message: _150.QueryCodesResponse): _150.QueryCodesResponseAminoMsg;
                fromProtoMsg(message: _150.QueryCodesResponseProtoMsg): _150.QueryCodesResponse;
                toProto(message: _150.QueryCodesResponse): Uint8Array;
                toProtoMsg(message: _150.QueryCodesResponse): _150.QueryCodesResponseProtoMsg;
                registerTypeUrl(): void;
            };
            QueryPinnedCodesRequest: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryPinnedCodesRequest;
                isSDK(o: any): o is _150.QueryPinnedCodesRequestSDKType;
                isAmino(o: any): o is _150.QueryPinnedCodesRequestAmino;
                encode(message: _150.QueryPinnedCodesRequest, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryPinnedCodesRequest;
                fromJSON(object: any): _150.QueryPinnedCodesRequest;
                toJSON(message: _150.QueryPinnedCodesRequest): import("..").JsonSafe<_150.QueryPinnedCodesRequest>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryPinnedCodesRequest>): _150.QueryPinnedCodesRequest;
                fromSDK(object: _150.QueryPinnedCodesRequestSDKType): _150.QueryPinnedCodesRequest;
                fromSDKJSON(object: any): _150.QueryPinnedCodesRequestSDKType;
                toSDK(message: _150.QueryPinnedCodesRequest): _150.QueryPinnedCodesRequestSDKType;
                fromAmino(object: _150.QueryPinnedCodesRequestAmino): _150.QueryPinnedCodesRequest;
                toAmino(message: _150.QueryPinnedCodesRequest): _150.QueryPinnedCodesRequestAmino;
                fromAminoMsg(object: _150.QueryPinnedCodesRequestAminoMsg): _150.QueryPinnedCodesRequest;
                toAminoMsg(message: _150.QueryPinnedCodesRequest): _150.QueryPinnedCodesRequestAminoMsg;
                fromProtoMsg(message: _150.QueryPinnedCodesRequestProtoMsg): _150.QueryPinnedCodesRequest;
                toProto(message: _150.QueryPinnedCodesRequest): Uint8Array;
                toProtoMsg(message: _150.QueryPinnedCodesRequest): _150.QueryPinnedCodesRequestProtoMsg;
                registerTypeUrl(): void;
            };
            QueryPinnedCodesResponse: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _150.QueryPinnedCodesResponse;
                isSDK(o: any): o is _150.QueryPinnedCodesResponseSDKType;
                isAmino(o: any): o is _150.QueryPinnedCodesResponseAmino;
                encode(message: _150.QueryPinnedCodesResponse, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _150.QueryPinnedCodesResponse;
                fromJSON(object: any): _150.QueryPinnedCodesResponse;
                toJSON(message: _150.QueryPinnedCodesResponse): import("..").JsonSafe<_150.QueryPinnedCodesResponse>;
                fromPartial(object: import("../helpers").DeepPartial<_150.QueryPinnedCodesResponse>): _150.QueryPinnedCodesResponse;
                fromSDK(object: _150.QueryPinnedCodesResponseSDKType): _150.QueryPinnedCodesResponse;
                fromSDKJSON(object: any): _150.QueryPinnedCodesResponseSDKType;
                toSDK(message: _150.QueryPinnedCodesResponse): _150.QueryPinnedCodesResponseSDKType;
                fromAmino(object: _150.QueryPinnedCodesResponseAmino): _150.QueryPinnedCodesResponse;
                toAmino(message: _150.QueryPinnedCodesResponse): _150.QueryPinnedCodesResponseAmino;
                fromAminoMsg(object: _150.QueryPinnedCodesResponseAminoMsg): _150.QueryPinnedCodesResponse;
                toAminoMsg(message: _150.QueryPinnedCodesResponse): _150.QueryPinnedCodesResponseAminoMsg;
                fromProtoMsg(message: _150.QueryPinnedCodesResponseProtoMsg): _150.QueryPinnedCodesResponse;
                toProto(message: _150.QueryPinnedCodesResponse): Uint8Array;
                toProtoMsg(message: _150.QueryPinnedCodesResponse): _150.QueryPinnedCodesResponseProtoMsg;
                registerTypeUrl(): void;
            };
            StoreCodeProposal: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _149.StoreCodeProposal;
                isSDK(o: any): o is _149.StoreCodeProposalSDKType;
                isAmino(o: any): o is _149.StoreCodeProposalAmino;
                encode(message: _149.StoreCodeProposal, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _149.StoreCodeProposal;
                fromJSON(object: any): _149.StoreCodeProposal;
                toJSON(message: _149.StoreCodeProposal): import("..").JsonSafe<_149.StoreCodeProposal>;
                fromPartial(object: import("../helpers").DeepPartial<_149.StoreCodeProposal>): _149.StoreCodeProposal;
                fromSDK(object: _149.StoreCodeProposalSDKType): _149.StoreCodeProposal;
                fromSDKJSON(object: any): _149.StoreCodeProposalSDKType;
                toSDK(message: _149.StoreCodeProposal): _149.StoreCodeProposalSDKType;
                fromAmino(object: _149.StoreCodeProposalAmino): _149.StoreCodeProposal;
                toAmino(message: _149.StoreCodeProposal): _149.StoreCodeProposalAmino;
                fromAminoMsg(object: _149.StoreCodeProposalAminoMsg): _149.StoreCodeProposal;
                toAminoMsg(message: _149.StoreCodeProposal): _149.StoreCodeProposalAminoMsg;
                fromProtoMsg(message: _149.StoreCodeProposalProtoMsg): _149.StoreCodeProposal;
                toProto(message: _149.StoreCodeProposal): Uint8Array;
                toProtoMsg(message: _149.StoreCodeProposal): _149.StoreCodeProposalProtoMsg;
                registerTypeUrl(): void;
            };
            InstantiateContractProposal: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _149.InstantiateContractProposal;
                isSDK(o: any): o is _149.InstantiateContractProposalSDKType;
                isAmino(o: any): o is _149.InstantiateContractProposalAmino;
                encode(message: _149.InstantiateContractProposal, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _149.InstantiateContractProposal;
                fromJSON(object: any): _149.InstantiateContractProposal;
                toJSON(message: _149.InstantiateContractProposal): import("..").JsonSafe<_149.InstantiateContractProposal>;
                fromPartial(object: import("../helpers").DeepPartial<_149.InstantiateContractProposal>): _149.InstantiateContractProposal;
                fromSDK(object: _149.InstantiateContractProposalSDKType): _149.InstantiateContractProposal;
                fromSDKJSON(object: any): _149.InstantiateContractProposalSDKType;
                toSDK(message: _149.InstantiateContractProposal): _149.InstantiateContractProposalSDKType;
                fromAmino(object: _149.InstantiateContractProposalAmino): _149.InstantiateContractProposal;
                toAmino(message: _149.InstantiateContractProposal): _149.InstantiateContractProposalAmino;
                fromAminoMsg(object: _149.InstantiateContractProposalAminoMsg): _149.InstantiateContractProposal;
                toAminoMsg(message: _149.InstantiateContractProposal): _149.InstantiateContractProposalAminoMsg;
                fromProtoMsg(message: _149.InstantiateContractProposalProtoMsg): _149.InstantiateContractProposal;
                toProto(message: _149.InstantiateContractProposal): Uint8Array;
                toProtoMsg(message: _149.InstantiateContractProposal): _149.InstantiateContractProposalProtoMsg;
                registerTypeUrl(): void;
            };
            MigrateContractProposal: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _149.MigrateContractProposal;
                isSDK(o: any): o is _149.MigrateContractProposalSDKType;
                isAmino(o: any): o is _149.MigrateContractProposalAmino;
                encode(message: _149.MigrateContractProposal, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _149.MigrateContractProposal;
                fromJSON(object: any): _149.MigrateContractProposal;
                toJSON(message: _149.MigrateContractProposal): import("..").JsonSafe<_149.MigrateContractProposal>;
                fromPartial(object: import("../helpers").DeepPartial<_149.MigrateContractProposal>): _149.MigrateContractProposal;
                fromSDK(object: _149.MigrateContractProposalSDKType): _149.MigrateContractProposal;
                fromSDKJSON(object: any): _149.MigrateContractProposalSDKType;
                toSDK(message: _149.MigrateContractProposal): _149.MigrateContractProposalSDKType;
                fromAmino(object: _149.MigrateContractProposalAmino): _149.MigrateContractProposal;
                toAmino(message: _149.MigrateContractProposal): _149.MigrateContractProposalAmino;
                fromAminoMsg(object: _149.MigrateContractProposalAminoMsg): _149.MigrateContractProposal;
                toAminoMsg(message: _149.MigrateContractProposal): _149.MigrateContractProposalAminoMsg;
                fromProtoMsg(message: _149.MigrateContractProposalProtoMsg): _149.MigrateContractProposal;
                toProto(message: _149.MigrateContractProposal): Uint8Array;
                toProtoMsg(message: _149.MigrateContractProposal): _149.MigrateContractProposalProtoMsg;
                registerTypeUrl(): void;
            };
            SudoContractProposal: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _149.SudoContractProposal;
                isSDK(o: any): o is _149.SudoContractProposalSDKType;
                isAmino(o: any): o is _149.SudoContractProposalAmino;
                encode(message: _149.SudoContractProposal, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _149.SudoContractProposal;
                fromJSON(object: any): _149.SudoContractProposal;
                toJSON(message: _149.SudoContractProposal): import("..").JsonSafe<_149.SudoContractProposal>;
                fromPartial(object: import("../helpers").DeepPartial<_149.SudoContractProposal>): _149.SudoContractProposal;
                fromSDK(object: _149.SudoContractProposalSDKType): _149.SudoContractProposal;
                fromSDKJSON(object: any): _149.SudoContractProposalSDKType;
                toSDK(message: _149.SudoContractProposal): _149.SudoContractProposalSDKType;
                fromAmino(object: _149.SudoContractProposalAmino): _149.SudoContractProposal;
                toAmino(message: _149.SudoContractProposal): _149.SudoContractProposalAmino;
                fromAminoMsg(object: _149.SudoContractProposalAminoMsg): _149.SudoContractProposal;
                toAminoMsg(message: _149.SudoContractProposal): _149.SudoContractProposalAminoMsg;
                fromProtoMsg(message: _149.SudoContractProposalProtoMsg): _149.SudoContractProposal;
                toProto(message: _149.SudoContractProposal): Uint8Array;
                toProtoMsg(message: _149.SudoContractProposal): _149.SudoContractProposalProtoMsg;
                registerTypeUrl(): void;
            };
            ExecuteContractProposal: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _149.ExecuteContractProposal;
                isSDK(o: any): o is _149.ExecuteContractProposalSDKType;
                isAmino(o: any): o is _149.ExecuteContractProposalAmino;
                encode(message: _149.ExecuteContractProposal, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _149.ExecuteContractProposal;
                fromJSON(object: any): _149.ExecuteContractProposal;
                toJSON(message: _149.ExecuteContractProposal): import("..").JsonSafe<_149.ExecuteContractProposal>;
                fromPartial(object: import("../helpers").DeepPartial<_149.ExecuteContractProposal>): _149.ExecuteContractProposal;
                fromSDK(object: _149.ExecuteContractProposalSDKType): _149.ExecuteContractProposal;
                fromSDKJSON(object: any): _149.ExecuteContractProposalSDKType;
                toSDK(message: _149.ExecuteContractProposal): _149.ExecuteContractProposalSDKType;
                fromAmino(object: _149.ExecuteContractProposalAmino): _149.ExecuteContractProposal;
                toAmino(message: _149.ExecuteContractProposal): _149.ExecuteContractProposalAmino;
                fromAminoMsg(object: _149.ExecuteContractProposalAminoMsg): _149.ExecuteContractProposal;
                toAminoMsg(message: _149.ExecuteContractProposal): _149.ExecuteContractProposalAminoMsg;
                fromProtoMsg(message: _149.ExecuteContractProposalProtoMsg): _149.ExecuteContractProposal;
                toProto(message: _149.ExecuteContractProposal): Uint8Array;
                toProtoMsg(message: _149.ExecuteContractProposal): _149.ExecuteContractProposalProtoMsg;
                registerTypeUrl(): void;
            };
            UpdateAdminProposal: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _149.UpdateAdminProposal;
                isSDK(o: any): o is _149.UpdateAdminProposalSDKType;
                isAmino(o: any): o is _149.UpdateAdminProposalAmino;
                encode(message: _149.UpdateAdminProposal, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _149.UpdateAdminProposal;
                fromJSON(object: any): _149.UpdateAdminProposal;
                toJSON(message: _149.UpdateAdminProposal): import("..").JsonSafe<_149.UpdateAdminProposal>;
                fromPartial(object: import("../helpers").DeepPartial<_149.UpdateAdminProposal>): _149.UpdateAdminProposal;
                fromSDK(object: _149.UpdateAdminProposalSDKType): _149.UpdateAdminProposal;
                fromSDKJSON(object: any): _149.UpdateAdminProposalSDKType;
                toSDK(message: _149.UpdateAdminProposal): _149.UpdateAdminProposalSDKType;
                fromAmino(object: _149.UpdateAdminProposalAmino): _149.UpdateAdminProposal;
                toAmino(message: _149.UpdateAdminProposal): _149.UpdateAdminProposalAmino;
                fromAminoMsg(object: _149.UpdateAdminProposalAminoMsg): _149.UpdateAdminProposal;
                toAminoMsg(message: _149.UpdateAdminProposal): _149.UpdateAdminProposalAminoMsg;
                fromProtoMsg(message: _149.UpdateAdminProposalProtoMsg): _149.UpdateAdminProposal;
                toProto(message: _149.UpdateAdminProposal): Uint8Array;
                toProtoMsg(message: _149.UpdateAdminProposal): _149.UpdateAdminProposalProtoMsg;
                registerTypeUrl(): void;
            };
            ClearAdminProposal: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _149.ClearAdminProposal;
                isSDK(o: any): o is _149.ClearAdminProposalSDKType;
                isAmino(o: any): o is _149.ClearAdminProposalAmino;
                encode(message: _149.ClearAdminProposal, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _149.ClearAdminProposal;
                fromJSON(object: any): _149.ClearAdminProposal;
                toJSON(message: _149.ClearAdminProposal): import("..").JsonSafe<_149.ClearAdminProposal>;
                fromPartial(object: import("../helpers").DeepPartial<_149.ClearAdminProposal>): _149.ClearAdminProposal;
                fromSDK(object: _149.ClearAdminProposalSDKType): _149.ClearAdminProposal;
                fromSDKJSON(object: any): _149.ClearAdminProposalSDKType;
                toSDK(message: _149.ClearAdminProposal): _149.ClearAdminProposalSDKType;
                fromAmino(object: _149.ClearAdminProposalAmino): _149.ClearAdminProposal;
                toAmino(message: _149.ClearAdminProposal): _149.ClearAdminProposalAmino;
                fromAminoMsg(object: _149.ClearAdminProposalAminoMsg): _149.ClearAdminProposal;
                toAminoMsg(message: _149.ClearAdminProposal): _149.ClearAdminProposalAminoMsg;
                fromProtoMsg(message: _149.ClearAdminProposalProtoMsg): _149.ClearAdminProposal;
                toProto(message: _149.ClearAdminProposal): Uint8Array;
                toProtoMsg(message: _149.ClearAdminProposal): _149.ClearAdminProposalProtoMsg;
                registerTypeUrl(): void;
            };
            PinCodesProposal: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _149.PinCodesProposal;
                isSDK(o: any): o is _149.PinCodesProposalSDKType;
                isAmino(o: any): o is _149.PinCodesProposalAmino;
                encode(message: _149.PinCodesProposal, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _149.PinCodesProposal;
                fromJSON(object: any): _149.PinCodesProposal;
                toJSON(message: _149.PinCodesProposal): import("..").JsonSafe<_149.PinCodesProposal>;
                fromPartial(object: import("../helpers").DeepPartial<_149.PinCodesProposal>): _149.PinCodesProposal;
                fromSDK(object: _149.PinCodesProposalSDKType): _149.PinCodesProposal;
                fromSDKJSON(object: any): _149.PinCodesProposalSDKType;
                toSDK(message: _149.PinCodesProposal): _149.PinCodesProposalSDKType;
                fromAmino(object: _149.PinCodesProposalAmino): _149.PinCodesProposal;
                toAmino(message: _149.PinCodesProposal): _149.PinCodesProposalAmino;
                fromAminoMsg(object: _149.PinCodesProposalAminoMsg): _149.PinCodesProposal;
                toAminoMsg(message: _149.PinCodesProposal): _149.PinCodesProposalAminoMsg;
                fromProtoMsg(message: _149.PinCodesProposalProtoMsg): _149.PinCodesProposal;
                toProto(message: _149.PinCodesProposal): Uint8Array;
                toProtoMsg(message: _149.PinCodesProposal): _149.PinCodesProposalProtoMsg;
                registerTypeUrl(): void;
            };
            UnpinCodesProposal: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _149.UnpinCodesProposal;
                isSDK(o: any): o is _149.UnpinCodesProposalSDKType;
                isAmino(o: any): o is _149.UnpinCodesProposalAmino;
                encode(message: _149.UnpinCodesProposal, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _149.UnpinCodesProposal;
                fromJSON(object: any): _149.UnpinCodesProposal;
                toJSON(message: _149.UnpinCodesProposal): import("..").JsonSafe<_149.UnpinCodesProposal>;
                fromPartial(object: import("../helpers").DeepPartial<_149.UnpinCodesProposal>): _149.UnpinCodesProposal;
                fromSDK(object: _149.UnpinCodesProposalSDKType): _149.UnpinCodesProposal;
                fromSDKJSON(object: any): _149.UnpinCodesProposalSDKType;
                toSDK(message: _149.UnpinCodesProposal): _149.UnpinCodesProposalSDKType;
                fromAmino(object: _149.UnpinCodesProposalAmino): _149.UnpinCodesProposal;
                toAmino(message: _149.UnpinCodesProposal): _149.UnpinCodesProposalAmino;
                fromAminoMsg(object: _149.UnpinCodesProposalAminoMsg): _149.UnpinCodesProposal;
                toAminoMsg(message: _149.UnpinCodesProposal): _149.UnpinCodesProposalAminoMsg;
                fromProtoMsg(message: _149.UnpinCodesProposalProtoMsg): _149.UnpinCodesProposal;
                toProto(message: _149.UnpinCodesProposal): Uint8Array;
                toProtoMsg(message: _149.UnpinCodesProposal): _149.UnpinCodesProposalProtoMsg;
                registerTypeUrl(): void;
            };
            MsgIBCSend: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _148.MsgIBCSend;
                isSDK(o: any): o is _148.MsgIBCSendSDKType;
                isAmino(o: any): o is _148.MsgIBCSendAmino;
                encode(message: _148.MsgIBCSend, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _148.MsgIBCSend;
                fromJSON(object: any): _148.MsgIBCSend;
                toJSON(message: _148.MsgIBCSend): import("..").JsonSafe<_148.MsgIBCSend>;
                fromPartial(object: import("../helpers").DeepPartial<_148.MsgIBCSend>): _148.MsgIBCSend;
                fromSDK(object: _148.MsgIBCSendSDKType): _148.MsgIBCSend;
                fromSDKJSON(object: any): _148.MsgIBCSendSDKType;
                toSDK(message: _148.MsgIBCSend): _148.MsgIBCSendSDKType;
                fromAmino(object: _148.MsgIBCSendAmino): _148.MsgIBCSend;
                toAmino(message: _148.MsgIBCSend): _148.MsgIBCSendAmino;
                fromAminoMsg(object: _148.MsgIBCSendAminoMsg): _148.MsgIBCSend;
                toAminoMsg(message: _148.MsgIBCSend): _148.MsgIBCSendAminoMsg;
                fromProtoMsg(message: _148.MsgIBCSendProtoMsg): _148.MsgIBCSend;
                toProto(message: _148.MsgIBCSend): Uint8Array;
                toProtoMsg(message: _148.MsgIBCSend): _148.MsgIBCSendProtoMsg;
                registerTypeUrl(): void;
            };
            MsgIBCCloseChannel: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _148.MsgIBCCloseChannel;
                isSDK(o: any): o is _148.MsgIBCCloseChannelSDKType;
                isAmino(o: any): o is _148.MsgIBCCloseChannelAmino;
                encode(message: _148.MsgIBCCloseChannel, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _148.MsgIBCCloseChannel;
                fromJSON(object: any): _148.MsgIBCCloseChannel;
                toJSON(message: _148.MsgIBCCloseChannel): import("..").JsonSafe<_148.MsgIBCCloseChannel>;
                fromPartial(object: import("../helpers").DeepPartial<_148.MsgIBCCloseChannel>): _148.MsgIBCCloseChannel;
                fromSDK(object: _148.MsgIBCCloseChannelSDKType): _148.MsgIBCCloseChannel;
                fromSDKJSON(object: any): _148.MsgIBCCloseChannelSDKType;
                toSDK(message: _148.MsgIBCCloseChannel): _148.MsgIBCCloseChannelSDKType;
                fromAmino(object: _148.MsgIBCCloseChannelAmino): _148.MsgIBCCloseChannel;
                toAmino(message: _148.MsgIBCCloseChannel): _148.MsgIBCCloseChannelAmino;
                fromAminoMsg(object: _148.MsgIBCCloseChannelAminoMsg): _148.MsgIBCCloseChannel;
                toAminoMsg(message: _148.MsgIBCCloseChannel): _148.MsgIBCCloseChannelAminoMsg;
                fromProtoMsg(message: _148.MsgIBCCloseChannelProtoMsg): _148.MsgIBCCloseChannel;
                toProto(message: _148.MsgIBCCloseChannel): Uint8Array;
                toProtoMsg(message: _148.MsgIBCCloseChannel): _148.MsgIBCCloseChannelProtoMsg;
                registerTypeUrl(): void;
            };
            GenesisState: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _147.GenesisState;
                isSDK(o: any): o is _147.GenesisStateSDKType;
                isAmino(o: any): o is _147.GenesisStateAmino;
                encode(message: _147.GenesisState, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _147.GenesisState;
                fromJSON(object: any): _147.GenesisState;
                toJSON(message: _147.GenesisState): import("..").JsonSafe<_147.GenesisState>;
                fromPartial(object: import("../helpers").DeepPartial<_147.GenesisState>): _147.GenesisState;
                fromSDK(object: _147.GenesisStateSDKType): _147.GenesisState;
                fromSDKJSON(object: any): _147.GenesisStateSDKType;
                toSDK(message: _147.GenesisState): _147.GenesisStateSDKType;
                fromAmino(object: _147.GenesisStateAmino): _147.GenesisState;
                toAmino(message: _147.GenesisState): _147.GenesisStateAmino;
                fromAminoMsg(object: _147.GenesisStateAminoMsg): _147.GenesisState;
                toAminoMsg(message: _147.GenesisState): _147.GenesisStateAminoMsg;
                fromProtoMsg(message: _147.GenesisStateProtoMsg): _147.GenesisState;
                toProto(message: _147.GenesisState): Uint8Array;
                toProtoMsg(message: _147.GenesisState): _147.GenesisStateProtoMsg;
                registerTypeUrl(): void;
            };
            GenesisState_GenMsgs: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _147.GenesisState_GenMsgs;
                isSDK(o: any): o is _147.GenesisState_GenMsgsSDKType;
                isAmino(o: any): o is _147.GenesisState_GenMsgsAmino;
                encode(message: _147.GenesisState_GenMsgs, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _147.GenesisState_GenMsgs;
                fromJSON(object: any): _147.GenesisState_GenMsgs;
                toJSON(message: _147.GenesisState_GenMsgs): import("..").JsonSafe<_147.GenesisState_GenMsgs>;
                fromPartial(object: import("../helpers").DeepPartial<_147.GenesisState_GenMsgs>): _147.GenesisState_GenMsgs;
                fromSDK(object: _147.GenesisState_GenMsgsSDKType): _147.GenesisState_GenMsgs;
                fromSDKJSON(object: any): _147.GenesisState_GenMsgsSDKType;
                toSDK(message: _147.GenesisState_GenMsgs): _147.GenesisState_GenMsgsSDKType;
                fromAmino(object: _147.GenesisState_GenMsgsAmino): _147.GenesisState_GenMsgs;
                toAmino(message: _147.GenesisState_GenMsgs): _147.GenesisState_GenMsgsAmino;
                fromAminoMsg(object: _147.GenesisState_GenMsgsAminoMsg): _147.GenesisState_GenMsgs;
                toAminoMsg(message: _147.GenesisState_GenMsgs): _147.GenesisState_GenMsgsAminoMsg;
                fromProtoMsg(message: _147.GenesisState_GenMsgsProtoMsg): _147.GenesisState_GenMsgs;
                toProto(message: _147.GenesisState_GenMsgs): Uint8Array;
                toProtoMsg(message: _147.GenesisState_GenMsgs): _147.GenesisState_GenMsgsProtoMsg;
                registerTypeUrl(): void;
            };
            Code: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _147.Code;
                isSDK(o: any): o is _147.CodeSDKType;
                isAmino(o: any): o is _147.CodeAmino;
                encode(message: _147.Code, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _147.Code;
                fromJSON(object: any): _147.Code;
                toJSON(message: _147.Code): import("..").JsonSafe<_147.Code>;
                fromPartial(object: import("../helpers").DeepPartial<_147.Code>): _147.Code;
                fromSDK(object: _147.CodeSDKType): _147.Code;
                fromSDKJSON(object: any): _147.CodeSDKType;
                toSDK(message: _147.Code): _147.CodeSDKType;
                fromAmino(object: _147.CodeAmino): _147.Code;
                toAmino(message: _147.Code): _147.CodeAmino;
                fromAminoMsg(object: _147.CodeAminoMsg): _147.Code;
                toAminoMsg(message: _147.Code): _147.CodeAminoMsg;
                fromProtoMsg(message: _147.CodeProtoMsg): _147.Code;
                toProto(message: _147.Code): Uint8Array;
                toProtoMsg(message: _147.Code): _147.CodeProtoMsg;
                registerTypeUrl(): void;
            };
            Contract: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _147.Contract;
                isSDK(o: any): o is _147.ContractSDKType;
                isAmino(o: any): o is _147.ContractAmino;
                encode(message: _147.Contract, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _147.Contract;
                fromJSON(object: any): _147.Contract;
                toJSON(message: _147.Contract): import("..").JsonSafe<_147.Contract>;
                fromPartial(object: import("../helpers").DeepPartial<_147.Contract>): _147.Contract;
                fromSDK(object: _147.ContractSDKType): _147.Contract;
                fromSDKJSON(object: any): _147.ContractSDKType;
                toSDK(message: _147.Contract): _147.ContractSDKType;
                fromAmino(object: _147.ContractAmino): _147.Contract;
                toAmino(message: _147.Contract): _147.ContractAmino;
                fromAminoMsg(object: _147.ContractAminoMsg): _147.Contract;
                toAminoMsg(message: _147.Contract): _147.ContractAminoMsg;
                fromProtoMsg(message: _147.ContractProtoMsg): _147.Contract;
                toProto(message: _147.Contract): Uint8Array;
                toProtoMsg(message: _147.Contract): _147.ContractProtoMsg;
                registerTypeUrl(): void;
            };
            Sequence: {
                typeUrl: string;
                aminoType: string;
                is(o: any): o is _147.Sequence;
                isSDK(o: any): o is _147.SequenceSDKType;
                isAmino(o: any): o is _147.SequenceAmino;
                encode(message: _147.Sequence, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _147.Sequence;
                fromJSON(object: any): _147.Sequence;
                toJSON(message: _147.Sequence): import("..").JsonSafe<_147.Sequence>;
                fromPartial(object: import("../helpers").DeepPartial<_147.Sequence>): _147.Sequence;
                fromSDK(object: _147.SequenceSDKType): _147.Sequence;
                fromSDKJSON(object: any): _147.SequenceSDKType;
                toSDK(message: _147.Sequence): _147.SequenceSDKType;
                fromAmino(object: _147.SequenceAmino): _147.Sequence;
                toAmino(message: _147.Sequence): _147.SequenceAmino;
                fromAminoMsg(object: _147.SequenceAminoMsg): _147.Sequence;
                toAminoMsg(message: _147.Sequence): _147.SequenceAminoMsg;
                fromProtoMsg(message: _147.SequenceProtoMsg): _147.Sequence;
                toProto(message: _147.Sequence): Uint8Array;
                toProtoMsg(message: _147.Sequence): _147.SequenceProtoMsg;
                registerTypeUrl(): void;
            };
        };
    }
    const ClientFactory: {
        createRPCMsgClient: ({ rpc }: {
            rpc: import("../helpers").Rpc;
        }) => Promise<{
            cosmos: {
                authz: {
                    v1beta1: import("../cosmos/authz/v1beta1/tx.rpc.msg").MsgClientImpl;
                };
                bank: {
                    v1beta1: import("../cosmos/bank/v1beta1/tx.rpc.msg").MsgClientImpl;
                };
                crisis: {
                    v1beta1: import("../cosmos/crisis/v1beta1/tx.rpc.msg").MsgClientImpl;
                };
                distribution: {
                    v1beta1: import("../cosmos/distribution/v1beta1/tx.rpc.msg").MsgClientImpl;
                };
                evidence: {
                    v1beta1: import("../cosmos/evidence/v1beta1/tx.rpc.msg").MsgClientImpl;
                };
                feegrant: {
                    v1beta1: import("../cosmos/feegrant/v1beta1/tx.rpc.msg").MsgClientImpl;
                };
                gov: {
                    v1: import("../cosmos/gov/v1/tx.rpc.msg").MsgClientImpl;
                    v1beta1: import("../cosmos/gov/v1beta1/tx.rpc.msg").MsgClientImpl;
                };
                group: {
                    v1: import("../cosmos/group/v1/tx.rpc.msg").MsgClientImpl;
                };
                nft: {
                    v1beta1: import("../cosmos/nft/v1beta1/tx.rpc.msg").MsgClientImpl;
                };
                slashing: {
                    v1beta1: import("../cosmos/slashing/v1beta1/tx.rpc.msg").MsgClientImpl;
                };
                staking: {
                    v1beta1: import("../cosmos/staking/v1beta1/tx.rpc.msg").MsgClientImpl;
                };
                upgrade: {
                    v1beta1: import("../cosmos/upgrade/v1beta1/tx.rpc.msg").MsgClientImpl;
                };
                vesting: {
                    v1beta1: import("../cosmos/vesting/v1beta1/tx.rpc.msg").MsgClientImpl;
                };
            };
            cosmwasm: {
                wasm: {
                    v1: _443.MsgClientImpl;
                };
            };
        }>;
        createRPCQueryClient: ({ rpc }: {
            rpc: import("../helpers").Rpc;
        }) => Promise<{
            cosmos: {
                app: {
                    v1alpha1: import("../cosmos/app/v1alpha1/query.rpc.Query").QueryClientImpl;
                };
                auth: {
                    v1beta1: import("../cosmos/auth/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                authz: {
                    v1beta1: import("../cosmos/authz/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                bank: {
                    v1beta1: import("../cosmos/bank/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                base: {
                    reflection: {
                        v1beta1: import("../cosmos/base/reflection/v1beta1/reflection.rpc.ReflectionService").ReflectionServiceClientImpl;
                        v2alpha1: import("../cosmos/base/reflection/v2alpha1/reflection.rpc.ReflectionService").ReflectionServiceClientImpl;
                    };
                    tendermint: {
                        v1beta1: import("../cosmos/base/tendermint/v1beta1/query.rpc.Service").ServiceClientImpl;
                    };
                };
                distribution: {
                    v1beta1: import("../cosmos/distribution/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                evidence: {
                    v1beta1: import("../cosmos/evidence/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                feegrant: {
                    v1beta1: import("../cosmos/feegrant/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                gov: {
                    v1: import("../cosmos/gov/v1/query.rpc.Query").QueryClientImpl;
                    v1beta1: import("../cosmos/gov/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                group: {
                    v1: import("../cosmos/group/v1/query.rpc.Query").QueryClientImpl;
                };
                mint: {
                    v1beta1: import("../cosmos/mint/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                nft: {
                    v1beta1: import("../cosmos/nft/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                params: {
                    v1beta1: import("../cosmos/params/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                slashing: {
                    v1beta1: import("../cosmos/slashing/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                staking: {
                    v1beta1: import("../cosmos/staking/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                tx: {
                    v1beta1: import("../cosmos/tx/v1beta1/service.rpc.Service").ServiceClientImpl;
                };
                upgrade: {
                    v1beta1: import("../cosmos/upgrade/v1beta1/query.rpc.Query").QueryClientImpl;
                };
            };
            cosmwasm: {
                wasm: {
                    v1: _442.QueryClientImpl;
                };
            };
        }>;
        createLCDClient: ({ restEndpoint }: {
            restEndpoint: string;
        }) => Promise<{
            cosmos: {
                auth: {
                    v1beta1: import("../cosmos/auth/v1beta1/query.lcd").LCDQueryClient;
                };
                authz: {
                    v1beta1: import("../cosmos/authz/v1beta1/query.lcd").LCDQueryClient;
                };
                bank: {
                    v1beta1: import("../cosmos/bank/v1beta1/query.lcd").LCDQueryClient;
                };
                base: {
                    reflection: {
                        v1beta1: import("../cosmos/base/reflection/v1beta1/reflection.lcd").LCDQueryClient;
                        v2alpha1: import("../cosmos/base/reflection/v2alpha1/reflection.lcd").LCDQueryClient;
                    };
                    tendermint: {
                        v1beta1: import("../cosmos/base/tendermint/v1beta1/query.lcd").LCDQueryClient;
                    };
                };
                distribution: {
                    v1beta1: import("../cosmos/distribution/v1beta1/query.lcd").LCDQueryClient;
                };
                evidence: {
                    v1beta1: import("../cosmos/evidence/v1beta1/query.lcd").LCDQueryClient;
                };
                feegrant: {
                    v1beta1: import("../cosmos/feegrant/v1beta1/query.lcd").LCDQueryClient;
                };
                gov: {
                    v1: import("../cosmos/gov/v1/query.lcd").LCDQueryClient;
                    v1beta1: import("../cosmos/gov/v1beta1/query.lcd").LCDQueryClient;
                };
                group: {
                    v1: import("../cosmos/group/v1/query.lcd").LCDQueryClient;
                };
                mint: {
                    v1beta1: import("../cosmos/mint/v1beta1/query.lcd").LCDQueryClient;
                };
                nft: {
                    v1beta1: import("../cosmos/nft/v1beta1/query.lcd").LCDQueryClient;
                };
                params: {
                    v1beta1: import("../cosmos/params/v1beta1/query.lcd").LCDQueryClient;
                };
                slashing: {
                    v1beta1: import("../cosmos/slashing/v1beta1/query.lcd").LCDQueryClient;
                };
                staking: {
                    v1beta1: import("../cosmos/staking/v1beta1/query.lcd").LCDQueryClient;
                };
                tx: {
                    v1beta1: import("../cosmos/tx/v1beta1/service.lcd").LCDQueryClient;
                };
                upgrade: {
                    v1beta1: import("../cosmos/upgrade/v1beta1/query.lcd").LCDQueryClient;
                };
            };
            cosmwasm: {
                wasm: {
                    v1: _441.LCDQueryClient;
                };
            };
        }>;
    };
}
