import { TelescopeGeneratedType } from "../../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgStoreCode, MsgInstantiateContract, MsgExecuteContract, MsgMigrateContract, MsgUpdateAdmin, MsgClearAdmin } from "./tx";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        storeCode(value: MsgStoreCode): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        instantiateContract(value: MsgInstantiateContract): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        executeContract(value: MsgExecuteContract): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        migrateContract(value: MsgMigrateContract): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        updateAdmin(value: MsgUpdateAdmin): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        clearAdmin(value: MsgClearAdmin): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        storeCode(value: MsgStoreCode): {
            typeUrl: string;
            value: MsgStoreCode;
        };
        instantiateContract(value: MsgInstantiateContract): {
            typeUrl: string;
            value: MsgInstantiateContract;
        };
        executeContract(value: MsgExecuteContract): {
            typeUrl: string;
            value: MsgExecuteContract;
        };
        migrateContract(value: MsgMigrateContract): {
            typeUrl: string;
            value: MsgMigrateContract;
        };
        updateAdmin(value: MsgUpdateAdmin): {
            typeUrl: string;
            value: MsgUpdateAdmin;
        };
        clearAdmin(value: MsgClearAdmin): {
            typeUrl: string;
            value: MsgClearAdmin;
        };
    };
    toJSON: {
        storeCode(value: MsgStoreCode): {
            typeUrl: string;
            value: {
                sender: string;
                wasmByteCode: string;
                instantiatePermission?: {
                    permission: import("./types").AccessType;
                    address: string;
                };
            };
        };
        instantiateContract(value: MsgInstantiateContract): {
            typeUrl: string;
            value: {
                sender: string;
                admin: string;
                codeId: string;
                label: string;
                msg: string;
                funds: {
                    denom: string;
                    amount: string;
                }[];
            };
        };
        executeContract(value: MsgExecuteContract): {
            typeUrl: string;
            value: {
                sender: string;
                contract: string;
                msg: string;
                funds: {
                    denom: string;
                    amount: string;
                }[];
            };
        };
        migrateContract(value: MsgMigrateContract): {
            typeUrl: string;
            value: {
                sender: string;
                contract: string;
                codeId: string;
                msg: string;
            };
        };
        updateAdmin(value: MsgUpdateAdmin): {
            typeUrl: string;
            value: {
                sender: string;
                newAdmin: string;
                contract: string;
            };
        };
        clearAdmin(value: MsgClearAdmin): {
            typeUrl: string;
            value: {
                sender: string;
                contract: string;
            };
        };
    };
    fromJSON: {
        storeCode(value: any): {
            typeUrl: string;
            value: MsgStoreCode;
        };
        instantiateContract(value: any): {
            typeUrl: string;
            value: MsgInstantiateContract;
        };
        executeContract(value: any): {
            typeUrl: string;
            value: MsgExecuteContract;
        };
        migrateContract(value: any): {
            typeUrl: string;
            value: MsgMigrateContract;
        };
        updateAdmin(value: any): {
            typeUrl: string;
            value: MsgUpdateAdmin;
        };
        clearAdmin(value: any): {
            typeUrl: string;
            value: MsgClearAdmin;
        };
    };
    fromPartial: {
        storeCode(value: MsgStoreCode): {
            typeUrl: string;
            value: MsgStoreCode;
        };
        instantiateContract(value: MsgInstantiateContract): {
            typeUrl: string;
            value: MsgInstantiateContract;
        };
        executeContract(value: MsgExecuteContract): {
            typeUrl: string;
            value: MsgExecuteContract;
        };
        migrateContract(value: MsgMigrateContract): {
            typeUrl: string;
            value: MsgMigrateContract;
        };
        updateAdmin(value: MsgUpdateAdmin): {
            typeUrl: string;
            value: MsgUpdateAdmin;
        };
        clearAdmin(value: MsgClearAdmin): {
            typeUrl: string;
            value: MsgClearAdmin;
        };
    };
};
