import { Attribute } from "../../base/v1beta1/attribute";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.audit.v1beta1";
function createBaseProvider() {
    return {
        owner: "",
        auditor: "",
        attributes: []
    };
}
export const Provider = {
    typeUrl: "/akash.audit.v1beta1.Provider",
    aminoType: "akash/audit/provider",
    is(o) {
        return o && (o.$typeUrl === Provider.typeUrl || typeof o.owner === "string" && typeof o.auditor === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.is(o.attributes[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Provider.typeUrl || typeof o.owner === "string" && typeof o.auditor === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isSDK(o.attributes[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Provider.typeUrl || typeof o.owner === "string" && typeof o.auditor === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isAmino(o.attributes[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.auditor !== undefined) {
            writer.uint32(18).string(message.auditor);
        }
        for (const v of message.attributes) {
            Attribute.encode(v, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseProvider();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.auditor = reader.string();
                    break;
                case 4:
                    message.attributes.push(Attribute.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseProvider();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.auditor))
            obj.auditor = String(object.auditor);
        if (Array.isArray(object?.attributes))
            obj.attributes = object.attributes.map((e) => Attribute.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.auditor !== undefined && (obj.auditor = message.auditor);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toJSON(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseProvider();
        message.owner = object.owner ?? "";
        message.auditor = object.auditor ?? "";
        message.attributes = object.attributes?.map(e => Attribute.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            auditor: object?.auditor,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            auditor: isSet(object.auditor) ? String(object.auditor) : "",
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.auditor = message.auditor;
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toSDK(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseProvider();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.auditor !== undefined && object.auditor !== null) {
            message.auditor = object.auditor;
        }
        message.attributes = object.attributes?.map(e => Attribute.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.auditor = message.auditor ?? "";
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toAmino(e) : undefined);
        }
        else {
            obj.attributes = message.attributes;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Provider.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/audit/provider",
            value: Provider.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Provider.decode(message.value);
    },
    toProto(message) {
        return Provider.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.audit.v1beta1.Provider",
            value: Provider.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Attribute.registerTypeUrl();
    }
};
function createBaseAuditedAttributes() {
    return {
        owner: "",
        auditor: "",
        attributes: []
    };
}
export const AuditedAttributes = {
    typeUrl: "/akash.audit.v1beta1.AuditedAttributes",
    aminoType: "akash/audit/audited-attributes",
    is(o) {
        return o && (o.$typeUrl === AuditedAttributes.typeUrl || typeof o.owner === "string" && typeof o.auditor === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.is(o.attributes[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === AuditedAttributes.typeUrl || typeof o.owner === "string" && typeof o.auditor === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isSDK(o.attributes[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === AuditedAttributes.typeUrl || typeof o.owner === "string" && typeof o.auditor === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isAmino(o.attributes[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.auditor !== undefined) {
            writer.uint32(18).string(message.auditor);
        }
        for (const v of message.attributes) {
            Attribute.encode(v, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAuditedAttributes();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.auditor = reader.string();
                    break;
                case 3:
                    message.attributes.push(Attribute.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAuditedAttributes();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.auditor))
            obj.auditor = String(object.auditor);
        if (Array.isArray(object?.attributes))
            obj.attributes = object.attributes.map((e) => Attribute.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.auditor !== undefined && (obj.auditor = message.auditor);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toJSON(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAuditedAttributes();
        message.owner = object.owner ?? "";
        message.auditor = object.auditor ?? "";
        message.attributes = object.attributes?.map(e => Attribute.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            auditor: object?.auditor,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            auditor: isSet(object.auditor) ? String(object.auditor) : "",
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.auditor = message.auditor;
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toSDK(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAuditedAttributes();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.auditor !== undefined && object.auditor !== null) {
            message.auditor = object.auditor;
        }
        message.attributes = object.attributes?.map(e => Attribute.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.auditor = message.auditor ?? "";
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toAmino(e) : undefined);
        }
        else {
            obj.attributes = message.attributes;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return AuditedAttributes.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/audit/audited-attributes",
            value: AuditedAttributes.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return AuditedAttributes.decode(message.value);
    },
    toProto(message) {
        return AuditedAttributes.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.audit.v1beta1.AuditedAttributes",
            value: AuditedAttributes.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Attribute.registerTypeUrl();
    }
};
function createBaseAttributesResponse() {
    return {
        attributes: []
    };
}
export const AttributesResponse = {
    typeUrl: "/akash.audit.v1beta1.AttributesResponse",
    aminoType: "akash/audit/attributes-response",
    is(o) {
        return o && (o.$typeUrl === AttributesResponse.typeUrl || Array.isArray(o.attributes) && (!o.attributes.length || AuditedAttributes.is(o.attributes[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === AttributesResponse.typeUrl || Array.isArray(o.attributes) && (!o.attributes.length || AuditedAttributes.isSDK(o.attributes[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === AttributesResponse.typeUrl || Array.isArray(o.attributes) && (!o.attributes.length || AuditedAttributes.isAmino(o.attributes[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.attributes) {
            AuditedAttributes.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAttributesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.attributes.push(AuditedAttributes.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAttributesResponse();
        if (Array.isArray(object?.attributes))
            obj.attributes = object.attributes.map((e) => AuditedAttributes.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? AuditedAttributes.toJSON(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAttributesResponse();
        message.attributes = object.attributes?.map(e => AuditedAttributes.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => AuditedAttributes.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => AuditedAttributes.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? AuditedAttributes.toSDK(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAttributesResponse();
        message.attributes = object.attributes?.map(e => AuditedAttributes.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? AuditedAttributes.toAmino(e) : undefined);
        }
        else {
            obj.attributes = message.attributes;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return AttributesResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/audit/attributes-response",
            value: AttributesResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return AttributesResponse.decode(message.value);
    },
    toProto(message) {
        return AttributesResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.audit.v1beta1.AttributesResponse",
            value: AttributesResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        AuditedAttributes.registerTypeUrl();
    }
};
function createBaseAttributesFilters() {
    return {
        auditors: [],
        owners: []
    };
}
export const AttributesFilters = {
    typeUrl: "/akash.audit.v1beta1.AttributesFilters",
    aminoType: "akash/audit/attributes-filters",
    is(o) {
        return o && (o.$typeUrl === AttributesFilters.typeUrl || Array.isArray(o.auditors) && (!o.auditors.length || typeof o.auditors[0] === "string") && Array.isArray(o.owners) && (!o.owners.length || typeof o.owners[0] === "string"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === AttributesFilters.typeUrl || Array.isArray(o.auditors) && (!o.auditors.length || typeof o.auditors[0] === "string") && Array.isArray(o.owners) && (!o.owners.length || typeof o.owners[0] === "string"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === AttributesFilters.typeUrl || Array.isArray(o.auditors) && (!o.auditors.length || typeof o.auditors[0] === "string") && Array.isArray(o.owners) && (!o.owners.length || typeof o.owners[0] === "string"));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.auditors) {
            writer.uint32(10).string(v);
        }
        for (const v of message.owners) {
            writer.uint32(18).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAttributesFilters();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.auditors.push(reader.string());
                    break;
                case 2:
                    message.owners.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAttributesFilters();
        if (Array.isArray(object?.auditors))
            obj.auditors = object.auditors.map((e) => String(e));
        if (Array.isArray(object?.owners))
            obj.owners = object.owners.map((e) => String(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.auditors) {
            obj.auditors = message.auditors.map(e => e);
        }
        else {
            obj.auditors = [];
        }
        if (message.owners) {
            obj.owners = message.owners.map(e => e);
        }
        else {
            obj.owners = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAttributesFilters();
        message.auditors = object.auditors?.map(e => e) || [];
        message.owners = object.owners?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            auditors: Array.isArray(object?.auditors) ? object.auditors.map((e) => e) : [],
            owners: Array.isArray(object?.owners) ? object.owners.map((e) => e) : []
        };
    },
    fromSDKJSON(object) {
        return {
            auditors: Array.isArray(object?.auditors) ? object.auditors.map((e) => String(e)) : [],
            owners: Array.isArray(object?.owners) ? object.owners.map((e) => String(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.auditors) {
            obj.auditors = message.auditors.map(e => e);
        }
        else {
            obj.auditors = [];
        }
        if (message.owners) {
            obj.owners = message.owners.map(e => e);
        }
        else {
            obj.owners = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAttributesFilters();
        message.auditors = object.auditors?.map(e => e) || [];
        message.owners = object.owners?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.auditors) {
            obj.auditors = message.auditors.map(e => e);
        }
        else {
            obj.auditors = message.auditors;
        }
        if (message.owners) {
            obj.owners = message.owners.map(e => e);
        }
        else {
            obj.owners = message.owners;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return AttributesFilters.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/audit/attributes-filters",
            value: AttributesFilters.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return AttributesFilters.decode(message.value);
    },
    toProto(message) {
        return AttributesFilters.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.audit.v1beta1.AttributesFilters",
            value: AttributesFilters.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgSignProviderAttributes() {
    return {
        owner: "",
        auditor: "",
        attributes: []
    };
}
export const MsgSignProviderAttributes = {
    typeUrl: "/akash.audit.v1beta1.MsgSignProviderAttributes",
    aminoType: "akash/audit/testonly-sign-provider-attributes",
    is(o) {
        return o && (o.$typeUrl === MsgSignProviderAttributes.typeUrl || typeof o.owner === "string" && typeof o.auditor === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.is(o.attributes[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgSignProviderAttributes.typeUrl || typeof o.owner === "string" && typeof o.auditor === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isSDK(o.attributes[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgSignProviderAttributes.typeUrl || typeof o.owner === "string" && typeof o.auditor === "string" && Array.isArray(o.attributes) && (!o.attributes.length || Attribute.isAmino(o.attributes[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.auditor !== undefined) {
            writer.uint32(18).string(message.auditor);
        }
        for (const v of message.attributes) {
            Attribute.encode(v, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgSignProviderAttributes();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.auditor = reader.string();
                    break;
                case 3:
                    message.attributes.push(Attribute.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgSignProviderAttributes();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.auditor))
            obj.auditor = String(object.auditor);
        if (Array.isArray(object?.attributes))
            obj.attributes = object.attributes.map((e) => Attribute.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.auditor !== undefined && (obj.auditor = message.auditor);
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toJSON(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgSignProviderAttributes();
        message.owner = object.owner ?? "";
        message.auditor = object.auditor ?? "";
        message.attributes = object.attributes?.map(e => Attribute.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            auditor: object?.auditor,
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            auditor: isSet(object.auditor) ? String(object.auditor) : "",
            attributes: Array.isArray(object?.attributes) ? object.attributes.map((e) => Attribute.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.auditor = message.auditor;
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toSDK(e) : undefined);
        }
        else {
            obj.attributes = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgSignProviderAttributes();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.auditor !== undefined && object.auditor !== null) {
            message.auditor = object.auditor;
        }
        message.attributes = object.attributes?.map(e => Attribute.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.auditor = message.auditor ?? "";
        if (message.attributes) {
            obj.attributes = message.attributes.map(e => e ? Attribute.toAmino(e) : undefined);
        }
        else {
            obj.attributes = message.attributes;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return MsgSignProviderAttributes.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/audit/testonly-sign-provider-attributes",
            value: MsgSignProviderAttributes.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgSignProviderAttributes.decode(message.value);
    },
    toProto(message) {
        return MsgSignProviderAttributes.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.audit.v1beta1.MsgSignProviderAttributes",
            value: MsgSignProviderAttributes.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Attribute.registerTypeUrl();
    }
};
function createBaseMsgSignProviderAttributesResponse() {
    return {};
}
export const MsgSignProviderAttributesResponse = {
    typeUrl: "/akash.audit.v1beta1.MsgSignProviderAttributesResponse",
    aminoType: "akash/audit/testonly-sign-provider-attributes-response",
    is(o) {
        return o && o.$typeUrl === MsgSignProviderAttributesResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgSignProviderAttributesResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgSignProviderAttributesResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgSignProviderAttributesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgSignProviderAttributesResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgSignProviderAttributesResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgSignProviderAttributesResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgSignProviderAttributesResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/audit/testonly-sign-provider-attributes-response",
            value: MsgSignProviderAttributesResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgSignProviderAttributesResponse.decode(message.value);
    },
    toProto(message) {
        return MsgSignProviderAttributesResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.audit.v1beta1.MsgSignProviderAttributesResponse",
            value: MsgSignProviderAttributesResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgDeleteProviderAttributes() {
    return {
        owner: "",
        auditor: "",
        keys: []
    };
}
export const MsgDeleteProviderAttributes = {
    typeUrl: "/akash.audit.v1beta1.MsgDeleteProviderAttributes",
    aminoType: "akash/audit/testonly-delete-provider-attributes",
    is(o) {
        return o && (o.$typeUrl === MsgDeleteProviderAttributes.typeUrl || typeof o.owner === "string" && typeof o.auditor === "string" && Array.isArray(o.keys) && (!o.keys.length || typeof o.keys[0] === "string"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgDeleteProviderAttributes.typeUrl || typeof o.owner === "string" && typeof o.auditor === "string" && Array.isArray(o.keys) && (!o.keys.length || typeof o.keys[0] === "string"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgDeleteProviderAttributes.typeUrl || typeof o.owner === "string" && typeof o.auditor === "string" && Array.isArray(o.keys) && (!o.keys.length || typeof o.keys[0] === "string"));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.auditor !== undefined) {
            writer.uint32(18).string(message.auditor);
        }
        for (const v of message.keys) {
            writer.uint32(26).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgDeleteProviderAttributes();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.auditor = reader.string();
                    break;
                case 3:
                    message.keys.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgDeleteProviderAttributes();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.auditor))
            obj.auditor = String(object.auditor);
        if (Array.isArray(object?.keys))
            obj.keys = object.keys.map((e) => String(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.auditor !== undefined && (obj.auditor = message.auditor);
        if (message.keys) {
            obj.keys = message.keys.map(e => e);
        }
        else {
            obj.keys = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgDeleteProviderAttributes();
        message.owner = object.owner ?? "";
        message.auditor = object.auditor ?? "";
        message.keys = object.keys?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            auditor: object?.auditor,
            keys: Array.isArray(object?.keys) ? object.keys.map((e) => e) : []
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            auditor: isSet(object.auditor) ? String(object.auditor) : "",
            keys: Array.isArray(object?.keys) ? object.keys.map((e) => String(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.auditor = message.auditor;
        if (message.keys) {
            obj.keys = message.keys.map(e => e);
        }
        else {
            obj.keys = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgDeleteProviderAttributes();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.auditor !== undefined && object.auditor !== null) {
            message.auditor = object.auditor;
        }
        message.keys = object.keys?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.auditor = message.auditor ?? "";
        if (message.keys) {
            obj.keys = message.keys.map(e => e);
        }
        else {
            obj.keys = message.keys;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return MsgDeleteProviderAttributes.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/audit/testonly-delete-provider-attributes",
            value: MsgDeleteProviderAttributes.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgDeleteProviderAttributes.decode(message.value);
    },
    toProto(message) {
        return MsgDeleteProviderAttributes.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.audit.v1beta1.MsgDeleteProviderAttributes",
            value: MsgDeleteProviderAttributes.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgDeleteProviderAttributesResponse() {
    return {};
}
export const MsgDeleteProviderAttributesResponse = {
    typeUrl: "/akash.audit.v1beta1.MsgDeleteProviderAttributesResponse",
    aminoType: "akash/audit/testonly-delete-provider-attributes-response",
    is(o) {
        return o && o.$typeUrl === MsgDeleteProviderAttributesResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgDeleteProviderAttributesResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgDeleteProviderAttributesResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgDeleteProviderAttributesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgDeleteProviderAttributesResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgDeleteProviderAttributesResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgDeleteProviderAttributesResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgDeleteProviderAttributesResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/audit/testonly-delete-provider-attributes-response",
            value: MsgDeleteProviderAttributesResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgDeleteProviderAttributesResponse.decode(message.value);
    },
    toProto(message) {
        return MsgDeleteProviderAttributesResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.audit.v1beta1.MsgDeleteProviderAttributesResponse",
            value: MsgDeleteProviderAttributesResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
