import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet, bytesFromBase64, base64FromBytes } from "../../../helpers";
export const protobufPackage = "akash.base.v1beta1";
function createBaseResourceValue() {
    return {
        val: new Uint8Array()
    };
}
export const ResourceValue = {
    typeUrl: "/akash.base.v1beta1.ResourceValue",
    aminoType: "akash/base/resource-value",
    is(o) {
        return o && (o.$typeUrl === ResourceValue.typeUrl || o.val instanceof Uint8Array || typeof o.val === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ResourceValue.typeUrl || o.val instanceof Uint8Array || typeof o.val === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ResourceValue.typeUrl || o.val instanceof Uint8Array || typeof o.val === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.val.length !== 0) {
            writer.uint32(10).bytes(message.val);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseResourceValue();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.val = reader.bytes();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseResourceValue();
        if (isSet(object.val))
            obj.val = bytesFromBase64(object.val);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.val !== undefined && (obj.val = base64FromBytes(message.val !== undefined ? message.val : new Uint8Array()));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseResourceValue();
        message.val = object.val ?? new Uint8Array();
        return message;
    },
    fromSDK(object) {
        return {
            val: object?.val
        };
    },
    fromSDKJSON(object) {
        return {
            val: isSet(object.val) ? bytesFromBase64(object.val) : new Uint8Array()
        };
    },
    toSDK(message) {
        const obj = {};
        obj.val = message.val;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseResourceValue();
        if (object.val !== undefined && object.val !== null) {
            message.val = bytesFromBase64(object.val);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.val = message.val ? base64FromBytes(message.val) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return ResourceValue.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/base/resource-value",
            value: ResourceValue.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return ResourceValue.decode(message.value);
    },
    toProto(message) {
        return ResourceValue.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.base.v1beta1.ResourceValue",
            value: ResourceValue.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
