//@ts-nocheck
/* eslint-disable */
import { GroupSpec } from "./group";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet, bytesFromBase64, base64FromBytes } from "../../../helpers";
export const protobufPackage = "akash.deployment.v1beta1";
/** State is an enum which refers to state of deployment */
export var Deployment_State;
(function (Deployment_State) {
    /** invalid - Prefix should start with 0 in enum. So declaring dummy state */
    Deployment_State[Deployment_State["invalid"] = 0] = "invalid";
    /** active - DeploymentActive denotes state for deployment active */
    Deployment_State[Deployment_State["active"] = 1] = "active";
    /** closed - DeploymentClosed denotes state for deployment closed */
    Deployment_State[Deployment_State["closed"] = 2] = "closed";
    Deployment_State[Deployment_State["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(Deployment_State || (Deployment_State = {}));
export const Deployment_StateSDKType = Deployment_State;
export const Deployment_StateAmino = Deployment_State;
export function deployment_StateFromJSON(object) {
    switch (object) {
        case 0:
        case "invalid":
            return Deployment_State.invalid;
        case 1:
        case "active":
            return Deployment_State.active;
        case 2:
        case "closed":
            return Deployment_State.closed;
        case -1:
        case "UNRECOGNIZED":
        default:
            return Deployment_State.UNRECOGNIZED;
    }
}
export function deployment_StateToJSON(object) {
    switch (object) {
        case Deployment_State.invalid:
            return "invalid";
        case Deployment_State.active:
            return "active";
        case Deployment_State.closed:
            return "closed";
        case Deployment_State.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
function createBaseMsgCreateDeployment() {
    return {
        id: DeploymentID.fromPartial({}),
        groups: [],
        version: new Uint8Array(),
        deposit: Coin.fromPartial({})
    };
}
export const MsgCreateDeployment = {
    typeUrl: "/akash.deployment.v1beta1.MsgCreateDeployment",
    aminoType: "akash/deployment/testonly-create-deployment",
    is(o) {
        return o && (o.$typeUrl === MsgCreateDeployment.typeUrl || DeploymentID.is(o.id) && Array.isArray(o.groups) && (!o.groups.length || GroupSpec.is(o.groups[0])) && (o.version instanceof Uint8Array || typeof o.version === "string") && Coin.is(o.deposit));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgCreateDeployment.typeUrl || DeploymentID.isSDK(o.id) && Array.isArray(o.groups) && (!o.groups.length || GroupSpec.isSDK(o.groups[0])) && (o.version instanceof Uint8Array || typeof o.version === "string") && Coin.isSDK(o.deposit));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            DeploymentID.encode(message.id, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.groups) {
            GroupSpec.encode(v, writer.uint32(18).fork()).ldelim();
        }
        if (message.version.length !== 0) {
            writer.uint32(26).bytes(message.version);
        }
        if (message.deposit !== undefined) {
            Coin.encode(message.deposit, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCreateDeployment();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = DeploymentID.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.groups.push(GroupSpec.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.version = reader.bytes();
                    break;
                case 4:
                    message.deposit = Coin.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgCreateDeployment();
        if (isSet(object.id))
            obj.id = DeploymentID.fromJSON(object.id);
        if (Array.isArray(object?.groups))
            obj.groups = object.groups.map((e) => GroupSpec.fromJSON(e));
        if (isSet(object.version))
            obj.version = bytesFromBase64(object.version);
        if (isSet(object.deposit))
            obj.deposit = Coin.fromJSON(object.deposit);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? DeploymentID.toJSON(message.id) : undefined);
        if (message.groups) {
            obj.groups = message.groups.map(e => e ? GroupSpec.toJSON(e) : undefined);
        }
        else {
            obj.groups = [];
        }
        message.version !== undefined && (obj.version = base64FromBytes(message.version !== undefined ? message.version : new Uint8Array()));
        message.deposit !== undefined && (obj.deposit = message.deposit ? Coin.toJSON(message.deposit) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgCreateDeployment();
        if (object.id !== undefined && object.id !== null) {
            message.id = DeploymentID.fromPartial(object.id);
        }
        message.groups = object.groups?.map(e => GroupSpec.fromPartial(e)) || [];
        message.version = object.version ?? new Uint8Array();
        if (object.deposit !== undefined && object.deposit !== null) {
            message.deposit = Coin.fromPartial(object.deposit);
        }
        return message;
    },
    fromSDK(object) {
        return {
            id: object.id ? DeploymentID.fromSDK(object.id) : undefined,
            groups: Array.isArray(object?.groups) ? object.groups.map((e) => GroupSpec.fromSDK(e)) : [],
            version: object?.version,
            deposit: object.deposit ? Coin.fromSDK(object.deposit) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? DeploymentID.fromSDKJSON(object.id) : undefined,
            groups: Array.isArray(object?.groups) ? object.groups.map((e) => GroupSpec.fromSDKJSON(e)) : [],
            version: isSet(object.version) ? bytesFromBase64(object.version) : new Uint8Array(),
            deposit: isSet(object.deposit) ? Coin.fromSDKJSON(object.deposit) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? DeploymentID.toSDK(message.id) : undefined);
        if (message.groups) {
            obj.groups = message.groups.map(e => e ? GroupSpec.toSDK(e) : undefined);
        }
        else {
            obj.groups = [];
        }
        obj.version = message.version;
        message.deposit !== undefined && (obj.deposit = message.deposit ? Coin.toSDK(message.deposit) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgCreateDeployment();
        if (object.id !== undefined && object.id !== null) {
            message.id = DeploymentID.fromAmino(object.id);
        }
        message.groups = object.groups?.map(e => GroupSpec.fromAmino(e)) || [];
        if (object.version !== undefined && object.version !== null) {
            message.version = bytesFromBase64(object.version);
        }
        if (object.deposit !== undefined && object.deposit !== null) {
            message.deposit = Coin.fromAmino(object.deposit);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id ? DeploymentID.toAmino(message.id) : DeploymentID.toAmino(DeploymentID.fromPartial({}));
        if (message.groups) {
            obj.groups = message.groups.map(e => e ? GroupSpec.toAmino(e) : undefined);
        }
        else {
            obj.groups = message.groups;
        }
        obj.version = message.version ? base64FromBytes(message.version) : "";
        obj.deposit = message.deposit ? Coin.toAmino(message.deposit) : Coin.toAmino(Coin.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCreateDeployment.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/testonly-create-deployment",
            value: MsgCreateDeployment.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgCreateDeployment.decode(message.value);
    },
    toProto(message) {
        return MsgCreateDeployment.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.MsgCreateDeployment",
            value: MsgCreateDeployment.encode(message).finish()
        };
    },
    registerTypeUrl() {
        DeploymentID.registerTypeUrl();
        GroupSpec.registerTypeUrl();
        Coin.registerTypeUrl();
    }
};
function createBaseMsgCreateDeploymentResponse() {
    return {};
}
export const MsgCreateDeploymentResponse = {
    typeUrl: "/akash.deployment.v1beta1.MsgCreateDeploymentResponse",
    aminoType: "akash/deployment/testonly-create-deployment-response",
    is(o) {
        return o && o.$typeUrl === MsgCreateDeploymentResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgCreateDeploymentResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCreateDeploymentResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgCreateDeploymentResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgCreateDeploymentResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgCreateDeploymentResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCreateDeploymentResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/testonly-create-deployment-response",
            value: MsgCreateDeploymentResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgCreateDeploymentResponse.decode(message.value);
    },
    toProto(message) {
        return MsgCreateDeploymentResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.MsgCreateDeploymentResponse",
            value: MsgCreateDeploymentResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgDepositDeployment() {
    return {
        id: DeploymentID.fromPartial({}),
        amount: Coin.fromPartial({})
    };
}
export const MsgDepositDeployment = {
    typeUrl: "/akash.deployment.v1beta1.MsgDepositDeployment",
    aminoType: "akash/deployment/testonly-deposit-deployment",
    is(o) {
        return o && (o.$typeUrl === MsgDepositDeployment.typeUrl || DeploymentID.is(o.id) && Coin.is(o.amount));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgDepositDeployment.typeUrl || DeploymentID.isSDK(o.id) && Coin.isSDK(o.amount));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            DeploymentID.encode(message.id, writer.uint32(10).fork()).ldelim();
        }
        if (message.amount !== undefined) {
            Coin.encode(message.amount, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgDepositDeployment();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = DeploymentID.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.amount = Coin.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgDepositDeployment();
        if (isSet(object.id))
            obj.id = DeploymentID.fromJSON(object.id);
        if (isSet(object.amount))
            obj.amount = Coin.fromJSON(object.amount);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? DeploymentID.toJSON(message.id) : undefined);
        message.amount !== undefined && (obj.amount = message.amount ? Coin.toJSON(message.amount) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgDepositDeployment();
        if (object.id !== undefined && object.id !== null) {
            message.id = DeploymentID.fromPartial(object.id);
        }
        if (object.amount !== undefined && object.amount !== null) {
            message.amount = Coin.fromPartial(object.amount);
        }
        return message;
    },
    fromSDK(object) {
        return {
            id: object.id ? DeploymentID.fromSDK(object.id) : undefined,
            amount: object.amount ? Coin.fromSDK(object.amount) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? DeploymentID.fromSDKJSON(object.id) : undefined,
            amount: isSet(object.amount) ? Coin.fromSDKJSON(object.amount) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? DeploymentID.toSDK(message.id) : undefined);
        message.amount !== undefined && (obj.amount = message.amount ? Coin.toSDK(message.amount) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgDepositDeployment();
        if (object.id !== undefined && object.id !== null) {
            message.id = DeploymentID.fromAmino(object.id);
        }
        if (object.amount !== undefined && object.amount !== null) {
            message.amount = Coin.fromAmino(object.amount);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id ? DeploymentID.toAmino(message.id) : DeploymentID.toAmino(DeploymentID.fromPartial({}));
        obj.amount = message.amount ? Coin.toAmino(message.amount) : Coin.toAmino(Coin.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return MsgDepositDeployment.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/testonly-deposit-deployment",
            value: MsgDepositDeployment.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgDepositDeployment.decode(message.value);
    },
    toProto(message) {
        return MsgDepositDeployment.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.MsgDepositDeployment",
            value: MsgDepositDeployment.encode(message).finish()
        };
    },
    registerTypeUrl() {
        DeploymentID.registerTypeUrl();
        Coin.registerTypeUrl();
    }
};
function createBaseMsgDepositDeploymentResponse() {
    return {};
}
export const MsgDepositDeploymentResponse = {
    typeUrl: "/akash.deployment.v1beta1.MsgDepositDeploymentResponse",
    aminoType: "akash/deployment/testonly-deposit-deployment-response",
    is(o) {
        return o && o.$typeUrl === MsgDepositDeploymentResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgDepositDeploymentResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgDepositDeploymentResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgDepositDeploymentResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgDepositDeploymentResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgDepositDeploymentResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgDepositDeploymentResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/testonly-deposit-deployment-response",
            value: MsgDepositDeploymentResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgDepositDeploymentResponse.decode(message.value);
    },
    toProto(message) {
        return MsgDepositDeploymentResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.MsgDepositDeploymentResponse",
            value: MsgDepositDeploymentResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgUpdateDeployment() {
    return {
        id: DeploymentID.fromPartial({}),
        groups: [],
        version: new Uint8Array()
    };
}
export const MsgUpdateDeployment = {
    typeUrl: "/akash.deployment.v1beta1.MsgUpdateDeployment",
    aminoType: "akash/deployment/testonly-update-deployment",
    is(o) {
        return o && (o.$typeUrl === MsgUpdateDeployment.typeUrl || DeploymentID.is(o.id) && Array.isArray(o.groups) && (!o.groups.length || GroupSpec.is(o.groups[0])) && (o.version instanceof Uint8Array || typeof o.version === "string"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgUpdateDeployment.typeUrl || DeploymentID.isSDK(o.id) && Array.isArray(o.groups) && (!o.groups.length || GroupSpec.isSDK(o.groups[0])) && (o.version instanceof Uint8Array || typeof o.version === "string"));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            DeploymentID.encode(message.id, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.groups) {
            GroupSpec.encode(v, writer.uint32(18).fork()).ldelim();
        }
        if (message.version.length !== 0) {
            writer.uint32(26).bytes(message.version);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgUpdateDeployment();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = DeploymentID.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.groups.push(GroupSpec.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.version = reader.bytes();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgUpdateDeployment();
        if (isSet(object.id))
            obj.id = DeploymentID.fromJSON(object.id);
        if (Array.isArray(object?.groups))
            obj.groups = object.groups.map((e) => GroupSpec.fromJSON(e));
        if (isSet(object.version))
            obj.version = bytesFromBase64(object.version);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? DeploymentID.toJSON(message.id) : undefined);
        if (message.groups) {
            obj.groups = message.groups.map(e => e ? GroupSpec.toJSON(e) : undefined);
        }
        else {
            obj.groups = [];
        }
        message.version !== undefined && (obj.version = base64FromBytes(message.version !== undefined ? message.version : new Uint8Array()));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgUpdateDeployment();
        if (object.id !== undefined && object.id !== null) {
            message.id = DeploymentID.fromPartial(object.id);
        }
        message.groups = object.groups?.map(e => GroupSpec.fromPartial(e)) || [];
        message.version = object.version ?? new Uint8Array();
        return message;
    },
    fromSDK(object) {
        return {
            id: object.id ? DeploymentID.fromSDK(object.id) : undefined,
            groups: Array.isArray(object?.groups) ? object.groups.map((e) => GroupSpec.fromSDK(e)) : [],
            version: object?.version
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? DeploymentID.fromSDKJSON(object.id) : undefined,
            groups: Array.isArray(object?.groups) ? object.groups.map((e) => GroupSpec.fromSDKJSON(e)) : [],
            version: isSet(object.version) ? bytesFromBase64(object.version) : new Uint8Array()
        };
    },
    toSDK(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? DeploymentID.toSDK(message.id) : undefined);
        if (message.groups) {
            obj.groups = message.groups.map(e => e ? GroupSpec.toSDK(e) : undefined);
        }
        else {
            obj.groups = [];
        }
        obj.version = message.version;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgUpdateDeployment();
        if (object.id !== undefined && object.id !== null) {
            message.id = DeploymentID.fromAmino(object.id);
        }
        message.groups = object.groups?.map(e => GroupSpec.fromAmino(e)) || [];
        if (object.version !== undefined && object.version !== null) {
            message.version = bytesFromBase64(object.version);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id ? DeploymentID.toAmino(message.id) : DeploymentID.toAmino(DeploymentID.fromPartial({}));
        if (message.groups) {
            obj.groups = message.groups.map(e => e ? GroupSpec.toAmino(e) : undefined);
        }
        else {
            obj.groups = message.groups;
        }
        obj.version = message.version ? base64FromBytes(message.version) : "";
        return obj;
    },
    fromAminoMsg(object) {
        return MsgUpdateDeployment.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/testonly-update-deployment",
            value: MsgUpdateDeployment.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgUpdateDeployment.decode(message.value);
    },
    toProto(message) {
        return MsgUpdateDeployment.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.MsgUpdateDeployment",
            value: MsgUpdateDeployment.encode(message).finish()
        };
    },
    registerTypeUrl() {
        DeploymentID.registerTypeUrl();
        GroupSpec.registerTypeUrl();
    }
};
function createBaseMsgUpdateDeploymentResponse() {
    return {};
}
export const MsgUpdateDeploymentResponse = {
    typeUrl: "/akash.deployment.v1beta1.MsgUpdateDeploymentResponse",
    aminoType: "akash/deployment/testonly-update-deployment-response",
    is(o) {
        return o && o.$typeUrl === MsgUpdateDeploymentResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgUpdateDeploymentResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgUpdateDeploymentResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgUpdateDeploymentResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgUpdateDeploymentResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgUpdateDeploymentResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgUpdateDeploymentResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/testonly-update-deployment-response",
            value: MsgUpdateDeploymentResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgUpdateDeploymentResponse.decode(message.value);
    },
    toProto(message) {
        return MsgUpdateDeploymentResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.MsgUpdateDeploymentResponse",
            value: MsgUpdateDeploymentResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgCloseDeployment() {
    return {
        id: DeploymentID.fromPartial({})
    };
}
export const MsgCloseDeployment = {
    typeUrl: "/akash.deployment.v1beta1.MsgCloseDeployment",
    aminoType: "akash/deployment/testonly-close-deployment",
    is(o) {
        return o && (o.$typeUrl === MsgCloseDeployment.typeUrl || DeploymentID.is(o.id));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgCloseDeployment.typeUrl || DeploymentID.isSDK(o.id));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            DeploymentID.encode(message.id, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCloseDeployment();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = DeploymentID.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgCloseDeployment();
        if (isSet(object.id))
            obj.id = DeploymentID.fromJSON(object.id);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? DeploymentID.toJSON(message.id) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgCloseDeployment();
        if (object.id !== undefined && object.id !== null) {
            message.id = DeploymentID.fromPartial(object.id);
        }
        return message;
    },
    fromSDK(object) {
        return {
            id: object.id ? DeploymentID.fromSDK(object.id) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? DeploymentID.fromSDKJSON(object.id) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? DeploymentID.toSDK(message.id) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgCloseDeployment();
        if (object.id !== undefined && object.id !== null) {
            message.id = DeploymentID.fromAmino(object.id);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id ? DeploymentID.toAmino(message.id) : DeploymentID.toAmino(DeploymentID.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCloseDeployment.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/testonly-close-deployment",
            value: MsgCloseDeployment.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgCloseDeployment.decode(message.value);
    },
    toProto(message) {
        return MsgCloseDeployment.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.MsgCloseDeployment",
            value: MsgCloseDeployment.encode(message).finish()
        };
    },
    registerTypeUrl() {
        DeploymentID.registerTypeUrl();
    }
};
function createBaseMsgCloseDeploymentResponse() {
    return {};
}
export const MsgCloseDeploymentResponse = {
    typeUrl: "/akash.deployment.v1beta1.MsgCloseDeploymentResponse",
    aminoType: "akash/deployment/testonly-close-deployment-response",
    is(o) {
        return o && o.$typeUrl === MsgCloseDeploymentResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgCloseDeploymentResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCloseDeploymentResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgCloseDeploymentResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgCloseDeploymentResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgCloseDeploymentResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCloseDeploymentResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/testonly-close-deployment-response",
            value: MsgCloseDeploymentResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgCloseDeploymentResponse.decode(message.value);
    },
    toProto(message) {
        return MsgCloseDeploymentResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.MsgCloseDeploymentResponse",
            value: MsgCloseDeploymentResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseDeploymentID() {
    return {
        owner: "",
        dseq: BigInt(0)
    };
}
export const DeploymentID = {
    typeUrl: "/akash.deployment.v1beta1.DeploymentID",
    aminoType: "akash/deployment/deployment-i-d",
    is(o) {
        return o && (o.$typeUrl === DeploymentID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint");
    },
    isSDK(o) {
        return o && (o.$typeUrl === DeploymentID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.dseq !== undefined) {
            writer.uint32(16).uint64(message.dseq);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeploymentID();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.dseq = reader.uint64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDeploymentID();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.dseq))
            obj.dseq = BigInt(object.dseq.toString());
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.dseq !== undefined && (obj.dseq = (message.dseq || BigInt(0)).toString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDeploymentID();
        message.owner = object.owner ?? "";
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq.toString());
        }
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            dseq: object?.dseq
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            dseq: isSet(object.dseq) ? BigInt(object.dseq.toString()) : BigInt(0)
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.dseq = message.dseq;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDeploymentID();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.dseq = message.dseq ? message.dseq?.toString() : "0";
        return obj;
    },
    fromAminoMsg(object) {
        return DeploymentID.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/deployment-i-d",
            value: DeploymentID.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return DeploymentID.decode(message.value);
    },
    toProto(message) {
        return DeploymentID.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.DeploymentID",
            value: DeploymentID.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseDeployment() {
    return {
        deploymentId: DeploymentID.fromPartial({}),
        state: 0,
        version: new Uint8Array(),
        createdAt: BigInt(0)
    };
}
export const Deployment = {
    typeUrl: "/akash.deployment.v1beta1.Deployment",
    aminoType: "akash/deployment/deployment",
    is(o) {
        return o && (o.$typeUrl === Deployment.typeUrl || DeploymentID.is(o.deploymentId) && isSet(o.state) && (o.version instanceof Uint8Array || typeof o.version === "string") && typeof o.createdAt === "bigint");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Deployment.typeUrl || DeploymentID.isSDK(o.deployment_id) && isSet(o.state) && (o.version instanceof Uint8Array || typeof o.version === "string") && typeof o.created_at === "bigint");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.deploymentId !== undefined) {
            DeploymentID.encode(message.deploymentId, writer.uint32(10).fork()).ldelim();
        }
        if (message.state !== 0) {
            writer.uint32(16).int32(message.state);
        }
        if (message.version.length !== 0) {
            writer.uint32(26).bytes(message.version);
        }
        if (message.createdAt !== undefined) {
            writer.uint32(32).int64(message.createdAt);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeployment();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.deploymentId = DeploymentID.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.state = reader.int32();
                    break;
                case 3:
                    message.version = reader.bytes();
                    break;
                case 4:
                    message.createdAt = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDeployment();
        if (isSet(object.deploymentId))
            obj.deploymentId = DeploymentID.fromJSON(object.deploymentId);
        if (isSet(object.state))
            obj.state = deployment_StateFromJSON(object.state);
        if (isSet(object.version))
            obj.version = bytesFromBase64(object.version);
        if (isSet(object.createdAt))
            obj.createdAt = BigInt(object.createdAt.toString());
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.deploymentId !== undefined && (obj.deploymentId = message.deploymentId ? DeploymentID.toJSON(message.deploymentId) : undefined);
        message.state !== undefined && (obj.state = deployment_StateToJSON(message.state));
        message.version !== undefined && (obj.version = base64FromBytes(message.version !== undefined ? message.version : new Uint8Array()));
        message.createdAt !== undefined && (obj.createdAt = (message.createdAt || BigInt(0)).toString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDeployment();
        if (object.deploymentId !== undefined && object.deploymentId !== null) {
            message.deploymentId = DeploymentID.fromPartial(object.deploymentId);
        }
        message.state = object.state ?? 0;
        message.version = object.version ?? new Uint8Array();
        if (object.createdAt !== undefined && object.createdAt !== null) {
            message.createdAt = BigInt(object.createdAt.toString());
        }
        return message;
    },
    fromSDK(object) {
        return {
            deploymentId: object.deployment_id ? DeploymentID.fromSDK(object.deployment_id) : undefined,
            state: isSet(object.state) ? deployment_StateFromJSON(object.state) : -1,
            version: object?.version,
            createdAt: object?.created_at
        };
    },
    fromSDKJSON(object) {
        return {
            deployment_id: isSet(object.deployment_id) ? DeploymentID.fromSDKJSON(object.deployment_id) : undefined,
            state: isSet(object.state) ? deployment_StateFromJSON(object.state) : -1,
            version: isSet(object.version) ? bytesFromBase64(object.version) : new Uint8Array(),
            created_at: isSet(object.created_at) ? BigInt(object.created_at.toString()) : BigInt(0)
        };
    },
    toSDK(message) {
        const obj = {};
        message.deploymentId !== undefined && (obj.deployment_id = message.deploymentId ? DeploymentID.toSDK(message.deploymentId) : undefined);
        message.state !== undefined && (obj.state = deployment_StateToJSON(message.state));
        obj.version = message.version;
        obj.created_at = message.createdAt;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDeployment();
        if (object.deployment_id !== undefined && object.deployment_id !== null) {
            message.deploymentId = DeploymentID.fromAmino(object.deployment_id);
        }
        if (object.state !== undefined && object.state !== null) {
            message.state = object.state;
        }
        if (object.version !== undefined && object.version !== null) {
            message.version = bytesFromBase64(object.version);
        }
        if (object.created_at !== undefined && object.created_at !== null) {
            message.createdAt = BigInt(object.created_at);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.deployment_id = message.deploymentId ? DeploymentID.toAmino(message.deploymentId) : DeploymentID.toAmino(DeploymentID.fromPartial({}));
        obj.state = message.state ?? 0;
        obj.version = message.version ? base64FromBytes(message.version) : "";
        obj.created_at = message.createdAt !== BigInt(0) ? message.createdAt?.toString() : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return Deployment.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/deployment",
            value: Deployment.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Deployment.decode(message.value);
    },
    toProto(message) {
        return Deployment.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.Deployment",
            value: Deployment.encode(message).finish()
        };
    },
    registerTypeUrl() {
        DeploymentID.registerTypeUrl();
    }
};
function createBaseDeploymentFilters() {
    return {
        owner: "",
        dseq: BigInt(0),
        state: ""
    };
}
export const DeploymentFilters = {
    typeUrl: "/akash.deployment.v1beta1.DeploymentFilters",
    aminoType: "akash/deployment/deployment-filters",
    is(o) {
        return o && (o.$typeUrl === DeploymentFilters.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.state === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === DeploymentFilters.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.state === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.dseq !== undefined) {
            writer.uint32(16).uint64(message.dseq);
        }
        if (message.state !== undefined) {
            writer.uint32(26).string(message.state);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeploymentFilters();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.dseq = reader.uint64();
                    break;
                case 3:
                    message.state = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDeploymentFilters();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.dseq))
            obj.dseq = BigInt(object.dseq.toString());
        if (isSet(object.state))
            obj.state = String(object.state);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.dseq !== undefined && (obj.dseq = (message.dseq || BigInt(0)).toString());
        message.state !== undefined && (obj.state = message.state);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDeploymentFilters();
        message.owner = object.owner ?? "";
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq.toString());
        }
        message.state = object.state ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            dseq: object?.dseq,
            state: object?.state
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            dseq: isSet(object.dseq) ? BigInt(object.dseq.toString()) : BigInt(0),
            state: isSet(object.state) ? String(object.state) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.dseq = message.dseq;
        obj.state = message.state;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDeploymentFilters();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq);
        }
        if (object.state !== undefined && object.state !== null) {
            message.state = object.state;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.dseq = message.dseq ? message.dseq?.toString() : "0";
        obj.state = message.state ?? "";
        return obj;
    },
    fromAminoMsg(object) {
        return DeploymentFilters.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/deployment-filters",
            value: DeploymentFilters.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return DeploymentFilters.decode(message.value);
    },
    toProto(message) {
        return DeploymentFilters.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.DeploymentFilters",
            value: DeploymentFilters.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* CreateDeployment defines a method to create new deployment given proper inputs. */
    createDeployment = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgCreateDeployment.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* DepositDeployment deposits more funds into the deployment account */
    depositDeployment = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgDepositDeployment.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* UpdateDeployment defines a method to update a deployment given proper inputs. */
    updateDeployment = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgUpdateDeployment.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* CloseDeployment defines a method to close a deployment given proper inputs. */
    closeDeployment = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgCloseDeployment.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* CloseGroup defines a method to close a group of a deployment given proper inputs. */
    closeGroup = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgCloseGroup.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* PauseGroup defines a method to close a group of a deployment given proper inputs. */
    pauseGroup = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgPauseGroup.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* StartGroup defines a method to close a group of a deployment given proper inputs. */
    startGroup = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgStartGroup.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
