import { Deployment } from "./deployment";
import { Group } from "./group";
import { Params } from "./params";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.deployment.v1beta1";
function createBaseGenesisDeployment() {
    return {
        deployment: Deployment.fromPartial({}),
        groups: []
    };
}
export const GenesisDeployment = {
    typeUrl: "/akash.deployment.v1beta1.GenesisDeployment",
    aminoType: "akash/deployment/genesis-deployment",
    is(o) {
        return o && (o.$typeUrl === GenesisDeployment.typeUrl || Deployment.is(o.deployment) && Array.isArray(o.groups) && (!o.groups.length || Group.is(o.groups[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === GenesisDeployment.typeUrl || Deployment.isSDK(o.deployment) && Array.isArray(o.groups) && (!o.groups.length || Group.isSDK(o.groups[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.deployment !== undefined) {
            Deployment.encode(message.deployment, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.groups) {
            Group.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGenesisDeployment();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.deployment = Deployment.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.groups.push(Group.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGenesisDeployment();
        if (isSet(object.deployment))
            obj.deployment = Deployment.fromJSON(object.deployment);
        if (Array.isArray(object?.groups))
            obj.groups = object.groups.map((e) => Group.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.deployment !== undefined && (obj.deployment = message.deployment ? Deployment.toJSON(message.deployment) : undefined);
        if (message.groups) {
            obj.groups = message.groups.map(e => e ? Group.toJSON(e) : undefined);
        }
        else {
            obj.groups = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGenesisDeployment();
        if (object.deployment !== undefined && object.deployment !== null) {
            message.deployment = Deployment.fromPartial(object.deployment);
        }
        message.groups = object.groups?.map(e => Group.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            deployment: object.deployment ? Deployment.fromSDK(object.deployment) : undefined,
            groups: Array.isArray(object?.groups) ? object.groups.map((e) => Group.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            deployment: isSet(object.deployment) ? Deployment.fromSDKJSON(object.deployment) : undefined,
            groups: Array.isArray(object?.groups) ? object.groups.map((e) => Group.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        message.deployment !== undefined && (obj.deployment = message.deployment ? Deployment.toSDK(message.deployment) : undefined);
        if (message.groups) {
            obj.groups = message.groups.map(e => e ? Group.toSDK(e) : undefined);
        }
        else {
            obj.groups = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGenesisDeployment();
        if (object.deployment !== undefined && object.deployment !== null) {
            message.deployment = Deployment.fromAmino(object.deployment);
        }
        message.groups = object.groups?.map(e => Group.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.deployment = message.deployment ? Deployment.toAmino(message.deployment) : Deployment.toAmino(Deployment.fromPartial({}));
        if (message.groups) {
            obj.groups = message.groups.map(e => e ? Group.toAmino(e) : undefined);
        }
        else {
            obj.groups = message.groups;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return GenesisDeployment.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/genesis-deployment",
            value: GenesisDeployment.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return GenesisDeployment.decode(message.value);
    },
    toProto(message) {
        return GenesisDeployment.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.GenesisDeployment",
            value: GenesisDeployment.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Deployment.registerTypeUrl();
        Group.registerTypeUrl();
    }
};
function createBaseGenesisState() {
    return {
        deployments: [],
        params: Params.fromPartial({})
    };
}
export const GenesisState = {
    typeUrl: "/akash.deployment.v1beta1.GenesisState",
    aminoType: "akash/deployment/genesis-state",
    is(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Array.isArray(o.deployments) && (!o.deployments.length || GenesisDeployment.is(o.deployments[0])) && Params.is(o.params));
    },
    isSDK(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Array.isArray(o.deployments) && (!o.deployments.length || GenesisDeployment.isSDK(o.deployments[0])) && Params.isSDK(o.params));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.deployments) {
            GenesisDeployment.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.params !== undefined) {
            Params.encode(message.params, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGenesisState();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.deployments.push(GenesisDeployment.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.params = Params.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGenesisState();
        if (Array.isArray(object?.deployments))
            obj.deployments = object.deployments.map((e) => GenesisDeployment.fromJSON(e));
        if (isSet(object.params))
            obj.params = Params.fromJSON(object.params);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.deployments) {
            obj.deployments = message.deployments.map(e => e ? GenesisDeployment.toJSON(e) : undefined);
        }
        else {
            obj.deployments = [];
        }
        message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGenesisState();
        message.deployments = object.deployments?.map(e => GenesisDeployment.fromPartial(e)) || [];
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromPartial(object.params);
        }
        return message;
    },
    fromSDK(object) {
        return {
            deployments: Array.isArray(object?.deployments) ? object.deployments.map((e) => GenesisDeployment.fromSDK(e)) : [],
            params: object.params ? Params.fromSDK(object.params) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            deployments: Array.isArray(object?.deployments) ? object.deployments.map((e) => GenesisDeployment.fromSDKJSON(e)) : [],
            params: isSet(object.params) ? Params.fromSDKJSON(object.params) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.deployments) {
            obj.deployments = message.deployments.map(e => e ? GenesisDeployment.toSDK(e) : undefined);
        }
        else {
            obj.deployments = [];
        }
        message.params !== undefined && (obj.params = message.params ? Params.toSDK(message.params) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGenesisState();
        message.deployments = object.deployments?.map(e => GenesisDeployment.fromAmino(e)) || [];
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromAmino(object.params);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.deployments) {
            obj.deployments = message.deployments.map(e => e ? GenesisDeployment.toAmino(e) : undefined);
        }
        else {
            obj.deployments = message.deployments;
        }
        obj.params = message.params ? Params.toAmino(message.params) : Params.toAmino(Params.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return GenesisState.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/genesis-state",
            value: GenesisState.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return GenesisState.decode(message.value);
    },
    toProto(message) {
        return GenesisState.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.GenesisState",
            value: GenesisState.encode(message).finish()
        };
    },
    registerTypeUrl() {
        GenesisDeployment.registerTypeUrl();
        Params.registerTypeUrl();
    }
};
