import { PlacementRequirements } from "../../base/v1beta1/attribute";
import { ResourceUnits } from "../../base/v1beta1/resource";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.deployment.v1beta1";
/** State is an enum which refers to state of group */
export var Group_State;
(function (Group_State) {
    /** invalid - Prefix should start with 0 in enum. So declaring dummy state */
    Group_State[Group_State["invalid"] = 0] = "invalid";
    /** open - GroupOpen denotes state for group open */
    Group_State[Group_State["open"] = 1] = "open";
    /** paused - GroupOrdered denotes state for group ordered */
    Group_State[Group_State["paused"] = 2] = "paused";
    /** insufficient_funds - GroupInsufficientFunds denotes state for group insufficient_funds */
    Group_State[Group_State["insufficient_funds"] = 3] = "insufficient_funds";
    /** closed - GroupClosed denotes state for group closed */
    Group_State[Group_State["closed"] = 4] = "closed";
    Group_State[Group_State["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(Group_State || (Group_State = {}));
export const Group_StateSDKType = Group_State;
export const Group_StateAmino = Group_State;
export function group_StateFromJSON(object) {
    switch (object) {
        case 0:
        case "invalid":
            return Group_State.invalid;
        case 1:
        case "open":
            return Group_State.open;
        case 2:
        case "paused":
            return Group_State.paused;
        case 3:
        case "insufficient_funds":
            return Group_State.insufficient_funds;
        case 4:
        case "closed":
            return Group_State.closed;
        case -1:
        case "UNRECOGNIZED":
        default:
            return Group_State.UNRECOGNIZED;
    }
}
export function group_StateToJSON(object) {
    switch (object) {
        case Group_State.invalid:
            return "invalid";
        case Group_State.open:
            return "open";
        case Group_State.paused:
            return "paused";
        case Group_State.insufficient_funds:
            return "insufficient_funds";
        case Group_State.closed:
            return "closed";
        case Group_State.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
function createBaseMsgCloseGroup() {
    return {
        id: GroupID.fromPartial({})
    };
}
export const MsgCloseGroup = {
    typeUrl: "/akash.deployment.v1beta1.MsgCloseGroup",
    aminoType: "akash/deployment/testonly-close-group",
    is(o) {
        return o && (o.$typeUrl === MsgCloseGroup.typeUrl || GroupID.is(o.id));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgCloseGroup.typeUrl || GroupID.isSDK(o.id));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            GroupID.encode(message.id, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCloseGroup();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = GroupID.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgCloseGroup();
        if (isSet(object.id))
            obj.id = GroupID.fromJSON(object.id);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? GroupID.toJSON(message.id) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgCloseGroup();
        if (object.id !== undefined && object.id !== null) {
            message.id = GroupID.fromPartial(object.id);
        }
        return message;
    },
    fromSDK(object) {
        return {
            id: object.id ? GroupID.fromSDK(object.id) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? GroupID.fromSDKJSON(object.id) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? GroupID.toSDK(message.id) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgCloseGroup();
        if (object.id !== undefined && object.id !== null) {
            message.id = GroupID.fromAmino(object.id);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id ? GroupID.toAmino(message.id) : GroupID.toAmino(GroupID.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCloseGroup.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/testonly-close-group",
            value: MsgCloseGroup.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgCloseGroup.decode(message.value);
    },
    toProto(message) {
        return MsgCloseGroup.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.MsgCloseGroup",
            value: MsgCloseGroup.encode(message).finish()
        };
    },
    registerTypeUrl() {
        GroupID.registerTypeUrl();
    }
};
function createBaseMsgCloseGroupResponse() {
    return {};
}
export const MsgCloseGroupResponse = {
    typeUrl: "/akash.deployment.v1beta1.MsgCloseGroupResponse",
    aminoType: "akash/deployment/testonly-close-group-response",
    is(o) {
        return o && o.$typeUrl === MsgCloseGroupResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgCloseGroupResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCloseGroupResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgCloseGroupResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgCloseGroupResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgCloseGroupResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCloseGroupResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/testonly-close-group-response",
            value: MsgCloseGroupResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgCloseGroupResponse.decode(message.value);
    },
    toProto(message) {
        return MsgCloseGroupResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.MsgCloseGroupResponse",
            value: MsgCloseGroupResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgPauseGroup() {
    return {
        id: GroupID.fromPartial({})
    };
}
export const MsgPauseGroup = {
    typeUrl: "/akash.deployment.v1beta1.MsgPauseGroup",
    aminoType: "akash/deployment/testonly-pause-group",
    is(o) {
        return o && (o.$typeUrl === MsgPauseGroup.typeUrl || GroupID.is(o.id));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgPauseGroup.typeUrl || GroupID.isSDK(o.id));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            GroupID.encode(message.id, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgPauseGroup();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = GroupID.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgPauseGroup();
        if (isSet(object.id))
            obj.id = GroupID.fromJSON(object.id);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? GroupID.toJSON(message.id) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgPauseGroup();
        if (object.id !== undefined && object.id !== null) {
            message.id = GroupID.fromPartial(object.id);
        }
        return message;
    },
    fromSDK(object) {
        return {
            id: object.id ? GroupID.fromSDK(object.id) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? GroupID.fromSDKJSON(object.id) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? GroupID.toSDK(message.id) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgPauseGroup();
        if (object.id !== undefined && object.id !== null) {
            message.id = GroupID.fromAmino(object.id);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id ? GroupID.toAmino(message.id) : GroupID.toAmino(GroupID.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return MsgPauseGroup.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/testonly-pause-group",
            value: MsgPauseGroup.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgPauseGroup.decode(message.value);
    },
    toProto(message) {
        return MsgPauseGroup.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.MsgPauseGroup",
            value: MsgPauseGroup.encode(message).finish()
        };
    },
    registerTypeUrl() {
        GroupID.registerTypeUrl();
    }
};
function createBaseMsgPauseGroupResponse() {
    return {};
}
export const MsgPauseGroupResponse = {
    typeUrl: "/akash.deployment.v1beta1.MsgPauseGroupResponse",
    aminoType: "akash/deployment/testonly-pause-group-response",
    is(o) {
        return o && o.$typeUrl === MsgPauseGroupResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgPauseGroupResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgPauseGroupResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgPauseGroupResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgPauseGroupResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgPauseGroupResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgPauseGroupResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/testonly-pause-group-response",
            value: MsgPauseGroupResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgPauseGroupResponse.decode(message.value);
    },
    toProto(message) {
        return MsgPauseGroupResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.MsgPauseGroupResponse",
            value: MsgPauseGroupResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgStartGroup() {
    return {
        id: GroupID.fromPartial({})
    };
}
export const MsgStartGroup = {
    typeUrl: "/akash.deployment.v1beta1.MsgStartGroup",
    aminoType: "akash/deployment/testonly-start-group",
    is(o) {
        return o && (o.$typeUrl === MsgStartGroup.typeUrl || GroupID.is(o.id));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgStartGroup.typeUrl || GroupID.isSDK(o.id));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            GroupID.encode(message.id, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgStartGroup();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = GroupID.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgStartGroup();
        if (isSet(object.id))
            obj.id = GroupID.fromJSON(object.id);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? GroupID.toJSON(message.id) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgStartGroup();
        if (object.id !== undefined && object.id !== null) {
            message.id = GroupID.fromPartial(object.id);
        }
        return message;
    },
    fromSDK(object) {
        return {
            id: object.id ? GroupID.fromSDK(object.id) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? GroupID.fromSDKJSON(object.id) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id ? GroupID.toSDK(message.id) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgStartGroup();
        if (object.id !== undefined && object.id !== null) {
            message.id = GroupID.fromAmino(object.id);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id ? GroupID.toAmino(message.id) : GroupID.toAmino(GroupID.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return MsgStartGroup.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/testonly-start-group",
            value: MsgStartGroup.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgStartGroup.decode(message.value);
    },
    toProto(message) {
        return MsgStartGroup.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.MsgStartGroup",
            value: MsgStartGroup.encode(message).finish()
        };
    },
    registerTypeUrl() {
        GroupID.registerTypeUrl();
    }
};
function createBaseMsgStartGroupResponse() {
    return {};
}
export const MsgStartGroupResponse = {
    typeUrl: "/akash.deployment.v1beta1.MsgStartGroupResponse",
    aminoType: "akash/deployment/testonly-start-group-response",
    is(o) {
        return o && o.$typeUrl === MsgStartGroupResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgStartGroupResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgStartGroupResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgStartGroupResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgStartGroupResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgStartGroupResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgStartGroupResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/testonly-start-group-response",
            value: MsgStartGroupResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgStartGroupResponse.decode(message.value);
    },
    toProto(message) {
        return MsgStartGroupResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.MsgStartGroupResponse",
            value: MsgStartGroupResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseGroupID() {
    return {
        owner: "",
        dseq: BigInt(0),
        gseq: 0
    };
}
export const GroupID = {
    typeUrl: "/akash.deployment.v1beta1.GroupID",
    aminoType: "akash/deployment/group-i-d",
    is(o) {
        return o && (o.$typeUrl === GroupID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === GroupID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.dseq !== undefined) {
            writer.uint32(16).uint64(message.dseq);
        }
        if (message.gseq !== undefined) {
            writer.uint32(24).uint32(message.gseq);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGroupID();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.dseq = reader.uint64();
                    break;
                case 3:
                    message.gseq = reader.uint32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGroupID();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.dseq))
            obj.dseq = BigInt(object.dseq.toString());
        if (isSet(object.gseq))
            obj.gseq = Number(object.gseq);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.dseq !== undefined && (obj.dseq = (message.dseq || BigInt(0)).toString());
        message.gseq !== undefined && (obj.gseq = Math.round(message.gseq));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGroupID();
        message.owner = object.owner ?? "";
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq.toString());
        }
        message.gseq = object.gseq ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            dseq: object?.dseq,
            gseq: object?.gseq
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            dseq: isSet(object.dseq) ? BigInt(object.dseq.toString()) : BigInt(0),
            gseq: isSet(object.gseq) ? Number(object.gseq) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.dseq = message.dseq;
        obj.gseq = message.gseq;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGroupID();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq);
        }
        if (object.gseq !== undefined && object.gseq !== null) {
            message.gseq = object.gseq;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.dseq = message.dseq ? message.dseq?.toString() : "0";
        obj.gseq = message.gseq ?? 0;
        return obj;
    },
    fromAminoMsg(object) {
        return GroupID.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/group-i-d",
            value: GroupID.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return GroupID.decode(message.value);
    },
    toProto(message) {
        return GroupID.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.GroupID",
            value: GroupID.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseGroupSpec() {
    return {
        name: "",
        requirements: PlacementRequirements.fromPartial({}),
        resources: []
    };
}
export const GroupSpec = {
    typeUrl: "/akash.deployment.v1beta1.GroupSpec",
    aminoType: "akash/deployment/group-spec",
    is(o) {
        return o && (o.$typeUrl === GroupSpec.typeUrl || typeof o.name === "string" && PlacementRequirements.is(o.requirements) && Array.isArray(o.resources) && (!o.resources.length || Resource.is(o.resources[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === GroupSpec.typeUrl || typeof o.name === "string" && PlacementRequirements.isSDK(o.requirements) && Array.isArray(o.resources) && (!o.resources.length || Resource.isSDK(o.resources[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.requirements !== undefined) {
            PlacementRequirements.encode(message.requirements, writer.uint32(18).fork()).ldelim();
        }
        for (const v of message.resources) {
            Resource.encode(v, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGroupSpec();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.requirements = PlacementRequirements.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.resources.push(Resource.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGroupSpec();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.requirements))
            obj.requirements = PlacementRequirements.fromJSON(object.requirements);
        if (Array.isArray(object?.resources))
            obj.resources = object.resources.map((e) => Resource.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.requirements !== undefined && (obj.requirements = message.requirements ? PlacementRequirements.toJSON(message.requirements) : undefined);
        if (message.resources) {
            obj.resources = message.resources.map(e => e ? Resource.toJSON(e) : undefined);
        }
        else {
            obj.resources = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGroupSpec();
        message.name = object.name ?? "";
        if (object.requirements !== undefined && object.requirements !== null) {
            message.requirements = PlacementRequirements.fromPartial(object.requirements);
        }
        message.resources = object.resources?.map(e => Resource.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            requirements: object.requirements ? PlacementRequirements.fromSDK(object.requirements) : undefined,
            resources: Array.isArray(object?.resources) ? object.resources.map((e) => Resource.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            requirements: isSet(object.requirements) ? PlacementRequirements.fromSDKJSON(object.requirements) : undefined,
            resources: Array.isArray(object?.resources) ? object.resources.map((e) => Resource.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        message.requirements !== undefined && (obj.requirements = message.requirements ? PlacementRequirements.toSDK(message.requirements) : undefined);
        if (message.resources) {
            obj.resources = message.resources.map(e => e ? Resource.toSDK(e) : undefined);
        }
        else {
            obj.resources = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGroupSpec();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.requirements !== undefined && object.requirements !== null) {
            message.requirements = PlacementRequirements.fromAmino(object.requirements);
        }
        message.resources = object.resources?.map(e => Resource.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name ?? "";
        obj.requirements = message.requirements ? PlacementRequirements.toAmino(message.requirements) : PlacementRequirements.toAmino(PlacementRequirements.fromPartial({}));
        if (message.resources) {
            obj.resources = message.resources.map(e => e ? Resource.toAmino(e) : undefined);
        }
        else {
            obj.resources = message.resources;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return GroupSpec.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/group-spec",
            value: GroupSpec.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return GroupSpec.decode(message.value);
    },
    toProto(message) {
        return GroupSpec.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.GroupSpec",
            value: GroupSpec.encode(message).finish()
        };
    },
    registerTypeUrl() {
        PlacementRequirements.registerTypeUrl();
        Resource.registerTypeUrl();
    }
};
function createBaseGroup() {
    return {
        groupId: GroupID.fromPartial({}),
        state: 0,
        groupSpec: GroupSpec.fromPartial({}),
        createdAt: BigInt(0)
    };
}
export const Group = {
    typeUrl: "/akash.deployment.v1beta1.Group",
    aminoType: "akash/deployment/group",
    is(o) {
        return o && (o.$typeUrl === Group.typeUrl || GroupID.is(o.groupId) && isSet(o.state) && GroupSpec.is(o.groupSpec) && typeof o.createdAt === "bigint");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Group.typeUrl || GroupID.isSDK(o.group_id) && isSet(o.state) && GroupSpec.isSDK(o.group_spec) && typeof o.created_at === "bigint");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.groupId !== undefined) {
            GroupID.encode(message.groupId, writer.uint32(10).fork()).ldelim();
        }
        if (message.state !== 0) {
            writer.uint32(16).int32(message.state);
        }
        if (message.groupSpec !== undefined) {
            GroupSpec.encode(message.groupSpec, writer.uint32(26).fork()).ldelim();
        }
        if (message.createdAt !== undefined) {
            writer.uint32(32).int64(message.createdAt);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGroup();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.groupId = GroupID.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.state = reader.int32();
                    break;
                case 3:
                    message.groupSpec = GroupSpec.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.createdAt = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGroup();
        if (isSet(object.groupId))
            obj.groupId = GroupID.fromJSON(object.groupId);
        if (isSet(object.state))
            obj.state = group_StateFromJSON(object.state);
        if (isSet(object.groupSpec))
            obj.groupSpec = GroupSpec.fromJSON(object.groupSpec);
        if (isSet(object.createdAt))
            obj.createdAt = BigInt(object.createdAt.toString());
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.groupId !== undefined && (obj.groupId = message.groupId ? GroupID.toJSON(message.groupId) : undefined);
        message.state !== undefined && (obj.state = group_StateToJSON(message.state));
        message.groupSpec !== undefined && (obj.groupSpec = message.groupSpec ? GroupSpec.toJSON(message.groupSpec) : undefined);
        message.createdAt !== undefined && (obj.createdAt = (message.createdAt || BigInt(0)).toString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGroup();
        if (object.groupId !== undefined && object.groupId !== null) {
            message.groupId = GroupID.fromPartial(object.groupId);
        }
        message.state = object.state ?? 0;
        if (object.groupSpec !== undefined && object.groupSpec !== null) {
            message.groupSpec = GroupSpec.fromPartial(object.groupSpec);
        }
        if (object.createdAt !== undefined && object.createdAt !== null) {
            message.createdAt = BigInt(object.createdAt.toString());
        }
        return message;
    },
    fromSDK(object) {
        return {
            groupId: object.group_id ? GroupID.fromSDK(object.group_id) : undefined,
            state: isSet(object.state) ? group_StateFromJSON(object.state) : -1,
            groupSpec: object.group_spec ? GroupSpec.fromSDK(object.group_spec) : undefined,
            createdAt: object?.created_at
        };
    },
    fromSDKJSON(object) {
        return {
            group_id: isSet(object.group_id) ? GroupID.fromSDKJSON(object.group_id) : undefined,
            state: isSet(object.state) ? group_StateFromJSON(object.state) : -1,
            group_spec: isSet(object.group_spec) ? GroupSpec.fromSDKJSON(object.group_spec) : undefined,
            created_at: isSet(object.created_at) ? BigInt(object.created_at.toString()) : BigInt(0)
        };
    },
    toSDK(message) {
        const obj = {};
        message.groupId !== undefined && (obj.group_id = message.groupId ? GroupID.toSDK(message.groupId) : undefined);
        message.state !== undefined && (obj.state = group_StateToJSON(message.state));
        message.groupSpec !== undefined && (obj.group_spec = message.groupSpec ? GroupSpec.toSDK(message.groupSpec) : undefined);
        obj.created_at = message.createdAt;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGroup();
        if (object.group_id !== undefined && object.group_id !== null) {
            message.groupId = GroupID.fromAmino(object.group_id);
        }
        if (object.state !== undefined && object.state !== null) {
            message.state = object.state;
        }
        if (object.group_spec !== undefined && object.group_spec !== null) {
            message.groupSpec = GroupSpec.fromAmino(object.group_spec);
        }
        if (object.created_at !== undefined && object.created_at !== null) {
            message.createdAt = BigInt(object.created_at);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.group_id = message.groupId ? GroupID.toAmino(message.groupId) : GroupID.toAmino(GroupID.fromPartial({}));
        obj.state = message.state ?? 0;
        obj.group_spec = message.groupSpec ? GroupSpec.toAmino(message.groupSpec) : GroupSpec.toAmino(GroupSpec.fromPartial({}));
        obj.created_at = message.createdAt !== BigInt(0) ? message.createdAt?.toString() : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return Group.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/group",
            value: Group.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Group.decode(message.value);
    },
    toProto(message) {
        return Group.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.Group",
            value: Group.encode(message).finish()
        };
    },
    registerTypeUrl() {
        GroupID.registerTypeUrl();
        GroupSpec.registerTypeUrl();
    }
};
function createBaseResource() {
    return {
        resources: ResourceUnits.fromPartial({}),
        count: 0,
        price: Coin.fromPartial({})
    };
}
export const Resource = {
    typeUrl: "/akash.deployment.v1beta1.Resource",
    aminoType: "akash/deployment/resource",
    is(o) {
        return o && (o.$typeUrl === Resource.typeUrl || ResourceUnits.is(o.resources) && typeof o.count === "number" && Coin.is(o.price));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Resource.typeUrl || ResourceUnits.isSDK(o.resources) && typeof o.count === "number" && Coin.isSDK(o.price));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.resources !== undefined) {
            ResourceUnits.encode(message.resources, writer.uint32(10).fork()).ldelim();
        }
        if (message.count !== undefined) {
            writer.uint32(16).uint32(message.count);
        }
        if (message.price !== undefined) {
            Coin.encode(message.price, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseResource();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.resources = ResourceUnits.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.count = reader.uint32();
                    break;
                case 3:
                    message.price = Coin.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseResource();
        if (isSet(object.resources))
            obj.resources = ResourceUnits.fromJSON(object.resources);
        if (isSet(object.count))
            obj.count = Number(object.count);
        if (isSet(object.price))
            obj.price = Coin.fromJSON(object.price);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.resources !== undefined && (obj.resources = message.resources ? ResourceUnits.toJSON(message.resources) : undefined);
        message.count !== undefined && (obj.count = Math.round(message.count));
        message.price !== undefined && (obj.price = message.price ? Coin.toJSON(message.price) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseResource();
        if (object.resources !== undefined && object.resources !== null) {
            message.resources = ResourceUnits.fromPartial(object.resources);
        }
        message.count = object.count ?? 0;
        if (object.price !== undefined && object.price !== null) {
            message.price = Coin.fromPartial(object.price);
        }
        return message;
    },
    fromSDK(object) {
        return {
            resources: object.resources ? ResourceUnits.fromSDK(object.resources) : undefined,
            count: object?.count,
            price: object.price ? Coin.fromSDK(object.price) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            resources: isSet(object.resources) ? ResourceUnits.fromSDKJSON(object.resources) : undefined,
            count: isSet(object.count) ? Number(object.count) : 0,
            price: isSet(object.price) ? Coin.fromSDKJSON(object.price) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.resources !== undefined && (obj.resources = message.resources ? ResourceUnits.toSDK(message.resources) : undefined);
        obj.count = message.count;
        message.price !== undefined && (obj.price = message.price ? Coin.toSDK(message.price) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseResource();
        if (object.resources !== undefined && object.resources !== null) {
            message.resources = ResourceUnits.fromAmino(object.resources);
        }
        if (object.count !== undefined && object.count !== null) {
            message.count = object.count;
        }
        if (object.price !== undefined && object.price !== null) {
            message.price = Coin.fromAmino(object.price);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.resources = message.resources ? ResourceUnits.toAmino(message.resources) : ResourceUnits.toAmino(ResourceUnits.fromPartial({}));
        obj.count = message.count ?? 0;
        obj.price = message.price ? Coin.toAmino(message.price) : Coin.toAmino(Coin.fromPartial({}));
        return obj;
    },
    fromAminoMsg(object) {
        return Resource.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/resource",
            value: Resource.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Resource.decode(message.value);
    },
    toProto(message) {
        return Resource.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta1.Resource",
            value: Resource.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ResourceUnits.registerTypeUrl();
        Coin.registerTypeUrl();
    }
};
