import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet, bytesFromBase64, base64FromBytes } from "../../../helpers";
export const protobufPackage = "akash.deployment.v1beta2";
/** State is an enum which refers to state of deployment */
export var Deployment_State;
(function (Deployment_State) {
    /** invalid - Prefix should start with 0 in enum. So declaring dummy state */
    Deployment_State[Deployment_State["invalid"] = 0] = "invalid";
    /** active - DeploymentActive denotes state for deployment active */
    Deployment_State[Deployment_State["active"] = 1] = "active";
    /** closed - DeploymentClosed denotes state for deployment closed */
    Deployment_State[Deployment_State["closed"] = 2] = "closed";
    Deployment_State[Deployment_State["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(Deployment_State || (Deployment_State = {}));
export const Deployment_StateSDKType = Deployment_State;
export const Deployment_StateAmino = Deployment_State;
export function deployment_StateFromJSON(object) {
    switch (object) {
        case 0:
        case "invalid":
            return Deployment_State.invalid;
        case 1:
        case "active":
            return Deployment_State.active;
        case 2:
        case "closed":
            return Deployment_State.closed;
        case -1:
        case "UNRECOGNIZED":
        default:
            return Deployment_State.UNRECOGNIZED;
    }
}
export function deployment_StateToJSON(object) {
    switch (object) {
        case Deployment_State.invalid:
            return "invalid";
        case Deployment_State.active:
            return "active";
        case Deployment_State.closed:
            return "closed";
        case Deployment_State.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
function createBaseDeploymentID() {
    return {
        owner: "",
        dseq: BigInt(0)
    };
}
export const DeploymentID = {
    typeUrl: "/akash.deployment.v1beta2.DeploymentID",
    aminoType: "akash/deployment/v1beta2/deployment-i-d",
    is(o) {
        return o && (o.$typeUrl === DeploymentID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint");
    },
    isSDK(o) {
        return o && (o.$typeUrl === DeploymentID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint");
    },
    isAmino(o) {
        return o && (o.$typeUrl === DeploymentID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.dseq !== undefined) {
            writer.uint32(16).uint64(message.dseq);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeploymentID();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.dseq = reader.uint64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDeploymentID();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.dseq))
            obj.dseq = BigInt(object.dseq.toString());
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.dseq !== undefined && (obj.dseq = (message.dseq || BigInt(0)).toString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDeploymentID();
        message.owner = object.owner ?? "";
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq.toString());
        }
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            dseq: object?.dseq
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            dseq: isSet(object.dseq) ? BigInt(object.dseq.toString()) : BigInt(0)
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.dseq = message.dseq;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDeploymentID();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.dseq = message.dseq ? message.dseq?.toString() : "0";
        return obj;
    },
    fromAminoMsg(object) {
        return DeploymentID.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/v1beta2/deployment-i-d",
            value: DeploymentID.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return DeploymentID.decode(message.value);
    },
    toProto(message) {
        return DeploymentID.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta2.DeploymentID",
            value: DeploymentID.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseDeployment() {
    return {
        deploymentId: DeploymentID.fromPartial({}),
        state: 0,
        version: new Uint8Array(),
        createdAt: BigInt(0)
    };
}
export const Deployment = {
    typeUrl: "/akash.deployment.v1beta2.Deployment",
    aminoType: "akash/deployment/v1beta2/deployment",
    is(o) {
        return o && (o.$typeUrl === Deployment.typeUrl || DeploymentID.is(o.deploymentId) && isSet(o.state) && (o.version instanceof Uint8Array || typeof o.version === "string") && typeof o.createdAt === "bigint");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Deployment.typeUrl || DeploymentID.isSDK(o.deployment_id) && isSet(o.state) && (o.version instanceof Uint8Array || typeof o.version === "string") && typeof o.created_at === "bigint");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Deployment.typeUrl || DeploymentID.isAmino(o.deployment_id) && isSet(o.state) && (o.version instanceof Uint8Array || typeof o.version === "string") && typeof o.created_at === "bigint");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.deploymentId !== undefined) {
            DeploymentID.encode(message.deploymentId, writer.uint32(10).fork()).ldelim();
        }
        if (message.state !== 0) {
            writer.uint32(16).int32(message.state);
        }
        if (message.version.length !== 0) {
            writer.uint32(26).bytes(message.version);
        }
        if (message.createdAt !== undefined) {
            writer.uint32(32).int64(message.createdAt);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeployment();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.deploymentId = DeploymentID.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.state = reader.int32();
                    break;
                case 3:
                    message.version = reader.bytes();
                    break;
                case 4:
                    message.createdAt = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDeployment();
        if (isSet(object.deploymentId))
            obj.deploymentId = DeploymentID.fromJSON(object.deploymentId);
        if (isSet(object.state))
            obj.state = deployment_StateFromJSON(object.state);
        if (isSet(object.version))
            obj.version = bytesFromBase64(object.version);
        if (isSet(object.createdAt))
            obj.createdAt = BigInt(object.createdAt.toString());
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.deploymentId !== undefined && (obj.deploymentId = message.deploymentId ? DeploymentID.toJSON(message.deploymentId) : undefined);
        message.state !== undefined && (obj.state = deployment_StateToJSON(message.state));
        message.version !== undefined && (obj.version = base64FromBytes(message.version !== undefined ? message.version : new Uint8Array()));
        message.createdAt !== undefined && (obj.createdAt = (message.createdAt || BigInt(0)).toString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDeployment();
        if (object.deploymentId !== undefined && object.deploymentId !== null) {
            message.deploymentId = DeploymentID.fromPartial(object.deploymentId);
        }
        message.state = object.state ?? 0;
        message.version = object.version ?? new Uint8Array();
        if (object.createdAt !== undefined && object.createdAt !== null) {
            message.createdAt = BigInt(object.createdAt.toString());
        }
        return message;
    },
    fromSDK(object) {
        return {
            deploymentId: object.deployment_id ? DeploymentID.fromSDK(object.deployment_id) : undefined,
            state: isSet(object.state) ? deployment_StateFromJSON(object.state) : -1,
            version: object?.version,
            createdAt: object?.created_at
        };
    },
    fromSDKJSON(object) {
        return {
            deployment_id: isSet(object.deployment_id) ? DeploymentID.fromSDKJSON(object.deployment_id) : undefined,
            state: isSet(object.state) ? deployment_StateFromJSON(object.state) : -1,
            version: isSet(object.version) ? bytesFromBase64(object.version) : new Uint8Array(),
            created_at: isSet(object.created_at) ? BigInt(object.created_at.toString()) : BigInt(0)
        };
    },
    toSDK(message) {
        const obj = {};
        message.deploymentId !== undefined && (obj.deployment_id = message.deploymentId ? DeploymentID.toSDK(message.deploymentId) : undefined);
        message.state !== undefined && (obj.state = deployment_StateToJSON(message.state));
        obj.version = message.version;
        obj.created_at = message.createdAt;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDeployment();
        if (object.deployment_id !== undefined && object.deployment_id !== null) {
            message.deploymentId = DeploymentID.fromAmino(object.deployment_id);
        }
        if (object.state !== undefined && object.state !== null) {
            message.state = object.state;
        }
        if (object.version !== undefined && object.version !== null) {
            message.version = bytesFromBase64(object.version);
        }
        if (object.created_at !== undefined && object.created_at !== null) {
            message.createdAt = BigInt(object.created_at);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.deployment_id = message.deploymentId ? DeploymentID.toAmino(message.deploymentId) : DeploymentID.toAmino(DeploymentID.fromPartial({}));
        obj.state = message.state ?? 0;
        obj.version = message.version ? base64FromBytes(message.version) : "";
        obj.created_at = message.createdAt !== BigInt(0) ? message.createdAt?.toString() : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return Deployment.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/v1beta2/deployment",
            value: Deployment.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Deployment.decode(message.value);
    },
    toProto(message) {
        return Deployment.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta2.Deployment",
            value: Deployment.encode(message).finish()
        };
    },
    registerTypeUrl() {
        DeploymentID.registerTypeUrl();
    }
};
function createBaseDeploymentFilters() {
    return {
        owner: "",
        dseq: BigInt(0),
        state: ""
    };
}
export const DeploymentFilters = {
    typeUrl: "/akash.deployment.v1beta2.DeploymentFilters",
    aminoType: "akash/deployment/v1beta2/deployment-filters",
    is(o) {
        return o && (o.$typeUrl === DeploymentFilters.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.state === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === DeploymentFilters.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.state === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === DeploymentFilters.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.state === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.dseq !== undefined) {
            writer.uint32(16).uint64(message.dseq);
        }
        if (message.state !== undefined) {
            writer.uint32(26).string(message.state);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeploymentFilters();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.dseq = reader.uint64();
                    break;
                case 3:
                    message.state = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDeploymentFilters();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.dseq))
            obj.dseq = BigInt(object.dseq.toString());
        if (isSet(object.state))
            obj.state = String(object.state);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.dseq !== undefined && (obj.dseq = (message.dseq || BigInt(0)).toString());
        message.state !== undefined && (obj.state = message.state);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDeploymentFilters();
        message.owner = object.owner ?? "";
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq.toString());
        }
        message.state = object.state ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            dseq: object?.dseq,
            state: object?.state
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            dseq: isSet(object.dseq) ? BigInt(object.dseq.toString()) : BigInt(0),
            state: isSet(object.state) ? String(object.state) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.dseq = message.dseq;
        obj.state = message.state;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDeploymentFilters();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq);
        }
        if (object.state !== undefined && object.state !== null) {
            message.state = object.state;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.dseq = message.dseq ? message.dseq?.toString() : "0";
        obj.state = message.state ?? "";
        return obj;
    },
    fromAminoMsg(object) {
        return DeploymentFilters.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/v1beta2/deployment-filters",
            value: DeploymentFilters.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return DeploymentFilters.decode(message.value);
    },
    toProto(message) {
        return DeploymentFilters.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta2.DeploymentFilters",
            value: DeploymentFilters.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
