import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.deployment.v1beta2";
function createBaseGroupID() {
    return {
        owner: "",
        dseq: BigInt(0),
        gseq: 0
    };
}
export const GroupID = {
    typeUrl: "/akash.deployment.v1beta2.GroupID",
    aminoType: "akash/deployment/v1beta2/group-i-d",
    is(o) {
        return o && (o.$typeUrl === GroupID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === GroupID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === GroupID.typeUrl || typeof o.owner === "string" && typeof o.dseq === "bigint" && typeof o.gseq === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.owner !== undefined) {
            writer.uint32(10).string(message.owner);
        }
        if (message.dseq !== undefined) {
            writer.uint32(16).uint64(message.dseq);
        }
        if (message.gseq !== undefined) {
            writer.uint32(24).uint32(message.gseq);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGroupID();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.owner = reader.string();
                    break;
                case 2:
                    message.dseq = reader.uint64();
                    break;
                case 3:
                    message.gseq = reader.uint32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGroupID();
        if (isSet(object.owner))
            obj.owner = String(object.owner);
        if (isSet(object.dseq))
            obj.dseq = BigInt(object.dseq.toString());
        if (isSet(object.gseq))
            obj.gseq = Number(object.gseq);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.owner !== undefined && (obj.owner = message.owner);
        message.dseq !== undefined && (obj.dseq = (message.dseq || BigInt(0)).toString());
        message.gseq !== undefined && (obj.gseq = Math.round(message.gseq));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGroupID();
        message.owner = object.owner ?? "";
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq.toString());
        }
        message.gseq = object.gseq ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            owner: object?.owner,
            dseq: object?.dseq,
            gseq: object?.gseq
        };
    },
    fromSDKJSON(object) {
        return {
            owner: isSet(object.owner) ? String(object.owner) : "",
            dseq: isSet(object.dseq) ? BigInt(object.dseq.toString()) : BigInt(0),
            gseq: isSet(object.gseq) ? Number(object.gseq) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.owner = message.owner;
        obj.dseq = message.dseq;
        obj.gseq = message.gseq;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGroupID();
        if (object.owner !== undefined && object.owner !== null) {
            message.owner = object.owner;
        }
        if (object.dseq !== undefined && object.dseq !== null) {
            message.dseq = BigInt(object.dseq);
        }
        if (object.gseq !== undefined && object.gseq !== null) {
            message.gseq = object.gseq;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.owner = message.owner ?? "";
        obj.dseq = message.dseq ? message.dseq?.toString() : "0";
        obj.gseq = message.gseq ?? 0;
        return obj;
    },
    fromAminoMsg(object) {
        return GroupID.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/deployment/v1beta2/group-i-d",
            value: GroupID.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return GroupID.decode(message.value);
    },
    toProto(message) {
        return GroupID.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.deployment.v1beta2.GroupID",
            value: GroupID.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
