import { setPaginationParams } from "../../../helpers";
import { QueryDeploymentsResponse, QueryDeploymentResponse, QueryGroupResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* Deployments queries deployments */
    deployments = async (params) => {
        const options = {
            params: {}
        };
        if (typeof params?.filters !== "undefined") {
            options.params.filters = params.filters;
        }
        if (typeof params?.pagination !== "undefined") {
            setPaginationParams(options, params.pagination);
        }
        const endpoint = `akash/deployment/v1beta2/deployments/list`;
        return QueryDeploymentsResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
    /* Deployment queries deployment details */
    deployment = async (params) => {
        const options = {
            params: {}
        };
        if (typeof params?.id !== "undefined") {
            options.params.id = params.id;
        }
        const endpoint = `akash/deployment/v1beta2/deployments/info`;
        return QueryDeploymentResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
    /* Group queries group details */
    group = async (params) => {
        const options = {
            params: {}
        };
        if (typeof params?.id !== "undefined") {
            options.params.id = params.id;
        }
        const endpoint = `akash/deployment/v1beta2/groups/info`;
        return QueryGroupResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
}
