import { MsgCreateDeployment, MsgDepositDeployment, MsgUpdateDeployment, MsgCloseDeployment } from "./deploymentmsg";
import { MsgCloseGroup, MsgPauseGroup, MsgStartGroup } from "./groupmsg";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* CreateDeployment defines a method to create new deployment given proper inputs. */
    createDeployment = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgCreateDeployment.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* DepositDeployment deposits more funds into the deployment account */
    depositDeployment = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgDepositDeployment.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* UpdateDeployment defines a method to update a deployment given proper inputs. */
    updateDeployment = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgUpdateDeployment.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* CloseDeployment defines a method to close a deployment given proper inputs. */
    closeDeployment = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgCloseDeployment.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* CloseGroup defines a method to close a group of a deployment given proper inputs. */
    closeGroup = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgCloseGroup.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* PauseGroup defines a method to close a group of a deployment given proper inputs. */
    pauseGroup = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgPauseGroup.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* StartGroup defines a method to close a group of a deployment given proper inputs. */
    startGroup = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgStartGroup.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
