import { Account, Payment } from "./types";
import { BinaryReader, BinaryWriter } from "../../../binary";
export const protobufPackage = "akash.escrow.v1beta1";
function createBaseGenesisState() {
    return {
        accounts: [],
        payments: []
    };
}
export const GenesisState = {
    typeUrl: "/akash.escrow.v1beta1.GenesisState",
    aminoType: "akash/escrow/genesis-state",
    is(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Array.isArray(o.accounts) && (!o.accounts.length || Account.is(o.accounts[0])) && Array.isArray(o.payments) && (!o.payments.length || Payment.is(o.payments[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Array.isArray(o.accounts) && (!o.accounts.length || Account.isSDK(o.accounts[0])) && Array.isArray(o.payments) && (!o.payments.length || Payment.isSDK(o.payments[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Array.isArray(o.accounts) && (!o.accounts.length || Account.isAmino(o.accounts[0])) && Array.isArray(o.payments) && (!o.payments.length || Payment.isAmino(o.payments[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.accounts) {
            Account.encode(v, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.payments) {
            Payment.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGenesisState();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.accounts.push(Account.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.payments.push(Payment.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGenesisState();
        if (Array.isArray(object?.accounts))
            obj.accounts = object.accounts.map((e) => Account.fromJSON(e));
        if (Array.isArray(object?.payments))
            obj.payments = object.payments.map((e) => Payment.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.accounts) {
            obj.accounts = message.accounts.map(e => e ? Account.toJSON(e) : undefined);
        }
        else {
            obj.accounts = [];
        }
        if (message.payments) {
            obj.payments = message.payments.map(e => e ? Payment.toJSON(e) : undefined);
        }
        else {
            obj.payments = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGenesisState();
        message.accounts = object.accounts?.map(e => Account.fromPartial(e)) || [];
        message.payments = object.payments?.map(e => Payment.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            accounts: Array.isArray(object?.accounts) ? object.accounts.map((e) => Account.fromSDK(e)) : [],
            payments: Array.isArray(object?.payments) ? object.payments.map((e) => Payment.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            accounts: Array.isArray(object?.accounts) ? object.accounts.map((e) => Account.fromSDKJSON(e)) : [],
            payments: Array.isArray(object?.payments) ? object.payments.map((e) => Payment.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.accounts) {
            obj.accounts = message.accounts.map(e => e ? Account.toSDK(e) : undefined);
        }
        else {
            obj.accounts = [];
        }
        if (message.payments) {
            obj.payments = message.payments.map(e => e ? Payment.toSDK(e) : undefined);
        }
        else {
            obj.payments = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGenesisState();
        message.accounts = object.accounts?.map(e => Account.fromAmino(e)) || [];
        message.payments = object.payments?.map(e => Payment.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.accounts) {
            obj.accounts = message.accounts.map(e => e ? Account.toAmino(e) : undefined);
        }
        else {
            obj.accounts = message.accounts;
        }
        if (message.payments) {
            obj.payments = message.payments.map(e => e ? Payment.toAmino(e) : undefined);
        }
        else {
            obj.payments = message.payments;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return GenesisState.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/escrow/genesis-state",
            value: GenesisState.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return GenesisState.decode(message.value);
    },
    toProto(message) {
        return GenesisState.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.escrow.v1beta1.GenesisState",
            value: GenesisState.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Account.registerTypeUrl();
        Payment.registerTypeUrl();
    }
};
