import { BinaryReader, BinaryWriter } from "../../../binary";
import { Decimal } from "@cosmjs/math";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.inflation.v1beta2";
function createBaseParams() {
    return {
        inflationDecayFactor: "",
        initialInflation: "",
        variance: ""
    };
}
export const Params = {
    typeUrl: "/akash.inflation.v1beta2.Params",
    aminoType: "akash/inflation/v1beta2/params",
    is(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.inflationDecayFactor === "string" && typeof o.initialInflation === "string" && typeof o.variance === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.inflation_decay_factor === "string" && typeof o.initial_inflation === "string" && typeof o.variance === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.inflation_decay_factor === "string" && typeof o.initial_inflation === "string" && typeof o.variance === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.inflationDecayFactor !== undefined) {
            writer.uint32(10).string(Decimal.fromUserInput(message.inflationDecayFactor, 18).atomics);
        }
        if (message.initialInflation !== undefined) {
            writer.uint32(18).string(Decimal.fromUserInput(message.initialInflation, 18).atomics);
        }
        if (message.variance !== undefined) {
            writer.uint32(26).string(Decimal.fromUserInput(message.variance, 18).atomics);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseParams();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.inflationDecayFactor = Decimal.fromAtomics(reader.string(), 18).toString();
                    break;
                case 2:
                    message.initialInflation = Decimal.fromAtomics(reader.string(), 18).toString();
                    break;
                case 3:
                    message.variance = Decimal.fromAtomics(reader.string(), 18).toString();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseParams();
        if (isSet(object.inflationDecayFactor))
            obj.inflationDecayFactor = String(object.inflationDecayFactor);
        if (isSet(object.initialInflation))
            obj.initialInflation = String(object.initialInflation);
        if (isSet(object.variance))
            obj.variance = String(object.variance);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.inflationDecayFactor !== undefined && (obj.inflationDecayFactor = message.inflationDecayFactor);
        message.initialInflation !== undefined && (obj.initialInflation = message.initialInflation);
        message.variance !== undefined && (obj.variance = message.variance);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseParams();
        message.inflationDecayFactor = object.inflationDecayFactor ?? "";
        message.initialInflation = object.initialInflation ?? "";
        message.variance = object.variance ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            inflationDecayFactor: object?.inflation_decay_factor,
            initialInflation: object?.initial_inflation,
            variance: object?.variance
        };
    },
    fromSDKJSON(object) {
        return {
            inflation_decay_factor: isSet(object.inflation_decay_factor) ? String(object.inflation_decay_factor) : "",
            initial_inflation: isSet(object.initial_inflation) ? String(object.initial_inflation) : "",
            variance: isSet(object.variance) ? String(object.variance) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.inflation_decay_factor = message.inflationDecayFactor;
        obj.initial_inflation = message.initialInflation;
        obj.variance = message.variance;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseParams();
        if (object.inflation_decay_factor !== undefined && object.inflation_decay_factor !== null) {
            message.inflationDecayFactor = object.inflation_decay_factor;
        }
        if (object.initial_inflation !== undefined && object.initial_inflation !== null) {
            message.initialInflation = object.initial_inflation;
        }
        if (object.variance !== undefined && object.variance !== null) {
            message.variance = object.variance;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.inflation_decay_factor = message.inflationDecayFactor ?? "";
        obj.initial_inflation = message.initialInflation ?? "";
        obj.variance = message.variance ?? "";
        return obj;
    },
    fromAminoMsg(object) {
        return Params.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/inflation/v1beta2/params",
            value: Params.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Params.decode(message.value);
    },
    toProto(message) {
        return Params.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.inflation.v1beta2.Params",
            value: Params.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
