import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "akash.market.v1beta2";
function createBaseParams() {
    return {
        bidMinDeposit: Coin.fromPartial({}),
        orderMaxBids: 0
    };
}
export const Params = {
    typeUrl: "/akash.market.v1beta2.Params",
    aminoType: "akash/market/v1beta2/params",
    is(o) {
        return o && (o.$typeUrl === Params.typeUrl || Coin.is(o.bidMinDeposit) && typeof o.orderMaxBids === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Params.typeUrl || Coin.isSDK(o.bid_min_deposit) && typeof o.order_max_bids === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Params.typeUrl || Coin.isAmino(o.bid_min_deposit) && typeof o.order_max_bids === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.bidMinDeposit !== undefined) {
            Coin.encode(message.bidMinDeposit, writer.uint32(10).fork()).ldelim();
        }
        if (message.orderMaxBids !== undefined) {
            writer.uint32(16).uint32(message.orderMaxBids);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseParams();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.bidMinDeposit = Coin.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.orderMaxBids = reader.uint32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseParams();
        if (isSet(object.bidMinDeposit))
            obj.bidMinDeposit = Coin.fromJSON(object.bidMinDeposit);
        if (isSet(object.orderMaxBids))
            obj.orderMaxBids = Number(object.orderMaxBids);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.bidMinDeposit !== undefined && (obj.bidMinDeposit = message.bidMinDeposit ? Coin.toJSON(message.bidMinDeposit) : undefined);
        message.orderMaxBids !== undefined && (obj.orderMaxBids = Math.round(message.orderMaxBids));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseParams();
        if (object.bidMinDeposit !== undefined && object.bidMinDeposit !== null) {
            message.bidMinDeposit = Coin.fromPartial(object.bidMinDeposit);
        }
        message.orderMaxBids = object.orderMaxBids ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            bidMinDeposit: object.bid_min_deposit ? Coin.fromSDK(object.bid_min_deposit) : undefined,
            orderMaxBids: object?.order_max_bids
        };
    },
    fromSDKJSON(object) {
        return {
            bid_min_deposit: isSet(object.bid_min_deposit) ? Coin.fromSDKJSON(object.bid_min_deposit) : undefined,
            order_max_bids: isSet(object.order_max_bids) ? Number(object.order_max_bids) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        message.bidMinDeposit !== undefined && (obj.bid_min_deposit = message.bidMinDeposit ? Coin.toSDK(message.bidMinDeposit) : undefined);
        obj.order_max_bids = message.orderMaxBids;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseParams();
        if (object.bid_min_deposit !== undefined && object.bid_min_deposit !== null) {
            message.bidMinDeposit = Coin.fromAmino(object.bid_min_deposit);
        }
        if (object.order_max_bids !== undefined && object.order_max_bids !== null) {
            message.orderMaxBids = object.order_max_bids;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.bid_min_deposit = message.bidMinDeposit ? Coin.toAmino(message.bidMinDeposit) : Coin.toAmino(Coin.fromPartial({}));
        obj.order_max_bids = message.orderMaxBids ?? 0;
        return obj;
    },
    fromAminoMsg(object) {
        return Params.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "akash/market/v1beta2/params",
            value: Params.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Params.decode(message.value);
    },
    toProto(message) {
        return Params.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/akash.market.v1beta2.Params",
            value: Params.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Coin.registerTypeUrl();
    }
};
