import { BinaryReader } from "../../../binary";
import { QueryOrdersRequest, QueryOrdersResponse, QueryOrderRequest, QueryOrderResponse, QueryBidsRequest, QueryBidsResponse, QueryBidRequest, QueryBidResponse, QueryLeasesRequest, QueryLeasesResponse, QueryLeaseRequest, QueryLeaseResponse } from "./query";
export class QueryClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* Orders queries orders with filters */
    orders = async (request) => {
        const data = QueryOrdersRequest.encode(request).finish();
        const promise = this.rpc.request("akash.market.v1beta2.Query", "Orders", data);
        return promise.then(data => QueryOrdersResponse.decode(new BinaryReader(data)));
    };
    /* Order queries order details */
    order = async (request) => {
        const data = QueryOrderRequest.encode(request).finish();
        const promise = this.rpc.request("akash.market.v1beta2.Query", "Order", data);
        return promise.then(data => QueryOrderResponse.decode(new BinaryReader(data)));
    };
    /* Bids queries bids with filters */
    bids = async (request) => {
        const data = QueryBidsRequest.encode(request).finish();
        const promise = this.rpc.request("akash.market.v1beta2.Query", "Bids", data);
        return promise.then(data => QueryBidsResponse.decode(new BinaryReader(data)));
    };
    /* Bid queries bid details */
    bid = async (request) => {
        const data = QueryBidRequest.encode(request).finish();
        const promise = this.rpc.request("akash.market.v1beta2.Query", "Bid", data);
        return promise.then(data => QueryBidResponse.decode(new BinaryReader(data)));
    };
    /* Leases queries leases with filters */
    leases = async (request) => {
        const data = QueryLeasesRequest.encode(request).finish();
        const promise = this.rpc.request("akash.market.v1beta2.Query", "Leases", data);
        return promise.then(data => QueryLeasesResponse.decode(new BinaryReader(data)));
    };
    /* Lease queries lease details */
    lease = async (request) => {
        const data = QueryLeaseRequest.encode(request).finish();
        const promise = this.rpc.request("akash.market.v1beta2.Query", "Lease", data);
        return promise.then(data => QueryLeaseResponse.decode(new BinaryReader(data)));
    };
}
export const createClientImpl = (rpc) => {
    return new QueryClientImpl(rpc);
};
