import { PageRequest } from "../../../cosmos/base/query/v1beta1/pagination";
import { BinaryReader } from "../../../binary";
import { QueryProvidersRequest, QueryProvidersResponse, QueryProviderRequest, QueryProviderResponse } from "./query";
export class QueryClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* Providers queries providers */
    providers = async (request = {
        pagination: PageRequest.fromPartial({})
    }) => {
        const data = QueryProvidersRequest.encode(request).finish();
        const promise = this.rpc.request("akash.provider.v1beta2.Query", "Providers", data);
        return promise.then(data => QueryProvidersResponse.decode(new BinaryReader(data)));
    };
    /* Provider queries provider details */
    provider = async (request) => {
        const data = QueryProviderRequest.encode(request).finish();
        const promise = this.rpc.request("akash.provider.v1beta2.Query", "Provider", data);
        return promise.then(data => QueryProviderResponse.decode(new BinaryReader(data)));
    };
}
export const createClientImpl = (rpc) => {
    return new QueryClientImpl(rpc);
};
