import { buildUseQuery } from "../../../react-query";
import { createGetBalance, createGetAllBalances, createGetSpendableBalances, createGetTotalSupply, createGetSupplyOf, createGetParams, createGetDenomMetadata, createGetDenomsMetadata, createGetDenomOwners } from "./query.rpc.func";
export const useGetBalance = buildUseQuery({
    builderQueryFn: createGetBalance,
    queryKeyPrefix: "BalanceQuery"
});
export const useGetAllBalances = buildUseQuery({
    builderQueryFn: createGetAllBalances,
    queryKeyPrefix: "AllBalancesQuery"
});
export const useGetSpendableBalances = buildUseQuery({
    builderQueryFn: createGetSpendableBalances,
    queryKeyPrefix: "SpendableBalancesQuery"
});
export const useGetTotalSupply = buildUseQuery({
    builderQueryFn: createGetTotalSupply,
    queryKeyPrefix: "TotalSupplyQuery"
});
export const useGetSupplyOf = buildUseQuery({
    builderQueryFn: createGetSupplyOf,
    queryKeyPrefix: "SupplyOfQuery"
});
export const useGetParams = buildUseQuery({
    builderQueryFn: createGetParams,
    queryKeyPrefix: "ParamsQuery"
});
export const useGetDenomMetadata = buildUseQuery({
    builderQueryFn: createGetDenomMetadata,
    queryKeyPrefix: "DenomMetadataQuery"
});
export const useGetDenomsMetadata = buildUseQuery({
    builderQueryFn: createGetDenomsMetadata,
    queryKeyPrefix: "DenomsMetadataQuery"
});
export const useGetDenomOwners = buildUseQuery({
    builderQueryFn: createGetDenomOwners,
    queryKeyPrefix: "DenomOwnersQuery"
});
