import { MsgSend, MsgMultiSend } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* Send defines a method for sending coins from one account to another account. */
    send = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgSend.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* MultiSend defines a method for sending coins from some accounts to other accounts. */
    multiSend = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgMultiSend.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
