import { ListAllInterfacesResponse, ListImplementationsResponse } from "./reflection";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* ListAllInterfaces lists all the interfaces registered in the interface
     registry. */
    listAllInterfaces = async (_params = {}) => {
        const endpoint = `cosmos/base/reflection/v1beta1/interfaces`;
        return ListAllInterfacesResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* ListImplementations list all the concrete types that implement a given
     interface. */
    listImplementations = async (params) => {
        const endpoint = `cosmos/base/reflection/v1beta1/interfaces/${params.interfaceName}/implementations`;
        return ListImplementationsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
}
