import { Any } from "../../../../google/protobuf/any";
import { BIP44Params } from "../../hd/v1/hd";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { isSet } from "../../../../helpers";
export const protobufPackage = "cosmos.crypto.keyring.v1";
function createBaseRecord() {
    return {
        name: "",
        pubKey: undefined,
        local: undefined,
        ledger: undefined,
        multi: undefined,
        offline: undefined
    };
}
export const Record = {
    typeUrl: "/cosmos.crypto.keyring.v1.Record",
    aminoType: "cosmos-sdk/Record",
    is(o) {
        return o && (o.$typeUrl === Record.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Record.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Record.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.pubKey !== undefined) {
            Any.encode(message.pubKey, writer.uint32(18).fork()).ldelim();
        }
        if (message.local !== undefined) {
            Record_Local.encode(message.local, writer.uint32(26).fork()).ldelim();
        }
        if (message.ledger !== undefined) {
            Record_Ledger.encode(message.ledger, writer.uint32(34).fork()).ldelim();
        }
        if (message.multi !== undefined) {
            Record_Multi.encode(message.multi, writer.uint32(42).fork()).ldelim();
        }
        if (message.offline !== undefined) {
            Record_Offline.encode(message.offline, writer.uint32(50).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRecord();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.pubKey = Any.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.local = Record_Local.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.ledger = Record_Ledger.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.multi = Record_Multi.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.offline = Record_Offline.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseRecord();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.pubKey))
            obj.pubKey = Any.fromJSON(object.pubKey);
        if (isSet(object.local))
            obj.local = Record_Local.fromJSON(object.local);
        if (isSet(object.ledger))
            obj.ledger = Record_Ledger.fromJSON(object.ledger);
        if (isSet(object.multi))
            obj.multi = Record_Multi.fromJSON(object.multi);
        if (isSet(object.offline))
            obj.offline = Record_Offline.fromJSON(object.offline);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.pubKey !== undefined && (obj.pubKey = message.pubKey ? Any.toJSON(message.pubKey) : undefined);
        message.local !== undefined && (obj.local = message.local ? Record_Local.toJSON(message.local) : undefined);
        message.ledger !== undefined && (obj.ledger = message.ledger ? Record_Ledger.toJSON(message.ledger) : undefined);
        message.multi !== undefined && (obj.multi = message.multi ? Record_Multi.toJSON(message.multi) : undefined);
        message.offline !== undefined && (obj.offline = message.offline ? Record_Offline.toJSON(message.offline) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseRecord();
        message.name = object.name ?? "";
        if (object.pubKey !== undefined && object.pubKey !== null) {
            message.pubKey = Any.fromPartial(object.pubKey);
        }
        if (object.local !== undefined && object.local !== null) {
            message.local = Record_Local.fromPartial(object.local);
        }
        if (object.ledger !== undefined && object.ledger !== null) {
            message.ledger = Record_Ledger.fromPartial(object.ledger);
        }
        if (object.multi !== undefined && object.multi !== null) {
            message.multi = Record_Multi.fromPartial(object.multi);
        }
        if (object.offline !== undefined && object.offline !== null) {
            message.offline = Record_Offline.fromPartial(object.offline);
        }
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            pubKey: object.pub_key ? Any.fromSDK(object.pub_key) : undefined,
            local: object.local ? Record_Local.fromSDK(object.local) : undefined,
            ledger: object.ledger ? Record_Ledger.fromSDK(object.ledger) : undefined,
            multi: object.multi ? Record_Multi.fromSDK(object.multi) : undefined,
            offline: object.offline ? Record_Offline.fromSDK(object.offline) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            pub_key: isSet(object.pub_key) ? Any.fromSDKJSON(object.pub_key) : undefined,
            local: isSet(object.local) ? Record_Local.fromSDKJSON(object.local) : undefined,
            ledger: isSet(object.ledger) ? Record_Ledger.fromSDKJSON(object.ledger) : undefined,
            multi: isSet(object.multi) ? Record_Multi.fromSDKJSON(object.multi) : undefined,
            offline: isSet(object.offline) ? Record_Offline.fromSDKJSON(object.offline) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        message.pubKey !== undefined && (obj.pub_key = message.pubKey ? Any.toSDK(message.pubKey) : undefined);
        message.local !== undefined && (obj.local = message.local ? Record_Local.toSDK(message.local) : undefined);
        message.ledger !== undefined && (obj.ledger = message.ledger ? Record_Ledger.toSDK(message.ledger) : undefined);
        message.multi !== undefined && (obj.multi = message.multi ? Record_Multi.toSDK(message.multi) : undefined);
        message.offline !== undefined && (obj.offline = message.offline ? Record_Offline.toSDK(message.offline) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseRecord();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.pub_key !== undefined && object.pub_key !== null) {
            message.pubKey = Any.fromAmino(object.pub_key);
        }
        if (object.local !== undefined && object.local !== null) {
            message.local = Record_Local.fromAmino(object.local);
        }
        if (object.ledger !== undefined && object.ledger !== null) {
            message.ledger = Record_Ledger.fromAmino(object.ledger);
        }
        if (object.multi !== undefined && object.multi !== null) {
            message.multi = Record_Multi.fromAmino(object.multi);
        }
        if (object.offline !== undefined && object.offline !== null) {
            message.offline = Record_Offline.fromAmino(object.offline);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.pub_key = message.pubKey ? Any.toAmino(message.pubKey) : undefined;
        obj.local = message.local ? Record_Local.toAmino(message.local) : undefined;
        obj.ledger = message.ledger ? Record_Ledger.toAmino(message.ledger) : undefined;
        obj.multi = message.multi ? Record_Multi.toAmino(message.multi) : undefined;
        obj.offline = message.offline ? Record_Offline.toAmino(message.offline) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return Record.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "cosmos-sdk/Record",
            value: Record.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Record.decode(message.value);
    },
    toProto(message) {
        return Record.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/cosmos.crypto.keyring.v1.Record",
            value: Record.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Record_Local.registerTypeUrl();
        Record_Ledger.registerTypeUrl();
        Record_Multi.registerTypeUrl();
        Record_Offline.registerTypeUrl();
    }
};
function createBaseRecord_Local() {
    return {
        privKey: undefined,
        privKeyType: ""
    };
}
export const Record_Local = {
    typeUrl: "/cosmos.crypto.keyring.v1.Local",
    aminoType: "cosmos-sdk/Local",
    is(o) {
        return o && (o.$typeUrl === Record_Local.typeUrl || typeof o.privKeyType === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Record_Local.typeUrl || typeof o.priv_key_type === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Record_Local.typeUrl || typeof o.priv_key_type === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.privKey !== undefined) {
            Any.encode(message.privKey, writer.uint32(10).fork()).ldelim();
        }
        if (message.privKeyType !== undefined) {
            writer.uint32(18).string(message.privKeyType);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRecord_Local();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.privKey = Any.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.privKeyType = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseRecord_Local();
        if (isSet(object.privKey))
            obj.privKey = Any.fromJSON(object.privKey);
        if (isSet(object.privKeyType))
            obj.privKeyType = String(object.privKeyType);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.privKey !== undefined && (obj.privKey = message.privKey ? Any.toJSON(message.privKey) : undefined);
        message.privKeyType !== undefined && (obj.privKeyType = message.privKeyType);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseRecord_Local();
        if (object.privKey !== undefined && object.privKey !== null) {
            message.privKey = Any.fromPartial(object.privKey);
        }
        message.privKeyType = object.privKeyType ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            privKey: object.priv_key ? Any.fromSDK(object.priv_key) : undefined,
            privKeyType: object?.priv_key_type
        };
    },
    fromSDKJSON(object) {
        return {
            priv_key: isSet(object.priv_key) ? Any.fromSDKJSON(object.priv_key) : undefined,
            priv_key_type: isSet(object.priv_key_type) ? String(object.priv_key_type) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        message.privKey !== undefined && (obj.priv_key = message.privKey ? Any.toSDK(message.privKey) : undefined);
        obj.priv_key_type = message.privKeyType;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseRecord_Local();
        if (object.priv_key !== undefined && object.priv_key !== null) {
            message.privKey = Any.fromAmino(object.priv_key);
        }
        if (object.priv_key_type !== undefined && object.priv_key_type !== null) {
            message.privKeyType = object.priv_key_type;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.priv_key = message.privKey ? Any.toAmino(message.privKey) : undefined;
        obj.priv_key_type = message.privKeyType === "" ? undefined : message.privKeyType;
        return obj;
    },
    fromAminoMsg(object) {
        return Record_Local.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "cosmos-sdk/Local",
            value: Record_Local.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Record_Local.decode(message.value);
    },
    toProto(message) {
        return Record_Local.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/cosmos.crypto.keyring.v1.Local",
            value: Record_Local.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseRecord_Ledger() {
    return {
        path: undefined
    };
}
export const Record_Ledger = {
    typeUrl: "/cosmos.crypto.keyring.v1.Ledger",
    aminoType: "cosmos-sdk/Ledger",
    is(o) {
        return o && o.$typeUrl === Record_Ledger.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === Record_Ledger.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === Record_Ledger.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.path !== undefined) {
            BIP44Params.encode(message.path, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRecord_Ledger();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.path = BIP44Params.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseRecord_Ledger();
        if (isSet(object.path))
            obj.path = BIP44Params.fromJSON(object.path);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.path !== undefined && (obj.path = message.path ? BIP44Params.toJSON(message.path) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseRecord_Ledger();
        if (object.path !== undefined && object.path !== null) {
            message.path = BIP44Params.fromPartial(object.path);
        }
        return message;
    },
    fromSDK(object) {
        return {
            path: object.path ? BIP44Params.fromSDK(object.path) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            path: isSet(object.path) ? BIP44Params.fromSDKJSON(object.path) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.path !== undefined && (obj.path = message.path ? BIP44Params.toSDK(message.path) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseRecord_Ledger();
        if (object.path !== undefined && object.path !== null) {
            message.path = BIP44Params.fromAmino(object.path);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.path = message.path ? BIP44Params.toAmino(message.path) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return Record_Ledger.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "cosmos-sdk/Ledger",
            value: Record_Ledger.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Record_Ledger.decode(message.value);
    },
    toProto(message) {
        return Record_Ledger.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/cosmos.crypto.keyring.v1.Ledger",
            value: Record_Ledger.encode(message).finish()
        };
    },
    registerTypeUrl() {
        BIP44Params.registerTypeUrl();
    }
};
function createBaseRecord_Multi() {
    return {};
}
export const Record_Multi = {
    typeUrl: "/cosmos.crypto.keyring.v1.Multi",
    aminoType: "cosmos-sdk/Multi",
    is(o) {
        return o && o.$typeUrl === Record_Multi.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === Record_Multi.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === Record_Multi.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRecord_Multi();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseRecord_Multi();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseRecord_Multi();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseRecord_Multi();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return Record_Multi.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "cosmos-sdk/Multi",
            value: Record_Multi.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Record_Multi.decode(message.value);
    },
    toProto(message) {
        return Record_Multi.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/cosmos.crypto.keyring.v1.Multi",
            value: Record_Multi.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseRecord_Offline() {
    return {};
}
export const Record_Offline = {
    typeUrl: "/cosmos.crypto.keyring.v1.Offline",
    aminoType: "cosmos-sdk/Offline",
    is(o) {
        return o && o.$typeUrl === Record_Offline.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === Record_Offline.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === Record_Offline.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRecord_Offline();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseRecord_Offline();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseRecord_Offline();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseRecord_Offline();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return Record_Offline.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "cosmos-sdk/Offline",
            value: Record_Offline.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Record_Offline.decode(message.value);
    },
    toProto(message) {
        return Record_Offline.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/cosmos.crypto.keyring.v1.Offline",
            value: Record_Offline.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
