import { PageRequest } from "../../base/query/v1beta1/pagination";
import { BinaryReader } from "../../../binary";
import { QueryEvidenceRequest, QueryEvidenceResponse, QueryAllEvidenceRequest, QueryAllEvidenceResponse } from "./query";
export class QueryClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* Evidence queries evidence based on evidence hash. */
    evidence = async (request) => {
        const data = QueryEvidenceRequest.encode(request).finish();
        const promise = this.rpc.request("cosmos.evidence.v1beta1.Query", "Evidence", data);
        return promise.then(data => QueryEvidenceResponse.decode(new BinaryReader(data)));
    };
    /* AllEvidence queries all evidence. */
    allEvidence = async (request = {
        pagination: PageRequest.fromPartial({})
    }) => {
        const data = QueryAllEvidenceRequest.encode(request).finish();
        const promise = this.rpc.request("cosmos.evidence.v1beta1.Query", "AllEvidence", data);
        return promise.then(data => QueryAllEvidenceResponse.decode(new BinaryReader(data)));
    };
}
export const createClientImpl = (rpc) => {
    return new QueryClientImpl(rpc);
};
