import { QueryParamsResponse, QuerySubspacesResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* Params queries a specific parameter of a module, given its subspace and
     key. */
    params = async (params) => {
        const options = {
            params: {}
        };
        if (typeof params?.subspace !== "undefined") {
            options.params.subspace = params.subspace;
        }
        if (typeof params?.key !== "undefined") {
            options.params.key = params.key;
        }
        const endpoint = `cosmos/params/v1beta1/params`;
        return QueryParamsResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
    /* Subspaces queries for all registered subspaces and all keys for a subspace. */
    subspaces = async (_params = {}) => {
        const endpoint = `cosmos/params/v1beta1/subspaces`;
        return QuerySubspacesResponse.fromSDKJSON(await this.req.get(endpoint));
    };
}
