import { PageRequest } from "../../base/query/v1beta1/pagination";
import { setPaginationParams } from "../../../helpers";
import { QueryParamsResponse, QuerySigningInfoResponse, QuerySigningInfosResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* Params queries the parameters of slashing module */
    params = async (_params = {}) => {
        const endpoint = `cosmos/slashing/v1beta1/params`;
        return QueryParamsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* SigningInfo queries the signing info of given cons address */
    signingInfo = async (params) => {
        const endpoint = `cosmos/slashing/v1beta1/signing_infos/${params.consAddress}`;
        return QuerySigningInfoResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* SigningInfos queries signing info of all validators */
    signingInfos = async (params = {
        pagination: PageRequest.fromPartial({})
    }) => {
        const options = {
            params: {}
        };
        if (typeof params?.pagination !== "undefined") {
            setPaginationParams(options, params.pagination);
        }
        const endpoint = `cosmos/slashing/v1beta1/signing_infos`;
        return QuerySigningInfosResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
}
