import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "cosmos.slashing.v1beta1";
function createBaseMsgUnjail() {
    return {
        validatorAddr: ""
    };
}
export const MsgUnjail = {
    typeUrl: "/cosmos.slashing.v1beta1.MsgUnjail",
    aminoType: "cosmos-sdk/MsgUnjail",
    is(o) {
        return o && (o.$typeUrl === MsgUnjail.typeUrl || typeof o.validatorAddr === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgUnjail.typeUrl || typeof o.validator_addr === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgUnjail.typeUrl || typeof o.validator_addr === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.validatorAddr !== undefined) {
            writer.uint32(10).string(message.validatorAddr);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgUnjail();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.validatorAddr = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgUnjail();
        if (isSet(object.validatorAddr))
            obj.validatorAddr = String(object.validatorAddr);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.validatorAddr !== undefined && (obj.validatorAddr = message.validatorAddr);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgUnjail();
        message.validatorAddr = object.validatorAddr ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            validatorAddr: object?.validator_addr
        };
    },
    fromSDKJSON(object) {
        return {
            validator_addr: isSet(object.validator_addr) ? String(object.validator_addr) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.validator_addr = message.validatorAddr;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgUnjail();
        if (object.validator_addr !== undefined && object.validator_addr !== null) {
            message.validatorAddr = object.validator_addr;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.validator_addr = message.validatorAddr ?? "";
        return obj;
    },
    fromAminoMsg(object) {
        return MsgUnjail.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "cosmos-sdk/MsgUnjail",
            value: MsgUnjail.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgUnjail.decode(message.value);
    },
    toProto(message) {
        return MsgUnjail.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/cosmos.slashing.v1beta1.MsgUnjail",
            value: MsgUnjail.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgUnjailResponse() {
    return {};
}
export const MsgUnjailResponse = {
    typeUrl: "/cosmos.slashing.v1beta1.MsgUnjailResponse",
    aminoType: "cosmos-sdk/MsgUnjailResponse",
    is(o) {
        return o && o.$typeUrl === MsgUnjailResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgUnjailResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgUnjailResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgUnjailResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgUnjailResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgUnjailResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgUnjailResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgUnjailResponse.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "cosmos-sdk/MsgUnjailResponse",
            value: MsgUnjailResponse.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return MsgUnjailResponse.decode(message.value);
    },
    toProto(message) {
        return MsgUnjailResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/cosmos.slashing.v1beta1.MsgUnjailResponse",
            value: MsgUnjailResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
