import { buildTx } from "../../../helper-func-types";
import { toEncoders, toConverters } from "@interchainjs/cosmos/utils";
import { MsgCreateValidator, MsgEditValidator, MsgDelegate, MsgBeginRedelegate, MsgUndelegate } from "./tx";
export const createCreateValidator = (clientResolver) => buildTx({
    clientResolver,
    typeUrl: MsgCreateValidator.typeUrl,
    encoders: toEncoders(MsgCreateValidator),
    converters: toConverters(MsgCreateValidator),
    deps: [MsgCreateValidator]
});
export const createEditValidator = (clientResolver) => buildTx({
    clientResolver,
    typeUrl: MsgEditValidator.typeUrl,
    encoders: toEncoders(MsgEditValidator),
    converters: toConverters(MsgEditValidator),
    deps: [MsgEditValidator]
});
export const createDelegate = (clientResolver) => buildTx({
    clientResolver,
    typeUrl: MsgDelegate.typeUrl,
    encoders: toEncoders(MsgDelegate),
    converters: toConverters(MsgDelegate),
    deps: [MsgDelegate]
});
export const createBeginRedelegate = (clientResolver) => buildTx({
    clientResolver,
    typeUrl: MsgBeginRedelegate.typeUrl,
    encoders: toEncoders(MsgBeginRedelegate),
    converters: toConverters(MsgBeginRedelegate),
    deps: [MsgBeginRedelegate]
});
export const createUndelegate = (clientResolver) => buildTx({
    clientResolver,
    typeUrl: MsgUndelegate.typeUrl,
    encoders: toEncoders(MsgUndelegate),
    converters: toConverters(MsgUndelegate),
    deps: [MsgUndelegate]
});
