import { MsgSoftwareUpgrade, MsgCancelUpgrade } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* SoftwareUpgrade is a governance operation for initiating a software upgrade.
    
     Since: cosmos-sdk 0.46 */
    softwareUpgrade = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgSoftwareUpgrade.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* CancelUpgrade is a governance operation for cancelling a previously
     approvid software upgrade.
    
     Since: cosmos-sdk 0.46 */
    cancelUpgrade = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgCancelUpgrade.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
