import { PageRequest } from "../../../cosmos/base/query/v1beta1/pagination";
import { setPaginationParams } from "../../../helpers";
import { QueryTotalUnclaimedResponse, QueryParamsResponse, QueryClaimsRecordsResponse, QueryClaimsRecordResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* TotalUnclaimed queries the total unclaimed tokens from the airdrop */
    totalUnclaimed = async (_params = {}) => {
        const endpoint = `evmos/claims/v1/total_unclaimed`;
        return QueryTotalUnclaimedResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* Params returns the claims module parameters */
    params = async (_params = {}) => {
        const endpoint = `evmos/claims/v1/params`;
        return QueryParamsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* ClaimsRecords returns all claims records */
    claimsRecords = async (params = {
        pagination: PageRequest.fromPartial({})
    }) => {
        const options = {
            params: {}
        };
        if (typeof params?.pagination !== "undefined") {
            setPaginationParams(options, params.pagination);
        }
        const endpoint = `evmos/claims/v1/claims_records`;
        return QueryClaimsRecordsResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
    /* ClaimsRecord returns the claims record for a given address */
    claimsRecord = async (params) => {
        const endpoint = `evmos/claims/v1/claims_records/${params.address}`;
        return QueryClaimsRecordResponse.fromSDKJSON(await this.req.get(endpoint));
    };
}
