import { PageRequest } from "../../../cosmos/base/query/v1beta1/pagination";
import { setPaginationParams } from "../../../helpers";
import { QueryEpochsInfoResponse, QueryCurrentEpochResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* EpochInfos provide running epochInfos */
    epochInfos = async (params = {
        pagination: PageRequest.fromPartial({})
    }) => {
        const options = {
            params: {}
        };
        if (typeof params?.pagination !== "undefined") {
            setPaginationParams(options, params.pagination);
        }
        const endpoint = `evmos/epochs/v1/epochs`;
        return QueryEpochsInfoResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
    /* CurrentEpoch provide current epoch of specified identifier */
    currentEpoch = async (params) => {
        const options = {
            params: {}
        };
        if (typeof params?.identifier !== "undefined") {
            options.params.identifier = params.identifier;
        }
        const endpoint = `evmos/epochs/v1/current_epoch`;
        return QueryCurrentEpochResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
}
