import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import { TokenPair } from "./erc20";
import { Params } from "./genesis";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "evmos.erc20.v1";
function createBaseQueryTokenPairsRequest() {
    return {
        pagination: undefined
    };
}
export const QueryTokenPairsRequest = {
    typeUrl: "/evmos.erc20.v1.QueryTokenPairsRequest",
    is(o) {
        return o && o.$typeUrl === QueryTokenPairsRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryTokenPairsRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryTokenPairsRequest.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryTokenPairsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryTokenPairsRequest();
        if (isSet(object.pagination))
            obj.pagination = PageRequest.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryTokenPairsRequest();
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            pagination: object.pagination ? PageRequest.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            pagination: isSet(object.pagination) ? PageRequest.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryTokenPairsRequest();
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.pagination = message.pagination ? PageRequest.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryTokenPairsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryTokenPairsRequest.decode(message.value);
    },
    toProto(message) {
        return QueryTokenPairsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.erc20.v1.QueryTokenPairsRequest",
            value: QueryTokenPairsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        PageRequest.registerTypeUrl();
    }
};
function createBaseQueryTokenPairsResponse() {
    return {
        tokenPairs: [],
        pagination: undefined
    };
}
export const QueryTokenPairsResponse = {
    typeUrl: "/evmos.erc20.v1.QueryTokenPairsResponse",
    is(o) {
        return o && (o.$typeUrl === QueryTokenPairsResponse.typeUrl || Array.isArray(o.tokenPairs) && (!o.tokenPairs.length || TokenPair.is(o.tokenPairs[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryTokenPairsResponse.typeUrl || Array.isArray(o.token_pairs) && (!o.token_pairs.length || TokenPair.isSDK(o.token_pairs[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryTokenPairsResponse.typeUrl || Array.isArray(o.token_pairs) && (!o.token_pairs.length || TokenPair.isAmino(o.token_pairs[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.tokenPairs) {
            TokenPair.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryTokenPairsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.tokenPairs.push(TokenPair.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryTokenPairsResponse();
        if (Array.isArray(object?.tokenPairs))
            obj.tokenPairs = object.tokenPairs.map((e) => TokenPair.fromJSON(e));
        if (isSet(object.pagination))
            obj.pagination = PageResponse.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.tokenPairs) {
            obj.tokenPairs = message.tokenPairs.map(e => e ? TokenPair.toJSON(e) : undefined);
        }
        else {
            obj.tokenPairs = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryTokenPairsResponse();
        message.tokenPairs = object.tokenPairs?.map(e => TokenPair.fromPartial(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            tokenPairs: Array.isArray(object?.token_pairs) ? object.token_pairs.map((e) => TokenPair.fromSDK(e)) : [],
            pagination: object.pagination ? PageResponse.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            token_pairs: Array.isArray(object?.token_pairs) ? object.token_pairs.map((e) => TokenPair.fromSDKJSON(e)) : [],
            pagination: isSet(object.pagination) ? PageResponse.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.tokenPairs) {
            obj.token_pairs = message.tokenPairs.map(e => e ? TokenPair.toSDK(e) : undefined);
        }
        else {
            obj.token_pairs = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryTokenPairsResponse();
        message.tokenPairs = object.token_pairs?.map(e => TokenPair.fromAmino(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.tokenPairs) {
            obj.token_pairs = message.tokenPairs.map(e => e ? TokenPair.toAmino(e) : undefined);
        }
        else {
            obj.token_pairs = message.tokenPairs;
        }
        obj.pagination = message.pagination ? PageResponse.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryTokenPairsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryTokenPairsResponse.decode(message.value);
    },
    toProto(message) {
        return QueryTokenPairsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.erc20.v1.QueryTokenPairsResponse",
            value: QueryTokenPairsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        TokenPair.registerTypeUrl();
        PageResponse.registerTypeUrl();
    }
};
function createBaseQueryTokenPairRequest() {
    return {
        token: ""
    };
}
export const QueryTokenPairRequest = {
    typeUrl: "/evmos.erc20.v1.QueryTokenPairRequest",
    is(o) {
        return o && (o.$typeUrl === QueryTokenPairRequest.typeUrl || typeof o.token === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryTokenPairRequest.typeUrl || typeof o.token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryTokenPairRequest.typeUrl || typeof o.token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.token !== undefined) {
            writer.uint32(10).string(message.token);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryTokenPairRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.token = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryTokenPairRequest();
        if (isSet(object.token))
            obj.token = String(object.token);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.token !== undefined && (obj.token = message.token);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryTokenPairRequest();
        message.token = object.token ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            token: object?.token
        };
    },
    fromSDKJSON(object) {
        return {
            token: isSet(object.token) ? String(object.token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.token = message.token;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryTokenPairRequest();
        if (object.token !== undefined && object.token !== null) {
            message.token = object.token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.token = message.token === "" ? undefined : message.token;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryTokenPairRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryTokenPairRequest.decode(message.value);
    },
    toProto(message) {
        return QueryTokenPairRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.erc20.v1.QueryTokenPairRequest",
            value: QueryTokenPairRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryTokenPairResponse() {
    return {
        tokenPair: TokenPair.fromPartial({})
    };
}
export const QueryTokenPairResponse = {
    typeUrl: "/evmos.erc20.v1.QueryTokenPairResponse",
    is(o) {
        return o && (o.$typeUrl === QueryTokenPairResponse.typeUrl || TokenPair.is(o.tokenPair));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryTokenPairResponse.typeUrl || TokenPair.isSDK(o.token_pair));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryTokenPairResponse.typeUrl || TokenPair.isAmino(o.token_pair));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.tokenPair !== undefined) {
            TokenPair.encode(message.tokenPair, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryTokenPairResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.tokenPair = TokenPair.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryTokenPairResponse();
        if (isSet(object.tokenPair))
            obj.tokenPair = TokenPair.fromJSON(object.tokenPair);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.tokenPair !== undefined && (obj.tokenPair = message.tokenPair ? TokenPair.toJSON(message.tokenPair) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryTokenPairResponse();
        if (object.tokenPair !== undefined && object.tokenPair !== null) {
            message.tokenPair = TokenPair.fromPartial(object.tokenPair);
        }
        return message;
    },
    fromSDK(object) {
        return {
            tokenPair: object.token_pair ? TokenPair.fromSDK(object.token_pair) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            token_pair: isSet(object.token_pair) ? TokenPair.fromSDKJSON(object.token_pair) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.tokenPair !== undefined && (obj.token_pair = message.tokenPair ? TokenPair.toSDK(message.tokenPair) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryTokenPairResponse();
        if (object.token_pair !== undefined && object.token_pair !== null) {
            message.tokenPair = TokenPair.fromAmino(object.token_pair);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.token_pair = message.tokenPair ? TokenPair.toAmino(message.tokenPair) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryTokenPairResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryTokenPairResponse.decode(message.value);
    },
    toProto(message) {
        return QueryTokenPairResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.erc20.v1.QueryTokenPairResponse",
            value: QueryTokenPairResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        TokenPair.registerTypeUrl();
    }
};
function createBaseQueryParamsRequest() {
    return {};
}
export const QueryParamsRequest = {
    typeUrl: "/evmos.erc20.v1.QueryParamsRequest",
    is(o) {
        return o && o.$typeUrl === QueryParamsRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryParamsRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryParamsRequest.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParamsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseQueryParamsRequest();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseQueryParamsRequest();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseQueryParamsRequest();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return QueryParamsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryParamsRequest.decode(message.value);
    },
    toProto(message) {
        return QueryParamsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.erc20.v1.QueryParamsRequest",
            value: QueryParamsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryParamsResponse() {
    return {
        params: Params.fromPartial({})
    };
}
export const QueryParamsResponse = {
    typeUrl: "/evmos.erc20.v1.QueryParamsResponse",
    is(o) {
        return o && (o.$typeUrl === QueryParamsResponse.typeUrl || Params.is(o.params));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryParamsResponse.typeUrl || Params.isSDK(o.params));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryParamsResponse.typeUrl || Params.isAmino(o.params));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.params !== undefined) {
            Params.encode(message.params, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParamsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.params = Params.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryParamsResponse();
        if (isSet(object.params))
            obj.params = Params.fromJSON(object.params);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryParamsResponse();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromPartial(object.params);
        }
        return message;
    },
    fromSDK(object) {
        return {
            params: object.params ? Params.fromSDK(object.params) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            params: isSet(object.params) ? Params.fromSDKJSON(object.params) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toSDK(message.params) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryParamsResponse();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromAmino(object.params);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.params = message.params ? Params.toAmino(message.params) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryParamsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryParamsResponse.decode(message.value);
    },
    toProto(message) {
        return QueryParamsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.erc20.v1.QueryParamsResponse",
            value: QueryParamsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Params.registerTypeUrl();
    }
};
