import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "evmos.erc20.v1";
function createBaseMsgConvertCoin() {
    return {
        coin: Coin.fromPartial({}),
        receiver: "",
        sender: ""
    };
}
export const MsgConvertCoin = {
    typeUrl: "/evmos.erc20.v1.MsgConvertCoin",
    is(o) {
        return o && (o.$typeUrl === MsgConvertCoin.typeUrl || Coin.is(o.coin) && typeof o.receiver === "string" && typeof o.sender === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgConvertCoin.typeUrl || Coin.isSDK(o.coin) && typeof o.receiver === "string" && typeof o.sender === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgConvertCoin.typeUrl || Coin.isAmino(o.coin) && typeof o.receiver === "string" && typeof o.sender === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.coin !== undefined) {
            Coin.encode(message.coin, writer.uint32(10).fork()).ldelim();
        }
        if (message.receiver !== undefined) {
            writer.uint32(18).string(message.receiver);
        }
        if (message.sender !== undefined) {
            writer.uint32(26).string(message.sender);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgConvertCoin();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.coin = Coin.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.receiver = reader.string();
                    break;
                case 3:
                    message.sender = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgConvertCoin();
        if (isSet(object.coin))
            obj.coin = Coin.fromJSON(object.coin);
        if (isSet(object.receiver))
            obj.receiver = String(object.receiver);
        if (isSet(object.sender))
            obj.sender = String(object.sender);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.coin !== undefined && (obj.coin = message.coin ? Coin.toJSON(message.coin) : undefined);
        message.receiver !== undefined && (obj.receiver = message.receiver);
        message.sender !== undefined && (obj.sender = message.sender);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgConvertCoin();
        if (object.coin !== undefined && object.coin !== null) {
            message.coin = Coin.fromPartial(object.coin);
        }
        message.receiver = object.receiver ?? "";
        message.sender = object.sender ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            coin: object.coin ? Coin.fromSDK(object.coin) : undefined,
            receiver: object?.receiver,
            sender: object?.sender
        };
    },
    fromSDKJSON(object) {
        return {
            coin: isSet(object.coin) ? Coin.fromSDKJSON(object.coin) : undefined,
            receiver: isSet(object.receiver) ? String(object.receiver) : "",
            sender: isSet(object.sender) ? String(object.sender) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        message.coin !== undefined && (obj.coin = message.coin ? Coin.toSDK(message.coin) : undefined);
        obj.receiver = message.receiver;
        obj.sender = message.sender;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgConvertCoin();
        if (object.coin !== undefined && object.coin !== null) {
            message.coin = Coin.fromAmino(object.coin);
        }
        if (object.receiver !== undefined && object.receiver !== null) {
            message.receiver = object.receiver;
        }
        if (object.sender !== undefined && object.sender !== null) {
            message.sender = object.sender;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.coin = message.coin ? Coin.toAmino(message.coin) : undefined;
        obj.receiver = message.receiver === "" ? undefined : message.receiver;
        obj.sender = message.sender === "" ? undefined : message.sender;
        return obj;
    },
    fromAminoMsg(object) {
        return MsgConvertCoin.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MsgConvertCoin.decode(message.value);
    },
    toProto(message) {
        return MsgConvertCoin.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.erc20.v1.MsgConvertCoin",
            value: MsgConvertCoin.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Coin.registerTypeUrl();
    }
};
function createBaseMsgConvertCoinResponse() {
    return {};
}
export const MsgConvertCoinResponse = {
    typeUrl: "/evmos.erc20.v1.MsgConvertCoinResponse",
    is(o) {
        return o && o.$typeUrl === MsgConvertCoinResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgConvertCoinResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgConvertCoinResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgConvertCoinResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgConvertCoinResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgConvertCoinResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgConvertCoinResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgConvertCoinResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MsgConvertCoinResponse.decode(message.value);
    },
    toProto(message) {
        return MsgConvertCoinResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.erc20.v1.MsgConvertCoinResponse",
            value: MsgConvertCoinResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgConvertERC20() {
    return {
        contractAddress: "",
        amount: "",
        receiver: "",
        sender: ""
    };
}
export const MsgConvertERC20 = {
    typeUrl: "/evmos.erc20.v1.MsgConvertERC20",
    is(o) {
        return o && (o.$typeUrl === MsgConvertERC20.typeUrl || typeof o.contractAddress === "string" && typeof o.amount === "string" && typeof o.receiver === "string" && typeof o.sender === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgConvertERC20.typeUrl || typeof o.contract_address === "string" && typeof o.amount === "string" && typeof o.receiver === "string" && typeof o.sender === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgConvertERC20.typeUrl || typeof o.contract_address === "string" && typeof o.amount === "string" && typeof o.receiver === "string" && typeof o.sender === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.contractAddress !== undefined) {
            writer.uint32(10).string(message.contractAddress);
        }
        if (message.amount !== undefined) {
            writer.uint32(18).string(message.amount);
        }
        if (message.receiver !== undefined) {
            writer.uint32(26).string(message.receiver);
        }
        if (message.sender !== undefined) {
            writer.uint32(34).string(message.sender);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgConvertERC20();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.contractAddress = reader.string();
                    break;
                case 2:
                    message.amount = reader.string();
                    break;
                case 3:
                    message.receiver = reader.string();
                    break;
                case 4:
                    message.sender = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgConvertERC20();
        if (isSet(object.contractAddress))
            obj.contractAddress = String(object.contractAddress);
        if (isSet(object.amount))
            obj.amount = String(object.amount);
        if (isSet(object.receiver))
            obj.receiver = String(object.receiver);
        if (isSet(object.sender))
            obj.sender = String(object.sender);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.contractAddress !== undefined && (obj.contractAddress = message.contractAddress);
        message.amount !== undefined && (obj.amount = message.amount);
        message.receiver !== undefined && (obj.receiver = message.receiver);
        message.sender !== undefined && (obj.sender = message.sender);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgConvertERC20();
        message.contractAddress = object.contractAddress ?? "";
        message.amount = object.amount ?? "";
        message.receiver = object.receiver ?? "";
        message.sender = object.sender ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            contractAddress: object?.contract_address,
            amount: object?.amount,
            receiver: object?.receiver,
            sender: object?.sender
        };
    },
    fromSDKJSON(object) {
        return {
            contract_address: isSet(object.contract_address) ? String(object.contract_address) : "",
            amount: isSet(object.amount) ? String(object.amount) : "",
            receiver: isSet(object.receiver) ? String(object.receiver) : "",
            sender: isSet(object.sender) ? String(object.sender) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.contract_address = message.contractAddress;
        obj.amount = message.amount;
        obj.receiver = message.receiver;
        obj.sender = message.sender;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgConvertERC20();
        if (object.contract_address !== undefined && object.contract_address !== null) {
            message.contractAddress = object.contract_address;
        }
        if (object.amount !== undefined && object.amount !== null) {
            message.amount = object.amount;
        }
        if (object.receiver !== undefined && object.receiver !== null) {
            message.receiver = object.receiver;
        }
        if (object.sender !== undefined && object.sender !== null) {
            message.sender = object.sender;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.contract_address = message.contractAddress === "" ? undefined : message.contractAddress;
        obj.amount = message.amount === "" ? undefined : message.amount;
        obj.receiver = message.receiver === "" ? undefined : message.receiver;
        obj.sender = message.sender === "" ? undefined : message.sender;
        return obj;
    },
    fromAminoMsg(object) {
        return MsgConvertERC20.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MsgConvertERC20.decode(message.value);
    },
    toProto(message) {
        return MsgConvertERC20.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.erc20.v1.MsgConvertERC20",
            value: MsgConvertERC20.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgConvertERC20Response() {
    return {};
}
export const MsgConvertERC20Response = {
    typeUrl: "/evmos.erc20.v1.MsgConvertERC20Response",
    is(o) {
        return o && o.$typeUrl === MsgConvertERC20Response.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgConvertERC20Response.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgConvertERC20Response.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgConvertERC20Response();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgConvertERC20Response();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgConvertERC20Response();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgConvertERC20Response();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgConvertERC20Response.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MsgConvertERC20Response.decode(message.value);
    },
    toProto(message) {
        return MsgConvertERC20Response.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.erc20.v1.MsgConvertERC20Response",
            value: MsgConvertERC20Response.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
