import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import { DevFeeInfo } from "./fees";
import { Params } from "./genesis";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "evmos.fees.v1";
function createBaseQueryDevFeeInfosRequest() {
    return {
        pagination: undefined
    };
}
export const QueryDevFeeInfosRequest = {
    typeUrl: "/evmos.fees.v1.QueryDevFeeInfosRequest",
    is(o) {
        return o && o.$typeUrl === QueryDevFeeInfosRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryDevFeeInfosRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryDevFeeInfosRequest.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryDevFeeInfosRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryDevFeeInfosRequest();
        if (isSet(object.pagination))
            obj.pagination = PageRequest.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryDevFeeInfosRequest();
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            pagination: object.pagination ? PageRequest.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            pagination: isSet(object.pagination) ? PageRequest.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryDevFeeInfosRequest();
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.pagination = message.pagination ? PageRequest.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryDevFeeInfosRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryDevFeeInfosRequest.decode(message.value);
    },
    toProto(message) {
        return QueryDevFeeInfosRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.fees.v1.QueryDevFeeInfosRequest",
            value: QueryDevFeeInfosRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        PageRequest.registerTypeUrl();
    }
};
function createBaseQueryDevFeeInfosResponse() {
    return {
        fees: [],
        pagination: undefined
    };
}
export const QueryDevFeeInfosResponse = {
    typeUrl: "/evmos.fees.v1.QueryDevFeeInfosResponse",
    is(o) {
        return o && (o.$typeUrl === QueryDevFeeInfosResponse.typeUrl || Array.isArray(o.fees) && (!o.fees.length || DevFeeInfo.is(o.fees[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryDevFeeInfosResponse.typeUrl || Array.isArray(o.fees) && (!o.fees.length || DevFeeInfo.isSDK(o.fees[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryDevFeeInfosResponse.typeUrl || Array.isArray(o.fees) && (!o.fees.length || DevFeeInfo.isAmino(o.fees[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.fees) {
            DevFeeInfo.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryDevFeeInfosResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.fees.push(DevFeeInfo.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryDevFeeInfosResponse();
        if (Array.isArray(object?.fees))
            obj.fees = object.fees.map((e) => DevFeeInfo.fromJSON(e));
        if (isSet(object.pagination))
            obj.pagination = PageResponse.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.fees) {
            obj.fees = message.fees.map(e => e ? DevFeeInfo.toJSON(e) : undefined);
        }
        else {
            obj.fees = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryDevFeeInfosResponse();
        message.fees = object.fees?.map(e => DevFeeInfo.fromPartial(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            fees: Array.isArray(object?.fees) ? object.fees.map((e) => DevFeeInfo.fromSDK(e)) : [],
            pagination: object.pagination ? PageResponse.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            fees: Array.isArray(object?.fees) ? object.fees.map((e) => DevFeeInfo.fromSDKJSON(e)) : [],
            pagination: isSet(object.pagination) ? PageResponse.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.fees) {
            obj.fees = message.fees.map(e => e ? DevFeeInfo.toSDK(e) : undefined);
        }
        else {
            obj.fees = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryDevFeeInfosResponse();
        message.fees = object.fees?.map(e => DevFeeInfo.fromAmino(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.fees) {
            obj.fees = message.fees.map(e => e ? DevFeeInfo.toAmino(e) : undefined);
        }
        else {
            obj.fees = message.fees;
        }
        obj.pagination = message.pagination ? PageResponse.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryDevFeeInfosResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryDevFeeInfosResponse.decode(message.value);
    },
    toProto(message) {
        return QueryDevFeeInfosResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.fees.v1.QueryDevFeeInfosResponse",
            value: QueryDevFeeInfosResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        DevFeeInfo.registerTypeUrl();
        PageResponse.registerTypeUrl();
    }
};
function createBaseQueryDevFeeInfoRequest() {
    return {
        contractAddress: ""
    };
}
export const QueryDevFeeInfoRequest = {
    typeUrl: "/evmos.fees.v1.QueryDevFeeInfoRequest",
    is(o) {
        return o && (o.$typeUrl === QueryDevFeeInfoRequest.typeUrl || typeof o.contractAddress === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryDevFeeInfoRequest.typeUrl || typeof o.contract_address === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryDevFeeInfoRequest.typeUrl || typeof o.contract_address === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.contractAddress !== undefined) {
            writer.uint32(10).string(message.contractAddress);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryDevFeeInfoRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.contractAddress = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryDevFeeInfoRequest();
        if (isSet(object.contractAddress))
            obj.contractAddress = String(object.contractAddress);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.contractAddress !== undefined && (obj.contractAddress = message.contractAddress);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryDevFeeInfoRequest();
        message.contractAddress = object.contractAddress ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            contractAddress: object?.contract_address
        };
    },
    fromSDKJSON(object) {
        return {
            contract_address: isSet(object.contract_address) ? String(object.contract_address) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.contract_address = message.contractAddress;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryDevFeeInfoRequest();
        if (object.contract_address !== undefined && object.contract_address !== null) {
            message.contractAddress = object.contract_address;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.contract_address = message.contractAddress === "" ? undefined : message.contractAddress;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryDevFeeInfoRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryDevFeeInfoRequest.decode(message.value);
    },
    toProto(message) {
        return QueryDevFeeInfoRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.fees.v1.QueryDevFeeInfoRequest",
            value: QueryDevFeeInfoRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryDevFeeInfoResponse() {
    return {
        fee: DevFeeInfo.fromPartial({})
    };
}
export const QueryDevFeeInfoResponse = {
    typeUrl: "/evmos.fees.v1.QueryDevFeeInfoResponse",
    is(o) {
        return o && (o.$typeUrl === QueryDevFeeInfoResponse.typeUrl || DevFeeInfo.is(o.fee));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryDevFeeInfoResponse.typeUrl || DevFeeInfo.isSDK(o.fee));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryDevFeeInfoResponse.typeUrl || DevFeeInfo.isAmino(o.fee));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.fee !== undefined) {
            DevFeeInfo.encode(message.fee, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryDevFeeInfoResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.fee = DevFeeInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryDevFeeInfoResponse();
        if (isSet(object.fee))
            obj.fee = DevFeeInfo.fromJSON(object.fee);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.fee !== undefined && (obj.fee = message.fee ? DevFeeInfo.toJSON(message.fee) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryDevFeeInfoResponse();
        if (object.fee !== undefined && object.fee !== null) {
            message.fee = DevFeeInfo.fromPartial(object.fee);
        }
        return message;
    },
    fromSDK(object) {
        return {
            fee: object.fee ? DevFeeInfo.fromSDK(object.fee) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            fee: isSet(object.fee) ? DevFeeInfo.fromSDKJSON(object.fee) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.fee !== undefined && (obj.fee = message.fee ? DevFeeInfo.toSDK(message.fee) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryDevFeeInfoResponse();
        if (object.fee !== undefined && object.fee !== null) {
            message.fee = DevFeeInfo.fromAmino(object.fee);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.fee = message.fee ? DevFeeInfo.toAmino(message.fee) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryDevFeeInfoResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryDevFeeInfoResponse.decode(message.value);
    },
    toProto(message) {
        return QueryDevFeeInfoResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.fees.v1.QueryDevFeeInfoResponse",
            value: QueryDevFeeInfoResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        DevFeeInfo.registerTypeUrl();
    }
};
function createBaseQueryParamsRequest() {
    return {};
}
export const QueryParamsRequest = {
    typeUrl: "/evmos.fees.v1.QueryParamsRequest",
    is(o) {
        return o && o.$typeUrl === QueryParamsRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryParamsRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryParamsRequest.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParamsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseQueryParamsRequest();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseQueryParamsRequest();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseQueryParamsRequest();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return QueryParamsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryParamsRequest.decode(message.value);
    },
    toProto(message) {
        return QueryParamsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.fees.v1.QueryParamsRequest",
            value: QueryParamsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryParamsResponse() {
    return {
        params: Params.fromPartial({})
    };
}
export const QueryParamsResponse = {
    typeUrl: "/evmos.fees.v1.QueryParamsResponse",
    is(o) {
        return o && (o.$typeUrl === QueryParamsResponse.typeUrl || Params.is(o.params));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryParamsResponse.typeUrl || Params.isSDK(o.params));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryParamsResponse.typeUrl || Params.isAmino(o.params));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.params !== undefined) {
            Params.encode(message.params, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParamsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.params = Params.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryParamsResponse();
        if (isSet(object.params))
            obj.params = Params.fromJSON(object.params);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryParamsResponse();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromPartial(object.params);
        }
        return message;
    },
    fromSDK(object) {
        return {
            params: object.params ? Params.fromSDK(object.params) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            params: isSet(object.params) ? Params.fromSDKJSON(object.params) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toSDK(message.params) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryParamsResponse();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromAmino(object.params);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.params = message.params ? Params.toAmino(message.params) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryParamsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryParamsResponse.decode(message.value);
    },
    toProto(message) {
        return QueryParamsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.fees.v1.QueryParamsResponse",
            value: QueryParamsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Params.registerTypeUrl();
    }
};
function createBaseQueryDevFeeInfosPerDeployerRequest() {
    return {
        deployerAddress: "",
        pagination: undefined
    };
}
export const QueryDevFeeInfosPerDeployerRequest = {
    typeUrl: "/evmos.fees.v1.QueryDevFeeInfosPerDeployerRequest",
    is(o) {
        return o && (o.$typeUrl === QueryDevFeeInfosPerDeployerRequest.typeUrl || typeof o.deployerAddress === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryDevFeeInfosPerDeployerRequest.typeUrl || typeof o.deployer_address === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryDevFeeInfosPerDeployerRequest.typeUrl || typeof o.deployer_address === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.deployerAddress !== undefined) {
            writer.uint32(10).string(message.deployerAddress);
        }
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryDevFeeInfosPerDeployerRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.deployerAddress = reader.string();
                    break;
                case 2:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryDevFeeInfosPerDeployerRequest();
        if (isSet(object.deployerAddress))
            obj.deployerAddress = String(object.deployerAddress);
        if (isSet(object.pagination))
            obj.pagination = PageRequest.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.deployerAddress !== undefined && (obj.deployerAddress = message.deployerAddress);
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryDevFeeInfosPerDeployerRequest();
        message.deployerAddress = object.deployerAddress ?? "";
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            deployerAddress: object?.deployer_address,
            pagination: object.pagination ? PageRequest.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            deployer_address: isSet(object.deployer_address) ? String(object.deployer_address) : "",
            pagination: isSet(object.pagination) ? PageRequest.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.deployer_address = message.deployerAddress;
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryDevFeeInfosPerDeployerRequest();
        if (object.deployer_address !== undefined && object.deployer_address !== null) {
            message.deployerAddress = object.deployer_address;
        }
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.deployer_address = message.deployerAddress === "" ? undefined : message.deployerAddress;
        obj.pagination = message.pagination ? PageRequest.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryDevFeeInfosPerDeployerRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryDevFeeInfosPerDeployerRequest.decode(message.value);
    },
    toProto(message) {
        return QueryDevFeeInfosPerDeployerRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.fees.v1.QueryDevFeeInfosPerDeployerRequest",
            value: QueryDevFeeInfosPerDeployerRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        PageRequest.registerTypeUrl();
    }
};
function createBaseQueryDevFeeInfosPerDeployerResponse() {
    return {
        fees: [],
        pagination: undefined
    };
}
export const QueryDevFeeInfosPerDeployerResponse = {
    typeUrl: "/evmos.fees.v1.QueryDevFeeInfosPerDeployerResponse",
    is(o) {
        return o && (o.$typeUrl === QueryDevFeeInfosPerDeployerResponse.typeUrl || Array.isArray(o.fees) && (!o.fees.length || DevFeeInfo.is(o.fees[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryDevFeeInfosPerDeployerResponse.typeUrl || Array.isArray(o.fees) && (!o.fees.length || DevFeeInfo.isSDK(o.fees[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryDevFeeInfosPerDeployerResponse.typeUrl || Array.isArray(o.fees) && (!o.fees.length || DevFeeInfo.isAmino(o.fees[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.fees) {
            DevFeeInfo.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryDevFeeInfosPerDeployerResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.fees.push(DevFeeInfo.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryDevFeeInfosPerDeployerResponse();
        if (Array.isArray(object?.fees))
            obj.fees = object.fees.map((e) => DevFeeInfo.fromJSON(e));
        if (isSet(object.pagination))
            obj.pagination = PageResponse.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.fees) {
            obj.fees = message.fees.map(e => e ? DevFeeInfo.toJSON(e) : undefined);
        }
        else {
            obj.fees = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryDevFeeInfosPerDeployerResponse();
        message.fees = object.fees?.map(e => DevFeeInfo.fromPartial(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            fees: Array.isArray(object?.fees) ? object.fees.map((e) => DevFeeInfo.fromSDK(e)) : [],
            pagination: object.pagination ? PageResponse.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            fees: Array.isArray(object?.fees) ? object.fees.map((e) => DevFeeInfo.fromSDKJSON(e)) : [],
            pagination: isSet(object.pagination) ? PageResponse.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.fees) {
            obj.fees = message.fees.map(e => e ? DevFeeInfo.toSDK(e) : undefined);
        }
        else {
            obj.fees = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryDevFeeInfosPerDeployerResponse();
        message.fees = object.fees?.map(e => DevFeeInfo.fromAmino(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.fees) {
            obj.fees = message.fees.map(e => e ? DevFeeInfo.toAmino(e) : undefined);
        }
        else {
            obj.fees = message.fees;
        }
        obj.pagination = message.pagination ? PageResponse.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryDevFeeInfosPerDeployerResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryDevFeeInfosPerDeployerResponse.decode(message.value);
    },
    toProto(message) {
        return QueryDevFeeInfosPerDeployerResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.fees.v1.QueryDevFeeInfosPerDeployerResponse",
            value: QueryDevFeeInfosPerDeployerResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        DevFeeInfo.registerTypeUrl();
        PageResponse.registerTypeUrl();
    }
};
