import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "evmos.fees.v1";
function createBaseMsgRegisterDevFeeInfo() {
    return {
        contractAddress: "",
        deployerAddress: "",
        withdrawAddress: "",
        nonces: []
    };
}
export const MsgRegisterDevFeeInfo = {
    typeUrl: "/evmos.fees.v1.MsgRegisterDevFeeInfo",
    is(o) {
        return o && (o.$typeUrl === MsgRegisterDevFeeInfo.typeUrl || typeof o.contractAddress === "string" && typeof o.deployerAddress === "string" && typeof o.withdrawAddress === "string" && Array.isArray(o.nonces) && (!o.nonces.length || typeof o.nonces[0] === "bigint"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgRegisterDevFeeInfo.typeUrl || typeof o.contract_address === "string" && typeof o.deployer_address === "string" && typeof o.withdraw_address === "string" && Array.isArray(o.nonces) && (!o.nonces.length || typeof o.nonces[0] === "bigint"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgRegisterDevFeeInfo.typeUrl || typeof o.contract_address === "string" && typeof o.deployer_address === "string" && typeof o.withdraw_address === "string" && Array.isArray(o.nonces) && (!o.nonces.length || typeof o.nonces[0] === "bigint"));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.contractAddress !== undefined) {
            writer.uint32(10).string(message.contractAddress);
        }
        if (message.deployerAddress !== undefined) {
            writer.uint32(18).string(message.deployerAddress);
        }
        if (message.withdrawAddress !== undefined) {
            writer.uint32(26).string(message.withdrawAddress);
        }
        writer.uint32(34).fork();
        for (const v of message.nonces) {
            writer.uint64(v);
        }
        writer.ldelim();
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgRegisterDevFeeInfo();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.contractAddress = reader.string();
                    break;
                case 2:
                    message.deployerAddress = reader.string();
                    break;
                case 3:
                    message.withdrawAddress = reader.string();
                    break;
                case 4:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.nonces.push(reader.uint64());
                        }
                    }
                    else {
                        message.nonces.push(reader.uint64());
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgRegisterDevFeeInfo();
        if (isSet(object.contractAddress))
            obj.contractAddress = String(object.contractAddress);
        if (isSet(object.deployerAddress))
            obj.deployerAddress = String(object.deployerAddress);
        if (isSet(object.withdrawAddress))
            obj.withdrawAddress = String(object.withdrawAddress);
        if (Array.isArray(object?.nonces))
            obj.nonces = object.nonces.map((e) => BigInt(e.toString()));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.contractAddress !== undefined && (obj.contractAddress = message.contractAddress);
        message.deployerAddress !== undefined && (obj.deployerAddress = message.deployerAddress);
        message.withdrawAddress !== undefined && (obj.withdrawAddress = message.withdrawAddress);
        if (message.nonces) {
            obj.nonces = message.nonces.map(e => (e || BigInt(0)).toString());
        }
        else {
            obj.nonces = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgRegisterDevFeeInfo();
        message.contractAddress = object.contractAddress ?? "";
        message.deployerAddress = object.deployerAddress ?? "";
        message.withdrawAddress = object.withdrawAddress ?? "";
        message.nonces = object.nonces?.map(e => BigInt(e.toString())) || [];
        return message;
    },
    fromSDK(object) {
        return {
            contractAddress: object?.contract_address,
            deployerAddress: object?.deployer_address,
            withdrawAddress: object?.withdraw_address,
            nonces: Array.isArray(object?.nonces) ? object.nonces.map((e) => e) : []
        };
    },
    fromSDKJSON(object) {
        return {
            contract_address: isSet(object.contract_address) ? String(object.contract_address) : "",
            deployer_address: isSet(object.deployer_address) ? String(object.deployer_address) : "",
            withdraw_address: isSet(object.withdraw_address) ? String(object.withdraw_address) : "",
            nonces: Array.isArray(object?.nonces) ? object.nonces.map((e) => BigInt(e.toString())) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.contract_address = message.contractAddress;
        obj.deployer_address = message.deployerAddress;
        obj.withdraw_address = message.withdrawAddress;
        if (message.nonces) {
            obj.nonces = message.nonces.map(e => e);
        }
        else {
            obj.nonces = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgRegisterDevFeeInfo();
        if (object.contract_address !== undefined && object.contract_address !== null) {
            message.contractAddress = object.contract_address;
        }
        if (object.deployer_address !== undefined && object.deployer_address !== null) {
            message.deployerAddress = object.deployer_address;
        }
        if (object.withdraw_address !== undefined && object.withdraw_address !== null) {
            message.withdrawAddress = object.withdraw_address;
        }
        message.nonces = object.nonces?.map(e => BigInt(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.contract_address = message.contractAddress === "" ? undefined : message.contractAddress;
        obj.deployer_address = message.deployerAddress === "" ? undefined : message.deployerAddress;
        obj.withdraw_address = message.withdrawAddress === "" ? undefined : message.withdrawAddress;
        if (message.nonces) {
            obj.nonces = message.nonces.map(e => e.toString());
        }
        else {
            obj.nonces = message.nonces;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return MsgRegisterDevFeeInfo.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MsgRegisterDevFeeInfo.decode(message.value);
    },
    toProto(message) {
        return MsgRegisterDevFeeInfo.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.fees.v1.MsgRegisterDevFeeInfo",
            value: MsgRegisterDevFeeInfo.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgRegisterDevFeeInfoResponse() {
    return {};
}
export const MsgRegisterDevFeeInfoResponse = {
    typeUrl: "/evmos.fees.v1.MsgRegisterDevFeeInfoResponse",
    is(o) {
        return o && o.$typeUrl === MsgRegisterDevFeeInfoResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgRegisterDevFeeInfoResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgRegisterDevFeeInfoResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgRegisterDevFeeInfoResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgRegisterDevFeeInfoResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgRegisterDevFeeInfoResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgRegisterDevFeeInfoResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgRegisterDevFeeInfoResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MsgRegisterDevFeeInfoResponse.decode(message.value);
    },
    toProto(message) {
        return MsgRegisterDevFeeInfoResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.fees.v1.MsgRegisterDevFeeInfoResponse",
            value: MsgRegisterDevFeeInfoResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgCancelDevFeeInfo() {
    return {
        contractAddress: "",
        deployerAddress: ""
    };
}
export const MsgCancelDevFeeInfo = {
    typeUrl: "/evmos.fees.v1.MsgCancelDevFeeInfo",
    is(o) {
        return o && (o.$typeUrl === MsgCancelDevFeeInfo.typeUrl || typeof o.contractAddress === "string" && typeof o.deployerAddress === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgCancelDevFeeInfo.typeUrl || typeof o.contract_address === "string" && typeof o.deployer_address === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgCancelDevFeeInfo.typeUrl || typeof o.contract_address === "string" && typeof o.deployer_address === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.contractAddress !== undefined) {
            writer.uint32(10).string(message.contractAddress);
        }
        if (message.deployerAddress !== undefined) {
            writer.uint32(18).string(message.deployerAddress);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCancelDevFeeInfo();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.contractAddress = reader.string();
                    break;
                case 2:
                    message.deployerAddress = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgCancelDevFeeInfo();
        if (isSet(object.contractAddress))
            obj.contractAddress = String(object.contractAddress);
        if (isSet(object.deployerAddress))
            obj.deployerAddress = String(object.deployerAddress);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.contractAddress !== undefined && (obj.contractAddress = message.contractAddress);
        message.deployerAddress !== undefined && (obj.deployerAddress = message.deployerAddress);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgCancelDevFeeInfo();
        message.contractAddress = object.contractAddress ?? "";
        message.deployerAddress = object.deployerAddress ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            contractAddress: object?.contract_address,
            deployerAddress: object?.deployer_address
        };
    },
    fromSDKJSON(object) {
        return {
            contract_address: isSet(object.contract_address) ? String(object.contract_address) : "",
            deployer_address: isSet(object.deployer_address) ? String(object.deployer_address) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.contract_address = message.contractAddress;
        obj.deployer_address = message.deployerAddress;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgCancelDevFeeInfo();
        if (object.contract_address !== undefined && object.contract_address !== null) {
            message.contractAddress = object.contract_address;
        }
        if (object.deployer_address !== undefined && object.deployer_address !== null) {
            message.deployerAddress = object.deployer_address;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.contract_address = message.contractAddress === "" ? undefined : message.contractAddress;
        obj.deployer_address = message.deployerAddress === "" ? undefined : message.deployerAddress;
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCancelDevFeeInfo.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MsgCancelDevFeeInfo.decode(message.value);
    },
    toProto(message) {
        return MsgCancelDevFeeInfo.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.fees.v1.MsgCancelDevFeeInfo",
            value: MsgCancelDevFeeInfo.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgCancelDevFeeInfoResponse() {
    return {};
}
export const MsgCancelDevFeeInfoResponse = {
    typeUrl: "/evmos.fees.v1.MsgCancelDevFeeInfoResponse",
    is(o) {
        return o && o.$typeUrl === MsgCancelDevFeeInfoResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgCancelDevFeeInfoResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgCancelDevFeeInfoResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCancelDevFeeInfoResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgCancelDevFeeInfoResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgCancelDevFeeInfoResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgCancelDevFeeInfoResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCancelDevFeeInfoResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MsgCancelDevFeeInfoResponse.decode(message.value);
    },
    toProto(message) {
        return MsgCancelDevFeeInfoResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.fees.v1.MsgCancelDevFeeInfoResponse",
            value: MsgCancelDevFeeInfoResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgUpdateDevFeeInfo() {
    return {
        contractAddress: "",
        deployerAddress: "",
        withdrawAddress: ""
    };
}
export const MsgUpdateDevFeeInfo = {
    typeUrl: "/evmos.fees.v1.MsgUpdateDevFeeInfo",
    is(o) {
        return o && (o.$typeUrl === MsgUpdateDevFeeInfo.typeUrl || typeof o.contractAddress === "string" && typeof o.deployerAddress === "string" && typeof o.withdrawAddress === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgUpdateDevFeeInfo.typeUrl || typeof o.contract_address === "string" && typeof o.deployer_address === "string" && typeof o.withdraw_address === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgUpdateDevFeeInfo.typeUrl || typeof o.contract_address === "string" && typeof o.deployer_address === "string" && typeof o.withdraw_address === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.contractAddress !== undefined) {
            writer.uint32(10).string(message.contractAddress);
        }
        if (message.deployerAddress !== undefined) {
            writer.uint32(18).string(message.deployerAddress);
        }
        if (message.withdrawAddress !== undefined) {
            writer.uint32(26).string(message.withdrawAddress);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgUpdateDevFeeInfo();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.contractAddress = reader.string();
                    break;
                case 2:
                    message.deployerAddress = reader.string();
                    break;
                case 3:
                    message.withdrawAddress = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgUpdateDevFeeInfo();
        if (isSet(object.contractAddress))
            obj.contractAddress = String(object.contractAddress);
        if (isSet(object.deployerAddress))
            obj.deployerAddress = String(object.deployerAddress);
        if (isSet(object.withdrawAddress))
            obj.withdrawAddress = String(object.withdrawAddress);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.contractAddress !== undefined && (obj.contractAddress = message.contractAddress);
        message.deployerAddress !== undefined && (obj.deployerAddress = message.deployerAddress);
        message.withdrawAddress !== undefined && (obj.withdrawAddress = message.withdrawAddress);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgUpdateDevFeeInfo();
        message.contractAddress = object.contractAddress ?? "";
        message.deployerAddress = object.deployerAddress ?? "";
        message.withdrawAddress = object.withdrawAddress ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            contractAddress: object?.contract_address,
            deployerAddress: object?.deployer_address,
            withdrawAddress: object?.withdraw_address
        };
    },
    fromSDKJSON(object) {
        return {
            contract_address: isSet(object.contract_address) ? String(object.contract_address) : "",
            deployer_address: isSet(object.deployer_address) ? String(object.deployer_address) : "",
            withdraw_address: isSet(object.withdraw_address) ? String(object.withdraw_address) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.contract_address = message.contractAddress;
        obj.deployer_address = message.deployerAddress;
        obj.withdraw_address = message.withdrawAddress;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgUpdateDevFeeInfo();
        if (object.contract_address !== undefined && object.contract_address !== null) {
            message.contractAddress = object.contract_address;
        }
        if (object.deployer_address !== undefined && object.deployer_address !== null) {
            message.deployerAddress = object.deployer_address;
        }
        if (object.withdraw_address !== undefined && object.withdraw_address !== null) {
            message.withdrawAddress = object.withdraw_address;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.contract_address = message.contractAddress === "" ? undefined : message.contractAddress;
        obj.deployer_address = message.deployerAddress === "" ? undefined : message.deployerAddress;
        obj.withdraw_address = message.withdrawAddress === "" ? undefined : message.withdrawAddress;
        return obj;
    },
    fromAminoMsg(object) {
        return MsgUpdateDevFeeInfo.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MsgUpdateDevFeeInfo.decode(message.value);
    },
    toProto(message) {
        return MsgUpdateDevFeeInfo.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.fees.v1.MsgUpdateDevFeeInfo",
            value: MsgUpdateDevFeeInfo.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgUpdateDevFeeInfoResponse() {
    return {};
}
export const MsgUpdateDevFeeInfoResponse = {
    typeUrl: "/evmos.fees.v1.MsgUpdateDevFeeInfoResponse",
    is(o) {
        return o && o.$typeUrl === MsgUpdateDevFeeInfoResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgUpdateDevFeeInfoResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgUpdateDevFeeInfoResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgUpdateDevFeeInfoResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgUpdateDevFeeInfoResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgUpdateDevFeeInfoResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgUpdateDevFeeInfoResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgUpdateDevFeeInfoResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MsgUpdateDevFeeInfoResponse.decode(message.value);
    },
    toProto(message) {
        return MsgUpdateDevFeeInfoResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.fees.v1.MsgUpdateDevFeeInfoResponse",
            value: MsgUpdateDevFeeInfoResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
