import { MsgRegisterDevFeeInfo, MsgCancelDevFeeInfo, MsgUpdateDevFeeInfo } from "./tx";
export const registry = [["/evmos.fees.v1.MsgRegisterDevFeeInfo", MsgRegisterDevFeeInfo], ["/evmos.fees.v1.MsgCancelDevFeeInfo", MsgCancelDevFeeInfo], ["/evmos.fees.v1.MsgUpdateDevFeeInfo", MsgUpdateDevFeeInfo]];
export const load = (protoRegistry) => {
    registry.forEach(([typeUrl, mod]) => {
        protoRegistry.register(typeUrl, mod);
    });
};
export const MessageComposer = {
    encoded: {
        registerDevFeeInfo(value) {
            return {
                typeUrl: "/evmos.fees.v1.MsgRegisterDevFeeInfo",
                value: MsgRegisterDevFeeInfo.encode(value).finish()
            };
        },
        cancelDevFeeInfo(value) {
            return {
                typeUrl: "/evmos.fees.v1.MsgCancelDevFeeInfo",
                value: MsgCancelDevFeeInfo.encode(value).finish()
            };
        },
        updateDevFeeInfo(value) {
            return {
                typeUrl: "/evmos.fees.v1.MsgUpdateDevFeeInfo",
                value: MsgUpdateDevFeeInfo.encode(value).finish()
            };
        }
    },
    withTypeUrl: {
        registerDevFeeInfo(value) {
            return {
                typeUrl: "/evmos.fees.v1.MsgRegisterDevFeeInfo",
                value
            };
        },
        cancelDevFeeInfo(value) {
            return {
                typeUrl: "/evmos.fees.v1.MsgCancelDevFeeInfo",
                value
            };
        },
        updateDevFeeInfo(value) {
            return {
                typeUrl: "/evmos.fees.v1.MsgUpdateDevFeeInfo",
                value
            };
        }
    },
    toJSON: {
        registerDevFeeInfo(value) {
            return {
                typeUrl: "/evmos.fees.v1.MsgRegisterDevFeeInfo",
                value: MsgRegisterDevFeeInfo.toJSON(value)
            };
        },
        cancelDevFeeInfo(value) {
            return {
                typeUrl: "/evmos.fees.v1.MsgCancelDevFeeInfo",
                value: MsgCancelDevFeeInfo.toJSON(value)
            };
        },
        updateDevFeeInfo(value) {
            return {
                typeUrl: "/evmos.fees.v1.MsgUpdateDevFeeInfo",
                value: MsgUpdateDevFeeInfo.toJSON(value)
            };
        }
    },
    fromJSON: {
        registerDevFeeInfo(value) {
            return {
                typeUrl: "/evmos.fees.v1.MsgRegisterDevFeeInfo",
                value: MsgRegisterDevFeeInfo.fromJSON(value)
            };
        },
        cancelDevFeeInfo(value) {
            return {
                typeUrl: "/evmos.fees.v1.MsgCancelDevFeeInfo",
                value: MsgCancelDevFeeInfo.fromJSON(value)
            };
        },
        updateDevFeeInfo(value) {
            return {
                typeUrl: "/evmos.fees.v1.MsgUpdateDevFeeInfo",
                value: MsgUpdateDevFeeInfo.fromJSON(value)
            };
        }
    },
    fromPartial: {
        registerDevFeeInfo(value) {
            return {
                typeUrl: "/evmos.fees.v1.MsgRegisterDevFeeInfo",
                value: MsgRegisterDevFeeInfo.fromPartial(value)
            };
        },
        cancelDevFeeInfo(value) {
            return {
                typeUrl: "/evmos.fees.v1.MsgCancelDevFeeInfo",
                value: MsgCancelDevFeeInfo.fromPartial(value)
            };
        },
        updateDevFeeInfo(value) {
            return {
                typeUrl: "/evmos.fees.v1.MsgUpdateDevFeeInfo",
                value: MsgUpdateDevFeeInfo.fromPartial(value)
            };
        }
    }
};
