import { MsgRegisterDevFeeInfo, MsgCancelDevFeeInfo, MsgUpdateDevFeeInfo } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* RegisterDevFeeInfo is used by a deployer to register a new contract for
     receiving transaction fees */
    registerDevFeeInfo = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgRegisterDevFeeInfo.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* CancelDevFeeInfo is used by a deployer to cancel a registered contract
     and stop receiving transaction fees */
    cancelDevFeeInfo = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgCancelDevFeeInfo.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* UpdateDevFeeInfo is used by a deployer to update the withdraw address */
    updateDevFeeInfo = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgUpdateDevFeeInfo.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
