import { QueryPeriodResponse, QueryEpochMintProvisionResponse, QuerySkippedEpochsResponse, QueryCirculatingSupplyResponse, QueryInflationRateResponse, QueryParamsResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* Period retrieves current period. */
    period = async (_params = {}) => {
        const endpoint = `evmos/inflation/v1/period`;
        return QueryPeriodResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* EpochMintProvision retrieves current minting epoch provision value. */
    epochMintProvision = async (_params = {}) => {
        const endpoint = `evmos/inflation/v1/epoch_mint_provision`;
        return QueryEpochMintProvisionResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* SkippedEpochs retrieves the total number of skipped epochs. */
    skippedEpochs = async (_params = {}) => {
        const endpoint = `evmos/inflation/v1/skipped_epochs`;
        return QuerySkippedEpochsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* CirculatingSupply retrieves the total number of tokens that are in
     circulation (i.e. excluding unvested tokens). */
    circulatingSupply = async (_params = {}) => {
        const endpoint = `evmos/inflation/v1/circulating_supply`;
        return QueryCirculatingSupplyResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* InflationRate retrieves the inflation rate of the current period. */
    inflationRate = async (_params = {}) => {
        const endpoint = `evmos/inflation/v1/inflation_rate`;
        return QueryInflationRateResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* Params retrieves the total set of minting parameters. */
    params = async (_params = {}) => {
        const endpoint = `evmos/inflation/v1/params`;
        return QueryParamsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
}
