import { Duration } from "../../../google/protobuf/duration";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "evmos.recovery.v1";
function createBaseGenesisState() {
    return {
        params: Params.fromPartial({})
    };
}
export const GenesisState = {
    typeUrl: "/evmos.recovery.v1.GenesisState",
    is(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Params.is(o.params));
    },
    isSDK(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Params.isSDK(o.params));
    },
    isAmino(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Params.isAmino(o.params));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.params !== undefined) {
            Params.encode(message.params, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGenesisState();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.params = Params.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGenesisState();
        if (isSet(object.params))
            obj.params = Params.fromJSON(object.params);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGenesisState();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromPartial(object.params);
        }
        return message;
    },
    fromSDK(object) {
        return {
            params: object.params ? Params.fromSDK(object.params) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            params: isSet(object.params) ? Params.fromSDKJSON(object.params) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toSDK(message.params) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGenesisState();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromAmino(object.params);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.params = message.params ? Params.toAmino(message.params) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return GenesisState.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GenesisState.decode(message.value);
    },
    toProto(message) {
        return GenesisState.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.recovery.v1.GenesisState",
            value: GenesisState.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Params.registerTypeUrl();
    }
};
function createBaseParams() {
    return {
        enableRecovery: false,
        packetTimeoutDuration: Duration.fromPartial({})
    };
}
export const Params = {
    typeUrl: "/evmos.recovery.v1.Params",
    is(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.enableRecovery === "boolean" && Duration.is(o.packetTimeoutDuration));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.enable_recovery === "boolean" && Duration.isSDK(o.packet_timeout_duration));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.enable_recovery === "boolean" && Duration.isAmino(o.packet_timeout_duration));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.enableRecovery !== undefined) {
            writer.uint32(8).bool(message.enableRecovery);
        }
        if (message.packetTimeoutDuration !== undefined) {
            Duration.encode(message.packetTimeoutDuration, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseParams();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.enableRecovery = reader.bool();
                    break;
                case 2:
                    message.packetTimeoutDuration = Duration.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseParams();
        if (isSet(object.enableRecovery))
            obj.enableRecovery = Boolean(object.enableRecovery);
        if (isSet(object.packetTimeoutDuration))
            obj.packetTimeoutDuration = Duration.fromJSON(object.packetTimeoutDuration);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.enableRecovery !== undefined && (obj.enableRecovery = message.enableRecovery);
        message.packetTimeoutDuration !== undefined && (obj.packetTimeoutDuration = message.packetTimeoutDuration ? Duration.toJSON(message.packetTimeoutDuration) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseParams();
        message.enableRecovery = object.enableRecovery ?? false;
        if (object.packetTimeoutDuration !== undefined && object.packetTimeoutDuration !== null) {
            message.packetTimeoutDuration = Duration.fromPartial(object.packetTimeoutDuration);
        }
        return message;
    },
    fromSDK(object) {
        return {
            enableRecovery: object?.enable_recovery,
            packetTimeoutDuration: object.packet_timeout_duration ? Duration.fromSDK(object.packet_timeout_duration) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            enable_recovery: isSet(object.enable_recovery) ? Boolean(object.enable_recovery) : false,
            packet_timeout_duration: isSet(object.packet_timeout_duration) ? Duration.fromSDKJSON(object.packet_timeout_duration) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.enable_recovery = message.enableRecovery;
        message.packetTimeoutDuration !== undefined && (obj.packet_timeout_duration = message.packetTimeoutDuration ? Duration.toSDK(message.packetTimeoutDuration) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseParams();
        if (object.enable_recovery !== undefined && object.enable_recovery !== null) {
            message.enableRecovery = object.enable_recovery;
        }
        if (object.packet_timeout_duration !== undefined && object.packet_timeout_duration !== null) {
            message.packetTimeoutDuration = Duration.fromAmino(object.packet_timeout_duration);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.enable_recovery = message.enableRecovery === false ? undefined : message.enableRecovery;
        obj.packet_timeout_duration = message.packetTimeoutDuration ? Duration.toAmino(message.packetTimeoutDuration) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return Params.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Params.decode(message.value);
    },
    toProto(message) {
        return Params.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.recovery.v1.Params",
            value: Params.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
