import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "evmos.vesting.v1";
function createBaseQueryBalancesRequest() {
    return {
        address: ""
    };
}
export const QueryBalancesRequest = {
    typeUrl: "/evmos.vesting.v1.QueryBalancesRequest",
    is(o) {
        return o && (o.$typeUrl === QueryBalancesRequest.typeUrl || typeof o.address === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryBalancesRequest.typeUrl || typeof o.address === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryBalancesRequest.typeUrl || typeof o.address === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.address !== undefined) {
            writer.uint32(10).string(message.address);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryBalancesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.address = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryBalancesRequest();
        if (isSet(object.address))
            obj.address = String(object.address);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.address !== undefined && (obj.address = message.address);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryBalancesRequest();
        message.address = object.address ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            address: object?.address
        };
    },
    fromSDKJSON(object) {
        return {
            address: isSet(object.address) ? String(object.address) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.address = message.address;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryBalancesRequest();
        if (object.address !== undefined && object.address !== null) {
            message.address = object.address;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.address = message.address === "" ? undefined : message.address;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryBalancesRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryBalancesRequest.decode(message.value);
    },
    toProto(message) {
        return QueryBalancesRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.vesting.v1.QueryBalancesRequest",
            value: QueryBalancesRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryBalancesResponse() {
    return {
        locked: [],
        unvested: [],
        vested: []
    };
}
export const QueryBalancesResponse = {
    typeUrl: "/evmos.vesting.v1.QueryBalancesResponse",
    is(o) {
        return o && (o.$typeUrl === QueryBalancesResponse.typeUrl || Array.isArray(o.locked) && (!o.locked.length || Coin.is(o.locked[0])) && Array.isArray(o.unvested) && (!o.unvested.length || Coin.is(o.unvested[0])) && Array.isArray(o.vested) && (!o.vested.length || Coin.is(o.vested[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryBalancesResponse.typeUrl || Array.isArray(o.locked) && (!o.locked.length || Coin.isSDK(o.locked[0])) && Array.isArray(o.unvested) && (!o.unvested.length || Coin.isSDK(o.unvested[0])) && Array.isArray(o.vested) && (!o.vested.length || Coin.isSDK(o.vested[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryBalancesResponse.typeUrl || Array.isArray(o.locked) && (!o.locked.length || Coin.isAmino(o.locked[0])) && Array.isArray(o.unvested) && (!o.unvested.length || Coin.isAmino(o.unvested[0])) && Array.isArray(o.vested) && (!o.vested.length || Coin.isAmino(o.vested[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.locked) {
            Coin.encode(v, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.unvested) {
            Coin.encode(v, writer.uint32(18).fork()).ldelim();
        }
        for (const v of message.vested) {
            Coin.encode(v, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryBalancesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.locked.push(Coin.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.unvested.push(Coin.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.vested.push(Coin.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryBalancesResponse();
        if (Array.isArray(object?.locked))
            obj.locked = object.locked.map((e) => Coin.fromJSON(e));
        if (Array.isArray(object?.unvested))
            obj.unvested = object.unvested.map((e) => Coin.fromJSON(e));
        if (Array.isArray(object?.vested))
            obj.vested = object.vested.map((e) => Coin.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.locked) {
            obj.locked = message.locked.map(e => e ? Coin.toJSON(e) : undefined);
        }
        else {
            obj.locked = [];
        }
        if (message.unvested) {
            obj.unvested = message.unvested.map(e => e ? Coin.toJSON(e) : undefined);
        }
        else {
            obj.unvested = [];
        }
        if (message.vested) {
            obj.vested = message.vested.map(e => e ? Coin.toJSON(e) : undefined);
        }
        else {
            obj.vested = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryBalancesResponse();
        message.locked = object.locked?.map(e => Coin.fromPartial(e)) || [];
        message.unvested = object.unvested?.map(e => Coin.fromPartial(e)) || [];
        message.vested = object.vested?.map(e => Coin.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            locked: Array.isArray(object?.locked) ? object.locked.map((e) => Coin.fromSDK(e)) : [],
            unvested: Array.isArray(object?.unvested) ? object.unvested.map((e) => Coin.fromSDK(e)) : [],
            vested: Array.isArray(object?.vested) ? object.vested.map((e) => Coin.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            locked: Array.isArray(object?.locked) ? object.locked.map((e) => Coin.fromSDKJSON(e)) : [],
            unvested: Array.isArray(object?.unvested) ? object.unvested.map((e) => Coin.fromSDKJSON(e)) : [],
            vested: Array.isArray(object?.vested) ? object.vested.map((e) => Coin.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.locked) {
            obj.locked = message.locked.map(e => e ? Coin.toSDK(e) : undefined);
        }
        else {
            obj.locked = [];
        }
        if (message.unvested) {
            obj.unvested = message.unvested.map(e => e ? Coin.toSDK(e) : undefined);
        }
        else {
            obj.unvested = [];
        }
        if (message.vested) {
            obj.vested = message.vested.map(e => e ? Coin.toSDK(e) : undefined);
        }
        else {
            obj.vested = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryBalancesResponse();
        message.locked = object.locked?.map(e => Coin.fromAmino(e)) || [];
        message.unvested = object.unvested?.map(e => Coin.fromAmino(e)) || [];
        message.vested = object.vested?.map(e => Coin.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.locked) {
            obj.locked = message.locked.map(e => e ? Coin.toAmino(e) : undefined);
        }
        else {
            obj.locked = message.locked;
        }
        if (message.unvested) {
            obj.unvested = message.unvested.map(e => e ? Coin.toAmino(e) : undefined);
        }
        else {
            obj.unvested = message.unvested;
        }
        if (message.vested) {
            obj.vested = message.vested.map(e => e ? Coin.toAmino(e) : undefined);
        }
        else {
            obj.vested = message.vested;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return QueryBalancesResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryBalancesResponse.decode(message.value);
    },
    toProto(message) {
        return QueryBalancesResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.vesting.v1.QueryBalancesResponse",
            value: QueryBalancesResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Coin.registerTypeUrl();
    }
};
