import { MsgCreateClawbackVestingAccount, MsgClawback } from "./tx";
export const registry = [["/evmos.vesting.v1.MsgCreateClawbackVestingAccount", MsgCreateClawbackVestingAccount], ["/evmos.vesting.v1.MsgClawback", MsgClawback]];
export const load = (protoRegistry) => {
    registry.forEach(([typeUrl, mod]) => {
        protoRegistry.register(typeUrl, mod);
    });
};
export const MessageComposer = {
    encoded: {
        createClawbackVestingAccount(value) {
            return {
                typeUrl: "/evmos.vesting.v1.MsgCreateClawbackVestingAccount",
                value: MsgCreateClawbackVestingAccount.encode(value).finish()
            };
        },
        clawback(value) {
            return {
                typeUrl: "/evmos.vesting.v1.MsgClawback",
                value: MsgClawback.encode(value).finish()
            };
        }
    },
    withTypeUrl: {
        createClawbackVestingAccount(value) {
            return {
                typeUrl: "/evmos.vesting.v1.MsgCreateClawbackVestingAccount",
                value
            };
        },
        clawback(value) {
            return {
                typeUrl: "/evmos.vesting.v1.MsgClawback",
                value
            };
        }
    },
    toJSON: {
        createClawbackVestingAccount(value) {
            return {
                typeUrl: "/evmos.vesting.v1.MsgCreateClawbackVestingAccount",
                value: MsgCreateClawbackVestingAccount.toJSON(value)
            };
        },
        clawback(value) {
            return {
                typeUrl: "/evmos.vesting.v1.MsgClawback",
                value: MsgClawback.toJSON(value)
            };
        }
    },
    fromJSON: {
        createClawbackVestingAccount(value) {
            return {
                typeUrl: "/evmos.vesting.v1.MsgCreateClawbackVestingAccount",
                value: MsgCreateClawbackVestingAccount.fromJSON(value)
            };
        },
        clawback(value) {
            return {
                typeUrl: "/evmos.vesting.v1.MsgClawback",
                value: MsgClawback.fromJSON(value)
            };
        }
    },
    fromPartial: {
        createClawbackVestingAccount(value) {
            return {
                typeUrl: "/evmos.vesting.v1.MsgCreateClawbackVestingAccount",
                value: MsgCreateClawbackVestingAccount.fromPartial(value)
            };
        },
        clawback(value) {
            return {
                typeUrl: "/evmos.vesting.v1.MsgClawback",
                value: MsgClawback.fromPartial(value)
            };
        }
    }
};
