import { MsgCreateClawbackVestingAccount, MsgClawback } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* CreateClawbackVestingAccount creats a vesting account that is subject to
     clawback and the configuration of vesting and lockup schedules. */
    createClawbackVestingAccount = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgCreateClawbackVestingAccount.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* Clawback removes the unvested tokens from a ClawbackVestingAccount. */
    clawback = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgClawback.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
