import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseBilling() {
    return {
        consumerDestinations: []
    };
}
export const Billing = {
    typeUrl: "/google.api.Billing",
    is(o) {
        return o && (o.$typeUrl === Billing.typeUrl || Array.isArray(o.consumerDestinations) && (!o.consumerDestinations.length || Billing_BillingDestination.is(o.consumerDestinations[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Billing.typeUrl || Array.isArray(o.consumer_destinations) && (!o.consumer_destinations.length || Billing_BillingDestination.isSDK(o.consumer_destinations[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Billing.typeUrl || Array.isArray(o.consumer_destinations) && (!o.consumer_destinations.length || Billing_BillingDestination.isAmino(o.consumer_destinations[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.consumerDestinations) {
            Billing_BillingDestination.encode(v, writer.uint32(66).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseBilling();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 8:
                    message.consumerDestinations.push(Billing_BillingDestination.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseBilling();
        if (Array.isArray(object?.consumerDestinations))
            obj.consumerDestinations = object.consumerDestinations.map((e) => Billing_BillingDestination.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.consumerDestinations) {
            obj.consumerDestinations = message.consumerDestinations.map(e => e ? Billing_BillingDestination.toJSON(e) : undefined);
        }
        else {
            obj.consumerDestinations = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseBilling();
        message.consumerDestinations = object.consumerDestinations?.map(e => Billing_BillingDestination.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            consumerDestinations: Array.isArray(object?.consumer_destinations) ? object.consumer_destinations.map((e) => Billing_BillingDestination.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            consumer_destinations: Array.isArray(object?.consumer_destinations) ? object.consumer_destinations.map((e) => Billing_BillingDestination.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.consumerDestinations) {
            obj.consumer_destinations = message.consumerDestinations.map(e => e ? Billing_BillingDestination.toSDK(e) : undefined);
        }
        else {
            obj.consumer_destinations = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseBilling();
        message.consumerDestinations = object.consumer_destinations?.map(e => Billing_BillingDestination.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.consumerDestinations) {
            obj.consumer_destinations = message.consumerDestinations.map(e => e ? Billing_BillingDestination.toAmino(e) : undefined);
        }
        else {
            obj.consumer_destinations = message.consumerDestinations;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Billing.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Billing.decode(message.value);
    },
    toProto(message) {
        return Billing.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Billing",
            value: Billing.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Billing_BillingDestination.registerTypeUrl();
    }
};
function createBaseBilling_BillingDestination() {
    return {
        monitoredResource: "",
        metrics: []
    };
}
export const Billing_BillingDestination = {
    typeUrl: "/google.api.BillingDestination",
    is(o) {
        return o && (o.$typeUrl === Billing_BillingDestination.typeUrl || typeof o.monitoredResource === "string" && Array.isArray(o.metrics) && (!o.metrics.length || typeof o.metrics[0] === "string"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Billing_BillingDestination.typeUrl || typeof o.monitored_resource === "string" && Array.isArray(o.metrics) && (!o.metrics.length || typeof o.metrics[0] === "string"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Billing_BillingDestination.typeUrl || typeof o.monitored_resource === "string" && Array.isArray(o.metrics) && (!o.metrics.length || typeof o.metrics[0] === "string"));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.monitoredResource !== undefined) {
            writer.uint32(10).string(message.monitoredResource);
        }
        for (const v of message.metrics) {
            writer.uint32(18).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseBilling_BillingDestination();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.monitoredResource = reader.string();
                    break;
                case 2:
                    message.metrics.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseBilling_BillingDestination();
        if (isSet(object.monitoredResource))
            obj.monitoredResource = String(object.monitoredResource);
        if (Array.isArray(object?.metrics))
            obj.metrics = object.metrics.map((e) => String(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.monitoredResource !== undefined && (obj.monitoredResource = message.monitoredResource);
        if (message.metrics) {
            obj.metrics = message.metrics.map(e => e);
        }
        else {
            obj.metrics = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseBilling_BillingDestination();
        message.monitoredResource = object.monitoredResource ?? "";
        message.metrics = object.metrics?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            monitoredResource: object?.monitored_resource,
            metrics: Array.isArray(object?.metrics) ? object.metrics.map((e) => e) : []
        };
    },
    fromSDKJSON(object) {
        return {
            monitored_resource: isSet(object.monitored_resource) ? String(object.monitored_resource) : "",
            metrics: Array.isArray(object?.metrics) ? object.metrics.map((e) => String(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.monitored_resource = message.monitoredResource;
        if (message.metrics) {
            obj.metrics = message.metrics.map(e => e);
        }
        else {
            obj.metrics = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseBilling_BillingDestination();
        if (object.monitored_resource !== undefined && object.monitored_resource !== null) {
            message.monitoredResource = object.monitored_resource;
        }
        message.metrics = object.metrics?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.monitored_resource = message.monitoredResource === "" ? undefined : message.monitoredResource;
        if (message.metrics) {
            obj.metrics = message.metrics.map(e => e);
        }
        else {
            obj.metrics = message.metrics;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Billing_BillingDestination.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Billing_BillingDestination.decode(message.value);
    },
    toProto(message) {
        return Billing_BillingDestination.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.BillingDestination",
            value: Billing_BillingDestination.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
