import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseControl() {
    return {
        environment: ""
    };
}
export const Control = {
    typeUrl: "/google.api.Control",
    is(o) {
        return o && (o.$typeUrl === Control.typeUrl || typeof o.environment === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Control.typeUrl || typeof o.environment === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Control.typeUrl || typeof o.environment === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.environment !== undefined) {
            writer.uint32(10).string(message.environment);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseControl();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.environment = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseControl();
        if (isSet(object.environment))
            obj.environment = String(object.environment);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.environment !== undefined && (obj.environment = message.environment);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseControl();
        message.environment = object.environment ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            environment: object?.environment
        };
    },
    fromSDKJSON(object) {
        return {
            environment: isSet(object.environment) ? String(object.environment) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.environment = message.environment;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseControl();
        if (object.environment !== undefined && object.environment !== null) {
            message.environment = object.environment;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.environment = message.environment === "" ? undefined : message.environment;
        return obj;
    },
    fromAminoMsg(object) {
        return Control.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Control.decode(message.value);
    },
    toProto(message) {
        return Control.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Control",
            value: Control.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
