import { Value } from "./value";
import { Status } from "../../../rpc/status";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { isSet } from "../../../../helpers";
export const protobufPackage = "google.api.expr.v1alpha1";
function createBaseEvalState() {
    return {
        values: [],
        results: []
    };
}
export const EvalState = {
    typeUrl: "/google.api.expr.v1alpha1.EvalState",
    is(o) {
        return o && (o.$typeUrl === EvalState.typeUrl || Array.isArray(o.values) && (!o.values.length || ExprValue.is(o.values[0])) && Array.isArray(o.results) && (!o.results.length || EvalState_Result.is(o.results[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === EvalState.typeUrl || Array.isArray(o.values) && (!o.values.length || ExprValue.isSDK(o.values[0])) && Array.isArray(o.results) && (!o.results.length || EvalState_Result.isSDK(o.results[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === EvalState.typeUrl || Array.isArray(o.values) && (!o.values.length || ExprValue.isAmino(o.values[0])) && Array.isArray(o.results) && (!o.results.length || EvalState_Result.isAmino(o.results[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.values) {
            ExprValue.encode(v, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.results) {
            EvalState_Result.encode(v, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseEvalState();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.values.push(ExprValue.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.results.push(EvalState_Result.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseEvalState();
        if (Array.isArray(object?.values))
            obj.values = object.values.map((e) => ExprValue.fromJSON(e));
        if (Array.isArray(object?.results))
            obj.results = object.results.map((e) => EvalState_Result.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.values) {
            obj.values = message.values.map(e => e ? ExprValue.toJSON(e) : undefined);
        }
        else {
            obj.values = [];
        }
        if (message.results) {
            obj.results = message.results.map(e => e ? EvalState_Result.toJSON(e) : undefined);
        }
        else {
            obj.results = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseEvalState();
        message.values = object.values?.map(e => ExprValue.fromPartial(e)) || [];
        message.results = object.results?.map(e => EvalState_Result.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            values: Array.isArray(object?.values) ? object.values.map((e) => ExprValue.fromSDK(e)) : [],
            results: Array.isArray(object?.results) ? object.results.map((e) => EvalState_Result.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            values: Array.isArray(object?.values) ? object.values.map((e) => ExprValue.fromSDKJSON(e)) : [],
            results: Array.isArray(object?.results) ? object.results.map((e) => EvalState_Result.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.values) {
            obj.values = message.values.map(e => e ? ExprValue.toSDK(e) : undefined);
        }
        else {
            obj.values = [];
        }
        if (message.results) {
            obj.results = message.results.map(e => e ? EvalState_Result.toSDK(e) : undefined);
        }
        else {
            obj.results = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseEvalState();
        message.values = object.values?.map(e => ExprValue.fromAmino(e)) || [];
        message.results = object.results?.map(e => EvalState_Result.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.values) {
            obj.values = message.values.map(e => e ? ExprValue.toAmino(e) : undefined);
        }
        else {
            obj.values = message.values;
        }
        if (message.results) {
            obj.results = message.results.map(e => e ? EvalState_Result.toAmino(e) : undefined);
        }
        else {
            obj.results = message.results;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return EvalState.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return EvalState.decode(message.value);
    },
    toProto(message) {
        return EvalState.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.EvalState",
            value: EvalState.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ExprValue.registerTypeUrl();
        EvalState_Result.registerTypeUrl();
    }
};
function createBaseEvalState_Result() {
    return {
        expr: BigInt(0),
        value: BigInt(0)
    };
}
export const EvalState_Result = {
    typeUrl: "/google.api.expr.v1alpha1.Result",
    is(o) {
        return o && (o.$typeUrl === EvalState_Result.typeUrl || typeof o.expr === "bigint" && typeof o.value === "bigint");
    },
    isSDK(o) {
        return o && (o.$typeUrl === EvalState_Result.typeUrl || typeof o.expr === "bigint" && typeof o.value === "bigint");
    },
    isAmino(o) {
        return o && (o.$typeUrl === EvalState_Result.typeUrl || typeof o.expr === "bigint" && typeof o.value === "bigint");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.expr !== undefined) {
            writer.uint32(8).int64(message.expr);
        }
        if (message.value !== undefined) {
            writer.uint32(16).int64(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseEvalState_Result();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.expr = reader.int64();
                    break;
                case 2:
                    message.value = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseEvalState_Result();
        if (isSet(object.expr))
            obj.expr = BigInt(object.expr.toString());
        if (isSet(object.value))
            obj.value = BigInt(object.value.toString());
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.expr !== undefined && (obj.expr = (message.expr || BigInt(0)).toString());
        message.value !== undefined && (obj.value = (message.value || BigInt(0)).toString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseEvalState_Result();
        if (object.expr !== undefined && object.expr !== null) {
            message.expr = BigInt(object.expr.toString());
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = BigInt(object.value.toString());
        }
        return message;
    },
    fromSDK(object) {
        return {
            expr: object?.expr,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            expr: isSet(object.expr) ? BigInt(object.expr.toString()) : BigInt(0),
            value: isSet(object.value) ? BigInt(object.value.toString()) : BigInt(0)
        };
    },
    toSDK(message) {
        const obj = {};
        obj.expr = message.expr;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseEvalState_Result();
        if (object.expr !== undefined && object.expr !== null) {
            message.expr = BigInt(object.expr);
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = BigInt(object.value);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.expr = message.expr !== BigInt(0) ? message.expr?.toString() : undefined;
        obj.value = message.value !== BigInt(0) ? message.value?.toString() : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return EvalState_Result.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return EvalState_Result.decode(message.value);
    },
    toProto(message) {
        return EvalState_Result.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.Result",
            value: EvalState_Result.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseExprValue() {
    return {
        value: undefined,
        error: undefined,
        unknown: undefined
    };
}
export const ExprValue = {
    typeUrl: "/google.api.expr.v1alpha1.ExprValue",
    is(o) {
        return o && o.$typeUrl === ExprValue.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === ExprValue.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === ExprValue.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.value !== undefined) {
            Value.encode(message.value, writer.uint32(10).fork()).ldelim();
        }
        if (message.error !== undefined) {
            ErrorSet.encode(message.error, writer.uint32(18).fork()).ldelim();
        }
        if (message.unknown !== undefined) {
            UnknownSet.encode(message.unknown, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExprValue();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.value = Value.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.error = ErrorSet.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.unknown = UnknownSet.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseExprValue();
        if (isSet(object.value))
            obj.value = Value.fromJSON(object.value);
        if (isSet(object.error))
            obj.error = ErrorSet.fromJSON(object.error);
        if (isSet(object.unknown))
            obj.unknown = UnknownSet.fromJSON(object.unknown);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.value !== undefined && (obj.value = message.value ? Value.toJSON(message.value) : undefined);
        message.error !== undefined && (obj.error = message.error ? ErrorSet.toJSON(message.error) : undefined);
        message.unknown !== undefined && (obj.unknown = message.unknown ? UnknownSet.toJSON(message.unknown) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseExprValue();
        if (object.value !== undefined && object.value !== null) {
            message.value = Value.fromPartial(object.value);
        }
        if (object.error !== undefined && object.error !== null) {
            message.error = ErrorSet.fromPartial(object.error);
        }
        if (object.unknown !== undefined && object.unknown !== null) {
            message.unknown = UnknownSet.fromPartial(object.unknown);
        }
        return message;
    },
    fromSDK(object) {
        return {
            value: object.value ? Value.fromSDK(object.value) : undefined,
            error: object.error ? ErrorSet.fromSDK(object.error) : undefined,
            unknown: object.unknown ? UnknownSet.fromSDK(object.unknown) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            value: isSet(object.value) ? Value.fromSDKJSON(object.value) : undefined,
            error: isSet(object.error) ? ErrorSet.fromSDKJSON(object.error) : undefined,
            unknown: isSet(object.unknown) ? UnknownSet.fromSDKJSON(object.unknown) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.value !== undefined && (obj.value = message.value ? Value.toSDK(message.value) : undefined);
        message.error !== undefined && (obj.error = message.error ? ErrorSet.toSDK(message.error) : undefined);
        message.unknown !== undefined && (obj.unknown = message.unknown ? UnknownSet.toSDK(message.unknown) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseExprValue();
        if (object.value !== undefined && object.value !== null) {
            message.value = Value.fromAmino(object.value);
        }
        if (object.error !== undefined && object.error !== null) {
            message.error = ErrorSet.fromAmino(object.error);
        }
        if (object.unknown !== undefined && object.unknown !== null) {
            message.unknown = UnknownSet.fromAmino(object.unknown);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.value = message.value ? Value.toAmino(message.value) : undefined;
        obj.error = message.error ? ErrorSet.toAmino(message.error) : undefined;
        obj.unknown = message.unknown ? UnknownSet.toAmino(message.unknown) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return ExprValue.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ExprValue.decode(message.value);
    },
    toProto(message) {
        return ExprValue.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.ExprValue",
            value: ExprValue.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Value.registerTypeUrl();
        ErrorSet.registerTypeUrl();
        UnknownSet.registerTypeUrl();
    }
};
function createBaseErrorSet() {
    return {
        errors: []
    };
}
export const ErrorSet = {
    typeUrl: "/google.api.expr.v1alpha1.ErrorSet",
    is(o) {
        return o && (o.$typeUrl === ErrorSet.typeUrl || Array.isArray(o.errors) && (!o.errors.length || Status.is(o.errors[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === ErrorSet.typeUrl || Array.isArray(o.errors) && (!o.errors.length || Status.isSDK(o.errors[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === ErrorSet.typeUrl || Array.isArray(o.errors) && (!o.errors.length || Status.isAmino(o.errors[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.errors) {
            Status.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseErrorSet();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.errors.push(Status.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseErrorSet();
        if (Array.isArray(object?.errors))
            obj.errors = object.errors.map((e) => Status.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.errors) {
            obj.errors = message.errors.map(e => e ? Status.toJSON(e) : undefined);
        }
        else {
            obj.errors = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseErrorSet();
        message.errors = object.errors?.map(e => Status.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            errors: Array.isArray(object?.errors) ? object.errors.map((e) => Status.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            errors: Array.isArray(object?.errors) ? object.errors.map((e) => Status.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.errors) {
            obj.errors = message.errors.map(e => e ? Status.toSDK(e) : undefined);
        }
        else {
            obj.errors = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseErrorSet();
        message.errors = object.errors?.map(e => Status.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.errors) {
            obj.errors = message.errors.map(e => e ? Status.toAmino(e) : undefined);
        }
        else {
            obj.errors = message.errors;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return ErrorSet.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ErrorSet.decode(message.value);
    },
    toProto(message) {
        return ErrorSet.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.ErrorSet",
            value: ErrorSet.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Status.registerTypeUrl();
    }
};
function createBaseUnknownSet() {
    return {
        exprs: []
    };
}
export const UnknownSet = {
    typeUrl: "/google.api.expr.v1alpha1.UnknownSet",
    is(o) {
        return o && (o.$typeUrl === UnknownSet.typeUrl || Array.isArray(o.exprs) && (!o.exprs.length || typeof o.exprs[0] === "bigint"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === UnknownSet.typeUrl || Array.isArray(o.exprs) && (!o.exprs.length || typeof o.exprs[0] === "bigint"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === UnknownSet.typeUrl || Array.isArray(o.exprs) && (!o.exprs.length || typeof o.exprs[0] === "bigint"));
    },
    encode(message, writer = BinaryWriter.create()) {
        writer.uint32(10).fork();
        for (const v of message.exprs) {
            writer.int64(v);
        }
        writer.ldelim();
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUnknownSet();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.exprs.push(reader.int64());
                        }
                    }
                    else {
                        message.exprs.push(reader.int64());
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseUnknownSet();
        if (Array.isArray(object?.exprs))
            obj.exprs = object.exprs.map((e) => BigInt(e.toString()));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.exprs) {
            obj.exprs = message.exprs.map(e => (e || BigInt(0)).toString());
        }
        else {
            obj.exprs = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseUnknownSet();
        message.exprs = object.exprs?.map(e => BigInt(e.toString())) || [];
        return message;
    },
    fromSDK(object) {
        return {
            exprs: Array.isArray(object?.exprs) ? object.exprs.map((e) => e) : []
        };
    },
    fromSDKJSON(object) {
        return {
            exprs: Array.isArray(object?.exprs) ? object.exprs.map((e) => BigInt(e.toString())) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.exprs) {
            obj.exprs = message.exprs.map(e => e);
        }
        else {
            obj.exprs = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseUnknownSet();
        message.exprs = object.exprs?.map(e => BigInt(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.exprs) {
            obj.exprs = message.exprs.map(e => e.toString());
        }
        else {
            obj.exprs = message.exprs;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return UnknownSet.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return UnknownSet.decode(message.value);
    },
    toProto(message) {
        return UnknownSet.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.UnknownSet",
            value: UnknownSet.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
