import { Value } from "./value";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { isSet } from "../../../../helpers";
export const protobufPackage = "google.api.expr.v1alpha1";
function createBaseExplain() {
    return {
        values: [],
        exprSteps: []
    };
}
export const Explain = {
    typeUrl: "/google.api.expr.v1alpha1.Explain",
    is(o) {
        return o && (o.$typeUrl === Explain.typeUrl || Array.isArray(o.values) && (!o.values.length || Value.is(o.values[0])) && Array.isArray(o.exprSteps) && (!o.exprSteps.length || Explain_ExprStep.is(o.exprSteps[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Explain.typeUrl || Array.isArray(o.values) && (!o.values.length || Value.isSDK(o.values[0])) && Array.isArray(o.expr_steps) && (!o.expr_steps.length || Explain_ExprStep.isSDK(o.expr_steps[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Explain.typeUrl || Array.isArray(o.values) && (!o.values.length || Value.isAmino(o.values[0])) && Array.isArray(o.expr_steps) && (!o.expr_steps.length || Explain_ExprStep.isAmino(o.expr_steps[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.values) {
            Value.encode(v, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.exprSteps) {
            Explain_ExprStep.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExplain();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.values.push(Value.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.exprSteps.push(Explain_ExprStep.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseExplain();
        if (Array.isArray(object?.values))
            obj.values = object.values.map((e) => Value.fromJSON(e));
        if (Array.isArray(object?.exprSteps))
            obj.exprSteps = object.exprSteps.map((e) => Explain_ExprStep.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.values) {
            obj.values = message.values.map(e => e ? Value.toJSON(e) : undefined);
        }
        else {
            obj.values = [];
        }
        if (message.exprSteps) {
            obj.exprSteps = message.exprSteps.map(e => e ? Explain_ExprStep.toJSON(e) : undefined);
        }
        else {
            obj.exprSteps = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseExplain();
        message.values = object.values?.map(e => Value.fromPartial(e)) || [];
        message.exprSteps = object.exprSteps?.map(e => Explain_ExprStep.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            values: Array.isArray(object?.values) ? object.values.map((e) => Value.fromSDK(e)) : [],
            exprSteps: Array.isArray(object?.expr_steps) ? object.expr_steps.map((e) => Explain_ExprStep.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            values: Array.isArray(object?.values) ? object.values.map((e) => Value.fromSDKJSON(e)) : [],
            expr_steps: Array.isArray(object?.expr_steps) ? object.expr_steps.map((e) => Explain_ExprStep.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.values) {
            obj.values = message.values.map(e => e ? Value.toSDK(e) : undefined);
        }
        else {
            obj.values = [];
        }
        if (message.exprSteps) {
            obj.expr_steps = message.exprSteps.map(e => e ? Explain_ExprStep.toSDK(e) : undefined);
        }
        else {
            obj.expr_steps = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseExplain();
        message.values = object.values?.map(e => Value.fromAmino(e)) || [];
        message.exprSteps = object.expr_steps?.map(e => Explain_ExprStep.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.values) {
            obj.values = message.values.map(e => e ? Value.toAmino(e) : undefined);
        }
        else {
            obj.values = message.values;
        }
        if (message.exprSteps) {
            obj.expr_steps = message.exprSteps.map(e => e ? Explain_ExprStep.toAmino(e) : undefined);
        }
        else {
            obj.expr_steps = message.exprSteps;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Explain.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Explain.decode(message.value);
    },
    toProto(message) {
        return Explain.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.Explain",
            value: Explain.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Value.registerTypeUrl();
        Explain_ExprStep.registerTypeUrl();
    }
};
function createBaseExplain_ExprStep() {
    return {
        id: BigInt(0),
        valueIndex: 0
    };
}
export const Explain_ExprStep = {
    typeUrl: "/google.api.expr.v1alpha1.ExprStep",
    is(o) {
        return o && (o.$typeUrl === Explain_ExprStep.typeUrl || typeof o.id === "bigint" && typeof o.valueIndex === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Explain_ExprStep.typeUrl || typeof o.id === "bigint" && typeof o.value_index === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Explain_ExprStep.typeUrl || typeof o.id === "bigint" && typeof o.value_index === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            writer.uint32(8).int64(message.id);
        }
        if (message.valueIndex !== undefined) {
            writer.uint32(16).int32(message.valueIndex);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExplain_ExprStep();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.int64();
                    break;
                case 2:
                    message.valueIndex = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseExplain_ExprStep();
        if (isSet(object.id))
            obj.id = BigInt(object.id.toString());
        if (isSet(object.valueIndex))
            obj.valueIndex = Number(object.valueIndex);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = (message.id || BigInt(0)).toString());
        message.valueIndex !== undefined && (obj.valueIndex = Math.round(message.valueIndex));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseExplain_ExprStep();
        if (object.id !== undefined && object.id !== null) {
            message.id = BigInt(object.id.toString());
        }
        message.valueIndex = object.valueIndex ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            id: object?.id,
            valueIndex: object?.value_index
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? BigInt(object.id.toString()) : BigInt(0),
            value_index: isSet(object.value_index) ? Number(object.value_index) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.id = message.id;
        obj.value_index = message.valueIndex;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseExplain_ExprStep();
        if (object.id !== undefined && object.id !== null) {
            message.id = BigInt(object.id);
        }
        if (object.value_index !== undefined && object.value_index !== null) {
            message.valueIndex = object.value_index;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id !== BigInt(0) ? message.id?.toString() : undefined;
        obj.value_index = message.valueIndex === 0 ? undefined : message.valueIndex;
        return obj;
    },
    fromAminoMsg(object) {
        return Explain_ExprStep.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Explain_ExprStep.decode(message.value);
    },
    toProto(message) {
        return Explain_ExprStep.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.ExprStep",
            value: Explain_ExprStep.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
