//@ts-nocheck
import { nullValueFromJSON, nullValueToJSON } from "../../../protobuf/struct";
import { Duration } from "../../../protobuf/duration";
import { Timestamp } from "../../../protobuf/timestamp";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { isSet, toTimestamp, fromTimestamp, bytesFromBase64, base64FromBytes, isObject } from "../../../../helpers";
export const protobufPackage = "google.api.expr.v1alpha1";
function createBaseParsedExpr() {
    return {
        expr: undefined,
        sourceInfo: undefined
    };
}
export const ParsedExpr = {
    typeUrl: "/google.api.expr.v1alpha1.ParsedExpr",
    is(o) {
        return o && o.$typeUrl === ParsedExpr.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === ParsedExpr.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === ParsedExpr.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.expr !== undefined) {
            Expr.encode(message.expr, writer.uint32(18).fork()).ldelim();
        }
        if (message.sourceInfo !== undefined) {
            SourceInfo.encode(message.sourceInfo, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseParsedExpr();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 2:
                    message.expr = Expr.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.sourceInfo = SourceInfo.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseParsedExpr();
        if (isSet(object.expr))
            obj.expr = Expr.fromJSON(object.expr);
        if (isSet(object.sourceInfo))
            obj.sourceInfo = SourceInfo.fromJSON(object.sourceInfo);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.expr !== undefined && (obj.expr = message.expr ? Expr.toJSON(message.expr) : undefined);
        message.sourceInfo !== undefined && (obj.sourceInfo = message.sourceInfo ? SourceInfo.toJSON(message.sourceInfo) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseParsedExpr();
        if (object.expr !== undefined && object.expr !== null) {
            message.expr = Expr.fromPartial(object.expr);
        }
        if (object.sourceInfo !== undefined && object.sourceInfo !== null) {
            message.sourceInfo = SourceInfo.fromPartial(object.sourceInfo);
        }
        return message;
    },
    fromSDK(object) {
        return {
            expr: object.expr ? Expr.fromSDK(object.expr) : undefined,
            sourceInfo: object.source_info ? SourceInfo.fromSDK(object.source_info) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            expr: isSet(object.expr) ? Expr.fromSDKJSON(object.expr) : undefined,
            source_info: isSet(object.source_info) ? SourceInfo.fromSDKJSON(object.source_info) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.expr !== undefined && (obj.expr = message.expr ? Expr.toSDK(message.expr) : undefined);
        message.sourceInfo !== undefined && (obj.source_info = message.sourceInfo ? SourceInfo.toSDK(message.sourceInfo) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseParsedExpr();
        if (object.expr !== undefined && object.expr !== null) {
            message.expr = Expr.fromAmino(object.expr);
        }
        if (object.source_info !== undefined && object.source_info !== null) {
            message.sourceInfo = SourceInfo.fromAmino(object.source_info);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.expr = message.expr ? Expr.toAmino(message.expr) : undefined;
        obj.source_info = message.sourceInfo ? SourceInfo.toAmino(message.sourceInfo) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return ParsedExpr.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ParsedExpr.decode(message.value);
    },
    toProto(message) {
        return ParsedExpr.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.ParsedExpr",
            value: ParsedExpr.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Expr.registerTypeUrl();
        SourceInfo.registerTypeUrl();
    }
};
function createBaseExpr() {
    return {
        id: BigInt(0),
        constExpr: undefined,
        identExpr: undefined,
        selectExpr: undefined,
        callExpr: undefined,
        listExpr: undefined,
        structExpr: undefined,
        comprehensionExpr: undefined
    };
}
export const Expr = {
    typeUrl: "/google.api.expr.v1alpha1.Expr",
    is(o) {
        return o && (o.$typeUrl === Expr.typeUrl || typeof o.id === "bigint");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Expr.typeUrl || typeof o.id === "bigint");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Expr.typeUrl || typeof o.id === "bigint");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            writer.uint32(16).int64(message.id);
        }
        if (message.constExpr !== undefined) {
            Constant.encode(message.constExpr, writer.uint32(26).fork()).ldelim();
        }
        if (message.identExpr !== undefined) {
            Expr_Ident.encode(message.identExpr, writer.uint32(34).fork()).ldelim();
        }
        if (message.selectExpr !== undefined) {
            Expr_Select.encode(message.selectExpr, writer.uint32(42).fork()).ldelim();
        }
        if (message.callExpr !== undefined) {
            Expr_Call.encode(message.callExpr, writer.uint32(50).fork()).ldelim();
        }
        if (message.listExpr !== undefined) {
            Expr_CreateList.encode(message.listExpr, writer.uint32(58).fork()).ldelim();
        }
        if (message.structExpr !== undefined) {
            Expr_CreateStruct.encode(message.structExpr, writer.uint32(66).fork()).ldelim();
        }
        if (message.comprehensionExpr !== undefined) {
            Expr_Comprehension.encode(message.comprehensionExpr, writer.uint32(74).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExpr();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 2:
                    message.id = reader.int64();
                    break;
                case 3:
                    message.constExpr = Constant.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.identExpr = Expr_Ident.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.selectExpr = Expr_Select.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.callExpr = Expr_Call.decode(reader, reader.uint32());
                    break;
                case 7:
                    message.listExpr = Expr_CreateList.decode(reader, reader.uint32());
                    break;
                case 8:
                    message.structExpr = Expr_CreateStruct.decode(reader, reader.uint32());
                    break;
                case 9:
                    message.comprehensionExpr = Expr_Comprehension.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseExpr();
        if (isSet(object.id))
            obj.id = BigInt(object.id.toString());
        if (isSet(object.constExpr))
            obj.constExpr = Constant.fromJSON(object.constExpr);
        if (isSet(object.identExpr))
            obj.identExpr = Expr_Ident.fromJSON(object.identExpr);
        if (isSet(object.selectExpr))
            obj.selectExpr = Expr_Select.fromJSON(object.selectExpr);
        if (isSet(object.callExpr))
            obj.callExpr = Expr_Call.fromJSON(object.callExpr);
        if (isSet(object.listExpr))
            obj.listExpr = Expr_CreateList.fromJSON(object.listExpr);
        if (isSet(object.structExpr))
            obj.structExpr = Expr_CreateStruct.fromJSON(object.structExpr);
        if (isSet(object.comprehensionExpr))
            obj.comprehensionExpr = Expr_Comprehension.fromJSON(object.comprehensionExpr);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = (message.id || BigInt(0)).toString());
        message.constExpr !== undefined && (obj.constExpr = message.constExpr ? Constant.toJSON(message.constExpr) : undefined);
        message.identExpr !== undefined && (obj.identExpr = message.identExpr ? Expr_Ident.toJSON(message.identExpr) : undefined);
        message.selectExpr !== undefined && (obj.selectExpr = message.selectExpr ? Expr_Select.toJSON(message.selectExpr) : undefined);
        message.callExpr !== undefined && (obj.callExpr = message.callExpr ? Expr_Call.toJSON(message.callExpr) : undefined);
        message.listExpr !== undefined && (obj.listExpr = message.listExpr ? Expr_CreateList.toJSON(message.listExpr) : undefined);
        message.structExpr !== undefined && (obj.structExpr = message.structExpr ? Expr_CreateStruct.toJSON(message.structExpr) : undefined);
        message.comprehensionExpr !== undefined && (obj.comprehensionExpr = message.comprehensionExpr ? Expr_Comprehension.toJSON(message.comprehensionExpr) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseExpr();
        if (object.id !== undefined && object.id !== null) {
            message.id = BigInt(object.id.toString());
        }
        if (object.constExpr !== undefined && object.constExpr !== null) {
            message.constExpr = Constant.fromPartial(object.constExpr);
        }
        if (object.identExpr !== undefined && object.identExpr !== null) {
            message.identExpr = Expr_Ident.fromPartial(object.identExpr);
        }
        if (object.selectExpr !== undefined && object.selectExpr !== null) {
            message.selectExpr = Expr_Select.fromPartial(object.selectExpr);
        }
        if (object.callExpr !== undefined && object.callExpr !== null) {
            message.callExpr = Expr_Call.fromPartial(object.callExpr);
        }
        if (object.listExpr !== undefined && object.listExpr !== null) {
            message.listExpr = Expr_CreateList.fromPartial(object.listExpr);
        }
        if (object.structExpr !== undefined && object.structExpr !== null) {
            message.structExpr = Expr_CreateStruct.fromPartial(object.structExpr);
        }
        if (object.comprehensionExpr !== undefined && object.comprehensionExpr !== null) {
            message.comprehensionExpr = Expr_Comprehension.fromPartial(object.comprehensionExpr);
        }
        return message;
    },
    fromSDK(object) {
        return {
            id: object?.id,
            constExpr: object.const_expr ? Constant.fromSDK(object.const_expr) : undefined,
            identExpr: object.ident_expr ? Expr_Ident.fromSDK(object.ident_expr) : undefined,
            selectExpr: object.select_expr ? Expr_Select.fromSDK(object.select_expr) : undefined,
            callExpr: object.call_expr ? Expr_Call.fromSDK(object.call_expr) : undefined,
            listExpr: object.list_expr ? Expr_CreateList.fromSDK(object.list_expr) : undefined,
            structExpr: object.struct_expr ? Expr_CreateStruct.fromSDK(object.struct_expr) : undefined,
            comprehensionExpr: object.comprehension_expr ? Expr_Comprehension.fromSDK(object.comprehension_expr) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? BigInt(object.id.toString()) : BigInt(0),
            const_expr: isSet(object.const_expr) ? Constant.fromSDKJSON(object.const_expr) : undefined,
            ident_expr: isSet(object.ident_expr) ? Expr_Ident.fromSDKJSON(object.ident_expr) : undefined,
            select_expr: isSet(object.select_expr) ? Expr_Select.fromSDKJSON(object.select_expr) : undefined,
            call_expr: isSet(object.call_expr) ? Expr_Call.fromSDKJSON(object.call_expr) : undefined,
            list_expr: isSet(object.list_expr) ? Expr_CreateList.fromSDKJSON(object.list_expr) : undefined,
            struct_expr: isSet(object.struct_expr) ? Expr_CreateStruct.fromSDKJSON(object.struct_expr) : undefined,
            comprehension_expr: isSet(object.comprehension_expr) ? Expr_Comprehension.fromSDKJSON(object.comprehension_expr) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.id = message.id;
        message.constExpr !== undefined && (obj.const_expr = message.constExpr ? Constant.toSDK(message.constExpr) : undefined);
        message.identExpr !== undefined && (obj.ident_expr = message.identExpr ? Expr_Ident.toSDK(message.identExpr) : undefined);
        message.selectExpr !== undefined && (obj.select_expr = message.selectExpr ? Expr_Select.toSDK(message.selectExpr) : undefined);
        message.callExpr !== undefined && (obj.call_expr = message.callExpr ? Expr_Call.toSDK(message.callExpr) : undefined);
        message.listExpr !== undefined && (obj.list_expr = message.listExpr ? Expr_CreateList.toSDK(message.listExpr) : undefined);
        message.structExpr !== undefined && (obj.struct_expr = message.structExpr ? Expr_CreateStruct.toSDK(message.structExpr) : undefined);
        message.comprehensionExpr !== undefined && (obj.comprehension_expr = message.comprehensionExpr ? Expr_Comprehension.toSDK(message.comprehensionExpr) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseExpr();
        if (object.id !== undefined && object.id !== null) {
            message.id = BigInt(object.id);
        }
        if (object.const_expr !== undefined && object.const_expr !== null) {
            message.constExpr = Constant.fromAmino(object.const_expr);
        }
        if (object.ident_expr !== undefined && object.ident_expr !== null) {
            message.identExpr = Expr_Ident.fromAmino(object.ident_expr);
        }
        if (object.select_expr !== undefined && object.select_expr !== null) {
            message.selectExpr = Expr_Select.fromAmino(object.select_expr);
        }
        if (object.call_expr !== undefined && object.call_expr !== null) {
            message.callExpr = Expr_Call.fromAmino(object.call_expr);
        }
        if (object.list_expr !== undefined && object.list_expr !== null) {
            message.listExpr = Expr_CreateList.fromAmino(object.list_expr);
        }
        if (object.struct_expr !== undefined && object.struct_expr !== null) {
            message.structExpr = Expr_CreateStruct.fromAmino(object.struct_expr);
        }
        if (object.comprehension_expr !== undefined && object.comprehension_expr !== null) {
            message.comprehensionExpr = Expr_Comprehension.fromAmino(object.comprehension_expr);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id !== BigInt(0) ? message.id?.toString() : undefined;
        obj.const_expr = message.constExpr ? Constant.toAmino(message.constExpr) : undefined;
        obj.ident_expr = message.identExpr ? Expr_Ident.toAmino(message.identExpr) : undefined;
        obj.select_expr = message.selectExpr ? Expr_Select.toAmino(message.selectExpr) : undefined;
        obj.call_expr = message.callExpr ? Expr_Call.toAmino(message.callExpr) : undefined;
        obj.list_expr = message.listExpr ? Expr_CreateList.toAmino(message.listExpr) : undefined;
        obj.struct_expr = message.structExpr ? Expr_CreateStruct.toAmino(message.structExpr) : undefined;
        obj.comprehension_expr = message.comprehensionExpr ? Expr_Comprehension.toAmino(message.comprehensionExpr) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return Expr.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Expr.decode(message.value);
    },
    toProto(message) {
        return Expr.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.Expr",
            value: Expr.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Constant.registerTypeUrl();
        Expr_Ident.registerTypeUrl();
        Expr_Select.registerTypeUrl();
        Expr_Call.registerTypeUrl();
        Expr_CreateList.registerTypeUrl();
        Expr_CreateStruct.registerTypeUrl();
        Expr_Comprehension.registerTypeUrl();
    }
};
function createBaseExpr_Ident() {
    return {
        name: ""
    };
}
export const Expr_Ident = {
    typeUrl: "/google.api.expr.v1alpha1.Ident",
    is(o) {
        return o && (o.$typeUrl === Expr_Ident.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Expr_Ident.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Expr_Ident.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExpr_Ident();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseExpr_Ident();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseExpr_Ident();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseExpr_Ident();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return Expr_Ident.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Expr_Ident.decode(message.value);
    },
    toProto(message) {
        return Expr_Ident.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.Ident",
            value: Expr_Ident.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseExpr_Select() {
    return {
        operand: undefined,
        field: "",
        testOnly: false
    };
}
export const Expr_Select = {
    typeUrl: "/google.api.expr.v1alpha1.Select",
    is(o) {
        return o && (o.$typeUrl === Expr_Select.typeUrl || typeof o.field === "string" && typeof o.testOnly === "boolean");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Expr_Select.typeUrl || typeof o.field === "string" && typeof o.test_only === "boolean");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Expr_Select.typeUrl || typeof o.field === "string" && typeof o.test_only === "boolean");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.operand !== undefined) {
            Expr.encode(message.operand, writer.uint32(10).fork()).ldelim();
        }
        if (message.field !== undefined) {
            writer.uint32(18).string(message.field);
        }
        if (message.testOnly !== undefined) {
            writer.uint32(24).bool(message.testOnly);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExpr_Select();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.operand = Expr.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.field = reader.string();
                    break;
                case 3:
                    message.testOnly = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseExpr_Select();
        if (isSet(object.operand))
            obj.operand = Expr.fromJSON(object.operand);
        if (isSet(object.field))
            obj.field = String(object.field);
        if (isSet(object.testOnly))
            obj.testOnly = Boolean(object.testOnly);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.operand !== undefined && (obj.operand = message.operand ? Expr.toJSON(message.operand) : undefined);
        message.field !== undefined && (obj.field = message.field);
        message.testOnly !== undefined && (obj.testOnly = message.testOnly);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseExpr_Select();
        if (object.operand !== undefined && object.operand !== null) {
            message.operand = Expr.fromPartial(object.operand);
        }
        message.field = object.field ?? "";
        message.testOnly = object.testOnly ?? false;
        return message;
    },
    fromSDK(object) {
        return {
            operand: object.operand ? Expr.fromSDK(object.operand) : undefined,
            field: object?.field,
            testOnly: object?.test_only
        };
    },
    fromSDKJSON(object) {
        return {
            operand: isSet(object.operand) ? Expr.fromSDKJSON(object.operand) : undefined,
            field: isSet(object.field) ? String(object.field) : "",
            test_only: isSet(object.test_only) ? Boolean(object.test_only) : false
        };
    },
    toSDK(message) {
        const obj = {};
        message.operand !== undefined && (obj.operand = message.operand ? Expr.toSDK(message.operand) : undefined);
        obj.field = message.field;
        obj.test_only = message.testOnly;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseExpr_Select();
        if (object.operand !== undefined && object.operand !== null) {
            message.operand = Expr.fromAmino(object.operand);
        }
        if (object.field !== undefined && object.field !== null) {
            message.field = object.field;
        }
        if (object.test_only !== undefined && object.test_only !== null) {
            message.testOnly = object.test_only;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.operand = message.operand ? Expr.toAmino(message.operand) : undefined;
        obj.field = message.field === "" ? undefined : message.field;
        obj.test_only = message.testOnly === false ? undefined : message.testOnly;
        return obj;
    },
    fromAminoMsg(object) {
        return Expr_Select.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Expr_Select.decode(message.value);
    },
    toProto(message) {
        return Expr_Select.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.Select",
            value: Expr_Select.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Expr.registerTypeUrl();
    }
};
function createBaseExpr_Call() {
    return {
        target: undefined,
        function: "",
        args: []
    };
}
export const Expr_Call = {
    typeUrl: "/google.api.expr.v1alpha1.Call",
    is(o) {
        return o && (o.$typeUrl === Expr_Call.typeUrl || typeof o.function === "string" && Array.isArray(o.args) && (!o.args.length || Expr.is(o.args[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Expr_Call.typeUrl || typeof o.function === "string" && Array.isArray(o.args) && (!o.args.length || Expr.isSDK(o.args[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Expr_Call.typeUrl || typeof o.function === "string" && Array.isArray(o.args) && (!o.args.length || Expr.isAmino(o.args[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.target !== undefined) {
            Expr.encode(message.target, writer.uint32(10).fork()).ldelim();
        }
        if (message.function !== undefined) {
            writer.uint32(18).string(message.function);
        }
        for (const v of message.args) {
            Expr.encode(v, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExpr_Call();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.target = Expr.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.function = reader.string();
                    break;
                case 3:
                    message.args.push(Expr.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseExpr_Call();
        if (isSet(object.target))
            obj.target = Expr.fromJSON(object.target);
        if (isSet(object.function))
            obj.function = String(object.function);
        if (Array.isArray(object?.args))
            obj.args = object.args.map((e) => Expr.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.target !== undefined && (obj.target = message.target ? Expr.toJSON(message.target) : undefined);
        message.function !== undefined && (obj.function = message.function);
        if (message.args) {
            obj.args = message.args.map(e => e ? Expr.toJSON(e) : undefined);
        }
        else {
            obj.args = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseExpr_Call();
        if (object.target !== undefined && object.target !== null) {
            message.target = Expr.fromPartial(object.target);
        }
        message.function = object.function ?? "";
        message.args = object.args?.map(e => Expr.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            target: object.target ? Expr.fromSDK(object.target) : undefined,
            function: object?.function,
            args: Array.isArray(object?.args) ? object.args.map((e) => Expr.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            target: isSet(object.target) ? Expr.fromSDKJSON(object.target) : undefined,
            function: isSet(object.function) ? String(object.function) : "",
            args: Array.isArray(object?.args) ? object.args.map((e) => Expr.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        message.target !== undefined && (obj.target = message.target ? Expr.toSDK(message.target) : undefined);
        obj.function = message.function;
        if (message.args) {
            obj.args = message.args.map(e => e ? Expr.toSDK(e) : undefined);
        }
        else {
            obj.args = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseExpr_Call();
        if (object.target !== undefined && object.target !== null) {
            message.target = Expr.fromAmino(object.target);
        }
        if (object.function !== undefined && object.function !== null) {
            message.function = object.function;
        }
        message.args = object.args?.map(e => Expr.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.target = message.target ? Expr.toAmino(message.target) : undefined;
        obj.function = message.function === "" ? undefined : message.function;
        if (message.args) {
            obj.args = message.args.map(e => e ? Expr.toAmino(e) : undefined);
        }
        else {
            obj.args = message.args;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Expr_Call.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Expr_Call.decode(message.value);
    },
    toProto(message) {
        return Expr_Call.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.Call",
            value: Expr_Call.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Expr.registerTypeUrl();
    }
};
function createBaseExpr_CreateList() {
    return {
        elements: []
    };
}
export const Expr_CreateList = {
    typeUrl: "/google.api.expr.v1alpha1.CreateList",
    is(o) {
        return o && (o.$typeUrl === Expr_CreateList.typeUrl || Array.isArray(o.elements) && (!o.elements.length || Expr.is(o.elements[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Expr_CreateList.typeUrl || Array.isArray(o.elements) && (!o.elements.length || Expr.isSDK(o.elements[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Expr_CreateList.typeUrl || Array.isArray(o.elements) && (!o.elements.length || Expr.isAmino(o.elements[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.elements) {
            Expr.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExpr_CreateList();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.elements.push(Expr.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseExpr_CreateList();
        if (Array.isArray(object?.elements))
            obj.elements = object.elements.map((e) => Expr.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.elements) {
            obj.elements = message.elements.map(e => e ? Expr.toJSON(e) : undefined);
        }
        else {
            obj.elements = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseExpr_CreateList();
        message.elements = object.elements?.map(e => Expr.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            elements: Array.isArray(object?.elements) ? object.elements.map((e) => Expr.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            elements: Array.isArray(object?.elements) ? object.elements.map((e) => Expr.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.elements) {
            obj.elements = message.elements.map(e => e ? Expr.toSDK(e) : undefined);
        }
        else {
            obj.elements = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseExpr_CreateList();
        message.elements = object.elements?.map(e => Expr.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.elements) {
            obj.elements = message.elements.map(e => e ? Expr.toAmino(e) : undefined);
        }
        else {
            obj.elements = message.elements;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Expr_CreateList.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Expr_CreateList.decode(message.value);
    },
    toProto(message) {
        return Expr_CreateList.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.CreateList",
            value: Expr_CreateList.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Expr.registerTypeUrl();
    }
};
function createBaseExpr_CreateStruct() {
    return {
        messageName: "",
        entries: []
    };
}
export const Expr_CreateStruct = {
    typeUrl: "/google.api.expr.v1alpha1.CreateStruct",
    is(o) {
        return o && (o.$typeUrl === Expr_CreateStruct.typeUrl || typeof o.messageName === "string" && Array.isArray(o.entries) && (!o.entries.length || Expr_CreateStruct_Entry.is(o.entries[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Expr_CreateStruct.typeUrl || typeof o.message_name === "string" && Array.isArray(o.entries) && (!o.entries.length || Expr_CreateStruct_Entry.isSDK(o.entries[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Expr_CreateStruct.typeUrl || typeof o.message_name === "string" && Array.isArray(o.entries) && (!o.entries.length || Expr_CreateStruct_Entry.isAmino(o.entries[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.messageName !== undefined) {
            writer.uint32(10).string(message.messageName);
        }
        for (const v of message.entries) {
            Expr_CreateStruct_Entry.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExpr_CreateStruct();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.messageName = reader.string();
                    break;
                case 2:
                    message.entries.push(Expr_CreateStruct_Entry.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseExpr_CreateStruct();
        if (isSet(object.messageName))
            obj.messageName = String(object.messageName);
        if (Array.isArray(object?.entries))
            obj.entries = object.entries.map((e) => Expr_CreateStruct_Entry.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.messageName !== undefined && (obj.messageName = message.messageName);
        if (message.entries) {
            obj.entries = message.entries.map(e => e ? Expr_CreateStruct_Entry.toJSON(e) : undefined);
        }
        else {
            obj.entries = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseExpr_CreateStruct();
        message.messageName = object.messageName ?? "";
        message.entries = object.entries?.map(e => Expr_CreateStruct_Entry.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            messageName: object?.message_name,
            entries: Array.isArray(object?.entries) ? object.entries.map((e) => Expr_CreateStruct_Entry.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            message_name: isSet(object.message_name) ? String(object.message_name) : "",
            entries: Array.isArray(object?.entries) ? object.entries.map((e) => Expr_CreateStruct_Entry.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.message_name = message.messageName;
        if (message.entries) {
            obj.entries = message.entries.map(e => e ? Expr_CreateStruct_Entry.toSDK(e) : undefined);
        }
        else {
            obj.entries = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseExpr_CreateStruct();
        if (object.message_name !== undefined && object.message_name !== null) {
            message.messageName = object.message_name;
        }
        message.entries = object.entries?.map(e => Expr_CreateStruct_Entry.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.message_name = message.messageName === "" ? undefined : message.messageName;
        if (message.entries) {
            obj.entries = message.entries.map(e => e ? Expr_CreateStruct_Entry.toAmino(e) : undefined);
        }
        else {
            obj.entries = message.entries;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Expr_CreateStruct.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Expr_CreateStruct.decode(message.value);
    },
    toProto(message) {
        return Expr_CreateStruct.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.CreateStruct",
            value: Expr_CreateStruct.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Expr_CreateStruct_Entry.registerTypeUrl();
    }
};
function createBaseExpr_CreateStruct_Entry() {
    return {
        id: BigInt(0),
        fieldKey: undefined,
        mapKey: undefined,
        value: undefined
    };
}
export const Expr_CreateStruct_Entry = {
    typeUrl: "/google.api.expr.v1alpha1.Entry",
    is(o) {
        return o && (o.$typeUrl === Expr_CreateStruct_Entry.typeUrl || typeof o.id === "bigint");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Expr_CreateStruct_Entry.typeUrl || typeof o.id === "bigint");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Expr_CreateStruct_Entry.typeUrl || typeof o.id === "bigint");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            writer.uint32(8).int64(message.id);
        }
        if (message.fieldKey !== undefined) {
            writer.uint32(18).string(message.fieldKey);
        }
        if (message.mapKey !== undefined) {
            Expr.encode(message.mapKey, writer.uint32(26).fork()).ldelim();
        }
        if (message.value !== undefined) {
            Expr.encode(message.value, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExpr_CreateStruct_Entry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.int64();
                    break;
                case 2:
                    message.fieldKey = reader.string();
                    break;
                case 3:
                    message.mapKey = Expr.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.value = Expr.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseExpr_CreateStruct_Entry();
        if (isSet(object.id))
            obj.id = BigInt(object.id.toString());
        if (isSet(object.fieldKey))
            obj.fieldKey = String(object.fieldKey);
        if (isSet(object.mapKey))
            obj.mapKey = Expr.fromJSON(object.mapKey);
        if (isSet(object.value))
            obj.value = Expr.fromJSON(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = (message.id || BigInt(0)).toString());
        message.fieldKey !== undefined && (obj.fieldKey = message.fieldKey);
        message.mapKey !== undefined && (obj.mapKey = message.mapKey ? Expr.toJSON(message.mapKey) : undefined);
        message.value !== undefined && (obj.value = message.value ? Expr.toJSON(message.value) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseExpr_CreateStruct_Entry();
        if (object.id !== undefined && object.id !== null) {
            message.id = BigInt(object.id.toString());
        }
        message.fieldKey = object.fieldKey ?? undefined;
        if (object.mapKey !== undefined && object.mapKey !== null) {
            message.mapKey = Expr.fromPartial(object.mapKey);
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = Expr.fromPartial(object.value);
        }
        return message;
    },
    fromSDK(object) {
        return {
            id: object?.id,
            fieldKey: object?.field_key,
            mapKey: object.map_key ? Expr.fromSDK(object.map_key) : undefined,
            value: object.value ? Expr.fromSDK(object.value) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? BigInt(object.id.toString()) : BigInt(0),
            field_key: isSet(object.field_key) ? String(object.field_key) : undefined,
            map_key: isSet(object.map_key) ? Expr.fromSDKJSON(object.map_key) : undefined,
            value: isSet(object.value) ? Expr.fromSDKJSON(object.value) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.id = message.id;
        obj.field_key = message.fieldKey;
        message.mapKey !== undefined && (obj.map_key = message.mapKey ? Expr.toSDK(message.mapKey) : undefined);
        message.value !== undefined && (obj.value = message.value ? Expr.toSDK(message.value) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseExpr_CreateStruct_Entry();
        if (object.id !== undefined && object.id !== null) {
            message.id = BigInt(object.id);
        }
        if (object.field_key !== undefined && object.field_key !== null) {
            message.fieldKey = object.field_key;
        }
        if (object.map_key !== undefined && object.map_key !== null) {
            message.mapKey = Expr.fromAmino(object.map_key);
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = Expr.fromAmino(object.value);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id !== BigInt(0) ? message.id?.toString() : undefined;
        obj.field_key = message.fieldKey === null ? undefined : message.fieldKey;
        obj.map_key = message.mapKey ? Expr.toAmino(message.mapKey) : undefined;
        obj.value = message.value ? Expr.toAmino(message.value) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return Expr_CreateStruct_Entry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Expr_CreateStruct_Entry.decode(message.value);
    },
    toProto(message) {
        return Expr_CreateStruct_Entry.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.Entry",
            value: Expr_CreateStruct_Entry.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Expr.registerTypeUrl();
    }
};
function createBaseExpr_Comprehension() {
    return {
        iterVar: "",
        iterRange: undefined,
        accuVar: "",
        accuInit: undefined,
        loopCondition: undefined,
        loopStep: undefined,
        result: undefined
    };
}
export const Expr_Comprehension = {
    typeUrl: "/google.api.expr.v1alpha1.Comprehension",
    is(o) {
        return o && (o.$typeUrl === Expr_Comprehension.typeUrl || typeof o.iterVar === "string" && typeof o.accuVar === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Expr_Comprehension.typeUrl || typeof o.iter_var === "string" && typeof o.accu_var === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Expr_Comprehension.typeUrl || typeof o.iter_var === "string" && typeof o.accu_var === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.iterVar !== undefined) {
            writer.uint32(10).string(message.iterVar);
        }
        if (message.iterRange !== undefined) {
            Expr.encode(message.iterRange, writer.uint32(18).fork()).ldelim();
        }
        if (message.accuVar !== undefined) {
            writer.uint32(26).string(message.accuVar);
        }
        if (message.accuInit !== undefined) {
            Expr.encode(message.accuInit, writer.uint32(34).fork()).ldelim();
        }
        if (message.loopCondition !== undefined) {
            Expr.encode(message.loopCondition, writer.uint32(42).fork()).ldelim();
        }
        if (message.loopStep !== undefined) {
            Expr.encode(message.loopStep, writer.uint32(50).fork()).ldelim();
        }
        if (message.result !== undefined) {
            Expr.encode(message.result, writer.uint32(58).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseExpr_Comprehension();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.iterVar = reader.string();
                    break;
                case 2:
                    message.iterRange = Expr.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.accuVar = reader.string();
                    break;
                case 4:
                    message.accuInit = Expr.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.loopCondition = Expr.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.loopStep = Expr.decode(reader, reader.uint32());
                    break;
                case 7:
                    message.result = Expr.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseExpr_Comprehension();
        if (isSet(object.iterVar))
            obj.iterVar = String(object.iterVar);
        if (isSet(object.iterRange))
            obj.iterRange = Expr.fromJSON(object.iterRange);
        if (isSet(object.accuVar))
            obj.accuVar = String(object.accuVar);
        if (isSet(object.accuInit))
            obj.accuInit = Expr.fromJSON(object.accuInit);
        if (isSet(object.loopCondition))
            obj.loopCondition = Expr.fromJSON(object.loopCondition);
        if (isSet(object.loopStep))
            obj.loopStep = Expr.fromJSON(object.loopStep);
        if (isSet(object.result))
            obj.result = Expr.fromJSON(object.result);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.iterVar !== undefined && (obj.iterVar = message.iterVar);
        message.iterRange !== undefined && (obj.iterRange = message.iterRange ? Expr.toJSON(message.iterRange) : undefined);
        message.accuVar !== undefined && (obj.accuVar = message.accuVar);
        message.accuInit !== undefined && (obj.accuInit = message.accuInit ? Expr.toJSON(message.accuInit) : undefined);
        message.loopCondition !== undefined && (obj.loopCondition = message.loopCondition ? Expr.toJSON(message.loopCondition) : undefined);
        message.loopStep !== undefined && (obj.loopStep = message.loopStep ? Expr.toJSON(message.loopStep) : undefined);
        message.result !== undefined && (obj.result = message.result ? Expr.toJSON(message.result) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseExpr_Comprehension();
        message.iterVar = object.iterVar ?? "";
        if (object.iterRange !== undefined && object.iterRange !== null) {
            message.iterRange = Expr.fromPartial(object.iterRange);
        }
        message.accuVar = object.accuVar ?? "";
        if (object.accuInit !== undefined && object.accuInit !== null) {
            message.accuInit = Expr.fromPartial(object.accuInit);
        }
        if (object.loopCondition !== undefined && object.loopCondition !== null) {
            message.loopCondition = Expr.fromPartial(object.loopCondition);
        }
        if (object.loopStep !== undefined && object.loopStep !== null) {
            message.loopStep = Expr.fromPartial(object.loopStep);
        }
        if (object.result !== undefined && object.result !== null) {
            message.result = Expr.fromPartial(object.result);
        }
        return message;
    },
    fromSDK(object) {
        return {
            iterVar: object?.iter_var,
            iterRange: object.iter_range ? Expr.fromSDK(object.iter_range) : undefined,
            accuVar: object?.accu_var,
            accuInit: object.accu_init ? Expr.fromSDK(object.accu_init) : undefined,
            loopCondition: object.loop_condition ? Expr.fromSDK(object.loop_condition) : undefined,
            loopStep: object.loop_step ? Expr.fromSDK(object.loop_step) : undefined,
            result: object.result ? Expr.fromSDK(object.result) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            iter_var: isSet(object.iter_var) ? String(object.iter_var) : "",
            iter_range: isSet(object.iter_range) ? Expr.fromSDKJSON(object.iter_range) : undefined,
            accu_var: isSet(object.accu_var) ? String(object.accu_var) : "",
            accu_init: isSet(object.accu_init) ? Expr.fromSDKJSON(object.accu_init) : undefined,
            loop_condition: isSet(object.loop_condition) ? Expr.fromSDKJSON(object.loop_condition) : undefined,
            loop_step: isSet(object.loop_step) ? Expr.fromSDKJSON(object.loop_step) : undefined,
            result: isSet(object.result) ? Expr.fromSDKJSON(object.result) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.iter_var = message.iterVar;
        message.iterRange !== undefined && (obj.iter_range = message.iterRange ? Expr.toSDK(message.iterRange) : undefined);
        obj.accu_var = message.accuVar;
        message.accuInit !== undefined && (obj.accu_init = message.accuInit ? Expr.toSDK(message.accuInit) : undefined);
        message.loopCondition !== undefined && (obj.loop_condition = message.loopCondition ? Expr.toSDK(message.loopCondition) : undefined);
        message.loopStep !== undefined && (obj.loop_step = message.loopStep ? Expr.toSDK(message.loopStep) : undefined);
        message.result !== undefined && (obj.result = message.result ? Expr.toSDK(message.result) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseExpr_Comprehension();
        if (object.iter_var !== undefined && object.iter_var !== null) {
            message.iterVar = object.iter_var;
        }
        if (object.iter_range !== undefined && object.iter_range !== null) {
            message.iterRange = Expr.fromAmino(object.iter_range);
        }
        if (object.accu_var !== undefined && object.accu_var !== null) {
            message.accuVar = object.accu_var;
        }
        if (object.accu_init !== undefined && object.accu_init !== null) {
            message.accuInit = Expr.fromAmino(object.accu_init);
        }
        if (object.loop_condition !== undefined && object.loop_condition !== null) {
            message.loopCondition = Expr.fromAmino(object.loop_condition);
        }
        if (object.loop_step !== undefined && object.loop_step !== null) {
            message.loopStep = Expr.fromAmino(object.loop_step);
        }
        if (object.result !== undefined && object.result !== null) {
            message.result = Expr.fromAmino(object.result);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.iter_var = message.iterVar === "" ? undefined : message.iterVar;
        obj.iter_range = message.iterRange ? Expr.toAmino(message.iterRange) : undefined;
        obj.accu_var = message.accuVar === "" ? undefined : message.accuVar;
        obj.accu_init = message.accuInit ? Expr.toAmino(message.accuInit) : undefined;
        obj.loop_condition = message.loopCondition ? Expr.toAmino(message.loopCondition) : undefined;
        obj.loop_step = message.loopStep ? Expr.toAmino(message.loopStep) : undefined;
        obj.result = message.result ? Expr.toAmino(message.result) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return Expr_Comprehension.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Expr_Comprehension.decode(message.value);
    },
    toProto(message) {
        return Expr_Comprehension.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.Comprehension",
            value: Expr_Comprehension.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Expr.registerTypeUrl();
    }
};
function createBaseConstant() {
    return {
        nullValue: undefined,
        boolValue: undefined,
        int64Value: undefined,
        uint64Value: undefined,
        doubleValue: undefined,
        stringValue: undefined,
        bytesValue: undefined,
        durationValue: undefined,
        timestampValue: undefined
    };
}
export const Constant = {
    typeUrl: "/google.api.expr.v1alpha1.Constant",
    is(o) {
        return o && o.$typeUrl === Constant.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === Constant.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === Constant.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.nullValue !== undefined) {
            writer.uint32(8).int32(message.nullValue);
        }
        if (message.boolValue !== undefined) {
            writer.uint32(16).bool(message.boolValue);
        }
        if (message.int64Value !== undefined) {
            writer.uint32(24).int64(message.int64Value);
        }
        if (message.uint64Value !== undefined) {
            writer.uint32(32).uint64(message.uint64Value);
        }
        if (message.doubleValue !== undefined) {
            writer.uint32(41).double(message.doubleValue);
        }
        if (message.stringValue !== undefined) {
            writer.uint32(50).string(message.stringValue);
        }
        if (message.bytesValue !== undefined) {
            writer.uint32(58).bytes(message.bytesValue);
        }
        if (message.durationValue !== undefined) {
            Duration.encode(message.durationValue, writer.uint32(66).fork()).ldelim();
        }
        if (message.timestampValue !== undefined) {
            Timestamp.encode(toTimestamp(message.timestampValue), writer.uint32(74).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseConstant();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.nullValue = reader.int32();
                    break;
                case 2:
                    message.boolValue = reader.bool();
                    break;
                case 3:
                    message.int64Value = reader.int64();
                    break;
                case 4:
                    message.uint64Value = reader.uint64();
                    break;
                case 5:
                    message.doubleValue = reader.double();
                    break;
                case 6:
                    message.stringValue = reader.string();
                    break;
                case 7:
                    message.bytesValue = reader.bytes();
                    break;
                case 8:
                    message.durationValue = Duration.decode(reader, reader.uint32());
                    break;
                case 9:
                    message.timestampValue = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseConstant();
        if (isSet(object.nullValue))
            obj.nullValue = nullValueFromJSON(object.nullValue);
        if (isSet(object.boolValue))
            obj.boolValue = Boolean(object.boolValue);
        if (isSet(object.int64Value))
            obj.int64Value = BigInt(object.int64Value.toString());
        if (isSet(object.uint64Value))
            obj.uint64Value = BigInt(object.uint64Value.toString());
        if (isSet(object.doubleValue))
            obj.doubleValue = Number(object.doubleValue);
        if (isSet(object.stringValue))
            obj.stringValue = String(object.stringValue);
        if (isSet(object.bytesValue))
            obj.bytesValue = bytesFromBase64(object.bytesValue);
        if (isSet(object.durationValue))
            obj.durationValue = Duration.fromJSON(object.durationValue);
        if (isSet(object.timestampValue))
            obj.timestampValue = new Date(object.timestampValue);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.nullValue !== undefined && (obj.nullValue = nullValueToJSON(message.nullValue));
        message.boolValue !== undefined && (obj.boolValue = message.boolValue);
        if (message.int64Value !== undefined) {
            obj.int64Value = message.int64Value.toString();
        }
        if (message.uint64Value !== undefined) {
            obj.uint64Value = message.uint64Value.toString();
        }
        message.doubleValue !== undefined && (obj.doubleValue = message.doubleValue);
        message.stringValue !== undefined && (obj.stringValue = message.stringValue);
        message.bytesValue !== undefined && (obj.bytesValue = message.bytesValue !== undefined ? base64FromBytes(message.bytesValue) : undefined);
        message.durationValue !== undefined && (obj.durationValue = message.durationValue ? Duration.toJSON(message.durationValue) : undefined);
        message.timestampValue !== undefined && (obj.timestampValue = message.timestampValue.toISOString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseConstant();
        message.nullValue = object.nullValue ?? undefined;
        message.boolValue = object.boolValue ?? undefined;
        if (object.int64Value !== undefined && object.int64Value !== null) {
            message.int64Value = BigInt(object.int64Value.toString());
        }
        if (object.uint64Value !== undefined && object.uint64Value !== null) {
            message.uint64Value = BigInt(object.uint64Value.toString());
        }
        message.doubleValue = object.doubleValue ?? undefined;
        message.stringValue = object.stringValue ?? undefined;
        message.bytesValue = object.bytesValue ?? undefined;
        if (object.durationValue !== undefined && object.durationValue !== null) {
            message.durationValue = Duration.fromPartial(object.durationValue);
        }
        message.timestampValue = object.timestampValue ?? undefined;
        return message;
    },
    fromSDK(object) {
        return {
            nullValue: isSet(object.null_value) ? nullValueFromJSON(object.null_value) : undefined,
            boolValue: object?.bool_value,
            int64Value: object?.int64_value,
            uint64Value: object?.uint64_value,
            doubleValue: object?.double_value,
            stringValue: object?.string_value,
            bytesValue: object?.bytes_value,
            durationValue: object.duration_value ? Duration.fromSDK(object.duration_value) : undefined,
            timestampValue: object.timestamp_value ?? undefined
        };
    },
    fromSDKJSON(object) {
        return {
            null_value: isSet(object.null_value) ? nullValueFromJSON(object.null_value) : undefined,
            bool_value: isSet(object.bool_value) ? Boolean(object.bool_value) : undefined,
            int64_value: isSet(object.int64_value) ? BigInt(object.int64_value.toString()) : undefined,
            uint64_value: isSet(object.uint64_value) ? BigInt(object.uint64_value.toString()) : undefined,
            double_value: isSet(object.double_value) ? Number(object.double_value) : undefined,
            string_value: isSet(object.string_value) ? String(object.string_value) : undefined,
            bytes_value: isSet(object.bytes_value) ? bytesFromBase64(object.bytes_value) : undefined,
            duration_value: isSet(object.duration_value) ? Duration.fromSDKJSON(object.duration_value) : undefined,
            timestamp_value: isSet(object.timestamp_value) ? new Date(object.timestamp_value) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.nullValue !== undefined && (obj.null_value = nullValueToJSON(message.nullValue));
        obj.bool_value = message.boolValue;
        obj.int64_value = message.int64Value;
        obj.uint64_value = message.uint64Value;
        obj.double_value = message.doubleValue;
        obj.string_value = message.stringValue;
        obj.bytes_value = message.bytesValue;
        message.durationValue !== undefined && (obj.duration_value = message.durationValue ? Duration.toSDK(message.durationValue) : undefined);
        message.timestampValue !== undefined && (obj.timestamp_value = message.timestampValue ?? undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseConstant();
        if (object.null_value !== undefined && object.null_value !== null) {
            message.nullValue = object.null_value;
        }
        if (object.bool_value !== undefined && object.bool_value !== null) {
            message.boolValue = object.bool_value;
        }
        if (object.int64_value !== undefined && object.int64_value !== null) {
            message.int64Value = BigInt(object.int64_value);
        }
        if (object.uint64_value !== undefined && object.uint64_value !== null) {
            message.uint64Value = BigInt(object.uint64_value);
        }
        if (object.double_value !== undefined && object.double_value !== null) {
            message.doubleValue = object.double_value;
        }
        if (object.string_value !== undefined && object.string_value !== null) {
            message.stringValue = object.string_value;
        }
        if (object.bytes_value !== undefined && object.bytes_value !== null) {
            message.bytesValue = bytesFromBase64(object.bytes_value);
        }
        if (object.duration_value !== undefined && object.duration_value !== null) {
            message.durationValue = Duration.fromAmino(object.duration_value);
        }
        if (object.timestamp_value !== undefined && object.timestamp_value !== null) {
            message.timestampValue = fromTimestamp(Timestamp.fromAmino(object.timestamp_value));
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.null_value = message.nullValue === null ? undefined : message.nullValue;
        obj.bool_value = message.boolValue === null ? undefined : message.boolValue;
        obj.int64_value = message.int64Value !== BigInt(0) ? message.int64Value?.toString() : undefined;
        obj.uint64_value = message.uint64Value !== BigInt(0) ? message.uint64Value?.toString() : undefined;
        obj.double_value = message.doubleValue === null ? undefined : message.doubleValue;
        obj.string_value = message.stringValue === null ? undefined : message.stringValue;
        obj.bytes_value = message.bytesValue ? base64FromBytes(message.bytesValue) : undefined;
        obj.duration_value = message.durationValue ? Duration.toAmino(message.durationValue) : undefined;
        obj.timestamp_value = message.timestampValue ? Timestamp.toAmino(toTimestamp(message.timestampValue)) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return Constant.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Constant.decode(message.value);
    },
    toProto(message) {
        return Constant.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.Constant",
            value: Constant.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseSourceInfo_PositionsEntry() {
    return {
        key: BigInt(0),
        value: 0
    };
}
export const SourceInfo_PositionsEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(8).int64(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(16).int32(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSourceInfo_PositionsEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.int64();
                    break;
                case 2:
                    message.value = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseSourceInfo_PositionsEntry();
        if (isSet(object.key))
            obj.key = BigInt(object.key.toString());
        if (isSet(object.value))
            obj.value = Number(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = (message.key || BigInt(0)).toString());
        message.value !== undefined && (obj.value = Math.round(message.value));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseSourceInfo_PositionsEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = BigInt(object.key.toString());
        }
        message.value = object.value ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? BigInt(object.key.toString()) : BigInt(0),
            value: isSet(object.value) ? Number(object.value) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseSourceInfo_PositionsEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = BigInt(object.key);
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key !== BigInt(0) ? message.key?.toString() : undefined;
        obj.value = message.value === 0 ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return SourceInfo_PositionsEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return SourceInfo_PositionsEntry.decode(message.value);
    },
    toProto(message) {
        return SourceInfo_PositionsEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseSourceInfo_MacroCallsEntry() {
    return {
        key: BigInt(0),
        value: undefined
    };
}
export const SourceInfo_MacroCallsEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(8).int64(message.key);
        }
        if (message.value !== undefined) {
            Expr.encode(message.value, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSourceInfo_MacroCallsEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.int64();
                    break;
                case 2:
                    message.value = Expr.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseSourceInfo_MacroCallsEntry();
        if (isSet(object.key))
            obj.key = BigInt(object.key.toString());
        if (isSet(object.value))
            obj.value = Expr.fromJSON(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = (message.key || BigInt(0)).toString());
        message.value !== undefined && (obj.value = message.value ? Expr.toJSON(message.value) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseSourceInfo_MacroCallsEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = BigInt(object.key.toString());
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = Expr.fromPartial(object.value);
        }
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object.value ? Expr.fromSDK(object.value) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? BigInt(object.key.toString()) : BigInt(0),
            value: isSet(object.value) ? Expr.fromSDKJSON(object.value) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        message.value !== undefined && (obj.value = message.value ? Expr.toSDK(message.value) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseSourceInfo_MacroCallsEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = BigInt(object.key);
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = Expr.fromAmino(object.value);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key !== BigInt(0) ? message.key?.toString() : undefined;
        obj.value = message.value ? Expr.toAmino(message.value) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return SourceInfo_MacroCallsEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return SourceInfo_MacroCallsEntry.decode(message.value);
    },
    toProto(message) {
        return SourceInfo_MacroCallsEntry.encode(message).finish();
    },
    registerTypeUrl() {
        Expr.registerTypeUrl();
    }
};
function createBaseSourceInfo() {
    return {
        syntaxVersion: "",
        location: "",
        lineOffsets: [],
        positions: {},
        macroCalls: {}
    };
}
export const SourceInfo = {
    typeUrl: "/google.api.expr.v1alpha1.SourceInfo",
    is(o) {
        return o && (o.$typeUrl === SourceInfo.typeUrl || typeof o.syntaxVersion === "string" && typeof o.location === "string" && Array.isArray(o.lineOffsets) && (!o.lineOffsets.length || typeof o.lineOffsets[0] === "number") && isSet(o.positions) && isSet(o.macroCalls));
    },
    isSDK(o) {
        return o && (o.$typeUrl === SourceInfo.typeUrl || typeof o.syntax_version === "string" && typeof o.location === "string" && Array.isArray(o.line_offsets) && (!o.line_offsets.length || typeof o.line_offsets[0] === "number") && isSet(o.positions) && isSet(o.macro_calls));
    },
    isAmino(o) {
        return o && (o.$typeUrl === SourceInfo.typeUrl || typeof o.syntax_version === "string" && typeof o.location === "string" && Array.isArray(o.line_offsets) && (!o.line_offsets.length || typeof o.line_offsets[0] === "number") && isSet(o.positions) && isSet(o.macro_calls));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.syntaxVersion !== undefined) {
            writer.uint32(10).string(message.syntaxVersion);
        }
        if (message.location !== undefined) {
            writer.uint32(18).string(message.location);
        }
        writer.uint32(26).fork();
        for (const v of message.lineOffsets) {
            writer.int32(v);
        }
        writer.ldelim();
        Object.entries(message.positions).forEach(([key, value]) => {
            SourceInfo_PositionsEntry.encode({
                key: key,
                value
            }, writer.uint32(32).fork()).ldelim();
        });
        Object.entries(message.macroCalls).forEach(([key, value]) => {
            SourceInfo_MacroCallsEntry.encode({
                key: key,
                value
            }, writer.uint32(42).fork()).ldelim();
        });
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSourceInfo();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.syntaxVersion = reader.string();
                    break;
                case 2:
                    message.location = reader.string();
                    break;
                case 3:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.lineOffsets.push(reader.int32());
                        }
                    }
                    else {
                        message.lineOffsets.push(reader.int32());
                    }
                    break;
                case 4:
                    const entry4 = SourceInfo_PositionsEntry.decode(reader, reader.uint32());
                    if (entry4.value !== undefined) {
                        message.positions[entry4.key] = entry4.value;
                    }
                    break;
                case 5:
                    const entry5 = SourceInfo_MacroCallsEntry.decode(reader, reader.uint32());
                    if (entry5.value !== undefined) {
                        message.macroCalls[entry5.key] = entry5.value;
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseSourceInfo();
        if (isSet(object.syntaxVersion))
            obj.syntaxVersion = String(object.syntaxVersion);
        if (isSet(object.location))
            obj.location = String(object.location);
        if (Array.isArray(object?.lineOffsets))
            obj.lineOffsets = object.lineOffsets.map((e) => Number(e));
        if (isObject(object.positions))
            obj.positions = Object.entries(object.positions).reduce((acc, [key, value]) => {
                acc[Number(key)] = Number(value);
                return acc;
            }, {});
        if (isObject(object.macroCalls))
            obj.macroCalls = Object.entries(object.macroCalls).reduce((acc, [key, value]) => {
                acc[Number(key)] = Expr.fromJSON(value);
                return acc;
            }, {});
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.syntaxVersion !== undefined && (obj.syntaxVersion = message.syntaxVersion);
        message.location !== undefined && (obj.location = message.location);
        if (message.lineOffsets) {
            obj.lineOffsets = message.lineOffsets.map(e => Math.round(e));
        }
        else {
            obj.lineOffsets = [];
        }
        obj.positions = {};
        if (message.positions) {
            Object.entries(message.positions).forEach(([k, v]) => {
                obj.positions[k] = Math.round(v);
            });
        }
        obj.macroCalls = {};
        if (message.macroCalls) {
            Object.entries(message.macroCalls).forEach(([k, v]) => {
                obj.macroCalls[k] = Expr.toJSON(v);
            });
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseSourceInfo();
        message.syntaxVersion = object.syntaxVersion ?? "";
        message.location = object.location ?? "";
        message.lineOffsets = object.lineOffsets?.map(e => e) || [];
        message.positions = Object.entries(object.positions ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[Number(key)] = Number(value);
            }
            return acc;
        }, {});
        message.macroCalls = Object.entries(object.macroCalls ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[Number(key)] = Expr.fromPartial(value);
            }
            return acc;
        }, {});
        return message;
    },
    fromSDK(object) {
        return {
            syntaxVersion: object?.syntax_version,
            location: object?.location,
            lineOffsets: Array.isArray(object?.line_offsets) ? object.line_offsets.map((e) => e) : [],
            positions: isObject(object.positions) ? Object.entries(object.positions).reduce((acc, [key, value]) => {
                acc[Number(key)] = Number(value);
                return acc;
            }, {}) : {},
            macroCalls: isObject(object.macro_calls) ? Object.entries(object.macro_calls).reduce((acc, [key, value]) => {
                acc[Number(key)] = Expr.fromSDK(value);
                return acc;
            }, {}) : {}
        };
    },
    fromSDKJSON(object) {
        return {
            syntax_version: isSet(object.syntax_version) ? String(object.syntax_version) : "",
            location: isSet(object.location) ? String(object.location) : "",
            line_offsets: Array.isArray(object?.line_offsets) ? object.line_offsets.map((e) => Number(e)) : [],
            positions: isObject(object.positions) ? Object.entries(object.positions).reduce((acc, [key, value]) => {
                acc[Number(key)] = Number(value);
                return acc;
            }, {}) : {},
            macro_calls: isObject(object.macro_calls) ? Object.entries(object.macro_calls).reduce((acc, [key, value]) => {
                acc[Number(key)] = Expr.fromSDKJSON(value);
                return acc;
            }, {}) : {}
        };
    },
    toSDK(message) {
        const obj = {};
        obj.syntax_version = message.syntaxVersion;
        obj.location = message.location;
        if (message.lineOffsets) {
            obj.line_offsets = message.lineOffsets.map(e => e);
        }
        else {
            obj.line_offsets = [];
        }
        obj.positions = {};
        if (message.positions) {
            Object.entries(message.positions).forEach(([k, v]) => {
                obj.positions[k] = Math.round(v);
            });
        }
        obj.macro_calls = {};
        if (message.macroCalls) {
            Object.entries(message.macroCalls).forEach(([k, v]) => {
                obj.macro_calls[k] = Expr.toSDK(v);
            });
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseSourceInfo();
        if (object.syntax_version !== undefined && object.syntax_version !== null) {
            message.syntaxVersion = object.syntax_version;
        }
        if (object.location !== undefined && object.location !== null) {
            message.location = object.location;
        }
        message.lineOffsets = object.line_offsets?.map(e => e) || [];
        message.positions = Object.entries(object.positions ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[Number(key)] = Number(value);
            }
            return acc;
        }, {});
        message.macroCalls = Object.entries(object.macro_calls ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[Number(key)] = Expr.fromAmino(value);
            }
            return acc;
        }, {});
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.syntax_version = message.syntaxVersion === "" ? undefined : message.syntaxVersion;
        obj.location = message.location === "" ? undefined : message.location;
        if (message.lineOffsets) {
            obj.line_offsets = message.lineOffsets.map(e => e);
        }
        else {
            obj.line_offsets = message.lineOffsets;
        }
        obj.positions = {};
        if (message.positions) {
            Object.entries(message.positions).forEach(([k, v]) => {
                obj.positions[k] = Math.round(v);
            });
        }
        obj.macro_calls = {};
        if (message.macroCalls) {
            Object.entries(message.macroCalls).forEach(([k, v]) => {
                obj.macro_calls[k] = Expr.toAmino(v);
            });
        }
        return obj;
    },
    fromAminoMsg(object) {
        return SourceInfo.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return SourceInfo.decode(message.value);
    },
    toProto(message) {
        return SourceInfo.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.SourceInfo",
            value: SourceInfo.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Expr.registerTypeUrl();
    }
};
function createBaseSourcePosition() {
    return {
        location: "",
        offset: 0,
        line: 0,
        column: 0
    };
}
export const SourcePosition = {
    typeUrl: "/google.api.expr.v1alpha1.SourcePosition",
    is(o) {
        return o && (o.$typeUrl === SourcePosition.typeUrl || typeof o.location === "string" && typeof o.offset === "number" && typeof o.line === "number" && typeof o.column === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === SourcePosition.typeUrl || typeof o.location === "string" && typeof o.offset === "number" && typeof o.line === "number" && typeof o.column === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === SourcePosition.typeUrl || typeof o.location === "string" && typeof o.offset === "number" && typeof o.line === "number" && typeof o.column === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.location !== undefined) {
            writer.uint32(10).string(message.location);
        }
        if (message.offset !== undefined) {
            writer.uint32(16).int32(message.offset);
        }
        if (message.line !== undefined) {
            writer.uint32(24).int32(message.line);
        }
        if (message.column !== undefined) {
            writer.uint32(32).int32(message.column);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSourcePosition();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.location = reader.string();
                    break;
                case 2:
                    message.offset = reader.int32();
                    break;
                case 3:
                    message.line = reader.int32();
                    break;
                case 4:
                    message.column = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseSourcePosition();
        if (isSet(object.location))
            obj.location = String(object.location);
        if (isSet(object.offset))
            obj.offset = Number(object.offset);
        if (isSet(object.line))
            obj.line = Number(object.line);
        if (isSet(object.column))
            obj.column = Number(object.column);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.location !== undefined && (obj.location = message.location);
        message.offset !== undefined && (obj.offset = Math.round(message.offset));
        message.line !== undefined && (obj.line = Math.round(message.line));
        message.column !== undefined && (obj.column = Math.round(message.column));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseSourcePosition();
        message.location = object.location ?? "";
        message.offset = object.offset ?? 0;
        message.line = object.line ?? 0;
        message.column = object.column ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            location: object?.location,
            offset: object?.offset,
            line: object?.line,
            column: object?.column
        };
    },
    fromSDKJSON(object) {
        return {
            location: isSet(object.location) ? String(object.location) : "",
            offset: isSet(object.offset) ? Number(object.offset) : 0,
            line: isSet(object.line) ? Number(object.line) : 0,
            column: isSet(object.column) ? Number(object.column) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.location = message.location;
        obj.offset = message.offset;
        obj.line = message.line;
        obj.column = message.column;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseSourcePosition();
        if (object.location !== undefined && object.location !== null) {
            message.location = object.location;
        }
        if (object.offset !== undefined && object.offset !== null) {
            message.offset = object.offset;
        }
        if (object.line !== undefined && object.line !== null) {
            message.line = object.line;
        }
        if (object.column !== undefined && object.column !== null) {
            message.column = object.column;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.location = message.location === "" ? undefined : message.location;
        obj.offset = message.offset === 0 ? undefined : message.offset;
        obj.line = message.line === 0 ? undefined : message.line;
        obj.column = message.column === 0 ? undefined : message.column;
        return obj;
    },
    fromAminoMsg(object) {
        return SourcePosition.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return SourcePosition.decode(message.value);
    },
    toProto(message) {
        return SourcePosition.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.SourcePosition",
            value: SourcePosition.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
