import { nullValueFromJSON, nullValueToJSON } from "../../../protobuf/struct";
import { Any } from "../../../protobuf/any";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { isSet, bytesFromBase64, base64FromBytes } from "../../../../helpers";
export const protobufPackage = "google.api.expr.v1alpha1";
function createBaseValue() {
    return {
        nullValue: undefined,
        boolValue: undefined,
        int64Value: undefined,
        uint64Value: undefined,
        doubleValue: undefined,
        stringValue: undefined,
        bytesValue: undefined,
        enumValue: undefined,
        objectValue: undefined,
        mapValue: undefined,
        listValue: undefined,
        typeValue: undefined
    };
}
export const Value = {
    typeUrl: "/google.api.expr.v1alpha1.Value",
    is(o) {
        return o && o.$typeUrl === Value.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === Value.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === Value.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.nullValue !== undefined) {
            writer.uint32(8).int32(message.nullValue);
        }
        if (message.boolValue !== undefined) {
            writer.uint32(16).bool(message.boolValue);
        }
        if (message.int64Value !== undefined) {
            writer.uint32(24).int64(message.int64Value);
        }
        if (message.uint64Value !== undefined) {
            writer.uint32(32).uint64(message.uint64Value);
        }
        if (message.doubleValue !== undefined) {
            writer.uint32(41).double(message.doubleValue);
        }
        if (message.stringValue !== undefined) {
            writer.uint32(50).string(message.stringValue);
        }
        if (message.bytesValue !== undefined) {
            writer.uint32(58).bytes(message.bytesValue);
        }
        if (message.enumValue !== undefined) {
            EnumValue.encode(message.enumValue, writer.uint32(74).fork()).ldelim();
        }
        if (message.objectValue !== undefined) {
            Any.encode(message.objectValue, writer.uint32(82).fork()).ldelim();
        }
        if (message.mapValue !== undefined) {
            MapValue.encode(message.mapValue, writer.uint32(90).fork()).ldelim();
        }
        if (message.listValue !== undefined) {
            ListValue.encode(message.listValue, writer.uint32(98).fork()).ldelim();
        }
        if (message.typeValue !== undefined) {
            writer.uint32(122).string(message.typeValue);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseValue();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.nullValue = reader.int32();
                    break;
                case 2:
                    message.boolValue = reader.bool();
                    break;
                case 3:
                    message.int64Value = reader.int64();
                    break;
                case 4:
                    message.uint64Value = reader.uint64();
                    break;
                case 5:
                    message.doubleValue = reader.double();
                    break;
                case 6:
                    message.stringValue = reader.string();
                    break;
                case 7:
                    message.bytesValue = reader.bytes();
                    break;
                case 9:
                    message.enumValue = EnumValue.decode(reader, reader.uint32());
                    break;
                case 10:
                    message.objectValue = Any.decode(reader, reader.uint32());
                    break;
                case 11:
                    message.mapValue = MapValue.decode(reader, reader.uint32());
                    break;
                case 12:
                    message.listValue = ListValue.decode(reader, reader.uint32());
                    break;
                case 15:
                    message.typeValue = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseValue();
        if (isSet(object.nullValue))
            obj.nullValue = nullValueFromJSON(object.nullValue);
        if (isSet(object.boolValue))
            obj.boolValue = Boolean(object.boolValue);
        if (isSet(object.int64Value))
            obj.int64Value = BigInt(object.int64Value.toString());
        if (isSet(object.uint64Value))
            obj.uint64Value = BigInt(object.uint64Value.toString());
        if (isSet(object.doubleValue))
            obj.doubleValue = Number(object.doubleValue);
        if (isSet(object.stringValue))
            obj.stringValue = String(object.stringValue);
        if (isSet(object.bytesValue))
            obj.bytesValue = bytesFromBase64(object.bytesValue);
        if (isSet(object.enumValue))
            obj.enumValue = EnumValue.fromJSON(object.enumValue);
        if (isSet(object.objectValue))
            obj.objectValue = Any.fromJSON(object.objectValue);
        if (isSet(object.mapValue))
            obj.mapValue = MapValue.fromJSON(object.mapValue);
        if (isSet(object.listValue))
            obj.listValue = ListValue.fromJSON(object.listValue);
        if (isSet(object.typeValue))
            obj.typeValue = String(object.typeValue);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.nullValue !== undefined && (obj.nullValue = nullValueToJSON(message.nullValue));
        message.boolValue !== undefined && (obj.boolValue = message.boolValue);
        if (message.int64Value !== undefined) {
            obj.int64Value = message.int64Value.toString();
        }
        if (message.uint64Value !== undefined) {
            obj.uint64Value = message.uint64Value.toString();
        }
        message.doubleValue !== undefined && (obj.doubleValue = message.doubleValue);
        message.stringValue !== undefined && (obj.stringValue = message.stringValue);
        message.bytesValue !== undefined && (obj.bytesValue = message.bytesValue !== undefined ? base64FromBytes(message.bytesValue) : undefined);
        message.enumValue !== undefined && (obj.enumValue = message.enumValue ? EnumValue.toJSON(message.enumValue) : undefined);
        message.objectValue !== undefined && (obj.objectValue = message.objectValue ? Any.toJSON(message.objectValue) : undefined);
        message.mapValue !== undefined && (obj.mapValue = message.mapValue ? MapValue.toJSON(message.mapValue) : undefined);
        message.listValue !== undefined && (obj.listValue = message.listValue ? ListValue.toJSON(message.listValue) : undefined);
        message.typeValue !== undefined && (obj.typeValue = message.typeValue);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseValue();
        message.nullValue = object.nullValue ?? undefined;
        message.boolValue = object.boolValue ?? undefined;
        if (object.int64Value !== undefined && object.int64Value !== null) {
            message.int64Value = BigInt(object.int64Value.toString());
        }
        if (object.uint64Value !== undefined && object.uint64Value !== null) {
            message.uint64Value = BigInt(object.uint64Value.toString());
        }
        message.doubleValue = object.doubleValue ?? undefined;
        message.stringValue = object.stringValue ?? undefined;
        message.bytesValue = object.bytesValue ?? undefined;
        if (object.enumValue !== undefined && object.enumValue !== null) {
            message.enumValue = EnumValue.fromPartial(object.enumValue);
        }
        if (object.objectValue !== undefined && object.objectValue !== null) {
            message.objectValue = Any.fromPartial(object.objectValue);
        }
        if (object.mapValue !== undefined && object.mapValue !== null) {
            message.mapValue = MapValue.fromPartial(object.mapValue);
        }
        if (object.listValue !== undefined && object.listValue !== null) {
            message.listValue = ListValue.fromPartial(object.listValue);
        }
        message.typeValue = object.typeValue ?? undefined;
        return message;
    },
    fromSDK(object) {
        return {
            nullValue: isSet(object.null_value) ? nullValueFromJSON(object.null_value) : undefined,
            boolValue: object?.bool_value,
            int64Value: object?.int64_value,
            uint64Value: object?.uint64_value,
            doubleValue: object?.double_value,
            stringValue: object?.string_value,
            bytesValue: object?.bytes_value,
            enumValue: object.enum_value ? EnumValue.fromSDK(object.enum_value) : undefined,
            objectValue: object.object_value ? Any.fromSDK(object.object_value) : undefined,
            mapValue: object.map_value ? MapValue.fromSDK(object.map_value) : undefined,
            listValue: object.list_value ? ListValue.fromSDK(object.list_value) : undefined,
            typeValue: object?.type_value
        };
    },
    fromSDKJSON(object) {
        return {
            null_value: isSet(object.null_value) ? nullValueFromJSON(object.null_value) : undefined,
            bool_value: isSet(object.bool_value) ? Boolean(object.bool_value) : undefined,
            int64_value: isSet(object.int64_value) ? BigInt(object.int64_value.toString()) : undefined,
            uint64_value: isSet(object.uint64_value) ? BigInt(object.uint64_value.toString()) : undefined,
            double_value: isSet(object.double_value) ? Number(object.double_value) : undefined,
            string_value: isSet(object.string_value) ? String(object.string_value) : undefined,
            bytes_value: isSet(object.bytes_value) ? bytesFromBase64(object.bytes_value) : undefined,
            enum_value: isSet(object.enum_value) ? EnumValue.fromSDKJSON(object.enum_value) : undefined,
            object_value: isSet(object.object_value) ? Any.fromSDKJSON(object.object_value) : undefined,
            map_value: isSet(object.map_value) ? MapValue.fromSDKJSON(object.map_value) : undefined,
            list_value: isSet(object.list_value) ? ListValue.fromSDKJSON(object.list_value) : undefined,
            type_value: isSet(object.type_value) ? String(object.type_value) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.nullValue !== undefined && (obj.null_value = nullValueToJSON(message.nullValue));
        obj.bool_value = message.boolValue;
        obj.int64_value = message.int64Value;
        obj.uint64_value = message.uint64Value;
        obj.double_value = message.doubleValue;
        obj.string_value = message.stringValue;
        obj.bytes_value = message.bytesValue;
        message.enumValue !== undefined && (obj.enum_value = message.enumValue ? EnumValue.toSDK(message.enumValue) : undefined);
        message.objectValue !== undefined && (obj.object_value = message.objectValue ? Any.toSDK(message.objectValue) : undefined);
        message.mapValue !== undefined && (obj.map_value = message.mapValue ? MapValue.toSDK(message.mapValue) : undefined);
        message.listValue !== undefined && (obj.list_value = message.listValue ? ListValue.toSDK(message.listValue) : undefined);
        obj.type_value = message.typeValue;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseValue();
        if (object.null_value !== undefined && object.null_value !== null) {
            message.nullValue = object.null_value;
        }
        if (object.bool_value !== undefined && object.bool_value !== null) {
            message.boolValue = object.bool_value;
        }
        if (object.int64_value !== undefined && object.int64_value !== null) {
            message.int64Value = BigInt(object.int64_value);
        }
        if (object.uint64_value !== undefined && object.uint64_value !== null) {
            message.uint64Value = BigInt(object.uint64_value);
        }
        if (object.double_value !== undefined && object.double_value !== null) {
            message.doubleValue = object.double_value;
        }
        if (object.string_value !== undefined && object.string_value !== null) {
            message.stringValue = object.string_value;
        }
        if (object.bytes_value !== undefined && object.bytes_value !== null) {
            message.bytesValue = bytesFromBase64(object.bytes_value);
        }
        if (object.enum_value !== undefined && object.enum_value !== null) {
            message.enumValue = EnumValue.fromAmino(object.enum_value);
        }
        if (object.object_value !== undefined && object.object_value !== null) {
            message.objectValue = Any.fromAmino(object.object_value);
        }
        if (object.map_value !== undefined && object.map_value !== null) {
            message.mapValue = MapValue.fromAmino(object.map_value);
        }
        if (object.list_value !== undefined && object.list_value !== null) {
            message.listValue = ListValue.fromAmino(object.list_value);
        }
        if (object.type_value !== undefined && object.type_value !== null) {
            message.typeValue = object.type_value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.null_value = message.nullValue === null ? undefined : message.nullValue;
        obj.bool_value = message.boolValue === null ? undefined : message.boolValue;
        obj.int64_value = message.int64Value !== BigInt(0) ? message.int64Value?.toString() : undefined;
        obj.uint64_value = message.uint64Value !== BigInt(0) ? message.uint64Value?.toString() : undefined;
        obj.double_value = message.doubleValue === null ? undefined : message.doubleValue;
        obj.string_value = message.stringValue === null ? undefined : message.stringValue;
        obj.bytes_value = message.bytesValue ? base64FromBytes(message.bytesValue) : undefined;
        obj.enum_value = message.enumValue ? EnumValue.toAmino(message.enumValue) : undefined;
        obj.object_value = message.objectValue ? Any.toAmino(message.objectValue) : undefined;
        obj.map_value = message.mapValue ? MapValue.toAmino(message.mapValue) : undefined;
        obj.list_value = message.listValue ? ListValue.toAmino(message.listValue) : undefined;
        obj.type_value = message.typeValue === null ? undefined : message.typeValue;
        return obj;
    },
    fromAminoMsg(object) {
        return Value.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Value.decode(message.value);
    },
    toProto(message) {
        return Value.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.Value",
            value: Value.encode(message).finish()
        };
    },
    registerTypeUrl() {
        MapValue.registerTypeUrl();
        ListValue.registerTypeUrl();
    }
};
function createBaseEnumValue() {
    return {
        type: "",
        value: 0
    };
}
export const EnumValue = {
    typeUrl: "/google.api.expr.v1alpha1.EnumValue",
    is(o) {
        return o && (o.$typeUrl === EnumValue.typeUrl || typeof o.type === "string" && typeof o.value === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === EnumValue.typeUrl || typeof o.type === "string" && typeof o.value === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === EnumValue.typeUrl || typeof o.type === "string" && typeof o.value === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.type !== undefined) {
            writer.uint32(10).string(message.type);
        }
        if (message.value !== undefined) {
            writer.uint32(16).int32(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseEnumValue();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.type = reader.string();
                    break;
                case 2:
                    message.value = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseEnumValue();
        if (isSet(object.type))
            obj.type = String(object.type);
        if (isSet(object.value))
            obj.value = Number(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.type !== undefined && (obj.type = message.type);
        message.value !== undefined && (obj.value = Math.round(message.value));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseEnumValue();
        message.type = object.type ?? "";
        message.value = object.value ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            type: object?.type,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            type: isSet(object.type) ? String(object.type) : "",
            value: isSet(object.value) ? Number(object.value) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.type = message.type;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseEnumValue();
        if (object.type !== undefined && object.type !== null) {
            message.type = object.type;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.type = message.type === "" ? undefined : message.type;
        obj.value = message.value === 0 ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return EnumValue.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return EnumValue.decode(message.value);
    },
    toProto(message) {
        return EnumValue.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.EnumValue",
            value: EnumValue.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListValue() {
    return {
        values: []
    };
}
export const ListValue = {
    typeUrl: "/google.api.expr.v1alpha1.ListValue",
    is(o) {
        return o && (o.$typeUrl === ListValue.typeUrl || Array.isArray(o.values) && (!o.values.length || Value.is(o.values[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListValue.typeUrl || Array.isArray(o.values) && (!o.values.length || Value.isSDK(o.values[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListValue.typeUrl || Array.isArray(o.values) && (!o.values.length || Value.isAmino(o.values[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.values) {
            Value.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListValue();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.values.push(Value.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListValue();
        if (Array.isArray(object?.values))
            obj.values = object.values.map((e) => Value.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.values) {
            obj.values = message.values.map(e => e ? Value.toJSON(e) : undefined);
        }
        else {
            obj.values = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListValue();
        message.values = object.values?.map(e => Value.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            values: Array.isArray(object?.values) ? object.values.map((e) => Value.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            values: Array.isArray(object?.values) ? object.values.map((e) => Value.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.values) {
            obj.values = message.values.map(e => e ? Value.toSDK(e) : undefined);
        }
        else {
            obj.values = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListValue();
        message.values = object.values?.map(e => Value.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.values) {
            obj.values = message.values.map(e => e ? Value.toAmino(e) : undefined);
        }
        else {
            obj.values = message.values;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return ListValue.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListValue.decode(message.value);
    },
    toProto(message) {
        return ListValue.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.ListValue",
            value: ListValue.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Value.registerTypeUrl();
    }
};
function createBaseMapValue() {
    return {
        entries: []
    };
}
export const MapValue = {
    typeUrl: "/google.api.expr.v1alpha1.MapValue",
    is(o) {
        return o && (o.$typeUrl === MapValue.typeUrl || Array.isArray(o.entries) && (!o.entries.length || MapValue_Entry.is(o.entries[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MapValue.typeUrl || Array.isArray(o.entries) && (!o.entries.length || MapValue_Entry.isSDK(o.entries[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MapValue.typeUrl || Array.isArray(o.entries) && (!o.entries.length || MapValue_Entry.isAmino(o.entries[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.entries) {
            MapValue_Entry.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMapValue();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.entries.push(MapValue_Entry.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMapValue();
        if (Array.isArray(object?.entries))
            obj.entries = object.entries.map((e) => MapValue_Entry.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.entries) {
            obj.entries = message.entries.map(e => e ? MapValue_Entry.toJSON(e) : undefined);
        }
        else {
            obj.entries = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMapValue();
        message.entries = object.entries?.map(e => MapValue_Entry.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            entries: Array.isArray(object?.entries) ? object.entries.map((e) => MapValue_Entry.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            entries: Array.isArray(object?.entries) ? object.entries.map((e) => MapValue_Entry.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.entries) {
            obj.entries = message.entries.map(e => e ? MapValue_Entry.toSDK(e) : undefined);
        }
        else {
            obj.entries = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMapValue();
        message.entries = object.entries?.map(e => MapValue_Entry.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.entries) {
            obj.entries = message.entries.map(e => e ? MapValue_Entry.toAmino(e) : undefined);
        }
        else {
            obj.entries = message.entries;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return MapValue.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MapValue.decode(message.value);
    },
    toProto(message) {
        return MapValue.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.MapValue",
            value: MapValue.encode(message).finish()
        };
    },
    registerTypeUrl() {
        MapValue_Entry.registerTypeUrl();
    }
};
function createBaseMapValue_Entry() {
    return {
        key: undefined,
        value: undefined
    };
}
export const MapValue_Entry = {
    typeUrl: "/google.api.expr.v1alpha1.Entry",
    is(o) {
        return o && o.$typeUrl === MapValue_Entry.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MapValue_Entry.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MapValue_Entry.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            Value.encode(message.key, writer.uint32(10).fork()).ldelim();
        }
        if (message.value !== undefined) {
            Value.encode(message.value, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMapValue_Entry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = Value.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.value = Value.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMapValue_Entry();
        if (isSet(object.key))
            obj.key = Value.fromJSON(object.key);
        if (isSet(object.value))
            obj.value = Value.fromJSON(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key ? Value.toJSON(message.key) : undefined);
        message.value !== undefined && (obj.value = message.value ? Value.toJSON(message.value) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMapValue_Entry();
        if (object.key !== undefined && object.key !== null) {
            message.key = Value.fromPartial(object.key);
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = Value.fromPartial(object.value);
        }
        return message;
    },
    fromSDK(object) {
        return {
            key: object.key ? Value.fromSDK(object.key) : undefined,
            value: object.value ? Value.fromSDK(object.value) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? Value.fromSDKJSON(object.key) : undefined,
            value: isSet(object.value) ? Value.fromSDKJSON(object.value) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key ? Value.toSDK(message.key) : undefined);
        message.value !== undefined && (obj.value = message.value ? Value.toSDK(message.value) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMapValue_Entry();
        if (object.key !== undefined && object.key !== null) {
            message.key = Value.fromAmino(object.key);
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = Value.fromAmino(object.value);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key ? Value.toAmino(message.key) : undefined;
        obj.value = message.value ? Value.toAmino(message.value) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return MapValue_Entry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MapValue_Entry.decode(message.value);
    },
    toProto(message) {
        return MapValue_Entry.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.expr.v1alpha1.Entry",
            value: MapValue_Entry.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Value.registerTypeUrl();
    }
};
