import { LabelDescriptor } from "./label";
import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseLogDescriptor() {
    return {
        name: "",
        labels: [],
        description: "",
        displayName: ""
    };
}
export const LogDescriptor = {
    typeUrl: "/google.api.LogDescriptor",
    is(o) {
        return o && (o.$typeUrl === LogDescriptor.typeUrl || typeof o.name === "string" && Array.isArray(o.labels) && (!o.labels.length || LabelDescriptor.is(o.labels[0])) && typeof o.description === "string" && typeof o.displayName === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === LogDescriptor.typeUrl || typeof o.name === "string" && Array.isArray(o.labels) && (!o.labels.length || LabelDescriptor.isSDK(o.labels[0])) && typeof o.description === "string" && typeof o.display_name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === LogDescriptor.typeUrl || typeof o.name === "string" && Array.isArray(o.labels) && (!o.labels.length || LabelDescriptor.isAmino(o.labels[0])) && typeof o.description === "string" && typeof o.display_name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        for (const v of message.labels) {
            LabelDescriptor.encode(v, writer.uint32(18).fork()).ldelim();
        }
        if (message.description !== undefined) {
            writer.uint32(26).string(message.description);
        }
        if (message.displayName !== undefined) {
            writer.uint32(34).string(message.displayName);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLogDescriptor();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.labels.push(LabelDescriptor.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.description = reader.string();
                    break;
                case 4:
                    message.displayName = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLogDescriptor();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (Array.isArray(object?.labels))
            obj.labels = object.labels.map((e) => LabelDescriptor.fromJSON(e));
        if (isSet(object.description))
            obj.description = String(object.description);
        if (isSet(object.displayName))
            obj.displayName = String(object.displayName);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        if (message.labels) {
            obj.labels = message.labels.map(e => e ? LabelDescriptor.toJSON(e) : undefined);
        }
        else {
            obj.labels = [];
        }
        message.description !== undefined && (obj.description = message.description);
        message.displayName !== undefined && (obj.displayName = message.displayName);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLogDescriptor();
        message.name = object.name ?? "";
        message.labels = object.labels?.map(e => LabelDescriptor.fromPartial(e)) || [];
        message.description = object.description ?? "";
        message.displayName = object.displayName ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            labels: Array.isArray(object?.labels) ? object.labels.map((e) => LabelDescriptor.fromSDK(e)) : [],
            description: object?.description,
            displayName: object?.display_name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            labels: Array.isArray(object?.labels) ? object.labels.map((e) => LabelDescriptor.fromSDKJSON(e)) : [],
            description: isSet(object.description) ? String(object.description) : "",
            display_name: isSet(object.display_name) ? String(object.display_name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        if (message.labels) {
            obj.labels = message.labels.map(e => e ? LabelDescriptor.toSDK(e) : undefined);
        }
        else {
            obj.labels = [];
        }
        obj.description = message.description;
        obj.display_name = message.displayName;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLogDescriptor();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        message.labels = object.labels?.map(e => LabelDescriptor.fromAmino(e)) || [];
        if (object.description !== undefined && object.description !== null) {
            message.description = object.description;
        }
        if (object.display_name !== undefined && object.display_name !== null) {
            message.displayName = object.display_name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        if (message.labels) {
            obj.labels = message.labels.map(e => e ? LabelDescriptor.toAmino(e) : undefined);
        }
        else {
            obj.labels = message.labels;
        }
        obj.description = message.description === "" ? undefined : message.description;
        obj.display_name = message.displayName === "" ? undefined : message.displayName;
        return obj;
    },
    fromAminoMsg(object) {
        return LogDescriptor.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return LogDescriptor.decode(message.value);
    },
    toProto(message) {
        return LogDescriptor.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.LogDescriptor",
            value: LogDescriptor.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LabelDescriptor.registerTypeUrl();
    }
};
