import { launchStageFromJSON, launchStageToJSON } from "./launch_stage";
import { Duration } from "../protobuf/duration";
import { LabelDescriptor } from "./label";
import { isSet, isObject } from "../../helpers";
import { BinaryReader, BinaryWriter } from "../../binary";
export const protobufPackage = "google.api";
/**
 * The kind of measurement. It describes how the data is reported.
 * For information on setting the start time and end time based on
 * the MetricKind, see [TimeInterval][google.monitoring.v3.TimeInterval].
 */
export var MetricDescriptor_MetricKind;
(function (MetricDescriptor_MetricKind) {
    /** METRIC_KIND_UNSPECIFIED - Do not use this default value. */
    MetricDescriptor_MetricKind[MetricDescriptor_MetricKind["METRIC_KIND_UNSPECIFIED"] = 0] = "METRIC_KIND_UNSPECIFIED";
    /** GAUGE - An instantaneous measurement of a value. */
    MetricDescriptor_MetricKind[MetricDescriptor_MetricKind["GAUGE"] = 1] = "GAUGE";
    /** DELTA - The change in a value during a time interval. */
    MetricDescriptor_MetricKind[MetricDescriptor_MetricKind["DELTA"] = 2] = "DELTA";
    /**
     * CUMULATIVE - A value accumulated over a time interval.  Cumulative
     * measurements in a time series should have the same start time
     * and increasing end times, until an event resets the cumulative
     * value to zero and sets a new start time for the following
     * points.
     */
    MetricDescriptor_MetricKind[MetricDescriptor_MetricKind["CUMULATIVE"] = 3] = "CUMULATIVE";
    MetricDescriptor_MetricKind[MetricDescriptor_MetricKind["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(MetricDescriptor_MetricKind || (MetricDescriptor_MetricKind = {}));
export const MetricDescriptor_MetricKindSDKType = MetricDescriptor_MetricKind;
export const MetricDescriptor_MetricKindAmino = MetricDescriptor_MetricKind;
export function metricDescriptor_MetricKindFromJSON(object) {
    switch (object) {
        case 0:
        case "METRIC_KIND_UNSPECIFIED":
            return MetricDescriptor_MetricKind.METRIC_KIND_UNSPECIFIED;
        case 1:
        case "GAUGE":
            return MetricDescriptor_MetricKind.GAUGE;
        case 2:
        case "DELTA":
            return MetricDescriptor_MetricKind.DELTA;
        case 3:
        case "CUMULATIVE":
            return MetricDescriptor_MetricKind.CUMULATIVE;
        case -1:
        case "UNRECOGNIZED":
        default:
            return MetricDescriptor_MetricKind.UNRECOGNIZED;
    }
}
export function metricDescriptor_MetricKindToJSON(object) {
    switch (object) {
        case MetricDescriptor_MetricKind.METRIC_KIND_UNSPECIFIED:
            return "METRIC_KIND_UNSPECIFIED";
        case MetricDescriptor_MetricKind.GAUGE:
            return "GAUGE";
        case MetricDescriptor_MetricKind.DELTA:
            return "DELTA";
        case MetricDescriptor_MetricKind.CUMULATIVE:
            return "CUMULATIVE";
        case MetricDescriptor_MetricKind.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
/** The value type of a metric. */
export var MetricDescriptor_ValueType;
(function (MetricDescriptor_ValueType) {
    /** VALUE_TYPE_UNSPECIFIED - Do not use this default value. */
    MetricDescriptor_ValueType[MetricDescriptor_ValueType["VALUE_TYPE_UNSPECIFIED"] = 0] = "VALUE_TYPE_UNSPECIFIED";
    /**
     * BOOL - The value is a boolean.
     * This value type can be used only if the metric kind is `GAUGE`.
     */
    MetricDescriptor_ValueType[MetricDescriptor_ValueType["BOOL"] = 1] = "BOOL";
    /** INT64 - The value is a signed 64-bit integer. */
    MetricDescriptor_ValueType[MetricDescriptor_ValueType["INT64"] = 2] = "INT64";
    /** DOUBLE - The value is a double precision floating point number. */
    MetricDescriptor_ValueType[MetricDescriptor_ValueType["DOUBLE"] = 3] = "DOUBLE";
    /**
     * STRING - The value is a text string.
     * This value type can be used only if the metric kind is `GAUGE`.
     */
    MetricDescriptor_ValueType[MetricDescriptor_ValueType["STRING"] = 4] = "STRING";
    /** DISTRIBUTION - The value is a [`Distribution`][google.api.Distribution]. */
    MetricDescriptor_ValueType[MetricDescriptor_ValueType["DISTRIBUTION"] = 5] = "DISTRIBUTION";
    /** MONEY - The value is money. */
    MetricDescriptor_ValueType[MetricDescriptor_ValueType["MONEY"] = 6] = "MONEY";
    MetricDescriptor_ValueType[MetricDescriptor_ValueType["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(MetricDescriptor_ValueType || (MetricDescriptor_ValueType = {}));
export const MetricDescriptor_ValueTypeSDKType = MetricDescriptor_ValueType;
export const MetricDescriptor_ValueTypeAmino = MetricDescriptor_ValueType;
export function metricDescriptor_ValueTypeFromJSON(object) {
    switch (object) {
        case 0:
        case "VALUE_TYPE_UNSPECIFIED":
            return MetricDescriptor_ValueType.VALUE_TYPE_UNSPECIFIED;
        case 1:
        case "BOOL":
            return MetricDescriptor_ValueType.BOOL;
        case 2:
        case "INT64":
            return MetricDescriptor_ValueType.INT64;
        case 3:
        case "DOUBLE":
            return MetricDescriptor_ValueType.DOUBLE;
        case 4:
        case "STRING":
            return MetricDescriptor_ValueType.STRING;
        case 5:
        case "DISTRIBUTION":
            return MetricDescriptor_ValueType.DISTRIBUTION;
        case 6:
        case "MONEY":
            return MetricDescriptor_ValueType.MONEY;
        case -1:
        case "UNRECOGNIZED":
        default:
            return MetricDescriptor_ValueType.UNRECOGNIZED;
    }
}
export function metricDescriptor_ValueTypeToJSON(object) {
    switch (object) {
        case MetricDescriptor_ValueType.VALUE_TYPE_UNSPECIFIED:
            return "VALUE_TYPE_UNSPECIFIED";
        case MetricDescriptor_ValueType.BOOL:
            return "BOOL";
        case MetricDescriptor_ValueType.INT64:
            return "INT64";
        case MetricDescriptor_ValueType.DOUBLE:
            return "DOUBLE";
        case MetricDescriptor_ValueType.STRING:
            return "STRING";
        case MetricDescriptor_ValueType.DISTRIBUTION:
            return "DISTRIBUTION";
        case MetricDescriptor_ValueType.MONEY:
            return "MONEY";
        case MetricDescriptor_ValueType.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
function createBaseMetricDescriptor() {
    return {
        name: "",
        type: "",
        labels: [],
        metricKind: 0,
        valueType: 0,
        unit: "",
        description: "",
        displayName: "",
        metadata: undefined,
        launchStage: 0,
        monitoredResourceTypes: []
    };
}
export const MetricDescriptor = {
    typeUrl: "/google.api.MetricDescriptor",
    is(o) {
        return o && (o.$typeUrl === MetricDescriptor.typeUrl || typeof o.name === "string" && typeof o.type === "string" && Array.isArray(o.labels) && (!o.labels.length || LabelDescriptor.is(o.labels[0])) && isSet(o.metricKind) && isSet(o.valueType) && typeof o.unit === "string" && typeof o.description === "string" && typeof o.displayName === "string" && isSet(o.launchStage) && Array.isArray(o.monitoredResourceTypes) && (!o.monitoredResourceTypes.length || typeof o.monitoredResourceTypes[0] === "string"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MetricDescriptor.typeUrl || typeof o.name === "string" && typeof o.type === "string" && Array.isArray(o.labels) && (!o.labels.length || LabelDescriptor.isSDK(o.labels[0])) && isSet(o.metric_kind) && isSet(o.value_type) && typeof o.unit === "string" && typeof o.description === "string" && typeof o.display_name === "string" && isSet(o.launch_stage) && Array.isArray(o.monitored_resource_types) && (!o.monitored_resource_types.length || typeof o.monitored_resource_types[0] === "string"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MetricDescriptor.typeUrl || typeof o.name === "string" && typeof o.type === "string" && Array.isArray(o.labels) && (!o.labels.length || LabelDescriptor.isAmino(o.labels[0])) && isSet(o.metric_kind) && isSet(o.value_type) && typeof o.unit === "string" && typeof o.description === "string" && typeof o.display_name === "string" && isSet(o.launch_stage) && Array.isArray(o.monitored_resource_types) && (!o.monitored_resource_types.length || typeof o.monitored_resource_types[0] === "string"));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.type !== undefined) {
            writer.uint32(66).string(message.type);
        }
        for (const v of message.labels) {
            LabelDescriptor.encode(v, writer.uint32(18).fork()).ldelim();
        }
        if (message.metricKind !== 0) {
            writer.uint32(24).int32(message.metricKind);
        }
        if (message.valueType !== 0) {
            writer.uint32(32).int32(message.valueType);
        }
        if (message.unit !== undefined) {
            writer.uint32(42).string(message.unit);
        }
        if (message.description !== undefined) {
            writer.uint32(50).string(message.description);
        }
        if (message.displayName !== undefined) {
            writer.uint32(58).string(message.displayName);
        }
        if (message.metadata !== undefined) {
            MetricDescriptor_MetricDescriptorMetadata.encode(message.metadata, writer.uint32(82).fork()).ldelim();
        }
        if (message.launchStage !== 0) {
            writer.uint32(96).int32(message.launchStage);
        }
        for (const v of message.monitoredResourceTypes) {
            writer.uint32(106).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMetricDescriptor();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 8:
                    message.type = reader.string();
                    break;
                case 2:
                    message.labels.push(LabelDescriptor.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.metricKind = reader.int32();
                    break;
                case 4:
                    message.valueType = reader.int32();
                    break;
                case 5:
                    message.unit = reader.string();
                    break;
                case 6:
                    message.description = reader.string();
                    break;
                case 7:
                    message.displayName = reader.string();
                    break;
                case 10:
                    message.metadata = MetricDescriptor_MetricDescriptorMetadata.decode(reader, reader.uint32());
                    break;
                case 12:
                    message.launchStage = reader.int32();
                    break;
                case 13:
                    message.monitoredResourceTypes.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMetricDescriptor();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.type))
            obj.type = String(object.type);
        if (Array.isArray(object?.labels))
            obj.labels = object.labels.map((e) => LabelDescriptor.fromJSON(e));
        if (isSet(object.metricKind))
            obj.metricKind = metricDescriptor_MetricKindFromJSON(object.metricKind);
        if (isSet(object.valueType))
            obj.valueType = metricDescriptor_ValueTypeFromJSON(object.valueType);
        if (isSet(object.unit))
            obj.unit = String(object.unit);
        if (isSet(object.description))
            obj.description = String(object.description);
        if (isSet(object.displayName))
            obj.displayName = String(object.displayName);
        if (isSet(object.metadata))
            obj.metadata = MetricDescriptor_MetricDescriptorMetadata.fromJSON(object.metadata);
        if (isSet(object.launchStage))
            obj.launchStage = launchStageFromJSON(object.launchStage);
        if (Array.isArray(object?.monitoredResourceTypes))
            obj.monitoredResourceTypes = object.monitoredResourceTypes.map((e) => String(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.type !== undefined && (obj.type = message.type);
        if (message.labels) {
            obj.labels = message.labels.map(e => e ? LabelDescriptor.toJSON(e) : undefined);
        }
        else {
            obj.labels = [];
        }
        message.metricKind !== undefined && (obj.metricKind = metricDescriptor_MetricKindToJSON(message.metricKind));
        message.valueType !== undefined && (obj.valueType = metricDescriptor_ValueTypeToJSON(message.valueType));
        message.unit !== undefined && (obj.unit = message.unit);
        message.description !== undefined && (obj.description = message.description);
        message.displayName !== undefined && (obj.displayName = message.displayName);
        message.metadata !== undefined && (obj.metadata = message.metadata ? MetricDescriptor_MetricDescriptorMetadata.toJSON(message.metadata) : undefined);
        message.launchStage !== undefined && (obj.launchStage = launchStageToJSON(message.launchStage));
        if (message.monitoredResourceTypes) {
            obj.monitoredResourceTypes = message.monitoredResourceTypes.map(e => e);
        }
        else {
            obj.monitoredResourceTypes = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMetricDescriptor();
        message.name = object.name ?? "";
        message.type = object.type ?? "";
        message.labels = object.labels?.map(e => LabelDescriptor.fromPartial(e)) || [];
        message.metricKind = object.metricKind ?? 0;
        message.valueType = object.valueType ?? 0;
        message.unit = object.unit ?? "";
        message.description = object.description ?? "";
        message.displayName = object.displayName ?? "";
        if (object.metadata !== undefined && object.metadata !== null) {
            message.metadata = MetricDescriptor_MetricDescriptorMetadata.fromPartial(object.metadata);
        }
        message.launchStage = object.launchStage ?? 0;
        message.monitoredResourceTypes = object.monitoredResourceTypes?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            type: object?.type,
            labels: Array.isArray(object?.labels) ? object.labels.map((e) => LabelDescriptor.fromSDK(e)) : [],
            metricKind: isSet(object.metric_kind) ? metricDescriptor_MetricKindFromJSON(object.metric_kind) : -1,
            valueType: isSet(object.value_type) ? metricDescriptor_ValueTypeFromJSON(object.value_type) : -1,
            unit: object?.unit,
            description: object?.description,
            displayName: object?.display_name,
            metadata: object.metadata ? MetricDescriptor_MetricDescriptorMetadata.fromSDK(object.metadata) : undefined,
            launchStage: isSet(object.launch_stage) ? launchStageFromJSON(object.launch_stage) : -1,
            monitoredResourceTypes: Array.isArray(object?.monitored_resource_types) ? object.monitored_resource_types.map((e) => e) : []
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            type: isSet(object.type) ? String(object.type) : "",
            labels: Array.isArray(object?.labels) ? object.labels.map((e) => LabelDescriptor.fromSDKJSON(e)) : [],
            metric_kind: isSet(object.metric_kind) ? metricDescriptor_MetricKindFromJSON(object.metric_kind) : -1,
            value_type: isSet(object.value_type) ? metricDescriptor_ValueTypeFromJSON(object.value_type) : -1,
            unit: isSet(object.unit) ? String(object.unit) : "",
            description: isSet(object.description) ? String(object.description) : "",
            display_name: isSet(object.display_name) ? String(object.display_name) : "",
            metadata: isSet(object.metadata) ? MetricDescriptor_MetricDescriptorMetadata.fromSDKJSON(object.metadata) : undefined,
            launch_stage: isSet(object.launch_stage) ? launchStageFromJSON(object.launch_stage) : -1,
            monitored_resource_types: Array.isArray(object?.monitored_resource_types) ? object.monitored_resource_types.map((e) => String(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.type = message.type;
        if (message.labels) {
            obj.labels = message.labels.map(e => e ? LabelDescriptor.toSDK(e) : undefined);
        }
        else {
            obj.labels = [];
        }
        message.metricKind !== undefined && (obj.metric_kind = metricDescriptor_MetricKindToJSON(message.metricKind));
        message.valueType !== undefined && (obj.value_type = metricDescriptor_ValueTypeToJSON(message.valueType));
        obj.unit = message.unit;
        obj.description = message.description;
        obj.display_name = message.displayName;
        message.metadata !== undefined && (obj.metadata = message.metadata ? MetricDescriptor_MetricDescriptorMetadata.toSDK(message.metadata) : undefined);
        message.launchStage !== undefined && (obj.launch_stage = launchStageToJSON(message.launchStage));
        if (message.monitoredResourceTypes) {
            obj.monitored_resource_types = message.monitoredResourceTypes.map(e => e);
        }
        else {
            obj.monitored_resource_types = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMetricDescriptor();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.type !== undefined && object.type !== null) {
            message.type = object.type;
        }
        message.labels = object.labels?.map(e => LabelDescriptor.fromAmino(e)) || [];
        if (object.metric_kind !== undefined && object.metric_kind !== null) {
            message.metricKind = object.metric_kind;
        }
        if (object.value_type !== undefined && object.value_type !== null) {
            message.valueType = object.value_type;
        }
        if (object.unit !== undefined && object.unit !== null) {
            message.unit = object.unit;
        }
        if (object.description !== undefined && object.description !== null) {
            message.description = object.description;
        }
        if (object.display_name !== undefined && object.display_name !== null) {
            message.displayName = object.display_name;
        }
        if (object.metadata !== undefined && object.metadata !== null) {
            message.metadata = MetricDescriptor_MetricDescriptorMetadata.fromAmino(object.metadata);
        }
        if (object.launch_stage !== undefined && object.launch_stage !== null) {
            message.launchStage = object.launch_stage;
        }
        message.monitoredResourceTypes = object.monitored_resource_types?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.type = message.type === "" ? undefined : message.type;
        if (message.labels) {
            obj.labels = message.labels.map(e => e ? LabelDescriptor.toAmino(e) : undefined);
        }
        else {
            obj.labels = message.labels;
        }
        obj.metric_kind = message.metricKind === 0 ? undefined : message.metricKind;
        obj.value_type = message.valueType === 0 ? undefined : message.valueType;
        obj.unit = message.unit === "" ? undefined : message.unit;
        obj.description = message.description === "" ? undefined : message.description;
        obj.display_name = message.displayName === "" ? undefined : message.displayName;
        obj.metadata = message.metadata ? MetricDescriptor_MetricDescriptorMetadata.toAmino(message.metadata) : undefined;
        obj.launch_stage = message.launchStage === 0 ? undefined : message.launchStage;
        if (message.monitoredResourceTypes) {
            obj.monitored_resource_types = message.monitoredResourceTypes.map(e => e);
        }
        else {
            obj.monitored_resource_types = message.monitoredResourceTypes;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return MetricDescriptor.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MetricDescriptor.decode(message.value);
    },
    toProto(message) {
        return MetricDescriptor.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.MetricDescriptor",
            value: MetricDescriptor.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LabelDescriptor.registerTypeUrl();
        MetricDescriptor_MetricDescriptorMetadata.registerTypeUrl();
    }
};
function createBaseMetricDescriptor_MetricDescriptorMetadata() {
    return {
        launchStage: 0,
        samplePeriod: undefined,
        ingestDelay: undefined
    };
}
export const MetricDescriptor_MetricDescriptorMetadata = {
    typeUrl: "/google.api.MetricDescriptorMetadata",
    is(o) {
        return o && (o.$typeUrl === MetricDescriptor_MetricDescriptorMetadata.typeUrl || isSet(o.launchStage));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MetricDescriptor_MetricDescriptorMetadata.typeUrl || isSet(o.launch_stage));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MetricDescriptor_MetricDescriptorMetadata.typeUrl || isSet(o.launch_stage));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.launchStage !== 0) {
            writer.uint32(8).int32(message.launchStage);
        }
        if (message.samplePeriod !== undefined) {
            Duration.encode(message.samplePeriod, writer.uint32(18).fork()).ldelim();
        }
        if (message.ingestDelay !== undefined) {
            Duration.encode(message.ingestDelay, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMetricDescriptor_MetricDescriptorMetadata();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.launchStage = reader.int32();
                    break;
                case 2:
                    message.samplePeriod = Duration.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.ingestDelay = Duration.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMetricDescriptor_MetricDescriptorMetadata();
        if (isSet(object.launchStage))
            obj.launchStage = launchStageFromJSON(object.launchStage);
        if (isSet(object.samplePeriod))
            obj.samplePeriod = Duration.fromJSON(object.samplePeriod);
        if (isSet(object.ingestDelay))
            obj.ingestDelay = Duration.fromJSON(object.ingestDelay);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.launchStage !== undefined && (obj.launchStage = launchStageToJSON(message.launchStage));
        message.samplePeriod !== undefined && (obj.samplePeriod = message.samplePeriod ? Duration.toJSON(message.samplePeriod) : undefined);
        message.ingestDelay !== undefined && (obj.ingestDelay = message.ingestDelay ? Duration.toJSON(message.ingestDelay) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMetricDescriptor_MetricDescriptorMetadata();
        message.launchStage = object.launchStage ?? 0;
        if (object.samplePeriod !== undefined && object.samplePeriod !== null) {
            message.samplePeriod = Duration.fromPartial(object.samplePeriod);
        }
        if (object.ingestDelay !== undefined && object.ingestDelay !== null) {
            message.ingestDelay = Duration.fromPartial(object.ingestDelay);
        }
        return message;
    },
    fromSDK(object) {
        return {
            launchStage: isSet(object.launch_stage) ? launchStageFromJSON(object.launch_stage) : -1,
            samplePeriod: object.sample_period ? Duration.fromSDK(object.sample_period) : undefined,
            ingestDelay: object.ingest_delay ? Duration.fromSDK(object.ingest_delay) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            launch_stage: isSet(object.launch_stage) ? launchStageFromJSON(object.launch_stage) : -1,
            sample_period: isSet(object.sample_period) ? Duration.fromSDKJSON(object.sample_period) : undefined,
            ingest_delay: isSet(object.ingest_delay) ? Duration.fromSDKJSON(object.ingest_delay) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.launchStage !== undefined && (obj.launch_stage = launchStageToJSON(message.launchStage));
        message.samplePeriod !== undefined && (obj.sample_period = message.samplePeriod ? Duration.toSDK(message.samplePeriod) : undefined);
        message.ingestDelay !== undefined && (obj.ingest_delay = message.ingestDelay ? Duration.toSDK(message.ingestDelay) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMetricDescriptor_MetricDescriptorMetadata();
        if (object.launch_stage !== undefined && object.launch_stage !== null) {
            message.launchStage = object.launch_stage;
        }
        if (object.sample_period !== undefined && object.sample_period !== null) {
            message.samplePeriod = Duration.fromAmino(object.sample_period);
        }
        if (object.ingest_delay !== undefined && object.ingest_delay !== null) {
            message.ingestDelay = Duration.fromAmino(object.ingest_delay);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.launch_stage = message.launchStage === 0 ? undefined : message.launchStage;
        obj.sample_period = message.samplePeriod ? Duration.toAmino(message.samplePeriod) : undefined;
        obj.ingest_delay = message.ingestDelay ? Duration.toAmino(message.ingestDelay) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return MetricDescriptor_MetricDescriptorMetadata.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MetricDescriptor_MetricDescriptorMetadata.decode(message.value);
    },
    toProto(message) {
        return MetricDescriptor_MetricDescriptorMetadata.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.MetricDescriptorMetadata",
            value: MetricDescriptor_MetricDescriptorMetadata.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMetric_LabelsEntry() {
    return {
        key: "",
        value: ""
    };
}
export const Metric_LabelsEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(18).string(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMetric_LabelsEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMetric_LabelsEntry();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = String(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = message.value);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMetric_LabelsEntry();
        message.key = object.key ?? "";
        message.value = object.value ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? String(object.value) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMetric_LabelsEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value === "" ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return Metric_LabelsEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Metric_LabelsEntry.decode(message.value);
    },
    toProto(message) {
        return Metric_LabelsEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseMetric() {
    return {
        type: "",
        labels: {}
    };
}
export const Metric = {
    typeUrl: "/google.api.Metric",
    is(o) {
        return o && (o.$typeUrl === Metric.typeUrl || typeof o.type === "string" && isSet(o.labels));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Metric.typeUrl || typeof o.type === "string" && isSet(o.labels));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Metric.typeUrl || typeof o.type === "string" && isSet(o.labels));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.type !== undefined) {
            writer.uint32(26).string(message.type);
        }
        Object.entries(message.labels).forEach(([key, value]) => {
            Metric_LabelsEntry.encode({
                key: key,
                value
            }, writer.uint32(18).fork()).ldelim();
        });
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMetric();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 3:
                    message.type = reader.string();
                    break;
                case 2:
                    const entry2 = Metric_LabelsEntry.decode(reader, reader.uint32());
                    if (entry2.value !== undefined) {
                        message.labels[entry2.key] = entry2.value;
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMetric();
        if (isSet(object.type))
            obj.type = String(object.type);
        if (isObject(object.labels))
            obj.labels = Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {});
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.type !== undefined && (obj.type = message.type);
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMetric();
        message.type = object.type ?? "";
        message.labels = Object.entries(object.labels ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        return message;
    },
    fromSDK(object) {
        return {
            type: object?.type,
            labels: isObject(object.labels) ? Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {}
        };
    },
    fromSDKJSON(object) {
        return {
            type: isSet(object.type) ? String(object.type) : "",
            labels: isObject(object.labels) ? Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {}
        };
    },
    toSDK(message) {
        const obj = {};
        obj.type = message.type;
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMetric();
        if (object.type !== undefined && object.type !== null) {
            message.type = object.type;
        }
        message.labels = Object.entries(object.labels ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.type = message.type === "" ? undefined : message.type;
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Metric.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Metric.decode(message.value);
    },
    toProto(message) {
        return Metric.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Metric",
            value: Metric.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
