import { LabelDescriptor } from "./label";
import { launchStageFromJSON, launchStageToJSON } from "./launch_stage";
import { Struct } from "../protobuf/struct";
import { isSet, isObject } from "../../helpers";
import { BinaryReader, BinaryWriter } from "../../binary";
export const protobufPackage = "google.api";
function createBaseMonitoredResourceDescriptor() {
    return {
        name: "",
        type: "",
        displayName: "",
        description: "",
        labels: [],
        launchStage: 0
    };
}
export const MonitoredResourceDescriptor = {
    typeUrl: "/google.api.MonitoredResourceDescriptor",
    is(o) {
        return o && (o.$typeUrl === MonitoredResourceDescriptor.typeUrl || typeof o.name === "string" && typeof o.type === "string" && typeof o.displayName === "string" && typeof o.description === "string" && Array.isArray(o.labels) && (!o.labels.length || LabelDescriptor.is(o.labels[0])) && isSet(o.launchStage));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MonitoredResourceDescriptor.typeUrl || typeof o.name === "string" && typeof o.type === "string" && typeof o.display_name === "string" && typeof o.description === "string" && Array.isArray(o.labels) && (!o.labels.length || LabelDescriptor.isSDK(o.labels[0])) && isSet(o.launch_stage));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MonitoredResourceDescriptor.typeUrl || typeof o.name === "string" && typeof o.type === "string" && typeof o.display_name === "string" && typeof o.description === "string" && Array.isArray(o.labels) && (!o.labels.length || LabelDescriptor.isAmino(o.labels[0])) && isSet(o.launch_stage));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(42).string(message.name);
        }
        if (message.type !== undefined) {
            writer.uint32(10).string(message.type);
        }
        if (message.displayName !== undefined) {
            writer.uint32(18).string(message.displayName);
        }
        if (message.description !== undefined) {
            writer.uint32(26).string(message.description);
        }
        for (const v of message.labels) {
            LabelDescriptor.encode(v, writer.uint32(34).fork()).ldelim();
        }
        if (message.launchStage !== 0) {
            writer.uint32(56).int32(message.launchStage);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMonitoredResourceDescriptor();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 5:
                    message.name = reader.string();
                    break;
                case 1:
                    message.type = reader.string();
                    break;
                case 2:
                    message.displayName = reader.string();
                    break;
                case 3:
                    message.description = reader.string();
                    break;
                case 4:
                    message.labels.push(LabelDescriptor.decode(reader, reader.uint32()));
                    break;
                case 7:
                    message.launchStage = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMonitoredResourceDescriptor();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.type))
            obj.type = String(object.type);
        if (isSet(object.displayName))
            obj.displayName = String(object.displayName);
        if (isSet(object.description))
            obj.description = String(object.description);
        if (Array.isArray(object?.labels))
            obj.labels = object.labels.map((e) => LabelDescriptor.fromJSON(e));
        if (isSet(object.launchStage))
            obj.launchStage = launchStageFromJSON(object.launchStage);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.type !== undefined && (obj.type = message.type);
        message.displayName !== undefined && (obj.displayName = message.displayName);
        message.description !== undefined && (obj.description = message.description);
        if (message.labels) {
            obj.labels = message.labels.map(e => e ? LabelDescriptor.toJSON(e) : undefined);
        }
        else {
            obj.labels = [];
        }
        message.launchStage !== undefined && (obj.launchStage = launchStageToJSON(message.launchStage));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMonitoredResourceDescriptor();
        message.name = object.name ?? "";
        message.type = object.type ?? "";
        message.displayName = object.displayName ?? "";
        message.description = object.description ?? "";
        message.labels = object.labels?.map(e => LabelDescriptor.fromPartial(e)) || [];
        message.launchStage = object.launchStage ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            type: object?.type,
            displayName: object?.display_name,
            description: object?.description,
            labels: Array.isArray(object?.labels) ? object.labels.map((e) => LabelDescriptor.fromSDK(e)) : [],
            launchStage: isSet(object.launch_stage) ? launchStageFromJSON(object.launch_stage) : -1
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            type: isSet(object.type) ? String(object.type) : "",
            display_name: isSet(object.display_name) ? String(object.display_name) : "",
            description: isSet(object.description) ? String(object.description) : "",
            labels: Array.isArray(object?.labels) ? object.labels.map((e) => LabelDescriptor.fromSDKJSON(e)) : [],
            launch_stage: isSet(object.launch_stage) ? launchStageFromJSON(object.launch_stage) : -1
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.type = message.type;
        obj.display_name = message.displayName;
        obj.description = message.description;
        if (message.labels) {
            obj.labels = message.labels.map(e => e ? LabelDescriptor.toSDK(e) : undefined);
        }
        else {
            obj.labels = [];
        }
        message.launchStage !== undefined && (obj.launch_stage = launchStageToJSON(message.launchStage));
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMonitoredResourceDescriptor();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.type !== undefined && object.type !== null) {
            message.type = object.type;
        }
        if (object.display_name !== undefined && object.display_name !== null) {
            message.displayName = object.display_name;
        }
        if (object.description !== undefined && object.description !== null) {
            message.description = object.description;
        }
        message.labels = object.labels?.map(e => LabelDescriptor.fromAmino(e)) || [];
        if (object.launch_stage !== undefined && object.launch_stage !== null) {
            message.launchStage = object.launch_stage;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.type = message.type === "" ? undefined : message.type;
        obj.display_name = message.displayName === "" ? undefined : message.displayName;
        obj.description = message.description === "" ? undefined : message.description;
        if (message.labels) {
            obj.labels = message.labels.map(e => e ? LabelDescriptor.toAmino(e) : undefined);
        }
        else {
            obj.labels = message.labels;
        }
        obj.launch_stage = message.launchStage === 0 ? undefined : message.launchStage;
        return obj;
    },
    fromAminoMsg(object) {
        return MonitoredResourceDescriptor.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MonitoredResourceDescriptor.decode(message.value);
    },
    toProto(message) {
        return MonitoredResourceDescriptor.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.MonitoredResourceDescriptor",
            value: MonitoredResourceDescriptor.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LabelDescriptor.registerTypeUrl();
    }
};
function createBaseMonitoredResource_LabelsEntry() {
    return {
        key: "",
        value: ""
    };
}
export const MonitoredResource_LabelsEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(18).string(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMonitoredResource_LabelsEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMonitoredResource_LabelsEntry();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = String(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = message.value);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMonitoredResource_LabelsEntry();
        message.key = object.key ?? "";
        message.value = object.value ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? String(object.value) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMonitoredResource_LabelsEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value === "" ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return MonitoredResource_LabelsEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MonitoredResource_LabelsEntry.decode(message.value);
    },
    toProto(message) {
        return MonitoredResource_LabelsEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseMonitoredResource() {
    return {
        type: "",
        labels: {}
    };
}
export const MonitoredResource = {
    typeUrl: "/google.api.MonitoredResource",
    is(o) {
        return o && (o.$typeUrl === MonitoredResource.typeUrl || typeof o.type === "string" && isSet(o.labels));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MonitoredResource.typeUrl || typeof o.type === "string" && isSet(o.labels));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MonitoredResource.typeUrl || typeof o.type === "string" && isSet(o.labels));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.type !== undefined) {
            writer.uint32(10).string(message.type);
        }
        Object.entries(message.labels).forEach(([key, value]) => {
            MonitoredResource_LabelsEntry.encode({
                key: key,
                value
            }, writer.uint32(18).fork()).ldelim();
        });
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMonitoredResource();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.type = reader.string();
                    break;
                case 2:
                    const entry2 = MonitoredResource_LabelsEntry.decode(reader, reader.uint32());
                    if (entry2.value !== undefined) {
                        message.labels[entry2.key] = entry2.value;
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMonitoredResource();
        if (isSet(object.type))
            obj.type = String(object.type);
        if (isObject(object.labels))
            obj.labels = Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {});
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.type !== undefined && (obj.type = message.type);
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMonitoredResource();
        message.type = object.type ?? "";
        message.labels = Object.entries(object.labels ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        return message;
    },
    fromSDK(object) {
        return {
            type: object?.type,
            labels: isObject(object.labels) ? Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {}
        };
    },
    fromSDKJSON(object) {
        return {
            type: isSet(object.type) ? String(object.type) : "",
            labels: isObject(object.labels) ? Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {}
        };
    },
    toSDK(message) {
        const obj = {};
        obj.type = message.type;
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMonitoredResource();
        if (object.type !== undefined && object.type !== null) {
            message.type = object.type;
        }
        message.labels = Object.entries(object.labels ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.type = message.type === "" ? undefined : message.type;
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        return obj;
    },
    fromAminoMsg(object) {
        return MonitoredResource.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MonitoredResource.decode(message.value);
    },
    toProto(message) {
        return MonitoredResource.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.MonitoredResource",
            value: MonitoredResource.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMonitoredResourceMetadata_UserLabelsEntry() {
    return {
        key: "",
        value: ""
    };
}
export const MonitoredResourceMetadata_UserLabelsEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(18).string(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMonitoredResourceMetadata_UserLabelsEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMonitoredResourceMetadata_UserLabelsEntry();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = String(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = message.value);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMonitoredResourceMetadata_UserLabelsEntry();
        message.key = object.key ?? "";
        message.value = object.value ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? String(object.value) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMonitoredResourceMetadata_UserLabelsEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value === "" ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return MonitoredResourceMetadata_UserLabelsEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MonitoredResourceMetadata_UserLabelsEntry.decode(message.value);
    },
    toProto(message) {
        return MonitoredResourceMetadata_UserLabelsEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseMonitoredResourceMetadata() {
    return {
        systemLabels: undefined,
        userLabels: {}
    };
}
export const MonitoredResourceMetadata = {
    typeUrl: "/google.api.MonitoredResourceMetadata",
    is(o) {
        return o && (o.$typeUrl === MonitoredResourceMetadata.typeUrl || isSet(o.userLabels));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MonitoredResourceMetadata.typeUrl || isSet(o.user_labels));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MonitoredResourceMetadata.typeUrl || isSet(o.user_labels));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.systemLabels !== undefined) {
            Struct.encode(message.systemLabels, writer.uint32(10).fork()).ldelim();
        }
        Object.entries(message.userLabels).forEach(([key, value]) => {
            MonitoredResourceMetadata_UserLabelsEntry.encode({
                key: key,
                value
            }, writer.uint32(18).fork()).ldelim();
        });
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMonitoredResourceMetadata();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.systemLabels = Struct.decode(reader, reader.uint32());
                    break;
                case 2:
                    const entry2 = MonitoredResourceMetadata_UserLabelsEntry.decode(reader, reader.uint32());
                    if (entry2.value !== undefined) {
                        message.userLabels[entry2.key] = entry2.value;
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMonitoredResourceMetadata();
        if (isSet(object.systemLabels))
            obj.systemLabels = Struct.fromJSON(object.systemLabels);
        if (isObject(object.userLabels))
            obj.userLabels = Object.entries(object.userLabels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {});
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.systemLabels !== undefined && (obj.systemLabels = message.systemLabels ? Struct.toJSON(message.systemLabels) : undefined);
        obj.userLabels = {};
        if (message.userLabels) {
            Object.entries(message.userLabels).forEach(([k, v]) => {
                obj.userLabels[k] = v;
            });
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMonitoredResourceMetadata();
        if (object.systemLabels !== undefined && object.systemLabels !== null) {
            message.systemLabels = Struct.fromPartial(object.systemLabels);
        }
        message.userLabels = Object.entries(object.userLabels ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        return message;
    },
    fromSDK(object) {
        return {
            systemLabels: object.system_labels ? Struct.fromSDK(object.system_labels) : undefined,
            userLabels: isObject(object.user_labels) ? Object.entries(object.user_labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {}
        };
    },
    fromSDKJSON(object) {
        return {
            system_labels: isSet(object.system_labels) ? Struct.fromSDKJSON(object.system_labels) : undefined,
            user_labels: isObject(object.user_labels) ? Object.entries(object.user_labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {}
        };
    },
    toSDK(message) {
        const obj = {};
        message.systemLabels !== undefined && (obj.system_labels = message.systemLabels ? Struct.toSDK(message.systemLabels) : undefined);
        obj.user_labels = {};
        if (message.userLabels) {
            Object.entries(message.userLabels).forEach(([k, v]) => {
                obj.user_labels[k] = v;
            });
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMonitoredResourceMetadata();
        if (object.system_labels !== undefined && object.system_labels !== null) {
            message.systemLabels = Struct.fromAmino(object.system_labels);
        }
        message.userLabels = Object.entries(object.user_labels ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.system_labels = message.systemLabels ? Struct.toAmino(message.systemLabels) : undefined;
        obj.user_labels = {};
        if (message.userLabels) {
            Object.entries(message.userLabels).forEach(([k, v]) => {
                obj.user_labels[k] = v;
            });
        }
        return obj;
    },
    fromAminoMsg(object) {
        return MonitoredResourceMetadata.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MonitoredResourceMetadata.decode(message.value);
    },
    toProto(message) {
        return MonitoredResourceMetadata.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.MonitoredResourceMetadata",
            value: MonitoredResourceMetadata.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Struct.registerTypeUrl();
    }
};
