import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseMonitoring() {
    return {
        producerDestinations: [],
        consumerDestinations: []
    };
}
export const Monitoring = {
    typeUrl: "/google.api.Monitoring",
    is(o) {
        return o && (o.$typeUrl === Monitoring.typeUrl || Array.isArray(o.producerDestinations) && (!o.producerDestinations.length || Monitoring_MonitoringDestination.is(o.producerDestinations[0])) && Array.isArray(o.consumerDestinations) && (!o.consumerDestinations.length || Monitoring_MonitoringDestination.is(o.consumerDestinations[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Monitoring.typeUrl || Array.isArray(o.producer_destinations) && (!o.producer_destinations.length || Monitoring_MonitoringDestination.isSDK(o.producer_destinations[0])) && Array.isArray(o.consumer_destinations) && (!o.consumer_destinations.length || Monitoring_MonitoringDestination.isSDK(o.consumer_destinations[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Monitoring.typeUrl || Array.isArray(o.producer_destinations) && (!o.producer_destinations.length || Monitoring_MonitoringDestination.isAmino(o.producer_destinations[0])) && Array.isArray(o.consumer_destinations) && (!o.consumer_destinations.length || Monitoring_MonitoringDestination.isAmino(o.consumer_destinations[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.producerDestinations) {
            Monitoring_MonitoringDestination.encode(v, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.consumerDestinations) {
            Monitoring_MonitoringDestination.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMonitoring();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.producerDestinations.push(Monitoring_MonitoringDestination.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.consumerDestinations.push(Monitoring_MonitoringDestination.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMonitoring();
        if (Array.isArray(object?.producerDestinations))
            obj.producerDestinations = object.producerDestinations.map((e) => Monitoring_MonitoringDestination.fromJSON(e));
        if (Array.isArray(object?.consumerDestinations))
            obj.consumerDestinations = object.consumerDestinations.map((e) => Monitoring_MonitoringDestination.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.producerDestinations) {
            obj.producerDestinations = message.producerDestinations.map(e => e ? Monitoring_MonitoringDestination.toJSON(e) : undefined);
        }
        else {
            obj.producerDestinations = [];
        }
        if (message.consumerDestinations) {
            obj.consumerDestinations = message.consumerDestinations.map(e => e ? Monitoring_MonitoringDestination.toJSON(e) : undefined);
        }
        else {
            obj.consumerDestinations = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMonitoring();
        message.producerDestinations = object.producerDestinations?.map(e => Monitoring_MonitoringDestination.fromPartial(e)) || [];
        message.consumerDestinations = object.consumerDestinations?.map(e => Monitoring_MonitoringDestination.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            producerDestinations: Array.isArray(object?.producer_destinations) ? object.producer_destinations.map((e) => Monitoring_MonitoringDestination.fromSDK(e)) : [],
            consumerDestinations: Array.isArray(object?.consumer_destinations) ? object.consumer_destinations.map((e) => Monitoring_MonitoringDestination.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            producer_destinations: Array.isArray(object?.producer_destinations) ? object.producer_destinations.map((e) => Monitoring_MonitoringDestination.fromSDKJSON(e)) : [],
            consumer_destinations: Array.isArray(object?.consumer_destinations) ? object.consumer_destinations.map((e) => Monitoring_MonitoringDestination.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.producerDestinations) {
            obj.producer_destinations = message.producerDestinations.map(e => e ? Monitoring_MonitoringDestination.toSDK(e) : undefined);
        }
        else {
            obj.producer_destinations = [];
        }
        if (message.consumerDestinations) {
            obj.consumer_destinations = message.consumerDestinations.map(e => e ? Monitoring_MonitoringDestination.toSDK(e) : undefined);
        }
        else {
            obj.consumer_destinations = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMonitoring();
        message.producerDestinations = object.producer_destinations?.map(e => Monitoring_MonitoringDestination.fromAmino(e)) || [];
        message.consumerDestinations = object.consumer_destinations?.map(e => Monitoring_MonitoringDestination.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.producerDestinations) {
            obj.producer_destinations = message.producerDestinations.map(e => e ? Monitoring_MonitoringDestination.toAmino(e) : undefined);
        }
        else {
            obj.producer_destinations = message.producerDestinations;
        }
        if (message.consumerDestinations) {
            obj.consumer_destinations = message.consumerDestinations.map(e => e ? Monitoring_MonitoringDestination.toAmino(e) : undefined);
        }
        else {
            obj.consumer_destinations = message.consumerDestinations;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Monitoring.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Monitoring.decode(message.value);
    },
    toProto(message) {
        return Monitoring.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Monitoring",
            value: Monitoring.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Monitoring_MonitoringDestination.registerTypeUrl();
    }
};
function createBaseMonitoring_MonitoringDestination() {
    return {
        monitoredResource: "",
        metrics: []
    };
}
export const Monitoring_MonitoringDestination = {
    typeUrl: "/google.api.MonitoringDestination",
    is(o) {
        return o && (o.$typeUrl === Monitoring_MonitoringDestination.typeUrl || typeof o.monitoredResource === "string" && Array.isArray(o.metrics) && (!o.metrics.length || typeof o.metrics[0] === "string"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Monitoring_MonitoringDestination.typeUrl || typeof o.monitored_resource === "string" && Array.isArray(o.metrics) && (!o.metrics.length || typeof o.metrics[0] === "string"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Monitoring_MonitoringDestination.typeUrl || typeof o.monitored_resource === "string" && Array.isArray(o.metrics) && (!o.metrics.length || typeof o.metrics[0] === "string"));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.monitoredResource !== undefined) {
            writer.uint32(10).string(message.monitoredResource);
        }
        for (const v of message.metrics) {
            writer.uint32(18).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMonitoring_MonitoringDestination();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.monitoredResource = reader.string();
                    break;
                case 2:
                    message.metrics.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMonitoring_MonitoringDestination();
        if (isSet(object.monitoredResource))
            obj.monitoredResource = String(object.monitoredResource);
        if (Array.isArray(object?.metrics))
            obj.metrics = object.metrics.map((e) => String(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.monitoredResource !== undefined && (obj.monitoredResource = message.monitoredResource);
        if (message.metrics) {
            obj.metrics = message.metrics.map(e => e);
        }
        else {
            obj.metrics = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMonitoring_MonitoringDestination();
        message.monitoredResource = object.monitoredResource ?? "";
        message.metrics = object.metrics?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            monitoredResource: object?.monitored_resource,
            metrics: Array.isArray(object?.metrics) ? object.metrics.map((e) => e) : []
        };
    },
    fromSDKJSON(object) {
        return {
            monitored_resource: isSet(object.monitored_resource) ? String(object.monitored_resource) : "",
            metrics: Array.isArray(object?.metrics) ? object.metrics.map((e) => String(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.monitored_resource = message.monitoredResource;
        if (message.metrics) {
            obj.metrics = message.metrics.map(e => e);
        }
        else {
            obj.metrics = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMonitoring_MonitoringDestination();
        if (object.monitored_resource !== undefined && object.monitored_resource !== null) {
            message.monitoredResource = object.monitored_resource;
        }
        message.metrics = object.metrics?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.monitored_resource = message.monitoredResource === "" ? undefined : message.monitoredResource;
        if (message.metrics) {
            obj.metrics = message.metrics.map(e => e);
        }
        else {
            obj.metrics = message.metrics;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Monitoring_MonitoringDestination.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Monitoring_MonitoringDestination.decode(message.value);
    },
    toProto(message) {
        return Monitoring_MonitoringDestination.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.MonitoringDestination",
            value: Monitoring_MonitoringDestination.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
