import { Timestamp } from "../../../protobuf/timestamp";
import { logSeverityFromJSON, logSeverityToJSON } from "../../../logging/type/log_severity";
import { HttpRequest } from "./http_request";
import { Any } from "../../../protobuf/any";
import { Struct } from "../../../protobuf/struct";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { isSet, toTimestamp, fromTimestamp, isObject } from "../../../../helpers";
export const protobufPackage = "google.api.servicecontrol.v1";
function createBaseLogEntry_LabelsEntry() {
    return {
        key: "",
        value: ""
    };
}
export const LogEntry_LabelsEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(18).string(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLogEntry_LabelsEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLogEntry_LabelsEntry();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = String(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = message.value);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLogEntry_LabelsEntry();
        message.key = object.key ?? "";
        message.value = object.value ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? String(object.value) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLogEntry_LabelsEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value === "" ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return LogEntry_LabelsEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return LogEntry_LabelsEntry.decode(message.value);
    },
    toProto(message) {
        return LogEntry_LabelsEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseLogEntry() {
    return {
        name: "",
        timestamp: undefined,
        severity: 0,
        httpRequest: undefined,
        trace: "",
        insertId: "",
        labels: {},
        protoPayload: undefined,
        textPayload: undefined,
        structPayload: undefined,
        operation: undefined,
        sourceLocation: undefined
    };
}
export const LogEntry = {
    typeUrl: "/google.api.servicecontrol.v1.LogEntry",
    is(o) {
        return o && (o.$typeUrl === LogEntry.typeUrl || typeof o.name === "string" && isSet(o.severity) && typeof o.trace === "string" && typeof o.insertId === "string" && isSet(o.labels));
    },
    isSDK(o) {
        return o && (o.$typeUrl === LogEntry.typeUrl || typeof o.name === "string" && isSet(o.severity) && typeof o.trace === "string" && typeof o.insert_id === "string" && isSet(o.labels));
    },
    isAmino(o) {
        return o && (o.$typeUrl === LogEntry.typeUrl || typeof o.name === "string" && isSet(o.severity) && typeof o.trace === "string" && typeof o.insert_id === "string" && isSet(o.labels));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(82).string(message.name);
        }
        if (message.timestamp !== undefined) {
            Timestamp.encode(toTimestamp(message.timestamp), writer.uint32(90).fork()).ldelim();
        }
        if (message.severity !== 0) {
            writer.uint32(96).int32(message.severity);
        }
        if (message.httpRequest !== undefined) {
            HttpRequest.encode(message.httpRequest, writer.uint32(114).fork()).ldelim();
        }
        if (message.trace !== undefined) {
            writer.uint32(122).string(message.trace);
        }
        if (message.insertId !== undefined) {
            writer.uint32(34).string(message.insertId);
        }
        Object.entries(message.labels).forEach(([key, value]) => {
            LogEntry_LabelsEntry.encode({
                key: key,
                value
            }, writer.uint32(106).fork()).ldelim();
        });
        if (message.protoPayload !== undefined) {
            Any.encode(message.protoPayload, writer.uint32(18).fork()).ldelim();
        }
        if (message.textPayload !== undefined) {
            writer.uint32(26).string(message.textPayload);
        }
        if (message.structPayload !== undefined) {
            Struct.encode(message.structPayload, writer.uint32(50).fork()).ldelim();
        }
        if (message.operation !== undefined) {
            LogEntryOperation.encode(message.operation, writer.uint32(130).fork()).ldelim();
        }
        if (message.sourceLocation !== undefined) {
            LogEntrySourceLocation.encode(message.sourceLocation, writer.uint32(138).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLogEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 10:
                    message.name = reader.string();
                    break;
                case 11:
                    message.timestamp = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 12:
                    message.severity = reader.int32();
                    break;
                case 14:
                    message.httpRequest = HttpRequest.decode(reader, reader.uint32());
                    break;
                case 15:
                    message.trace = reader.string();
                    break;
                case 4:
                    message.insertId = reader.string();
                    break;
                case 13:
                    const entry13 = LogEntry_LabelsEntry.decode(reader, reader.uint32());
                    if (entry13.value !== undefined) {
                        message.labels[entry13.key] = entry13.value;
                    }
                    break;
                case 2:
                    message.protoPayload = Any.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.textPayload = reader.string();
                    break;
                case 6:
                    message.structPayload = Struct.decode(reader, reader.uint32());
                    break;
                case 16:
                    message.operation = LogEntryOperation.decode(reader, reader.uint32());
                    break;
                case 17:
                    message.sourceLocation = LogEntrySourceLocation.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLogEntry();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.timestamp))
            obj.timestamp = new Date(object.timestamp);
        if (isSet(object.severity))
            obj.severity = logSeverityFromJSON(object.severity);
        if (isSet(object.httpRequest))
            obj.httpRequest = HttpRequest.fromJSON(object.httpRequest);
        if (isSet(object.trace))
            obj.trace = String(object.trace);
        if (isSet(object.insertId))
            obj.insertId = String(object.insertId);
        if (isObject(object.labels))
            obj.labels = Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {});
        if (isSet(object.protoPayload))
            obj.protoPayload = Any.fromJSON(object.protoPayload);
        if (isSet(object.textPayload))
            obj.textPayload = String(object.textPayload);
        if (isSet(object.structPayload))
            obj.structPayload = Struct.fromJSON(object.structPayload);
        if (isSet(object.operation))
            obj.operation = LogEntryOperation.fromJSON(object.operation);
        if (isSet(object.sourceLocation))
            obj.sourceLocation = LogEntrySourceLocation.fromJSON(object.sourceLocation);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.timestamp !== undefined && (obj.timestamp = message.timestamp.toISOString());
        message.severity !== undefined && (obj.severity = logSeverityToJSON(message.severity));
        message.httpRequest !== undefined && (obj.httpRequest = message.httpRequest ? HttpRequest.toJSON(message.httpRequest) : undefined);
        message.trace !== undefined && (obj.trace = message.trace);
        message.insertId !== undefined && (obj.insertId = message.insertId);
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        message.protoPayload !== undefined && (obj.protoPayload = message.protoPayload ? Any.toJSON(message.protoPayload) : undefined);
        message.textPayload !== undefined && (obj.textPayload = message.textPayload);
        message.structPayload !== undefined && (obj.structPayload = message.structPayload ? Struct.toJSON(message.structPayload) : undefined);
        message.operation !== undefined && (obj.operation = message.operation ? LogEntryOperation.toJSON(message.operation) : undefined);
        message.sourceLocation !== undefined && (obj.sourceLocation = message.sourceLocation ? LogEntrySourceLocation.toJSON(message.sourceLocation) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLogEntry();
        message.name = object.name ?? "";
        message.timestamp = object.timestamp ?? undefined;
        message.severity = object.severity ?? 0;
        if (object.httpRequest !== undefined && object.httpRequest !== null) {
            message.httpRequest = HttpRequest.fromPartial(object.httpRequest);
        }
        message.trace = object.trace ?? "";
        message.insertId = object.insertId ?? "";
        message.labels = Object.entries(object.labels ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        if (object.protoPayload !== undefined && object.protoPayload !== null) {
            message.protoPayload = Any.fromPartial(object.protoPayload);
        }
        message.textPayload = object.textPayload ?? undefined;
        if (object.structPayload !== undefined && object.structPayload !== null) {
            message.structPayload = Struct.fromPartial(object.structPayload);
        }
        if (object.operation !== undefined && object.operation !== null) {
            message.operation = LogEntryOperation.fromPartial(object.operation);
        }
        if (object.sourceLocation !== undefined && object.sourceLocation !== null) {
            message.sourceLocation = LogEntrySourceLocation.fromPartial(object.sourceLocation);
        }
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            timestamp: object.timestamp ?? undefined,
            severity: isSet(object.severity) ? logSeverityFromJSON(object.severity) : -1,
            httpRequest: object.http_request ? HttpRequest.fromSDK(object.http_request) : undefined,
            trace: object?.trace,
            insertId: object?.insert_id,
            labels: isObject(object.labels) ? Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            protoPayload: object.proto_payload ? Any.fromSDK(object.proto_payload) : undefined,
            textPayload: object?.text_payload,
            structPayload: object.struct_payload ? Struct.fromSDK(object.struct_payload) : undefined,
            operation: object.operation ? LogEntryOperation.fromSDK(object.operation) : undefined,
            sourceLocation: object.source_location ? LogEntrySourceLocation.fromSDK(object.source_location) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            timestamp: isSet(object.timestamp) ? new Date(object.timestamp) : undefined,
            severity: isSet(object.severity) ? logSeverityFromJSON(object.severity) : -1,
            http_request: isSet(object.http_request) ? HttpRequest.fromSDKJSON(object.http_request) : undefined,
            trace: isSet(object.trace) ? String(object.trace) : "",
            insert_id: isSet(object.insert_id) ? String(object.insert_id) : "",
            labels: isObject(object.labels) ? Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            proto_payload: isSet(object.proto_payload) ? Any.fromSDKJSON(object.proto_payload) : undefined,
            text_payload: isSet(object.text_payload) ? String(object.text_payload) : undefined,
            struct_payload: isSet(object.struct_payload) ? Struct.fromSDKJSON(object.struct_payload) : undefined,
            operation: isSet(object.operation) ? LogEntryOperation.fromSDKJSON(object.operation) : undefined,
            source_location: isSet(object.source_location) ? LogEntrySourceLocation.fromSDKJSON(object.source_location) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        message.timestamp !== undefined && (obj.timestamp = message.timestamp ?? undefined);
        message.severity !== undefined && (obj.severity = logSeverityToJSON(message.severity));
        message.httpRequest !== undefined && (obj.http_request = message.httpRequest ? HttpRequest.toSDK(message.httpRequest) : undefined);
        obj.trace = message.trace;
        obj.insert_id = message.insertId;
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        message.protoPayload !== undefined && (obj.proto_payload = message.protoPayload ? Any.toSDK(message.protoPayload) : undefined);
        obj.text_payload = message.textPayload;
        message.structPayload !== undefined && (obj.struct_payload = message.structPayload ? Struct.toSDK(message.structPayload) : undefined);
        message.operation !== undefined && (obj.operation = message.operation ? LogEntryOperation.toSDK(message.operation) : undefined);
        message.sourceLocation !== undefined && (obj.source_location = message.sourceLocation ? LogEntrySourceLocation.toSDK(message.sourceLocation) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLogEntry();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.timestamp !== undefined && object.timestamp !== null) {
            message.timestamp = fromTimestamp(Timestamp.fromAmino(object.timestamp));
        }
        if (object.severity !== undefined && object.severity !== null) {
            message.severity = object.severity;
        }
        if (object.http_request !== undefined && object.http_request !== null) {
            message.httpRequest = HttpRequest.fromAmino(object.http_request);
        }
        if (object.trace !== undefined && object.trace !== null) {
            message.trace = object.trace;
        }
        if (object.insert_id !== undefined && object.insert_id !== null) {
            message.insertId = object.insert_id;
        }
        message.labels = Object.entries(object.labels ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        if (object.proto_payload !== undefined && object.proto_payload !== null) {
            message.protoPayload = Any.fromAmino(object.proto_payload);
        }
        if (object.text_payload !== undefined && object.text_payload !== null) {
            message.textPayload = object.text_payload;
        }
        if (object.struct_payload !== undefined && object.struct_payload !== null) {
            message.structPayload = Struct.fromAmino(object.struct_payload);
        }
        if (object.operation !== undefined && object.operation !== null) {
            message.operation = LogEntryOperation.fromAmino(object.operation);
        }
        if (object.source_location !== undefined && object.source_location !== null) {
            message.sourceLocation = LogEntrySourceLocation.fromAmino(object.source_location);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.timestamp = message.timestamp ? Timestamp.toAmino(toTimestamp(message.timestamp)) : undefined;
        obj.severity = message.severity === 0 ? undefined : message.severity;
        obj.http_request = message.httpRequest ? HttpRequest.toAmino(message.httpRequest) : undefined;
        obj.trace = message.trace === "" ? undefined : message.trace;
        obj.insert_id = message.insertId === "" ? undefined : message.insertId;
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        obj.proto_payload = message.protoPayload ? Any.toAmino(message.protoPayload) : undefined;
        obj.text_payload = message.textPayload === null ? undefined : message.textPayload;
        obj.struct_payload = message.structPayload ? Struct.toAmino(message.structPayload) : undefined;
        obj.operation = message.operation ? LogEntryOperation.toAmino(message.operation) : undefined;
        obj.source_location = message.sourceLocation ? LogEntrySourceLocation.toAmino(message.sourceLocation) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return LogEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return LogEntry.decode(message.value);
    },
    toProto(message) {
        return LogEntry.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicecontrol.v1.LogEntry",
            value: LogEntry.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Struct.registerTypeUrl();
        LogEntryOperation.registerTypeUrl();
        LogEntrySourceLocation.registerTypeUrl();
    }
};
function createBaseLogEntryOperation() {
    return {
        id: "",
        producer: "",
        first: false,
        last: false
    };
}
export const LogEntryOperation = {
    typeUrl: "/google.api.servicecontrol.v1.LogEntryOperation",
    is(o) {
        return o && (o.$typeUrl === LogEntryOperation.typeUrl || typeof o.id === "string" && typeof o.producer === "string" && typeof o.first === "boolean" && typeof o.last === "boolean");
    },
    isSDK(o) {
        return o && (o.$typeUrl === LogEntryOperation.typeUrl || typeof o.id === "string" && typeof o.producer === "string" && typeof o.first === "boolean" && typeof o.last === "boolean");
    },
    isAmino(o) {
        return o && (o.$typeUrl === LogEntryOperation.typeUrl || typeof o.id === "string" && typeof o.producer === "string" && typeof o.first === "boolean" && typeof o.last === "boolean");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            writer.uint32(10).string(message.id);
        }
        if (message.producer !== undefined) {
            writer.uint32(18).string(message.producer);
        }
        if (message.first !== undefined) {
            writer.uint32(24).bool(message.first);
        }
        if (message.last !== undefined) {
            writer.uint32(32).bool(message.last);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLogEntryOperation();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    message.producer = reader.string();
                    break;
                case 3:
                    message.first = reader.bool();
                    break;
                case 4:
                    message.last = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLogEntryOperation();
        if (isSet(object.id))
            obj.id = String(object.id);
        if (isSet(object.producer))
            obj.producer = String(object.producer);
        if (isSet(object.first))
            obj.first = Boolean(object.first);
        if (isSet(object.last))
            obj.last = Boolean(object.last);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        message.producer !== undefined && (obj.producer = message.producer);
        message.first !== undefined && (obj.first = message.first);
        message.last !== undefined && (obj.last = message.last);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLogEntryOperation();
        message.id = object.id ?? "";
        message.producer = object.producer ?? "";
        message.first = object.first ?? false;
        message.last = object.last ?? false;
        return message;
    },
    fromSDK(object) {
        return {
            id: object?.id,
            producer: object?.producer,
            first: object?.first,
            last: object?.last
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? String(object.id) : "",
            producer: isSet(object.producer) ? String(object.producer) : "",
            first: isSet(object.first) ? Boolean(object.first) : false,
            last: isSet(object.last) ? Boolean(object.last) : false
        };
    },
    toSDK(message) {
        const obj = {};
        obj.id = message.id;
        obj.producer = message.producer;
        obj.first = message.first;
        obj.last = message.last;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLogEntryOperation();
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        if (object.producer !== undefined && object.producer !== null) {
            message.producer = object.producer;
        }
        if (object.first !== undefined && object.first !== null) {
            message.first = object.first;
        }
        if (object.last !== undefined && object.last !== null) {
            message.last = object.last;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id === "" ? undefined : message.id;
        obj.producer = message.producer === "" ? undefined : message.producer;
        obj.first = message.first === false ? undefined : message.first;
        obj.last = message.last === false ? undefined : message.last;
        return obj;
    },
    fromAminoMsg(object) {
        return LogEntryOperation.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return LogEntryOperation.decode(message.value);
    },
    toProto(message) {
        return LogEntryOperation.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicecontrol.v1.LogEntryOperation",
            value: LogEntryOperation.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseLogEntrySourceLocation() {
    return {
        file: "",
        line: BigInt(0),
        function: ""
    };
}
export const LogEntrySourceLocation = {
    typeUrl: "/google.api.servicecontrol.v1.LogEntrySourceLocation",
    is(o) {
        return o && (o.$typeUrl === LogEntrySourceLocation.typeUrl || typeof o.file === "string" && typeof o.line === "bigint" && typeof o.function === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === LogEntrySourceLocation.typeUrl || typeof o.file === "string" && typeof o.line === "bigint" && typeof o.function === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === LogEntrySourceLocation.typeUrl || typeof o.file === "string" && typeof o.line === "bigint" && typeof o.function === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.file !== undefined) {
            writer.uint32(10).string(message.file);
        }
        if (message.line !== undefined) {
            writer.uint32(16).int64(message.line);
        }
        if (message.function !== undefined) {
            writer.uint32(26).string(message.function);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLogEntrySourceLocation();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.file = reader.string();
                    break;
                case 2:
                    message.line = reader.int64();
                    break;
                case 3:
                    message.function = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLogEntrySourceLocation();
        if (isSet(object.file))
            obj.file = String(object.file);
        if (isSet(object.line))
            obj.line = BigInt(object.line.toString());
        if (isSet(object.function))
            obj.function = String(object.function);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.file !== undefined && (obj.file = message.file);
        message.line !== undefined && (obj.line = (message.line || BigInt(0)).toString());
        message.function !== undefined && (obj.function = message.function);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLogEntrySourceLocation();
        message.file = object.file ?? "";
        if (object.line !== undefined && object.line !== null) {
            message.line = BigInt(object.line.toString());
        }
        message.function = object.function ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            file: object?.file,
            line: object?.line,
            function: object?.function
        };
    },
    fromSDKJSON(object) {
        return {
            file: isSet(object.file) ? String(object.file) : "",
            line: isSet(object.line) ? BigInt(object.line.toString()) : BigInt(0),
            function: isSet(object.function) ? String(object.function) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.file = message.file;
        obj.line = message.line;
        obj.function = message.function;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLogEntrySourceLocation();
        if (object.file !== undefined && object.file !== null) {
            message.file = object.file;
        }
        if (object.line !== undefined && object.line !== null) {
            message.line = BigInt(object.line);
        }
        if (object.function !== undefined && object.function !== null) {
            message.function = object.function;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.file = message.file === "" ? undefined : message.file;
        obj.line = message.line !== BigInt(0) ? message.line?.toString() : undefined;
        obj.function = message.function === "" ? undefined : message.function;
        return obj;
    },
    fromAminoMsg(object) {
        return LogEntrySourceLocation.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return LogEntrySourceLocation.decode(message.value);
    },
    toProto(message) {
        return LogEntrySourceLocation.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicecontrol.v1.LogEntrySourceLocation",
            value: LogEntrySourceLocation.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
