import { ManagedService, ConfigSource, Rollout, ChangeReport, Diagnostic } from "./resources";
import { Service } from "../../service";
import { Any } from "../../../protobuf/any";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { isSet } from "../../../../helpers";
export const protobufPackage = "google.api.servicemanagement.v1";
export var GetServiceConfigRequest_ConfigView;
(function (GetServiceConfigRequest_ConfigView) {
    /** BASIC - Server response includes all fields except SourceInfo. */
    GetServiceConfigRequest_ConfigView[GetServiceConfigRequest_ConfigView["BASIC"] = 0] = "BASIC";
    /**
     * FULL - Server response includes all fields including SourceInfo.
     * SourceFiles are of type 'google.api.servicemanagement.v1.ConfigFile'
     * and are only available for configs created using the
     * SubmitConfigSource method.
     */
    GetServiceConfigRequest_ConfigView[GetServiceConfigRequest_ConfigView["FULL"] = 1] = "FULL";
    GetServiceConfigRequest_ConfigView[GetServiceConfigRequest_ConfigView["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(GetServiceConfigRequest_ConfigView || (GetServiceConfigRequest_ConfigView = {}));
export const GetServiceConfigRequest_ConfigViewSDKType = GetServiceConfigRequest_ConfigView;
export const GetServiceConfigRequest_ConfigViewAmino = GetServiceConfigRequest_ConfigView;
export function getServiceConfigRequest_ConfigViewFromJSON(object) {
    switch (object) {
        case 0:
        case "BASIC":
            return GetServiceConfigRequest_ConfigView.BASIC;
        case 1:
        case "FULL":
            return GetServiceConfigRequest_ConfigView.FULL;
        case -1:
        case "UNRECOGNIZED":
        default:
            return GetServiceConfigRequest_ConfigView.UNRECOGNIZED;
    }
}
export function getServiceConfigRequest_ConfigViewToJSON(object) {
    switch (object) {
        case GetServiceConfigRequest_ConfigView.BASIC:
            return "BASIC";
        case GetServiceConfigRequest_ConfigView.FULL:
            return "FULL";
        case GetServiceConfigRequest_ConfigView.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
function createBaseListServicesRequest() {
    return {
        producerProjectId: "",
        pageSize: 0,
        pageToken: "",
        consumerId: ""
    };
}
export const ListServicesRequest = {
    typeUrl: "/google.api.servicemanagement.v1.ListServicesRequest",
    is(o) {
        return o && (o.$typeUrl === ListServicesRequest.typeUrl || typeof o.producerProjectId === "string" && typeof o.pageSize === "number" && typeof o.pageToken === "string" && typeof o.consumerId === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListServicesRequest.typeUrl || typeof o.producer_project_id === "string" && typeof o.page_size === "number" && typeof o.page_token === "string" && typeof o.consumer_id === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListServicesRequest.typeUrl || typeof o.producer_project_id === "string" && typeof o.page_size === "number" && typeof o.page_token === "string" && typeof o.consumer_id === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.producerProjectId !== undefined) {
            writer.uint32(10).string(message.producerProjectId);
        }
        if (message.pageSize !== undefined) {
            writer.uint32(40).int32(message.pageSize);
        }
        if (message.pageToken !== undefined) {
            writer.uint32(50).string(message.pageToken);
        }
        if (message.consumerId !== undefined) {
            writer.uint32(58).string(message.consumerId);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListServicesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.producerProjectId = reader.string();
                    break;
                case 5:
                    message.pageSize = reader.int32();
                    break;
                case 6:
                    message.pageToken = reader.string();
                    break;
                case 7:
                    message.consumerId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListServicesRequest();
        if (isSet(object.producerProjectId))
            obj.producerProjectId = String(object.producerProjectId);
        if (isSet(object.pageSize))
            obj.pageSize = Number(object.pageSize);
        if (isSet(object.pageToken))
            obj.pageToken = String(object.pageToken);
        if (isSet(object.consumerId))
            obj.consumerId = String(object.consumerId);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.producerProjectId !== undefined && (obj.producerProjectId = message.producerProjectId);
        message.pageSize !== undefined && (obj.pageSize = Math.round(message.pageSize));
        message.pageToken !== undefined && (obj.pageToken = message.pageToken);
        message.consumerId !== undefined && (obj.consumerId = message.consumerId);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListServicesRequest();
        message.producerProjectId = object.producerProjectId ?? "";
        message.pageSize = object.pageSize ?? 0;
        message.pageToken = object.pageToken ?? "";
        message.consumerId = object.consumerId ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            producerProjectId: object?.producer_project_id,
            pageSize: object?.page_size,
            pageToken: object?.page_token,
            consumerId: object?.consumer_id
        };
    },
    fromSDKJSON(object) {
        return {
            producer_project_id: isSet(object.producer_project_id) ? String(object.producer_project_id) : "",
            page_size: isSet(object.page_size) ? Number(object.page_size) : 0,
            page_token: isSet(object.page_token) ? String(object.page_token) : "",
            consumer_id: isSet(object.consumer_id) ? String(object.consumer_id) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.producer_project_id = message.producerProjectId;
        obj.page_size = message.pageSize;
        obj.page_token = message.pageToken;
        obj.consumer_id = message.consumerId;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListServicesRequest();
        if (object.producer_project_id !== undefined && object.producer_project_id !== null) {
            message.producerProjectId = object.producer_project_id;
        }
        if (object.page_size !== undefined && object.page_size !== null) {
            message.pageSize = object.page_size;
        }
        if (object.page_token !== undefined && object.page_token !== null) {
            message.pageToken = object.page_token;
        }
        if (object.consumer_id !== undefined && object.consumer_id !== null) {
            message.consumerId = object.consumer_id;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.producer_project_id = message.producerProjectId === "" ? undefined : message.producerProjectId;
        obj.page_size = message.pageSize === 0 ? undefined : message.pageSize;
        obj.page_token = message.pageToken === "" ? undefined : message.pageToken;
        obj.consumer_id = message.consumerId === "" ? undefined : message.consumerId;
        return obj;
    },
    fromAminoMsg(object) {
        return ListServicesRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListServicesRequest.decode(message.value);
    },
    toProto(message) {
        return ListServicesRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.ListServicesRequest",
            value: ListServicesRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListServicesResponse() {
    return {
        services: [],
        nextPageToken: ""
    };
}
export const ListServicesResponse = {
    typeUrl: "/google.api.servicemanagement.v1.ListServicesResponse",
    is(o) {
        return o && (o.$typeUrl === ListServicesResponse.typeUrl || Array.isArray(o.services) && (!o.services.length || ManagedService.is(o.services[0])) && typeof o.nextPageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListServicesResponse.typeUrl || Array.isArray(o.services) && (!o.services.length || ManagedService.isSDK(o.services[0])) && typeof o.next_page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListServicesResponse.typeUrl || Array.isArray(o.services) && (!o.services.length || ManagedService.isAmino(o.services[0])) && typeof o.next_page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.services) {
            ManagedService.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.nextPageToken !== undefined) {
            writer.uint32(18).string(message.nextPageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListServicesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.services.push(ManagedService.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.nextPageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListServicesResponse();
        if (Array.isArray(object?.services))
            obj.services = object.services.map((e) => ManagedService.fromJSON(e));
        if (isSet(object.nextPageToken))
            obj.nextPageToken = String(object.nextPageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.services) {
            obj.services = message.services.map(e => e ? ManagedService.toJSON(e) : undefined);
        }
        else {
            obj.services = [];
        }
        message.nextPageToken !== undefined && (obj.nextPageToken = message.nextPageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListServicesResponse();
        message.services = object.services?.map(e => ManagedService.fromPartial(e)) || [];
        message.nextPageToken = object.nextPageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            services: Array.isArray(object?.services) ? object.services.map((e) => ManagedService.fromSDK(e)) : [],
            nextPageToken: object?.next_page_token
        };
    },
    fromSDKJSON(object) {
        return {
            services: Array.isArray(object?.services) ? object.services.map((e) => ManagedService.fromSDKJSON(e)) : [],
            next_page_token: isSet(object.next_page_token) ? String(object.next_page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.services) {
            obj.services = message.services.map(e => e ? ManagedService.toSDK(e) : undefined);
        }
        else {
            obj.services = [];
        }
        obj.next_page_token = message.nextPageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListServicesResponse();
        message.services = object.services?.map(e => ManagedService.fromAmino(e)) || [];
        if (object.next_page_token !== undefined && object.next_page_token !== null) {
            message.nextPageToken = object.next_page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.services) {
            obj.services = message.services.map(e => e ? ManagedService.toAmino(e) : undefined);
        }
        else {
            obj.services = message.services;
        }
        obj.next_page_token = message.nextPageToken === "" ? undefined : message.nextPageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListServicesResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListServicesResponse.decode(message.value);
    },
    toProto(message) {
        return ListServicesResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.ListServicesResponse",
            value: ListServicesResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ManagedService.registerTypeUrl();
    }
};
function createBaseGetServiceRequest() {
    return {
        serviceName: ""
    };
}
export const GetServiceRequest = {
    typeUrl: "/google.api.servicemanagement.v1.GetServiceRequest",
    is(o) {
        return o && (o.$typeUrl === GetServiceRequest.typeUrl || typeof o.serviceName === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === GetServiceRequest.typeUrl || typeof o.service_name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === GetServiceRequest.typeUrl || typeof o.service_name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.serviceName !== undefined) {
            writer.uint32(10).string(message.serviceName);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetServiceRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.serviceName = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGetServiceRequest();
        if (isSet(object.serviceName))
            obj.serviceName = String(object.serviceName);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.serviceName !== undefined && (obj.serviceName = message.serviceName);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGetServiceRequest();
        message.serviceName = object.serviceName ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            serviceName: object?.service_name
        };
    },
    fromSDKJSON(object) {
        return {
            service_name: isSet(object.service_name) ? String(object.service_name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service_name = message.serviceName;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGetServiceRequest();
        if (object.service_name !== undefined && object.service_name !== null) {
            message.serviceName = object.service_name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service_name = message.serviceName === "" ? undefined : message.serviceName;
        return obj;
    },
    fromAminoMsg(object) {
        return GetServiceRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetServiceRequest.decode(message.value);
    },
    toProto(message) {
        return GetServiceRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.GetServiceRequest",
            value: GetServiceRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseCreateServiceRequest() {
    return {
        service: undefined
    };
}
export const CreateServiceRequest = {
    typeUrl: "/google.api.servicemanagement.v1.CreateServiceRequest",
    is(o) {
        return o && o.$typeUrl === CreateServiceRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === CreateServiceRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === CreateServiceRequest.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.service !== undefined) {
            ManagedService.encode(message.service, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCreateServiceRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.service = ManagedService.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCreateServiceRequest();
        if (isSet(object.service))
            obj.service = ManagedService.fromJSON(object.service);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.service !== undefined && (obj.service = message.service ? ManagedService.toJSON(message.service) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCreateServiceRequest();
        if (object.service !== undefined && object.service !== null) {
            message.service = ManagedService.fromPartial(object.service);
        }
        return message;
    },
    fromSDK(object) {
        return {
            service: object.service ? ManagedService.fromSDK(object.service) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            service: isSet(object.service) ? ManagedService.fromSDKJSON(object.service) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.service !== undefined && (obj.service = message.service ? ManagedService.toSDK(message.service) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCreateServiceRequest();
        if (object.service !== undefined && object.service !== null) {
            message.service = ManagedService.fromAmino(object.service);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service = message.service ? ManagedService.toAmino(message.service) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return CreateServiceRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CreateServiceRequest.decode(message.value);
    },
    toProto(message) {
        return CreateServiceRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.CreateServiceRequest",
            value: CreateServiceRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ManagedService.registerTypeUrl();
    }
};
function createBaseDeleteServiceRequest() {
    return {
        serviceName: ""
    };
}
export const DeleteServiceRequest = {
    typeUrl: "/google.api.servicemanagement.v1.DeleteServiceRequest",
    is(o) {
        return o && (o.$typeUrl === DeleteServiceRequest.typeUrl || typeof o.serviceName === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === DeleteServiceRequest.typeUrl || typeof o.service_name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === DeleteServiceRequest.typeUrl || typeof o.service_name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.serviceName !== undefined) {
            writer.uint32(10).string(message.serviceName);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeleteServiceRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.serviceName = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDeleteServiceRequest();
        if (isSet(object.serviceName))
            obj.serviceName = String(object.serviceName);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.serviceName !== undefined && (obj.serviceName = message.serviceName);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDeleteServiceRequest();
        message.serviceName = object.serviceName ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            serviceName: object?.service_name
        };
    },
    fromSDKJSON(object) {
        return {
            service_name: isSet(object.service_name) ? String(object.service_name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service_name = message.serviceName;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDeleteServiceRequest();
        if (object.service_name !== undefined && object.service_name !== null) {
            message.serviceName = object.service_name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service_name = message.serviceName === "" ? undefined : message.serviceName;
        return obj;
    },
    fromAminoMsg(object) {
        return DeleteServiceRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return DeleteServiceRequest.decode(message.value);
    },
    toProto(message) {
        return DeleteServiceRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.DeleteServiceRequest",
            value: DeleteServiceRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseUndeleteServiceRequest() {
    return {
        serviceName: ""
    };
}
export const UndeleteServiceRequest = {
    typeUrl: "/google.api.servicemanagement.v1.UndeleteServiceRequest",
    is(o) {
        return o && (o.$typeUrl === UndeleteServiceRequest.typeUrl || typeof o.serviceName === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === UndeleteServiceRequest.typeUrl || typeof o.service_name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === UndeleteServiceRequest.typeUrl || typeof o.service_name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.serviceName !== undefined) {
            writer.uint32(10).string(message.serviceName);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUndeleteServiceRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.serviceName = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseUndeleteServiceRequest();
        if (isSet(object.serviceName))
            obj.serviceName = String(object.serviceName);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.serviceName !== undefined && (obj.serviceName = message.serviceName);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseUndeleteServiceRequest();
        message.serviceName = object.serviceName ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            serviceName: object?.service_name
        };
    },
    fromSDKJSON(object) {
        return {
            service_name: isSet(object.service_name) ? String(object.service_name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service_name = message.serviceName;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseUndeleteServiceRequest();
        if (object.service_name !== undefined && object.service_name !== null) {
            message.serviceName = object.service_name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service_name = message.serviceName === "" ? undefined : message.serviceName;
        return obj;
    },
    fromAminoMsg(object) {
        return UndeleteServiceRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return UndeleteServiceRequest.decode(message.value);
    },
    toProto(message) {
        return UndeleteServiceRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.UndeleteServiceRequest",
            value: UndeleteServiceRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseUndeleteServiceResponse() {
    return {
        service: undefined
    };
}
export const UndeleteServiceResponse = {
    typeUrl: "/google.api.servicemanagement.v1.UndeleteServiceResponse",
    is(o) {
        return o && o.$typeUrl === UndeleteServiceResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === UndeleteServiceResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === UndeleteServiceResponse.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.service !== undefined) {
            ManagedService.encode(message.service, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUndeleteServiceResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.service = ManagedService.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseUndeleteServiceResponse();
        if (isSet(object.service))
            obj.service = ManagedService.fromJSON(object.service);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.service !== undefined && (obj.service = message.service ? ManagedService.toJSON(message.service) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseUndeleteServiceResponse();
        if (object.service !== undefined && object.service !== null) {
            message.service = ManagedService.fromPartial(object.service);
        }
        return message;
    },
    fromSDK(object) {
        return {
            service: object.service ? ManagedService.fromSDK(object.service) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            service: isSet(object.service) ? ManagedService.fromSDKJSON(object.service) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.service !== undefined && (obj.service = message.service ? ManagedService.toSDK(message.service) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseUndeleteServiceResponse();
        if (object.service !== undefined && object.service !== null) {
            message.service = ManagedService.fromAmino(object.service);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service = message.service ? ManagedService.toAmino(message.service) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return UndeleteServiceResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return UndeleteServiceResponse.decode(message.value);
    },
    toProto(message) {
        return UndeleteServiceResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.UndeleteServiceResponse",
            value: UndeleteServiceResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ManagedService.registerTypeUrl();
    }
};
function createBaseGetServiceConfigRequest() {
    return {
        serviceName: "",
        configId: "",
        view: 0
    };
}
export const GetServiceConfigRequest = {
    typeUrl: "/google.api.servicemanagement.v1.GetServiceConfigRequest",
    is(o) {
        return o && (o.$typeUrl === GetServiceConfigRequest.typeUrl || typeof o.serviceName === "string" && typeof o.configId === "string" && isSet(o.view));
    },
    isSDK(o) {
        return o && (o.$typeUrl === GetServiceConfigRequest.typeUrl || typeof o.service_name === "string" && typeof o.config_id === "string" && isSet(o.view));
    },
    isAmino(o) {
        return o && (o.$typeUrl === GetServiceConfigRequest.typeUrl || typeof o.service_name === "string" && typeof o.config_id === "string" && isSet(o.view));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.serviceName !== undefined) {
            writer.uint32(10).string(message.serviceName);
        }
        if (message.configId !== undefined) {
            writer.uint32(18).string(message.configId);
        }
        if (message.view !== 0) {
            writer.uint32(24).int32(message.view);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetServiceConfigRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.serviceName = reader.string();
                    break;
                case 2:
                    message.configId = reader.string();
                    break;
                case 3:
                    message.view = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGetServiceConfigRequest();
        if (isSet(object.serviceName))
            obj.serviceName = String(object.serviceName);
        if (isSet(object.configId))
            obj.configId = String(object.configId);
        if (isSet(object.view))
            obj.view = getServiceConfigRequest_ConfigViewFromJSON(object.view);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.serviceName !== undefined && (obj.serviceName = message.serviceName);
        message.configId !== undefined && (obj.configId = message.configId);
        message.view !== undefined && (obj.view = getServiceConfigRequest_ConfigViewToJSON(message.view));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGetServiceConfigRequest();
        message.serviceName = object.serviceName ?? "";
        message.configId = object.configId ?? "";
        message.view = object.view ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            serviceName: object?.service_name,
            configId: object?.config_id,
            view: isSet(object.view) ? getServiceConfigRequest_ConfigViewFromJSON(object.view) : -1
        };
    },
    fromSDKJSON(object) {
        return {
            service_name: isSet(object.service_name) ? String(object.service_name) : "",
            config_id: isSet(object.config_id) ? String(object.config_id) : "",
            view: isSet(object.view) ? getServiceConfigRequest_ConfigViewFromJSON(object.view) : -1
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service_name = message.serviceName;
        obj.config_id = message.configId;
        message.view !== undefined && (obj.view = getServiceConfigRequest_ConfigViewToJSON(message.view));
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGetServiceConfigRequest();
        if (object.service_name !== undefined && object.service_name !== null) {
            message.serviceName = object.service_name;
        }
        if (object.config_id !== undefined && object.config_id !== null) {
            message.configId = object.config_id;
        }
        if (object.view !== undefined && object.view !== null) {
            message.view = object.view;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service_name = message.serviceName === "" ? undefined : message.serviceName;
        obj.config_id = message.configId === "" ? undefined : message.configId;
        obj.view = message.view === 0 ? undefined : message.view;
        return obj;
    },
    fromAminoMsg(object) {
        return GetServiceConfigRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetServiceConfigRequest.decode(message.value);
    },
    toProto(message) {
        return GetServiceConfigRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.GetServiceConfigRequest",
            value: GetServiceConfigRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListServiceConfigsRequest() {
    return {
        serviceName: "",
        pageToken: "",
        pageSize: 0
    };
}
export const ListServiceConfigsRequest = {
    typeUrl: "/google.api.servicemanagement.v1.ListServiceConfigsRequest",
    is(o) {
        return o && (o.$typeUrl === ListServiceConfigsRequest.typeUrl || typeof o.serviceName === "string" && typeof o.pageToken === "string" && typeof o.pageSize === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListServiceConfigsRequest.typeUrl || typeof o.service_name === "string" && typeof o.page_token === "string" && typeof o.page_size === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListServiceConfigsRequest.typeUrl || typeof o.service_name === "string" && typeof o.page_token === "string" && typeof o.page_size === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.serviceName !== undefined) {
            writer.uint32(10).string(message.serviceName);
        }
        if (message.pageToken !== undefined) {
            writer.uint32(18).string(message.pageToken);
        }
        if (message.pageSize !== undefined) {
            writer.uint32(24).int32(message.pageSize);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListServiceConfigsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.serviceName = reader.string();
                    break;
                case 2:
                    message.pageToken = reader.string();
                    break;
                case 3:
                    message.pageSize = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListServiceConfigsRequest();
        if (isSet(object.serviceName))
            obj.serviceName = String(object.serviceName);
        if (isSet(object.pageToken))
            obj.pageToken = String(object.pageToken);
        if (isSet(object.pageSize))
            obj.pageSize = Number(object.pageSize);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.serviceName !== undefined && (obj.serviceName = message.serviceName);
        message.pageToken !== undefined && (obj.pageToken = message.pageToken);
        message.pageSize !== undefined && (obj.pageSize = Math.round(message.pageSize));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListServiceConfigsRequest();
        message.serviceName = object.serviceName ?? "";
        message.pageToken = object.pageToken ?? "";
        message.pageSize = object.pageSize ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            serviceName: object?.service_name,
            pageToken: object?.page_token,
            pageSize: object?.page_size
        };
    },
    fromSDKJSON(object) {
        return {
            service_name: isSet(object.service_name) ? String(object.service_name) : "",
            page_token: isSet(object.page_token) ? String(object.page_token) : "",
            page_size: isSet(object.page_size) ? Number(object.page_size) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service_name = message.serviceName;
        obj.page_token = message.pageToken;
        obj.page_size = message.pageSize;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListServiceConfigsRequest();
        if (object.service_name !== undefined && object.service_name !== null) {
            message.serviceName = object.service_name;
        }
        if (object.page_token !== undefined && object.page_token !== null) {
            message.pageToken = object.page_token;
        }
        if (object.page_size !== undefined && object.page_size !== null) {
            message.pageSize = object.page_size;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service_name = message.serviceName === "" ? undefined : message.serviceName;
        obj.page_token = message.pageToken === "" ? undefined : message.pageToken;
        obj.page_size = message.pageSize === 0 ? undefined : message.pageSize;
        return obj;
    },
    fromAminoMsg(object) {
        return ListServiceConfigsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListServiceConfigsRequest.decode(message.value);
    },
    toProto(message) {
        return ListServiceConfigsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.ListServiceConfigsRequest",
            value: ListServiceConfigsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListServiceConfigsResponse() {
    return {
        serviceConfigs: [],
        nextPageToken: ""
    };
}
export const ListServiceConfigsResponse = {
    typeUrl: "/google.api.servicemanagement.v1.ListServiceConfigsResponse",
    is(o) {
        return o && (o.$typeUrl === ListServiceConfigsResponse.typeUrl || Array.isArray(o.serviceConfigs) && (!o.serviceConfigs.length || Service.is(o.serviceConfigs[0])) && typeof o.nextPageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListServiceConfigsResponse.typeUrl || Array.isArray(o.service_configs) && (!o.service_configs.length || Service.isSDK(o.service_configs[0])) && typeof o.next_page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListServiceConfigsResponse.typeUrl || Array.isArray(o.service_configs) && (!o.service_configs.length || Service.isAmino(o.service_configs[0])) && typeof o.next_page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.serviceConfigs) {
            Service.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.nextPageToken !== undefined) {
            writer.uint32(18).string(message.nextPageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListServiceConfigsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.serviceConfigs.push(Service.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.nextPageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListServiceConfigsResponse();
        if (Array.isArray(object?.serviceConfigs))
            obj.serviceConfigs = object.serviceConfigs.map((e) => Service.fromJSON(e));
        if (isSet(object.nextPageToken))
            obj.nextPageToken = String(object.nextPageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.serviceConfigs) {
            obj.serviceConfigs = message.serviceConfigs.map(e => e ? Service.toJSON(e) : undefined);
        }
        else {
            obj.serviceConfigs = [];
        }
        message.nextPageToken !== undefined && (obj.nextPageToken = message.nextPageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListServiceConfigsResponse();
        message.serviceConfigs = object.serviceConfigs?.map(e => Service.fromPartial(e)) || [];
        message.nextPageToken = object.nextPageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            serviceConfigs: Array.isArray(object?.service_configs) ? object.service_configs.map((e) => Service.fromSDK(e)) : [],
            nextPageToken: object?.next_page_token
        };
    },
    fromSDKJSON(object) {
        return {
            service_configs: Array.isArray(object?.service_configs) ? object.service_configs.map((e) => Service.fromSDKJSON(e)) : [],
            next_page_token: isSet(object.next_page_token) ? String(object.next_page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.serviceConfigs) {
            obj.service_configs = message.serviceConfigs.map(e => e ? Service.toSDK(e) : undefined);
        }
        else {
            obj.service_configs = [];
        }
        obj.next_page_token = message.nextPageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListServiceConfigsResponse();
        message.serviceConfigs = object.service_configs?.map(e => Service.fromAmino(e)) || [];
        if (object.next_page_token !== undefined && object.next_page_token !== null) {
            message.nextPageToken = object.next_page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.serviceConfigs) {
            obj.service_configs = message.serviceConfigs.map(e => e ? Service.toAmino(e) : undefined);
        }
        else {
            obj.service_configs = message.serviceConfigs;
        }
        obj.next_page_token = message.nextPageToken === "" ? undefined : message.nextPageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListServiceConfigsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListServiceConfigsResponse.decode(message.value);
    },
    toProto(message) {
        return ListServiceConfigsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.ListServiceConfigsResponse",
            value: ListServiceConfigsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Service.registerTypeUrl();
    }
};
function createBaseCreateServiceConfigRequest() {
    return {
        serviceName: "",
        serviceConfig: undefined
    };
}
export const CreateServiceConfigRequest = {
    typeUrl: "/google.api.servicemanagement.v1.CreateServiceConfigRequest",
    is(o) {
        return o && (o.$typeUrl === CreateServiceConfigRequest.typeUrl || typeof o.serviceName === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === CreateServiceConfigRequest.typeUrl || typeof o.service_name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === CreateServiceConfigRequest.typeUrl || typeof o.service_name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.serviceName !== undefined) {
            writer.uint32(10).string(message.serviceName);
        }
        if (message.serviceConfig !== undefined) {
            Service.encode(message.serviceConfig, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCreateServiceConfigRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.serviceName = reader.string();
                    break;
                case 2:
                    message.serviceConfig = Service.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCreateServiceConfigRequest();
        if (isSet(object.serviceName))
            obj.serviceName = String(object.serviceName);
        if (isSet(object.serviceConfig))
            obj.serviceConfig = Service.fromJSON(object.serviceConfig);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.serviceName !== undefined && (obj.serviceName = message.serviceName);
        message.serviceConfig !== undefined && (obj.serviceConfig = message.serviceConfig ? Service.toJSON(message.serviceConfig) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCreateServiceConfigRequest();
        message.serviceName = object.serviceName ?? "";
        if (object.serviceConfig !== undefined && object.serviceConfig !== null) {
            message.serviceConfig = Service.fromPartial(object.serviceConfig);
        }
        return message;
    },
    fromSDK(object) {
        return {
            serviceName: object?.service_name,
            serviceConfig: object.service_config ? Service.fromSDK(object.service_config) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            service_name: isSet(object.service_name) ? String(object.service_name) : "",
            service_config: isSet(object.service_config) ? Service.fromSDKJSON(object.service_config) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service_name = message.serviceName;
        message.serviceConfig !== undefined && (obj.service_config = message.serviceConfig ? Service.toSDK(message.serviceConfig) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCreateServiceConfigRequest();
        if (object.service_name !== undefined && object.service_name !== null) {
            message.serviceName = object.service_name;
        }
        if (object.service_config !== undefined && object.service_config !== null) {
            message.serviceConfig = Service.fromAmino(object.service_config);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service_name = message.serviceName === "" ? undefined : message.serviceName;
        obj.service_config = message.serviceConfig ? Service.toAmino(message.serviceConfig) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return CreateServiceConfigRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CreateServiceConfigRequest.decode(message.value);
    },
    toProto(message) {
        return CreateServiceConfigRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.CreateServiceConfigRequest",
            value: CreateServiceConfigRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Service.registerTypeUrl();
    }
};
function createBaseSubmitConfigSourceRequest() {
    return {
        serviceName: "",
        configSource: undefined,
        validateOnly: false
    };
}
export const SubmitConfigSourceRequest = {
    typeUrl: "/google.api.servicemanagement.v1.SubmitConfigSourceRequest",
    is(o) {
        return o && (o.$typeUrl === SubmitConfigSourceRequest.typeUrl || typeof o.serviceName === "string" && typeof o.validateOnly === "boolean");
    },
    isSDK(o) {
        return o && (o.$typeUrl === SubmitConfigSourceRequest.typeUrl || typeof o.service_name === "string" && typeof o.validate_only === "boolean");
    },
    isAmino(o) {
        return o && (o.$typeUrl === SubmitConfigSourceRequest.typeUrl || typeof o.service_name === "string" && typeof o.validate_only === "boolean");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.serviceName !== undefined) {
            writer.uint32(10).string(message.serviceName);
        }
        if (message.configSource !== undefined) {
            ConfigSource.encode(message.configSource, writer.uint32(18).fork()).ldelim();
        }
        if (message.validateOnly !== undefined) {
            writer.uint32(24).bool(message.validateOnly);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSubmitConfigSourceRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.serviceName = reader.string();
                    break;
                case 2:
                    message.configSource = ConfigSource.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.validateOnly = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseSubmitConfigSourceRequest();
        if (isSet(object.serviceName))
            obj.serviceName = String(object.serviceName);
        if (isSet(object.configSource))
            obj.configSource = ConfigSource.fromJSON(object.configSource);
        if (isSet(object.validateOnly))
            obj.validateOnly = Boolean(object.validateOnly);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.serviceName !== undefined && (obj.serviceName = message.serviceName);
        message.configSource !== undefined && (obj.configSource = message.configSource ? ConfigSource.toJSON(message.configSource) : undefined);
        message.validateOnly !== undefined && (obj.validateOnly = message.validateOnly);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseSubmitConfigSourceRequest();
        message.serviceName = object.serviceName ?? "";
        if (object.configSource !== undefined && object.configSource !== null) {
            message.configSource = ConfigSource.fromPartial(object.configSource);
        }
        message.validateOnly = object.validateOnly ?? false;
        return message;
    },
    fromSDK(object) {
        return {
            serviceName: object?.service_name,
            configSource: object.config_source ? ConfigSource.fromSDK(object.config_source) : undefined,
            validateOnly: object?.validate_only
        };
    },
    fromSDKJSON(object) {
        return {
            service_name: isSet(object.service_name) ? String(object.service_name) : "",
            config_source: isSet(object.config_source) ? ConfigSource.fromSDKJSON(object.config_source) : undefined,
            validate_only: isSet(object.validate_only) ? Boolean(object.validate_only) : false
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service_name = message.serviceName;
        message.configSource !== undefined && (obj.config_source = message.configSource ? ConfigSource.toSDK(message.configSource) : undefined);
        obj.validate_only = message.validateOnly;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseSubmitConfigSourceRequest();
        if (object.service_name !== undefined && object.service_name !== null) {
            message.serviceName = object.service_name;
        }
        if (object.config_source !== undefined && object.config_source !== null) {
            message.configSource = ConfigSource.fromAmino(object.config_source);
        }
        if (object.validate_only !== undefined && object.validate_only !== null) {
            message.validateOnly = object.validate_only;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service_name = message.serviceName === "" ? undefined : message.serviceName;
        obj.config_source = message.configSource ? ConfigSource.toAmino(message.configSource) : undefined;
        obj.validate_only = message.validateOnly === false ? undefined : message.validateOnly;
        return obj;
    },
    fromAminoMsg(object) {
        return SubmitConfigSourceRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return SubmitConfigSourceRequest.decode(message.value);
    },
    toProto(message) {
        return SubmitConfigSourceRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.SubmitConfigSourceRequest",
            value: SubmitConfigSourceRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ConfigSource.registerTypeUrl();
    }
};
function createBaseSubmitConfigSourceResponse() {
    return {
        serviceConfig: undefined
    };
}
export const SubmitConfigSourceResponse = {
    typeUrl: "/google.api.servicemanagement.v1.SubmitConfigSourceResponse",
    is(o) {
        return o && o.$typeUrl === SubmitConfigSourceResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === SubmitConfigSourceResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === SubmitConfigSourceResponse.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.serviceConfig !== undefined) {
            Service.encode(message.serviceConfig, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSubmitConfigSourceResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.serviceConfig = Service.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseSubmitConfigSourceResponse();
        if (isSet(object.serviceConfig))
            obj.serviceConfig = Service.fromJSON(object.serviceConfig);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.serviceConfig !== undefined && (obj.serviceConfig = message.serviceConfig ? Service.toJSON(message.serviceConfig) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseSubmitConfigSourceResponse();
        if (object.serviceConfig !== undefined && object.serviceConfig !== null) {
            message.serviceConfig = Service.fromPartial(object.serviceConfig);
        }
        return message;
    },
    fromSDK(object) {
        return {
            serviceConfig: object.service_config ? Service.fromSDK(object.service_config) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            service_config: isSet(object.service_config) ? Service.fromSDKJSON(object.service_config) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.serviceConfig !== undefined && (obj.service_config = message.serviceConfig ? Service.toSDK(message.serviceConfig) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseSubmitConfigSourceResponse();
        if (object.service_config !== undefined && object.service_config !== null) {
            message.serviceConfig = Service.fromAmino(object.service_config);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service_config = message.serviceConfig ? Service.toAmino(message.serviceConfig) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return SubmitConfigSourceResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return SubmitConfigSourceResponse.decode(message.value);
    },
    toProto(message) {
        return SubmitConfigSourceResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.SubmitConfigSourceResponse",
            value: SubmitConfigSourceResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Service.registerTypeUrl();
    }
};
function createBaseCreateServiceRolloutRequest() {
    return {
        serviceName: "",
        rollout: undefined
    };
}
export const CreateServiceRolloutRequest = {
    typeUrl: "/google.api.servicemanagement.v1.CreateServiceRolloutRequest",
    is(o) {
        return o && (o.$typeUrl === CreateServiceRolloutRequest.typeUrl || typeof o.serviceName === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === CreateServiceRolloutRequest.typeUrl || typeof o.service_name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === CreateServiceRolloutRequest.typeUrl || typeof o.service_name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.serviceName !== undefined) {
            writer.uint32(10).string(message.serviceName);
        }
        if (message.rollout !== undefined) {
            Rollout.encode(message.rollout, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCreateServiceRolloutRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.serviceName = reader.string();
                    break;
                case 2:
                    message.rollout = Rollout.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCreateServiceRolloutRequest();
        if (isSet(object.serviceName))
            obj.serviceName = String(object.serviceName);
        if (isSet(object.rollout))
            obj.rollout = Rollout.fromJSON(object.rollout);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.serviceName !== undefined && (obj.serviceName = message.serviceName);
        message.rollout !== undefined && (obj.rollout = message.rollout ? Rollout.toJSON(message.rollout) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCreateServiceRolloutRequest();
        message.serviceName = object.serviceName ?? "";
        if (object.rollout !== undefined && object.rollout !== null) {
            message.rollout = Rollout.fromPartial(object.rollout);
        }
        return message;
    },
    fromSDK(object) {
        return {
            serviceName: object?.service_name,
            rollout: object.rollout ? Rollout.fromSDK(object.rollout) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            service_name: isSet(object.service_name) ? String(object.service_name) : "",
            rollout: isSet(object.rollout) ? Rollout.fromSDKJSON(object.rollout) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service_name = message.serviceName;
        message.rollout !== undefined && (obj.rollout = message.rollout ? Rollout.toSDK(message.rollout) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCreateServiceRolloutRequest();
        if (object.service_name !== undefined && object.service_name !== null) {
            message.serviceName = object.service_name;
        }
        if (object.rollout !== undefined && object.rollout !== null) {
            message.rollout = Rollout.fromAmino(object.rollout);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service_name = message.serviceName === "" ? undefined : message.serviceName;
        obj.rollout = message.rollout ? Rollout.toAmino(message.rollout) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return CreateServiceRolloutRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CreateServiceRolloutRequest.decode(message.value);
    },
    toProto(message) {
        return CreateServiceRolloutRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.CreateServiceRolloutRequest",
            value: CreateServiceRolloutRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Rollout.registerTypeUrl();
    }
};
function createBaseListServiceRolloutsRequest() {
    return {
        serviceName: "",
        pageToken: "",
        pageSize: 0,
        filter: ""
    };
}
export const ListServiceRolloutsRequest = {
    typeUrl: "/google.api.servicemanagement.v1.ListServiceRolloutsRequest",
    is(o) {
        return o && (o.$typeUrl === ListServiceRolloutsRequest.typeUrl || typeof o.serviceName === "string" && typeof o.pageToken === "string" && typeof o.pageSize === "number" && typeof o.filter === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListServiceRolloutsRequest.typeUrl || typeof o.service_name === "string" && typeof o.page_token === "string" && typeof o.page_size === "number" && typeof o.filter === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListServiceRolloutsRequest.typeUrl || typeof o.service_name === "string" && typeof o.page_token === "string" && typeof o.page_size === "number" && typeof o.filter === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.serviceName !== undefined) {
            writer.uint32(10).string(message.serviceName);
        }
        if (message.pageToken !== undefined) {
            writer.uint32(18).string(message.pageToken);
        }
        if (message.pageSize !== undefined) {
            writer.uint32(24).int32(message.pageSize);
        }
        if (message.filter !== undefined) {
            writer.uint32(34).string(message.filter);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListServiceRolloutsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.serviceName = reader.string();
                    break;
                case 2:
                    message.pageToken = reader.string();
                    break;
                case 3:
                    message.pageSize = reader.int32();
                    break;
                case 4:
                    message.filter = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListServiceRolloutsRequest();
        if (isSet(object.serviceName))
            obj.serviceName = String(object.serviceName);
        if (isSet(object.pageToken))
            obj.pageToken = String(object.pageToken);
        if (isSet(object.pageSize))
            obj.pageSize = Number(object.pageSize);
        if (isSet(object.filter))
            obj.filter = String(object.filter);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.serviceName !== undefined && (obj.serviceName = message.serviceName);
        message.pageToken !== undefined && (obj.pageToken = message.pageToken);
        message.pageSize !== undefined && (obj.pageSize = Math.round(message.pageSize));
        message.filter !== undefined && (obj.filter = message.filter);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListServiceRolloutsRequest();
        message.serviceName = object.serviceName ?? "";
        message.pageToken = object.pageToken ?? "";
        message.pageSize = object.pageSize ?? 0;
        message.filter = object.filter ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            serviceName: object?.service_name,
            pageToken: object?.page_token,
            pageSize: object?.page_size,
            filter: object?.filter
        };
    },
    fromSDKJSON(object) {
        return {
            service_name: isSet(object.service_name) ? String(object.service_name) : "",
            page_token: isSet(object.page_token) ? String(object.page_token) : "",
            page_size: isSet(object.page_size) ? Number(object.page_size) : 0,
            filter: isSet(object.filter) ? String(object.filter) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service_name = message.serviceName;
        obj.page_token = message.pageToken;
        obj.page_size = message.pageSize;
        obj.filter = message.filter;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListServiceRolloutsRequest();
        if (object.service_name !== undefined && object.service_name !== null) {
            message.serviceName = object.service_name;
        }
        if (object.page_token !== undefined && object.page_token !== null) {
            message.pageToken = object.page_token;
        }
        if (object.page_size !== undefined && object.page_size !== null) {
            message.pageSize = object.page_size;
        }
        if (object.filter !== undefined && object.filter !== null) {
            message.filter = object.filter;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service_name = message.serviceName === "" ? undefined : message.serviceName;
        obj.page_token = message.pageToken === "" ? undefined : message.pageToken;
        obj.page_size = message.pageSize === 0 ? undefined : message.pageSize;
        obj.filter = message.filter === "" ? undefined : message.filter;
        return obj;
    },
    fromAminoMsg(object) {
        return ListServiceRolloutsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListServiceRolloutsRequest.decode(message.value);
    },
    toProto(message) {
        return ListServiceRolloutsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.ListServiceRolloutsRequest",
            value: ListServiceRolloutsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListServiceRolloutsResponse() {
    return {
        rollouts: [],
        nextPageToken: ""
    };
}
export const ListServiceRolloutsResponse = {
    typeUrl: "/google.api.servicemanagement.v1.ListServiceRolloutsResponse",
    is(o) {
        return o && (o.$typeUrl === ListServiceRolloutsResponse.typeUrl || Array.isArray(o.rollouts) && (!o.rollouts.length || Rollout.is(o.rollouts[0])) && typeof o.nextPageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListServiceRolloutsResponse.typeUrl || Array.isArray(o.rollouts) && (!o.rollouts.length || Rollout.isSDK(o.rollouts[0])) && typeof o.next_page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListServiceRolloutsResponse.typeUrl || Array.isArray(o.rollouts) && (!o.rollouts.length || Rollout.isAmino(o.rollouts[0])) && typeof o.next_page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.rollouts) {
            Rollout.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.nextPageToken !== undefined) {
            writer.uint32(18).string(message.nextPageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListServiceRolloutsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.rollouts.push(Rollout.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.nextPageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListServiceRolloutsResponse();
        if (Array.isArray(object?.rollouts))
            obj.rollouts = object.rollouts.map((e) => Rollout.fromJSON(e));
        if (isSet(object.nextPageToken))
            obj.nextPageToken = String(object.nextPageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.rollouts) {
            obj.rollouts = message.rollouts.map(e => e ? Rollout.toJSON(e) : undefined);
        }
        else {
            obj.rollouts = [];
        }
        message.nextPageToken !== undefined && (obj.nextPageToken = message.nextPageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListServiceRolloutsResponse();
        message.rollouts = object.rollouts?.map(e => Rollout.fromPartial(e)) || [];
        message.nextPageToken = object.nextPageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            rollouts: Array.isArray(object?.rollouts) ? object.rollouts.map((e) => Rollout.fromSDK(e)) : [],
            nextPageToken: object?.next_page_token
        };
    },
    fromSDKJSON(object) {
        return {
            rollouts: Array.isArray(object?.rollouts) ? object.rollouts.map((e) => Rollout.fromSDKJSON(e)) : [],
            next_page_token: isSet(object.next_page_token) ? String(object.next_page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.rollouts) {
            obj.rollouts = message.rollouts.map(e => e ? Rollout.toSDK(e) : undefined);
        }
        else {
            obj.rollouts = [];
        }
        obj.next_page_token = message.nextPageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListServiceRolloutsResponse();
        message.rollouts = object.rollouts?.map(e => Rollout.fromAmino(e)) || [];
        if (object.next_page_token !== undefined && object.next_page_token !== null) {
            message.nextPageToken = object.next_page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.rollouts) {
            obj.rollouts = message.rollouts.map(e => e ? Rollout.toAmino(e) : undefined);
        }
        else {
            obj.rollouts = message.rollouts;
        }
        obj.next_page_token = message.nextPageToken === "" ? undefined : message.nextPageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListServiceRolloutsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListServiceRolloutsResponse.decode(message.value);
    },
    toProto(message) {
        return ListServiceRolloutsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.ListServiceRolloutsResponse",
            value: ListServiceRolloutsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Rollout.registerTypeUrl();
    }
};
function createBaseGetServiceRolloutRequest() {
    return {
        serviceName: "",
        rolloutId: ""
    };
}
export const GetServiceRolloutRequest = {
    typeUrl: "/google.api.servicemanagement.v1.GetServiceRolloutRequest",
    is(o) {
        return o && (o.$typeUrl === GetServiceRolloutRequest.typeUrl || typeof o.serviceName === "string" && typeof o.rolloutId === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === GetServiceRolloutRequest.typeUrl || typeof o.service_name === "string" && typeof o.rollout_id === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === GetServiceRolloutRequest.typeUrl || typeof o.service_name === "string" && typeof o.rollout_id === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.serviceName !== undefined) {
            writer.uint32(10).string(message.serviceName);
        }
        if (message.rolloutId !== undefined) {
            writer.uint32(18).string(message.rolloutId);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetServiceRolloutRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.serviceName = reader.string();
                    break;
                case 2:
                    message.rolloutId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGetServiceRolloutRequest();
        if (isSet(object.serviceName))
            obj.serviceName = String(object.serviceName);
        if (isSet(object.rolloutId))
            obj.rolloutId = String(object.rolloutId);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.serviceName !== undefined && (obj.serviceName = message.serviceName);
        message.rolloutId !== undefined && (obj.rolloutId = message.rolloutId);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGetServiceRolloutRequest();
        message.serviceName = object.serviceName ?? "";
        message.rolloutId = object.rolloutId ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            serviceName: object?.service_name,
            rolloutId: object?.rollout_id
        };
    },
    fromSDKJSON(object) {
        return {
            service_name: isSet(object.service_name) ? String(object.service_name) : "",
            rollout_id: isSet(object.rollout_id) ? String(object.rollout_id) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service_name = message.serviceName;
        obj.rollout_id = message.rolloutId;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGetServiceRolloutRequest();
        if (object.service_name !== undefined && object.service_name !== null) {
            message.serviceName = object.service_name;
        }
        if (object.rollout_id !== undefined && object.rollout_id !== null) {
            message.rolloutId = object.rollout_id;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service_name = message.serviceName === "" ? undefined : message.serviceName;
        obj.rollout_id = message.rolloutId === "" ? undefined : message.rolloutId;
        return obj;
    },
    fromAminoMsg(object) {
        return GetServiceRolloutRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetServiceRolloutRequest.decode(message.value);
    },
    toProto(message) {
        return GetServiceRolloutRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.GetServiceRolloutRequest",
            value: GetServiceRolloutRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseGenerateConfigReportRequest() {
    return {
        newConfig: undefined,
        oldConfig: undefined
    };
}
export const GenerateConfigReportRequest = {
    typeUrl: "/google.api.servicemanagement.v1.GenerateConfigReportRequest",
    is(o) {
        return o && o.$typeUrl === GenerateConfigReportRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === GenerateConfigReportRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === GenerateConfigReportRequest.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.newConfig !== undefined) {
            Any.encode(message.newConfig, writer.uint32(10).fork()).ldelim();
        }
        if (message.oldConfig !== undefined) {
            Any.encode(message.oldConfig, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGenerateConfigReportRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.newConfig = Any.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.oldConfig = Any.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGenerateConfigReportRequest();
        if (isSet(object.newConfig))
            obj.newConfig = Any.fromJSON(object.newConfig);
        if (isSet(object.oldConfig))
            obj.oldConfig = Any.fromJSON(object.oldConfig);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.newConfig !== undefined && (obj.newConfig = message.newConfig ? Any.toJSON(message.newConfig) : undefined);
        message.oldConfig !== undefined && (obj.oldConfig = message.oldConfig ? Any.toJSON(message.oldConfig) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGenerateConfigReportRequest();
        if (object.newConfig !== undefined && object.newConfig !== null) {
            message.newConfig = Any.fromPartial(object.newConfig);
        }
        if (object.oldConfig !== undefined && object.oldConfig !== null) {
            message.oldConfig = Any.fromPartial(object.oldConfig);
        }
        return message;
    },
    fromSDK(object) {
        return {
            newConfig: object.new_config ? Any.fromSDK(object.new_config) : undefined,
            oldConfig: object.old_config ? Any.fromSDK(object.old_config) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            new_config: isSet(object.new_config) ? Any.fromSDKJSON(object.new_config) : undefined,
            old_config: isSet(object.old_config) ? Any.fromSDKJSON(object.old_config) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.newConfig !== undefined && (obj.new_config = message.newConfig ? Any.toSDK(message.newConfig) : undefined);
        message.oldConfig !== undefined && (obj.old_config = message.oldConfig ? Any.toSDK(message.oldConfig) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGenerateConfigReportRequest();
        if (object.new_config !== undefined && object.new_config !== null) {
            message.newConfig = Any.fromAmino(object.new_config);
        }
        if (object.old_config !== undefined && object.old_config !== null) {
            message.oldConfig = Any.fromAmino(object.old_config);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.new_config = message.newConfig ? Any.toAmino(message.newConfig) : undefined;
        obj.old_config = message.oldConfig ? Any.toAmino(message.oldConfig) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return GenerateConfigReportRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GenerateConfigReportRequest.decode(message.value);
    },
    toProto(message) {
        return GenerateConfigReportRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.GenerateConfigReportRequest",
            value: GenerateConfigReportRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseGenerateConfigReportResponse() {
    return {
        serviceName: "",
        id: "",
        changeReports: [],
        diagnostics: []
    };
}
export const GenerateConfigReportResponse = {
    typeUrl: "/google.api.servicemanagement.v1.GenerateConfigReportResponse",
    is(o) {
        return o && (o.$typeUrl === GenerateConfigReportResponse.typeUrl || typeof o.serviceName === "string" && typeof o.id === "string" && Array.isArray(o.changeReports) && (!o.changeReports.length || ChangeReport.is(o.changeReports[0])) && Array.isArray(o.diagnostics) && (!o.diagnostics.length || Diagnostic.is(o.diagnostics[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === GenerateConfigReportResponse.typeUrl || typeof o.service_name === "string" && typeof o.id === "string" && Array.isArray(o.change_reports) && (!o.change_reports.length || ChangeReport.isSDK(o.change_reports[0])) && Array.isArray(o.diagnostics) && (!o.diagnostics.length || Diagnostic.isSDK(o.diagnostics[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === GenerateConfigReportResponse.typeUrl || typeof o.service_name === "string" && typeof o.id === "string" && Array.isArray(o.change_reports) && (!o.change_reports.length || ChangeReport.isAmino(o.change_reports[0])) && Array.isArray(o.diagnostics) && (!o.diagnostics.length || Diagnostic.isAmino(o.diagnostics[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.serviceName !== undefined) {
            writer.uint32(10).string(message.serviceName);
        }
        if (message.id !== undefined) {
            writer.uint32(18).string(message.id);
        }
        for (const v of message.changeReports) {
            ChangeReport.encode(v, writer.uint32(26).fork()).ldelim();
        }
        for (const v of message.diagnostics) {
            Diagnostic.encode(v, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGenerateConfigReportResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.serviceName = reader.string();
                    break;
                case 2:
                    message.id = reader.string();
                    break;
                case 3:
                    message.changeReports.push(ChangeReport.decode(reader, reader.uint32()));
                    break;
                case 4:
                    message.diagnostics.push(Diagnostic.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGenerateConfigReportResponse();
        if (isSet(object.serviceName))
            obj.serviceName = String(object.serviceName);
        if (isSet(object.id))
            obj.id = String(object.id);
        if (Array.isArray(object?.changeReports))
            obj.changeReports = object.changeReports.map((e) => ChangeReport.fromJSON(e));
        if (Array.isArray(object?.diagnostics))
            obj.diagnostics = object.diagnostics.map((e) => Diagnostic.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.serviceName !== undefined && (obj.serviceName = message.serviceName);
        message.id !== undefined && (obj.id = message.id);
        if (message.changeReports) {
            obj.changeReports = message.changeReports.map(e => e ? ChangeReport.toJSON(e) : undefined);
        }
        else {
            obj.changeReports = [];
        }
        if (message.diagnostics) {
            obj.diagnostics = message.diagnostics.map(e => e ? Diagnostic.toJSON(e) : undefined);
        }
        else {
            obj.diagnostics = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGenerateConfigReportResponse();
        message.serviceName = object.serviceName ?? "";
        message.id = object.id ?? "";
        message.changeReports = object.changeReports?.map(e => ChangeReport.fromPartial(e)) || [];
        message.diagnostics = object.diagnostics?.map(e => Diagnostic.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            serviceName: object?.service_name,
            id: object?.id,
            changeReports: Array.isArray(object?.change_reports) ? object.change_reports.map((e) => ChangeReport.fromSDK(e)) : [],
            diagnostics: Array.isArray(object?.diagnostics) ? object.diagnostics.map((e) => Diagnostic.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            service_name: isSet(object.service_name) ? String(object.service_name) : "",
            id: isSet(object.id) ? String(object.id) : "",
            change_reports: Array.isArray(object?.change_reports) ? object.change_reports.map((e) => ChangeReport.fromSDKJSON(e)) : [],
            diagnostics: Array.isArray(object?.diagnostics) ? object.diagnostics.map((e) => Diagnostic.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service_name = message.serviceName;
        obj.id = message.id;
        if (message.changeReports) {
            obj.change_reports = message.changeReports.map(e => e ? ChangeReport.toSDK(e) : undefined);
        }
        else {
            obj.change_reports = [];
        }
        if (message.diagnostics) {
            obj.diagnostics = message.diagnostics.map(e => e ? Diagnostic.toSDK(e) : undefined);
        }
        else {
            obj.diagnostics = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGenerateConfigReportResponse();
        if (object.service_name !== undefined && object.service_name !== null) {
            message.serviceName = object.service_name;
        }
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        message.changeReports = object.change_reports?.map(e => ChangeReport.fromAmino(e)) || [];
        message.diagnostics = object.diagnostics?.map(e => Diagnostic.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service_name = message.serviceName === "" ? undefined : message.serviceName;
        obj.id = message.id === "" ? undefined : message.id;
        if (message.changeReports) {
            obj.change_reports = message.changeReports.map(e => e ? ChangeReport.toAmino(e) : undefined);
        }
        else {
            obj.change_reports = message.changeReports;
        }
        if (message.diagnostics) {
            obj.diagnostics = message.diagnostics.map(e => e ? Diagnostic.toAmino(e) : undefined);
        }
        else {
            obj.diagnostics = message.diagnostics;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return GenerateConfigReportResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GenerateConfigReportResponse.decode(message.value);
    },
    toProto(message) {
        return GenerateConfigReportResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.GenerateConfigReportResponse",
            value: GenerateConfigReportResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ChangeReport.registerTypeUrl();
        Diagnostic.registerTypeUrl();
    }
};
