import { QuotaOverride, OverrideInlineSource, Service, ConsumerQuotaMetric, AdminQuotaPolicy, ServiceIdentity, quotaViewFromJSON, quotaViewToJSON, quotaSafetyCheckFromJSON, quotaSafetyCheckToJSON } from "./resources";
import { FieldMask } from "../../../protobuf/field_mask";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { isSet } from "../../../../helpers";
export const protobufPackage = "google.api.serviceusage.v1beta1";
/** Enum for service identity state. */
export var GetServiceIdentityResponse_IdentityState;
(function (GetServiceIdentityResponse_IdentityState) {
    /**
     * IDENTITY_STATE_UNSPECIFIED - Default service identity state. This value is used if the state is
     * omitted.
     */
    GetServiceIdentityResponse_IdentityState[GetServiceIdentityResponse_IdentityState["IDENTITY_STATE_UNSPECIFIED"] = 0] = "IDENTITY_STATE_UNSPECIFIED";
    /** ACTIVE - Service identity has been created and can be used. */
    GetServiceIdentityResponse_IdentityState[GetServiceIdentityResponse_IdentityState["ACTIVE"] = 1] = "ACTIVE";
    GetServiceIdentityResponse_IdentityState[GetServiceIdentityResponse_IdentityState["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(GetServiceIdentityResponse_IdentityState || (GetServiceIdentityResponse_IdentityState = {}));
export const GetServiceIdentityResponse_IdentityStateSDKType = GetServiceIdentityResponse_IdentityState;
export const GetServiceIdentityResponse_IdentityStateAmino = GetServiceIdentityResponse_IdentityState;
export function getServiceIdentityResponse_IdentityStateFromJSON(object) {
    switch (object) {
        case 0:
        case "IDENTITY_STATE_UNSPECIFIED":
            return GetServiceIdentityResponse_IdentityState.IDENTITY_STATE_UNSPECIFIED;
        case 1:
        case "ACTIVE":
            return GetServiceIdentityResponse_IdentityState.ACTIVE;
        case -1:
        case "UNRECOGNIZED":
        default:
            return GetServiceIdentityResponse_IdentityState.UNRECOGNIZED;
    }
}
export function getServiceIdentityResponse_IdentityStateToJSON(object) {
    switch (object) {
        case GetServiceIdentityResponse_IdentityState.IDENTITY_STATE_UNSPECIFIED:
            return "IDENTITY_STATE_UNSPECIFIED";
        case GetServiceIdentityResponse_IdentityState.ACTIVE:
            return "ACTIVE";
        case GetServiceIdentityResponse_IdentityState.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
function createBaseEnableServiceRequest() {
    return {
        name: ""
    };
}
export const EnableServiceRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.EnableServiceRequest",
    is(o) {
        return o && (o.$typeUrl === EnableServiceRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === EnableServiceRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === EnableServiceRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseEnableServiceRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseEnableServiceRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseEnableServiceRequest();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseEnableServiceRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return EnableServiceRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return EnableServiceRequest.decode(message.value);
    },
    toProto(message) {
        return EnableServiceRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.EnableServiceRequest",
            value: EnableServiceRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseDisableServiceRequest() {
    return {
        name: ""
    };
}
export const DisableServiceRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.DisableServiceRequest",
    is(o) {
        return o && (o.$typeUrl === DisableServiceRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === DisableServiceRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === DisableServiceRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDisableServiceRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDisableServiceRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDisableServiceRequest();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDisableServiceRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return DisableServiceRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return DisableServiceRequest.decode(message.value);
    },
    toProto(message) {
        return DisableServiceRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.DisableServiceRequest",
            value: DisableServiceRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseGetServiceRequest() {
    return {
        name: ""
    };
}
export const GetServiceRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.GetServiceRequest",
    is(o) {
        return o && (o.$typeUrl === GetServiceRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === GetServiceRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === GetServiceRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetServiceRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGetServiceRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGetServiceRequest();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGetServiceRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return GetServiceRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetServiceRequest.decode(message.value);
    },
    toProto(message) {
        return GetServiceRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.GetServiceRequest",
            value: GetServiceRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListServicesRequest() {
    return {
        parent: "",
        pageSize: 0,
        pageToken: "",
        filter: ""
    };
}
export const ListServicesRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.ListServicesRequest",
    is(o) {
        return o && (o.$typeUrl === ListServicesRequest.typeUrl || typeof o.parent === "string" && typeof o.pageSize === "number" && typeof o.pageToken === "string" && typeof o.filter === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListServicesRequest.typeUrl || typeof o.parent === "string" && typeof o.page_size === "number" && typeof o.page_token === "string" && typeof o.filter === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListServicesRequest.typeUrl || typeof o.parent === "string" && typeof o.page_size === "number" && typeof o.page_token === "string" && typeof o.filter === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.pageSize !== undefined) {
            writer.uint32(16).int32(message.pageSize);
        }
        if (message.pageToken !== undefined) {
            writer.uint32(26).string(message.pageToken);
        }
        if (message.filter !== undefined) {
            writer.uint32(34).string(message.filter);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListServicesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.pageSize = reader.int32();
                    break;
                case 3:
                    message.pageToken = reader.string();
                    break;
                case 4:
                    message.filter = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListServicesRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.pageSize))
            obj.pageSize = Number(object.pageSize);
        if (isSet(object.pageToken))
            obj.pageToken = String(object.pageToken);
        if (isSet(object.filter))
            obj.filter = String(object.filter);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.pageSize !== undefined && (obj.pageSize = Math.round(message.pageSize));
        message.pageToken !== undefined && (obj.pageToken = message.pageToken);
        message.filter !== undefined && (obj.filter = message.filter);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListServicesRequest();
        message.parent = object.parent ?? "";
        message.pageSize = object.pageSize ?? 0;
        message.pageToken = object.pageToken ?? "";
        message.filter = object.filter ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            pageSize: object?.page_size,
            pageToken: object?.page_token,
            filter: object?.filter
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            page_size: isSet(object.page_size) ? Number(object.page_size) : 0,
            page_token: isSet(object.page_token) ? String(object.page_token) : "",
            filter: isSet(object.filter) ? String(object.filter) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        obj.page_size = message.pageSize;
        obj.page_token = message.pageToken;
        obj.filter = message.filter;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListServicesRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.page_size !== undefined && object.page_size !== null) {
            message.pageSize = object.page_size;
        }
        if (object.page_token !== undefined && object.page_token !== null) {
            message.pageToken = object.page_token;
        }
        if (object.filter !== undefined && object.filter !== null) {
            message.filter = object.filter;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.page_size = message.pageSize === 0 ? undefined : message.pageSize;
        obj.page_token = message.pageToken === "" ? undefined : message.pageToken;
        obj.filter = message.filter === "" ? undefined : message.filter;
        return obj;
    },
    fromAminoMsg(object) {
        return ListServicesRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListServicesRequest.decode(message.value);
    },
    toProto(message) {
        return ListServicesRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ListServicesRequest",
            value: ListServicesRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListServicesResponse() {
    return {
        services: [],
        nextPageToken: ""
    };
}
export const ListServicesResponse = {
    typeUrl: "/google.api.serviceusage.v1beta1.ListServicesResponse",
    is(o) {
        return o && (o.$typeUrl === ListServicesResponse.typeUrl || Array.isArray(o.services) && (!o.services.length || Service.is(o.services[0])) && typeof o.nextPageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListServicesResponse.typeUrl || Array.isArray(o.services) && (!o.services.length || Service.isSDK(o.services[0])) && typeof o.next_page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListServicesResponse.typeUrl || Array.isArray(o.services) && (!o.services.length || Service.isAmino(o.services[0])) && typeof o.next_page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.services) {
            Service.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.nextPageToken !== undefined) {
            writer.uint32(18).string(message.nextPageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListServicesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.services.push(Service.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.nextPageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListServicesResponse();
        if (Array.isArray(object?.services))
            obj.services = object.services.map((e) => Service.fromJSON(e));
        if (isSet(object.nextPageToken))
            obj.nextPageToken = String(object.nextPageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.services) {
            obj.services = message.services.map(e => e ? Service.toJSON(e) : undefined);
        }
        else {
            obj.services = [];
        }
        message.nextPageToken !== undefined && (obj.nextPageToken = message.nextPageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListServicesResponse();
        message.services = object.services?.map(e => Service.fromPartial(e)) || [];
        message.nextPageToken = object.nextPageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            services: Array.isArray(object?.services) ? object.services.map((e) => Service.fromSDK(e)) : [],
            nextPageToken: object?.next_page_token
        };
    },
    fromSDKJSON(object) {
        return {
            services: Array.isArray(object?.services) ? object.services.map((e) => Service.fromSDKJSON(e)) : [],
            next_page_token: isSet(object.next_page_token) ? String(object.next_page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.services) {
            obj.services = message.services.map(e => e ? Service.toSDK(e) : undefined);
        }
        else {
            obj.services = [];
        }
        obj.next_page_token = message.nextPageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListServicesResponse();
        message.services = object.services?.map(e => Service.fromAmino(e)) || [];
        if (object.next_page_token !== undefined && object.next_page_token !== null) {
            message.nextPageToken = object.next_page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.services) {
            obj.services = message.services.map(e => e ? Service.toAmino(e) : undefined);
        }
        else {
            obj.services = message.services;
        }
        obj.next_page_token = message.nextPageToken === "" ? undefined : message.nextPageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListServicesResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListServicesResponse.decode(message.value);
    },
    toProto(message) {
        return ListServicesResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ListServicesResponse",
            value: ListServicesResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Service.registerTypeUrl();
    }
};
function createBaseBatchEnableServicesRequest() {
    return {
        parent: "",
        serviceIds: []
    };
}
export const BatchEnableServicesRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.BatchEnableServicesRequest",
    is(o) {
        return o && (o.$typeUrl === BatchEnableServicesRequest.typeUrl || typeof o.parent === "string" && Array.isArray(o.serviceIds) && (!o.serviceIds.length || typeof o.serviceIds[0] === "string"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === BatchEnableServicesRequest.typeUrl || typeof o.parent === "string" && Array.isArray(o.service_ids) && (!o.service_ids.length || typeof o.service_ids[0] === "string"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === BatchEnableServicesRequest.typeUrl || typeof o.parent === "string" && Array.isArray(o.service_ids) && (!o.service_ids.length || typeof o.service_ids[0] === "string"));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        for (const v of message.serviceIds) {
            writer.uint32(18).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseBatchEnableServicesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.serviceIds.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseBatchEnableServicesRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (Array.isArray(object?.serviceIds))
            obj.serviceIds = object.serviceIds.map((e) => String(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        if (message.serviceIds) {
            obj.serviceIds = message.serviceIds.map(e => e);
        }
        else {
            obj.serviceIds = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseBatchEnableServicesRequest();
        message.parent = object.parent ?? "";
        message.serviceIds = object.serviceIds?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            serviceIds: Array.isArray(object?.service_ids) ? object.service_ids.map((e) => e) : []
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            service_ids: Array.isArray(object?.service_ids) ? object.service_ids.map((e) => String(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        if (message.serviceIds) {
            obj.service_ids = message.serviceIds.map(e => e);
        }
        else {
            obj.service_ids = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseBatchEnableServicesRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        message.serviceIds = object.service_ids?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        if (message.serviceIds) {
            obj.service_ids = message.serviceIds.map(e => e);
        }
        else {
            obj.service_ids = message.serviceIds;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return BatchEnableServicesRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return BatchEnableServicesRequest.decode(message.value);
    },
    toProto(message) {
        return BatchEnableServicesRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.BatchEnableServicesRequest",
            value: BatchEnableServicesRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListConsumerQuotaMetricsRequest() {
    return {
        parent: "",
        pageSize: 0,
        pageToken: "",
        view: 0
    };
}
export const ListConsumerQuotaMetricsRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.ListConsumerQuotaMetricsRequest",
    is(o) {
        return o && (o.$typeUrl === ListConsumerQuotaMetricsRequest.typeUrl || typeof o.parent === "string" && typeof o.pageSize === "number" && typeof o.pageToken === "string" && isSet(o.view));
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListConsumerQuotaMetricsRequest.typeUrl || typeof o.parent === "string" && typeof o.page_size === "number" && typeof o.page_token === "string" && isSet(o.view));
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListConsumerQuotaMetricsRequest.typeUrl || typeof o.parent === "string" && typeof o.page_size === "number" && typeof o.page_token === "string" && isSet(o.view));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.pageSize !== undefined) {
            writer.uint32(16).int32(message.pageSize);
        }
        if (message.pageToken !== undefined) {
            writer.uint32(26).string(message.pageToken);
        }
        if (message.view !== 0) {
            writer.uint32(32).int32(message.view);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListConsumerQuotaMetricsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.pageSize = reader.int32();
                    break;
                case 3:
                    message.pageToken = reader.string();
                    break;
                case 4:
                    message.view = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListConsumerQuotaMetricsRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.pageSize))
            obj.pageSize = Number(object.pageSize);
        if (isSet(object.pageToken))
            obj.pageToken = String(object.pageToken);
        if (isSet(object.view))
            obj.view = quotaViewFromJSON(object.view);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.pageSize !== undefined && (obj.pageSize = Math.round(message.pageSize));
        message.pageToken !== undefined && (obj.pageToken = message.pageToken);
        message.view !== undefined && (obj.view = quotaViewToJSON(message.view));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListConsumerQuotaMetricsRequest();
        message.parent = object.parent ?? "";
        message.pageSize = object.pageSize ?? 0;
        message.pageToken = object.pageToken ?? "";
        message.view = object.view ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            pageSize: object?.page_size,
            pageToken: object?.page_token,
            view: isSet(object.view) ? quotaViewFromJSON(object.view) : -1
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            page_size: isSet(object.page_size) ? Number(object.page_size) : 0,
            page_token: isSet(object.page_token) ? String(object.page_token) : "",
            view: isSet(object.view) ? quotaViewFromJSON(object.view) : -1
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        obj.page_size = message.pageSize;
        obj.page_token = message.pageToken;
        message.view !== undefined && (obj.view = quotaViewToJSON(message.view));
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListConsumerQuotaMetricsRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.page_size !== undefined && object.page_size !== null) {
            message.pageSize = object.page_size;
        }
        if (object.page_token !== undefined && object.page_token !== null) {
            message.pageToken = object.page_token;
        }
        if (object.view !== undefined && object.view !== null) {
            message.view = object.view;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.page_size = message.pageSize === 0 ? undefined : message.pageSize;
        obj.page_token = message.pageToken === "" ? undefined : message.pageToken;
        obj.view = message.view === 0 ? undefined : message.view;
        return obj;
    },
    fromAminoMsg(object) {
        return ListConsumerQuotaMetricsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListConsumerQuotaMetricsRequest.decode(message.value);
    },
    toProto(message) {
        return ListConsumerQuotaMetricsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ListConsumerQuotaMetricsRequest",
            value: ListConsumerQuotaMetricsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListConsumerQuotaMetricsResponse() {
    return {
        metrics: [],
        nextPageToken: ""
    };
}
export const ListConsumerQuotaMetricsResponse = {
    typeUrl: "/google.api.serviceusage.v1beta1.ListConsumerQuotaMetricsResponse",
    is(o) {
        return o && (o.$typeUrl === ListConsumerQuotaMetricsResponse.typeUrl || Array.isArray(o.metrics) && (!o.metrics.length || ConsumerQuotaMetric.is(o.metrics[0])) && typeof o.nextPageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListConsumerQuotaMetricsResponse.typeUrl || Array.isArray(o.metrics) && (!o.metrics.length || ConsumerQuotaMetric.isSDK(o.metrics[0])) && typeof o.next_page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListConsumerQuotaMetricsResponse.typeUrl || Array.isArray(o.metrics) && (!o.metrics.length || ConsumerQuotaMetric.isAmino(o.metrics[0])) && typeof o.next_page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.metrics) {
            ConsumerQuotaMetric.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.nextPageToken !== undefined) {
            writer.uint32(18).string(message.nextPageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListConsumerQuotaMetricsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.metrics.push(ConsumerQuotaMetric.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.nextPageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListConsumerQuotaMetricsResponse();
        if (Array.isArray(object?.metrics))
            obj.metrics = object.metrics.map((e) => ConsumerQuotaMetric.fromJSON(e));
        if (isSet(object.nextPageToken))
            obj.nextPageToken = String(object.nextPageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.metrics) {
            obj.metrics = message.metrics.map(e => e ? ConsumerQuotaMetric.toJSON(e) : undefined);
        }
        else {
            obj.metrics = [];
        }
        message.nextPageToken !== undefined && (obj.nextPageToken = message.nextPageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListConsumerQuotaMetricsResponse();
        message.metrics = object.metrics?.map(e => ConsumerQuotaMetric.fromPartial(e)) || [];
        message.nextPageToken = object.nextPageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            metrics: Array.isArray(object?.metrics) ? object.metrics.map((e) => ConsumerQuotaMetric.fromSDK(e)) : [],
            nextPageToken: object?.next_page_token
        };
    },
    fromSDKJSON(object) {
        return {
            metrics: Array.isArray(object?.metrics) ? object.metrics.map((e) => ConsumerQuotaMetric.fromSDKJSON(e)) : [],
            next_page_token: isSet(object.next_page_token) ? String(object.next_page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.metrics) {
            obj.metrics = message.metrics.map(e => e ? ConsumerQuotaMetric.toSDK(e) : undefined);
        }
        else {
            obj.metrics = [];
        }
        obj.next_page_token = message.nextPageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListConsumerQuotaMetricsResponse();
        message.metrics = object.metrics?.map(e => ConsumerQuotaMetric.fromAmino(e)) || [];
        if (object.next_page_token !== undefined && object.next_page_token !== null) {
            message.nextPageToken = object.next_page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.metrics) {
            obj.metrics = message.metrics.map(e => e ? ConsumerQuotaMetric.toAmino(e) : undefined);
        }
        else {
            obj.metrics = message.metrics;
        }
        obj.next_page_token = message.nextPageToken === "" ? undefined : message.nextPageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListConsumerQuotaMetricsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListConsumerQuotaMetricsResponse.decode(message.value);
    },
    toProto(message) {
        return ListConsumerQuotaMetricsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ListConsumerQuotaMetricsResponse",
            value: ListConsumerQuotaMetricsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ConsumerQuotaMetric.registerTypeUrl();
    }
};
function createBaseGetConsumerQuotaMetricRequest() {
    return {
        name: "",
        view: 0
    };
}
export const GetConsumerQuotaMetricRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.GetConsumerQuotaMetricRequest",
    is(o) {
        return o && (o.$typeUrl === GetConsumerQuotaMetricRequest.typeUrl || typeof o.name === "string" && isSet(o.view));
    },
    isSDK(o) {
        return o && (o.$typeUrl === GetConsumerQuotaMetricRequest.typeUrl || typeof o.name === "string" && isSet(o.view));
    },
    isAmino(o) {
        return o && (o.$typeUrl === GetConsumerQuotaMetricRequest.typeUrl || typeof o.name === "string" && isSet(o.view));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.view !== 0) {
            writer.uint32(16).int32(message.view);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetConsumerQuotaMetricRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.view = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGetConsumerQuotaMetricRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.view))
            obj.view = quotaViewFromJSON(object.view);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.view !== undefined && (obj.view = quotaViewToJSON(message.view));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGetConsumerQuotaMetricRequest();
        message.name = object.name ?? "";
        message.view = object.view ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            view: isSet(object.view) ? quotaViewFromJSON(object.view) : -1
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            view: isSet(object.view) ? quotaViewFromJSON(object.view) : -1
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        message.view !== undefined && (obj.view = quotaViewToJSON(message.view));
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGetConsumerQuotaMetricRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.view !== undefined && object.view !== null) {
            message.view = object.view;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.view = message.view === 0 ? undefined : message.view;
        return obj;
    },
    fromAminoMsg(object) {
        return GetConsumerQuotaMetricRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetConsumerQuotaMetricRequest.decode(message.value);
    },
    toProto(message) {
        return GetConsumerQuotaMetricRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.GetConsumerQuotaMetricRequest",
            value: GetConsumerQuotaMetricRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseGetConsumerQuotaLimitRequest() {
    return {
        name: "",
        view: 0
    };
}
export const GetConsumerQuotaLimitRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.GetConsumerQuotaLimitRequest",
    is(o) {
        return o && (o.$typeUrl === GetConsumerQuotaLimitRequest.typeUrl || typeof o.name === "string" && isSet(o.view));
    },
    isSDK(o) {
        return o && (o.$typeUrl === GetConsumerQuotaLimitRequest.typeUrl || typeof o.name === "string" && isSet(o.view));
    },
    isAmino(o) {
        return o && (o.$typeUrl === GetConsumerQuotaLimitRequest.typeUrl || typeof o.name === "string" && isSet(o.view));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.view !== 0) {
            writer.uint32(16).int32(message.view);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetConsumerQuotaLimitRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.view = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGetConsumerQuotaLimitRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.view))
            obj.view = quotaViewFromJSON(object.view);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.view !== undefined && (obj.view = quotaViewToJSON(message.view));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGetConsumerQuotaLimitRequest();
        message.name = object.name ?? "";
        message.view = object.view ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            view: isSet(object.view) ? quotaViewFromJSON(object.view) : -1
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            view: isSet(object.view) ? quotaViewFromJSON(object.view) : -1
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        message.view !== undefined && (obj.view = quotaViewToJSON(message.view));
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGetConsumerQuotaLimitRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.view !== undefined && object.view !== null) {
            message.view = object.view;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.view = message.view === 0 ? undefined : message.view;
        return obj;
    },
    fromAminoMsg(object) {
        return GetConsumerQuotaLimitRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetConsumerQuotaLimitRequest.decode(message.value);
    },
    toProto(message) {
        return GetConsumerQuotaLimitRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.GetConsumerQuotaLimitRequest",
            value: GetConsumerQuotaLimitRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseCreateAdminOverrideRequest() {
    return {
        parent: "",
        override: undefined,
        force: false,
        forceOnly: []
    };
}
export const CreateAdminOverrideRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.CreateAdminOverrideRequest",
    is(o) {
        return o && (o.$typeUrl === CreateAdminOverrideRequest.typeUrl || typeof o.parent === "string" && typeof o.force === "boolean" && Array.isArray(o.forceOnly));
    },
    isSDK(o) {
        return o && (o.$typeUrl === CreateAdminOverrideRequest.typeUrl || typeof o.parent === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    isAmino(o) {
        return o && (o.$typeUrl === CreateAdminOverrideRequest.typeUrl || typeof o.parent === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.override !== undefined) {
            QuotaOverride.encode(message.override, writer.uint32(18).fork()).ldelim();
        }
        if (message.force !== undefined) {
            writer.uint32(24).bool(message.force);
        }
        writer.uint32(34).fork();
        for (const v of message.forceOnly) {
            writer.int32(v);
        }
        writer.ldelim();
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCreateAdminOverrideRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.override = QuotaOverride.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.force = reader.bool();
                    break;
                case 4:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.forceOnly.push(reader.int32());
                        }
                    }
                    else {
                        message.forceOnly.push(reader.int32());
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCreateAdminOverrideRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.override))
            obj.override = QuotaOverride.fromJSON(object.override);
        if (isSet(object.force))
            obj.force = Boolean(object.force);
        if (Array.isArray(object?.forceOnly))
            obj.forceOnly = object.forceOnly.map((e) => quotaSafetyCheckFromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.override !== undefined && (obj.override = message.override ? QuotaOverride.toJSON(message.override) : undefined);
        message.force !== undefined && (obj.force = message.force);
        if (message.forceOnly) {
            obj.forceOnly = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.forceOnly = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCreateAdminOverrideRequest();
        message.parent = object.parent ?? "";
        if (object.override !== undefined && object.override !== null) {
            message.override = QuotaOverride.fromPartial(object.override);
        }
        message.force = object.force ?? false;
        message.forceOnly = object.forceOnly?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            override: object.override ? QuotaOverride.fromSDK(object.override) : undefined,
            force: object?.force,
            forceOnly: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            override: isSet(object.override) ? QuotaOverride.fromSDKJSON(object.override) : undefined,
            force: isSet(object.force) ? Boolean(object.force) : false,
            force_only: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        message.override !== undefined && (obj.override = message.override ? QuotaOverride.toSDK(message.override) : undefined);
        obj.force = message.force;
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.force_only = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCreateAdminOverrideRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.override !== undefined && object.override !== null) {
            message.override = QuotaOverride.fromAmino(object.override);
        }
        if (object.force !== undefined && object.force !== null) {
            message.force = object.force;
        }
        message.forceOnly = object.force_only?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.override = message.override ? QuotaOverride.toAmino(message.override) : undefined;
        obj.force = message.force === false ? undefined : message.force;
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => e);
        }
        else {
            obj.force_only = message.forceOnly;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return CreateAdminOverrideRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CreateAdminOverrideRequest.decode(message.value);
    },
    toProto(message) {
        return CreateAdminOverrideRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.CreateAdminOverrideRequest",
            value: CreateAdminOverrideRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        QuotaOverride.registerTypeUrl();
    }
};
function createBaseUpdateAdminOverrideRequest() {
    return {
        name: "",
        override: undefined,
        force: false,
        updateMask: undefined,
        forceOnly: []
    };
}
export const UpdateAdminOverrideRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.UpdateAdminOverrideRequest",
    is(o) {
        return o && (o.$typeUrl === UpdateAdminOverrideRequest.typeUrl || typeof o.name === "string" && typeof o.force === "boolean" && Array.isArray(o.forceOnly));
    },
    isSDK(o) {
        return o && (o.$typeUrl === UpdateAdminOverrideRequest.typeUrl || typeof o.name === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    isAmino(o) {
        return o && (o.$typeUrl === UpdateAdminOverrideRequest.typeUrl || typeof o.name === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.override !== undefined) {
            QuotaOverride.encode(message.override, writer.uint32(18).fork()).ldelim();
        }
        if (message.force !== undefined) {
            writer.uint32(24).bool(message.force);
        }
        if (message.updateMask !== undefined) {
            FieldMask.encode(message.updateMask, writer.uint32(34).fork()).ldelim();
        }
        writer.uint32(42).fork();
        for (const v of message.forceOnly) {
            writer.int32(v);
        }
        writer.ldelim();
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUpdateAdminOverrideRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.override = QuotaOverride.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.force = reader.bool();
                    break;
                case 4:
                    message.updateMask = FieldMask.decode(reader, reader.uint32());
                    break;
                case 5:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.forceOnly.push(reader.int32());
                        }
                    }
                    else {
                        message.forceOnly.push(reader.int32());
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseUpdateAdminOverrideRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.override))
            obj.override = QuotaOverride.fromJSON(object.override);
        if (isSet(object.force))
            obj.force = Boolean(object.force);
        if (isSet(object.updateMask))
            obj.updateMask = FieldMask.fromJSON(object.updateMask);
        if (Array.isArray(object?.forceOnly))
            obj.forceOnly = object.forceOnly.map((e) => quotaSafetyCheckFromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.override !== undefined && (obj.override = message.override ? QuotaOverride.toJSON(message.override) : undefined);
        message.force !== undefined && (obj.force = message.force);
        message.updateMask !== undefined && (obj.updateMask = message.updateMask ? FieldMask.toJSON(message.updateMask) : undefined);
        if (message.forceOnly) {
            obj.forceOnly = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.forceOnly = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseUpdateAdminOverrideRequest();
        message.name = object.name ?? "";
        if (object.override !== undefined && object.override !== null) {
            message.override = QuotaOverride.fromPartial(object.override);
        }
        message.force = object.force ?? false;
        if (object.updateMask !== undefined && object.updateMask !== null) {
            message.updateMask = FieldMask.fromPartial(object.updateMask);
        }
        message.forceOnly = object.forceOnly?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            override: object.override ? QuotaOverride.fromSDK(object.override) : undefined,
            force: object?.force,
            updateMask: object.update_mask ? FieldMask.fromSDK(object.update_mask) : undefined,
            forceOnly: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            override: isSet(object.override) ? QuotaOverride.fromSDKJSON(object.override) : undefined,
            force: isSet(object.force) ? Boolean(object.force) : false,
            update_mask: isSet(object.update_mask) ? FieldMask.fromSDKJSON(object.update_mask) : undefined,
            force_only: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        message.override !== undefined && (obj.override = message.override ? QuotaOverride.toSDK(message.override) : undefined);
        obj.force = message.force;
        message.updateMask !== undefined && (obj.update_mask = message.updateMask ? FieldMask.toSDK(message.updateMask) : undefined);
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.force_only = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseUpdateAdminOverrideRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.override !== undefined && object.override !== null) {
            message.override = QuotaOverride.fromAmino(object.override);
        }
        if (object.force !== undefined && object.force !== null) {
            message.force = object.force;
        }
        if (object.update_mask !== undefined && object.update_mask !== null) {
            message.updateMask = FieldMask.fromAmino(object.update_mask);
        }
        message.forceOnly = object.force_only?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.override = message.override ? QuotaOverride.toAmino(message.override) : undefined;
        obj.force = message.force === false ? undefined : message.force;
        obj.update_mask = message.updateMask ? FieldMask.toAmino(message.updateMask) : undefined;
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => e);
        }
        else {
            obj.force_only = message.forceOnly;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return UpdateAdminOverrideRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return UpdateAdminOverrideRequest.decode(message.value);
    },
    toProto(message) {
        return UpdateAdminOverrideRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.UpdateAdminOverrideRequest",
            value: UpdateAdminOverrideRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        QuotaOverride.registerTypeUrl();
        FieldMask.registerTypeUrl();
    }
};
function createBaseDeleteAdminOverrideRequest() {
    return {
        name: "",
        force: false,
        forceOnly: []
    };
}
export const DeleteAdminOverrideRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.DeleteAdminOverrideRequest",
    is(o) {
        return o && (o.$typeUrl === DeleteAdminOverrideRequest.typeUrl || typeof o.name === "string" && typeof o.force === "boolean" && Array.isArray(o.forceOnly));
    },
    isSDK(o) {
        return o && (o.$typeUrl === DeleteAdminOverrideRequest.typeUrl || typeof o.name === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    isAmino(o) {
        return o && (o.$typeUrl === DeleteAdminOverrideRequest.typeUrl || typeof o.name === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.force !== undefined) {
            writer.uint32(16).bool(message.force);
        }
        writer.uint32(26).fork();
        for (const v of message.forceOnly) {
            writer.int32(v);
        }
        writer.ldelim();
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeleteAdminOverrideRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.force = reader.bool();
                    break;
                case 3:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.forceOnly.push(reader.int32());
                        }
                    }
                    else {
                        message.forceOnly.push(reader.int32());
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDeleteAdminOverrideRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.force))
            obj.force = Boolean(object.force);
        if (Array.isArray(object?.forceOnly))
            obj.forceOnly = object.forceOnly.map((e) => quotaSafetyCheckFromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.force !== undefined && (obj.force = message.force);
        if (message.forceOnly) {
            obj.forceOnly = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.forceOnly = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDeleteAdminOverrideRequest();
        message.name = object.name ?? "";
        message.force = object.force ?? false;
        message.forceOnly = object.forceOnly?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            force: object?.force,
            forceOnly: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            force: isSet(object.force) ? Boolean(object.force) : false,
            force_only: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.force = message.force;
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.force_only = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDeleteAdminOverrideRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.force !== undefined && object.force !== null) {
            message.force = object.force;
        }
        message.forceOnly = object.force_only?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.force = message.force === false ? undefined : message.force;
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => e);
        }
        else {
            obj.force_only = message.forceOnly;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return DeleteAdminOverrideRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return DeleteAdminOverrideRequest.decode(message.value);
    },
    toProto(message) {
        return DeleteAdminOverrideRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.DeleteAdminOverrideRequest",
            value: DeleteAdminOverrideRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListAdminOverridesRequest() {
    return {
        parent: "",
        pageSize: 0,
        pageToken: ""
    };
}
export const ListAdminOverridesRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.ListAdminOverridesRequest",
    is(o) {
        return o && (o.$typeUrl === ListAdminOverridesRequest.typeUrl || typeof o.parent === "string" && typeof o.pageSize === "number" && typeof o.pageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListAdminOverridesRequest.typeUrl || typeof o.parent === "string" && typeof o.page_size === "number" && typeof o.page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListAdminOverridesRequest.typeUrl || typeof o.parent === "string" && typeof o.page_size === "number" && typeof o.page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.pageSize !== undefined) {
            writer.uint32(16).int32(message.pageSize);
        }
        if (message.pageToken !== undefined) {
            writer.uint32(26).string(message.pageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListAdminOverridesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.pageSize = reader.int32();
                    break;
                case 3:
                    message.pageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListAdminOverridesRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.pageSize))
            obj.pageSize = Number(object.pageSize);
        if (isSet(object.pageToken))
            obj.pageToken = String(object.pageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.pageSize !== undefined && (obj.pageSize = Math.round(message.pageSize));
        message.pageToken !== undefined && (obj.pageToken = message.pageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListAdminOverridesRequest();
        message.parent = object.parent ?? "";
        message.pageSize = object.pageSize ?? 0;
        message.pageToken = object.pageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            pageSize: object?.page_size,
            pageToken: object?.page_token
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            page_size: isSet(object.page_size) ? Number(object.page_size) : 0,
            page_token: isSet(object.page_token) ? String(object.page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        obj.page_size = message.pageSize;
        obj.page_token = message.pageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListAdminOverridesRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.page_size !== undefined && object.page_size !== null) {
            message.pageSize = object.page_size;
        }
        if (object.page_token !== undefined && object.page_token !== null) {
            message.pageToken = object.page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.page_size = message.pageSize === 0 ? undefined : message.pageSize;
        obj.page_token = message.pageToken === "" ? undefined : message.pageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListAdminOverridesRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListAdminOverridesRequest.decode(message.value);
    },
    toProto(message) {
        return ListAdminOverridesRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ListAdminOverridesRequest",
            value: ListAdminOverridesRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListAdminOverridesResponse() {
    return {
        overrides: [],
        nextPageToken: ""
    };
}
export const ListAdminOverridesResponse = {
    typeUrl: "/google.api.serviceusage.v1beta1.ListAdminOverridesResponse",
    is(o) {
        return o && (o.$typeUrl === ListAdminOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.is(o.overrides[0])) && typeof o.nextPageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListAdminOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.isSDK(o.overrides[0])) && typeof o.next_page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListAdminOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.isAmino(o.overrides[0])) && typeof o.next_page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.overrides) {
            QuotaOverride.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.nextPageToken !== undefined) {
            writer.uint32(18).string(message.nextPageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListAdminOverridesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.overrides.push(QuotaOverride.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.nextPageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListAdminOverridesResponse();
        if (Array.isArray(object?.overrides))
            obj.overrides = object.overrides.map((e) => QuotaOverride.fromJSON(e));
        if (isSet(object.nextPageToken))
            obj.nextPageToken = String(object.nextPageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toJSON(e) : undefined);
        }
        else {
            obj.overrides = [];
        }
        message.nextPageToken !== undefined && (obj.nextPageToken = message.nextPageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListAdminOverridesResponse();
        message.overrides = object.overrides?.map(e => QuotaOverride.fromPartial(e)) || [];
        message.nextPageToken = object.nextPageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            overrides: Array.isArray(object?.overrides) ? object.overrides.map((e) => QuotaOverride.fromSDK(e)) : [],
            nextPageToken: object?.next_page_token
        };
    },
    fromSDKJSON(object) {
        return {
            overrides: Array.isArray(object?.overrides) ? object.overrides.map((e) => QuotaOverride.fromSDKJSON(e)) : [],
            next_page_token: isSet(object.next_page_token) ? String(object.next_page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toSDK(e) : undefined);
        }
        else {
            obj.overrides = [];
        }
        obj.next_page_token = message.nextPageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListAdminOverridesResponse();
        message.overrides = object.overrides?.map(e => QuotaOverride.fromAmino(e)) || [];
        if (object.next_page_token !== undefined && object.next_page_token !== null) {
            message.nextPageToken = object.next_page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toAmino(e) : undefined);
        }
        else {
            obj.overrides = message.overrides;
        }
        obj.next_page_token = message.nextPageToken === "" ? undefined : message.nextPageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListAdminOverridesResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListAdminOverridesResponse.decode(message.value);
    },
    toProto(message) {
        return ListAdminOverridesResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ListAdminOverridesResponse",
            value: ListAdminOverridesResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        QuotaOverride.registerTypeUrl();
    }
};
function createBaseBatchCreateAdminOverridesResponse() {
    return {
        overrides: []
    };
}
export const BatchCreateAdminOverridesResponse = {
    typeUrl: "/google.api.serviceusage.v1beta1.BatchCreateAdminOverridesResponse",
    is(o) {
        return o && (o.$typeUrl === BatchCreateAdminOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.is(o.overrides[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === BatchCreateAdminOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.isSDK(o.overrides[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === BatchCreateAdminOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.isAmino(o.overrides[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.overrides) {
            QuotaOverride.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseBatchCreateAdminOverridesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.overrides.push(QuotaOverride.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseBatchCreateAdminOverridesResponse();
        if (Array.isArray(object?.overrides))
            obj.overrides = object.overrides.map((e) => QuotaOverride.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toJSON(e) : undefined);
        }
        else {
            obj.overrides = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseBatchCreateAdminOverridesResponse();
        message.overrides = object.overrides?.map(e => QuotaOverride.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            overrides: Array.isArray(object?.overrides) ? object.overrides.map((e) => QuotaOverride.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            overrides: Array.isArray(object?.overrides) ? object.overrides.map((e) => QuotaOverride.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toSDK(e) : undefined);
        }
        else {
            obj.overrides = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseBatchCreateAdminOverridesResponse();
        message.overrides = object.overrides?.map(e => QuotaOverride.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toAmino(e) : undefined);
        }
        else {
            obj.overrides = message.overrides;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return BatchCreateAdminOverridesResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return BatchCreateAdminOverridesResponse.decode(message.value);
    },
    toProto(message) {
        return BatchCreateAdminOverridesResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.BatchCreateAdminOverridesResponse",
            value: BatchCreateAdminOverridesResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        QuotaOverride.registerTypeUrl();
    }
};
function createBaseImportAdminOverridesRequest() {
    return {
        parent: "",
        inlineSource: undefined,
        force: false,
        forceOnly: []
    };
}
export const ImportAdminOverridesRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportAdminOverridesRequest",
    is(o) {
        return o && (o.$typeUrl === ImportAdminOverridesRequest.typeUrl || typeof o.parent === "string" && typeof o.force === "boolean" && Array.isArray(o.forceOnly));
    },
    isSDK(o) {
        return o && (o.$typeUrl === ImportAdminOverridesRequest.typeUrl || typeof o.parent === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    isAmino(o) {
        return o && (o.$typeUrl === ImportAdminOverridesRequest.typeUrl || typeof o.parent === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.inlineSource !== undefined) {
            OverrideInlineSource.encode(message.inlineSource, writer.uint32(18).fork()).ldelim();
        }
        if (message.force !== undefined) {
            writer.uint32(24).bool(message.force);
        }
        writer.uint32(34).fork();
        for (const v of message.forceOnly) {
            writer.int32(v);
        }
        writer.ldelim();
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseImportAdminOverridesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.inlineSource = OverrideInlineSource.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.force = reader.bool();
                    break;
                case 4:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.forceOnly.push(reader.int32());
                        }
                    }
                    else {
                        message.forceOnly.push(reader.int32());
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseImportAdminOverridesRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.inlineSource))
            obj.inlineSource = OverrideInlineSource.fromJSON(object.inlineSource);
        if (isSet(object.force))
            obj.force = Boolean(object.force);
        if (Array.isArray(object?.forceOnly))
            obj.forceOnly = object.forceOnly.map((e) => quotaSafetyCheckFromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.inlineSource !== undefined && (obj.inlineSource = message.inlineSource ? OverrideInlineSource.toJSON(message.inlineSource) : undefined);
        message.force !== undefined && (obj.force = message.force);
        if (message.forceOnly) {
            obj.forceOnly = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.forceOnly = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseImportAdminOverridesRequest();
        message.parent = object.parent ?? "";
        if (object.inlineSource !== undefined && object.inlineSource !== null) {
            message.inlineSource = OverrideInlineSource.fromPartial(object.inlineSource);
        }
        message.force = object.force ?? false;
        message.forceOnly = object.forceOnly?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            inlineSource: object.inline_source ? OverrideInlineSource.fromSDK(object.inline_source) : undefined,
            force: object?.force,
            forceOnly: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            inline_source: isSet(object.inline_source) ? OverrideInlineSource.fromSDKJSON(object.inline_source) : undefined,
            force: isSet(object.force) ? Boolean(object.force) : false,
            force_only: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        message.inlineSource !== undefined && (obj.inline_source = message.inlineSource ? OverrideInlineSource.toSDK(message.inlineSource) : undefined);
        obj.force = message.force;
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.force_only = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseImportAdminOverridesRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.inline_source !== undefined && object.inline_source !== null) {
            message.inlineSource = OverrideInlineSource.fromAmino(object.inline_source);
        }
        if (object.force !== undefined && object.force !== null) {
            message.force = object.force;
        }
        message.forceOnly = object.force_only?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.inline_source = message.inlineSource ? OverrideInlineSource.toAmino(message.inlineSource) : undefined;
        obj.force = message.force === false ? undefined : message.force;
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => e);
        }
        else {
            obj.force_only = message.forceOnly;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return ImportAdminOverridesRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ImportAdminOverridesRequest.decode(message.value);
    },
    toProto(message) {
        return ImportAdminOverridesRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ImportAdminOverridesRequest",
            value: ImportAdminOverridesRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        OverrideInlineSource.registerTypeUrl();
    }
};
function createBaseImportAdminOverridesResponse() {
    return {
        overrides: []
    };
}
export const ImportAdminOverridesResponse = {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportAdminOverridesResponse",
    is(o) {
        return o && (o.$typeUrl === ImportAdminOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.is(o.overrides[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === ImportAdminOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.isSDK(o.overrides[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === ImportAdminOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.isAmino(o.overrides[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.overrides) {
            QuotaOverride.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseImportAdminOverridesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.overrides.push(QuotaOverride.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseImportAdminOverridesResponse();
        if (Array.isArray(object?.overrides))
            obj.overrides = object.overrides.map((e) => QuotaOverride.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toJSON(e) : undefined);
        }
        else {
            obj.overrides = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseImportAdminOverridesResponse();
        message.overrides = object.overrides?.map(e => QuotaOverride.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            overrides: Array.isArray(object?.overrides) ? object.overrides.map((e) => QuotaOverride.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            overrides: Array.isArray(object?.overrides) ? object.overrides.map((e) => QuotaOverride.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toSDK(e) : undefined);
        }
        else {
            obj.overrides = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseImportAdminOverridesResponse();
        message.overrides = object.overrides?.map(e => QuotaOverride.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toAmino(e) : undefined);
        }
        else {
            obj.overrides = message.overrides;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return ImportAdminOverridesResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ImportAdminOverridesResponse.decode(message.value);
    },
    toProto(message) {
        return ImportAdminOverridesResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ImportAdminOverridesResponse",
            value: ImportAdminOverridesResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        QuotaOverride.registerTypeUrl();
    }
};
function createBaseImportAdminOverridesMetadata() {
    return {};
}
export const ImportAdminOverridesMetadata = {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportAdminOverridesMetadata",
    is(o) {
        return o && o.$typeUrl === ImportAdminOverridesMetadata.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === ImportAdminOverridesMetadata.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === ImportAdminOverridesMetadata.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseImportAdminOverridesMetadata();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseImportAdminOverridesMetadata();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseImportAdminOverridesMetadata();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseImportAdminOverridesMetadata();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return ImportAdminOverridesMetadata.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ImportAdminOverridesMetadata.decode(message.value);
    },
    toProto(message) {
        return ImportAdminOverridesMetadata.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ImportAdminOverridesMetadata",
            value: ImportAdminOverridesMetadata.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseCreateConsumerOverrideRequest() {
    return {
        parent: "",
        override: undefined,
        force: false,
        forceOnly: []
    };
}
export const CreateConsumerOverrideRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.CreateConsumerOverrideRequest",
    is(o) {
        return o && (o.$typeUrl === CreateConsumerOverrideRequest.typeUrl || typeof o.parent === "string" && typeof o.force === "boolean" && Array.isArray(o.forceOnly));
    },
    isSDK(o) {
        return o && (o.$typeUrl === CreateConsumerOverrideRequest.typeUrl || typeof o.parent === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    isAmino(o) {
        return o && (o.$typeUrl === CreateConsumerOverrideRequest.typeUrl || typeof o.parent === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.override !== undefined) {
            QuotaOverride.encode(message.override, writer.uint32(18).fork()).ldelim();
        }
        if (message.force !== undefined) {
            writer.uint32(24).bool(message.force);
        }
        writer.uint32(34).fork();
        for (const v of message.forceOnly) {
            writer.int32(v);
        }
        writer.ldelim();
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCreateConsumerOverrideRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.override = QuotaOverride.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.force = reader.bool();
                    break;
                case 4:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.forceOnly.push(reader.int32());
                        }
                    }
                    else {
                        message.forceOnly.push(reader.int32());
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCreateConsumerOverrideRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.override))
            obj.override = QuotaOverride.fromJSON(object.override);
        if (isSet(object.force))
            obj.force = Boolean(object.force);
        if (Array.isArray(object?.forceOnly))
            obj.forceOnly = object.forceOnly.map((e) => quotaSafetyCheckFromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.override !== undefined && (obj.override = message.override ? QuotaOverride.toJSON(message.override) : undefined);
        message.force !== undefined && (obj.force = message.force);
        if (message.forceOnly) {
            obj.forceOnly = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.forceOnly = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCreateConsumerOverrideRequest();
        message.parent = object.parent ?? "";
        if (object.override !== undefined && object.override !== null) {
            message.override = QuotaOverride.fromPartial(object.override);
        }
        message.force = object.force ?? false;
        message.forceOnly = object.forceOnly?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            override: object.override ? QuotaOverride.fromSDK(object.override) : undefined,
            force: object?.force,
            forceOnly: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            override: isSet(object.override) ? QuotaOverride.fromSDKJSON(object.override) : undefined,
            force: isSet(object.force) ? Boolean(object.force) : false,
            force_only: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        message.override !== undefined && (obj.override = message.override ? QuotaOverride.toSDK(message.override) : undefined);
        obj.force = message.force;
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.force_only = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCreateConsumerOverrideRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.override !== undefined && object.override !== null) {
            message.override = QuotaOverride.fromAmino(object.override);
        }
        if (object.force !== undefined && object.force !== null) {
            message.force = object.force;
        }
        message.forceOnly = object.force_only?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.override = message.override ? QuotaOverride.toAmino(message.override) : undefined;
        obj.force = message.force === false ? undefined : message.force;
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => e);
        }
        else {
            obj.force_only = message.forceOnly;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return CreateConsumerOverrideRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CreateConsumerOverrideRequest.decode(message.value);
    },
    toProto(message) {
        return CreateConsumerOverrideRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.CreateConsumerOverrideRequest",
            value: CreateConsumerOverrideRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        QuotaOverride.registerTypeUrl();
    }
};
function createBaseUpdateConsumerOverrideRequest() {
    return {
        name: "",
        override: undefined,
        force: false,
        updateMask: undefined,
        forceOnly: []
    };
}
export const UpdateConsumerOverrideRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.UpdateConsumerOverrideRequest",
    is(o) {
        return o && (o.$typeUrl === UpdateConsumerOverrideRequest.typeUrl || typeof o.name === "string" && typeof o.force === "boolean" && Array.isArray(o.forceOnly));
    },
    isSDK(o) {
        return o && (o.$typeUrl === UpdateConsumerOverrideRequest.typeUrl || typeof o.name === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    isAmino(o) {
        return o && (o.$typeUrl === UpdateConsumerOverrideRequest.typeUrl || typeof o.name === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.override !== undefined) {
            QuotaOverride.encode(message.override, writer.uint32(18).fork()).ldelim();
        }
        if (message.force !== undefined) {
            writer.uint32(24).bool(message.force);
        }
        if (message.updateMask !== undefined) {
            FieldMask.encode(message.updateMask, writer.uint32(34).fork()).ldelim();
        }
        writer.uint32(42).fork();
        for (const v of message.forceOnly) {
            writer.int32(v);
        }
        writer.ldelim();
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUpdateConsumerOverrideRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.override = QuotaOverride.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.force = reader.bool();
                    break;
                case 4:
                    message.updateMask = FieldMask.decode(reader, reader.uint32());
                    break;
                case 5:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.forceOnly.push(reader.int32());
                        }
                    }
                    else {
                        message.forceOnly.push(reader.int32());
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseUpdateConsumerOverrideRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.override))
            obj.override = QuotaOverride.fromJSON(object.override);
        if (isSet(object.force))
            obj.force = Boolean(object.force);
        if (isSet(object.updateMask))
            obj.updateMask = FieldMask.fromJSON(object.updateMask);
        if (Array.isArray(object?.forceOnly))
            obj.forceOnly = object.forceOnly.map((e) => quotaSafetyCheckFromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.override !== undefined && (obj.override = message.override ? QuotaOverride.toJSON(message.override) : undefined);
        message.force !== undefined && (obj.force = message.force);
        message.updateMask !== undefined && (obj.updateMask = message.updateMask ? FieldMask.toJSON(message.updateMask) : undefined);
        if (message.forceOnly) {
            obj.forceOnly = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.forceOnly = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseUpdateConsumerOverrideRequest();
        message.name = object.name ?? "";
        if (object.override !== undefined && object.override !== null) {
            message.override = QuotaOverride.fromPartial(object.override);
        }
        message.force = object.force ?? false;
        if (object.updateMask !== undefined && object.updateMask !== null) {
            message.updateMask = FieldMask.fromPartial(object.updateMask);
        }
        message.forceOnly = object.forceOnly?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            override: object.override ? QuotaOverride.fromSDK(object.override) : undefined,
            force: object?.force,
            updateMask: object.update_mask ? FieldMask.fromSDK(object.update_mask) : undefined,
            forceOnly: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            override: isSet(object.override) ? QuotaOverride.fromSDKJSON(object.override) : undefined,
            force: isSet(object.force) ? Boolean(object.force) : false,
            update_mask: isSet(object.update_mask) ? FieldMask.fromSDKJSON(object.update_mask) : undefined,
            force_only: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        message.override !== undefined && (obj.override = message.override ? QuotaOverride.toSDK(message.override) : undefined);
        obj.force = message.force;
        message.updateMask !== undefined && (obj.update_mask = message.updateMask ? FieldMask.toSDK(message.updateMask) : undefined);
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.force_only = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseUpdateConsumerOverrideRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.override !== undefined && object.override !== null) {
            message.override = QuotaOverride.fromAmino(object.override);
        }
        if (object.force !== undefined && object.force !== null) {
            message.force = object.force;
        }
        if (object.update_mask !== undefined && object.update_mask !== null) {
            message.updateMask = FieldMask.fromAmino(object.update_mask);
        }
        message.forceOnly = object.force_only?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.override = message.override ? QuotaOverride.toAmino(message.override) : undefined;
        obj.force = message.force === false ? undefined : message.force;
        obj.update_mask = message.updateMask ? FieldMask.toAmino(message.updateMask) : undefined;
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => e);
        }
        else {
            obj.force_only = message.forceOnly;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return UpdateConsumerOverrideRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return UpdateConsumerOverrideRequest.decode(message.value);
    },
    toProto(message) {
        return UpdateConsumerOverrideRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.UpdateConsumerOverrideRequest",
            value: UpdateConsumerOverrideRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        QuotaOverride.registerTypeUrl();
        FieldMask.registerTypeUrl();
    }
};
function createBaseDeleteConsumerOverrideRequest() {
    return {
        name: "",
        force: false,
        forceOnly: []
    };
}
export const DeleteConsumerOverrideRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.DeleteConsumerOverrideRequest",
    is(o) {
        return o && (o.$typeUrl === DeleteConsumerOverrideRequest.typeUrl || typeof o.name === "string" && typeof o.force === "boolean" && Array.isArray(o.forceOnly));
    },
    isSDK(o) {
        return o && (o.$typeUrl === DeleteConsumerOverrideRequest.typeUrl || typeof o.name === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    isAmino(o) {
        return o && (o.$typeUrl === DeleteConsumerOverrideRequest.typeUrl || typeof o.name === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.force !== undefined) {
            writer.uint32(16).bool(message.force);
        }
        writer.uint32(26).fork();
        for (const v of message.forceOnly) {
            writer.int32(v);
        }
        writer.ldelim();
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeleteConsumerOverrideRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.force = reader.bool();
                    break;
                case 3:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.forceOnly.push(reader.int32());
                        }
                    }
                    else {
                        message.forceOnly.push(reader.int32());
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDeleteConsumerOverrideRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.force))
            obj.force = Boolean(object.force);
        if (Array.isArray(object?.forceOnly))
            obj.forceOnly = object.forceOnly.map((e) => quotaSafetyCheckFromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.force !== undefined && (obj.force = message.force);
        if (message.forceOnly) {
            obj.forceOnly = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.forceOnly = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDeleteConsumerOverrideRequest();
        message.name = object.name ?? "";
        message.force = object.force ?? false;
        message.forceOnly = object.forceOnly?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            force: object?.force,
            forceOnly: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            force: isSet(object.force) ? Boolean(object.force) : false,
            force_only: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.force = message.force;
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.force_only = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDeleteConsumerOverrideRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.force !== undefined && object.force !== null) {
            message.force = object.force;
        }
        message.forceOnly = object.force_only?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.force = message.force === false ? undefined : message.force;
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => e);
        }
        else {
            obj.force_only = message.forceOnly;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return DeleteConsumerOverrideRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return DeleteConsumerOverrideRequest.decode(message.value);
    },
    toProto(message) {
        return DeleteConsumerOverrideRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.DeleteConsumerOverrideRequest",
            value: DeleteConsumerOverrideRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListConsumerOverridesRequest() {
    return {
        parent: "",
        pageSize: 0,
        pageToken: ""
    };
}
export const ListConsumerOverridesRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.ListConsumerOverridesRequest",
    is(o) {
        return o && (o.$typeUrl === ListConsumerOverridesRequest.typeUrl || typeof o.parent === "string" && typeof o.pageSize === "number" && typeof o.pageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListConsumerOverridesRequest.typeUrl || typeof o.parent === "string" && typeof o.page_size === "number" && typeof o.page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListConsumerOverridesRequest.typeUrl || typeof o.parent === "string" && typeof o.page_size === "number" && typeof o.page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.pageSize !== undefined) {
            writer.uint32(16).int32(message.pageSize);
        }
        if (message.pageToken !== undefined) {
            writer.uint32(26).string(message.pageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListConsumerOverridesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.pageSize = reader.int32();
                    break;
                case 3:
                    message.pageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListConsumerOverridesRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.pageSize))
            obj.pageSize = Number(object.pageSize);
        if (isSet(object.pageToken))
            obj.pageToken = String(object.pageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.pageSize !== undefined && (obj.pageSize = Math.round(message.pageSize));
        message.pageToken !== undefined && (obj.pageToken = message.pageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListConsumerOverridesRequest();
        message.parent = object.parent ?? "";
        message.pageSize = object.pageSize ?? 0;
        message.pageToken = object.pageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            pageSize: object?.page_size,
            pageToken: object?.page_token
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            page_size: isSet(object.page_size) ? Number(object.page_size) : 0,
            page_token: isSet(object.page_token) ? String(object.page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        obj.page_size = message.pageSize;
        obj.page_token = message.pageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListConsumerOverridesRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.page_size !== undefined && object.page_size !== null) {
            message.pageSize = object.page_size;
        }
        if (object.page_token !== undefined && object.page_token !== null) {
            message.pageToken = object.page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.page_size = message.pageSize === 0 ? undefined : message.pageSize;
        obj.page_token = message.pageToken === "" ? undefined : message.pageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListConsumerOverridesRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListConsumerOverridesRequest.decode(message.value);
    },
    toProto(message) {
        return ListConsumerOverridesRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ListConsumerOverridesRequest",
            value: ListConsumerOverridesRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListConsumerOverridesResponse() {
    return {
        overrides: [],
        nextPageToken: ""
    };
}
export const ListConsumerOverridesResponse = {
    typeUrl: "/google.api.serviceusage.v1beta1.ListConsumerOverridesResponse",
    is(o) {
        return o && (o.$typeUrl === ListConsumerOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.is(o.overrides[0])) && typeof o.nextPageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListConsumerOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.isSDK(o.overrides[0])) && typeof o.next_page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListConsumerOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.isAmino(o.overrides[0])) && typeof o.next_page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.overrides) {
            QuotaOverride.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.nextPageToken !== undefined) {
            writer.uint32(18).string(message.nextPageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListConsumerOverridesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.overrides.push(QuotaOverride.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.nextPageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListConsumerOverridesResponse();
        if (Array.isArray(object?.overrides))
            obj.overrides = object.overrides.map((e) => QuotaOverride.fromJSON(e));
        if (isSet(object.nextPageToken))
            obj.nextPageToken = String(object.nextPageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toJSON(e) : undefined);
        }
        else {
            obj.overrides = [];
        }
        message.nextPageToken !== undefined && (obj.nextPageToken = message.nextPageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListConsumerOverridesResponse();
        message.overrides = object.overrides?.map(e => QuotaOverride.fromPartial(e)) || [];
        message.nextPageToken = object.nextPageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            overrides: Array.isArray(object?.overrides) ? object.overrides.map((e) => QuotaOverride.fromSDK(e)) : [],
            nextPageToken: object?.next_page_token
        };
    },
    fromSDKJSON(object) {
        return {
            overrides: Array.isArray(object?.overrides) ? object.overrides.map((e) => QuotaOverride.fromSDKJSON(e)) : [],
            next_page_token: isSet(object.next_page_token) ? String(object.next_page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toSDK(e) : undefined);
        }
        else {
            obj.overrides = [];
        }
        obj.next_page_token = message.nextPageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListConsumerOverridesResponse();
        message.overrides = object.overrides?.map(e => QuotaOverride.fromAmino(e)) || [];
        if (object.next_page_token !== undefined && object.next_page_token !== null) {
            message.nextPageToken = object.next_page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toAmino(e) : undefined);
        }
        else {
            obj.overrides = message.overrides;
        }
        obj.next_page_token = message.nextPageToken === "" ? undefined : message.nextPageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListConsumerOverridesResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListConsumerOverridesResponse.decode(message.value);
    },
    toProto(message) {
        return ListConsumerOverridesResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ListConsumerOverridesResponse",
            value: ListConsumerOverridesResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        QuotaOverride.registerTypeUrl();
    }
};
function createBaseBatchCreateConsumerOverridesResponse() {
    return {
        overrides: []
    };
}
export const BatchCreateConsumerOverridesResponse = {
    typeUrl: "/google.api.serviceusage.v1beta1.BatchCreateConsumerOverridesResponse",
    is(o) {
        return o && (o.$typeUrl === BatchCreateConsumerOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.is(o.overrides[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === BatchCreateConsumerOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.isSDK(o.overrides[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === BatchCreateConsumerOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.isAmino(o.overrides[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.overrides) {
            QuotaOverride.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseBatchCreateConsumerOverridesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.overrides.push(QuotaOverride.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseBatchCreateConsumerOverridesResponse();
        if (Array.isArray(object?.overrides))
            obj.overrides = object.overrides.map((e) => QuotaOverride.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toJSON(e) : undefined);
        }
        else {
            obj.overrides = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseBatchCreateConsumerOverridesResponse();
        message.overrides = object.overrides?.map(e => QuotaOverride.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            overrides: Array.isArray(object?.overrides) ? object.overrides.map((e) => QuotaOverride.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            overrides: Array.isArray(object?.overrides) ? object.overrides.map((e) => QuotaOverride.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toSDK(e) : undefined);
        }
        else {
            obj.overrides = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseBatchCreateConsumerOverridesResponse();
        message.overrides = object.overrides?.map(e => QuotaOverride.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toAmino(e) : undefined);
        }
        else {
            obj.overrides = message.overrides;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return BatchCreateConsumerOverridesResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return BatchCreateConsumerOverridesResponse.decode(message.value);
    },
    toProto(message) {
        return BatchCreateConsumerOverridesResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.BatchCreateConsumerOverridesResponse",
            value: BatchCreateConsumerOverridesResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        QuotaOverride.registerTypeUrl();
    }
};
function createBaseImportConsumerOverridesRequest() {
    return {
        parent: "",
        inlineSource: undefined,
        force: false,
        forceOnly: []
    };
}
export const ImportConsumerOverridesRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportConsumerOverridesRequest",
    is(o) {
        return o && (o.$typeUrl === ImportConsumerOverridesRequest.typeUrl || typeof o.parent === "string" && typeof o.force === "boolean" && Array.isArray(o.forceOnly));
    },
    isSDK(o) {
        return o && (o.$typeUrl === ImportConsumerOverridesRequest.typeUrl || typeof o.parent === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    isAmino(o) {
        return o && (o.$typeUrl === ImportConsumerOverridesRequest.typeUrl || typeof o.parent === "string" && typeof o.force === "boolean" && Array.isArray(o.force_only));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.inlineSource !== undefined) {
            OverrideInlineSource.encode(message.inlineSource, writer.uint32(18).fork()).ldelim();
        }
        if (message.force !== undefined) {
            writer.uint32(24).bool(message.force);
        }
        writer.uint32(34).fork();
        for (const v of message.forceOnly) {
            writer.int32(v);
        }
        writer.ldelim();
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseImportConsumerOverridesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.inlineSource = OverrideInlineSource.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.force = reader.bool();
                    break;
                case 4:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.forceOnly.push(reader.int32());
                        }
                    }
                    else {
                        message.forceOnly.push(reader.int32());
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseImportConsumerOverridesRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.inlineSource))
            obj.inlineSource = OverrideInlineSource.fromJSON(object.inlineSource);
        if (isSet(object.force))
            obj.force = Boolean(object.force);
        if (Array.isArray(object?.forceOnly))
            obj.forceOnly = object.forceOnly.map((e) => quotaSafetyCheckFromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.inlineSource !== undefined && (obj.inlineSource = message.inlineSource ? OverrideInlineSource.toJSON(message.inlineSource) : undefined);
        message.force !== undefined && (obj.force = message.force);
        if (message.forceOnly) {
            obj.forceOnly = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.forceOnly = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseImportConsumerOverridesRequest();
        message.parent = object.parent ?? "";
        if (object.inlineSource !== undefined && object.inlineSource !== null) {
            message.inlineSource = OverrideInlineSource.fromPartial(object.inlineSource);
        }
        message.force = object.force ?? false;
        message.forceOnly = object.forceOnly?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            inlineSource: object.inline_source ? OverrideInlineSource.fromSDK(object.inline_source) : undefined,
            force: object?.force,
            forceOnly: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            inline_source: isSet(object.inline_source) ? OverrideInlineSource.fromSDKJSON(object.inline_source) : undefined,
            force: isSet(object.force) ? Boolean(object.force) : false,
            force_only: Array.isArray(object?.force_only) ? object.force_only.map((e) => quotaSafetyCheckFromJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        message.inlineSource !== undefined && (obj.inline_source = message.inlineSource ? OverrideInlineSource.toSDK(message.inlineSource) : undefined);
        obj.force = message.force;
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => quotaSafetyCheckToJSON(e));
        }
        else {
            obj.force_only = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseImportConsumerOverridesRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.inline_source !== undefined && object.inline_source !== null) {
            message.inlineSource = OverrideInlineSource.fromAmino(object.inline_source);
        }
        if (object.force !== undefined && object.force !== null) {
            message.force = object.force;
        }
        message.forceOnly = object.force_only?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.inline_source = message.inlineSource ? OverrideInlineSource.toAmino(message.inlineSource) : undefined;
        obj.force = message.force === false ? undefined : message.force;
        if (message.forceOnly) {
            obj.force_only = message.forceOnly.map(e => e);
        }
        else {
            obj.force_only = message.forceOnly;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return ImportConsumerOverridesRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ImportConsumerOverridesRequest.decode(message.value);
    },
    toProto(message) {
        return ImportConsumerOverridesRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ImportConsumerOverridesRequest",
            value: ImportConsumerOverridesRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        OverrideInlineSource.registerTypeUrl();
    }
};
function createBaseImportConsumerOverridesResponse() {
    return {
        overrides: []
    };
}
export const ImportConsumerOverridesResponse = {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportConsumerOverridesResponse",
    is(o) {
        return o && (o.$typeUrl === ImportConsumerOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.is(o.overrides[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === ImportConsumerOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.isSDK(o.overrides[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === ImportConsumerOverridesResponse.typeUrl || Array.isArray(o.overrides) && (!o.overrides.length || QuotaOverride.isAmino(o.overrides[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.overrides) {
            QuotaOverride.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseImportConsumerOverridesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.overrides.push(QuotaOverride.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseImportConsumerOverridesResponse();
        if (Array.isArray(object?.overrides))
            obj.overrides = object.overrides.map((e) => QuotaOverride.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toJSON(e) : undefined);
        }
        else {
            obj.overrides = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseImportConsumerOverridesResponse();
        message.overrides = object.overrides?.map(e => QuotaOverride.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            overrides: Array.isArray(object?.overrides) ? object.overrides.map((e) => QuotaOverride.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            overrides: Array.isArray(object?.overrides) ? object.overrides.map((e) => QuotaOverride.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toSDK(e) : undefined);
        }
        else {
            obj.overrides = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseImportConsumerOverridesResponse();
        message.overrides = object.overrides?.map(e => QuotaOverride.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.overrides) {
            obj.overrides = message.overrides.map(e => e ? QuotaOverride.toAmino(e) : undefined);
        }
        else {
            obj.overrides = message.overrides;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return ImportConsumerOverridesResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ImportConsumerOverridesResponse.decode(message.value);
    },
    toProto(message) {
        return ImportConsumerOverridesResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ImportConsumerOverridesResponse",
            value: ImportConsumerOverridesResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        QuotaOverride.registerTypeUrl();
    }
};
function createBaseImportConsumerOverridesMetadata() {
    return {};
}
export const ImportConsumerOverridesMetadata = {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportConsumerOverridesMetadata",
    is(o) {
        return o && o.$typeUrl === ImportConsumerOverridesMetadata.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === ImportConsumerOverridesMetadata.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === ImportConsumerOverridesMetadata.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseImportConsumerOverridesMetadata();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseImportConsumerOverridesMetadata();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseImportConsumerOverridesMetadata();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseImportConsumerOverridesMetadata();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return ImportConsumerOverridesMetadata.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ImportConsumerOverridesMetadata.decode(message.value);
    },
    toProto(message) {
        return ImportConsumerOverridesMetadata.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ImportConsumerOverridesMetadata",
            value: ImportConsumerOverridesMetadata.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseImportAdminQuotaPoliciesResponse() {
    return {
        policies: []
    };
}
export const ImportAdminQuotaPoliciesResponse = {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportAdminQuotaPoliciesResponse",
    is(o) {
        return o && (o.$typeUrl === ImportAdminQuotaPoliciesResponse.typeUrl || Array.isArray(o.policies) && (!o.policies.length || AdminQuotaPolicy.is(o.policies[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === ImportAdminQuotaPoliciesResponse.typeUrl || Array.isArray(o.policies) && (!o.policies.length || AdminQuotaPolicy.isSDK(o.policies[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === ImportAdminQuotaPoliciesResponse.typeUrl || Array.isArray(o.policies) && (!o.policies.length || AdminQuotaPolicy.isAmino(o.policies[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.policies) {
            AdminQuotaPolicy.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseImportAdminQuotaPoliciesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.policies.push(AdminQuotaPolicy.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseImportAdminQuotaPoliciesResponse();
        if (Array.isArray(object?.policies))
            obj.policies = object.policies.map((e) => AdminQuotaPolicy.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.policies) {
            obj.policies = message.policies.map(e => e ? AdminQuotaPolicy.toJSON(e) : undefined);
        }
        else {
            obj.policies = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseImportAdminQuotaPoliciesResponse();
        message.policies = object.policies?.map(e => AdminQuotaPolicy.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            policies: Array.isArray(object?.policies) ? object.policies.map((e) => AdminQuotaPolicy.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            policies: Array.isArray(object?.policies) ? object.policies.map((e) => AdminQuotaPolicy.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.policies) {
            obj.policies = message.policies.map(e => e ? AdminQuotaPolicy.toSDK(e) : undefined);
        }
        else {
            obj.policies = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseImportAdminQuotaPoliciesResponse();
        message.policies = object.policies?.map(e => AdminQuotaPolicy.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.policies) {
            obj.policies = message.policies.map(e => e ? AdminQuotaPolicy.toAmino(e) : undefined);
        }
        else {
            obj.policies = message.policies;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return ImportAdminQuotaPoliciesResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ImportAdminQuotaPoliciesResponse.decode(message.value);
    },
    toProto(message) {
        return ImportAdminQuotaPoliciesResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ImportAdminQuotaPoliciesResponse",
            value: ImportAdminQuotaPoliciesResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        AdminQuotaPolicy.registerTypeUrl();
    }
};
function createBaseImportAdminQuotaPoliciesMetadata() {
    return {};
}
export const ImportAdminQuotaPoliciesMetadata = {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportAdminQuotaPoliciesMetadata",
    is(o) {
        return o && o.$typeUrl === ImportAdminQuotaPoliciesMetadata.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === ImportAdminQuotaPoliciesMetadata.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === ImportAdminQuotaPoliciesMetadata.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseImportAdminQuotaPoliciesMetadata();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseImportAdminQuotaPoliciesMetadata();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseImportAdminQuotaPoliciesMetadata();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseImportAdminQuotaPoliciesMetadata();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return ImportAdminQuotaPoliciesMetadata.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ImportAdminQuotaPoliciesMetadata.decode(message.value);
    },
    toProto(message) {
        return ImportAdminQuotaPoliciesMetadata.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.ImportAdminQuotaPoliciesMetadata",
            value: ImportAdminQuotaPoliciesMetadata.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseCreateAdminQuotaPolicyMetadata() {
    return {};
}
export const CreateAdminQuotaPolicyMetadata = {
    typeUrl: "/google.api.serviceusage.v1beta1.CreateAdminQuotaPolicyMetadata",
    is(o) {
        return o && o.$typeUrl === CreateAdminQuotaPolicyMetadata.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === CreateAdminQuotaPolicyMetadata.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === CreateAdminQuotaPolicyMetadata.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCreateAdminQuotaPolicyMetadata();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseCreateAdminQuotaPolicyMetadata();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseCreateAdminQuotaPolicyMetadata();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseCreateAdminQuotaPolicyMetadata();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return CreateAdminQuotaPolicyMetadata.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CreateAdminQuotaPolicyMetadata.decode(message.value);
    },
    toProto(message) {
        return CreateAdminQuotaPolicyMetadata.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.CreateAdminQuotaPolicyMetadata",
            value: CreateAdminQuotaPolicyMetadata.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseUpdateAdminQuotaPolicyMetadata() {
    return {};
}
export const UpdateAdminQuotaPolicyMetadata = {
    typeUrl: "/google.api.serviceusage.v1beta1.UpdateAdminQuotaPolicyMetadata",
    is(o) {
        return o && o.$typeUrl === UpdateAdminQuotaPolicyMetadata.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === UpdateAdminQuotaPolicyMetadata.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === UpdateAdminQuotaPolicyMetadata.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUpdateAdminQuotaPolicyMetadata();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseUpdateAdminQuotaPolicyMetadata();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseUpdateAdminQuotaPolicyMetadata();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseUpdateAdminQuotaPolicyMetadata();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return UpdateAdminQuotaPolicyMetadata.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return UpdateAdminQuotaPolicyMetadata.decode(message.value);
    },
    toProto(message) {
        return UpdateAdminQuotaPolicyMetadata.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.UpdateAdminQuotaPolicyMetadata",
            value: UpdateAdminQuotaPolicyMetadata.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseDeleteAdminQuotaPolicyMetadata() {
    return {};
}
export const DeleteAdminQuotaPolicyMetadata = {
    typeUrl: "/google.api.serviceusage.v1beta1.DeleteAdminQuotaPolicyMetadata",
    is(o) {
        return o && o.$typeUrl === DeleteAdminQuotaPolicyMetadata.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === DeleteAdminQuotaPolicyMetadata.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === DeleteAdminQuotaPolicyMetadata.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeleteAdminQuotaPolicyMetadata();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseDeleteAdminQuotaPolicyMetadata();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseDeleteAdminQuotaPolicyMetadata();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseDeleteAdminQuotaPolicyMetadata();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return DeleteAdminQuotaPolicyMetadata.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return DeleteAdminQuotaPolicyMetadata.decode(message.value);
    },
    toProto(message) {
        return DeleteAdminQuotaPolicyMetadata.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.DeleteAdminQuotaPolicyMetadata",
            value: DeleteAdminQuotaPolicyMetadata.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseGenerateServiceIdentityRequest() {
    return {
        parent: ""
    };
}
export const GenerateServiceIdentityRequest = {
    typeUrl: "/google.api.serviceusage.v1beta1.GenerateServiceIdentityRequest",
    is(o) {
        return o && (o.$typeUrl === GenerateServiceIdentityRequest.typeUrl || typeof o.parent === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === GenerateServiceIdentityRequest.typeUrl || typeof o.parent === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === GenerateServiceIdentityRequest.typeUrl || typeof o.parent === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGenerateServiceIdentityRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGenerateServiceIdentityRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGenerateServiceIdentityRequest();
        message.parent = object.parent ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGenerateServiceIdentityRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        return obj;
    },
    fromAminoMsg(object) {
        return GenerateServiceIdentityRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GenerateServiceIdentityRequest.decode(message.value);
    },
    toProto(message) {
        return GenerateServiceIdentityRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.GenerateServiceIdentityRequest",
            value: GenerateServiceIdentityRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseGetServiceIdentityResponse() {
    return {
        identity: undefined,
        state: 0
    };
}
export const GetServiceIdentityResponse = {
    typeUrl: "/google.api.serviceusage.v1beta1.GetServiceIdentityResponse",
    is(o) {
        return o && (o.$typeUrl === GetServiceIdentityResponse.typeUrl || isSet(o.state));
    },
    isSDK(o) {
        return o && (o.$typeUrl === GetServiceIdentityResponse.typeUrl || isSet(o.state));
    },
    isAmino(o) {
        return o && (o.$typeUrl === GetServiceIdentityResponse.typeUrl || isSet(o.state));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.identity !== undefined) {
            ServiceIdentity.encode(message.identity, writer.uint32(10).fork()).ldelim();
        }
        if (message.state !== 0) {
            writer.uint32(16).int32(message.state);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetServiceIdentityResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.identity = ServiceIdentity.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.state = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGetServiceIdentityResponse();
        if (isSet(object.identity))
            obj.identity = ServiceIdentity.fromJSON(object.identity);
        if (isSet(object.state))
            obj.state = getServiceIdentityResponse_IdentityStateFromJSON(object.state);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.identity !== undefined && (obj.identity = message.identity ? ServiceIdentity.toJSON(message.identity) : undefined);
        message.state !== undefined && (obj.state = getServiceIdentityResponse_IdentityStateToJSON(message.state));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGetServiceIdentityResponse();
        if (object.identity !== undefined && object.identity !== null) {
            message.identity = ServiceIdentity.fromPartial(object.identity);
        }
        message.state = object.state ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            identity: object.identity ? ServiceIdentity.fromSDK(object.identity) : undefined,
            state: isSet(object.state) ? getServiceIdentityResponse_IdentityStateFromJSON(object.state) : -1
        };
    },
    fromSDKJSON(object) {
        return {
            identity: isSet(object.identity) ? ServiceIdentity.fromSDKJSON(object.identity) : undefined,
            state: isSet(object.state) ? getServiceIdentityResponse_IdentityStateFromJSON(object.state) : -1
        };
    },
    toSDK(message) {
        const obj = {};
        message.identity !== undefined && (obj.identity = message.identity ? ServiceIdentity.toSDK(message.identity) : undefined);
        message.state !== undefined && (obj.state = getServiceIdentityResponse_IdentityStateToJSON(message.state));
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGetServiceIdentityResponse();
        if (object.identity !== undefined && object.identity !== null) {
            message.identity = ServiceIdentity.fromAmino(object.identity);
        }
        if (object.state !== undefined && object.state !== null) {
            message.state = object.state;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.identity = message.identity ? ServiceIdentity.toAmino(message.identity) : undefined;
        obj.state = message.state === 0 ? undefined : message.state;
        return obj;
    },
    fromAminoMsg(object) {
        return GetServiceIdentityResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetServiceIdentityResponse.decode(message.value);
    },
    toProto(message) {
        return GetServiceIdentityResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.GetServiceIdentityResponse",
            value: GetServiceIdentityResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ServiceIdentity.registerTypeUrl();
    }
};
function createBaseGetServiceIdentityMetadata() {
    return {};
}
export const GetServiceIdentityMetadata = {
    typeUrl: "/google.api.serviceusage.v1beta1.GetServiceIdentityMetadata",
    is(o) {
        return o && o.$typeUrl === GetServiceIdentityMetadata.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === GetServiceIdentityMetadata.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === GetServiceIdentityMetadata.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetServiceIdentityMetadata();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseGetServiceIdentityMetadata();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseGetServiceIdentityMetadata();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseGetServiceIdentityMetadata();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return GetServiceIdentityMetadata.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetServiceIdentityMetadata.decode(message.value);
    },
    toProto(message) {
        return GetServiceIdentityMetadata.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.serviceusage.v1beta1.GetServiceIdentityMetadata",
            value: GetServiceIdentityMetadata.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
