import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseVisibility() {
    return {
        rules: []
    };
}
export const Visibility = {
    typeUrl: "/google.api.Visibility",
    is(o) {
        return o && (o.$typeUrl === Visibility.typeUrl || Array.isArray(o.rules) && (!o.rules.length || VisibilityRule.is(o.rules[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Visibility.typeUrl || Array.isArray(o.rules) && (!o.rules.length || VisibilityRule.isSDK(o.rules[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Visibility.typeUrl || Array.isArray(o.rules) && (!o.rules.length || VisibilityRule.isAmino(o.rules[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.rules) {
            VisibilityRule.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseVisibility();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.rules.push(VisibilityRule.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseVisibility();
        if (Array.isArray(object?.rules))
            obj.rules = object.rules.map((e) => VisibilityRule.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? VisibilityRule.toJSON(e) : undefined);
        }
        else {
            obj.rules = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseVisibility();
        message.rules = object.rules?.map(e => VisibilityRule.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            rules: Array.isArray(object?.rules) ? object.rules.map((e) => VisibilityRule.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            rules: Array.isArray(object?.rules) ? object.rules.map((e) => VisibilityRule.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? VisibilityRule.toSDK(e) : undefined);
        }
        else {
            obj.rules = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseVisibility();
        message.rules = object.rules?.map(e => VisibilityRule.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? VisibilityRule.toAmino(e) : undefined);
        }
        else {
            obj.rules = message.rules;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Visibility.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Visibility.decode(message.value);
    },
    toProto(message) {
        return Visibility.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Visibility",
            value: Visibility.encode(message).finish()
        };
    },
    registerTypeUrl() {
        VisibilityRule.registerTypeUrl();
    }
};
function createBaseVisibilityRule() {
    return {
        selector: "",
        restriction: ""
    };
}
export const VisibilityRule = {
    typeUrl: "/google.api.VisibilityRule",
    is(o) {
        return o && (o.$typeUrl === VisibilityRule.typeUrl || typeof o.selector === "string" && typeof o.restriction === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === VisibilityRule.typeUrl || typeof o.selector === "string" && typeof o.restriction === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === VisibilityRule.typeUrl || typeof o.selector === "string" && typeof o.restriction === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.selector !== undefined) {
            writer.uint32(10).string(message.selector);
        }
        if (message.restriction !== undefined) {
            writer.uint32(18).string(message.restriction);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseVisibilityRule();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.selector = reader.string();
                    break;
                case 2:
                    message.restriction = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseVisibilityRule();
        if (isSet(object.selector))
            obj.selector = String(object.selector);
        if (isSet(object.restriction))
            obj.restriction = String(object.restriction);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.selector !== undefined && (obj.selector = message.selector);
        message.restriction !== undefined && (obj.restriction = message.restriction);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseVisibilityRule();
        message.selector = object.selector ?? "";
        message.restriction = object.restriction ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            selector: object?.selector,
            restriction: object?.restriction
        };
    },
    fromSDKJSON(object) {
        return {
            selector: isSet(object.selector) ? String(object.selector) : "",
            restriction: isSet(object.restriction) ? String(object.restriction) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.selector = message.selector;
        obj.restriction = message.restriction;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseVisibilityRule();
        if (object.selector !== undefined && object.selector !== null) {
            message.selector = object.selector;
        }
        if (object.restriction !== undefined && object.restriction !== null) {
            message.restriction = object.restriction;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.selector = message.selector === "" ? undefined : message.selector;
        obj.restriction = message.restriction === "" ? undefined : message.restriction;
        return obj;
    },
    fromAminoMsg(object) {
        return VisibilityRule.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return VisibilityRule.decode(message.value);
    },
    toProto(message) {
        return VisibilityRule.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.VisibilityRule",
            value: VisibilityRule.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
