import { Struct } from "../../protobuf/struct";
import { Timestamp } from "../../protobuf/timestamp";
import { Duration } from "../../protobuf/duration";
import { Any } from "../../protobuf/any";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet, isObject, toTimestamp, fromTimestamp } from "../../../helpers";
export const protobufPackage = "google.rpc.context";
function createBaseAttributeContext() {
    return {
        origin: undefined,
        source: undefined,
        destination: undefined,
        request: undefined,
        response: undefined,
        resource: undefined,
        api: undefined,
        extensions: []
    };
}
export const AttributeContext = {
    typeUrl: "/google.rpc.context.AttributeContext",
    is(o) {
        return o && (o.$typeUrl === AttributeContext.typeUrl || Array.isArray(o.extensions) && (!o.extensions.length || Any.is(o.extensions[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === AttributeContext.typeUrl || Array.isArray(o.extensions) && (!o.extensions.length || Any.isSDK(o.extensions[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === AttributeContext.typeUrl || Array.isArray(o.extensions) && (!o.extensions.length || Any.isAmino(o.extensions[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.origin !== undefined) {
            AttributeContext_Peer.encode(message.origin, writer.uint32(58).fork()).ldelim();
        }
        if (message.source !== undefined) {
            AttributeContext_Peer.encode(message.source, writer.uint32(10).fork()).ldelim();
        }
        if (message.destination !== undefined) {
            AttributeContext_Peer.encode(message.destination, writer.uint32(18).fork()).ldelim();
        }
        if (message.request !== undefined) {
            AttributeContext_Request.encode(message.request, writer.uint32(26).fork()).ldelim();
        }
        if (message.response !== undefined) {
            AttributeContext_Response.encode(message.response, writer.uint32(34).fork()).ldelim();
        }
        if (message.resource !== undefined) {
            AttributeContext_Resource.encode(message.resource, writer.uint32(42).fork()).ldelim();
        }
        if (message.api !== undefined) {
            AttributeContext_Api.encode(message.api, writer.uint32(50).fork()).ldelim();
        }
        for (const v of message.extensions) {
            Any.encode(v, writer.uint32(66).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAttributeContext();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 7:
                    message.origin = AttributeContext_Peer.decode(reader, reader.uint32());
                    break;
                case 1:
                    message.source = AttributeContext_Peer.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.destination = AttributeContext_Peer.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.request = AttributeContext_Request.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.response = AttributeContext_Response.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.resource = AttributeContext_Resource.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.api = AttributeContext_Api.decode(reader, reader.uint32());
                    break;
                case 8:
                    message.extensions.push(Any.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAttributeContext();
        if (isSet(object.origin))
            obj.origin = AttributeContext_Peer.fromJSON(object.origin);
        if (isSet(object.source))
            obj.source = AttributeContext_Peer.fromJSON(object.source);
        if (isSet(object.destination))
            obj.destination = AttributeContext_Peer.fromJSON(object.destination);
        if (isSet(object.request))
            obj.request = AttributeContext_Request.fromJSON(object.request);
        if (isSet(object.response))
            obj.response = AttributeContext_Response.fromJSON(object.response);
        if (isSet(object.resource))
            obj.resource = AttributeContext_Resource.fromJSON(object.resource);
        if (isSet(object.api))
            obj.api = AttributeContext_Api.fromJSON(object.api);
        if (Array.isArray(object?.extensions))
            obj.extensions = object.extensions.map((e) => Any.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.origin !== undefined && (obj.origin = message.origin ? AttributeContext_Peer.toJSON(message.origin) : undefined);
        message.source !== undefined && (obj.source = message.source ? AttributeContext_Peer.toJSON(message.source) : undefined);
        message.destination !== undefined && (obj.destination = message.destination ? AttributeContext_Peer.toJSON(message.destination) : undefined);
        message.request !== undefined && (obj.request = message.request ? AttributeContext_Request.toJSON(message.request) : undefined);
        message.response !== undefined && (obj.response = message.response ? AttributeContext_Response.toJSON(message.response) : undefined);
        message.resource !== undefined && (obj.resource = message.resource ? AttributeContext_Resource.toJSON(message.resource) : undefined);
        message.api !== undefined && (obj.api = message.api ? AttributeContext_Api.toJSON(message.api) : undefined);
        if (message.extensions) {
            obj.extensions = message.extensions.map(e => e ? Any.toJSON(e) : undefined);
        }
        else {
            obj.extensions = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAttributeContext();
        if (object.origin !== undefined && object.origin !== null) {
            message.origin = AttributeContext_Peer.fromPartial(object.origin);
        }
        if (object.source !== undefined && object.source !== null) {
            message.source = AttributeContext_Peer.fromPartial(object.source);
        }
        if (object.destination !== undefined && object.destination !== null) {
            message.destination = AttributeContext_Peer.fromPartial(object.destination);
        }
        if (object.request !== undefined && object.request !== null) {
            message.request = AttributeContext_Request.fromPartial(object.request);
        }
        if (object.response !== undefined && object.response !== null) {
            message.response = AttributeContext_Response.fromPartial(object.response);
        }
        if (object.resource !== undefined && object.resource !== null) {
            message.resource = AttributeContext_Resource.fromPartial(object.resource);
        }
        if (object.api !== undefined && object.api !== null) {
            message.api = AttributeContext_Api.fromPartial(object.api);
        }
        message.extensions = object.extensions?.map(e => Any.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            origin: object.origin ? AttributeContext_Peer.fromSDK(object.origin) : undefined,
            source: object.source ? AttributeContext_Peer.fromSDK(object.source) : undefined,
            destination: object.destination ? AttributeContext_Peer.fromSDK(object.destination) : undefined,
            request: object.request ? AttributeContext_Request.fromSDK(object.request) : undefined,
            response: object.response ? AttributeContext_Response.fromSDK(object.response) : undefined,
            resource: object.resource ? AttributeContext_Resource.fromSDK(object.resource) : undefined,
            api: object.api ? AttributeContext_Api.fromSDK(object.api) : undefined,
            extensions: Array.isArray(object?.extensions) ? object.extensions.map((e) => Any.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            origin: isSet(object.origin) ? AttributeContext_Peer.fromSDKJSON(object.origin) : undefined,
            source: isSet(object.source) ? AttributeContext_Peer.fromSDKJSON(object.source) : undefined,
            destination: isSet(object.destination) ? AttributeContext_Peer.fromSDKJSON(object.destination) : undefined,
            request: isSet(object.request) ? AttributeContext_Request.fromSDKJSON(object.request) : undefined,
            response: isSet(object.response) ? AttributeContext_Response.fromSDKJSON(object.response) : undefined,
            resource: isSet(object.resource) ? AttributeContext_Resource.fromSDKJSON(object.resource) : undefined,
            api: isSet(object.api) ? AttributeContext_Api.fromSDKJSON(object.api) : undefined,
            extensions: Array.isArray(object?.extensions) ? object.extensions.map((e) => Any.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        message.origin !== undefined && (obj.origin = message.origin ? AttributeContext_Peer.toSDK(message.origin) : undefined);
        message.source !== undefined && (obj.source = message.source ? AttributeContext_Peer.toSDK(message.source) : undefined);
        message.destination !== undefined && (obj.destination = message.destination ? AttributeContext_Peer.toSDK(message.destination) : undefined);
        message.request !== undefined && (obj.request = message.request ? AttributeContext_Request.toSDK(message.request) : undefined);
        message.response !== undefined && (obj.response = message.response ? AttributeContext_Response.toSDK(message.response) : undefined);
        message.resource !== undefined && (obj.resource = message.resource ? AttributeContext_Resource.toSDK(message.resource) : undefined);
        message.api !== undefined && (obj.api = message.api ? AttributeContext_Api.toSDK(message.api) : undefined);
        if (message.extensions) {
            obj.extensions = message.extensions.map(e => e ? Any.toSDK(e) : undefined);
        }
        else {
            obj.extensions = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAttributeContext();
        if (object.origin !== undefined && object.origin !== null) {
            message.origin = AttributeContext_Peer.fromAmino(object.origin);
        }
        if (object.source !== undefined && object.source !== null) {
            message.source = AttributeContext_Peer.fromAmino(object.source);
        }
        if (object.destination !== undefined && object.destination !== null) {
            message.destination = AttributeContext_Peer.fromAmino(object.destination);
        }
        if (object.request !== undefined && object.request !== null) {
            message.request = AttributeContext_Request.fromAmino(object.request);
        }
        if (object.response !== undefined && object.response !== null) {
            message.response = AttributeContext_Response.fromAmino(object.response);
        }
        if (object.resource !== undefined && object.resource !== null) {
            message.resource = AttributeContext_Resource.fromAmino(object.resource);
        }
        if (object.api !== undefined && object.api !== null) {
            message.api = AttributeContext_Api.fromAmino(object.api);
        }
        message.extensions = object.extensions?.map(e => Any.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.origin = message.origin ? AttributeContext_Peer.toAmino(message.origin) : undefined;
        obj.source = message.source ? AttributeContext_Peer.toAmino(message.source) : undefined;
        obj.destination = message.destination ? AttributeContext_Peer.toAmino(message.destination) : undefined;
        obj.request = message.request ? AttributeContext_Request.toAmino(message.request) : undefined;
        obj.response = message.response ? AttributeContext_Response.toAmino(message.response) : undefined;
        obj.resource = message.resource ? AttributeContext_Resource.toAmino(message.resource) : undefined;
        obj.api = message.api ? AttributeContext_Api.toAmino(message.api) : undefined;
        if (message.extensions) {
            obj.extensions = message.extensions.map(e => e ? Any.toAmino(e) : undefined);
        }
        else {
            obj.extensions = message.extensions;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return AttributeContext.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return AttributeContext.decode(message.value);
    },
    toProto(message) {
        return AttributeContext.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.rpc.context.AttributeContext",
            value: AttributeContext.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseAttributeContext_Peer_LabelsEntry() {
    return {
        key: "",
        value: ""
    };
}
export const AttributeContext_Peer_LabelsEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(18).string(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAttributeContext_Peer_LabelsEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAttributeContext_Peer_LabelsEntry();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = String(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = message.value);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAttributeContext_Peer_LabelsEntry();
        message.key = object.key ?? "";
        message.value = object.value ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? String(object.value) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAttributeContext_Peer_LabelsEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value === "" ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return AttributeContext_Peer_LabelsEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return AttributeContext_Peer_LabelsEntry.decode(message.value);
    },
    toProto(message) {
        return AttributeContext_Peer_LabelsEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseAttributeContext_Peer() {
    return {
        ip: "",
        port: BigInt(0),
        labels: {},
        principal: "",
        regionCode: ""
    };
}
export const AttributeContext_Peer = {
    typeUrl: "/google.rpc.context.Peer",
    is(o) {
        return o && (o.$typeUrl === AttributeContext_Peer.typeUrl || typeof o.ip === "string" && typeof o.port === "bigint" && isSet(o.labels) && typeof o.principal === "string" && typeof o.regionCode === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === AttributeContext_Peer.typeUrl || typeof o.ip === "string" && typeof o.port === "bigint" && isSet(o.labels) && typeof o.principal === "string" && typeof o.region_code === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === AttributeContext_Peer.typeUrl || typeof o.ip === "string" && typeof o.port === "bigint" && isSet(o.labels) && typeof o.principal === "string" && typeof o.region_code === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.ip !== undefined) {
            writer.uint32(10).string(message.ip);
        }
        if (message.port !== undefined) {
            writer.uint32(16).int64(message.port);
        }
        Object.entries(message.labels).forEach(([key, value]) => {
            AttributeContext_Peer_LabelsEntry.encode({
                key: key,
                value
            }, writer.uint32(50).fork()).ldelim();
        });
        if (message.principal !== undefined) {
            writer.uint32(58).string(message.principal);
        }
        if (message.regionCode !== undefined) {
            writer.uint32(66).string(message.regionCode);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAttributeContext_Peer();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.ip = reader.string();
                    break;
                case 2:
                    message.port = reader.int64();
                    break;
                case 6:
                    const entry6 = AttributeContext_Peer_LabelsEntry.decode(reader, reader.uint32());
                    if (entry6.value !== undefined) {
                        message.labels[entry6.key] = entry6.value;
                    }
                    break;
                case 7:
                    message.principal = reader.string();
                    break;
                case 8:
                    message.regionCode = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAttributeContext_Peer();
        if (isSet(object.ip))
            obj.ip = String(object.ip);
        if (isSet(object.port))
            obj.port = BigInt(object.port.toString());
        if (isObject(object.labels))
            obj.labels = Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {});
        if (isSet(object.principal))
            obj.principal = String(object.principal);
        if (isSet(object.regionCode))
            obj.regionCode = String(object.regionCode);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.ip !== undefined && (obj.ip = message.ip);
        message.port !== undefined && (obj.port = (message.port || BigInt(0)).toString());
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        message.principal !== undefined && (obj.principal = message.principal);
        message.regionCode !== undefined && (obj.regionCode = message.regionCode);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAttributeContext_Peer();
        message.ip = object.ip ?? "";
        if (object.port !== undefined && object.port !== null) {
            message.port = BigInt(object.port.toString());
        }
        message.labels = Object.entries(object.labels ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        message.principal = object.principal ?? "";
        message.regionCode = object.regionCode ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            ip: object?.ip,
            port: object?.port,
            labels: isObject(object.labels) ? Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            principal: object?.principal,
            regionCode: object?.region_code
        };
    },
    fromSDKJSON(object) {
        return {
            ip: isSet(object.ip) ? String(object.ip) : "",
            port: isSet(object.port) ? BigInt(object.port.toString()) : BigInt(0),
            labels: isObject(object.labels) ? Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            principal: isSet(object.principal) ? String(object.principal) : "",
            region_code: isSet(object.region_code) ? String(object.region_code) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.ip = message.ip;
        obj.port = message.port;
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        obj.principal = message.principal;
        obj.region_code = message.regionCode;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAttributeContext_Peer();
        if (object.ip !== undefined && object.ip !== null) {
            message.ip = object.ip;
        }
        if (object.port !== undefined && object.port !== null) {
            message.port = BigInt(object.port);
        }
        message.labels = Object.entries(object.labels ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        if (object.principal !== undefined && object.principal !== null) {
            message.principal = object.principal;
        }
        if (object.region_code !== undefined && object.region_code !== null) {
            message.regionCode = object.region_code;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.ip = message.ip === "" ? undefined : message.ip;
        obj.port = message.port !== BigInt(0) ? message.port?.toString() : undefined;
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        obj.principal = message.principal === "" ? undefined : message.principal;
        obj.region_code = message.regionCode === "" ? undefined : message.regionCode;
        return obj;
    },
    fromAminoMsg(object) {
        return AttributeContext_Peer.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return AttributeContext_Peer.decode(message.value);
    },
    toProto(message) {
        return AttributeContext_Peer.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.rpc.context.Peer",
            value: AttributeContext_Peer.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseAttributeContext_Api() {
    return {
        service: "",
        operation: "",
        protocol: "",
        version: ""
    };
}
export const AttributeContext_Api = {
    typeUrl: "/google.rpc.context.Api",
    is(o) {
        return o && (o.$typeUrl === AttributeContext_Api.typeUrl || typeof o.service === "string" && typeof o.operation === "string" && typeof o.protocol === "string" && typeof o.version === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === AttributeContext_Api.typeUrl || typeof o.service === "string" && typeof o.operation === "string" && typeof o.protocol === "string" && typeof o.version === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === AttributeContext_Api.typeUrl || typeof o.service === "string" && typeof o.operation === "string" && typeof o.protocol === "string" && typeof o.version === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.service !== undefined) {
            writer.uint32(10).string(message.service);
        }
        if (message.operation !== undefined) {
            writer.uint32(18).string(message.operation);
        }
        if (message.protocol !== undefined) {
            writer.uint32(26).string(message.protocol);
        }
        if (message.version !== undefined) {
            writer.uint32(34).string(message.version);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAttributeContext_Api();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.service = reader.string();
                    break;
                case 2:
                    message.operation = reader.string();
                    break;
                case 3:
                    message.protocol = reader.string();
                    break;
                case 4:
                    message.version = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAttributeContext_Api();
        if (isSet(object.service))
            obj.service = String(object.service);
        if (isSet(object.operation))
            obj.operation = String(object.operation);
        if (isSet(object.protocol))
            obj.protocol = String(object.protocol);
        if (isSet(object.version))
            obj.version = String(object.version);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.service !== undefined && (obj.service = message.service);
        message.operation !== undefined && (obj.operation = message.operation);
        message.protocol !== undefined && (obj.protocol = message.protocol);
        message.version !== undefined && (obj.version = message.version);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAttributeContext_Api();
        message.service = object.service ?? "";
        message.operation = object.operation ?? "";
        message.protocol = object.protocol ?? "";
        message.version = object.version ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            service: object?.service,
            operation: object?.operation,
            protocol: object?.protocol,
            version: object?.version
        };
    },
    fromSDKJSON(object) {
        return {
            service: isSet(object.service) ? String(object.service) : "",
            operation: isSet(object.operation) ? String(object.operation) : "",
            protocol: isSet(object.protocol) ? String(object.protocol) : "",
            version: isSet(object.version) ? String(object.version) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service = message.service;
        obj.operation = message.operation;
        obj.protocol = message.protocol;
        obj.version = message.version;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAttributeContext_Api();
        if (object.service !== undefined && object.service !== null) {
            message.service = object.service;
        }
        if (object.operation !== undefined && object.operation !== null) {
            message.operation = object.operation;
        }
        if (object.protocol !== undefined && object.protocol !== null) {
            message.protocol = object.protocol;
        }
        if (object.version !== undefined && object.version !== null) {
            message.version = object.version;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service = message.service === "" ? undefined : message.service;
        obj.operation = message.operation === "" ? undefined : message.operation;
        obj.protocol = message.protocol === "" ? undefined : message.protocol;
        obj.version = message.version === "" ? undefined : message.version;
        return obj;
    },
    fromAminoMsg(object) {
        return AttributeContext_Api.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return AttributeContext_Api.decode(message.value);
    },
    toProto(message) {
        return AttributeContext_Api.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.rpc.context.Api",
            value: AttributeContext_Api.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseAttributeContext_Auth() {
    return {
        principal: "",
        audiences: [],
        presenter: "",
        claims: undefined,
        accessLevels: []
    };
}
export const AttributeContext_Auth = {
    typeUrl: "/google.rpc.context.Auth",
    is(o) {
        return o && (o.$typeUrl === AttributeContext_Auth.typeUrl || typeof o.principal === "string" && Array.isArray(o.audiences) && (!o.audiences.length || typeof o.audiences[0] === "string") && typeof o.presenter === "string" && Array.isArray(o.accessLevels) && (!o.accessLevels.length || typeof o.accessLevels[0] === "string"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === AttributeContext_Auth.typeUrl || typeof o.principal === "string" && Array.isArray(o.audiences) && (!o.audiences.length || typeof o.audiences[0] === "string") && typeof o.presenter === "string" && Array.isArray(o.access_levels) && (!o.access_levels.length || typeof o.access_levels[0] === "string"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === AttributeContext_Auth.typeUrl || typeof o.principal === "string" && Array.isArray(o.audiences) && (!o.audiences.length || typeof o.audiences[0] === "string") && typeof o.presenter === "string" && Array.isArray(o.access_levels) && (!o.access_levels.length || typeof o.access_levels[0] === "string"));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.principal !== undefined) {
            writer.uint32(10).string(message.principal);
        }
        for (const v of message.audiences) {
            writer.uint32(18).string(v);
        }
        if (message.presenter !== undefined) {
            writer.uint32(26).string(message.presenter);
        }
        if (message.claims !== undefined) {
            Struct.encode(message.claims, writer.uint32(34).fork()).ldelim();
        }
        for (const v of message.accessLevels) {
            writer.uint32(42).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAttributeContext_Auth();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.principal = reader.string();
                    break;
                case 2:
                    message.audiences.push(reader.string());
                    break;
                case 3:
                    message.presenter = reader.string();
                    break;
                case 4:
                    message.claims = Struct.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.accessLevels.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAttributeContext_Auth();
        if (isSet(object.principal))
            obj.principal = String(object.principal);
        if (Array.isArray(object?.audiences))
            obj.audiences = object.audiences.map((e) => String(e));
        if (isSet(object.presenter))
            obj.presenter = String(object.presenter);
        if (isSet(object.claims))
            obj.claims = Struct.fromJSON(object.claims);
        if (Array.isArray(object?.accessLevels))
            obj.accessLevels = object.accessLevels.map((e) => String(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.principal !== undefined && (obj.principal = message.principal);
        if (message.audiences) {
            obj.audiences = message.audiences.map(e => e);
        }
        else {
            obj.audiences = [];
        }
        message.presenter !== undefined && (obj.presenter = message.presenter);
        message.claims !== undefined && (obj.claims = message.claims ? Struct.toJSON(message.claims) : undefined);
        if (message.accessLevels) {
            obj.accessLevels = message.accessLevels.map(e => e);
        }
        else {
            obj.accessLevels = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAttributeContext_Auth();
        message.principal = object.principal ?? "";
        message.audiences = object.audiences?.map(e => e) || [];
        message.presenter = object.presenter ?? "";
        if (object.claims !== undefined && object.claims !== null) {
            message.claims = Struct.fromPartial(object.claims);
        }
        message.accessLevels = object.accessLevels?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            principal: object?.principal,
            audiences: Array.isArray(object?.audiences) ? object.audiences.map((e) => e) : [],
            presenter: object?.presenter,
            claims: object.claims ? Struct.fromSDK(object.claims) : undefined,
            accessLevels: Array.isArray(object?.access_levels) ? object.access_levels.map((e) => e) : []
        };
    },
    fromSDKJSON(object) {
        return {
            principal: isSet(object.principal) ? String(object.principal) : "",
            audiences: Array.isArray(object?.audiences) ? object.audiences.map((e) => String(e)) : [],
            presenter: isSet(object.presenter) ? String(object.presenter) : "",
            claims: isSet(object.claims) ? Struct.fromSDKJSON(object.claims) : undefined,
            access_levels: Array.isArray(object?.access_levels) ? object.access_levels.map((e) => String(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.principal = message.principal;
        if (message.audiences) {
            obj.audiences = message.audiences.map(e => e);
        }
        else {
            obj.audiences = [];
        }
        obj.presenter = message.presenter;
        message.claims !== undefined && (obj.claims = message.claims ? Struct.toSDK(message.claims) : undefined);
        if (message.accessLevels) {
            obj.access_levels = message.accessLevels.map(e => e);
        }
        else {
            obj.access_levels = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAttributeContext_Auth();
        if (object.principal !== undefined && object.principal !== null) {
            message.principal = object.principal;
        }
        message.audiences = object.audiences?.map(e => e) || [];
        if (object.presenter !== undefined && object.presenter !== null) {
            message.presenter = object.presenter;
        }
        if (object.claims !== undefined && object.claims !== null) {
            message.claims = Struct.fromAmino(object.claims);
        }
        message.accessLevels = object.access_levels?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.principal = message.principal === "" ? undefined : message.principal;
        if (message.audiences) {
            obj.audiences = message.audiences.map(e => e);
        }
        else {
            obj.audiences = message.audiences;
        }
        obj.presenter = message.presenter === "" ? undefined : message.presenter;
        obj.claims = message.claims ? Struct.toAmino(message.claims) : undefined;
        if (message.accessLevels) {
            obj.access_levels = message.accessLevels.map(e => e);
        }
        else {
            obj.access_levels = message.accessLevels;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return AttributeContext_Auth.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return AttributeContext_Auth.decode(message.value);
    },
    toProto(message) {
        return AttributeContext_Auth.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.rpc.context.Auth",
            value: AttributeContext_Auth.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Struct.registerTypeUrl();
    }
};
function createBaseAttributeContext_Request_HeadersEntry() {
    return {
        key: "",
        value: ""
    };
}
export const AttributeContext_Request_HeadersEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(18).string(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAttributeContext_Request_HeadersEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAttributeContext_Request_HeadersEntry();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = String(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = message.value);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAttributeContext_Request_HeadersEntry();
        message.key = object.key ?? "";
        message.value = object.value ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? String(object.value) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAttributeContext_Request_HeadersEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value === "" ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return AttributeContext_Request_HeadersEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return AttributeContext_Request_HeadersEntry.decode(message.value);
    },
    toProto(message) {
        return AttributeContext_Request_HeadersEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseAttributeContext_Request() {
    return {
        id: "",
        method: "",
        headers: {},
        path: "",
        host: "",
        scheme: "",
        query: "",
        time: undefined,
        size: BigInt(0),
        protocol: "",
        reason: "",
        auth: undefined
    };
}
export const AttributeContext_Request = {
    typeUrl: "/google.rpc.context.Request",
    is(o) {
        return o && (o.$typeUrl === AttributeContext_Request.typeUrl || typeof o.id === "string" && typeof o.method === "string" && isSet(o.headers) && typeof o.path === "string" && typeof o.host === "string" && typeof o.scheme === "string" && typeof o.query === "string" && typeof o.size === "bigint" && typeof o.protocol === "string" && typeof o.reason === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === AttributeContext_Request.typeUrl || typeof o.id === "string" && typeof o.method === "string" && isSet(o.headers) && typeof o.path === "string" && typeof o.host === "string" && typeof o.scheme === "string" && typeof o.query === "string" && typeof o.size === "bigint" && typeof o.protocol === "string" && typeof o.reason === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === AttributeContext_Request.typeUrl || typeof o.id === "string" && typeof o.method === "string" && isSet(o.headers) && typeof o.path === "string" && typeof o.host === "string" && typeof o.scheme === "string" && typeof o.query === "string" && typeof o.size === "bigint" && typeof o.protocol === "string" && typeof o.reason === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            writer.uint32(10).string(message.id);
        }
        if (message.method !== undefined) {
            writer.uint32(18).string(message.method);
        }
        Object.entries(message.headers).forEach(([key, value]) => {
            AttributeContext_Request_HeadersEntry.encode({
                key: key,
                value
            }, writer.uint32(26).fork()).ldelim();
        });
        if (message.path !== undefined) {
            writer.uint32(34).string(message.path);
        }
        if (message.host !== undefined) {
            writer.uint32(42).string(message.host);
        }
        if (message.scheme !== undefined) {
            writer.uint32(50).string(message.scheme);
        }
        if (message.query !== undefined) {
            writer.uint32(58).string(message.query);
        }
        if (message.time !== undefined) {
            Timestamp.encode(toTimestamp(message.time), writer.uint32(74).fork()).ldelim();
        }
        if (message.size !== undefined) {
            writer.uint32(80).int64(message.size);
        }
        if (message.protocol !== undefined) {
            writer.uint32(90).string(message.protocol);
        }
        if (message.reason !== undefined) {
            writer.uint32(98).string(message.reason);
        }
        if (message.auth !== undefined) {
            AttributeContext_Auth.encode(message.auth, writer.uint32(106).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAttributeContext_Request();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    message.method = reader.string();
                    break;
                case 3:
                    const entry3 = AttributeContext_Request_HeadersEntry.decode(reader, reader.uint32());
                    if (entry3.value !== undefined) {
                        message.headers[entry3.key] = entry3.value;
                    }
                    break;
                case 4:
                    message.path = reader.string();
                    break;
                case 5:
                    message.host = reader.string();
                    break;
                case 6:
                    message.scheme = reader.string();
                    break;
                case 7:
                    message.query = reader.string();
                    break;
                case 9:
                    message.time = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 10:
                    message.size = reader.int64();
                    break;
                case 11:
                    message.protocol = reader.string();
                    break;
                case 12:
                    message.reason = reader.string();
                    break;
                case 13:
                    message.auth = AttributeContext_Auth.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAttributeContext_Request();
        if (isSet(object.id))
            obj.id = String(object.id);
        if (isSet(object.method))
            obj.method = String(object.method);
        if (isObject(object.headers))
            obj.headers = Object.entries(object.headers).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {});
        if (isSet(object.path))
            obj.path = String(object.path);
        if (isSet(object.host))
            obj.host = String(object.host);
        if (isSet(object.scheme))
            obj.scheme = String(object.scheme);
        if (isSet(object.query))
            obj.query = String(object.query);
        if (isSet(object.time))
            obj.time = new Date(object.time);
        if (isSet(object.size))
            obj.size = BigInt(object.size.toString());
        if (isSet(object.protocol))
            obj.protocol = String(object.protocol);
        if (isSet(object.reason))
            obj.reason = String(object.reason);
        if (isSet(object.auth))
            obj.auth = AttributeContext_Auth.fromJSON(object.auth);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        message.method !== undefined && (obj.method = message.method);
        obj.headers = {};
        if (message.headers) {
            Object.entries(message.headers).forEach(([k, v]) => {
                obj.headers[k] = v;
            });
        }
        message.path !== undefined && (obj.path = message.path);
        message.host !== undefined && (obj.host = message.host);
        message.scheme !== undefined && (obj.scheme = message.scheme);
        message.query !== undefined && (obj.query = message.query);
        message.time !== undefined && (obj.time = message.time.toISOString());
        message.size !== undefined && (obj.size = (message.size || BigInt(0)).toString());
        message.protocol !== undefined && (obj.protocol = message.protocol);
        message.reason !== undefined && (obj.reason = message.reason);
        message.auth !== undefined && (obj.auth = message.auth ? AttributeContext_Auth.toJSON(message.auth) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAttributeContext_Request();
        message.id = object.id ?? "";
        message.method = object.method ?? "";
        message.headers = Object.entries(object.headers ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        message.path = object.path ?? "";
        message.host = object.host ?? "";
        message.scheme = object.scheme ?? "";
        message.query = object.query ?? "";
        message.time = object.time ?? undefined;
        if (object.size !== undefined && object.size !== null) {
            message.size = BigInt(object.size.toString());
        }
        message.protocol = object.protocol ?? "";
        message.reason = object.reason ?? "";
        if (object.auth !== undefined && object.auth !== null) {
            message.auth = AttributeContext_Auth.fromPartial(object.auth);
        }
        return message;
    },
    fromSDK(object) {
        return {
            id: object?.id,
            method: object?.method,
            headers: isObject(object.headers) ? Object.entries(object.headers).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            path: object?.path,
            host: object?.host,
            scheme: object?.scheme,
            query: object?.query,
            time: object.time ?? undefined,
            size: object?.size,
            protocol: object?.protocol,
            reason: object?.reason,
            auth: object.auth ? AttributeContext_Auth.fromSDK(object.auth) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? String(object.id) : "",
            method: isSet(object.method) ? String(object.method) : "",
            headers: isObject(object.headers) ? Object.entries(object.headers).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            path: isSet(object.path) ? String(object.path) : "",
            host: isSet(object.host) ? String(object.host) : "",
            scheme: isSet(object.scheme) ? String(object.scheme) : "",
            query: isSet(object.query) ? String(object.query) : "",
            time: isSet(object.time) ? new Date(object.time) : undefined,
            size: isSet(object.size) ? BigInt(object.size.toString()) : BigInt(0),
            protocol: isSet(object.protocol) ? String(object.protocol) : "",
            reason: isSet(object.reason) ? String(object.reason) : "",
            auth: isSet(object.auth) ? AttributeContext_Auth.fromSDKJSON(object.auth) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.id = message.id;
        obj.method = message.method;
        obj.headers = {};
        if (message.headers) {
            Object.entries(message.headers).forEach(([k, v]) => {
                obj.headers[k] = v;
            });
        }
        obj.path = message.path;
        obj.host = message.host;
        obj.scheme = message.scheme;
        obj.query = message.query;
        message.time !== undefined && (obj.time = message.time ?? undefined);
        obj.size = message.size;
        obj.protocol = message.protocol;
        obj.reason = message.reason;
        message.auth !== undefined && (obj.auth = message.auth ? AttributeContext_Auth.toSDK(message.auth) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAttributeContext_Request();
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        if (object.method !== undefined && object.method !== null) {
            message.method = object.method;
        }
        message.headers = Object.entries(object.headers ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        if (object.path !== undefined && object.path !== null) {
            message.path = object.path;
        }
        if (object.host !== undefined && object.host !== null) {
            message.host = object.host;
        }
        if (object.scheme !== undefined && object.scheme !== null) {
            message.scheme = object.scheme;
        }
        if (object.query !== undefined && object.query !== null) {
            message.query = object.query;
        }
        if (object.time !== undefined && object.time !== null) {
            message.time = fromTimestamp(Timestamp.fromAmino(object.time));
        }
        if (object.size !== undefined && object.size !== null) {
            message.size = BigInt(object.size);
        }
        if (object.protocol !== undefined && object.protocol !== null) {
            message.protocol = object.protocol;
        }
        if (object.reason !== undefined && object.reason !== null) {
            message.reason = object.reason;
        }
        if (object.auth !== undefined && object.auth !== null) {
            message.auth = AttributeContext_Auth.fromAmino(object.auth);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id === "" ? undefined : message.id;
        obj.method = message.method === "" ? undefined : message.method;
        obj.headers = {};
        if (message.headers) {
            Object.entries(message.headers).forEach(([k, v]) => {
                obj.headers[k] = v;
            });
        }
        obj.path = message.path === "" ? undefined : message.path;
        obj.host = message.host === "" ? undefined : message.host;
        obj.scheme = message.scheme === "" ? undefined : message.scheme;
        obj.query = message.query === "" ? undefined : message.query;
        obj.time = message.time ? Timestamp.toAmino(toTimestamp(message.time)) : undefined;
        obj.size = message.size !== BigInt(0) ? message.size?.toString() : undefined;
        obj.protocol = message.protocol === "" ? undefined : message.protocol;
        obj.reason = message.reason === "" ? undefined : message.reason;
        obj.auth = message.auth ? AttributeContext_Auth.toAmino(message.auth) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return AttributeContext_Request.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return AttributeContext_Request.decode(message.value);
    },
    toProto(message) {
        return AttributeContext_Request.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.rpc.context.Request",
            value: AttributeContext_Request.encode(message).finish()
        };
    },
    registerTypeUrl() {
        AttributeContext_Auth.registerTypeUrl();
    }
};
function createBaseAttributeContext_Response_HeadersEntry() {
    return {
        key: "",
        value: ""
    };
}
export const AttributeContext_Response_HeadersEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(18).string(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAttributeContext_Response_HeadersEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAttributeContext_Response_HeadersEntry();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = String(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = message.value);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAttributeContext_Response_HeadersEntry();
        message.key = object.key ?? "";
        message.value = object.value ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? String(object.value) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAttributeContext_Response_HeadersEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value === "" ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return AttributeContext_Response_HeadersEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return AttributeContext_Response_HeadersEntry.decode(message.value);
    },
    toProto(message) {
        return AttributeContext_Response_HeadersEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseAttributeContext_Response() {
    return {
        code: BigInt(0),
        size: BigInt(0),
        headers: {},
        time: undefined,
        backendLatency: undefined
    };
}
export const AttributeContext_Response = {
    typeUrl: "/google.rpc.context.Response",
    is(o) {
        return o && (o.$typeUrl === AttributeContext_Response.typeUrl || typeof o.code === "bigint" && typeof o.size === "bigint" && isSet(o.headers));
    },
    isSDK(o) {
        return o && (o.$typeUrl === AttributeContext_Response.typeUrl || typeof o.code === "bigint" && typeof o.size === "bigint" && isSet(o.headers));
    },
    isAmino(o) {
        return o && (o.$typeUrl === AttributeContext_Response.typeUrl || typeof o.code === "bigint" && typeof o.size === "bigint" && isSet(o.headers));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.code !== undefined) {
            writer.uint32(8).int64(message.code);
        }
        if (message.size !== undefined) {
            writer.uint32(16).int64(message.size);
        }
        Object.entries(message.headers).forEach(([key, value]) => {
            AttributeContext_Response_HeadersEntry.encode({
                key: key,
                value
            }, writer.uint32(26).fork()).ldelim();
        });
        if (message.time !== undefined) {
            Timestamp.encode(toTimestamp(message.time), writer.uint32(34).fork()).ldelim();
        }
        if (message.backendLatency !== undefined) {
            Duration.encode(message.backendLatency, writer.uint32(42).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAttributeContext_Response();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.code = reader.int64();
                    break;
                case 2:
                    message.size = reader.int64();
                    break;
                case 3:
                    const entry3 = AttributeContext_Response_HeadersEntry.decode(reader, reader.uint32());
                    if (entry3.value !== undefined) {
                        message.headers[entry3.key] = entry3.value;
                    }
                    break;
                case 4:
                    message.time = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 5:
                    message.backendLatency = Duration.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAttributeContext_Response();
        if (isSet(object.code))
            obj.code = BigInt(object.code.toString());
        if (isSet(object.size))
            obj.size = BigInt(object.size.toString());
        if (isObject(object.headers))
            obj.headers = Object.entries(object.headers).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {});
        if (isSet(object.time))
            obj.time = new Date(object.time);
        if (isSet(object.backendLatency))
            obj.backendLatency = Duration.fromJSON(object.backendLatency);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.code !== undefined && (obj.code = (message.code || BigInt(0)).toString());
        message.size !== undefined && (obj.size = (message.size || BigInt(0)).toString());
        obj.headers = {};
        if (message.headers) {
            Object.entries(message.headers).forEach(([k, v]) => {
                obj.headers[k] = v;
            });
        }
        message.time !== undefined && (obj.time = message.time.toISOString());
        message.backendLatency !== undefined && (obj.backendLatency = message.backendLatency ? Duration.toJSON(message.backendLatency) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAttributeContext_Response();
        if (object.code !== undefined && object.code !== null) {
            message.code = BigInt(object.code.toString());
        }
        if (object.size !== undefined && object.size !== null) {
            message.size = BigInt(object.size.toString());
        }
        message.headers = Object.entries(object.headers ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        message.time = object.time ?? undefined;
        if (object.backendLatency !== undefined && object.backendLatency !== null) {
            message.backendLatency = Duration.fromPartial(object.backendLatency);
        }
        return message;
    },
    fromSDK(object) {
        return {
            code: object?.code,
            size: object?.size,
            headers: isObject(object.headers) ? Object.entries(object.headers).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            time: object.time ?? undefined,
            backendLatency: object.backend_latency ? Duration.fromSDK(object.backend_latency) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            code: isSet(object.code) ? BigInt(object.code.toString()) : BigInt(0),
            size: isSet(object.size) ? BigInt(object.size.toString()) : BigInt(0),
            headers: isObject(object.headers) ? Object.entries(object.headers).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            time: isSet(object.time) ? new Date(object.time) : undefined,
            backend_latency: isSet(object.backend_latency) ? Duration.fromSDKJSON(object.backend_latency) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.code = message.code;
        obj.size = message.size;
        obj.headers = {};
        if (message.headers) {
            Object.entries(message.headers).forEach(([k, v]) => {
                obj.headers[k] = v;
            });
        }
        message.time !== undefined && (obj.time = message.time ?? undefined);
        message.backendLatency !== undefined && (obj.backend_latency = message.backendLatency ? Duration.toSDK(message.backendLatency) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAttributeContext_Response();
        if (object.code !== undefined && object.code !== null) {
            message.code = BigInt(object.code);
        }
        if (object.size !== undefined && object.size !== null) {
            message.size = BigInt(object.size);
        }
        message.headers = Object.entries(object.headers ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        if (object.time !== undefined && object.time !== null) {
            message.time = fromTimestamp(Timestamp.fromAmino(object.time));
        }
        if (object.backend_latency !== undefined && object.backend_latency !== null) {
            message.backendLatency = Duration.fromAmino(object.backend_latency);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.code = message.code !== BigInt(0) ? message.code?.toString() : undefined;
        obj.size = message.size !== BigInt(0) ? message.size?.toString() : undefined;
        obj.headers = {};
        if (message.headers) {
            Object.entries(message.headers).forEach(([k, v]) => {
                obj.headers[k] = v;
            });
        }
        obj.time = message.time ? Timestamp.toAmino(toTimestamp(message.time)) : undefined;
        obj.backend_latency = message.backendLatency ? Duration.toAmino(message.backendLatency) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return AttributeContext_Response.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return AttributeContext_Response.decode(message.value);
    },
    toProto(message) {
        return AttributeContext_Response.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.rpc.context.Response",
            value: AttributeContext_Response.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseAttributeContext_Resource_LabelsEntry() {
    return {
        key: "",
        value: ""
    };
}
export const AttributeContext_Resource_LabelsEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(18).string(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAttributeContext_Resource_LabelsEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAttributeContext_Resource_LabelsEntry();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = String(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = message.value);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAttributeContext_Resource_LabelsEntry();
        message.key = object.key ?? "";
        message.value = object.value ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? String(object.value) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAttributeContext_Resource_LabelsEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value === "" ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return AttributeContext_Resource_LabelsEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return AttributeContext_Resource_LabelsEntry.decode(message.value);
    },
    toProto(message) {
        return AttributeContext_Resource_LabelsEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseAttributeContext_Resource_AnnotationsEntry() {
    return {
        key: "",
        value: ""
    };
}
export const AttributeContext_Resource_AnnotationsEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(18).string(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAttributeContext_Resource_AnnotationsEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAttributeContext_Resource_AnnotationsEntry();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = String(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = message.value);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAttributeContext_Resource_AnnotationsEntry();
        message.key = object.key ?? "";
        message.value = object.value ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? String(object.value) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAttributeContext_Resource_AnnotationsEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value === "" ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return AttributeContext_Resource_AnnotationsEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return AttributeContext_Resource_AnnotationsEntry.decode(message.value);
    },
    toProto(message) {
        return AttributeContext_Resource_AnnotationsEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseAttributeContext_Resource() {
    return {
        service: "",
        name: "",
        type: "",
        labels: {},
        uid: "",
        annotations: {},
        displayName: "",
        createTime: undefined,
        updateTime: undefined,
        deleteTime: undefined,
        etag: "",
        location: ""
    };
}
export const AttributeContext_Resource = {
    typeUrl: "/google.rpc.context.Resource",
    is(o) {
        return o && (o.$typeUrl === AttributeContext_Resource.typeUrl || typeof o.service === "string" && typeof o.name === "string" && typeof o.type === "string" && isSet(o.labels) && typeof o.uid === "string" && isSet(o.annotations) && typeof o.displayName === "string" && typeof o.etag === "string" && typeof o.location === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === AttributeContext_Resource.typeUrl || typeof o.service === "string" && typeof o.name === "string" && typeof o.type === "string" && isSet(o.labels) && typeof o.uid === "string" && isSet(o.annotations) && typeof o.display_name === "string" && typeof o.etag === "string" && typeof o.location === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === AttributeContext_Resource.typeUrl || typeof o.service === "string" && typeof o.name === "string" && typeof o.type === "string" && isSet(o.labels) && typeof o.uid === "string" && isSet(o.annotations) && typeof o.display_name === "string" && typeof o.etag === "string" && typeof o.location === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.service !== undefined) {
            writer.uint32(10).string(message.service);
        }
        if (message.name !== undefined) {
            writer.uint32(18).string(message.name);
        }
        if (message.type !== undefined) {
            writer.uint32(26).string(message.type);
        }
        Object.entries(message.labels).forEach(([key, value]) => {
            AttributeContext_Resource_LabelsEntry.encode({
                key: key,
                value
            }, writer.uint32(34).fork()).ldelim();
        });
        if (message.uid !== undefined) {
            writer.uint32(42).string(message.uid);
        }
        Object.entries(message.annotations).forEach(([key, value]) => {
            AttributeContext_Resource_AnnotationsEntry.encode({
                key: key,
                value
            }, writer.uint32(50).fork()).ldelim();
        });
        if (message.displayName !== undefined) {
            writer.uint32(58).string(message.displayName);
        }
        if (message.createTime !== undefined) {
            Timestamp.encode(toTimestamp(message.createTime), writer.uint32(66).fork()).ldelim();
        }
        if (message.updateTime !== undefined) {
            Timestamp.encode(toTimestamp(message.updateTime), writer.uint32(74).fork()).ldelim();
        }
        if (message.deleteTime !== undefined) {
            Timestamp.encode(toTimestamp(message.deleteTime), writer.uint32(82).fork()).ldelim();
        }
        if (message.etag !== undefined) {
            writer.uint32(90).string(message.etag);
        }
        if (message.location !== undefined) {
            writer.uint32(98).string(message.location);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAttributeContext_Resource();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.service = reader.string();
                    break;
                case 2:
                    message.name = reader.string();
                    break;
                case 3:
                    message.type = reader.string();
                    break;
                case 4:
                    const entry4 = AttributeContext_Resource_LabelsEntry.decode(reader, reader.uint32());
                    if (entry4.value !== undefined) {
                        message.labels[entry4.key] = entry4.value;
                    }
                    break;
                case 5:
                    message.uid = reader.string();
                    break;
                case 6:
                    const entry6 = AttributeContext_Resource_AnnotationsEntry.decode(reader, reader.uint32());
                    if (entry6.value !== undefined) {
                        message.annotations[entry6.key] = entry6.value;
                    }
                    break;
                case 7:
                    message.displayName = reader.string();
                    break;
                case 8:
                    message.createTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 9:
                    message.updateTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 10:
                    message.deleteTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 11:
                    message.etag = reader.string();
                    break;
                case 12:
                    message.location = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAttributeContext_Resource();
        if (isSet(object.service))
            obj.service = String(object.service);
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.type))
            obj.type = String(object.type);
        if (isObject(object.labels))
            obj.labels = Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {});
        if (isSet(object.uid))
            obj.uid = String(object.uid);
        if (isObject(object.annotations))
            obj.annotations = Object.entries(object.annotations).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {});
        if (isSet(object.displayName))
            obj.displayName = String(object.displayName);
        if (isSet(object.createTime))
            obj.createTime = new Date(object.createTime);
        if (isSet(object.updateTime))
            obj.updateTime = new Date(object.updateTime);
        if (isSet(object.deleteTime))
            obj.deleteTime = new Date(object.deleteTime);
        if (isSet(object.etag))
            obj.etag = String(object.etag);
        if (isSet(object.location))
            obj.location = String(object.location);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.service !== undefined && (obj.service = message.service);
        message.name !== undefined && (obj.name = message.name);
        message.type !== undefined && (obj.type = message.type);
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        message.uid !== undefined && (obj.uid = message.uid);
        obj.annotations = {};
        if (message.annotations) {
            Object.entries(message.annotations).forEach(([k, v]) => {
                obj.annotations[k] = v;
            });
        }
        message.displayName !== undefined && (obj.displayName = message.displayName);
        message.createTime !== undefined && (obj.createTime = message.createTime.toISOString());
        message.updateTime !== undefined && (obj.updateTime = message.updateTime.toISOString());
        message.deleteTime !== undefined && (obj.deleteTime = message.deleteTime.toISOString());
        message.etag !== undefined && (obj.etag = message.etag);
        message.location !== undefined && (obj.location = message.location);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAttributeContext_Resource();
        message.service = object.service ?? "";
        message.name = object.name ?? "";
        message.type = object.type ?? "";
        message.labels = Object.entries(object.labels ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        message.uid = object.uid ?? "";
        message.annotations = Object.entries(object.annotations ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        message.displayName = object.displayName ?? "";
        message.createTime = object.createTime ?? undefined;
        message.updateTime = object.updateTime ?? undefined;
        message.deleteTime = object.deleteTime ?? undefined;
        message.etag = object.etag ?? "";
        message.location = object.location ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            service: object?.service,
            name: object?.name,
            type: object?.type,
            labels: isObject(object.labels) ? Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            uid: object?.uid,
            annotations: isObject(object.annotations) ? Object.entries(object.annotations).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            displayName: object?.display_name,
            createTime: object.create_time ?? undefined,
            updateTime: object.update_time ?? undefined,
            deleteTime: object.delete_time ?? undefined,
            etag: object?.etag,
            location: object?.location
        };
    },
    fromSDKJSON(object) {
        return {
            service: isSet(object.service) ? String(object.service) : "",
            name: isSet(object.name) ? String(object.name) : "",
            type: isSet(object.type) ? String(object.type) : "",
            labels: isObject(object.labels) ? Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            uid: isSet(object.uid) ? String(object.uid) : "",
            annotations: isObject(object.annotations) ? Object.entries(object.annotations).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            display_name: isSet(object.display_name) ? String(object.display_name) : "",
            create_time: isSet(object.create_time) ? new Date(object.create_time) : undefined,
            update_time: isSet(object.update_time) ? new Date(object.update_time) : undefined,
            delete_time: isSet(object.delete_time) ? new Date(object.delete_time) : undefined,
            etag: isSet(object.etag) ? String(object.etag) : "",
            location: isSet(object.location) ? String(object.location) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service = message.service;
        obj.name = message.name;
        obj.type = message.type;
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        obj.uid = message.uid;
        obj.annotations = {};
        if (message.annotations) {
            Object.entries(message.annotations).forEach(([k, v]) => {
                obj.annotations[k] = v;
            });
        }
        obj.display_name = message.displayName;
        message.createTime !== undefined && (obj.create_time = message.createTime ?? undefined);
        message.updateTime !== undefined && (obj.update_time = message.updateTime ?? undefined);
        message.deleteTime !== undefined && (obj.delete_time = message.deleteTime ?? undefined);
        obj.etag = message.etag;
        obj.location = message.location;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAttributeContext_Resource();
        if (object.service !== undefined && object.service !== null) {
            message.service = object.service;
        }
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.type !== undefined && object.type !== null) {
            message.type = object.type;
        }
        message.labels = Object.entries(object.labels ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        if (object.uid !== undefined && object.uid !== null) {
            message.uid = object.uid;
        }
        message.annotations = Object.entries(object.annotations ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        if (object.display_name !== undefined && object.display_name !== null) {
            message.displayName = object.display_name;
        }
        if (object.create_time !== undefined && object.create_time !== null) {
            message.createTime = fromTimestamp(Timestamp.fromAmino(object.create_time));
        }
        if (object.update_time !== undefined && object.update_time !== null) {
            message.updateTime = fromTimestamp(Timestamp.fromAmino(object.update_time));
        }
        if (object.delete_time !== undefined && object.delete_time !== null) {
            message.deleteTime = fromTimestamp(Timestamp.fromAmino(object.delete_time));
        }
        if (object.etag !== undefined && object.etag !== null) {
            message.etag = object.etag;
        }
        if (object.location !== undefined && object.location !== null) {
            message.location = object.location;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service = message.service === "" ? undefined : message.service;
        obj.name = message.name === "" ? undefined : message.name;
        obj.type = message.type === "" ? undefined : message.type;
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        obj.uid = message.uid === "" ? undefined : message.uid;
        obj.annotations = {};
        if (message.annotations) {
            Object.entries(message.annotations).forEach(([k, v]) => {
                obj.annotations[k] = v;
            });
        }
        obj.display_name = message.displayName === "" ? undefined : message.displayName;
        obj.create_time = message.createTime ? Timestamp.toAmino(toTimestamp(message.createTime)) : undefined;
        obj.update_time = message.updateTime ? Timestamp.toAmino(toTimestamp(message.updateTime)) : undefined;
        obj.delete_time = message.deleteTime ? Timestamp.toAmino(toTimestamp(message.deleteTime)) : undefined;
        obj.etag = message.etag === "" ? undefined : message.etag;
        obj.location = message.location === "" ? undefined : message.location;
        return obj;
    },
    fromAminoMsg(object) {
        return AttributeContext_Resource.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return AttributeContext_Resource.decode(message.value);
    },
    toProto(message) {
        return AttributeContext_Resource.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.rpc.context.Resource",
            value: AttributeContext_Resource.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
