/**
* This file and any referenced files were automatically generated by @cosmology/telescope@latest
* DO NOT MODIFY BY HAND. Instead, download the latest proto files for your chain
* and run the transpile command or npm scripts command that is used to regenerate this bundle.
*/
import { getRpcClient } from "./extern";
import { isRpc } from "./helpers";
export function buildQuery(opts) {
    registerDependencies(opts.deps ?? []);
    console.log('buildquery', opts, opts.clientResolver);
    return async (request) => {
        let rpc;
        if (isRpc(opts.clientResolver)) {
            rpc = opts.clientResolver;
        }
        else {
            rpc = opts.clientResolver ? await getRpcClient(opts.clientResolver) : undefined;
        }
        if (!rpc)
            throw new Error("Query Rpc is not initialized");
        const data = opts.encode(request).finish();
        const response = await rpc.request(opts.service, opts.method, data);
        return opts.decode(response);
    };
}
export function isISigningClient(client) {
    return client !== null && client !== undefined
        && typeof client.signAndBroadcast === 'function'
        && typeof client.addConverters === 'function'
        && typeof client.addEncoders === 'function';
}
export function buildTx(opts) {
    registerDependencies(opts.deps ?? []);
    return async (signerAddress, message, fee, memo) => {
        let client;
        // if opts.getSigningClient is a function, call it to get the SigningClient instance
        if (isISigningClient(opts.clientResolver)) {
            client = opts.clientResolver;
        }
        if (!client)
            throw new Error("SigningClient is not initialized");
        //register all related encoders and converters
        client.addEncoders(opts.encoders ?? []);
        client.addConverters(opts.converters ?? []);
        const data = [
            {
                typeUrl: opts.typeUrl,
                value: message,
            },
        ];
        return client.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
function registerDependencies(deps) {
    for (const dep of deps) {
        dep.registerTypeUrl?.();
    }
}
