import { PageRequest } from "../../../../cosmos/base/query/v1beta1/pagination";
import { setPaginationParams } from "../../../../helpers";
import { QueryDenomTraceResponse, QueryDenomTracesResponse, QueryParamsResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* DenomTrace queries a denomination trace information. */
    denomTrace = async (params) => {
        const endpoint = `ibc/apps/transfer/v1/denom_traces/${params.hash}`;
        return QueryDenomTraceResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* DenomTraces queries all denomination traces. */
    denomTraces = async (params = {
        pagination: PageRequest.fromPartial({})
    }) => {
        const options = {
            params: {}
        };
        if (typeof params?.pagination !== "undefined") {
            setPaginationParams(options, params.pagination);
        }
        const endpoint = `ibc/apps/transfer/v1/denom_traces`;
        return QueryDenomTracesResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
    /* Params queries all parameters of the ibc-transfer module. */
    params = async (_params = {}) => {
        const endpoint = `ibc/apps/transfer/v1/params`;
        return QueryParamsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
}
