import { MsgTransfer } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* Transfer defines a rpc handler method for MsgTransfer. */
    transfer = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgTransfer.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
