import { BinaryReader } from "../../binary";
import { QueryEpochsInfoRequest, QueryEpochsInfoResponse, QueryCurrentEpochRequest, QueryCurrentEpochResponse } from "./query";
export class QueryClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* EpochInfos provide running epochInfos */
    epochInfos = async (request = {}) => {
        const data = QueryEpochsInfoRequest.encode(request).finish();
        const promise = this.rpc.request("osmosis.epochs.v1beta1.Query", "EpochInfos", data);
        return promise.then(data => QueryEpochsInfoResponse.decode(new BinaryReader(data)));
    };
    /* CurrentEpoch provide current epoch of specified identifier */
    currentEpoch = async (request) => {
        const data = QueryCurrentEpochRequest.encode(request).finish();
        const promise = this.rpc.request("osmosis.epochs.v1beta1.Query", "CurrentEpoch", data);
        return promise.then(data => QueryCurrentEpochResponse.decode(new BinaryReader(data)));
    };
}
export const createClientImpl = (rpc) => {
    return new QueryClientImpl(rpc);
};
