import { MsgCreateStableswapPool, MsgStableSwapAdjustScalingFactors } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* CreateStableswapPool */
    createStableswapPool = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgCreateStableswapPool.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* StableSwapAdjustScalingFactors */
    stableSwapAdjustScalingFactors = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgStableSwapAdjustScalingFactors.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
