import { MsgJoinPool, MsgExitPool, MsgSwapExactAmountIn, MsgSwapExactAmountOut, MsgJoinSwapExternAmountIn, MsgJoinSwapShareAmountOut, MsgExitSwapExternAmountOut, MsgExitSwapShareAmountIn } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* JoinPool */
    joinPool = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgJoinPool.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* ExitPool */
    exitPool = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgExitPool.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* SwapExactAmountIn */
    swapExactAmountIn = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgSwapExactAmountIn.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* SwapExactAmountOut */
    swapExactAmountOut = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgSwapExactAmountOut.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* JoinSwapExternAmountIn */
    joinSwapExternAmountIn = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgJoinSwapExternAmountIn.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* JoinSwapShareAmountOut */
    joinSwapShareAmountOut = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgJoinSwapShareAmountOut.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* ExitSwapExternAmountOut */
    exitSwapExternAmountOut = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgExitSwapExternAmountOut.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* ExitSwapShareAmountIn */
    exitSwapShareAmountIn = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgExitSwapShareAmountIn.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
