import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "osmosis.ibcratelimit.v1beta1";
function createBaseParams() {
    return {
        contractAddress: ""
    };
}
export const Params = {
    typeUrl: "/osmosis.ibcratelimit.v1beta1.Params",
    aminoType: "osmosis/ibcratelimit/params",
    is(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.contractAddress === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.contract_address === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.contract_address === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.contractAddress !== undefined) {
            writer.uint32(10).string(message.contractAddress);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseParams();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.contractAddress = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseParams();
        if (isSet(object.contractAddress))
            obj.contractAddress = String(object.contractAddress);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.contractAddress !== undefined && (obj.contractAddress = message.contractAddress);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseParams();
        message.contractAddress = object.contractAddress ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            contractAddress: object?.contract_address
        };
    },
    fromSDKJSON(object) {
        return {
            contract_address: isSet(object.contract_address) ? String(object.contract_address) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.contract_address = message.contractAddress;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseParams();
        if (object.contract_address !== undefined && object.contract_address !== null) {
            message.contractAddress = object.contract_address;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.contract_address = message.contractAddress === "" ? undefined : message.contractAddress;
        return obj;
    },
    fromAminoMsg(object) {
        return Params.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "osmosis/ibcratelimit/params",
            value: Params.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Params.decode(message.value);
    },
    toProto(message) {
        return Params.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/osmosis.ibcratelimit.v1beta1.Params",
            value: Params.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
