import { QueryParamsResponse, QueryDenomAuthorityMetadataResponse, QueryDenomsFromCreatorResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* Params defines a gRPC query method that returns the tokenfactory module's
     parameters. */
    params = async (_params = {}) => {
        const endpoint = `osmosis/tokenfactory/v1beta1/params`;
        return QueryParamsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* DenomAuthorityMetadata defines a gRPC query method for fetching
     DenomAuthorityMetadata for a particular denom. */
    denomAuthorityMetadata = async (params) => {
        const endpoint = `osmosis/tokenfactory/v1beta1/denoms/${params.denom}/authority_metadata`;
        return QueryDenomAuthorityMetadataResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* DenomsFromCreator defines a gRPC query method for fetching all
     denominations created by a specific admin/creator. */
    denomsFromCreator = async (params) => {
        const endpoint = `osmosis/tokenfactory/v1beta1/denoms_from_creator/${params.creator}`;
        return QueryDenomsFromCreatorResponse.fromSDKJSON(await this.req.get(endpoint));
    };
}
