import { MsgCreateDenom, MsgMint, MsgBurn, MsgChangeAdmin, MsgSetDenomMetadata } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* CreateDenom */
    createDenom = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgCreateDenom.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* Mint */
    mint = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgMint.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* Burn */
    burn = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgBurn.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* ChangeAdmin */
    changeAdmin = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgChangeAdmin.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* SetDenomMetadata */
    setDenomMetadata = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgSetDenomMetadata.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
