import { ParamsResponse, ArithmeticTwapResponse, ArithmeticTwapToNowResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* Params */
    params = async (_params = {}) => {
        const endpoint = `osmosis/twap/v1beta1/Params`;
        return ParamsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* ArithmeticTwap */
    arithmeticTwap = async (params) => {
        const options = {
            params: {}
        };
        if (typeof params?.poolId !== "undefined") {
            options.params.pool_id = params.poolId;
        }
        if (typeof params?.baseAsset !== "undefined") {
            options.params.base_asset = params.baseAsset;
        }
        if (typeof params?.quoteAsset !== "undefined") {
            options.params.quote_asset = params.quoteAsset;
        }
        if (typeof params?.startTime !== "undefined") {
            options.params.start_time = params.startTime;
        }
        if (typeof params?.endTime !== "undefined") {
            options.params.end_time = params.endTime;
        }
        const endpoint = `osmosis/twap/v1beta1/ArithmeticTwap`;
        return ArithmeticTwapResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
    /* ArithmeticTwapToNow */
    arithmeticTwapToNow = async (params) => {
        const options = {
            params: {}
        };
        if (typeof params?.poolId !== "undefined") {
            options.params.pool_id = params.poolId;
        }
        if (typeof params?.baseAsset !== "undefined") {
            options.params.base_asset = params.baseAsset;
        }
        if (typeof params?.quoteAsset !== "undefined") {
            options.params.quote_asset = params.quoteAsset;
        }
        if (typeof params?.startTime !== "undefined") {
            options.params.start_time = params.startTime;
        }
        const endpoint = `osmosis/twap/v1beta1/ArithmeticTwapToNow`;
        return ArithmeticTwapToNowResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
}
