/**
* This file and any referenced files were automatically generated by @cosmology/telescope@latest
* DO NOT MODIFY BY HAND. Instead, download the latest proto files for your chain
* and run the transpile command or npm scripts command that is used to regenerate this bundle.
*/
import { getRpcClient } from './extern';
import { isRpc, } from './helpers';
import { isISigningClient } from './helper-func-types';
import { useQuery, useQueryClient, useMutation, } from '@tanstack/react-query';
export const DEFAULT_RPC_CLIENT_QUERY_KEY = 'rpcClient';
export const DEFAULT_RPC_ENDPOINT_QUERY_KEY = 'rpcEndPoint';
export const DEFAULT_SIGNING_CLIENT_QUERY_KEY = 'signingClient';
export function isCacheResolver(resolver) {
    return resolver !== null && resolver !== undefined && resolver.rpcEndpoint !== undefined && resolver.clientQueryKey !== undefined;
}
export const useRpcEndpoint = ({ getter, options, rpcEndPointKey, extraKey }) => {
    const key = rpcEndPointKey || DEFAULT_RPC_ENDPOINT_QUERY_KEY;
    return useQuery([key, extraKey], async () => {
        return await getter();
    }, options);
};
export const useRpcClient = ({ options, clientResolver }) => {
    const queryClient = useQueryClient({
        context: options?.context
    });
    const key = clientResolver?.clientQueryKey || DEFAULT_RPC_CLIENT_QUERY_KEY;
    return useQuery([key, clientResolver?.rpcEndpoint], async () => {
        if (!clientResolver?.rpcEndpoint) {
            throw new Error('rpcEndpoint is required');
        }
        const client = await getRpcClient(clientResolver.rpcEndpoint);
        if (!client) {
            throw new Error('Failed to connect to rpc client');
        }
        queryClient.setQueryData([key], client);
        return client;
    }, options);
};
export function buildUseQuery(opts) {
    return ({ request, options, clientResolver, customizedQueryKey, }) => {
        const queryClient = useQueryClient({
            context: options?.context
        });
        let rpcResolver;
        if (isRpc(clientResolver)) {
            rpcResolver = clientResolver;
        }
        else if (isCacheResolver(clientResolver)) {
            const key = clientResolver.clientQueryKey || DEFAULT_RPC_CLIENT_QUERY_KEY;
            const queryKey = clientResolver.rpcEndpoint ? [key, clientResolver.rpcEndpoint] : [key];
            rpcResolver = queryClient.getQueryData(queryKey);
            if (!rpcResolver && clientResolver.rpcEndpoint) {
                rpcResolver = clientResolver.rpcEndpoint;
            }
        }
        else {
            rpcResolver = clientResolver;
        }
        const queryFn = opts.builderQueryFn(rpcResolver);
        return useQuery(customizedQueryKey || [opts.queryKeyPrefix, request], () => queryFn(request), options);
    };
}
export function buildUseMutation(opts) {
    return ({ options, clientResolver }) => {
        const queryClient = useQueryClient({
            context: options?.context
        });
        let signingClientResolver;
        if (isISigningClient(clientResolver)) {
            signingClientResolver = clientResolver;
        }
        else if (isCacheResolver(clientResolver)) {
            const key = clientResolver.clientQueryKey || DEFAULT_SIGNING_CLIENT_QUERY_KEY;
            const queryKey = clientResolver.rpcEndpoint ? [key, clientResolver.rpcEndpoint] : [key];
            signingClientResolver = queryClient.getQueryData(queryKey);
        }
        else {
            clientResolver = clientResolver;
        }
        const mutationFn = opts.builderMutationFn(signingClientResolver);
        return useMutation((reqData) => mutationFn(reqData.signerAddress, reqData.message, reqData.fee, reqData.memo), options);
    };
}
