import { ClaimsRecordAddress } from "./claims";
import { Timestamp } from "../../../google/protobuf/timestamp";
import { Duration } from "../../../google/protobuf/duration";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet, toTimestamp, fromTimestamp } from "../../../helpers";
export const protobufPackage = "evmos.claims.v1";
function createBaseGenesisState() {
    return {
        params: Params.fromPartial({}),
        claimsRecords: []
    };
}
export const GenesisState = {
    typeUrl: "/evmos.claims.v1.GenesisState",
    is(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Params.is(o.params) && Array.isArray(o.claimsRecords) && (!o.claimsRecords.length || ClaimsRecordAddress.is(o.claimsRecords[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Params.isSDK(o.params) && Array.isArray(o.claims_records) && (!o.claims_records.length || ClaimsRecordAddress.isSDK(o.claims_records[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Params.isAmino(o.params) && Array.isArray(o.claims_records) && (!o.claims_records.length || ClaimsRecordAddress.isAmino(o.claims_records[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.params !== undefined) {
            Params.encode(message.params, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.claimsRecords) {
            ClaimsRecordAddress.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGenesisState();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.params = Params.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.claimsRecords.push(ClaimsRecordAddress.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGenesisState();
        if (isSet(object.params))
            obj.params = Params.fromJSON(object.params);
        if (Array.isArray(object?.claimsRecords))
            obj.claimsRecords = object.claimsRecords.map((e) => ClaimsRecordAddress.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
        if (message.claimsRecords) {
            obj.claimsRecords = message.claimsRecords.map(e => e ? ClaimsRecordAddress.toJSON(e) : undefined);
        }
        else {
            obj.claimsRecords = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGenesisState();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromPartial(object.params);
        }
        message.claimsRecords = object.claimsRecords?.map(e => ClaimsRecordAddress.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            params: object.params ? Params.fromSDK(object.params) : undefined,
            claimsRecords: Array.isArray(object?.claims_records) ? object.claims_records.map((e) => ClaimsRecordAddress.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            params: isSet(object.params) ? Params.fromSDKJSON(object.params) : undefined,
            claims_records: Array.isArray(object?.claims_records) ? object.claims_records.map((e) => ClaimsRecordAddress.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toSDK(message.params) : undefined);
        if (message.claimsRecords) {
            obj.claims_records = message.claimsRecords.map(e => e ? ClaimsRecordAddress.toSDK(e) : undefined);
        }
        else {
            obj.claims_records = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGenesisState();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromAmino(object.params);
        }
        message.claimsRecords = object.claims_records?.map(e => ClaimsRecordAddress.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.params = message.params ? Params.toAmino(message.params) : undefined;
        if (message.claimsRecords) {
            obj.claims_records = message.claimsRecords.map(e => e ? ClaimsRecordAddress.toAmino(e) : undefined);
        }
        else {
            obj.claims_records = message.claimsRecords;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return GenesisState.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GenesisState.decode(message.value);
    },
    toProto(message) {
        return GenesisState.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.claims.v1.GenesisState",
            value: GenesisState.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Params.registerTypeUrl();
        ClaimsRecordAddress.registerTypeUrl();
    }
};
function createBaseParams() {
    return {
        enableClaims: false,
        airdropStartTime: new Date(),
        durationUntilDecay: Duration.fromPartial({}),
        durationOfDecay: Duration.fromPartial({}),
        claimsDenom: "",
        authorizedChannels: [],
        evmChannels: []
    };
}
export const Params = {
    typeUrl: "/evmos.claims.v1.Params",
    is(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.enableClaims === "boolean" && Timestamp.is(o.airdropStartTime) && Duration.is(o.durationUntilDecay) && Duration.is(o.durationOfDecay) && typeof o.claimsDenom === "string" && Array.isArray(o.authorizedChannels) && (!o.authorizedChannels.length || typeof o.authorizedChannels[0] === "string") && Array.isArray(o.evmChannels) && (!o.evmChannels.length || typeof o.evmChannels[0] === "string"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.enable_claims === "boolean" && Timestamp.isSDK(o.airdrop_start_time) && Duration.isSDK(o.duration_until_decay) && Duration.isSDK(o.duration_of_decay) && typeof o.claims_denom === "string" && Array.isArray(o.authorized_channels) && (!o.authorized_channels.length || typeof o.authorized_channels[0] === "string") && Array.isArray(o.evm_channels) && (!o.evm_channels.length || typeof o.evm_channels[0] === "string"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.enable_claims === "boolean" && Timestamp.isAmino(o.airdrop_start_time) && Duration.isAmino(o.duration_until_decay) && Duration.isAmino(o.duration_of_decay) && typeof o.claims_denom === "string" && Array.isArray(o.authorized_channels) && (!o.authorized_channels.length || typeof o.authorized_channels[0] === "string") && Array.isArray(o.evm_channels) && (!o.evm_channels.length || typeof o.evm_channels[0] === "string"));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.enableClaims !== undefined) {
            writer.uint32(8).bool(message.enableClaims);
        }
        if (message.airdropStartTime !== undefined) {
            Timestamp.encode(toTimestamp(message.airdropStartTime), writer.uint32(18).fork()).ldelim();
        }
        if (message.durationUntilDecay !== undefined) {
            Duration.encode(message.durationUntilDecay, writer.uint32(26).fork()).ldelim();
        }
        if (message.durationOfDecay !== undefined) {
            Duration.encode(message.durationOfDecay, writer.uint32(34).fork()).ldelim();
        }
        if (message.claimsDenom !== undefined) {
            writer.uint32(42).string(message.claimsDenom);
        }
        for (const v of message.authorizedChannels) {
            writer.uint32(50).string(v);
        }
        for (const v of message.evmChannels) {
            writer.uint32(58).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseParams();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.enableClaims = reader.bool();
                    break;
                case 2:
                    message.airdropStartTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.durationUntilDecay = Duration.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.durationOfDecay = Duration.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.claimsDenom = reader.string();
                    break;
                case 6:
                    message.authorizedChannels.push(reader.string());
                    break;
                case 7:
                    message.evmChannels.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseParams();
        if (isSet(object.enableClaims))
            obj.enableClaims = Boolean(object.enableClaims);
        if (isSet(object.airdropStartTime))
            obj.airdropStartTime = new Date(object.airdropStartTime);
        if (isSet(object.durationUntilDecay))
            obj.durationUntilDecay = Duration.fromJSON(object.durationUntilDecay);
        if (isSet(object.durationOfDecay))
            obj.durationOfDecay = Duration.fromJSON(object.durationOfDecay);
        if (isSet(object.claimsDenom))
            obj.claimsDenom = String(object.claimsDenom);
        if (Array.isArray(object?.authorizedChannels))
            obj.authorizedChannels = object.authorizedChannels.map((e) => String(e));
        if (Array.isArray(object?.evmChannels))
            obj.evmChannels = object.evmChannels.map((e) => String(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.enableClaims !== undefined && (obj.enableClaims = message.enableClaims);
        message.airdropStartTime !== undefined && (obj.airdropStartTime = message.airdropStartTime.toISOString());
        message.durationUntilDecay !== undefined && (obj.durationUntilDecay = message.durationUntilDecay ? Duration.toJSON(message.durationUntilDecay) : undefined);
        message.durationOfDecay !== undefined && (obj.durationOfDecay = message.durationOfDecay ? Duration.toJSON(message.durationOfDecay) : undefined);
        message.claimsDenom !== undefined && (obj.claimsDenom = message.claimsDenom);
        if (message.authorizedChannels) {
            obj.authorizedChannels = message.authorizedChannels.map(e => e);
        }
        else {
            obj.authorizedChannels = [];
        }
        if (message.evmChannels) {
            obj.evmChannels = message.evmChannels.map(e => e);
        }
        else {
            obj.evmChannels = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseParams();
        message.enableClaims = object.enableClaims ?? false;
        message.airdropStartTime = object.airdropStartTime ?? undefined;
        if (object.durationUntilDecay !== undefined && object.durationUntilDecay !== null) {
            message.durationUntilDecay = Duration.fromPartial(object.durationUntilDecay);
        }
        if (object.durationOfDecay !== undefined && object.durationOfDecay !== null) {
            message.durationOfDecay = Duration.fromPartial(object.durationOfDecay);
        }
        message.claimsDenom = object.claimsDenom ?? "";
        message.authorizedChannels = object.authorizedChannels?.map(e => e) || [];
        message.evmChannels = object.evmChannels?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            enableClaims: object?.enable_claims,
            airdropStartTime: object.airdrop_start_time ?? undefined,
            durationUntilDecay: object.duration_until_decay ? Duration.fromSDK(object.duration_until_decay) : undefined,
            durationOfDecay: object.duration_of_decay ? Duration.fromSDK(object.duration_of_decay) : undefined,
            claimsDenom: object?.claims_denom,
            authorizedChannels: Array.isArray(object?.authorized_channels) ? object.authorized_channels.map((e) => e) : [],
            evmChannels: Array.isArray(object?.evm_channels) ? object.evm_channels.map((e) => e) : []
        };
    },
    fromSDKJSON(object) {
        return {
            enable_claims: isSet(object.enable_claims) ? Boolean(object.enable_claims) : false,
            airdrop_start_time: isSet(object.airdrop_start_time) ? new Date(object.airdrop_start_time) : undefined,
            duration_until_decay: isSet(object.duration_until_decay) ? Duration.fromSDKJSON(object.duration_until_decay) : undefined,
            duration_of_decay: isSet(object.duration_of_decay) ? Duration.fromSDKJSON(object.duration_of_decay) : undefined,
            claims_denom: isSet(object.claims_denom) ? String(object.claims_denom) : "",
            authorized_channels: Array.isArray(object?.authorized_channels) ? object.authorized_channels.map((e) => String(e)) : [],
            evm_channels: Array.isArray(object?.evm_channels) ? object.evm_channels.map((e) => String(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.enable_claims = message.enableClaims;
        message.airdropStartTime !== undefined && (obj.airdrop_start_time = message.airdropStartTime ?? undefined);
        message.durationUntilDecay !== undefined && (obj.duration_until_decay = message.durationUntilDecay ? Duration.toSDK(message.durationUntilDecay) : undefined);
        message.durationOfDecay !== undefined && (obj.duration_of_decay = message.durationOfDecay ? Duration.toSDK(message.durationOfDecay) : undefined);
        obj.claims_denom = message.claimsDenom;
        if (message.authorizedChannels) {
            obj.authorized_channels = message.authorizedChannels.map(e => e);
        }
        else {
            obj.authorized_channels = [];
        }
        if (message.evmChannels) {
            obj.evm_channels = message.evmChannels.map(e => e);
        }
        else {
            obj.evm_channels = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseParams();
        if (object.enable_claims !== undefined && object.enable_claims !== null) {
            message.enableClaims = object.enable_claims;
        }
        if (object.airdrop_start_time !== undefined && object.airdrop_start_time !== null) {
            message.airdropStartTime = fromTimestamp(Timestamp.fromAmino(object.airdrop_start_time));
        }
        if (object.duration_until_decay !== undefined && object.duration_until_decay !== null) {
            message.durationUntilDecay = Duration.fromAmino(object.duration_until_decay);
        }
        if (object.duration_of_decay !== undefined && object.duration_of_decay !== null) {
            message.durationOfDecay = Duration.fromAmino(object.duration_of_decay);
        }
        if (object.claims_denom !== undefined && object.claims_denom !== null) {
            message.claimsDenom = object.claims_denom;
        }
        message.authorizedChannels = object.authorized_channels?.map(e => e) || [];
        message.evmChannels = object.evm_channels?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.enable_claims = message.enableClaims === false ? undefined : message.enableClaims;
        obj.airdrop_start_time = message.airdropStartTime ? Timestamp.toAmino(toTimestamp(message.airdropStartTime)) : undefined;
        obj.duration_until_decay = message.durationUntilDecay ? Duration.toAmino(message.durationUntilDecay) : undefined;
        obj.duration_of_decay = message.durationOfDecay ? Duration.toAmino(message.durationOfDecay) : undefined;
        obj.claims_denom = message.claimsDenom === "" ? undefined : message.claimsDenom;
        if (message.authorizedChannels) {
            obj.authorized_channels = message.authorizedChannels.map(e => e);
        }
        else {
            obj.authorized_channels = message.authorizedChannels;
        }
        if (message.evmChannels) {
            obj.evm_channels = message.evmChannels.map(e => e);
        }
        else {
            obj.evm_channels = message.evmChannels;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Params.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Params.decode(message.value);
    },
    toProto(message) {
        return Params.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.claims.v1.Params",
            value: Params.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
