import { PageRequest, PageRequestAmino, PageRequestSDKType, PageResponse, PageResponseAmino, PageResponseSDKType } from "../../../cosmos/base/query/v1beta1/pagination";
import { Coin, CoinAmino, CoinSDKType } from "../../../cosmos/base/v1beta1/coin";
import { Params, ParamsAmino, ParamsSDKType } from "./genesis";
import { ClaimsRecordAddress, ClaimsRecordAddressAmino, ClaimsRecordAddressSDKType, Claim, ClaimAmino, ClaimSDKType } from "./claims";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { JsonSafe } from "../../../json-safe";
import { DeepPartial } from "../../../helpers";
export declare const protobufPackage = "evmos.claims.v1";
/**
 * QueryTotalUnclaimedRequest is the request type for the Query/TotalUnclaimed
 * RPC method.
 */
export interface QueryTotalUnclaimedRequest {
}
export interface QueryTotalUnclaimedRequestProtoMsg {
    typeUrl: "/evmos.claims.v1.QueryTotalUnclaimedRequest";
    value: Uint8Array;
}
/**
 * QueryTotalUnclaimedRequest is the request type for the Query/TotalUnclaimed
 * RPC method.
 */
export interface QueryTotalUnclaimedRequestAmino {
}
export interface QueryTotalUnclaimedRequestAminoMsg {
    type: "/evmos.claims.v1.QueryTotalUnclaimedRequest";
    value: QueryTotalUnclaimedRequestAmino;
}
/**
 * QueryTotalUnclaimedRequest is the request type for the Query/TotalUnclaimed
 * RPC method.
 */
export interface QueryTotalUnclaimedRequestSDKType {
}
/**
 * QueryTotalUnclaimedResponse is the response type for the Query/TotalUnclaimed
 * RPC method.
 */
export interface QueryTotalUnclaimedResponse {
    /** coins defines the unclaimed coins */
    coins: Coin[];
}
export interface QueryTotalUnclaimedResponseProtoMsg {
    typeUrl: "/evmos.claims.v1.QueryTotalUnclaimedResponse";
    value: Uint8Array;
}
/**
 * QueryTotalUnclaimedResponse is the response type for the Query/TotalUnclaimed
 * RPC method.
 */
export interface QueryTotalUnclaimedResponseAmino {
    /** coins defines the unclaimed coins */
    coins?: CoinAmino[];
}
export interface QueryTotalUnclaimedResponseAminoMsg {
    type: "/evmos.claims.v1.QueryTotalUnclaimedResponse";
    value: QueryTotalUnclaimedResponseAmino;
}
/**
 * QueryTotalUnclaimedResponse is the response type for the Query/TotalUnclaimed
 * RPC method.
 */
export interface QueryTotalUnclaimedResponseSDKType {
    coins: CoinSDKType[];
}
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequest {
}
export interface QueryParamsRequestProtoMsg {
    typeUrl: "/evmos.claims.v1.QueryParamsRequest";
    value: Uint8Array;
}
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequestAmino {
}
export interface QueryParamsRequestAminoMsg {
    type: "/evmos.claims.v1.QueryParamsRequest";
    value: QueryParamsRequestAmino;
}
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequestSDKType {
}
/** QueryParamsResponse is the response type for the Query/Params RPC method. */
export interface QueryParamsResponse {
    /** params defines the parameters of the module. */
    params: Params;
}
export interface QueryParamsResponseProtoMsg {
    typeUrl: "/evmos.claims.v1.QueryParamsResponse";
    value: Uint8Array;
}
/** QueryParamsResponse is the response type for the Query/Params RPC method. */
export interface QueryParamsResponseAmino {
    /** params defines the parameters of the module. */
    params?: ParamsAmino;
}
export interface QueryParamsResponseAminoMsg {
    type: "/evmos.claims.v1.QueryParamsResponse";
    value: QueryParamsResponseAmino;
}
/** QueryParamsResponse is the response type for the Query/Params RPC method. */
export interface QueryParamsResponseSDKType {
    params: ParamsSDKType;
}
/**
 * QueryClaimsRecordsRequest is the request type for the Query/ClaimsRecords RPC
 * method.
 */
export interface QueryClaimsRecordsRequest {
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequest;
}
export interface QueryClaimsRecordsRequestProtoMsg {
    typeUrl: "/evmos.claims.v1.QueryClaimsRecordsRequest";
    value: Uint8Array;
}
/**
 * QueryClaimsRecordsRequest is the request type for the Query/ClaimsRecords RPC
 * method.
 */
export interface QueryClaimsRecordsRequestAmino {
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequestAmino;
}
export interface QueryClaimsRecordsRequestAminoMsg {
    type: "/evmos.claims.v1.QueryClaimsRecordsRequest";
    value: QueryClaimsRecordsRequestAmino;
}
/**
 * QueryClaimsRecordsRequest is the request type for the Query/ClaimsRecords RPC
 * method.
 */
export interface QueryClaimsRecordsRequestSDKType {
    pagination?: PageRequestSDKType;
}
/**
 * QueryClaimsRecordsResponse is the response type for the Query/ClaimsRecords
 * RPC method.
 */
export interface QueryClaimsRecordsResponse {
    /** claims defines all claims records */
    claims: ClaimsRecordAddress[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponse;
}
export interface QueryClaimsRecordsResponseProtoMsg {
    typeUrl: "/evmos.claims.v1.QueryClaimsRecordsResponse";
    value: Uint8Array;
}
/**
 * QueryClaimsRecordsResponse is the response type for the Query/ClaimsRecords
 * RPC method.
 */
export interface QueryClaimsRecordsResponseAmino {
    /** claims defines all claims records */
    claims?: ClaimsRecordAddressAmino[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponseAmino;
}
export interface QueryClaimsRecordsResponseAminoMsg {
    type: "/evmos.claims.v1.QueryClaimsRecordsResponse";
    value: QueryClaimsRecordsResponseAmino;
}
/**
 * QueryClaimsRecordsResponse is the response type for the Query/ClaimsRecords
 * RPC method.
 */
export interface QueryClaimsRecordsResponseSDKType {
    claims: ClaimsRecordAddressSDKType[];
    pagination?: PageResponseSDKType;
}
/**
 * QueryClaimsRecordRequest is the request type for the Query/ClaimsRecord RPC
 * method.
 */
export interface QueryClaimsRecordRequest {
    /** address defines the user to query claims record for */
    address: string;
}
export interface QueryClaimsRecordRequestProtoMsg {
    typeUrl: "/evmos.claims.v1.QueryClaimsRecordRequest";
    value: Uint8Array;
}
/**
 * QueryClaimsRecordRequest is the request type for the Query/ClaimsRecord RPC
 * method.
 */
export interface QueryClaimsRecordRequestAmino {
    /** address defines the user to query claims record for */
    address?: string;
}
export interface QueryClaimsRecordRequestAminoMsg {
    type: "/evmos.claims.v1.QueryClaimsRecordRequest";
    value: QueryClaimsRecordRequestAmino;
}
/**
 * QueryClaimsRecordRequest is the request type for the Query/ClaimsRecord RPC
 * method.
 */
export interface QueryClaimsRecordRequestSDKType {
    address: string;
}
/**
 * QueryClaimsRecordResponse is the response type for the Query/ClaimsRecord RPC
 * method.
 */
export interface QueryClaimsRecordResponse {
    /** total initial claimable amount for the user */
    initialClaimableAmount: string;
    /** the claims of the user */
    claims: Claim[];
}
export interface QueryClaimsRecordResponseProtoMsg {
    typeUrl: "/evmos.claims.v1.QueryClaimsRecordResponse";
    value: Uint8Array;
}
/**
 * QueryClaimsRecordResponse is the response type for the Query/ClaimsRecord RPC
 * method.
 */
export interface QueryClaimsRecordResponseAmino {
    /** total initial claimable amount for the user */
    initial_claimable_amount?: string;
    /** the claims of the user */
    claims?: ClaimAmino[];
}
export interface QueryClaimsRecordResponseAminoMsg {
    type: "/evmos.claims.v1.QueryClaimsRecordResponse";
    value: QueryClaimsRecordResponseAmino;
}
/**
 * QueryClaimsRecordResponse is the response type for the Query/ClaimsRecord RPC
 * method.
 */
export interface QueryClaimsRecordResponseSDKType {
    initial_claimable_amount: string;
    claims: ClaimSDKType[];
}
export declare const QueryTotalUnclaimedRequest: {
    typeUrl: string;
    is(o: any): o is QueryTotalUnclaimedRequest;
    isSDK(o: any): o is QueryTotalUnclaimedRequestSDKType;
    isAmino(o: any): o is QueryTotalUnclaimedRequestAmino;
    encode(_: QueryTotalUnclaimedRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryTotalUnclaimedRequest;
    fromJSON(_: any): QueryTotalUnclaimedRequest;
    toJSON(_: QueryTotalUnclaimedRequest): JsonSafe<QueryTotalUnclaimedRequest>;
    fromPartial(_: DeepPartial<QueryTotalUnclaimedRequest>): QueryTotalUnclaimedRequest;
    fromSDK(_: QueryTotalUnclaimedRequestSDKType): QueryTotalUnclaimedRequest;
    fromSDKJSON(_: any): QueryTotalUnclaimedRequestSDKType;
    toSDK(_: QueryTotalUnclaimedRequest): QueryTotalUnclaimedRequestSDKType;
    fromAmino(_: QueryTotalUnclaimedRequestAmino): QueryTotalUnclaimedRequest;
    toAmino(_: QueryTotalUnclaimedRequest): QueryTotalUnclaimedRequestAmino;
    fromAminoMsg(object: QueryTotalUnclaimedRequestAminoMsg): QueryTotalUnclaimedRequest;
    fromProtoMsg(message: QueryTotalUnclaimedRequestProtoMsg): QueryTotalUnclaimedRequest;
    toProto(message: QueryTotalUnclaimedRequest): Uint8Array;
    toProtoMsg(message: QueryTotalUnclaimedRequest): QueryTotalUnclaimedRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryTotalUnclaimedResponse: {
    typeUrl: string;
    is(o: any): o is QueryTotalUnclaimedResponse;
    isSDK(o: any): o is QueryTotalUnclaimedResponseSDKType;
    isAmino(o: any): o is QueryTotalUnclaimedResponseAmino;
    encode(message: QueryTotalUnclaimedResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryTotalUnclaimedResponse;
    fromJSON(object: any): QueryTotalUnclaimedResponse;
    toJSON(message: QueryTotalUnclaimedResponse): JsonSafe<QueryTotalUnclaimedResponse>;
    fromPartial(object: DeepPartial<QueryTotalUnclaimedResponse>): QueryTotalUnclaimedResponse;
    fromSDK(object: QueryTotalUnclaimedResponseSDKType): QueryTotalUnclaimedResponse;
    fromSDKJSON(object: any): QueryTotalUnclaimedResponseSDKType;
    toSDK(message: QueryTotalUnclaimedResponse): QueryTotalUnclaimedResponseSDKType;
    fromAmino(object: QueryTotalUnclaimedResponseAmino): QueryTotalUnclaimedResponse;
    toAmino(message: QueryTotalUnclaimedResponse): QueryTotalUnclaimedResponseAmino;
    fromAminoMsg(object: QueryTotalUnclaimedResponseAminoMsg): QueryTotalUnclaimedResponse;
    fromProtoMsg(message: QueryTotalUnclaimedResponseProtoMsg): QueryTotalUnclaimedResponse;
    toProto(message: QueryTotalUnclaimedResponse): Uint8Array;
    toProtoMsg(message: QueryTotalUnclaimedResponse): QueryTotalUnclaimedResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryParamsRequest: {
    typeUrl: string;
    is(o: any): o is QueryParamsRequest;
    isSDK(o: any): o is QueryParamsRequestSDKType;
    isAmino(o: any): o is QueryParamsRequestAmino;
    encode(_: QueryParamsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryParamsRequest;
    fromJSON(_: any): QueryParamsRequest;
    toJSON(_: QueryParamsRequest): JsonSafe<QueryParamsRequest>;
    fromPartial(_: DeepPartial<QueryParamsRequest>): QueryParamsRequest;
    fromSDK(_: QueryParamsRequestSDKType): QueryParamsRequest;
    fromSDKJSON(_: any): QueryParamsRequestSDKType;
    toSDK(_: QueryParamsRequest): QueryParamsRequestSDKType;
    fromAmino(_: QueryParamsRequestAmino): QueryParamsRequest;
    toAmino(_: QueryParamsRequest): QueryParamsRequestAmino;
    fromAminoMsg(object: QueryParamsRequestAminoMsg): QueryParamsRequest;
    fromProtoMsg(message: QueryParamsRequestProtoMsg): QueryParamsRequest;
    toProto(message: QueryParamsRequest): Uint8Array;
    toProtoMsg(message: QueryParamsRequest): QueryParamsRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryParamsResponse: {
    typeUrl: string;
    is(o: any): o is QueryParamsResponse;
    isSDK(o: any): o is QueryParamsResponseSDKType;
    isAmino(o: any): o is QueryParamsResponseAmino;
    encode(message: QueryParamsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryParamsResponse;
    fromJSON(object: any): QueryParamsResponse;
    toJSON(message: QueryParamsResponse): JsonSafe<QueryParamsResponse>;
    fromPartial(object: DeepPartial<QueryParamsResponse>): QueryParamsResponse;
    fromSDK(object: QueryParamsResponseSDKType): QueryParamsResponse;
    fromSDKJSON(object: any): QueryParamsResponseSDKType;
    toSDK(message: QueryParamsResponse): QueryParamsResponseSDKType;
    fromAmino(object: QueryParamsResponseAmino): QueryParamsResponse;
    toAmino(message: QueryParamsResponse): QueryParamsResponseAmino;
    fromAminoMsg(object: QueryParamsResponseAminoMsg): QueryParamsResponse;
    fromProtoMsg(message: QueryParamsResponseProtoMsg): QueryParamsResponse;
    toProto(message: QueryParamsResponse): Uint8Array;
    toProtoMsg(message: QueryParamsResponse): QueryParamsResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryClaimsRecordsRequest: {
    typeUrl: string;
    is(o: any): o is QueryClaimsRecordsRequest;
    isSDK(o: any): o is QueryClaimsRecordsRequestSDKType;
    isAmino(o: any): o is QueryClaimsRecordsRequestAmino;
    encode(message: QueryClaimsRecordsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryClaimsRecordsRequest;
    fromJSON(object: any): QueryClaimsRecordsRequest;
    toJSON(message: QueryClaimsRecordsRequest): JsonSafe<QueryClaimsRecordsRequest>;
    fromPartial(object: DeepPartial<QueryClaimsRecordsRequest>): QueryClaimsRecordsRequest;
    fromSDK(object: QueryClaimsRecordsRequestSDKType): QueryClaimsRecordsRequest;
    fromSDKJSON(object: any): QueryClaimsRecordsRequestSDKType;
    toSDK(message: QueryClaimsRecordsRequest): QueryClaimsRecordsRequestSDKType;
    fromAmino(object: QueryClaimsRecordsRequestAmino): QueryClaimsRecordsRequest;
    toAmino(message: QueryClaimsRecordsRequest): QueryClaimsRecordsRequestAmino;
    fromAminoMsg(object: QueryClaimsRecordsRequestAminoMsg): QueryClaimsRecordsRequest;
    fromProtoMsg(message: QueryClaimsRecordsRequestProtoMsg): QueryClaimsRecordsRequest;
    toProto(message: QueryClaimsRecordsRequest): Uint8Array;
    toProtoMsg(message: QueryClaimsRecordsRequest): QueryClaimsRecordsRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryClaimsRecordsResponse: {
    typeUrl: string;
    is(o: any): o is QueryClaimsRecordsResponse;
    isSDK(o: any): o is QueryClaimsRecordsResponseSDKType;
    isAmino(o: any): o is QueryClaimsRecordsResponseAmino;
    encode(message: QueryClaimsRecordsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryClaimsRecordsResponse;
    fromJSON(object: any): QueryClaimsRecordsResponse;
    toJSON(message: QueryClaimsRecordsResponse): JsonSafe<QueryClaimsRecordsResponse>;
    fromPartial(object: DeepPartial<QueryClaimsRecordsResponse>): QueryClaimsRecordsResponse;
    fromSDK(object: QueryClaimsRecordsResponseSDKType): QueryClaimsRecordsResponse;
    fromSDKJSON(object: any): QueryClaimsRecordsResponseSDKType;
    toSDK(message: QueryClaimsRecordsResponse): QueryClaimsRecordsResponseSDKType;
    fromAmino(object: QueryClaimsRecordsResponseAmino): QueryClaimsRecordsResponse;
    toAmino(message: QueryClaimsRecordsResponse): QueryClaimsRecordsResponseAmino;
    fromAminoMsg(object: QueryClaimsRecordsResponseAminoMsg): QueryClaimsRecordsResponse;
    fromProtoMsg(message: QueryClaimsRecordsResponseProtoMsg): QueryClaimsRecordsResponse;
    toProto(message: QueryClaimsRecordsResponse): Uint8Array;
    toProtoMsg(message: QueryClaimsRecordsResponse): QueryClaimsRecordsResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryClaimsRecordRequest: {
    typeUrl: string;
    is(o: any): o is QueryClaimsRecordRequest;
    isSDK(o: any): o is QueryClaimsRecordRequestSDKType;
    isAmino(o: any): o is QueryClaimsRecordRequestAmino;
    encode(message: QueryClaimsRecordRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryClaimsRecordRequest;
    fromJSON(object: any): QueryClaimsRecordRequest;
    toJSON(message: QueryClaimsRecordRequest): JsonSafe<QueryClaimsRecordRequest>;
    fromPartial(object: DeepPartial<QueryClaimsRecordRequest>): QueryClaimsRecordRequest;
    fromSDK(object: QueryClaimsRecordRequestSDKType): QueryClaimsRecordRequest;
    fromSDKJSON(object: any): QueryClaimsRecordRequestSDKType;
    toSDK(message: QueryClaimsRecordRequest): QueryClaimsRecordRequestSDKType;
    fromAmino(object: QueryClaimsRecordRequestAmino): QueryClaimsRecordRequest;
    toAmino(message: QueryClaimsRecordRequest): QueryClaimsRecordRequestAmino;
    fromAminoMsg(object: QueryClaimsRecordRequestAminoMsg): QueryClaimsRecordRequest;
    fromProtoMsg(message: QueryClaimsRecordRequestProtoMsg): QueryClaimsRecordRequest;
    toProto(message: QueryClaimsRecordRequest): Uint8Array;
    toProtoMsg(message: QueryClaimsRecordRequest): QueryClaimsRecordRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryClaimsRecordResponse: {
    typeUrl: string;
    is(o: any): o is QueryClaimsRecordResponse;
    isSDK(o: any): o is QueryClaimsRecordResponseSDKType;
    isAmino(o: any): o is QueryClaimsRecordResponseAmino;
    encode(message: QueryClaimsRecordResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryClaimsRecordResponse;
    fromJSON(object: any): QueryClaimsRecordResponse;
    toJSON(message: QueryClaimsRecordResponse): JsonSafe<QueryClaimsRecordResponse>;
    fromPartial(object: DeepPartial<QueryClaimsRecordResponse>): QueryClaimsRecordResponse;
    fromSDK(object: QueryClaimsRecordResponseSDKType): QueryClaimsRecordResponse;
    fromSDKJSON(object: any): QueryClaimsRecordResponseSDKType;
    toSDK(message: QueryClaimsRecordResponse): QueryClaimsRecordResponseSDKType;
    fromAmino(object: QueryClaimsRecordResponseAmino): QueryClaimsRecordResponse;
    toAmino(message: QueryClaimsRecordResponse): QueryClaimsRecordResponseAmino;
    fromAminoMsg(object: QueryClaimsRecordResponseAminoMsg): QueryClaimsRecordResponse;
    fromProtoMsg(message: QueryClaimsRecordResponseProtoMsg): QueryClaimsRecordResponse;
    toProto(message: QueryClaimsRecordResponse): Uint8Array;
    toProtoMsg(message: QueryClaimsRecordResponse): QueryClaimsRecordResponseProtoMsg;
    registerTypeUrl(): void;
};
