import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import { Coin } from "../../../cosmos/base/v1beta1/coin";
import { Params } from "./genesis";
import { ClaimsRecordAddress, Claim } from "./claims";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "evmos.claims.v1";
function createBaseQueryTotalUnclaimedRequest() {
    return {};
}
export const QueryTotalUnclaimedRequest = {
    typeUrl: "/evmos.claims.v1.QueryTotalUnclaimedRequest",
    is(o) {
        return o && o.$typeUrl === QueryTotalUnclaimedRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryTotalUnclaimedRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryTotalUnclaimedRequest.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryTotalUnclaimedRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseQueryTotalUnclaimedRequest();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseQueryTotalUnclaimedRequest();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseQueryTotalUnclaimedRequest();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return QueryTotalUnclaimedRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryTotalUnclaimedRequest.decode(message.value);
    },
    toProto(message) {
        return QueryTotalUnclaimedRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.claims.v1.QueryTotalUnclaimedRequest",
            value: QueryTotalUnclaimedRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryTotalUnclaimedResponse() {
    return {
        coins: []
    };
}
export const QueryTotalUnclaimedResponse = {
    typeUrl: "/evmos.claims.v1.QueryTotalUnclaimedResponse",
    is(o) {
        return o && (o.$typeUrl === QueryTotalUnclaimedResponse.typeUrl || Array.isArray(o.coins) && (!o.coins.length || Coin.is(o.coins[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryTotalUnclaimedResponse.typeUrl || Array.isArray(o.coins) && (!o.coins.length || Coin.isSDK(o.coins[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryTotalUnclaimedResponse.typeUrl || Array.isArray(o.coins) && (!o.coins.length || Coin.isAmino(o.coins[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.coins) {
            Coin.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryTotalUnclaimedResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.coins.push(Coin.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryTotalUnclaimedResponse();
        if (Array.isArray(object?.coins))
            obj.coins = object.coins.map((e) => Coin.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.coins) {
            obj.coins = message.coins.map(e => e ? Coin.toJSON(e) : undefined);
        }
        else {
            obj.coins = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryTotalUnclaimedResponse();
        message.coins = object.coins?.map(e => Coin.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            coins: Array.isArray(object?.coins) ? object.coins.map((e) => Coin.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            coins: Array.isArray(object?.coins) ? object.coins.map((e) => Coin.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.coins) {
            obj.coins = message.coins.map(e => e ? Coin.toSDK(e) : undefined);
        }
        else {
            obj.coins = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryTotalUnclaimedResponse();
        message.coins = object.coins?.map(e => Coin.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.coins) {
            obj.coins = message.coins.map(e => e ? Coin.toAmino(e) : undefined);
        }
        else {
            obj.coins = message.coins;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return QueryTotalUnclaimedResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryTotalUnclaimedResponse.decode(message.value);
    },
    toProto(message) {
        return QueryTotalUnclaimedResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.claims.v1.QueryTotalUnclaimedResponse",
            value: QueryTotalUnclaimedResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Coin.registerTypeUrl();
    }
};
function createBaseQueryParamsRequest() {
    return {};
}
export const QueryParamsRequest = {
    typeUrl: "/evmos.claims.v1.QueryParamsRequest",
    is(o) {
        return o && o.$typeUrl === QueryParamsRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryParamsRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryParamsRequest.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParamsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseQueryParamsRequest();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseQueryParamsRequest();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseQueryParamsRequest();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return QueryParamsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryParamsRequest.decode(message.value);
    },
    toProto(message) {
        return QueryParamsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.claims.v1.QueryParamsRequest",
            value: QueryParamsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryParamsResponse() {
    return {
        params: Params.fromPartial({})
    };
}
export const QueryParamsResponse = {
    typeUrl: "/evmos.claims.v1.QueryParamsResponse",
    is(o) {
        return o && (o.$typeUrl === QueryParamsResponse.typeUrl || Params.is(o.params));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryParamsResponse.typeUrl || Params.isSDK(o.params));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryParamsResponse.typeUrl || Params.isAmino(o.params));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.params !== undefined) {
            Params.encode(message.params, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParamsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.params = Params.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryParamsResponse();
        if (isSet(object.params))
            obj.params = Params.fromJSON(object.params);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryParamsResponse();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromPartial(object.params);
        }
        return message;
    },
    fromSDK(object) {
        return {
            params: object.params ? Params.fromSDK(object.params) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            params: isSet(object.params) ? Params.fromSDKJSON(object.params) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toSDK(message.params) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryParamsResponse();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromAmino(object.params);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.params = message.params ? Params.toAmino(message.params) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryParamsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryParamsResponse.decode(message.value);
    },
    toProto(message) {
        return QueryParamsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.claims.v1.QueryParamsResponse",
            value: QueryParamsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Params.registerTypeUrl();
    }
};
function createBaseQueryClaimsRecordsRequest() {
    return {
        pagination: undefined
    };
}
export const QueryClaimsRecordsRequest = {
    typeUrl: "/evmos.claims.v1.QueryClaimsRecordsRequest",
    is(o) {
        return o && o.$typeUrl === QueryClaimsRecordsRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryClaimsRecordsRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryClaimsRecordsRequest.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryClaimsRecordsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryClaimsRecordsRequest();
        if (isSet(object.pagination))
            obj.pagination = PageRequest.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryClaimsRecordsRequest();
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            pagination: object.pagination ? PageRequest.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            pagination: isSet(object.pagination) ? PageRequest.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryClaimsRecordsRequest();
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.pagination = message.pagination ? PageRequest.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryClaimsRecordsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryClaimsRecordsRequest.decode(message.value);
    },
    toProto(message) {
        return QueryClaimsRecordsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.claims.v1.QueryClaimsRecordsRequest",
            value: QueryClaimsRecordsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        PageRequest.registerTypeUrl();
    }
};
function createBaseQueryClaimsRecordsResponse() {
    return {
        claims: [],
        pagination: undefined
    };
}
export const QueryClaimsRecordsResponse = {
    typeUrl: "/evmos.claims.v1.QueryClaimsRecordsResponse",
    is(o) {
        return o && (o.$typeUrl === QueryClaimsRecordsResponse.typeUrl || Array.isArray(o.claims) && (!o.claims.length || ClaimsRecordAddress.is(o.claims[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryClaimsRecordsResponse.typeUrl || Array.isArray(o.claims) && (!o.claims.length || ClaimsRecordAddress.isSDK(o.claims[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryClaimsRecordsResponse.typeUrl || Array.isArray(o.claims) && (!o.claims.length || ClaimsRecordAddress.isAmino(o.claims[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.claims) {
            ClaimsRecordAddress.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryClaimsRecordsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.claims.push(ClaimsRecordAddress.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryClaimsRecordsResponse();
        if (Array.isArray(object?.claims))
            obj.claims = object.claims.map((e) => ClaimsRecordAddress.fromJSON(e));
        if (isSet(object.pagination))
            obj.pagination = PageResponse.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.claims) {
            obj.claims = message.claims.map(e => e ? ClaimsRecordAddress.toJSON(e) : undefined);
        }
        else {
            obj.claims = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryClaimsRecordsResponse();
        message.claims = object.claims?.map(e => ClaimsRecordAddress.fromPartial(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            claims: Array.isArray(object?.claims) ? object.claims.map((e) => ClaimsRecordAddress.fromSDK(e)) : [],
            pagination: object.pagination ? PageResponse.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            claims: Array.isArray(object?.claims) ? object.claims.map((e) => ClaimsRecordAddress.fromSDKJSON(e)) : [],
            pagination: isSet(object.pagination) ? PageResponse.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.claims) {
            obj.claims = message.claims.map(e => e ? ClaimsRecordAddress.toSDK(e) : undefined);
        }
        else {
            obj.claims = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryClaimsRecordsResponse();
        message.claims = object.claims?.map(e => ClaimsRecordAddress.fromAmino(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.claims) {
            obj.claims = message.claims.map(e => e ? ClaimsRecordAddress.toAmino(e) : undefined);
        }
        else {
            obj.claims = message.claims;
        }
        obj.pagination = message.pagination ? PageResponse.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryClaimsRecordsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryClaimsRecordsResponse.decode(message.value);
    },
    toProto(message) {
        return QueryClaimsRecordsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.claims.v1.QueryClaimsRecordsResponse",
            value: QueryClaimsRecordsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ClaimsRecordAddress.registerTypeUrl();
        PageResponse.registerTypeUrl();
    }
};
function createBaseQueryClaimsRecordRequest() {
    return {
        address: ""
    };
}
export const QueryClaimsRecordRequest = {
    typeUrl: "/evmos.claims.v1.QueryClaimsRecordRequest",
    is(o) {
        return o && (o.$typeUrl === QueryClaimsRecordRequest.typeUrl || typeof o.address === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryClaimsRecordRequest.typeUrl || typeof o.address === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryClaimsRecordRequest.typeUrl || typeof o.address === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.address !== undefined) {
            writer.uint32(10).string(message.address);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryClaimsRecordRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.address = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryClaimsRecordRequest();
        if (isSet(object.address))
            obj.address = String(object.address);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.address !== undefined && (obj.address = message.address);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryClaimsRecordRequest();
        message.address = object.address ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            address: object?.address
        };
    },
    fromSDKJSON(object) {
        return {
            address: isSet(object.address) ? String(object.address) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.address = message.address;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryClaimsRecordRequest();
        if (object.address !== undefined && object.address !== null) {
            message.address = object.address;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.address = message.address === "" ? undefined : message.address;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryClaimsRecordRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryClaimsRecordRequest.decode(message.value);
    },
    toProto(message) {
        return QueryClaimsRecordRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.claims.v1.QueryClaimsRecordRequest",
            value: QueryClaimsRecordRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryClaimsRecordResponse() {
    return {
        initialClaimableAmount: "",
        claims: []
    };
}
export const QueryClaimsRecordResponse = {
    typeUrl: "/evmos.claims.v1.QueryClaimsRecordResponse",
    is(o) {
        return o && (o.$typeUrl === QueryClaimsRecordResponse.typeUrl || typeof o.initialClaimableAmount === "string" && Array.isArray(o.claims) && (!o.claims.length || Claim.is(o.claims[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryClaimsRecordResponse.typeUrl || typeof o.initial_claimable_amount === "string" && Array.isArray(o.claims) && (!o.claims.length || Claim.isSDK(o.claims[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryClaimsRecordResponse.typeUrl || typeof o.initial_claimable_amount === "string" && Array.isArray(o.claims) && (!o.claims.length || Claim.isAmino(o.claims[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.initialClaimableAmount !== undefined) {
            writer.uint32(10).string(message.initialClaimableAmount);
        }
        for (const v of message.claims) {
            Claim.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryClaimsRecordResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.initialClaimableAmount = reader.string();
                    break;
                case 2:
                    message.claims.push(Claim.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryClaimsRecordResponse();
        if (isSet(object.initialClaimableAmount))
            obj.initialClaimableAmount = String(object.initialClaimableAmount);
        if (Array.isArray(object?.claims))
            obj.claims = object.claims.map((e) => Claim.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.initialClaimableAmount !== undefined && (obj.initialClaimableAmount = message.initialClaimableAmount);
        if (message.claims) {
            obj.claims = message.claims.map(e => e ? Claim.toJSON(e) : undefined);
        }
        else {
            obj.claims = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryClaimsRecordResponse();
        message.initialClaimableAmount = object.initialClaimableAmount ?? "";
        message.claims = object.claims?.map(e => Claim.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            initialClaimableAmount: object?.initial_claimable_amount,
            claims: Array.isArray(object?.claims) ? object.claims.map((e) => Claim.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            initial_claimable_amount: isSet(object.initial_claimable_amount) ? String(object.initial_claimable_amount) : "",
            claims: Array.isArray(object?.claims) ? object.claims.map((e) => Claim.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.initial_claimable_amount = message.initialClaimableAmount;
        if (message.claims) {
            obj.claims = message.claims.map(e => e ? Claim.toSDK(e) : undefined);
        }
        else {
            obj.claims = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryClaimsRecordResponse();
        if (object.initial_claimable_amount !== undefined && object.initial_claimable_amount !== null) {
            message.initialClaimableAmount = object.initial_claimable_amount;
        }
        message.claims = object.claims?.map(e => Claim.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.initial_claimable_amount = message.initialClaimableAmount === "" ? undefined : message.initialClaimableAmount;
        if (message.claims) {
            obj.claims = message.claims.map(e => e ? Claim.toAmino(e) : undefined);
        }
        else {
            obj.claims = message.claims;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return QueryClaimsRecordResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryClaimsRecordResponse.decode(message.value);
    },
    toProto(message) {
        return QueryClaimsRecordResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.claims.v1.QueryClaimsRecordResponse",
            value: QueryClaimsRecordResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Claim.registerTypeUrl();
    }
};
