import { GeneratedType, Registry, OfflineSigner } from "@cosmjs/proto-signing";
import { AminoTypes, SigningStargateClient } from "@cosmjs/stargate";
import { HttpEndpoint } from "@cosmjs/tendermint-rpc";
import { TxRpc, SigningClientParams } from "../types";
export declare const evmosAminoConverters: {
    "/evmos.vesting.v1.MsgCreateClawbackVestingAccount": {
        aminoType: string;
        toAmino: (message: import("./vesting/v1/tx").MsgCreateClawbackVestingAccount) => import("./vesting/v1/tx").MsgCreateClawbackVestingAccountAmino;
        fromAmino: (object: import("./vesting/v1/tx").MsgCreateClawbackVestingAccountAmino) => import("./vesting/v1/tx").MsgCreateClawbackVestingAccount;
    };
    "/evmos.vesting.v1.MsgClawback": {
        aminoType: string;
        toAmino: (message: import("./vesting/v1/tx").MsgClawback) => import("./vesting/v1/tx").MsgClawbackAmino;
        fromAmino: (object: import("./vesting/v1/tx").MsgClawbackAmino) => import("./vesting/v1/tx").MsgClawback;
    };
    "/evmos.fees.v1.MsgRegisterDevFeeInfo": {
        aminoType: string;
        toAmino: (message: import("./fees/v1/tx").MsgRegisterDevFeeInfo) => import("./fees/v1/tx").MsgRegisterDevFeeInfoAmino;
        fromAmino: (object: import("./fees/v1/tx").MsgRegisterDevFeeInfoAmino) => import("./fees/v1/tx").MsgRegisterDevFeeInfo;
    };
    "/evmos.fees.v1.MsgCancelDevFeeInfo": {
        aminoType: string;
        toAmino: (message: import("./fees/v1/tx").MsgCancelDevFeeInfo) => import("./fees/v1/tx").MsgCancelDevFeeInfoAmino;
        fromAmino: (object: import("./fees/v1/tx").MsgCancelDevFeeInfoAmino) => import("./fees/v1/tx").MsgCancelDevFeeInfo;
    };
    "/evmos.fees.v1.MsgUpdateDevFeeInfo": {
        aminoType: string;
        toAmino: (message: import("./fees/v1/tx").MsgUpdateDevFeeInfo) => import("./fees/v1/tx").MsgUpdateDevFeeInfoAmino;
        fromAmino: (object: import("./fees/v1/tx").MsgUpdateDevFeeInfoAmino) => import("./fees/v1/tx").MsgUpdateDevFeeInfo;
    };
    "/evmos.erc20.v1.MsgConvertCoin": {
        aminoType: string;
        toAmino: (message: import("./erc20/v1/tx").MsgConvertCoin) => import("./erc20/v1/tx").MsgConvertCoinAmino;
        fromAmino: (object: import("./erc20/v1/tx").MsgConvertCoinAmino) => import("./erc20/v1/tx").MsgConvertCoin;
    };
    "/evmos.erc20.v1.MsgConvertERC20": {
        aminoType: string;
        toAmino: (message: import("./erc20/v1/tx").MsgConvertERC20) => import("./erc20/v1/tx").MsgConvertERC20Amino;
        fromAmino: (object: import("./erc20/v1/tx").MsgConvertERC20Amino) => import("./erc20/v1/tx").MsgConvertERC20;
    };
};
export declare const evmosProtoRegistry: ReadonlyArray<[string, GeneratedType]>;
export declare const getSigningEvmosClientOptions: ({ defaultTypes }?: {
    defaultTypes?: ReadonlyArray<[string, GeneratedType]>;
}) => {
    registry: Registry;
    aminoTypes: AminoTypes;
};
export declare const getSigningEvmosClient: ({ rpcEndpoint, signer, defaultTypes }: {
    rpcEndpoint: string | HttpEndpoint;
    signer: OfflineSigner;
    defaultTypes?: ReadonlyArray<[string, GeneratedType]>;
}) => Promise<SigningStargateClient>;
export declare const getSigningEvmosTxRpc: ({ rpcEndpoint, signer }: SigningClientParams) => Promise<TxRpc>;
