import { Duration, DurationAmino, DurationSDKType } from "../../../google/protobuf/duration";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "evmos.epochs.v1";
export interface EpochInfo {
    identifier: string;
    startTime: Date;
    duration: Duration;
    currentEpoch: bigint;
    currentEpochStartTime: Date;
    epochCountingStarted: boolean;
    currentEpochStartHeight: bigint;
}
export interface EpochInfoProtoMsg {
    typeUrl: "/evmos.epochs.v1.EpochInfo";
    value: Uint8Array;
}
export interface EpochInfoAmino {
    identifier?: string;
    start_time?: string;
    duration?: DurationAmino;
    current_epoch?: string;
    current_epoch_start_time?: string;
    epoch_counting_started?: boolean;
    current_epoch_start_height?: string;
}
export interface EpochInfoAminoMsg {
    type: "/evmos.epochs.v1.EpochInfo";
    value: EpochInfoAmino;
}
export interface EpochInfoSDKType {
    identifier: string;
    start_time: Date;
    duration: DurationSDKType;
    current_epoch: bigint;
    current_epoch_start_time: Date;
    epoch_counting_started: boolean;
    current_epoch_start_height: bigint;
}
/** GenesisState defines the epochs module's genesis state. */
export interface GenesisState {
    epochs: EpochInfo[];
}
export interface GenesisStateProtoMsg {
    typeUrl: "/evmos.epochs.v1.GenesisState";
    value: Uint8Array;
}
/** GenesisState defines the epochs module's genesis state. */
export interface GenesisStateAmino {
    epochs?: EpochInfoAmino[];
}
export interface GenesisStateAminoMsg {
    type: "/evmos.epochs.v1.GenesisState";
    value: GenesisStateAmino;
}
/** GenesisState defines the epochs module's genesis state. */
export interface GenesisStateSDKType {
    epochs: EpochInfoSDKType[];
}
export declare const EpochInfo: {
    typeUrl: string;
    is(o: any): o is EpochInfo;
    isSDK(o: any): o is EpochInfoSDKType;
    isAmino(o: any): o is EpochInfoAmino;
    encode(message: EpochInfo, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): EpochInfo;
    fromJSON(object: any): EpochInfo;
    toJSON(message: EpochInfo): JsonSafe<EpochInfo>;
    fromPartial(object: DeepPartial<EpochInfo>): EpochInfo;
    fromSDK(object: EpochInfoSDKType): EpochInfo;
    fromSDKJSON(object: any): EpochInfoSDKType;
    toSDK(message: EpochInfo): EpochInfoSDKType;
    fromAmino(object: EpochInfoAmino): EpochInfo;
    toAmino(message: EpochInfo): EpochInfoAmino;
    fromAminoMsg(object: EpochInfoAminoMsg): EpochInfo;
    fromProtoMsg(message: EpochInfoProtoMsg): EpochInfo;
    toProto(message: EpochInfo): Uint8Array;
    toProtoMsg(message: EpochInfo): EpochInfoProtoMsg;
    registerTypeUrl(): void;
};
export declare const GenesisState: {
    typeUrl: string;
    is(o: any): o is GenesisState;
    isSDK(o: any): o is GenesisStateSDKType;
    isAmino(o: any): o is GenesisStateAmino;
    encode(message: GenesisState, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GenesisState;
    fromJSON(object: any): GenesisState;
    toJSON(message: GenesisState): JsonSafe<GenesisState>;
    fromPartial(object: DeepPartial<GenesisState>): GenesisState;
    fromSDK(object: GenesisStateSDKType): GenesisState;
    fromSDKJSON(object: any): GenesisStateSDKType;
    toSDK(message: GenesisState): GenesisStateSDKType;
    fromAmino(object: GenesisStateAmino): GenesisState;
    toAmino(message: GenesisState): GenesisStateAmino;
    fromAminoMsg(object: GenesisStateAminoMsg): GenesisState;
    fromProtoMsg(message: GenesisStateProtoMsg): GenesisState;
    toProto(message: GenesisState): Uint8Array;
    toProtoMsg(message: GenesisState): GenesisStateProtoMsg;
    registerTypeUrl(): void;
};
