import { TokenPair, TokenPairAmino, TokenPairSDKType } from "./erc20";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "evmos.erc20.v1";
/** GenesisState defines the module's genesis state. */
export interface GenesisState {
    /** module parameters */
    params: Params;
    /** registered token pairs */
    tokenPairs: TokenPair[];
}
export interface GenesisStateProtoMsg {
    typeUrl: "/evmos.erc20.v1.GenesisState";
    value: Uint8Array;
}
/** GenesisState defines the module's genesis state. */
export interface GenesisStateAmino {
    /** module parameters */
    params?: ParamsAmino;
    /** registered token pairs */
    token_pairs?: TokenPairAmino[];
}
export interface GenesisStateAminoMsg {
    type: "/evmos.erc20.v1.GenesisState";
    value: GenesisStateAmino;
}
/** GenesisState defines the module's genesis state. */
export interface GenesisStateSDKType {
    params: ParamsSDKType;
    token_pairs: TokenPairSDKType[];
}
/** Params defines the erc20 module params */
export interface Params {
    /** parameter to enable the conversion of Cosmos coins <--> ERC20 tokens. */
    enableErc20: boolean;
    /**
     * parameter to enable the EVM hook that converts an ERC20 token to a Cosmos
     * Coin by transferring the Tokens through a MsgEthereumTx to the
     * ModuleAddress Ethereum address.
     */
    enableEvmHook: boolean;
}
export interface ParamsProtoMsg {
    typeUrl: "/evmos.erc20.v1.Params";
    value: Uint8Array;
}
/** Params defines the erc20 module params */
export interface ParamsAmino {
    /** parameter to enable the conversion of Cosmos coins <--> ERC20 tokens. */
    enable_erc20?: boolean;
    /**
     * parameter to enable the EVM hook that converts an ERC20 token to a Cosmos
     * Coin by transferring the Tokens through a MsgEthereumTx to the
     * ModuleAddress Ethereum address.
     */
    enable_evm_hook?: boolean;
}
export interface ParamsAminoMsg {
    type: "/evmos.erc20.v1.Params";
    value: ParamsAmino;
}
/** Params defines the erc20 module params */
export interface ParamsSDKType {
    enable_erc20: boolean;
    enable_evm_hook: boolean;
}
export declare const GenesisState: {
    typeUrl: string;
    is(o: any): o is GenesisState;
    isSDK(o: any): o is GenesisStateSDKType;
    isAmino(o: any): o is GenesisStateAmino;
    encode(message: GenesisState, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GenesisState;
    fromJSON(object: any): GenesisState;
    toJSON(message: GenesisState): JsonSafe<GenesisState>;
    fromPartial(object: DeepPartial<GenesisState>): GenesisState;
    fromSDK(object: GenesisStateSDKType): GenesisState;
    fromSDKJSON(object: any): GenesisStateSDKType;
    toSDK(message: GenesisState): GenesisStateSDKType;
    fromAmino(object: GenesisStateAmino): GenesisState;
    toAmino(message: GenesisState): GenesisStateAmino;
    fromAminoMsg(object: GenesisStateAminoMsg): GenesisState;
    fromProtoMsg(message: GenesisStateProtoMsg): GenesisState;
    toProto(message: GenesisState): Uint8Array;
    toProtoMsg(message: GenesisState): GenesisStateProtoMsg;
    registerTypeUrl(): void;
};
export declare const Params: {
    typeUrl: string;
    is(o: any): o is Params;
    isSDK(o: any): o is ParamsSDKType;
    isAmino(o: any): o is ParamsAmino;
    encode(message: Params, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Params;
    fromJSON(object: any): Params;
    toJSON(message: Params): JsonSafe<Params>;
    fromPartial(object: DeepPartial<Params>): Params;
    fromSDK(object: ParamsSDKType): Params;
    fromSDKJSON(object: any): ParamsSDKType;
    toSDK(message: Params): ParamsSDKType;
    fromAmino(object: ParamsAmino): Params;
    toAmino(message: Params): ParamsAmino;
    fromAminoMsg(object: ParamsAminoMsg): Params;
    fromProtoMsg(message: ParamsProtoMsg): Params;
    toProto(message: Params): Uint8Array;
    toProtoMsg(message: Params): ParamsProtoMsg;
    registerTypeUrl(): void;
};
