import { PageRequest, PageRequestAmino, PageRequestSDKType, PageResponse, PageResponseAmino, PageResponseSDKType } from "../../../cosmos/base/query/v1beta1/pagination";
import { TokenPair, TokenPairAmino, TokenPairSDKType } from "./erc20";
import { Params, ParamsAmino, ParamsSDKType } from "./genesis";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "evmos.erc20.v1";
/**
 * QueryTokenPairsRequest is the request type for the Query/TokenPairs RPC
 * method.
 */
export interface QueryTokenPairsRequest {
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequest;
}
export interface QueryTokenPairsRequestProtoMsg {
    typeUrl: "/evmos.erc20.v1.QueryTokenPairsRequest";
    value: Uint8Array;
}
/**
 * QueryTokenPairsRequest is the request type for the Query/TokenPairs RPC
 * method.
 */
export interface QueryTokenPairsRequestAmino {
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequestAmino;
}
export interface QueryTokenPairsRequestAminoMsg {
    type: "/evmos.erc20.v1.QueryTokenPairsRequest";
    value: QueryTokenPairsRequestAmino;
}
/**
 * QueryTokenPairsRequest is the request type for the Query/TokenPairs RPC
 * method.
 */
export interface QueryTokenPairsRequestSDKType {
    pagination?: PageRequestSDKType;
}
/**
 * QueryTokenPairsResponse is the response type for the Query/TokenPairs RPC
 * method.
 */
export interface QueryTokenPairsResponse {
    tokenPairs: TokenPair[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponse;
}
export interface QueryTokenPairsResponseProtoMsg {
    typeUrl: "/evmos.erc20.v1.QueryTokenPairsResponse";
    value: Uint8Array;
}
/**
 * QueryTokenPairsResponse is the response type for the Query/TokenPairs RPC
 * method.
 */
export interface QueryTokenPairsResponseAmino {
    token_pairs?: TokenPairAmino[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponseAmino;
}
export interface QueryTokenPairsResponseAminoMsg {
    type: "/evmos.erc20.v1.QueryTokenPairsResponse";
    value: QueryTokenPairsResponseAmino;
}
/**
 * QueryTokenPairsResponse is the response type for the Query/TokenPairs RPC
 * method.
 */
export interface QueryTokenPairsResponseSDKType {
    token_pairs: TokenPairSDKType[];
    pagination?: PageResponseSDKType;
}
/** QueryTokenPairRequest is the request type for the Query/TokenPair RPC method. */
export interface QueryTokenPairRequest {
    /**
     * token identifier can be either the hex contract address of the ERC20 or the
     * Cosmos base denomination
     */
    token: string;
}
export interface QueryTokenPairRequestProtoMsg {
    typeUrl: "/evmos.erc20.v1.QueryTokenPairRequest";
    value: Uint8Array;
}
/** QueryTokenPairRequest is the request type for the Query/TokenPair RPC method. */
export interface QueryTokenPairRequestAmino {
    /**
     * token identifier can be either the hex contract address of the ERC20 or the
     * Cosmos base denomination
     */
    token?: string;
}
export interface QueryTokenPairRequestAminoMsg {
    type: "/evmos.erc20.v1.QueryTokenPairRequest";
    value: QueryTokenPairRequestAmino;
}
/** QueryTokenPairRequest is the request type for the Query/TokenPair RPC method. */
export interface QueryTokenPairRequestSDKType {
    token: string;
}
/**
 * QueryTokenPairResponse is the response type for the Query/TokenPair RPC
 * method.
 */
export interface QueryTokenPairResponse {
    tokenPair: TokenPair;
}
export interface QueryTokenPairResponseProtoMsg {
    typeUrl: "/evmos.erc20.v1.QueryTokenPairResponse";
    value: Uint8Array;
}
/**
 * QueryTokenPairResponse is the response type for the Query/TokenPair RPC
 * method.
 */
export interface QueryTokenPairResponseAmino {
    token_pair?: TokenPairAmino;
}
export interface QueryTokenPairResponseAminoMsg {
    type: "/evmos.erc20.v1.QueryTokenPairResponse";
    value: QueryTokenPairResponseAmino;
}
/**
 * QueryTokenPairResponse is the response type for the Query/TokenPair RPC
 * method.
 */
export interface QueryTokenPairResponseSDKType {
    token_pair: TokenPairSDKType;
}
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequest {
}
export interface QueryParamsRequestProtoMsg {
    typeUrl: "/evmos.erc20.v1.QueryParamsRequest";
    value: Uint8Array;
}
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequestAmino {
}
export interface QueryParamsRequestAminoMsg {
    type: "/evmos.erc20.v1.QueryParamsRequest";
    value: QueryParamsRequestAmino;
}
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequestSDKType {
}
/**
 * QueryParamsResponse is the response type for the Query/Params RPC
 * method.
 */
export interface QueryParamsResponse {
    params: Params;
}
export interface QueryParamsResponseProtoMsg {
    typeUrl: "/evmos.erc20.v1.QueryParamsResponse";
    value: Uint8Array;
}
/**
 * QueryParamsResponse is the response type for the Query/Params RPC
 * method.
 */
export interface QueryParamsResponseAmino {
    params?: ParamsAmino;
}
export interface QueryParamsResponseAminoMsg {
    type: "/evmos.erc20.v1.QueryParamsResponse";
    value: QueryParamsResponseAmino;
}
/**
 * QueryParamsResponse is the response type for the Query/Params RPC
 * method.
 */
export interface QueryParamsResponseSDKType {
    params: ParamsSDKType;
}
export declare const QueryTokenPairsRequest: {
    typeUrl: string;
    is(o: any): o is QueryTokenPairsRequest;
    isSDK(o: any): o is QueryTokenPairsRequestSDKType;
    isAmino(o: any): o is QueryTokenPairsRequestAmino;
    encode(message: QueryTokenPairsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryTokenPairsRequest;
    fromJSON(object: any): QueryTokenPairsRequest;
    toJSON(message: QueryTokenPairsRequest): JsonSafe<QueryTokenPairsRequest>;
    fromPartial(object: DeepPartial<QueryTokenPairsRequest>): QueryTokenPairsRequest;
    fromSDK(object: QueryTokenPairsRequestSDKType): QueryTokenPairsRequest;
    fromSDKJSON(object: any): QueryTokenPairsRequestSDKType;
    toSDK(message: QueryTokenPairsRequest): QueryTokenPairsRequestSDKType;
    fromAmino(object: QueryTokenPairsRequestAmino): QueryTokenPairsRequest;
    toAmino(message: QueryTokenPairsRequest): QueryTokenPairsRequestAmino;
    fromAminoMsg(object: QueryTokenPairsRequestAminoMsg): QueryTokenPairsRequest;
    fromProtoMsg(message: QueryTokenPairsRequestProtoMsg): QueryTokenPairsRequest;
    toProto(message: QueryTokenPairsRequest): Uint8Array;
    toProtoMsg(message: QueryTokenPairsRequest): QueryTokenPairsRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryTokenPairsResponse: {
    typeUrl: string;
    is(o: any): o is QueryTokenPairsResponse;
    isSDK(o: any): o is QueryTokenPairsResponseSDKType;
    isAmino(o: any): o is QueryTokenPairsResponseAmino;
    encode(message: QueryTokenPairsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryTokenPairsResponse;
    fromJSON(object: any): QueryTokenPairsResponse;
    toJSON(message: QueryTokenPairsResponse): JsonSafe<QueryTokenPairsResponse>;
    fromPartial(object: DeepPartial<QueryTokenPairsResponse>): QueryTokenPairsResponse;
    fromSDK(object: QueryTokenPairsResponseSDKType): QueryTokenPairsResponse;
    fromSDKJSON(object: any): QueryTokenPairsResponseSDKType;
    toSDK(message: QueryTokenPairsResponse): QueryTokenPairsResponseSDKType;
    fromAmino(object: QueryTokenPairsResponseAmino): QueryTokenPairsResponse;
    toAmino(message: QueryTokenPairsResponse): QueryTokenPairsResponseAmino;
    fromAminoMsg(object: QueryTokenPairsResponseAminoMsg): QueryTokenPairsResponse;
    fromProtoMsg(message: QueryTokenPairsResponseProtoMsg): QueryTokenPairsResponse;
    toProto(message: QueryTokenPairsResponse): Uint8Array;
    toProtoMsg(message: QueryTokenPairsResponse): QueryTokenPairsResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryTokenPairRequest: {
    typeUrl: string;
    is(o: any): o is QueryTokenPairRequest;
    isSDK(o: any): o is QueryTokenPairRequestSDKType;
    isAmino(o: any): o is QueryTokenPairRequestAmino;
    encode(message: QueryTokenPairRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryTokenPairRequest;
    fromJSON(object: any): QueryTokenPairRequest;
    toJSON(message: QueryTokenPairRequest): JsonSafe<QueryTokenPairRequest>;
    fromPartial(object: DeepPartial<QueryTokenPairRequest>): QueryTokenPairRequest;
    fromSDK(object: QueryTokenPairRequestSDKType): QueryTokenPairRequest;
    fromSDKJSON(object: any): QueryTokenPairRequestSDKType;
    toSDK(message: QueryTokenPairRequest): QueryTokenPairRequestSDKType;
    fromAmino(object: QueryTokenPairRequestAmino): QueryTokenPairRequest;
    toAmino(message: QueryTokenPairRequest): QueryTokenPairRequestAmino;
    fromAminoMsg(object: QueryTokenPairRequestAminoMsg): QueryTokenPairRequest;
    fromProtoMsg(message: QueryTokenPairRequestProtoMsg): QueryTokenPairRequest;
    toProto(message: QueryTokenPairRequest): Uint8Array;
    toProtoMsg(message: QueryTokenPairRequest): QueryTokenPairRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryTokenPairResponse: {
    typeUrl: string;
    is(o: any): o is QueryTokenPairResponse;
    isSDK(o: any): o is QueryTokenPairResponseSDKType;
    isAmino(o: any): o is QueryTokenPairResponseAmino;
    encode(message: QueryTokenPairResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryTokenPairResponse;
    fromJSON(object: any): QueryTokenPairResponse;
    toJSON(message: QueryTokenPairResponse): JsonSafe<QueryTokenPairResponse>;
    fromPartial(object: DeepPartial<QueryTokenPairResponse>): QueryTokenPairResponse;
    fromSDK(object: QueryTokenPairResponseSDKType): QueryTokenPairResponse;
    fromSDKJSON(object: any): QueryTokenPairResponseSDKType;
    toSDK(message: QueryTokenPairResponse): QueryTokenPairResponseSDKType;
    fromAmino(object: QueryTokenPairResponseAmino): QueryTokenPairResponse;
    toAmino(message: QueryTokenPairResponse): QueryTokenPairResponseAmino;
    fromAminoMsg(object: QueryTokenPairResponseAminoMsg): QueryTokenPairResponse;
    fromProtoMsg(message: QueryTokenPairResponseProtoMsg): QueryTokenPairResponse;
    toProto(message: QueryTokenPairResponse): Uint8Array;
    toProtoMsg(message: QueryTokenPairResponse): QueryTokenPairResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryParamsRequest: {
    typeUrl: string;
    is(o: any): o is QueryParamsRequest;
    isSDK(o: any): o is QueryParamsRequestSDKType;
    isAmino(o: any): o is QueryParamsRequestAmino;
    encode(_: QueryParamsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryParamsRequest;
    fromJSON(_: any): QueryParamsRequest;
    toJSON(_: QueryParamsRequest): JsonSafe<QueryParamsRequest>;
    fromPartial(_: DeepPartial<QueryParamsRequest>): QueryParamsRequest;
    fromSDK(_: QueryParamsRequestSDKType): QueryParamsRequest;
    fromSDKJSON(_: any): QueryParamsRequestSDKType;
    toSDK(_: QueryParamsRequest): QueryParamsRequestSDKType;
    fromAmino(_: QueryParamsRequestAmino): QueryParamsRequest;
    toAmino(_: QueryParamsRequest): QueryParamsRequestAmino;
    fromAminoMsg(object: QueryParamsRequestAminoMsg): QueryParamsRequest;
    fromProtoMsg(message: QueryParamsRequestProtoMsg): QueryParamsRequest;
    toProto(message: QueryParamsRequest): Uint8Array;
    toProtoMsg(message: QueryParamsRequest): QueryParamsRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryParamsResponse: {
    typeUrl: string;
    is(o: any): o is QueryParamsResponse;
    isSDK(o: any): o is QueryParamsResponseSDKType;
    isAmino(o: any): o is QueryParamsResponseAmino;
    encode(message: QueryParamsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryParamsResponse;
    fromJSON(object: any): QueryParamsResponse;
    toJSON(message: QueryParamsResponse): JsonSafe<QueryParamsResponse>;
    fromPartial(object: DeepPartial<QueryParamsResponse>): QueryParamsResponse;
    fromSDK(object: QueryParamsResponseSDKType): QueryParamsResponse;
    fromSDKJSON(object: any): QueryParamsResponseSDKType;
    toSDK(message: QueryParamsResponse): QueryParamsResponseSDKType;
    fromAmino(object: QueryParamsResponseAmino): QueryParamsResponse;
    toAmino(message: QueryParamsResponse): QueryParamsResponseAmino;
    fromAminoMsg(object: QueryParamsResponseAminoMsg): QueryParamsResponse;
    fromProtoMsg(message: QueryParamsResponseProtoMsg): QueryParamsResponse;
    toProto(message: QueryParamsResponse): Uint8Array;
    toProtoMsg(message: QueryParamsResponse): QueryParamsResponseProtoMsg;
    registerTypeUrl(): void;
};
