import { PageRequest } from "../../../cosmos/base/query/v1beta1/pagination";
import { setPaginationParams } from "../../../helpers";
import { QueryTokenPairsResponse, QueryTokenPairResponse, QueryParamsResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* TokenPairs retrieves registered token pairs */
    tokenPairs = async (params = {
        pagination: PageRequest.fromPartial({})
    }) => {
        const options = {
            params: {}
        };
        if (typeof params?.pagination !== "undefined") {
            setPaginationParams(options, params.pagination);
        }
        const endpoint = `evmos/erc20/v1/token_pairs`;
        return QueryTokenPairsResponse.fromSDKJSON(await this.req.get(endpoint, options));
    };
    /* TokenPair retrieves a registered token pair */
    tokenPair = async (params) => {
        const endpoint = `evmos/erc20/v1/token_pairs/${params.token}`;
        return QueryTokenPairResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* Params retrieves the erc20 module params */
    params = async (_params = {}) => {
        const endpoint = `evmos/erc20/v1/params`;
        return QueryParamsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
}
