import { TelescopeGeneratedType } from "../../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgConvertCoin, MsgConvertERC20 } from "./tx";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        convertCoin(value: MsgConvertCoin): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        convertERC20(value: MsgConvertERC20): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        convertCoin(value: MsgConvertCoin): {
            typeUrl: string;
            value: MsgConvertCoin;
        };
        convertERC20(value: MsgConvertERC20): {
            typeUrl: string;
            value: MsgConvertERC20;
        };
    };
    toJSON: {
        convertCoin(value: MsgConvertCoin): {
            typeUrl: string;
            value: {
                coin: {
                    denom: string;
                    amount: string;
                };
                receiver: string;
                sender: string;
            };
        };
        convertERC20(value: MsgConvertERC20): {
            typeUrl: string;
            value: {
                contractAddress: string;
                amount: string;
                receiver: string;
                sender: string;
            };
        };
    };
    fromJSON: {
        convertCoin(value: any): {
            typeUrl: string;
            value: MsgConvertCoin;
        };
        convertERC20(value: any): {
            typeUrl: string;
            value: MsgConvertERC20;
        };
    };
    fromPartial: {
        convertCoin(value: MsgConvertCoin): {
            typeUrl: string;
            value: MsgConvertCoin;
        };
        convertERC20(value: MsgConvertERC20): {
            typeUrl: string;
            value: MsgConvertERC20;
        };
    };
};
