import { DeliverTxResponse, StdFee, TxRpc } from "../../../types";
import { MsgConvertCoin, MsgConvertERC20 } from "./tx";
/** Msg defines the erc20 Msg service. */
export interface Msg {
    /**
     * ConvertCoin mints a ERC20 representation of the native Cosmos coin denom
     * that is registered on the token mapping.
     */
    convertCoin(signerAddress: string, message: MsgConvertCoin, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    /**
     * ConvertERC20 mints a native Cosmos coin representation of the ERC20 token
     * contract that is registered on the token mapping.
     */
    convertERC20(signerAddress: string, message: MsgConvertERC20, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
}
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    constructor(rpc: TxRpc);
    convertCoin: (signerAddress: string, message: MsgConvertCoin, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    convertERC20: (signerAddress: string, message: MsgConvertERC20, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
}
export declare const createClientImpl: (rpc: TxRpc) => MsgClientImpl;
