import { MsgConvertCoin, MsgConvertERC20 } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* ConvertCoin mints a ERC20 representation of the native Cosmos coin denom
     that is registered on the token mapping. */
    convertCoin = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgConvertCoin.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* ConvertERC20 mints a native Cosmos coin representation of the ERC20 token
     contract that is registered on the token mapping. */
    convertERC20 = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgConvertERC20.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
