import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "evmos.fees.v1";
/**
 * DevFeeInfo defines an instance that organizes fee distribution conditions
 * for the owner of a given smart contract
 */
export interface DevFeeInfo {
    /** hex address of registered contract */
    contractAddress: string;
    /** bech32 address of contract deployer */
    deployerAddress: string;
    /**
     * bech32 address of account receiving the transaction fees
     * it defaults to deployer_address
     */
    withdrawAddress: string;
}
export interface DevFeeInfoProtoMsg {
    typeUrl: "/evmos.fees.v1.DevFeeInfo";
    value: Uint8Array;
}
/**
 * DevFeeInfo defines an instance that organizes fee distribution conditions
 * for the owner of a given smart contract
 */
export interface DevFeeInfoAmino {
    /** hex address of registered contract */
    contract_address?: string;
    /** bech32 address of contract deployer */
    deployer_address?: string;
    /**
     * bech32 address of account receiving the transaction fees
     * it defaults to deployer_address
     */
    withdraw_address?: string;
}
export interface DevFeeInfoAminoMsg {
    type: "/evmos.fees.v1.DevFeeInfo";
    value: DevFeeInfoAmino;
}
/**
 * DevFeeInfo defines an instance that organizes fee distribution conditions
 * for the owner of a given smart contract
 */
export interface DevFeeInfoSDKType {
    contract_address: string;
    deployer_address: string;
    withdraw_address: string;
}
export declare const DevFeeInfo: {
    typeUrl: string;
    is(o: any): o is DevFeeInfo;
    isSDK(o: any): o is DevFeeInfoSDKType;
    isAmino(o: any): o is DevFeeInfoAmino;
    encode(message: DevFeeInfo, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): DevFeeInfo;
    fromJSON(object: any): DevFeeInfo;
    toJSON(message: DevFeeInfo): JsonSafe<DevFeeInfo>;
    fromPartial(object: DeepPartial<DevFeeInfo>): DevFeeInfo;
    fromSDK(object: DevFeeInfoSDKType): DevFeeInfo;
    fromSDKJSON(object: any): DevFeeInfoSDKType;
    toSDK(message: DevFeeInfo): DevFeeInfoSDKType;
    fromAmino(object: DevFeeInfoAmino): DevFeeInfo;
    toAmino(message: DevFeeInfo): DevFeeInfoAmino;
    fromAminoMsg(object: DevFeeInfoAminoMsg): DevFeeInfo;
    fromProtoMsg(message: DevFeeInfoProtoMsg): DevFeeInfo;
    toProto(message: DevFeeInfo): Uint8Array;
    toProtoMsg(message: DevFeeInfo): DevFeeInfoProtoMsg;
    registerTypeUrl(): void;
};
