import { PageRequest, PageRequestAmino, PageRequestSDKType, PageResponse, PageResponseAmino, PageResponseSDKType } from "../../../cosmos/base/query/v1beta1/pagination";
import { DevFeeInfo, DevFeeInfoAmino, DevFeeInfoSDKType } from "./fees";
import { Params, ParamsAmino, ParamsSDKType } from "./genesis";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "evmos.fees.v1";
/**
 * QueryDevFeeInfosRequest is the request type for the Query/DevFeeInfos RPC
 * method.
 */
export interface QueryDevFeeInfosRequest {
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequest;
}
export interface QueryDevFeeInfosRequestProtoMsg {
    typeUrl: "/evmos.fees.v1.QueryDevFeeInfosRequest";
    value: Uint8Array;
}
/**
 * QueryDevFeeInfosRequest is the request type for the Query/DevFeeInfos RPC
 * method.
 */
export interface QueryDevFeeInfosRequestAmino {
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequestAmino;
}
export interface QueryDevFeeInfosRequestAminoMsg {
    type: "/evmos.fees.v1.QueryDevFeeInfosRequest";
    value: QueryDevFeeInfosRequestAmino;
}
/**
 * QueryDevFeeInfosRequest is the request type for the Query/DevFeeInfos RPC
 * method.
 */
export interface QueryDevFeeInfosRequestSDKType {
    pagination?: PageRequestSDKType;
}
/**
 * QueryDevFeeInfosResponse is the response type for the Query/DevFeeInfos
 * RPC method.
 */
export interface QueryDevFeeInfosResponse {
    fees: DevFeeInfo[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponse;
}
export interface QueryDevFeeInfosResponseProtoMsg {
    typeUrl: "/evmos.fees.v1.QueryDevFeeInfosResponse";
    value: Uint8Array;
}
/**
 * QueryDevFeeInfosResponse is the response type for the Query/DevFeeInfos
 * RPC method.
 */
export interface QueryDevFeeInfosResponseAmino {
    fees?: DevFeeInfoAmino[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponseAmino;
}
export interface QueryDevFeeInfosResponseAminoMsg {
    type: "/evmos.fees.v1.QueryDevFeeInfosResponse";
    value: QueryDevFeeInfosResponseAmino;
}
/**
 * QueryDevFeeInfosResponse is the response type for the Query/DevFeeInfos
 * RPC method.
 */
export interface QueryDevFeeInfosResponseSDKType {
    fees: DevFeeInfoSDKType[];
    pagination?: PageResponseSDKType;
}
/**
 * QueryDevFeeInfoRequest is the request type for the Query/DevFeeInfo RPC
 * method.
 */
export interface QueryDevFeeInfoRequest {
    /** contract identifier is the hex contract address of a contract */
    contractAddress: string;
}
export interface QueryDevFeeInfoRequestProtoMsg {
    typeUrl: "/evmos.fees.v1.QueryDevFeeInfoRequest";
    value: Uint8Array;
}
/**
 * QueryDevFeeInfoRequest is the request type for the Query/DevFeeInfo RPC
 * method.
 */
export interface QueryDevFeeInfoRequestAmino {
    /** contract identifier is the hex contract address of a contract */
    contract_address?: string;
}
export interface QueryDevFeeInfoRequestAminoMsg {
    type: "/evmos.fees.v1.QueryDevFeeInfoRequest";
    value: QueryDevFeeInfoRequestAmino;
}
/**
 * QueryDevFeeInfoRequest is the request type for the Query/DevFeeInfo RPC
 * method.
 */
export interface QueryDevFeeInfoRequestSDKType {
    contract_address: string;
}
/**
 * QueryDevFeeInfoResponse is the response type for the Query/DevFeeInfo RPC
 * method.
 */
export interface QueryDevFeeInfoResponse {
    fee: DevFeeInfo;
}
export interface QueryDevFeeInfoResponseProtoMsg {
    typeUrl: "/evmos.fees.v1.QueryDevFeeInfoResponse";
    value: Uint8Array;
}
/**
 * QueryDevFeeInfoResponse is the response type for the Query/DevFeeInfo RPC
 * method.
 */
export interface QueryDevFeeInfoResponseAmino {
    fee?: DevFeeInfoAmino;
}
export interface QueryDevFeeInfoResponseAminoMsg {
    type: "/evmos.fees.v1.QueryDevFeeInfoResponse";
    value: QueryDevFeeInfoResponseAmino;
}
/**
 * QueryDevFeeInfoResponse is the response type for the Query/DevFeeInfo RPC
 * method.
 */
export interface QueryDevFeeInfoResponseSDKType {
    fee: DevFeeInfoSDKType;
}
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequest {
}
export interface QueryParamsRequestProtoMsg {
    typeUrl: "/evmos.fees.v1.QueryParamsRequest";
    value: Uint8Array;
}
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequestAmino {
}
export interface QueryParamsRequestAminoMsg {
    type: "/evmos.fees.v1.QueryParamsRequest";
    value: QueryParamsRequestAmino;
}
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequestSDKType {
}
/**
 * QueryParamsResponse is the response type for the Query/Params RPC
 * method.
 */
export interface QueryParamsResponse {
    params: Params;
}
export interface QueryParamsResponseProtoMsg {
    typeUrl: "/evmos.fees.v1.QueryParamsResponse";
    value: Uint8Array;
}
/**
 * QueryParamsResponse is the response type for the Query/Params RPC
 * method.
 */
export interface QueryParamsResponseAmino {
    params?: ParamsAmino;
}
export interface QueryParamsResponseAminoMsg {
    type: "/evmos.fees.v1.QueryParamsResponse";
    value: QueryParamsResponseAmino;
}
/**
 * QueryParamsResponse is the response type for the Query/Params RPC
 * method.
 */
export interface QueryParamsResponseSDKType {
    params: ParamsSDKType;
}
/**
 * QueryDevFeeInfosPerDeployerRequest is the request type for the
 * Query/DevFeeInfosPerDeployer RPC method.
 */
export interface QueryDevFeeInfosPerDeployerRequest {
    /** deployer bech32 address */
    deployerAddress: string;
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequest;
}
export interface QueryDevFeeInfosPerDeployerRequestProtoMsg {
    typeUrl: "/evmos.fees.v1.QueryDevFeeInfosPerDeployerRequest";
    value: Uint8Array;
}
/**
 * QueryDevFeeInfosPerDeployerRequest is the request type for the
 * Query/DevFeeInfosPerDeployer RPC method.
 */
export interface QueryDevFeeInfosPerDeployerRequestAmino {
    /** deployer bech32 address */
    deployer_address?: string;
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequestAmino;
}
export interface QueryDevFeeInfosPerDeployerRequestAminoMsg {
    type: "/evmos.fees.v1.QueryDevFeeInfosPerDeployerRequest";
    value: QueryDevFeeInfosPerDeployerRequestAmino;
}
/**
 * QueryDevFeeInfosPerDeployerRequest is the request type for the
 * Query/DevFeeInfosPerDeployer RPC method.
 */
export interface QueryDevFeeInfosPerDeployerRequestSDKType {
    deployer_address: string;
    pagination?: PageRequestSDKType;
}
/**
 * QueryDevFeeInfosPerDeployerResponse is the response type for the
 * Query/DevFeeInfosPerDeployer RPC method.
 */
export interface QueryDevFeeInfosPerDeployerResponse {
    fees: DevFeeInfo[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponse;
}
export interface QueryDevFeeInfosPerDeployerResponseProtoMsg {
    typeUrl: "/evmos.fees.v1.QueryDevFeeInfosPerDeployerResponse";
    value: Uint8Array;
}
/**
 * QueryDevFeeInfosPerDeployerResponse is the response type for the
 * Query/DevFeeInfosPerDeployer RPC method.
 */
export interface QueryDevFeeInfosPerDeployerResponseAmino {
    fees?: DevFeeInfoAmino[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponseAmino;
}
export interface QueryDevFeeInfosPerDeployerResponseAminoMsg {
    type: "/evmos.fees.v1.QueryDevFeeInfosPerDeployerResponse";
    value: QueryDevFeeInfosPerDeployerResponseAmino;
}
/**
 * QueryDevFeeInfosPerDeployerResponse is the response type for the
 * Query/DevFeeInfosPerDeployer RPC method.
 */
export interface QueryDevFeeInfosPerDeployerResponseSDKType {
    fees: DevFeeInfoSDKType[];
    pagination?: PageResponseSDKType;
}
export declare const QueryDevFeeInfosRequest: {
    typeUrl: string;
    is(o: any): o is QueryDevFeeInfosRequest;
    isSDK(o: any): o is QueryDevFeeInfosRequestSDKType;
    isAmino(o: any): o is QueryDevFeeInfosRequestAmino;
    encode(message: QueryDevFeeInfosRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryDevFeeInfosRequest;
    fromJSON(object: any): QueryDevFeeInfosRequest;
    toJSON(message: QueryDevFeeInfosRequest): JsonSafe<QueryDevFeeInfosRequest>;
    fromPartial(object: DeepPartial<QueryDevFeeInfosRequest>): QueryDevFeeInfosRequest;
    fromSDK(object: QueryDevFeeInfosRequestSDKType): QueryDevFeeInfosRequest;
    fromSDKJSON(object: any): QueryDevFeeInfosRequestSDKType;
    toSDK(message: QueryDevFeeInfosRequest): QueryDevFeeInfosRequestSDKType;
    fromAmino(object: QueryDevFeeInfosRequestAmino): QueryDevFeeInfosRequest;
    toAmino(message: QueryDevFeeInfosRequest): QueryDevFeeInfosRequestAmino;
    fromAminoMsg(object: QueryDevFeeInfosRequestAminoMsg): QueryDevFeeInfosRequest;
    fromProtoMsg(message: QueryDevFeeInfosRequestProtoMsg): QueryDevFeeInfosRequest;
    toProto(message: QueryDevFeeInfosRequest): Uint8Array;
    toProtoMsg(message: QueryDevFeeInfosRequest): QueryDevFeeInfosRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryDevFeeInfosResponse: {
    typeUrl: string;
    is(o: any): o is QueryDevFeeInfosResponse;
    isSDK(o: any): o is QueryDevFeeInfosResponseSDKType;
    isAmino(o: any): o is QueryDevFeeInfosResponseAmino;
    encode(message: QueryDevFeeInfosResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryDevFeeInfosResponse;
    fromJSON(object: any): QueryDevFeeInfosResponse;
    toJSON(message: QueryDevFeeInfosResponse): JsonSafe<QueryDevFeeInfosResponse>;
    fromPartial(object: DeepPartial<QueryDevFeeInfosResponse>): QueryDevFeeInfosResponse;
    fromSDK(object: QueryDevFeeInfosResponseSDKType): QueryDevFeeInfosResponse;
    fromSDKJSON(object: any): QueryDevFeeInfosResponseSDKType;
    toSDK(message: QueryDevFeeInfosResponse): QueryDevFeeInfosResponseSDKType;
    fromAmino(object: QueryDevFeeInfosResponseAmino): QueryDevFeeInfosResponse;
    toAmino(message: QueryDevFeeInfosResponse): QueryDevFeeInfosResponseAmino;
    fromAminoMsg(object: QueryDevFeeInfosResponseAminoMsg): QueryDevFeeInfosResponse;
    fromProtoMsg(message: QueryDevFeeInfosResponseProtoMsg): QueryDevFeeInfosResponse;
    toProto(message: QueryDevFeeInfosResponse): Uint8Array;
    toProtoMsg(message: QueryDevFeeInfosResponse): QueryDevFeeInfosResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryDevFeeInfoRequest: {
    typeUrl: string;
    is(o: any): o is QueryDevFeeInfoRequest;
    isSDK(o: any): o is QueryDevFeeInfoRequestSDKType;
    isAmino(o: any): o is QueryDevFeeInfoRequestAmino;
    encode(message: QueryDevFeeInfoRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryDevFeeInfoRequest;
    fromJSON(object: any): QueryDevFeeInfoRequest;
    toJSON(message: QueryDevFeeInfoRequest): JsonSafe<QueryDevFeeInfoRequest>;
    fromPartial(object: DeepPartial<QueryDevFeeInfoRequest>): QueryDevFeeInfoRequest;
    fromSDK(object: QueryDevFeeInfoRequestSDKType): QueryDevFeeInfoRequest;
    fromSDKJSON(object: any): QueryDevFeeInfoRequestSDKType;
    toSDK(message: QueryDevFeeInfoRequest): QueryDevFeeInfoRequestSDKType;
    fromAmino(object: QueryDevFeeInfoRequestAmino): QueryDevFeeInfoRequest;
    toAmino(message: QueryDevFeeInfoRequest): QueryDevFeeInfoRequestAmino;
    fromAminoMsg(object: QueryDevFeeInfoRequestAminoMsg): QueryDevFeeInfoRequest;
    fromProtoMsg(message: QueryDevFeeInfoRequestProtoMsg): QueryDevFeeInfoRequest;
    toProto(message: QueryDevFeeInfoRequest): Uint8Array;
    toProtoMsg(message: QueryDevFeeInfoRequest): QueryDevFeeInfoRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryDevFeeInfoResponse: {
    typeUrl: string;
    is(o: any): o is QueryDevFeeInfoResponse;
    isSDK(o: any): o is QueryDevFeeInfoResponseSDKType;
    isAmino(o: any): o is QueryDevFeeInfoResponseAmino;
    encode(message: QueryDevFeeInfoResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryDevFeeInfoResponse;
    fromJSON(object: any): QueryDevFeeInfoResponse;
    toJSON(message: QueryDevFeeInfoResponse): JsonSafe<QueryDevFeeInfoResponse>;
    fromPartial(object: DeepPartial<QueryDevFeeInfoResponse>): QueryDevFeeInfoResponse;
    fromSDK(object: QueryDevFeeInfoResponseSDKType): QueryDevFeeInfoResponse;
    fromSDKJSON(object: any): QueryDevFeeInfoResponseSDKType;
    toSDK(message: QueryDevFeeInfoResponse): QueryDevFeeInfoResponseSDKType;
    fromAmino(object: QueryDevFeeInfoResponseAmino): QueryDevFeeInfoResponse;
    toAmino(message: QueryDevFeeInfoResponse): QueryDevFeeInfoResponseAmino;
    fromAminoMsg(object: QueryDevFeeInfoResponseAminoMsg): QueryDevFeeInfoResponse;
    fromProtoMsg(message: QueryDevFeeInfoResponseProtoMsg): QueryDevFeeInfoResponse;
    toProto(message: QueryDevFeeInfoResponse): Uint8Array;
    toProtoMsg(message: QueryDevFeeInfoResponse): QueryDevFeeInfoResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryParamsRequest: {
    typeUrl: string;
    is(o: any): o is QueryParamsRequest;
    isSDK(o: any): o is QueryParamsRequestSDKType;
    isAmino(o: any): o is QueryParamsRequestAmino;
    encode(_: QueryParamsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryParamsRequest;
    fromJSON(_: any): QueryParamsRequest;
    toJSON(_: QueryParamsRequest): JsonSafe<QueryParamsRequest>;
    fromPartial(_: DeepPartial<QueryParamsRequest>): QueryParamsRequest;
    fromSDK(_: QueryParamsRequestSDKType): QueryParamsRequest;
    fromSDKJSON(_: any): QueryParamsRequestSDKType;
    toSDK(_: QueryParamsRequest): QueryParamsRequestSDKType;
    fromAmino(_: QueryParamsRequestAmino): QueryParamsRequest;
    toAmino(_: QueryParamsRequest): QueryParamsRequestAmino;
    fromAminoMsg(object: QueryParamsRequestAminoMsg): QueryParamsRequest;
    fromProtoMsg(message: QueryParamsRequestProtoMsg): QueryParamsRequest;
    toProto(message: QueryParamsRequest): Uint8Array;
    toProtoMsg(message: QueryParamsRequest): QueryParamsRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryParamsResponse: {
    typeUrl: string;
    is(o: any): o is QueryParamsResponse;
    isSDK(o: any): o is QueryParamsResponseSDKType;
    isAmino(o: any): o is QueryParamsResponseAmino;
    encode(message: QueryParamsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryParamsResponse;
    fromJSON(object: any): QueryParamsResponse;
    toJSON(message: QueryParamsResponse): JsonSafe<QueryParamsResponse>;
    fromPartial(object: DeepPartial<QueryParamsResponse>): QueryParamsResponse;
    fromSDK(object: QueryParamsResponseSDKType): QueryParamsResponse;
    fromSDKJSON(object: any): QueryParamsResponseSDKType;
    toSDK(message: QueryParamsResponse): QueryParamsResponseSDKType;
    fromAmino(object: QueryParamsResponseAmino): QueryParamsResponse;
    toAmino(message: QueryParamsResponse): QueryParamsResponseAmino;
    fromAminoMsg(object: QueryParamsResponseAminoMsg): QueryParamsResponse;
    fromProtoMsg(message: QueryParamsResponseProtoMsg): QueryParamsResponse;
    toProto(message: QueryParamsResponse): Uint8Array;
    toProtoMsg(message: QueryParamsResponse): QueryParamsResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryDevFeeInfosPerDeployerRequest: {
    typeUrl: string;
    is(o: any): o is QueryDevFeeInfosPerDeployerRequest;
    isSDK(o: any): o is QueryDevFeeInfosPerDeployerRequestSDKType;
    isAmino(o: any): o is QueryDevFeeInfosPerDeployerRequestAmino;
    encode(message: QueryDevFeeInfosPerDeployerRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryDevFeeInfosPerDeployerRequest;
    fromJSON(object: any): QueryDevFeeInfosPerDeployerRequest;
    toJSON(message: QueryDevFeeInfosPerDeployerRequest): JsonSafe<QueryDevFeeInfosPerDeployerRequest>;
    fromPartial(object: DeepPartial<QueryDevFeeInfosPerDeployerRequest>): QueryDevFeeInfosPerDeployerRequest;
    fromSDK(object: QueryDevFeeInfosPerDeployerRequestSDKType): QueryDevFeeInfosPerDeployerRequest;
    fromSDKJSON(object: any): QueryDevFeeInfosPerDeployerRequestSDKType;
    toSDK(message: QueryDevFeeInfosPerDeployerRequest): QueryDevFeeInfosPerDeployerRequestSDKType;
    fromAmino(object: QueryDevFeeInfosPerDeployerRequestAmino): QueryDevFeeInfosPerDeployerRequest;
    toAmino(message: QueryDevFeeInfosPerDeployerRequest): QueryDevFeeInfosPerDeployerRequestAmino;
    fromAminoMsg(object: QueryDevFeeInfosPerDeployerRequestAminoMsg): QueryDevFeeInfosPerDeployerRequest;
    fromProtoMsg(message: QueryDevFeeInfosPerDeployerRequestProtoMsg): QueryDevFeeInfosPerDeployerRequest;
    toProto(message: QueryDevFeeInfosPerDeployerRequest): Uint8Array;
    toProtoMsg(message: QueryDevFeeInfosPerDeployerRequest): QueryDevFeeInfosPerDeployerRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryDevFeeInfosPerDeployerResponse: {
    typeUrl: string;
    is(o: any): o is QueryDevFeeInfosPerDeployerResponse;
    isSDK(o: any): o is QueryDevFeeInfosPerDeployerResponseSDKType;
    isAmino(o: any): o is QueryDevFeeInfosPerDeployerResponseAmino;
    encode(message: QueryDevFeeInfosPerDeployerResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryDevFeeInfosPerDeployerResponse;
    fromJSON(object: any): QueryDevFeeInfosPerDeployerResponse;
    toJSON(message: QueryDevFeeInfosPerDeployerResponse): JsonSafe<QueryDevFeeInfosPerDeployerResponse>;
    fromPartial(object: DeepPartial<QueryDevFeeInfosPerDeployerResponse>): QueryDevFeeInfosPerDeployerResponse;
    fromSDK(object: QueryDevFeeInfosPerDeployerResponseSDKType): QueryDevFeeInfosPerDeployerResponse;
    fromSDKJSON(object: any): QueryDevFeeInfosPerDeployerResponseSDKType;
    toSDK(message: QueryDevFeeInfosPerDeployerResponse): QueryDevFeeInfosPerDeployerResponseSDKType;
    fromAmino(object: QueryDevFeeInfosPerDeployerResponseAmino): QueryDevFeeInfosPerDeployerResponse;
    toAmino(message: QueryDevFeeInfosPerDeployerResponse): QueryDevFeeInfosPerDeployerResponseAmino;
    fromAminoMsg(object: QueryDevFeeInfosPerDeployerResponseAminoMsg): QueryDevFeeInfosPerDeployerResponse;
    fromProtoMsg(message: QueryDevFeeInfosPerDeployerResponseProtoMsg): QueryDevFeeInfosPerDeployerResponse;
    toProto(message: QueryDevFeeInfosPerDeployerResponse): Uint8Array;
    toProtoMsg(message: QueryDevFeeInfosPerDeployerResponse): QueryDevFeeInfosPerDeployerResponseProtoMsg;
    registerTypeUrl(): void;
};
