import { TxRpc } from "../../../types";
import { QueryDevFeeInfosRequest, QueryDevFeeInfosResponse, QueryDevFeeInfoRequest, QueryDevFeeInfoResponse, QueryParamsRequest, QueryParamsResponse, QueryDevFeeInfosPerDeployerRequest, QueryDevFeeInfosPerDeployerResponse } from "./query";
/** Query defines the gRPC querier service. */
export interface Query {
    /** DevFeeInfos retrieves all registered contracts for fee distribution */
    devFeeInfos(request?: QueryDevFeeInfosRequest): Promise<QueryDevFeeInfosResponse>;
    /** DevFeeInfo retrieves a registered contract for fee distribution */
    devFeeInfo(request: QueryDevFeeInfoRequest): Promise<QueryDevFeeInfoResponse>;
    /** Params retrieves the fees module params */
    params(request?: QueryParamsRequest): Promise<QueryParamsResponse>;
    /**
     * DevFeeInfosPerDeployer retrieves all contracts that a deployer has
     * registered for fee distribution
     */
    devFeeInfosPerDeployer(request: QueryDevFeeInfosPerDeployerRequest): Promise<QueryDevFeeInfosPerDeployerResponse>;
}
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    constructor(rpc: TxRpc);
    devFeeInfos: (request?: QueryDevFeeInfosRequest) => Promise<QueryDevFeeInfosResponse>;
    devFeeInfo: (request: QueryDevFeeInfoRequest) => Promise<QueryDevFeeInfoResponse>;
    params: (request?: QueryParamsRequest) => Promise<QueryParamsResponse>;
    devFeeInfosPerDeployer: (request: QueryDevFeeInfosPerDeployerRequest) => Promise<QueryDevFeeInfosPerDeployerResponse>;
}
export declare const createClientImpl: (rpc: TxRpc) => QueryClientImpl;
