import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "evmos.fees.v1";
/** MsgRegisterFeesContract defines a message that registers a DevFeeInfo */
export interface MsgRegisterDevFeeInfo {
    /** contract hex address */
    contractAddress: string;
    /**
     * bech32 address of message sender, must be the same as the origin EOA
     * sending the transaction which deploys the contract
     */
    deployerAddress: string;
    /** bech32 address of account receiving the transaction fees */
    withdrawAddress: string;
    /**
     * array of nonces from the address path, where the last nonce is
     * the nonce that determines the contract's address - it can be an EOA nonce
     * or a factory contract nonce
     */
    nonces: bigint[];
}
export interface MsgRegisterDevFeeInfoProtoMsg {
    typeUrl: "/evmos.fees.v1.MsgRegisterDevFeeInfo";
    value: Uint8Array;
}
/** MsgRegisterFeesContract defines a message that registers a DevFeeInfo */
export interface MsgRegisterDevFeeInfoAmino {
    /** contract hex address */
    contract_address?: string;
    /**
     * bech32 address of message sender, must be the same as the origin EOA
     * sending the transaction which deploys the contract
     */
    deployer_address?: string;
    /** bech32 address of account receiving the transaction fees */
    withdraw_address?: string;
    /**
     * array of nonces from the address path, where the last nonce is
     * the nonce that determines the contract's address - it can be an EOA nonce
     * or a factory contract nonce
     */
    nonces?: string[];
}
export interface MsgRegisterDevFeeInfoAminoMsg {
    type: "/evmos.fees.v1.MsgRegisterDevFeeInfo";
    value: MsgRegisterDevFeeInfoAmino;
}
/** MsgRegisterFeesContract defines a message that registers a DevFeeInfo */
export interface MsgRegisterDevFeeInfoSDKType {
    contract_address: string;
    deployer_address: string;
    withdraw_address: string;
    nonces: bigint[];
}
/**
 * MsgRegisterDevFeeInfoResponse defines the MsgRegisterDevFeeInfo response
 * type
 */
export interface MsgRegisterDevFeeInfoResponse {
}
export interface MsgRegisterDevFeeInfoResponseProtoMsg {
    typeUrl: "/evmos.fees.v1.MsgRegisterDevFeeInfoResponse";
    value: Uint8Array;
}
/**
 * MsgRegisterDevFeeInfoResponse defines the MsgRegisterDevFeeInfo response
 * type
 */
export interface MsgRegisterDevFeeInfoResponseAmino {
}
export interface MsgRegisterDevFeeInfoResponseAminoMsg {
    type: "/evmos.fees.v1.MsgRegisterDevFeeInfoResponse";
    value: MsgRegisterDevFeeInfoResponseAmino;
}
/**
 * MsgRegisterDevFeeInfoResponse defines the MsgRegisterDevFeeInfo response
 * type
 */
export interface MsgRegisterDevFeeInfoResponseSDKType {
}
/**
 * MsgCancelDevFeeInfo defines a message that cancels a registered a
 * DevFeeInfo
 */
export interface MsgCancelDevFeeInfo {
    /** contract hex address */
    contractAddress: string;
    /** deployer bech32 address */
    deployerAddress: string;
}
export interface MsgCancelDevFeeInfoProtoMsg {
    typeUrl: "/evmos.fees.v1.MsgCancelDevFeeInfo";
    value: Uint8Array;
}
/**
 * MsgCancelDevFeeInfo defines a message that cancels a registered a
 * DevFeeInfo
 */
export interface MsgCancelDevFeeInfoAmino {
    /** contract hex address */
    contract_address?: string;
    /** deployer bech32 address */
    deployer_address?: string;
}
export interface MsgCancelDevFeeInfoAminoMsg {
    type: "/evmos.fees.v1.MsgCancelDevFeeInfo";
    value: MsgCancelDevFeeInfoAmino;
}
/**
 * MsgCancelDevFeeInfo defines a message that cancels a registered a
 * DevFeeInfo
 */
export interface MsgCancelDevFeeInfoSDKType {
    contract_address: string;
    deployer_address: string;
}
/** MsgCancelDevFeeInfoResponse defines the MsgCancelDevFeeInfo response type */
export interface MsgCancelDevFeeInfoResponse {
}
export interface MsgCancelDevFeeInfoResponseProtoMsg {
    typeUrl: "/evmos.fees.v1.MsgCancelDevFeeInfoResponse";
    value: Uint8Array;
}
/** MsgCancelDevFeeInfoResponse defines the MsgCancelDevFeeInfo response type */
export interface MsgCancelDevFeeInfoResponseAmino {
}
export interface MsgCancelDevFeeInfoResponseAminoMsg {
    type: "/evmos.fees.v1.MsgCancelDevFeeInfoResponse";
    value: MsgCancelDevFeeInfoResponseAmino;
}
/** MsgCancelDevFeeInfoResponse defines the MsgCancelDevFeeInfo response type */
export interface MsgCancelDevFeeInfoResponseSDKType {
}
/**
 * MsgUpdateDevFeeInfo defines a message that updates the withdraw address for
 * a registered DevFeeInfo
 */
export interface MsgUpdateDevFeeInfo {
    /** contract hex address */
    contractAddress: string;
    /** deployer bech32 address */
    deployerAddress: string;
    /** new withdraw bech32 address for receiving the transaction fees */
    withdrawAddress: string;
}
export interface MsgUpdateDevFeeInfoProtoMsg {
    typeUrl: "/evmos.fees.v1.MsgUpdateDevFeeInfo";
    value: Uint8Array;
}
/**
 * MsgUpdateDevFeeInfo defines a message that updates the withdraw address for
 * a registered DevFeeInfo
 */
export interface MsgUpdateDevFeeInfoAmino {
    /** contract hex address */
    contract_address?: string;
    /** deployer bech32 address */
    deployer_address?: string;
    /** new withdraw bech32 address for receiving the transaction fees */
    withdraw_address?: string;
}
export interface MsgUpdateDevFeeInfoAminoMsg {
    type: "/evmos.fees.v1.MsgUpdateDevFeeInfo";
    value: MsgUpdateDevFeeInfoAmino;
}
/**
 * MsgUpdateDevFeeInfo defines a message that updates the withdraw address for
 * a registered DevFeeInfo
 */
export interface MsgUpdateDevFeeInfoSDKType {
    contract_address: string;
    deployer_address: string;
    withdraw_address: string;
}
/** MsgUpdateDevFeeInfoResponse defines the MsgUpdateDevFeeInfo response type */
export interface MsgUpdateDevFeeInfoResponse {
}
export interface MsgUpdateDevFeeInfoResponseProtoMsg {
    typeUrl: "/evmos.fees.v1.MsgUpdateDevFeeInfoResponse";
    value: Uint8Array;
}
/** MsgUpdateDevFeeInfoResponse defines the MsgUpdateDevFeeInfo response type */
export interface MsgUpdateDevFeeInfoResponseAmino {
}
export interface MsgUpdateDevFeeInfoResponseAminoMsg {
    type: "/evmos.fees.v1.MsgUpdateDevFeeInfoResponse";
    value: MsgUpdateDevFeeInfoResponseAmino;
}
/** MsgUpdateDevFeeInfoResponse defines the MsgUpdateDevFeeInfo response type */
export interface MsgUpdateDevFeeInfoResponseSDKType {
}
export declare const MsgRegisterDevFeeInfo: {
    typeUrl: string;
    is(o: any): o is MsgRegisterDevFeeInfo;
    isSDK(o: any): o is MsgRegisterDevFeeInfoSDKType;
    isAmino(o: any): o is MsgRegisterDevFeeInfoAmino;
    encode(message: MsgRegisterDevFeeInfo, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgRegisterDevFeeInfo;
    fromJSON(object: any): MsgRegisterDevFeeInfo;
    toJSON(message: MsgRegisterDevFeeInfo): JsonSafe<MsgRegisterDevFeeInfo>;
    fromPartial(object: DeepPartial<MsgRegisterDevFeeInfo>): MsgRegisterDevFeeInfo;
    fromSDK(object: MsgRegisterDevFeeInfoSDKType): MsgRegisterDevFeeInfo;
    fromSDKJSON(object: any): MsgRegisterDevFeeInfoSDKType;
    toSDK(message: MsgRegisterDevFeeInfo): MsgRegisterDevFeeInfoSDKType;
    fromAmino(object: MsgRegisterDevFeeInfoAmino): MsgRegisterDevFeeInfo;
    toAmino(message: MsgRegisterDevFeeInfo): MsgRegisterDevFeeInfoAmino;
    fromAminoMsg(object: MsgRegisterDevFeeInfoAminoMsg): MsgRegisterDevFeeInfo;
    fromProtoMsg(message: MsgRegisterDevFeeInfoProtoMsg): MsgRegisterDevFeeInfo;
    toProto(message: MsgRegisterDevFeeInfo): Uint8Array;
    toProtoMsg(message: MsgRegisterDevFeeInfo): MsgRegisterDevFeeInfoProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgRegisterDevFeeInfoResponse: {
    typeUrl: string;
    is(o: any): o is MsgRegisterDevFeeInfoResponse;
    isSDK(o: any): o is MsgRegisterDevFeeInfoResponseSDKType;
    isAmino(o: any): o is MsgRegisterDevFeeInfoResponseAmino;
    encode(_: MsgRegisterDevFeeInfoResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgRegisterDevFeeInfoResponse;
    fromJSON(_: any): MsgRegisterDevFeeInfoResponse;
    toJSON(_: MsgRegisterDevFeeInfoResponse): JsonSafe<MsgRegisterDevFeeInfoResponse>;
    fromPartial(_: DeepPartial<MsgRegisterDevFeeInfoResponse>): MsgRegisterDevFeeInfoResponse;
    fromSDK(_: MsgRegisterDevFeeInfoResponseSDKType): MsgRegisterDevFeeInfoResponse;
    fromSDKJSON(_: any): MsgRegisterDevFeeInfoResponseSDKType;
    toSDK(_: MsgRegisterDevFeeInfoResponse): MsgRegisterDevFeeInfoResponseSDKType;
    fromAmino(_: MsgRegisterDevFeeInfoResponseAmino): MsgRegisterDevFeeInfoResponse;
    toAmino(_: MsgRegisterDevFeeInfoResponse): MsgRegisterDevFeeInfoResponseAmino;
    fromAminoMsg(object: MsgRegisterDevFeeInfoResponseAminoMsg): MsgRegisterDevFeeInfoResponse;
    fromProtoMsg(message: MsgRegisterDevFeeInfoResponseProtoMsg): MsgRegisterDevFeeInfoResponse;
    toProto(message: MsgRegisterDevFeeInfoResponse): Uint8Array;
    toProtoMsg(message: MsgRegisterDevFeeInfoResponse): MsgRegisterDevFeeInfoResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgCancelDevFeeInfo: {
    typeUrl: string;
    is(o: any): o is MsgCancelDevFeeInfo;
    isSDK(o: any): o is MsgCancelDevFeeInfoSDKType;
    isAmino(o: any): o is MsgCancelDevFeeInfoAmino;
    encode(message: MsgCancelDevFeeInfo, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCancelDevFeeInfo;
    fromJSON(object: any): MsgCancelDevFeeInfo;
    toJSON(message: MsgCancelDevFeeInfo): JsonSafe<MsgCancelDevFeeInfo>;
    fromPartial(object: DeepPartial<MsgCancelDevFeeInfo>): MsgCancelDevFeeInfo;
    fromSDK(object: MsgCancelDevFeeInfoSDKType): MsgCancelDevFeeInfo;
    fromSDKJSON(object: any): MsgCancelDevFeeInfoSDKType;
    toSDK(message: MsgCancelDevFeeInfo): MsgCancelDevFeeInfoSDKType;
    fromAmino(object: MsgCancelDevFeeInfoAmino): MsgCancelDevFeeInfo;
    toAmino(message: MsgCancelDevFeeInfo): MsgCancelDevFeeInfoAmino;
    fromAminoMsg(object: MsgCancelDevFeeInfoAminoMsg): MsgCancelDevFeeInfo;
    fromProtoMsg(message: MsgCancelDevFeeInfoProtoMsg): MsgCancelDevFeeInfo;
    toProto(message: MsgCancelDevFeeInfo): Uint8Array;
    toProtoMsg(message: MsgCancelDevFeeInfo): MsgCancelDevFeeInfoProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgCancelDevFeeInfoResponse: {
    typeUrl: string;
    is(o: any): o is MsgCancelDevFeeInfoResponse;
    isSDK(o: any): o is MsgCancelDevFeeInfoResponseSDKType;
    isAmino(o: any): o is MsgCancelDevFeeInfoResponseAmino;
    encode(_: MsgCancelDevFeeInfoResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgCancelDevFeeInfoResponse;
    fromJSON(_: any): MsgCancelDevFeeInfoResponse;
    toJSON(_: MsgCancelDevFeeInfoResponse): JsonSafe<MsgCancelDevFeeInfoResponse>;
    fromPartial(_: DeepPartial<MsgCancelDevFeeInfoResponse>): MsgCancelDevFeeInfoResponse;
    fromSDK(_: MsgCancelDevFeeInfoResponseSDKType): MsgCancelDevFeeInfoResponse;
    fromSDKJSON(_: any): MsgCancelDevFeeInfoResponseSDKType;
    toSDK(_: MsgCancelDevFeeInfoResponse): MsgCancelDevFeeInfoResponseSDKType;
    fromAmino(_: MsgCancelDevFeeInfoResponseAmino): MsgCancelDevFeeInfoResponse;
    toAmino(_: MsgCancelDevFeeInfoResponse): MsgCancelDevFeeInfoResponseAmino;
    fromAminoMsg(object: MsgCancelDevFeeInfoResponseAminoMsg): MsgCancelDevFeeInfoResponse;
    fromProtoMsg(message: MsgCancelDevFeeInfoResponseProtoMsg): MsgCancelDevFeeInfoResponse;
    toProto(message: MsgCancelDevFeeInfoResponse): Uint8Array;
    toProtoMsg(message: MsgCancelDevFeeInfoResponse): MsgCancelDevFeeInfoResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgUpdateDevFeeInfo: {
    typeUrl: string;
    is(o: any): o is MsgUpdateDevFeeInfo;
    isSDK(o: any): o is MsgUpdateDevFeeInfoSDKType;
    isAmino(o: any): o is MsgUpdateDevFeeInfoAmino;
    encode(message: MsgUpdateDevFeeInfo, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgUpdateDevFeeInfo;
    fromJSON(object: any): MsgUpdateDevFeeInfo;
    toJSON(message: MsgUpdateDevFeeInfo): JsonSafe<MsgUpdateDevFeeInfo>;
    fromPartial(object: DeepPartial<MsgUpdateDevFeeInfo>): MsgUpdateDevFeeInfo;
    fromSDK(object: MsgUpdateDevFeeInfoSDKType): MsgUpdateDevFeeInfo;
    fromSDKJSON(object: any): MsgUpdateDevFeeInfoSDKType;
    toSDK(message: MsgUpdateDevFeeInfo): MsgUpdateDevFeeInfoSDKType;
    fromAmino(object: MsgUpdateDevFeeInfoAmino): MsgUpdateDevFeeInfo;
    toAmino(message: MsgUpdateDevFeeInfo): MsgUpdateDevFeeInfoAmino;
    fromAminoMsg(object: MsgUpdateDevFeeInfoAminoMsg): MsgUpdateDevFeeInfo;
    fromProtoMsg(message: MsgUpdateDevFeeInfoProtoMsg): MsgUpdateDevFeeInfo;
    toProto(message: MsgUpdateDevFeeInfo): Uint8Array;
    toProtoMsg(message: MsgUpdateDevFeeInfo): MsgUpdateDevFeeInfoProtoMsg;
    registerTypeUrl(): void;
};
export declare const MsgUpdateDevFeeInfoResponse: {
    typeUrl: string;
    is(o: any): o is MsgUpdateDevFeeInfoResponse;
    isSDK(o: any): o is MsgUpdateDevFeeInfoResponseSDKType;
    isAmino(o: any): o is MsgUpdateDevFeeInfoResponseAmino;
    encode(_: MsgUpdateDevFeeInfoResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): MsgUpdateDevFeeInfoResponse;
    fromJSON(_: any): MsgUpdateDevFeeInfoResponse;
    toJSON(_: MsgUpdateDevFeeInfoResponse): JsonSafe<MsgUpdateDevFeeInfoResponse>;
    fromPartial(_: DeepPartial<MsgUpdateDevFeeInfoResponse>): MsgUpdateDevFeeInfoResponse;
    fromSDK(_: MsgUpdateDevFeeInfoResponseSDKType): MsgUpdateDevFeeInfoResponse;
    fromSDKJSON(_: any): MsgUpdateDevFeeInfoResponseSDKType;
    toSDK(_: MsgUpdateDevFeeInfoResponse): MsgUpdateDevFeeInfoResponseSDKType;
    fromAmino(_: MsgUpdateDevFeeInfoResponseAmino): MsgUpdateDevFeeInfoResponse;
    toAmino(_: MsgUpdateDevFeeInfoResponse): MsgUpdateDevFeeInfoResponseAmino;
    fromAminoMsg(object: MsgUpdateDevFeeInfoResponseAminoMsg): MsgUpdateDevFeeInfoResponse;
    fromProtoMsg(message: MsgUpdateDevFeeInfoResponseProtoMsg): MsgUpdateDevFeeInfoResponse;
    toProto(message: MsgUpdateDevFeeInfoResponse): Uint8Array;
    toProtoMsg(message: MsgUpdateDevFeeInfoResponse): MsgUpdateDevFeeInfoResponseProtoMsg;
    registerTypeUrl(): void;
};
