import { TelescopeGeneratedType } from "../../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgRegisterDevFeeInfo, MsgCancelDevFeeInfo, MsgUpdateDevFeeInfo } from "./tx";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        registerDevFeeInfo(value: MsgRegisterDevFeeInfo): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        cancelDevFeeInfo(value: MsgCancelDevFeeInfo): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        updateDevFeeInfo(value: MsgUpdateDevFeeInfo): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        registerDevFeeInfo(value: MsgRegisterDevFeeInfo): {
            typeUrl: string;
            value: MsgRegisterDevFeeInfo;
        };
        cancelDevFeeInfo(value: MsgCancelDevFeeInfo): {
            typeUrl: string;
            value: MsgCancelDevFeeInfo;
        };
        updateDevFeeInfo(value: MsgUpdateDevFeeInfo): {
            typeUrl: string;
            value: MsgUpdateDevFeeInfo;
        };
    };
    toJSON: {
        registerDevFeeInfo(value: MsgRegisterDevFeeInfo): {
            typeUrl: string;
            value: {
                contractAddress: string;
                deployerAddress: string;
                withdrawAddress: string;
                nonces: string[];
            };
        };
        cancelDevFeeInfo(value: MsgCancelDevFeeInfo): {
            typeUrl: string;
            value: {
                contractAddress: string;
                deployerAddress: string;
            };
        };
        updateDevFeeInfo(value: MsgUpdateDevFeeInfo): {
            typeUrl: string;
            value: {
                contractAddress: string;
                deployerAddress: string;
                withdrawAddress: string;
            };
        };
    };
    fromJSON: {
        registerDevFeeInfo(value: any): {
            typeUrl: string;
            value: MsgRegisterDevFeeInfo;
        };
        cancelDevFeeInfo(value: any): {
            typeUrl: string;
            value: MsgCancelDevFeeInfo;
        };
        updateDevFeeInfo(value: any): {
            typeUrl: string;
            value: MsgUpdateDevFeeInfo;
        };
    };
    fromPartial: {
        registerDevFeeInfo(value: MsgRegisterDevFeeInfo): {
            typeUrl: string;
            value: MsgRegisterDevFeeInfo;
        };
        cancelDevFeeInfo(value: MsgCancelDevFeeInfo): {
            typeUrl: string;
            value: MsgCancelDevFeeInfo;
        };
        updateDevFeeInfo(value: MsgUpdateDevFeeInfo): {
            typeUrl: string;
            value: MsgUpdateDevFeeInfo;
        };
    };
};
