import { Incentive, IncentiveAmino, IncentiveSDKType, GasMeter, GasMeterAmino, GasMeterSDKType } from "./incentives";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "evmos.incentives.v1";
/** GenesisState defines the module's genesis state. */
export interface GenesisState {
    /** module parameters */
    params: Params;
    /** active incentives */
    incentives: Incentive[];
    /** active Gasmeters */
    gasMeters: GasMeter[];
}
export interface GenesisStateProtoMsg {
    typeUrl: "/evmos.incentives.v1.GenesisState";
    value: Uint8Array;
}
/** GenesisState defines the module's genesis state. */
export interface GenesisStateAmino {
    /** module parameters */
    params?: ParamsAmino;
    /** active incentives */
    incentives?: IncentiveAmino[];
    /** active Gasmeters */
    gas_meters?: GasMeterAmino[];
}
export interface GenesisStateAminoMsg {
    type: "/evmos.incentives.v1.GenesisState";
    value: GenesisStateAmino;
}
/** GenesisState defines the module's genesis state. */
export interface GenesisStateSDKType {
    params: ParamsSDKType;
    incentives: IncentiveSDKType[];
    gas_meters: GasMeterSDKType[];
}
/** Params defines the incentives module params */
export interface Params {
    /** parameter to enable incentives */
    enableIncentives: boolean;
    /** maximum percentage an incentive can allocate per denomination */
    allocationLimit: string;
    /** identifier for the epochs module hooks */
    incentivesEpochIdentifier: string;
    /** scaling factor for capping rewards */
    rewardScaler: string;
}
export interface ParamsProtoMsg {
    typeUrl: "/evmos.incentives.v1.Params";
    value: Uint8Array;
}
/** Params defines the incentives module params */
export interface ParamsAmino {
    /** parameter to enable incentives */
    enable_incentives?: boolean;
    /** maximum percentage an incentive can allocate per denomination */
    allocation_limit?: string;
    /** identifier for the epochs module hooks */
    incentives_epoch_identifier?: string;
    /** scaling factor for capping rewards */
    reward_scaler?: string;
}
export interface ParamsAminoMsg {
    type: "/evmos.incentives.v1.Params";
    value: ParamsAmino;
}
/** Params defines the incentives module params */
export interface ParamsSDKType {
    enable_incentives: boolean;
    allocation_limit: string;
    incentives_epoch_identifier: string;
    reward_scaler: string;
}
export declare const GenesisState: {
    typeUrl: string;
    is(o: any): o is GenesisState;
    isSDK(o: any): o is GenesisStateSDKType;
    isAmino(o: any): o is GenesisStateAmino;
    encode(message: GenesisState, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GenesisState;
    fromJSON(object: any): GenesisState;
    toJSON(message: GenesisState): JsonSafe<GenesisState>;
    fromPartial(object: DeepPartial<GenesisState>): GenesisState;
    fromSDK(object: GenesisStateSDKType): GenesisState;
    fromSDKJSON(object: any): GenesisStateSDKType;
    toSDK(message: GenesisState): GenesisStateSDKType;
    fromAmino(object: GenesisStateAmino): GenesisState;
    toAmino(message: GenesisState): GenesisStateAmino;
    fromAminoMsg(object: GenesisStateAminoMsg): GenesisState;
    fromProtoMsg(message: GenesisStateProtoMsg): GenesisState;
    toProto(message: GenesisState): Uint8Array;
    toProtoMsg(message: GenesisState): GenesisStateProtoMsg;
    registerTypeUrl(): void;
};
export declare const Params: {
    typeUrl: string;
    is(o: any): o is Params;
    isSDK(o: any): o is ParamsSDKType;
    isAmino(o: any): o is ParamsAmino;
    encode(message: Params, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Params;
    fromJSON(object: any): Params;
    toJSON(message: Params): JsonSafe<Params>;
    fromPartial(object: DeepPartial<Params>): Params;
    fromSDK(object: ParamsSDKType): Params;
    fromSDKJSON(object: any): ParamsSDKType;
    toSDK(message: Params): ParamsSDKType;
    fromAmino(object: ParamsAmino): Params;
    toAmino(message: Params): ParamsAmino;
    fromAminoMsg(object: ParamsAminoMsg): Params;
    fromProtoMsg(message: ParamsProtoMsg): Params;
    toProto(message: Params): Uint8Array;
    toProtoMsg(message: Params): ParamsProtoMsg;
    registerTypeUrl(): void;
};
