import { Incentive, GasMeter } from "./incentives";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
import { Decimal } from "@cosmjs/math";
export const protobufPackage = "evmos.incentives.v1";
function createBaseGenesisState() {
    return {
        params: Params.fromPartial({}),
        incentives: [],
        gasMeters: []
    };
}
export const GenesisState = {
    typeUrl: "/evmos.incentives.v1.GenesisState",
    is(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Params.is(o.params) && Array.isArray(o.incentives) && (!o.incentives.length || Incentive.is(o.incentives[0])) && Array.isArray(o.gasMeters) && (!o.gasMeters.length || GasMeter.is(o.gasMeters[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Params.isSDK(o.params) && Array.isArray(o.incentives) && (!o.incentives.length || Incentive.isSDK(o.incentives[0])) && Array.isArray(o.gas_meters) && (!o.gas_meters.length || GasMeter.isSDK(o.gas_meters[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === GenesisState.typeUrl || Params.isAmino(o.params) && Array.isArray(o.incentives) && (!o.incentives.length || Incentive.isAmino(o.incentives[0])) && Array.isArray(o.gas_meters) && (!o.gas_meters.length || GasMeter.isAmino(o.gas_meters[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.params !== undefined) {
            Params.encode(message.params, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.incentives) {
            Incentive.encode(v, writer.uint32(18).fork()).ldelim();
        }
        for (const v of message.gasMeters) {
            GasMeter.encode(v, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGenesisState();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.params = Params.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.incentives.push(Incentive.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.gasMeters.push(GasMeter.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGenesisState();
        if (isSet(object.params))
            obj.params = Params.fromJSON(object.params);
        if (Array.isArray(object?.incentives))
            obj.incentives = object.incentives.map((e) => Incentive.fromJSON(e));
        if (Array.isArray(object?.gasMeters))
            obj.gasMeters = object.gasMeters.map((e) => GasMeter.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
        if (message.incentives) {
            obj.incentives = message.incentives.map(e => e ? Incentive.toJSON(e) : undefined);
        }
        else {
            obj.incentives = [];
        }
        if (message.gasMeters) {
            obj.gasMeters = message.gasMeters.map(e => e ? GasMeter.toJSON(e) : undefined);
        }
        else {
            obj.gasMeters = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGenesisState();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromPartial(object.params);
        }
        message.incentives = object.incentives?.map(e => Incentive.fromPartial(e)) || [];
        message.gasMeters = object.gasMeters?.map(e => GasMeter.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            params: object.params ? Params.fromSDK(object.params) : undefined,
            incentives: Array.isArray(object?.incentives) ? object.incentives.map((e) => Incentive.fromSDK(e)) : [],
            gasMeters: Array.isArray(object?.gas_meters) ? object.gas_meters.map((e) => GasMeter.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            params: isSet(object.params) ? Params.fromSDKJSON(object.params) : undefined,
            incentives: Array.isArray(object?.incentives) ? object.incentives.map((e) => Incentive.fromSDKJSON(e)) : [],
            gas_meters: Array.isArray(object?.gas_meters) ? object.gas_meters.map((e) => GasMeter.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toSDK(message.params) : undefined);
        if (message.incentives) {
            obj.incentives = message.incentives.map(e => e ? Incentive.toSDK(e) : undefined);
        }
        else {
            obj.incentives = [];
        }
        if (message.gasMeters) {
            obj.gas_meters = message.gasMeters.map(e => e ? GasMeter.toSDK(e) : undefined);
        }
        else {
            obj.gas_meters = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGenesisState();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromAmino(object.params);
        }
        message.incentives = object.incentives?.map(e => Incentive.fromAmino(e)) || [];
        message.gasMeters = object.gas_meters?.map(e => GasMeter.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.params = message.params ? Params.toAmino(message.params) : undefined;
        if (message.incentives) {
            obj.incentives = message.incentives.map(e => e ? Incentive.toAmino(e) : undefined);
        }
        else {
            obj.incentives = message.incentives;
        }
        if (message.gasMeters) {
            obj.gas_meters = message.gasMeters.map(e => e ? GasMeter.toAmino(e) : undefined);
        }
        else {
            obj.gas_meters = message.gasMeters;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return GenesisState.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GenesisState.decode(message.value);
    },
    toProto(message) {
        return GenesisState.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.GenesisState",
            value: GenesisState.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Params.registerTypeUrl();
        Incentive.registerTypeUrl();
        GasMeter.registerTypeUrl();
    }
};
function createBaseParams() {
    return {
        enableIncentives: false,
        allocationLimit: "",
        incentivesEpochIdentifier: "",
        rewardScaler: ""
    };
}
export const Params = {
    typeUrl: "/evmos.incentives.v1.Params",
    is(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.enableIncentives === "boolean" && typeof o.allocationLimit === "string" && typeof o.incentivesEpochIdentifier === "string" && typeof o.rewardScaler === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.enable_incentives === "boolean" && typeof o.allocation_limit === "string" && typeof o.incentives_epoch_identifier === "string" && typeof o.reward_scaler === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.enable_incentives === "boolean" && typeof o.allocation_limit === "string" && typeof o.incentives_epoch_identifier === "string" && typeof o.reward_scaler === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.enableIncentives !== undefined) {
            writer.uint32(8).bool(message.enableIncentives);
        }
        if (message.allocationLimit !== undefined) {
            writer.uint32(18).string(Decimal.fromUserInput(message.allocationLimit, 18).atomics);
        }
        if (message.incentivesEpochIdentifier !== undefined) {
            writer.uint32(26).string(message.incentivesEpochIdentifier);
        }
        if (message.rewardScaler !== undefined) {
            writer.uint32(34).string(Decimal.fromUserInput(message.rewardScaler, 18).atomics);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseParams();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.enableIncentives = reader.bool();
                    break;
                case 2:
                    message.allocationLimit = Decimal.fromAtomics(reader.string(), 18).toString();
                    break;
                case 3:
                    message.incentivesEpochIdentifier = reader.string();
                    break;
                case 4:
                    message.rewardScaler = Decimal.fromAtomics(reader.string(), 18).toString();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseParams();
        if (isSet(object.enableIncentives))
            obj.enableIncentives = Boolean(object.enableIncentives);
        if (isSet(object.allocationLimit))
            obj.allocationLimit = String(object.allocationLimit);
        if (isSet(object.incentivesEpochIdentifier))
            obj.incentivesEpochIdentifier = String(object.incentivesEpochIdentifier);
        if (isSet(object.rewardScaler))
            obj.rewardScaler = String(object.rewardScaler);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.enableIncentives !== undefined && (obj.enableIncentives = message.enableIncentives);
        message.allocationLimit !== undefined && (obj.allocationLimit = message.allocationLimit);
        message.incentivesEpochIdentifier !== undefined && (obj.incentivesEpochIdentifier = message.incentivesEpochIdentifier);
        message.rewardScaler !== undefined && (obj.rewardScaler = message.rewardScaler);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseParams();
        message.enableIncentives = object.enableIncentives ?? false;
        message.allocationLimit = object.allocationLimit ?? "";
        message.incentivesEpochIdentifier = object.incentivesEpochIdentifier ?? "";
        message.rewardScaler = object.rewardScaler ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            enableIncentives: object?.enable_incentives,
            allocationLimit: object?.allocation_limit,
            incentivesEpochIdentifier: object?.incentives_epoch_identifier,
            rewardScaler: object?.reward_scaler
        };
    },
    fromSDKJSON(object) {
        return {
            enable_incentives: isSet(object.enable_incentives) ? Boolean(object.enable_incentives) : false,
            allocation_limit: isSet(object.allocation_limit) ? String(object.allocation_limit) : "",
            incentives_epoch_identifier: isSet(object.incentives_epoch_identifier) ? String(object.incentives_epoch_identifier) : "",
            reward_scaler: isSet(object.reward_scaler) ? String(object.reward_scaler) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.enable_incentives = message.enableIncentives;
        obj.allocation_limit = message.allocationLimit;
        obj.incentives_epoch_identifier = message.incentivesEpochIdentifier;
        obj.reward_scaler = message.rewardScaler;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseParams();
        if (object.enable_incentives !== undefined && object.enable_incentives !== null) {
            message.enableIncentives = object.enable_incentives;
        }
        if (object.allocation_limit !== undefined && object.allocation_limit !== null) {
            message.allocationLimit = object.allocation_limit;
        }
        if (object.incentives_epoch_identifier !== undefined && object.incentives_epoch_identifier !== null) {
            message.incentivesEpochIdentifier = object.incentives_epoch_identifier;
        }
        if (object.reward_scaler !== undefined && object.reward_scaler !== null) {
            message.rewardScaler = object.reward_scaler;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.enable_incentives = message.enableIncentives === false ? undefined : message.enableIncentives;
        obj.allocation_limit = message.allocationLimit === "" ? undefined : message.allocationLimit;
        obj.incentives_epoch_identifier = message.incentivesEpochIdentifier === "" ? undefined : message.incentivesEpochIdentifier;
        obj.reward_scaler = message.rewardScaler === "" ? undefined : message.rewardScaler;
        return obj;
    },
    fromAminoMsg(object) {
        return Params.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Params.decode(message.value);
    },
    toProto(message) {
        return Params.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.Params",
            value: Params.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
