import { PageRequest, PageRequestAmino, PageRequestSDKType, PageResponse, PageResponseAmino, PageResponseSDKType } from "../../../cosmos/base/query/v1beta1/pagination";
import { Incentive, IncentiveAmino, IncentiveSDKType, GasMeter, GasMeterAmino, GasMeterSDKType } from "./incentives";
import { DecCoin, DecCoinAmino, DecCoinSDKType } from "../../../cosmos/base/v1beta1/coin";
import { Params, ParamsAmino, ParamsSDKType } from "./genesis";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "evmos.incentives.v1";
/**
 * QueryIncentivesRequest is the request type for the Query/Incentives RPC
 * method.
 */
export interface QueryIncentivesRequest {
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequest;
}
export interface QueryIncentivesRequestProtoMsg {
    typeUrl: "/evmos.incentives.v1.QueryIncentivesRequest";
    value: Uint8Array;
}
/**
 * QueryIncentivesRequest is the request type for the Query/Incentives RPC
 * method.
 */
export interface QueryIncentivesRequestAmino {
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequestAmino;
}
export interface QueryIncentivesRequestAminoMsg {
    type: "/evmos.incentives.v1.QueryIncentivesRequest";
    value: QueryIncentivesRequestAmino;
}
/**
 * QueryIncentivesRequest is the request type for the Query/Incentives RPC
 * method.
 */
export interface QueryIncentivesRequestSDKType {
    pagination?: PageRequestSDKType;
}
/**
 * QueryIncentivesResponse is the response type for the Query/Incentives RPC
 * method.
 */
export interface QueryIncentivesResponse {
    incentives: Incentive[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponse;
}
export interface QueryIncentivesResponseProtoMsg {
    typeUrl: "/evmos.incentives.v1.QueryIncentivesResponse";
    value: Uint8Array;
}
/**
 * QueryIncentivesResponse is the response type for the Query/Incentives RPC
 * method.
 */
export interface QueryIncentivesResponseAmino {
    incentives?: IncentiveAmino[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponseAmino;
}
export interface QueryIncentivesResponseAminoMsg {
    type: "/evmos.incentives.v1.QueryIncentivesResponse";
    value: QueryIncentivesResponseAmino;
}
/**
 * QueryIncentivesResponse is the response type for the Query/Incentives RPC
 * method.
 */
export interface QueryIncentivesResponseSDKType {
    incentives: IncentiveSDKType[];
    pagination?: PageResponseSDKType;
}
/** QueryIncentiveRequest is the request type for the Query/Incentive RPC method. */
export interface QueryIncentiveRequest {
    /** contract identifier is the hex contract address of a contract */
    contract: string;
}
export interface QueryIncentiveRequestProtoMsg {
    typeUrl: "/evmos.incentives.v1.QueryIncentiveRequest";
    value: Uint8Array;
}
/** QueryIncentiveRequest is the request type for the Query/Incentive RPC method. */
export interface QueryIncentiveRequestAmino {
    /** contract identifier is the hex contract address of a contract */
    contract?: string;
}
export interface QueryIncentiveRequestAminoMsg {
    type: "/evmos.incentives.v1.QueryIncentiveRequest";
    value: QueryIncentiveRequestAmino;
}
/** QueryIncentiveRequest is the request type for the Query/Incentive RPC method. */
export interface QueryIncentiveRequestSDKType {
    contract: string;
}
/**
 * QueryIncentiveResponse is the response type for the Query/Incentive RPC
 * method.
 */
export interface QueryIncentiveResponse {
    incentive: Incentive;
}
export interface QueryIncentiveResponseProtoMsg {
    typeUrl: "/evmos.incentives.v1.QueryIncentiveResponse";
    value: Uint8Array;
}
/**
 * QueryIncentiveResponse is the response type for the Query/Incentive RPC
 * method.
 */
export interface QueryIncentiveResponseAmino {
    incentive?: IncentiveAmino;
}
export interface QueryIncentiveResponseAminoMsg {
    type: "/evmos.incentives.v1.QueryIncentiveResponse";
    value: QueryIncentiveResponseAmino;
}
/**
 * QueryIncentiveResponse is the response type for the Query/Incentive RPC
 * method.
 */
export interface QueryIncentiveResponseSDKType {
    incentive: IncentiveSDKType;
}
/**
 * QueryGasMetersRequest is the request type for the Query/Incentives RPC
 * method.
 */
export interface QueryGasMetersRequest {
    /** contract is the hex contract address of a incentivized smart contract */
    contract: string;
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequest;
}
export interface QueryGasMetersRequestProtoMsg {
    typeUrl: "/evmos.incentives.v1.QueryGasMetersRequest";
    value: Uint8Array;
}
/**
 * QueryGasMetersRequest is the request type for the Query/Incentives RPC
 * method.
 */
export interface QueryGasMetersRequestAmino {
    /** contract is the hex contract address of a incentivized smart contract */
    contract?: string;
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequestAmino;
}
export interface QueryGasMetersRequestAminoMsg {
    type: "/evmos.incentives.v1.QueryGasMetersRequest";
    value: QueryGasMetersRequestAmino;
}
/**
 * QueryGasMetersRequest is the request type for the Query/Incentives RPC
 * method.
 */
export interface QueryGasMetersRequestSDKType {
    contract: string;
    pagination?: PageRequestSDKType;
}
/**
 * QueryGasMetersResponse is the response type for the Query/Incentives RPC
 * method.
 */
export interface QueryGasMetersResponse {
    gasMeters: GasMeter[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponse;
}
export interface QueryGasMetersResponseProtoMsg {
    typeUrl: "/evmos.incentives.v1.QueryGasMetersResponse";
    value: Uint8Array;
}
/**
 * QueryGasMetersResponse is the response type for the Query/Incentives RPC
 * method.
 */
export interface QueryGasMetersResponseAmino {
    gas_meters?: GasMeterAmino[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponseAmino;
}
export interface QueryGasMetersResponseAminoMsg {
    type: "/evmos.incentives.v1.QueryGasMetersResponse";
    value: QueryGasMetersResponseAmino;
}
/**
 * QueryGasMetersResponse is the response type for the Query/Incentives RPC
 * method.
 */
export interface QueryGasMetersResponseSDKType {
    gas_meters: GasMeterSDKType[];
    pagination?: PageResponseSDKType;
}
/** QueryGasMeterRequest is the request type for the Query/Incentive RPC method. */
export interface QueryGasMeterRequest {
    /** contract identifier is the hex contract address of a contract */
    contract: string;
    /** participant identifier is the hex address of a user */
    participant: string;
}
export interface QueryGasMeterRequestProtoMsg {
    typeUrl: "/evmos.incentives.v1.QueryGasMeterRequest";
    value: Uint8Array;
}
/** QueryGasMeterRequest is the request type for the Query/Incentive RPC method. */
export interface QueryGasMeterRequestAmino {
    /** contract identifier is the hex contract address of a contract */
    contract?: string;
    /** participant identifier is the hex address of a user */
    participant?: string;
}
export interface QueryGasMeterRequestAminoMsg {
    type: "/evmos.incentives.v1.QueryGasMeterRequest";
    value: QueryGasMeterRequestAmino;
}
/** QueryGasMeterRequest is the request type for the Query/Incentive RPC method. */
export interface QueryGasMeterRequestSDKType {
    contract: string;
    participant: string;
}
/**
 * QueryGasMeterResponse is the response type for the Query/Incentive RPC
 * method.
 */
export interface QueryGasMeterResponse {
    gasMeter: bigint;
}
export interface QueryGasMeterResponseProtoMsg {
    typeUrl: "/evmos.incentives.v1.QueryGasMeterResponse";
    value: Uint8Array;
}
/**
 * QueryGasMeterResponse is the response type for the Query/Incentive RPC
 * method.
 */
export interface QueryGasMeterResponseAmino {
    gas_meter?: string;
}
export interface QueryGasMeterResponseAminoMsg {
    type: "/evmos.incentives.v1.QueryGasMeterResponse";
    value: QueryGasMeterResponseAmino;
}
/**
 * QueryGasMeterResponse is the response type for the Query/Incentive RPC
 * method.
 */
export interface QueryGasMeterResponseSDKType {
    gas_meter: bigint;
}
/**
 * QueryAllocationMetersRequest is the request type for the
 * Query/AllocationMeters RPC method.
 */
export interface QueryAllocationMetersRequest {
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequest;
}
export interface QueryAllocationMetersRequestProtoMsg {
    typeUrl: "/evmos.incentives.v1.QueryAllocationMetersRequest";
    value: Uint8Array;
}
/**
 * QueryAllocationMetersRequest is the request type for the
 * Query/AllocationMeters RPC method.
 */
export interface QueryAllocationMetersRequestAmino {
    /** pagination defines an optional pagination for the request. */
    pagination?: PageRequestAmino;
}
export interface QueryAllocationMetersRequestAminoMsg {
    type: "/evmos.incentives.v1.QueryAllocationMetersRequest";
    value: QueryAllocationMetersRequestAmino;
}
/**
 * QueryAllocationMetersRequest is the request type for the
 * Query/AllocationMeters RPC method.
 */
export interface QueryAllocationMetersRequestSDKType {
    pagination?: PageRequestSDKType;
}
/**
 * QueryAllocationMetersResponse is the response type for the
 * Query/AllocationMeters RPC method.
 */
export interface QueryAllocationMetersResponse {
    allocationMeters: DecCoin[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponse;
}
export interface QueryAllocationMetersResponseProtoMsg {
    typeUrl: "/evmos.incentives.v1.QueryAllocationMetersResponse";
    value: Uint8Array;
}
/**
 * QueryAllocationMetersResponse is the response type for the
 * Query/AllocationMeters RPC method.
 */
export interface QueryAllocationMetersResponseAmino {
    allocation_meters?: DecCoinAmino[];
    /** pagination defines the pagination in the response. */
    pagination?: PageResponseAmino;
}
export interface QueryAllocationMetersResponseAminoMsg {
    type: "/evmos.incentives.v1.QueryAllocationMetersResponse";
    value: QueryAllocationMetersResponseAmino;
}
/**
 * QueryAllocationMetersResponse is the response type for the
 * Query/AllocationMeters RPC method.
 */
export interface QueryAllocationMetersResponseSDKType {
    allocation_meters: DecCoinSDKType[];
    pagination?: PageResponseSDKType;
}
/**
 * QueryAllocationMeterRequest is the request type for the Query/AllocationMeter
 * RPC method.
 */
export interface QueryAllocationMeterRequest {
    /** denom is the coin denom to query an allocation meter for. */
    denom: string;
}
export interface QueryAllocationMeterRequestProtoMsg {
    typeUrl: "/evmos.incentives.v1.QueryAllocationMeterRequest";
    value: Uint8Array;
}
/**
 * QueryAllocationMeterRequest is the request type for the Query/AllocationMeter
 * RPC method.
 */
export interface QueryAllocationMeterRequestAmino {
    /** denom is the coin denom to query an allocation meter for. */
    denom?: string;
}
export interface QueryAllocationMeterRequestAminoMsg {
    type: "/evmos.incentives.v1.QueryAllocationMeterRequest";
    value: QueryAllocationMeterRequestAmino;
}
/**
 * QueryAllocationMeterRequest is the request type for the Query/AllocationMeter
 * RPC method.
 */
export interface QueryAllocationMeterRequestSDKType {
    denom: string;
}
/**
 * QueryAllocationMeterResponse is the response type for the
 * Query/AllocationMeter RPC method.
 */
export interface QueryAllocationMeterResponse {
    allocationMeter: DecCoin;
}
export interface QueryAllocationMeterResponseProtoMsg {
    typeUrl: "/evmos.incentives.v1.QueryAllocationMeterResponse";
    value: Uint8Array;
}
/**
 * QueryAllocationMeterResponse is the response type for the
 * Query/AllocationMeter RPC method.
 */
export interface QueryAllocationMeterResponseAmino {
    allocation_meter?: DecCoinAmino;
}
export interface QueryAllocationMeterResponseAminoMsg {
    type: "/evmos.incentives.v1.QueryAllocationMeterResponse";
    value: QueryAllocationMeterResponseAmino;
}
/**
 * QueryAllocationMeterResponse is the response type for the
 * Query/AllocationMeter RPC method.
 */
export interface QueryAllocationMeterResponseSDKType {
    allocation_meter: DecCoinSDKType;
}
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequest {
}
export interface QueryParamsRequestProtoMsg {
    typeUrl: "/evmos.incentives.v1.QueryParamsRequest";
    value: Uint8Array;
}
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequestAmino {
}
export interface QueryParamsRequestAminoMsg {
    type: "/evmos.incentives.v1.QueryParamsRequest";
    value: QueryParamsRequestAmino;
}
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequestSDKType {
}
/**
 * QueryParamsResponse is the response type for the Query/Params RPC
 * method.
 */
export interface QueryParamsResponse {
    params: Params;
}
export interface QueryParamsResponseProtoMsg {
    typeUrl: "/evmos.incentives.v1.QueryParamsResponse";
    value: Uint8Array;
}
/**
 * QueryParamsResponse is the response type for the Query/Params RPC
 * method.
 */
export interface QueryParamsResponseAmino {
    params?: ParamsAmino;
}
export interface QueryParamsResponseAminoMsg {
    type: "/evmos.incentives.v1.QueryParamsResponse";
    value: QueryParamsResponseAmino;
}
/**
 * QueryParamsResponse is the response type for the Query/Params RPC
 * method.
 */
export interface QueryParamsResponseSDKType {
    params: ParamsSDKType;
}
export declare const QueryIncentivesRequest: {
    typeUrl: string;
    is(o: any): o is QueryIncentivesRequest;
    isSDK(o: any): o is QueryIncentivesRequestSDKType;
    isAmino(o: any): o is QueryIncentivesRequestAmino;
    encode(message: QueryIncentivesRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryIncentivesRequest;
    fromJSON(object: any): QueryIncentivesRequest;
    toJSON(message: QueryIncentivesRequest): JsonSafe<QueryIncentivesRequest>;
    fromPartial(object: DeepPartial<QueryIncentivesRequest>): QueryIncentivesRequest;
    fromSDK(object: QueryIncentivesRequestSDKType): QueryIncentivesRequest;
    fromSDKJSON(object: any): QueryIncentivesRequestSDKType;
    toSDK(message: QueryIncentivesRequest): QueryIncentivesRequestSDKType;
    fromAmino(object: QueryIncentivesRequestAmino): QueryIncentivesRequest;
    toAmino(message: QueryIncentivesRequest): QueryIncentivesRequestAmino;
    fromAminoMsg(object: QueryIncentivesRequestAminoMsg): QueryIncentivesRequest;
    fromProtoMsg(message: QueryIncentivesRequestProtoMsg): QueryIncentivesRequest;
    toProto(message: QueryIncentivesRequest): Uint8Array;
    toProtoMsg(message: QueryIncentivesRequest): QueryIncentivesRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryIncentivesResponse: {
    typeUrl: string;
    is(o: any): o is QueryIncentivesResponse;
    isSDK(o: any): o is QueryIncentivesResponseSDKType;
    isAmino(o: any): o is QueryIncentivesResponseAmino;
    encode(message: QueryIncentivesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryIncentivesResponse;
    fromJSON(object: any): QueryIncentivesResponse;
    toJSON(message: QueryIncentivesResponse): JsonSafe<QueryIncentivesResponse>;
    fromPartial(object: DeepPartial<QueryIncentivesResponse>): QueryIncentivesResponse;
    fromSDK(object: QueryIncentivesResponseSDKType): QueryIncentivesResponse;
    fromSDKJSON(object: any): QueryIncentivesResponseSDKType;
    toSDK(message: QueryIncentivesResponse): QueryIncentivesResponseSDKType;
    fromAmino(object: QueryIncentivesResponseAmino): QueryIncentivesResponse;
    toAmino(message: QueryIncentivesResponse): QueryIncentivesResponseAmino;
    fromAminoMsg(object: QueryIncentivesResponseAminoMsg): QueryIncentivesResponse;
    fromProtoMsg(message: QueryIncentivesResponseProtoMsg): QueryIncentivesResponse;
    toProto(message: QueryIncentivesResponse): Uint8Array;
    toProtoMsg(message: QueryIncentivesResponse): QueryIncentivesResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryIncentiveRequest: {
    typeUrl: string;
    is(o: any): o is QueryIncentiveRequest;
    isSDK(o: any): o is QueryIncentiveRequestSDKType;
    isAmino(o: any): o is QueryIncentiveRequestAmino;
    encode(message: QueryIncentiveRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryIncentiveRequest;
    fromJSON(object: any): QueryIncentiveRequest;
    toJSON(message: QueryIncentiveRequest): JsonSafe<QueryIncentiveRequest>;
    fromPartial(object: DeepPartial<QueryIncentiveRequest>): QueryIncentiveRequest;
    fromSDK(object: QueryIncentiveRequestSDKType): QueryIncentiveRequest;
    fromSDKJSON(object: any): QueryIncentiveRequestSDKType;
    toSDK(message: QueryIncentiveRequest): QueryIncentiveRequestSDKType;
    fromAmino(object: QueryIncentiveRequestAmino): QueryIncentiveRequest;
    toAmino(message: QueryIncentiveRequest): QueryIncentiveRequestAmino;
    fromAminoMsg(object: QueryIncentiveRequestAminoMsg): QueryIncentiveRequest;
    fromProtoMsg(message: QueryIncentiveRequestProtoMsg): QueryIncentiveRequest;
    toProto(message: QueryIncentiveRequest): Uint8Array;
    toProtoMsg(message: QueryIncentiveRequest): QueryIncentiveRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryIncentiveResponse: {
    typeUrl: string;
    is(o: any): o is QueryIncentiveResponse;
    isSDK(o: any): o is QueryIncentiveResponseSDKType;
    isAmino(o: any): o is QueryIncentiveResponseAmino;
    encode(message: QueryIncentiveResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryIncentiveResponse;
    fromJSON(object: any): QueryIncentiveResponse;
    toJSON(message: QueryIncentiveResponse): JsonSafe<QueryIncentiveResponse>;
    fromPartial(object: DeepPartial<QueryIncentiveResponse>): QueryIncentiveResponse;
    fromSDK(object: QueryIncentiveResponseSDKType): QueryIncentiveResponse;
    fromSDKJSON(object: any): QueryIncentiveResponseSDKType;
    toSDK(message: QueryIncentiveResponse): QueryIncentiveResponseSDKType;
    fromAmino(object: QueryIncentiveResponseAmino): QueryIncentiveResponse;
    toAmino(message: QueryIncentiveResponse): QueryIncentiveResponseAmino;
    fromAminoMsg(object: QueryIncentiveResponseAminoMsg): QueryIncentiveResponse;
    fromProtoMsg(message: QueryIncentiveResponseProtoMsg): QueryIncentiveResponse;
    toProto(message: QueryIncentiveResponse): Uint8Array;
    toProtoMsg(message: QueryIncentiveResponse): QueryIncentiveResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryGasMetersRequest: {
    typeUrl: string;
    is(o: any): o is QueryGasMetersRequest;
    isSDK(o: any): o is QueryGasMetersRequestSDKType;
    isAmino(o: any): o is QueryGasMetersRequestAmino;
    encode(message: QueryGasMetersRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryGasMetersRequest;
    fromJSON(object: any): QueryGasMetersRequest;
    toJSON(message: QueryGasMetersRequest): JsonSafe<QueryGasMetersRequest>;
    fromPartial(object: DeepPartial<QueryGasMetersRequest>): QueryGasMetersRequest;
    fromSDK(object: QueryGasMetersRequestSDKType): QueryGasMetersRequest;
    fromSDKJSON(object: any): QueryGasMetersRequestSDKType;
    toSDK(message: QueryGasMetersRequest): QueryGasMetersRequestSDKType;
    fromAmino(object: QueryGasMetersRequestAmino): QueryGasMetersRequest;
    toAmino(message: QueryGasMetersRequest): QueryGasMetersRequestAmino;
    fromAminoMsg(object: QueryGasMetersRequestAminoMsg): QueryGasMetersRequest;
    fromProtoMsg(message: QueryGasMetersRequestProtoMsg): QueryGasMetersRequest;
    toProto(message: QueryGasMetersRequest): Uint8Array;
    toProtoMsg(message: QueryGasMetersRequest): QueryGasMetersRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryGasMetersResponse: {
    typeUrl: string;
    is(o: any): o is QueryGasMetersResponse;
    isSDK(o: any): o is QueryGasMetersResponseSDKType;
    isAmino(o: any): o is QueryGasMetersResponseAmino;
    encode(message: QueryGasMetersResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryGasMetersResponse;
    fromJSON(object: any): QueryGasMetersResponse;
    toJSON(message: QueryGasMetersResponse): JsonSafe<QueryGasMetersResponse>;
    fromPartial(object: DeepPartial<QueryGasMetersResponse>): QueryGasMetersResponse;
    fromSDK(object: QueryGasMetersResponseSDKType): QueryGasMetersResponse;
    fromSDKJSON(object: any): QueryGasMetersResponseSDKType;
    toSDK(message: QueryGasMetersResponse): QueryGasMetersResponseSDKType;
    fromAmino(object: QueryGasMetersResponseAmino): QueryGasMetersResponse;
    toAmino(message: QueryGasMetersResponse): QueryGasMetersResponseAmino;
    fromAminoMsg(object: QueryGasMetersResponseAminoMsg): QueryGasMetersResponse;
    fromProtoMsg(message: QueryGasMetersResponseProtoMsg): QueryGasMetersResponse;
    toProto(message: QueryGasMetersResponse): Uint8Array;
    toProtoMsg(message: QueryGasMetersResponse): QueryGasMetersResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryGasMeterRequest: {
    typeUrl: string;
    is(o: any): o is QueryGasMeterRequest;
    isSDK(o: any): o is QueryGasMeterRequestSDKType;
    isAmino(o: any): o is QueryGasMeterRequestAmino;
    encode(message: QueryGasMeterRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryGasMeterRequest;
    fromJSON(object: any): QueryGasMeterRequest;
    toJSON(message: QueryGasMeterRequest): JsonSafe<QueryGasMeterRequest>;
    fromPartial(object: DeepPartial<QueryGasMeterRequest>): QueryGasMeterRequest;
    fromSDK(object: QueryGasMeterRequestSDKType): QueryGasMeterRequest;
    fromSDKJSON(object: any): QueryGasMeterRequestSDKType;
    toSDK(message: QueryGasMeterRequest): QueryGasMeterRequestSDKType;
    fromAmino(object: QueryGasMeterRequestAmino): QueryGasMeterRequest;
    toAmino(message: QueryGasMeterRequest): QueryGasMeterRequestAmino;
    fromAminoMsg(object: QueryGasMeterRequestAminoMsg): QueryGasMeterRequest;
    fromProtoMsg(message: QueryGasMeterRequestProtoMsg): QueryGasMeterRequest;
    toProto(message: QueryGasMeterRequest): Uint8Array;
    toProtoMsg(message: QueryGasMeterRequest): QueryGasMeterRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryGasMeterResponse: {
    typeUrl: string;
    is(o: any): o is QueryGasMeterResponse;
    isSDK(o: any): o is QueryGasMeterResponseSDKType;
    isAmino(o: any): o is QueryGasMeterResponseAmino;
    encode(message: QueryGasMeterResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryGasMeterResponse;
    fromJSON(object: any): QueryGasMeterResponse;
    toJSON(message: QueryGasMeterResponse): JsonSafe<QueryGasMeterResponse>;
    fromPartial(object: DeepPartial<QueryGasMeterResponse>): QueryGasMeterResponse;
    fromSDK(object: QueryGasMeterResponseSDKType): QueryGasMeterResponse;
    fromSDKJSON(object: any): QueryGasMeterResponseSDKType;
    toSDK(message: QueryGasMeterResponse): QueryGasMeterResponseSDKType;
    fromAmino(object: QueryGasMeterResponseAmino): QueryGasMeterResponse;
    toAmino(message: QueryGasMeterResponse): QueryGasMeterResponseAmino;
    fromAminoMsg(object: QueryGasMeterResponseAminoMsg): QueryGasMeterResponse;
    fromProtoMsg(message: QueryGasMeterResponseProtoMsg): QueryGasMeterResponse;
    toProto(message: QueryGasMeterResponse): Uint8Array;
    toProtoMsg(message: QueryGasMeterResponse): QueryGasMeterResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryAllocationMetersRequest: {
    typeUrl: string;
    is(o: any): o is QueryAllocationMetersRequest;
    isSDK(o: any): o is QueryAllocationMetersRequestSDKType;
    isAmino(o: any): o is QueryAllocationMetersRequestAmino;
    encode(message: QueryAllocationMetersRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryAllocationMetersRequest;
    fromJSON(object: any): QueryAllocationMetersRequest;
    toJSON(message: QueryAllocationMetersRequest): JsonSafe<QueryAllocationMetersRequest>;
    fromPartial(object: DeepPartial<QueryAllocationMetersRequest>): QueryAllocationMetersRequest;
    fromSDK(object: QueryAllocationMetersRequestSDKType): QueryAllocationMetersRequest;
    fromSDKJSON(object: any): QueryAllocationMetersRequestSDKType;
    toSDK(message: QueryAllocationMetersRequest): QueryAllocationMetersRequestSDKType;
    fromAmino(object: QueryAllocationMetersRequestAmino): QueryAllocationMetersRequest;
    toAmino(message: QueryAllocationMetersRequest): QueryAllocationMetersRequestAmino;
    fromAminoMsg(object: QueryAllocationMetersRequestAminoMsg): QueryAllocationMetersRequest;
    fromProtoMsg(message: QueryAllocationMetersRequestProtoMsg): QueryAllocationMetersRequest;
    toProto(message: QueryAllocationMetersRequest): Uint8Array;
    toProtoMsg(message: QueryAllocationMetersRequest): QueryAllocationMetersRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryAllocationMetersResponse: {
    typeUrl: string;
    is(o: any): o is QueryAllocationMetersResponse;
    isSDK(o: any): o is QueryAllocationMetersResponseSDKType;
    isAmino(o: any): o is QueryAllocationMetersResponseAmino;
    encode(message: QueryAllocationMetersResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryAllocationMetersResponse;
    fromJSON(object: any): QueryAllocationMetersResponse;
    toJSON(message: QueryAllocationMetersResponse): JsonSafe<QueryAllocationMetersResponse>;
    fromPartial(object: DeepPartial<QueryAllocationMetersResponse>): QueryAllocationMetersResponse;
    fromSDK(object: QueryAllocationMetersResponseSDKType): QueryAllocationMetersResponse;
    fromSDKJSON(object: any): QueryAllocationMetersResponseSDKType;
    toSDK(message: QueryAllocationMetersResponse): QueryAllocationMetersResponseSDKType;
    fromAmino(object: QueryAllocationMetersResponseAmino): QueryAllocationMetersResponse;
    toAmino(message: QueryAllocationMetersResponse): QueryAllocationMetersResponseAmino;
    fromAminoMsg(object: QueryAllocationMetersResponseAminoMsg): QueryAllocationMetersResponse;
    fromProtoMsg(message: QueryAllocationMetersResponseProtoMsg): QueryAllocationMetersResponse;
    toProto(message: QueryAllocationMetersResponse): Uint8Array;
    toProtoMsg(message: QueryAllocationMetersResponse): QueryAllocationMetersResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryAllocationMeterRequest: {
    typeUrl: string;
    is(o: any): o is QueryAllocationMeterRequest;
    isSDK(o: any): o is QueryAllocationMeterRequestSDKType;
    isAmino(o: any): o is QueryAllocationMeterRequestAmino;
    encode(message: QueryAllocationMeterRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryAllocationMeterRequest;
    fromJSON(object: any): QueryAllocationMeterRequest;
    toJSON(message: QueryAllocationMeterRequest): JsonSafe<QueryAllocationMeterRequest>;
    fromPartial(object: DeepPartial<QueryAllocationMeterRequest>): QueryAllocationMeterRequest;
    fromSDK(object: QueryAllocationMeterRequestSDKType): QueryAllocationMeterRequest;
    fromSDKJSON(object: any): QueryAllocationMeterRequestSDKType;
    toSDK(message: QueryAllocationMeterRequest): QueryAllocationMeterRequestSDKType;
    fromAmino(object: QueryAllocationMeterRequestAmino): QueryAllocationMeterRequest;
    toAmino(message: QueryAllocationMeterRequest): QueryAllocationMeterRequestAmino;
    fromAminoMsg(object: QueryAllocationMeterRequestAminoMsg): QueryAllocationMeterRequest;
    fromProtoMsg(message: QueryAllocationMeterRequestProtoMsg): QueryAllocationMeterRequest;
    toProto(message: QueryAllocationMeterRequest): Uint8Array;
    toProtoMsg(message: QueryAllocationMeterRequest): QueryAllocationMeterRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryAllocationMeterResponse: {
    typeUrl: string;
    is(o: any): o is QueryAllocationMeterResponse;
    isSDK(o: any): o is QueryAllocationMeterResponseSDKType;
    isAmino(o: any): o is QueryAllocationMeterResponseAmino;
    encode(message: QueryAllocationMeterResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryAllocationMeterResponse;
    fromJSON(object: any): QueryAllocationMeterResponse;
    toJSON(message: QueryAllocationMeterResponse): JsonSafe<QueryAllocationMeterResponse>;
    fromPartial(object: DeepPartial<QueryAllocationMeterResponse>): QueryAllocationMeterResponse;
    fromSDK(object: QueryAllocationMeterResponseSDKType): QueryAllocationMeterResponse;
    fromSDKJSON(object: any): QueryAllocationMeterResponseSDKType;
    toSDK(message: QueryAllocationMeterResponse): QueryAllocationMeterResponseSDKType;
    fromAmino(object: QueryAllocationMeterResponseAmino): QueryAllocationMeterResponse;
    toAmino(message: QueryAllocationMeterResponse): QueryAllocationMeterResponseAmino;
    fromAminoMsg(object: QueryAllocationMeterResponseAminoMsg): QueryAllocationMeterResponse;
    fromProtoMsg(message: QueryAllocationMeterResponseProtoMsg): QueryAllocationMeterResponse;
    toProto(message: QueryAllocationMeterResponse): Uint8Array;
    toProtoMsg(message: QueryAllocationMeterResponse): QueryAllocationMeterResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryParamsRequest: {
    typeUrl: string;
    is(o: any): o is QueryParamsRequest;
    isSDK(o: any): o is QueryParamsRequestSDKType;
    isAmino(o: any): o is QueryParamsRequestAmino;
    encode(_: QueryParamsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryParamsRequest;
    fromJSON(_: any): QueryParamsRequest;
    toJSON(_: QueryParamsRequest): JsonSafe<QueryParamsRequest>;
    fromPartial(_: DeepPartial<QueryParamsRequest>): QueryParamsRequest;
    fromSDK(_: QueryParamsRequestSDKType): QueryParamsRequest;
    fromSDKJSON(_: any): QueryParamsRequestSDKType;
    toSDK(_: QueryParamsRequest): QueryParamsRequestSDKType;
    fromAmino(_: QueryParamsRequestAmino): QueryParamsRequest;
    toAmino(_: QueryParamsRequest): QueryParamsRequestAmino;
    fromAminoMsg(object: QueryParamsRequestAminoMsg): QueryParamsRequest;
    fromProtoMsg(message: QueryParamsRequestProtoMsg): QueryParamsRequest;
    toProto(message: QueryParamsRequest): Uint8Array;
    toProtoMsg(message: QueryParamsRequest): QueryParamsRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryParamsResponse: {
    typeUrl: string;
    is(o: any): o is QueryParamsResponse;
    isSDK(o: any): o is QueryParamsResponseSDKType;
    isAmino(o: any): o is QueryParamsResponseAmino;
    encode(message: QueryParamsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryParamsResponse;
    fromJSON(object: any): QueryParamsResponse;
    toJSON(message: QueryParamsResponse): JsonSafe<QueryParamsResponse>;
    fromPartial(object: DeepPartial<QueryParamsResponse>): QueryParamsResponse;
    fromSDK(object: QueryParamsResponseSDKType): QueryParamsResponse;
    fromSDKJSON(object: any): QueryParamsResponseSDKType;
    toSDK(message: QueryParamsResponse): QueryParamsResponseSDKType;
    fromAmino(object: QueryParamsResponseAmino): QueryParamsResponse;
    toAmino(message: QueryParamsResponse): QueryParamsResponseAmino;
    fromAminoMsg(object: QueryParamsResponseAminoMsg): QueryParamsResponse;
    fromProtoMsg(message: QueryParamsResponseProtoMsg): QueryParamsResponse;
    toProto(message: QueryParamsResponse): Uint8Array;
    toProtoMsg(message: QueryParamsResponse): QueryParamsResponseProtoMsg;
    registerTypeUrl(): void;
};
