import { PageRequest, PageResponse } from "../../../cosmos/base/query/v1beta1/pagination";
import { Incentive, GasMeter } from "./incentives";
import { DecCoin } from "../../../cosmos/base/v1beta1/coin";
import { Params } from "./genesis";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
export const protobufPackage = "evmos.incentives.v1";
function createBaseQueryIncentivesRequest() {
    return {
        pagination: undefined
    };
}
export const QueryIncentivesRequest = {
    typeUrl: "/evmos.incentives.v1.QueryIncentivesRequest",
    is(o) {
        return o && o.$typeUrl === QueryIncentivesRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryIncentivesRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryIncentivesRequest.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryIncentivesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryIncentivesRequest();
        if (isSet(object.pagination))
            obj.pagination = PageRequest.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryIncentivesRequest();
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            pagination: object.pagination ? PageRequest.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            pagination: isSet(object.pagination) ? PageRequest.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryIncentivesRequest();
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.pagination = message.pagination ? PageRequest.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryIncentivesRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryIncentivesRequest.decode(message.value);
    },
    toProto(message) {
        return QueryIncentivesRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.QueryIncentivesRequest",
            value: QueryIncentivesRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        PageRequest.registerTypeUrl();
    }
};
function createBaseQueryIncentivesResponse() {
    return {
        incentives: [],
        pagination: undefined
    };
}
export const QueryIncentivesResponse = {
    typeUrl: "/evmos.incentives.v1.QueryIncentivesResponse",
    is(o) {
        return o && (o.$typeUrl === QueryIncentivesResponse.typeUrl || Array.isArray(o.incentives) && (!o.incentives.length || Incentive.is(o.incentives[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryIncentivesResponse.typeUrl || Array.isArray(o.incentives) && (!o.incentives.length || Incentive.isSDK(o.incentives[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryIncentivesResponse.typeUrl || Array.isArray(o.incentives) && (!o.incentives.length || Incentive.isAmino(o.incentives[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.incentives) {
            Incentive.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryIncentivesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.incentives.push(Incentive.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryIncentivesResponse();
        if (Array.isArray(object?.incentives))
            obj.incentives = object.incentives.map((e) => Incentive.fromJSON(e));
        if (isSet(object.pagination))
            obj.pagination = PageResponse.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.incentives) {
            obj.incentives = message.incentives.map(e => e ? Incentive.toJSON(e) : undefined);
        }
        else {
            obj.incentives = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryIncentivesResponse();
        message.incentives = object.incentives?.map(e => Incentive.fromPartial(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            incentives: Array.isArray(object?.incentives) ? object.incentives.map((e) => Incentive.fromSDK(e)) : [],
            pagination: object.pagination ? PageResponse.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            incentives: Array.isArray(object?.incentives) ? object.incentives.map((e) => Incentive.fromSDKJSON(e)) : [],
            pagination: isSet(object.pagination) ? PageResponse.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.incentives) {
            obj.incentives = message.incentives.map(e => e ? Incentive.toSDK(e) : undefined);
        }
        else {
            obj.incentives = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryIncentivesResponse();
        message.incentives = object.incentives?.map(e => Incentive.fromAmino(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.incentives) {
            obj.incentives = message.incentives.map(e => e ? Incentive.toAmino(e) : undefined);
        }
        else {
            obj.incentives = message.incentives;
        }
        obj.pagination = message.pagination ? PageResponse.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryIncentivesResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryIncentivesResponse.decode(message.value);
    },
    toProto(message) {
        return QueryIncentivesResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.QueryIncentivesResponse",
            value: QueryIncentivesResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Incentive.registerTypeUrl();
        PageResponse.registerTypeUrl();
    }
};
function createBaseQueryIncentiveRequest() {
    return {
        contract: ""
    };
}
export const QueryIncentiveRequest = {
    typeUrl: "/evmos.incentives.v1.QueryIncentiveRequest",
    is(o) {
        return o && (o.$typeUrl === QueryIncentiveRequest.typeUrl || typeof o.contract === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryIncentiveRequest.typeUrl || typeof o.contract === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryIncentiveRequest.typeUrl || typeof o.contract === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.contract !== undefined) {
            writer.uint32(10).string(message.contract);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryIncentiveRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.contract = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryIncentiveRequest();
        if (isSet(object.contract))
            obj.contract = String(object.contract);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.contract !== undefined && (obj.contract = message.contract);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryIncentiveRequest();
        message.contract = object.contract ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            contract: object?.contract
        };
    },
    fromSDKJSON(object) {
        return {
            contract: isSet(object.contract) ? String(object.contract) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.contract = message.contract;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryIncentiveRequest();
        if (object.contract !== undefined && object.contract !== null) {
            message.contract = object.contract;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.contract = message.contract === "" ? undefined : message.contract;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryIncentiveRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryIncentiveRequest.decode(message.value);
    },
    toProto(message) {
        return QueryIncentiveRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.QueryIncentiveRequest",
            value: QueryIncentiveRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryIncentiveResponse() {
    return {
        incentive: Incentive.fromPartial({})
    };
}
export const QueryIncentiveResponse = {
    typeUrl: "/evmos.incentives.v1.QueryIncentiveResponse",
    is(o) {
        return o && (o.$typeUrl === QueryIncentiveResponse.typeUrl || Incentive.is(o.incentive));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryIncentiveResponse.typeUrl || Incentive.isSDK(o.incentive));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryIncentiveResponse.typeUrl || Incentive.isAmino(o.incentive));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.incentive !== undefined) {
            Incentive.encode(message.incentive, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryIncentiveResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.incentive = Incentive.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryIncentiveResponse();
        if (isSet(object.incentive))
            obj.incentive = Incentive.fromJSON(object.incentive);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.incentive !== undefined && (obj.incentive = message.incentive ? Incentive.toJSON(message.incentive) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryIncentiveResponse();
        if (object.incentive !== undefined && object.incentive !== null) {
            message.incentive = Incentive.fromPartial(object.incentive);
        }
        return message;
    },
    fromSDK(object) {
        return {
            incentive: object.incentive ? Incentive.fromSDK(object.incentive) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            incentive: isSet(object.incentive) ? Incentive.fromSDKJSON(object.incentive) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.incentive !== undefined && (obj.incentive = message.incentive ? Incentive.toSDK(message.incentive) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryIncentiveResponse();
        if (object.incentive !== undefined && object.incentive !== null) {
            message.incentive = Incentive.fromAmino(object.incentive);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.incentive = message.incentive ? Incentive.toAmino(message.incentive) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryIncentiveResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryIncentiveResponse.decode(message.value);
    },
    toProto(message) {
        return QueryIncentiveResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.QueryIncentiveResponse",
            value: QueryIncentiveResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Incentive.registerTypeUrl();
    }
};
function createBaseQueryGasMetersRequest() {
    return {
        contract: "",
        pagination: undefined
    };
}
export const QueryGasMetersRequest = {
    typeUrl: "/evmos.incentives.v1.QueryGasMetersRequest",
    is(o) {
        return o && (o.$typeUrl === QueryGasMetersRequest.typeUrl || typeof o.contract === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryGasMetersRequest.typeUrl || typeof o.contract === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryGasMetersRequest.typeUrl || typeof o.contract === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.contract !== undefined) {
            writer.uint32(10).string(message.contract);
        }
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGasMetersRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.contract = reader.string();
                    break;
                case 2:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryGasMetersRequest();
        if (isSet(object.contract))
            obj.contract = String(object.contract);
        if (isSet(object.pagination))
            obj.pagination = PageRequest.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.contract !== undefined && (obj.contract = message.contract);
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryGasMetersRequest();
        message.contract = object.contract ?? "";
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            contract: object?.contract,
            pagination: object.pagination ? PageRequest.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            contract: isSet(object.contract) ? String(object.contract) : "",
            pagination: isSet(object.pagination) ? PageRequest.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.contract = message.contract;
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryGasMetersRequest();
        if (object.contract !== undefined && object.contract !== null) {
            message.contract = object.contract;
        }
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.contract = message.contract === "" ? undefined : message.contract;
        obj.pagination = message.pagination ? PageRequest.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryGasMetersRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryGasMetersRequest.decode(message.value);
    },
    toProto(message) {
        return QueryGasMetersRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.QueryGasMetersRequest",
            value: QueryGasMetersRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        PageRequest.registerTypeUrl();
    }
};
function createBaseQueryGasMetersResponse() {
    return {
        gasMeters: [],
        pagination: undefined
    };
}
export const QueryGasMetersResponse = {
    typeUrl: "/evmos.incentives.v1.QueryGasMetersResponse",
    is(o) {
        return o && (o.$typeUrl === QueryGasMetersResponse.typeUrl || Array.isArray(o.gasMeters) && (!o.gasMeters.length || GasMeter.is(o.gasMeters[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryGasMetersResponse.typeUrl || Array.isArray(o.gas_meters) && (!o.gas_meters.length || GasMeter.isSDK(o.gas_meters[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryGasMetersResponse.typeUrl || Array.isArray(o.gas_meters) && (!o.gas_meters.length || GasMeter.isAmino(o.gas_meters[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.gasMeters) {
            GasMeter.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGasMetersResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.gasMeters.push(GasMeter.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryGasMetersResponse();
        if (Array.isArray(object?.gasMeters))
            obj.gasMeters = object.gasMeters.map((e) => GasMeter.fromJSON(e));
        if (isSet(object.pagination))
            obj.pagination = PageResponse.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.gasMeters) {
            obj.gasMeters = message.gasMeters.map(e => e ? GasMeter.toJSON(e) : undefined);
        }
        else {
            obj.gasMeters = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryGasMetersResponse();
        message.gasMeters = object.gasMeters?.map(e => GasMeter.fromPartial(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            gasMeters: Array.isArray(object?.gas_meters) ? object.gas_meters.map((e) => GasMeter.fromSDK(e)) : [],
            pagination: object.pagination ? PageResponse.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            gas_meters: Array.isArray(object?.gas_meters) ? object.gas_meters.map((e) => GasMeter.fromSDKJSON(e)) : [],
            pagination: isSet(object.pagination) ? PageResponse.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.gasMeters) {
            obj.gas_meters = message.gasMeters.map(e => e ? GasMeter.toSDK(e) : undefined);
        }
        else {
            obj.gas_meters = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryGasMetersResponse();
        message.gasMeters = object.gas_meters?.map(e => GasMeter.fromAmino(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.gasMeters) {
            obj.gas_meters = message.gasMeters.map(e => e ? GasMeter.toAmino(e) : undefined);
        }
        else {
            obj.gas_meters = message.gasMeters;
        }
        obj.pagination = message.pagination ? PageResponse.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryGasMetersResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryGasMetersResponse.decode(message.value);
    },
    toProto(message) {
        return QueryGasMetersResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.QueryGasMetersResponse",
            value: QueryGasMetersResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        GasMeter.registerTypeUrl();
        PageResponse.registerTypeUrl();
    }
};
function createBaseQueryGasMeterRequest() {
    return {
        contract: "",
        participant: ""
    };
}
export const QueryGasMeterRequest = {
    typeUrl: "/evmos.incentives.v1.QueryGasMeterRequest",
    is(o) {
        return o && (o.$typeUrl === QueryGasMeterRequest.typeUrl || typeof o.contract === "string" && typeof o.participant === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryGasMeterRequest.typeUrl || typeof o.contract === "string" && typeof o.participant === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryGasMeterRequest.typeUrl || typeof o.contract === "string" && typeof o.participant === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.contract !== undefined) {
            writer.uint32(10).string(message.contract);
        }
        if (message.participant !== undefined) {
            writer.uint32(18).string(message.participant);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGasMeterRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.contract = reader.string();
                    break;
                case 2:
                    message.participant = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryGasMeterRequest();
        if (isSet(object.contract))
            obj.contract = String(object.contract);
        if (isSet(object.participant))
            obj.participant = String(object.participant);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.contract !== undefined && (obj.contract = message.contract);
        message.participant !== undefined && (obj.participant = message.participant);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryGasMeterRequest();
        message.contract = object.contract ?? "";
        message.participant = object.participant ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            contract: object?.contract,
            participant: object?.participant
        };
    },
    fromSDKJSON(object) {
        return {
            contract: isSet(object.contract) ? String(object.contract) : "",
            participant: isSet(object.participant) ? String(object.participant) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.contract = message.contract;
        obj.participant = message.participant;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryGasMeterRequest();
        if (object.contract !== undefined && object.contract !== null) {
            message.contract = object.contract;
        }
        if (object.participant !== undefined && object.participant !== null) {
            message.participant = object.participant;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.contract = message.contract === "" ? undefined : message.contract;
        obj.participant = message.participant === "" ? undefined : message.participant;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryGasMeterRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryGasMeterRequest.decode(message.value);
    },
    toProto(message) {
        return QueryGasMeterRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.QueryGasMeterRequest",
            value: QueryGasMeterRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryGasMeterResponse() {
    return {
        gasMeter: BigInt(0)
    };
}
export const QueryGasMeterResponse = {
    typeUrl: "/evmos.incentives.v1.QueryGasMeterResponse",
    is(o) {
        return o && (o.$typeUrl === QueryGasMeterResponse.typeUrl || typeof o.gasMeter === "bigint");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryGasMeterResponse.typeUrl || typeof o.gas_meter === "bigint");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryGasMeterResponse.typeUrl || typeof o.gas_meter === "bigint");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.gasMeter !== undefined) {
            writer.uint32(8).uint64(message.gasMeter);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryGasMeterResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.gasMeter = reader.uint64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryGasMeterResponse();
        if (isSet(object.gasMeter))
            obj.gasMeter = BigInt(object.gasMeter.toString());
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.gasMeter !== undefined && (obj.gasMeter = (message.gasMeter || BigInt(0)).toString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryGasMeterResponse();
        if (object.gasMeter !== undefined && object.gasMeter !== null) {
            message.gasMeter = BigInt(object.gasMeter.toString());
        }
        return message;
    },
    fromSDK(object) {
        return {
            gasMeter: object?.gas_meter
        };
    },
    fromSDKJSON(object) {
        return {
            gas_meter: isSet(object.gas_meter) ? BigInt(object.gas_meter.toString()) : BigInt(0)
        };
    },
    toSDK(message) {
        const obj = {};
        obj.gas_meter = message.gasMeter;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryGasMeterResponse();
        if (object.gas_meter !== undefined && object.gas_meter !== null) {
            message.gasMeter = BigInt(object.gas_meter);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.gas_meter = message.gasMeter !== BigInt(0) ? message.gasMeter?.toString() : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryGasMeterResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryGasMeterResponse.decode(message.value);
    },
    toProto(message) {
        return QueryGasMeterResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.QueryGasMeterResponse",
            value: QueryGasMeterResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryAllocationMetersRequest() {
    return {
        pagination: undefined
    };
}
export const QueryAllocationMetersRequest = {
    typeUrl: "/evmos.incentives.v1.QueryAllocationMetersRequest",
    is(o) {
        return o && o.$typeUrl === QueryAllocationMetersRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryAllocationMetersRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryAllocationMetersRequest.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.pagination !== undefined) {
            PageRequest.encode(message.pagination, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryAllocationMetersRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.pagination = PageRequest.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryAllocationMetersRequest();
        if (isSet(object.pagination))
            obj.pagination = PageRequest.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryAllocationMetersRequest();
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            pagination: object.pagination ? PageRequest.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            pagination: isSet(object.pagination) ? PageRequest.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageRequest.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryAllocationMetersRequest();
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageRequest.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.pagination = message.pagination ? PageRequest.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryAllocationMetersRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryAllocationMetersRequest.decode(message.value);
    },
    toProto(message) {
        return QueryAllocationMetersRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.QueryAllocationMetersRequest",
            value: QueryAllocationMetersRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        PageRequest.registerTypeUrl();
    }
};
function createBaseQueryAllocationMetersResponse() {
    return {
        allocationMeters: [],
        pagination: undefined
    };
}
export const QueryAllocationMetersResponse = {
    typeUrl: "/evmos.incentives.v1.QueryAllocationMetersResponse",
    is(o) {
        return o && (o.$typeUrl === QueryAllocationMetersResponse.typeUrl || Array.isArray(o.allocationMeters) && (!o.allocationMeters.length || DecCoin.is(o.allocationMeters[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryAllocationMetersResponse.typeUrl || Array.isArray(o.allocation_meters) && (!o.allocation_meters.length || DecCoin.isSDK(o.allocation_meters[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryAllocationMetersResponse.typeUrl || Array.isArray(o.allocation_meters) && (!o.allocation_meters.length || DecCoin.isAmino(o.allocation_meters[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.allocationMeters) {
            DecCoin.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.pagination !== undefined) {
            PageResponse.encode(message.pagination, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryAllocationMetersResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.allocationMeters.push(DecCoin.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.pagination = PageResponse.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryAllocationMetersResponse();
        if (Array.isArray(object?.allocationMeters))
            obj.allocationMeters = object.allocationMeters.map((e) => DecCoin.fromJSON(e));
        if (isSet(object.pagination))
            obj.pagination = PageResponse.fromJSON(object.pagination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.allocationMeters) {
            obj.allocationMeters = message.allocationMeters.map(e => e ? DecCoin.toJSON(e) : undefined);
        }
        else {
            obj.allocationMeters = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toJSON(message.pagination) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryAllocationMetersResponse();
        message.allocationMeters = object.allocationMeters?.map(e => DecCoin.fromPartial(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromPartial(object.pagination);
        }
        return message;
    },
    fromSDK(object) {
        return {
            allocationMeters: Array.isArray(object?.allocation_meters) ? object.allocation_meters.map((e) => DecCoin.fromSDK(e)) : [],
            pagination: object.pagination ? PageResponse.fromSDK(object.pagination) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            allocation_meters: Array.isArray(object?.allocation_meters) ? object.allocation_meters.map((e) => DecCoin.fromSDKJSON(e)) : [],
            pagination: isSet(object.pagination) ? PageResponse.fromSDKJSON(object.pagination) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.allocationMeters) {
            obj.allocation_meters = message.allocationMeters.map(e => e ? DecCoin.toSDK(e) : undefined);
        }
        else {
            obj.allocation_meters = [];
        }
        message.pagination !== undefined && (obj.pagination = message.pagination ? PageResponse.toSDK(message.pagination) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryAllocationMetersResponse();
        message.allocationMeters = object.allocation_meters?.map(e => DecCoin.fromAmino(e)) || [];
        if (object.pagination !== undefined && object.pagination !== null) {
            message.pagination = PageResponse.fromAmino(object.pagination);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.allocationMeters) {
            obj.allocation_meters = message.allocationMeters.map(e => e ? DecCoin.toAmino(e) : undefined);
        }
        else {
            obj.allocation_meters = message.allocationMeters;
        }
        obj.pagination = message.pagination ? PageResponse.toAmino(message.pagination) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryAllocationMetersResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryAllocationMetersResponse.decode(message.value);
    },
    toProto(message) {
        return QueryAllocationMetersResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.QueryAllocationMetersResponse",
            value: QueryAllocationMetersResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        DecCoin.registerTypeUrl();
        PageResponse.registerTypeUrl();
    }
};
function createBaseQueryAllocationMeterRequest() {
    return {
        denom: ""
    };
}
export const QueryAllocationMeterRequest = {
    typeUrl: "/evmos.incentives.v1.QueryAllocationMeterRequest",
    is(o) {
        return o && (o.$typeUrl === QueryAllocationMeterRequest.typeUrl || typeof o.denom === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryAllocationMeterRequest.typeUrl || typeof o.denom === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryAllocationMeterRequest.typeUrl || typeof o.denom === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.denom !== undefined) {
            writer.uint32(10).string(message.denom);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryAllocationMeterRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.denom = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryAllocationMeterRequest();
        if (isSet(object.denom))
            obj.denom = String(object.denom);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.denom !== undefined && (obj.denom = message.denom);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryAllocationMeterRequest();
        message.denom = object.denom ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            denom: object?.denom
        };
    },
    fromSDKJSON(object) {
        return {
            denom: isSet(object.denom) ? String(object.denom) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.denom = message.denom;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryAllocationMeterRequest();
        if (object.denom !== undefined && object.denom !== null) {
            message.denom = object.denom;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.denom = message.denom === "" ? undefined : message.denom;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryAllocationMeterRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryAllocationMeterRequest.decode(message.value);
    },
    toProto(message) {
        return QueryAllocationMeterRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.QueryAllocationMeterRequest",
            value: QueryAllocationMeterRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryAllocationMeterResponse() {
    return {
        allocationMeter: DecCoin.fromPartial({})
    };
}
export const QueryAllocationMeterResponse = {
    typeUrl: "/evmos.incentives.v1.QueryAllocationMeterResponse",
    is(o) {
        return o && (o.$typeUrl === QueryAllocationMeterResponse.typeUrl || DecCoin.is(o.allocationMeter));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryAllocationMeterResponse.typeUrl || DecCoin.isSDK(o.allocation_meter));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryAllocationMeterResponse.typeUrl || DecCoin.isAmino(o.allocation_meter));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.allocationMeter !== undefined) {
            DecCoin.encode(message.allocationMeter, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryAllocationMeterResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.allocationMeter = DecCoin.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryAllocationMeterResponse();
        if (isSet(object.allocationMeter))
            obj.allocationMeter = DecCoin.fromJSON(object.allocationMeter);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.allocationMeter !== undefined && (obj.allocationMeter = message.allocationMeter ? DecCoin.toJSON(message.allocationMeter) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryAllocationMeterResponse();
        if (object.allocationMeter !== undefined && object.allocationMeter !== null) {
            message.allocationMeter = DecCoin.fromPartial(object.allocationMeter);
        }
        return message;
    },
    fromSDK(object) {
        return {
            allocationMeter: object.allocation_meter ? DecCoin.fromSDK(object.allocation_meter) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            allocation_meter: isSet(object.allocation_meter) ? DecCoin.fromSDKJSON(object.allocation_meter) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.allocationMeter !== undefined && (obj.allocation_meter = message.allocationMeter ? DecCoin.toSDK(message.allocationMeter) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryAllocationMeterResponse();
        if (object.allocation_meter !== undefined && object.allocation_meter !== null) {
            message.allocationMeter = DecCoin.fromAmino(object.allocation_meter);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.allocation_meter = message.allocationMeter ? DecCoin.toAmino(message.allocationMeter) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryAllocationMeterResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryAllocationMeterResponse.decode(message.value);
    },
    toProto(message) {
        return QueryAllocationMeterResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.QueryAllocationMeterResponse",
            value: QueryAllocationMeterResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        DecCoin.registerTypeUrl();
    }
};
function createBaseQueryParamsRequest() {
    return {};
}
export const QueryParamsRequest = {
    typeUrl: "/evmos.incentives.v1.QueryParamsRequest",
    is(o) {
        return o && o.$typeUrl === QueryParamsRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryParamsRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryParamsRequest.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParamsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseQueryParamsRequest();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseQueryParamsRequest();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseQueryParamsRequest();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return QueryParamsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryParamsRequest.decode(message.value);
    },
    toProto(message) {
        return QueryParamsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.QueryParamsRequest",
            value: QueryParamsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryParamsResponse() {
    return {
        params: Params.fromPartial({})
    };
}
export const QueryParamsResponse = {
    typeUrl: "/evmos.incentives.v1.QueryParamsResponse",
    is(o) {
        return o && (o.$typeUrl === QueryParamsResponse.typeUrl || Params.is(o.params));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryParamsResponse.typeUrl || Params.isSDK(o.params));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryParamsResponse.typeUrl || Params.isAmino(o.params));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.params !== undefined) {
            Params.encode(message.params, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParamsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.params = Params.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryParamsResponse();
        if (isSet(object.params))
            obj.params = Params.fromJSON(object.params);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryParamsResponse();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromPartial(object.params);
        }
        return message;
    },
    fromSDK(object) {
        return {
            params: object.params ? Params.fromSDK(object.params) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            params: isSet(object.params) ? Params.fromSDKJSON(object.params) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toSDK(message.params) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryParamsResponse();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromAmino(object.params);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.params = message.params ? Params.toAmino(message.params) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryParamsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryParamsResponse.decode(message.value);
    },
    toProto(message) {
        return QueryParamsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.incentives.v1.QueryParamsResponse",
            value: QueryParamsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Params.registerTypeUrl();
    }
};
