import { DecCoin, DecCoinAmino, DecCoinSDKType } from "../../../cosmos/base/v1beta1/coin";
import { Params, ParamsAmino, ParamsSDKType } from "./genesis";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { JsonSafe } from "../../../json-safe";
import { DeepPartial } from "../../../helpers";
export declare const protobufPackage = "evmos.inflation.v1";
/** QueryPeriodRequest is the request type for the Query/Period RPC method. */
export interface QueryPeriodRequest {
}
export interface QueryPeriodRequestProtoMsg {
    typeUrl: "/evmos.inflation.v1.QueryPeriodRequest";
    value: Uint8Array;
}
/** QueryPeriodRequest is the request type for the Query/Period RPC method. */
export interface QueryPeriodRequestAmino {
}
export interface QueryPeriodRequestAminoMsg {
    type: "/evmos.inflation.v1.QueryPeriodRequest";
    value: QueryPeriodRequestAmino;
}
/** QueryPeriodRequest is the request type for the Query/Period RPC method. */
export interface QueryPeriodRequestSDKType {
}
/** QueryPeriodResponse is the response type for the Query/Period RPC method. */
export interface QueryPeriodResponse {
    /** period is the current minting per epoch provision value. */
    period: bigint;
}
export interface QueryPeriodResponseProtoMsg {
    typeUrl: "/evmos.inflation.v1.QueryPeriodResponse";
    value: Uint8Array;
}
/** QueryPeriodResponse is the response type for the Query/Period RPC method. */
export interface QueryPeriodResponseAmino {
    /** period is the current minting per epoch provision value. */
    period?: string;
}
export interface QueryPeriodResponseAminoMsg {
    type: "/evmos.inflation.v1.QueryPeriodResponse";
    value: QueryPeriodResponseAmino;
}
/** QueryPeriodResponse is the response type for the Query/Period RPC method. */
export interface QueryPeriodResponseSDKType {
    period: bigint;
}
/**
 * QueryEpochMintProvisionRequest is the request type for the
 * Query/EpochMintProvision RPC method.
 */
export interface QueryEpochMintProvisionRequest {
}
export interface QueryEpochMintProvisionRequestProtoMsg {
    typeUrl: "/evmos.inflation.v1.QueryEpochMintProvisionRequest";
    value: Uint8Array;
}
/**
 * QueryEpochMintProvisionRequest is the request type for the
 * Query/EpochMintProvision RPC method.
 */
export interface QueryEpochMintProvisionRequestAmino {
}
export interface QueryEpochMintProvisionRequestAminoMsg {
    type: "/evmos.inflation.v1.QueryEpochMintProvisionRequest";
    value: QueryEpochMintProvisionRequestAmino;
}
/**
 * QueryEpochMintProvisionRequest is the request type for the
 * Query/EpochMintProvision RPC method.
 */
export interface QueryEpochMintProvisionRequestSDKType {
}
/**
 * QueryEpochMintProvisionResponse is the response type for the
 * Query/EpochMintProvision RPC method.
 */
export interface QueryEpochMintProvisionResponse {
    /** epoch_mint_provision is the current minting per epoch provision value. */
    epochMintProvision: DecCoin;
}
export interface QueryEpochMintProvisionResponseProtoMsg {
    typeUrl: "/evmos.inflation.v1.QueryEpochMintProvisionResponse";
    value: Uint8Array;
}
/**
 * QueryEpochMintProvisionResponse is the response type for the
 * Query/EpochMintProvision RPC method.
 */
export interface QueryEpochMintProvisionResponseAmino {
    /** epoch_mint_provision is the current minting per epoch provision value. */
    epoch_mint_provision?: DecCoinAmino;
}
export interface QueryEpochMintProvisionResponseAminoMsg {
    type: "/evmos.inflation.v1.QueryEpochMintProvisionResponse";
    value: QueryEpochMintProvisionResponseAmino;
}
/**
 * QueryEpochMintProvisionResponse is the response type for the
 * Query/EpochMintProvision RPC method.
 */
export interface QueryEpochMintProvisionResponseSDKType {
    epoch_mint_provision: DecCoinSDKType;
}
/**
 * QuerySkippedEpochsRequest is the request type for the Query/SkippedEpochs RPC
 * method.
 */
export interface QuerySkippedEpochsRequest {
}
export interface QuerySkippedEpochsRequestProtoMsg {
    typeUrl: "/evmos.inflation.v1.QuerySkippedEpochsRequest";
    value: Uint8Array;
}
/**
 * QuerySkippedEpochsRequest is the request type for the Query/SkippedEpochs RPC
 * method.
 */
export interface QuerySkippedEpochsRequestAmino {
}
export interface QuerySkippedEpochsRequestAminoMsg {
    type: "/evmos.inflation.v1.QuerySkippedEpochsRequest";
    value: QuerySkippedEpochsRequestAmino;
}
/**
 * QuerySkippedEpochsRequest is the request type for the Query/SkippedEpochs RPC
 * method.
 */
export interface QuerySkippedEpochsRequestSDKType {
}
/**
 * QuerySkippedEpochsResponse is the response type for the Query/SkippedEpochs
 * RPC method.
 */
export interface QuerySkippedEpochsResponse {
    /** number of epochs that the inflation module has been disabled. */
    skippedEpochs: bigint;
}
export interface QuerySkippedEpochsResponseProtoMsg {
    typeUrl: "/evmos.inflation.v1.QuerySkippedEpochsResponse";
    value: Uint8Array;
}
/**
 * QuerySkippedEpochsResponse is the response type for the Query/SkippedEpochs
 * RPC method.
 */
export interface QuerySkippedEpochsResponseAmino {
    /** number of epochs that the inflation module has been disabled. */
    skipped_epochs?: string;
}
export interface QuerySkippedEpochsResponseAminoMsg {
    type: "/evmos.inflation.v1.QuerySkippedEpochsResponse";
    value: QuerySkippedEpochsResponseAmino;
}
/**
 * QuerySkippedEpochsResponse is the response type for the Query/SkippedEpochs
 * RPC method.
 */
export interface QuerySkippedEpochsResponseSDKType {
    skipped_epochs: bigint;
}
/**
 * QueryCirculatingSupplyRequest is the request type for the
 * Query/CirculatingSupply RPC method.
 */
export interface QueryCirculatingSupplyRequest {
}
export interface QueryCirculatingSupplyRequestProtoMsg {
    typeUrl: "/evmos.inflation.v1.QueryCirculatingSupplyRequest";
    value: Uint8Array;
}
/**
 * QueryCirculatingSupplyRequest is the request type for the
 * Query/CirculatingSupply RPC method.
 */
export interface QueryCirculatingSupplyRequestAmino {
}
export interface QueryCirculatingSupplyRequestAminoMsg {
    type: "/evmos.inflation.v1.QueryCirculatingSupplyRequest";
    value: QueryCirculatingSupplyRequestAmino;
}
/**
 * QueryCirculatingSupplyRequest is the request type for the
 * Query/CirculatingSupply RPC method.
 */
export interface QueryCirculatingSupplyRequestSDKType {
}
/**
 * QueryCirculatingSupplyResponse is the response type for the
 * Query/CirculatingSupply RPC method.
 */
export interface QueryCirculatingSupplyResponse {
    /** total amount of coins in circulation */
    circulatingSupply: DecCoin;
}
export interface QueryCirculatingSupplyResponseProtoMsg {
    typeUrl: "/evmos.inflation.v1.QueryCirculatingSupplyResponse";
    value: Uint8Array;
}
/**
 * QueryCirculatingSupplyResponse is the response type for the
 * Query/CirculatingSupply RPC method.
 */
export interface QueryCirculatingSupplyResponseAmino {
    /** total amount of coins in circulation */
    circulating_supply?: DecCoinAmino;
}
export interface QueryCirculatingSupplyResponseAminoMsg {
    type: "/evmos.inflation.v1.QueryCirculatingSupplyResponse";
    value: QueryCirculatingSupplyResponseAmino;
}
/**
 * QueryCirculatingSupplyResponse is the response type for the
 * Query/CirculatingSupply RPC method.
 */
export interface QueryCirculatingSupplyResponseSDKType {
    circulating_supply: DecCoinSDKType;
}
/**
 * QueryInflationRateRequest is the request type for the Query/InflationRate RPC
 * method.
 */
export interface QueryInflationRateRequest {
}
export interface QueryInflationRateRequestProtoMsg {
    typeUrl: "/evmos.inflation.v1.QueryInflationRateRequest";
    value: Uint8Array;
}
/**
 * QueryInflationRateRequest is the request type for the Query/InflationRate RPC
 * method.
 */
export interface QueryInflationRateRequestAmino {
}
export interface QueryInflationRateRequestAminoMsg {
    type: "/evmos.inflation.v1.QueryInflationRateRequest";
    value: QueryInflationRateRequestAmino;
}
/**
 * QueryInflationRateRequest is the request type for the Query/InflationRate RPC
 * method.
 */
export interface QueryInflationRateRequestSDKType {
}
/**
 * QueryInflationRateResponse is the response type for the Query/InflationRate
 * RPC method.
 */
export interface QueryInflationRateResponse {
    /** rate by which the total supply increases within one period */
    inflationRate: string;
}
export interface QueryInflationRateResponseProtoMsg {
    typeUrl: "/evmos.inflation.v1.QueryInflationRateResponse";
    value: Uint8Array;
}
/**
 * QueryInflationRateResponse is the response type for the Query/InflationRate
 * RPC method.
 */
export interface QueryInflationRateResponseAmino {
    /** rate by which the total supply increases within one period */
    inflation_rate?: string;
}
export interface QueryInflationRateResponseAminoMsg {
    type: "/evmos.inflation.v1.QueryInflationRateResponse";
    value: QueryInflationRateResponseAmino;
}
/**
 * QueryInflationRateResponse is the response type for the Query/InflationRate
 * RPC method.
 */
export interface QueryInflationRateResponseSDKType {
    inflation_rate: string;
}
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequest {
}
export interface QueryParamsRequestProtoMsg {
    typeUrl: "/evmos.inflation.v1.QueryParamsRequest";
    value: Uint8Array;
}
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequestAmino {
}
export interface QueryParamsRequestAminoMsg {
    type: "/evmos.inflation.v1.QueryParamsRequest";
    value: QueryParamsRequestAmino;
}
/** QueryParamsRequest is the request type for the Query/Params RPC method. */
export interface QueryParamsRequestSDKType {
}
/** QueryParamsResponse is the response type for the Query/Params RPC method. */
export interface QueryParamsResponse {
    /** params defines the parameters of the module. */
    params: Params;
}
export interface QueryParamsResponseProtoMsg {
    typeUrl: "/evmos.inflation.v1.QueryParamsResponse";
    value: Uint8Array;
}
/** QueryParamsResponse is the response type for the Query/Params RPC method. */
export interface QueryParamsResponseAmino {
    /** params defines the parameters of the module. */
    params?: ParamsAmino;
}
export interface QueryParamsResponseAminoMsg {
    type: "/evmos.inflation.v1.QueryParamsResponse";
    value: QueryParamsResponseAmino;
}
/** QueryParamsResponse is the response type for the Query/Params RPC method. */
export interface QueryParamsResponseSDKType {
    params: ParamsSDKType;
}
export declare const QueryPeriodRequest: {
    typeUrl: string;
    is(o: any): o is QueryPeriodRequest;
    isSDK(o: any): o is QueryPeriodRequestSDKType;
    isAmino(o: any): o is QueryPeriodRequestAmino;
    encode(_: QueryPeriodRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryPeriodRequest;
    fromJSON(_: any): QueryPeriodRequest;
    toJSON(_: QueryPeriodRequest): JsonSafe<QueryPeriodRequest>;
    fromPartial(_: DeepPartial<QueryPeriodRequest>): QueryPeriodRequest;
    fromSDK(_: QueryPeriodRequestSDKType): QueryPeriodRequest;
    fromSDKJSON(_: any): QueryPeriodRequestSDKType;
    toSDK(_: QueryPeriodRequest): QueryPeriodRequestSDKType;
    fromAmino(_: QueryPeriodRequestAmino): QueryPeriodRequest;
    toAmino(_: QueryPeriodRequest): QueryPeriodRequestAmino;
    fromAminoMsg(object: QueryPeriodRequestAminoMsg): QueryPeriodRequest;
    fromProtoMsg(message: QueryPeriodRequestProtoMsg): QueryPeriodRequest;
    toProto(message: QueryPeriodRequest): Uint8Array;
    toProtoMsg(message: QueryPeriodRequest): QueryPeriodRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryPeriodResponse: {
    typeUrl: string;
    is(o: any): o is QueryPeriodResponse;
    isSDK(o: any): o is QueryPeriodResponseSDKType;
    isAmino(o: any): o is QueryPeriodResponseAmino;
    encode(message: QueryPeriodResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryPeriodResponse;
    fromJSON(object: any): QueryPeriodResponse;
    toJSON(message: QueryPeriodResponse): JsonSafe<QueryPeriodResponse>;
    fromPartial(object: DeepPartial<QueryPeriodResponse>): QueryPeriodResponse;
    fromSDK(object: QueryPeriodResponseSDKType): QueryPeriodResponse;
    fromSDKJSON(object: any): QueryPeriodResponseSDKType;
    toSDK(message: QueryPeriodResponse): QueryPeriodResponseSDKType;
    fromAmino(object: QueryPeriodResponseAmino): QueryPeriodResponse;
    toAmino(message: QueryPeriodResponse): QueryPeriodResponseAmino;
    fromAminoMsg(object: QueryPeriodResponseAminoMsg): QueryPeriodResponse;
    fromProtoMsg(message: QueryPeriodResponseProtoMsg): QueryPeriodResponse;
    toProto(message: QueryPeriodResponse): Uint8Array;
    toProtoMsg(message: QueryPeriodResponse): QueryPeriodResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryEpochMintProvisionRequest: {
    typeUrl: string;
    is(o: any): o is QueryEpochMintProvisionRequest;
    isSDK(o: any): o is QueryEpochMintProvisionRequestSDKType;
    isAmino(o: any): o is QueryEpochMintProvisionRequestAmino;
    encode(_: QueryEpochMintProvisionRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryEpochMintProvisionRequest;
    fromJSON(_: any): QueryEpochMintProvisionRequest;
    toJSON(_: QueryEpochMintProvisionRequest): JsonSafe<QueryEpochMintProvisionRequest>;
    fromPartial(_: DeepPartial<QueryEpochMintProvisionRequest>): QueryEpochMintProvisionRequest;
    fromSDK(_: QueryEpochMintProvisionRequestSDKType): QueryEpochMintProvisionRequest;
    fromSDKJSON(_: any): QueryEpochMintProvisionRequestSDKType;
    toSDK(_: QueryEpochMintProvisionRequest): QueryEpochMintProvisionRequestSDKType;
    fromAmino(_: QueryEpochMintProvisionRequestAmino): QueryEpochMintProvisionRequest;
    toAmino(_: QueryEpochMintProvisionRequest): QueryEpochMintProvisionRequestAmino;
    fromAminoMsg(object: QueryEpochMintProvisionRequestAminoMsg): QueryEpochMintProvisionRequest;
    fromProtoMsg(message: QueryEpochMintProvisionRequestProtoMsg): QueryEpochMintProvisionRequest;
    toProto(message: QueryEpochMintProvisionRequest): Uint8Array;
    toProtoMsg(message: QueryEpochMintProvisionRequest): QueryEpochMintProvisionRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryEpochMintProvisionResponse: {
    typeUrl: string;
    is(o: any): o is QueryEpochMintProvisionResponse;
    isSDK(o: any): o is QueryEpochMintProvisionResponseSDKType;
    isAmino(o: any): o is QueryEpochMintProvisionResponseAmino;
    encode(message: QueryEpochMintProvisionResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryEpochMintProvisionResponse;
    fromJSON(object: any): QueryEpochMintProvisionResponse;
    toJSON(message: QueryEpochMintProvisionResponse): JsonSafe<QueryEpochMintProvisionResponse>;
    fromPartial(object: DeepPartial<QueryEpochMintProvisionResponse>): QueryEpochMintProvisionResponse;
    fromSDK(object: QueryEpochMintProvisionResponseSDKType): QueryEpochMintProvisionResponse;
    fromSDKJSON(object: any): QueryEpochMintProvisionResponseSDKType;
    toSDK(message: QueryEpochMintProvisionResponse): QueryEpochMintProvisionResponseSDKType;
    fromAmino(object: QueryEpochMintProvisionResponseAmino): QueryEpochMintProvisionResponse;
    toAmino(message: QueryEpochMintProvisionResponse): QueryEpochMintProvisionResponseAmino;
    fromAminoMsg(object: QueryEpochMintProvisionResponseAminoMsg): QueryEpochMintProvisionResponse;
    fromProtoMsg(message: QueryEpochMintProvisionResponseProtoMsg): QueryEpochMintProvisionResponse;
    toProto(message: QueryEpochMintProvisionResponse): Uint8Array;
    toProtoMsg(message: QueryEpochMintProvisionResponse): QueryEpochMintProvisionResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QuerySkippedEpochsRequest: {
    typeUrl: string;
    is(o: any): o is QuerySkippedEpochsRequest;
    isSDK(o: any): o is QuerySkippedEpochsRequestSDKType;
    isAmino(o: any): o is QuerySkippedEpochsRequestAmino;
    encode(_: QuerySkippedEpochsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QuerySkippedEpochsRequest;
    fromJSON(_: any): QuerySkippedEpochsRequest;
    toJSON(_: QuerySkippedEpochsRequest): JsonSafe<QuerySkippedEpochsRequest>;
    fromPartial(_: DeepPartial<QuerySkippedEpochsRequest>): QuerySkippedEpochsRequest;
    fromSDK(_: QuerySkippedEpochsRequestSDKType): QuerySkippedEpochsRequest;
    fromSDKJSON(_: any): QuerySkippedEpochsRequestSDKType;
    toSDK(_: QuerySkippedEpochsRequest): QuerySkippedEpochsRequestSDKType;
    fromAmino(_: QuerySkippedEpochsRequestAmino): QuerySkippedEpochsRequest;
    toAmino(_: QuerySkippedEpochsRequest): QuerySkippedEpochsRequestAmino;
    fromAminoMsg(object: QuerySkippedEpochsRequestAminoMsg): QuerySkippedEpochsRequest;
    fromProtoMsg(message: QuerySkippedEpochsRequestProtoMsg): QuerySkippedEpochsRequest;
    toProto(message: QuerySkippedEpochsRequest): Uint8Array;
    toProtoMsg(message: QuerySkippedEpochsRequest): QuerySkippedEpochsRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QuerySkippedEpochsResponse: {
    typeUrl: string;
    is(o: any): o is QuerySkippedEpochsResponse;
    isSDK(o: any): o is QuerySkippedEpochsResponseSDKType;
    isAmino(o: any): o is QuerySkippedEpochsResponseAmino;
    encode(message: QuerySkippedEpochsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QuerySkippedEpochsResponse;
    fromJSON(object: any): QuerySkippedEpochsResponse;
    toJSON(message: QuerySkippedEpochsResponse): JsonSafe<QuerySkippedEpochsResponse>;
    fromPartial(object: DeepPartial<QuerySkippedEpochsResponse>): QuerySkippedEpochsResponse;
    fromSDK(object: QuerySkippedEpochsResponseSDKType): QuerySkippedEpochsResponse;
    fromSDKJSON(object: any): QuerySkippedEpochsResponseSDKType;
    toSDK(message: QuerySkippedEpochsResponse): QuerySkippedEpochsResponseSDKType;
    fromAmino(object: QuerySkippedEpochsResponseAmino): QuerySkippedEpochsResponse;
    toAmino(message: QuerySkippedEpochsResponse): QuerySkippedEpochsResponseAmino;
    fromAminoMsg(object: QuerySkippedEpochsResponseAminoMsg): QuerySkippedEpochsResponse;
    fromProtoMsg(message: QuerySkippedEpochsResponseProtoMsg): QuerySkippedEpochsResponse;
    toProto(message: QuerySkippedEpochsResponse): Uint8Array;
    toProtoMsg(message: QuerySkippedEpochsResponse): QuerySkippedEpochsResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryCirculatingSupplyRequest: {
    typeUrl: string;
    is(o: any): o is QueryCirculatingSupplyRequest;
    isSDK(o: any): o is QueryCirculatingSupplyRequestSDKType;
    isAmino(o: any): o is QueryCirculatingSupplyRequestAmino;
    encode(_: QueryCirculatingSupplyRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryCirculatingSupplyRequest;
    fromJSON(_: any): QueryCirculatingSupplyRequest;
    toJSON(_: QueryCirculatingSupplyRequest): JsonSafe<QueryCirculatingSupplyRequest>;
    fromPartial(_: DeepPartial<QueryCirculatingSupplyRequest>): QueryCirculatingSupplyRequest;
    fromSDK(_: QueryCirculatingSupplyRequestSDKType): QueryCirculatingSupplyRequest;
    fromSDKJSON(_: any): QueryCirculatingSupplyRequestSDKType;
    toSDK(_: QueryCirculatingSupplyRequest): QueryCirculatingSupplyRequestSDKType;
    fromAmino(_: QueryCirculatingSupplyRequestAmino): QueryCirculatingSupplyRequest;
    toAmino(_: QueryCirculatingSupplyRequest): QueryCirculatingSupplyRequestAmino;
    fromAminoMsg(object: QueryCirculatingSupplyRequestAminoMsg): QueryCirculatingSupplyRequest;
    fromProtoMsg(message: QueryCirculatingSupplyRequestProtoMsg): QueryCirculatingSupplyRequest;
    toProto(message: QueryCirculatingSupplyRequest): Uint8Array;
    toProtoMsg(message: QueryCirculatingSupplyRequest): QueryCirculatingSupplyRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryCirculatingSupplyResponse: {
    typeUrl: string;
    is(o: any): o is QueryCirculatingSupplyResponse;
    isSDK(o: any): o is QueryCirculatingSupplyResponseSDKType;
    isAmino(o: any): o is QueryCirculatingSupplyResponseAmino;
    encode(message: QueryCirculatingSupplyResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryCirculatingSupplyResponse;
    fromJSON(object: any): QueryCirculatingSupplyResponse;
    toJSON(message: QueryCirculatingSupplyResponse): JsonSafe<QueryCirculatingSupplyResponse>;
    fromPartial(object: DeepPartial<QueryCirculatingSupplyResponse>): QueryCirculatingSupplyResponse;
    fromSDK(object: QueryCirculatingSupplyResponseSDKType): QueryCirculatingSupplyResponse;
    fromSDKJSON(object: any): QueryCirculatingSupplyResponseSDKType;
    toSDK(message: QueryCirculatingSupplyResponse): QueryCirculatingSupplyResponseSDKType;
    fromAmino(object: QueryCirculatingSupplyResponseAmino): QueryCirculatingSupplyResponse;
    toAmino(message: QueryCirculatingSupplyResponse): QueryCirculatingSupplyResponseAmino;
    fromAminoMsg(object: QueryCirculatingSupplyResponseAminoMsg): QueryCirculatingSupplyResponse;
    fromProtoMsg(message: QueryCirculatingSupplyResponseProtoMsg): QueryCirculatingSupplyResponse;
    toProto(message: QueryCirculatingSupplyResponse): Uint8Array;
    toProtoMsg(message: QueryCirculatingSupplyResponse): QueryCirculatingSupplyResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryInflationRateRequest: {
    typeUrl: string;
    is(o: any): o is QueryInflationRateRequest;
    isSDK(o: any): o is QueryInflationRateRequestSDKType;
    isAmino(o: any): o is QueryInflationRateRequestAmino;
    encode(_: QueryInflationRateRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryInflationRateRequest;
    fromJSON(_: any): QueryInflationRateRequest;
    toJSON(_: QueryInflationRateRequest): JsonSafe<QueryInflationRateRequest>;
    fromPartial(_: DeepPartial<QueryInflationRateRequest>): QueryInflationRateRequest;
    fromSDK(_: QueryInflationRateRequestSDKType): QueryInflationRateRequest;
    fromSDKJSON(_: any): QueryInflationRateRequestSDKType;
    toSDK(_: QueryInflationRateRequest): QueryInflationRateRequestSDKType;
    fromAmino(_: QueryInflationRateRequestAmino): QueryInflationRateRequest;
    toAmino(_: QueryInflationRateRequest): QueryInflationRateRequestAmino;
    fromAminoMsg(object: QueryInflationRateRequestAminoMsg): QueryInflationRateRequest;
    fromProtoMsg(message: QueryInflationRateRequestProtoMsg): QueryInflationRateRequest;
    toProto(message: QueryInflationRateRequest): Uint8Array;
    toProtoMsg(message: QueryInflationRateRequest): QueryInflationRateRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryInflationRateResponse: {
    typeUrl: string;
    is(o: any): o is QueryInflationRateResponse;
    isSDK(o: any): o is QueryInflationRateResponseSDKType;
    isAmino(o: any): o is QueryInflationRateResponseAmino;
    encode(message: QueryInflationRateResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryInflationRateResponse;
    fromJSON(object: any): QueryInflationRateResponse;
    toJSON(message: QueryInflationRateResponse): JsonSafe<QueryInflationRateResponse>;
    fromPartial(object: DeepPartial<QueryInflationRateResponse>): QueryInflationRateResponse;
    fromSDK(object: QueryInflationRateResponseSDKType): QueryInflationRateResponse;
    fromSDKJSON(object: any): QueryInflationRateResponseSDKType;
    toSDK(message: QueryInflationRateResponse): QueryInflationRateResponseSDKType;
    fromAmino(object: QueryInflationRateResponseAmino): QueryInflationRateResponse;
    toAmino(message: QueryInflationRateResponse): QueryInflationRateResponseAmino;
    fromAminoMsg(object: QueryInflationRateResponseAminoMsg): QueryInflationRateResponse;
    fromProtoMsg(message: QueryInflationRateResponseProtoMsg): QueryInflationRateResponse;
    toProto(message: QueryInflationRateResponse): Uint8Array;
    toProtoMsg(message: QueryInflationRateResponse): QueryInflationRateResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryParamsRequest: {
    typeUrl: string;
    is(o: any): o is QueryParamsRequest;
    isSDK(o: any): o is QueryParamsRequestSDKType;
    isAmino(o: any): o is QueryParamsRequestAmino;
    encode(_: QueryParamsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryParamsRequest;
    fromJSON(_: any): QueryParamsRequest;
    toJSON(_: QueryParamsRequest): JsonSafe<QueryParamsRequest>;
    fromPartial(_: DeepPartial<QueryParamsRequest>): QueryParamsRequest;
    fromSDK(_: QueryParamsRequestSDKType): QueryParamsRequest;
    fromSDKJSON(_: any): QueryParamsRequestSDKType;
    toSDK(_: QueryParamsRequest): QueryParamsRequestSDKType;
    fromAmino(_: QueryParamsRequestAmino): QueryParamsRequest;
    toAmino(_: QueryParamsRequest): QueryParamsRequestAmino;
    fromAminoMsg(object: QueryParamsRequestAminoMsg): QueryParamsRequest;
    fromProtoMsg(message: QueryParamsRequestProtoMsg): QueryParamsRequest;
    toProto(message: QueryParamsRequest): Uint8Array;
    toProtoMsg(message: QueryParamsRequest): QueryParamsRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryParamsResponse: {
    typeUrl: string;
    is(o: any): o is QueryParamsResponse;
    isSDK(o: any): o is QueryParamsResponseSDKType;
    isAmino(o: any): o is QueryParamsResponseAmino;
    encode(message: QueryParamsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryParamsResponse;
    fromJSON(object: any): QueryParamsResponse;
    toJSON(message: QueryParamsResponse): JsonSafe<QueryParamsResponse>;
    fromPartial(object: DeepPartial<QueryParamsResponse>): QueryParamsResponse;
    fromSDK(object: QueryParamsResponseSDKType): QueryParamsResponse;
    fromSDKJSON(object: any): QueryParamsResponseSDKType;
    toSDK(message: QueryParamsResponse): QueryParamsResponseSDKType;
    fromAmino(object: QueryParamsResponseAmino): QueryParamsResponse;
    toAmino(message: QueryParamsResponse): QueryParamsResponseAmino;
    fromAminoMsg(object: QueryParamsResponseAminoMsg): QueryParamsResponse;
    fromProtoMsg(message: QueryParamsResponseProtoMsg): QueryParamsResponse;
    toProto(message: QueryParamsResponse): Uint8Array;
    toProtoMsg(message: QueryParamsResponse): QueryParamsResponseProtoMsg;
    registerTypeUrl(): void;
};
