import { DecCoin } from "../../../cosmos/base/v1beta1/coin";
import { Params } from "./genesis";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet } from "../../../helpers";
import { Decimal } from "@cosmjs/math";
export const protobufPackage = "evmos.inflation.v1";
function createBaseQueryPeriodRequest() {
    return {};
}
export const QueryPeriodRequest = {
    typeUrl: "/evmos.inflation.v1.QueryPeriodRequest",
    is(o) {
        return o && o.$typeUrl === QueryPeriodRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryPeriodRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryPeriodRequest.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryPeriodRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseQueryPeriodRequest();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseQueryPeriodRequest();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseQueryPeriodRequest();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return QueryPeriodRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryPeriodRequest.decode(message.value);
    },
    toProto(message) {
        return QueryPeriodRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.inflation.v1.QueryPeriodRequest",
            value: QueryPeriodRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryPeriodResponse() {
    return {
        period: BigInt(0)
    };
}
export const QueryPeriodResponse = {
    typeUrl: "/evmos.inflation.v1.QueryPeriodResponse",
    is(o) {
        return o && (o.$typeUrl === QueryPeriodResponse.typeUrl || typeof o.period === "bigint");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryPeriodResponse.typeUrl || typeof o.period === "bigint");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryPeriodResponse.typeUrl || typeof o.period === "bigint");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.period !== undefined) {
            writer.uint32(8).uint64(message.period);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryPeriodResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.period = reader.uint64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryPeriodResponse();
        if (isSet(object.period))
            obj.period = BigInt(object.period.toString());
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.period !== undefined && (obj.period = (message.period || BigInt(0)).toString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryPeriodResponse();
        if (object.period !== undefined && object.period !== null) {
            message.period = BigInt(object.period.toString());
        }
        return message;
    },
    fromSDK(object) {
        return {
            period: object?.period
        };
    },
    fromSDKJSON(object) {
        return {
            period: isSet(object.period) ? BigInt(object.period.toString()) : BigInt(0)
        };
    },
    toSDK(message) {
        const obj = {};
        obj.period = message.period;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryPeriodResponse();
        if (object.period !== undefined && object.period !== null) {
            message.period = BigInt(object.period);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.period = message.period !== BigInt(0) ? message.period?.toString() : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryPeriodResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryPeriodResponse.decode(message.value);
    },
    toProto(message) {
        return QueryPeriodResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.inflation.v1.QueryPeriodResponse",
            value: QueryPeriodResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryEpochMintProvisionRequest() {
    return {};
}
export const QueryEpochMintProvisionRequest = {
    typeUrl: "/evmos.inflation.v1.QueryEpochMintProvisionRequest",
    is(o) {
        return o && o.$typeUrl === QueryEpochMintProvisionRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryEpochMintProvisionRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryEpochMintProvisionRequest.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryEpochMintProvisionRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseQueryEpochMintProvisionRequest();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseQueryEpochMintProvisionRequest();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseQueryEpochMintProvisionRequest();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return QueryEpochMintProvisionRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryEpochMintProvisionRequest.decode(message.value);
    },
    toProto(message) {
        return QueryEpochMintProvisionRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.inflation.v1.QueryEpochMintProvisionRequest",
            value: QueryEpochMintProvisionRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryEpochMintProvisionResponse() {
    return {
        epochMintProvision: DecCoin.fromPartial({})
    };
}
export const QueryEpochMintProvisionResponse = {
    typeUrl: "/evmos.inflation.v1.QueryEpochMintProvisionResponse",
    is(o) {
        return o && (o.$typeUrl === QueryEpochMintProvisionResponse.typeUrl || DecCoin.is(o.epochMintProvision));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryEpochMintProvisionResponse.typeUrl || DecCoin.isSDK(o.epoch_mint_provision));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryEpochMintProvisionResponse.typeUrl || DecCoin.isAmino(o.epoch_mint_provision));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.epochMintProvision !== undefined) {
            DecCoin.encode(message.epochMintProvision, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryEpochMintProvisionResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.epochMintProvision = DecCoin.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryEpochMintProvisionResponse();
        if (isSet(object.epochMintProvision))
            obj.epochMintProvision = DecCoin.fromJSON(object.epochMintProvision);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.epochMintProvision !== undefined && (obj.epochMintProvision = message.epochMintProvision ? DecCoin.toJSON(message.epochMintProvision) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryEpochMintProvisionResponse();
        if (object.epochMintProvision !== undefined && object.epochMintProvision !== null) {
            message.epochMintProvision = DecCoin.fromPartial(object.epochMintProvision);
        }
        return message;
    },
    fromSDK(object) {
        return {
            epochMintProvision: object.epoch_mint_provision ? DecCoin.fromSDK(object.epoch_mint_provision) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            epoch_mint_provision: isSet(object.epoch_mint_provision) ? DecCoin.fromSDKJSON(object.epoch_mint_provision) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.epochMintProvision !== undefined && (obj.epoch_mint_provision = message.epochMintProvision ? DecCoin.toSDK(message.epochMintProvision) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryEpochMintProvisionResponse();
        if (object.epoch_mint_provision !== undefined && object.epoch_mint_provision !== null) {
            message.epochMintProvision = DecCoin.fromAmino(object.epoch_mint_provision);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.epoch_mint_provision = message.epochMintProvision ? DecCoin.toAmino(message.epochMintProvision) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryEpochMintProvisionResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryEpochMintProvisionResponse.decode(message.value);
    },
    toProto(message) {
        return QueryEpochMintProvisionResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.inflation.v1.QueryEpochMintProvisionResponse",
            value: QueryEpochMintProvisionResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        DecCoin.registerTypeUrl();
    }
};
function createBaseQuerySkippedEpochsRequest() {
    return {};
}
export const QuerySkippedEpochsRequest = {
    typeUrl: "/evmos.inflation.v1.QuerySkippedEpochsRequest",
    is(o) {
        return o && o.$typeUrl === QuerySkippedEpochsRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QuerySkippedEpochsRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QuerySkippedEpochsRequest.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQuerySkippedEpochsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseQuerySkippedEpochsRequest();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseQuerySkippedEpochsRequest();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseQuerySkippedEpochsRequest();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return QuerySkippedEpochsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QuerySkippedEpochsRequest.decode(message.value);
    },
    toProto(message) {
        return QuerySkippedEpochsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.inflation.v1.QuerySkippedEpochsRequest",
            value: QuerySkippedEpochsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQuerySkippedEpochsResponse() {
    return {
        skippedEpochs: BigInt(0)
    };
}
export const QuerySkippedEpochsResponse = {
    typeUrl: "/evmos.inflation.v1.QuerySkippedEpochsResponse",
    is(o) {
        return o && (o.$typeUrl === QuerySkippedEpochsResponse.typeUrl || typeof o.skippedEpochs === "bigint");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QuerySkippedEpochsResponse.typeUrl || typeof o.skipped_epochs === "bigint");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QuerySkippedEpochsResponse.typeUrl || typeof o.skipped_epochs === "bigint");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.skippedEpochs !== undefined) {
            writer.uint32(8).uint64(message.skippedEpochs);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQuerySkippedEpochsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.skippedEpochs = reader.uint64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQuerySkippedEpochsResponse();
        if (isSet(object.skippedEpochs))
            obj.skippedEpochs = BigInt(object.skippedEpochs.toString());
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.skippedEpochs !== undefined && (obj.skippedEpochs = (message.skippedEpochs || BigInt(0)).toString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQuerySkippedEpochsResponse();
        if (object.skippedEpochs !== undefined && object.skippedEpochs !== null) {
            message.skippedEpochs = BigInt(object.skippedEpochs.toString());
        }
        return message;
    },
    fromSDK(object) {
        return {
            skippedEpochs: object?.skipped_epochs
        };
    },
    fromSDKJSON(object) {
        return {
            skipped_epochs: isSet(object.skipped_epochs) ? BigInt(object.skipped_epochs.toString()) : BigInt(0)
        };
    },
    toSDK(message) {
        const obj = {};
        obj.skipped_epochs = message.skippedEpochs;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQuerySkippedEpochsResponse();
        if (object.skipped_epochs !== undefined && object.skipped_epochs !== null) {
            message.skippedEpochs = BigInt(object.skipped_epochs);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.skipped_epochs = message.skippedEpochs !== BigInt(0) ? message.skippedEpochs?.toString() : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QuerySkippedEpochsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QuerySkippedEpochsResponse.decode(message.value);
    },
    toProto(message) {
        return QuerySkippedEpochsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.inflation.v1.QuerySkippedEpochsResponse",
            value: QuerySkippedEpochsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryCirculatingSupplyRequest() {
    return {};
}
export const QueryCirculatingSupplyRequest = {
    typeUrl: "/evmos.inflation.v1.QueryCirculatingSupplyRequest",
    is(o) {
        return o && o.$typeUrl === QueryCirculatingSupplyRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryCirculatingSupplyRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryCirculatingSupplyRequest.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryCirculatingSupplyRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseQueryCirculatingSupplyRequest();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseQueryCirculatingSupplyRequest();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseQueryCirculatingSupplyRequest();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return QueryCirculatingSupplyRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryCirculatingSupplyRequest.decode(message.value);
    },
    toProto(message) {
        return QueryCirculatingSupplyRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.inflation.v1.QueryCirculatingSupplyRequest",
            value: QueryCirculatingSupplyRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryCirculatingSupplyResponse() {
    return {
        circulatingSupply: DecCoin.fromPartial({})
    };
}
export const QueryCirculatingSupplyResponse = {
    typeUrl: "/evmos.inflation.v1.QueryCirculatingSupplyResponse",
    is(o) {
        return o && (o.$typeUrl === QueryCirculatingSupplyResponse.typeUrl || DecCoin.is(o.circulatingSupply));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryCirculatingSupplyResponse.typeUrl || DecCoin.isSDK(o.circulating_supply));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryCirculatingSupplyResponse.typeUrl || DecCoin.isAmino(o.circulating_supply));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.circulatingSupply !== undefined) {
            DecCoin.encode(message.circulatingSupply, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryCirculatingSupplyResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.circulatingSupply = DecCoin.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryCirculatingSupplyResponse();
        if (isSet(object.circulatingSupply))
            obj.circulatingSupply = DecCoin.fromJSON(object.circulatingSupply);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.circulatingSupply !== undefined && (obj.circulatingSupply = message.circulatingSupply ? DecCoin.toJSON(message.circulatingSupply) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryCirculatingSupplyResponse();
        if (object.circulatingSupply !== undefined && object.circulatingSupply !== null) {
            message.circulatingSupply = DecCoin.fromPartial(object.circulatingSupply);
        }
        return message;
    },
    fromSDK(object) {
        return {
            circulatingSupply: object.circulating_supply ? DecCoin.fromSDK(object.circulating_supply) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            circulating_supply: isSet(object.circulating_supply) ? DecCoin.fromSDKJSON(object.circulating_supply) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.circulatingSupply !== undefined && (obj.circulating_supply = message.circulatingSupply ? DecCoin.toSDK(message.circulatingSupply) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryCirculatingSupplyResponse();
        if (object.circulating_supply !== undefined && object.circulating_supply !== null) {
            message.circulatingSupply = DecCoin.fromAmino(object.circulating_supply);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.circulating_supply = message.circulatingSupply ? DecCoin.toAmino(message.circulatingSupply) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryCirculatingSupplyResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryCirculatingSupplyResponse.decode(message.value);
    },
    toProto(message) {
        return QueryCirculatingSupplyResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.inflation.v1.QueryCirculatingSupplyResponse",
            value: QueryCirculatingSupplyResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        DecCoin.registerTypeUrl();
    }
};
function createBaseQueryInflationRateRequest() {
    return {};
}
export const QueryInflationRateRequest = {
    typeUrl: "/evmos.inflation.v1.QueryInflationRateRequest",
    is(o) {
        return o && o.$typeUrl === QueryInflationRateRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryInflationRateRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryInflationRateRequest.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryInflationRateRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseQueryInflationRateRequest();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseQueryInflationRateRequest();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseQueryInflationRateRequest();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return QueryInflationRateRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryInflationRateRequest.decode(message.value);
    },
    toProto(message) {
        return QueryInflationRateRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.inflation.v1.QueryInflationRateRequest",
            value: QueryInflationRateRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryInflationRateResponse() {
    return {
        inflationRate: ""
    };
}
export const QueryInflationRateResponse = {
    typeUrl: "/evmos.inflation.v1.QueryInflationRateResponse",
    is(o) {
        return o && (o.$typeUrl === QueryInflationRateResponse.typeUrl || typeof o.inflationRate === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryInflationRateResponse.typeUrl || typeof o.inflation_rate === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryInflationRateResponse.typeUrl || typeof o.inflation_rate === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.inflationRate !== undefined) {
            writer.uint32(10).string(Decimal.fromUserInput(message.inflationRate, 18).atomics);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryInflationRateResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.inflationRate = Decimal.fromAtomics(reader.string(), 18).toString();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryInflationRateResponse();
        if (isSet(object.inflationRate))
            obj.inflationRate = String(object.inflationRate);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.inflationRate !== undefined && (obj.inflationRate = message.inflationRate);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryInflationRateResponse();
        message.inflationRate = object.inflationRate ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            inflationRate: object?.inflation_rate
        };
    },
    fromSDKJSON(object) {
        return {
            inflation_rate: isSet(object.inflation_rate) ? String(object.inflation_rate) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.inflation_rate = message.inflationRate;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryInflationRateResponse();
        if (object.inflation_rate !== undefined && object.inflation_rate !== null) {
            message.inflationRate = object.inflation_rate;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.inflation_rate = message.inflationRate === "" ? undefined : message.inflationRate;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryInflationRateResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryInflationRateResponse.decode(message.value);
    },
    toProto(message) {
        return QueryInflationRateResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.inflation.v1.QueryInflationRateResponse",
            value: QueryInflationRateResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryParamsRequest() {
    return {};
}
export const QueryParamsRequest = {
    typeUrl: "/evmos.inflation.v1.QueryParamsRequest",
    is(o) {
        return o && o.$typeUrl === QueryParamsRequest.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === QueryParamsRequest.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === QueryParamsRequest.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParamsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseQueryParamsRequest();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseQueryParamsRequest();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseQueryParamsRequest();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return QueryParamsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryParamsRequest.decode(message.value);
    },
    toProto(message) {
        return QueryParamsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.inflation.v1.QueryParamsRequest",
            value: QueryParamsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQueryParamsResponse() {
    return {
        params: Params.fromPartial({})
    };
}
export const QueryParamsResponse = {
    typeUrl: "/evmos.inflation.v1.QueryParamsResponse",
    is(o) {
        return o && (o.$typeUrl === QueryParamsResponse.typeUrl || Params.is(o.params));
    },
    isSDK(o) {
        return o && (o.$typeUrl === QueryParamsResponse.typeUrl || Params.isSDK(o.params));
    },
    isAmino(o) {
        return o && (o.$typeUrl === QueryParamsResponse.typeUrl || Params.isAmino(o.params));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.params !== undefined) {
            Params.encode(message.params, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQueryParamsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.params = Params.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQueryParamsResponse();
        if (isSet(object.params))
            obj.params = Params.fromJSON(object.params);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toJSON(message.params) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQueryParamsResponse();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromPartial(object.params);
        }
        return message;
    },
    fromSDK(object) {
        return {
            params: object.params ? Params.fromSDK(object.params) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            params: isSet(object.params) ? Params.fromSDKJSON(object.params) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.params !== undefined && (obj.params = message.params ? Params.toSDK(message.params) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQueryParamsResponse();
        if (object.params !== undefined && object.params !== null) {
            message.params = Params.fromAmino(object.params);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.params = message.params ? Params.toAmino(message.params) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QueryParamsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QueryParamsResponse.decode(message.value);
    },
    toProto(message) {
        return QueryParamsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.inflation.v1.QueryParamsResponse",
            value: QueryParamsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Params.registerTypeUrl();
    }
};
