import { Coin, CoinAmino, CoinSDKType } from "../../../cosmos/base/v1beta1/coin";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial } from "../../../helpers";
import { JsonSafe } from "../../../json-safe";
export declare const protobufPackage = "evmos.vesting.v1";
/** QueryBalancesRequest is the request type for the Query/Balances RPC method. */
export interface QueryBalancesRequest {
    /** address of the clawback vesting account */
    address: string;
}
export interface QueryBalancesRequestProtoMsg {
    typeUrl: "/evmos.vesting.v1.QueryBalancesRequest";
    value: Uint8Array;
}
/** QueryBalancesRequest is the request type for the Query/Balances RPC method. */
export interface QueryBalancesRequestAmino {
    /** address of the clawback vesting account */
    address?: string;
}
export interface QueryBalancesRequestAminoMsg {
    type: "/evmos.vesting.v1.QueryBalancesRequest";
    value: QueryBalancesRequestAmino;
}
/** QueryBalancesRequest is the request type for the Query/Balances RPC method. */
export interface QueryBalancesRequestSDKType {
    address: string;
}
/**
 * QueryBalancesResponse is the response type for the Query/Balances RPC
 * method.
 */
export interface QueryBalancesResponse {
    /** current amount of locked tokens */
    locked: Coin[];
    /** current amount of unvested tokens */
    unvested: Coin[];
    /** current amount of vested tokens */
    vested: Coin[];
}
export interface QueryBalancesResponseProtoMsg {
    typeUrl: "/evmos.vesting.v1.QueryBalancesResponse";
    value: Uint8Array;
}
/**
 * QueryBalancesResponse is the response type for the Query/Balances RPC
 * method.
 */
export interface QueryBalancesResponseAmino {
    /** current amount of locked tokens */
    locked?: CoinAmino[];
    /** current amount of unvested tokens */
    unvested?: CoinAmino[];
    /** current amount of vested tokens */
    vested?: CoinAmino[];
}
export interface QueryBalancesResponseAminoMsg {
    type: "/evmos.vesting.v1.QueryBalancesResponse";
    value: QueryBalancesResponseAmino;
}
/**
 * QueryBalancesResponse is the response type for the Query/Balances RPC
 * method.
 */
export interface QueryBalancesResponseSDKType {
    locked: CoinSDKType[];
    unvested: CoinSDKType[];
    vested: CoinSDKType[];
}
export declare const QueryBalancesRequest: {
    typeUrl: string;
    is(o: any): o is QueryBalancesRequest;
    isSDK(o: any): o is QueryBalancesRequestSDKType;
    isAmino(o: any): o is QueryBalancesRequestAmino;
    encode(message: QueryBalancesRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryBalancesRequest;
    fromJSON(object: any): QueryBalancesRequest;
    toJSON(message: QueryBalancesRequest): JsonSafe<QueryBalancesRequest>;
    fromPartial(object: DeepPartial<QueryBalancesRequest>): QueryBalancesRequest;
    fromSDK(object: QueryBalancesRequestSDKType): QueryBalancesRequest;
    fromSDKJSON(object: any): QueryBalancesRequestSDKType;
    toSDK(message: QueryBalancesRequest): QueryBalancesRequestSDKType;
    fromAmino(object: QueryBalancesRequestAmino): QueryBalancesRequest;
    toAmino(message: QueryBalancesRequest): QueryBalancesRequestAmino;
    fromAminoMsg(object: QueryBalancesRequestAminoMsg): QueryBalancesRequest;
    fromProtoMsg(message: QueryBalancesRequestProtoMsg): QueryBalancesRequest;
    toProto(message: QueryBalancesRequest): Uint8Array;
    toProtoMsg(message: QueryBalancesRequest): QueryBalancesRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const QueryBalancesResponse: {
    typeUrl: string;
    is(o: any): o is QueryBalancesResponse;
    isSDK(o: any): o is QueryBalancesResponseSDKType;
    isAmino(o: any): o is QueryBalancesResponseAmino;
    encode(message: QueryBalancesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): QueryBalancesResponse;
    fromJSON(object: any): QueryBalancesResponse;
    toJSON(message: QueryBalancesResponse): JsonSafe<QueryBalancesResponse>;
    fromPartial(object: DeepPartial<QueryBalancesResponse>): QueryBalancesResponse;
    fromSDK(object: QueryBalancesResponseSDKType): QueryBalancesResponse;
    fromSDKJSON(object: any): QueryBalancesResponseSDKType;
    toSDK(message: QueryBalancesResponse): QueryBalancesResponseSDKType;
    fromAmino(object: QueryBalancesResponseAmino): QueryBalancesResponse;
    toAmino(message: QueryBalancesResponse): QueryBalancesResponseAmino;
    fromAminoMsg(object: QueryBalancesResponseAminoMsg): QueryBalancesResponse;
    fromProtoMsg(message: QueryBalancesResponseProtoMsg): QueryBalancesResponse;
    toProto(message: QueryBalancesResponse): Uint8Array;
    toProtoMsg(message: QueryBalancesResponse): QueryBalancesResponseProtoMsg;
    registerTypeUrl(): void;
};
