import { TxRpc } from "../../../types";
import { QueryBalancesRequest, QueryBalancesResponse } from "./query";
/** Query defines the gRPC querier service. */
export interface Query {
    /** Retrieves the unvested, vested and locked tokens for a vesting account */
    balances(request: QueryBalancesRequest): Promise<QueryBalancesResponse>;
}
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    constructor(rpc: TxRpc);
    balances: (request: QueryBalancesRequest) => Promise<QueryBalancesResponse>;
}
export declare const createClientImpl: (rpc: TxRpc) => QueryClientImpl;
