import { BinaryReader } from "../../../binary";
import { QueryBalancesRequest, QueryBalancesResponse } from "./query";
export class QueryClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* Retrieves the unvested, vested and locked tokens for a vesting account */
    balances = async (request) => {
        const data = QueryBalancesRequest.encode(request).finish();
        const promise = this.rpc.request("evmos.vesting.v1.Query", "Balances", data);
        return promise.then(data => QueryBalancesResponse.decode(new BinaryReader(data)));
    };
}
export const createClientImpl = (rpc) => {
    return new QueryClientImpl(rpc);
};
