import { Timestamp } from "../../../google/protobuf/timestamp";
import { Period } from "../../../cosmos/vesting/v1beta1/vesting";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { toTimestamp, fromTimestamp, isSet } from "../../../helpers";
export const protobufPackage = "evmos.vesting.v1";
function createBaseMsgCreateClawbackVestingAccount() {
    return {
        fromAddress: "",
        toAddress: "",
        startTime: new Date(),
        lockupPeriods: [],
        vestingPeriods: [],
        merge: false
    };
}
export const MsgCreateClawbackVestingAccount = {
    typeUrl: "/evmos.vesting.v1.MsgCreateClawbackVestingAccount",
    is(o) {
        return o && (o.$typeUrl === MsgCreateClawbackVestingAccount.typeUrl || typeof o.fromAddress === "string" && typeof o.toAddress === "string" && Timestamp.is(o.startTime) && Array.isArray(o.lockupPeriods) && (!o.lockupPeriods.length || Period.is(o.lockupPeriods[0])) && Array.isArray(o.vestingPeriods) && (!o.vestingPeriods.length || Period.is(o.vestingPeriods[0])) && typeof o.merge === "boolean");
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgCreateClawbackVestingAccount.typeUrl || typeof o.from_address === "string" && typeof o.to_address === "string" && Timestamp.isSDK(o.start_time) && Array.isArray(o.lockup_periods) && (!o.lockup_periods.length || Period.isSDK(o.lockup_periods[0])) && Array.isArray(o.vesting_periods) && (!o.vesting_periods.length || Period.isSDK(o.vesting_periods[0])) && typeof o.merge === "boolean");
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgCreateClawbackVestingAccount.typeUrl || typeof o.from_address === "string" && typeof o.to_address === "string" && Timestamp.isAmino(o.start_time) && Array.isArray(o.lockup_periods) && (!o.lockup_periods.length || Period.isAmino(o.lockup_periods[0])) && Array.isArray(o.vesting_periods) && (!o.vesting_periods.length || Period.isAmino(o.vesting_periods[0])) && typeof o.merge === "boolean");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.fromAddress !== undefined) {
            writer.uint32(10).string(message.fromAddress);
        }
        if (message.toAddress !== undefined) {
            writer.uint32(18).string(message.toAddress);
        }
        if (message.startTime !== undefined) {
            Timestamp.encode(toTimestamp(message.startTime), writer.uint32(26).fork()).ldelim();
        }
        for (const v of message.lockupPeriods) {
            Period.encode(v, writer.uint32(34).fork()).ldelim();
        }
        for (const v of message.vestingPeriods) {
            Period.encode(v, writer.uint32(42).fork()).ldelim();
        }
        if (message.merge !== undefined) {
            writer.uint32(48).bool(message.merge);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCreateClawbackVestingAccount();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.fromAddress = reader.string();
                    break;
                case 2:
                    message.toAddress = reader.string();
                    break;
                case 3:
                    message.startTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 4:
                    message.lockupPeriods.push(Period.decode(reader, reader.uint32()));
                    break;
                case 5:
                    message.vestingPeriods.push(Period.decode(reader, reader.uint32()));
                    break;
                case 6:
                    message.merge = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgCreateClawbackVestingAccount();
        if (isSet(object.fromAddress))
            obj.fromAddress = String(object.fromAddress);
        if (isSet(object.toAddress))
            obj.toAddress = String(object.toAddress);
        if (isSet(object.startTime))
            obj.startTime = new Date(object.startTime);
        if (Array.isArray(object?.lockupPeriods))
            obj.lockupPeriods = object.lockupPeriods.map((e) => Period.fromJSON(e));
        if (Array.isArray(object?.vestingPeriods))
            obj.vestingPeriods = object.vestingPeriods.map((e) => Period.fromJSON(e));
        if (isSet(object.merge))
            obj.merge = Boolean(object.merge);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.fromAddress !== undefined && (obj.fromAddress = message.fromAddress);
        message.toAddress !== undefined && (obj.toAddress = message.toAddress);
        message.startTime !== undefined && (obj.startTime = message.startTime.toISOString());
        if (message.lockupPeriods) {
            obj.lockupPeriods = message.lockupPeriods.map(e => e ? Period.toJSON(e) : undefined);
        }
        else {
            obj.lockupPeriods = [];
        }
        if (message.vestingPeriods) {
            obj.vestingPeriods = message.vestingPeriods.map(e => e ? Period.toJSON(e) : undefined);
        }
        else {
            obj.vestingPeriods = [];
        }
        message.merge !== undefined && (obj.merge = message.merge);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgCreateClawbackVestingAccount();
        message.fromAddress = object.fromAddress ?? "";
        message.toAddress = object.toAddress ?? "";
        message.startTime = object.startTime ?? undefined;
        message.lockupPeriods = object.lockupPeriods?.map(e => Period.fromPartial(e)) || [];
        message.vestingPeriods = object.vestingPeriods?.map(e => Period.fromPartial(e)) || [];
        message.merge = object.merge ?? false;
        return message;
    },
    fromSDK(object) {
        return {
            fromAddress: object?.from_address,
            toAddress: object?.to_address,
            startTime: object.start_time ?? undefined,
            lockupPeriods: Array.isArray(object?.lockup_periods) ? object.lockup_periods.map((e) => Period.fromSDK(e)) : [],
            vestingPeriods: Array.isArray(object?.vesting_periods) ? object.vesting_periods.map((e) => Period.fromSDK(e)) : [],
            merge: object?.merge
        };
    },
    fromSDKJSON(object) {
        return {
            from_address: isSet(object.from_address) ? String(object.from_address) : "",
            to_address: isSet(object.to_address) ? String(object.to_address) : "",
            start_time: isSet(object.start_time) ? new Date(object.start_time) : undefined,
            lockup_periods: Array.isArray(object?.lockup_periods) ? object.lockup_periods.map((e) => Period.fromSDKJSON(e)) : [],
            vesting_periods: Array.isArray(object?.vesting_periods) ? object.vesting_periods.map((e) => Period.fromSDKJSON(e)) : [],
            merge: isSet(object.merge) ? Boolean(object.merge) : false
        };
    },
    toSDK(message) {
        const obj = {};
        obj.from_address = message.fromAddress;
        obj.to_address = message.toAddress;
        message.startTime !== undefined && (obj.start_time = message.startTime ?? undefined);
        if (message.lockupPeriods) {
            obj.lockup_periods = message.lockupPeriods.map(e => e ? Period.toSDK(e) : undefined);
        }
        else {
            obj.lockup_periods = [];
        }
        if (message.vestingPeriods) {
            obj.vesting_periods = message.vestingPeriods.map(e => e ? Period.toSDK(e) : undefined);
        }
        else {
            obj.vesting_periods = [];
        }
        obj.merge = message.merge;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgCreateClawbackVestingAccount();
        if (object.from_address !== undefined && object.from_address !== null) {
            message.fromAddress = object.from_address;
        }
        if (object.to_address !== undefined && object.to_address !== null) {
            message.toAddress = object.to_address;
        }
        if (object.start_time !== undefined && object.start_time !== null) {
            message.startTime = fromTimestamp(Timestamp.fromAmino(object.start_time));
        }
        message.lockupPeriods = object.lockup_periods?.map(e => Period.fromAmino(e)) || [];
        message.vestingPeriods = object.vesting_periods?.map(e => Period.fromAmino(e)) || [];
        if (object.merge !== undefined && object.merge !== null) {
            message.merge = object.merge;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.from_address = message.fromAddress === "" ? undefined : message.fromAddress;
        obj.to_address = message.toAddress === "" ? undefined : message.toAddress;
        obj.start_time = message.startTime ? Timestamp.toAmino(toTimestamp(message.startTime)) : undefined;
        if (message.lockupPeriods) {
            obj.lockup_periods = message.lockupPeriods.map(e => e ? Period.toAmino(e) : undefined);
        }
        else {
            obj.lockup_periods = message.lockupPeriods;
        }
        if (message.vestingPeriods) {
            obj.vesting_periods = message.vestingPeriods.map(e => e ? Period.toAmino(e) : undefined);
        }
        else {
            obj.vesting_periods = message.vestingPeriods;
        }
        obj.merge = message.merge === false ? undefined : message.merge;
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCreateClawbackVestingAccount.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MsgCreateClawbackVestingAccount.decode(message.value);
    },
    toProto(message) {
        return MsgCreateClawbackVestingAccount.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.vesting.v1.MsgCreateClawbackVestingAccount",
            value: MsgCreateClawbackVestingAccount.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Period.registerTypeUrl();
    }
};
function createBaseMsgCreateClawbackVestingAccountResponse() {
    return {};
}
export const MsgCreateClawbackVestingAccountResponse = {
    typeUrl: "/evmos.vesting.v1.MsgCreateClawbackVestingAccountResponse",
    is(o) {
        return o && o.$typeUrl === MsgCreateClawbackVestingAccountResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgCreateClawbackVestingAccountResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgCreateClawbackVestingAccountResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgCreateClawbackVestingAccountResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgCreateClawbackVestingAccountResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgCreateClawbackVestingAccountResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgCreateClawbackVestingAccountResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgCreateClawbackVestingAccountResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MsgCreateClawbackVestingAccountResponse.decode(message.value);
    },
    toProto(message) {
        return MsgCreateClawbackVestingAccountResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.vesting.v1.MsgCreateClawbackVestingAccountResponse",
            value: MsgCreateClawbackVestingAccountResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgClawback() {
    return {
        funderAddress: "",
        accountAddress: "",
        destAddress: ""
    };
}
export const MsgClawback = {
    typeUrl: "/evmos.vesting.v1.MsgClawback",
    is(o) {
        return o && (o.$typeUrl === MsgClawback.typeUrl || typeof o.funderAddress === "string" && typeof o.accountAddress === "string" && typeof o.destAddress === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === MsgClawback.typeUrl || typeof o.funder_address === "string" && typeof o.account_address === "string" && typeof o.dest_address === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === MsgClawback.typeUrl || typeof o.funder_address === "string" && typeof o.account_address === "string" && typeof o.dest_address === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.funderAddress !== undefined) {
            writer.uint32(10).string(message.funderAddress);
        }
        if (message.accountAddress !== undefined) {
            writer.uint32(18).string(message.accountAddress);
        }
        if (message.destAddress !== undefined) {
            writer.uint32(26).string(message.destAddress);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgClawback();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.funderAddress = reader.string();
                    break;
                case 2:
                    message.accountAddress = reader.string();
                    break;
                case 3:
                    message.destAddress = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMsgClawback();
        if (isSet(object.funderAddress))
            obj.funderAddress = String(object.funderAddress);
        if (isSet(object.accountAddress))
            obj.accountAddress = String(object.accountAddress);
        if (isSet(object.destAddress))
            obj.destAddress = String(object.destAddress);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.funderAddress !== undefined && (obj.funderAddress = message.funderAddress);
        message.accountAddress !== undefined && (obj.accountAddress = message.accountAddress);
        message.destAddress !== undefined && (obj.destAddress = message.destAddress);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMsgClawback();
        message.funderAddress = object.funderAddress ?? "";
        message.accountAddress = object.accountAddress ?? "";
        message.destAddress = object.destAddress ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            funderAddress: object?.funder_address,
            accountAddress: object?.account_address,
            destAddress: object?.dest_address
        };
    },
    fromSDKJSON(object) {
        return {
            funder_address: isSet(object.funder_address) ? String(object.funder_address) : "",
            account_address: isSet(object.account_address) ? String(object.account_address) : "",
            dest_address: isSet(object.dest_address) ? String(object.dest_address) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.funder_address = message.funderAddress;
        obj.account_address = message.accountAddress;
        obj.dest_address = message.destAddress;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMsgClawback();
        if (object.funder_address !== undefined && object.funder_address !== null) {
            message.funderAddress = object.funder_address;
        }
        if (object.account_address !== undefined && object.account_address !== null) {
            message.accountAddress = object.account_address;
        }
        if (object.dest_address !== undefined && object.dest_address !== null) {
            message.destAddress = object.dest_address;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.funder_address = message.funderAddress === "" ? undefined : message.funderAddress;
        obj.account_address = message.accountAddress === "" ? undefined : message.accountAddress;
        obj.dest_address = message.destAddress === "" ? undefined : message.destAddress;
        return obj;
    },
    fromAminoMsg(object) {
        return MsgClawback.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MsgClawback.decode(message.value);
    },
    toProto(message) {
        return MsgClawback.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.vesting.v1.MsgClawback",
            value: MsgClawback.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseMsgClawbackResponse() {
    return {};
}
export const MsgClawbackResponse = {
    typeUrl: "/evmos.vesting.v1.MsgClawbackResponse",
    is(o) {
        return o && o.$typeUrl === MsgClawbackResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === MsgClawbackResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === MsgClawbackResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgClawbackResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseMsgClawbackResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgClawbackResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseMsgClawbackResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return MsgClawbackResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MsgClawbackResponse.decode(message.value);
    },
    toProto(message) {
        return MsgClawbackResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/evmos.vesting.v1.MsgClawbackResponse",
            value: MsgClawbackResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
