import { TelescopeGeneratedType } from "../../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgCreateClawbackVestingAccount, MsgClawback } from "./tx";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        createClawbackVestingAccount(value: MsgCreateClawbackVestingAccount): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        clawback(value: MsgClawback): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        createClawbackVestingAccount(value: MsgCreateClawbackVestingAccount): {
            typeUrl: string;
            value: MsgCreateClawbackVestingAccount;
        };
        clawback(value: MsgClawback): {
            typeUrl: string;
            value: MsgClawback;
        };
    };
    toJSON: {
        createClawbackVestingAccount(value: MsgCreateClawbackVestingAccount): {
            typeUrl: string;
            value: {
                fromAddress: string;
                toAddress: string;
                startTime: string;
                lockupPeriods: {
                    length: string;
                    amount: {
                        denom: string;
                        amount: string;
                    }[];
                }[];
                vestingPeriods: {
                    length: string;
                    amount: {
                        denom: string;
                        amount: string;
                    }[];
                }[];
                merge: boolean;
            };
        };
        clawback(value: MsgClawback): {
            typeUrl: string;
            value: {
                funderAddress: string;
                accountAddress: string;
                destAddress: string;
            };
        };
    };
    fromJSON: {
        createClawbackVestingAccount(value: any): {
            typeUrl: string;
            value: MsgCreateClawbackVestingAccount;
        };
        clawback(value: any): {
            typeUrl: string;
            value: MsgClawback;
        };
    };
    fromPartial: {
        createClawbackVestingAccount(value: MsgCreateClawbackVestingAccount): {
            typeUrl: string;
            value: MsgCreateClawbackVestingAccount;
        };
        clawback(value: MsgClawback): {
            typeUrl: string;
            value: MsgClawback;
        };
    };
};
