import { DeliverTxResponse, StdFee, TxRpc } from "../../../types";
import { MsgCreateClawbackVestingAccount, MsgClawback } from "./tx";
/** Msg defines the vesting Msg service. */
export interface Msg {
    /**
     * CreateClawbackVestingAccount creats a vesting account that is subject to
     * clawback and the configuration of vesting and lockup schedules.
     */
    createClawbackVestingAccount(signerAddress: string, message: MsgCreateClawbackVestingAccount, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    /** Clawback removes the unvested tokens from a ClawbackVestingAccount. */
    clawback(signerAddress: string, message: MsgClawback, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
}
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    constructor(rpc: TxRpc);
    createClawbackVestingAccount: (signerAddress: string, message: MsgCreateClawbackVestingAccount, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    clawback: (signerAddress: string, message: MsgClawback, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
}
export declare const createClientImpl: (rpc: TxRpc) => MsgClientImpl;
