import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseAuthentication() {
    return {
        rules: [],
        providers: []
    };
}
export const Authentication = {
    typeUrl: "/google.api.Authentication",
    is(o) {
        return o && (o.$typeUrl === Authentication.typeUrl || Array.isArray(o.rules) && (!o.rules.length || AuthenticationRule.is(o.rules[0])) && Array.isArray(o.providers) && (!o.providers.length || AuthProvider.is(o.providers[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Authentication.typeUrl || Array.isArray(o.rules) && (!o.rules.length || AuthenticationRule.isSDK(o.rules[0])) && Array.isArray(o.providers) && (!o.providers.length || AuthProvider.isSDK(o.providers[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Authentication.typeUrl || Array.isArray(o.rules) && (!o.rules.length || AuthenticationRule.isAmino(o.rules[0])) && Array.isArray(o.providers) && (!o.providers.length || AuthProvider.isAmino(o.providers[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.rules) {
            AuthenticationRule.encode(v, writer.uint32(26).fork()).ldelim();
        }
        for (const v of message.providers) {
            AuthProvider.encode(v, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAuthentication();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 3:
                    message.rules.push(AuthenticationRule.decode(reader, reader.uint32()));
                    break;
                case 4:
                    message.providers.push(AuthProvider.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAuthentication();
        if (Array.isArray(object?.rules))
            obj.rules = object.rules.map((e) => AuthenticationRule.fromJSON(e));
        if (Array.isArray(object?.providers))
            obj.providers = object.providers.map((e) => AuthProvider.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? AuthenticationRule.toJSON(e) : undefined);
        }
        else {
            obj.rules = [];
        }
        if (message.providers) {
            obj.providers = message.providers.map(e => e ? AuthProvider.toJSON(e) : undefined);
        }
        else {
            obj.providers = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAuthentication();
        message.rules = object.rules?.map(e => AuthenticationRule.fromPartial(e)) || [];
        message.providers = object.providers?.map(e => AuthProvider.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            rules: Array.isArray(object?.rules) ? object.rules.map((e) => AuthenticationRule.fromSDK(e)) : [],
            providers: Array.isArray(object?.providers) ? object.providers.map((e) => AuthProvider.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            rules: Array.isArray(object?.rules) ? object.rules.map((e) => AuthenticationRule.fromSDKJSON(e)) : [],
            providers: Array.isArray(object?.providers) ? object.providers.map((e) => AuthProvider.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? AuthenticationRule.toSDK(e) : undefined);
        }
        else {
            obj.rules = [];
        }
        if (message.providers) {
            obj.providers = message.providers.map(e => e ? AuthProvider.toSDK(e) : undefined);
        }
        else {
            obj.providers = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAuthentication();
        message.rules = object.rules?.map(e => AuthenticationRule.fromAmino(e)) || [];
        message.providers = object.providers?.map(e => AuthProvider.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? AuthenticationRule.toAmino(e) : undefined);
        }
        else {
            obj.rules = message.rules;
        }
        if (message.providers) {
            obj.providers = message.providers.map(e => e ? AuthProvider.toAmino(e) : undefined);
        }
        else {
            obj.providers = message.providers;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Authentication.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Authentication.decode(message.value);
    },
    toProto(message) {
        return Authentication.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Authentication",
            value: Authentication.encode(message).finish()
        };
    },
    registerTypeUrl() {
        AuthenticationRule.registerTypeUrl();
        AuthProvider.registerTypeUrl();
    }
};
function createBaseAuthenticationRule() {
    return {
        selector: "",
        oauth: undefined,
        allowWithoutCredential: false,
        requirements: []
    };
}
export const AuthenticationRule = {
    typeUrl: "/google.api.AuthenticationRule",
    is(o) {
        return o && (o.$typeUrl === AuthenticationRule.typeUrl || typeof o.selector === "string" && typeof o.allowWithoutCredential === "boolean" && Array.isArray(o.requirements) && (!o.requirements.length || AuthRequirement.is(o.requirements[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === AuthenticationRule.typeUrl || typeof o.selector === "string" && typeof o.allow_without_credential === "boolean" && Array.isArray(o.requirements) && (!o.requirements.length || AuthRequirement.isSDK(o.requirements[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === AuthenticationRule.typeUrl || typeof o.selector === "string" && typeof o.allow_without_credential === "boolean" && Array.isArray(o.requirements) && (!o.requirements.length || AuthRequirement.isAmino(o.requirements[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.selector !== undefined) {
            writer.uint32(10).string(message.selector);
        }
        if (message.oauth !== undefined) {
            OAuthRequirements.encode(message.oauth, writer.uint32(18).fork()).ldelim();
        }
        if (message.allowWithoutCredential !== undefined) {
            writer.uint32(40).bool(message.allowWithoutCredential);
        }
        for (const v of message.requirements) {
            AuthRequirement.encode(v, writer.uint32(58).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAuthenticationRule();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.selector = reader.string();
                    break;
                case 2:
                    message.oauth = OAuthRequirements.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.allowWithoutCredential = reader.bool();
                    break;
                case 7:
                    message.requirements.push(AuthRequirement.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAuthenticationRule();
        if (isSet(object.selector))
            obj.selector = String(object.selector);
        if (isSet(object.oauth))
            obj.oauth = OAuthRequirements.fromJSON(object.oauth);
        if (isSet(object.allowWithoutCredential))
            obj.allowWithoutCredential = Boolean(object.allowWithoutCredential);
        if (Array.isArray(object?.requirements))
            obj.requirements = object.requirements.map((e) => AuthRequirement.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.selector !== undefined && (obj.selector = message.selector);
        message.oauth !== undefined && (obj.oauth = message.oauth ? OAuthRequirements.toJSON(message.oauth) : undefined);
        message.allowWithoutCredential !== undefined && (obj.allowWithoutCredential = message.allowWithoutCredential);
        if (message.requirements) {
            obj.requirements = message.requirements.map(e => e ? AuthRequirement.toJSON(e) : undefined);
        }
        else {
            obj.requirements = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAuthenticationRule();
        message.selector = object.selector ?? "";
        if (object.oauth !== undefined && object.oauth !== null) {
            message.oauth = OAuthRequirements.fromPartial(object.oauth);
        }
        message.allowWithoutCredential = object.allowWithoutCredential ?? false;
        message.requirements = object.requirements?.map(e => AuthRequirement.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            selector: object?.selector,
            oauth: object.oauth ? OAuthRequirements.fromSDK(object.oauth) : undefined,
            allowWithoutCredential: object?.allow_without_credential,
            requirements: Array.isArray(object?.requirements) ? object.requirements.map((e) => AuthRequirement.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            selector: isSet(object.selector) ? String(object.selector) : "",
            oauth: isSet(object.oauth) ? OAuthRequirements.fromSDKJSON(object.oauth) : undefined,
            allow_without_credential: isSet(object.allow_without_credential) ? Boolean(object.allow_without_credential) : false,
            requirements: Array.isArray(object?.requirements) ? object.requirements.map((e) => AuthRequirement.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.selector = message.selector;
        message.oauth !== undefined && (obj.oauth = message.oauth ? OAuthRequirements.toSDK(message.oauth) : undefined);
        obj.allow_without_credential = message.allowWithoutCredential;
        if (message.requirements) {
            obj.requirements = message.requirements.map(e => e ? AuthRequirement.toSDK(e) : undefined);
        }
        else {
            obj.requirements = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAuthenticationRule();
        if (object.selector !== undefined && object.selector !== null) {
            message.selector = object.selector;
        }
        if (object.oauth !== undefined && object.oauth !== null) {
            message.oauth = OAuthRequirements.fromAmino(object.oauth);
        }
        if (object.allow_without_credential !== undefined && object.allow_without_credential !== null) {
            message.allowWithoutCredential = object.allow_without_credential;
        }
        message.requirements = object.requirements?.map(e => AuthRequirement.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.selector = message.selector === "" ? undefined : message.selector;
        obj.oauth = message.oauth ? OAuthRequirements.toAmino(message.oauth) : undefined;
        obj.allow_without_credential = message.allowWithoutCredential === false ? undefined : message.allowWithoutCredential;
        if (message.requirements) {
            obj.requirements = message.requirements.map(e => e ? AuthRequirement.toAmino(e) : undefined);
        }
        else {
            obj.requirements = message.requirements;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return AuthenticationRule.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return AuthenticationRule.decode(message.value);
    },
    toProto(message) {
        return AuthenticationRule.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.AuthenticationRule",
            value: AuthenticationRule.encode(message).finish()
        };
    },
    registerTypeUrl() {
        OAuthRequirements.registerTypeUrl();
        AuthRequirement.registerTypeUrl();
    }
};
function createBaseJwtLocation() {
    return {
        header: undefined,
        query: undefined,
        valuePrefix: ""
    };
}
export const JwtLocation = {
    typeUrl: "/google.api.JwtLocation",
    is(o) {
        return o && (o.$typeUrl === JwtLocation.typeUrl || typeof o.valuePrefix === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === JwtLocation.typeUrl || typeof o.value_prefix === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === JwtLocation.typeUrl || typeof o.value_prefix === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.header !== undefined) {
            writer.uint32(10).string(message.header);
        }
        if (message.query !== undefined) {
            writer.uint32(18).string(message.query);
        }
        if (message.valuePrefix !== undefined) {
            writer.uint32(26).string(message.valuePrefix);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseJwtLocation();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.header = reader.string();
                    break;
                case 2:
                    message.query = reader.string();
                    break;
                case 3:
                    message.valuePrefix = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseJwtLocation();
        if (isSet(object.header))
            obj.header = String(object.header);
        if (isSet(object.query))
            obj.query = String(object.query);
        if (isSet(object.valuePrefix))
            obj.valuePrefix = String(object.valuePrefix);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.header !== undefined && (obj.header = message.header);
        message.query !== undefined && (obj.query = message.query);
        message.valuePrefix !== undefined && (obj.valuePrefix = message.valuePrefix);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseJwtLocation();
        message.header = object.header ?? undefined;
        message.query = object.query ?? undefined;
        message.valuePrefix = object.valuePrefix ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            header: object?.header,
            query: object?.query,
            valuePrefix: object?.value_prefix
        };
    },
    fromSDKJSON(object) {
        return {
            header: isSet(object.header) ? String(object.header) : undefined,
            query: isSet(object.query) ? String(object.query) : undefined,
            value_prefix: isSet(object.value_prefix) ? String(object.value_prefix) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.header = message.header;
        obj.query = message.query;
        obj.value_prefix = message.valuePrefix;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseJwtLocation();
        if (object.header !== undefined && object.header !== null) {
            message.header = object.header;
        }
        if (object.query !== undefined && object.query !== null) {
            message.query = object.query;
        }
        if (object.value_prefix !== undefined && object.value_prefix !== null) {
            message.valuePrefix = object.value_prefix;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.header = message.header === null ? undefined : message.header;
        obj.query = message.query === null ? undefined : message.query;
        obj.value_prefix = message.valuePrefix === "" ? undefined : message.valuePrefix;
        return obj;
    },
    fromAminoMsg(object) {
        return JwtLocation.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return JwtLocation.decode(message.value);
    },
    toProto(message) {
        return JwtLocation.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.JwtLocation",
            value: JwtLocation.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseAuthProvider() {
    return {
        id: "",
        issuer: "",
        jwksUri: "",
        audiences: "",
        authorizationUrl: "",
        jwtLocations: []
    };
}
export const AuthProvider = {
    typeUrl: "/google.api.AuthProvider",
    is(o) {
        return o && (o.$typeUrl === AuthProvider.typeUrl || typeof o.id === "string" && typeof o.issuer === "string" && typeof o.jwksUri === "string" && typeof o.audiences === "string" && typeof o.authorizationUrl === "string" && Array.isArray(o.jwtLocations) && (!o.jwtLocations.length || JwtLocation.is(o.jwtLocations[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === AuthProvider.typeUrl || typeof o.id === "string" && typeof o.issuer === "string" && typeof o.jwks_uri === "string" && typeof o.audiences === "string" && typeof o.authorization_url === "string" && Array.isArray(o.jwt_locations) && (!o.jwt_locations.length || JwtLocation.isSDK(o.jwt_locations[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === AuthProvider.typeUrl || typeof o.id === "string" && typeof o.issuer === "string" && typeof o.jwks_uri === "string" && typeof o.audiences === "string" && typeof o.authorization_url === "string" && Array.isArray(o.jwt_locations) && (!o.jwt_locations.length || JwtLocation.isAmino(o.jwt_locations[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            writer.uint32(10).string(message.id);
        }
        if (message.issuer !== undefined) {
            writer.uint32(18).string(message.issuer);
        }
        if (message.jwksUri !== undefined) {
            writer.uint32(26).string(message.jwksUri);
        }
        if (message.audiences !== undefined) {
            writer.uint32(34).string(message.audiences);
        }
        if (message.authorizationUrl !== undefined) {
            writer.uint32(42).string(message.authorizationUrl);
        }
        for (const v of message.jwtLocations) {
            JwtLocation.encode(v, writer.uint32(50).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAuthProvider();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.id = reader.string();
                    break;
                case 2:
                    message.issuer = reader.string();
                    break;
                case 3:
                    message.jwksUri = reader.string();
                    break;
                case 4:
                    message.audiences = reader.string();
                    break;
                case 5:
                    message.authorizationUrl = reader.string();
                    break;
                case 6:
                    message.jwtLocations.push(JwtLocation.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAuthProvider();
        if (isSet(object.id))
            obj.id = String(object.id);
        if (isSet(object.issuer))
            obj.issuer = String(object.issuer);
        if (isSet(object.jwksUri))
            obj.jwksUri = String(object.jwksUri);
        if (isSet(object.audiences))
            obj.audiences = String(object.audiences);
        if (isSet(object.authorizationUrl))
            obj.authorizationUrl = String(object.authorizationUrl);
        if (Array.isArray(object?.jwtLocations))
            obj.jwtLocations = object.jwtLocations.map((e) => JwtLocation.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        message.issuer !== undefined && (obj.issuer = message.issuer);
        message.jwksUri !== undefined && (obj.jwksUri = message.jwksUri);
        message.audiences !== undefined && (obj.audiences = message.audiences);
        message.authorizationUrl !== undefined && (obj.authorizationUrl = message.authorizationUrl);
        if (message.jwtLocations) {
            obj.jwtLocations = message.jwtLocations.map(e => e ? JwtLocation.toJSON(e) : undefined);
        }
        else {
            obj.jwtLocations = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAuthProvider();
        message.id = object.id ?? "";
        message.issuer = object.issuer ?? "";
        message.jwksUri = object.jwksUri ?? "";
        message.audiences = object.audiences ?? "";
        message.authorizationUrl = object.authorizationUrl ?? "";
        message.jwtLocations = object.jwtLocations?.map(e => JwtLocation.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            id: object?.id,
            issuer: object?.issuer,
            jwksUri: object?.jwks_uri,
            audiences: object?.audiences,
            authorizationUrl: object?.authorization_url,
            jwtLocations: Array.isArray(object?.jwt_locations) ? object.jwt_locations.map((e) => JwtLocation.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? String(object.id) : "",
            issuer: isSet(object.issuer) ? String(object.issuer) : "",
            jwks_uri: isSet(object.jwks_uri) ? String(object.jwks_uri) : "",
            audiences: isSet(object.audiences) ? String(object.audiences) : "",
            authorization_url: isSet(object.authorization_url) ? String(object.authorization_url) : "",
            jwt_locations: Array.isArray(object?.jwt_locations) ? object.jwt_locations.map((e) => JwtLocation.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.id = message.id;
        obj.issuer = message.issuer;
        obj.jwks_uri = message.jwksUri;
        obj.audiences = message.audiences;
        obj.authorization_url = message.authorizationUrl;
        if (message.jwtLocations) {
            obj.jwt_locations = message.jwtLocations.map(e => e ? JwtLocation.toSDK(e) : undefined);
        }
        else {
            obj.jwt_locations = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAuthProvider();
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        if (object.issuer !== undefined && object.issuer !== null) {
            message.issuer = object.issuer;
        }
        if (object.jwks_uri !== undefined && object.jwks_uri !== null) {
            message.jwksUri = object.jwks_uri;
        }
        if (object.audiences !== undefined && object.audiences !== null) {
            message.audiences = object.audiences;
        }
        if (object.authorization_url !== undefined && object.authorization_url !== null) {
            message.authorizationUrl = object.authorization_url;
        }
        message.jwtLocations = object.jwt_locations?.map(e => JwtLocation.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id === "" ? undefined : message.id;
        obj.issuer = message.issuer === "" ? undefined : message.issuer;
        obj.jwks_uri = message.jwksUri === "" ? undefined : message.jwksUri;
        obj.audiences = message.audiences === "" ? undefined : message.audiences;
        obj.authorization_url = message.authorizationUrl === "" ? undefined : message.authorizationUrl;
        if (message.jwtLocations) {
            obj.jwt_locations = message.jwtLocations.map(e => e ? JwtLocation.toAmino(e) : undefined);
        }
        else {
            obj.jwt_locations = message.jwtLocations;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return AuthProvider.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return AuthProvider.decode(message.value);
    },
    toProto(message) {
        return AuthProvider.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.AuthProvider",
            value: AuthProvider.encode(message).finish()
        };
    },
    registerTypeUrl() {
        JwtLocation.registerTypeUrl();
    }
};
function createBaseOAuthRequirements() {
    return {
        canonicalScopes: ""
    };
}
export const OAuthRequirements = {
    typeUrl: "/google.api.OAuthRequirements",
    is(o) {
        return o && (o.$typeUrl === OAuthRequirements.typeUrl || typeof o.canonicalScopes === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === OAuthRequirements.typeUrl || typeof o.canonical_scopes === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === OAuthRequirements.typeUrl || typeof o.canonical_scopes === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.canonicalScopes !== undefined) {
            writer.uint32(10).string(message.canonicalScopes);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseOAuthRequirements();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.canonicalScopes = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseOAuthRequirements();
        if (isSet(object.canonicalScopes))
            obj.canonicalScopes = String(object.canonicalScopes);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.canonicalScopes !== undefined && (obj.canonicalScopes = message.canonicalScopes);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseOAuthRequirements();
        message.canonicalScopes = object.canonicalScopes ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            canonicalScopes: object?.canonical_scopes
        };
    },
    fromSDKJSON(object) {
        return {
            canonical_scopes: isSet(object.canonical_scopes) ? String(object.canonical_scopes) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.canonical_scopes = message.canonicalScopes;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseOAuthRequirements();
        if (object.canonical_scopes !== undefined && object.canonical_scopes !== null) {
            message.canonicalScopes = object.canonical_scopes;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.canonical_scopes = message.canonicalScopes === "" ? undefined : message.canonicalScopes;
        return obj;
    },
    fromAminoMsg(object) {
        return OAuthRequirements.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return OAuthRequirements.decode(message.value);
    },
    toProto(message) {
        return OAuthRequirements.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.OAuthRequirements",
            value: OAuthRequirements.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseAuthRequirement() {
    return {
        providerId: "",
        audiences: ""
    };
}
export const AuthRequirement = {
    typeUrl: "/google.api.AuthRequirement",
    is(o) {
        return o && (o.$typeUrl === AuthRequirement.typeUrl || typeof o.providerId === "string" && typeof o.audiences === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === AuthRequirement.typeUrl || typeof o.provider_id === "string" && typeof o.audiences === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === AuthRequirement.typeUrl || typeof o.provider_id === "string" && typeof o.audiences === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.providerId !== undefined) {
            writer.uint32(10).string(message.providerId);
        }
        if (message.audiences !== undefined) {
            writer.uint32(18).string(message.audiences);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseAuthRequirement();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.providerId = reader.string();
                    break;
                case 2:
                    message.audiences = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseAuthRequirement();
        if (isSet(object.providerId))
            obj.providerId = String(object.providerId);
        if (isSet(object.audiences))
            obj.audiences = String(object.audiences);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.providerId !== undefined && (obj.providerId = message.providerId);
        message.audiences !== undefined && (obj.audiences = message.audiences);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseAuthRequirement();
        message.providerId = object.providerId ?? "";
        message.audiences = object.audiences ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            providerId: object?.provider_id,
            audiences: object?.audiences
        };
    },
    fromSDKJSON(object) {
        return {
            provider_id: isSet(object.provider_id) ? String(object.provider_id) : "",
            audiences: isSet(object.audiences) ? String(object.audiences) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.provider_id = message.providerId;
        obj.audiences = message.audiences;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseAuthRequirement();
        if (object.provider_id !== undefined && object.provider_id !== null) {
            message.providerId = object.provider_id;
        }
        if (object.audiences !== undefined && object.audiences !== null) {
            message.audiences = object.audiences;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.provider_id = message.providerId === "" ? undefined : message.providerId;
        obj.audiences = message.audiences === "" ? undefined : message.audiences;
        return obj;
    },
    fromAminoMsg(object) {
        return AuthRequirement.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return AuthRequirement.decode(message.value);
    },
    toProto(message) {
        return AuthRequirement.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.AuthRequirement",
            value: AuthRequirement.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
