import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseContext() {
    return {
        rules: []
    };
}
export const Context = {
    typeUrl: "/google.api.Context",
    is(o) {
        return o && (o.$typeUrl === Context.typeUrl || Array.isArray(o.rules) && (!o.rules.length || ContextRule.is(o.rules[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Context.typeUrl || Array.isArray(o.rules) && (!o.rules.length || ContextRule.isSDK(o.rules[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Context.typeUrl || Array.isArray(o.rules) && (!o.rules.length || ContextRule.isAmino(o.rules[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.rules) {
            ContextRule.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContext();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.rules.push(ContextRule.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseContext();
        if (Array.isArray(object?.rules))
            obj.rules = object.rules.map((e) => ContextRule.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? ContextRule.toJSON(e) : undefined);
        }
        else {
            obj.rules = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseContext();
        message.rules = object.rules?.map(e => ContextRule.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            rules: Array.isArray(object?.rules) ? object.rules.map((e) => ContextRule.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            rules: Array.isArray(object?.rules) ? object.rules.map((e) => ContextRule.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? ContextRule.toSDK(e) : undefined);
        }
        else {
            obj.rules = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseContext();
        message.rules = object.rules?.map(e => ContextRule.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? ContextRule.toAmino(e) : undefined);
        }
        else {
            obj.rules = message.rules;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Context.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Context.decode(message.value);
    },
    toProto(message) {
        return Context.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Context",
            value: Context.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ContextRule.registerTypeUrl();
    }
};
function createBaseContextRule() {
    return {
        selector: "",
        requested: [],
        provided: [],
        allowedRequestExtensions: [],
        allowedResponseExtensions: []
    };
}
export const ContextRule = {
    typeUrl: "/google.api.ContextRule",
    is(o) {
        return o && (o.$typeUrl === ContextRule.typeUrl || typeof o.selector === "string" && Array.isArray(o.requested) && (!o.requested.length || typeof o.requested[0] === "string") && Array.isArray(o.provided) && (!o.provided.length || typeof o.provided[0] === "string") && Array.isArray(o.allowedRequestExtensions) && (!o.allowedRequestExtensions.length || typeof o.allowedRequestExtensions[0] === "string") && Array.isArray(o.allowedResponseExtensions) && (!o.allowedResponseExtensions.length || typeof o.allowedResponseExtensions[0] === "string"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === ContextRule.typeUrl || typeof o.selector === "string" && Array.isArray(o.requested) && (!o.requested.length || typeof o.requested[0] === "string") && Array.isArray(o.provided) && (!o.provided.length || typeof o.provided[0] === "string") && Array.isArray(o.allowed_request_extensions) && (!o.allowed_request_extensions.length || typeof o.allowed_request_extensions[0] === "string") && Array.isArray(o.allowed_response_extensions) && (!o.allowed_response_extensions.length || typeof o.allowed_response_extensions[0] === "string"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === ContextRule.typeUrl || typeof o.selector === "string" && Array.isArray(o.requested) && (!o.requested.length || typeof o.requested[0] === "string") && Array.isArray(o.provided) && (!o.provided.length || typeof o.provided[0] === "string") && Array.isArray(o.allowed_request_extensions) && (!o.allowed_request_extensions.length || typeof o.allowed_request_extensions[0] === "string") && Array.isArray(o.allowed_response_extensions) && (!o.allowed_response_extensions.length || typeof o.allowed_response_extensions[0] === "string"));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.selector !== undefined) {
            writer.uint32(10).string(message.selector);
        }
        for (const v of message.requested) {
            writer.uint32(18).string(v);
        }
        for (const v of message.provided) {
            writer.uint32(26).string(v);
        }
        for (const v of message.allowedRequestExtensions) {
            writer.uint32(34).string(v);
        }
        for (const v of message.allowedResponseExtensions) {
            writer.uint32(42).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseContextRule();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.selector = reader.string();
                    break;
                case 2:
                    message.requested.push(reader.string());
                    break;
                case 3:
                    message.provided.push(reader.string());
                    break;
                case 4:
                    message.allowedRequestExtensions.push(reader.string());
                    break;
                case 5:
                    message.allowedResponseExtensions.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseContextRule();
        if (isSet(object.selector))
            obj.selector = String(object.selector);
        if (Array.isArray(object?.requested))
            obj.requested = object.requested.map((e) => String(e));
        if (Array.isArray(object?.provided))
            obj.provided = object.provided.map((e) => String(e));
        if (Array.isArray(object?.allowedRequestExtensions))
            obj.allowedRequestExtensions = object.allowedRequestExtensions.map((e) => String(e));
        if (Array.isArray(object?.allowedResponseExtensions))
            obj.allowedResponseExtensions = object.allowedResponseExtensions.map((e) => String(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.selector !== undefined && (obj.selector = message.selector);
        if (message.requested) {
            obj.requested = message.requested.map(e => e);
        }
        else {
            obj.requested = [];
        }
        if (message.provided) {
            obj.provided = message.provided.map(e => e);
        }
        else {
            obj.provided = [];
        }
        if (message.allowedRequestExtensions) {
            obj.allowedRequestExtensions = message.allowedRequestExtensions.map(e => e);
        }
        else {
            obj.allowedRequestExtensions = [];
        }
        if (message.allowedResponseExtensions) {
            obj.allowedResponseExtensions = message.allowedResponseExtensions.map(e => e);
        }
        else {
            obj.allowedResponseExtensions = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseContextRule();
        message.selector = object.selector ?? "";
        message.requested = object.requested?.map(e => e) || [];
        message.provided = object.provided?.map(e => e) || [];
        message.allowedRequestExtensions = object.allowedRequestExtensions?.map(e => e) || [];
        message.allowedResponseExtensions = object.allowedResponseExtensions?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            selector: object?.selector,
            requested: Array.isArray(object?.requested) ? object.requested.map((e) => e) : [],
            provided: Array.isArray(object?.provided) ? object.provided.map((e) => e) : [],
            allowedRequestExtensions: Array.isArray(object?.allowed_request_extensions) ? object.allowed_request_extensions.map((e) => e) : [],
            allowedResponseExtensions: Array.isArray(object?.allowed_response_extensions) ? object.allowed_response_extensions.map((e) => e) : []
        };
    },
    fromSDKJSON(object) {
        return {
            selector: isSet(object.selector) ? String(object.selector) : "",
            requested: Array.isArray(object?.requested) ? object.requested.map((e) => String(e)) : [],
            provided: Array.isArray(object?.provided) ? object.provided.map((e) => String(e)) : [],
            allowed_request_extensions: Array.isArray(object?.allowed_request_extensions) ? object.allowed_request_extensions.map((e) => String(e)) : [],
            allowed_response_extensions: Array.isArray(object?.allowed_response_extensions) ? object.allowed_response_extensions.map((e) => String(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.selector = message.selector;
        if (message.requested) {
            obj.requested = message.requested.map(e => e);
        }
        else {
            obj.requested = [];
        }
        if (message.provided) {
            obj.provided = message.provided.map(e => e);
        }
        else {
            obj.provided = [];
        }
        if (message.allowedRequestExtensions) {
            obj.allowed_request_extensions = message.allowedRequestExtensions.map(e => e);
        }
        else {
            obj.allowed_request_extensions = [];
        }
        if (message.allowedResponseExtensions) {
            obj.allowed_response_extensions = message.allowedResponseExtensions.map(e => e);
        }
        else {
            obj.allowed_response_extensions = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseContextRule();
        if (object.selector !== undefined && object.selector !== null) {
            message.selector = object.selector;
        }
        message.requested = object.requested?.map(e => e) || [];
        message.provided = object.provided?.map(e => e) || [];
        message.allowedRequestExtensions = object.allowed_request_extensions?.map(e => e) || [];
        message.allowedResponseExtensions = object.allowed_response_extensions?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.selector = message.selector === "" ? undefined : message.selector;
        if (message.requested) {
            obj.requested = message.requested.map(e => e);
        }
        else {
            obj.requested = message.requested;
        }
        if (message.provided) {
            obj.provided = message.provided.map(e => e);
        }
        else {
            obj.provided = message.provided;
        }
        if (message.allowedRequestExtensions) {
            obj.allowed_request_extensions = message.allowedRequestExtensions.map(e => e);
        }
        else {
            obj.allowed_request_extensions = message.allowedRequestExtensions;
        }
        if (message.allowedResponseExtensions) {
            obj.allowed_response_extensions = message.allowedResponseExtensions.map(e => e);
        }
        else {
            obj.allowed_response_extensions = message.allowedResponseExtensions;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return ContextRule.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ContextRule.decode(message.value);
    },
    toProto(message) {
        return ContextRule.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.ContextRule",
            value: ContextRule.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
