import { BinaryReader, BinaryWriter } from "../../binary";
import { DeepPartial } from "../../helpers";
import { JsonSafe } from "../../json-safe";
export declare const protobufPackage = "google.api";
/**
 * Selects and configures the service controller used by the service.  The
 * service controller handles features like abuse, quota, billing, logging,
 * monitoring, etc.
 */
export interface Control {
    /**
     * The service control environment to use. If empty, no control plane
     * feature (like quota and billing) will be enabled.
     */
    environment: string;
}
export interface ControlProtoMsg {
    typeUrl: "/google.api.Control";
    value: Uint8Array;
}
/**
 * Selects and configures the service controller used by the service.  The
 * service controller handles features like abuse, quota, billing, logging,
 * monitoring, etc.
 */
export interface ControlAmino {
    /**
     * The service control environment to use. If empty, no control plane
     * feature (like quota and billing) will be enabled.
     */
    environment?: string;
}
export interface ControlAminoMsg {
    type: "/google.api.Control";
    value: ControlAmino;
}
/**
 * Selects and configures the service controller used by the service.  The
 * service controller handles features like abuse, quota, billing, logging,
 * monitoring, etc.
 */
export interface ControlSDKType {
    environment: string;
}
export declare const Control: {
    typeUrl: string;
    is(o: any): o is Control;
    isSDK(o: any): o is ControlSDKType;
    isAmino(o: any): o is ControlAmino;
    encode(message: Control, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Control;
    fromJSON(object: any): Control;
    toJSON(message: Control): JsonSafe<Control>;
    fromPartial(object: DeepPartial<Control>): Control;
    fromSDK(object: ControlSDKType): Control;
    fromSDKJSON(object: any): ControlSDKType;
    toSDK(message: Control): ControlSDKType;
    fromAmino(object: ControlAmino): Control;
    toAmino(message: Control): ControlAmino;
    fromAminoMsg(object: ControlAminoMsg): Control;
    fromProtoMsg(message: ControlProtoMsg): Control;
    toProto(message: Control): Uint8Array;
    toProtoMsg(message: Control): ControlProtoMsg;
    registerTypeUrl(): void;
};
