import { Timestamp } from "../protobuf/timestamp";
import { Any } from "../protobuf/any";
import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet, toTimestamp, fromTimestamp } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseDistribution() {
    return {
        count: BigInt(0),
        mean: 0,
        sumOfSquaredDeviation: 0,
        range: undefined,
        bucketOptions: undefined,
        bucketCounts: [],
        exemplars: []
    };
}
export const Distribution = {
    typeUrl: "/google.api.Distribution",
    is(o) {
        return o && (o.$typeUrl === Distribution.typeUrl || typeof o.count === "bigint" && typeof o.mean === "number" && typeof o.sumOfSquaredDeviation === "number" && Array.isArray(o.bucketCounts) && (!o.bucketCounts.length || typeof o.bucketCounts[0] === "bigint") && Array.isArray(o.exemplars) && (!o.exemplars.length || Distribution_Exemplar.is(o.exemplars[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Distribution.typeUrl || typeof o.count === "bigint" && typeof o.mean === "number" && typeof o.sum_of_squared_deviation === "number" && Array.isArray(o.bucket_counts) && (!o.bucket_counts.length || typeof o.bucket_counts[0] === "bigint") && Array.isArray(o.exemplars) && (!o.exemplars.length || Distribution_Exemplar.isSDK(o.exemplars[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Distribution.typeUrl || typeof o.count === "bigint" && typeof o.mean === "number" && typeof o.sum_of_squared_deviation === "number" && Array.isArray(o.bucket_counts) && (!o.bucket_counts.length || typeof o.bucket_counts[0] === "bigint") && Array.isArray(o.exemplars) && (!o.exemplars.length || Distribution_Exemplar.isAmino(o.exemplars[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.count !== undefined) {
            writer.uint32(8).int64(message.count);
        }
        if (message.mean !== undefined) {
            writer.uint32(17).double(message.mean);
        }
        if (message.sumOfSquaredDeviation !== undefined) {
            writer.uint32(25).double(message.sumOfSquaredDeviation);
        }
        if (message.range !== undefined) {
            Distribution_Range.encode(message.range, writer.uint32(34).fork()).ldelim();
        }
        if (message.bucketOptions !== undefined) {
            Distribution_BucketOptions.encode(message.bucketOptions, writer.uint32(50).fork()).ldelim();
        }
        writer.uint32(58).fork();
        for (const v of message.bucketCounts) {
            writer.int64(v);
        }
        writer.ldelim();
        for (const v of message.exemplars) {
            Distribution_Exemplar.encode(v, writer.uint32(82).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDistribution();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.count = reader.int64();
                    break;
                case 2:
                    message.mean = reader.double();
                    break;
                case 3:
                    message.sumOfSquaredDeviation = reader.double();
                    break;
                case 4:
                    message.range = Distribution_Range.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.bucketOptions = Distribution_BucketOptions.decode(reader, reader.uint32());
                    break;
                case 7:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.bucketCounts.push(reader.int64());
                        }
                    }
                    else {
                        message.bucketCounts.push(reader.int64());
                    }
                    break;
                case 10:
                    message.exemplars.push(Distribution_Exemplar.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDistribution();
        if (isSet(object.count))
            obj.count = BigInt(object.count.toString());
        if (isSet(object.mean))
            obj.mean = Number(object.mean);
        if (isSet(object.sumOfSquaredDeviation))
            obj.sumOfSquaredDeviation = Number(object.sumOfSquaredDeviation);
        if (isSet(object.range))
            obj.range = Distribution_Range.fromJSON(object.range);
        if (isSet(object.bucketOptions))
            obj.bucketOptions = Distribution_BucketOptions.fromJSON(object.bucketOptions);
        if (Array.isArray(object?.bucketCounts))
            obj.bucketCounts = object.bucketCounts.map((e) => BigInt(e.toString()));
        if (Array.isArray(object?.exemplars))
            obj.exemplars = object.exemplars.map((e) => Distribution_Exemplar.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.count !== undefined && (obj.count = (message.count || BigInt(0)).toString());
        message.mean !== undefined && (obj.mean = message.mean);
        message.sumOfSquaredDeviation !== undefined && (obj.sumOfSquaredDeviation = message.sumOfSquaredDeviation);
        message.range !== undefined && (obj.range = message.range ? Distribution_Range.toJSON(message.range) : undefined);
        message.bucketOptions !== undefined && (obj.bucketOptions = message.bucketOptions ? Distribution_BucketOptions.toJSON(message.bucketOptions) : undefined);
        if (message.bucketCounts) {
            obj.bucketCounts = message.bucketCounts.map(e => (e || BigInt(0)).toString());
        }
        else {
            obj.bucketCounts = [];
        }
        if (message.exemplars) {
            obj.exemplars = message.exemplars.map(e => e ? Distribution_Exemplar.toJSON(e) : undefined);
        }
        else {
            obj.exemplars = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDistribution();
        if (object.count !== undefined && object.count !== null) {
            message.count = BigInt(object.count.toString());
        }
        message.mean = object.mean ?? 0;
        message.sumOfSquaredDeviation = object.sumOfSquaredDeviation ?? 0;
        if (object.range !== undefined && object.range !== null) {
            message.range = Distribution_Range.fromPartial(object.range);
        }
        if (object.bucketOptions !== undefined && object.bucketOptions !== null) {
            message.bucketOptions = Distribution_BucketOptions.fromPartial(object.bucketOptions);
        }
        message.bucketCounts = object.bucketCounts?.map(e => BigInt(e.toString())) || [];
        message.exemplars = object.exemplars?.map(e => Distribution_Exemplar.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            count: object?.count,
            mean: object?.mean,
            sumOfSquaredDeviation: object?.sum_of_squared_deviation,
            range: object.range ? Distribution_Range.fromSDK(object.range) : undefined,
            bucketOptions: object.bucket_options ? Distribution_BucketOptions.fromSDK(object.bucket_options) : undefined,
            bucketCounts: Array.isArray(object?.bucket_counts) ? object.bucket_counts.map((e) => e) : [],
            exemplars: Array.isArray(object?.exemplars) ? object.exemplars.map((e) => Distribution_Exemplar.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            count: isSet(object.count) ? BigInt(object.count.toString()) : BigInt(0),
            mean: isSet(object.mean) ? Number(object.mean) : 0,
            sum_of_squared_deviation: isSet(object.sum_of_squared_deviation) ? Number(object.sum_of_squared_deviation) : 0,
            range: isSet(object.range) ? Distribution_Range.fromSDKJSON(object.range) : undefined,
            bucket_options: isSet(object.bucket_options) ? Distribution_BucketOptions.fromSDKJSON(object.bucket_options) : undefined,
            bucket_counts: Array.isArray(object?.bucket_counts) ? object.bucket_counts.map((e) => BigInt(e.toString())) : [],
            exemplars: Array.isArray(object?.exemplars) ? object.exemplars.map((e) => Distribution_Exemplar.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.count = message.count;
        obj.mean = message.mean;
        obj.sum_of_squared_deviation = message.sumOfSquaredDeviation;
        message.range !== undefined && (obj.range = message.range ? Distribution_Range.toSDK(message.range) : undefined);
        message.bucketOptions !== undefined && (obj.bucket_options = message.bucketOptions ? Distribution_BucketOptions.toSDK(message.bucketOptions) : undefined);
        if (message.bucketCounts) {
            obj.bucket_counts = message.bucketCounts.map(e => e);
        }
        else {
            obj.bucket_counts = [];
        }
        if (message.exemplars) {
            obj.exemplars = message.exemplars.map(e => e ? Distribution_Exemplar.toSDK(e) : undefined);
        }
        else {
            obj.exemplars = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDistribution();
        if (object.count !== undefined && object.count !== null) {
            message.count = BigInt(object.count);
        }
        if (object.mean !== undefined && object.mean !== null) {
            message.mean = object.mean;
        }
        if (object.sum_of_squared_deviation !== undefined && object.sum_of_squared_deviation !== null) {
            message.sumOfSquaredDeviation = object.sum_of_squared_deviation;
        }
        if (object.range !== undefined && object.range !== null) {
            message.range = Distribution_Range.fromAmino(object.range);
        }
        if (object.bucket_options !== undefined && object.bucket_options !== null) {
            message.bucketOptions = Distribution_BucketOptions.fromAmino(object.bucket_options);
        }
        message.bucketCounts = object.bucket_counts?.map(e => BigInt(e)) || [];
        message.exemplars = object.exemplars?.map(e => Distribution_Exemplar.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.count = message.count !== BigInt(0) ? message.count?.toString() : undefined;
        obj.mean = message.mean === 0 ? undefined : message.mean;
        obj.sum_of_squared_deviation = message.sumOfSquaredDeviation === 0 ? undefined : message.sumOfSquaredDeviation;
        obj.range = message.range ? Distribution_Range.toAmino(message.range) : undefined;
        obj.bucket_options = message.bucketOptions ? Distribution_BucketOptions.toAmino(message.bucketOptions) : undefined;
        if (message.bucketCounts) {
            obj.bucket_counts = message.bucketCounts.map(e => e.toString());
        }
        else {
            obj.bucket_counts = message.bucketCounts;
        }
        if (message.exemplars) {
            obj.exemplars = message.exemplars.map(e => e ? Distribution_Exemplar.toAmino(e) : undefined);
        }
        else {
            obj.exemplars = message.exemplars;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Distribution.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Distribution.decode(message.value);
    },
    toProto(message) {
        return Distribution.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Distribution",
            value: Distribution.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Distribution_Range.registerTypeUrl();
        Distribution_BucketOptions.registerTypeUrl();
        Distribution_Exemplar.registerTypeUrl();
    }
};
function createBaseDistribution_Range() {
    return {
        min: 0,
        max: 0
    };
}
export const Distribution_Range = {
    typeUrl: "/google.api.Range",
    is(o) {
        return o && (o.$typeUrl === Distribution_Range.typeUrl || typeof o.min === "number" && typeof o.max === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Distribution_Range.typeUrl || typeof o.min === "number" && typeof o.max === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Distribution_Range.typeUrl || typeof o.min === "number" && typeof o.max === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.min !== undefined) {
            writer.uint32(9).double(message.min);
        }
        if (message.max !== undefined) {
            writer.uint32(17).double(message.max);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDistribution_Range();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.min = reader.double();
                    break;
                case 2:
                    message.max = reader.double();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDistribution_Range();
        if (isSet(object.min))
            obj.min = Number(object.min);
        if (isSet(object.max))
            obj.max = Number(object.max);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.min !== undefined && (obj.min = message.min);
        message.max !== undefined && (obj.max = message.max);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDistribution_Range();
        message.min = object.min ?? 0;
        message.max = object.max ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            min: object?.min,
            max: object?.max
        };
    },
    fromSDKJSON(object) {
        return {
            min: isSet(object.min) ? Number(object.min) : 0,
            max: isSet(object.max) ? Number(object.max) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.min = message.min;
        obj.max = message.max;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDistribution_Range();
        if (object.min !== undefined && object.min !== null) {
            message.min = object.min;
        }
        if (object.max !== undefined && object.max !== null) {
            message.max = object.max;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.min = message.min === 0 ? undefined : message.min;
        obj.max = message.max === 0 ? undefined : message.max;
        return obj;
    },
    fromAminoMsg(object) {
        return Distribution_Range.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Distribution_Range.decode(message.value);
    },
    toProto(message) {
        return Distribution_Range.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Range",
            value: Distribution_Range.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseDistribution_BucketOptions() {
    return {
        linearBuckets: undefined,
        exponentialBuckets: undefined,
        explicitBuckets: undefined
    };
}
export const Distribution_BucketOptions = {
    typeUrl: "/google.api.BucketOptions",
    is(o) {
        return o && o.$typeUrl === Distribution_BucketOptions.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === Distribution_BucketOptions.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === Distribution_BucketOptions.typeUrl;
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.linearBuckets !== undefined) {
            Distribution_BucketOptions_Linear.encode(message.linearBuckets, writer.uint32(10).fork()).ldelim();
        }
        if (message.exponentialBuckets !== undefined) {
            Distribution_BucketOptions_Exponential.encode(message.exponentialBuckets, writer.uint32(18).fork()).ldelim();
        }
        if (message.explicitBuckets !== undefined) {
            Distribution_BucketOptions_Explicit.encode(message.explicitBuckets, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDistribution_BucketOptions();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.linearBuckets = Distribution_BucketOptions_Linear.decode(reader, reader.uint32());
                    break;
                case 2:
                    message.exponentialBuckets = Distribution_BucketOptions_Exponential.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.explicitBuckets = Distribution_BucketOptions_Explicit.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDistribution_BucketOptions();
        if (isSet(object.linearBuckets))
            obj.linearBuckets = Distribution_BucketOptions_Linear.fromJSON(object.linearBuckets);
        if (isSet(object.exponentialBuckets))
            obj.exponentialBuckets = Distribution_BucketOptions_Exponential.fromJSON(object.exponentialBuckets);
        if (isSet(object.explicitBuckets))
            obj.explicitBuckets = Distribution_BucketOptions_Explicit.fromJSON(object.explicitBuckets);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.linearBuckets !== undefined && (obj.linearBuckets = message.linearBuckets ? Distribution_BucketOptions_Linear.toJSON(message.linearBuckets) : undefined);
        message.exponentialBuckets !== undefined && (obj.exponentialBuckets = message.exponentialBuckets ? Distribution_BucketOptions_Exponential.toJSON(message.exponentialBuckets) : undefined);
        message.explicitBuckets !== undefined && (obj.explicitBuckets = message.explicitBuckets ? Distribution_BucketOptions_Explicit.toJSON(message.explicitBuckets) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDistribution_BucketOptions();
        if (object.linearBuckets !== undefined && object.linearBuckets !== null) {
            message.linearBuckets = Distribution_BucketOptions_Linear.fromPartial(object.linearBuckets);
        }
        if (object.exponentialBuckets !== undefined && object.exponentialBuckets !== null) {
            message.exponentialBuckets = Distribution_BucketOptions_Exponential.fromPartial(object.exponentialBuckets);
        }
        if (object.explicitBuckets !== undefined && object.explicitBuckets !== null) {
            message.explicitBuckets = Distribution_BucketOptions_Explicit.fromPartial(object.explicitBuckets);
        }
        return message;
    },
    fromSDK(object) {
        return {
            linearBuckets: object.linear_buckets ? Distribution_BucketOptions_Linear.fromSDK(object.linear_buckets) : undefined,
            exponentialBuckets: object.exponential_buckets ? Distribution_BucketOptions_Exponential.fromSDK(object.exponential_buckets) : undefined,
            explicitBuckets: object.explicit_buckets ? Distribution_BucketOptions_Explicit.fromSDK(object.explicit_buckets) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            linear_buckets: isSet(object.linear_buckets) ? Distribution_BucketOptions_Linear.fromSDKJSON(object.linear_buckets) : undefined,
            exponential_buckets: isSet(object.exponential_buckets) ? Distribution_BucketOptions_Exponential.fromSDKJSON(object.exponential_buckets) : undefined,
            explicit_buckets: isSet(object.explicit_buckets) ? Distribution_BucketOptions_Explicit.fromSDKJSON(object.explicit_buckets) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        message.linearBuckets !== undefined && (obj.linear_buckets = message.linearBuckets ? Distribution_BucketOptions_Linear.toSDK(message.linearBuckets) : undefined);
        message.exponentialBuckets !== undefined && (obj.exponential_buckets = message.exponentialBuckets ? Distribution_BucketOptions_Exponential.toSDK(message.exponentialBuckets) : undefined);
        message.explicitBuckets !== undefined && (obj.explicit_buckets = message.explicitBuckets ? Distribution_BucketOptions_Explicit.toSDK(message.explicitBuckets) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDistribution_BucketOptions();
        if (object.linear_buckets !== undefined && object.linear_buckets !== null) {
            message.linearBuckets = Distribution_BucketOptions_Linear.fromAmino(object.linear_buckets);
        }
        if (object.exponential_buckets !== undefined && object.exponential_buckets !== null) {
            message.exponentialBuckets = Distribution_BucketOptions_Exponential.fromAmino(object.exponential_buckets);
        }
        if (object.explicit_buckets !== undefined && object.explicit_buckets !== null) {
            message.explicitBuckets = Distribution_BucketOptions_Explicit.fromAmino(object.explicit_buckets);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.linear_buckets = message.linearBuckets ? Distribution_BucketOptions_Linear.toAmino(message.linearBuckets) : undefined;
        obj.exponential_buckets = message.exponentialBuckets ? Distribution_BucketOptions_Exponential.toAmino(message.exponentialBuckets) : undefined;
        obj.explicit_buckets = message.explicitBuckets ? Distribution_BucketOptions_Explicit.toAmino(message.explicitBuckets) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return Distribution_BucketOptions.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Distribution_BucketOptions.decode(message.value);
    },
    toProto(message) {
        return Distribution_BucketOptions.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.BucketOptions",
            value: Distribution_BucketOptions.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Distribution_BucketOptions_Linear.registerTypeUrl();
        Distribution_BucketOptions_Exponential.registerTypeUrl();
        Distribution_BucketOptions_Explicit.registerTypeUrl();
    }
};
function createBaseDistribution_BucketOptions_Linear() {
    return {
        numFiniteBuckets: 0,
        width: 0,
        offset: 0
    };
}
export const Distribution_BucketOptions_Linear = {
    typeUrl: "/google.api.Linear",
    is(o) {
        return o && (o.$typeUrl === Distribution_BucketOptions_Linear.typeUrl || typeof o.numFiniteBuckets === "number" && typeof o.width === "number" && typeof o.offset === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Distribution_BucketOptions_Linear.typeUrl || typeof o.num_finite_buckets === "number" && typeof o.width === "number" && typeof o.offset === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Distribution_BucketOptions_Linear.typeUrl || typeof o.num_finite_buckets === "number" && typeof o.width === "number" && typeof o.offset === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.numFiniteBuckets !== undefined) {
            writer.uint32(8).int32(message.numFiniteBuckets);
        }
        if (message.width !== undefined) {
            writer.uint32(17).double(message.width);
        }
        if (message.offset !== undefined) {
            writer.uint32(25).double(message.offset);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDistribution_BucketOptions_Linear();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.numFiniteBuckets = reader.int32();
                    break;
                case 2:
                    message.width = reader.double();
                    break;
                case 3:
                    message.offset = reader.double();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDistribution_BucketOptions_Linear();
        if (isSet(object.numFiniteBuckets))
            obj.numFiniteBuckets = Number(object.numFiniteBuckets);
        if (isSet(object.width))
            obj.width = Number(object.width);
        if (isSet(object.offset))
            obj.offset = Number(object.offset);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.numFiniteBuckets !== undefined && (obj.numFiniteBuckets = Math.round(message.numFiniteBuckets));
        message.width !== undefined && (obj.width = message.width);
        message.offset !== undefined && (obj.offset = message.offset);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDistribution_BucketOptions_Linear();
        message.numFiniteBuckets = object.numFiniteBuckets ?? 0;
        message.width = object.width ?? 0;
        message.offset = object.offset ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            numFiniteBuckets: object?.num_finite_buckets,
            width: object?.width,
            offset: object?.offset
        };
    },
    fromSDKJSON(object) {
        return {
            num_finite_buckets: isSet(object.num_finite_buckets) ? Number(object.num_finite_buckets) : 0,
            width: isSet(object.width) ? Number(object.width) : 0,
            offset: isSet(object.offset) ? Number(object.offset) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.num_finite_buckets = message.numFiniteBuckets;
        obj.width = message.width;
        obj.offset = message.offset;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDistribution_BucketOptions_Linear();
        if (object.num_finite_buckets !== undefined && object.num_finite_buckets !== null) {
            message.numFiniteBuckets = object.num_finite_buckets;
        }
        if (object.width !== undefined && object.width !== null) {
            message.width = object.width;
        }
        if (object.offset !== undefined && object.offset !== null) {
            message.offset = object.offset;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.num_finite_buckets = message.numFiniteBuckets === 0 ? undefined : message.numFiniteBuckets;
        obj.width = message.width === 0 ? undefined : message.width;
        obj.offset = message.offset === 0 ? undefined : message.offset;
        return obj;
    },
    fromAminoMsg(object) {
        return Distribution_BucketOptions_Linear.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Distribution_BucketOptions_Linear.decode(message.value);
    },
    toProto(message) {
        return Distribution_BucketOptions_Linear.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Linear",
            value: Distribution_BucketOptions_Linear.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseDistribution_BucketOptions_Exponential() {
    return {
        numFiniteBuckets: 0,
        growthFactor: 0,
        scale: 0
    };
}
export const Distribution_BucketOptions_Exponential = {
    typeUrl: "/google.api.Exponential",
    is(o) {
        return o && (o.$typeUrl === Distribution_BucketOptions_Exponential.typeUrl || typeof o.numFiniteBuckets === "number" && typeof o.growthFactor === "number" && typeof o.scale === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Distribution_BucketOptions_Exponential.typeUrl || typeof o.num_finite_buckets === "number" && typeof o.growth_factor === "number" && typeof o.scale === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Distribution_BucketOptions_Exponential.typeUrl || typeof o.num_finite_buckets === "number" && typeof o.growth_factor === "number" && typeof o.scale === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.numFiniteBuckets !== undefined) {
            writer.uint32(8).int32(message.numFiniteBuckets);
        }
        if (message.growthFactor !== undefined) {
            writer.uint32(17).double(message.growthFactor);
        }
        if (message.scale !== undefined) {
            writer.uint32(25).double(message.scale);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDistribution_BucketOptions_Exponential();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.numFiniteBuckets = reader.int32();
                    break;
                case 2:
                    message.growthFactor = reader.double();
                    break;
                case 3:
                    message.scale = reader.double();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDistribution_BucketOptions_Exponential();
        if (isSet(object.numFiniteBuckets))
            obj.numFiniteBuckets = Number(object.numFiniteBuckets);
        if (isSet(object.growthFactor))
            obj.growthFactor = Number(object.growthFactor);
        if (isSet(object.scale))
            obj.scale = Number(object.scale);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.numFiniteBuckets !== undefined && (obj.numFiniteBuckets = Math.round(message.numFiniteBuckets));
        message.growthFactor !== undefined && (obj.growthFactor = message.growthFactor);
        message.scale !== undefined && (obj.scale = message.scale);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDistribution_BucketOptions_Exponential();
        message.numFiniteBuckets = object.numFiniteBuckets ?? 0;
        message.growthFactor = object.growthFactor ?? 0;
        message.scale = object.scale ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            numFiniteBuckets: object?.num_finite_buckets,
            growthFactor: object?.growth_factor,
            scale: object?.scale
        };
    },
    fromSDKJSON(object) {
        return {
            num_finite_buckets: isSet(object.num_finite_buckets) ? Number(object.num_finite_buckets) : 0,
            growth_factor: isSet(object.growth_factor) ? Number(object.growth_factor) : 0,
            scale: isSet(object.scale) ? Number(object.scale) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.num_finite_buckets = message.numFiniteBuckets;
        obj.growth_factor = message.growthFactor;
        obj.scale = message.scale;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDistribution_BucketOptions_Exponential();
        if (object.num_finite_buckets !== undefined && object.num_finite_buckets !== null) {
            message.numFiniteBuckets = object.num_finite_buckets;
        }
        if (object.growth_factor !== undefined && object.growth_factor !== null) {
            message.growthFactor = object.growth_factor;
        }
        if (object.scale !== undefined && object.scale !== null) {
            message.scale = object.scale;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.num_finite_buckets = message.numFiniteBuckets === 0 ? undefined : message.numFiniteBuckets;
        obj.growth_factor = message.growthFactor === 0 ? undefined : message.growthFactor;
        obj.scale = message.scale === 0 ? undefined : message.scale;
        return obj;
    },
    fromAminoMsg(object) {
        return Distribution_BucketOptions_Exponential.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Distribution_BucketOptions_Exponential.decode(message.value);
    },
    toProto(message) {
        return Distribution_BucketOptions_Exponential.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Exponential",
            value: Distribution_BucketOptions_Exponential.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseDistribution_BucketOptions_Explicit() {
    return {
        bounds: []
    };
}
export const Distribution_BucketOptions_Explicit = {
    typeUrl: "/google.api.Explicit",
    is(o) {
        return o && (o.$typeUrl === Distribution_BucketOptions_Explicit.typeUrl || Array.isArray(o.bounds) && (!o.bounds.length || typeof o.bounds[0] === "number"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Distribution_BucketOptions_Explicit.typeUrl || Array.isArray(o.bounds) && (!o.bounds.length || typeof o.bounds[0] === "number"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Distribution_BucketOptions_Explicit.typeUrl || Array.isArray(o.bounds) && (!o.bounds.length || typeof o.bounds[0] === "number"));
    },
    encode(message, writer = BinaryWriter.create()) {
        writer.uint32(10).fork();
        for (const v of message.bounds) {
            writer.double(v);
        }
        writer.ldelim();
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDistribution_BucketOptions_Explicit();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.bounds.push(reader.double());
                        }
                    }
                    else {
                        message.bounds.push(reader.double());
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDistribution_BucketOptions_Explicit();
        if (Array.isArray(object?.bounds))
            obj.bounds = object.bounds.map((e) => Number(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.bounds) {
            obj.bounds = message.bounds.map(e => e);
        }
        else {
            obj.bounds = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDistribution_BucketOptions_Explicit();
        message.bounds = object.bounds?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            bounds: Array.isArray(object?.bounds) ? object.bounds.map((e) => e) : []
        };
    },
    fromSDKJSON(object) {
        return {
            bounds: Array.isArray(object?.bounds) ? object.bounds.map((e) => Number(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.bounds) {
            obj.bounds = message.bounds.map(e => e);
        }
        else {
            obj.bounds = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDistribution_BucketOptions_Explicit();
        message.bounds = object.bounds?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.bounds) {
            obj.bounds = message.bounds.map(e => e);
        }
        else {
            obj.bounds = message.bounds;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Distribution_BucketOptions_Explicit.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Distribution_BucketOptions_Explicit.decode(message.value);
    },
    toProto(message) {
        return Distribution_BucketOptions_Explicit.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Explicit",
            value: Distribution_BucketOptions_Explicit.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseDistribution_Exemplar() {
    return {
        value: 0,
        timestamp: undefined,
        attachments: []
    };
}
export const Distribution_Exemplar = {
    typeUrl: "/google.api.Exemplar",
    is(o) {
        return o && (o.$typeUrl === Distribution_Exemplar.typeUrl || typeof o.value === "number" && Array.isArray(o.attachments) && (!o.attachments.length || Any.is(o.attachments[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Distribution_Exemplar.typeUrl || typeof o.value === "number" && Array.isArray(o.attachments) && (!o.attachments.length || Any.isSDK(o.attachments[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Distribution_Exemplar.typeUrl || typeof o.value === "number" && Array.isArray(o.attachments) && (!o.attachments.length || Any.isAmino(o.attachments[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.value !== undefined) {
            writer.uint32(9).double(message.value);
        }
        if (message.timestamp !== undefined) {
            Timestamp.encode(toTimestamp(message.timestamp), writer.uint32(18).fork()).ldelim();
        }
        for (const v of message.attachments) {
            Any.encode(v, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDistribution_Exemplar();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.value = reader.double();
                    break;
                case 2:
                    message.timestamp = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.attachments.push(Any.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDistribution_Exemplar();
        if (isSet(object.value))
            obj.value = Number(object.value);
        if (isSet(object.timestamp))
            obj.timestamp = new Date(object.timestamp);
        if (Array.isArray(object?.attachments))
            obj.attachments = object.attachments.map((e) => Any.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.value !== undefined && (obj.value = message.value);
        message.timestamp !== undefined && (obj.timestamp = message.timestamp.toISOString());
        if (message.attachments) {
            obj.attachments = message.attachments.map(e => e ? Any.toJSON(e) : undefined);
        }
        else {
            obj.attachments = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDistribution_Exemplar();
        message.value = object.value ?? 0;
        message.timestamp = object.timestamp ?? undefined;
        message.attachments = object.attachments?.map(e => Any.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            value: object?.value,
            timestamp: object.timestamp ?? undefined,
            attachments: Array.isArray(object?.attachments) ? object.attachments.map((e) => Any.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            value: isSet(object.value) ? Number(object.value) : 0,
            timestamp: isSet(object.timestamp) ? new Date(object.timestamp) : undefined,
            attachments: Array.isArray(object?.attachments) ? object.attachments.map((e) => Any.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.value = message.value;
        message.timestamp !== undefined && (obj.timestamp = message.timestamp ?? undefined);
        if (message.attachments) {
            obj.attachments = message.attachments.map(e => e ? Any.toSDK(e) : undefined);
        }
        else {
            obj.attachments = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDistribution_Exemplar();
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        if (object.timestamp !== undefined && object.timestamp !== null) {
            message.timestamp = fromTimestamp(Timestamp.fromAmino(object.timestamp));
        }
        message.attachments = object.attachments?.map(e => Any.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.value = message.value === 0 ? undefined : message.value;
        obj.timestamp = message.timestamp ? Timestamp.toAmino(toTimestamp(message.timestamp)) : undefined;
        if (message.attachments) {
            obj.attachments = message.attachments.map(e => e ? Any.toAmino(e) : undefined);
        }
        else {
            obj.attachments = message.attachments;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Distribution_Exemplar.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Distribution_Exemplar.decode(message.value);
    },
    toProto(message) {
        return Distribution_Exemplar.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Exemplar",
            value: Distribution_Exemplar.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
