import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseDocumentation() {
    return {
        summary: "",
        pages: [],
        rules: [],
        documentationRootUrl: "",
        serviceRootUrl: "",
        overview: ""
    };
}
export const Documentation = {
    typeUrl: "/google.api.Documentation",
    is(o) {
        return o && (o.$typeUrl === Documentation.typeUrl || typeof o.summary === "string" && Array.isArray(o.pages) && (!o.pages.length || Page.is(o.pages[0])) && Array.isArray(o.rules) && (!o.rules.length || DocumentationRule.is(o.rules[0])) && typeof o.documentationRootUrl === "string" && typeof o.serviceRootUrl === "string" && typeof o.overview === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Documentation.typeUrl || typeof o.summary === "string" && Array.isArray(o.pages) && (!o.pages.length || Page.isSDK(o.pages[0])) && Array.isArray(o.rules) && (!o.rules.length || DocumentationRule.isSDK(o.rules[0])) && typeof o.documentation_root_url === "string" && typeof o.service_root_url === "string" && typeof o.overview === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Documentation.typeUrl || typeof o.summary === "string" && Array.isArray(o.pages) && (!o.pages.length || Page.isAmino(o.pages[0])) && Array.isArray(o.rules) && (!o.rules.length || DocumentationRule.isAmino(o.rules[0])) && typeof o.documentation_root_url === "string" && typeof o.service_root_url === "string" && typeof o.overview === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.summary !== undefined) {
            writer.uint32(10).string(message.summary);
        }
        for (const v of message.pages) {
            Page.encode(v, writer.uint32(42).fork()).ldelim();
        }
        for (const v of message.rules) {
            DocumentationRule.encode(v, writer.uint32(26).fork()).ldelim();
        }
        if (message.documentationRootUrl !== undefined) {
            writer.uint32(34).string(message.documentationRootUrl);
        }
        if (message.serviceRootUrl !== undefined) {
            writer.uint32(50).string(message.serviceRootUrl);
        }
        if (message.overview !== undefined) {
            writer.uint32(18).string(message.overview);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDocumentation();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.summary = reader.string();
                    break;
                case 5:
                    message.pages.push(Page.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.rules.push(DocumentationRule.decode(reader, reader.uint32()));
                    break;
                case 4:
                    message.documentationRootUrl = reader.string();
                    break;
                case 6:
                    message.serviceRootUrl = reader.string();
                    break;
                case 2:
                    message.overview = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDocumentation();
        if (isSet(object.summary))
            obj.summary = String(object.summary);
        if (Array.isArray(object?.pages))
            obj.pages = object.pages.map((e) => Page.fromJSON(e));
        if (Array.isArray(object?.rules))
            obj.rules = object.rules.map((e) => DocumentationRule.fromJSON(e));
        if (isSet(object.documentationRootUrl))
            obj.documentationRootUrl = String(object.documentationRootUrl);
        if (isSet(object.serviceRootUrl))
            obj.serviceRootUrl = String(object.serviceRootUrl);
        if (isSet(object.overview))
            obj.overview = String(object.overview);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.summary !== undefined && (obj.summary = message.summary);
        if (message.pages) {
            obj.pages = message.pages.map(e => e ? Page.toJSON(e) : undefined);
        }
        else {
            obj.pages = [];
        }
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? DocumentationRule.toJSON(e) : undefined);
        }
        else {
            obj.rules = [];
        }
        message.documentationRootUrl !== undefined && (obj.documentationRootUrl = message.documentationRootUrl);
        message.serviceRootUrl !== undefined && (obj.serviceRootUrl = message.serviceRootUrl);
        message.overview !== undefined && (obj.overview = message.overview);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDocumentation();
        message.summary = object.summary ?? "";
        message.pages = object.pages?.map(e => Page.fromPartial(e)) || [];
        message.rules = object.rules?.map(e => DocumentationRule.fromPartial(e)) || [];
        message.documentationRootUrl = object.documentationRootUrl ?? "";
        message.serviceRootUrl = object.serviceRootUrl ?? "";
        message.overview = object.overview ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            summary: object?.summary,
            pages: Array.isArray(object?.pages) ? object.pages.map((e) => Page.fromSDK(e)) : [],
            rules: Array.isArray(object?.rules) ? object.rules.map((e) => DocumentationRule.fromSDK(e)) : [],
            documentationRootUrl: object?.documentation_root_url,
            serviceRootUrl: object?.service_root_url,
            overview: object?.overview
        };
    },
    fromSDKJSON(object) {
        return {
            summary: isSet(object.summary) ? String(object.summary) : "",
            pages: Array.isArray(object?.pages) ? object.pages.map((e) => Page.fromSDKJSON(e)) : [],
            rules: Array.isArray(object?.rules) ? object.rules.map((e) => DocumentationRule.fromSDKJSON(e)) : [],
            documentation_root_url: isSet(object.documentation_root_url) ? String(object.documentation_root_url) : "",
            service_root_url: isSet(object.service_root_url) ? String(object.service_root_url) : "",
            overview: isSet(object.overview) ? String(object.overview) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.summary = message.summary;
        if (message.pages) {
            obj.pages = message.pages.map(e => e ? Page.toSDK(e) : undefined);
        }
        else {
            obj.pages = [];
        }
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? DocumentationRule.toSDK(e) : undefined);
        }
        else {
            obj.rules = [];
        }
        obj.documentation_root_url = message.documentationRootUrl;
        obj.service_root_url = message.serviceRootUrl;
        obj.overview = message.overview;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDocumentation();
        if (object.summary !== undefined && object.summary !== null) {
            message.summary = object.summary;
        }
        message.pages = object.pages?.map(e => Page.fromAmino(e)) || [];
        message.rules = object.rules?.map(e => DocumentationRule.fromAmino(e)) || [];
        if (object.documentation_root_url !== undefined && object.documentation_root_url !== null) {
            message.documentationRootUrl = object.documentation_root_url;
        }
        if (object.service_root_url !== undefined && object.service_root_url !== null) {
            message.serviceRootUrl = object.service_root_url;
        }
        if (object.overview !== undefined && object.overview !== null) {
            message.overview = object.overview;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.summary = message.summary === "" ? undefined : message.summary;
        if (message.pages) {
            obj.pages = message.pages.map(e => e ? Page.toAmino(e) : undefined);
        }
        else {
            obj.pages = message.pages;
        }
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? DocumentationRule.toAmino(e) : undefined);
        }
        else {
            obj.rules = message.rules;
        }
        obj.documentation_root_url = message.documentationRootUrl === "" ? undefined : message.documentationRootUrl;
        obj.service_root_url = message.serviceRootUrl === "" ? undefined : message.serviceRootUrl;
        obj.overview = message.overview === "" ? undefined : message.overview;
        return obj;
    },
    fromAminoMsg(object) {
        return Documentation.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Documentation.decode(message.value);
    },
    toProto(message) {
        return Documentation.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Documentation",
            value: Documentation.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Page.registerTypeUrl();
        DocumentationRule.registerTypeUrl();
    }
};
function createBaseDocumentationRule() {
    return {
        selector: "",
        description: "",
        deprecationDescription: ""
    };
}
export const DocumentationRule = {
    typeUrl: "/google.api.DocumentationRule",
    is(o) {
        return o && (o.$typeUrl === DocumentationRule.typeUrl || typeof o.selector === "string" && typeof o.description === "string" && typeof o.deprecationDescription === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === DocumentationRule.typeUrl || typeof o.selector === "string" && typeof o.description === "string" && typeof o.deprecation_description === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === DocumentationRule.typeUrl || typeof o.selector === "string" && typeof o.description === "string" && typeof o.deprecation_description === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.selector !== undefined) {
            writer.uint32(10).string(message.selector);
        }
        if (message.description !== undefined) {
            writer.uint32(18).string(message.description);
        }
        if (message.deprecationDescription !== undefined) {
            writer.uint32(26).string(message.deprecationDescription);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDocumentationRule();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.selector = reader.string();
                    break;
                case 2:
                    message.description = reader.string();
                    break;
                case 3:
                    message.deprecationDescription = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDocumentationRule();
        if (isSet(object.selector))
            obj.selector = String(object.selector);
        if (isSet(object.description))
            obj.description = String(object.description);
        if (isSet(object.deprecationDescription))
            obj.deprecationDescription = String(object.deprecationDescription);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.selector !== undefined && (obj.selector = message.selector);
        message.description !== undefined && (obj.description = message.description);
        message.deprecationDescription !== undefined && (obj.deprecationDescription = message.deprecationDescription);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDocumentationRule();
        message.selector = object.selector ?? "";
        message.description = object.description ?? "";
        message.deprecationDescription = object.deprecationDescription ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            selector: object?.selector,
            description: object?.description,
            deprecationDescription: object?.deprecation_description
        };
    },
    fromSDKJSON(object) {
        return {
            selector: isSet(object.selector) ? String(object.selector) : "",
            description: isSet(object.description) ? String(object.description) : "",
            deprecation_description: isSet(object.deprecation_description) ? String(object.deprecation_description) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.selector = message.selector;
        obj.description = message.description;
        obj.deprecation_description = message.deprecationDescription;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDocumentationRule();
        if (object.selector !== undefined && object.selector !== null) {
            message.selector = object.selector;
        }
        if (object.description !== undefined && object.description !== null) {
            message.description = object.description;
        }
        if (object.deprecation_description !== undefined && object.deprecation_description !== null) {
            message.deprecationDescription = object.deprecation_description;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.selector = message.selector === "" ? undefined : message.selector;
        obj.description = message.description === "" ? undefined : message.description;
        obj.deprecation_description = message.deprecationDescription === "" ? undefined : message.deprecationDescription;
        return obj;
    },
    fromAminoMsg(object) {
        return DocumentationRule.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return DocumentationRule.decode(message.value);
    },
    toProto(message) {
        return DocumentationRule.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.DocumentationRule",
            value: DocumentationRule.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBasePage() {
    return {
        name: "",
        content: "",
        subpages: []
    };
}
export const Page = {
    typeUrl: "/google.api.Page",
    is(o) {
        return o && (o.$typeUrl === Page.typeUrl || typeof o.name === "string" && typeof o.content === "string" && Array.isArray(o.subpages) && (!o.subpages.length || Page.is(o.subpages[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Page.typeUrl || typeof o.name === "string" && typeof o.content === "string" && Array.isArray(o.subpages) && (!o.subpages.length || Page.isSDK(o.subpages[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Page.typeUrl || typeof o.name === "string" && typeof o.content === "string" && Array.isArray(o.subpages) && (!o.subpages.length || Page.isAmino(o.subpages[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.content !== undefined) {
            writer.uint32(18).string(message.content);
        }
        for (const v of message.subpages) {
            Page.encode(v, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBasePage();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.content = reader.string();
                    break;
                case 3:
                    message.subpages.push(Page.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBasePage();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.content))
            obj.content = String(object.content);
        if (Array.isArray(object?.subpages))
            obj.subpages = object.subpages.map((e) => Page.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.content !== undefined && (obj.content = message.content);
        if (message.subpages) {
            obj.subpages = message.subpages.map(e => e ? Page.toJSON(e) : undefined);
        }
        else {
            obj.subpages = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBasePage();
        message.name = object.name ?? "";
        message.content = object.content ?? "";
        message.subpages = object.subpages?.map(e => Page.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            content: object?.content,
            subpages: Array.isArray(object?.subpages) ? object.subpages.map((e) => Page.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            content: isSet(object.content) ? String(object.content) : "",
            subpages: Array.isArray(object?.subpages) ? object.subpages.map((e) => Page.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.content = message.content;
        if (message.subpages) {
            obj.subpages = message.subpages.map(e => e ? Page.toSDK(e) : undefined);
        }
        else {
            obj.subpages = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBasePage();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.content !== undefined && object.content !== null) {
            message.content = object.content;
        }
        message.subpages = object.subpages?.map(e => Page.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.content = message.content === "" ? undefined : message.content;
        if (message.subpages) {
            obj.subpages = message.subpages.map(e => e ? Page.toAmino(e) : undefined);
        }
        else {
            obj.subpages = message.subpages;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Page.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Page.decode(message.value);
    },
    toProto(message) {
        return Page.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Page",
            value: Page.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Page.registerTypeUrl();
    }
};
