import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseEndpoint() {
    return {
        name: "",
        aliases: [],
        target: "",
        allowCors: false
    };
}
export const Endpoint = {
    typeUrl: "/google.api.Endpoint",
    is(o) {
        return o && (o.$typeUrl === Endpoint.typeUrl || typeof o.name === "string" && Array.isArray(o.aliases) && (!o.aliases.length || typeof o.aliases[0] === "string") && typeof o.target === "string" && typeof o.allowCors === "boolean");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Endpoint.typeUrl || typeof o.name === "string" && Array.isArray(o.aliases) && (!o.aliases.length || typeof o.aliases[0] === "string") && typeof o.target === "string" && typeof o.allow_cors === "boolean");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Endpoint.typeUrl || typeof o.name === "string" && Array.isArray(o.aliases) && (!o.aliases.length || typeof o.aliases[0] === "string") && typeof o.target === "string" && typeof o.allow_cors === "boolean");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        for (const v of message.aliases) {
            writer.uint32(18).string(v);
        }
        if (message.target !== undefined) {
            writer.uint32(810).string(message.target);
        }
        if (message.allowCors !== undefined) {
            writer.uint32(40).bool(message.allowCors);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseEndpoint();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.aliases.push(reader.string());
                    break;
                case 101:
                    message.target = reader.string();
                    break;
                case 5:
                    message.allowCors = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseEndpoint();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (Array.isArray(object?.aliases))
            obj.aliases = object.aliases.map((e) => String(e));
        if (isSet(object.target))
            obj.target = String(object.target);
        if (isSet(object.allowCors))
            obj.allowCors = Boolean(object.allowCors);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        if (message.aliases) {
            obj.aliases = message.aliases.map(e => e);
        }
        else {
            obj.aliases = [];
        }
        message.target !== undefined && (obj.target = message.target);
        message.allowCors !== undefined && (obj.allowCors = message.allowCors);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseEndpoint();
        message.name = object.name ?? "";
        message.aliases = object.aliases?.map(e => e) || [];
        message.target = object.target ?? "";
        message.allowCors = object.allowCors ?? false;
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            aliases: Array.isArray(object?.aliases) ? object.aliases.map((e) => e) : [],
            target: object?.target,
            allowCors: object?.allow_cors
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            aliases: Array.isArray(object?.aliases) ? object.aliases.map((e) => String(e)) : [],
            target: isSet(object.target) ? String(object.target) : "",
            allow_cors: isSet(object.allow_cors) ? Boolean(object.allow_cors) : false
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        if (message.aliases) {
            obj.aliases = message.aliases.map(e => e);
        }
        else {
            obj.aliases = [];
        }
        obj.target = message.target;
        obj.allow_cors = message.allowCors;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseEndpoint();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        message.aliases = object.aliases?.map(e => e) || [];
        if (object.target !== undefined && object.target !== null) {
            message.target = object.target;
        }
        if (object.allow_cors !== undefined && object.allow_cors !== null) {
            message.allowCors = object.allow_cors;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        if (message.aliases) {
            obj.aliases = message.aliases.map(e => e);
        }
        else {
            obj.aliases = message.aliases;
        }
        obj.target = message.target === "" ? undefined : message.target;
        obj.allow_cors = message.allowCors === false ? undefined : message.allowCors;
        return obj;
    },
    fromAminoMsg(object) {
        return Endpoint.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Endpoint.decode(message.value);
    },
    toProto(message) {
        return Endpoint.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Endpoint",
            value: Endpoint.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
