import { Value, ValueAmino, ValueSDKType } from "./value";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { JsonSafe } from "../../../../json-safe";
import { DeepPartial } from "../../../../helpers";
export declare const protobufPackage = "google.api.expr.v1alpha1";
/**
 * Values of intermediate expressions produced when evaluating expression.
 * Deprecated, use `EvalState` instead.
 */
/** @deprecated */
export interface Explain {
    /**
     * All of the observed values.
     *
     * The field value_index is an index in the values list.
     * Separating values from steps is needed to remove redundant values.
     */
    values: Value[];
    /**
     * List of steps.
     *
     * Repeated evaluations of the same expression generate new ExprStep
     * instances. The order of such ExprStep instances matches the order of
     * elements returned by Comprehension.iter_range.
     */
    exprSteps: Explain_ExprStep[];
}
export interface ExplainProtoMsg {
    typeUrl: "/google.api.expr.v1alpha1.Explain";
    value: Uint8Array;
}
/**
 * Values of intermediate expressions produced when evaluating expression.
 * Deprecated, use `EvalState` instead.
 */
/** @deprecated */
export interface ExplainAmino {
    /**
     * All of the observed values.
     *
     * The field value_index is an index in the values list.
     * Separating values from steps is needed to remove redundant values.
     */
    values?: ValueAmino[];
    /**
     * List of steps.
     *
     * Repeated evaluations of the same expression generate new ExprStep
     * instances. The order of such ExprStep instances matches the order of
     * elements returned by Comprehension.iter_range.
     */
    expr_steps?: Explain_ExprStepAmino[];
}
export interface ExplainAminoMsg {
    type: "/google.api.expr.v1alpha1.Explain";
    value: ExplainAmino;
}
/**
 * Values of intermediate expressions produced when evaluating expression.
 * Deprecated, use `EvalState` instead.
 */
/** @deprecated */
export interface ExplainSDKType {
    values: ValueSDKType[];
    expr_steps: Explain_ExprStepSDKType[];
}
/** ID and value index of one step. */
export interface Explain_ExprStep {
    /** ID of corresponding Expr node. */
    id: bigint;
    /** Index of the value in the values list. */
    valueIndex: number;
}
export interface Explain_ExprStepProtoMsg {
    typeUrl: "/google.api.expr.v1alpha1.ExprStep";
    value: Uint8Array;
}
/** ID and value index of one step. */
export interface Explain_ExprStepAmino {
    /** ID of corresponding Expr node. */
    id?: string;
    /** Index of the value in the values list. */
    value_index?: number;
}
export interface Explain_ExprStepAminoMsg {
    type: "/google.api.expr.v1alpha1.ExprStep";
    value: Explain_ExprStepAmino;
}
/** ID and value index of one step. */
export interface Explain_ExprStepSDKType {
    id: bigint;
    value_index: number;
}
export declare const Explain: {
    typeUrl: string;
    is(o: any): o is Explain;
    isSDK(o: any): o is ExplainSDKType;
    isAmino(o: any): o is ExplainAmino;
    encode(message: Explain, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Explain;
    fromJSON(object: any): Explain;
    toJSON(message: Explain): JsonSafe<Explain>;
    fromPartial(object: DeepPartial<Explain>): Explain;
    fromSDK(object: ExplainSDKType): Explain;
    fromSDKJSON(object: any): ExplainSDKType;
    toSDK(message: Explain): ExplainSDKType;
    fromAmino(object: ExplainAmino): Explain;
    toAmino(message: Explain): ExplainAmino;
    fromAminoMsg(object: ExplainAminoMsg): Explain;
    fromProtoMsg(message: ExplainProtoMsg): Explain;
    toProto(message: Explain): Uint8Array;
    toProtoMsg(message: Explain): ExplainProtoMsg;
    registerTypeUrl(): void;
};
export declare const Explain_ExprStep: {
    typeUrl: string;
    is(o: any): o is Explain_ExprStep;
    isSDK(o: any): o is Explain_ExprStepSDKType;
    isAmino(o: any): o is Explain_ExprStepAmino;
    encode(message: Explain_ExprStep, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Explain_ExprStep;
    fromJSON(object: any): Explain_ExprStep;
    toJSON(message: Explain_ExprStep): JsonSafe<Explain_ExprStep>;
    fromPartial(object: DeepPartial<Explain_ExprStep>): Explain_ExprStep;
    fromSDK(object: Explain_ExprStepSDKType): Explain_ExprStep;
    fromSDKJSON(object: any): Explain_ExprStepSDKType;
    toSDK(message: Explain_ExprStep): Explain_ExprStepSDKType;
    fromAmino(object: Explain_ExprStepAmino): Explain_ExprStep;
    toAmino(message: Explain_ExprStep): Explain_ExprStepAmino;
    fromAminoMsg(object: Explain_ExprStepAminoMsg): Explain_ExprStep;
    fromProtoMsg(message: Explain_ExprStepProtoMsg): Explain_ExprStep;
    toProto(message: Explain_ExprStep): Uint8Array;
    toProtoMsg(message: Explain_ExprStep): Explain_ExprStepProtoMsg;
    registerTypeUrl(): void;
};
