import { Any } from "../protobuf/any";
import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet, bytesFromBase64, base64FromBytes } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseHttpBody() {
    return {
        contentType: "",
        data: new Uint8Array(),
        extensions: []
    };
}
export const HttpBody = {
    typeUrl: "/google.api.HttpBody",
    is(o) {
        return o && (o.$typeUrl === HttpBody.typeUrl || typeof o.contentType === "string" && (o.data instanceof Uint8Array || typeof o.data === "string") && Array.isArray(o.extensions) && (!o.extensions.length || Any.is(o.extensions[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === HttpBody.typeUrl || typeof o.content_type === "string" && (o.data instanceof Uint8Array || typeof o.data === "string") && Array.isArray(o.extensions) && (!o.extensions.length || Any.isSDK(o.extensions[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === HttpBody.typeUrl || typeof o.content_type === "string" && (o.data instanceof Uint8Array || typeof o.data === "string") && Array.isArray(o.extensions) && (!o.extensions.length || Any.isAmino(o.extensions[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.contentType !== undefined) {
            writer.uint32(10).string(message.contentType);
        }
        if (message.data.length !== 0) {
            writer.uint32(18).bytes(message.data);
        }
        for (const v of message.extensions) {
            Any.encode(v, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseHttpBody();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.contentType = reader.string();
                    break;
                case 2:
                    message.data = reader.bytes();
                    break;
                case 3:
                    message.extensions.push(Any.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseHttpBody();
        if (isSet(object.contentType))
            obj.contentType = String(object.contentType);
        if (isSet(object.data))
            obj.data = bytesFromBase64(object.data);
        if (Array.isArray(object?.extensions))
            obj.extensions = object.extensions.map((e) => Any.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.contentType !== undefined && (obj.contentType = message.contentType);
        message.data !== undefined && (obj.data = base64FromBytes(message.data !== undefined ? message.data : new Uint8Array()));
        if (message.extensions) {
            obj.extensions = message.extensions.map(e => e ? Any.toJSON(e) : undefined);
        }
        else {
            obj.extensions = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseHttpBody();
        message.contentType = object.contentType ?? "";
        message.data = object.data ?? new Uint8Array();
        message.extensions = object.extensions?.map(e => Any.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            contentType: object?.content_type,
            data: object?.data,
            extensions: Array.isArray(object?.extensions) ? object.extensions.map((e) => Any.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            content_type: isSet(object.content_type) ? String(object.content_type) : "",
            data: isSet(object.data) ? bytesFromBase64(object.data) : new Uint8Array(),
            extensions: Array.isArray(object?.extensions) ? object.extensions.map((e) => Any.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.content_type = message.contentType;
        obj.data = message.data;
        if (message.extensions) {
            obj.extensions = message.extensions.map(e => e ? Any.toSDK(e) : undefined);
        }
        else {
            obj.extensions = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseHttpBody();
        if (object.content_type !== undefined && object.content_type !== null) {
            message.contentType = object.content_type;
        }
        if (object.data !== undefined && object.data !== null) {
            message.data = bytesFromBase64(object.data);
        }
        message.extensions = object.extensions?.map(e => Any.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.content_type = message.contentType === "" ? undefined : message.contentType;
        obj.data = message.data ? base64FromBytes(message.data) : undefined;
        if (message.extensions) {
            obj.extensions = message.extensions.map(e => e ? Any.toAmino(e) : undefined);
        }
        else {
            obj.extensions = message.extensions;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return HttpBody.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return HttpBody.decode(message.value);
    },
    toProto(message) {
        return HttpBody.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.HttpBody",
            value: HttpBody.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
