import { DeepPartial } from "../../helpers";
import { BinaryReader, BinaryWriter } from "../../binary";
import { JsonSafe } from "../../json-safe";
export declare const protobufPackage = "google.api";
/** Value types that can be used as label values. */
export declare enum LabelDescriptor_ValueType {
    /** STRING - A variable-length string. This is the default. */
    STRING = 0,
    /** BOOL - Boolean; true or false. */
    BOOL = 1,
    /** INT64 - A 64-bit signed integer. */
    INT64 = 2,
    UNRECOGNIZED = -1
}
export declare const LabelDescriptor_ValueTypeSDKType: typeof LabelDescriptor_ValueType;
export declare const LabelDescriptor_ValueTypeAmino: typeof LabelDescriptor_ValueType;
export declare function labelDescriptor_ValueTypeFromJSON(object: any): LabelDescriptor_ValueType;
export declare function labelDescriptor_ValueTypeToJSON(object: LabelDescriptor_ValueType): string;
/** A description of a label. */
export interface LabelDescriptor {
    /** The label key. */
    key: string;
    /** The type of data that can be assigned to the label. */
    valueType: LabelDescriptor_ValueType;
    /** A human-readable description for the label. */
    description: string;
}
export interface LabelDescriptorProtoMsg {
    typeUrl: "/google.api.LabelDescriptor";
    value: Uint8Array;
}
/** A description of a label. */
export interface LabelDescriptorAmino {
    /** The label key. */
    key?: string;
    /** The type of data that can be assigned to the label. */
    value_type?: LabelDescriptor_ValueType;
    /** A human-readable description for the label. */
    description?: string;
}
export interface LabelDescriptorAminoMsg {
    type: "/google.api.LabelDescriptor";
    value: LabelDescriptorAmino;
}
/** A description of a label. */
export interface LabelDescriptorSDKType {
    key: string;
    value_type: LabelDescriptor_ValueType;
    description: string;
}
export declare const LabelDescriptor: {
    typeUrl: string;
    is(o: any): o is LabelDescriptor;
    isSDK(o: any): o is LabelDescriptorSDKType;
    isAmino(o: any): o is LabelDescriptorAmino;
    encode(message: LabelDescriptor, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): LabelDescriptor;
    fromJSON(object: any): LabelDescriptor;
    toJSON(message: LabelDescriptor): JsonSafe<LabelDescriptor>;
    fromPartial(object: DeepPartial<LabelDescriptor>): LabelDescriptor;
    fromSDK(object: LabelDescriptorSDKType): LabelDescriptor;
    fromSDKJSON(object: any): LabelDescriptorSDKType;
    toSDK(message: LabelDescriptor): LabelDescriptorSDKType;
    fromAmino(object: LabelDescriptorAmino): LabelDescriptor;
    toAmino(message: LabelDescriptor): LabelDescriptorAmino;
    fromAminoMsg(object: LabelDescriptorAminoMsg): LabelDescriptor;
    fromProtoMsg(message: LabelDescriptorProtoMsg): LabelDescriptor;
    toProto(message: LabelDescriptor): Uint8Array;
    toProtoMsg(message: LabelDescriptor): LabelDescriptorProtoMsg;
    registerTypeUrl(): void;
};
