import { isSet } from "../../helpers";
import { BinaryReader, BinaryWriter } from "../../binary";
export const protobufPackage = "google.api";
/** Value types that can be used as label values. */
export var LabelDescriptor_ValueType;
(function (LabelDescriptor_ValueType) {
    /** STRING - A variable-length string. This is the default. */
    LabelDescriptor_ValueType[LabelDescriptor_ValueType["STRING"] = 0] = "STRING";
    /** BOOL - Boolean; true or false. */
    LabelDescriptor_ValueType[LabelDescriptor_ValueType["BOOL"] = 1] = "BOOL";
    /** INT64 - A 64-bit signed integer. */
    LabelDescriptor_ValueType[LabelDescriptor_ValueType["INT64"] = 2] = "INT64";
    LabelDescriptor_ValueType[LabelDescriptor_ValueType["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(LabelDescriptor_ValueType || (LabelDescriptor_ValueType = {}));
export const LabelDescriptor_ValueTypeSDKType = LabelDescriptor_ValueType;
export const LabelDescriptor_ValueTypeAmino = LabelDescriptor_ValueType;
export function labelDescriptor_ValueTypeFromJSON(object) {
    switch (object) {
        case 0:
        case "STRING":
            return LabelDescriptor_ValueType.STRING;
        case 1:
        case "BOOL":
            return LabelDescriptor_ValueType.BOOL;
        case 2:
        case "INT64":
            return LabelDescriptor_ValueType.INT64;
        case -1:
        case "UNRECOGNIZED":
        default:
            return LabelDescriptor_ValueType.UNRECOGNIZED;
    }
}
export function labelDescriptor_ValueTypeToJSON(object) {
    switch (object) {
        case LabelDescriptor_ValueType.STRING:
            return "STRING";
        case LabelDescriptor_ValueType.BOOL:
            return "BOOL";
        case LabelDescriptor_ValueType.INT64:
            return "INT64";
        case LabelDescriptor_ValueType.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
function createBaseLabelDescriptor() {
    return {
        key: "",
        valueType: 0,
        description: ""
    };
}
export const LabelDescriptor = {
    typeUrl: "/google.api.LabelDescriptor",
    is(o) {
        return o && (o.$typeUrl === LabelDescriptor.typeUrl || typeof o.key === "string" && isSet(o.valueType) && typeof o.description === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === LabelDescriptor.typeUrl || typeof o.key === "string" && isSet(o.value_type) && typeof o.description === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === LabelDescriptor.typeUrl || typeof o.key === "string" && isSet(o.value_type) && typeof o.description === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.valueType !== 0) {
            writer.uint32(16).int32(message.valueType);
        }
        if (message.description !== undefined) {
            writer.uint32(26).string(message.description);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLabelDescriptor();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.valueType = reader.int32();
                    break;
                case 3:
                    message.description = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLabelDescriptor();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.valueType))
            obj.valueType = labelDescriptor_ValueTypeFromJSON(object.valueType);
        if (isSet(object.description))
            obj.description = String(object.description);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.valueType !== undefined && (obj.valueType = labelDescriptor_ValueTypeToJSON(message.valueType));
        message.description !== undefined && (obj.description = message.description);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLabelDescriptor();
        message.key = object.key ?? "";
        message.valueType = object.valueType ?? 0;
        message.description = object.description ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            valueType: isSet(object.value_type) ? labelDescriptor_ValueTypeFromJSON(object.value_type) : -1,
            description: object?.description
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value_type: isSet(object.value_type) ? labelDescriptor_ValueTypeFromJSON(object.value_type) : -1,
            description: isSet(object.description) ? String(object.description) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        message.valueType !== undefined && (obj.value_type = labelDescriptor_ValueTypeToJSON(message.valueType));
        obj.description = message.description;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLabelDescriptor();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value_type !== undefined && object.value_type !== null) {
            message.valueType = object.value_type;
        }
        if (object.description !== undefined && object.description !== null) {
            message.description = object.description;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value_type = message.valueType === 0 ? undefined : message.valueType;
        obj.description = message.description === "" ? undefined : message.description;
        return obj;
    },
    fromAminoMsg(object) {
        return LabelDescriptor.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return LabelDescriptor.decode(message.value);
    },
    toProto(message) {
        return LabelDescriptor.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.LabelDescriptor",
            value: LabelDescriptor.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
