import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseLogging() {
    return {
        producerDestinations: [],
        consumerDestinations: []
    };
}
export const Logging = {
    typeUrl: "/google.api.Logging",
    is(o) {
        return o && (o.$typeUrl === Logging.typeUrl || Array.isArray(o.producerDestinations) && (!o.producerDestinations.length || Logging_LoggingDestination.is(o.producerDestinations[0])) && Array.isArray(o.consumerDestinations) && (!o.consumerDestinations.length || Logging_LoggingDestination.is(o.consumerDestinations[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Logging.typeUrl || Array.isArray(o.producer_destinations) && (!o.producer_destinations.length || Logging_LoggingDestination.isSDK(o.producer_destinations[0])) && Array.isArray(o.consumer_destinations) && (!o.consumer_destinations.length || Logging_LoggingDestination.isSDK(o.consumer_destinations[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Logging.typeUrl || Array.isArray(o.producer_destinations) && (!o.producer_destinations.length || Logging_LoggingDestination.isAmino(o.producer_destinations[0])) && Array.isArray(o.consumer_destinations) && (!o.consumer_destinations.length || Logging_LoggingDestination.isAmino(o.consumer_destinations[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.producerDestinations) {
            Logging_LoggingDestination.encode(v, writer.uint32(10).fork()).ldelim();
        }
        for (const v of message.consumerDestinations) {
            Logging_LoggingDestination.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLogging();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.producerDestinations.push(Logging_LoggingDestination.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.consumerDestinations.push(Logging_LoggingDestination.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLogging();
        if (Array.isArray(object?.producerDestinations))
            obj.producerDestinations = object.producerDestinations.map((e) => Logging_LoggingDestination.fromJSON(e));
        if (Array.isArray(object?.consumerDestinations))
            obj.consumerDestinations = object.consumerDestinations.map((e) => Logging_LoggingDestination.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.producerDestinations) {
            obj.producerDestinations = message.producerDestinations.map(e => e ? Logging_LoggingDestination.toJSON(e) : undefined);
        }
        else {
            obj.producerDestinations = [];
        }
        if (message.consumerDestinations) {
            obj.consumerDestinations = message.consumerDestinations.map(e => e ? Logging_LoggingDestination.toJSON(e) : undefined);
        }
        else {
            obj.consumerDestinations = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLogging();
        message.producerDestinations = object.producerDestinations?.map(e => Logging_LoggingDestination.fromPartial(e)) || [];
        message.consumerDestinations = object.consumerDestinations?.map(e => Logging_LoggingDestination.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            producerDestinations: Array.isArray(object?.producer_destinations) ? object.producer_destinations.map((e) => Logging_LoggingDestination.fromSDK(e)) : [],
            consumerDestinations: Array.isArray(object?.consumer_destinations) ? object.consumer_destinations.map((e) => Logging_LoggingDestination.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            producer_destinations: Array.isArray(object?.producer_destinations) ? object.producer_destinations.map((e) => Logging_LoggingDestination.fromSDKJSON(e)) : [],
            consumer_destinations: Array.isArray(object?.consumer_destinations) ? object.consumer_destinations.map((e) => Logging_LoggingDestination.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.producerDestinations) {
            obj.producer_destinations = message.producerDestinations.map(e => e ? Logging_LoggingDestination.toSDK(e) : undefined);
        }
        else {
            obj.producer_destinations = [];
        }
        if (message.consumerDestinations) {
            obj.consumer_destinations = message.consumerDestinations.map(e => e ? Logging_LoggingDestination.toSDK(e) : undefined);
        }
        else {
            obj.consumer_destinations = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLogging();
        message.producerDestinations = object.producer_destinations?.map(e => Logging_LoggingDestination.fromAmino(e)) || [];
        message.consumerDestinations = object.consumer_destinations?.map(e => Logging_LoggingDestination.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.producerDestinations) {
            obj.producer_destinations = message.producerDestinations.map(e => e ? Logging_LoggingDestination.toAmino(e) : undefined);
        }
        else {
            obj.producer_destinations = message.producerDestinations;
        }
        if (message.consumerDestinations) {
            obj.consumer_destinations = message.consumerDestinations.map(e => e ? Logging_LoggingDestination.toAmino(e) : undefined);
        }
        else {
            obj.consumer_destinations = message.consumerDestinations;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Logging.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Logging.decode(message.value);
    },
    toProto(message) {
        return Logging.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Logging",
            value: Logging.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Logging_LoggingDestination.registerTypeUrl();
    }
};
function createBaseLogging_LoggingDestination() {
    return {
        monitoredResource: "",
        logs: []
    };
}
export const Logging_LoggingDestination = {
    typeUrl: "/google.api.LoggingDestination",
    is(o) {
        return o && (o.$typeUrl === Logging_LoggingDestination.typeUrl || typeof o.monitoredResource === "string" && Array.isArray(o.logs) && (!o.logs.length || typeof o.logs[0] === "string"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Logging_LoggingDestination.typeUrl || typeof o.monitored_resource === "string" && Array.isArray(o.logs) && (!o.logs.length || typeof o.logs[0] === "string"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Logging_LoggingDestination.typeUrl || typeof o.monitored_resource === "string" && Array.isArray(o.logs) && (!o.logs.length || typeof o.logs[0] === "string"));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.monitoredResource !== undefined) {
            writer.uint32(26).string(message.monitoredResource);
        }
        for (const v of message.logs) {
            writer.uint32(10).string(v);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLogging_LoggingDestination();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 3:
                    message.monitoredResource = reader.string();
                    break;
                case 1:
                    message.logs.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLogging_LoggingDestination();
        if (isSet(object.monitoredResource))
            obj.monitoredResource = String(object.monitoredResource);
        if (Array.isArray(object?.logs))
            obj.logs = object.logs.map((e) => String(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.monitoredResource !== undefined && (obj.monitoredResource = message.monitoredResource);
        if (message.logs) {
            obj.logs = message.logs.map(e => e);
        }
        else {
            obj.logs = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLogging_LoggingDestination();
        message.monitoredResource = object.monitoredResource ?? "";
        message.logs = object.logs?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            monitoredResource: object?.monitored_resource,
            logs: Array.isArray(object?.logs) ? object.logs.map((e) => e) : []
        };
    },
    fromSDKJSON(object) {
        return {
            monitored_resource: isSet(object.monitored_resource) ? String(object.monitored_resource) : "",
            logs: Array.isArray(object?.logs) ? object.logs.map((e) => String(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.monitored_resource = message.monitoredResource;
        if (message.logs) {
            obj.logs = message.logs.map(e => e);
        }
        else {
            obj.logs = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLogging_LoggingDestination();
        if (object.monitored_resource !== undefined && object.monitored_resource !== null) {
            message.monitoredResource = object.monitored_resource;
        }
        message.logs = object.logs?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.monitored_resource = message.monitoredResource === "" ? undefined : message.monitoredResource;
        if (message.logs) {
            obj.logs = message.logs.map(e => e);
        }
        else {
            obj.logs = message.logs;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Logging_LoggingDestination.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Logging_LoggingDestination.decode(message.value);
    },
    toProto(message) {
        return Logging_LoggingDestination.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.LoggingDestination",
            value: Logging_LoggingDestination.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
