import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet, isObject } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseQuota() {
    return {
        limits: [],
        metricRules: []
    };
}
export const Quota = {
    typeUrl: "/google.api.Quota",
    is(o) {
        return o && (o.$typeUrl === Quota.typeUrl || Array.isArray(o.limits) && (!o.limits.length || QuotaLimit.is(o.limits[0])) && Array.isArray(o.metricRules) && (!o.metricRules.length || MetricRule.is(o.metricRules[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Quota.typeUrl || Array.isArray(o.limits) && (!o.limits.length || QuotaLimit.isSDK(o.limits[0])) && Array.isArray(o.metric_rules) && (!o.metric_rules.length || MetricRule.isSDK(o.metric_rules[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Quota.typeUrl || Array.isArray(o.limits) && (!o.limits.length || QuotaLimit.isAmino(o.limits[0])) && Array.isArray(o.metric_rules) && (!o.metric_rules.length || MetricRule.isAmino(o.metric_rules[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.limits) {
            QuotaLimit.encode(v, writer.uint32(26).fork()).ldelim();
        }
        for (const v of message.metricRules) {
            MetricRule.encode(v, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQuota();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 3:
                    message.limits.push(QuotaLimit.decode(reader, reader.uint32()));
                    break;
                case 4:
                    message.metricRules.push(MetricRule.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQuota();
        if (Array.isArray(object?.limits))
            obj.limits = object.limits.map((e) => QuotaLimit.fromJSON(e));
        if (Array.isArray(object?.metricRules))
            obj.metricRules = object.metricRules.map((e) => MetricRule.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.limits) {
            obj.limits = message.limits.map(e => e ? QuotaLimit.toJSON(e) : undefined);
        }
        else {
            obj.limits = [];
        }
        if (message.metricRules) {
            obj.metricRules = message.metricRules.map(e => e ? MetricRule.toJSON(e) : undefined);
        }
        else {
            obj.metricRules = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQuota();
        message.limits = object.limits?.map(e => QuotaLimit.fromPartial(e)) || [];
        message.metricRules = object.metricRules?.map(e => MetricRule.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            limits: Array.isArray(object?.limits) ? object.limits.map((e) => QuotaLimit.fromSDK(e)) : [],
            metricRules: Array.isArray(object?.metric_rules) ? object.metric_rules.map((e) => MetricRule.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            limits: Array.isArray(object?.limits) ? object.limits.map((e) => QuotaLimit.fromSDKJSON(e)) : [],
            metric_rules: Array.isArray(object?.metric_rules) ? object.metric_rules.map((e) => MetricRule.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.limits) {
            obj.limits = message.limits.map(e => e ? QuotaLimit.toSDK(e) : undefined);
        }
        else {
            obj.limits = [];
        }
        if (message.metricRules) {
            obj.metric_rules = message.metricRules.map(e => e ? MetricRule.toSDK(e) : undefined);
        }
        else {
            obj.metric_rules = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQuota();
        message.limits = object.limits?.map(e => QuotaLimit.fromAmino(e)) || [];
        message.metricRules = object.metric_rules?.map(e => MetricRule.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.limits) {
            obj.limits = message.limits.map(e => e ? QuotaLimit.toAmino(e) : undefined);
        }
        else {
            obj.limits = message.limits;
        }
        if (message.metricRules) {
            obj.metric_rules = message.metricRules.map(e => e ? MetricRule.toAmino(e) : undefined);
        }
        else {
            obj.metric_rules = message.metricRules;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Quota.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Quota.decode(message.value);
    },
    toProto(message) {
        return Quota.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Quota",
            value: Quota.encode(message).finish()
        };
    },
    registerTypeUrl() {
        QuotaLimit.registerTypeUrl();
        MetricRule.registerTypeUrl();
    }
};
function createBaseMetricRule_MetricCostsEntry() {
    return {
        key: "",
        value: BigInt(0)
    };
}
export const MetricRule_MetricCostsEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(16).int64(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMetricRule_MetricCostsEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMetricRule_MetricCostsEntry();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = BigInt(object.value.toString());
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = (message.value || BigInt(0)).toString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMetricRule_MetricCostsEntry();
        message.key = object.key ?? "";
        if (object.value !== undefined && object.value !== null) {
            message.value = BigInt(object.value.toString());
        }
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? BigInt(object.value.toString()) : BigInt(0)
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMetricRule_MetricCostsEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = BigInt(object.value);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value !== BigInt(0) ? message.value?.toString() : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return MetricRule_MetricCostsEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MetricRule_MetricCostsEntry.decode(message.value);
    },
    toProto(message) {
        return MetricRule_MetricCostsEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseMetricRule() {
    return {
        selector: "",
        metricCosts: {}
    };
}
export const MetricRule = {
    typeUrl: "/google.api.MetricRule",
    is(o) {
        return o && (o.$typeUrl === MetricRule.typeUrl || typeof o.selector === "string" && isSet(o.metricCosts));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MetricRule.typeUrl || typeof o.selector === "string" && isSet(o.metric_costs));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MetricRule.typeUrl || typeof o.selector === "string" && isSet(o.metric_costs));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.selector !== undefined) {
            writer.uint32(10).string(message.selector);
        }
        Object.entries(message.metricCosts).forEach(([key, value]) => {
            MetricRule_MetricCostsEntry.encode({
                key: key,
                value
            }, writer.uint32(16).fork()).ldelim();
        });
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMetricRule();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.selector = reader.string();
                    break;
                case 2:
                    const entry2 = MetricRule_MetricCostsEntry.decode(reader, reader.uint32());
                    if (entry2.value !== undefined) {
                        message.metricCosts[entry2.key] = entry2.value;
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMetricRule();
        if (isSet(object.selector))
            obj.selector = String(object.selector);
        if (isObject(object.metricCosts))
            obj.metricCosts = Object.entries(object.metricCosts).reduce((acc, [key, value]) => {
                acc[key] = BigInt(value.toString());
                return acc;
            }, {});
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.selector !== undefined && (obj.selector = message.selector);
        obj.metricCosts = {};
        if (message.metricCosts) {
            Object.entries(message.metricCosts).forEach(([k, v]) => {
                obj.metricCosts[k] = v.toString();
            });
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMetricRule();
        message.selector = object.selector ?? "";
        message.metricCosts = Object.entries(object.metricCosts ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = BigInt(value.toString());
            }
            return acc;
        }, {});
        return message;
    },
    fromSDK(object) {
        return {
            selector: object?.selector,
            metricCosts: isObject(object.metric_costs) ? Object.entries(object.metric_costs).reduce((acc, [key, value]) => {
                acc[key] = BigInt(value.toString());
                return acc;
            }, {}) : {}
        };
    },
    fromSDKJSON(object) {
        return {
            selector: isSet(object.selector) ? String(object.selector) : "",
            metric_costs: isObject(object.metric_costs) ? Object.entries(object.metric_costs).reduce((acc, [key, value]) => {
                acc[key] = BigInt(value.toString());
                return acc;
            }, {}) : {}
        };
    },
    toSDK(message) {
        const obj = {};
        obj.selector = message.selector;
        obj.metric_costs = {};
        if (message.metricCosts) {
            Object.entries(message.metricCosts).forEach(([k, v]) => {
                obj.metric_costs[k] = v.toString();
            });
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMetricRule();
        if (object.selector !== undefined && object.selector !== null) {
            message.selector = object.selector;
        }
        message.metricCosts = Object.entries(object.metric_costs ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = BigInt(value.toString());
            }
            return acc;
        }, {});
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.selector = message.selector === "" ? undefined : message.selector;
        obj.metric_costs = {};
        if (message.metricCosts) {
            Object.entries(message.metricCosts).forEach(([k, v]) => {
                obj.metric_costs[k] = v.toString();
            });
        }
        return obj;
    },
    fromAminoMsg(object) {
        return MetricRule.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MetricRule.decode(message.value);
    },
    toProto(message) {
        return MetricRule.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.MetricRule",
            value: MetricRule.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseQuotaLimit_ValuesEntry() {
    return {
        key: "",
        value: BigInt(0)
    };
}
export const QuotaLimit_ValuesEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(16).int64(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQuotaLimit_ValuesEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQuotaLimit_ValuesEntry();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = BigInt(object.value.toString());
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = (message.value || BigInt(0)).toString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQuotaLimit_ValuesEntry();
        message.key = object.key ?? "";
        if (object.value !== undefined && object.value !== null) {
            message.value = BigInt(object.value.toString());
        }
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? BigInt(object.value.toString()) : BigInt(0)
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQuotaLimit_ValuesEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = BigInt(object.value);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value !== BigInt(0) ? message.value?.toString() : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return QuotaLimit_ValuesEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QuotaLimit_ValuesEntry.decode(message.value);
    },
    toProto(message) {
        return QuotaLimit_ValuesEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseQuotaLimit() {
    return {
        name: "",
        description: "",
        defaultLimit: BigInt(0),
        maxLimit: BigInt(0),
        freeTier: BigInt(0),
        duration: "",
        metric: "",
        unit: "",
        values: {},
        displayName: ""
    };
}
export const QuotaLimit = {
    typeUrl: "/google.api.QuotaLimit",
    is(o) {
        return o && (o.$typeUrl === QuotaLimit.typeUrl || typeof o.name === "string" && typeof o.description === "string" && typeof o.defaultLimit === "bigint" && typeof o.maxLimit === "bigint" && typeof o.freeTier === "bigint" && typeof o.duration === "string" && typeof o.metric === "string" && typeof o.unit === "string" && isSet(o.values) && typeof o.displayName === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === QuotaLimit.typeUrl || typeof o.name === "string" && typeof o.description === "string" && typeof o.default_limit === "bigint" && typeof o.max_limit === "bigint" && typeof o.free_tier === "bigint" && typeof o.duration === "string" && typeof o.metric === "string" && typeof o.unit === "string" && isSet(o.values) && typeof o.display_name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === QuotaLimit.typeUrl || typeof o.name === "string" && typeof o.description === "string" && typeof o.default_limit === "bigint" && typeof o.max_limit === "bigint" && typeof o.free_tier === "bigint" && typeof o.duration === "string" && typeof o.metric === "string" && typeof o.unit === "string" && isSet(o.values) && typeof o.display_name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(50).string(message.name);
        }
        if (message.description !== undefined) {
            writer.uint32(18).string(message.description);
        }
        if (message.defaultLimit !== undefined) {
            writer.uint32(24).int64(message.defaultLimit);
        }
        if (message.maxLimit !== undefined) {
            writer.uint32(32).int64(message.maxLimit);
        }
        if (message.freeTier !== undefined) {
            writer.uint32(56).int64(message.freeTier);
        }
        if (message.duration !== undefined) {
            writer.uint32(42).string(message.duration);
        }
        if (message.metric !== undefined) {
            writer.uint32(66).string(message.metric);
        }
        if (message.unit !== undefined) {
            writer.uint32(74).string(message.unit);
        }
        Object.entries(message.values).forEach(([key, value]) => {
            QuotaLimit_ValuesEntry.encode({
                key: key,
                value
            }, writer.uint32(80).fork()).ldelim();
        });
        if (message.displayName !== undefined) {
            writer.uint32(98).string(message.displayName);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseQuotaLimit();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 6:
                    message.name = reader.string();
                    break;
                case 2:
                    message.description = reader.string();
                    break;
                case 3:
                    message.defaultLimit = reader.int64();
                    break;
                case 4:
                    message.maxLimit = reader.int64();
                    break;
                case 7:
                    message.freeTier = reader.int64();
                    break;
                case 5:
                    message.duration = reader.string();
                    break;
                case 8:
                    message.metric = reader.string();
                    break;
                case 9:
                    message.unit = reader.string();
                    break;
                case 10:
                    const entry10 = QuotaLimit_ValuesEntry.decode(reader, reader.uint32());
                    if (entry10.value !== undefined) {
                        message.values[entry10.key] = entry10.value;
                    }
                    break;
                case 12:
                    message.displayName = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseQuotaLimit();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.description))
            obj.description = String(object.description);
        if (isSet(object.defaultLimit))
            obj.defaultLimit = BigInt(object.defaultLimit.toString());
        if (isSet(object.maxLimit))
            obj.maxLimit = BigInt(object.maxLimit.toString());
        if (isSet(object.freeTier))
            obj.freeTier = BigInt(object.freeTier.toString());
        if (isSet(object.duration))
            obj.duration = String(object.duration);
        if (isSet(object.metric))
            obj.metric = String(object.metric);
        if (isSet(object.unit))
            obj.unit = String(object.unit);
        if (isObject(object.values))
            obj.values = Object.entries(object.values).reduce((acc, [key, value]) => {
                acc[key] = BigInt(value.toString());
                return acc;
            }, {});
        if (isSet(object.displayName))
            obj.displayName = String(object.displayName);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.description !== undefined && (obj.description = message.description);
        message.defaultLimit !== undefined && (obj.defaultLimit = (message.defaultLimit || BigInt(0)).toString());
        message.maxLimit !== undefined && (obj.maxLimit = (message.maxLimit || BigInt(0)).toString());
        message.freeTier !== undefined && (obj.freeTier = (message.freeTier || BigInt(0)).toString());
        message.duration !== undefined && (obj.duration = message.duration);
        message.metric !== undefined && (obj.metric = message.metric);
        message.unit !== undefined && (obj.unit = message.unit);
        obj.values = {};
        if (message.values) {
            Object.entries(message.values).forEach(([k, v]) => {
                obj.values[k] = v.toString();
            });
        }
        message.displayName !== undefined && (obj.displayName = message.displayName);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseQuotaLimit();
        message.name = object.name ?? "";
        message.description = object.description ?? "";
        if (object.defaultLimit !== undefined && object.defaultLimit !== null) {
            message.defaultLimit = BigInt(object.defaultLimit.toString());
        }
        if (object.maxLimit !== undefined && object.maxLimit !== null) {
            message.maxLimit = BigInt(object.maxLimit.toString());
        }
        if (object.freeTier !== undefined && object.freeTier !== null) {
            message.freeTier = BigInt(object.freeTier.toString());
        }
        message.duration = object.duration ?? "";
        message.metric = object.metric ?? "";
        message.unit = object.unit ?? "";
        message.values = Object.entries(object.values ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = BigInt(value.toString());
            }
            return acc;
        }, {});
        message.displayName = object.displayName ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            description: object?.description,
            defaultLimit: object?.default_limit,
            maxLimit: object?.max_limit,
            freeTier: object?.free_tier,
            duration: object?.duration,
            metric: object?.metric,
            unit: object?.unit,
            values: isObject(object.values) ? Object.entries(object.values).reduce((acc, [key, value]) => {
                acc[key] = BigInt(value.toString());
                return acc;
            }, {}) : {},
            displayName: object?.display_name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            description: isSet(object.description) ? String(object.description) : "",
            default_limit: isSet(object.default_limit) ? BigInt(object.default_limit.toString()) : BigInt(0),
            max_limit: isSet(object.max_limit) ? BigInt(object.max_limit.toString()) : BigInt(0),
            free_tier: isSet(object.free_tier) ? BigInt(object.free_tier.toString()) : BigInt(0),
            duration: isSet(object.duration) ? String(object.duration) : "",
            metric: isSet(object.metric) ? String(object.metric) : "",
            unit: isSet(object.unit) ? String(object.unit) : "",
            values: isObject(object.values) ? Object.entries(object.values).reduce((acc, [key, value]) => {
                acc[key] = BigInt(value.toString());
                return acc;
            }, {}) : {},
            display_name: isSet(object.display_name) ? String(object.display_name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.description = message.description;
        obj.default_limit = message.defaultLimit;
        obj.max_limit = message.maxLimit;
        obj.free_tier = message.freeTier;
        obj.duration = message.duration;
        obj.metric = message.metric;
        obj.unit = message.unit;
        obj.values = {};
        if (message.values) {
            Object.entries(message.values).forEach(([k, v]) => {
                obj.values[k] = v.toString();
            });
        }
        obj.display_name = message.displayName;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseQuotaLimit();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.description !== undefined && object.description !== null) {
            message.description = object.description;
        }
        if (object.default_limit !== undefined && object.default_limit !== null) {
            message.defaultLimit = BigInt(object.default_limit);
        }
        if (object.max_limit !== undefined && object.max_limit !== null) {
            message.maxLimit = BigInt(object.max_limit);
        }
        if (object.free_tier !== undefined && object.free_tier !== null) {
            message.freeTier = BigInt(object.free_tier);
        }
        if (object.duration !== undefined && object.duration !== null) {
            message.duration = object.duration;
        }
        if (object.metric !== undefined && object.metric !== null) {
            message.metric = object.metric;
        }
        if (object.unit !== undefined && object.unit !== null) {
            message.unit = object.unit;
        }
        message.values = Object.entries(object.values ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = BigInt(value.toString());
            }
            return acc;
        }, {});
        if (object.display_name !== undefined && object.display_name !== null) {
            message.displayName = object.display_name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.description = message.description === "" ? undefined : message.description;
        obj.default_limit = message.defaultLimit !== BigInt(0) ? message.defaultLimit?.toString() : undefined;
        obj.max_limit = message.maxLimit !== BigInt(0) ? message.maxLimit?.toString() : undefined;
        obj.free_tier = message.freeTier !== BigInt(0) ? message.freeTier?.toString() : undefined;
        obj.duration = message.duration === "" ? undefined : message.duration;
        obj.metric = message.metric === "" ? undefined : message.metric;
        obj.unit = message.unit === "" ? undefined : message.unit;
        obj.values = {};
        if (message.values) {
            Object.entries(message.values).forEach(([k, v]) => {
                obj.values[k] = v.toString();
            });
        }
        obj.display_name = message.displayName === "" ? undefined : message.displayName;
        return obj;
    },
    fromAminoMsg(object) {
        return QuotaLimit.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return QuotaLimit.decode(message.value);
    },
    toProto(message) {
        return QuotaLimit.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.QuotaLimit",
            value: QuotaLimit.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
