import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseRoutingRule() {
    return {
        routingParameters: []
    };
}
export const RoutingRule = {
    typeUrl: "/google.api.RoutingRule",
    is(o) {
        return o && (o.$typeUrl === RoutingRule.typeUrl || Array.isArray(o.routingParameters) && (!o.routingParameters.length || RoutingParameter.is(o.routingParameters[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === RoutingRule.typeUrl || Array.isArray(o.routing_parameters) && (!o.routing_parameters.length || RoutingParameter.isSDK(o.routing_parameters[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === RoutingRule.typeUrl || Array.isArray(o.routing_parameters) && (!o.routing_parameters.length || RoutingParameter.isAmino(o.routing_parameters[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.routingParameters) {
            RoutingParameter.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRoutingRule();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 2:
                    message.routingParameters.push(RoutingParameter.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseRoutingRule();
        if (Array.isArray(object?.routingParameters))
            obj.routingParameters = object.routingParameters.map((e) => RoutingParameter.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.routingParameters) {
            obj.routingParameters = message.routingParameters.map(e => e ? RoutingParameter.toJSON(e) : undefined);
        }
        else {
            obj.routingParameters = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseRoutingRule();
        message.routingParameters = object.routingParameters?.map(e => RoutingParameter.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            routingParameters: Array.isArray(object?.routing_parameters) ? object.routing_parameters.map((e) => RoutingParameter.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            routing_parameters: Array.isArray(object?.routing_parameters) ? object.routing_parameters.map((e) => RoutingParameter.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.routingParameters) {
            obj.routing_parameters = message.routingParameters.map(e => e ? RoutingParameter.toSDK(e) : undefined);
        }
        else {
            obj.routing_parameters = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseRoutingRule();
        message.routingParameters = object.routing_parameters?.map(e => RoutingParameter.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.routingParameters) {
            obj.routing_parameters = message.routingParameters.map(e => e ? RoutingParameter.toAmino(e) : undefined);
        }
        else {
            obj.routing_parameters = message.routingParameters;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return RoutingRule.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return RoutingRule.decode(message.value);
    },
    toProto(message) {
        return RoutingRule.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.RoutingRule",
            value: RoutingRule.encode(message).finish()
        };
    },
    registerTypeUrl() {
        RoutingParameter.registerTypeUrl();
    }
};
function createBaseRoutingParameter() {
    return {
        field: "",
        pathTemplate: ""
    };
}
export const RoutingParameter = {
    typeUrl: "/google.api.RoutingParameter",
    is(o) {
        return o && (o.$typeUrl === RoutingParameter.typeUrl || typeof o.field === "string" && typeof o.pathTemplate === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === RoutingParameter.typeUrl || typeof o.field === "string" && typeof o.path_template === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === RoutingParameter.typeUrl || typeof o.field === "string" && typeof o.path_template === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.field !== undefined) {
            writer.uint32(10).string(message.field);
        }
        if (message.pathTemplate !== undefined) {
            writer.uint32(18).string(message.pathTemplate);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRoutingParameter();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.field = reader.string();
                    break;
                case 2:
                    message.pathTemplate = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseRoutingParameter();
        if (isSet(object.field))
            obj.field = String(object.field);
        if (isSet(object.pathTemplate))
            obj.pathTemplate = String(object.pathTemplate);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.field !== undefined && (obj.field = message.field);
        message.pathTemplate !== undefined && (obj.pathTemplate = message.pathTemplate);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseRoutingParameter();
        message.field = object.field ?? "";
        message.pathTemplate = object.pathTemplate ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            field: object?.field,
            pathTemplate: object?.path_template
        };
    },
    fromSDKJSON(object) {
        return {
            field: isSet(object.field) ? String(object.field) : "",
            path_template: isSet(object.path_template) ? String(object.path_template) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.field = message.field;
        obj.path_template = message.pathTemplate;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseRoutingParameter();
        if (object.field !== undefined && object.field !== null) {
            message.field = object.field;
        }
        if (object.path_template !== undefined && object.path_template !== null) {
            message.pathTemplate = object.path_template;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.field = message.field === "" ? undefined : message.field;
        obj.path_template = message.pathTemplate === "" ? undefined : message.pathTemplate;
        return obj;
    },
    fromAminoMsg(object) {
        return RoutingParameter.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return RoutingParameter.decode(message.value);
    },
    toProto(message) {
        return RoutingParameter.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.RoutingParameter",
            value: RoutingParameter.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
