import { Distribution_Exemplar } from "../../distribution";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { isSet } from "../../../../helpers";
export const protobufPackage = "google.api.servicecontrol.v1";
function createBaseDistribution() {
    return {
        count: BigInt(0),
        mean: 0,
        minimum: 0,
        maximum: 0,
        sumOfSquaredDeviation: 0,
        bucketCounts: [],
        linearBuckets: undefined,
        exponentialBuckets: undefined,
        explicitBuckets: undefined,
        exemplars: []
    };
}
export const Distribution = {
    typeUrl: "/google.api.servicecontrol.v1.Distribution",
    is(o) {
        return o && (o.$typeUrl === Distribution.typeUrl || typeof o.count === "bigint" && typeof o.mean === "number" && typeof o.minimum === "number" && typeof o.maximum === "number" && typeof o.sumOfSquaredDeviation === "number" && Array.isArray(o.bucketCounts) && (!o.bucketCounts.length || typeof o.bucketCounts[0] === "bigint") && Array.isArray(o.exemplars) && (!o.exemplars.length || Distribution_Exemplar.is(o.exemplars[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Distribution.typeUrl || typeof o.count === "bigint" && typeof o.mean === "number" && typeof o.minimum === "number" && typeof o.maximum === "number" && typeof o.sum_of_squared_deviation === "number" && Array.isArray(o.bucket_counts) && (!o.bucket_counts.length || typeof o.bucket_counts[0] === "bigint") && Array.isArray(o.exemplars) && (!o.exemplars.length || Distribution_Exemplar.isSDK(o.exemplars[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Distribution.typeUrl || typeof o.count === "bigint" && typeof o.mean === "number" && typeof o.minimum === "number" && typeof o.maximum === "number" && typeof o.sum_of_squared_deviation === "number" && Array.isArray(o.bucket_counts) && (!o.bucket_counts.length || typeof o.bucket_counts[0] === "bigint") && Array.isArray(o.exemplars) && (!o.exemplars.length || Distribution_Exemplar.isAmino(o.exemplars[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.count !== undefined) {
            writer.uint32(8).int64(message.count);
        }
        if (message.mean !== undefined) {
            writer.uint32(17).double(message.mean);
        }
        if (message.minimum !== undefined) {
            writer.uint32(25).double(message.minimum);
        }
        if (message.maximum !== undefined) {
            writer.uint32(33).double(message.maximum);
        }
        if (message.sumOfSquaredDeviation !== undefined) {
            writer.uint32(41).double(message.sumOfSquaredDeviation);
        }
        writer.uint32(50).fork();
        for (const v of message.bucketCounts) {
            writer.int64(v);
        }
        writer.ldelim();
        if (message.linearBuckets !== undefined) {
            Distribution_LinearBuckets.encode(message.linearBuckets, writer.uint32(58).fork()).ldelim();
        }
        if (message.exponentialBuckets !== undefined) {
            Distribution_ExponentialBuckets.encode(message.exponentialBuckets, writer.uint32(66).fork()).ldelim();
        }
        if (message.explicitBuckets !== undefined) {
            Distribution_ExplicitBuckets.encode(message.explicitBuckets, writer.uint32(74).fork()).ldelim();
        }
        for (const v of message.exemplars) {
            Distribution_Exemplar.encode(v, writer.uint32(82).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDistribution();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.count = reader.int64();
                    break;
                case 2:
                    message.mean = reader.double();
                    break;
                case 3:
                    message.minimum = reader.double();
                    break;
                case 4:
                    message.maximum = reader.double();
                    break;
                case 5:
                    message.sumOfSquaredDeviation = reader.double();
                    break;
                case 6:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.bucketCounts.push(reader.int64());
                        }
                    }
                    else {
                        message.bucketCounts.push(reader.int64());
                    }
                    break;
                case 7:
                    message.linearBuckets = Distribution_LinearBuckets.decode(reader, reader.uint32());
                    break;
                case 8:
                    message.exponentialBuckets = Distribution_ExponentialBuckets.decode(reader, reader.uint32());
                    break;
                case 9:
                    message.explicitBuckets = Distribution_ExplicitBuckets.decode(reader, reader.uint32());
                    break;
                case 10:
                    message.exemplars.push(Distribution_Exemplar.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDistribution();
        if (isSet(object.count))
            obj.count = BigInt(object.count.toString());
        if (isSet(object.mean))
            obj.mean = Number(object.mean);
        if (isSet(object.minimum))
            obj.minimum = Number(object.minimum);
        if (isSet(object.maximum))
            obj.maximum = Number(object.maximum);
        if (isSet(object.sumOfSquaredDeviation))
            obj.sumOfSquaredDeviation = Number(object.sumOfSquaredDeviation);
        if (Array.isArray(object?.bucketCounts))
            obj.bucketCounts = object.bucketCounts.map((e) => BigInt(e.toString()));
        if (isSet(object.linearBuckets))
            obj.linearBuckets = Distribution_LinearBuckets.fromJSON(object.linearBuckets);
        if (isSet(object.exponentialBuckets))
            obj.exponentialBuckets = Distribution_ExponentialBuckets.fromJSON(object.exponentialBuckets);
        if (isSet(object.explicitBuckets))
            obj.explicitBuckets = Distribution_ExplicitBuckets.fromJSON(object.explicitBuckets);
        if (Array.isArray(object?.exemplars))
            obj.exemplars = object.exemplars.map((e) => Distribution_Exemplar.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.count !== undefined && (obj.count = (message.count || BigInt(0)).toString());
        message.mean !== undefined && (obj.mean = message.mean);
        message.minimum !== undefined && (obj.minimum = message.minimum);
        message.maximum !== undefined && (obj.maximum = message.maximum);
        message.sumOfSquaredDeviation !== undefined && (obj.sumOfSquaredDeviation = message.sumOfSquaredDeviation);
        if (message.bucketCounts) {
            obj.bucketCounts = message.bucketCounts.map(e => (e || BigInt(0)).toString());
        }
        else {
            obj.bucketCounts = [];
        }
        message.linearBuckets !== undefined && (obj.linearBuckets = message.linearBuckets ? Distribution_LinearBuckets.toJSON(message.linearBuckets) : undefined);
        message.exponentialBuckets !== undefined && (obj.exponentialBuckets = message.exponentialBuckets ? Distribution_ExponentialBuckets.toJSON(message.exponentialBuckets) : undefined);
        message.explicitBuckets !== undefined && (obj.explicitBuckets = message.explicitBuckets ? Distribution_ExplicitBuckets.toJSON(message.explicitBuckets) : undefined);
        if (message.exemplars) {
            obj.exemplars = message.exemplars.map(e => e ? Distribution_Exemplar.toJSON(e) : undefined);
        }
        else {
            obj.exemplars = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDistribution();
        if (object.count !== undefined && object.count !== null) {
            message.count = BigInt(object.count.toString());
        }
        message.mean = object.mean ?? 0;
        message.minimum = object.minimum ?? 0;
        message.maximum = object.maximum ?? 0;
        message.sumOfSquaredDeviation = object.sumOfSquaredDeviation ?? 0;
        message.bucketCounts = object.bucketCounts?.map(e => BigInt(e.toString())) || [];
        if (object.linearBuckets !== undefined && object.linearBuckets !== null) {
            message.linearBuckets = Distribution_LinearBuckets.fromPartial(object.linearBuckets);
        }
        if (object.exponentialBuckets !== undefined && object.exponentialBuckets !== null) {
            message.exponentialBuckets = Distribution_ExponentialBuckets.fromPartial(object.exponentialBuckets);
        }
        if (object.explicitBuckets !== undefined && object.explicitBuckets !== null) {
            message.explicitBuckets = Distribution_ExplicitBuckets.fromPartial(object.explicitBuckets);
        }
        message.exemplars = object.exemplars?.map(e => Distribution_Exemplar.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            count: object?.count,
            mean: object?.mean,
            minimum: object?.minimum,
            maximum: object?.maximum,
            sumOfSquaredDeviation: object?.sum_of_squared_deviation,
            bucketCounts: Array.isArray(object?.bucket_counts) ? object.bucket_counts.map((e) => e) : [],
            linearBuckets: object.linear_buckets ? Distribution_LinearBuckets.fromSDK(object.linear_buckets) : undefined,
            exponentialBuckets: object.exponential_buckets ? Distribution_ExponentialBuckets.fromSDK(object.exponential_buckets) : undefined,
            explicitBuckets: object.explicit_buckets ? Distribution_ExplicitBuckets.fromSDK(object.explicit_buckets) : undefined,
            exemplars: Array.isArray(object?.exemplars) ? object.exemplars.map((e) => Distribution_Exemplar.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            count: isSet(object.count) ? BigInt(object.count.toString()) : BigInt(0),
            mean: isSet(object.mean) ? Number(object.mean) : 0,
            minimum: isSet(object.minimum) ? Number(object.minimum) : 0,
            maximum: isSet(object.maximum) ? Number(object.maximum) : 0,
            sum_of_squared_deviation: isSet(object.sum_of_squared_deviation) ? Number(object.sum_of_squared_deviation) : 0,
            bucket_counts: Array.isArray(object?.bucket_counts) ? object.bucket_counts.map((e) => BigInt(e.toString())) : [],
            linear_buckets: isSet(object.linear_buckets) ? Distribution_LinearBuckets.fromSDKJSON(object.linear_buckets) : undefined,
            exponential_buckets: isSet(object.exponential_buckets) ? Distribution_ExponentialBuckets.fromSDKJSON(object.exponential_buckets) : undefined,
            explicit_buckets: isSet(object.explicit_buckets) ? Distribution_ExplicitBuckets.fromSDKJSON(object.explicit_buckets) : undefined,
            exemplars: Array.isArray(object?.exemplars) ? object.exemplars.map((e) => Distribution_Exemplar.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.count = message.count;
        obj.mean = message.mean;
        obj.minimum = message.minimum;
        obj.maximum = message.maximum;
        obj.sum_of_squared_deviation = message.sumOfSquaredDeviation;
        if (message.bucketCounts) {
            obj.bucket_counts = message.bucketCounts.map(e => e);
        }
        else {
            obj.bucket_counts = [];
        }
        message.linearBuckets !== undefined && (obj.linear_buckets = message.linearBuckets ? Distribution_LinearBuckets.toSDK(message.linearBuckets) : undefined);
        message.exponentialBuckets !== undefined && (obj.exponential_buckets = message.exponentialBuckets ? Distribution_ExponentialBuckets.toSDK(message.exponentialBuckets) : undefined);
        message.explicitBuckets !== undefined && (obj.explicit_buckets = message.explicitBuckets ? Distribution_ExplicitBuckets.toSDK(message.explicitBuckets) : undefined);
        if (message.exemplars) {
            obj.exemplars = message.exemplars.map(e => e ? Distribution_Exemplar.toSDK(e) : undefined);
        }
        else {
            obj.exemplars = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDistribution();
        if (object.count !== undefined && object.count !== null) {
            message.count = BigInt(object.count);
        }
        if (object.mean !== undefined && object.mean !== null) {
            message.mean = object.mean;
        }
        if (object.minimum !== undefined && object.minimum !== null) {
            message.minimum = object.minimum;
        }
        if (object.maximum !== undefined && object.maximum !== null) {
            message.maximum = object.maximum;
        }
        if (object.sum_of_squared_deviation !== undefined && object.sum_of_squared_deviation !== null) {
            message.sumOfSquaredDeviation = object.sum_of_squared_deviation;
        }
        message.bucketCounts = object.bucket_counts?.map(e => BigInt(e)) || [];
        if (object.linear_buckets !== undefined && object.linear_buckets !== null) {
            message.linearBuckets = Distribution_LinearBuckets.fromAmino(object.linear_buckets);
        }
        if (object.exponential_buckets !== undefined && object.exponential_buckets !== null) {
            message.exponentialBuckets = Distribution_ExponentialBuckets.fromAmino(object.exponential_buckets);
        }
        if (object.explicit_buckets !== undefined && object.explicit_buckets !== null) {
            message.explicitBuckets = Distribution_ExplicitBuckets.fromAmino(object.explicit_buckets);
        }
        message.exemplars = object.exemplars?.map(e => Distribution_Exemplar.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.count = message.count !== BigInt(0) ? message.count?.toString() : undefined;
        obj.mean = message.mean === 0 ? undefined : message.mean;
        obj.minimum = message.minimum === 0 ? undefined : message.minimum;
        obj.maximum = message.maximum === 0 ? undefined : message.maximum;
        obj.sum_of_squared_deviation = message.sumOfSquaredDeviation === 0 ? undefined : message.sumOfSquaredDeviation;
        if (message.bucketCounts) {
            obj.bucket_counts = message.bucketCounts.map(e => e.toString());
        }
        else {
            obj.bucket_counts = message.bucketCounts;
        }
        obj.linear_buckets = message.linearBuckets ? Distribution_LinearBuckets.toAmino(message.linearBuckets) : undefined;
        obj.exponential_buckets = message.exponentialBuckets ? Distribution_ExponentialBuckets.toAmino(message.exponentialBuckets) : undefined;
        obj.explicit_buckets = message.explicitBuckets ? Distribution_ExplicitBuckets.toAmino(message.explicitBuckets) : undefined;
        if (message.exemplars) {
            obj.exemplars = message.exemplars.map(e => e ? Distribution_Exemplar.toAmino(e) : undefined);
        }
        else {
            obj.exemplars = message.exemplars;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Distribution.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Distribution.decode(message.value);
    },
    toProto(message) {
        return Distribution.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicecontrol.v1.Distribution",
            value: Distribution.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Distribution_LinearBuckets.registerTypeUrl();
        Distribution_ExponentialBuckets.registerTypeUrl();
        Distribution_ExplicitBuckets.registerTypeUrl();
        Distribution_Exemplar.registerTypeUrl();
    }
};
function createBaseDistribution_LinearBuckets() {
    return {
        numFiniteBuckets: 0,
        width: 0,
        offset: 0
    };
}
export const Distribution_LinearBuckets = {
    typeUrl: "/google.api.servicecontrol.v1.LinearBuckets",
    is(o) {
        return o && (o.$typeUrl === Distribution_LinearBuckets.typeUrl || typeof o.numFiniteBuckets === "number" && typeof o.width === "number" && typeof o.offset === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Distribution_LinearBuckets.typeUrl || typeof o.num_finite_buckets === "number" && typeof o.width === "number" && typeof o.offset === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Distribution_LinearBuckets.typeUrl || typeof o.num_finite_buckets === "number" && typeof o.width === "number" && typeof o.offset === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.numFiniteBuckets !== undefined) {
            writer.uint32(8).int32(message.numFiniteBuckets);
        }
        if (message.width !== undefined) {
            writer.uint32(17).double(message.width);
        }
        if (message.offset !== undefined) {
            writer.uint32(25).double(message.offset);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDistribution_LinearBuckets();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.numFiniteBuckets = reader.int32();
                    break;
                case 2:
                    message.width = reader.double();
                    break;
                case 3:
                    message.offset = reader.double();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDistribution_LinearBuckets();
        if (isSet(object.numFiniteBuckets))
            obj.numFiniteBuckets = Number(object.numFiniteBuckets);
        if (isSet(object.width))
            obj.width = Number(object.width);
        if (isSet(object.offset))
            obj.offset = Number(object.offset);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.numFiniteBuckets !== undefined && (obj.numFiniteBuckets = Math.round(message.numFiniteBuckets));
        message.width !== undefined && (obj.width = message.width);
        message.offset !== undefined && (obj.offset = message.offset);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDistribution_LinearBuckets();
        message.numFiniteBuckets = object.numFiniteBuckets ?? 0;
        message.width = object.width ?? 0;
        message.offset = object.offset ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            numFiniteBuckets: object?.num_finite_buckets,
            width: object?.width,
            offset: object?.offset
        };
    },
    fromSDKJSON(object) {
        return {
            num_finite_buckets: isSet(object.num_finite_buckets) ? Number(object.num_finite_buckets) : 0,
            width: isSet(object.width) ? Number(object.width) : 0,
            offset: isSet(object.offset) ? Number(object.offset) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.num_finite_buckets = message.numFiniteBuckets;
        obj.width = message.width;
        obj.offset = message.offset;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDistribution_LinearBuckets();
        if (object.num_finite_buckets !== undefined && object.num_finite_buckets !== null) {
            message.numFiniteBuckets = object.num_finite_buckets;
        }
        if (object.width !== undefined && object.width !== null) {
            message.width = object.width;
        }
        if (object.offset !== undefined && object.offset !== null) {
            message.offset = object.offset;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.num_finite_buckets = message.numFiniteBuckets === 0 ? undefined : message.numFiniteBuckets;
        obj.width = message.width === 0 ? undefined : message.width;
        obj.offset = message.offset === 0 ? undefined : message.offset;
        return obj;
    },
    fromAminoMsg(object) {
        return Distribution_LinearBuckets.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Distribution_LinearBuckets.decode(message.value);
    },
    toProto(message) {
        return Distribution_LinearBuckets.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicecontrol.v1.LinearBuckets",
            value: Distribution_LinearBuckets.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseDistribution_ExponentialBuckets() {
    return {
        numFiniteBuckets: 0,
        growthFactor: 0,
        scale: 0
    };
}
export const Distribution_ExponentialBuckets = {
    typeUrl: "/google.api.servicecontrol.v1.ExponentialBuckets",
    is(o) {
        return o && (o.$typeUrl === Distribution_ExponentialBuckets.typeUrl || typeof o.numFiniteBuckets === "number" && typeof o.growthFactor === "number" && typeof o.scale === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Distribution_ExponentialBuckets.typeUrl || typeof o.num_finite_buckets === "number" && typeof o.growth_factor === "number" && typeof o.scale === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Distribution_ExponentialBuckets.typeUrl || typeof o.num_finite_buckets === "number" && typeof o.growth_factor === "number" && typeof o.scale === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.numFiniteBuckets !== undefined) {
            writer.uint32(8).int32(message.numFiniteBuckets);
        }
        if (message.growthFactor !== undefined) {
            writer.uint32(17).double(message.growthFactor);
        }
        if (message.scale !== undefined) {
            writer.uint32(25).double(message.scale);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDistribution_ExponentialBuckets();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.numFiniteBuckets = reader.int32();
                    break;
                case 2:
                    message.growthFactor = reader.double();
                    break;
                case 3:
                    message.scale = reader.double();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDistribution_ExponentialBuckets();
        if (isSet(object.numFiniteBuckets))
            obj.numFiniteBuckets = Number(object.numFiniteBuckets);
        if (isSet(object.growthFactor))
            obj.growthFactor = Number(object.growthFactor);
        if (isSet(object.scale))
            obj.scale = Number(object.scale);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.numFiniteBuckets !== undefined && (obj.numFiniteBuckets = Math.round(message.numFiniteBuckets));
        message.growthFactor !== undefined && (obj.growthFactor = message.growthFactor);
        message.scale !== undefined && (obj.scale = message.scale);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDistribution_ExponentialBuckets();
        message.numFiniteBuckets = object.numFiniteBuckets ?? 0;
        message.growthFactor = object.growthFactor ?? 0;
        message.scale = object.scale ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            numFiniteBuckets: object?.num_finite_buckets,
            growthFactor: object?.growth_factor,
            scale: object?.scale
        };
    },
    fromSDKJSON(object) {
        return {
            num_finite_buckets: isSet(object.num_finite_buckets) ? Number(object.num_finite_buckets) : 0,
            growth_factor: isSet(object.growth_factor) ? Number(object.growth_factor) : 0,
            scale: isSet(object.scale) ? Number(object.scale) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.num_finite_buckets = message.numFiniteBuckets;
        obj.growth_factor = message.growthFactor;
        obj.scale = message.scale;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDistribution_ExponentialBuckets();
        if (object.num_finite_buckets !== undefined && object.num_finite_buckets !== null) {
            message.numFiniteBuckets = object.num_finite_buckets;
        }
        if (object.growth_factor !== undefined && object.growth_factor !== null) {
            message.growthFactor = object.growth_factor;
        }
        if (object.scale !== undefined && object.scale !== null) {
            message.scale = object.scale;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.num_finite_buckets = message.numFiniteBuckets === 0 ? undefined : message.numFiniteBuckets;
        obj.growth_factor = message.growthFactor === 0 ? undefined : message.growthFactor;
        obj.scale = message.scale === 0 ? undefined : message.scale;
        return obj;
    },
    fromAminoMsg(object) {
        return Distribution_ExponentialBuckets.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Distribution_ExponentialBuckets.decode(message.value);
    },
    toProto(message) {
        return Distribution_ExponentialBuckets.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicecontrol.v1.ExponentialBuckets",
            value: Distribution_ExponentialBuckets.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseDistribution_ExplicitBuckets() {
    return {
        bounds: []
    };
}
export const Distribution_ExplicitBuckets = {
    typeUrl: "/google.api.servicecontrol.v1.ExplicitBuckets",
    is(o) {
        return o && (o.$typeUrl === Distribution_ExplicitBuckets.typeUrl || Array.isArray(o.bounds) && (!o.bounds.length || typeof o.bounds[0] === "number"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Distribution_ExplicitBuckets.typeUrl || Array.isArray(o.bounds) && (!o.bounds.length || typeof o.bounds[0] === "number"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Distribution_ExplicitBuckets.typeUrl || Array.isArray(o.bounds) && (!o.bounds.length || typeof o.bounds[0] === "number"));
    },
    encode(message, writer = BinaryWriter.create()) {
        writer.uint32(10).fork();
        for (const v of message.bounds) {
            writer.double(v);
        }
        writer.ldelim();
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDistribution_ExplicitBuckets();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    if ((tag & 7) === 2) {
                        const end2 = reader.uint32() + reader.pos;
                        while (reader.pos < end2) {
                            message.bounds.push(reader.double());
                        }
                    }
                    else {
                        message.bounds.push(reader.double());
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDistribution_ExplicitBuckets();
        if (Array.isArray(object?.bounds))
            obj.bounds = object.bounds.map((e) => Number(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.bounds) {
            obj.bounds = message.bounds.map(e => e);
        }
        else {
            obj.bounds = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDistribution_ExplicitBuckets();
        message.bounds = object.bounds?.map(e => e) || [];
        return message;
    },
    fromSDK(object) {
        return {
            bounds: Array.isArray(object?.bounds) ? object.bounds.map((e) => e) : []
        };
    },
    fromSDKJSON(object) {
        return {
            bounds: Array.isArray(object?.bounds) ? object.bounds.map((e) => Number(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.bounds) {
            obj.bounds = message.bounds.map(e => e);
        }
        else {
            obj.bounds = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDistribution_ExplicitBuckets();
        message.bounds = object.bounds?.map(e => e) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.bounds) {
            obj.bounds = message.bounds.map(e => e);
        }
        else {
            obj.bounds = message.bounds;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Distribution_ExplicitBuckets.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Distribution_ExplicitBuckets.decode(message.value);
    },
    toProto(message) {
        return Distribution_ExplicitBuckets.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicecontrol.v1.ExplicitBuckets",
            value: Distribution_ExplicitBuckets.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
