import { Duration } from "../../../protobuf/duration";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { isSet } from "../../../../helpers";
export const protobufPackage = "google.api.servicecontrol.v1";
function createBaseHttpRequest() {
    return {
        requestMethod: "",
        requestUrl: "",
        requestSize: BigInt(0),
        status: 0,
        responseSize: BigInt(0),
        userAgent: "",
        remoteIp: "",
        serverIp: "",
        referer: "",
        latency: undefined,
        cacheLookup: false,
        cacheHit: false,
        cacheValidatedWithOriginServer: false,
        cacheFillBytes: BigInt(0),
        protocol: ""
    };
}
export const HttpRequest = {
    typeUrl: "/google.api.servicecontrol.v1.HttpRequest",
    is(o) {
        return o && (o.$typeUrl === HttpRequest.typeUrl || typeof o.requestMethod === "string" && typeof o.requestUrl === "string" && typeof o.requestSize === "bigint" && typeof o.status === "number" && typeof o.responseSize === "bigint" && typeof o.userAgent === "string" && typeof o.remoteIp === "string" && typeof o.serverIp === "string" && typeof o.referer === "string" && typeof o.cacheLookup === "boolean" && typeof o.cacheHit === "boolean" && typeof o.cacheValidatedWithOriginServer === "boolean" && typeof o.cacheFillBytes === "bigint" && typeof o.protocol === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === HttpRequest.typeUrl || typeof o.request_method === "string" && typeof o.request_url === "string" && typeof o.request_size === "bigint" && typeof o.status === "number" && typeof o.response_size === "bigint" && typeof o.user_agent === "string" && typeof o.remote_ip === "string" && typeof o.server_ip === "string" && typeof o.referer === "string" && typeof o.cache_lookup === "boolean" && typeof o.cache_hit === "boolean" && typeof o.cache_validated_with_origin_server === "boolean" && typeof o.cache_fill_bytes === "bigint" && typeof o.protocol === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === HttpRequest.typeUrl || typeof o.request_method === "string" && typeof o.request_url === "string" && typeof o.request_size === "bigint" && typeof o.status === "number" && typeof o.response_size === "bigint" && typeof o.user_agent === "string" && typeof o.remote_ip === "string" && typeof o.server_ip === "string" && typeof o.referer === "string" && typeof o.cache_lookup === "boolean" && typeof o.cache_hit === "boolean" && typeof o.cache_validated_with_origin_server === "boolean" && typeof o.cache_fill_bytes === "bigint" && typeof o.protocol === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.requestMethod !== undefined) {
            writer.uint32(10).string(message.requestMethod);
        }
        if (message.requestUrl !== undefined) {
            writer.uint32(18).string(message.requestUrl);
        }
        if (message.requestSize !== undefined) {
            writer.uint32(24).int64(message.requestSize);
        }
        if (message.status !== undefined) {
            writer.uint32(32).int32(message.status);
        }
        if (message.responseSize !== undefined) {
            writer.uint32(40).int64(message.responseSize);
        }
        if (message.userAgent !== undefined) {
            writer.uint32(50).string(message.userAgent);
        }
        if (message.remoteIp !== undefined) {
            writer.uint32(58).string(message.remoteIp);
        }
        if (message.serverIp !== undefined) {
            writer.uint32(106).string(message.serverIp);
        }
        if (message.referer !== undefined) {
            writer.uint32(66).string(message.referer);
        }
        if (message.latency !== undefined) {
            Duration.encode(message.latency, writer.uint32(114).fork()).ldelim();
        }
        if (message.cacheLookup !== undefined) {
            writer.uint32(88).bool(message.cacheLookup);
        }
        if (message.cacheHit !== undefined) {
            writer.uint32(72).bool(message.cacheHit);
        }
        if (message.cacheValidatedWithOriginServer !== undefined) {
            writer.uint32(80).bool(message.cacheValidatedWithOriginServer);
        }
        if (message.cacheFillBytes !== undefined) {
            writer.uint32(96).int64(message.cacheFillBytes);
        }
        if (message.protocol !== undefined) {
            writer.uint32(122).string(message.protocol);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseHttpRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.requestMethod = reader.string();
                    break;
                case 2:
                    message.requestUrl = reader.string();
                    break;
                case 3:
                    message.requestSize = reader.int64();
                    break;
                case 4:
                    message.status = reader.int32();
                    break;
                case 5:
                    message.responseSize = reader.int64();
                    break;
                case 6:
                    message.userAgent = reader.string();
                    break;
                case 7:
                    message.remoteIp = reader.string();
                    break;
                case 13:
                    message.serverIp = reader.string();
                    break;
                case 8:
                    message.referer = reader.string();
                    break;
                case 14:
                    message.latency = Duration.decode(reader, reader.uint32());
                    break;
                case 11:
                    message.cacheLookup = reader.bool();
                    break;
                case 9:
                    message.cacheHit = reader.bool();
                    break;
                case 10:
                    message.cacheValidatedWithOriginServer = reader.bool();
                    break;
                case 12:
                    message.cacheFillBytes = reader.int64();
                    break;
                case 15:
                    message.protocol = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseHttpRequest();
        if (isSet(object.requestMethod))
            obj.requestMethod = String(object.requestMethod);
        if (isSet(object.requestUrl))
            obj.requestUrl = String(object.requestUrl);
        if (isSet(object.requestSize))
            obj.requestSize = BigInt(object.requestSize.toString());
        if (isSet(object.status))
            obj.status = Number(object.status);
        if (isSet(object.responseSize))
            obj.responseSize = BigInt(object.responseSize.toString());
        if (isSet(object.userAgent))
            obj.userAgent = String(object.userAgent);
        if (isSet(object.remoteIp))
            obj.remoteIp = String(object.remoteIp);
        if (isSet(object.serverIp))
            obj.serverIp = String(object.serverIp);
        if (isSet(object.referer))
            obj.referer = String(object.referer);
        if (isSet(object.latency))
            obj.latency = Duration.fromJSON(object.latency);
        if (isSet(object.cacheLookup))
            obj.cacheLookup = Boolean(object.cacheLookup);
        if (isSet(object.cacheHit))
            obj.cacheHit = Boolean(object.cacheHit);
        if (isSet(object.cacheValidatedWithOriginServer))
            obj.cacheValidatedWithOriginServer = Boolean(object.cacheValidatedWithOriginServer);
        if (isSet(object.cacheFillBytes))
            obj.cacheFillBytes = BigInt(object.cacheFillBytes.toString());
        if (isSet(object.protocol))
            obj.protocol = String(object.protocol);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.requestMethod !== undefined && (obj.requestMethod = message.requestMethod);
        message.requestUrl !== undefined && (obj.requestUrl = message.requestUrl);
        message.requestSize !== undefined && (obj.requestSize = (message.requestSize || BigInt(0)).toString());
        message.status !== undefined && (obj.status = Math.round(message.status));
        message.responseSize !== undefined && (obj.responseSize = (message.responseSize || BigInt(0)).toString());
        message.userAgent !== undefined && (obj.userAgent = message.userAgent);
        message.remoteIp !== undefined && (obj.remoteIp = message.remoteIp);
        message.serverIp !== undefined && (obj.serverIp = message.serverIp);
        message.referer !== undefined && (obj.referer = message.referer);
        message.latency !== undefined && (obj.latency = message.latency ? Duration.toJSON(message.latency) : undefined);
        message.cacheLookup !== undefined && (obj.cacheLookup = message.cacheLookup);
        message.cacheHit !== undefined && (obj.cacheHit = message.cacheHit);
        message.cacheValidatedWithOriginServer !== undefined && (obj.cacheValidatedWithOriginServer = message.cacheValidatedWithOriginServer);
        message.cacheFillBytes !== undefined && (obj.cacheFillBytes = (message.cacheFillBytes || BigInt(0)).toString());
        message.protocol !== undefined && (obj.protocol = message.protocol);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseHttpRequest();
        message.requestMethod = object.requestMethod ?? "";
        message.requestUrl = object.requestUrl ?? "";
        if (object.requestSize !== undefined && object.requestSize !== null) {
            message.requestSize = BigInt(object.requestSize.toString());
        }
        message.status = object.status ?? 0;
        if (object.responseSize !== undefined && object.responseSize !== null) {
            message.responseSize = BigInt(object.responseSize.toString());
        }
        message.userAgent = object.userAgent ?? "";
        message.remoteIp = object.remoteIp ?? "";
        message.serverIp = object.serverIp ?? "";
        message.referer = object.referer ?? "";
        if (object.latency !== undefined && object.latency !== null) {
            message.latency = Duration.fromPartial(object.latency);
        }
        message.cacheLookup = object.cacheLookup ?? false;
        message.cacheHit = object.cacheHit ?? false;
        message.cacheValidatedWithOriginServer = object.cacheValidatedWithOriginServer ?? false;
        if (object.cacheFillBytes !== undefined && object.cacheFillBytes !== null) {
            message.cacheFillBytes = BigInt(object.cacheFillBytes.toString());
        }
        message.protocol = object.protocol ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            requestMethod: object?.request_method,
            requestUrl: object?.request_url,
            requestSize: object?.request_size,
            status: object?.status,
            responseSize: object?.response_size,
            userAgent: object?.user_agent,
            remoteIp: object?.remote_ip,
            serverIp: object?.server_ip,
            referer: object?.referer,
            latency: object.latency ? Duration.fromSDK(object.latency) : undefined,
            cacheLookup: object?.cache_lookup,
            cacheHit: object?.cache_hit,
            cacheValidatedWithOriginServer: object?.cache_validated_with_origin_server,
            cacheFillBytes: object?.cache_fill_bytes,
            protocol: object?.protocol
        };
    },
    fromSDKJSON(object) {
        return {
            request_method: isSet(object.request_method) ? String(object.request_method) : "",
            request_url: isSet(object.request_url) ? String(object.request_url) : "",
            request_size: isSet(object.request_size) ? BigInt(object.request_size.toString()) : BigInt(0),
            status: isSet(object.status) ? Number(object.status) : 0,
            response_size: isSet(object.response_size) ? BigInt(object.response_size.toString()) : BigInt(0),
            user_agent: isSet(object.user_agent) ? String(object.user_agent) : "",
            remote_ip: isSet(object.remote_ip) ? String(object.remote_ip) : "",
            server_ip: isSet(object.server_ip) ? String(object.server_ip) : "",
            referer: isSet(object.referer) ? String(object.referer) : "",
            latency: isSet(object.latency) ? Duration.fromSDKJSON(object.latency) : undefined,
            cache_lookup: isSet(object.cache_lookup) ? Boolean(object.cache_lookup) : false,
            cache_hit: isSet(object.cache_hit) ? Boolean(object.cache_hit) : false,
            cache_validated_with_origin_server: isSet(object.cache_validated_with_origin_server) ? Boolean(object.cache_validated_with_origin_server) : false,
            cache_fill_bytes: isSet(object.cache_fill_bytes) ? BigInt(object.cache_fill_bytes.toString()) : BigInt(0),
            protocol: isSet(object.protocol) ? String(object.protocol) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.request_method = message.requestMethod;
        obj.request_url = message.requestUrl;
        obj.request_size = message.requestSize;
        obj.status = message.status;
        obj.response_size = message.responseSize;
        obj.user_agent = message.userAgent;
        obj.remote_ip = message.remoteIp;
        obj.server_ip = message.serverIp;
        obj.referer = message.referer;
        message.latency !== undefined && (obj.latency = message.latency ? Duration.toSDK(message.latency) : undefined);
        obj.cache_lookup = message.cacheLookup;
        obj.cache_hit = message.cacheHit;
        obj.cache_validated_with_origin_server = message.cacheValidatedWithOriginServer;
        obj.cache_fill_bytes = message.cacheFillBytes;
        obj.protocol = message.protocol;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseHttpRequest();
        if (object.request_method !== undefined && object.request_method !== null) {
            message.requestMethod = object.request_method;
        }
        if (object.request_url !== undefined && object.request_url !== null) {
            message.requestUrl = object.request_url;
        }
        if (object.request_size !== undefined && object.request_size !== null) {
            message.requestSize = BigInt(object.request_size);
        }
        if (object.status !== undefined && object.status !== null) {
            message.status = object.status;
        }
        if (object.response_size !== undefined && object.response_size !== null) {
            message.responseSize = BigInt(object.response_size);
        }
        if (object.user_agent !== undefined && object.user_agent !== null) {
            message.userAgent = object.user_agent;
        }
        if (object.remote_ip !== undefined && object.remote_ip !== null) {
            message.remoteIp = object.remote_ip;
        }
        if (object.server_ip !== undefined && object.server_ip !== null) {
            message.serverIp = object.server_ip;
        }
        if (object.referer !== undefined && object.referer !== null) {
            message.referer = object.referer;
        }
        if (object.latency !== undefined && object.latency !== null) {
            message.latency = Duration.fromAmino(object.latency);
        }
        if (object.cache_lookup !== undefined && object.cache_lookup !== null) {
            message.cacheLookup = object.cache_lookup;
        }
        if (object.cache_hit !== undefined && object.cache_hit !== null) {
            message.cacheHit = object.cache_hit;
        }
        if (object.cache_validated_with_origin_server !== undefined && object.cache_validated_with_origin_server !== null) {
            message.cacheValidatedWithOriginServer = object.cache_validated_with_origin_server;
        }
        if (object.cache_fill_bytes !== undefined && object.cache_fill_bytes !== null) {
            message.cacheFillBytes = BigInt(object.cache_fill_bytes);
        }
        if (object.protocol !== undefined && object.protocol !== null) {
            message.protocol = object.protocol;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.request_method = message.requestMethod === "" ? undefined : message.requestMethod;
        obj.request_url = message.requestUrl === "" ? undefined : message.requestUrl;
        obj.request_size = message.requestSize !== BigInt(0) ? message.requestSize?.toString() : undefined;
        obj.status = message.status === 0 ? undefined : message.status;
        obj.response_size = message.responseSize !== BigInt(0) ? message.responseSize?.toString() : undefined;
        obj.user_agent = message.userAgent === "" ? undefined : message.userAgent;
        obj.remote_ip = message.remoteIp === "" ? undefined : message.remoteIp;
        obj.server_ip = message.serverIp === "" ? undefined : message.serverIp;
        obj.referer = message.referer === "" ? undefined : message.referer;
        obj.latency = message.latency ? Duration.toAmino(message.latency) : undefined;
        obj.cache_lookup = message.cacheLookup === false ? undefined : message.cacheLookup;
        obj.cache_hit = message.cacheHit === false ? undefined : message.cacheHit;
        obj.cache_validated_with_origin_server = message.cacheValidatedWithOriginServer === false ? undefined : message.cacheValidatedWithOriginServer;
        obj.cache_fill_bytes = message.cacheFillBytes !== BigInt(0) ? message.cacheFillBytes?.toString() : undefined;
        obj.protocol = message.protocol === "" ? undefined : message.protocol;
        return obj;
    },
    fromAminoMsg(object) {
        return HttpRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return HttpRequest.decode(message.value);
    },
    toProto(message) {
        return HttpRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicecontrol.v1.HttpRequest",
            value: HttpRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
