import { Timestamp } from "../../../protobuf/timestamp";
import { Distribution } from "./distribution";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { isSet, toTimestamp, fromTimestamp, isObject } from "../../../../helpers";
export const protobufPackage = "google.api.servicecontrol.v1";
function createBaseMetricValue_LabelsEntry() {
    return {
        key: "",
        value: ""
    };
}
export const MetricValue_LabelsEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(18).string(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMetricValue_LabelsEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMetricValue_LabelsEntry();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = String(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = message.value);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMetricValue_LabelsEntry();
        message.key = object.key ?? "";
        message.value = object.value ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? String(object.value) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMetricValue_LabelsEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value === "" ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return MetricValue_LabelsEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MetricValue_LabelsEntry.decode(message.value);
    },
    toProto(message) {
        return MetricValue_LabelsEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseMetricValue() {
    return {
        labels: {},
        startTime: undefined,
        endTime: undefined,
        boolValue: undefined,
        int64Value: undefined,
        doubleValue: undefined,
        stringValue: undefined,
        distributionValue: undefined
    };
}
export const MetricValue = {
    typeUrl: "/google.api.servicecontrol.v1.MetricValue",
    is(o) {
        return o && (o.$typeUrl === MetricValue.typeUrl || isSet(o.labels));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MetricValue.typeUrl || isSet(o.labels));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MetricValue.typeUrl || isSet(o.labels));
    },
    encode(message, writer = BinaryWriter.create()) {
        Object.entries(message.labels).forEach(([key, value]) => {
            MetricValue_LabelsEntry.encode({
                key: key,
                value
            }, writer.uint32(10).fork()).ldelim();
        });
        if (message.startTime !== undefined) {
            Timestamp.encode(toTimestamp(message.startTime), writer.uint32(18).fork()).ldelim();
        }
        if (message.endTime !== undefined) {
            Timestamp.encode(toTimestamp(message.endTime), writer.uint32(26).fork()).ldelim();
        }
        if (message.boolValue !== undefined) {
            writer.uint32(32).bool(message.boolValue);
        }
        if (message.int64Value !== undefined) {
            writer.uint32(40).int64(message.int64Value);
        }
        if (message.doubleValue !== undefined) {
            writer.uint32(49).double(message.doubleValue);
        }
        if (message.stringValue !== undefined) {
            writer.uint32(58).string(message.stringValue);
        }
        if (message.distributionValue !== undefined) {
            Distribution.encode(message.distributionValue, writer.uint32(66).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMetricValue();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    const entry1 = MetricValue_LabelsEntry.decode(reader, reader.uint32());
                    if (entry1.value !== undefined) {
                        message.labels[entry1.key] = entry1.value;
                    }
                    break;
                case 2:
                    message.startTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.endTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 4:
                    message.boolValue = reader.bool();
                    break;
                case 5:
                    message.int64Value = reader.int64();
                    break;
                case 6:
                    message.doubleValue = reader.double();
                    break;
                case 7:
                    message.stringValue = reader.string();
                    break;
                case 8:
                    message.distributionValue = Distribution.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMetricValue();
        if (isObject(object.labels))
            obj.labels = Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {});
        if (isSet(object.startTime))
            obj.startTime = new Date(object.startTime);
        if (isSet(object.endTime))
            obj.endTime = new Date(object.endTime);
        if (isSet(object.boolValue))
            obj.boolValue = Boolean(object.boolValue);
        if (isSet(object.int64Value))
            obj.int64Value = BigInt(object.int64Value.toString());
        if (isSet(object.doubleValue))
            obj.doubleValue = Number(object.doubleValue);
        if (isSet(object.stringValue))
            obj.stringValue = String(object.stringValue);
        if (isSet(object.distributionValue))
            obj.distributionValue = Distribution.fromJSON(object.distributionValue);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        message.startTime !== undefined && (obj.startTime = message.startTime.toISOString());
        message.endTime !== undefined && (obj.endTime = message.endTime.toISOString());
        message.boolValue !== undefined && (obj.boolValue = message.boolValue);
        if (message.int64Value !== undefined) {
            obj.int64Value = message.int64Value.toString();
        }
        message.doubleValue !== undefined && (obj.doubleValue = message.doubleValue);
        message.stringValue !== undefined && (obj.stringValue = message.stringValue);
        message.distributionValue !== undefined && (obj.distributionValue = message.distributionValue ? Distribution.toJSON(message.distributionValue) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMetricValue();
        message.labels = Object.entries(object.labels ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        message.startTime = object.startTime ?? undefined;
        message.endTime = object.endTime ?? undefined;
        message.boolValue = object.boolValue ?? undefined;
        if (object.int64Value !== undefined && object.int64Value !== null) {
            message.int64Value = BigInt(object.int64Value.toString());
        }
        message.doubleValue = object.doubleValue ?? undefined;
        message.stringValue = object.stringValue ?? undefined;
        if (object.distributionValue !== undefined && object.distributionValue !== null) {
            message.distributionValue = Distribution.fromPartial(object.distributionValue);
        }
        return message;
    },
    fromSDK(object) {
        return {
            labels: isObject(object.labels) ? Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            startTime: object.start_time ?? undefined,
            endTime: object.end_time ?? undefined,
            boolValue: object?.bool_value,
            int64Value: object?.int64_value,
            doubleValue: object?.double_value,
            stringValue: object?.string_value,
            distributionValue: object.distribution_value ? Distribution.fromSDK(object.distribution_value) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            labels: isObject(object.labels) ? Object.entries(object.labels).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            start_time: isSet(object.start_time) ? new Date(object.start_time) : undefined,
            end_time: isSet(object.end_time) ? new Date(object.end_time) : undefined,
            bool_value: isSet(object.bool_value) ? Boolean(object.bool_value) : undefined,
            int64_value: isSet(object.int64_value) ? BigInt(object.int64_value.toString()) : undefined,
            double_value: isSet(object.double_value) ? Number(object.double_value) : undefined,
            string_value: isSet(object.string_value) ? String(object.string_value) : undefined,
            distribution_value: isSet(object.distribution_value) ? Distribution.fromSDKJSON(object.distribution_value) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        message.startTime !== undefined && (obj.start_time = message.startTime ?? undefined);
        message.endTime !== undefined && (obj.end_time = message.endTime ?? undefined);
        obj.bool_value = message.boolValue;
        obj.int64_value = message.int64Value;
        obj.double_value = message.doubleValue;
        obj.string_value = message.stringValue;
        message.distributionValue !== undefined && (obj.distribution_value = message.distributionValue ? Distribution.toSDK(message.distributionValue) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMetricValue();
        message.labels = Object.entries(object.labels ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        if (object.start_time !== undefined && object.start_time !== null) {
            message.startTime = fromTimestamp(Timestamp.fromAmino(object.start_time));
        }
        if (object.end_time !== undefined && object.end_time !== null) {
            message.endTime = fromTimestamp(Timestamp.fromAmino(object.end_time));
        }
        if (object.bool_value !== undefined && object.bool_value !== null) {
            message.boolValue = object.bool_value;
        }
        if (object.int64_value !== undefined && object.int64_value !== null) {
            message.int64Value = BigInt(object.int64_value);
        }
        if (object.double_value !== undefined && object.double_value !== null) {
            message.doubleValue = object.double_value;
        }
        if (object.string_value !== undefined && object.string_value !== null) {
            message.stringValue = object.string_value;
        }
        if (object.distribution_value !== undefined && object.distribution_value !== null) {
            message.distributionValue = Distribution.fromAmino(object.distribution_value);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.labels = {};
        if (message.labels) {
            Object.entries(message.labels).forEach(([k, v]) => {
                obj.labels[k] = v;
            });
        }
        obj.start_time = message.startTime ? Timestamp.toAmino(toTimestamp(message.startTime)) : undefined;
        obj.end_time = message.endTime ? Timestamp.toAmino(toTimestamp(message.endTime)) : undefined;
        obj.bool_value = message.boolValue === null ? undefined : message.boolValue;
        obj.int64_value = message.int64Value !== BigInt(0) ? message.int64Value?.toString() : undefined;
        obj.double_value = message.doubleValue === null ? undefined : message.doubleValue;
        obj.string_value = message.stringValue === null ? undefined : message.stringValue;
        obj.distribution_value = message.distributionValue ? Distribution.toAmino(message.distributionValue) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return MetricValue.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MetricValue.decode(message.value);
    },
    toProto(message) {
        return MetricValue.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicecontrol.v1.MetricValue",
            value: MetricValue.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Distribution.registerTypeUrl();
    }
};
function createBaseMetricValueSet() {
    return {
        metricName: "",
        metricValues: []
    };
}
export const MetricValueSet = {
    typeUrl: "/google.api.servicecontrol.v1.MetricValueSet",
    is(o) {
        return o && (o.$typeUrl === MetricValueSet.typeUrl || typeof o.metricName === "string" && Array.isArray(o.metricValues) && (!o.metricValues.length || MetricValue.is(o.metricValues[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === MetricValueSet.typeUrl || typeof o.metric_name === "string" && Array.isArray(o.metric_values) && (!o.metric_values.length || MetricValue.isSDK(o.metric_values[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === MetricValueSet.typeUrl || typeof o.metric_name === "string" && Array.isArray(o.metric_values) && (!o.metric_values.length || MetricValue.isAmino(o.metric_values[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.metricName !== undefined) {
            writer.uint32(10).string(message.metricName);
        }
        for (const v of message.metricValues) {
            MetricValue.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMetricValueSet();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.metricName = reader.string();
                    break;
                case 2:
                    message.metricValues.push(MetricValue.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMetricValueSet();
        if (isSet(object.metricName))
            obj.metricName = String(object.metricName);
        if (Array.isArray(object?.metricValues))
            obj.metricValues = object.metricValues.map((e) => MetricValue.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.metricName !== undefined && (obj.metricName = message.metricName);
        if (message.metricValues) {
            obj.metricValues = message.metricValues.map(e => e ? MetricValue.toJSON(e) : undefined);
        }
        else {
            obj.metricValues = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMetricValueSet();
        message.metricName = object.metricName ?? "";
        message.metricValues = object.metricValues?.map(e => MetricValue.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            metricName: object?.metric_name,
            metricValues: Array.isArray(object?.metric_values) ? object.metric_values.map((e) => MetricValue.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            metric_name: isSet(object.metric_name) ? String(object.metric_name) : "",
            metric_values: Array.isArray(object?.metric_values) ? object.metric_values.map((e) => MetricValue.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.metric_name = message.metricName;
        if (message.metricValues) {
            obj.metric_values = message.metricValues.map(e => e ? MetricValue.toSDK(e) : undefined);
        }
        else {
            obj.metric_values = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMetricValueSet();
        if (object.metric_name !== undefined && object.metric_name !== null) {
            message.metricName = object.metric_name;
        }
        message.metricValues = object.metric_values?.map(e => MetricValue.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.metric_name = message.metricName === "" ? undefined : message.metricName;
        if (message.metricValues) {
            obj.metric_values = message.metricValues.map(e => e ? MetricValue.toAmino(e) : undefined);
        }
        else {
            obj.metric_values = message.metricValues;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return MetricValueSet.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return MetricValueSet.decode(message.value);
    },
    toProto(message) {
        return MetricValueSet.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicecontrol.v1.MetricValueSet",
            value: MetricValueSet.encode(message).finish()
        };
    },
    registerTypeUrl() {
        MetricValue.registerTypeUrl();
    }
};
