import { AttributeContext } from "../../../rpc/context/attribute_context";
import { Status } from "../../../rpc/status";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { isSet, isObject } from "../../../../helpers";
export const protobufPackage = "google.api.servicecontrol.v2";
function createBaseCheckRequest() {
    return {
        serviceName: "",
        serviceConfigId: "",
        attributes: undefined,
        resources: [],
        flags: ""
    };
}
export const CheckRequest = {
    typeUrl: "/google.api.servicecontrol.v2.CheckRequest",
    is(o) {
        return o && (o.$typeUrl === CheckRequest.typeUrl || typeof o.serviceName === "string" && typeof o.serviceConfigId === "string" && Array.isArray(o.resources) && (!o.resources.length || ResourceInfo.is(o.resources[0])) && typeof o.flags === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === CheckRequest.typeUrl || typeof o.service_name === "string" && typeof o.service_config_id === "string" && Array.isArray(o.resources) && (!o.resources.length || ResourceInfo.isSDK(o.resources[0])) && typeof o.flags === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === CheckRequest.typeUrl || typeof o.service_name === "string" && typeof o.service_config_id === "string" && Array.isArray(o.resources) && (!o.resources.length || ResourceInfo.isAmino(o.resources[0])) && typeof o.flags === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.serviceName !== undefined) {
            writer.uint32(10).string(message.serviceName);
        }
        if (message.serviceConfigId !== undefined) {
            writer.uint32(18).string(message.serviceConfigId);
        }
        if (message.attributes !== undefined) {
            AttributeContext.encode(message.attributes, writer.uint32(26).fork()).ldelim();
        }
        for (const v of message.resources) {
            ResourceInfo.encode(v, writer.uint32(34).fork()).ldelim();
        }
        if (message.flags !== undefined) {
            writer.uint32(42).string(message.flags);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCheckRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.serviceName = reader.string();
                    break;
                case 2:
                    message.serviceConfigId = reader.string();
                    break;
                case 3:
                    message.attributes = AttributeContext.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.resources.push(ResourceInfo.decode(reader, reader.uint32()));
                    break;
                case 5:
                    message.flags = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCheckRequest();
        if (isSet(object.serviceName))
            obj.serviceName = String(object.serviceName);
        if (isSet(object.serviceConfigId))
            obj.serviceConfigId = String(object.serviceConfigId);
        if (isSet(object.attributes))
            obj.attributes = AttributeContext.fromJSON(object.attributes);
        if (Array.isArray(object?.resources))
            obj.resources = object.resources.map((e) => ResourceInfo.fromJSON(e));
        if (isSet(object.flags))
            obj.flags = String(object.flags);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.serviceName !== undefined && (obj.serviceName = message.serviceName);
        message.serviceConfigId !== undefined && (obj.serviceConfigId = message.serviceConfigId);
        message.attributes !== undefined && (obj.attributes = message.attributes ? AttributeContext.toJSON(message.attributes) : undefined);
        if (message.resources) {
            obj.resources = message.resources.map(e => e ? ResourceInfo.toJSON(e) : undefined);
        }
        else {
            obj.resources = [];
        }
        message.flags !== undefined && (obj.flags = message.flags);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCheckRequest();
        message.serviceName = object.serviceName ?? "";
        message.serviceConfigId = object.serviceConfigId ?? "";
        if (object.attributes !== undefined && object.attributes !== null) {
            message.attributes = AttributeContext.fromPartial(object.attributes);
        }
        message.resources = object.resources?.map(e => ResourceInfo.fromPartial(e)) || [];
        message.flags = object.flags ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            serviceName: object?.service_name,
            serviceConfigId: object?.service_config_id,
            attributes: object.attributes ? AttributeContext.fromSDK(object.attributes) : undefined,
            resources: Array.isArray(object?.resources) ? object.resources.map((e) => ResourceInfo.fromSDK(e)) : [],
            flags: object?.flags
        };
    },
    fromSDKJSON(object) {
        return {
            service_name: isSet(object.service_name) ? String(object.service_name) : "",
            service_config_id: isSet(object.service_config_id) ? String(object.service_config_id) : "",
            attributes: isSet(object.attributes) ? AttributeContext.fromSDKJSON(object.attributes) : undefined,
            resources: Array.isArray(object?.resources) ? object.resources.map((e) => ResourceInfo.fromSDKJSON(e)) : [],
            flags: isSet(object.flags) ? String(object.flags) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service_name = message.serviceName;
        obj.service_config_id = message.serviceConfigId;
        message.attributes !== undefined && (obj.attributes = message.attributes ? AttributeContext.toSDK(message.attributes) : undefined);
        if (message.resources) {
            obj.resources = message.resources.map(e => e ? ResourceInfo.toSDK(e) : undefined);
        }
        else {
            obj.resources = [];
        }
        obj.flags = message.flags;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCheckRequest();
        if (object.service_name !== undefined && object.service_name !== null) {
            message.serviceName = object.service_name;
        }
        if (object.service_config_id !== undefined && object.service_config_id !== null) {
            message.serviceConfigId = object.service_config_id;
        }
        if (object.attributes !== undefined && object.attributes !== null) {
            message.attributes = AttributeContext.fromAmino(object.attributes);
        }
        message.resources = object.resources?.map(e => ResourceInfo.fromAmino(e)) || [];
        if (object.flags !== undefined && object.flags !== null) {
            message.flags = object.flags;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service_name = message.serviceName === "" ? undefined : message.serviceName;
        obj.service_config_id = message.serviceConfigId === "" ? undefined : message.serviceConfigId;
        obj.attributes = message.attributes ? AttributeContext.toAmino(message.attributes) : undefined;
        if (message.resources) {
            obj.resources = message.resources.map(e => e ? ResourceInfo.toAmino(e) : undefined);
        }
        else {
            obj.resources = message.resources;
        }
        obj.flags = message.flags === "" ? undefined : message.flags;
        return obj;
    },
    fromAminoMsg(object) {
        return CheckRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CheckRequest.decode(message.value);
    },
    toProto(message) {
        return CheckRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicecontrol.v2.CheckRequest",
            value: CheckRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        AttributeContext.registerTypeUrl();
        ResourceInfo.registerTypeUrl();
    }
};
function createBaseResourceInfo() {
    return {
        name: "",
        type: "",
        permission: "",
        container: "",
        location: ""
    };
}
export const ResourceInfo = {
    typeUrl: "/google.api.servicecontrol.v2.ResourceInfo",
    is(o) {
        return o && (o.$typeUrl === ResourceInfo.typeUrl || typeof o.name === "string" && typeof o.type === "string" && typeof o.permission === "string" && typeof o.container === "string" && typeof o.location === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ResourceInfo.typeUrl || typeof o.name === "string" && typeof o.type === "string" && typeof o.permission === "string" && typeof o.container === "string" && typeof o.location === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ResourceInfo.typeUrl || typeof o.name === "string" && typeof o.type === "string" && typeof o.permission === "string" && typeof o.container === "string" && typeof o.location === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.type !== undefined) {
            writer.uint32(18).string(message.type);
        }
        if (message.permission !== undefined) {
            writer.uint32(26).string(message.permission);
        }
        if (message.container !== undefined) {
            writer.uint32(34).string(message.container);
        }
        if (message.location !== undefined) {
            writer.uint32(42).string(message.location);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseResourceInfo();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.type = reader.string();
                    break;
                case 3:
                    message.permission = reader.string();
                    break;
                case 4:
                    message.container = reader.string();
                    break;
                case 5:
                    message.location = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseResourceInfo();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.type))
            obj.type = String(object.type);
        if (isSet(object.permission))
            obj.permission = String(object.permission);
        if (isSet(object.container))
            obj.container = String(object.container);
        if (isSet(object.location))
            obj.location = String(object.location);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.type !== undefined && (obj.type = message.type);
        message.permission !== undefined && (obj.permission = message.permission);
        message.container !== undefined && (obj.container = message.container);
        message.location !== undefined && (obj.location = message.location);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseResourceInfo();
        message.name = object.name ?? "";
        message.type = object.type ?? "";
        message.permission = object.permission ?? "";
        message.container = object.container ?? "";
        message.location = object.location ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            type: object?.type,
            permission: object?.permission,
            container: object?.container,
            location: object?.location
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            type: isSet(object.type) ? String(object.type) : "",
            permission: isSet(object.permission) ? String(object.permission) : "",
            container: isSet(object.container) ? String(object.container) : "",
            location: isSet(object.location) ? String(object.location) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.type = message.type;
        obj.permission = message.permission;
        obj.container = message.container;
        obj.location = message.location;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseResourceInfo();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.type !== undefined && object.type !== null) {
            message.type = object.type;
        }
        if (object.permission !== undefined && object.permission !== null) {
            message.permission = object.permission;
        }
        if (object.container !== undefined && object.container !== null) {
            message.container = object.container;
        }
        if (object.location !== undefined && object.location !== null) {
            message.location = object.location;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.type = message.type === "" ? undefined : message.type;
        obj.permission = message.permission === "" ? undefined : message.permission;
        obj.container = message.container === "" ? undefined : message.container;
        obj.location = message.location === "" ? undefined : message.location;
        return obj;
    },
    fromAminoMsg(object) {
        return ResourceInfo.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ResourceInfo.decode(message.value);
    },
    toProto(message) {
        return ResourceInfo.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicecontrol.v2.ResourceInfo",
            value: ResourceInfo.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseCheckResponse_HeadersEntry() {
    return {
        key: "",
        value: ""
    };
}
export const CheckResponse_HeadersEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(18).string(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCheckResponse_HeadersEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCheckResponse_HeadersEntry();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = String(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = message.value);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCheckResponse_HeadersEntry();
        message.key = object.key ?? "";
        message.value = object.value ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? String(object.value) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCheckResponse_HeadersEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value === "" ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return CheckResponse_HeadersEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CheckResponse_HeadersEntry.decode(message.value);
    },
    toProto(message) {
        return CheckResponse_HeadersEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseCheckResponse() {
    return {
        status: undefined,
        headers: {}
    };
}
export const CheckResponse = {
    typeUrl: "/google.api.servicecontrol.v2.CheckResponse",
    is(o) {
        return o && (o.$typeUrl === CheckResponse.typeUrl || isSet(o.headers));
    },
    isSDK(o) {
        return o && (o.$typeUrl === CheckResponse.typeUrl || isSet(o.headers));
    },
    isAmino(o) {
        return o && (o.$typeUrl === CheckResponse.typeUrl || isSet(o.headers));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.status !== undefined) {
            Status.encode(message.status, writer.uint32(10).fork()).ldelim();
        }
        Object.entries(message.headers).forEach(([key, value]) => {
            CheckResponse_HeadersEntry.encode({
                key: key,
                value
            }, writer.uint32(18).fork()).ldelim();
        });
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCheckResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.status = Status.decode(reader, reader.uint32());
                    break;
                case 2:
                    const entry2 = CheckResponse_HeadersEntry.decode(reader, reader.uint32());
                    if (entry2.value !== undefined) {
                        message.headers[entry2.key] = entry2.value;
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCheckResponse();
        if (isSet(object.status))
            obj.status = Status.fromJSON(object.status);
        if (isObject(object.headers))
            obj.headers = Object.entries(object.headers).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {});
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.status !== undefined && (obj.status = message.status ? Status.toJSON(message.status) : undefined);
        obj.headers = {};
        if (message.headers) {
            Object.entries(message.headers).forEach(([k, v]) => {
                obj.headers[k] = v;
            });
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCheckResponse();
        if (object.status !== undefined && object.status !== null) {
            message.status = Status.fromPartial(object.status);
        }
        message.headers = Object.entries(object.headers ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        return message;
    },
    fromSDK(object) {
        return {
            status: object.status ? Status.fromSDK(object.status) : undefined,
            headers: isObject(object.headers) ? Object.entries(object.headers).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {}
        };
    },
    fromSDKJSON(object) {
        return {
            status: isSet(object.status) ? Status.fromSDKJSON(object.status) : undefined,
            headers: isObject(object.headers) ? Object.entries(object.headers).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {}
        };
    },
    toSDK(message) {
        const obj = {};
        message.status !== undefined && (obj.status = message.status ? Status.toSDK(message.status) : undefined);
        obj.headers = {};
        if (message.headers) {
            Object.entries(message.headers).forEach(([k, v]) => {
                obj.headers[k] = v;
            });
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCheckResponse();
        if (object.status !== undefined && object.status !== null) {
            message.status = Status.fromAmino(object.status);
        }
        message.headers = Object.entries(object.headers ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.status = message.status ? Status.toAmino(message.status) : undefined;
        obj.headers = {};
        if (message.headers) {
            Object.entries(message.headers).forEach(([k, v]) => {
                obj.headers[k] = v;
            });
        }
        return obj;
    },
    fromAminoMsg(object) {
        return CheckResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CheckResponse.decode(message.value);
    },
    toProto(message) {
        return CheckResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicecontrol.v2.CheckResponse",
            value: CheckResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Status.registerTypeUrl();
    }
};
function createBaseReportRequest() {
    return {
        serviceName: "",
        serviceConfigId: "",
        operations: []
    };
}
export const ReportRequest = {
    typeUrl: "/google.api.servicecontrol.v2.ReportRequest",
    is(o) {
        return o && (o.$typeUrl === ReportRequest.typeUrl || typeof o.serviceName === "string" && typeof o.serviceConfigId === "string" && Array.isArray(o.operations) && (!o.operations.length || AttributeContext.is(o.operations[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === ReportRequest.typeUrl || typeof o.service_name === "string" && typeof o.service_config_id === "string" && Array.isArray(o.operations) && (!o.operations.length || AttributeContext.isSDK(o.operations[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === ReportRequest.typeUrl || typeof o.service_name === "string" && typeof o.service_config_id === "string" && Array.isArray(o.operations) && (!o.operations.length || AttributeContext.isAmino(o.operations[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.serviceName !== undefined) {
            writer.uint32(10).string(message.serviceName);
        }
        if (message.serviceConfigId !== undefined) {
            writer.uint32(18).string(message.serviceConfigId);
        }
        for (const v of message.operations) {
            AttributeContext.encode(v, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseReportRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.serviceName = reader.string();
                    break;
                case 2:
                    message.serviceConfigId = reader.string();
                    break;
                case 3:
                    message.operations.push(AttributeContext.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseReportRequest();
        if (isSet(object.serviceName))
            obj.serviceName = String(object.serviceName);
        if (isSet(object.serviceConfigId))
            obj.serviceConfigId = String(object.serviceConfigId);
        if (Array.isArray(object?.operations))
            obj.operations = object.operations.map((e) => AttributeContext.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.serviceName !== undefined && (obj.serviceName = message.serviceName);
        message.serviceConfigId !== undefined && (obj.serviceConfigId = message.serviceConfigId);
        if (message.operations) {
            obj.operations = message.operations.map(e => e ? AttributeContext.toJSON(e) : undefined);
        }
        else {
            obj.operations = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseReportRequest();
        message.serviceName = object.serviceName ?? "";
        message.serviceConfigId = object.serviceConfigId ?? "";
        message.operations = object.operations?.map(e => AttributeContext.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            serviceName: object?.service_name,
            serviceConfigId: object?.service_config_id,
            operations: Array.isArray(object?.operations) ? object.operations.map((e) => AttributeContext.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            service_name: isSet(object.service_name) ? String(object.service_name) : "",
            service_config_id: isSet(object.service_config_id) ? String(object.service_config_id) : "",
            operations: Array.isArray(object?.operations) ? object.operations.map((e) => AttributeContext.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service_name = message.serviceName;
        obj.service_config_id = message.serviceConfigId;
        if (message.operations) {
            obj.operations = message.operations.map(e => e ? AttributeContext.toSDK(e) : undefined);
        }
        else {
            obj.operations = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseReportRequest();
        if (object.service_name !== undefined && object.service_name !== null) {
            message.serviceName = object.service_name;
        }
        if (object.service_config_id !== undefined && object.service_config_id !== null) {
            message.serviceConfigId = object.service_config_id;
        }
        message.operations = object.operations?.map(e => AttributeContext.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service_name = message.serviceName === "" ? undefined : message.serviceName;
        obj.service_config_id = message.serviceConfigId === "" ? undefined : message.serviceConfigId;
        if (message.operations) {
            obj.operations = message.operations.map(e => e ? AttributeContext.toAmino(e) : undefined);
        }
        else {
            obj.operations = message.operations;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return ReportRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ReportRequest.decode(message.value);
    },
    toProto(message) {
        return ReportRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicecontrol.v2.ReportRequest",
            value: ReportRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        AttributeContext.registerTypeUrl();
    }
};
function createBaseReportResponse() {
    return {};
}
export const ReportResponse = {
    typeUrl: "/google.api.servicecontrol.v2.ReportResponse",
    is(o) {
        return o && o.$typeUrl === ReportResponse.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === ReportResponse.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === ReportResponse.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseReportResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseReportResponse();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseReportResponse();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseReportResponse();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return ReportResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ReportResponse.decode(message.value);
    },
    toProto(message) {
        return ReportResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicecontrol.v2.ReportResponse",
            value: ReportResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
