//@ts-nocheck
import { Timestamp } from "../../../protobuf/timestamp";
import { ConfigChange } from "../../config_change";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { isSet, toTimestamp, fromTimestamp, bytesFromBase64, base64FromBytes, isObject } from "../../../../helpers";
export const protobufPackage = "google.api.servicemanagement.v1";
/** Code describes the status of the operation (or one of its steps). */
export var OperationMetadata_Status;
(function (OperationMetadata_Status) {
    /** STATUS_UNSPECIFIED - Unspecifed code. */
    OperationMetadata_Status[OperationMetadata_Status["STATUS_UNSPECIFIED"] = 0] = "STATUS_UNSPECIFIED";
    /** DONE - The operation or step has completed without errors. */
    OperationMetadata_Status[OperationMetadata_Status["DONE"] = 1] = "DONE";
    /** NOT_STARTED - The operation or step has not started yet. */
    OperationMetadata_Status[OperationMetadata_Status["NOT_STARTED"] = 2] = "NOT_STARTED";
    /** IN_PROGRESS - The operation or step is in progress. */
    OperationMetadata_Status[OperationMetadata_Status["IN_PROGRESS"] = 3] = "IN_PROGRESS";
    /**
     * FAILED - The operation or step has completed with errors. If the operation is
     * rollbackable, the rollback completed with errors too.
     */
    OperationMetadata_Status[OperationMetadata_Status["FAILED"] = 4] = "FAILED";
    /** CANCELLED - The operation or step has completed with cancellation. */
    OperationMetadata_Status[OperationMetadata_Status["CANCELLED"] = 5] = "CANCELLED";
    OperationMetadata_Status[OperationMetadata_Status["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(OperationMetadata_Status || (OperationMetadata_Status = {}));
export const OperationMetadata_StatusSDKType = OperationMetadata_Status;
export const OperationMetadata_StatusAmino = OperationMetadata_Status;
export function operationMetadata_StatusFromJSON(object) {
    switch (object) {
        case 0:
        case "STATUS_UNSPECIFIED":
            return OperationMetadata_Status.STATUS_UNSPECIFIED;
        case 1:
        case "DONE":
            return OperationMetadata_Status.DONE;
        case 2:
        case "NOT_STARTED":
            return OperationMetadata_Status.NOT_STARTED;
        case 3:
        case "IN_PROGRESS":
            return OperationMetadata_Status.IN_PROGRESS;
        case 4:
        case "FAILED":
            return OperationMetadata_Status.FAILED;
        case 5:
        case "CANCELLED":
            return OperationMetadata_Status.CANCELLED;
        case -1:
        case "UNRECOGNIZED":
        default:
            return OperationMetadata_Status.UNRECOGNIZED;
    }
}
export function operationMetadata_StatusToJSON(object) {
    switch (object) {
        case OperationMetadata_Status.STATUS_UNSPECIFIED:
            return "STATUS_UNSPECIFIED";
        case OperationMetadata_Status.DONE:
            return "DONE";
        case OperationMetadata_Status.NOT_STARTED:
            return "NOT_STARTED";
        case OperationMetadata_Status.IN_PROGRESS:
            return "IN_PROGRESS";
        case OperationMetadata_Status.FAILED:
            return "FAILED";
        case OperationMetadata_Status.CANCELLED:
            return "CANCELLED";
        case OperationMetadata_Status.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
/** The kind of diagnostic information possible. */
export var Diagnostic_Kind;
(function (Diagnostic_Kind) {
    /** WARNING - Warnings and errors */
    Diagnostic_Kind[Diagnostic_Kind["WARNING"] = 0] = "WARNING";
    /** ERROR - Only errors */
    Diagnostic_Kind[Diagnostic_Kind["ERROR"] = 1] = "ERROR";
    Diagnostic_Kind[Diagnostic_Kind["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(Diagnostic_Kind || (Diagnostic_Kind = {}));
export const Diagnostic_KindSDKType = Diagnostic_Kind;
export const Diagnostic_KindAmino = Diagnostic_Kind;
export function diagnostic_KindFromJSON(object) {
    switch (object) {
        case 0:
        case "WARNING":
            return Diagnostic_Kind.WARNING;
        case 1:
        case "ERROR":
            return Diagnostic_Kind.ERROR;
        case -1:
        case "UNRECOGNIZED":
        default:
            return Diagnostic_Kind.UNRECOGNIZED;
    }
}
export function diagnostic_KindToJSON(object) {
    switch (object) {
        case Diagnostic_Kind.WARNING:
            return "WARNING";
        case Diagnostic_Kind.ERROR:
            return "ERROR";
        case Diagnostic_Kind.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
export var ConfigFile_FileType;
(function (ConfigFile_FileType) {
    /** FILE_TYPE_UNSPECIFIED - Unknown file type. */
    ConfigFile_FileType[ConfigFile_FileType["FILE_TYPE_UNSPECIFIED"] = 0] = "FILE_TYPE_UNSPECIFIED";
    /** SERVICE_CONFIG_YAML - YAML-specification of service. */
    ConfigFile_FileType[ConfigFile_FileType["SERVICE_CONFIG_YAML"] = 1] = "SERVICE_CONFIG_YAML";
    /** OPEN_API_JSON - OpenAPI specification, serialized in JSON. */
    ConfigFile_FileType[ConfigFile_FileType["OPEN_API_JSON"] = 2] = "OPEN_API_JSON";
    /** OPEN_API_YAML - OpenAPI specification, serialized in YAML. */
    ConfigFile_FileType[ConfigFile_FileType["OPEN_API_YAML"] = 3] = "OPEN_API_YAML";
    /**
     * FILE_DESCRIPTOR_SET_PROTO - FileDescriptorSet, generated by protoc.
     *
     * To generate, use protoc with imports and source info included.
     * For an example test.proto file, the following command would put the value
     * in a new file named out.pb.
     *
     * $protoc --include_imports --include_source_info test.proto -o out.pb
     */
    ConfigFile_FileType[ConfigFile_FileType["FILE_DESCRIPTOR_SET_PROTO"] = 4] = "FILE_DESCRIPTOR_SET_PROTO";
    /**
     * PROTO_FILE - Uncompiled Proto file. Used for storage and display purposes only,
     * currently server-side compilation is not supported. Should match the
     * inputs to 'protoc' command used to generated FILE_DESCRIPTOR_SET_PROTO. A
     * file of this type can only be included if at least one file of type
     * FILE_DESCRIPTOR_SET_PROTO is included.
     */
    ConfigFile_FileType[ConfigFile_FileType["PROTO_FILE"] = 6] = "PROTO_FILE";
    ConfigFile_FileType[ConfigFile_FileType["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(ConfigFile_FileType || (ConfigFile_FileType = {}));
export const ConfigFile_FileTypeSDKType = ConfigFile_FileType;
export const ConfigFile_FileTypeAmino = ConfigFile_FileType;
export function configFile_FileTypeFromJSON(object) {
    switch (object) {
        case 0:
        case "FILE_TYPE_UNSPECIFIED":
            return ConfigFile_FileType.FILE_TYPE_UNSPECIFIED;
        case 1:
        case "SERVICE_CONFIG_YAML":
            return ConfigFile_FileType.SERVICE_CONFIG_YAML;
        case 2:
        case "OPEN_API_JSON":
            return ConfigFile_FileType.OPEN_API_JSON;
        case 3:
        case "OPEN_API_YAML":
            return ConfigFile_FileType.OPEN_API_YAML;
        case 4:
        case "FILE_DESCRIPTOR_SET_PROTO":
            return ConfigFile_FileType.FILE_DESCRIPTOR_SET_PROTO;
        case 6:
        case "PROTO_FILE":
            return ConfigFile_FileType.PROTO_FILE;
        case -1:
        case "UNRECOGNIZED":
        default:
            return ConfigFile_FileType.UNRECOGNIZED;
    }
}
export function configFile_FileTypeToJSON(object) {
    switch (object) {
        case ConfigFile_FileType.FILE_TYPE_UNSPECIFIED:
            return "FILE_TYPE_UNSPECIFIED";
        case ConfigFile_FileType.SERVICE_CONFIG_YAML:
            return "SERVICE_CONFIG_YAML";
        case ConfigFile_FileType.OPEN_API_JSON:
            return "OPEN_API_JSON";
        case ConfigFile_FileType.OPEN_API_YAML:
            return "OPEN_API_YAML";
        case ConfigFile_FileType.FILE_DESCRIPTOR_SET_PROTO:
            return "FILE_DESCRIPTOR_SET_PROTO";
        case ConfigFile_FileType.PROTO_FILE:
            return "PROTO_FILE";
        case ConfigFile_FileType.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
/** Status of a Rollout. */
export var Rollout_RolloutStatus;
(function (Rollout_RolloutStatus) {
    /** ROLLOUT_STATUS_UNSPECIFIED - No status specified. */
    Rollout_RolloutStatus[Rollout_RolloutStatus["ROLLOUT_STATUS_UNSPECIFIED"] = 0] = "ROLLOUT_STATUS_UNSPECIFIED";
    /** IN_PROGRESS - The Rollout is in progress. */
    Rollout_RolloutStatus[Rollout_RolloutStatus["IN_PROGRESS"] = 1] = "IN_PROGRESS";
    /** SUCCESS - The Rollout has completed successfully. */
    Rollout_RolloutStatus[Rollout_RolloutStatus["SUCCESS"] = 2] = "SUCCESS";
    /**
     * CANCELLED - The Rollout has been cancelled. This can happen if you have overlapping
     * Rollout pushes, and the previous ones will be cancelled.
     */
    Rollout_RolloutStatus[Rollout_RolloutStatus["CANCELLED"] = 3] = "CANCELLED";
    /** FAILED - The Rollout has failed and the rollback attempt has failed too. */
    Rollout_RolloutStatus[Rollout_RolloutStatus["FAILED"] = 4] = "FAILED";
    /** PENDING - The Rollout has not started yet and is pending for execution. */
    Rollout_RolloutStatus[Rollout_RolloutStatus["PENDING"] = 5] = "PENDING";
    /**
     * FAILED_ROLLED_BACK - The Rollout has failed and rolled back to the previous successful
     * Rollout.
     */
    Rollout_RolloutStatus[Rollout_RolloutStatus["FAILED_ROLLED_BACK"] = 6] = "FAILED_ROLLED_BACK";
    Rollout_RolloutStatus[Rollout_RolloutStatus["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(Rollout_RolloutStatus || (Rollout_RolloutStatus = {}));
export const Rollout_RolloutStatusSDKType = Rollout_RolloutStatus;
export const Rollout_RolloutStatusAmino = Rollout_RolloutStatus;
export function rollout_RolloutStatusFromJSON(object) {
    switch (object) {
        case 0:
        case "ROLLOUT_STATUS_UNSPECIFIED":
            return Rollout_RolloutStatus.ROLLOUT_STATUS_UNSPECIFIED;
        case 1:
        case "IN_PROGRESS":
            return Rollout_RolloutStatus.IN_PROGRESS;
        case 2:
        case "SUCCESS":
            return Rollout_RolloutStatus.SUCCESS;
        case 3:
        case "CANCELLED":
            return Rollout_RolloutStatus.CANCELLED;
        case 4:
        case "FAILED":
            return Rollout_RolloutStatus.FAILED;
        case 5:
        case "PENDING":
            return Rollout_RolloutStatus.PENDING;
        case 6:
        case "FAILED_ROLLED_BACK":
            return Rollout_RolloutStatus.FAILED_ROLLED_BACK;
        case -1:
        case "UNRECOGNIZED":
        default:
            return Rollout_RolloutStatus.UNRECOGNIZED;
    }
}
export function rollout_RolloutStatusToJSON(object) {
    switch (object) {
        case Rollout_RolloutStatus.ROLLOUT_STATUS_UNSPECIFIED:
            return "ROLLOUT_STATUS_UNSPECIFIED";
        case Rollout_RolloutStatus.IN_PROGRESS:
            return "IN_PROGRESS";
        case Rollout_RolloutStatus.SUCCESS:
            return "SUCCESS";
        case Rollout_RolloutStatus.CANCELLED:
            return "CANCELLED";
        case Rollout_RolloutStatus.FAILED:
            return "FAILED";
        case Rollout_RolloutStatus.PENDING:
            return "PENDING";
        case Rollout_RolloutStatus.FAILED_ROLLED_BACK:
            return "FAILED_ROLLED_BACK";
        case Rollout_RolloutStatus.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
function createBaseManagedService() {
    return {
        serviceName: "",
        producerProjectId: ""
    };
}
export const ManagedService = {
    typeUrl: "/google.api.servicemanagement.v1.ManagedService",
    is(o) {
        return o && (o.$typeUrl === ManagedService.typeUrl || typeof o.serviceName === "string" && typeof o.producerProjectId === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ManagedService.typeUrl || typeof o.service_name === "string" && typeof o.producer_project_id === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ManagedService.typeUrl || typeof o.service_name === "string" && typeof o.producer_project_id === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.serviceName !== undefined) {
            writer.uint32(18).string(message.serviceName);
        }
        if (message.producerProjectId !== undefined) {
            writer.uint32(26).string(message.producerProjectId);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseManagedService();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 2:
                    message.serviceName = reader.string();
                    break;
                case 3:
                    message.producerProjectId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseManagedService();
        if (isSet(object.serviceName))
            obj.serviceName = String(object.serviceName);
        if (isSet(object.producerProjectId))
            obj.producerProjectId = String(object.producerProjectId);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.serviceName !== undefined && (obj.serviceName = message.serviceName);
        message.producerProjectId !== undefined && (obj.producerProjectId = message.producerProjectId);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseManagedService();
        message.serviceName = object.serviceName ?? "";
        message.producerProjectId = object.producerProjectId ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            serviceName: object?.service_name,
            producerProjectId: object?.producer_project_id
        };
    },
    fromSDKJSON(object) {
        return {
            service_name: isSet(object.service_name) ? String(object.service_name) : "",
            producer_project_id: isSet(object.producer_project_id) ? String(object.producer_project_id) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.service_name = message.serviceName;
        obj.producer_project_id = message.producerProjectId;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseManagedService();
        if (object.service_name !== undefined && object.service_name !== null) {
            message.serviceName = object.service_name;
        }
        if (object.producer_project_id !== undefined && object.producer_project_id !== null) {
            message.producerProjectId = object.producer_project_id;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.service_name = message.serviceName === "" ? undefined : message.serviceName;
        obj.producer_project_id = message.producerProjectId === "" ? undefined : message.producerProjectId;
        return obj;
    },
    fromAminoMsg(object) {
        return ManagedService.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ManagedService.decode(message.value);
    },
    toProto(message) {
        return ManagedService.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.ManagedService",
            value: ManagedService.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseOperationMetadata() {
    return {
        resourceNames: [],
        steps: [],
        progressPercentage: 0,
        startTime: undefined
    };
}
export const OperationMetadata = {
    typeUrl: "/google.api.servicemanagement.v1.OperationMetadata",
    is(o) {
        return o && (o.$typeUrl === OperationMetadata.typeUrl || Array.isArray(o.resourceNames) && (!o.resourceNames.length || typeof o.resourceNames[0] === "string") && Array.isArray(o.steps) && (!o.steps.length || OperationMetadata_Step.is(o.steps[0])) && typeof o.progressPercentage === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === OperationMetadata.typeUrl || Array.isArray(o.resource_names) && (!o.resource_names.length || typeof o.resource_names[0] === "string") && Array.isArray(o.steps) && (!o.steps.length || OperationMetadata_Step.isSDK(o.steps[0])) && typeof o.progress_percentage === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === OperationMetadata.typeUrl || Array.isArray(o.resource_names) && (!o.resource_names.length || typeof o.resource_names[0] === "string") && Array.isArray(o.steps) && (!o.steps.length || OperationMetadata_Step.isAmino(o.steps[0])) && typeof o.progress_percentage === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.resourceNames) {
            writer.uint32(10).string(v);
        }
        for (const v of message.steps) {
            OperationMetadata_Step.encode(v, writer.uint32(18).fork()).ldelim();
        }
        if (message.progressPercentage !== undefined) {
            writer.uint32(24).int32(message.progressPercentage);
        }
        if (message.startTime !== undefined) {
            Timestamp.encode(toTimestamp(message.startTime), writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseOperationMetadata();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.resourceNames.push(reader.string());
                    break;
                case 2:
                    message.steps.push(OperationMetadata_Step.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.progressPercentage = reader.int32();
                    break;
                case 4:
                    message.startTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseOperationMetadata();
        if (Array.isArray(object?.resourceNames))
            obj.resourceNames = object.resourceNames.map((e) => String(e));
        if (Array.isArray(object?.steps))
            obj.steps = object.steps.map((e) => OperationMetadata_Step.fromJSON(e));
        if (isSet(object.progressPercentage))
            obj.progressPercentage = Number(object.progressPercentage);
        if (isSet(object.startTime))
            obj.startTime = new Date(object.startTime);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.resourceNames) {
            obj.resourceNames = message.resourceNames.map(e => e);
        }
        else {
            obj.resourceNames = [];
        }
        if (message.steps) {
            obj.steps = message.steps.map(e => e ? OperationMetadata_Step.toJSON(e) : undefined);
        }
        else {
            obj.steps = [];
        }
        message.progressPercentage !== undefined && (obj.progressPercentage = Math.round(message.progressPercentage));
        message.startTime !== undefined && (obj.startTime = message.startTime.toISOString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseOperationMetadata();
        message.resourceNames = object.resourceNames?.map(e => e) || [];
        message.steps = object.steps?.map(e => OperationMetadata_Step.fromPartial(e)) || [];
        message.progressPercentage = object.progressPercentage ?? 0;
        message.startTime = object.startTime ?? undefined;
        return message;
    },
    fromSDK(object) {
        return {
            resourceNames: Array.isArray(object?.resource_names) ? object.resource_names.map((e) => e) : [],
            steps: Array.isArray(object?.steps) ? object.steps.map((e) => OperationMetadata_Step.fromSDK(e)) : [],
            progressPercentage: object?.progress_percentage,
            startTime: object.start_time ?? undefined
        };
    },
    fromSDKJSON(object) {
        return {
            resource_names: Array.isArray(object?.resource_names) ? object.resource_names.map((e) => String(e)) : [],
            steps: Array.isArray(object?.steps) ? object.steps.map((e) => OperationMetadata_Step.fromSDKJSON(e)) : [],
            progress_percentage: isSet(object.progress_percentage) ? Number(object.progress_percentage) : 0,
            start_time: isSet(object.start_time) ? new Date(object.start_time) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.resourceNames) {
            obj.resource_names = message.resourceNames.map(e => e);
        }
        else {
            obj.resource_names = [];
        }
        if (message.steps) {
            obj.steps = message.steps.map(e => e ? OperationMetadata_Step.toSDK(e) : undefined);
        }
        else {
            obj.steps = [];
        }
        obj.progress_percentage = message.progressPercentage;
        message.startTime !== undefined && (obj.start_time = message.startTime ?? undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseOperationMetadata();
        message.resourceNames = object.resource_names?.map(e => e) || [];
        message.steps = object.steps?.map(e => OperationMetadata_Step.fromAmino(e)) || [];
        if (object.progress_percentage !== undefined && object.progress_percentage !== null) {
            message.progressPercentage = object.progress_percentage;
        }
        if (object.start_time !== undefined && object.start_time !== null) {
            message.startTime = fromTimestamp(Timestamp.fromAmino(object.start_time));
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.resourceNames) {
            obj.resource_names = message.resourceNames.map(e => e);
        }
        else {
            obj.resource_names = message.resourceNames;
        }
        if (message.steps) {
            obj.steps = message.steps.map(e => e ? OperationMetadata_Step.toAmino(e) : undefined);
        }
        else {
            obj.steps = message.steps;
        }
        obj.progress_percentage = message.progressPercentage === 0 ? undefined : message.progressPercentage;
        obj.start_time = message.startTime ? Timestamp.toAmino(toTimestamp(message.startTime)) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return OperationMetadata.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return OperationMetadata.decode(message.value);
    },
    toProto(message) {
        return OperationMetadata.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.OperationMetadata",
            value: OperationMetadata.encode(message).finish()
        };
    },
    registerTypeUrl() {
        OperationMetadata_Step.registerTypeUrl();
    }
};
function createBaseOperationMetadata_Step() {
    return {
        description: "",
        status: 0
    };
}
export const OperationMetadata_Step = {
    typeUrl: "/google.api.servicemanagement.v1.Step",
    is(o) {
        return o && (o.$typeUrl === OperationMetadata_Step.typeUrl || typeof o.description === "string" && isSet(o.status));
    },
    isSDK(o) {
        return o && (o.$typeUrl === OperationMetadata_Step.typeUrl || typeof o.description === "string" && isSet(o.status));
    },
    isAmino(o) {
        return o && (o.$typeUrl === OperationMetadata_Step.typeUrl || typeof o.description === "string" && isSet(o.status));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.description !== undefined) {
            writer.uint32(18).string(message.description);
        }
        if (message.status !== 0) {
            writer.uint32(32).int32(message.status);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseOperationMetadata_Step();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 2:
                    message.description = reader.string();
                    break;
                case 4:
                    message.status = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseOperationMetadata_Step();
        if (isSet(object.description))
            obj.description = String(object.description);
        if (isSet(object.status))
            obj.status = operationMetadata_StatusFromJSON(object.status);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.description !== undefined && (obj.description = message.description);
        message.status !== undefined && (obj.status = operationMetadata_StatusToJSON(message.status));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseOperationMetadata_Step();
        message.description = object.description ?? "";
        message.status = object.status ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            description: object?.description,
            status: isSet(object.status) ? operationMetadata_StatusFromJSON(object.status) : -1
        };
    },
    fromSDKJSON(object) {
        return {
            description: isSet(object.description) ? String(object.description) : "",
            status: isSet(object.status) ? operationMetadata_StatusFromJSON(object.status) : -1
        };
    },
    toSDK(message) {
        const obj = {};
        obj.description = message.description;
        message.status !== undefined && (obj.status = operationMetadata_StatusToJSON(message.status));
        return obj;
    },
    fromAmino(object) {
        const message = createBaseOperationMetadata_Step();
        if (object.description !== undefined && object.description !== null) {
            message.description = object.description;
        }
        if (object.status !== undefined && object.status !== null) {
            message.status = object.status;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.description = message.description === "" ? undefined : message.description;
        obj.status = message.status === 0 ? undefined : message.status;
        return obj;
    },
    fromAminoMsg(object) {
        return OperationMetadata_Step.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return OperationMetadata_Step.decode(message.value);
    },
    toProto(message) {
        return OperationMetadata_Step.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.Step",
            value: OperationMetadata_Step.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseDiagnostic() {
    return {
        location: "",
        kind: 0,
        message: ""
    };
}
export const Diagnostic = {
    typeUrl: "/google.api.servicemanagement.v1.Diagnostic",
    is(o) {
        return o && (o.$typeUrl === Diagnostic.typeUrl || typeof o.location === "string" && isSet(o.kind) && typeof o.message === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Diagnostic.typeUrl || typeof o.location === "string" && isSet(o.kind) && typeof o.message === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Diagnostic.typeUrl || typeof o.location === "string" && isSet(o.kind) && typeof o.message === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.location !== undefined) {
            writer.uint32(10).string(message.location);
        }
        if (message.kind !== 0) {
            writer.uint32(16).int32(message.kind);
        }
        if (message.message !== undefined) {
            writer.uint32(26).string(message.message);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDiagnostic();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.location = reader.string();
                    break;
                case 2:
                    message.kind = reader.int32();
                    break;
                case 3:
                    message.message = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDiagnostic();
        if (isSet(object.location))
            obj.location = String(object.location);
        if (isSet(object.kind))
            obj.kind = diagnostic_KindFromJSON(object.kind);
        if (isSet(object.message))
            obj.message = String(object.message);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.location !== undefined && (obj.location = message.location);
        message.kind !== undefined && (obj.kind = diagnostic_KindToJSON(message.kind));
        message.message !== undefined && (obj.message = message.message);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDiagnostic();
        message.location = object.location ?? "";
        message.kind = object.kind ?? 0;
        message.message = object.message ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            location: object?.location,
            kind: isSet(object.kind) ? diagnostic_KindFromJSON(object.kind) : -1,
            message: object?.message
        };
    },
    fromSDKJSON(object) {
        return {
            location: isSet(object.location) ? String(object.location) : "",
            kind: isSet(object.kind) ? diagnostic_KindFromJSON(object.kind) : -1,
            message: isSet(object.message) ? String(object.message) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.location = message.location;
        message.kind !== undefined && (obj.kind = diagnostic_KindToJSON(message.kind));
        obj.message = message.message;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDiagnostic();
        if (object.location !== undefined && object.location !== null) {
            message.location = object.location;
        }
        if (object.kind !== undefined && object.kind !== null) {
            message.kind = object.kind;
        }
        if (object.message !== undefined && object.message !== null) {
            message.message = object.message;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.location = message.location === "" ? undefined : message.location;
        obj.kind = message.kind === 0 ? undefined : message.kind;
        obj.message = message.message === "" ? undefined : message.message;
        return obj;
    },
    fromAminoMsg(object) {
        return Diagnostic.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Diagnostic.decode(message.value);
    },
    toProto(message) {
        return Diagnostic.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.Diagnostic",
            value: Diagnostic.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseConfigSource() {
    return {
        id: "",
        files: []
    };
}
export const ConfigSource = {
    typeUrl: "/google.api.servicemanagement.v1.ConfigSource",
    is(o) {
        return o && (o.$typeUrl === ConfigSource.typeUrl || typeof o.id === "string" && Array.isArray(o.files) && (!o.files.length || ConfigFile.is(o.files[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === ConfigSource.typeUrl || typeof o.id === "string" && Array.isArray(o.files) && (!o.files.length || ConfigFile.isSDK(o.files[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === ConfigSource.typeUrl || typeof o.id === "string" && Array.isArray(o.files) && (!o.files.length || ConfigFile.isAmino(o.files[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.id !== undefined) {
            writer.uint32(42).string(message.id);
        }
        for (const v of message.files) {
            ConfigFile.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseConfigSource();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 5:
                    message.id = reader.string();
                    break;
                case 2:
                    message.files.push(ConfigFile.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseConfigSource();
        if (isSet(object.id))
            obj.id = String(object.id);
        if (Array.isArray(object?.files))
            obj.files = object.files.map((e) => ConfigFile.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.id !== undefined && (obj.id = message.id);
        if (message.files) {
            obj.files = message.files.map(e => e ? ConfigFile.toJSON(e) : undefined);
        }
        else {
            obj.files = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseConfigSource();
        message.id = object.id ?? "";
        message.files = object.files?.map(e => ConfigFile.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            id: object?.id,
            files: Array.isArray(object?.files) ? object.files.map((e) => ConfigFile.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            id: isSet(object.id) ? String(object.id) : "",
            files: Array.isArray(object?.files) ? object.files.map((e) => ConfigFile.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.id = message.id;
        if (message.files) {
            obj.files = message.files.map(e => e ? ConfigFile.toSDK(e) : undefined);
        }
        else {
            obj.files = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseConfigSource();
        if (object.id !== undefined && object.id !== null) {
            message.id = object.id;
        }
        message.files = object.files?.map(e => ConfigFile.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.id = message.id === "" ? undefined : message.id;
        if (message.files) {
            obj.files = message.files.map(e => e ? ConfigFile.toAmino(e) : undefined);
        }
        else {
            obj.files = message.files;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return ConfigSource.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ConfigSource.decode(message.value);
    },
    toProto(message) {
        return ConfigSource.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.ConfigSource",
            value: ConfigSource.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ConfigFile.registerTypeUrl();
    }
};
function createBaseConfigFile() {
    return {
        filePath: "",
        fileContents: new Uint8Array(),
        fileType: 0
    };
}
export const ConfigFile = {
    typeUrl: "/google.api.servicemanagement.v1.ConfigFile",
    is(o) {
        return o && (o.$typeUrl === ConfigFile.typeUrl || typeof o.filePath === "string" && (o.fileContents instanceof Uint8Array || typeof o.fileContents === "string") && isSet(o.fileType));
    },
    isSDK(o) {
        return o && (o.$typeUrl === ConfigFile.typeUrl || typeof o.file_path === "string" && (o.file_contents instanceof Uint8Array || typeof o.file_contents === "string") && isSet(o.file_type));
    },
    isAmino(o) {
        return o && (o.$typeUrl === ConfigFile.typeUrl || typeof o.file_path === "string" && (o.file_contents instanceof Uint8Array || typeof o.file_contents === "string") && isSet(o.file_type));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.filePath !== undefined) {
            writer.uint32(10).string(message.filePath);
        }
        if (message.fileContents.length !== 0) {
            writer.uint32(26).bytes(message.fileContents);
        }
        if (message.fileType !== 0) {
            writer.uint32(32).int32(message.fileType);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseConfigFile();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.filePath = reader.string();
                    break;
                case 3:
                    message.fileContents = reader.bytes();
                    break;
                case 4:
                    message.fileType = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseConfigFile();
        if (isSet(object.filePath))
            obj.filePath = String(object.filePath);
        if (isSet(object.fileContents))
            obj.fileContents = bytesFromBase64(object.fileContents);
        if (isSet(object.fileType))
            obj.fileType = configFile_FileTypeFromJSON(object.fileType);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.filePath !== undefined && (obj.filePath = message.filePath);
        message.fileContents !== undefined && (obj.fileContents = base64FromBytes(message.fileContents !== undefined ? message.fileContents : new Uint8Array()));
        message.fileType !== undefined && (obj.fileType = configFile_FileTypeToJSON(message.fileType));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseConfigFile();
        message.filePath = object.filePath ?? "";
        message.fileContents = object.fileContents ?? new Uint8Array();
        message.fileType = object.fileType ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            filePath: object?.file_path,
            fileContents: object?.file_contents,
            fileType: isSet(object.file_type) ? configFile_FileTypeFromJSON(object.file_type) : -1
        };
    },
    fromSDKJSON(object) {
        return {
            file_path: isSet(object.file_path) ? String(object.file_path) : "",
            file_contents: isSet(object.file_contents) ? bytesFromBase64(object.file_contents) : new Uint8Array(),
            file_type: isSet(object.file_type) ? configFile_FileTypeFromJSON(object.file_type) : -1
        };
    },
    toSDK(message) {
        const obj = {};
        obj.file_path = message.filePath;
        obj.file_contents = message.fileContents;
        message.fileType !== undefined && (obj.file_type = configFile_FileTypeToJSON(message.fileType));
        return obj;
    },
    fromAmino(object) {
        const message = createBaseConfigFile();
        if (object.file_path !== undefined && object.file_path !== null) {
            message.filePath = object.file_path;
        }
        if (object.file_contents !== undefined && object.file_contents !== null) {
            message.fileContents = bytesFromBase64(object.file_contents);
        }
        if (object.file_type !== undefined && object.file_type !== null) {
            message.fileType = object.file_type;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.file_path = message.filePath === "" ? undefined : message.filePath;
        obj.file_contents = message.fileContents ? base64FromBytes(message.fileContents) : undefined;
        obj.file_type = message.fileType === 0 ? undefined : message.fileType;
        return obj;
    },
    fromAminoMsg(object) {
        return ConfigFile.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ConfigFile.decode(message.value);
    },
    toProto(message) {
        return ConfigFile.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.ConfigFile",
            value: ConfigFile.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseConfigRef() {
    return {
        name: ""
    };
}
export const ConfigRef = {
    typeUrl: "/google.api.servicemanagement.v1.ConfigRef",
    is(o) {
        return o && (o.$typeUrl === ConfigRef.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ConfigRef.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ConfigRef.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseConfigRef();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseConfigRef();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseConfigRef();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseConfigRef();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return ConfigRef.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ConfigRef.decode(message.value);
    },
    toProto(message) {
        return ConfigRef.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.ConfigRef",
            value: ConfigRef.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseChangeReport() {
    return {
        configChanges: []
    };
}
export const ChangeReport = {
    typeUrl: "/google.api.servicemanagement.v1.ChangeReport",
    is(o) {
        return o && (o.$typeUrl === ChangeReport.typeUrl || Array.isArray(o.configChanges) && (!o.configChanges.length || ConfigChange.is(o.configChanges[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === ChangeReport.typeUrl || Array.isArray(o.config_changes) && (!o.config_changes.length || ConfigChange.isSDK(o.config_changes[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === ChangeReport.typeUrl || Array.isArray(o.config_changes) && (!o.config_changes.length || ConfigChange.isAmino(o.config_changes[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.configChanges) {
            ConfigChange.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseChangeReport();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.configChanges.push(ConfigChange.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseChangeReport();
        if (Array.isArray(object?.configChanges))
            obj.configChanges = object.configChanges.map((e) => ConfigChange.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.configChanges) {
            obj.configChanges = message.configChanges.map(e => e ? ConfigChange.toJSON(e) : undefined);
        }
        else {
            obj.configChanges = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseChangeReport();
        message.configChanges = object.configChanges?.map(e => ConfigChange.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            configChanges: Array.isArray(object?.config_changes) ? object.config_changes.map((e) => ConfigChange.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            config_changes: Array.isArray(object?.config_changes) ? object.config_changes.map((e) => ConfigChange.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.configChanges) {
            obj.config_changes = message.configChanges.map(e => e ? ConfigChange.toSDK(e) : undefined);
        }
        else {
            obj.config_changes = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseChangeReport();
        message.configChanges = object.config_changes?.map(e => ConfigChange.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.configChanges) {
            obj.config_changes = message.configChanges.map(e => e ? ConfigChange.toAmino(e) : undefined);
        }
        else {
            obj.config_changes = message.configChanges;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return ChangeReport.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ChangeReport.decode(message.value);
    },
    toProto(message) {
        return ChangeReport.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.ChangeReport",
            value: ChangeReport.encode(message).finish()
        };
    },
    registerTypeUrl() {
        ConfigChange.registerTypeUrl();
    }
};
function createBaseRollout() {
    return {
        rolloutId: "",
        createTime: undefined,
        createdBy: "",
        status: 0,
        trafficPercentStrategy: undefined,
        deleteServiceStrategy: undefined,
        serviceName: ""
    };
}
export const Rollout = {
    typeUrl: "/google.api.servicemanagement.v1.Rollout",
    is(o) {
        return o && (o.$typeUrl === Rollout.typeUrl || typeof o.rolloutId === "string" && typeof o.createdBy === "string" && isSet(o.status) && typeof o.serviceName === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Rollout.typeUrl || typeof o.rollout_id === "string" && typeof o.created_by === "string" && isSet(o.status) && typeof o.service_name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Rollout.typeUrl || typeof o.rollout_id === "string" && typeof o.created_by === "string" && isSet(o.status) && typeof o.service_name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.rolloutId !== undefined) {
            writer.uint32(10).string(message.rolloutId);
        }
        if (message.createTime !== undefined) {
            Timestamp.encode(toTimestamp(message.createTime), writer.uint32(18).fork()).ldelim();
        }
        if (message.createdBy !== undefined) {
            writer.uint32(26).string(message.createdBy);
        }
        if (message.status !== 0) {
            writer.uint32(32).int32(message.status);
        }
        if (message.trafficPercentStrategy !== undefined) {
            Rollout_TrafficPercentStrategy.encode(message.trafficPercentStrategy, writer.uint32(42).fork()).ldelim();
        }
        if (message.deleteServiceStrategy !== undefined) {
            Rollout_DeleteServiceStrategy.encode(message.deleteServiceStrategy, writer.uint32(1602).fork()).ldelim();
        }
        if (message.serviceName !== undefined) {
            writer.uint32(66).string(message.serviceName);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRollout();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.rolloutId = reader.string();
                    break;
                case 2:
                    message.createTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.createdBy = reader.string();
                    break;
                case 4:
                    message.status = reader.int32();
                    break;
                case 5:
                    message.trafficPercentStrategy = Rollout_TrafficPercentStrategy.decode(reader, reader.uint32());
                    break;
                case 200:
                    message.deleteServiceStrategy = Rollout_DeleteServiceStrategy.decode(reader, reader.uint32());
                    break;
                case 8:
                    message.serviceName = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseRollout();
        if (isSet(object.rolloutId))
            obj.rolloutId = String(object.rolloutId);
        if (isSet(object.createTime))
            obj.createTime = new Date(object.createTime);
        if (isSet(object.createdBy))
            obj.createdBy = String(object.createdBy);
        if (isSet(object.status))
            obj.status = rollout_RolloutStatusFromJSON(object.status);
        if (isSet(object.trafficPercentStrategy))
            obj.trafficPercentStrategy = Rollout_TrafficPercentStrategy.fromJSON(object.trafficPercentStrategy);
        if (isSet(object.deleteServiceStrategy))
            obj.deleteServiceStrategy = Rollout_DeleteServiceStrategy.fromJSON(object.deleteServiceStrategy);
        if (isSet(object.serviceName))
            obj.serviceName = String(object.serviceName);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.rolloutId !== undefined && (obj.rolloutId = message.rolloutId);
        message.createTime !== undefined && (obj.createTime = message.createTime.toISOString());
        message.createdBy !== undefined && (obj.createdBy = message.createdBy);
        message.status !== undefined && (obj.status = rollout_RolloutStatusToJSON(message.status));
        message.trafficPercentStrategy !== undefined && (obj.trafficPercentStrategy = message.trafficPercentStrategy ? Rollout_TrafficPercentStrategy.toJSON(message.trafficPercentStrategy) : undefined);
        message.deleteServiceStrategy !== undefined && (obj.deleteServiceStrategy = message.deleteServiceStrategy ? Rollout_DeleteServiceStrategy.toJSON(message.deleteServiceStrategy) : undefined);
        message.serviceName !== undefined && (obj.serviceName = message.serviceName);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseRollout();
        message.rolloutId = object.rolloutId ?? "";
        message.createTime = object.createTime ?? undefined;
        message.createdBy = object.createdBy ?? "";
        message.status = object.status ?? 0;
        if (object.trafficPercentStrategy !== undefined && object.trafficPercentStrategy !== null) {
            message.trafficPercentStrategy = Rollout_TrafficPercentStrategy.fromPartial(object.trafficPercentStrategy);
        }
        if (object.deleteServiceStrategy !== undefined && object.deleteServiceStrategy !== null) {
            message.deleteServiceStrategy = Rollout_DeleteServiceStrategy.fromPartial(object.deleteServiceStrategy);
        }
        message.serviceName = object.serviceName ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            rolloutId: object?.rollout_id,
            createTime: object.create_time ?? undefined,
            createdBy: object?.created_by,
            status: isSet(object.status) ? rollout_RolloutStatusFromJSON(object.status) : -1,
            trafficPercentStrategy: object.traffic_percent_strategy ? Rollout_TrafficPercentStrategy.fromSDK(object.traffic_percent_strategy) : undefined,
            deleteServiceStrategy: object.delete_service_strategy ? Rollout_DeleteServiceStrategy.fromSDK(object.delete_service_strategy) : undefined,
            serviceName: object?.service_name
        };
    },
    fromSDKJSON(object) {
        return {
            rollout_id: isSet(object.rollout_id) ? String(object.rollout_id) : "",
            create_time: isSet(object.create_time) ? new Date(object.create_time) : undefined,
            created_by: isSet(object.created_by) ? String(object.created_by) : "",
            status: isSet(object.status) ? rollout_RolloutStatusFromJSON(object.status) : -1,
            traffic_percent_strategy: isSet(object.traffic_percent_strategy) ? Rollout_TrafficPercentStrategy.fromSDKJSON(object.traffic_percent_strategy) : undefined,
            delete_service_strategy: isSet(object.delete_service_strategy) ? Rollout_DeleteServiceStrategy.fromSDKJSON(object.delete_service_strategy) : undefined,
            service_name: isSet(object.service_name) ? String(object.service_name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.rollout_id = message.rolloutId;
        message.createTime !== undefined && (obj.create_time = message.createTime ?? undefined);
        obj.created_by = message.createdBy;
        message.status !== undefined && (obj.status = rollout_RolloutStatusToJSON(message.status));
        message.trafficPercentStrategy !== undefined && (obj.traffic_percent_strategy = message.trafficPercentStrategy ? Rollout_TrafficPercentStrategy.toSDK(message.trafficPercentStrategy) : undefined);
        message.deleteServiceStrategy !== undefined && (obj.delete_service_strategy = message.deleteServiceStrategy ? Rollout_DeleteServiceStrategy.toSDK(message.deleteServiceStrategy) : undefined);
        obj.service_name = message.serviceName;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseRollout();
        if (object.rollout_id !== undefined && object.rollout_id !== null) {
            message.rolloutId = object.rollout_id;
        }
        if (object.create_time !== undefined && object.create_time !== null) {
            message.createTime = fromTimestamp(Timestamp.fromAmino(object.create_time));
        }
        if (object.created_by !== undefined && object.created_by !== null) {
            message.createdBy = object.created_by;
        }
        if (object.status !== undefined && object.status !== null) {
            message.status = object.status;
        }
        if (object.traffic_percent_strategy !== undefined && object.traffic_percent_strategy !== null) {
            message.trafficPercentStrategy = Rollout_TrafficPercentStrategy.fromAmino(object.traffic_percent_strategy);
        }
        if (object.delete_service_strategy !== undefined && object.delete_service_strategy !== null) {
            message.deleteServiceStrategy = Rollout_DeleteServiceStrategy.fromAmino(object.delete_service_strategy);
        }
        if (object.service_name !== undefined && object.service_name !== null) {
            message.serviceName = object.service_name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.rollout_id = message.rolloutId === "" ? undefined : message.rolloutId;
        obj.create_time = message.createTime ? Timestamp.toAmino(toTimestamp(message.createTime)) : undefined;
        obj.created_by = message.createdBy === "" ? undefined : message.createdBy;
        obj.status = message.status === 0 ? undefined : message.status;
        obj.traffic_percent_strategy = message.trafficPercentStrategy ? Rollout_TrafficPercentStrategy.toAmino(message.trafficPercentStrategy) : undefined;
        obj.delete_service_strategy = message.deleteServiceStrategy ? Rollout_DeleteServiceStrategy.toAmino(message.deleteServiceStrategy) : undefined;
        obj.service_name = message.serviceName === "" ? undefined : message.serviceName;
        return obj;
    },
    fromAminoMsg(object) {
        return Rollout.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Rollout.decode(message.value);
    },
    toProto(message) {
        return Rollout.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.Rollout",
            value: Rollout.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Rollout_TrafficPercentStrategy.registerTypeUrl();
        Rollout_DeleteServiceStrategy.registerTypeUrl();
    }
};
function createBaseRollout_TrafficPercentStrategy_PercentagesEntry() {
    return {
        key: "",
        value: 0
    };
}
export const Rollout_TrafficPercentStrategy_PercentagesEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(17).double(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRollout_TrafficPercentStrategy_PercentagesEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.double();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseRollout_TrafficPercentStrategy_PercentagesEntry();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = Number(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = message.value);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseRollout_TrafficPercentStrategy_PercentagesEntry();
        message.key = object.key ?? "";
        message.value = object.value ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? Number(object.value) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseRollout_TrafficPercentStrategy_PercentagesEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value === 0 ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return Rollout_TrafficPercentStrategy_PercentagesEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Rollout_TrafficPercentStrategy_PercentagesEntry.decode(message.value);
    },
    toProto(message) {
        return Rollout_TrafficPercentStrategy_PercentagesEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseRollout_TrafficPercentStrategy() {
    return {
        percentages: {}
    };
}
export const Rollout_TrafficPercentStrategy = {
    typeUrl: "/google.api.servicemanagement.v1.TrafficPercentStrategy",
    is(o) {
        return o && (o.$typeUrl === Rollout_TrafficPercentStrategy.typeUrl || isSet(o.percentages));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Rollout_TrafficPercentStrategy.typeUrl || isSet(o.percentages));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Rollout_TrafficPercentStrategy.typeUrl || isSet(o.percentages));
    },
    encode(message, writer = BinaryWriter.create()) {
        Object.entries(message.percentages).forEach(([key, value]) => {
            Rollout_TrafficPercentStrategy_PercentagesEntry.encode({
                key: key,
                value
            }, writer.uint32(9).fork()).ldelim();
        });
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRollout_TrafficPercentStrategy();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    const entry1 = Rollout_TrafficPercentStrategy_PercentagesEntry.decode(reader, reader.uint32());
                    if (entry1.value !== undefined) {
                        message.percentages[entry1.key] = entry1.value;
                    }
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseRollout_TrafficPercentStrategy();
        if (isObject(object.percentages))
            obj.percentages = Object.entries(object.percentages).reduce((acc, [key, value]) => {
                acc[key] = double.fromJSON(value);
                return acc;
            }, {});
        return obj;
    },
    toJSON(message) {
        const obj = {};
        obj.percentages = {};
        if (message.percentages) {
            Object.entries(message.percentages).forEach(([k, v]) => {
                obj.percentages[k] = double.toJSON(v);
            });
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseRollout_TrafficPercentStrategy();
        message.percentages = Object.entries(object.percentages ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = double.fromPartial(value);
            }
            return acc;
        }, {});
        return message;
    },
    fromSDK(object) {
        return {
            percentages: isObject(object.percentages) ? Object.entries(object.percentages).reduce((acc, [key, value]) => {
                acc[key] = double.fromSDK(value);
                return acc;
            }, {}) : {}
        };
    },
    fromSDKJSON(object) {
        return {
            percentages: isObject(object.percentages) ? Object.entries(object.percentages).reduce((acc, [key, value]) => {
                acc[key] = double.fromSDKJSON(value);
                return acc;
            }, {}) : {}
        };
    },
    toSDK(message) {
        const obj = {};
        obj.percentages = {};
        if (message.percentages) {
            Object.entries(message.percentages).forEach(([k, v]) => {
                obj.percentages[k] = double.toSDK(v);
            });
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseRollout_TrafficPercentStrategy();
        message.percentages = Object.entries(object.percentages ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = double.fromAmino(value);
            }
            return acc;
        }, {});
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.percentages = {};
        if (message.percentages) {
            Object.entries(message.percentages).forEach(([k, v]) => {
                obj.percentages[k] = double.toAmino(v);
            });
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Rollout_TrafficPercentStrategy.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Rollout_TrafficPercentStrategy.decode(message.value);
    },
    toProto(message) {
        return Rollout_TrafficPercentStrategy.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.TrafficPercentStrategy",
            value: Rollout_TrafficPercentStrategy.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseRollout_DeleteServiceStrategy() {
    return {};
}
export const Rollout_DeleteServiceStrategy = {
    typeUrl: "/google.api.servicemanagement.v1.DeleteServiceStrategy",
    is(o) {
        return o && o.$typeUrl === Rollout_DeleteServiceStrategy.typeUrl;
    },
    isSDK(o) {
        return o && o.$typeUrl === Rollout_DeleteServiceStrategy.typeUrl;
    },
    isAmino(o) {
        return o && o.$typeUrl === Rollout_DeleteServiceStrategy.typeUrl;
    },
    encode(_, writer = BinaryWriter.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseRollout_DeleteServiceStrategy();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        const obj = createBaseRollout_DeleteServiceStrategy();
        return obj;
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseRollout_DeleteServiceStrategy();
        return message;
    },
    fromSDK(_) {
        return {};
    },
    fromSDKJSON(_) {
        return {};
    },
    toSDK(_) {
        const obj = {};
        return obj;
    },
    fromAmino(_) {
        const message = createBaseRollout_DeleteServiceStrategy();
        return message;
    },
    toAmino(_) {
        const obj = {};
        return obj;
    },
    fromAminoMsg(object) {
        return Rollout_DeleteServiceStrategy.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Rollout_DeleteServiceStrategy.decode(message.value);
    },
    toProto(message) {
        return Rollout_DeleteServiceStrategy.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.servicemanagement.v1.DeleteServiceStrategy",
            value: Rollout_DeleteServiceStrategy.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
