import { ManagedService, ManagedServiceAmino, ManagedServiceSDKType, ConfigSource, ConfigSourceAmino, ConfigSourceSDKType, Rollout, RolloutAmino, RolloutSDKType, ChangeReport, ChangeReportAmino, ChangeReportSDKType, Diagnostic, DiagnosticAmino, DiagnosticSDKType } from "./resources";
import { Service, ServiceAmino, ServiceSDKType } from "../../service";
import { Any, AnyAmino, AnySDKType } from "../../../protobuf/any";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { DeepPartial } from "../../../../helpers";
import { JsonSafe } from "../../../../json-safe";
export declare const protobufPackage = "google.api.servicemanagement.v1";
export declare enum GetServiceConfigRequest_ConfigView {
    /** BASIC - Server response includes all fields except SourceInfo. */
    BASIC = 0,
    /**
     * FULL - Server response includes all fields including SourceInfo.
     * SourceFiles are of type 'google.api.servicemanagement.v1.ConfigFile'
     * and are only available for configs created using the
     * SubmitConfigSource method.
     */
    FULL = 1,
    UNRECOGNIZED = -1
}
export declare const GetServiceConfigRequest_ConfigViewSDKType: typeof GetServiceConfigRequest_ConfigView;
export declare const GetServiceConfigRequest_ConfigViewAmino: typeof GetServiceConfigRequest_ConfigView;
export declare function getServiceConfigRequest_ConfigViewFromJSON(object: any): GetServiceConfigRequest_ConfigView;
export declare function getServiceConfigRequest_ConfigViewToJSON(object: GetServiceConfigRequest_ConfigView): string;
/** Request message for `ListServices` method. */
export interface ListServicesRequest {
    /** Include services produced by the specified project. */
    producerProjectId: string;
    /**
     * The max number of items to include in the response list. Page size is 50
     * if not specified. Maximum value is 100.
     */
    pageSize: number;
    /**
     * Token identifying which result to start with; returned by a previous list
     * call.
     */
    pageToken: string;
    /**
     * Include services consumed by the specified consumer.
     *
     * The Google Service Management implementation accepts the following
     * forms:
     * - project:<project_id>
     */
    /** @deprecated */
    consumerId: string;
}
export interface ListServicesRequestProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.ListServicesRequest";
    value: Uint8Array;
}
/** Request message for `ListServices` method. */
export interface ListServicesRequestAmino {
    /** Include services produced by the specified project. */
    producer_project_id?: string;
    /**
     * The max number of items to include in the response list. Page size is 50
     * if not specified. Maximum value is 100.
     */
    page_size?: number;
    /**
     * Token identifying which result to start with; returned by a previous list
     * call.
     */
    page_token?: string;
    /**
     * Include services consumed by the specified consumer.
     *
     * The Google Service Management implementation accepts the following
     * forms:
     * - project:<project_id>
     */
    /** @deprecated */
    consumer_id?: string;
}
export interface ListServicesRequestAminoMsg {
    type: "/google.api.servicemanagement.v1.ListServicesRequest";
    value: ListServicesRequestAmino;
}
/** Request message for `ListServices` method. */
export interface ListServicesRequestSDKType {
    producer_project_id: string;
    page_size: number;
    page_token: string;
    /** @deprecated */
    consumer_id: string;
}
/** Response message for `ListServices` method. */
export interface ListServicesResponse {
    /** The returned services will only have the name field set. */
    services: ManagedService[];
    /** Token that can be passed to `ListServices` to resume a paginated query. */
    nextPageToken: string;
}
export interface ListServicesResponseProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.ListServicesResponse";
    value: Uint8Array;
}
/** Response message for `ListServices` method. */
export interface ListServicesResponseAmino {
    /** The returned services will only have the name field set. */
    services?: ManagedServiceAmino[];
    /** Token that can be passed to `ListServices` to resume a paginated query. */
    next_page_token?: string;
}
export interface ListServicesResponseAminoMsg {
    type: "/google.api.servicemanagement.v1.ListServicesResponse";
    value: ListServicesResponseAmino;
}
/** Response message for `ListServices` method. */
export interface ListServicesResponseSDKType {
    services: ManagedServiceSDKType[];
    next_page_token: string;
}
/** Request message for `GetService` method. */
export interface GetServiceRequest {
    /**
     * Required. The name of the service.  See the `ServiceManager` overview for naming
     * requirements.  For example: `example.googleapis.com`.
     */
    serviceName: string;
}
export interface GetServiceRequestProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.GetServiceRequest";
    value: Uint8Array;
}
/** Request message for `GetService` method. */
export interface GetServiceRequestAmino {
    /**
     * Required. The name of the service.  See the `ServiceManager` overview for naming
     * requirements.  For example: `example.googleapis.com`.
     */
    service_name?: string;
}
export interface GetServiceRequestAminoMsg {
    type: "/google.api.servicemanagement.v1.GetServiceRequest";
    value: GetServiceRequestAmino;
}
/** Request message for `GetService` method. */
export interface GetServiceRequestSDKType {
    service_name: string;
}
/** Request message for CreateService method. */
export interface CreateServiceRequest {
    /** Required. Initial values for the service resource. */
    service?: ManagedService;
}
export interface CreateServiceRequestProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.CreateServiceRequest";
    value: Uint8Array;
}
/** Request message for CreateService method. */
export interface CreateServiceRequestAmino {
    /** Required. Initial values for the service resource. */
    service?: ManagedServiceAmino;
}
export interface CreateServiceRequestAminoMsg {
    type: "/google.api.servicemanagement.v1.CreateServiceRequest";
    value: CreateServiceRequestAmino;
}
/** Request message for CreateService method. */
export interface CreateServiceRequestSDKType {
    service?: ManagedServiceSDKType;
}
/** Request message for DeleteService method. */
export interface DeleteServiceRequest {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    serviceName: string;
}
export interface DeleteServiceRequestProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.DeleteServiceRequest";
    value: Uint8Array;
}
/** Request message for DeleteService method. */
export interface DeleteServiceRequestAmino {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    service_name?: string;
}
export interface DeleteServiceRequestAminoMsg {
    type: "/google.api.servicemanagement.v1.DeleteServiceRequest";
    value: DeleteServiceRequestAmino;
}
/** Request message for DeleteService method. */
export interface DeleteServiceRequestSDKType {
    service_name: string;
}
/** Request message for UndeleteService method. */
export interface UndeleteServiceRequest {
    /**
     * Required. The name of the service. See the [overview](/service-management/overview)
     * for naming requirements. For example: `example.googleapis.com`.
     */
    serviceName: string;
}
export interface UndeleteServiceRequestProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.UndeleteServiceRequest";
    value: Uint8Array;
}
/** Request message for UndeleteService method. */
export interface UndeleteServiceRequestAmino {
    /**
     * Required. The name of the service. See the [overview](/service-management/overview)
     * for naming requirements. For example: `example.googleapis.com`.
     */
    service_name?: string;
}
export interface UndeleteServiceRequestAminoMsg {
    type: "/google.api.servicemanagement.v1.UndeleteServiceRequest";
    value: UndeleteServiceRequestAmino;
}
/** Request message for UndeleteService method. */
export interface UndeleteServiceRequestSDKType {
    service_name: string;
}
/** Response message for UndeleteService method. */
export interface UndeleteServiceResponse {
    /** Revived service resource. */
    service?: ManagedService;
}
export interface UndeleteServiceResponseProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.UndeleteServiceResponse";
    value: Uint8Array;
}
/** Response message for UndeleteService method. */
export interface UndeleteServiceResponseAmino {
    /** Revived service resource. */
    service?: ManagedServiceAmino;
}
export interface UndeleteServiceResponseAminoMsg {
    type: "/google.api.servicemanagement.v1.UndeleteServiceResponse";
    value: UndeleteServiceResponseAmino;
}
/** Response message for UndeleteService method. */
export interface UndeleteServiceResponseSDKType {
    service?: ManagedServiceSDKType;
}
/** Request message for GetServiceConfig method. */
export interface GetServiceConfigRequest {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    serviceName: string;
    /**
     * Required. The id of the service configuration resource.
     *
     * This field must be specified for the server to return all fields, including
     * `SourceInfo`.
     */
    configId: string;
    /**
     * Specifies which parts of the Service Config should be returned in the
     * response.
     */
    view: GetServiceConfigRequest_ConfigView;
}
export interface GetServiceConfigRequestProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.GetServiceConfigRequest";
    value: Uint8Array;
}
/** Request message for GetServiceConfig method. */
export interface GetServiceConfigRequestAmino {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    service_name?: string;
    /**
     * Required. The id of the service configuration resource.
     *
     * This field must be specified for the server to return all fields, including
     * `SourceInfo`.
     */
    config_id?: string;
    /**
     * Specifies which parts of the Service Config should be returned in the
     * response.
     */
    view?: GetServiceConfigRequest_ConfigView;
}
export interface GetServiceConfigRequestAminoMsg {
    type: "/google.api.servicemanagement.v1.GetServiceConfigRequest";
    value: GetServiceConfigRequestAmino;
}
/** Request message for GetServiceConfig method. */
export interface GetServiceConfigRequestSDKType {
    service_name: string;
    config_id: string;
    view: GetServiceConfigRequest_ConfigView;
}
/** Request message for ListServiceConfigs method. */
export interface ListServiceConfigsRequest {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    serviceName: string;
    /** The token of the page to retrieve. */
    pageToken: string;
    /**
     * The max number of items to include in the response list. Page size is 50
     * if not specified. Maximum value is 100.
     */
    pageSize: number;
}
export interface ListServiceConfigsRequestProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.ListServiceConfigsRequest";
    value: Uint8Array;
}
/** Request message for ListServiceConfigs method. */
export interface ListServiceConfigsRequestAmino {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    service_name?: string;
    /** The token of the page to retrieve. */
    page_token?: string;
    /**
     * The max number of items to include in the response list. Page size is 50
     * if not specified. Maximum value is 100.
     */
    page_size?: number;
}
export interface ListServiceConfigsRequestAminoMsg {
    type: "/google.api.servicemanagement.v1.ListServiceConfigsRequest";
    value: ListServiceConfigsRequestAmino;
}
/** Request message for ListServiceConfigs method. */
export interface ListServiceConfigsRequestSDKType {
    service_name: string;
    page_token: string;
    page_size: number;
}
/** Response message for ListServiceConfigs method. */
export interface ListServiceConfigsResponse {
    /** The list of service configuration resources. */
    serviceConfigs: Service[];
    /** The token of the next page of results. */
    nextPageToken: string;
}
export interface ListServiceConfigsResponseProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.ListServiceConfigsResponse";
    value: Uint8Array;
}
/** Response message for ListServiceConfigs method. */
export interface ListServiceConfigsResponseAmino {
    /** The list of service configuration resources. */
    service_configs?: ServiceAmino[];
    /** The token of the next page of results. */
    next_page_token?: string;
}
export interface ListServiceConfigsResponseAminoMsg {
    type: "/google.api.servicemanagement.v1.ListServiceConfigsResponse";
    value: ListServiceConfigsResponseAmino;
}
/** Response message for ListServiceConfigs method. */
export interface ListServiceConfigsResponseSDKType {
    service_configs: ServiceSDKType[];
    next_page_token: string;
}
/** Request message for CreateServiceConfig method. */
export interface CreateServiceConfigRequest {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    serviceName: string;
    /** Required. The service configuration resource. */
    serviceConfig?: Service;
}
export interface CreateServiceConfigRequestProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.CreateServiceConfigRequest";
    value: Uint8Array;
}
/** Request message for CreateServiceConfig method. */
export interface CreateServiceConfigRequestAmino {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    service_name?: string;
    /** Required. The service configuration resource. */
    service_config?: ServiceAmino;
}
export interface CreateServiceConfigRequestAminoMsg {
    type: "/google.api.servicemanagement.v1.CreateServiceConfigRequest";
    value: CreateServiceConfigRequestAmino;
}
/** Request message for CreateServiceConfig method. */
export interface CreateServiceConfigRequestSDKType {
    service_name: string;
    service_config?: ServiceSDKType;
}
/** Request message for SubmitConfigSource method. */
export interface SubmitConfigSourceRequest {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    serviceName: string;
    /** Required. The source configuration for the service. */
    configSource?: ConfigSource;
    /**
     * Optional. If set, this will result in the generation of a
     * `google.api.Service` configuration based on the `ConfigSource` provided,
     * but the generated config and the sources will NOT be persisted.
     */
    validateOnly: boolean;
}
export interface SubmitConfigSourceRequestProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.SubmitConfigSourceRequest";
    value: Uint8Array;
}
/** Request message for SubmitConfigSource method. */
export interface SubmitConfigSourceRequestAmino {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    service_name?: string;
    /** Required. The source configuration for the service. */
    config_source?: ConfigSourceAmino;
    /**
     * Optional. If set, this will result in the generation of a
     * `google.api.Service` configuration based on the `ConfigSource` provided,
     * but the generated config and the sources will NOT be persisted.
     */
    validate_only?: boolean;
}
export interface SubmitConfigSourceRequestAminoMsg {
    type: "/google.api.servicemanagement.v1.SubmitConfigSourceRequest";
    value: SubmitConfigSourceRequestAmino;
}
/** Request message for SubmitConfigSource method. */
export interface SubmitConfigSourceRequestSDKType {
    service_name: string;
    config_source?: ConfigSourceSDKType;
    validate_only: boolean;
}
/** Response message for SubmitConfigSource method. */
export interface SubmitConfigSourceResponse {
    /** The generated service configuration. */
    serviceConfig?: Service;
}
export interface SubmitConfigSourceResponseProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.SubmitConfigSourceResponse";
    value: Uint8Array;
}
/** Response message for SubmitConfigSource method. */
export interface SubmitConfigSourceResponseAmino {
    /** The generated service configuration. */
    service_config?: ServiceAmino;
}
export interface SubmitConfigSourceResponseAminoMsg {
    type: "/google.api.servicemanagement.v1.SubmitConfigSourceResponse";
    value: SubmitConfigSourceResponseAmino;
}
/** Response message for SubmitConfigSource method. */
export interface SubmitConfigSourceResponseSDKType {
    service_config?: ServiceSDKType;
}
/** Request message for 'CreateServiceRollout' */
export interface CreateServiceRolloutRequest {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    serviceName: string;
    /** Required. The rollout resource. The `service_name` field is output only. */
    rollout?: Rollout;
}
export interface CreateServiceRolloutRequestProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.CreateServiceRolloutRequest";
    value: Uint8Array;
}
/** Request message for 'CreateServiceRollout' */
export interface CreateServiceRolloutRequestAmino {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    service_name?: string;
    /** Required. The rollout resource. The `service_name` field is output only. */
    rollout?: RolloutAmino;
}
export interface CreateServiceRolloutRequestAminoMsg {
    type: "/google.api.servicemanagement.v1.CreateServiceRolloutRequest";
    value: CreateServiceRolloutRequestAmino;
}
/** Request message for 'CreateServiceRollout' */
export interface CreateServiceRolloutRequestSDKType {
    service_name: string;
    rollout?: RolloutSDKType;
}
/** Request message for 'ListServiceRollouts' */
export interface ListServiceRolloutsRequest {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    serviceName: string;
    /** The token of the page to retrieve. */
    pageToken: string;
    /**
     * The max number of items to include in the response list. Page size is 50
     * if not specified. Maximum value is 100.
     */
    pageSize: number;
    /**
     * Required. Use `filter` to return subset of rollouts.
     * The following filters are supported:
     *   -- To limit the results to only those in
     *      [status](google.api.servicemanagement.v1.RolloutStatus) 'SUCCESS',
     *      use filter='status=SUCCESS'
     *   -- To limit the results to those in
     *      [status](google.api.servicemanagement.v1.RolloutStatus) 'CANCELLED'
     *      or 'FAILED', use filter='status=CANCELLED OR status=FAILED'
     */
    filter: string;
}
export interface ListServiceRolloutsRequestProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.ListServiceRolloutsRequest";
    value: Uint8Array;
}
/** Request message for 'ListServiceRollouts' */
export interface ListServiceRolloutsRequestAmino {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    service_name?: string;
    /** The token of the page to retrieve. */
    page_token?: string;
    /**
     * The max number of items to include in the response list. Page size is 50
     * if not specified. Maximum value is 100.
     */
    page_size?: number;
    /**
     * Required. Use `filter` to return subset of rollouts.
     * The following filters are supported:
     *   -- To limit the results to only those in
     *      [status](google.api.servicemanagement.v1.RolloutStatus) 'SUCCESS',
     *      use filter='status=SUCCESS'
     *   -- To limit the results to those in
     *      [status](google.api.servicemanagement.v1.RolloutStatus) 'CANCELLED'
     *      or 'FAILED', use filter='status=CANCELLED OR status=FAILED'
     */
    filter?: string;
}
export interface ListServiceRolloutsRequestAminoMsg {
    type: "/google.api.servicemanagement.v1.ListServiceRolloutsRequest";
    value: ListServiceRolloutsRequestAmino;
}
/** Request message for 'ListServiceRollouts' */
export interface ListServiceRolloutsRequestSDKType {
    service_name: string;
    page_token: string;
    page_size: number;
    filter: string;
}
/** Response message for ListServiceRollouts method. */
export interface ListServiceRolloutsResponse {
    /** The list of rollout resources. */
    rollouts: Rollout[];
    /** The token of the next page of results. */
    nextPageToken: string;
}
export interface ListServiceRolloutsResponseProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.ListServiceRolloutsResponse";
    value: Uint8Array;
}
/** Response message for ListServiceRollouts method. */
export interface ListServiceRolloutsResponseAmino {
    /** The list of rollout resources. */
    rollouts?: RolloutAmino[];
    /** The token of the next page of results. */
    next_page_token?: string;
}
export interface ListServiceRolloutsResponseAminoMsg {
    type: "/google.api.servicemanagement.v1.ListServiceRolloutsResponse";
    value: ListServiceRolloutsResponseAmino;
}
/** Response message for ListServiceRollouts method. */
export interface ListServiceRolloutsResponseSDKType {
    rollouts: RolloutSDKType[];
    next_page_token: string;
}
/** Request message for GetServiceRollout method. */
export interface GetServiceRolloutRequest {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    serviceName: string;
    /** Required. The id of the rollout resource. */
    rolloutId: string;
}
export interface GetServiceRolloutRequestProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.GetServiceRolloutRequest";
    value: Uint8Array;
}
/** Request message for GetServiceRollout method. */
export interface GetServiceRolloutRequestAmino {
    /**
     * Required. The name of the service.  See the [overview](/service-management/overview)
     * for naming requirements.  For example: `example.googleapis.com`.
     */
    service_name?: string;
    /** Required. The id of the rollout resource. */
    rollout_id?: string;
}
export interface GetServiceRolloutRequestAminoMsg {
    type: "/google.api.servicemanagement.v1.GetServiceRolloutRequest";
    value: GetServiceRolloutRequestAmino;
}
/** Request message for GetServiceRollout method. */
export interface GetServiceRolloutRequestSDKType {
    service_name: string;
    rollout_id: string;
}
/** Request message for GenerateConfigReport method. */
export interface GenerateConfigReportRequest {
    /**
     * Required. Service configuration for which we want to generate the report.
     * For this version of API, the supported types are
     * [google.api.servicemanagement.v1.ConfigRef][google.api.servicemanagement.v1.ConfigRef],
     * [google.api.servicemanagement.v1.ConfigSource][google.api.servicemanagement.v1.ConfigSource],
     * and [google.api.Service][google.api.Service]
     */
    newConfig?: Any;
    /**
     * Optional. Service configuration against which the comparison will be done.
     * For this version of API, the supported types are
     * [google.api.servicemanagement.v1.ConfigRef][google.api.servicemanagement.v1.ConfigRef],
     * [google.api.servicemanagement.v1.ConfigSource][google.api.servicemanagement.v1.ConfigSource],
     * and [google.api.Service][google.api.Service]
     */
    oldConfig?: Any;
}
export interface GenerateConfigReportRequestProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.GenerateConfigReportRequest";
    value: Uint8Array;
}
/** Request message for GenerateConfigReport method. */
export interface GenerateConfigReportRequestAmino {
    /**
     * Required. Service configuration for which we want to generate the report.
     * For this version of API, the supported types are
     * [google.api.servicemanagement.v1.ConfigRef][google.api.servicemanagement.v1.ConfigRef],
     * [google.api.servicemanagement.v1.ConfigSource][google.api.servicemanagement.v1.ConfigSource],
     * and [google.api.Service][google.api.Service]
     */
    new_config?: AnyAmino;
    /**
     * Optional. Service configuration against which the comparison will be done.
     * For this version of API, the supported types are
     * [google.api.servicemanagement.v1.ConfigRef][google.api.servicemanagement.v1.ConfigRef],
     * [google.api.servicemanagement.v1.ConfigSource][google.api.servicemanagement.v1.ConfigSource],
     * and [google.api.Service][google.api.Service]
     */
    old_config?: AnyAmino;
}
export interface GenerateConfigReportRequestAminoMsg {
    type: "/google.api.servicemanagement.v1.GenerateConfigReportRequest";
    value: GenerateConfigReportRequestAmino;
}
/** Request message for GenerateConfigReport method. */
export interface GenerateConfigReportRequestSDKType {
    new_config?: AnySDKType;
    old_config?: AnySDKType;
}
/** Response message for GenerateConfigReport method. */
export interface GenerateConfigReportResponse {
    /** Name of the service this report belongs to. */
    serviceName: string;
    /** ID of the service configuration this report belongs to. */
    id: string;
    /**
     * list of ChangeReport, each corresponding to comparison between two
     * service configurations.
     */
    changeReports: ChangeReport[];
    /**
     * Errors / Linter warnings associated with the service definition this
     * report
     * belongs to.
     */
    diagnostics: Diagnostic[];
}
export interface GenerateConfigReportResponseProtoMsg {
    typeUrl: "/google.api.servicemanagement.v1.GenerateConfigReportResponse";
    value: Uint8Array;
}
/** Response message for GenerateConfigReport method. */
export interface GenerateConfigReportResponseAmino {
    /** Name of the service this report belongs to. */
    service_name?: string;
    /** ID of the service configuration this report belongs to. */
    id?: string;
    /**
     * list of ChangeReport, each corresponding to comparison between two
     * service configurations.
     */
    change_reports?: ChangeReportAmino[];
    /**
     * Errors / Linter warnings associated with the service definition this
     * report
     * belongs to.
     */
    diagnostics?: DiagnosticAmino[];
}
export interface GenerateConfigReportResponseAminoMsg {
    type: "/google.api.servicemanagement.v1.GenerateConfigReportResponse";
    value: GenerateConfigReportResponseAmino;
}
/** Response message for GenerateConfigReport method. */
export interface GenerateConfigReportResponseSDKType {
    service_name: string;
    id: string;
    change_reports: ChangeReportSDKType[];
    diagnostics: DiagnosticSDKType[];
}
export declare const ListServicesRequest: {
    typeUrl: string;
    is(o: any): o is ListServicesRequest;
    isSDK(o: any): o is ListServicesRequestSDKType;
    isAmino(o: any): o is ListServicesRequestAmino;
    encode(message: ListServicesRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ListServicesRequest;
    fromJSON(object: any): ListServicesRequest;
    toJSON(message: ListServicesRequest): JsonSafe<ListServicesRequest>;
    fromPartial(object: DeepPartial<ListServicesRequest>): ListServicesRequest;
    fromSDK(object: ListServicesRequestSDKType): ListServicesRequest;
    fromSDKJSON(object: any): ListServicesRequestSDKType;
    toSDK(message: ListServicesRequest): ListServicesRequestSDKType;
    fromAmino(object: ListServicesRequestAmino): ListServicesRequest;
    toAmino(message: ListServicesRequest): ListServicesRequestAmino;
    fromAminoMsg(object: ListServicesRequestAminoMsg): ListServicesRequest;
    fromProtoMsg(message: ListServicesRequestProtoMsg): ListServicesRequest;
    toProto(message: ListServicesRequest): Uint8Array;
    toProtoMsg(message: ListServicesRequest): ListServicesRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const ListServicesResponse: {
    typeUrl: string;
    is(o: any): o is ListServicesResponse;
    isSDK(o: any): o is ListServicesResponseSDKType;
    isAmino(o: any): o is ListServicesResponseAmino;
    encode(message: ListServicesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ListServicesResponse;
    fromJSON(object: any): ListServicesResponse;
    toJSON(message: ListServicesResponse): JsonSafe<ListServicesResponse>;
    fromPartial(object: DeepPartial<ListServicesResponse>): ListServicesResponse;
    fromSDK(object: ListServicesResponseSDKType): ListServicesResponse;
    fromSDKJSON(object: any): ListServicesResponseSDKType;
    toSDK(message: ListServicesResponse): ListServicesResponseSDKType;
    fromAmino(object: ListServicesResponseAmino): ListServicesResponse;
    toAmino(message: ListServicesResponse): ListServicesResponseAmino;
    fromAminoMsg(object: ListServicesResponseAminoMsg): ListServicesResponse;
    fromProtoMsg(message: ListServicesResponseProtoMsg): ListServicesResponse;
    toProto(message: ListServicesResponse): Uint8Array;
    toProtoMsg(message: ListServicesResponse): ListServicesResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const GetServiceRequest: {
    typeUrl: string;
    is(o: any): o is GetServiceRequest;
    isSDK(o: any): o is GetServiceRequestSDKType;
    isAmino(o: any): o is GetServiceRequestAmino;
    encode(message: GetServiceRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GetServiceRequest;
    fromJSON(object: any): GetServiceRequest;
    toJSON(message: GetServiceRequest): JsonSafe<GetServiceRequest>;
    fromPartial(object: DeepPartial<GetServiceRequest>): GetServiceRequest;
    fromSDK(object: GetServiceRequestSDKType): GetServiceRequest;
    fromSDKJSON(object: any): GetServiceRequestSDKType;
    toSDK(message: GetServiceRequest): GetServiceRequestSDKType;
    fromAmino(object: GetServiceRequestAmino): GetServiceRequest;
    toAmino(message: GetServiceRequest): GetServiceRequestAmino;
    fromAminoMsg(object: GetServiceRequestAminoMsg): GetServiceRequest;
    fromProtoMsg(message: GetServiceRequestProtoMsg): GetServiceRequest;
    toProto(message: GetServiceRequest): Uint8Array;
    toProtoMsg(message: GetServiceRequest): GetServiceRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const CreateServiceRequest: {
    typeUrl: string;
    is(o: any): o is CreateServiceRequest;
    isSDK(o: any): o is CreateServiceRequestSDKType;
    isAmino(o: any): o is CreateServiceRequestAmino;
    encode(message: CreateServiceRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): CreateServiceRequest;
    fromJSON(object: any): CreateServiceRequest;
    toJSON(message: CreateServiceRequest): JsonSafe<CreateServiceRequest>;
    fromPartial(object: DeepPartial<CreateServiceRequest>): CreateServiceRequest;
    fromSDK(object: CreateServiceRequestSDKType): CreateServiceRequest;
    fromSDKJSON(object: any): CreateServiceRequestSDKType;
    toSDK(message: CreateServiceRequest): CreateServiceRequestSDKType;
    fromAmino(object: CreateServiceRequestAmino): CreateServiceRequest;
    toAmino(message: CreateServiceRequest): CreateServiceRequestAmino;
    fromAminoMsg(object: CreateServiceRequestAminoMsg): CreateServiceRequest;
    fromProtoMsg(message: CreateServiceRequestProtoMsg): CreateServiceRequest;
    toProto(message: CreateServiceRequest): Uint8Array;
    toProtoMsg(message: CreateServiceRequest): CreateServiceRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const DeleteServiceRequest: {
    typeUrl: string;
    is(o: any): o is DeleteServiceRequest;
    isSDK(o: any): o is DeleteServiceRequestSDKType;
    isAmino(o: any): o is DeleteServiceRequestAmino;
    encode(message: DeleteServiceRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): DeleteServiceRequest;
    fromJSON(object: any): DeleteServiceRequest;
    toJSON(message: DeleteServiceRequest): JsonSafe<DeleteServiceRequest>;
    fromPartial(object: DeepPartial<DeleteServiceRequest>): DeleteServiceRequest;
    fromSDK(object: DeleteServiceRequestSDKType): DeleteServiceRequest;
    fromSDKJSON(object: any): DeleteServiceRequestSDKType;
    toSDK(message: DeleteServiceRequest): DeleteServiceRequestSDKType;
    fromAmino(object: DeleteServiceRequestAmino): DeleteServiceRequest;
    toAmino(message: DeleteServiceRequest): DeleteServiceRequestAmino;
    fromAminoMsg(object: DeleteServiceRequestAminoMsg): DeleteServiceRequest;
    fromProtoMsg(message: DeleteServiceRequestProtoMsg): DeleteServiceRequest;
    toProto(message: DeleteServiceRequest): Uint8Array;
    toProtoMsg(message: DeleteServiceRequest): DeleteServiceRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const UndeleteServiceRequest: {
    typeUrl: string;
    is(o: any): o is UndeleteServiceRequest;
    isSDK(o: any): o is UndeleteServiceRequestSDKType;
    isAmino(o: any): o is UndeleteServiceRequestAmino;
    encode(message: UndeleteServiceRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): UndeleteServiceRequest;
    fromJSON(object: any): UndeleteServiceRequest;
    toJSON(message: UndeleteServiceRequest): JsonSafe<UndeleteServiceRequest>;
    fromPartial(object: DeepPartial<UndeleteServiceRequest>): UndeleteServiceRequest;
    fromSDK(object: UndeleteServiceRequestSDKType): UndeleteServiceRequest;
    fromSDKJSON(object: any): UndeleteServiceRequestSDKType;
    toSDK(message: UndeleteServiceRequest): UndeleteServiceRequestSDKType;
    fromAmino(object: UndeleteServiceRequestAmino): UndeleteServiceRequest;
    toAmino(message: UndeleteServiceRequest): UndeleteServiceRequestAmino;
    fromAminoMsg(object: UndeleteServiceRequestAminoMsg): UndeleteServiceRequest;
    fromProtoMsg(message: UndeleteServiceRequestProtoMsg): UndeleteServiceRequest;
    toProto(message: UndeleteServiceRequest): Uint8Array;
    toProtoMsg(message: UndeleteServiceRequest): UndeleteServiceRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const UndeleteServiceResponse: {
    typeUrl: string;
    is(o: any): o is UndeleteServiceResponse;
    isSDK(o: any): o is UndeleteServiceResponseSDKType;
    isAmino(o: any): o is UndeleteServiceResponseAmino;
    encode(message: UndeleteServiceResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): UndeleteServiceResponse;
    fromJSON(object: any): UndeleteServiceResponse;
    toJSON(message: UndeleteServiceResponse): JsonSafe<UndeleteServiceResponse>;
    fromPartial(object: DeepPartial<UndeleteServiceResponse>): UndeleteServiceResponse;
    fromSDK(object: UndeleteServiceResponseSDKType): UndeleteServiceResponse;
    fromSDKJSON(object: any): UndeleteServiceResponseSDKType;
    toSDK(message: UndeleteServiceResponse): UndeleteServiceResponseSDKType;
    fromAmino(object: UndeleteServiceResponseAmino): UndeleteServiceResponse;
    toAmino(message: UndeleteServiceResponse): UndeleteServiceResponseAmino;
    fromAminoMsg(object: UndeleteServiceResponseAminoMsg): UndeleteServiceResponse;
    fromProtoMsg(message: UndeleteServiceResponseProtoMsg): UndeleteServiceResponse;
    toProto(message: UndeleteServiceResponse): Uint8Array;
    toProtoMsg(message: UndeleteServiceResponse): UndeleteServiceResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const GetServiceConfigRequest: {
    typeUrl: string;
    is(o: any): o is GetServiceConfigRequest;
    isSDK(o: any): o is GetServiceConfigRequestSDKType;
    isAmino(o: any): o is GetServiceConfigRequestAmino;
    encode(message: GetServiceConfigRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GetServiceConfigRequest;
    fromJSON(object: any): GetServiceConfigRequest;
    toJSON(message: GetServiceConfigRequest): JsonSafe<GetServiceConfigRequest>;
    fromPartial(object: DeepPartial<GetServiceConfigRequest>): GetServiceConfigRequest;
    fromSDK(object: GetServiceConfigRequestSDKType): GetServiceConfigRequest;
    fromSDKJSON(object: any): GetServiceConfigRequestSDKType;
    toSDK(message: GetServiceConfigRequest): GetServiceConfigRequestSDKType;
    fromAmino(object: GetServiceConfigRequestAmino): GetServiceConfigRequest;
    toAmino(message: GetServiceConfigRequest): GetServiceConfigRequestAmino;
    fromAminoMsg(object: GetServiceConfigRequestAminoMsg): GetServiceConfigRequest;
    fromProtoMsg(message: GetServiceConfigRequestProtoMsg): GetServiceConfigRequest;
    toProto(message: GetServiceConfigRequest): Uint8Array;
    toProtoMsg(message: GetServiceConfigRequest): GetServiceConfigRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const ListServiceConfigsRequest: {
    typeUrl: string;
    is(o: any): o is ListServiceConfigsRequest;
    isSDK(o: any): o is ListServiceConfigsRequestSDKType;
    isAmino(o: any): o is ListServiceConfigsRequestAmino;
    encode(message: ListServiceConfigsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ListServiceConfigsRequest;
    fromJSON(object: any): ListServiceConfigsRequest;
    toJSON(message: ListServiceConfigsRequest): JsonSafe<ListServiceConfigsRequest>;
    fromPartial(object: DeepPartial<ListServiceConfigsRequest>): ListServiceConfigsRequest;
    fromSDK(object: ListServiceConfigsRequestSDKType): ListServiceConfigsRequest;
    fromSDKJSON(object: any): ListServiceConfigsRequestSDKType;
    toSDK(message: ListServiceConfigsRequest): ListServiceConfigsRequestSDKType;
    fromAmino(object: ListServiceConfigsRequestAmino): ListServiceConfigsRequest;
    toAmino(message: ListServiceConfigsRequest): ListServiceConfigsRequestAmino;
    fromAminoMsg(object: ListServiceConfigsRequestAminoMsg): ListServiceConfigsRequest;
    fromProtoMsg(message: ListServiceConfigsRequestProtoMsg): ListServiceConfigsRequest;
    toProto(message: ListServiceConfigsRequest): Uint8Array;
    toProtoMsg(message: ListServiceConfigsRequest): ListServiceConfigsRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const ListServiceConfigsResponse: {
    typeUrl: string;
    is(o: any): o is ListServiceConfigsResponse;
    isSDK(o: any): o is ListServiceConfigsResponseSDKType;
    isAmino(o: any): o is ListServiceConfigsResponseAmino;
    encode(message: ListServiceConfigsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ListServiceConfigsResponse;
    fromJSON(object: any): ListServiceConfigsResponse;
    toJSON(message: ListServiceConfigsResponse): JsonSafe<ListServiceConfigsResponse>;
    fromPartial(object: DeepPartial<ListServiceConfigsResponse>): ListServiceConfigsResponse;
    fromSDK(object: ListServiceConfigsResponseSDKType): ListServiceConfigsResponse;
    fromSDKJSON(object: any): ListServiceConfigsResponseSDKType;
    toSDK(message: ListServiceConfigsResponse): ListServiceConfigsResponseSDKType;
    fromAmino(object: ListServiceConfigsResponseAmino): ListServiceConfigsResponse;
    toAmino(message: ListServiceConfigsResponse): ListServiceConfigsResponseAmino;
    fromAminoMsg(object: ListServiceConfigsResponseAminoMsg): ListServiceConfigsResponse;
    fromProtoMsg(message: ListServiceConfigsResponseProtoMsg): ListServiceConfigsResponse;
    toProto(message: ListServiceConfigsResponse): Uint8Array;
    toProtoMsg(message: ListServiceConfigsResponse): ListServiceConfigsResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const CreateServiceConfigRequest: {
    typeUrl: string;
    is(o: any): o is CreateServiceConfigRequest;
    isSDK(o: any): o is CreateServiceConfigRequestSDKType;
    isAmino(o: any): o is CreateServiceConfigRequestAmino;
    encode(message: CreateServiceConfigRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): CreateServiceConfigRequest;
    fromJSON(object: any): CreateServiceConfigRequest;
    toJSON(message: CreateServiceConfigRequest): JsonSafe<CreateServiceConfigRequest>;
    fromPartial(object: DeepPartial<CreateServiceConfigRequest>): CreateServiceConfigRequest;
    fromSDK(object: CreateServiceConfigRequestSDKType): CreateServiceConfigRequest;
    fromSDKJSON(object: any): CreateServiceConfigRequestSDKType;
    toSDK(message: CreateServiceConfigRequest): CreateServiceConfigRequestSDKType;
    fromAmino(object: CreateServiceConfigRequestAmino): CreateServiceConfigRequest;
    toAmino(message: CreateServiceConfigRequest): CreateServiceConfigRequestAmino;
    fromAminoMsg(object: CreateServiceConfigRequestAminoMsg): CreateServiceConfigRequest;
    fromProtoMsg(message: CreateServiceConfigRequestProtoMsg): CreateServiceConfigRequest;
    toProto(message: CreateServiceConfigRequest): Uint8Array;
    toProtoMsg(message: CreateServiceConfigRequest): CreateServiceConfigRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const SubmitConfigSourceRequest: {
    typeUrl: string;
    is(o: any): o is SubmitConfigSourceRequest;
    isSDK(o: any): o is SubmitConfigSourceRequestSDKType;
    isAmino(o: any): o is SubmitConfigSourceRequestAmino;
    encode(message: SubmitConfigSourceRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): SubmitConfigSourceRequest;
    fromJSON(object: any): SubmitConfigSourceRequest;
    toJSON(message: SubmitConfigSourceRequest): JsonSafe<SubmitConfigSourceRequest>;
    fromPartial(object: DeepPartial<SubmitConfigSourceRequest>): SubmitConfigSourceRequest;
    fromSDK(object: SubmitConfigSourceRequestSDKType): SubmitConfigSourceRequest;
    fromSDKJSON(object: any): SubmitConfigSourceRequestSDKType;
    toSDK(message: SubmitConfigSourceRequest): SubmitConfigSourceRequestSDKType;
    fromAmino(object: SubmitConfigSourceRequestAmino): SubmitConfigSourceRequest;
    toAmino(message: SubmitConfigSourceRequest): SubmitConfigSourceRequestAmino;
    fromAminoMsg(object: SubmitConfigSourceRequestAminoMsg): SubmitConfigSourceRequest;
    fromProtoMsg(message: SubmitConfigSourceRequestProtoMsg): SubmitConfigSourceRequest;
    toProto(message: SubmitConfigSourceRequest): Uint8Array;
    toProtoMsg(message: SubmitConfigSourceRequest): SubmitConfigSourceRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const SubmitConfigSourceResponse: {
    typeUrl: string;
    is(o: any): o is SubmitConfigSourceResponse;
    isSDK(o: any): o is SubmitConfigSourceResponseSDKType;
    isAmino(o: any): o is SubmitConfigSourceResponseAmino;
    encode(message: SubmitConfigSourceResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): SubmitConfigSourceResponse;
    fromJSON(object: any): SubmitConfigSourceResponse;
    toJSON(message: SubmitConfigSourceResponse): JsonSafe<SubmitConfigSourceResponse>;
    fromPartial(object: DeepPartial<SubmitConfigSourceResponse>): SubmitConfigSourceResponse;
    fromSDK(object: SubmitConfigSourceResponseSDKType): SubmitConfigSourceResponse;
    fromSDKJSON(object: any): SubmitConfigSourceResponseSDKType;
    toSDK(message: SubmitConfigSourceResponse): SubmitConfigSourceResponseSDKType;
    fromAmino(object: SubmitConfigSourceResponseAmino): SubmitConfigSourceResponse;
    toAmino(message: SubmitConfigSourceResponse): SubmitConfigSourceResponseAmino;
    fromAminoMsg(object: SubmitConfigSourceResponseAminoMsg): SubmitConfigSourceResponse;
    fromProtoMsg(message: SubmitConfigSourceResponseProtoMsg): SubmitConfigSourceResponse;
    toProto(message: SubmitConfigSourceResponse): Uint8Array;
    toProtoMsg(message: SubmitConfigSourceResponse): SubmitConfigSourceResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const CreateServiceRolloutRequest: {
    typeUrl: string;
    is(o: any): o is CreateServiceRolloutRequest;
    isSDK(o: any): o is CreateServiceRolloutRequestSDKType;
    isAmino(o: any): o is CreateServiceRolloutRequestAmino;
    encode(message: CreateServiceRolloutRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): CreateServiceRolloutRequest;
    fromJSON(object: any): CreateServiceRolloutRequest;
    toJSON(message: CreateServiceRolloutRequest): JsonSafe<CreateServiceRolloutRequest>;
    fromPartial(object: DeepPartial<CreateServiceRolloutRequest>): CreateServiceRolloutRequest;
    fromSDK(object: CreateServiceRolloutRequestSDKType): CreateServiceRolloutRequest;
    fromSDKJSON(object: any): CreateServiceRolloutRequestSDKType;
    toSDK(message: CreateServiceRolloutRequest): CreateServiceRolloutRequestSDKType;
    fromAmino(object: CreateServiceRolloutRequestAmino): CreateServiceRolloutRequest;
    toAmino(message: CreateServiceRolloutRequest): CreateServiceRolloutRequestAmino;
    fromAminoMsg(object: CreateServiceRolloutRequestAminoMsg): CreateServiceRolloutRequest;
    fromProtoMsg(message: CreateServiceRolloutRequestProtoMsg): CreateServiceRolloutRequest;
    toProto(message: CreateServiceRolloutRequest): Uint8Array;
    toProtoMsg(message: CreateServiceRolloutRequest): CreateServiceRolloutRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const ListServiceRolloutsRequest: {
    typeUrl: string;
    is(o: any): o is ListServiceRolloutsRequest;
    isSDK(o: any): o is ListServiceRolloutsRequestSDKType;
    isAmino(o: any): o is ListServiceRolloutsRequestAmino;
    encode(message: ListServiceRolloutsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ListServiceRolloutsRequest;
    fromJSON(object: any): ListServiceRolloutsRequest;
    toJSON(message: ListServiceRolloutsRequest): JsonSafe<ListServiceRolloutsRequest>;
    fromPartial(object: DeepPartial<ListServiceRolloutsRequest>): ListServiceRolloutsRequest;
    fromSDK(object: ListServiceRolloutsRequestSDKType): ListServiceRolloutsRequest;
    fromSDKJSON(object: any): ListServiceRolloutsRequestSDKType;
    toSDK(message: ListServiceRolloutsRequest): ListServiceRolloutsRequestSDKType;
    fromAmino(object: ListServiceRolloutsRequestAmino): ListServiceRolloutsRequest;
    toAmino(message: ListServiceRolloutsRequest): ListServiceRolloutsRequestAmino;
    fromAminoMsg(object: ListServiceRolloutsRequestAminoMsg): ListServiceRolloutsRequest;
    fromProtoMsg(message: ListServiceRolloutsRequestProtoMsg): ListServiceRolloutsRequest;
    toProto(message: ListServiceRolloutsRequest): Uint8Array;
    toProtoMsg(message: ListServiceRolloutsRequest): ListServiceRolloutsRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const ListServiceRolloutsResponse: {
    typeUrl: string;
    is(o: any): o is ListServiceRolloutsResponse;
    isSDK(o: any): o is ListServiceRolloutsResponseSDKType;
    isAmino(o: any): o is ListServiceRolloutsResponseAmino;
    encode(message: ListServiceRolloutsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ListServiceRolloutsResponse;
    fromJSON(object: any): ListServiceRolloutsResponse;
    toJSON(message: ListServiceRolloutsResponse): JsonSafe<ListServiceRolloutsResponse>;
    fromPartial(object: DeepPartial<ListServiceRolloutsResponse>): ListServiceRolloutsResponse;
    fromSDK(object: ListServiceRolloutsResponseSDKType): ListServiceRolloutsResponse;
    fromSDKJSON(object: any): ListServiceRolloutsResponseSDKType;
    toSDK(message: ListServiceRolloutsResponse): ListServiceRolloutsResponseSDKType;
    fromAmino(object: ListServiceRolloutsResponseAmino): ListServiceRolloutsResponse;
    toAmino(message: ListServiceRolloutsResponse): ListServiceRolloutsResponseAmino;
    fromAminoMsg(object: ListServiceRolloutsResponseAminoMsg): ListServiceRolloutsResponse;
    fromProtoMsg(message: ListServiceRolloutsResponseProtoMsg): ListServiceRolloutsResponse;
    toProto(message: ListServiceRolloutsResponse): Uint8Array;
    toProtoMsg(message: ListServiceRolloutsResponse): ListServiceRolloutsResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const GetServiceRolloutRequest: {
    typeUrl: string;
    is(o: any): o is GetServiceRolloutRequest;
    isSDK(o: any): o is GetServiceRolloutRequestSDKType;
    isAmino(o: any): o is GetServiceRolloutRequestAmino;
    encode(message: GetServiceRolloutRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GetServiceRolloutRequest;
    fromJSON(object: any): GetServiceRolloutRequest;
    toJSON(message: GetServiceRolloutRequest): JsonSafe<GetServiceRolloutRequest>;
    fromPartial(object: DeepPartial<GetServiceRolloutRequest>): GetServiceRolloutRequest;
    fromSDK(object: GetServiceRolloutRequestSDKType): GetServiceRolloutRequest;
    fromSDKJSON(object: any): GetServiceRolloutRequestSDKType;
    toSDK(message: GetServiceRolloutRequest): GetServiceRolloutRequestSDKType;
    fromAmino(object: GetServiceRolloutRequestAmino): GetServiceRolloutRequest;
    toAmino(message: GetServiceRolloutRequest): GetServiceRolloutRequestAmino;
    fromAminoMsg(object: GetServiceRolloutRequestAminoMsg): GetServiceRolloutRequest;
    fromProtoMsg(message: GetServiceRolloutRequestProtoMsg): GetServiceRolloutRequest;
    toProto(message: GetServiceRolloutRequest): Uint8Array;
    toProtoMsg(message: GetServiceRolloutRequest): GetServiceRolloutRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const GenerateConfigReportRequest: {
    typeUrl: string;
    is(o: any): o is GenerateConfigReportRequest;
    isSDK(o: any): o is GenerateConfigReportRequestSDKType;
    isAmino(o: any): o is GenerateConfigReportRequestAmino;
    encode(message: GenerateConfigReportRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GenerateConfigReportRequest;
    fromJSON(object: any): GenerateConfigReportRequest;
    toJSON(message: GenerateConfigReportRequest): JsonSafe<GenerateConfigReportRequest>;
    fromPartial(object: DeepPartial<GenerateConfigReportRequest>): GenerateConfigReportRequest;
    fromSDK(object: GenerateConfigReportRequestSDKType): GenerateConfigReportRequest;
    fromSDKJSON(object: any): GenerateConfigReportRequestSDKType;
    toSDK(message: GenerateConfigReportRequest): GenerateConfigReportRequestSDKType;
    fromAmino(object: GenerateConfigReportRequestAmino): GenerateConfigReportRequest;
    toAmino(message: GenerateConfigReportRequest): GenerateConfigReportRequestAmino;
    fromAminoMsg(object: GenerateConfigReportRequestAminoMsg): GenerateConfigReportRequest;
    fromProtoMsg(message: GenerateConfigReportRequestProtoMsg): GenerateConfigReportRequest;
    toProto(message: GenerateConfigReportRequest): Uint8Array;
    toProtoMsg(message: GenerateConfigReportRequest): GenerateConfigReportRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const GenerateConfigReportResponse: {
    typeUrl: string;
    is(o: any): o is GenerateConfigReportResponse;
    isSDK(o: any): o is GenerateConfigReportResponseSDKType;
    isAmino(o: any): o is GenerateConfigReportResponseAmino;
    encode(message: GenerateConfigReportResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GenerateConfigReportResponse;
    fromJSON(object: any): GenerateConfigReportResponse;
    toJSON(message: GenerateConfigReportResponse): JsonSafe<GenerateConfigReportResponse>;
    fromPartial(object: DeepPartial<GenerateConfigReportResponse>): GenerateConfigReportResponse;
    fromSDK(object: GenerateConfigReportResponseSDKType): GenerateConfigReportResponse;
    fromSDKJSON(object: any): GenerateConfigReportResponseSDKType;
    toSDK(message: GenerateConfigReportResponse): GenerateConfigReportResponseSDKType;
    fromAmino(object: GenerateConfigReportResponseAmino): GenerateConfigReportResponse;
    toAmino(message: GenerateConfigReportResponse): GenerateConfigReportResponseAmino;
    fromAminoMsg(object: GenerateConfigReportResponseAminoMsg): GenerateConfigReportResponse;
    fromProtoMsg(message: GenerateConfigReportResponseProtoMsg): GenerateConfigReportResponse;
    toProto(message: GenerateConfigReportResponse): Uint8Array;
    toProtoMsg(message: GenerateConfigReportResponse): GenerateConfigReportResponseProtoMsg;
    registerTypeUrl(): void;
};
