import { QuotaView, QuotaOverride, QuotaOverrideAmino, QuotaOverrideSDKType, QuotaSafetyCheck, OverrideInlineSource, OverrideInlineSourceAmino, OverrideInlineSourceSDKType, Service, ServiceAmino, ServiceSDKType, ConsumerQuotaMetric, ConsumerQuotaMetricAmino, ConsumerQuotaMetricSDKType, AdminQuotaPolicy, AdminQuotaPolicyAmino, AdminQuotaPolicySDKType, ServiceIdentity, ServiceIdentityAmino, ServiceIdentitySDKType } from "./resources";
import { FieldMask, FieldMaskAmino, FieldMaskSDKType } from "../../../protobuf/field_mask";
import { BinaryReader, BinaryWriter } from "../../../../binary";
import { DeepPartial } from "../../../../helpers";
import { JsonSafe } from "../../../../json-safe";
export declare const protobufPackage = "google.api.serviceusage.v1beta1";
/** Enum for service identity state. */
export declare enum GetServiceIdentityResponse_IdentityState {
    /**
     * IDENTITY_STATE_UNSPECIFIED - Default service identity state. This value is used if the state is
     * omitted.
     */
    IDENTITY_STATE_UNSPECIFIED = 0,
    /** ACTIVE - Service identity has been created and can be used. */
    ACTIVE = 1,
    UNRECOGNIZED = -1
}
export declare const GetServiceIdentityResponse_IdentityStateSDKType: typeof GetServiceIdentityResponse_IdentityState;
export declare const GetServiceIdentityResponse_IdentityStateAmino: typeof GetServiceIdentityResponse_IdentityState;
export declare function getServiceIdentityResponse_IdentityStateFromJSON(object: any): GetServiceIdentityResponse_IdentityState;
export declare function getServiceIdentityResponse_IdentityStateToJSON(object: GetServiceIdentityResponse_IdentityState): string;
/** Request message for the `EnableService` method. */
export interface EnableServiceRequest {
    /**
     * Name of the consumer and service to enable the service on.
     *
     * The `EnableService` and `DisableService` methods currently only support
     * projects.
     *
     * Enabling a service requires that the service is public or is shared with
     * the user enabling the service.
     *
     * An example name would be:
     * `projects/123/services/serviceusage.googleapis.com`
     * where `123` is the project number (not project ID).
     */
    name: string;
}
export interface EnableServiceRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.EnableServiceRequest";
    value: Uint8Array;
}
/** Request message for the `EnableService` method. */
export interface EnableServiceRequestAmino {
    /**
     * Name of the consumer and service to enable the service on.
     *
     * The `EnableService` and `DisableService` methods currently only support
     * projects.
     *
     * Enabling a service requires that the service is public or is shared with
     * the user enabling the service.
     *
     * An example name would be:
     * `projects/123/services/serviceusage.googleapis.com`
     * where `123` is the project number (not project ID).
     */
    name?: string;
}
export interface EnableServiceRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.EnableServiceRequest";
    value: EnableServiceRequestAmino;
}
/** Request message for the `EnableService` method. */
export interface EnableServiceRequestSDKType {
    name: string;
}
/** Request message for the `DisableService` method. */
export interface DisableServiceRequest {
    /**
     * Name of the consumer and service to disable the service on.
     *
     * The enable and disable methods currently only support projects.
     *
     * An example name would be:
     * `projects/123/services/serviceusage.googleapis.com`
     * where `123` is the project number (not project ID).
     */
    name: string;
}
export interface DisableServiceRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.DisableServiceRequest";
    value: Uint8Array;
}
/** Request message for the `DisableService` method. */
export interface DisableServiceRequestAmino {
    /**
     * Name of the consumer and service to disable the service on.
     *
     * The enable and disable methods currently only support projects.
     *
     * An example name would be:
     * `projects/123/services/serviceusage.googleapis.com`
     * where `123` is the project number (not project ID).
     */
    name?: string;
}
export interface DisableServiceRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.DisableServiceRequest";
    value: DisableServiceRequestAmino;
}
/** Request message for the `DisableService` method. */
export interface DisableServiceRequestSDKType {
    name: string;
}
/** Request message for the `GetService` method. */
export interface GetServiceRequest {
    /**
     * Name of the consumer and service to get the `ConsumerState` for.
     *
     * An example name would be:
     * `projects/123/services/serviceusage.googleapis.com`
     * where `123` is the project number (not project ID).
     */
    name: string;
}
export interface GetServiceRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.GetServiceRequest";
    value: Uint8Array;
}
/** Request message for the `GetService` method. */
export interface GetServiceRequestAmino {
    /**
     * Name of the consumer and service to get the `ConsumerState` for.
     *
     * An example name would be:
     * `projects/123/services/serviceusage.googleapis.com`
     * where `123` is the project number (not project ID).
     */
    name?: string;
}
export interface GetServiceRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.GetServiceRequest";
    value: GetServiceRequestAmino;
}
/** Request message for the `GetService` method. */
export interface GetServiceRequestSDKType {
    name: string;
}
/** Request message for the `ListServices` method. */
export interface ListServicesRequest {
    /**
     * Parent to search for services on.
     *
     * An example name would be:
     * `projects/123`
     * where `123` is the project number (not project ID).
     */
    parent: string;
    /**
     * Requested size of the next page of data.
     * Requested page size cannot exceed 200.
     *  If not set, the default page size is 50.
     */
    pageSize: number;
    /**
     * Token identifying which result to start with, which is returned by a
     * previous list call.
     */
    pageToken: string;
    /**
     * Only list services that conform to the given filter.
     * The allowed filter strings are `state:ENABLED` and `state:DISABLED`.
     */
    filter: string;
}
export interface ListServicesRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ListServicesRequest";
    value: Uint8Array;
}
/** Request message for the `ListServices` method. */
export interface ListServicesRequestAmino {
    /**
     * Parent to search for services on.
     *
     * An example name would be:
     * `projects/123`
     * where `123` is the project number (not project ID).
     */
    parent?: string;
    /**
     * Requested size of the next page of data.
     * Requested page size cannot exceed 200.
     *  If not set, the default page size is 50.
     */
    page_size?: number;
    /**
     * Token identifying which result to start with, which is returned by a
     * previous list call.
     */
    page_token?: string;
    /**
     * Only list services that conform to the given filter.
     * The allowed filter strings are `state:ENABLED` and `state:DISABLED`.
     */
    filter?: string;
}
export interface ListServicesRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ListServicesRequest";
    value: ListServicesRequestAmino;
}
/** Request message for the `ListServices` method. */
export interface ListServicesRequestSDKType {
    parent: string;
    page_size: number;
    page_token: string;
    filter: string;
}
/** Response message for the `ListServices` method. */
export interface ListServicesResponse {
    /** The available services for the requested project. */
    services: Service[];
    /**
     * Token that can be passed to `ListServices` to resume a paginated
     * query.
     */
    nextPageToken: string;
}
export interface ListServicesResponseProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ListServicesResponse";
    value: Uint8Array;
}
/** Response message for the `ListServices` method. */
export interface ListServicesResponseAmino {
    /** The available services for the requested project. */
    services?: ServiceAmino[];
    /**
     * Token that can be passed to `ListServices` to resume a paginated
     * query.
     */
    next_page_token?: string;
}
export interface ListServicesResponseAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ListServicesResponse";
    value: ListServicesResponseAmino;
}
/** Response message for the `ListServices` method. */
export interface ListServicesResponseSDKType {
    services: ServiceSDKType[];
    next_page_token: string;
}
/** Request message for the `BatchEnableServices` method. */
export interface BatchEnableServicesRequest {
    /**
     * Parent to enable services on.
     *
     * An example name would be:
     * `projects/123`
     * where `123` is the project number (not project ID).
     *
     * The `BatchEnableServices` method currently only supports projects.
     */
    parent: string;
    /**
     * The identifiers of the services to enable on the project.
     *
     * A valid identifier would be:
     * serviceusage.googleapis.com
     *
     * Enabling services requires that each service is public or is shared with
     * the user enabling the service.
     *
     * Two or more services must be specified. To enable a single service,
     * use the `EnableService` method instead.
     *
     * A single request can enable a maximum of 20 services at a time. If more
     * than 20 services are specified, the request will fail, and no state changes
     * will occur.
     */
    serviceIds: string[];
}
export interface BatchEnableServicesRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.BatchEnableServicesRequest";
    value: Uint8Array;
}
/** Request message for the `BatchEnableServices` method. */
export interface BatchEnableServicesRequestAmino {
    /**
     * Parent to enable services on.
     *
     * An example name would be:
     * `projects/123`
     * where `123` is the project number (not project ID).
     *
     * The `BatchEnableServices` method currently only supports projects.
     */
    parent?: string;
    /**
     * The identifiers of the services to enable on the project.
     *
     * A valid identifier would be:
     * serviceusage.googleapis.com
     *
     * Enabling services requires that each service is public or is shared with
     * the user enabling the service.
     *
     * Two or more services must be specified. To enable a single service,
     * use the `EnableService` method instead.
     *
     * A single request can enable a maximum of 20 services at a time. If more
     * than 20 services are specified, the request will fail, and no state changes
     * will occur.
     */
    service_ids?: string[];
}
export interface BatchEnableServicesRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.BatchEnableServicesRequest";
    value: BatchEnableServicesRequestAmino;
}
/** Request message for the `BatchEnableServices` method. */
export interface BatchEnableServicesRequestSDKType {
    parent: string;
    service_ids: string[];
}
/** Request message for ListConsumerQuotaMetrics */
export interface ListConsumerQuotaMetricsRequest {
    /**
     * Parent of the quotas resource.
     *
     * Some example names would be:
     * `projects/123/services/serviceconsumermanagement.googleapis.com`
     * `folders/345/services/serviceconsumermanagement.googleapis.com`
     * `organizations/456/services/serviceconsumermanagement.googleapis.com`
     */
    parent: string;
    /** Requested size of the next page of data. */
    pageSize: number;
    /**
     * Token identifying which result to start with; returned by a previous list
     * call.
     */
    pageToken: string;
    /** Specifies the level of detail for quota information in the response. */
    view: QuotaView;
}
export interface ListConsumerQuotaMetricsRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ListConsumerQuotaMetricsRequest";
    value: Uint8Array;
}
/** Request message for ListConsumerQuotaMetrics */
export interface ListConsumerQuotaMetricsRequestAmino {
    /**
     * Parent of the quotas resource.
     *
     * Some example names would be:
     * `projects/123/services/serviceconsumermanagement.googleapis.com`
     * `folders/345/services/serviceconsumermanagement.googleapis.com`
     * `organizations/456/services/serviceconsumermanagement.googleapis.com`
     */
    parent?: string;
    /** Requested size of the next page of data. */
    page_size?: number;
    /**
     * Token identifying which result to start with; returned by a previous list
     * call.
     */
    page_token?: string;
    /** Specifies the level of detail for quota information in the response. */
    view?: QuotaView;
}
export interface ListConsumerQuotaMetricsRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ListConsumerQuotaMetricsRequest";
    value: ListConsumerQuotaMetricsRequestAmino;
}
/** Request message for ListConsumerQuotaMetrics */
export interface ListConsumerQuotaMetricsRequestSDKType {
    parent: string;
    page_size: number;
    page_token: string;
    view: QuotaView;
}
/** Response message for ListConsumerQuotaMetrics */
export interface ListConsumerQuotaMetricsResponse {
    /** Quota settings for the consumer, organized by quota metric. */
    metrics: ConsumerQuotaMetric[];
    /**
     * Token identifying which result to start with; returned by a previous list
     * call.
     */
    nextPageToken: string;
}
export interface ListConsumerQuotaMetricsResponseProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ListConsumerQuotaMetricsResponse";
    value: Uint8Array;
}
/** Response message for ListConsumerQuotaMetrics */
export interface ListConsumerQuotaMetricsResponseAmino {
    /** Quota settings for the consumer, organized by quota metric. */
    metrics?: ConsumerQuotaMetricAmino[];
    /**
     * Token identifying which result to start with; returned by a previous list
     * call.
     */
    next_page_token?: string;
}
export interface ListConsumerQuotaMetricsResponseAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ListConsumerQuotaMetricsResponse";
    value: ListConsumerQuotaMetricsResponseAmino;
}
/** Response message for ListConsumerQuotaMetrics */
export interface ListConsumerQuotaMetricsResponseSDKType {
    metrics: ConsumerQuotaMetricSDKType[];
    next_page_token: string;
}
/** Request message for GetConsumerQuotaMetric */
export interface GetConsumerQuotaMetricRequest {
    /**
     * The resource name of the quota limit.
     *
     * An example name would be:
     * `projects/123/services/serviceusage.googleapis.com/quotas/metrics/serviceusage.googleapis.com%2Fmutate_requests`
     */
    name: string;
    /** Specifies the level of detail for quota information in the response. */
    view: QuotaView;
}
export interface GetConsumerQuotaMetricRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.GetConsumerQuotaMetricRequest";
    value: Uint8Array;
}
/** Request message for GetConsumerQuotaMetric */
export interface GetConsumerQuotaMetricRequestAmino {
    /**
     * The resource name of the quota limit.
     *
     * An example name would be:
     * `projects/123/services/serviceusage.googleapis.com/quotas/metrics/serviceusage.googleapis.com%2Fmutate_requests`
     */
    name?: string;
    /** Specifies the level of detail for quota information in the response. */
    view?: QuotaView;
}
export interface GetConsumerQuotaMetricRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.GetConsumerQuotaMetricRequest";
    value: GetConsumerQuotaMetricRequestAmino;
}
/** Request message for GetConsumerQuotaMetric */
export interface GetConsumerQuotaMetricRequestSDKType {
    name: string;
    view: QuotaView;
}
/** Request message for GetConsumerQuotaLimit */
export interface GetConsumerQuotaLimitRequest {
    /**
     * The resource name of the quota limit.
     *
     * Use the quota limit resource name returned by previous
     * ListConsumerQuotaMetrics and GetConsumerQuotaMetric API calls.
     */
    name: string;
    /** Specifies the level of detail for quota information in the response. */
    view: QuotaView;
}
export interface GetConsumerQuotaLimitRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.GetConsumerQuotaLimitRequest";
    value: Uint8Array;
}
/** Request message for GetConsumerQuotaLimit */
export interface GetConsumerQuotaLimitRequestAmino {
    /**
     * The resource name of the quota limit.
     *
     * Use the quota limit resource name returned by previous
     * ListConsumerQuotaMetrics and GetConsumerQuotaMetric API calls.
     */
    name?: string;
    /** Specifies the level of detail for quota information in the response. */
    view?: QuotaView;
}
export interface GetConsumerQuotaLimitRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.GetConsumerQuotaLimitRequest";
    value: GetConsumerQuotaLimitRequestAmino;
}
/** Request message for GetConsumerQuotaLimit */
export interface GetConsumerQuotaLimitRequestSDKType {
    name: string;
    view: QuotaView;
}
/** Request message for CreateAdminOverride. */
export interface CreateAdminOverrideRequest {
    /**
     * The resource name of the parent quota limit, returned by a
     * ListConsumerQuotaMetrics or GetConsumerQuotaMetric call.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion`
     */
    parent: string;
    /** The admin override to create. */
    override?: QuotaOverride;
    /**
     * Whether to force the creation of the quota override.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force: boolean;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    forceOnly: QuotaSafetyCheck[];
}
export interface CreateAdminOverrideRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.CreateAdminOverrideRequest";
    value: Uint8Array;
}
/** Request message for CreateAdminOverride. */
export interface CreateAdminOverrideRequestAmino {
    /**
     * The resource name of the parent quota limit, returned by a
     * ListConsumerQuotaMetrics or GetConsumerQuotaMetric call.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion`
     */
    parent?: string;
    /** The admin override to create. */
    override?: QuotaOverrideAmino;
    /**
     * Whether to force the creation of the quota override.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force?: boolean;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    force_only?: QuotaSafetyCheck[];
}
export interface CreateAdminOverrideRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.CreateAdminOverrideRequest";
    value: CreateAdminOverrideRequestAmino;
}
/** Request message for CreateAdminOverride. */
export interface CreateAdminOverrideRequestSDKType {
    parent: string;
    override?: QuotaOverrideSDKType;
    force: boolean;
    force_only: QuotaSafetyCheck[];
}
/** Request message for UpdateAdminOverride. */
export interface UpdateAdminOverrideRequest {
    /**
     * The resource name of the override to update.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion/adminOverrides/4a3f2c1d`
     */
    name: string;
    /**
     * The new override.
     * Only the override_value is updated; all other fields are ignored.
     */
    override?: QuotaOverride;
    /**
     * Whether to force the update of the quota override.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force: boolean;
    /**
     * Update only the specified fields of the override.
     * If unset, all fields will be updated.
     */
    updateMask?: FieldMask;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    forceOnly: QuotaSafetyCheck[];
}
export interface UpdateAdminOverrideRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.UpdateAdminOverrideRequest";
    value: Uint8Array;
}
/** Request message for UpdateAdminOverride. */
export interface UpdateAdminOverrideRequestAmino {
    /**
     * The resource name of the override to update.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion/adminOverrides/4a3f2c1d`
     */
    name?: string;
    /**
     * The new override.
     * Only the override_value is updated; all other fields are ignored.
     */
    override?: QuotaOverrideAmino;
    /**
     * Whether to force the update of the quota override.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force?: boolean;
    /**
     * Update only the specified fields of the override.
     * If unset, all fields will be updated.
     */
    update_mask?: FieldMaskAmino;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    force_only?: QuotaSafetyCheck[];
}
export interface UpdateAdminOverrideRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.UpdateAdminOverrideRequest";
    value: UpdateAdminOverrideRequestAmino;
}
/** Request message for UpdateAdminOverride. */
export interface UpdateAdminOverrideRequestSDKType {
    name: string;
    override?: QuotaOverrideSDKType;
    force: boolean;
    update_mask?: FieldMaskSDKType;
    force_only: QuotaSafetyCheck[];
}
/** Request message for DeleteAdminOverride. */
export interface DeleteAdminOverrideRequest {
    /**
     * The resource name of the override to delete.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion/adminOverrides/4a3f2c1d`
     */
    name: string;
    /**
     * Whether to force the deletion of the quota override.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force: boolean;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    forceOnly: QuotaSafetyCheck[];
}
export interface DeleteAdminOverrideRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.DeleteAdminOverrideRequest";
    value: Uint8Array;
}
/** Request message for DeleteAdminOverride. */
export interface DeleteAdminOverrideRequestAmino {
    /**
     * The resource name of the override to delete.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion/adminOverrides/4a3f2c1d`
     */
    name?: string;
    /**
     * Whether to force the deletion of the quota override.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force?: boolean;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    force_only?: QuotaSafetyCheck[];
}
export interface DeleteAdminOverrideRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.DeleteAdminOverrideRequest";
    value: DeleteAdminOverrideRequestAmino;
}
/** Request message for DeleteAdminOverride. */
export interface DeleteAdminOverrideRequestSDKType {
    name: string;
    force: boolean;
    force_only: QuotaSafetyCheck[];
}
/** Request message for ListAdminOverrides */
export interface ListAdminOverridesRequest {
    /**
     * The resource name of the parent quota limit, returned by a
     * ListConsumerQuotaMetrics or GetConsumerQuotaMetric call.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion`
     */
    parent: string;
    /** Requested size of the next page of data. */
    pageSize: number;
    /**
     * Token identifying which result to start with; returned by a previous list
     * call.
     */
    pageToken: string;
}
export interface ListAdminOverridesRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ListAdminOverridesRequest";
    value: Uint8Array;
}
/** Request message for ListAdminOverrides */
export interface ListAdminOverridesRequestAmino {
    /**
     * The resource name of the parent quota limit, returned by a
     * ListConsumerQuotaMetrics or GetConsumerQuotaMetric call.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion`
     */
    parent?: string;
    /** Requested size of the next page of data. */
    page_size?: number;
    /**
     * Token identifying which result to start with; returned by a previous list
     * call.
     */
    page_token?: string;
}
export interface ListAdminOverridesRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ListAdminOverridesRequest";
    value: ListAdminOverridesRequestAmino;
}
/** Request message for ListAdminOverrides */
export interface ListAdminOverridesRequestSDKType {
    parent: string;
    page_size: number;
    page_token: string;
}
/** Response message for ListAdminOverrides. */
export interface ListAdminOverridesResponse {
    /** Admin overrides on this limit. */
    overrides: QuotaOverride[];
    /**
     * Token identifying which result to start with; returned by a previous list
     * call.
     */
    nextPageToken: string;
}
export interface ListAdminOverridesResponseProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ListAdminOverridesResponse";
    value: Uint8Array;
}
/** Response message for ListAdminOverrides. */
export interface ListAdminOverridesResponseAmino {
    /** Admin overrides on this limit. */
    overrides?: QuotaOverrideAmino[];
    /**
     * Token identifying which result to start with; returned by a previous list
     * call.
     */
    next_page_token?: string;
}
export interface ListAdminOverridesResponseAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ListAdminOverridesResponse";
    value: ListAdminOverridesResponseAmino;
}
/** Response message for ListAdminOverrides. */
export interface ListAdminOverridesResponseSDKType {
    overrides: QuotaOverrideSDKType[];
    next_page_token: string;
}
/** Response message for BatchCreateAdminOverrides */
export interface BatchCreateAdminOverridesResponse {
    /** The overrides that were created. */
    overrides: QuotaOverride[];
}
export interface BatchCreateAdminOverridesResponseProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.BatchCreateAdminOverridesResponse";
    value: Uint8Array;
}
/** Response message for BatchCreateAdminOverrides */
export interface BatchCreateAdminOverridesResponseAmino {
    /** The overrides that were created. */
    overrides?: QuotaOverrideAmino[];
}
export interface BatchCreateAdminOverridesResponseAminoMsg {
    type: "/google.api.serviceusage.v1beta1.BatchCreateAdminOverridesResponse";
    value: BatchCreateAdminOverridesResponseAmino;
}
/** Response message for BatchCreateAdminOverrides */
export interface BatchCreateAdminOverridesResponseSDKType {
    overrides: QuotaOverrideSDKType[];
}
/** Request message for ImportAdminOverrides */
export interface ImportAdminOverridesRequest {
    /**
     * The resource name of the consumer.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com`
     */
    parent: string;
    /** The import data is specified in the request message itself */
    inlineSource?: OverrideInlineSource;
    /**
     * Whether to force the creation of the quota overrides.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force: boolean;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    forceOnly: QuotaSafetyCheck[];
}
export interface ImportAdminOverridesRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportAdminOverridesRequest";
    value: Uint8Array;
}
/** Request message for ImportAdminOverrides */
export interface ImportAdminOverridesRequestAmino {
    /**
     * The resource name of the consumer.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com`
     */
    parent?: string;
    /** The import data is specified in the request message itself */
    inline_source?: OverrideInlineSourceAmino;
    /**
     * Whether to force the creation of the quota overrides.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force?: boolean;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    force_only?: QuotaSafetyCheck[];
}
export interface ImportAdminOverridesRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ImportAdminOverridesRequest";
    value: ImportAdminOverridesRequestAmino;
}
/** Request message for ImportAdminOverrides */
export interface ImportAdminOverridesRequestSDKType {
    parent: string;
    inline_source?: OverrideInlineSourceSDKType;
    force: boolean;
    force_only: QuotaSafetyCheck[];
}
/** Response message for ImportAdminOverrides */
export interface ImportAdminOverridesResponse {
    /** The overrides that were created from the imported data. */
    overrides: QuotaOverride[];
}
export interface ImportAdminOverridesResponseProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportAdminOverridesResponse";
    value: Uint8Array;
}
/** Response message for ImportAdminOverrides */
export interface ImportAdminOverridesResponseAmino {
    /** The overrides that were created from the imported data. */
    overrides?: QuotaOverrideAmino[];
}
export interface ImportAdminOverridesResponseAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ImportAdminOverridesResponse";
    value: ImportAdminOverridesResponseAmino;
}
/** Response message for ImportAdminOverrides */
export interface ImportAdminOverridesResponseSDKType {
    overrides: QuotaOverrideSDKType[];
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by ImportAdminOverrides.
 */
export interface ImportAdminOverridesMetadata {
}
export interface ImportAdminOverridesMetadataProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportAdminOverridesMetadata";
    value: Uint8Array;
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by ImportAdminOverrides.
 */
export interface ImportAdminOverridesMetadataAmino {
}
export interface ImportAdminOverridesMetadataAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ImportAdminOverridesMetadata";
    value: ImportAdminOverridesMetadataAmino;
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by ImportAdminOverrides.
 */
export interface ImportAdminOverridesMetadataSDKType {
}
/** Request message for CreateConsumerOverride. */
export interface CreateConsumerOverrideRequest {
    /**
     * The resource name of the parent quota limit, returned by a
     * ListConsumerQuotaMetrics or GetConsumerQuotaMetric call.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion`
     */
    parent: string;
    /** The override to create. */
    override?: QuotaOverride;
    /**
     * Whether to force the creation of the quota override.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force: boolean;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    forceOnly: QuotaSafetyCheck[];
}
export interface CreateConsumerOverrideRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.CreateConsumerOverrideRequest";
    value: Uint8Array;
}
/** Request message for CreateConsumerOverride. */
export interface CreateConsumerOverrideRequestAmino {
    /**
     * The resource name of the parent quota limit, returned by a
     * ListConsumerQuotaMetrics or GetConsumerQuotaMetric call.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion`
     */
    parent?: string;
    /** The override to create. */
    override?: QuotaOverrideAmino;
    /**
     * Whether to force the creation of the quota override.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force?: boolean;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    force_only?: QuotaSafetyCheck[];
}
export interface CreateConsumerOverrideRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.CreateConsumerOverrideRequest";
    value: CreateConsumerOverrideRequestAmino;
}
/** Request message for CreateConsumerOverride. */
export interface CreateConsumerOverrideRequestSDKType {
    parent: string;
    override?: QuotaOverrideSDKType;
    force: boolean;
    force_only: QuotaSafetyCheck[];
}
/** Request message for UpdateConsumerOverride. */
export interface UpdateConsumerOverrideRequest {
    /**
     * The resource name of the override to update.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion/consumerOverrides/4a3f2c1d`
     */
    name: string;
    /**
     * The new override.
     * Only the override_value is updated; all other fields are ignored.
     */
    override?: QuotaOverride;
    /**
     * Whether to force the update of the quota override.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force: boolean;
    /**
     * Update only the specified fields of the override.
     * If unset, all fields will be updated.
     */
    updateMask?: FieldMask;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    forceOnly: QuotaSafetyCheck[];
}
export interface UpdateConsumerOverrideRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.UpdateConsumerOverrideRequest";
    value: Uint8Array;
}
/** Request message for UpdateConsumerOverride. */
export interface UpdateConsumerOverrideRequestAmino {
    /**
     * The resource name of the override to update.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion/consumerOverrides/4a3f2c1d`
     */
    name?: string;
    /**
     * The new override.
     * Only the override_value is updated; all other fields are ignored.
     */
    override?: QuotaOverrideAmino;
    /**
     * Whether to force the update of the quota override.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force?: boolean;
    /**
     * Update only the specified fields of the override.
     * If unset, all fields will be updated.
     */
    update_mask?: FieldMaskAmino;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    force_only?: QuotaSafetyCheck[];
}
export interface UpdateConsumerOverrideRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.UpdateConsumerOverrideRequest";
    value: UpdateConsumerOverrideRequestAmino;
}
/** Request message for UpdateConsumerOverride. */
export interface UpdateConsumerOverrideRequestSDKType {
    name: string;
    override?: QuotaOverrideSDKType;
    force: boolean;
    update_mask?: FieldMaskSDKType;
    force_only: QuotaSafetyCheck[];
}
/** Request message for DeleteConsumerOverride. */
export interface DeleteConsumerOverrideRequest {
    /**
     * The resource name of the override to delete.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion/consumerOverrides/4a3f2c1d`
     */
    name: string;
    /**
     * Whether to force the deletion of the quota override.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force: boolean;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    forceOnly: QuotaSafetyCheck[];
}
export interface DeleteConsumerOverrideRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.DeleteConsumerOverrideRequest";
    value: Uint8Array;
}
/** Request message for DeleteConsumerOverride. */
export interface DeleteConsumerOverrideRequestAmino {
    /**
     * The resource name of the override to delete.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion/consumerOverrides/4a3f2c1d`
     */
    name?: string;
    /**
     * Whether to force the deletion of the quota override.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force?: boolean;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    force_only?: QuotaSafetyCheck[];
}
export interface DeleteConsumerOverrideRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.DeleteConsumerOverrideRequest";
    value: DeleteConsumerOverrideRequestAmino;
}
/** Request message for DeleteConsumerOverride. */
export interface DeleteConsumerOverrideRequestSDKType {
    name: string;
    force: boolean;
    force_only: QuotaSafetyCheck[];
}
/** Request message for ListConsumerOverrides */
export interface ListConsumerOverridesRequest {
    /**
     * The resource name of the parent quota limit, returned by a
     * ListConsumerQuotaMetrics or GetConsumerQuotaMetric call.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion`
     */
    parent: string;
    /** Requested size of the next page of data. */
    pageSize: number;
    /**
     * Token identifying which result to start with; returned by a previous list
     * call.
     */
    pageToken: string;
}
export interface ListConsumerOverridesRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ListConsumerOverridesRequest";
    value: Uint8Array;
}
/** Request message for ListConsumerOverrides */
export interface ListConsumerOverridesRequestAmino {
    /**
     * The resource name of the parent quota limit, returned by a
     * ListConsumerQuotaMetrics or GetConsumerQuotaMetric call.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com/consumerQuotaMetrics/compute.googleapis.com%2Fcpus/limits/%2Fproject%2Fregion`
     */
    parent?: string;
    /** Requested size of the next page of data. */
    page_size?: number;
    /**
     * Token identifying which result to start with; returned by a previous list
     * call.
     */
    page_token?: string;
}
export interface ListConsumerOverridesRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ListConsumerOverridesRequest";
    value: ListConsumerOverridesRequestAmino;
}
/** Request message for ListConsumerOverrides */
export interface ListConsumerOverridesRequestSDKType {
    parent: string;
    page_size: number;
    page_token: string;
}
/** Response message for ListConsumerOverrides. */
export interface ListConsumerOverridesResponse {
    /** Consumer overrides on this limit. */
    overrides: QuotaOverride[];
    /**
     * Token identifying which result to start with; returned by a previous list
     * call.
     */
    nextPageToken: string;
}
export interface ListConsumerOverridesResponseProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ListConsumerOverridesResponse";
    value: Uint8Array;
}
/** Response message for ListConsumerOverrides. */
export interface ListConsumerOverridesResponseAmino {
    /** Consumer overrides on this limit. */
    overrides?: QuotaOverrideAmino[];
    /**
     * Token identifying which result to start with; returned by a previous list
     * call.
     */
    next_page_token?: string;
}
export interface ListConsumerOverridesResponseAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ListConsumerOverridesResponse";
    value: ListConsumerOverridesResponseAmino;
}
/** Response message for ListConsumerOverrides. */
export interface ListConsumerOverridesResponseSDKType {
    overrides: QuotaOverrideSDKType[];
    next_page_token: string;
}
/** Response message for BatchCreateConsumerOverrides */
export interface BatchCreateConsumerOverridesResponse {
    /** The overrides that were created. */
    overrides: QuotaOverride[];
}
export interface BatchCreateConsumerOverridesResponseProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.BatchCreateConsumerOverridesResponse";
    value: Uint8Array;
}
/** Response message for BatchCreateConsumerOverrides */
export interface BatchCreateConsumerOverridesResponseAmino {
    /** The overrides that were created. */
    overrides?: QuotaOverrideAmino[];
}
export interface BatchCreateConsumerOverridesResponseAminoMsg {
    type: "/google.api.serviceusage.v1beta1.BatchCreateConsumerOverridesResponse";
    value: BatchCreateConsumerOverridesResponseAmino;
}
/** Response message for BatchCreateConsumerOverrides */
export interface BatchCreateConsumerOverridesResponseSDKType {
    overrides: QuotaOverrideSDKType[];
}
/** Request message for ImportConsumerOverrides */
export interface ImportConsumerOverridesRequest {
    /**
     * The resource name of the consumer.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com`
     */
    parent: string;
    /** The import data is specified in the request message itself */
    inlineSource?: OverrideInlineSource;
    /**
     * Whether to force the creation of the quota overrides.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force: boolean;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    forceOnly: QuotaSafetyCheck[];
}
export interface ImportConsumerOverridesRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportConsumerOverridesRequest";
    value: Uint8Array;
}
/** Request message for ImportConsumerOverrides */
export interface ImportConsumerOverridesRequestAmino {
    /**
     * The resource name of the consumer.
     *
     * An example name would be:
     * `projects/123/services/compute.googleapis.com`
     */
    parent?: string;
    /** The import data is specified in the request message itself */
    inline_source?: OverrideInlineSourceAmino;
    /**
     * Whether to force the creation of the quota overrides.
     * Setting the force parameter to 'true' ignores all quota safety checks that
     * would fail the request. QuotaSafetyCheck lists all such validations.
     */
    force?: boolean;
    /**
     * The list of quota safety checks to ignore before the override mutation.
     * Unlike 'force' field that ignores all the quota safety checks, the
     * 'force_only' field ignores only the specified checks; other checks are
     * still enforced. The 'force' and 'force_only' fields cannot both be set.
     */
    force_only?: QuotaSafetyCheck[];
}
export interface ImportConsumerOverridesRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ImportConsumerOverridesRequest";
    value: ImportConsumerOverridesRequestAmino;
}
/** Request message for ImportConsumerOverrides */
export interface ImportConsumerOverridesRequestSDKType {
    parent: string;
    inline_source?: OverrideInlineSourceSDKType;
    force: boolean;
    force_only: QuotaSafetyCheck[];
}
/** Response message for ImportConsumerOverrides */
export interface ImportConsumerOverridesResponse {
    /** The overrides that were created from the imported data. */
    overrides: QuotaOverride[];
}
export interface ImportConsumerOverridesResponseProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportConsumerOverridesResponse";
    value: Uint8Array;
}
/** Response message for ImportConsumerOverrides */
export interface ImportConsumerOverridesResponseAmino {
    /** The overrides that were created from the imported data. */
    overrides?: QuotaOverrideAmino[];
}
export interface ImportConsumerOverridesResponseAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ImportConsumerOverridesResponse";
    value: ImportConsumerOverridesResponseAmino;
}
/** Response message for ImportConsumerOverrides */
export interface ImportConsumerOverridesResponseSDKType {
    overrides: QuotaOverrideSDKType[];
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by ImportConsumerOverrides.
 */
export interface ImportConsumerOverridesMetadata {
}
export interface ImportConsumerOverridesMetadataProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportConsumerOverridesMetadata";
    value: Uint8Array;
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by ImportConsumerOverrides.
 */
export interface ImportConsumerOverridesMetadataAmino {
}
export interface ImportConsumerOverridesMetadataAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ImportConsumerOverridesMetadata";
    value: ImportConsumerOverridesMetadataAmino;
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by ImportConsumerOverrides.
 */
export interface ImportConsumerOverridesMetadataSDKType {
}
/** Response message for ImportAdminQuotaPolicies */
export interface ImportAdminQuotaPoliciesResponse {
    /** The policies that were created from the imported data. */
    policies: AdminQuotaPolicy[];
}
export interface ImportAdminQuotaPoliciesResponseProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportAdminQuotaPoliciesResponse";
    value: Uint8Array;
}
/** Response message for ImportAdminQuotaPolicies */
export interface ImportAdminQuotaPoliciesResponseAmino {
    /** The policies that were created from the imported data. */
    policies?: AdminQuotaPolicyAmino[];
}
export interface ImportAdminQuotaPoliciesResponseAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ImportAdminQuotaPoliciesResponse";
    value: ImportAdminQuotaPoliciesResponseAmino;
}
/** Response message for ImportAdminQuotaPolicies */
export interface ImportAdminQuotaPoliciesResponseSDKType {
    policies: AdminQuotaPolicySDKType[];
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by ImportAdminQuotaPolicies.
 */
export interface ImportAdminQuotaPoliciesMetadata {
}
export interface ImportAdminQuotaPoliciesMetadataProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.ImportAdminQuotaPoliciesMetadata";
    value: Uint8Array;
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by ImportAdminQuotaPolicies.
 */
export interface ImportAdminQuotaPoliciesMetadataAmino {
}
export interface ImportAdminQuotaPoliciesMetadataAminoMsg {
    type: "/google.api.serviceusage.v1beta1.ImportAdminQuotaPoliciesMetadata";
    value: ImportAdminQuotaPoliciesMetadataAmino;
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by ImportAdminQuotaPolicies.
 */
export interface ImportAdminQuotaPoliciesMetadataSDKType {
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by CreateAdminQuotaPolicy.
 */
export interface CreateAdminQuotaPolicyMetadata {
}
export interface CreateAdminQuotaPolicyMetadataProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.CreateAdminQuotaPolicyMetadata";
    value: Uint8Array;
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by CreateAdminQuotaPolicy.
 */
export interface CreateAdminQuotaPolicyMetadataAmino {
}
export interface CreateAdminQuotaPolicyMetadataAminoMsg {
    type: "/google.api.serviceusage.v1beta1.CreateAdminQuotaPolicyMetadata";
    value: CreateAdminQuotaPolicyMetadataAmino;
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by CreateAdminQuotaPolicy.
 */
export interface CreateAdminQuotaPolicyMetadataSDKType {
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by UpdateAdminQuotaPolicy.
 */
export interface UpdateAdminQuotaPolicyMetadata {
}
export interface UpdateAdminQuotaPolicyMetadataProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.UpdateAdminQuotaPolicyMetadata";
    value: Uint8Array;
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by UpdateAdminQuotaPolicy.
 */
export interface UpdateAdminQuotaPolicyMetadataAmino {
}
export interface UpdateAdminQuotaPolicyMetadataAminoMsg {
    type: "/google.api.serviceusage.v1beta1.UpdateAdminQuotaPolicyMetadata";
    value: UpdateAdminQuotaPolicyMetadataAmino;
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by UpdateAdminQuotaPolicy.
 */
export interface UpdateAdminQuotaPolicyMetadataSDKType {
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by DeleteAdminQuotaPolicy.
 */
export interface DeleteAdminQuotaPolicyMetadata {
}
export interface DeleteAdminQuotaPolicyMetadataProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.DeleteAdminQuotaPolicyMetadata";
    value: Uint8Array;
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by DeleteAdminQuotaPolicy.
 */
export interface DeleteAdminQuotaPolicyMetadataAmino {
}
export interface DeleteAdminQuotaPolicyMetadataAminoMsg {
    type: "/google.api.serviceusage.v1beta1.DeleteAdminQuotaPolicyMetadata";
    value: DeleteAdminQuotaPolicyMetadataAmino;
}
/**
 * Metadata message that provides information such as progress,
 * partial failures, and similar information on each GetOperation call
 * of LRO returned by DeleteAdminQuotaPolicy.
 */
export interface DeleteAdminQuotaPolicyMetadataSDKType {
}
/** Request message for generating service identity. */
export interface GenerateServiceIdentityRequest {
    /**
     * Name of the consumer and service to generate an identity for.
     *
     * The `GenerateServiceIdentity` methods currently only support projects.
     *
     * An example name would be:
     * `projects/123/services/example.googleapis.com` where `123` is the
     * project number.
     */
    parent: string;
}
export interface GenerateServiceIdentityRequestProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.GenerateServiceIdentityRequest";
    value: Uint8Array;
}
/** Request message for generating service identity. */
export interface GenerateServiceIdentityRequestAmino {
    /**
     * Name of the consumer and service to generate an identity for.
     *
     * The `GenerateServiceIdentity` methods currently only support projects.
     *
     * An example name would be:
     * `projects/123/services/example.googleapis.com` where `123` is the
     * project number.
     */
    parent?: string;
}
export interface GenerateServiceIdentityRequestAminoMsg {
    type: "/google.api.serviceusage.v1beta1.GenerateServiceIdentityRequest";
    value: GenerateServiceIdentityRequestAmino;
}
/** Request message for generating service identity. */
export interface GenerateServiceIdentityRequestSDKType {
    parent: string;
}
/** Response message for getting service identity. */
export interface GetServiceIdentityResponse {
    /**
     * Service identity that service producer can use to access consumer
     * resources. If exists is true, it contains email and unique_id. If exists is
     * false, it contains pre-constructed email and empty unique_id.
     */
    identity?: ServiceIdentity;
    /** Service identity state. */
    state: GetServiceIdentityResponse_IdentityState;
}
export interface GetServiceIdentityResponseProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.GetServiceIdentityResponse";
    value: Uint8Array;
}
/** Response message for getting service identity. */
export interface GetServiceIdentityResponseAmino {
    /**
     * Service identity that service producer can use to access consumer
     * resources. If exists is true, it contains email and unique_id. If exists is
     * false, it contains pre-constructed email and empty unique_id.
     */
    identity?: ServiceIdentityAmino;
    /** Service identity state. */
    state?: GetServiceIdentityResponse_IdentityState;
}
export interface GetServiceIdentityResponseAminoMsg {
    type: "/google.api.serviceusage.v1beta1.GetServiceIdentityResponse";
    value: GetServiceIdentityResponseAmino;
}
/** Response message for getting service identity. */
export interface GetServiceIdentityResponseSDKType {
    identity?: ServiceIdentitySDKType;
    state: GetServiceIdentityResponse_IdentityState;
}
/** Metadata for the `GetServiceIdentity` method. */
export interface GetServiceIdentityMetadata {
}
export interface GetServiceIdentityMetadataProtoMsg {
    typeUrl: "/google.api.serviceusage.v1beta1.GetServiceIdentityMetadata";
    value: Uint8Array;
}
/** Metadata for the `GetServiceIdentity` method. */
export interface GetServiceIdentityMetadataAmino {
}
export interface GetServiceIdentityMetadataAminoMsg {
    type: "/google.api.serviceusage.v1beta1.GetServiceIdentityMetadata";
    value: GetServiceIdentityMetadataAmino;
}
/** Metadata for the `GetServiceIdentity` method. */
export interface GetServiceIdentityMetadataSDKType {
}
export declare const EnableServiceRequest: {
    typeUrl: string;
    is(o: any): o is EnableServiceRequest;
    isSDK(o: any): o is EnableServiceRequestSDKType;
    isAmino(o: any): o is EnableServiceRequestAmino;
    encode(message: EnableServiceRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): EnableServiceRequest;
    fromJSON(object: any): EnableServiceRequest;
    toJSON(message: EnableServiceRequest): JsonSafe<EnableServiceRequest>;
    fromPartial(object: DeepPartial<EnableServiceRequest>): EnableServiceRequest;
    fromSDK(object: EnableServiceRequestSDKType): EnableServiceRequest;
    fromSDKJSON(object: any): EnableServiceRequestSDKType;
    toSDK(message: EnableServiceRequest): EnableServiceRequestSDKType;
    fromAmino(object: EnableServiceRequestAmino): EnableServiceRequest;
    toAmino(message: EnableServiceRequest): EnableServiceRequestAmino;
    fromAminoMsg(object: EnableServiceRequestAminoMsg): EnableServiceRequest;
    fromProtoMsg(message: EnableServiceRequestProtoMsg): EnableServiceRequest;
    toProto(message: EnableServiceRequest): Uint8Array;
    toProtoMsg(message: EnableServiceRequest): EnableServiceRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const DisableServiceRequest: {
    typeUrl: string;
    is(o: any): o is DisableServiceRequest;
    isSDK(o: any): o is DisableServiceRequestSDKType;
    isAmino(o: any): o is DisableServiceRequestAmino;
    encode(message: DisableServiceRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): DisableServiceRequest;
    fromJSON(object: any): DisableServiceRequest;
    toJSON(message: DisableServiceRequest): JsonSafe<DisableServiceRequest>;
    fromPartial(object: DeepPartial<DisableServiceRequest>): DisableServiceRequest;
    fromSDK(object: DisableServiceRequestSDKType): DisableServiceRequest;
    fromSDKJSON(object: any): DisableServiceRequestSDKType;
    toSDK(message: DisableServiceRequest): DisableServiceRequestSDKType;
    fromAmino(object: DisableServiceRequestAmino): DisableServiceRequest;
    toAmino(message: DisableServiceRequest): DisableServiceRequestAmino;
    fromAminoMsg(object: DisableServiceRequestAminoMsg): DisableServiceRequest;
    fromProtoMsg(message: DisableServiceRequestProtoMsg): DisableServiceRequest;
    toProto(message: DisableServiceRequest): Uint8Array;
    toProtoMsg(message: DisableServiceRequest): DisableServiceRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const GetServiceRequest: {
    typeUrl: string;
    is(o: any): o is GetServiceRequest;
    isSDK(o: any): o is GetServiceRequestSDKType;
    isAmino(o: any): o is GetServiceRequestAmino;
    encode(message: GetServiceRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GetServiceRequest;
    fromJSON(object: any): GetServiceRequest;
    toJSON(message: GetServiceRequest): JsonSafe<GetServiceRequest>;
    fromPartial(object: DeepPartial<GetServiceRequest>): GetServiceRequest;
    fromSDK(object: GetServiceRequestSDKType): GetServiceRequest;
    fromSDKJSON(object: any): GetServiceRequestSDKType;
    toSDK(message: GetServiceRequest): GetServiceRequestSDKType;
    fromAmino(object: GetServiceRequestAmino): GetServiceRequest;
    toAmino(message: GetServiceRequest): GetServiceRequestAmino;
    fromAminoMsg(object: GetServiceRequestAminoMsg): GetServiceRequest;
    fromProtoMsg(message: GetServiceRequestProtoMsg): GetServiceRequest;
    toProto(message: GetServiceRequest): Uint8Array;
    toProtoMsg(message: GetServiceRequest): GetServiceRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const ListServicesRequest: {
    typeUrl: string;
    is(o: any): o is ListServicesRequest;
    isSDK(o: any): o is ListServicesRequestSDKType;
    isAmino(o: any): o is ListServicesRequestAmino;
    encode(message: ListServicesRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ListServicesRequest;
    fromJSON(object: any): ListServicesRequest;
    toJSON(message: ListServicesRequest): JsonSafe<ListServicesRequest>;
    fromPartial(object: DeepPartial<ListServicesRequest>): ListServicesRequest;
    fromSDK(object: ListServicesRequestSDKType): ListServicesRequest;
    fromSDKJSON(object: any): ListServicesRequestSDKType;
    toSDK(message: ListServicesRequest): ListServicesRequestSDKType;
    fromAmino(object: ListServicesRequestAmino): ListServicesRequest;
    toAmino(message: ListServicesRequest): ListServicesRequestAmino;
    fromAminoMsg(object: ListServicesRequestAminoMsg): ListServicesRequest;
    fromProtoMsg(message: ListServicesRequestProtoMsg): ListServicesRequest;
    toProto(message: ListServicesRequest): Uint8Array;
    toProtoMsg(message: ListServicesRequest): ListServicesRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const ListServicesResponse: {
    typeUrl: string;
    is(o: any): o is ListServicesResponse;
    isSDK(o: any): o is ListServicesResponseSDKType;
    isAmino(o: any): o is ListServicesResponseAmino;
    encode(message: ListServicesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ListServicesResponse;
    fromJSON(object: any): ListServicesResponse;
    toJSON(message: ListServicesResponse): JsonSafe<ListServicesResponse>;
    fromPartial(object: DeepPartial<ListServicesResponse>): ListServicesResponse;
    fromSDK(object: ListServicesResponseSDKType): ListServicesResponse;
    fromSDKJSON(object: any): ListServicesResponseSDKType;
    toSDK(message: ListServicesResponse): ListServicesResponseSDKType;
    fromAmino(object: ListServicesResponseAmino): ListServicesResponse;
    toAmino(message: ListServicesResponse): ListServicesResponseAmino;
    fromAminoMsg(object: ListServicesResponseAminoMsg): ListServicesResponse;
    fromProtoMsg(message: ListServicesResponseProtoMsg): ListServicesResponse;
    toProto(message: ListServicesResponse): Uint8Array;
    toProtoMsg(message: ListServicesResponse): ListServicesResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const BatchEnableServicesRequest: {
    typeUrl: string;
    is(o: any): o is BatchEnableServicesRequest;
    isSDK(o: any): o is BatchEnableServicesRequestSDKType;
    isAmino(o: any): o is BatchEnableServicesRequestAmino;
    encode(message: BatchEnableServicesRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): BatchEnableServicesRequest;
    fromJSON(object: any): BatchEnableServicesRequest;
    toJSON(message: BatchEnableServicesRequest): JsonSafe<BatchEnableServicesRequest>;
    fromPartial(object: DeepPartial<BatchEnableServicesRequest>): BatchEnableServicesRequest;
    fromSDK(object: BatchEnableServicesRequestSDKType): BatchEnableServicesRequest;
    fromSDKJSON(object: any): BatchEnableServicesRequestSDKType;
    toSDK(message: BatchEnableServicesRequest): BatchEnableServicesRequestSDKType;
    fromAmino(object: BatchEnableServicesRequestAmino): BatchEnableServicesRequest;
    toAmino(message: BatchEnableServicesRequest): BatchEnableServicesRequestAmino;
    fromAminoMsg(object: BatchEnableServicesRequestAminoMsg): BatchEnableServicesRequest;
    fromProtoMsg(message: BatchEnableServicesRequestProtoMsg): BatchEnableServicesRequest;
    toProto(message: BatchEnableServicesRequest): Uint8Array;
    toProtoMsg(message: BatchEnableServicesRequest): BatchEnableServicesRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const ListConsumerQuotaMetricsRequest: {
    typeUrl: string;
    is(o: any): o is ListConsumerQuotaMetricsRequest;
    isSDK(o: any): o is ListConsumerQuotaMetricsRequestSDKType;
    isAmino(o: any): o is ListConsumerQuotaMetricsRequestAmino;
    encode(message: ListConsumerQuotaMetricsRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ListConsumerQuotaMetricsRequest;
    fromJSON(object: any): ListConsumerQuotaMetricsRequest;
    toJSON(message: ListConsumerQuotaMetricsRequest): JsonSafe<ListConsumerQuotaMetricsRequest>;
    fromPartial(object: DeepPartial<ListConsumerQuotaMetricsRequest>): ListConsumerQuotaMetricsRequest;
    fromSDK(object: ListConsumerQuotaMetricsRequestSDKType): ListConsumerQuotaMetricsRequest;
    fromSDKJSON(object: any): ListConsumerQuotaMetricsRequestSDKType;
    toSDK(message: ListConsumerQuotaMetricsRequest): ListConsumerQuotaMetricsRequestSDKType;
    fromAmino(object: ListConsumerQuotaMetricsRequestAmino): ListConsumerQuotaMetricsRequest;
    toAmino(message: ListConsumerQuotaMetricsRequest): ListConsumerQuotaMetricsRequestAmino;
    fromAminoMsg(object: ListConsumerQuotaMetricsRequestAminoMsg): ListConsumerQuotaMetricsRequest;
    fromProtoMsg(message: ListConsumerQuotaMetricsRequestProtoMsg): ListConsumerQuotaMetricsRequest;
    toProto(message: ListConsumerQuotaMetricsRequest): Uint8Array;
    toProtoMsg(message: ListConsumerQuotaMetricsRequest): ListConsumerQuotaMetricsRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const ListConsumerQuotaMetricsResponse: {
    typeUrl: string;
    is(o: any): o is ListConsumerQuotaMetricsResponse;
    isSDK(o: any): o is ListConsumerQuotaMetricsResponseSDKType;
    isAmino(o: any): o is ListConsumerQuotaMetricsResponseAmino;
    encode(message: ListConsumerQuotaMetricsResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ListConsumerQuotaMetricsResponse;
    fromJSON(object: any): ListConsumerQuotaMetricsResponse;
    toJSON(message: ListConsumerQuotaMetricsResponse): JsonSafe<ListConsumerQuotaMetricsResponse>;
    fromPartial(object: DeepPartial<ListConsumerQuotaMetricsResponse>): ListConsumerQuotaMetricsResponse;
    fromSDK(object: ListConsumerQuotaMetricsResponseSDKType): ListConsumerQuotaMetricsResponse;
    fromSDKJSON(object: any): ListConsumerQuotaMetricsResponseSDKType;
    toSDK(message: ListConsumerQuotaMetricsResponse): ListConsumerQuotaMetricsResponseSDKType;
    fromAmino(object: ListConsumerQuotaMetricsResponseAmino): ListConsumerQuotaMetricsResponse;
    toAmino(message: ListConsumerQuotaMetricsResponse): ListConsumerQuotaMetricsResponseAmino;
    fromAminoMsg(object: ListConsumerQuotaMetricsResponseAminoMsg): ListConsumerQuotaMetricsResponse;
    fromProtoMsg(message: ListConsumerQuotaMetricsResponseProtoMsg): ListConsumerQuotaMetricsResponse;
    toProto(message: ListConsumerQuotaMetricsResponse): Uint8Array;
    toProtoMsg(message: ListConsumerQuotaMetricsResponse): ListConsumerQuotaMetricsResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const GetConsumerQuotaMetricRequest: {
    typeUrl: string;
    is(o: any): o is GetConsumerQuotaMetricRequest;
    isSDK(o: any): o is GetConsumerQuotaMetricRequestSDKType;
    isAmino(o: any): o is GetConsumerQuotaMetricRequestAmino;
    encode(message: GetConsumerQuotaMetricRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GetConsumerQuotaMetricRequest;
    fromJSON(object: any): GetConsumerQuotaMetricRequest;
    toJSON(message: GetConsumerQuotaMetricRequest): JsonSafe<GetConsumerQuotaMetricRequest>;
    fromPartial(object: DeepPartial<GetConsumerQuotaMetricRequest>): GetConsumerQuotaMetricRequest;
    fromSDK(object: GetConsumerQuotaMetricRequestSDKType): GetConsumerQuotaMetricRequest;
    fromSDKJSON(object: any): GetConsumerQuotaMetricRequestSDKType;
    toSDK(message: GetConsumerQuotaMetricRequest): GetConsumerQuotaMetricRequestSDKType;
    fromAmino(object: GetConsumerQuotaMetricRequestAmino): GetConsumerQuotaMetricRequest;
    toAmino(message: GetConsumerQuotaMetricRequest): GetConsumerQuotaMetricRequestAmino;
    fromAminoMsg(object: GetConsumerQuotaMetricRequestAminoMsg): GetConsumerQuotaMetricRequest;
    fromProtoMsg(message: GetConsumerQuotaMetricRequestProtoMsg): GetConsumerQuotaMetricRequest;
    toProto(message: GetConsumerQuotaMetricRequest): Uint8Array;
    toProtoMsg(message: GetConsumerQuotaMetricRequest): GetConsumerQuotaMetricRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const GetConsumerQuotaLimitRequest: {
    typeUrl: string;
    is(o: any): o is GetConsumerQuotaLimitRequest;
    isSDK(o: any): o is GetConsumerQuotaLimitRequestSDKType;
    isAmino(o: any): o is GetConsumerQuotaLimitRequestAmino;
    encode(message: GetConsumerQuotaLimitRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GetConsumerQuotaLimitRequest;
    fromJSON(object: any): GetConsumerQuotaLimitRequest;
    toJSON(message: GetConsumerQuotaLimitRequest): JsonSafe<GetConsumerQuotaLimitRequest>;
    fromPartial(object: DeepPartial<GetConsumerQuotaLimitRequest>): GetConsumerQuotaLimitRequest;
    fromSDK(object: GetConsumerQuotaLimitRequestSDKType): GetConsumerQuotaLimitRequest;
    fromSDKJSON(object: any): GetConsumerQuotaLimitRequestSDKType;
    toSDK(message: GetConsumerQuotaLimitRequest): GetConsumerQuotaLimitRequestSDKType;
    fromAmino(object: GetConsumerQuotaLimitRequestAmino): GetConsumerQuotaLimitRequest;
    toAmino(message: GetConsumerQuotaLimitRequest): GetConsumerQuotaLimitRequestAmino;
    fromAminoMsg(object: GetConsumerQuotaLimitRequestAminoMsg): GetConsumerQuotaLimitRequest;
    fromProtoMsg(message: GetConsumerQuotaLimitRequestProtoMsg): GetConsumerQuotaLimitRequest;
    toProto(message: GetConsumerQuotaLimitRequest): Uint8Array;
    toProtoMsg(message: GetConsumerQuotaLimitRequest): GetConsumerQuotaLimitRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const CreateAdminOverrideRequest: {
    typeUrl: string;
    is(o: any): o is CreateAdminOverrideRequest;
    isSDK(o: any): o is CreateAdminOverrideRequestSDKType;
    isAmino(o: any): o is CreateAdminOverrideRequestAmino;
    encode(message: CreateAdminOverrideRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): CreateAdminOverrideRequest;
    fromJSON(object: any): CreateAdminOverrideRequest;
    toJSON(message: CreateAdminOverrideRequest): JsonSafe<CreateAdminOverrideRequest>;
    fromPartial(object: DeepPartial<CreateAdminOverrideRequest>): CreateAdminOverrideRequest;
    fromSDK(object: CreateAdminOverrideRequestSDKType): CreateAdminOverrideRequest;
    fromSDKJSON(object: any): CreateAdminOverrideRequestSDKType;
    toSDK(message: CreateAdminOverrideRequest): CreateAdminOverrideRequestSDKType;
    fromAmino(object: CreateAdminOverrideRequestAmino): CreateAdminOverrideRequest;
    toAmino(message: CreateAdminOverrideRequest): CreateAdminOverrideRequestAmino;
    fromAminoMsg(object: CreateAdminOverrideRequestAminoMsg): CreateAdminOverrideRequest;
    fromProtoMsg(message: CreateAdminOverrideRequestProtoMsg): CreateAdminOverrideRequest;
    toProto(message: CreateAdminOverrideRequest): Uint8Array;
    toProtoMsg(message: CreateAdminOverrideRequest): CreateAdminOverrideRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const UpdateAdminOverrideRequest: {
    typeUrl: string;
    is(o: any): o is UpdateAdminOverrideRequest;
    isSDK(o: any): o is UpdateAdminOverrideRequestSDKType;
    isAmino(o: any): o is UpdateAdminOverrideRequestAmino;
    encode(message: UpdateAdminOverrideRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): UpdateAdminOverrideRequest;
    fromJSON(object: any): UpdateAdminOverrideRequest;
    toJSON(message: UpdateAdminOverrideRequest): JsonSafe<UpdateAdminOverrideRequest>;
    fromPartial(object: DeepPartial<UpdateAdminOverrideRequest>): UpdateAdminOverrideRequest;
    fromSDK(object: UpdateAdminOverrideRequestSDKType): UpdateAdminOverrideRequest;
    fromSDKJSON(object: any): UpdateAdminOverrideRequestSDKType;
    toSDK(message: UpdateAdminOverrideRequest): UpdateAdminOverrideRequestSDKType;
    fromAmino(object: UpdateAdminOverrideRequestAmino): UpdateAdminOverrideRequest;
    toAmino(message: UpdateAdminOverrideRequest): UpdateAdminOverrideRequestAmino;
    fromAminoMsg(object: UpdateAdminOverrideRequestAminoMsg): UpdateAdminOverrideRequest;
    fromProtoMsg(message: UpdateAdminOverrideRequestProtoMsg): UpdateAdminOverrideRequest;
    toProto(message: UpdateAdminOverrideRequest): Uint8Array;
    toProtoMsg(message: UpdateAdminOverrideRequest): UpdateAdminOverrideRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const DeleteAdminOverrideRequest: {
    typeUrl: string;
    is(o: any): o is DeleteAdminOverrideRequest;
    isSDK(o: any): o is DeleteAdminOverrideRequestSDKType;
    isAmino(o: any): o is DeleteAdminOverrideRequestAmino;
    encode(message: DeleteAdminOverrideRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): DeleteAdminOverrideRequest;
    fromJSON(object: any): DeleteAdminOverrideRequest;
    toJSON(message: DeleteAdminOverrideRequest): JsonSafe<DeleteAdminOverrideRequest>;
    fromPartial(object: DeepPartial<DeleteAdminOverrideRequest>): DeleteAdminOverrideRequest;
    fromSDK(object: DeleteAdminOverrideRequestSDKType): DeleteAdminOverrideRequest;
    fromSDKJSON(object: any): DeleteAdminOverrideRequestSDKType;
    toSDK(message: DeleteAdminOverrideRequest): DeleteAdminOverrideRequestSDKType;
    fromAmino(object: DeleteAdminOverrideRequestAmino): DeleteAdminOverrideRequest;
    toAmino(message: DeleteAdminOverrideRequest): DeleteAdminOverrideRequestAmino;
    fromAminoMsg(object: DeleteAdminOverrideRequestAminoMsg): DeleteAdminOverrideRequest;
    fromProtoMsg(message: DeleteAdminOverrideRequestProtoMsg): DeleteAdminOverrideRequest;
    toProto(message: DeleteAdminOverrideRequest): Uint8Array;
    toProtoMsg(message: DeleteAdminOverrideRequest): DeleteAdminOverrideRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const ListAdminOverridesRequest: {
    typeUrl: string;
    is(o: any): o is ListAdminOverridesRequest;
    isSDK(o: any): o is ListAdminOverridesRequestSDKType;
    isAmino(o: any): o is ListAdminOverridesRequestAmino;
    encode(message: ListAdminOverridesRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ListAdminOverridesRequest;
    fromJSON(object: any): ListAdminOverridesRequest;
    toJSON(message: ListAdminOverridesRequest): JsonSafe<ListAdminOverridesRequest>;
    fromPartial(object: DeepPartial<ListAdminOverridesRequest>): ListAdminOverridesRequest;
    fromSDK(object: ListAdminOverridesRequestSDKType): ListAdminOverridesRequest;
    fromSDKJSON(object: any): ListAdminOverridesRequestSDKType;
    toSDK(message: ListAdminOverridesRequest): ListAdminOverridesRequestSDKType;
    fromAmino(object: ListAdminOverridesRequestAmino): ListAdminOverridesRequest;
    toAmino(message: ListAdminOverridesRequest): ListAdminOverridesRequestAmino;
    fromAminoMsg(object: ListAdminOverridesRequestAminoMsg): ListAdminOverridesRequest;
    fromProtoMsg(message: ListAdminOverridesRequestProtoMsg): ListAdminOverridesRequest;
    toProto(message: ListAdminOverridesRequest): Uint8Array;
    toProtoMsg(message: ListAdminOverridesRequest): ListAdminOverridesRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const ListAdminOverridesResponse: {
    typeUrl: string;
    is(o: any): o is ListAdminOverridesResponse;
    isSDK(o: any): o is ListAdminOverridesResponseSDKType;
    isAmino(o: any): o is ListAdminOverridesResponseAmino;
    encode(message: ListAdminOverridesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ListAdminOverridesResponse;
    fromJSON(object: any): ListAdminOverridesResponse;
    toJSON(message: ListAdminOverridesResponse): JsonSafe<ListAdminOverridesResponse>;
    fromPartial(object: DeepPartial<ListAdminOverridesResponse>): ListAdminOverridesResponse;
    fromSDK(object: ListAdminOverridesResponseSDKType): ListAdminOverridesResponse;
    fromSDKJSON(object: any): ListAdminOverridesResponseSDKType;
    toSDK(message: ListAdminOverridesResponse): ListAdminOverridesResponseSDKType;
    fromAmino(object: ListAdminOverridesResponseAmino): ListAdminOverridesResponse;
    toAmino(message: ListAdminOverridesResponse): ListAdminOverridesResponseAmino;
    fromAminoMsg(object: ListAdminOverridesResponseAminoMsg): ListAdminOverridesResponse;
    fromProtoMsg(message: ListAdminOverridesResponseProtoMsg): ListAdminOverridesResponse;
    toProto(message: ListAdminOverridesResponse): Uint8Array;
    toProtoMsg(message: ListAdminOverridesResponse): ListAdminOverridesResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const BatchCreateAdminOverridesResponse: {
    typeUrl: string;
    is(o: any): o is BatchCreateAdminOverridesResponse;
    isSDK(o: any): o is BatchCreateAdminOverridesResponseSDKType;
    isAmino(o: any): o is BatchCreateAdminOverridesResponseAmino;
    encode(message: BatchCreateAdminOverridesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): BatchCreateAdminOverridesResponse;
    fromJSON(object: any): BatchCreateAdminOverridesResponse;
    toJSON(message: BatchCreateAdminOverridesResponse): JsonSafe<BatchCreateAdminOverridesResponse>;
    fromPartial(object: DeepPartial<BatchCreateAdminOverridesResponse>): BatchCreateAdminOverridesResponse;
    fromSDK(object: BatchCreateAdminOverridesResponseSDKType): BatchCreateAdminOverridesResponse;
    fromSDKJSON(object: any): BatchCreateAdminOverridesResponseSDKType;
    toSDK(message: BatchCreateAdminOverridesResponse): BatchCreateAdminOverridesResponseSDKType;
    fromAmino(object: BatchCreateAdminOverridesResponseAmino): BatchCreateAdminOverridesResponse;
    toAmino(message: BatchCreateAdminOverridesResponse): BatchCreateAdminOverridesResponseAmino;
    fromAminoMsg(object: BatchCreateAdminOverridesResponseAminoMsg): BatchCreateAdminOverridesResponse;
    fromProtoMsg(message: BatchCreateAdminOverridesResponseProtoMsg): BatchCreateAdminOverridesResponse;
    toProto(message: BatchCreateAdminOverridesResponse): Uint8Array;
    toProtoMsg(message: BatchCreateAdminOverridesResponse): BatchCreateAdminOverridesResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const ImportAdminOverridesRequest: {
    typeUrl: string;
    is(o: any): o is ImportAdminOverridesRequest;
    isSDK(o: any): o is ImportAdminOverridesRequestSDKType;
    isAmino(o: any): o is ImportAdminOverridesRequestAmino;
    encode(message: ImportAdminOverridesRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ImportAdminOverridesRequest;
    fromJSON(object: any): ImportAdminOverridesRequest;
    toJSON(message: ImportAdminOverridesRequest): JsonSafe<ImportAdminOverridesRequest>;
    fromPartial(object: DeepPartial<ImportAdminOverridesRequest>): ImportAdminOverridesRequest;
    fromSDK(object: ImportAdminOverridesRequestSDKType): ImportAdminOverridesRequest;
    fromSDKJSON(object: any): ImportAdminOverridesRequestSDKType;
    toSDK(message: ImportAdminOverridesRequest): ImportAdminOverridesRequestSDKType;
    fromAmino(object: ImportAdminOverridesRequestAmino): ImportAdminOverridesRequest;
    toAmino(message: ImportAdminOverridesRequest): ImportAdminOverridesRequestAmino;
    fromAminoMsg(object: ImportAdminOverridesRequestAminoMsg): ImportAdminOverridesRequest;
    fromProtoMsg(message: ImportAdminOverridesRequestProtoMsg): ImportAdminOverridesRequest;
    toProto(message: ImportAdminOverridesRequest): Uint8Array;
    toProtoMsg(message: ImportAdminOverridesRequest): ImportAdminOverridesRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const ImportAdminOverridesResponse: {
    typeUrl: string;
    is(o: any): o is ImportAdminOverridesResponse;
    isSDK(o: any): o is ImportAdminOverridesResponseSDKType;
    isAmino(o: any): o is ImportAdminOverridesResponseAmino;
    encode(message: ImportAdminOverridesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ImportAdminOverridesResponse;
    fromJSON(object: any): ImportAdminOverridesResponse;
    toJSON(message: ImportAdminOverridesResponse): JsonSafe<ImportAdminOverridesResponse>;
    fromPartial(object: DeepPartial<ImportAdminOverridesResponse>): ImportAdminOverridesResponse;
    fromSDK(object: ImportAdminOverridesResponseSDKType): ImportAdminOverridesResponse;
    fromSDKJSON(object: any): ImportAdminOverridesResponseSDKType;
    toSDK(message: ImportAdminOverridesResponse): ImportAdminOverridesResponseSDKType;
    fromAmino(object: ImportAdminOverridesResponseAmino): ImportAdminOverridesResponse;
    toAmino(message: ImportAdminOverridesResponse): ImportAdminOverridesResponseAmino;
    fromAminoMsg(object: ImportAdminOverridesResponseAminoMsg): ImportAdminOverridesResponse;
    fromProtoMsg(message: ImportAdminOverridesResponseProtoMsg): ImportAdminOverridesResponse;
    toProto(message: ImportAdminOverridesResponse): Uint8Array;
    toProtoMsg(message: ImportAdminOverridesResponse): ImportAdminOverridesResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const ImportAdminOverridesMetadata: {
    typeUrl: string;
    is(o: any): o is ImportAdminOverridesMetadata;
    isSDK(o: any): o is ImportAdminOverridesMetadataSDKType;
    isAmino(o: any): o is ImportAdminOverridesMetadataAmino;
    encode(_: ImportAdminOverridesMetadata, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ImportAdminOverridesMetadata;
    fromJSON(_: any): ImportAdminOverridesMetadata;
    toJSON(_: ImportAdminOverridesMetadata): JsonSafe<ImportAdminOverridesMetadata>;
    fromPartial(_: DeepPartial<ImportAdminOverridesMetadata>): ImportAdminOverridesMetadata;
    fromSDK(_: ImportAdminOverridesMetadataSDKType): ImportAdminOverridesMetadata;
    fromSDKJSON(_: any): ImportAdminOverridesMetadataSDKType;
    toSDK(_: ImportAdminOverridesMetadata): ImportAdminOverridesMetadataSDKType;
    fromAmino(_: ImportAdminOverridesMetadataAmino): ImportAdminOverridesMetadata;
    toAmino(_: ImportAdminOverridesMetadata): ImportAdminOverridesMetadataAmino;
    fromAminoMsg(object: ImportAdminOverridesMetadataAminoMsg): ImportAdminOverridesMetadata;
    fromProtoMsg(message: ImportAdminOverridesMetadataProtoMsg): ImportAdminOverridesMetadata;
    toProto(message: ImportAdminOverridesMetadata): Uint8Array;
    toProtoMsg(message: ImportAdminOverridesMetadata): ImportAdminOverridesMetadataProtoMsg;
    registerTypeUrl(): void;
};
export declare const CreateConsumerOverrideRequest: {
    typeUrl: string;
    is(o: any): o is CreateConsumerOverrideRequest;
    isSDK(o: any): o is CreateConsumerOverrideRequestSDKType;
    isAmino(o: any): o is CreateConsumerOverrideRequestAmino;
    encode(message: CreateConsumerOverrideRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): CreateConsumerOverrideRequest;
    fromJSON(object: any): CreateConsumerOverrideRequest;
    toJSON(message: CreateConsumerOverrideRequest): JsonSafe<CreateConsumerOverrideRequest>;
    fromPartial(object: DeepPartial<CreateConsumerOverrideRequest>): CreateConsumerOverrideRequest;
    fromSDK(object: CreateConsumerOverrideRequestSDKType): CreateConsumerOverrideRequest;
    fromSDKJSON(object: any): CreateConsumerOverrideRequestSDKType;
    toSDK(message: CreateConsumerOverrideRequest): CreateConsumerOverrideRequestSDKType;
    fromAmino(object: CreateConsumerOverrideRequestAmino): CreateConsumerOverrideRequest;
    toAmino(message: CreateConsumerOverrideRequest): CreateConsumerOverrideRequestAmino;
    fromAminoMsg(object: CreateConsumerOverrideRequestAminoMsg): CreateConsumerOverrideRequest;
    fromProtoMsg(message: CreateConsumerOverrideRequestProtoMsg): CreateConsumerOverrideRequest;
    toProto(message: CreateConsumerOverrideRequest): Uint8Array;
    toProtoMsg(message: CreateConsumerOverrideRequest): CreateConsumerOverrideRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const UpdateConsumerOverrideRequest: {
    typeUrl: string;
    is(o: any): o is UpdateConsumerOverrideRequest;
    isSDK(o: any): o is UpdateConsumerOverrideRequestSDKType;
    isAmino(o: any): o is UpdateConsumerOverrideRequestAmino;
    encode(message: UpdateConsumerOverrideRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): UpdateConsumerOverrideRequest;
    fromJSON(object: any): UpdateConsumerOverrideRequest;
    toJSON(message: UpdateConsumerOverrideRequest): JsonSafe<UpdateConsumerOverrideRequest>;
    fromPartial(object: DeepPartial<UpdateConsumerOverrideRequest>): UpdateConsumerOverrideRequest;
    fromSDK(object: UpdateConsumerOverrideRequestSDKType): UpdateConsumerOverrideRequest;
    fromSDKJSON(object: any): UpdateConsumerOverrideRequestSDKType;
    toSDK(message: UpdateConsumerOverrideRequest): UpdateConsumerOverrideRequestSDKType;
    fromAmino(object: UpdateConsumerOverrideRequestAmino): UpdateConsumerOverrideRequest;
    toAmino(message: UpdateConsumerOverrideRequest): UpdateConsumerOverrideRequestAmino;
    fromAminoMsg(object: UpdateConsumerOverrideRequestAminoMsg): UpdateConsumerOverrideRequest;
    fromProtoMsg(message: UpdateConsumerOverrideRequestProtoMsg): UpdateConsumerOverrideRequest;
    toProto(message: UpdateConsumerOverrideRequest): Uint8Array;
    toProtoMsg(message: UpdateConsumerOverrideRequest): UpdateConsumerOverrideRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const DeleteConsumerOverrideRequest: {
    typeUrl: string;
    is(o: any): o is DeleteConsumerOverrideRequest;
    isSDK(o: any): o is DeleteConsumerOverrideRequestSDKType;
    isAmino(o: any): o is DeleteConsumerOverrideRequestAmino;
    encode(message: DeleteConsumerOverrideRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): DeleteConsumerOverrideRequest;
    fromJSON(object: any): DeleteConsumerOverrideRequest;
    toJSON(message: DeleteConsumerOverrideRequest): JsonSafe<DeleteConsumerOverrideRequest>;
    fromPartial(object: DeepPartial<DeleteConsumerOverrideRequest>): DeleteConsumerOverrideRequest;
    fromSDK(object: DeleteConsumerOverrideRequestSDKType): DeleteConsumerOverrideRequest;
    fromSDKJSON(object: any): DeleteConsumerOverrideRequestSDKType;
    toSDK(message: DeleteConsumerOverrideRequest): DeleteConsumerOverrideRequestSDKType;
    fromAmino(object: DeleteConsumerOverrideRequestAmino): DeleteConsumerOverrideRequest;
    toAmino(message: DeleteConsumerOverrideRequest): DeleteConsumerOverrideRequestAmino;
    fromAminoMsg(object: DeleteConsumerOverrideRequestAminoMsg): DeleteConsumerOverrideRequest;
    fromProtoMsg(message: DeleteConsumerOverrideRequestProtoMsg): DeleteConsumerOverrideRequest;
    toProto(message: DeleteConsumerOverrideRequest): Uint8Array;
    toProtoMsg(message: DeleteConsumerOverrideRequest): DeleteConsumerOverrideRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const ListConsumerOverridesRequest: {
    typeUrl: string;
    is(o: any): o is ListConsumerOverridesRequest;
    isSDK(o: any): o is ListConsumerOverridesRequestSDKType;
    isAmino(o: any): o is ListConsumerOverridesRequestAmino;
    encode(message: ListConsumerOverridesRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ListConsumerOverridesRequest;
    fromJSON(object: any): ListConsumerOverridesRequest;
    toJSON(message: ListConsumerOverridesRequest): JsonSafe<ListConsumerOverridesRequest>;
    fromPartial(object: DeepPartial<ListConsumerOverridesRequest>): ListConsumerOverridesRequest;
    fromSDK(object: ListConsumerOverridesRequestSDKType): ListConsumerOverridesRequest;
    fromSDKJSON(object: any): ListConsumerOverridesRequestSDKType;
    toSDK(message: ListConsumerOverridesRequest): ListConsumerOverridesRequestSDKType;
    fromAmino(object: ListConsumerOverridesRequestAmino): ListConsumerOverridesRequest;
    toAmino(message: ListConsumerOverridesRequest): ListConsumerOverridesRequestAmino;
    fromAminoMsg(object: ListConsumerOverridesRequestAminoMsg): ListConsumerOverridesRequest;
    fromProtoMsg(message: ListConsumerOverridesRequestProtoMsg): ListConsumerOverridesRequest;
    toProto(message: ListConsumerOverridesRequest): Uint8Array;
    toProtoMsg(message: ListConsumerOverridesRequest): ListConsumerOverridesRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const ListConsumerOverridesResponse: {
    typeUrl: string;
    is(o: any): o is ListConsumerOverridesResponse;
    isSDK(o: any): o is ListConsumerOverridesResponseSDKType;
    isAmino(o: any): o is ListConsumerOverridesResponseAmino;
    encode(message: ListConsumerOverridesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ListConsumerOverridesResponse;
    fromJSON(object: any): ListConsumerOverridesResponse;
    toJSON(message: ListConsumerOverridesResponse): JsonSafe<ListConsumerOverridesResponse>;
    fromPartial(object: DeepPartial<ListConsumerOverridesResponse>): ListConsumerOverridesResponse;
    fromSDK(object: ListConsumerOverridesResponseSDKType): ListConsumerOverridesResponse;
    fromSDKJSON(object: any): ListConsumerOverridesResponseSDKType;
    toSDK(message: ListConsumerOverridesResponse): ListConsumerOverridesResponseSDKType;
    fromAmino(object: ListConsumerOverridesResponseAmino): ListConsumerOverridesResponse;
    toAmino(message: ListConsumerOverridesResponse): ListConsumerOverridesResponseAmino;
    fromAminoMsg(object: ListConsumerOverridesResponseAminoMsg): ListConsumerOverridesResponse;
    fromProtoMsg(message: ListConsumerOverridesResponseProtoMsg): ListConsumerOverridesResponse;
    toProto(message: ListConsumerOverridesResponse): Uint8Array;
    toProtoMsg(message: ListConsumerOverridesResponse): ListConsumerOverridesResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const BatchCreateConsumerOverridesResponse: {
    typeUrl: string;
    is(o: any): o is BatchCreateConsumerOverridesResponse;
    isSDK(o: any): o is BatchCreateConsumerOverridesResponseSDKType;
    isAmino(o: any): o is BatchCreateConsumerOverridesResponseAmino;
    encode(message: BatchCreateConsumerOverridesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): BatchCreateConsumerOverridesResponse;
    fromJSON(object: any): BatchCreateConsumerOverridesResponse;
    toJSON(message: BatchCreateConsumerOverridesResponse): JsonSafe<BatchCreateConsumerOverridesResponse>;
    fromPartial(object: DeepPartial<BatchCreateConsumerOverridesResponse>): BatchCreateConsumerOverridesResponse;
    fromSDK(object: BatchCreateConsumerOverridesResponseSDKType): BatchCreateConsumerOverridesResponse;
    fromSDKJSON(object: any): BatchCreateConsumerOverridesResponseSDKType;
    toSDK(message: BatchCreateConsumerOverridesResponse): BatchCreateConsumerOverridesResponseSDKType;
    fromAmino(object: BatchCreateConsumerOverridesResponseAmino): BatchCreateConsumerOverridesResponse;
    toAmino(message: BatchCreateConsumerOverridesResponse): BatchCreateConsumerOverridesResponseAmino;
    fromAminoMsg(object: BatchCreateConsumerOverridesResponseAminoMsg): BatchCreateConsumerOverridesResponse;
    fromProtoMsg(message: BatchCreateConsumerOverridesResponseProtoMsg): BatchCreateConsumerOverridesResponse;
    toProto(message: BatchCreateConsumerOverridesResponse): Uint8Array;
    toProtoMsg(message: BatchCreateConsumerOverridesResponse): BatchCreateConsumerOverridesResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const ImportConsumerOverridesRequest: {
    typeUrl: string;
    is(o: any): o is ImportConsumerOverridesRequest;
    isSDK(o: any): o is ImportConsumerOverridesRequestSDKType;
    isAmino(o: any): o is ImportConsumerOverridesRequestAmino;
    encode(message: ImportConsumerOverridesRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ImportConsumerOverridesRequest;
    fromJSON(object: any): ImportConsumerOverridesRequest;
    toJSON(message: ImportConsumerOverridesRequest): JsonSafe<ImportConsumerOverridesRequest>;
    fromPartial(object: DeepPartial<ImportConsumerOverridesRequest>): ImportConsumerOverridesRequest;
    fromSDK(object: ImportConsumerOverridesRequestSDKType): ImportConsumerOverridesRequest;
    fromSDKJSON(object: any): ImportConsumerOverridesRequestSDKType;
    toSDK(message: ImportConsumerOverridesRequest): ImportConsumerOverridesRequestSDKType;
    fromAmino(object: ImportConsumerOverridesRequestAmino): ImportConsumerOverridesRequest;
    toAmino(message: ImportConsumerOverridesRequest): ImportConsumerOverridesRequestAmino;
    fromAminoMsg(object: ImportConsumerOverridesRequestAminoMsg): ImportConsumerOverridesRequest;
    fromProtoMsg(message: ImportConsumerOverridesRequestProtoMsg): ImportConsumerOverridesRequest;
    toProto(message: ImportConsumerOverridesRequest): Uint8Array;
    toProtoMsg(message: ImportConsumerOverridesRequest): ImportConsumerOverridesRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const ImportConsumerOverridesResponse: {
    typeUrl: string;
    is(o: any): o is ImportConsumerOverridesResponse;
    isSDK(o: any): o is ImportConsumerOverridesResponseSDKType;
    isAmino(o: any): o is ImportConsumerOverridesResponseAmino;
    encode(message: ImportConsumerOverridesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ImportConsumerOverridesResponse;
    fromJSON(object: any): ImportConsumerOverridesResponse;
    toJSON(message: ImportConsumerOverridesResponse): JsonSafe<ImportConsumerOverridesResponse>;
    fromPartial(object: DeepPartial<ImportConsumerOverridesResponse>): ImportConsumerOverridesResponse;
    fromSDK(object: ImportConsumerOverridesResponseSDKType): ImportConsumerOverridesResponse;
    fromSDKJSON(object: any): ImportConsumerOverridesResponseSDKType;
    toSDK(message: ImportConsumerOverridesResponse): ImportConsumerOverridesResponseSDKType;
    fromAmino(object: ImportConsumerOverridesResponseAmino): ImportConsumerOverridesResponse;
    toAmino(message: ImportConsumerOverridesResponse): ImportConsumerOverridesResponseAmino;
    fromAminoMsg(object: ImportConsumerOverridesResponseAminoMsg): ImportConsumerOverridesResponse;
    fromProtoMsg(message: ImportConsumerOverridesResponseProtoMsg): ImportConsumerOverridesResponse;
    toProto(message: ImportConsumerOverridesResponse): Uint8Array;
    toProtoMsg(message: ImportConsumerOverridesResponse): ImportConsumerOverridesResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const ImportConsumerOverridesMetadata: {
    typeUrl: string;
    is(o: any): o is ImportConsumerOverridesMetadata;
    isSDK(o: any): o is ImportConsumerOverridesMetadataSDKType;
    isAmino(o: any): o is ImportConsumerOverridesMetadataAmino;
    encode(_: ImportConsumerOverridesMetadata, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ImportConsumerOverridesMetadata;
    fromJSON(_: any): ImportConsumerOverridesMetadata;
    toJSON(_: ImportConsumerOverridesMetadata): JsonSafe<ImportConsumerOverridesMetadata>;
    fromPartial(_: DeepPartial<ImportConsumerOverridesMetadata>): ImportConsumerOverridesMetadata;
    fromSDK(_: ImportConsumerOverridesMetadataSDKType): ImportConsumerOverridesMetadata;
    fromSDKJSON(_: any): ImportConsumerOverridesMetadataSDKType;
    toSDK(_: ImportConsumerOverridesMetadata): ImportConsumerOverridesMetadataSDKType;
    fromAmino(_: ImportConsumerOverridesMetadataAmino): ImportConsumerOverridesMetadata;
    toAmino(_: ImportConsumerOverridesMetadata): ImportConsumerOverridesMetadataAmino;
    fromAminoMsg(object: ImportConsumerOverridesMetadataAminoMsg): ImportConsumerOverridesMetadata;
    fromProtoMsg(message: ImportConsumerOverridesMetadataProtoMsg): ImportConsumerOverridesMetadata;
    toProto(message: ImportConsumerOverridesMetadata): Uint8Array;
    toProtoMsg(message: ImportConsumerOverridesMetadata): ImportConsumerOverridesMetadataProtoMsg;
    registerTypeUrl(): void;
};
export declare const ImportAdminQuotaPoliciesResponse: {
    typeUrl: string;
    is(o: any): o is ImportAdminQuotaPoliciesResponse;
    isSDK(o: any): o is ImportAdminQuotaPoliciesResponseSDKType;
    isAmino(o: any): o is ImportAdminQuotaPoliciesResponseAmino;
    encode(message: ImportAdminQuotaPoliciesResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ImportAdminQuotaPoliciesResponse;
    fromJSON(object: any): ImportAdminQuotaPoliciesResponse;
    toJSON(message: ImportAdminQuotaPoliciesResponse): JsonSafe<ImportAdminQuotaPoliciesResponse>;
    fromPartial(object: DeepPartial<ImportAdminQuotaPoliciesResponse>): ImportAdminQuotaPoliciesResponse;
    fromSDK(object: ImportAdminQuotaPoliciesResponseSDKType): ImportAdminQuotaPoliciesResponse;
    fromSDKJSON(object: any): ImportAdminQuotaPoliciesResponseSDKType;
    toSDK(message: ImportAdminQuotaPoliciesResponse): ImportAdminQuotaPoliciesResponseSDKType;
    fromAmino(object: ImportAdminQuotaPoliciesResponseAmino): ImportAdminQuotaPoliciesResponse;
    toAmino(message: ImportAdminQuotaPoliciesResponse): ImportAdminQuotaPoliciesResponseAmino;
    fromAminoMsg(object: ImportAdminQuotaPoliciesResponseAminoMsg): ImportAdminQuotaPoliciesResponse;
    fromProtoMsg(message: ImportAdminQuotaPoliciesResponseProtoMsg): ImportAdminQuotaPoliciesResponse;
    toProto(message: ImportAdminQuotaPoliciesResponse): Uint8Array;
    toProtoMsg(message: ImportAdminQuotaPoliciesResponse): ImportAdminQuotaPoliciesResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const ImportAdminQuotaPoliciesMetadata: {
    typeUrl: string;
    is(o: any): o is ImportAdminQuotaPoliciesMetadata;
    isSDK(o: any): o is ImportAdminQuotaPoliciesMetadataSDKType;
    isAmino(o: any): o is ImportAdminQuotaPoliciesMetadataAmino;
    encode(_: ImportAdminQuotaPoliciesMetadata, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): ImportAdminQuotaPoliciesMetadata;
    fromJSON(_: any): ImportAdminQuotaPoliciesMetadata;
    toJSON(_: ImportAdminQuotaPoliciesMetadata): JsonSafe<ImportAdminQuotaPoliciesMetadata>;
    fromPartial(_: DeepPartial<ImportAdminQuotaPoliciesMetadata>): ImportAdminQuotaPoliciesMetadata;
    fromSDK(_: ImportAdminQuotaPoliciesMetadataSDKType): ImportAdminQuotaPoliciesMetadata;
    fromSDKJSON(_: any): ImportAdminQuotaPoliciesMetadataSDKType;
    toSDK(_: ImportAdminQuotaPoliciesMetadata): ImportAdminQuotaPoliciesMetadataSDKType;
    fromAmino(_: ImportAdminQuotaPoliciesMetadataAmino): ImportAdminQuotaPoliciesMetadata;
    toAmino(_: ImportAdminQuotaPoliciesMetadata): ImportAdminQuotaPoliciesMetadataAmino;
    fromAminoMsg(object: ImportAdminQuotaPoliciesMetadataAminoMsg): ImportAdminQuotaPoliciesMetadata;
    fromProtoMsg(message: ImportAdminQuotaPoliciesMetadataProtoMsg): ImportAdminQuotaPoliciesMetadata;
    toProto(message: ImportAdminQuotaPoliciesMetadata): Uint8Array;
    toProtoMsg(message: ImportAdminQuotaPoliciesMetadata): ImportAdminQuotaPoliciesMetadataProtoMsg;
    registerTypeUrl(): void;
};
export declare const CreateAdminQuotaPolicyMetadata: {
    typeUrl: string;
    is(o: any): o is CreateAdminQuotaPolicyMetadata;
    isSDK(o: any): o is CreateAdminQuotaPolicyMetadataSDKType;
    isAmino(o: any): o is CreateAdminQuotaPolicyMetadataAmino;
    encode(_: CreateAdminQuotaPolicyMetadata, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): CreateAdminQuotaPolicyMetadata;
    fromJSON(_: any): CreateAdminQuotaPolicyMetadata;
    toJSON(_: CreateAdminQuotaPolicyMetadata): JsonSafe<CreateAdminQuotaPolicyMetadata>;
    fromPartial(_: DeepPartial<CreateAdminQuotaPolicyMetadata>): CreateAdminQuotaPolicyMetadata;
    fromSDK(_: CreateAdminQuotaPolicyMetadataSDKType): CreateAdminQuotaPolicyMetadata;
    fromSDKJSON(_: any): CreateAdminQuotaPolicyMetadataSDKType;
    toSDK(_: CreateAdminQuotaPolicyMetadata): CreateAdminQuotaPolicyMetadataSDKType;
    fromAmino(_: CreateAdminQuotaPolicyMetadataAmino): CreateAdminQuotaPolicyMetadata;
    toAmino(_: CreateAdminQuotaPolicyMetadata): CreateAdminQuotaPolicyMetadataAmino;
    fromAminoMsg(object: CreateAdminQuotaPolicyMetadataAminoMsg): CreateAdminQuotaPolicyMetadata;
    fromProtoMsg(message: CreateAdminQuotaPolicyMetadataProtoMsg): CreateAdminQuotaPolicyMetadata;
    toProto(message: CreateAdminQuotaPolicyMetadata): Uint8Array;
    toProtoMsg(message: CreateAdminQuotaPolicyMetadata): CreateAdminQuotaPolicyMetadataProtoMsg;
    registerTypeUrl(): void;
};
export declare const UpdateAdminQuotaPolicyMetadata: {
    typeUrl: string;
    is(o: any): o is UpdateAdminQuotaPolicyMetadata;
    isSDK(o: any): o is UpdateAdminQuotaPolicyMetadataSDKType;
    isAmino(o: any): o is UpdateAdminQuotaPolicyMetadataAmino;
    encode(_: UpdateAdminQuotaPolicyMetadata, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): UpdateAdminQuotaPolicyMetadata;
    fromJSON(_: any): UpdateAdminQuotaPolicyMetadata;
    toJSON(_: UpdateAdminQuotaPolicyMetadata): JsonSafe<UpdateAdminQuotaPolicyMetadata>;
    fromPartial(_: DeepPartial<UpdateAdminQuotaPolicyMetadata>): UpdateAdminQuotaPolicyMetadata;
    fromSDK(_: UpdateAdminQuotaPolicyMetadataSDKType): UpdateAdminQuotaPolicyMetadata;
    fromSDKJSON(_: any): UpdateAdminQuotaPolicyMetadataSDKType;
    toSDK(_: UpdateAdminQuotaPolicyMetadata): UpdateAdminQuotaPolicyMetadataSDKType;
    fromAmino(_: UpdateAdminQuotaPolicyMetadataAmino): UpdateAdminQuotaPolicyMetadata;
    toAmino(_: UpdateAdminQuotaPolicyMetadata): UpdateAdminQuotaPolicyMetadataAmino;
    fromAminoMsg(object: UpdateAdminQuotaPolicyMetadataAminoMsg): UpdateAdminQuotaPolicyMetadata;
    fromProtoMsg(message: UpdateAdminQuotaPolicyMetadataProtoMsg): UpdateAdminQuotaPolicyMetadata;
    toProto(message: UpdateAdminQuotaPolicyMetadata): Uint8Array;
    toProtoMsg(message: UpdateAdminQuotaPolicyMetadata): UpdateAdminQuotaPolicyMetadataProtoMsg;
    registerTypeUrl(): void;
};
export declare const DeleteAdminQuotaPolicyMetadata: {
    typeUrl: string;
    is(o: any): o is DeleteAdminQuotaPolicyMetadata;
    isSDK(o: any): o is DeleteAdminQuotaPolicyMetadataSDKType;
    isAmino(o: any): o is DeleteAdminQuotaPolicyMetadataAmino;
    encode(_: DeleteAdminQuotaPolicyMetadata, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): DeleteAdminQuotaPolicyMetadata;
    fromJSON(_: any): DeleteAdminQuotaPolicyMetadata;
    toJSON(_: DeleteAdminQuotaPolicyMetadata): JsonSafe<DeleteAdminQuotaPolicyMetadata>;
    fromPartial(_: DeepPartial<DeleteAdminQuotaPolicyMetadata>): DeleteAdminQuotaPolicyMetadata;
    fromSDK(_: DeleteAdminQuotaPolicyMetadataSDKType): DeleteAdminQuotaPolicyMetadata;
    fromSDKJSON(_: any): DeleteAdminQuotaPolicyMetadataSDKType;
    toSDK(_: DeleteAdminQuotaPolicyMetadata): DeleteAdminQuotaPolicyMetadataSDKType;
    fromAmino(_: DeleteAdminQuotaPolicyMetadataAmino): DeleteAdminQuotaPolicyMetadata;
    toAmino(_: DeleteAdminQuotaPolicyMetadata): DeleteAdminQuotaPolicyMetadataAmino;
    fromAminoMsg(object: DeleteAdminQuotaPolicyMetadataAminoMsg): DeleteAdminQuotaPolicyMetadata;
    fromProtoMsg(message: DeleteAdminQuotaPolicyMetadataProtoMsg): DeleteAdminQuotaPolicyMetadata;
    toProto(message: DeleteAdminQuotaPolicyMetadata): Uint8Array;
    toProtoMsg(message: DeleteAdminQuotaPolicyMetadata): DeleteAdminQuotaPolicyMetadataProtoMsg;
    registerTypeUrl(): void;
};
export declare const GenerateServiceIdentityRequest: {
    typeUrl: string;
    is(o: any): o is GenerateServiceIdentityRequest;
    isSDK(o: any): o is GenerateServiceIdentityRequestSDKType;
    isAmino(o: any): o is GenerateServiceIdentityRequestAmino;
    encode(message: GenerateServiceIdentityRequest, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GenerateServiceIdentityRequest;
    fromJSON(object: any): GenerateServiceIdentityRequest;
    toJSON(message: GenerateServiceIdentityRequest): JsonSafe<GenerateServiceIdentityRequest>;
    fromPartial(object: DeepPartial<GenerateServiceIdentityRequest>): GenerateServiceIdentityRequest;
    fromSDK(object: GenerateServiceIdentityRequestSDKType): GenerateServiceIdentityRequest;
    fromSDKJSON(object: any): GenerateServiceIdentityRequestSDKType;
    toSDK(message: GenerateServiceIdentityRequest): GenerateServiceIdentityRequestSDKType;
    fromAmino(object: GenerateServiceIdentityRequestAmino): GenerateServiceIdentityRequest;
    toAmino(message: GenerateServiceIdentityRequest): GenerateServiceIdentityRequestAmino;
    fromAminoMsg(object: GenerateServiceIdentityRequestAminoMsg): GenerateServiceIdentityRequest;
    fromProtoMsg(message: GenerateServiceIdentityRequestProtoMsg): GenerateServiceIdentityRequest;
    toProto(message: GenerateServiceIdentityRequest): Uint8Array;
    toProtoMsg(message: GenerateServiceIdentityRequest): GenerateServiceIdentityRequestProtoMsg;
    registerTypeUrl(): void;
};
export declare const GetServiceIdentityResponse: {
    typeUrl: string;
    is(o: any): o is GetServiceIdentityResponse;
    isSDK(o: any): o is GetServiceIdentityResponseSDKType;
    isAmino(o: any): o is GetServiceIdentityResponseAmino;
    encode(message: GetServiceIdentityResponse, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GetServiceIdentityResponse;
    fromJSON(object: any): GetServiceIdentityResponse;
    toJSON(message: GetServiceIdentityResponse): JsonSafe<GetServiceIdentityResponse>;
    fromPartial(object: DeepPartial<GetServiceIdentityResponse>): GetServiceIdentityResponse;
    fromSDK(object: GetServiceIdentityResponseSDKType): GetServiceIdentityResponse;
    fromSDKJSON(object: any): GetServiceIdentityResponseSDKType;
    toSDK(message: GetServiceIdentityResponse): GetServiceIdentityResponseSDKType;
    fromAmino(object: GetServiceIdentityResponseAmino): GetServiceIdentityResponse;
    toAmino(message: GetServiceIdentityResponse): GetServiceIdentityResponseAmino;
    fromAminoMsg(object: GetServiceIdentityResponseAminoMsg): GetServiceIdentityResponse;
    fromProtoMsg(message: GetServiceIdentityResponseProtoMsg): GetServiceIdentityResponse;
    toProto(message: GetServiceIdentityResponse): Uint8Array;
    toProtoMsg(message: GetServiceIdentityResponse): GetServiceIdentityResponseProtoMsg;
    registerTypeUrl(): void;
};
export declare const GetServiceIdentityMetadata: {
    typeUrl: string;
    is(o: any): o is GetServiceIdentityMetadata;
    isSDK(o: any): o is GetServiceIdentityMetadataSDKType;
    isAmino(o: any): o is GetServiceIdentityMetadataAmino;
    encode(_: GetServiceIdentityMetadata, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): GetServiceIdentityMetadata;
    fromJSON(_: any): GetServiceIdentityMetadata;
    toJSON(_: GetServiceIdentityMetadata): JsonSafe<GetServiceIdentityMetadata>;
    fromPartial(_: DeepPartial<GetServiceIdentityMetadata>): GetServiceIdentityMetadata;
    fromSDK(_: GetServiceIdentityMetadataSDKType): GetServiceIdentityMetadata;
    fromSDKJSON(_: any): GetServiceIdentityMetadataSDKType;
    toSDK(_: GetServiceIdentityMetadata): GetServiceIdentityMetadataSDKType;
    fromAmino(_: GetServiceIdentityMetadataAmino): GetServiceIdentityMetadata;
    toAmino(_: GetServiceIdentityMetadata): GetServiceIdentityMetadataAmino;
    fromAminoMsg(object: GetServiceIdentityMetadataAminoMsg): GetServiceIdentityMetadata;
    fromProtoMsg(message: GetServiceIdentityMetadataProtoMsg): GetServiceIdentityMetadata;
    toProto(message: GetServiceIdentityMetadata): Uint8Array;
    toProtoMsg(message: GetServiceIdentityMetadata): GetServiceIdentityMetadataProtoMsg;
    registerTypeUrl(): void;
};
