import { Any, AnyAmino, AnySDKType } from "../protobuf/any";
import { BinaryReader, BinaryWriter } from "../../binary";
import { JsonSafe } from "../../json-safe";
import { DeepPartial } from "../../helpers";
export declare const protobufPackage = "google.api";
/** Source information used to create a Service Config */
export interface SourceInfo {
    /** All files used during config generation. */
    sourceFiles: Any[];
}
export interface SourceInfoProtoMsg {
    typeUrl: "/google.api.SourceInfo";
    value: Uint8Array;
}
/** Source information used to create a Service Config */
export interface SourceInfoAmino {
    /** All files used during config generation. */
    source_files?: AnyAmino[];
}
export interface SourceInfoAminoMsg {
    type: "/google.api.SourceInfo";
    value: SourceInfoAmino;
}
/** Source information used to create a Service Config */
export interface SourceInfoSDKType {
    source_files: AnySDKType[];
}
export declare const SourceInfo: {
    typeUrl: string;
    is(o: any): o is SourceInfo;
    isSDK(o: any): o is SourceInfoSDKType;
    isAmino(o: any): o is SourceInfoAmino;
    encode(message: SourceInfo, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): SourceInfo;
    fromJSON(object: any): SourceInfo;
    toJSON(message: SourceInfo): JsonSafe<SourceInfo>;
    fromPartial(object: DeepPartial<SourceInfo>): SourceInfo;
    fromSDK(object: SourceInfoSDKType): SourceInfo;
    fromSDKJSON(object: any): SourceInfoSDKType;
    toSDK(message: SourceInfo): SourceInfoSDKType;
    fromAmino(object: SourceInfoAmino): SourceInfo;
    toAmino(message: SourceInfo): SourceInfoAmino;
    fromAminoMsg(object: SourceInfoAminoMsg): SourceInfo;
    fromProtoMsg(message: SourceInfoProtoMsg): SourceInfo;
    toProto(message: SourceInfo): Uint8Array;
    toProtoMsg(message: SourceInfo): SourceInfoProtoMsg;
    registerTypeUrl(): void;
};
