import { Any } from "../protobuf/any";
import { BinaryReader, BinaryWriter } from "../../binary";
export const protobufPackage = "google.api";
function createBaseSourceInfo() {
    return {
        sourceFiles: []
    };
}
export const SourceInfo = {
    typeUrl: "/google.api.SourceInfo",
    is(o) {
        return o && (o.$typeUrl === SourceInfo.typeUrl || Array.isArray(o.sourceFiles) && (!o.sourceFiles.length || Any.is(o.sourceFiles[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === SourceInfo.typeUrl || Array.isArray(o.source_files) && (!o.source_files.length || Any.isSDK(o.source_files[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === SourceInfo.typeUrl || Array.isArray(o.source_files) && (!o.source_files.length || Any.isAmino(o.source_files[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.sourceFiles) {
            Any.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSourceInfo();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.sourceFiles.push(Any.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseSourceInfo();
        if (Array.isArray(object?.sourceFiles))
            obj.sourceFiles = object.sourceFiles.map((e) => Any.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.sourceFiles) {
            obj.sourceFiles = message.sourceFiles.map(e => e ? Any.toJSON(e) : undefined);
        }
        else {
            obj.sourceFiles = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseSourceInfo();
        message.sourceFiles = object.sourceFiles?.map(e => Any.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            sourceFiles: Array.isArray(object?.source_files) ? object.source_files.map((e) => Any.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            source_files: Array.isArray(object?.source_files) ? object.source_files.map((e) => Any.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.sourceFiles) {
            obj.source_files = message.sourceFiles.map(e => e ? Any.toSDK(e) : undefined);
        }
        else {
            obj.source_files = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseSourceInfo();
        message.sourceFiles = object.source_files?.map(e => Any.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.sourceFiles) {
            obj.source_files = message.sourceFiles.map(e => e ? Any.toAmino(e) : undefined);
        }
        else {
            obj.source_files = message.sourceFiles;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return SourceInfo.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return SourceInfo.decode(message.value);
    },
    toProto(message) {
        return SourceInfo.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.SourceInfo",
            value: SourceInfo.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
