import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseSystemParameters() {
    return {
        rules: []
    };
}
export const SystemParameters = {
    typeUrl: "/google.api.SystemParameters",
    is(o) {
        return o && (o.$typeUrl === SystemParameters.typeUrl || Array.isArray(o.rules) && (!o.rules.length || SystemParameterRule.is(o.rules[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === SystemParameters.typeUrl || Array.isArray(o.rules) && (!o.rules.length || SystemParameterRule.isSDK(o.rules[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === SystemParameters.typeUrl || Array.isArray(o.rules) && (!o.rules.length || SystemParameterRule.isAmino(o.rules[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.rules) {
            SystemParameterRule.encode(v, writer.uint32(10).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSystemParameters();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.rules.push(SystemParameterRule.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseSystemParameters();
        if (Array.isArray(object?.rules))
            obj.rules = object.rules.map((e) => SystemParameterRule.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? SystemParameterRule.toJSON(e) : undefined);
        }
        else {
            obj.rules = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseSystemParameters();
        message.rules = object.rules?.map(e => SystemParameterRule.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            rules: Array.isArray(object?.rules) ? object.rules.map((e) => SystemParameterRule.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            rules: Array.isArray(object?.rules) ? object.rules.map((e) => SystemParameterRule.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? SystemParameterRule.toSDK(e) : undefined);
        }
        else {
            obj.rules = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseSystemParameters();
        message.rules = object.rules?.map(e => SystemParameterRule.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? SystemParameterRule.toAmino(e) : undefined);
        }
        else {
            obj.rules = message.rules;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return SystemParameters.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return SystemParameters.decode(message.value);
    },
    toProto(message) {
        return SystemParameters.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.SystemParameters",
            value: SystemParameters.encode(message).finish()
        };
    },
    registerTypeUrl() {
        SystemParameterRule.registerTypeUrl();
    }
};
function createBaseSystemParameterRule() {
    return {
        selector: "",
        parameters: []
    };
}
export const SystemParameterRule = {
    typeUrl: "/google.api.SystemParameterRule",
    is(o) {
        return o && (o.$typeUrl === SystemParameterRule.typeUrl || typeof o.selector === "string" && Array.isArray(o.parameters) && (!o.parameters.length || SystemParameter.is(o.parameters[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === SystemParameterRule.typeUrl || typeof o.selector === "string" && Array.isArray(o.parameters) && (!o.parameters.length || SystemParameter.isSDK(o.parameters[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === SystemParameterRule.typeUrl || typeof o.selector === "string" && Array.isArray(o.parameters) && (!o.parameters.length || SystemParameter.isAmino(o.parameters[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.selector !== undefined) {
            writer.uint32(10).string(message.selector);
        }
        for (const v of message.parameters) {
            SystemParameter.encode(v, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSystemParameterRule();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.selector = reader.string();
                    break;
                case 2:
                    message.parameters.push(SystemParameter.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseSystemParameterRule();
        if (isSet(object.selector))
            obj.selector = String(object.selector);
        if (Array.isArray(object?.parameters))
            obj.parameters = object.parameters.map((e) => SystemParameter.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.selector !== undefined && (obj.selector = message.selector);
        if (message.parameters) {
            obj.parameters = message.parameters.map(e => e ? SystemParameter.toJSON(e) : undefined);
        }
        else {
            obj.parameters = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseSystemParameterRule();
        message.selector = object.selector ?? "";
        message.parameters = object.parameters?.map(e => SystemParameter.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            selector: object?.selector,
            parameters: Array.isArray(object?.parameters) ? object.parameters.map((e) => SystemParameter.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            selector: isSet(object.selector) ? String(object.selector) : "",
            parameters: Array.isArray(object?.parameters) ? object.parameters.map((e) => SystemParameter.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.selector = message.selector;
        if (message.parameters) {
            obj.parameters = message.parameters.map(e => e ? SystemParameter.toSDK(e) : undefined);
        }
        else {
            obj.parameters = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseSystemParameterRule();
        if (object.selector !== undefined && object.selector !== null) {
            message.selector = object.selector;
        }
        message.parameters = object.parameters?.map(e => SystemParameter.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.selector = message.selector === "" ? undefined : message.selector;
        if (message.parameters) {
            obj.parameters = message.parameters.map(e => e ? SystemParameter.toAmino(e) : undefined);
        }
        else {
            obj.parameters = message.parameters;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return SystemParameterRule.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return SystemParameterRule.decode(message.value);
    },
    toProto(message) {
        return SystemParameterRule.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.SystemParameterRule",
            value: SystemParameterRule.encode(message).finish()
        };
    },
    registerTypeUrl() {
        SystemParameter.registerTypeUrl();
    }
};
function createBaseSystemParameter() {
    return {
        name: "",
        httpHeader: "",
        urlQueryParameter: ""
    };
}
export const SystemParameter = {
    typeUrl: "/google.api.SystemParameter",
    is(o) {
        return o && (o.$typeUrl === SystemParameter.typeUrl || typeof o.name === "string" && typeof o.httpHeader === "string" && typeof o.urlQueryParameter === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === SystemParameter.typeUrl || typeof o.name === "string" && typeof o.http_header === "string" && typeof o.url_query_parameter === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === SystemParameter.typeUrl || typeof o.name === "string" && typeof o.http_header === "string" && typeof o.url_query_parameter === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.httpHeader !== undefined) {
            writer.uint32(18).string(message.httpHeader);
        }
        if (message.urlQueryParameter !== undefined) {
            writer.uint32(26).string(message.urlQueryParameter);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSystemParameter();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.httpHeader = reader.string();
                    break;
                case 3:
                    message.urlQueryParameter = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseSystemParameter();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.httpHeader))
            obj.httpHeader = String(object.httpHeader);
        if (isSet(object.urlQueryParameter))
            obj.urlQueryParameter = String(object.urlQueryParameter);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.httpHeader !== undefined && (obj.httpHeader = message.httpHeader);
        message.urlQueryParameter !== undefined && (obj.urlQueryParameter = message.urlQueryParameter);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseSystemParameter();
        message.name = object.name ?? "";
        message.httpHeader = object.httpHeader ?? "";
        message.urlQueryParameter = object.urlQueryParameter ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            httpHeader: object?.http_header,
            urlQueryParameter: object?.url_query_parameter
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            http_header: isSet(object.http_header) ? String(object.http_header) : "",
            url_query_parameter: isSet(object.url_query_parameter) ? String(object.url_query_parameter) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.http_header = message.httpHeader;
        obj.url_query_parameter = message.urlQueryParameter;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseSystemParameter();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.http_header !== undefined && object.http_header !== null) {
            message.httpHeader = object.http_header;
        }
        if (object.url_query_parameter !== undefined && object.url_query_parameter !== null) {
            message.urlQueryParameter = object.url_query_parameter;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.http_header = message.httpHeader === "" ? undefined : message.httpHeader;
        obj.url_query_parameter = message.urlQueryParameter === "" ? undefined : message.urlQueryParameter;
        return obj;
    },
    fromAminoMsg(object) {
        return SystemParameter.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return SystemParameter.decode(message.value);
    },
    toProto(message) {
        return SystemParameter.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.SystemParameter",
            value: SystemParameter.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
