import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.api";
function createBaseUsage() {
    return {
        requirements: [],
        rules: [],
        producerNotificationChannel: ""
    };
}
export const Usage = {
    typeUrl: "/google.api.Usage",
    is(o) {
        return o && (o.$typeUrl === Usage.typeUrl || Array.isArray(o.requirements) && (!o.requirements.length || typeof o.requirements[0] === "string") && Array.isArray(o.rules) && (!o.rules.length || UsageRule.is(o.rules[0])) && typeof o.producerNotificationChannel === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Usage.typeUrl || Array.isArray(o.requirements) && (!o.requirements.length || typeof o.requirements[0] === "string") && Array.isArray(o.rules) && (!o.rules.length || UsageRule.isSDK(o.rules[0])) && typeof o.producer_notification_channel === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Usage.typeUrl || Array.isArray(o.requirements) && (!o.requirements.length || typeof o.requirements[0] === "string") && Array.isArray(o.rules) && (!o.rules.length || UsageRule.isAmino(o.rules[0])) && typeof o.producer_notification_channel === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.requirements) {
            writer.uint32(10).string(v);
        }
        for (const v of message.rules) {
            UsageRule.encode(v, writer.uint32(50).fork()).ldelim();
        }
        if (message.producerNotificationChannel !== undefined) {
            writer.uint32(58).string(message.producerNotificationChannel);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUsage();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.requirements.push(reader.string());
                    break;
                case 6:
                    message.rules.push(UsageRule.decode(reader, reader.uint32()));
                    break;
                case 7:
                    message.producerNotificationChannel = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseUsage();
        if (Array.isArray(object?.requirements))
            obj.requirements = object.requirements.map((e) => String(e));
        if (Array.isArray(object?.rules))
            obj.rules = object.rules.map((e) => UsageRule.fromJSON(e));
        if (isSet(object.producerNotificationChannel))
            obj.producerNotificationChannel = String(object.producerNotificationChannel);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.requirements) {
            obj.requirements = message.requirements.map(e => e);
        }
        else {
            obj.requirements = [];
        }
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? UsageRule.toJSON(e) : undefined);
        }
        else {
            obj.rules = [];
        }
        message.producerNotificationChannel !== undefined && (obj.producerNotificationChannel = message.producerNotificationChannel);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseUsage();
        message.requirements = object.requirements?.map(e => e) || [];
        message.rules = object.rules?.map(e => UsageRule.fromPartial(e)) || [];
        message.producerNotificationChannel = object.producerNotificationChannel ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            requirements: Array.isArray(object?.requirements) ? object.requirements.map((e) => e) : [],
            rules: Array.isArray(object?.rules) ? object.rules.map((e) => UsageRule.fromSDK(e)) : [],
            producerNotificationChannel: object?.producer_notification_channel
        };
    },
    fromSDKJSON(object) {
        return {
            requirements: Array.isArray(object?.requirements) ? object.requirements.map((e) => String(e)) : [],
            rules: Array.isArray(object?.rules) ? object.rules.map((e) => UsageRule.fromSDKJSON(e)) : [],
            producer_notification_channel: isSet(object.producer_notification_channel) ? String(object.producer_notification_channel) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.requirements) {
            obj.requirements = message.requirements.map(e => e);
        }
        else {
            obj.requirements = [];
        }
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? UsageRule.toSDK(e) : undefined);
        }
        else {
            obj.rules = [];
        }
        obj.producer_notification_channel = message.producerNotificationChannel;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseUsage();
        message.requirements = object.requirements?.map(e => e) || [];
        message.rules = object.rules?.map(e => UsageRule.fromAmino(e)) || [];
        if (object.producer_notification_channel !== undefined && object.producer_notification_channel !== null) {
            message.producerNotificationChannel = object.producer_notification_channel;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.requirements) {
            obj.requirements = message.requirements.map(e => e);
        }
        else {
            obj.requirements = message.requirements;
        }
        if (message.rules) {
            obj.rules = message.rules.map(e => e ? UsageRule.toAmino(e) : undefined);
        }
        else {
            obj.rules = message.rules;
        }
        obj.producer_notification_channel = message.producerNotificationChannel === "" ? undefined : message.producerNotificationChannel;
        return obj;
    },
    fromAminoMsg(object) {
        return Usage.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Usage.decode(message.value);
    },
    toProto(message) {
        return Usage.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.Usage",
            value: Usage.encode(message).finish()
        };
    },
    registerTypeUrl() {
        UsageRule.registerTypeUrl();
    }
};
function createBaseUsageRule() {
    return {
        selector: "",
        allowUnregisteredCalls: false,
        skipServiceControl: false
    };
}
export const UsageRule = {
    typeUrl: "/google.api.UsageRule",
    is(o) {
        return o && (o.$typeUrl === UsageRule.typeUrl || typeof o.selector === "string" && typeof o.allowUnregisteredCalls === "boolean" && typeof o.skipServiceControl === "boolean");
    },
    isSDK(o) {
        return o && (o.$typeUrl === UsageRule.typeUrl || typeof o.selector === "string" && typeof o.allow_unregistered_calls === "boolean" && typeof o.skip_service_control === "boolean");
    },
    isAmino(o) {
        return o && (o.$typeUrl === UsageRule.typeUrl || typeof o.selector === "string" && typeof o.allow_unregistered_calls === "boolean" && typeof o.skip_service_control === "boolean");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.selector !== undefined) {
            writer.uint32(10).string(message.selector);
        }
        if (message.allowUnregisteredCalls !== undefined) {
            writer.uint32(16).bool(message.allowUnregisteredCalls);
        }
        if (message.skipServiceControl !== undefined) {
            writer.uint32(24).bool(message.skipServiceControl);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUsageRule();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.selector = reader.string();
                    break;
                case 2:
                    message.allowUnregisteredCalls = reader.bool();
                    break;
                case 3:
                    message.skipServiceControl = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseUsageRule();
        if (isSet(object.selector))
            obj.selector = String(object.selector);
        if (isSet(object.allowUnregisteredCalls))
            obj.allowUnregisteredCalls = Boolean(object.allowUnregisteredCalls);
        if (isSet(object.skipServiceControl))
            obj.skipServiceControl = Boolean(object.skipServiceControl);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.selector !== undefined && (obj.selector = message.selector);
        message.allowUnregisteredCalls !== undefined && (obj.allowUnregisteredCalls = message.allowUnregisteredCalls);
        message.skipServiceControl !== undefined && (obj.skipServiceControl = message.skipServiceControl);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseUsageRule();
        message.selector = object.selector ?? "";
        message.allowUnregisteredCalls = object.allowUnregisteredCalls ?? false;
        message.skipServiceControl = object.skipServiceControl ?? false;
        return message;
    },
    fromSDK(object) {
        return {
            selector: object?.selector,
            allowUnregisteredCalls: object?.allow_unregistered_calls,
            skipServiceControl: object?.skip_service_control
        };
    },
    fromSDKJSON(object) {
        return {
            selector: isSet(object.selector) ? String(object.selector) : "",
            allow_unregistered_calls: isSet(object.allow_unregistered_calls) ? Boolean(object.allow_unregistered_calls) : false,
            skip_service_control: isSet(object.skip_service_control) ? Boolean(object.skip_service_control) : false
        };
    },
    toSDK(message) {
        const obj = {};
        obj.selector = message.selector;
        obj.allow_unregistered_calls = message.allowUnregisteredCalls;
        obj.skip_service_control = message.skipServiceControl;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseUsageRule();
        if (object.selector !== undefined && object.selector !== null) {
            message.selector = object.selector;
        }
        if (object.allow_unregistered_calls !== undefined && object.allow_unregistered_calls !== null) {
            message.allowUnregisteredCalls = object.allow_unregistered_calls;
        }
        if (object.skip_service_control !== undefined && object.skip_service_control !== null) {
            message.skipServiceControl = object.skip_service_control;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.selector = message.selector === "" ? undefined : message.selector;
        obj.allow_unregistered_calls = message.allowUnregisteredCalls === false ? undefined : message.allowUnregisteredCalls;
        obj.skip_service_control = message.skipServiceControl === false ? undefined : message.skipServiceControl;
        return obj;
    },
    fromAminoMsg(object) {
        return UsageRule.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return UsageRule.decode(message.value);
    },
    toProto(message) {
        return UsageRule.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.api.UsageRule",
            value: UsageRule.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
