import { FieldMask } from "../../protobuf/field_mask";
import { Timestamp } from "../../protobuf/timestamp";
import { isSet, toTimestamp, fromTimestamp } from "../../../helpers";
import { BinaryReader, BinaryWriter } from "../../../binary";
export const protobufPackage = "google.logging.v2";
/** Deprecated. This is unused. */
export var LogSink_VersionFormat;
(function (LogSink_VersionFormat) {
    /** VERSION_FORMAT_UNSPECIFIED - An unspecified format version that will default to V2. */
    LogSink_VersionFormat[LogSink_VersionFormat["VERSION_FORMAT_UNSPECIFIED"] = 0] = "VERSION_FORMAT_UNSPECIFIED";
    /** V2 - `LogEntry` version 2 format. */
    LogSink_VersionFormat[LogSink_VersionFormat["V2"] = 1] = "V2";
    /** V1 - `LogEntry` version 1 format. */
    LogSink_VersionFormat[LogSink_VersionFormat["V1"] = 2] = "V1";
    LogSink_VersionFormat[LogSink_VersionFormat["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(LogSink_VersionFormat || (LogSink_VersionFormat = {}));
export const LogSink_VersionFormatSDKType = LogSink_VersionFormat;
export const LogSink_VersionFormatAmino = LogSink_VersionFormat;
export function logSink_VersionFormatFromJSON(object) {
    switch (object) {
        case 0:
        case "VERSION_FORMAT_UNSPECIFIED":
            return LogSink_VersionFormat.VERSION_FORMAT_UNSPECIFIED;
        case 1:
        case "V2":
            return LogSink_VersionFormat.V2;
        case 2:
        case "V1":
            return LogSink_VersionFormat.V1;
        case -1:
        case "UNRECOGNIZED":
        default:
            return LogSink_VersionFormat.UNRECOGNIZED;
    }
}
export function logSink_VersionFormatToJSON(object) {
    switch (object) {
        case LogSink_VersionFormat.VERSION_FORMAT_UNSPECIFIED:
            return "VERSION_FORMAT_UNSPECIFIED";
        case LogSink_VersionFormat.V2:
            return "V2";
        case LogSink_VersionFormat.V1:
            return "V1";
        case LogSink_VersionFormat.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
/** LogBucket lifecycle states. */
export var LifecycleState;
(function (LifecycleState) {
    /**
     * LIFECYCLE_STATE_UNSPECIFIED - Unspecified state. This is only used/useful for distinguishing unset
     * values.
     */
    LifecycleState[LifecycleState["LIFECYCLE_STATE_UNSPECIFIED"] = 0] = "LIFECYCLE_STATE_UNSPECIFIED";
    /** ACTIVE - The normal and active state. */
    LifecycleState[LifecycleState["ACTIVE"] = 1] = "ACTIVE";
    /**
     * DELETE_REQUESTED - The resource has been marked for deletion by the user. For some resources
     * (e.g. buckets), this can be reversed by an un-delete operation.
     */
    LifecycleState[LifecycleState["DELETE_REQUESTED"] = 2] = "DELETE_REQUESTED";
    LifecycleState[LifecycleState["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(LifecycleState || (LifecycleState = {}));
export const LifecycleStateSDKType = LifecycleState;
export const LifecycleStateAmino = LifecycleState;
export function lifecycleStateFromJSON(object) {
    switch (object) {
        case 0:
        case "LIFECYCLE_STATE_UNSPECIFIED":
            return LifecycleState.LIFECYCLE_STATE_UNSPECIFIED;
        case 1:
        case "ACTIVE":
            return LifecycleState.ACTIVE;
        case 2:
        case "DELETE_REQUESTED":
            return LifecycleState.DELETE_REQUESTED;
        case -1:
        case "UNRECOGNIZED":
        default:
            return LifecycleState.UNRECOGNIZED;
    }
}
export function lifecycleStateToJSON(object) {
    switch (object) {
        case LifecycleState.LIFECYCLE_STATE_UNSPECIFIED:
            return "LIFECYCLE_STATE_UNSPECIFIED";
        case LifecycleState.ACTIVE:
            return "ACTIVE";
        case LifecycleState.DELETE_REQUESTED:
            return "DELETE_REQUESTED";
        case LifecycleState.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
/**
 * List of different operation states.
 * High level state of the operation. This is used to report the job's
 * current state to the user. Once a long running operation is created,
 * the current state of the operation can be queried even before the
 * operation is finished and the final result is available.
 */
export var OperationState;
(function (OperationState) {
    /** OPERATION_STATE_UNSPECIFIED - Should not be used. */
    OperationState[OperationState["OPERATION_STATE_UNSPECIFIED"] = 0] = "OPERATION_STATE_UNSPECIFIED";
    /** OPERATION_STATE_SCHEDULED - The operation is scheduled. */
    OperationState[OperationState["OPERATION_STATE_SCHEDULED"] = 1] = "OPERATION_STATE_SCHEDULED";
    /** OPERATION_STATE_WAITING_FOR_PERMISSIONS - Waiting for necessary permissions. */
    OperationState[OperationState["OPERATION_STATE_WAITING_FOR_PERMISSIONS"] = 2] = "OPERATION_STATE_WAITING_FOR_PERMISSIONS";
    /** OPERATION_STATE_RUNNING - The operation is running. */
    OperationState[OperationState["OPERATION_STATE_RUNNING"] = 3] = "OPERATION_STATE_RUNNING";
    /** OPERATION_STATE_SUCCEEDED - The operation was completed successfully. */
    OperationState[OperationState["OPERATION_STATE_SUCCEEDED"] = 4] = "OPERATION_STATE_SUCCEEDED";
    /** OPERATION_STATE_FAILED - The operation failed. */
    OperationState[OperationState["OPERATION_STATE_FAILED"] = 5] = "OPERATION_STATE_FAILED";
    /** OPERATION_STATE_CANCELLED - The operation was cancelled by the user. */
    OperationState[OperationState["OPERATION_STATE_CANCELLED"] = 6] = "OPERATION_STATE_CANCELLED";
    OperationState[OperationState["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(OperationState || (OperationState = {}));
export const OperationStateSDKType = OperationState;
export const OperationStateAmino = OperationState;
export function operationStateFromJSON(object) {
    switch (object) {
        case 0:
        case "OPERATION_STATE_UNSPECIFIED":
            return OperationState.OPERATION_STATE_UNSPECIFIED;
        case 1:
        case "OPERATION_STATE_SCHEDULED":
            return OperationState.OPERATION_STATE_SCHEDULED;
        case 2:
        case "OPERATION_STATE_WAITING_FOR_PERMISSIONS":
            return OperationState.OPERATION_STATE_WAITING_FOR_PERMISSIONS;
        case 3:
        case "OPERATION_STATE_RUNNING":
            return OperationState.OPERATION_STATE_RUNNING;
        case 4:
        case "OPERATION_STATE_SUCCEEDED":
            return OperationState.OPERATION_STATE_SUCCEEDED;
        case 5:
        case "OPERATION_STATE_FAILED":
            return OperationState.OPERATION_STATE_FAILED;
        case 6:
        case "OPERATION_STATE_CANCELLED":
            return OperationState.OPERATION_STATE_CANCELLED;
        case -1:
        case "UNRECOGNIZED":
        default:
            return OperationState.UNRECOGNIZED;
    }
}
export function operationStateToJSON(object) {
    switch (object) {
        case OperationState.OPERATION_STATE_UNSPECIFIED:
            return "OPERATION_STATE_UNSPECIFIED";
        case OperationState.OPERATION_STATE_SCHEDULED:
            return "OPERATION_STATE_SCHEDULED";
        case OperationState.OPERATION_STATE_WAITING_FOR_PERMISSIONS:
            return "OPERATION_STATE_WAITING_FOR_PERMISSIONS";
        case OperationState.OPERATION_STATE_RUNNING:
            return "OPERATION_STATE_RUNNING";
        case OperationState.OPERATION_STATE_SUCCEEDED:
            return "OPERATION_STATE_SUCCEEDED";
        case OperationState.OPERATION_STATE_FAILED:
            return "OPERATION_STATE_FAILED";
        case OperationState.OPERATION_STATE_CANCELLED:
            return "OPERATION_STATE_CANCELLED";
        case OperationState.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
function createBaseLogBucket() {
    return {
        name: "",
        description: "",
        createTime: undefined,
        updateTime: undefined,
        retentionDays: 0,
        locked: false,
        lifecycleState: 0,
        restrictedFields: [],
        cmekSettings: undefined
    };
}
export const LogBucket = {
    typeUrl: "/google.logging.v2.LogBucket",
    is(o) {
        return o && (o.$typeUrl === LogBucket.typeUrl || typeof o.name === "string" && typeof o.description === "string" && typeof o.retentionDays === "number" && typeof o.locked === "boolean" && isSet(o.lifecycleState) && Array.isArray(o.restrictedFields) && (!o.restrictedFields.length || typeof o.restrictedFields[0] === "string"));
    },
    isSDK(o) {
        return o && (o.$typeUrl === LogBucket.typeUrl || typeof o.name === "string" && typeof o.description === "string" && typeof o.retention_days === "number" && typeof o.locked === "boolean" && isSet(o.lifecycle_state) && Array.isArray(o.restricted_fields) && (!o.restricted_fields.length || typeof o.restricted_fields[0] === "string"));
    },
    isAmino(o) {
        return o && (o.$typeUrl === LogBucket.typeUrl || typeof o.name === "string" && typeof o.description === "string" && typeof o.retention_days === "number" && typeof o.locked === "boolean" && isSet(o.lifecycle_state) && Array.isArray(o.restricted_fields) && (!o.restricted_fields.length || typeof o.restricted_fields[0] === "string"));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.description !== undefined) {
            writer.uint32(26).string(message.description);
        }
        if (message.createTime !== undefined) {
            Timestamp.encode(toTimestamp(message.createTime), writer.uint32(34).fork()).ldelim();
        }
        if (message.updateTime !== undefined) {
            Timestamp.encode(toTimestamp(message.updateTime), writer.uint32(42).fork()).ldelim();
        }
        if (message.retentionDays !== undefined) {
            writer.uint32(88).int32(message.retentionDays);
        }
        if (message.locked !== undefined) {
            writer.uint32(72).bool(message.locked);
        }
        if (message.lifecycleState !== 0) {
            writer.uint32(96).int32(message.lifecycleState);
        }
        for (const v of message.restrictedFields) {
            writer.uint32(122).string(v);
        }
        if (message.cmekSettings !== undefined) {
            CmekSettings.encode(message.cmekSettings, writer.uint32(154).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLogBucket();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 3:
                    message.description = reader.string();
                    break;
                case 4:
                    message.createTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 5:
                    message.updateTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 11:
                    message.retentionDays = reader.int32();
                    break;
                case 9:
                    message.locked = reader.bool();
                    break;
                case 12:
                    message.lifecycleState = reader.int32();
                    break;
                case 15:
                    message.restrictedFields.push(reader.string());
                    break;
                case 19:
                    message.cmekSettings = CmekSettings.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLogBucket();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.description))
            obj.description = String(object.description);
        if (isSet(object.createTime))
            obj.createTime = new Date(object.createTime);
        if (isSet(object.updateTime))
            obj.updateTime = new Date(object.updateTime);
        if (isSet(object.retentionDays))
            obj.retentionDays = Number(object.retentionDays);
        if (isSet(object.locked))
            obj.locked = Boolean(object.locked);
        if (isSet(object.lifecycleState))
            obj.lifecycleState = lifecycleStateFromJSON(object.lifecycleState);
        if (Array.isArray(object?.restrictedFields))
            obj.restrictedFields = object.restrictedFields.map((e) => String(e));
        if (isSet(object.cmekSettings))
            obj.cmekSettings = CmekSettings.fromJSON(object.cmekSettings);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.description !== undefined && (obj.description = message.description);
        message.createTime !== undefined && (obj.createTime = message.createTime.toISOString());
        message.updateTime !== undefined && (obj.updateTime = message.updateTime.toISOString());
        message.retentionDays !== undefined && (obj.retentionDays = Math.round(message.retentionDays));
        message.locked !== undefined && (obj.locked = message.locked);
        message.lifecycleState !== undefined && (obj.lifecycleState = lifecycleStateToJSON(message.lifecycleState));
        if (message.restrictedFields) {
            obj.restrictedFields = message.restrictedFields.map(e => e);
        }
        else {
            obj.restrictedFields = [];
        }
        message.cmekSettings !== undefined && (obj.cmekSettings = message.cmekSettings ? CmekSettings.toJSON(message.cmekSettings) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLogBucket();
        message.name = object.name ?? "";
        message.description = object.description ?? "";
        message.createTime = object.createTime ?? undefined;
        message.updateTime = object.updateTime ?? undefined;
        message.retentionDays = object.retentionDays ?? 0;
        message.locked = object.locked ?? false;
        message.lifecycleState = object.lifecycleState ?? 0;
        message.restrictedFields = object.restrictedFields?.map(e => e) || [];
        if (object.cmekSettings !== undefined && object.cmekSettings !== null) {
            message.cmekSettings = CmekSettings.fromPartial(object.cmekSettings);
        }
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            description: object?.description,
            createTime: object.create_time ?? undefined,
            updateTime: object.update_time ?? undefined,
            retentionDays: object?.retention_days,
            locked: object?.locked,
            lifecycleState: isSet(object.lifecycle_state) ? lifecycleStateFromJSON(object.lifecycle_state) : -1,
            restrictedFields: Array.isArray(object?.restricted_fields) ? object.restricted_fields.map((e) => e) : [],
            cmekSettings: object.cmek_settings ? CmekSettings.fromSDK(object.cmek_settings) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            description: isSet(object.description) ? String(object.description) : "",
            create_time: isSet(object.create_time) ? new Date(object.create_time) : undefined,
            update_time: isSet(object.update_time) ? new Date(object.update_time) : undefined,
            retention_days: isSet(object.retention_days) ? Number(object.retention_days) : 0,
            locked: isSet(object.locked) ? Boolean(object.locked) : false,
            lifecycle_state: isSet(object.lifecycle_state) ? lifecycleStateFromJSON(object.lifecycle_state) : -1,
            restricted_fields: Array.isArray(object?.restricted_fields) ? object.restricted_fields.map((e) => String(e)) : [],
            cmek_settings: isSet(object.cmek_settings) ? CmekSettings.fromSDKJSON(object.cmek_settings) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.description = message.description;
        message.createTime !== undefined && (obj.create_time = message.createTime ?? undefined);
        message.updateTime !== undefined && (obj.update_time = message.updateTime ?? undefined);
        obj.retention_days = message.retentionDays;
        obj.locked = message.locked;
        message.lifecycleState !== undefined && (obj.lifecycle_state = lifecycleStateToJSON(message.lifecycleState));
        if (message.restrictedFields) {
            obj.restricted_fields = message.restrictedFields.map(e => e);
        }
        else {
            obj.restricted_fields = [];
        }
        message.cmekSettings !== undefined && (obj.cmek_settings = message.cmekSettings ? CmekSettings.toSDK(message.cmekSettings) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLogBucket();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.description !== undefined && object.description !== null) {
            message.description = object.description;
        }
        if (object.create_time !== undefined && object.create_time !== null) {
            message.createTime = fromTimestamp(Timestamp.fromAmino(object.create_time));
        }
        if (object.update_time !== undefined && object.update_time !== null) {
            message.updateTime = fromTimestamp(Timestamp.fromAmino(object.update_time));
        }
        if (object.retention_days !== undefined && object.retention_days !== null) {
            message.retentionDays = object.retention_days;
        }
        if (object.locked !== undefined && object.locked !== null) {
            message.locked = object.locked;
        }
        if (object.lifecycle_state !== undefined && object.lifecycle_state !== null) {
            message.lifecycleState = object.lifecycle_state;
        }
        message.restrictedFields = object.restricted_fields?.map(e => e) || [];
        if (object.cmek_settings !== undefined && object.cmek_settings !== null) {
            message.cmekSettings = CmekSettings.fromAmino(object.cmek_settings);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.description = message.description === "" ? undefined : message.description;
        obj.create_time = message.createTime ? Timestamp.toAmino(toTimestamp(message.createTime)) : undefined;
        obj.update_time = message.updateTime ? Timestamp.toAmino(toTimestamp(message.updateTime)) : undefined;
        obj.retention_days = message.retentionDays === 0 ? undefined : message.retentionDays;
        obj.locked = message.locked === false ? undefined : message.locked;
        obj.lifecycle_state = message.lifecycleState === 0 ? undefined : message.lifecycleState;
        if (message.restrictedFields) {
            obj.restricted_fields = message.restrictedFields.map(e => e);
        }
        else {
            obj.restricted_fields = message.restrictedFields;
        }
        obj.cmek_settings = message.cmekSettings ? CmekSettings.toAmino(message.cmekSettings) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return LogBucket.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return LogBucket.decode(message.value);
    },
    toProto(message) {
        return LogBucket.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.LogBucket",
            value: LogBucket.encode(message).finish()
        };
    },
    registerTypeUrl() {
        CmekSettings.registerTypeUrl();
    }
};
function createBaseLogView() {
    return {
        name: "",
        description: "",
        createTime: undefined,
        updateTime: undefined,
        filter: ""
    };
}
export const LogView = {
    typeUrl: "/google.logging.v2.LogView",
    is(o) {
        return o && (o.$typeUrl === LogView.typeUrl || typeof o.name === "string" && typeof o.description === "string" && typeof o.filter === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === LogView.typeUrl || typeof o.name === "string" && typeof o.description === "string" && typeof o.filter === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === LogView.typeUrl || typeof o.name === "string" && typeof o.description === "string" && typeof o.filter === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.description !== undefined) {
            writer.uint32(26).string(message.description);
        }
        if (message.createTime !== undefined) {
            Timestamp.encode(toTimestamp(message.createTime), writer.uint32(34).fork()).ldelim();
        }
        if (message.updateTime !== undefined) {
            Timestamp.encode(toTimestamp(message.updateTime), writer.uint32(42).fork()).ldelim();
        }
        if (message.filter !== undefined) {
            writer.uint32(58).string(message.filter);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLogView();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 3:
                    message.description = reader.string();
                    break;
                case 4:
                    message.createTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 5:
                    message.updateTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 7:
                    message.filter = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLogView();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.description))
            obj.description = String(object.description);
        if (isSet(object.createTime))
            obj.createTime = new Date(object.createTime);
        if (isSet(object.updateTime))
            obj.updateTime = new Date(object.updateTime);
        if (isSet(object.filter))
            obj.filter = String(object.filter);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.description !== undefined && (obj.description = message.description);
        message.createTime !== undefined && (obj.createTime = message.createTime.toISOString());
        message.updateTime !== undefined && (obj.updateTime = message.updateTime.toISOString());
        message.filter !== undefined && (obj.filter = message.filter);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLogView();
        message.name = object.name ?? "";
        message.description = object.description ?? "";
        message.createTime = object.createTime ?? undefined;
        message.updateTime = object.updateTime ?? undefined;
        message.filter = object.filter ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            description: object?.description,
            createTime: object.create_time ?? undefined,
            updateTime: object.update_time ?? undefined,
            filter: object?.filter
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            description: isSet(object.description) ? String(object.description) : "",
            create_time: isSet(object.create_time) ? new Date(object.create_time) : undefined,
            update_time: isSet(object.update_time) ? new Date(object.update_time) : undefined,
            filter: isSet(object.filter) ? String(object.filter) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.description = message.description;
        message.createTime !== undefined && (obj.create_time = message.createTime ?? undefined);
        message.updateTime !== undefined && (obj.update_time = message.updateTime ?? undefined);
        obj.filter = message.filter;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLogView();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.description !== undefined && object.description !== null) {
            message.description = object.description;
        }
        if (object.create_time !== undefined && object.create_time !== null) {
            message.createTime = fromTimestamp(Timestamp.fromAmino(object.create_time));
        }
        if (object.update_time !== undefined && object.update_time !== null) {
            message.updateTime = fromTimestamp(Timestamp.fromAmino(object.update_time));
        }
        if (object.filter !== undefined && object.filter !== null) {
            message.filter = object.filter;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.description = message.description === "" ? undefined : message.description;
        obj.create_time = message.createTime ? Timestamp.toAmino(toTimestamp(message.createTime)) : undefined;
        obj.update_time = message.updateTime ? Timestamp.toAmino(toTimestamp(message.updateTime)) : undefined;
        obj.filter = message.filter === "" ? undefined : message.filter;
        return obj;
    },
    fromAminoMsg(object) {
        return LogView.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return LogView.decode(message.value);
    },
    toProto(message) {
        return LogView.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.LogView",
            value: LogView.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseLogSink() {
    return {
        name: "",
        destination: "",
        filter: "",
        description: "",
        disabled: false,
        exclusions: [],
        outputVersionFormat: 0,
        writerIdentity: "",
        includeChildren: false,
        bigqueryOptions: undefined,
        createTime: undefined,
        updateTime: undefined
    };
}
export const LogSink = {
    typeUrl: "/google.logging.v2.LogSink",
    is(o) {
        return o && (o.$typeUrl === LogSink.typeUrl || typeof o.name === "string" && typeof o.destination === "string" && typeof o.filter === "string" && typeof o.description === "string" && typeof o.disabled === "boolean" && Array.isArray(o.exclusions) && (!o.exclusions.length || LogExclusion.is(o.exclusions[0])) && isSet(o.outputVersionFormat) && typeof o.writerIdentity === "string" && typeof o.includeChildren === "boolean");
    },
    isSDK(o) {
        return o && (o.$typeUrl === LogSink.typeUrl || typeof o.name === "string" && typeof o.destination === "string" && typeof o.filter === "string" && typeof o.description === "string" && typeof o.disabled === "boolean" && Array.isArray(o.exclusions) && (!o.exclusions.length || LogExclusion.isSDK(o.exclusions[0])) && isSet(o.output_version_format) && typeof o.writer_identity === "string" && typeof o.include_children === "boolean");
    },
    isAmino(o) {
        return o && (o.$typeUrl === LogSink.typeUrl || typeof o.name === "string" && typeof o.destination === "string" && typeof o.filter === "string" && typeof o.description === "string" && typeof o.disabled === "boolean" && Array.isArray(o.exclusions) && (!o.exclusions.length || LogExclusion.isAmino(o.exclusions[0])) && isSet(o.output_version_format) && typeof o.writer_identity === "string" && typeof o.include_children === "boolean");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.destination !== undefined) {
            writer.uint32(26).string(message.destination);
        }
        if (message.filter !== undefined) {
            writer.uint32(42).string(message.filter);
        }
        if (message.description !== undefined) {
            writer.uint32(146).string(message.description);
        }
        if (message.disabled !== undefined) {
            writer.uint32(152).bool(message.disabled);
        }
        for (const v of message.exclusions) {
            LogExclusion.encode(v, writer.uint32(130).fork()).ldelim();
        }
        if (message.outputVersionFormat !== 0) {
            writer.uint32(48).int32(message.outputVersionFormat);
        }
        if (message.writerIdentity !== undefined) {
            writer.uint32(66).string(message.writerIdentity);
        }
        if (message.includeChildren !== undefined) {
            writer.uint32(72).bool(message.includeChildren);
        }
        if (message.bigqueryOptions !== undefined) {
            BigQueryOptions.encode(message.bigqueryOptions, writer.uint32(98).fork()).ldelim();
        }
        if (message.createTime !== undefined) {
            Timestamp.encode(toTimestamp(message.createTime), writer.uint32(106).fork()).ldelim();
        }
        if (message.updateTime !== undefined) {
            Timestamp.encode(toTimestamp(message.updateTime), writer.uint32(114).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLogSink();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 3:
                    message.destination = reader.string();
                    break;
                case 5:
                    message.filter = reader.string();
                    break;
                case 18:
                    message.description = reader.string();
                    break;
                case 19:
                    message.disabled = reader.bool();
                    break;
                case 16:
                    message.exclusions.push(LogExclusion.decode(reader, reader.uint32()));
                    break;
                case 6:
                    message.outputVersionFormat = reader.int32();
                    break;
                case 8:
                    message.writerIdentity = reader.string();
                    break;
                case 9:
                    message.includeChildren = reader.bool();
                    break;
                case 12:
                    message.bigqueryOptions = BigQueryOptions.decode(reader, reader.uint32());
                    break;
                case 13:
                    message.createTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 14:
                    message.updateTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLogSink();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.destination))
            obj.destination = String(object.destination);
        if (isSet(object.filter))
            obj.filter = String(object.filter);
        if (isSet(object.description))
            obj.description = String(object.description);
        if (isSet(object.disabled))
            obj.disabled = Boolean(object.disabled);
        if (Array.isArray(object?.exclusions))
            obj.exclusions = object.exclusions.map((e) => LogExclusion.fromJSON(e));
        if (isSet(object.outputVersionFormat))
            obj.outputVersionFormat = logSink_VersionFormatFromJSON(object.outputVersionFormat);
        if (isSet(object.writerIdentity))
            obj.writerIdentity = String(object.writerIdentity);
        if (isSet(object.includeChildren))
            obj.includeChildren = Boolean(object.includeChildren);
        if (isSet(object.bigqueryOptions))
            obj.bigqueryOptions = BigQueryOptions.fromJSON(object.bigqueryOptions);
        if (isSet(object.createTime))
            obj.createTime = new Date(object.createTime);
        if (isSet(object.updateTime))
            obj.updateTime = new Date(object.updateTime);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.destination !== undefined && (obj.destination = message.destination);
        message.filter !== undefined && (obj.filter = message.filter);
        message.description !== undefined && (obj.description = message.description);
        message.disabled !== undefined && (obj.disabled = message.disabled);
        if (message.exclusions) {
            obj.exclusions = message.exclusions.map(e => e ? LogExclusion.toJSON(e) : undefined);
        }
        else {
            obj.exclusions = [];
        }
        message.outputVersionFormat !== undefined && (obj.outputVersionFormat = logSink_VersionFormatToJSON(message.outputVersionFormat));
        message.writerIdentity !== undefined && (obj.writerIdentity = message.writerIdentity);
        message.includeChildren !== undefined && (obj.includeChildren = message.includeChildren);
        message.bigqueryOptions !== undefined && (obj.bigqueryOptions = message.bigqueryOptions ? BigQueryOptions.toJSON(message.bigqueryOptions) : undefined);
        message.createTime !== undefined && (obj.createTime = message.createTime.toISOString());
        message.updateTime !== undefined && (obj.updateTime = message.updateTime.toISOString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLogSink();
        message.name = object.name ?? "";
        message.destination = object.destination ?? "";
        message.filter = object.filter ?? "";
        message.description = object.description ?? "";
        message.disabled = object.disabled ?? false;
        message.exclusions = object.exclusions?.map(e => LogExclusion.fromPartial(e)) || [];
        message.outputVersionFormat = object.outputVersionFormat ?? 0;
        message.writerIdentity = object.writerIdentity ?? "";
        message.includeChildren = object.includeChildren ?? false;
        if (object.bigqueryOptions !== undefined && object.bigqueryOptions !== null) {
            message.bigqueryOptions = BigQueryOptions.fromPartial(object.bigqueryOptions);
        }
        message.createTime = object.createTime ?? undefined;
        message.updateTime = object.updateTime ?? undefined;
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            destination: object?.destination,
            filter: object?.filter,
            description: object?.description,
            disabled: object?.disabled,
            exclusions: Array.isArray(object?.exclusions) ? object.exclusions.map((e) => LogExclusion.fromSDK(e)) : [],
            outputVersionFormat: isSet(object.output_version_format) ? logSink_VersionFormatFromJSON(object.output_version_format) : -1,
            writerIdentity: object?.writer_identity,
            includeChildren: object?.include_children,
            bigqueryOptions: object.bigquery_options ? BigQueryOptions.fromSDK(object.bigquery_options) : undefined,
            createTime: object.create_time ?? undefined,
            updateTime: object.update_time ?? undefined
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            destination: isSet(object.destination) ? String(object.destination) : "",
            filter: isSet(object.filter) ? String(object.filter) : "",
            description: isSet(object.description) ? String(object.description) : "",
            disabled: isSet(object.disabled) ? Boolean(object.disabled) : false,
            exclusions: Array.isArray(object?.exclusions) ? object.exclusions.map((e) => LogExclusion.fromSDKJSON(e)) : [],
            output_version_format: isSet(object.output_version_format) ? logSink_VersionFormatFromJSON(object.output_version_format) : -1,
            writer_identity: isSet(object.writer_identity) ? String(object.writer_identity) : "",
            include_children: isSet(object.include_children) ? Boolean(object.include_children) : false,
            bigquery_options: isSet(object.bigquery_options) ? BigQueryOptions.fromSDKJSON(object.bigquery_options) : undefined,
            create_time: isSet(object.create_time) ? new Date(object.create_time) : undefined,
            update_time: isSet(object.update_time) ? new Date(object.update_time) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.destination = message.destination;
        obj.filter = message.filter;
        obj.description = message.description;
        obj.disabled = message.disabled;
        if (message.exclusions) {
            obj.exclusions = message.exclusions.map(e => e ? LogExclusion.toSDK(e) : undefined);
        }
        else {
            obj.exclusions = [];
        }
        message.outputVersionFormat !== undefined && (obj.output_version_format = logSink_VersionFormatToJSON(message.outputVersionFormat));
        obj.writer_identity = message.writerIdentity;
        obj.include_children = message.includeChildren;
        message.bigqueryOptions !== undefined && (obj.bigquery_options = message.bigqueryOptions ? BigQueryOptions.toSDK(message.bigqueryOptions) : undefined);
        message.createTime !== undefined && (obj.create_time = message.createTime ?? undefined);
        message.updateTime !== undefined && (obj.update_time = message.updateTime ?? undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLogSink();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.destination !== undefined && object.destination !== null) {
            message.destination = object.destination;
        }
        if (object.filter !== undefined && object.filter !== null) {
            message.filter = object.filter;
        }
        if (object.description !== undefined && object.description !== null) {
            message.description = object.description;
        }
        if (object.disabled !== undefined && object.disabled !== null) {
            message.disabled = object.disabled;
        }
        message.exclusions = object.exclusions?.map(e => LogExclusion.fromAmino(e)) || [];
        if (object.output_version_format !== undefined && object.output_version_format !== null) {
            message.outputVersionFormat = object.output_version_format;
        }
        if (object.writer_identity !== undefined && object.writer_identity !== null) {
            message.writerIdentity = object.writer_identity;
        }
        if (object.include_children !== undefined && object.include_children !== null) {
            message.includeChildren = object.include_children;
        }
        if (object.bigquery_options !== undefined && object.bigquery_options !== null) {
            message.bigqueryOptions = BigQueryOptions.fromAmino(object.bigquery_options);
        }
        if (object.create_time !== undefined && object.create_time !== null) {
            message.createTime = fromTimestamp(Timestamp.fromAmino(object.create_time));
        }
        if (object.update_time !== undefined && object.update_time !== null) {
            message.updateTime = fromTimestamp(Timestamp.fromAmino(object.update_time));
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.destination = message.destination === "" ? undefined : message.destination;
        obj.filter = message.filter === "" ? undefined : message.filter;
        obj.description = message.description === "" ? undefined : message.description;
        obj.disabled = message.disabled === false ? undefined : message.disabled;
        if (message.exclusions) {
            obj.exclusions = message.exclusions.map(e => e ? LogExclusion.toAmino(e) : undefined);
        }
        else {
            obj.exclusions = message.exclusions;
        }
        obj.output_version_format = message.outputVersionFormat === 0 ? undefined : message.outputVersionFormat;
        obj.writer_identity = message.writerIdentity === "" ? undefined : message.writerIdentity;
        obj.include_children = message.includeChildren === false ? undefined : message.includeChildren;
        obj.bigquery_options = message.bigqueryOptions ? BigQueryOptions.toAmino(message.bigqueryOptions) : undefined;
        obj.create_time = message.createTime ? Timestamp.toAmino(toTimestamp(message.createTime)) : undefined;
        obj.update_time = message.updateTime ? Timestamp.toAmino(toTimestamp(message.updateTime)) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return LogSink.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return LogSink.decode(message.value);
    },
    toProto(message) {
        return LogSink.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.LogSink",
            value: LogSink.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogExclusion.registerTypeUrl();
        BigQueryOptions.registerTypeUrl();
    }
};
function createBaseBigQueryOptions() {
    return {
        usePartitionedTables: false,
        usesTimestampColumnPartitioning: false
    };
}
export const BigQueryOptions = {
    typeUrl: "/google.logging.v2.BigQueryOptions",
    is(o) {
        return o && (o.$typeUrl === BigQueryOptions.typeUrl || typeof o.usePartitionedTables === "boolean" && typeof o.usesTimestampColumnPartitioning === "boolean");
    },
    isSDK(o) {
        return o && (o.$typeUrl === BigQueryOptions.typeUrl || typeof o.use_partitioned_tables === "boolean" && typeof o.uses_timestamp_column_partitioning === "boolean");
    },
    isAmino(o) {
        return o && (o.$typeUrl === BigQueryOptions.typeUrl || typeof o.use_partitioned_tables === "boolean" && typeof o.uses_timestamp_column_partitioning === "boolean");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.usePartitionedTables !== undefined) {
            writer.uint32(8).bool(message.usePartitionedTables);
        }
        if (message.usesTimestampColumnPartitioning !== undefined) {
            writer.uint32(24).bool(message.usesTimestampColumnPartitioning);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseBigQueryOptions();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.usePartitionedTables = reader.bool();
                    break;
                case 3:
                    message.usesTimestampColumnPartitioning = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseBigQueryOptions();
        if (isSet(object.usePartitionedTables))
            obj.usePartitionedTables = Boolean(object.usePartitionedTables);
        if (isSet(object.usesTimestampColumnPartitioning))
            obj.usesTimestampColumnPartitioning = Boolean(object.usesTimestampColumnPartitioning);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.usePartitionedTables !== undefined && (obj.usePartitionedTables = message.usePartitionedTables);
        message.usesTimestampColumnPartitioning !== undefined && (obj.usesTimestampColumnPartitioning = message.usesTimestampColumnPartitioning);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseBigQueryOptions();
        message.usePartitionedTables = object.usePartitionedTables ?? false;
        message.usesTimestampColumnPartitioning = object.usesTimestampColumnPartitioning ?? false;
        return message;
    },
    fromSDK(object) {
        return {
            usePartitionedTables: object?.use_partitioned_tables,
            usesTimestampColumnPartitioning: object?.uses_timestamp_column_partitioning
        };
    },
    fromSDKJSON(object) {
        return {
            use_partitioned_tables: isSet(object.use_partitioned_tables) ? Boolean(object.use_partitioned_tables) : false,
            uses_timestamp_column_partitioning: isSet(object.uses_timestamp_column_partitioning) ? Boolean(object.uses_timestamp_column_partitioning) : false
        };
    },
    toSDK(message) {
        const obj = {};
        obj.use_partitioned_tables = message.usePartitionedTables;
        obj.uses_timestamp_column_partitioning = message.usesTimestampColumnPartitioning;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseBigQueryOptions();
        if (object.use_partitioned_tables !== undefined && object.use_partitioned_tables !== null) {
            message.usePartitionedTables = object.use_partitioned_tables;
        }
        if (object.uses_timestamp_column_partitioning !== undefined && object.uses_timestamp_column_partitioning !== null) {
            message.usesTimestampColumnPartitioning = object.uses_timestamp_column_partitioning;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.use_partitioned_tables = message.usePartitionedTables === false ? undefined : message.usePartitionedTables;
        obj.uses_timestamp_column_partitioning = message.usesTimestampColumnPartitioning === false ? undefined : message.usesTimestampColumnPartitioning;
        return obj;
    },
    fromAminoMsg(object) {
        return BigQueryOptions.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return BigQueryOptions.decode(message.value);
    },
    toProto(message) {
        return BigQueryOptions.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.BigQueryOptions",
            value: BigQueryOptions.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListBucketsRequest() {
    return {
        parent: "",
        pageToken: "",
        pageSize: 0
    };
}
export const ListBucketsRequest = {
    typeUrl: "/google.logging.v2.ListBucketsRequest",
    is(o) {
        return o && (o.$typeUrl === ListBucketsRequest.typeUrl || typeof o.parent === "string" && typeof o.pageToken === "string" && typeof o.pageSize === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListBucketsRequest.typeUrl || typeof o.parent === "string" && typeof o.page_token === "string" && typeof o.page_size === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListBucketsRequest.typeUrl || typeof o.parent === "string" && typeof o.page_token === "string" && typeof o.page_size === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.pageToken !== undefined) {
            writer.uint32(18).string(message.pageToken);
        }
        if (message.pageSize !== undefined) {
            writer.uint32(24).int32(message.pageSize);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListBucketsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.pageToken = reader.string();
                    break;
                case 3:
                    message.pageSize = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListBucketsRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.pageToken))
            obj.pageToken = String(object.pageToken);
        if (isSet(object.pageSize))
            obj.pageSize = Number(object.pageSize);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.pageToken !== undefined && (obj.pageToken = message.pageToken);
        message.pageSize !== undefined && (obj.pageSize = Math.round(message.pageSize));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListBucketsRequest();
        message.parent = object.parent ?? "";
        message.pageToken = object.pageToken ?? "";
        message.pageSize = object.pageSize ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            pageToken: object?.page_token,
            pageSize: object?.page_size
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            page_token: isSet(object.page_token) ? String(object.page_token) : "",
            page_size: isSet(object.page_size) ? Number(object.page_size) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        obj.page_token = message.pageToken;
        obj.page_size = message.pageSize;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListBucketsRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.page_token !== undefined && object.page_token !== null) {
            message.pageToken = object.page_token;
        }
        if (object.page_size !== undefined && object.page_size !== null) {
            message.pageSize = object.page_size;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.page_token = message.pageToken === "" ? undefined : message.pageToken;
        obj.page_size = message.pageSize === 0 ? undefined : message.pageSize;
        return obj;
    },
    fromAminoMsg(object) {
        return ListBucketsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListBucketsRequest.decode(message.value);
    },
    toProto(message) {
        return ListBucketsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.ListBucketsRequest",
            value: ListBucketsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListBucketsResponse() {
    return {
        buckets: [],
        nextPageToken: ""
    };
}
export const ListBucketsResponse = {
    typeUrl: "/google.logging.v2.ListBucketsResponse",
    is(o) {
        return o && (o.$typeUrl === ListBucketsResponse.typeUrl || Array.isArray(o.buckets) && (!o.buckets.length || LogBucket.is(o.buckets[0])) && typeof o.nextPageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListBucketsResponse.typeUrl || Array.isArray(o.buckets) && (!o.buckets.length || LogBucket.isSDK(o.buckets[0])) && typeof o.next_page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListBucketsResponse.typeUrl || Array.isArray(o.buckets) && (!o.buckets.length || LogBucket.isAmino(o.buckets[0])) && typeof o.next_page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.buckets) {
            LogBucket.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.nextPageToken !== undefined) {
            writer.uint32(18).string(message.nextPageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListBucketsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.buckets.push(LogBucket.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.nextPageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListBucketsResponse();
        if (Array.isArray(object?.buckets))
            obj.buckets = object.buckets.map((e) => LogBucket.fromJSON(e));
        if (isSet(object.nextPageToken))
            obj.nextPageToken = String(object.nextPageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.buckets) {
            obj.buckets = message.buckets.map(e => e ? LogBucket.toJSON(e) : undefined);
        }
        else {
            obj.buckets = [];
        }
        message.nextPageToken !== undefined && (obj.nextPageToken = message.nextPageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListBucketsResponse();
        message.buckets = object.buckets?.map(e => LogBucket.fromPartial(e)) || [];
        message.nextPageToken = object.nextPageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            buckets: Array.isArray(object?.buckets) ? object.buckets.map((e) => LogBucket.fromSDK(e)) : [],
            nextPageToken: object?.next_page_token
        };
    },
    fromSDKJSON(object) {
        return {
            buckets: Array.isArray(object?.buckets) ? object.buckets.map((e) => LogBucket.fromSDKJSON(e)) : [],
            next_page_token: isSet(object.next_page_token) ? String(object.next_page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.buckets) {
            obj.buckets = message.buckets.map(e => e ? LogBucket.toSDK(e) : undefined);
        }
        else {
            obj.buckets = [];
        }
        obj.next_page_token = message.nextPageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListBucketsResponse();
        message.buckets = object.buckets?.map(e => LogBucket.fromAmino(e)) || [];
        if (object.next_page_token !== undefined && object.next_page_token !== null) {
            message.nextPageToken = object.next_page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.buckets) {
            obj.buckets = message.buckets.map(e => e ? LogBucket.toAmino(e) : undefined);
        }
        else {
            obj.buckets = message.buckets;
        }
        obj.next_page_token = message.nextPageToken === "" ? undefined : message.nextPageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListBucketsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListBucketsResponse.decode(message.value);
    },
    toProto(message) {
        return ListBucketsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.ListBucketsResponse",
            value: ListBucketsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogBucket.registerTypeUrl();
    }
};
function createBaseCreateBucketRequest() {
    return {
        parent: "",
        bucketId: "",
        bucket: undefined
    };
}
export const CreateBucketRequest = {
    typeUrl: "/google.logging.v2.CreateBucketRequest",
    is(o) {
        return o && (o.$typeUrl === CreateBucketRequest.typeUrl || typeof o.parent === "string" && typeof o.bucketId === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === CreateBucketRequest.typeUrl || typeof o.parent === "string" && typeof o.bucket_id === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === CreateBucketRequest.typeUrl || typeof o.parent === "string" && typeof o.bucket_id === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.bucketId !== undefined) {
            writer.uint32(18).string(message.bucketId);
        }
        if (message.bucket !== undefined) {
            LogBucket.encode(message.bucket, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCreateBucketRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.bucketId = reader.string();
                    break;
                case 3:
                    message.bucket = LogBucket.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCreateBucketRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.bucketId))
            obj.bucketId = String(object.bucketId);
        if (isSet(object.bucket))
            obj.bucket = LogBucket.fromJSON(object.bucket);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.bucketId !== undefined && (obj.bucketId = message.bucketId);
        message.bucket !== undefined && (obj.bucket = message.bucket ? LogBucket.toJSON(message.bucket) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCreateBucketRequest();
        message.parent = object.parent ?? "";
        message.bucketId = object.bucketId ?? "";
        if (object.bucket !== undefined && object.bucket !== null) {
            message.bucket = LogBucket.fromPartial(object.bucket);
        }
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            bucketId: object?.bucket_id,
            bucket: object.bucket ? LogBucket.fromSDK(object.bucket) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            bucket_id: isSet(object.bucket_id) ? String(object.bucket_id) : "",
            bucket: isSet(object.bucket) ? LogBucket.fromSDKJSON(object.bucket) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        obj.bucket_id = message.bucketId;
        message.bucket !== undefined && (obj.bucket = message.bucket ? LogBucket.toSDK(message.bucket) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCreateBucketRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.bucket_id !== undefined && object.bucket_id !== null) {
            message.bucketId = object.bucket_id;
        }
        if (object.bucket !== undefined && object.bucket !== null) {
            message.bucket = LogBucket.fromAmino(object.bucket);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.bucket_id = message.bucketId === "" ? undefined : message.bucketId;
        obj.bucket = message.bucket ? LogBucket.toAmino(message.bucket) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return CreateBucketRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CreateBucketRequest.decode(message.value);
    },
    toProto(message) {
        return CreateBucketRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.CreateBucketRequest",
            value: CreateBucketRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogBucket.registerTypeUrl();
    }
};
function createBaseUpdateBucketRequest() {
    return {
        name: "",
        bucket: undefined,
        updateMask: undefined
    };
}
export const UpdateBucketRequest = {
    typeUrl: "/google.logging.v2.UpdateBucketRequest",
    is(o) {
        return o && (o.$typeUrl === UpdateBucketRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === UpdateBucketRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === UpdateBucketRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.bucket !== undefined) {
            LogBucket.encode(message.bucket, writer.uint32(18).fork()).ldelim();
        }
        if (message.updateMask !== undefined) {
            FieldMask.encode(message.updateMask, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUpdateBucketRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.bucket = LogBucket.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.updateMask = FieldMask.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseUpdateBucketRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.bucket))
            obj.bucket = LogBucket.fromJSON(object.bucket);
        if (isSet(object.updateMask))
            obj.updateMask = FieldMask.fromJSON(object.updateMask);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.bucket !== undefined && (obj.bucket = message.bucket ? LogBucket.toJSON(message.bucket) : undefined);
        message.updateMask !== undefined && (obj.updateMask = message.updateMask ? FieldMask.toJSON(message.updateMask) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseUpdateBucketRequest();
        message.name = object.name ?? "";
        if (object.bucket !== undefined && object.bucket !== null) {
            message.bucket = LogBucket.fromPartial(object.bucket);
        }
        if (object.updateMask !== undefined && object.updateMask !== null) {
            message.updateMask = FieldMask.fromPartial(object.updateMask);
        }
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            bucket: object.bucket ? LogBucket.fromSDK(object.bucket) : undefined,
            updateMask: object.update_mask ? FieldMask.fromSDK(object.update_mask) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            bucket: isSet(object.bucket) ? LogBucket.fromSDKJSON(object.bucket) : undefined,
            update_mask: isSet(object.update_mask) ? FieldMask.fromSDKJSON(object.update_mask) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        message.bucket !== undefined && (obj.bucket = message.bucket ? LogBucket.toSDK(message.bucket) : undefined);
        message.updateMask !== undefined && (obj.update_mask = message.updateMask ? FieldMask.toSDK(message.updateMask) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseUpdateBucketRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.bucket !== undefined && object.bucket !== null) {
            message.bucket = LogBucket.fromAmino(object.bucket);
        }
        if (object.update_mask !== undefined && object.update_mask !== null) {
            message.updateMask = FieldMask.fromAmino(object.update_mask);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.bucket = message.bucket ? LogBucket.toAmino(message.bucket) : undefined;
        obj.update_mask = message.updateMask ? FieldMask.toAmino(message.updateMask) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return UpdateBucketRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return UpdateBucketRequest.decode(message.value);
    },
    toProto(message) {
        return UpdateBucketRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.UpdateBucketRequest",
            value: UpdateBucketRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogBucket.registerTypeUrl();
        FieldMask.registerTypeUrl();
    }
};
function createBaseGetBucketRequest() {
    return {
        name: ""
    };
}
export const GetBucketRequest = {
    typeUrl: "/google.logging.v2.GetBucketRequest",
    is(o) {
        return o && (o.$typeUrl === GetBucketRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === GetBucketRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === GetBucketRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetBucketRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGetBucketRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGetBucketRequest();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGetBucketRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return GetBucketRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetBucketRequest.decode(message.value);
    },
    toProto(message) {
        return GetBucketRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.GetBucketRequest",
            value: GetBucketRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseDeleteBucketRequest() {
    return {
        name: ""
    };
}
export const DeleteBucketRequest = {
    typeUrl: "/google.logging.v2.DeleteBucketRequest",
    is(o) {
        return o && (o.$typeUrl === DeleteBucketRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === DeleteBucketRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === DeleteBucketRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeleteBucketRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDeleteBucketRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDeleteBucketRequest();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDeleteBucketRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return DeleteBucketRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return DeleteBucketRequest.decode(message.value);
    },
    toProto(message) {
        return DeleteBucketRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.DeleteBucketRequest",
            value: DeleteBucketRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseUndeleteBucketRequest() {
    return {
        name: ""
    };
}
export const UndeleteBucketRequest = {
    typeUrl: "/google.logging.v2.UndeleteBucketRequest",
    is(o) {
        return o && (o.$typeUrl === UndeleteBucketRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === UndeleteBucketRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === UndeleteBucketRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUndeleteBucketRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseUndeleteBucketRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseUndeleteBucketRequest();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseUndeleteBucketRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return UndeleteBucketRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return UndeleteBucketRequest.decode(message.value);
    },
    toProto(message) {
        return UndeleteBucketRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.UndeleteBucketRequest",
            value: UndeleteBucketRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListViewsRequest() {
    return {
        parent: "",
        pageToken: "",
        pageSize: 0
    };
}
export const ListViewsRequest = {
    typeUrl: "/google.logging.v2.ListViewsRequest",
    is(o) {
        return o && (o.$typeUrl === ListViewsRequest.typeUrl || typeof o.parent === "string" && typeof o.pageToken === "string" && typeof o.pageSize === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListViewsRequest.typeUrl || typeof o.parent === "string" && typeof o.page_token === "string" && typeof o.page_size === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListViewsRequest.typeUrl || typeof o.parent === "string" && typeof o.page_token === "string" && typeof o.page_size === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.pageToken !== undefined) {
            writer.uint32(18).string(message.pageToken);
        }
        if (message.pageSize !== undefined) {
            writer.uint32(24).int32(message.pageSize);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListViewsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.pageToken = reader.string();
                    break;
                case 3:
                    message.pageSize = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListViewsRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.pageToken))
            obj.pageToken = String(object.pageToken);
        if (isSet(object.pageSize))
            obj.pageSize = Number(object.pageSize);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.pageToken !== undefined && (obj.pageToken = message.pageToken);
        message.pageSize !== undefined && (obj.pageSize = Math.round(message.pageSize));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListViewsRequest();
        message.parent = object.parent ?? "";
        message.pageToken = object.pageToken ?? "";
        message.pageSize = object.pageSize ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            pageToken: object?.page_token,
            pageSize: object?.page_size
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            page_token: isSet(object.page_token) ? String(object.page_token) : "",
            page_size: isSet(object.page_size) ? Number(object.page_size) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        obj.page_token = message.pageToken;
        obj.page_size = message.pageSize;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListViewsRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.page_token !== undefined && object.page_token !== null) {
            message.pageToken = object.page_token;
        }
        if (object.page_size !== undefined && object.page_size !== null) {
            message.pageSize = object.page_size;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.page_token = message.pageToken === "" ? undefined : message.pageToken;
        obj.page_size = message.pageSize === 0 ? undefined : message.pageSize;
        return obj;
    },
    fromAminoMsg(object) {
        return ListViewsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListViewsRequest.decode(message.value);
    },
    toProto(message) {
        return ListViewsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.ListViewsRequest",
            value: ListViewsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListViewsResponse() {
    return {
        views: [],
        nextPageToken: ""
    };
}
export const ListViewsResponse = {
    typeUrl: "/google.logging.v2.ListViewsResponse",
    is(o) {
        return o && (o.$typeUrl === ListViewsResponse.typeUrl || Array.isArray(o.views) && (!o.views.length || LogView.is(o.views[0])) && typeof o.nextPageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListViewsResponse.typeUrl || Array.isArray(o.views) && (!o.views.length || LogView.isSDK(o.views[0])) && typeof o.next_page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListViewsResponse.typeUrl || Array.isArray(o.views) && (!o.views.length || LogView.isAmino(o.views[0])) && typeof o.next_page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.views) {
            LogView.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.nextPageToken !== undefined) {
            writer.uint32(18).string(message.nextPageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListViewsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.views.push(LogView.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.nextPageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListViewsResponse();
        if (Array.isArray(object?.views))
            obj.views = object.views.map((e) => LogView.fromJSON(e));
        if (isSet(object.nextPageToken))
            obj.nextPageToken = String(object.nextPageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.views) {
            obj.views = message.views.map(e => e ? LogView.toJSON(e) : undefined);
        }
        else {
            obj.views = [];
        }
        message.nextPageToken !== undefined && (obj.nextPageToken = message.nextPageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListViewsResponse();
        message.views = object.views?.map(e => LogView.fromPartial(e)) || [];
        message.nextPageToken = object.nextPageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            views: Array.isArray(object?.views) ? object.views.map((e) => LogView.fromSDK(e)) : [],
            nextPageToken: object?.next_page_token
        };
    },
    fromSDKJSON(object) {
        return {
            views: Array.isArray(object?.views) ? object.views.map((e) => LogView.fromSDKJSON(e)) : [],
            next_page_token: isSet(object.next_page_token) ? String(object.next_page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.views) {
            obj.views = message.views.map(e => e ? LogView.toSDK(e) : undefined);
        }
        else {
            obj.views = [];
        }
        obj.next_page_token = message.nextPageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListViewsResponse();
        message.views = object.views?.map(e => LogView.fromAmino(e)) || [];
        if (object.next_page_token !== undefined && object.next_page_token !== null) {
            message.nextPageToken = object.next_page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.views) {
            obj.views = message.views.map(e => e ? LogView.toAmino(e) : undefined);
        }
        else {
            obj.views = message.views;
        }
        obj.next_page_token = message.nextPageToken === "" ? undefined : message.nextPageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListViewsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListViewsResponse.decode(message.value);
    },
    toProto(message) {
        return ListViewsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.ListViewsResponse",
            value: ListViewsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogView.registerTypeUrl();
    }
};
function createBaseCreateViewRequest() {
    return {
        parent: "",
        viewId: "",
        view: undefined
    };
}
export const CreateViewRequest = {
    typeUrl: "/google.logging.v2.CreateViewRequest",
    is(o) {
        return o && (o.$typeUrl === CreateViewRequest.typeUrl || typeof o.parent === "string" && typeof o.viewId === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === CreateViewRequest.typeUrl || typeof o.parent === "string" && typeof o.view_id === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === CreateViewRequest.typeUrl || typeof o.parent === "string" && typeof o.view_id === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.viewId !== undefined) {
            writer.uint32(18).string(message.viewId);
        }
        if (message.view !== undefined) {
            LogView.encode(message.view, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCreateViewRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.viewId = reader.string();
                    break;
                case 3:
                    message.view = LogView.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCreateViewRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.viewId))
            obj.viewId = String(object.viewId);
        if (isSet(object.view))
            obj.view = LogView.fromJSON(object.view);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.viewId !== undefined && (obj.viewId = message.viewId);
        message.view !== undefined && (obj.view = message.view ? LogView.toJSON(message.view) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCreateViewRequest();
        message.parent = object.parent ?? "";
        message.viewId = object.viewId ?? "";
        if (object.view !== undefined && object.view !== null) {
            message.view = LogView.fromPartial(object.view);
        }
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            viewId: object?.view_id,
            view: object.view ? LogView.fromSDK(object.view) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            view_id: isSet(object.view_id) ? String(object.view_id) : "",
            view: isSet(object.view) ? LogView.fromSDKJSON(object.view) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        obj.view_id = message.viewId;
        message.view !== undefined && (obj.view = message.view ? LogView.toSDK(message.view) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCreateViewRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.view_id !== undefined && object.view_id !== null) {
            message.viewId = object.view_id;
        }
        if (object.view !== undefined && object.view !== null) {
            message.view = LogView.fromAmino(object.view);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.view_id = message.viewId === "" ? undefined : message.viewId;
        obj.view = message.view ? LogView.toAmino(message.view) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return CreateViewRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CreateViewRequest.decode(message.value);
    },
    toProto(message) {
        return CreateViewRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.CreateViewRequest",
            value: CreateViewRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogView.registerTypeUrl();
    }
};
function createBaseUpdateViewRequest() {
    return {
        name: "",
        view: undefined,
        updateMask: undefined
    };
}
export const UpdateViewRequest = {
    typeUrl: "/google.logging.v2.UpdateViewRequest",
    is(o) {
        return o && (o.$typeUrl === UpdateViewRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === UpdateViewRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === UpdateViewRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.view !== undefined) {
            LogView.encode(message.view, writer.uint32(18).fork()).ldelim();
        }
        if (message.updateMask !== undefined) {
            FieldMask.encode(message.updateMask, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUpdateViewRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.view = LogView.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.updateMask = FieldMask.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseUpdateViewRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.view))
            obj.view = LogView.fromJSON(object.view);
        if (isSet(object.updateMask))
            obj.updateMask = FieldMask.fromJSON(object.updateMask);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.view !== undefined && (obj.view = message.view ? LogView.toJSON(message.view) : undefined);
        message.updateMask !== undefined && (obj.updateMask = message.updateMask ? FieldMask.toJSON(message.updateMask) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseUpdateViewRequest();
        message.name = object.name ?? "";
        if (object.view !== undefined && object.view !== null) {
            message.view = LogView.fromPartial(object.view);
        }
        if (object.updateMask !== undefined && object.updateMask !== null) {
            message.updateMask = FieldMask.fromPartial(object.updateMask);
        }
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            view: object.view ? LogView.fromSDK(object.view) : undefined,
            updateMask: object.update_mask ? FieldMask.fromSDK(object.update_mask) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            view: isSet(object.view) ? LogView.fromSDKJSON(object.view) : undefined,
            update_mask: isSet(object.update_mask) ? FieldMask.fromSDKJSON(object.update_mask) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        message.view !== undefined && (obj.view = message.view ? LogView.toSDK(message.view) : undefined);
        message.updateMask !== undefined && (obj.update_mask = message.updateMask ? FieldMask.toSDK(message.updateMask) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseUpdateViewRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.view !== undefined && object.view !== null) {
            message.view = LogView.fromAmino(object.view);
        }
        if (object.update_mask !== undefined && object.update_mask !== null) {
            message.updateMask = FieldMask.fromAmino(object.update_mask);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.view = message.view ? LogView.toAmino(message.view) : undefined;
        obj.update_mask = message.updateMask ? FieldMask.toAmino(message.updateMask) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return UpdateViewRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return UpdateViewRequest.decode(message.value);
    },
    toProto(message) {
        return UpdateViewRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.UpdateViewRequest",
            value: UpdateViewRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogView.registerTypeUrl();
        FieldMask.registerTypeUrl();
    }
};
function createBaseGetViewRequest() {
    return {
        name: ""
    };
}
export const GetViewRequest = {
    typeUrl: "/google.logging.v2.GetViewRequest",
    is(o) {
        return o && (o.$typeUrl === GetViewRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === GetViewRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === GetViewRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetViewRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGetViewRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGetViewRequest();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGetViewRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return GetViewRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetViewRequest.decode(message.value);
    },
    toProto(message) {
        return GetViewRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.GetViewRequest",
            value: GetViewRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseDeleteViewRequest() {
    return {
        name: ""
    };
}
export const DeleteViewRequest = {
    typeUrl: "/google.logging.v2.DeleteViewRequest",
    is(o) {
        return o && (o.$typeUrl === DeleteViewRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === DeleteViewRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === DeleteViewRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeleteViewRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDeleteViewRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDeleteViewRequest();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDeleteViewRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return DeleteViewRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return DeleteViewRequest.decode(message.value);
    },
    toProto(message) {
        return DeleteViewRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.DeleteViewRequest",
            value: DeleteViewRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListSinksRequest() {
    return {
        parent: "",
        pageToken: "",
        pageSize: 0
    };
}
export const ListSinksRequest = {
    typeUrl: "/google.logging.v2.ListSinksRequest",
    is(o) {
        return o && (o.$typeUrl === ListSinksRequest.typeUrl || typeof o.parent === "string" && typeof o.pageToken === "string" && typeof o.pageSize === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListSinksRequest.typeUrl || typeof o.parent === "string" && typeof o.page_token === "string" && typeof o.page_size === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListSinksRequest.typeUrl || typeof o.parent === "string" && typeof o.page_token === "string" && typeof o.page_size === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.pageToken !== undefined) {
            writer.uint32(18).string(message.pageToken);
        }
        if (message.pageSize !== undefined) {
            writer.uint32(24).int32(message.pageSize);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListSinksRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.pageToken = reader.string();
                    break;
                case 3:
                    message.pageSize = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListSinksRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.pageToken))
            obj.pageToken = String(object.pageToken);
        if (isSet(object.pageSize))
            obj.pageSize = Number(object.pageSize);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.pageToken !== undefined && (obj.pageToken = message.pageToken);
        message.pageSize !== undefined && (obj.pageSize = Math.round(message.pageSize));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListSinksRequest();
        message.parent = object.parent ?? "";
        message.pageToken = object.pageToken ?? "";
        message.pageSize = object.pageSize ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            pageToken: object?.page_token,
            pageSize: object?.page_size
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            page_token: isSet(object.page_token) ? String(object.page_token) : "",
            page_size: isSet(object.page_size) ? Number(object.page_size) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        obj.page_token = message.pageToken;
        obj.page_size = message.pageSize;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListSinksRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.page_token !== undefined && object.page_token !== null) {
            message.pageToken = object.page_token;
        }
        if (object.page_size !== undefined && object.page_size !== null) {
            message.pageSize = object.page_size;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.page_token = message.pageToken === "" ? undefined : message.pageToken;
        obj.page_size = message.pageSize === 0 ? undefined : message.pageSize;
        return obj;
    },
    fromAminoMsg(object) {
        return ListSinksRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListSinksRequest.decode(message.value);
    },
    toProto(message) {
        return ListSinksRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.ListSinksRequest",
            value: ListSinksRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListSinksResponse() {
    return {
        sinks: [],
        nextPageToken: ""
    };
}
export const ListSinksResponse = {
    typeUrl: "/google.logging.v2.ListSinksResponse",
    is(o) {
        return o && (o.$typeUrl === ListSinksResponse.typeUrl || Array.isArray(o.sinks) && (!o.sinks.length || LogSink.is(o.sinks[0])) && typeof o.nextPageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListSinksResponse.typeUrl || Array.isArray(o.sinks) && (!o.sinks.length || LogSink.isSDK(o.sinks[0])) && typeof o.next_page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListSinksResponse.typeUrl || Array.isArray(o.sinks) && (!o.sinks.length || LogSink.isAmino(o.sinks[0])) && typeof o.next_page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.sinks) {
            LogSink.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.nextPageToken !== undefined) {
            writer.uint32(18).string(message.nextPageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListSinksResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.sinks.push(LogSink.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.nextPageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListSinksResponse();
        if (Array.isArray(object?.sinks))
            obj.sinks = object.sinks.map((e) => LogSink.fromJSON(e));
        if (isSet(object.nextPageToken))
            obj.nextPageToken = String(object.nextPageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.sinks) {
            obj.sinks = message.sinks.map(e => e ? LogSink.toJSON(e) : undefined);
        }
        else {
            obj.sinks = [];
        }
        message.nextPageToken !== undefined && (obj.nextPageToken = message.nextPageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListSinksResponse();
        message.sinks = object.sinks?.map(e => LogSink.fromPartial(e)) || [];
        message.nextPageToken = object.nextPageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            sinks: Array.isArray(object?.sinks) ? object.sinks.map((e) => LogSink.fromSDK(e)) : [],
            nextPageToken: object?.next_page_token
        };
    },
    fromSDKJSON(object) {
        return {
            sinks: Array.isArray(object?.sinks) ? object.sinks.map((e) => LogSink.fromSDKJSON(e)) : [],
            next_page_token: isSet(object.next_page_token) ? String(object.next_page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.sinks) {
            obj.sinks = message.sinks.map(e => e ? LogSink.toSDK(e) : undefined);
        }
        else {
            obj.sinks = [];
        }
        obj.next_page_token = message.nextPageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListSinksResponse();
        message.sinks = object.sinks?.map(e => LogSink.fromAmino(e)) || [];
        if (object.next_page_token !== undefined && object.next_page_token !== null) {
            message.nextPageToken = object.next_page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.sinks) {
            obj.sinks = message.sinks.map(e => e ? LogSink.toAmino(e) : undefined);
        }
        else {
            obj.sinks = message.sinks;
        }
        obj.next_page_token = message.nextPageToken === "" ? undefined : message.nextPageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListSinksResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListSinksResponse.decode(message.value);
    },
    toProto(message) {
        return ListSinksResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.ListSinksResponse",
            value: ListSinksResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogSink.registerTypeUrl();
    }
};
function createBaseGetSinkRequest() {
    return {
        sinkName: ""
    };
}
export const GetSinkRequest = {
    typeUrl: "/google.logging.v2.GetSinkRequest",
    is(o) {
        return o && (o.$typeUrl === GetSinkRequest.typeUrl || typeof o.sinkName === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === GetSinkRequest.typeUrl || typeof o.sink_name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === GetSinkRequest.typeUrl || typeof o.sink_name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.sinkName !== undefined) {
            writer.uint32(10).string(message.sinkName);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetSinkRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.sinkName = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGetSinkRequest();
        if (isSet(object.sinkName))
            obj.sinkName = String(object.sinkName);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.sinkName !== undefined && (obj.sinkName = message.sinkName);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGetSinkRequest();
        message.sinkName = object.sinkName ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            sinkName: object?.sink_name
        };
    },
    fromSDKJSON(object) {
        return {
            sink_name: isSet(object.sink_name) ? String(object.sink_name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.sink_name = message.sinkName;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGetSinkRequest();
        if (object.sink_name !== undefined && object.sink_name !== null) {
            message.sinkName = object.sink_name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.sink_name = message.sinkName === "" ? undefined : message.sinkName;
        return obj;
    },
    fromAminoMsg(object) {
        return GetSinkRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetSinkRequest.decode(message.value);
    },
    toProto(message) {
        return GetSinkRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.GetSinkRequest",
            value: GetSinkRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseCreateSinkRequest() {
    return {
        parent: "",
        sink: undefined,
        uniqueWriterIdentity: false
    };
}
export const CreateSinkRequest = {
    typeUrl: "/google.logging.v2.CreateSinkRequest",
    is(o) {
        return o && (o.$typeUrl === CreateSinkRequest.typeUrl || typeof o.parent === "string" && typeof o.uniqueWriterIdentity === "boolean");
    },
    isSDK(o) {
        return o && (o.$typeUrl === CreateSinkRequest.typeUrl || typeof o.parent === "string" && typeof o.unique_writer_identity === "boolean");
    },
    isAmino(o) {
        return o && (o.$typeUrl === CreateSinkRequest.typeUrl || typeof o.parent === "string" && typeof o.unique_writer_identity === "boolean");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.sink !== undefined) {
            LogSink.encode(message.sink, writer.uint32(18).fork()).ldelim();
        }
        if (message.uniqueWriterIdentity !== undefined) {
            writer.uint32(24).bool(message.uniqueWriterIdentity);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCreateSinkRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.sink = LogSink.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.uniqueWriterIdentity = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCreateSinkRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.sink))
            obj.sink = LogSink.fromJSON(object.sink);
        if (isSet(object.uniqueWriterIdentity))
            obj.uniqueWriterIdentity = Boolean(object.uniqueWriterIdentity);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.sink !== undefined && (obj.sink = message.sink ? LogSink.toJSON(message.sink) : undefined);
        message.uniqueWriterIdentity !== undefined && (obj.uniqueWriterIdentity = message.uniqueWriterIdentity);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCreateSinkRequest();
        message.parent = object.parent ?? "";
        if (object.sink !== undefined && object.sink !== null) {
            message.sink = LogSink.fromPartial(object.sink);
        }
        message.uniqueWriterIdentity = object.uniqueWriterIdentity ?? false;
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            sink: object.sink ? LogSink.fromSDK(object.sink) : undefined,
            uniqueWriterIdentity: object?.unique_writer_identity
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            sink: isSet(object.sink) ? LogSink.fromSDKJSON(object.sink) : undefined,
            unique_writer_identity: isSet(object.unique_writer_identity) ? Boolean(object.unique_writer_identity) : false
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        message.sink !== undefined && (obj.sink = message.sink ? LogSink.toSDK(message.sink) : undefined);
        obj.unique_writer_identity = message.uniqueWriterIdentity;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCreateSinkRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.sink !== undefined && object.sink !== null) {
            message.sink = LogSink.fromAmino(object.sink);
        }
        if (object.unique_writer_identity !== undefined && object.unique_writer_identity !== null) {
            message.uniqueWriterIdentity = object.unique_writer_identity;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.sink = message.sink ? LogSink.toAmino(message.sink) : undefined;
        obj.unique_writer_identity = message.uniqueWriterIdentity === false ? undefined : message.uniqueWriterIdentity;
        return obj;
    },
    fromAminoMsg(object) {
        return CreateSinkRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CreateSinkRequest.decode(message.value);
    },
    toProto(message) {
        return CreateSinkRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.CreateSinkRequest",
            value: CreateSinkRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogSink.registerTypeUrl();
    }
};
function createBaseUpdateSinkRequest() {
    return {
        sinkName: "",
        sink: undefined,
        uniqueWriterIdentity: false,
        updateMask: undefined
    };
}
export const UpdateSinkRequest = {
    typeUrl: "/google.logging.v2.UpdateSinkRequest",
    is(o) {
        return o && (o.$typeUrl === UpdateSinkRequest.typeUrl || typeof o.sinkName === "string" && typeof o.uniqueWriterIdentity === "boolean");
    },
    isSDK(o) {
        return o && (o.$typeUrl === UpdateSinkRequest.typeUrl || typeof o.sink_name === "string" && typeof o.unique_writer_identity === "boolean");
    },
    isAmino(o) {
        return o && (o.$typeUrl === UpdateSinkRequest.typeUrl || typeof o.sink_name === "string" && typeof o.unique_writer_identity === "boolean");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.sinkName !== undefined) {
            writer.uint32(10).string(message.sinkName);
        }
        if (message.sink !== undefined) {
            LogSink.encode(message.sink, writer.uint32(18).fork()).ldelim();
        }
        if (message.uniqueWriterIdentity !== undefined) {
            writer.uint32(24).bool(message.uniqueWriterIdentity);
        }
        if (message.updateMask !== undefined) {
            FieldMask.encode(message.updateMask, writer.uint32(34).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUpdateSinkRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.sinkName = reader.string();
                    break;
                case 2:
                    message.sink = LogSink.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.uniqueWriterIdentity = reader.bool();
                    break;
                case 4:
                    message.updateMask = FieldMask.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseUpdateSinkRequest();
        if (isSet(object.sinkName))
            obj.sinkName = String(object.sinkName);
        if (isSet(object.sink))
            obj.sink = LogSink.fromJSON(object.sink);
        if (isSet(object.uniqueWriterIdentity))
            obj.uniqueWriterIdentity = Boolean(object.uniqueWriterIdentity);
        if (isSet(object.updateMask))
            obj.updateMask = FieldMask.fromJSON(object.updateMask);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.sinkName !== undefined && (obj.sinkName = message.sinkName);
        message.sink !== undefined && (obj.sink = message.sink ? LogSink.toJSON(message.sink) : undefined);
        message.uniqueWriterIdentity !== undefined && (obj.uniqueWriterIdentity = message.uniqueWriterIdentity);
        message.updateMask !== undefined && (obj.updateMask = message.updateMask ? FieldMask.toJSON(message.updateMask) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseUpdateSinkRequest();
        message.sinkName = object.sinkName ?? "";
        if (object.sink !== undefined && object.sink !== null) {
            message.sink = LogSink.fromPartial(object.sink);
        }
        message.uniqueWriterIdentity = object.uniqueWriterIdentity ?? false;
        if (object.updateMask !== undefined && object.updateMask !== null) {
            message.updateMask = FieldMask.fromPartial(object.updateMask);
        }
        return message;
    },
    fromSDK(object) {
        return {
            sinkName: object?.sink_name,
            sink: object.sink ? LogSink.fromSDK(object.sink) : undefined,
            uniqueWriterIdentity: object?.unique_writer_identity,
            updateMask: object.update_mask ? FieldMask.fromSDK(object.update_mask) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            sink_name: isSet(object.sink_name) ? String(object.sink_name) : "",
            sink: isSet(object.sink) ? LogSink.fromSDKJSON(object.sink) : undefined,
            unique_writer_identity: isSet(object.unique_writer_identity) ? Boolean(object.unique_writer_identity) : false,
            update_mask: isSet(object.update_mask) ? FieldMask.fromSDKJSON(object.update_mask) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.sink_name = message.sinkName;
        message.sink !== undefined && (obj.sink = message.sink ? LogSink.toSDK(message.sink) : undefined);
        obj.unique_writer_identity = message.uniqueWriterIdentity;
        message.updateMask !== undefined && (obj.update_mask = message.updateMask ? FieldMask.toSDK(message.updateMask) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseUpdateSinkRequest();
        if (object.sink_name !== undefined && object.sink_name !== null) {
            message.sinkName = object.sink_name;
        }
        if (object.sink !== undefined && object.sink !== null) {
            message.sink = LogSink.fromAmino(object.sink);
        }
        if (object.unique_writer_identity !== undefined && object.unique_writer_identity !== null) {
            message.uniqueWriterIdentity = object.unique_writer_identity;
        }
        if (object.update_mask !== undefined && object.update_mask !== null) {
            message.updateMask = FieldMask.fromAmino(object.update_mask);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.sink_name = message.sinkName === "" ? undefined : message.sinkName;
        obj.sink = message.sink ? LogSink.toAmino(message.sink) : undefined;
        obj.unique_writer_identity = message.uniqueWriterIdentity === false ? undefined : message.uniqueWriterIdentity;
        obj.update_mask = message.updateMask ? FieldMask.toAmino(message.updateMask) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return UpdateSinkRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return UpdateSinkRequest.decode(message.value);
    },
    toProto(message) {
        return UpdateSinkRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.UpdateSinkRequest",
            value: UpdateSinkRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogSink.registerTypeUrl();
        FieldMask.registerTypeUrl();
    }
};
function createBaseDeleteSinkRequest() {
    return {
        sinkName: ""
    };
}
export const DeleteSinkRequest = {
    typeUrl: "/google.logging.v2.DeleteSinkRequest",
    is(o) {
        return o && (o.$typeUrl === DeleteSinkRequest.typeUrl || typeof o.sinkName === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === DeleteSinkRequest.typeUrl || typeof o.sink_name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === DeleteSinkRequest.typeUrl || typeof o.sink_name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.sinkName !== undefined) {
            writer.uint32(10).string(message.sinkName);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeleteSinkRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.sinkName = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDeleteSinkRequest();
        if (isSet(object.sinkName))
            obj.sinkName = String(object.sinkName);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.sinkName !== undefined && (obj.sinkName = message.sinkName);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDeleteSinkRequest();
        message.sinkName = object.sinkName ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            sinkName: object?.sink_name
        };
    },
    fromSDKJSON(object) {
        return {
            sink_name: isSet(object.sink_name) ? String(object.sink_name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.sink_name = message.sinkName;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDeleteSinkRequest();
        if (object.sink_name !== undefined && object.sink_name !== null) {
            message.sinkName = object.sink_name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.sink_name = message.sinkName === "" ? undefined : message.sinkName;
        return obj;
    },
    fromAminoMsg(object) {
        return DeleteSinkRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return DeleteSinkRequest.decode(message.value);
    },
    toProto(message) {
        return DeleteSinkRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.DeleteSinkRequest",
            value: DeleteSinkRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseLogExclusion() {
    return {
        name: "",
        description: "",
        filter: "",
        disabled: false,
        createTime: undefined,
        updateTime: undefined
    };
}
export const LogExclusion = {
    typeUrl: "/google.logging.v2.LogExclusion",
    is(o) {
        return o && (o.$typeUrl === LogExclusion.typeUrl || typeof o.name === "string" && typeof o.description === "string" && typeof o.filter === "string" && typeof o.disabled === "boolean");
    },
    isSDK(o) {
        return o && (o.$typeUrl === LogExclusion.typeUrl || typeof o.name === "string" && typeof o.description === "string" && typeof o.filter === "string" && typeof o.disabled === "boolean");
    },
    isAmino(o) {
        return o && (o.$typeUrl === LogExclusion.typeUrl || typeof o.name === "string" && typeof o.description === "string" && typeof o.filter === "string" && typeof o.disabled === "boolean");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.description !== undefined) {
            writer.uint32(18).string(message.description);
        }
        if (message.filter !== undefined) {
            writer.uint32(26).string(message.filter);
        }
        if (message.disabled !== undefined) {
            writer.uint32(32).bool(message.disabled);
        }
        if (message.createTime !== undefined) {
            Timestamp.encode(toTimestamp(message.createTime), writer.uint32(42).fork()).ldelim();
        }
        if (message.updateTime !== undefined) {
            Timestamp.encode(toTimestamp(message.updateTime), writer.uint32(50).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLogExclusion();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.description = reader.string();
                    break;
                case 3:
                    message.filter = reader.string();
                    break;
                case 4:
                    message.disabled = reader.bool();
                    break;
                case 5:
                    message.createTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 6:
                    message.updateTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLogExclusion();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.description))
            obj.description = String(object.description);
        if (isSet(object.filter))
            obj.filter = String(object.filter);
        if (isSet(object.disabled))
            obj.disabled = Boolean(object.disabled);
        if (isSet(object.createTime))
            obj.createTime = new Date(object.createTime);
        if (isSet(object.updateTime))
            obj.updateTime = new Date(object.updateTime);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.description !== undefined && (obj.description = message.description);
        message.filter !== undefined && (obj.filter = message.filter);
        message.disabled !== undefined && (obj.disabled = message.disabled);
        message.createTime !== undefined && (obj.createTime = message.createTime.toISOString());
        message.updateTime !== undefined && (obj.updateTime = message.updateTime.toISOString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLogExclusion();
        message.name = object.name ?? "";
        message.description = object.description ?? "";
        message.filter = object.filter ?? "";
        message.disabled = object.disabled ?? false;
        message.createTime = object.createTime ?? undefined;
        message.updateTime = object.updateTime ?? undefined;
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            description: object?.description,
            filter: object?.filter,
            disabled: object?.disabled,
            createTime: object.create_time ?? undefined,
            updateTime: object.update_time ?? undefined
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            description: isSet(object.description) ? String(object.description) : "",
            filter: isSet(object.filter) ? String(object.filter) : "",
            disabled: isSet(object.disabled) ? Boolean(object.disabled) : false,
            create_time: isSet(object.create_time) ? new Date(object.create_time) : undefined,
            update_time: isSet(object.update_time) ? new Date(object.update_time) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.description = message.description;
        obj.filter = message.filter;
        obj.disabled = message.disabled;
        message.createTime !== undefined && (obj.create_time = message.createTime ?? undefined);
        message.updateTime !== undefined && (obj.update_time = message.updateTime ?? undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLogExclusion();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.description !== undefined && object.description !== null) {
            message.description = object.description;
        }
        if (object.filter !== undefined && object.filter !== null) {
            message.filter = object.filter;
        }
        if (object.disabled !== undefined && object.disabled !== null) {
            message.disabled = object.disabled;
        }
        if (object.create_time !== undefined && object.create_time !== null) {
            message.createTime = fromTimestamp(Timestamp.fromAmino(object.create_time));
        }
        if (object.update_time !== undefined && object.update_time !== null) {
            message.updateTime = fromTimestamp(Timestamp.fromAmino(object.update_time));
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.description = message.description === "" ? undefined : message.description;
        obj.filter = message.filter === "" ? undefined : message.filter;
        obj.disabled = message.disabled === false ? undefined : message.disabled;
        obj.create_time = message.createTime ? Timestamp.toAmino(toTimestamp(message.createTime)) : undefined;
        obj.update_time = message.updateTime ? Timestamp.toAmino(toTimestamp(message.updateTime)) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return LogExclusion.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return LogExclusion.decode(message.value);
    },
    toProto(message) {
        return LogExclusion.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.LogExclusion",
            value: LogExclusion.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListExclusionsRequest() {
    return {
        parent: "",
        pageToken: "",
        pageSize: 0
    };
}
export const ListExclusionsRequest = {
    typeUrl: "/google.logging.v2.ListExclusionsRequest",
    is(o) {
        return o && (o.$typeUrl === ListExclusionsRequest.typeUrl || typeof o.parent === "string" && typeof o.pageToken === "string" && typeof o.pageSize === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListExclusionsRequest.typeUrl || typeof o.parent === "string" && typeof o.page_token === "string" && typeof o.page_size === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListExclusionsRequest.typeUrl || typeof o.parent === "string" && typeof o.page_token === "string" && typeof o.page_size === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.pageToken !== undefined) {
            writer.uint32(18).string(message.pageToken);
        }
        if (message.pageSize !== undefined) {
            writer.uint32(24).int32(message.pageSize);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListExclusionsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.pageToken = reader.string();
                    break;
                case 3:
                    message.pageSize = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListExclusionsRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.pageToken))
            obj.pageToken = String(object.pageToken);
        if (isSet(object.pageSize))
            obj.pageSize = Number(object.pageSize);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.pageToken !== undefined && (obj.pageToken = message.pageToken);
        message.pageSize !== undefined && (obj.pageSize = Math.round(message.pageSize));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListExclusionsRequest();
        message.parent = object.parent ?? "";
        message.pageToken = object.pageToken ?? "";
        message.pageSize = object.pageSize ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            pageToken: object?.page_token,
            pageSize: object?.page_size
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            page_token: isSet(object.page_token) ? String(object.page_token) : "",
            page_size: isSet(object.page_size) ? Number(object.page_size) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        obj.page_token = message.pageToken;
        obj.page_size = message.pageSize;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListExclusionsRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.page_token !== undefined && object.page_token !== null) {
            message.pageToken = object.page_token;
        }
        if (object.page_size !== undefined && object.page_size !== null) {
            message.pageSize = object.page_size;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.page_token = message.pageToken === "" ? undefined : message.pageToken;
        obj.page_size = message.pageSize === 0 ? undefined : message.pageSize;
        return obj;
    },
    fromAminoMsg(object) {
        return ListExclusionsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListExclusionsRequest.decode(message.value);
    },
    toProto(message) {
        return ListExclusionsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.ListExclusionsRequest",
            value: ListExclusionsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListExclusionsResponse() {
    return {
        exclusions: [],
        nextPageToken: ""
    };
}
export const ListExclusionsResponse = {
    typeUrl: "/google.logging.v2.ListExclusionsResponse",
    is(o) {
        return o && (o.$typeUrl === ListExclusionsResponse.typeUrl || Array.isArray(o.exclusions) && (!o.exclusions.length || LogExclusion.is(o.exclusions[0])) && typeof o.nextPageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListExclusionsResponse.typeUrl || Array.isArray(o.exclusions) && (!o.exclusions.length || LogExclusion.isSDK(o.exclusions[0])) && typeof o.next_page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListExclusionsResponse.typeUrl || Array.isArray(o.exclusions) && (!o.exclusions.length || LogExclusion.isAmino(o.exclusions[0])) && typeof o.next_page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.exclusions) {
            LogExclusion.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.nextPageToken !== undefined) {
            writer.uint32(18).string(message.nextPageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListExclusionsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.exclusions.push(LogExclusion.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.nextPageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListExclusionsResponse();
        if (Array.isArray(object?.exclusions))
            obj.exclusions = object.exclusions.map((e) => LogExclusion.fromJSON(e));
        if (isSet(object.nextPageToken))
            obj.nextPageToken = String(object.nextPageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.exclusions) {
            obj.exclusions = message.exclusions.map(e => e ? LogExclusion.toJSON(e) : undefined);
        }
        else {
            obj.exclusions = [];
        }
        message.nextPageToken !== undefined && (obj.nextPageToken = message.nextPageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListExclusionsResponse();
        message.exclusions = object.exclusions?.map(e => LogExclusion.fromPartial(e)) || [];
        message.nextPageToken = object.nextPageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            exclusions: Array.isArray(object?.exclusions) ? object.exclusions.map((e) => LogExclusion.fromSDK(e)) : [],
            nextPageToken: object?.next_page_token
        };
    },
    fromSDKJSON(object) {
        return {
            exclusions: Array.isArray(object?.exclusions) ? object.exclusions.map((e) => LogExclusion.fromSDKJSON(e)) : [],
            next_page_token: isSet(object.next_page_token) ? String(object.next_page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.exclusions) {
            obj.exclusions = message.exclusions.map(e => e ? LogExclusion.toSDK(e) : undefined);
        }
        else {
            obj.exclusions = [];
        }
        obj.next_page_token = message.nextPageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListExclusionsResponse();
        message.exclusions = object.exclusions?.map(e => LogExclusion.fromAmino(e)) || [];
        if (object.next_page_token !== undefined && object.next_page_token !== null) {
            message.nextPageToken = object.next_page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.exclusions) {
            obj.exclusions = message.exclusions.map(e => e ? LogExclusion.toAmino(e) : undefined);
        }
        else {
            obj.exclusions = message.exclusions;
        }
        obj.next_page_token = message.nextPageToken === "" ? undefined : message.nextPageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListExclusionsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListExclusionsResponse.decode(message.value);
    },
    toProto(message) {
        return ListExclusionsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.ListExclusionsResponse",
            value: ListExclusionsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogExclusion.registerTypeUrl();
    }
};
function createBaseGetExclusionRequest() {
    return {
        name: ""
    };
}
export const GetExclusionRequest = {
    typeUrl: "/google.logging.v2.GetExclusionRequest",
    is(o) {
        return o && (o.$typeUrl === GetExclusionRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === GetExclusionRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === GetExclusionRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetExclusionRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGetExclusionRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGetExclusionRequest();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGetExclusionRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return GetExclusionRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetExclusionRequest.decode(message.value);
    },
    toProto(message) {
        return GetExclusionRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.GetExclusionRequest",
            value: GetExclusionRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseCreateExclusionRequest() {
    return {
        parent: "",
        exclusion: undefined
    };
}
export const CreateExclusionRequest = {
    typeUrl: "/google.logging.v2.CreateExclusionRequest",
    is(o) {
        return o && (o.$typeUrl === CreateExclusionRequest.typeUrl || typeof o.parent === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === CreateExclusionRequest.typeUrl || typeof o.parent === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === CreateExclusionRequest.typeUrl || typeof o.parent === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.exclusion !== undefined) {
            LogExclusion.encode(message.exclusion, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCreateExclusionRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.exclusion = LogExclusion.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCreateExclusionRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.exclusion))
            obj.exclusion = LogExclusion.fromJSON(object.exclusion);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.exclusion !== undefined && (obj.exclusion = message.exclusion ? LogExclusion.toJSON(message.exclusion) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCreateExclusionRequest();
        message.parent = object.parent ?? "";
        if (object.exclusion !== undefined && object.exclusion !== null) {
            message.exclusion = LogExclusion.fromPartial(object.exclusion);
        }
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            exclusion: object.exclusion ? LogExclusion.fromSDK(object.exclusion) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            exclusion: isSet(object.exclusion) ? LogExclusion.fromSDKJSON(object.exclusion) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        message.exclusion !== undefined && (obj.exclusion = message.exclusion ? LogExclusion.toSDK(message.exclusion) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCreateExclusionRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.exclusion !== undefined && object.exclusion !== null) {
            message.exclusion = LogExclusion.fromAmino(object.exclusion);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.exclusion = message.exclusion ? LogExclusion.toAmino(message.exclusion) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return CreateExclusionRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CreateExclusionRequest.decode(message.value);
    },
    toProto(message) {
        return CreateExclusionRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.CreateExclusionRequest",
            value: CreateExclusionRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogExclusion.registerTypeUrl();
    }
};
function createBaseUpdateExclusionRequest() {
    return {
        name: "",
        exclusion: undefined,
        updateMask: undefined
    };
}
export const UpdateExclusionRequest = {
    typeUrl: "/google.logging.v2.UpdateExclusionRequest",
    is(o) {
        return o && (o.$typeUrl === UpdateExclusionRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === UpdateExclusionRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === UpdateExclusionRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.exclusion !== undefined) {
            LogExclusion.encode(message.exclusion, writer.uint32(18).fork()).ldelim();
        }
        if (message.updateMask !== undefined) {
            FieldMask.encode(message.updateMask, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUpdateExclusionRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.exclusion = LogExclusion.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.updateMask = FieldMask.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseUpdateExclusionRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.exclusion))
            obj.exclusion = LogExclusion.fromJSON(object.exclusion);
        if (isSet(object.updateMask))
            obj.updateMask = FieldMask.fromJSON(object.updateMask);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.exclusion !== undefined && (obj.exclusion = message.exclusion ? LogExclusion.toJSON(message.exclusion) : undefined);
        message.updateMask !== undefined && (obj.updateMask = message.updateMask ? FieldMask.toJSON(message.updateMask) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseUpdateExclusionRequest();
        message.name = object.name ?? "";
        if (object.exclusion !== undefined && object.exclusion !== null) {
            message.exclusion = LogExclusion.fromPartial(object.exclusion);
        }
        if (object.updateMask !== undefined && object.updateMask !== null) {
            message.updateMask = FieldMask.fromPartial(object.updateMask);
        }
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            exclusion: object.exclusion ? LogExclusion.fromSDK(object.exclusion) : undefined,
            updateMask: object.update_mask ? FieldMask.fromSDK(object.update_mask) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            exclusion: isSet(object.exclusion) ? LogExclusion.fromSDKJSON(object.exclusion) : undefined,
            update_mask: isSet(object.update_mask) ? FieldMask.fromSDKJSON(object.update_mask) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        message.exclusion !== undefined && (obj.exclusion = message.exclusion ? LogExclusion.toSDK(message.exclusion) : undefined);
        message.updateMask !== undefined && (obj.update_mask = message.updateMask ? FieldMask.toSDK(message.updateMask) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseUpdateExclusionRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.exclusion !== undefined && object.exclusion !== null) {
            message.exclusion = LogExclusion.fromAmino(object.exclusion);
        }
        if (object.update_mask !== undefined && object.update_mask !== null) {
            message.updateMask = FieldMask.fromAmino(object.update_mask);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.exclusion = message.exclusion ? LogExclusion.toAmino(message.exclusion) : undefined;
        obj.update_mask = message.updateMask ? FieldMask.toAmino(message.updateMask) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return UpdateExclusionRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return UpdateExclusionRequest.decode(message.value);
    },
    toProto(message) {
        return UpdateExclusionRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.UpdateExclusionRequest",
            value: UpdateExclusionRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogExclusion.registerTypeUrl();
        FieldMask.registerTypeUrl();
    }
};
function createBaseDeleteExclusionRequest() {
    return {
        name: ""
    };
}
export const DeleteExclusionRequest = {
    typeUrl: "/google.logging.v2.DeleteExclusionRequest",
    is(o) {
        return o && (o.$typeUrl === DeleteExclusionRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === DeleteExclusionRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === DeleteExclusionRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeleteExclusionRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDeleteExclusionRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDeleteExclusionRequest();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDeleteExclusionRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return DeleteExclusionRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return DeleteExclusionRequest.decode(message.value);
    },
    toProto(message) {
        return DeleteExclusionRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.DeleteExclusionRequest",
            value: DeleteExclusionRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseGetCmekSettingsRequest() {
    return {
        name: ""
    };
}
export const GetCmekSettingsRequest = {
    typeUrl: "/google.logging.v2.GetCmekSettingsRequest",
    is(o) {
        return o && (o.$typeUrl === GetCmekSettingsRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === GetCmekSettingsRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === GetCmekSettingsRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetCmekSettingsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGetCmekSettingsRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGetCmekSettingsRequest();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGetCmekSettingsRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return GetCmekSettingsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetCmekSettingsRequest.decode(message.value);
    },
    toProto(message) {
        return GetCmekSettingsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.GetCmekSettingsRequest",
            value: GetCmekSettingsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseUpdateCmekSettingsRequest() {
    return {
        name: "",
        cmekSettings: undefined,
        updateMask: undefined
    };
}
export const UpdateCmekSettingsRequest = {
    typeUrl: "/google.logging.v2.UpdateCmekSettingsRequest",
    is(o) {
        return o && (o.$typeUrl === UpdateCmekSettingsRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === UpdateCmekSettingsRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === UpdateCmekSettingsRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.cmekSettings !== undefined) {
            CmekSettings.encode(message.cmekSettings, writer.uint32(18).fork()).ldelim();
        }
        if (message.updateMask !== undefined) {
            FieldMask.encode(message.updateMask, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUpdateCmekSettingsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.cmekSettings = CmekSettings.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.updateMask = FieldMask.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseUpdateCmekSettingsRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.cmekSettings))
            obj.cmekSettings = CmekSettings.fromJSON(object.cmekSettings);
        if (isSet(object.updateMask))
            obj.updateMask = FieldMask.fromJSON(object.updateMask);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.cmekSettings !== undefined && (obj.cmekSettings = message.cmekSettings ? CmekSettings.toJSON(message.cmekSettings) : undefined);
        message.updateMask !== undefined && (obj.updateMask = message.updateMask ? FieldMask.toJSON(message.updateMask) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseUpdateCmekSettingsRequest();
        message.name = object.name ?? "";
        if (object.cmekSettings !== undefined && object.cmekSettings !== null) {
            message.cmekSettings = CmekSettings.fromPartial(object.cmekSettings);
        }
        if (object.updateMask !== undefined && object.updateMask !== null) {
            message.updateMask = FieldMask.fromPartial(object.updateMask);
        }
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            cmekSettings: object.cmek_settings ? CmekSettings.fromSDK(object.cmek_settings) : undefined,
            updateMask: object.update_mask ? FieldMask.fromSDK(object.update_mask) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            cmek_settings: isSet(object.cmek_settings) ? CmekSettings.fromSDKJSON(object.cmek_settings) : undefined,
            update_mask: isSet(object.update_mask) ? FieldMask.fromSDKJSON(object.update_mask) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        message.cmekSettings !== undefined && (obj.cmek_settings = message.cmekSettings ? CmekSettings.toSDK(message.cmekSettings) : undefined);
        message.updateMask !== undefined && (obj.update_mask = message.updateMask ? FieldMask.toSDK(message.updateMask) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseUpdateCmekSettingsRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.cmek_settings !== undefined && object.cmek_settings !== null) {
            message.cmekSettings = CmekSettings.fromAmino(object.cmek_settings);
        }
        if (object.update_mask !== undefined && object.update_mask !== null) {
            message.updateMask = FieldMask.fromAmino(object.update_mask);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.cmek_settings = message.cmekSettings ? CmekSettings.toAmino(message.cmekSettings) : undefined;
        obj.update_mask = message.updateMask ? FieldMask.toAmino(message.updateMask) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return UpdateCmekSettingsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return UpdateCmekSettingsRequest.decode(message.value);
    },
    toProto(message) {
        return UpdateCmekSettingsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.UpdateCmekSettingsRequest",
            value: UpdateCmekSettingsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        CmekSettings.registerTypeUrl();
        FieldMask.registerTypeUrl();
    }
};
function createBaseCmekSettings() {
    return {
        name: "",
        kmsKeyName: "",
        serviceAccountId: ""
    };
}
export const CmekSettings = {
    typeUrl: "/google.logging.v2.CmekSettings",
    is(o) {
        return o && (o.$typeUrl === CmekSettings.typeUrl || typeof o.name === "string" && typeof o.kmsKeyName === "string" && typeof o.serviceAccountId === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === CmekSettings.typeUrl || typeof o.name === "string" && typeof o.kms_key_name === "string" && typeof o.service_account_id === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === CmekSettings.typeUrl || typeof o.name === "string" && typeof o.kms_key_name === "string" && typeof o.service_account_id === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.kmsKeyName !== undefined) {
            writer.uint32(18).string(message.kmsKeyName);
        }
        if (message.serviceAccountId !== undefined) {
            writer.uint32(26).string(message.serviceAccountId);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCmekSettings();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.kmsKeyName = reader.string();
                    break;
                case 3:
                    message.serviceAccountId = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCmekSettings();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.kmsKeyName))
            obj.kmsKeyName = String(object.kmsKeyName);
        if (isSet(object.serviceAccountId))
            obj.serviceAccountId = String(object.serviceAccountId);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.kmsKeyName !== undefined && (obj.kmsKeyName = message.kmsKeyName);
        message.serviceAccountId !== undefined && (obj.serviceAccountId = message.serviceAccountId);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCmekSettings();
        message.name = object.name ?? "";
        message.kmsKeyName = object.kmsKeyName ?? "";
        message.serviceAccountId = object.serviceAccountId ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            kmsKeyName: object?.kms_key_name,
            serviceAccountId: object?.service_account_id
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            kms_key_name: isSet(object.kms_key_name) ? String(object.kms_key_name) : "",
            service_account_id: isSet(object.service_account_id) ? String(object.service_account_id) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.kms_key_name = message.kmsKeyName;
        obj.service_account_id = message.serviceAccountId;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCmekSettings();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.kms_key_name !== undefined && object.kms_key_name !== null) {
            message.kmsKeyName = object.kms_key_name;
        }
        if (object.service_account_id !== undefined && object.service_account_id !== null) {
            message.serviceAccountId = object.service_account_id;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.kms_key_name = message.kmsKeyName === "" ? undefined : message.kmsKeyName;
        obj.service_account_id = message.serviceAccountId === "" ? undefined : message.serviceAccountId;
        return obj;
    },
    fromAminoMsg(object) {
        return CmekSettings.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CmekSettings.decode(message.value);
    },
    toProto(message) {
        return CmekSettings.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.CmekSettings",
            value: CmekSettings.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseGetSettingsRequest() {
    return {
        name: ""
    };
}
export const GetSettingsRequest = {
    typeUrl: "/google.logging.v2.GetSettingsRequest",
    is(o) {
        return o && (o.$typeUrl === GetSettingsRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === GetSettingsRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === GetSettingsRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetSettingsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGetSettingsRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGetSettingsRequest();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGetSettingsRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return GetSettingsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetSettingsRequest.decode(message.value);
    },
    toProto(message) {
        return GetSettingsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.GetSettingsRequest",
            value: GetSettingsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseUpdateSettingsRequest() {
    return {
        name: "",
        settings: undefined,
        updateMask: undefined
    };
}
export const UpdateSettingsRequest = {
    typeUrl: "/google.logging.v2.UpdateSettingsRequest",
    is(o) {
        return o && (o.$typeUrl === UpdateSettingsRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === UpdateSettingsRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === UpdateSettingsRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.settings !== undefined) {
            Settings.encode(message.settings, writer.uint32(18).fork()).ldelim();
        }
        if (message.updateMask !== undefined) {
            FieldMask.encode(message.updateMask, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUpdateSettingsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.settings = Settings.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.updateMask = FieldMask.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseUpdateSettingsRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.settings))
            obj.settings = Settings.fromJSON(object.settings);
        if (isSet(object.updateMask))
            obj.updateMask = FieldMask.fromJSON(object.updateMask);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.settings !== undefined && (obj.settings = message.settings ? Settings.toJSON(message.settings) : undefined);
        message.updateMask !== undefined && (obj.updateMask = message.updateMask ? FieldMask.toJSON(message.updateMask) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseUpdateSettingsRequest();
        message.name = object.name ?? "";
        if (object.settings !== undefined && object.settings !== null) {
            message.settings = Settings.fromPartial(object.settings);
        }
        if (object.updateMask !== undefined && object.updateMask !== null) {
            message.updateMask = FieldMask.fromPartial(object.updateMask);
        }
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            settings: object.settings ? Settings.fromSDK(object.settings) : undefined,
            updateMask: object.update_mask ? FieldMask.fromSDK(object.update_mask) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            settings: isSet(object.settings) ? Settings.fromSDKJSON(object.settings) : undefined,
            update_mask: isSet(object.update_mask) ? FieldMask.fromSDKJSON(object.update_mask) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        message.settings !== undefined && (obj.settings = message.settings ? Settings.toSDK(message.settings) : undefined);
        message.updateMask !== undefined && (obj.update_mask = message.updateMask ? FieldMask.toSDK(message.updateMask) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseUpdateSettingsRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.settings !== undefined && object.settings !== null) {
            message.settings = Settings.fromAmino(object.settings);
        }
        if (object.update_mask !== undefined && object.update_mask !== null) {
            message.updateMask = FieldMask.fromAmino(object.update_mask);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.settings = message.settings ? Settings.toAmino(message.settings) : undefined;
        obj.update_mask = message.updateMask ? FieldMask.toAmino(message.updateMask) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return UpdateSettingsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return UpdateSettingsRequest.decode(message.value);
    },
    toProto(message) {
        return UpdateSettingsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.UpdateSettingsRequest",
            value: UpdateSettingsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Settings.registerTypeUrl();
        FieldMask.registerTypeUrl();
    }
};
function createBaseSettings() {
    return {
        name: "",
        kmsKeyName: "",
        kmsServiceAccountId: "",
        storageLocation: "",
        disableDefaultSink: false
    };
}
export const Settings = {
    typeUrl: "/google.logging.v2.Settings",
    is(o) {
        return o && (o.$typeUrl === Settings.typeUrl || typeof o.name === "string" && typeof o.kmsKeyName === "string" && typeof o.kmsServiceAccountId === "string" && typeof o.storageLocation === "string" && typeof o.disableDefaultSink === "boolean");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Settings.typeUrl || typeof o.name === "string" && typeof o.kms_key_name === "string" && typeof o.kms_service_account_id === "string" && typeof o.storage_location === "string" && typeof o.disable_default_sink === "boolean");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Settings.typeUrl || typeof o.name === "string" && typeof o.kms_key_name === "string" && typeof o.kms_service_account_id === "string" && typeof o.storage_location === "string" && typeof o.disable_default_sink === "boolean");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.kmsKeyName !== undefined) {
            writer.uint32(18).string(message.kmsKeyName);
        }
        if (message.kmsServiceAccountId !== undefined) {
            writer.uint32(26).string(message.kmsServiceAccountId);
        }
        if (message.storageLocation !== undefined) {
            writer.uint32(34).string(message.storageLocation);
        }
        if (message.disableDefaultSink !== undefined) {
            writer.uint32(40).bool(message.disableDefaultSink);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSettings();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.kmsKeyName = reader.string();
                    break;
                case 3:
                    message.kmsServiceAccountId = reader.string();
                    break;
                case 4:
                    message.storageLocation = reader.string();
                    break;
                case 5:
                    message.disableDefaultSink = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseSettings();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.kmsKeyName))
            obj.kmsKeyName = String(object.kmsKeyName);
        if (isSet(object.kmsServiceAccountId))
            obj.kmsServiceAccountId = String(object.kmsServiceAccountId);
        if (isSet(object.storageLocation))
            obj.storageLocation = String(object.storageLocation);
        if (isSet(object.disableDefaultSink))
            obj.disableDefaultSink = Boolean(object.disableDefaultSink);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.kmsKeyName !== undefined && (obj.kmsKeyName = message.kmsKeyName);
        message.kmsServiceAccountId !== undefined && (obj.kmsServiceAccountId = message.kmsServiceAccountId);
        message.storageLocation !== undefined && (obj.storageLocation = message.storageLocation);
        message.disableDefaultSink !== undefined && (obj.disableDefaultSink = message.disableDefaultSink);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseSettings();
        message.name = object.name ?? "";
        message.kmsKeyName = object.kmsKeyName ?? "";
        message.kmsServiceAccountId = object.kmsServiceAccountId ?? "";
        message.storageLocation = object.storageLocation ?? "";
        message.disableDefaultSink = object.disableDefaultSink ?? false;
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            kmsKeyName: object?.kms_key_name,
            kmsServiceAccountId: object?.kms_service_account_id,
            storageLocation: object?.storage_location,
            disableDefaultSink: object?.disable_default_sink
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            kms_key_name: isSet(object.kms_key_name) ? String(object.kms_key_name) : "",
            kms_service_account_id: isSet(object.kms_service_account_id) ? String(object.kms_service_account_id) : "",
            storage_location: isSet(object.storage_location) ? String(object.storage_location) : "",
            disable_default_sink: isSet(object.disable_default_sink) ? Boolean(object.disable_default_sink) : false
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.kms_key_name = message.kmsKeyName;
        obj.kms_service_account_id = message.kmsServiceAccountId;
        obj.storage_location = message.storageLocation;
        obj.disable_default_sink = message.disableDefaultSink;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseSettings();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.kms_key_name !== undefined && object.kms_key_name !== null) {
            message.kmsKeyName = object.kms_key_name;
        }
        if (object.kms_service_account_id !== undefined && object.kms_service_account_id !== null) {
            message.kmsServiceAccountId = object.kms_service_account_id;
        }
        if (object.storage_location !== undefined && object.storage_location !== null) {
            message.storageLocation = object.storage_location;
        }
        if (object.disable_default_sink !== undefined && object.disable_default_sink !== null) {
            message.disableDefaultSink = object.disable_default_sink;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.kms_key_name = message.kmsKeyName === "" ? undefined : message.kmsKeyName;
        obj.kms_service_account_id = message.kmsServiceAccountId === "" ? undefined : message.kmsServiceAccountId;
        obj.storage_location = message.storageLocation === "" ? undefined : message.storageLocation;
        obj.disable_default_sink = message.disableDefaultSink === false ? undefined : message.disableDefaultSink;
        return obj;
    },
    fromAminoMsg(object) {
        return Settings.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Settings.decode(message.value);
    },
    toProto(message) {
        return Settings.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.Settings",
            value: Settings.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseCopyLogEntriesRequest() {
    return {
        name: "",
        filter: "",
        destination: ""
    };
}
export const CopyLogEntriesRequest = {
    typeUrl: "/google.logging.v2.CopyLogEntriesRequest",
    is(o) {
        return o && (o.$typeUrl === CopyLogEntriesRequest.typeUrl || typeof o.name === "string" && typeof o.filter === "string" && typeof o.destination === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === CopyLogEntriesRequest.typeUrl || typeof o.name === "string" && typeof o.filter === "string" && typeof o.destination === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === CopyLogEntriesRequest.typeUrl || typeof o.name === "string" && typeof o.filter === "string" && typeof o.destination === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.filter !== undefined) {
            writer.uint32(26).string(message.filter);
        }
        if (message.destination !== undefined) {
            writer.uint32(34).string(message.destination);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCopyLogEntriesRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 3:
                    message.filter = reader.string();
                    break;
                case 4:
                    message.destination = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCopyLogEntriesRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.filter))
            obj.filter = String(object.filter);
        if (isSet(object.destination))
            obj.destination = String(object.destination);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.filter !== undefined && (obj.filter = message.filter);
        message.destination !== undefined && (obj.destination = message.destination);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCopyLogEntriesRequest();
        message.name = object.name ?? "";
        message.filter = object.filter ?? "";
        message.destination = object.destination ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            filter: object?.filter,
            destination: object?.destination
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            filter: isSet(object.filter) ? String(object.filter) : "",
            destination: isSet(object.destination) ? String(object.destination) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.filter = message.filter;
        obj.destination = message.destination;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCopyLogEntriesRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.filter !== undefined && object.filter !== null) {
            message.filter = object.filter;
        }
        if (object.destination !== undefined && object.destination !== null) {
            message.destination = object.destination;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.filter = message.filter === "" ? undefined : message.filter;
        obj.destination = message.destination === "" ? undefined : message.destination;
        return obj;
    },
    fromAminoMsg(object) {
        return CopyLogEntriesRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CopyLogEntriesRequest.decode(message.value);
    },
    toProto(message) {
        return CopyLogEntriesRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.CopyLogEntriesRequest",
            value: CopyLogEntriesRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseCopyLogEntriesMetadata() {
    return {
        startTime: undefined,
        endTime: undefined,
        state: 0,
        cancellationRequested: false,
        request: undefined,
        progress: 0,
        writerIdentity: ""
    };
}
export const CopyLogEntriesMetadata = {
    typeUrl: "/google.logging.v2.CopyLogEntriesMetadata",
    is(o) {
        return o && (o.$typeUrl === CopyLogEntriesMetadata.typeUrl || isSet(o.state) && typeof o.cancellationRequested === "boolean" && typeof o.progress === "number" && typeof o.writerIdentity === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === CopyLogEntriesMetadata.typeUrl || isSet(o.state) && typeof o.cancellation_requested === "boolean" && typeof o.progress === "number" && typeof o.writer_identity === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === CopyLogEntriesMetadata.typeUrl || isSet(o.state) && typeof o.cancellation_requested === "boolean" && typeof o.progress === "number" && typeof o.writer_identity === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.startTime !== undefined) {
            Timestamp.encode(toTimestamp(message.startTime), writer.uint32(10).fork()).ldelim();
        }
        if (message.endTime !== undefined) {
            Timestamp.encode(toTimestamp(message.endTime), writer.uint32(18).fork()).ldelim();
        }
        if (message.state !== 0) {
            writer.uint32(24).int32(message.state);
        }
        if (message.cancellationRequested !== undefined) {
            writer.uint32(32).bool(message.cancellationRequested);
        }
        if (message.request !== undefined) {
            CopyLogEntriesRequest.encode(message.request, writer.uint32(42).fork()).ldelim();
        }
        if (message.progress !== undefined) {
            writer.uint32(48).int32(message.progress);
        }
        if (message.writerIdentity !== undefined) {
            writer.uint32(58).string(message.writerIdentity);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCopyLogEntriesMetadata();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.startTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.endTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.state = reader.int32();
                    break;
                case 4:
                    message.cancellationRequested = reader.bool();
                    break;
                case 5:
                    message.request = CopyLogEntriesRequest.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.progress = reader.int32();
                    break;
                case 7:
                    message.writerIdentity = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCopyLogEntriesMetadata();
        if (isSet(object.startTime))
            obj.startTime = new Date(object.startTime);
        if (isSet(object.endTime))
            obj.endTime = new Date(object.endTime);
        if (isSet(object.state))
            obj.state = operationStateFromJSON(object.state);
        if (isSet(object.cancellationRequested))
            obj.cancellationRequested = Boolean(object.cancellationRequested);
        if (isSet(object.request))
            obj.request = CopyLogEntriesRequest.fromJSON(object.request);
        if (isSet(object.progress))
            obj.progress = Number(object.progress);
        if (isSet(object.writerIdentity))
            obj.writerIdentity = String(object.writerIdentity);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.startTime !== undefined && (obj.startTime = message.startTime.toISOString());
        message.endTime !== undefined && (obj.endTime = message.endTime.toISOString());
        message.state !== undefined && (obj.state = operationStateToJSON(message.state));
        message.cancellationRequested !== undefined && (obj.cancellationRequested = message.cancellationRequested);
        message.request !== undefined && (obj.request = message.request ? CopyLogEntriesRequest.toJSON(message.request) : undefined);
        message.progress !== undefined && (obj.progress = Math.round(message.progress));
        message.writerIdentity !== undefined && (obj.writerIdentity = message.writerIdentity);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCopyLogEntriesMetadata();
        message.startTime = object.startTime ?? undefined;
        message.endTime = object.endTime ?? undefined;
        message.state = object.state ?? 0;
        message.cancellationRequested = object.cancellationRequested ?? false;
        if (object.request !== undefined && object.request !== null) {
            message.request = CopyLogEntriesRequest.fromPartial(object.request);
        }
        message.progress = object.progress ?? 0;
        message.writerIdentity = object.writerIdentity ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            startTime: object.start_time ?? undefined,
            endTime: object.end_time ?? undefined,
            state: isSet(object.state) ? operationStateFromJSON(object.state) : -1,
            cancellationRequested: object?.cancellation_requested,
            request: object.request ? CopyLogEntriesRequest.fromSDK(object.request) : undefined,
            progress: object?.progress,
            writerIdentity: object?.writer_identity
        };
    },
    fromSDKJSON(object) {
        return {
            start_time: isSet(object.start_time) ? new Date(object.start_time) : undefined,
            end_time: isSet(object.end_time) ? new Date(object.end_time) : undefined,
            state: isSet(object.state) ? operationStateFromJSON(object.state) : -1,
            cancellation_requested: isSet(object.cancellation_requested) ? Boolean(object.cancellation_requested) : false,
            request: isSet(object.request) ? CopyLogEntriesRequest.fromSDKJSON(object.request) : undefined,
            progress: isSet(object.progress) ? Number(object.progress) : 0,
            writer_identity: isSet(object.writer_identity) ? String(object.writer_identity) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        message.startTime !== undefined && (obj.start_time = message.startTime ?? undefined);
        message.endTime !== undefined && (obj.end_time = message.endTime ?? undefined);
        message.state !== undefined && (obj.state = operationStateToJSON(message.state));
        obj.cancellation_requested = message.cancellationRequested;
        message.request !== undefined && (obj.request = message.request ? CopyLogEntriesRequest.toSDK(message.request) : undefined);
        obj.progress = message.progress;
        obj.writer_identity = message.writerIdentity;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCopyLogEntriesMetadata();
        if (object.start_time !== undefined && object.start_time !== null) {
            message.startTime = fromTimestamp(Timestamp.fromAmino(object.start_time));
        }
        if (object.end_time !== undefined && object.end_time !== null) {
            message.endTime = fromTimestamp(Timestamp.fromAmino(object.end_time));
        }
        if (object.state !== undefined && object.state !== null) {
            message.state = object.state;
        }
        if (object.cancellation_requested !== undefined && object.cancellation_requested !== null) {
            message.cancellationRequested = object.cancellation_requested;
        }
        if (object.request !== undefined && object.request !== null) {
            message.request = CopyLogEntriesRequest.fromAmino(object.request);
        }
        if (object.progress !== undefined && object.progress !== null) {
            message.progress = object.progress;
        }
        if (object.writer_identity !== undefined && object.writer_identity !== null) {
            message.writerIdentity = object.writer_identity;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.start_time = message.startTime ? Timestamp.toAmino(toTimestamp(message.startTime)) : undefined;
        obj.end_time = message.endTime ? Timestamp.toAmino(toTimestamp(message.endTime)) : undefined;
        obj.state = message.state === 0 ? undefined : message.state;
        obj.cancellation_requested = message.cancellationRequested === false ? undefined : message.cancellationRequested;
        obj.request = message.request ? CopyLogEntriesRequest.toAmino(message.request) : undefined;
        obj.progress = message.progress === 0 ? undefined : message.progress;
        obj.writer_identity = message.writerIdentity === "" ? undefined : message.writerIdentity;
        return obj;
    },
    fromAminoMsg(object) {
        return CopyLogEntriesMetadata.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CopyLogEntriesMetadata.decode(message.value);
    },
    toProto(message) {
        return CopyLogEntriesMetadata.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.CopyLogEntriesMetadata",
            value: CopyLogEntriesMetadata.encode(message).finish()
        };
    },
    registerTypeUrl() {
        CopyLogEntriesRequest.registerTypeUrl();
    }
};
function createBaseCopyLogEntriesResponse() {
    return {
        logEntriesCopiedCount: BigInt(0)
    };
}
export const CopyLogEntriesResponse = {
    typeUrl: "/google.logging.v2.CopyLogEntriesResponse",
    is(o) {
        return o && (o.$typeUrl === CopyLogEntriesResponse.typeUrl || typeof o.logEntriesCopiedCount === "bigint");
    },
    isSDK(o) {
        return o && (o.$typeUrl === CopyLogEntriesResponse.typeUrl || typeof o.log_entries_copied_count === "bigint");
    },
    isAmino(o) {
        return o && (o.$typeUrl === CopyLogEntriesResponse.typeUrl || typeof o.log_entries_copied_count === "bigint");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.logEntriesCopiedCount !== undefined) {
            writer.uint32(8).int64(message.logEntriesCopiedCount);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCopyLogEntriesResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.logEntriesCopiedCount = reader.int64();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCopyLogEntriesResponse();
        if (isSet(object.logEntriesCopiedCount))
            obj.logEntriesCopiedCount = BigInt(object.logEntriesCopiedCount.toString());
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.logEntriesCopiedCount !== undefined && (obj.logEntriesCopiedCount = (message.logEntriesCopiedCount || BigInt(0)).toString());
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCopyLogEntriesResponse();
        if (object.logEntriesCopiedCount !== undefined && object.logEntriesCopiedCount !== null) {
            message.logEntriesCopiedCount = BigInt(object.logEntriesCopiedCount.toString());
        }
        return message;
    },
    fromSDK(object) {
        return {
            logEntriesCopiedCount: object?.log_entries_copied_count
        };
    },
    fromSDKJSON(object) {
        return {
            log_entries_copied_count: isSet(object.log_entries_copied_count) ? BigInt(object.log_entries_copied_count.toString()) : BigInt(0)
        };
    },
    toSDK(message) {
        const obj = {};
        obj.log_entries_copied_count = message.logEntriesCopiedCount;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCopyLogEntriesResponse();
        if (object.log_entries_copied_count !== undefined && object.log_entries_copied_count !== null) {
            message.logEntriesCopiedCount = BigInt(object.log_entries_copied_count);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.log_entries_copied_count = message.logEntriesCopiedCount !== BigInt(0) ? message.logEntriesCopiedCount?.toString() : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return CopyLogEntriesResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CopyLogEntriesResponse.decode(message.value);
    },
    toProto(message) {
        return CopyLogEntriesResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.CopyLogEntriesResponse",
            value: CopyLogEntriesResponse.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
