import { MetricDescriptor } from "../../api/metric";
import { Distribution_BucketOptions } from "../../api/distribution";
import { Timestamp } from "../../protobuf/timestamp";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { isSet, toTimestamp, fromTimestamp, isObject } from "../../../helpers";
export const protobufPackage = "google.logging.v2";
/** Logging API version. */
export var LogMetric_ApiVersion;
(function (LogMetric_ApiVersion) {
    /** V2 - Logging API v2. */
    LogMetric_ApiVersion[LogMetric_ApiVersion["V2"] = 0] = "V2";
    /** V1 - Logging API v1. */
    LogMetric_ApiVersion[LogMetric_ApiVersion["V1"] = 1] = "V1";
    LogMetric_ApiVersion[LogMetric_ApiVersion["UNRECOGNIZED"] = -1] = "UNRECOGNIZED";
})(LogMetric_ApiVersion || (LogMetric_ApiVersion = {}));
export const LogMetric_ApiVersionSDKType = LogMetric_ApiVersion;
export const LogMetric_ApiVersionAmino = LogMetric_ApiVersion;
export function logMetric_ApiVersionFromJSON(object) {
    switch (object) {
        case 0:
        case "V2":
            return LogMetric_ApiVersion.V2;
        case 1:
        case "V1":
            return LogMetric_ApiVersion.V1;
        case -1:
        case "UNRECOGNIZED":
        default:
            return LogMetric_ApiVersion.UNRECOGNIZED;
    }
}
export function logMetric_ApiVersionToJSON(object) {
    switch (object) {
        case LogMetric_ApiVersion.V2:
            return "V2";
        case LogMetric_ApiVersion.V1:
            return "V1";
        case LogMetric_ApiVersion.UNRECOGNIZED:
        default:
            return "UNRECOGNIZED";
    }
}
function createBaseLogMetric_LabelExtractorsEntry() {
    return {
        key: "",
        value: ""
    };
}
export const LogMetric_LabelExtractorsEntry = {
    encode(message, writer = BinaryWriter.create()) {
        if (message.key !== undefined) {
            writer.uint32(10).string(message.key);
        }
        if (message.value !== undefined) {
            writer.uint32(18).string(message.value);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLogMetric_LabelExtractorsEntry();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.key = reader.string();
                    break;
                case 2:
                    message.value = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLogMetric_LabelExtractorsEntry();
        if (isSet(object.key))
            obj.key = String(object.key);
        if (isSet(object.value))
            obj.value = String(object.value);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.key !== undefined && (obj.key = message.key);
        message.value !== undefined && (obj.value = message.value);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLogMetric_LabelExtractorsEntry();
        message.key = object.key ?? "";
        message.value = object.value ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            key: object?.key,
            value: object?.value
        };
    },
    fromSDKJSON(object) {
        return {
            key: isSet(object.key) ? String(object.key) : "",
            value: isSet(object.value) ? String(object.value) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.key = message.key;
        obj.value = message.value;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLogMetric_LabelExtractorsEntry();
        if (object.key !== undefined && object.key !== null) {
            message.key = object.key;
        }
        if (object.value !== undefined && object.value !== null) {
            message.value = object.value;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.key = message.key === "" ? undefined : message.key;
        obj.value = message.value === "" ? undefined : message.value;
        return obj;
    },
    fromAminoMsg(object) {
        return LogMetric_LabelExtractorsEntry.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return LogMetric_LabelExtractorsEntry.decode(message.value);
    },
    toProto(message) {
        return LogMetric_LabelExtractorsEntry.encode(message).finish();
    },
    registerTypeUrl() { }
};
function createBaseLogMetric() {
    return {
        name: "",
        description: "",
        filter: "",
        disabled: false,
        metricDescriptor: undefined,
        valueExtractor: "",
        labelExtractors: {},
        bucketOptions: undefined,
        createTime: undefined,
        updateTime: undefined,
        version: 0
    };
}
export const LogMetric = {
    typeUrl: "/google.logging.v2.LogMetric",
    is(o) {
        return o && (o.$typeUrl === LogMetric.typeUrl || typeof o.name === "string" && typeof o.description === "string" && typeof o.filter === "string" && typeof o.disabled === "boolean" && typeof o.valueExtractor === "string" && isSet(o.labelExtractors) && isSet(o.version));
    },
    isSDK(o) {
        return o && (o.$typeUrl === LogMetric.typeUrl || typeof o.name === "string" && typeof o.description === "string" && typeof o.filter === "string" && typeof o.disabled === "boolean" && typeof o.value_extractor === "string" && isSet(o.label_extractors) && isSet(o.version));
    },
    isAmino(o) {
        return o && (o.$typeUrl === LogMetric.typeUrl || typeof o.name === "string" && typeof o.description === "string" && typeof o.filter === "string" && typeof o.disabled === "boolean" && typeof o.value_extractor === "string" && isSet(o.label_extractors) && isSet(o.version));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.description !== undefined) {
            writer.uint32(18).string(message.description);
        }
        if (message.filter !== undefined) {
            writer.uint32(26).string(message.filter);
        }
        if (message.disabled !== undefined) {
            writer.uint32(96).bool(message.disabled);
        }
        if (message.metricDescriptor !== undefined) {
            MetricDescriptor.encode(message.metricDescriptor, writer.uint32(42).fork()).ldelim();
        }
        if (message.valueExtractor !== undefined) {
            writer.uint32(50).string(message.valueExtractor);
        }
        Object.entries(message.labelExtractors).forEach(([key, value]) => {
            LogMetric_LabelExtractorsEntry.encode({
                key: key,
                value
            }, writer.uint32(58).fork()).ldelim();
        });
        if (message.bucketOptions !== undefined) {
            Distribution_BucketOptions.encode(message.bucketOptions, writer.uint32(66).fork()).ldelim();
        }
        if (message.createTime !== undefined) {
            Timestamp.encode(toTimestamp(message.createTime), writer.uint32(74).fork()).ldelim();
        }
        if (message.updateTime !== undefined) {
            Timestamp.encode(toTimestamp(message.updateTime), writer.uint32(82).fork()).ldelim();
        }
        if (message.version !== 0) {
            writer.uint32(32).int32(message.version);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseLogMetric();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.description = reader.string();
                    break;
                case 3:
                    message.filter = reader.string();
                    break;
                case 12:
                    message.disabled = reader.bool();
                    break;
                case 5:
                    message.metricDescriptor = MetricDescriptor.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.valueExtractor = reader.string();
                    break;
                case 7:
                    const entry7 = LogMetric_LabelExtractorsEntry.decode(reader, reader.uint32());
                    if (entry7.value !== undefined) {
                        message.labelExtractors[entry7.key] = entry7.value;
                    }
                    break;
                case 8:
                    message.bucketOptions = Distribution_BucketOptions.decode(reader, reader.uint32());
                    break;
                case 9:
                    message.createTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 10:
                    message.updateTime = fromTimestamp(Timestamp.decode(reader, reader.uint32()));
                    break;
                case 4:
                    message.version = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseLogMetric();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.description))
            obj.description = String(object.description);
        if (isSet(object.filter))
            obj.filter = String(object.filter);
        if (isSet(object.disabled))
            obj.disabled = Boolean(object.disabled);
        if (isSet(object.metricDescriptor))
            obj.metricDescriptor = MetricDescriptor.fromJSON(object.metricDescriptor);
        if (isSet(object.valueExtractor))
            obj.valueExtractor = String(object.valueExtractor);
        if (isObject(object.labelExtractors))
            obj.labelExtractors = Object.entries(object.labelExtractors).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {});
        if (isSet(object.bucketOptions))
            obj.bucketOptions = Distribution_BucketOptions.fromJSON(object.bucketOptions);
        if (isSet(object.createTime))
            obj.createTime = new Date(object.createTime);
        if (isSet(object.updateTime))
            obj.updateTime = new Date(object.updateTime);
        if (isSet(object.version))
            obj.version = logMetric_ApiVersionFromJSON(object.version);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.description !== undefined && (obj.description = message.description);
        message.filter !== undefined && (obj.filter = message.filter);
        message.disabled !== undefined && (obj.disabled = message.disabled);
        message.metricDescriptor !== undefined && (obj.metricDescriptor = message.metricDescriptor ? MetricDescriptor.toJSON(message.metricDescriptor) : undefined);
        message.valueExtractor !== undefined && (obj.valueExtractor = message.valueExtractor);
        obj.labelExtractors = {};
        if (message.labelExtractors) {
            Object.entries(message.labelExtractors).forEach(([k, v]) => {
                obj.labelExtractors[k] = v;
            });
        }
        message.bucketOptions !== undefined && (obj.bucketOptions = message.bucketOptions ? Distribution_BucketOptions.toJSON(message.bucketOptions) : undefined);
        message.createTime !== undefined && (obj.createTime = message.createTime.toISOString());
        message.updateTime !== undefined && (obj.updateTime = message.updateTime.toISOString());
        message.version !== undefined && (obj.version = logMetric_ApiVersionToJSON(message.version));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseLogMetric();
        message.name = object.name ?? "";
        message.description = object.description ?? "";
        message.filter = object.filter ?? "";
        message.disabled = object.disabled ?? false;
        if (object.metricDescriptor !== undefined && object.metricDescriptor !== null) {
            message.metricDescriptor = MetricDescriptor.fromPartial(object.metricDescriptor);
        }
        message.valueExtractor = object.valueExtractor ?? "";
        message.labelExtractors = Object.entries(object.labelExtractors ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        if (object.bucketOptions !== undefined && object.bucketOptions !== null) {
            message.bucketOptions = Distribution_BucketOptions.fromPartial(object.bucketOptions);
        }
        message.createTime = object.createTime ?? undefined;
        message.updateTime = object.updateTime ?? undefined;
        message.version = object.version ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            description: object?.description,
            filter: object?.filter,
            disabled: object?.disabled,
            metricDescriptor: object.metric_descriptor ? MetricDescriptor.fromSDK(object.metric_descriptor) : undefined,
            valueExtractor: object?.value_extractor,
            labelExtractors: isObject(object.label_extractors) ? Object.entries(object.label_extractors).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            bucketOptions: object.bucket_options ? Distribution_BucketOptions.fromSDK(object.bucket_options) : undefined,
            createTime: object.create_time ?? undefined,
            updateTime: object.update_time ?? undefined,
            version: isSet(object.version) ? logMetric_ApiVersionFromJSON(object.version) : -1
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            description: isSet(object.description) ? String(object.description) : "",
            filter: isSet(object.filter) ? String(object.filter) : "",
            disabled: isSet(object.disabled) ? Boolean(object.disabled) : false,
            metric_descriptor: isSet(object.metric_descriptor) ? MetricDescriptor.fromSDKJSON(object.metric_descriptor) : undefined,
            value_extractor: isSet(object.value_extractor) ? String(object.value_extractor) : "",
            label_extractors: isObject(object.label_extractors) ? Object.entries(object.label_extractors).reduce((acc, [key, value]) => {
                acc[key] = String(value);
                return acc;
            }, {}) : {},
            bucket_options: isSet(object.bucket_options) ? Distribution_BucketOptions.fromSDKJSON(object.bucket_options) : undefined,
            create_time: isSet(object.create_time) ? new Date(object.create_time) : undefined,
            update_time: isSet(object.update_time) ? new Date(object.update_time) : undefined,
            version: isSet(object.version) ? logMetric_ApiVersionFromJSON(object.version) : -1
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.description = message.description;
        obj.filter = message.filter;
        obj.disabled = message.disabled;
        message.metricDescriptor !== undefined && (obj.metric_descriptor = message.metricDescriptor ? MetricDescriptor.toSDK(message.metricDescriptor) : undefined);
        obj.value_extractor = message.valueExtractor;
        obj.label_extractors = {};
        if (message.labelExtractors) {
            Object.entries(message.labelExtractors).forEach(([k, v]) => {
                obj.label_extractors[k] = v;
            });
        }
        message.bucketOptions !== undefined && (obj.bucket_options = message.bucketOptions ? Distribution_BucketOptions.toSDK(message.bucketOptions) : undefined);
        message.createTime !== undefined && (obj.create_time = message.createTime ?? undefined);
        message.updateTime !== undefined && (obj.update_time = message.updateTime ?? undefined);
        message.version !== undefined && (obj.version = logMetric_ApiVersionToJSON(message.version));
        return obj;
    },
    fromAmino(object) {
        const message = createBaseLogMetric();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.description !== undefined && object.description !== null) {
            message.description = object.description;
        }
        if (object.filter !== undefined && object.filter !== null) {
            message.filter = object.filter;
        }
        if (object.disabled !== undefined && object.disabled !== null) {
            message.disabled = object.disabled;
        }
        if (object.metric_descriptor !== undefined && object.metric_descriptor !== null) {
            message.metricDescriptor = MetricDescriptor.fromAmino(object.metric_descriptor);
        }
        if (object.value_extractor !== undefined && object.value_extractor !== null) {
            message.valueExtractor = object.value_extractor;
        }
        message.labelExtractors = Object.entries(object.label_extractors ?? {}).reduce((acc, [key, value]) => {
            if (value !== undefined) {
                acc[key] = String(value);
            }
            return acc;
        }, {});
        if (object.bucket_options !== undefined && object.bucket_options !== null) {
            message.bucketOptions = Distribution_BucketOptions.fromAmino(object.bucket_options);
        }
        if (object.create_time !== undefined && object.create_time !== null) {
            message.createTime = fromTimestamp(Timestamp.fromAmino(object.create_time));
        }
        if (object.update_time !== undefined && object.update_time !== null) {
            message.updateTime = fromTimestamp(Timestamp.fromAmino(object.update_time));
        }
        if (object.version !== undefined && object.version !== null) {
            message.version = object.version;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.description = message.description === "" ? undefined : message.description;
        obj.filter = message.filter === "" ? undefined : message.filter;
        obj.disabled = message.disabled === false ? undefined : message.disabled;
        obj.metric_descriptor = message.metricDescriptor ? MetricDescriptor.toAmino(message.metricDescriptor) : undefined;
        obj.value_extractor = message.valueExtractor === "" ? undefined : message.valueExtractor;
        obj.label_extractors = {};
        if (message.labelExtractors) {
            Object.entries(message.labelExtractors).forEach(([k, v]) => {
                obj.label_extractors[k] = v;
            });
        }
        obj.bucket_options = message.bucketOptions ? Distribution_BucketOptions.toAmino(message.bucketOptions) : undefined;
        obj.create_time = message.createTime ? Timestamp.toAmino(toTimestamp(message.createTime)) : undefined;
        obj.update_time = message.updateTime ? Timestamp.toAmino(toTimestamp(message.updateTime)) : undefined;
        obj.version = message.version === 0 ? undefined : message.version;
        return obj;
    },
    fromAminoMsg(object) {
        return LogMetric.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return LogMetric.decode(message.value);
    },
    toProto(message) {
        return LogMetric.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.LogMetric",
            value: LogMetric.encode(message).finish()
        };
    },
    registerTypeUrl() {
        MetricDescriptor.registerTypeUrl();
        Distribution_BucketOptions.registerTypeUrl();
    }
};
function createBaseListLogMetricsRequest() {
    return {
        parent: "",
        pageToken: "",
        pageSize: 0
    };
}
export const ListLogMetricsRequest = {
    typeUrl: "/google.logging.v2.ListLogMetricsRequest",
    is(o) {
        return o && (o.$typeUrl === ListLogMetricsRequest.typeUrl || typeof o.parent === "string" && typeof o.pageToken === "string" && typeof o.pageSize === "number");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListLogMetricsRequest.typeUrl || typeof o.parent === "string" && typeof o.page_token === "string" && typeof o.page_size === "number");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListLogMetricsRequest.typeUrl || typeof o.parent === "string" && typeof o.page_token === "string" && typeof o.page_size === "number");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.pageToken !== undefined) {
            writer.uint32(18).string(message.pageToken);
        }
        if (message.pageSize !== undefined) {
            writer.uint32(24).int32(message.pageSize);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListLogMetricsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.pageToken = reader.string();
                    break;
                case 3:
                    message.pageSize = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListLogMetricsRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.pageToken))
            obj.pageToken = String(object.pageToken);
        if (isSet(object.pageSize))
            obj.pageSize = Number(object.pageSize);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.pageToken !== undefined && (obj.pageToken = message.pageToken);
        message.pageSize !== undefined && (obj.pageSize = Math.round(message.pageSize));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListLogMetricsRequest();
        message.parent = object.parent ?? "";
        message.pageToken = object.pageToken ?? "";
        message.pageSize = object.pageSize ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            pageToken: object?.page_token,
            pageSize: object?.page_size
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            page_token: isSet(object.page_token) ? String(object.page_token) : "",
            page_size: isSet(object.page_size) ? Number(object.page_size) : 0
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        obj.page_token = message.pageToken;
        obj.page_size = message.pageSize;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListLogMetricsRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.page_token !== undefined && object.page_token !== null) {
            message.pageToken = object.page_token;
        }
        if (object.page_size !== undefined && object.page_size !== null) {
            message.pageSize = object.page_size;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.page_token = message.pageToken === "" ? undefined : message.pageToken;
        obj.page_size = message.pageSize === 0 ? undefined : message.pageSize;
        return obj;
    },
    fromAminoMsg(object) {
        return ListLogMetricsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListLogMetricsRequest.decode(message.value);
    },
    toProto(message) {
        return ListLogMetricsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.ListLogMetricsRequest",
            value: ListLogMetricsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListLogMetricsResponse() {
    return {
        metrics: [],
        nextPageToken: ""
    };
}
export const ListLogMetricsResponse = {
    typeUrl: "/google.logging.v2.ListLogMetricsResponse",
    is(o) {
        return o && (o.$typeUrl === ListLogMetricsResponse.typeUrl || Array.isArray(o.metrics) && (!o.metrics.length || LogMetric.is(o.metrics[0])) && typeof o.nextPageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListLogMetricsResponse.typeUrl || Array.isArray(o.metrics) && (!o.metrics.length || LogMetric.isSDK(o.metrics[0])) && typeof o.next_page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListLogMetricsResponse.typeUrl || Array.isArray(o.metrics) && (!o.metrics.length || LogMetric.isAmino(o.metrics[0])) && typeof o.next_page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.metrics) {
            LogMetric.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.nextPageToken !== undefined) {
            writer.uint32(18).string(message.nextPageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListLogMetricsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.metrics.push(LogMetric.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.nextPageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListLogMetricsResponse();
        if (Array.isArray(object?.metrics))
            obj.metrics = object.metrics.map((e) => LogMetric.fromJSON(e));
        if (isSet(object.nextPageToken))
            obj.nextPageToken = String(object.nextPageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.metrics) {
            obj.metrics = message.metrics.map(e => e ? LogMetric.toJSON(e) : undefined);
        }
        else {
            obj.metrics = [];
        }
        message.nextPageToken !== undefined && (obj.nextPageToken = message.nextPageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListLogMetricsResponse();
        message.metrics = object.metrics?.map(e => LogMetric.fromPartial(e)) || [];
        message.nextPageToken = object.nextPageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            metrics: Array.isArray(object?.metrics) ? object.metrics.map((e) => LogMetric.fromSDK(e)) : [],
            nextPageToken: object?.next_page_token
        };
    },
    fromSDKJSON(object) {
        return {
            metrics: Array.isArray(object?.metrics) ? object.metrics.map((e) => LogMetric.fromSDKJSON(e)) : [],
            next_page_token: isSet(object.next_page_token) ? String(object.next_page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.metrics) {
            obj.metrics = message.metrics.map(e => e ? LogMetric.toSDK(e) : undefined);
        }
        else {
            obj.metrics = [];
        }
        obj.next_page_token = message.nextPageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListLogMetricsResponse();
        message.metrics = object.metrics?.map(e => LogMetric.fromAmino(e)) || [];
        if (object.next_page_token !== undefined && object.next_page_token !== null) {
            message.nextPageToken = object.next_page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.metrics) {
            obj.metrics = message.metrics.map(e => e ? LogMetric.toAmino(e) : undefined);
        }
        else {
            obj.metrics = message.metrics;
        }
        obj.next_page_token = message.nextPageToken === "" ? undefined : message.nextPageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListLogMetricsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListLogMetricsResponse.decode(message.value);
    },
    toProto(message) {
        return ListLogMetricsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.ListLogMetricsResponse",
            value: ListLogMetricsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogMetric.registerTypeUrl();
    }
};
function createBaseGetLogMetricRequest() {
    return {
        metricName: ""
    };
}
export const GetLogMetricRequest = {
    typeUrl: "/google.logging.v2.GetLogMetricRequest",
    is(o) {
        return o && (o.$typeUrl === GetLogMetricRequest.typeUrl || typeof o.metricName === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === GetLogMetricRequest.typeUrl || typeof o.metric_name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === GetLogMetricRequest.typeUrl || typeof o.metric_name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.metricName !== undefined) {
            writer.uint32(10).string(message.metricName);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetLogMetricRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.metricName = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGetLogMetricRequest();
        if (isSet(object.metricName))
            obj.metricName = String(object.metricName);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.metricName !== undefined && (obj.metricName = message.metricName);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGetLogMetricRequest();
        message.metricName = object.metricName ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            metricName: object?.metric_name
        };
    },
    fromSDKJSON(object) {
        return {
            metric_name: isSet(object.metric_name) ? String(object.metric_name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.metric_name = message.metricName;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGetLogMetricRequest();
        if (object.metric_name !== undefined && object.metric_name !== null) {
            message.metricName = object.metric_name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.metric_name = message.metricName === "" ? undefined : message.metricName;
        return obj;
    },
    fromAminoMsg(object) {
        return GetLogMetricRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetLogMetricRequest.decode(message.value);
    },
    toProto(message) {
        return GetLogMetricRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.GetLogMetricRequest",
            value: GetLogMetricRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseCreateLogMetricRequest() {
    return {
        parent: "",
        metric: undefined
    };
}
export const CreateLogMetricRequest = {
    typeUrl: "/google.logging.v2.CreateLogMetricRequest",
    is(o) {
        return o && (o.$typeUrl === CreateLogMetricRequest.typeUrl || typeof o.parent === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === CreateLogMetricRequest.typeUrl || typeof o.parent === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === CreateLogMetricRequest.typeUrl || typeof o.parent === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.parent !== undefined) {
            writer.uint32(10).string(message.parent);
        }
        if (message.metric !== undefined) {
            LogMetric.encode(message.metric, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCreateLogMetricRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.parent = reader.string();
                    break;
                case 2:
                    message.metric = LogMetric.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCreateLogMetricRequest();
        if (isSet(object.parent))
            obj.parent = String(object.parent);
        if (isSet(object.metric))
            obj.metric = LogMetric.fromJSON(object.metric);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.parent !== undefined && (obj.parent = message.parent);
        message.metric !== undefined && (obj.metric = message.metric ? LogMetric.toJSON(message.metric) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCreateLogMetricRequest();
        message.parent = object.parent ?? "";
        if (object.metric !== undefined && object.metric !== null) {
            message.metric = LogMetric.fromPartial(object.metric);
        }
        return message;
    },
    fromSDK(object) {
        return {
            parent: object?.parent,
            metric: object.metric ? LogMetric.fromSDK(object.metric) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            parent: isSet(object.parent) ? String(object.parent) : "",
            metric: isSet(object.metric) ? LogMetric.fromSDKJSON(object.metric) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.parent = message.parent;
        message.metric !== undefined && (obj.metric = message.metric ? LogMetric.toSDK(message.metric) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCreateLogMetricRequest();
        if (object.parent !== undefined && object.parent !== null) {
            message.parent = object.parent;
        }
        if (object.metric !== undefined && object.metric !== null) {
            message.metric = LogMetric.fromAmino(object.metric);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.parent = message.parent === "" ? undefined : message.parent;
        obj.metric = message.metric ? LogMetric.toAmino(message.metric) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return CreateLogMetricRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CreateLogMetricRequest.decode(message.value);
    },
    toProto(message) {
        return CreateLogMetricRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.CreateLogMetricRequest",
            value: CreateLogMetricRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogMetric.registerTypeUrl();
    }
};
function createBaseUpdateLogMetricRequest() {
    return {
        metricName: "",
        metric: undefined
    };
}
export const UpdateLogMetricRequest = {
    typeUrl: "/google.logging.v2.UpdateLogMetricRequest",
    is(o) {
        return o && (o.$typeUrl === UpdateLogMetricRequest.typeUrl || typeof o.metricName === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === UpdateLogMetricRequest.typeUrl || typeof o.metric_name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === UpdateLogMetricRequest.typeUrl || typeof o.metric_name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.metricName !== undefined) {
            writer.uint32(10).string(message.metricName);
        }
        if (message.metric !== undefined) {
            LogMetric.encode(message.metric, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseUpdateLogMetricRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.metricName = reader.string();
                    break;
                case 2:
                    message.metric = LogMetric.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseUpdateLogMetricRequest();
        if (isSet(object.metricName))
            obj.metricName = String(object.metricName);
        if (isSet(object.metric))
            obj.metric = LogMetric.fromJSON(object.metric);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.metricName !== undefined && (obj.metricName = message.metricName);
        message.metric !== undefined && (obj.metric = message.metric ? LogMetric.toJSON(message.metric) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseUpdateLogMetricRequest();
        message.metricName = object.metricName ?? "";
        if (object.metric !== undefined && object.metric !== null) {
            message.metric = LogMetric.fromPartial(object.metric);
        }
        return message;
    },
    fromSDK(object) {
        return {
            metricName: object?.metric_name,
            metric: object.metric ? LogMetric.fromSDK(object.metric) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            metric_name: isSet(object.metric_name) ? String(object.metric_name) : "",
            metric: isSet(object.metric) ? LogMetric.fromSDKJSON(object.metric) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.metric_name = message.metricName;
        message.metric !== undefined && (obj.metric = message.metric ? LogMetric.toSDK(message.metric) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseUpdateLogMetricRequest();
        if (object.metric_name !== undefined && object.metric_name !== null) {
            message.metricName = object.metric_name;
        }
        if (object.metric !== undefined && object.metric !== null) {
            message.metric = LogMetric.fromAmino(object.metric);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.metric_name = message.metricName === "" ? undefined : message.metricName;
        obj.metric = message.metric ? LogMetric.toAmino(message.metric) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return UpdateLogMetricRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return UpdateLogMetricRequest.decode(message.value);
    },
    toProto(message) {
        return UpdateLogMetricRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.UpdateLogMetricRequest",
            value: UpdateLogMetricRequest.encode(message).finish()
        };
    },
    registerTypeUrl() {
        LogMetric.registerTypeUrl();
    }
};
function createBaseDeleteLogMetricRequest() {
    return {
        metricName: ""
    };
}
export const DeleteLogMetricRequest = {
    typeUrl: "/google.logging.v2.DeleteLogMetricRequest",
    is(o) {
        return o && (o.$typeUrl === DeleteLogMetricRequest.typeUrl || typeof o.metricName === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === DeleteLogMetricRequest.typeUrl || typeof o.metric_name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === DeleteLogMetricRequest.typeUrl || typeof o.metric_name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.metricName !== undefined) {
            writer.uint32(10).string(message.metricName);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeleteLogMetricRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.metricName = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDeleteLogMetricRequest();
        if (isSet(object.metricName))
            obj.metricName = String(object.metricName);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.metricName !== undefined && (obj.metricName = message.metricName);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDeleteLogMetricRequest();
        message.metricName = object.metricName ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            metricName: object?.metric_name
        };
    },
    fromSDKJSON(object) {
        return {
            metric_name: isSet(object.metric_name) ? String(object.metric_name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.metric_name = message.metricName;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDeleteLogMetricRequest();
        if (object.metric_name !== undefined && object.metric_name !== null) {
            message.metricName = object.metric_name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.metric_name = message.metricName === "" ? undefined : message.metricName;
        return obj;
    },
    fromAminoMsg(object) {
        return DeleteLogMetricRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return DeleteLogMetricRequest.decode(message.value);
    },
    toProto(message) {
        return DeleteLogMetricRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.logging.v2.DeleteLogMetricRequest",
            value: DeleteLogMetricRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
