import { Duration } from "../protobuf/duration";
import { Any } from "../protobuf/any";
import { Status } from "../rpc/status";
import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.longrunning";
function createBaseOperation() {
    return {
        name: "",
        metadata: undefined,
        done: false,
        error: undefined,
        response: undefined
    };
}
export const Operation = {
    typeUrl: "/google.longrunning.Operation",
    is(o) {
        return o && (o.$typeUrl === Operation.typeUrl || typeof o.name === "string" && typeof o.done === "boolean");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Operation.typeUrl || typeof o.name === "string" && typeof o.done === "boolean");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Operation.typeUrl || typeof o.name === "string" && typeof o.done === "boolean");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.metadata !== undefined) {
            Any.encode(message.metadata, writer.uint32(18).fork()).ldelim();
        }
        if (message.done !== undefined) {
            writer.uint32(24).bool(message.done);
        }
        if (message.error !== undefined) {
            Status.encode(message.error, writer.uint32(34).fork()).ldelim();
        }
        if (message.response !== undefined) {
            Any.encode(message.response, writer.uint32(42).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseOperation();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.metadata = Any.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.done = reader.bool();
                    break;
                case 4:
                    message.error = Status.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.response = Any.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseOperation();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.metadata))
            obj.metadata = Any.fromJSON(object.metadata);
        if (isSet(object.done))
            obj.done = Boolean(object.done);
        if (isSet(object.error))
            obj.error = Status.fromJSON(object.error);
        if (isSet(object.response))
            obj.response = Any.fromJSON(object.response);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.metadata !== undefined && (obj.metadata = message.metadata ? Any.toJSON(message.metadata) : undefined);
        message.done !== undefined && (obj.done = message.done);
        message.error !== undefined && (obj.error = message.error ? Status.toJSON(message.error) : undefined);
        message.response !== undefined && (obj.response = message.response ? Any.toJSON(message.response) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseOperation();
        message.name = object.name ?? "";
        if (object.metadata !== undefined && object.metadata !== null) {
            message.metadata = Any.fromPartial(object.metadata);
        }
        message.done = object.done ?? false;
        if (object.error !== undefined && object.error !== null) {
            message.error = Status.fromPartial(object.error);
        }
        if (object.response !== undefined && object.response !== null) {
            message.response = Any.fromPartial(object.response);
        }
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            metadata: object.metadata ? Any.fromSDK(object.metadata) : undefined,
            done: object?.done,
            error: object.error ? Status.fromSDK(object.error) : undefined,
            response: object.response ? Any.fromSDK(object.response) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            metadata: isSet(object.metadata) ? Any.fromSDKJSON(object.metadata) : undefined,
            done: isSet(object.done) ? Boolean(object.done) : false,
            error: isSet(object.error) ? Status.fromSDKJSON(object.error) : undefined,
            response: isSet(object.response) ? Any.fromSDKJSON(object.response) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        message.metadata !== undefined && (obj.metadata = message.metadata ? Any.toSDK(message.metadata) : undefined);
        obj.done = message.done;
        message.error !== undefined && (obj.error = message.error ? Status.toSDK(message.error) : undefined);
        message.response !== undefined && (obj.response = message.response ? Any.toSDK(message.response) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseOperation();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.metadata !== undefined && object.metadata !== null) {
            message.metadata = Any.fromAmino(object.metadata);
        }
        if (object.done !== undefined && object.done !== null) {
            message.done = object.done;
        }
        if (object.error !== undefined && object.error !== null) {
            message.error = Status.fromAmino(object.error);
        }
        if (object.response !== undefined && object.response !== null) {
            message.response = Any.fromAmino(object.response);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.metadata = message.metadata ? Any.toAmino(message.metadata) : undefined;
        obj.done = message.done === false ? undefined : message.done;
        obj.error = message.error ? Status.toAmino(message.error) : undefined;
        obj.response = message.response ? Any.toAmino(message.response) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return Operation.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Operation.decode(message.value);
    },
    toProto(message) {
        return Operation.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.longrunning.Operation",
            value: Operation.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseGetOperationRequest() {
    return {
        name: ""
    };
}
export const GetOperationRequest = {
    typeUrl: "/google.longrunning.GetOperationRequest",
    is(o) {
        return o && (o.$typeUrl === GetOperationRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === GetOperationRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === GetOperationRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseGetOperationRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseGetOperationRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseGetOperationRequest();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseGetOperationRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return GetOperationRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return GetOperationRequest.decode(message.value);
    },
    toProto(message) {
        return GetOperationRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.longrunning.GetOperationRequest",
            value: GetOperationRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListOperationsRequest() {
    return {
        name: "",
        filter: "",
        pageSize: 0,
        pageToken: ""
    };
}
export const ListOperationsRequest = {
    typeUrl: "/google.longrunning.ListOperationsRequest",
    is(o) {
        return o && (o.$typeUrl === ListOperationsRequest.typeUrl || typeof o.name === "string" && typeof o.filter === "string" && typeof o.pageSize === "number" && typeof o.pageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListOperationsRequest.typeUrl || typeof o.name === "string" && typeof o.filter === "string" && typeof o.page_size === "number" && typeof o.page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListOperationsRequest.typeUrl || typeof o.name === "string" && typeof o.filter === "string" && typeof o.page_size === "number" && typeof o.page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(34).string(message.name);
        }
        if (message.filter !== undefined) {
            writer.uint32(10).string(message.filter);
        }
        if (message.pageSize !== undefined) {
            writer.uint32(16).int32(message.pageSize);
        }
        if (message.pageToken !== undefined) {
            writer.uint32(26).string(message.pageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListOperationsRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 4:
                    message.name = reader.string();
                    break;
                case 1:
                    message.filter = reader.string();
                    break;
                case 2:
                    message.pageSize = reader.int32();
                    break;
                case 3:
                    message.pageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListOperationsRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.filter))
            obj.filter = String(object.filter);
        if (isSet(object.pageSize))
            obj.pageSize = Number(object.pageSize);
        if (isSet(object.pageToken))
            obj.pageToken = String(object.pageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.filter !== undefined && (obj.filter = message.filter);
        message.pageSize !== undefined && (obj.pageSize = Math.round(message.pageSize));
        message.pageToken !== undefined && (obj.pageToken = message.pageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListOperationsRequest();
        message.name = object.name ?? "";
        message.filter = object.filter ?? "";
        message.pageSize = object.pageSize ?? 0;
        message.pageToken = object.pageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            filter: object?.filter,
            pageSize: object?.page_size,
            pageToken: object?.page_token
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            filter: isSet(object.filter) ? String(object.filter) : "",
            page_size: isSet(object.page_size) ? Number(object.page_size) : 0,
            page_token: isSet(object.page_token) ? String(object.page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.filter = message.filter;
        obj.page_size = message.pageSize;
        obj.page_token = message.pageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListOperationsRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.filter !== undefined && object.filter !== null) {
            message.filter = object.filter;
        }
        if (object.page_size !== undefined && object.page_size !== null) {
            message.pageSize = object.page_size;
        }
        if (object.page_token !== undefined && object.page_token !== null) {
            message.pageToken = object.page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.filter = message.filter === "" ? undefined : message.filter;
        obj.page_size = message.pageSize === 0 ? undefined : message.pageSize;
        obj.page_token = message.pageToken === "" ? undefined : message.pageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListOperationsRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListOperationsRequest.decode(message.value);
    },
    toProto(message) {
        return ListOperationsRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.longrunning.ListOperationsRequest",
            value: ListOperationsRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseListOperationsResponse() {
    return {
        operations: [],
        nextPageToken: ""
    };
}
export const ListOperationsResponse = {
    typeUrl: "/google.longrunning.ListOperationsResponse",
    is(o) {
        return o && (o.$typeUrl === ListOperationsResponse.typeUrl || Array.isArray(o.operations) && (!o.operations.length || Operation.is(o.operations[0])) && typeof o.nextPageToken === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === ListOperationsResponse.typeUrl || Array.isArray(o.operations) && (!o.operations.length || Operation.isSDK(o.operations[0])) && typeof o.next_page_token === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === ListOperationsResponse.typeUrl || Array.isArray(o.operations) && (!o.operations.length || Operation.isAmino(o.operations[0])) && typeof o.next_page_token === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        for (const v of message.operations) {
            Operation.encode(v, writer.uint32(10).fork()).ldelim();
        }
        if (message.nextPageToken !== undefined) {
            writer.uint32(18).string(message.nextPageToken);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseListOperationsResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.operations.push(Operation.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.nextPageToken = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseListOperationsResponse();
        if (Array.isArray(object?.operations))
            obj.operations = object.operations.map((e) => Operation.fromJSON(e));
        if (isSet(object.nextPageToken))
            obj.nextPageToken = String(object.nextPageToken);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        if (message.operations) {
            obj.operations = message.operations.map(e => e ? Operation.toJSON(e) : undefined);
        }
        else {
            obj.operations = [];
        }
        message.nextPageToken !== undefined && (obj.nextPageToken = message.nextPageToken);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseListOperationsResponse();
        message.operations = object.operations?.map(e => Operation.fromPartial(e)) || [];
        message.nextPageToken = object.nextPageToken ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            operations: Array.isArray(object?.operations) ? object.operations.map((e) => Operation.fromSDK(e)) : [],
            nextPageToken: object?.next_page_token
        };
    },
    fromSDKJSON(object) {
        return {
            operations: Array.isArray(object?.operations) ? object.operations.map((e) => Operation.fromSDKJSON(e)) : [],
            next_page_token: isSet(object.next_page_token) ? String(object.next_page_token) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        if (message.operations) {
            obj.operations = message.operations.map(e => e ? Operation.toSDK(e) : undefined);
        }
        else {
            obj.operations = [];
        }
        obj.next_page_token = message.nextPageToken;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseListOperationsResponse();
        message.operations = object.operations?.map(e => Operation.fromAmino(e)) || [];
        if (object.next_page_token !== undefined && object.next_page_token !== null) {
            message.nextPageToken = object.next_page_token;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        if (message.operations) {
            obj.operations = message.operations.map(e => e ? Operation.toAmino(e) : undefined);
        }
        else {
            obj.operations = message.operations;
        }
        obj.next_page_token = message.nextPageToken === "" ? undefined : message.nextPageToken;
        return obj;
    },
    fromAminoMsg(object) {
        return ListOperationsResponse.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return ListOperationsResponse.decode(message.value);
    },
    toProto(message) {
        return ListOperationsResponse.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.longrunning.ListOperationsResponse",
            value: ListOperationsResponse.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Operation.registerTypeUrl();
    }
};
function createBaseCancelOperationRequest() {
    return {
        name: ""
    };
}
export const CancelOperationRequest = {
    typeUrl: "/google.longrunning.CancelOperationRequest",
    is(o) {
        return o && (o.$typeUrl === CancelOperationRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === CancelOperationRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === CancelOperationRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseCancelOperationRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseCancelOperationRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseCancelOperationRequest();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseCancelOperationRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return CancelOperationRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return CancelOperationRequest.decode(message.value);
    },
    toProto(message) {
        return CancelOperationRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.longrunning.CancelOperationRequest",
            value: CancelOperationRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseDeleteOperationRequest() {
    return {
        name: ""
    };
}
export const DeleteOperationRequest = {
    typeUrl: "/google.longrunning.DeleteOperationRequest",
    is(o) {
        return o && (o.$typeUrl === DeleteOperationRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === DeleteOperationRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === DeleteOperationRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseDeleteOperationRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseDeleteOperationRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseDeleteOperationRequest();
        message.name = object.name ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseDeleteOperationRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        return obj;
    },
    fromAminoMsg(object) {
        return DeleteOperationRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return DeleteOperationRequest.decode(message.value);
    },
    toProto(message) {
        return DeleteOperationRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.longrunning.DeleteOperationRequest",
            value: DeleteOperationRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseWaitOperationRequest() {
    return {
        name: "",
        timeout: undefined
    };
}
export const WaitOperationRequest = {
    typeUrl: "/google.longrunning.WaitOperationRequest",
    is(o) {
        return o && (o.$typeUrl === WaitOperationRequest.typeUrl || typeof o.name === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === WaitOperationRequest.typeUrl || typeof o.name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === WaitOperationRequest.typeUrl || typeof o.name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.timeout !== undefined) {
            Duration.encode(message.timeout, writer.uint32(18).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseWaitOperationRequest();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.timeout = Duration.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseWaitOperationRequest();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.timeout))
            obj.timeout = Duration.fromJSON(object.timeout);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.timeout !== undefined && (obj.timeout = message.timeout ? Duration.toJSON(message.timeout) : undefined);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseWaitOperationRequest();
        message.name = object.name ?? "";
        if (object.timeout !== undefined && object.timeout !== null) {
            message.timeout = Duration.fromPartial(object.timeout);
        }
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            timeout: object.timeout ? Duration.fromSDK(object.timeout) : undefined
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            timeout: isSet(object.timeout) ? Duration.fromSDKJSON(object.timeout) : undefined
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        message.timeout !== undefined && (obj.timeout = message.timeout ? Duration.toSDK(message.timeout) : undefined);
        return obj;
    },
    fromAmino(object) {
        const message = createBaseWaitOperationRequest();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.timeout !== undefined && object.timeout !== null) {
            message.timeout = Duration.fromAmino(object.timeout);
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.timeout = message.timeout ? Duration.toAmino(message.timeout) : undefined;
        return obj;
    },
    fromAminoMsg(object) {
        return WaitOperationRequest.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return WaitOperationRequest.decode(message.value);
    },
    toProto(message) {
        return WaitOperationRequest.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.longrunning.WaitOperationRequest",
            value: WaitOperationRequest.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
function createBaseOperationInfo() {
    return {
        responseType: "",
        metadataType: ""
    };
}
export const OperationInfo = {
    typeUrl: "/google.longrunning.OperationInfo",
    is(o) {
        return o && (o.$typeUrl === OperationInfo.typeUrl || typeof o.responseType === "string" && typeof o.metadataType === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === OperationInfo.typeUrl || typeof o.response_type === "string" && typeof o.metadata_type === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === OperationInfo.typeUrl || typeof o.response_type === "string" && typeof o.metadata_type === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.responseType !== undefined) {
            writer.uint32(10).string(message.responseType);
        }
        if (message.metadataType !== undefined) {
            writer.uint32(18).string(message.metadataType);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseOperationInfo();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.responseType = reader.string();
                    break;
                case 2:
                    message.metadataType = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseOperationInfo();
        if (isSet(object.responseType))
            obj.responseType = String(object.responseType);
        if (isSet(object.metadataType))
            obj.metadataType = String(object.metadataType);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.responseType !== undefined && (obj.responseType = message.responseType);
        message.metadataType !== undefined && (obj.metadataType = message.metadataType);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseOperationInfo();
        message.responseType = object.responseType ?? "";
        message.metadataType = object.metadataType ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            responseType: object?.response_type,
            metadataType: object?.metadata_type
        };
    },
    fromSDKJSON(object) {
        return {
            response_type: isSet(object.response_type) ? String(object.response_type) : "",
            metadata_type: isSet(object.metadata_type) ? String(object.metadata_type) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.response_type = message.responseType;
        obj.metadata_type = message.metadataType;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseOperationInfo();
        if (object.response_type !== undefined && object.response_type !== null) {
            message.responseType = object.response_type;
        }
        if (object.metadata_type !== undefined && object.metadata_type !== null) {
            message.metadataType = object.metadata_type;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.response_type = message.responseType === "" ? undefined : message.responseType;
        obj.metadata_type = message.metadataType === "" ? undefined : message.metadataType;
        return obj;
    },
    fromAminoMsg(object) {
        return OperationInfo.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return OperationInfo.decode(message.value);
    },
    toProto(message) {
        return OperationInfo.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.longrunning.OperationInfo",
            value: OperationInfo.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
