import { Option, syntaxFromJSON, syntaxToJSON } from "./type";
import { SourceContext } from "./source_context";
import { isSet } from "../../helpers";
import { BinaryReader, BinaryWriter } from "../../binary";
export const protobufPackage = "google.protobuf";
function createBaseApi() {
    return {
        name: "",
        methods: [],
        options: [],
        version: "",
        sourceContext: undefined,
        mixins: [],
        syntax: 0
    };
}
export const Api = {
    typeUrl: "/google.protobuf.Api",
    is(o) {
        return o && (o.$typeUrl === Api.typeUrl || typeof o.name === "string" && Array.isArray(o.methods) && (!o.methods.length || Method.is(o.methods[0])) && Array.isArray(o.options) && (!o.options.length || Option.is(o.options[0])) && typeof o.version === "string" && Array.isArray(o.mixins) && (!o.mixins.length || Mixin.is(o.mixins[0])) && isSet(o.syntax));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Api.typeUrl || typeof o.name === "string" && Array.isArray(o.methods) && (!o.methods.length || Method.isSDK(o.methods[0])) && Array.isArray(o.options) && (!o.options.length || Option.isSDK(o.options[0])) && typeof o.version === "string" && Array.isArray(o.mixins) && (!o.mixins.length || Mixin.isSDK(o.mixins[0])) && isSet(o.syntax));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Api.typeUrl || typeof o.name === "string" && Array.isArray(o.methods) && (!o.methods.length || Method.isAmino(o.methods[0])) && Array.isArray(o.options) && (!o.options.length || Option.isAmino(o.options[0])) && typeof o.version === "string" && Array.isArray(o.mixins) && (!o.mixins.length || Mixin.isAmino(o.mixins[0])) && isSet(o.syntax));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        for (const v of message.methods) {
            Method.encode(v, writer.uint32(18).fork()).ldelim();
        }
        for (const v of message.options) {
            Option.encode(v, writer.uint32(26).fork()).ldelim();
        }
        if (message.version !== undefined) {
            writer.uint32(34).string(message.version);
        }
        if (message.sourceContext !== undefined) {
            SourceContext.encode(message.sourceContext, writer.uint32(42).fork()).ldelim();
        }
        for (const v of message.mixins) {
            Mixin.encode(v, writer.uint32(50).fork()).ldelim();
        }
        if (message.syntax !== 0) {
            writer.uint32(56).int32(message.syntax);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseApi();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.methods.push(Method.decode(reader, reader.uint32()));
                    break;
                case 3:
                    message.options.push(Option.decode(reader, reader.uint32()));
                    break;
                case 4:
                    message.version = reader.string();
                    break;
                case 5:
                    message.sourceContext = SourceContext.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.mixins.push(Mixin.decode(reader, reader.uint32()));
                    break;
                case 7:
                    message.syntax = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseApi();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (Array.isArray(object?.methods))
            obj.methods = object.methods.map((e) => Method.fromJSON(e));
        if (Array.isArray(object?.options))
            obj.options = object.options.map((e) => Option.fromJSON(e));
        if (isSet(object.version))
            obj.version = String(object.version);
        if (isSet(object.sourceContext))
            obj.sourceContext = SourceContext.fromJSON(object.sourceContext);
        if (Array.isArray(object?.mixins))
            obj.mixins = object.mixins.map((e) => Mixin.fromJSON(e));
        if (isSet(object.syntax))
            obj.syntax = syntaxFromJSON(object.syntax);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        if (message.methods) {
            obj.methods = message.methods.map(e => e ? Method.toJSON(e) : undefined);
        }
        else {
            obj.methods = [];
        }
        if (message.options) {
            obj.options = message.options.map(e => e ? Option.toJSON(e) : undefined);
        }
        else {
            obj.options = [];
        }
        message.version !== undefined && (obj.version = message.version);
        message.sourceContext !== undefined && (obj.sourceContext = message.sourceContext ? SourceContext.toJSON(message.sourceContext) : undefined);
        if (message.mixins) {
            obj.mixins = message.mixins.map(e => e ? Mixin.toJSON(e) : undefined);
        }
        else {
            obj.mixins = [];
        }
        message.syntax !== undefined && (obj.syntax = syntaxToJSON(message.syntax));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseApi();
        message.name = object.name ?? "";
        message.methods = object.methods?.map(e => Method.fromPartial(e)) || [];
        message.options = object.options?.map(e => Option.fromPartial(e)) || [];
        message.version = object.version ?? "";
        if (object.sourceContext !== undefined && object.sourceContext !== null) {
            message.sourceContext = SourceContext.fromPartial(object.sourceContext);
        }
        message.mixins = object.mixins?.map(e => Mixin.fromPartial(e)) || [];
        message.syntax = object.syntax ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            methods: Array.isArray(object?.methods) ? object.methods.map((e) => Method.fromSDK(e)) : [],
            options: Array.isArray(object?.options) ? object.options.map((e) => Option.fromSDK(e)) : [],
            version: object?.version,
            sourceContext: object.source_context ? SourceContext.fromSDK(object.source_context) : undefined,
            mixins: Array.isArray(object?.mixins) ? object.mixins.map((e) => Mixin.fromSDK(e)) : [],
            syntax: isSet(object.syntax) ? syntaxFromJSON(object.syntax) : -1
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            methods: Array.isArray(object?.methods) ? object.methods.map((e) => Method.fromSDKJSON(e)) : [],
            options: Array.isArray(object?.options) ? object.options.map((e) => Option.fromSDKJSON(e)) : [],
            version: isSet(object.version) ? String(object.version) : "",
            source_context: isSet(object.source_context) ? SourceContext.fromSDKJSON(object.source_context) : undefined,
            mixins: Array.isArray(object?.mixins) ? object.mixins.map((e) => Mixin.fromSDKJSON(e)) : [],
            syntax: isSet(object.syntax) ? syntaxFromJSON(object.syntax) : -1
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        if (message.methods) {
            obj.methods = message.methods.map(e => e ? Method.toSDK(e) : undefined);
        }
        else {
            obj.methods = [];
        }
        if (message.options) {
            obj.options = message.options.map(e => e ? Option.toSDK(e) : undefined);
        }
        else {
            obj.options = [];
        }
        obj.version = message.version;
        message.sourceContext !== undefined && (obj.source_context = message.sourceContext ? SourceContext.toSDK(message.sourceContext) : undefined);
        if (message.mixins) {
            obj.mixins = message.mixins.map(e => e ? Mixin.toSDK(e) : undefined);
        }
        else {
            obj.mixins = [];
        }
        message.syntax !== undefined && (obj.syntax = syntaxToJSON(message.syntax));
        return obj;
    },
    fromAmino(object) {
        const message = createBaseApi();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        message.methods = object.methods?.map(e => Method.fromAmino(e)) || [];
        message.options = object.options?.map(e => Option.fromAmino(e)) || [];
        if (object.version !== undefined && object.version !== null) {
            message.version = object.version;
        }
        if (object.source_context !== undefined && object.source_context !== null) {
            message.sourceContext = SourceContext.fromAmino(object.source_context);
        }
        message.mixins = object.mixins?.map(e => Mixin.fromAmino(e)) || [];
        if (object.syntax !== undefined && object.syntax !== null) {
            message.syntax = object.syntax;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        if (message.methods) {
            obj.methods = message.methods.map(e => e ? Method.toAmino(e) : undefined);
        }
        else {
            obj.methods = message.methods;
        }
        if (message.options) {
            obj.options = message.options.map(e => e ? Option.toAmino(e) : undefined);
        }
        else {
            obj.options = message.options;
        }
        obj.version = message.version === "" ? undefined : message.version;
        obj.source_context = message.sourceContext ? SourceContext.toAmino(message.sourceContext) : undefined;
        if (message.mixins) {
            obj.mixins = message.mixins.map(e => e ? Mixin.toAmino(e) : undefined);
        }
        else {
            obj.mixins = message.mixins;
        }
        obj.syntax = message.syntax === 0 ? undefined : message.syntax;
        return obj;
    },
    fromAminoMsg(object) {
        return Api.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Api.decode(message.value);
    },
    toProto(message) {
        return Api.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.protobuf.Api",
            value: Api.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Method.registerTypeUrl();
        Option.registerTypeUrl();
        SourceContext.registerTypeUrl();
        Mixin.registerTypeUrl();
    }
};
function createBaseMethod() {
    return {
        name: "",
        requestTypeUrl: "",
        requestStreaming: false,
        responseTypeUrl: "",
        responseStreaming: false,
        options: [],
        syntax: 0
    };
}
export const Method = {
    typeUrl: "/google.protobuf.Method",
    is(o) {
        return o && (o.$typeUrl === Method.typeUrl || typeof o.name === "string" && typeof o.requestTypeUrl === "string" && typeof o.requestStreaming === "boolean" && typeof o.responseTypeUrl === "string" && typeof o.responseStreaming === "boolean" && Array.isArray(o.options) && (!o.options.length || Option.is(o.options[0])) && isSet(o.syntax));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Method.typeUrl || typeof o.name === "string" && typeof o.request_type_url === "string" && typeof o.request_streaming === "boolean" && typeof o.response_type_url === "string" && typeof o.response_streaming === "boolean" && Array.isArray(o.options) && (!o.options.length || Option.isSDK(o.options[0])) && isSet(o.syntax));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Method.typeUrl || typeof o.name === "string" && typeof o.request_type_url === "string" && typeof o.request_streaming === "boolean" && typeof o.response_type_url === "string" && typeof o.response_streaming === "boolean" && Array.isArray(o.options) && (!o.options.length || Option.isAmino(o.options[0])) && isSet(o.syntax));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.requestTypeUrl !== undefined) {
            writer.uint32(18).string(message.requestTypeUrl);
        }
        if (message.requestStreaming !== undefined) {
            writer.uint32(24).bool(message.requestStreaming);
        }
        if (message.responseTypeUrl !== undefined) {
            writer.uint32(34).string(message.responseTypeUrl);
        }
        if (message.responseStreaming !== undefined) {
            writer.uint32(40).bool(message.responseStreaming);
        }
        for (const v of message.options) {
            Option.encode(v, writer.uint32(50).fork()).ldelim();
        }
        if (message.syntax !== 0) {
            writer.uint32(56).int32(message.syntax);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMethod();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.requestTypeUrl = reader.string();
                    break;
                case 3:
                    message.requestStreaming = reader.bool();
                    break;
                case 4:
                    message.responseTypeUrl = reader.string();
                    break;
                case 5:
                    message.responseStreaming = reader.bool();
                    break;
                case 6:
                    message.options.push(Option.decode(reader, reader.uint32()));
                    break;
                case 7:
                    message.syntax = reader.int32();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMethod();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.requestTypeUrl))
            obj.requestTypeUrl = String(object.requestTypeUrl);
        if (isSet(object.requestStreaming))
            obj.requestStreaming = Boolean(object.requestStreaming);
        if (isSet(object.responseTypeUrl))
            obj.responseTypeUrl = String(object.responseTypeUrl);
        if (isSet(object.responseStreaming))
            obj.responseStreaming = Boolean(object.responseStreaming);
        if (Array.isArray(object?.options))
            obj.options = object.options.map((e) => Option.fromJSON(e));
        if (isSet(object.syntax))
            obj.syntax = syntaxFromJSON(object.syntax);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.requestTypeUrl !== undefined && (obj.requestTypeUrl = message.requestTypeUrl);
        message.requestStreaming !== undefined && (obj.requestStreaming = message.requestStreaming);
        message.responseTypeUrl !== undefined && (obj.responseTypeUrl = message.responseTypeUrl);
        message.responseStreaming !== undefined && (obj.responseStreaming = message.responseStreaming);
        if (message.options) {
            obj.options = message.options.map(e => e ? Option.toJSON(e) : undefined);
        }
        else {
            obj.options = [];
        }
        message.syntax !== undefined && (obj.syntax = syntaxToJSON(message.syntax));
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMethod();
        message.name = object.name ?? "";
        message.requestTypeUrl = object.requestTypeUrl ?? "";
        message.requestStreaming = object.requestStreaming ?? false;
        message.responseTypeUrl = object.responseTypeUrl ?? "";
        message.responseStreaming = object.responseStreaming ?? false;
        message.options = object.options?.map(e => Option.fromPartial(e)) || [];
        message.syntax = object.syntax ?? 0;
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            requestTypeUrl: object?.request_type_url,
            requestStreaming: object?.request_streaming,
            responseTypeUrl: object?.response_type_url,
            responseStreaming: object?.response_streaming,
            options: Array.isArray(object?.options) ? object.options.map((e) => Option.fromSDK(e)) : [],
            syntax: isSet(object.syntax) ? syntaxFromJSON(object.syntax) : -1
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            request_type_url: isSet(object.request_type_url) ? String(object.request_type_url) : "",
            request_streaming: isSet(object.request_streaming) ? Boolean(object.request_streaming) : false,
            response_type_url: isSet(object.response_type_url) ? String(object.response_type_url) : "",
            response_streaming: isSet(object.response_streaming) ? Boolean(object.response_streaming) : false,
            options: Array.isArray(object?.options) ? object.options.map((e) => Option.fromSDKJSON(e)) : [],
            syntax: isSet(object.syntax) ? syntaxFromJSON(object.syntax) : -1
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.request_type_url = message.requestTypeUrl;
        obj.request_streaming = message.requestStreaming;
        obj.response_type_url = message.responseTypeUrl;
        obj.response_streaming = message.responseStreaming;
        if (message.options) {
            obj.options = message.options.map(e => e ? Option.toSDK(e) : undefined);
        }
        else {
            obj.options = [];
        }
        message.syntax !== undefined && (obj.syntax = syntaxToJSON(message.syntax));
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMethod();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.request_type_url !== undefined && object.request_type_url !== null) {
            message.requestTypeUrl = object.request_type_url;
        }
        if (object.request_streaming !== undefined && object.request_streaming !== null) {
            message.requestStreaming = object.request_streaming;
        }
        if (object.response_type_url !== undefined && object.response_type_url !== null) {
            message.responseTypeUrl = object.response_type_url;
        }
        if (object.response_streaming !== undefined && object.response_streaming !== null) {
            message.responseStreaming = object.response_streaming;
        }
        message.options = object.options?.map(e => Option.fromAmino(e)) || [];
        if (object.syntax !== undefined && object.syntax !== null) {
            message.syntax = object.syntax;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.request_type_url = message.requestTypeUrl === "" ? undefined : message.requestTypeUrl;
        obj.request_streaming = message.requestStreaming === false ? undefined : message.requestStreaming;
        obj.response_type_url = message.responseTypeUrl === "" ? undefined : message.responseTypeUrl;
        obj.response_streaming = message.responseStreaming === false ? undefined : message.responseStreaming;
        if (message.options) {
            obj.options = message.options.map(e => e ? Option.toAmino(e) : undefined);
        }
        else {
            obj.options = message.options;
        }
        obj.syntax = message.syntax === 0 ? undefined : message.syntax;
        return obj;
    },
    fromAminoMsg(object) {
        return Method.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Method.decode(message.value);
    },
    toProto(message) {
        return Method.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.protobuf.Method",
            value: Method.encode(message).finish()
        };
    },
    registerTypeUrl() {
        Option.registerTypeUrl();
    }
};
function createBaseMixin() {
    return {
        name: "",
        root: ""
    };
}
export const Mixin = {
    typeUrl: "/google.protobuf.Mixin",
    is(o) {
        return o && (o.$typeUrl === Mixin.typeUrl || typeof o.name === "string" && typeof o.root === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Mixin.typeUrl || typeof o.name === "string" && typeof o.root === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Mixin.typeUrl || typeof o.name === "string" && typeof o.root === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.name !== undefined) {
            writer.uint32(10).string(message.name);
        }
        if (message.root !== undefined) {
            writer.uint32(18).string(message.root);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMixin();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.name = reader.string();
                    break;
                case 2:
                    message.root = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseMixin();
        if (isSet(object.name))
            obj.name = String(object.name);
        if (isSet(object.root))
            obj.root = String(object.root);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.name !== undefined && (obj.name = message.name);
        message.root !== undefined && (obj.root = message.root);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseMixin();
        message.name = object.name ?? "";
        message.root = object.root ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            name: object?.name,
            root: object?.root
        };
    },
    fromSDKJSON(object) {
        return {
            name: isSet(object.name) ? String(object.name) : "",
            root: isSet(object.root) ? String(object.root) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.name = message.name;
        obj.root = message.root;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseMixin();
        if (object.name !== undefined && object.name !== null) {
            message.name = object.name;
        }
        if (object.root !== undefined && object.root !== null) {
            message.root = object.root;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.name = message.name === "" ? undefined : message.name;
        obj.root = message.root === "" ? undefined : message.root;
        return obj;
    },
    fromAminoMsg(object) {
        return Mixin.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Mixin.decode(message.value);
    },
    toProto(message) {
        return Mixin.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.protobuf.Mixin",
            value: Mixin.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
