import { BinaryReader, BinaryWriter } from "../../binary";
import { DeepPartial } from "../../helpers";
import { JsonSafe } from "../../json-safe";
export declare const protobufPackage = "google.protobuf";
/**
 * `SourceContext` represents information about the source of a
 * protobuf element, like the file in which it is defined.
 */
export interface SourceContext {
    /**
     * The path-qualified name of the .proto file that contained the associated
     * protobuf element.  For example: `"google/protobuf/source_context.proto"`.
     */
    fileName: string;
}
export interface SourceContextProtoMsg {
    typeUrl: "/google.protobuf.SourceContext";
    value: Uint8Array;
}
/**
 * `SourceContext` represents information about the source of a
 * protobuf element, like the file in which it is defined.
 */
export interface SourceContextAmino {
    /**
     * The path-qualified name of the .proto file that contained the associated
     * protobuf element.  For example: `"google/protobuf/source_context.proto"`.
     */
    file_name?: string;
}
export interface SourceContextAminoMsg {
    type: "/google.protobuf.SourceContext";
    value: SourceContextAmino;
}
/**
 * `SourceContext` represents information about the source of a
 * protobuf element, like the file in which it is defined.
 */
export interface SourceContextSDKType {
    file_name: string;
}
export declare const SourceContext: {
    typeUrl: string;
    is(o: any): o is SourceContext;
    isSDK(o: any): o is SourceContextSDKType;
    isAmino(o: any): o is SourceContextAmino;
    encode(message: SourceContext, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): SourceContext;
    fromJSON(object: any): SourceContext;
    toJSON(message: SourceContext): JsonSafe<SourceContext>;
    fromPartial(object: DeepPartial<SourceContext>): SourceContext;
    fromSDK(object: SourceContextSDKType): SourceContext;
    fromSDKJSON(object: any): SourceContextSDKType;
    toSDK(message: SourceContext): SourceContextSDKType;
    fromAmino(object: SourceContextAmino): SourceContext;
    toAmino(message: SourceContext): SourceContextAmino;
    fromAminoMsg(object: SourceContextAminoMsg): SourceContext;
    fromProtoMsg(message: SourceContextProtoMsg): SourceContext;
    toProto(message: SourceContext): Uint8Array;
    toProtoMsg(message: SourceContext): SourceContextProtoMsg;
    registerTypeUrl(): void;
};
