import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.protobuf";
function createBaseSourceContext() {
    return {
        fileName: ""
    };
}
export const SourceContext = {
    typeUrl: "/google.protobuf.SourceContext",
    is(o) {
        return o && (o.$typeUrl === SourceContext.typeUrl || typeof o.fileName === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === SourceContext.typeUrl || typeof o.file_name === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === SourceContext.typeUrl || typeof o.file_name === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.fileName !== undefined) {
            writer.uint32(10).string(message.fileName);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseSourceContext();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.fileName = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseSourceContext();
        if (isSet(object.fileName))
            obj.fileName = String(object.fileName);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.fileName !== undefined && (obj.fileName = message.fileName);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseSourceContext();
        message.fileName = object.fileName ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            fileName: object?.file_name
        };
    },
    fromSDKJSON(object) {
        return {
            file_name: isSet(object.file_name) ? String(object.file_name) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.file_name = message.fileName;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseSourceContext();
        if (object.file_name !== undefined && object.file_name !== null) {
            message.fileName = object.file_name;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.file_name = message.fileName === "" ? undefined : message.fileName;
        return obj;
    },
    fromAminoMsg(object) {
        return SourceContext.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return SourceContext.decode(message.value);
    },
    toProto(message) {
        return SourceContext.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.protobuf.SourceContext",
            value: SourceContext.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
