import { Any, AnyAmino, AnySDKType } from "../protobuf/any";
import { BinaryReader, BinaryWriter } from "../../binary";
import { DeepPartial } from "../../helpers";
import { JsonSafe } from "../../json-safe";
export declare const protobufPackage = "google.rpc";
/**
 * The `Status` type defines a logical error model that is suitable for
 * different programming environments, including REST APIs and RPC APIs. It is
 * used by [gRPC](https://github.com/grpc). Each `Status` message contains
 * three pieces of data: error code, error message, and error details.
 *
 * You can find out more about this error model and how to work with it in the
 * [API Design Guide](https://cloud.google.com/apis/design/errors).
 */
export interface Status {
    /** The status code, which should be an enum value of [google.rpc.Code][google.rpc.Code]. */
    code: number;
    /**
     * A developer-facing error message, which should be in English. Any
     * user-facing error message should be localized and sent in the
     * [google.rpc.Status.details][google.rpc.Status.details] field, or localized by the client.
     */
    message: string;
    /**
     * A list of messages that carry the error details.  There is a common set of
     * message types for APIs to use.
     */
    details: Any[];
}
export interface StatusProtoMsg {
    typeUrl: "/google.rpc.Status";
    value: Uint8Array;
}
/**
 * The `Status` type defines a logical error model that is suitable for
 * different programming environments, including REST APIs and RPC APIs. It is
 * used by [gRPC](https://github.com/grpc). Each `Status` message contains
 * three pieces of data: error code, error message, and error details.
 *
 * You can find out more about this error model and how to work with it in the
 * [API Design Guide](https://cloud.google.com/apis/design/errors).
 */
export interface StatusAmino {
    /** The status code, which should be an enum value of [google.rpc.Code][google.rpc.Code]. */
    code?: number;
    /**
     * A developer-facing error message, which should be in English. Any
     * user-facing error message should be localized and sent in the
     * [google.rpc.Status.details][google.rpc.Status.details] field, or localized by the client.
     */
    message?: string;
    /**
     * A list of messages that carry the error details.  There is a common set of
     * message types for APIs to use.
     */
    details?: AnyAmino[];
}
export interface StatusAminoMsg {
    type: "/google.rpc.Status";
    value: StatusAmino;
}
/**
 * The `Status` type defines a logical error model that is suitable for
 * different programming environments, including REST APIs and RPC APIs. It is
 * used by [gRPC](https://github.com/grpc). Each `Status` message contains
 * three pieces of data: error code, error message, and error details.
 *
 * You can find out more about this error model and how to work with it in the
 * [API Design Guide](https://cloud.google.com/apis/design/errors).
 */
export interface StatusSDKType {
    code: number;
    message: string;
    details: AnySDKType[];
}
export declare const Status: {
    typeUrl: string;
    is(o: any): o is Status;
    isSDK(o: any): o is StatusSDKType;
    isAmino(o: any): o is StatusAmino;
    encode(message: Status, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): Status;
    fromJSON(object: any): Status;
    toJSON(message: Status): JsonSafe<Status>;
    fromPartial(object: DeepPartial<Status>): Status;
    fromSDK(object: StatusSDKType): Status;
    fromSDKJSON(object: any): StatusSDKType;
    toSDK(message: Status): StatusSDKType;
    fromAmino(object: StatusAmino): Status;
    toAmino(message: Status): StatusAmino;
    fromAminoMsg(object: StatusAminoMsg): Status;
    fromProtoMsg(message: StatusProtoMsg): Status;
    toProto(message: Status): Uint8Array;
    toProtoMsg(message: Status): StatusProtoMsg;
    registerTypeUrl(): void;
};
