import { Any } from "../protobuf/any";
import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "google.rpc";
function createBaseStatus() {
    return {
        code: 0,
        message: "",
        details: []
    };
}
export const Status = {
    typeUrl: "/google.rpc.Status",
    is(o) {
        return o && (o.$typeUrl === Status.typeUrl || typeof o.code === "number" && typeof o.message === "string" && Array.isArray(o.details) && (!o.details.length || Any.is(o.details[0])));
    },
    isSDK(o) {
        return o && (o.$typeUrl === Status.typeUrl || typeof o.code === "number" && typeof o.message === "string" && Array.isArray(o.details) && (!o.details.length || Any.isSDK(o.details[0])));
    },
    isAmino(o) {
        return o && (o.$typeUrl === Status.typeUrl || typeof o.code === "number" && typeof o.message === "string" && Array.isArray(o.details) && (!o.details.length || Any.isAmino(o.details[0])));
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.code !== undefined) {
            writer.uint32(8).int32(message.code);
        }
        if (message.message !== undefined) {
            writer.uint32(18).string(message.message);
        }
        for (const v of message.details) {
            Any.encode(v, writer.uint32(26).fork()).ldelim();
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseStatus();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.code = reader.int32();
                    break;
                case 2:
                    message.message = reader.string();
                    break;
                case 3:
                    message.details.push(Any.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseStatus();
        if (isSet(object.code))
            obj.code = Number(object.code);
        if (isSet(object.message))
            obj.message = String(object.message);
        if (Array.isArray(object?.details))
            obj.details = object.details.map((e) => Any.fromJSON(e));
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.code !== undefined && (obj.code = Math.round(message.code));
        message.message !== undefined && (obj.message = message.message);
        if (message.details) {
            obj.details = message.details.map(e => e ? Any.toJSON(e) : undefined);
        }
        else {
            obj.details = [];
        }
        return obj;
    },
    fromPartial(object) {
        const message = createBaseStatus();
        message.code = object.code ?? 0;
        message.message = object.message ?? "";
        message.details = object.details?.map(e => Any.fromPartial(e)) || [];
        return message;
    },
    fromSDK(object) {
        return {
            code: object?.code,
            message: object?.message,
            details: Array.isArray(object?.details) ? object.details.map((e) => Any.fromSDK(e)) : []
        };
    },
    fromSDKJSON(object) {
        return {
            code: isSet(object.code) ? Number(object.code) : 0,
            message: isSet(object.message) ? String(object.message) : "",
            details: Array.isArray(object?.details) ? object.details.map((e) => Any.fromSDKJSON(e)) : []
        };
    },
    toSDK(message) {
        const obj = {};
        obj.code = message.code;
        obj.message = message.message;
        if (message.details) {
            obj.details = message.details.map(e => e ? Any.toSDK(e) : undefined);
        }
        else {
            obj.details = [];
        }
        return obj;
    },
    fromAmino(object) {
        const message = createBaseStatus();
        if (object.code !== undefined && object.code !== null) {
            message.code = object.code;
        }
        if (object.message !== undefined && object.message !== null) {
            message.message = object.message;
        }
        message.details = object.details?.map(e => Any.fromAmino(e)) || [];
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.code = message.code === 0 ? undefined : message.code;
        obj.message = message.message === "" ? undefined : message.message;
        if (message.details) {
            obj.details = message.details.map(e => e ? Any.toAmino(e) : undefined);
        }
        else {
            obj.details = message.details;
        }
        return obj;
    },
    fromAminoMsg(object) {
        return Status.fromAmino(object.value);
    },
    fromProtoMsg(message) {
        return Status.decode(message.value);
    },
    toProto(message) {
        return Status.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/google.rpc.Status",
            value: Status.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
