import { TelescopeGeneratedType } from "../../../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgTransfer } from "./tx";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        transfer(value: MsgTransfer): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        transfer(value: MsgTransfer): {
            typeUrl: string;
            value: MsgTransfer;
        };
    };
    toJSON: {
        transfer(value: MsgTransfer): {
            typeUrl: string;
            value: {
                sourcePort: string;
                sourceChannel: string;
                token: {
                    denom: string;
                    amount: string;
                };
                sender: string;
                receiver: string;
                timeoutHeight: {
                    revisionNumber: string;
                    revisionHeight: string;
                };
                timeoutTimestamp: string;
            };
        };
    };
    fromJSON: {
        transfer(value: any): {
            typeUrl: string;
            value: MsgTransfer;
        };
    };
    fromPartial: {
        transfer(value: MsgTransfer): {
            typeUrl: string;
            value: MsgTransfer;
        };
    };
};
