import { TelescopeGeneratedType } from "../../../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgCreateClient, MsgUpdateClient, MsgUpgradeClient, MsgSubmitMisbehaviour } from "./tx";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        createClient(value: MsgCreateClient): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        updateClient(value: MsgUpdateClient): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        upgradeClient(value: MsgUpgradeClient): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        submitMisbehaviour(value: MsgSubmitMisbehaviour): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        createClient(value: MsgCreateClient): {
            typeUrl: string;
            value: MsgCreateClient;
        };
        updateClient(value: MsgUpdateClient): {
            typeUrl: string;
            value: MsgUpdateClient;
        };
        upgradeClient(value: MsgUpgradeClient): {
            typeUrl: string;
            value: MsgUpgradeClient;
        };
        submitMisbehaviour(value: MsgSubmitMisbehaviour): {
            typeUrl: string;
            value: MsgSubmitMisbehaviour;
        };
    };
    toJSON: {
        createClient(value: MsgCreateClient): {
            typeUrl: string;
            value: {
                clientState?: {
                    $typeUrl?: "/google.protobuf.Any" | string;
                    typeUrl: string;
                    value: string;
                };
                consensusState?: {
                    $typeUrl?: "/google.protobuf.Any" | string;
                    typeUrl: string;
                    value: string;
                };
                signer: string;
            };
        };
        updateClient(value: MsgUpdateClient): {
            typeUrl: string;
            value: {
                clientId: string;
                header?: {
                    $typeUrl?: "/google.protobuf.Any" | string;
                    typeUrl: string;
                    value: string;
                };
                signer: string;
            };
        };
        upgradeClient(value: MsgUpgradeClient): {
            typeUrl: string;
            value: {
                clientId: string;
                clientState?: {
                    $typeUrl?: "/google.protobuf.Any" | string;
                    typeUrl: string;
                    value: string;
                };
                consensusState?: {
                    $typeUrl?: "/google.protobuf.Any" | string;
                    typeUrl: string;
                    value: string;
                };
                proofUpgradeClient: string;
                proofUpgradeConsensusState: string;
                signer: string;
            };
        };
        submitMisbehaviour(value: MsgSubmitMisbehaviour): {
            typeUrl: string;
            value: {
                clientId: string;
                misbehaviour?: {
                    $typeUrl?: "/google.protobuf.Any" | string;
                    typeUrl: string;
                    value: string;
                };
                signer: string;
            };
        };
    };
    fromJSON: {
        createClient(value: any): {
            typeUrl: string;
            value: MsgCreateClient;
        };
        updateClient(value: any): {
            typeUrl: string;
            value: MsgUpdateClient;
        };
        upgradeClient(value: any): {
            typeUrl: string;
            value: MsgUpgradeClient;
        };
        submitMisbehaviour(value: any): {
            typeUrl: string;
            value: MsgSubmitMisbehaviour;
        };
    };
    fromPartial: {
        createClient(value: MsgCreateClient): {
            typeUrl: string;
            value: MsgCreateClient;
        };
        updateClient(value: MsgUpdateClient): {
            typeUrl: string;
            value: MsgUpdateClient;
        };
        upgradeClient(value: MsgUpgradeClient): {
            typeUrl: string;
            value: MsgUpgradeClient;
        };
        submitMisbehaviour(value: MsgSubmitMisbehaviour): {
            typeUrl: string;
            value: MsgSubmitMisbehaviour;
        };
    };
};
