import { MsgCreateClient, MsgUpdateClient, MsgUpgradeClient, MsgSubmitMisbehaviour } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* CreateClient defines a rpc handler method for MsgCreateClient. */
    createClient = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgCreateClient.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* UpdateClient defines a rpc handler method for MsgUpdateClient. */
    updateClient = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgUpdateClient.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* UpgradeClient defines a rpc handler method for MsgUpgradeClient. */
    upgradeClient = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgUpgradeClient.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* SubmitMisbehaviour defines a rpc handler method for MsgSubmitMisbehaviour. */
    submitMisbehaviour = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgSubmitMisbehaviour.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
