import { MsgConnectionOpenInit, MsgConnectionOpenTry, MsgConnectionOpenAck, MsgConnectionOpenConfirm } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* ConnectionOpenInit defines a rpc handler method for MsgConnectionOpenInit. */
    connectionOpenInit = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgConnectionOpenInit.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* ConnectionOpenTry defines a rpc handler method for MsgConnectionOpenTry. */
    connectionOpenTry = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgConnectionOpenTry.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* ConnectionOpenAck defines a rpc handler method for MsgConnectionOpenAck. */
    connectionOpenAck = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgConnectionOpenAck.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* ConnectionOpenConfirm defines a rpc handler method for
     MsgConnectionOpenConfirm. */
    connectionOpenConfirm = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgConnectionOpenConfirm.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
