import { TxRpc } from "../../../../types";
import { QueryAppVersionRequest, QueryAppVersionResponse } from "./query";
/** Query defines the gRPC querier service */
export interface Query {
    /** AppVersion queries an IBC Port and determines the appropriate application version to be used */
    appVersion(request: QueryAppVersionRequest): Promise<QueryAppVersionResponse>;
}
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    constructor(rpc: TxRpc);
    appVersion: (request: QueryAppVersionRequest) => Promise<QueryAppVersionResponse>;
}
export declare const createClientImpl: (rpc: TxRpc) => QueryClientImpl;
