import { BinaryReader } from "../../../../binary";
import { QueryAppVersionRequest, QueryAppVersionResponse } from "./query";
export class QueryClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* AppVersion queries an IBC Port and determines the appropriate application version to be used */
    appVersion = async (request) => {
        const data = QueryAppVersionRequest.encode(request).finish();
        const promise = this.rpc.request("ibc.core.port.v1.Query", "AppVersion", data);
        return promise.then(data => QueryAppVersionResponse.decode(new BinaryReader(data)));
    };
}
export const createClientImpl = (rpc) => {
    return new QueryClientImpl(rpc);
};
