import { LCDClient } from "@cosmology/lcd";
import { QueryBalanceRequest, QueryBalanceResponseSDKType, QueryAllBalancesRequest, QueryAllBalancesResponseSDKType, QuerySpendableBalancesRequest, QuerySpendableBalancesResponseSDKType, QueryTotalSupplyRequest, QueryTotalSupplyResponseSDKType, QuerySupplyOfRequest, QuerySupplyOfResponseSDKType, QueryParamsRequest, QueryParamsResponseSDKType, QueryDenomMetadataRequest, QueryDenomMetadataResponseSDKType, QueryDenomsMetadataRequest, QueryDenomsMetadataResponseSDKType, QueryDenomOwnersRequest, QueryDenomOwnersResponseSDKType } from "../cosmos/bank/v1beta1/query";
import { QueryPoolsRequest, QueryPoolsResponseSDKType, QueryNumPoolsRequest, QueryNumPoolsResponseSDKType, QueryTotalLiquidityRequest, QueryTotalLiquidityResponseSDKType, QueryPoolsWithFilterRequest, QueryPoolsWithFilterResponseSDKType, QueryPoolRequest, QueryPoolResponseSDKType, QueryPoolTypeRequest, QueryPoolTypeResponseSDKType, QueryCalcJoinPoolSharesRequest, QueryCalcJoinPoolSharesResponseSDKType, QueryCalcExitPoolCoinsFromSharesRequest, QueryCalcExitPoolCoinsFromSharesResponseSDKType, QueryPoolParamsRequest, QueryPoolParamsResponseSDKType, QueryTotalPoolLiquidityRequest, QueryTotalPoolLiquidityResponseSDKType, QueryTotalSharesRequest, QueryTotalSharesResponseSDKType, QuerySpotPriceRequest, QuerySpotPriceResponseSDKType, QuerySwapExactAmountInRequest, QuerySwapExactAmountInResponseSDKType, QuerySwapExactAmountOutRequest, QuerySwapExactAmountOutResponseSDKType } from "./gamm/v1beta1/query";
export declare class QueryClient {
    req: LCDClient;
    constructor({ requestClient }: {
        requestClient: LCDClient;
    });
    balance: (params: QueryBalanceRequest) => Promise<QueryBalanceResponseSDKType>;
    allBalances: (params: QueryAllBalancesRequest) => Promise<QueryAllBalancesResponseSDKType>;
    spendableBalances: (params: QuerySpendableBalancesRequest) => Promise<QuerySpendableBalancesResponseSDKType>;
    totalSupply: (params?: QueryTotalSupplyRequest) => Promise<QueryTotalSupplyResponseSDKType>;
    supplyOf: (params: QuerySupplyOfRequest) => Promise<QuerySupplyOfResponseSDKType>;
    params: (_params?: QueryParamsRequest) => Promise<QueryParamsResponseSDKType>;
    denomMetadata: (params: QueryDenomMetadataRequest) => Promise<QueryDenomMetadataResponseSDKType>;
    denomsMetadata: (params?: QueryDenomsMetadataRequest) => Promise<QueryDenomsMetadataResponseSDKType>;
    denomOwners: (params: QueryDenomOwnersRequest) => Promise<QueryDenomOwnersResponseSDKType>;
    pools: (params?: QueryPoolsRequest) => Promise<QueryPoolsResponseSDKType>;
    numPools: (_params?: QueryNumPoolsRequest) => Promise<QueryNumPoolsResponseSDKType>;
    totalLiquidity: (_params?: QueryTotalLiquidityRequest) => Promise<QueryTotalLiquidityResponseSDKType>;
    poolsWithFilter: (params: QueryPoolsWithFilterRequest) => Promise<QueryPoolsWithFilterResponseSDKType>;
    pool: (params: QueryPoolRequest) => Promise<QueryPoolResponseSDKType>;
    poolType: (params: QueryPoolTypeRequest) => Promise<QueryPoolTypeResponseSDKType>;
    calcJoinPoolShares: (params: QueryCalcJoinPoolSharesRequest) => Promise<QueryCalcJoinPoolSharesResponseSDKType>;
    calcExitPoolCoinsFromShares: (params: QueryCalcExitPoolCoinsFromSharesRequest) => Promise<QueryCalcExitPoolCoinsFromSharesResponseSDKType>;
    poolParams: (params: QueryPoolParamsRequest) => Promise<QueryPoolParamsResponseSDKType>;
    totalPoolLiquidity: (params: QueryTotalPoolLiquidityRequest) => Promise<QueryTotalPoolLiquidityResponseSDKType>;
    totalShares: (params: QueryTotalSharesRequest) => Promise<QueryTotalSharesResponseSDKType>;
    spotPrice: (params: QuerySpotPriceRequest) => Promise<QuerySpotPriceResponseSDKType>;
    estimateSwapExactAmountIn: (params: QuerySwapExactAmountInRequest) => Promise<QuerySwapExactAmountInResponseSDKType>;
    estimateSwapExactAmountOut: (params: QuerySwapExactAmountOutRequest) => Promise<QuerySwapExactAmountOutResponseSDKType>;
}
