import { QueryModuleAccountBalanceResponse, QueryParamsResponse, QueryClaimRecordResponse, QueryClaimableForActionResponse, QueryTotalClaimableResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* ModuleAccountBalance */
    moduleAccountBalance = async (_params = {}) => {
        const endpoint = `osmosis/claim/v1beta1/module_account_balance`;
        return QueryModuleAccountBalanceResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* Params */
    params = async (_params = {}) => {
        const endpoint = `osmosis/claim/v1beta1/params`;
        return QueryParamsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* ClaimRecord */
    claimRecord = async (params) => {
        const endpoint = `osmosis/claim/v1beta1/claim_record/${params.address}`;
        return QueryClaimRecordResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* ClaimableForAction */
    claimableForAction = async (params) => {
        const endpoint = `osmosis/claim/v1beta1/claimable_for_action/${params.address}/${params.action}`;
        return QueryClaimableForActionResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* TotalClaimable */
    totalClaimable = async (params) => {
        const endpoint = `osmosis/claim/v1beta1/total_claimable/${params.address}`;
        return QueryTotalClaimableResponse.fromSDKJSON(await this.req.get(endpoint));
    };
}
