import { TxRpc } from "../../../types";
import { QueryModuleAccountBalanceRequest, QueryModuleAccountBalanceResponse, QueryParamsRequest, QueryParamsResponse, QueryClaimRecordRequest, QueryClaimRecordResponse, QueryClaimableForActionRequest, QueryClaimableForActionResponse, QueryTotalClaimableRequest, QueryTotalClaimableResponse } from "./query";
/** Query defines the gRPC querier service. */
export interface Query {
    moduleAccountBalance(request?: QueryModuleAccountBalanceRequest): Promise<QueryModuleAccountBalanceResponse>;
    params(request?: QueryParamsRequest): Promise<QueryParamsResponse>;
    claimRecord(request: QueryClaimRecordRequest): Promise<QueryClaimRecordResponse>;
    claimableForAction(request: QueryClaimableForActionRequest): Promise<QueryClaimableForActionResponse>;
    totalClaimable(request: QueryTotalClaimableRequest): Promise<QueryTotalClaimableResponse>;
}
/** Query defines the gRPC querier service. */
export interface OsmosisClaim {
    claimRecord(request: QueryClaimRecordRequest): Promise<QueryClaimRecordResponse>;
    claimableForAction(request: QueryClaimableForActionRequest): Promise<QueryClaimableForActionResponse>;
}
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    constructor(rpc: TxRpc);
    moduleAccountBalance: (request?: QueryModuleAccountBalanceRequest) => Promise<QueryModuleAccountBalanceResponse>;
    params: (request?: QueryParamsRequest) => Promise<QueryParamsResponse>;
    claimRecord: (request: QueryClaimRecordRequest) => Promise<QueryClaimRecordResponse>;
    claimableForAction: (request: QueryClaimableForActionRequest) => Promise<QueryClaimableForActionResponse>;
    totalClaimable: (request: QueryTotalClaimableRequest) => Promise<QueryTotalClaimableResponse>;
}
export declare const createClientImpl: (rpc: TxRpc) => QueryClientImpl;
