import { BinaryReader } from "../../../binary";
import { QueryModuleAccountBalanceRequest, QueryModuleAccountBalanceResponse, QueryParamsRequest, QueryParamsResponse, QueryClaimRecordRequest, QueryClaimRecordResponse, QueryClaimableForActionRequest, QueryClaimableForActionResponse, QueryTotalClaimableRequest, QueryTotalClaimableResponse } from "./query";
export class QueryClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* ModuleAccountBalance */
    moduleAccountBalance = async (request = {}) => {
        const data = QueryModuleAccountBalanceRequest.encode(request).finish();
        const promise = this.rpc.request("osmosis.claim.v1beta1.Query", "ModuleAccountBalance", data);
        return promise.then(data => QueryModuleAccountBalanceResponse.decode(new BinaryReader(data)));
    };
    /* Params */
    params = async (request = {}) => {
        const data = QueryParamsRequest.encode(request).finish();
        const promise = this.rpc.request("osmosis.claim.v1beta1.Query", "Params", data);
        return promise.then(data => QueryParamsResponse.decode(new BinaryReader(data)));
    };
    /* ClaimRecord */
    claimRecord = async (request) => {
        const data = QueryClaimRecordRequest.encode(request).finish();
        const promise = this.rpc.request("osmosis.claim.v1beta1.Query", "ClaimRecord", data);
        return promise.then(data => QueryClaimRecordResponse.decode(new BinaryReader(data)));
    };
    /* ClaimableForAction */
    claimableForAction = async (request) => {
        const data = QueryClaimableForActionRequest.encode(request).finish();
        const promise = this.rpc.request("osmosis.claim.v1beta1.Query", "ClaimableForAction", data);
        return promise.then(data => QueryClaimableForActionResponse.decode(new BinaryReader(data)));
    };
    /* TotalClaimable */
    totalClaimable = async (request) => {
        const data = QueryTotalClaimableRequest.encode(request).finish();
        const promise = this.rpc.request("osmosis.claim.v1beta1.Query", "TotalClaimable", data);
        return promise.then(data => QueryTotalClaimableResponse.decode(new BinaryReader(data)));
    };
}
export const createClientImpl = (rpc) => {
    return new QueryClientImpl(rpc);
};
