import { TxRpc } from "../../types";
import { QueryEpochsInfoRequest, QueryEpochsInfoResponse, QueryCurrentEpochRequest, QueryCurrentEpochResponse } from "./query";
/** Query defines the gRPC querier service. */
export interface Query {
    /** EpochInfos provide running epochInfos */
    epochInfos(request?: QueryEpochsInfoRequest): Promise<QueryEpochsInfoResponse>;
    /** CurrentEpoch provide current epoch of specified identifier */
    currentEpoch(request: QueryCurrentEpochRequest): Promise<QueryCurrentEpochResponse>;
}
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    constructor(rpc: TxRpc);
    epochInfos: (request?: QueryEpochsInfoRequest) => Promise<QueryEpochsInfoResponse>;
    currentEpoch: (request: QueryCurrentEpochRequest) => Promise<QueryCurrentEpochResponse>;
}
export declare const createClientImpl: (rpc: TxRpc) => QueryClientImpl;
