import { TelescopeGeneratedType } from "../../../../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgCreateBalancerPool } from "./tx";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        createBalancerPool(value: MsgCreateBalancerPool): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        createBalancerPool(value: MsgCreateBalancerPool): {
            typeUrl: string;
            value: MsgCreateBalancerPool;
        };
    };
    toJSON: {
        createBalancerPool(value: MsgCreateBalancerPool): {
            typeUrl: string;
            value: {
                sender: string;
                poolParams?: {
                    swapFee: string;
                    exitFee: string;
                    smoothWeightChangeParams?: {
                        startTime: string;
                        duration: {
                            seconds: string;
                            nanos: number;
                        };
                        initialPoolWeights: {
                            token: {
                                denom: string;
                                amount: string;
                            };
                            weight: string;
                        }[];
                        targetPoolWeights: {
                            token: {
                                denom: string;
                                amount: string;
                            };
                            weight: string;
                        }[];
                    };
                };
                poolAssets: {
                    token: {
                        denom: string;
                        amount: string;
                    };
                    weight: string;
                }[];
                futurePoolGovernor: string;
            };
        };
    };
    fromJSON: {
        createBalancerPool(value: any): {
            typeUrl: string;
            value: MsgCreateBalancerPool;
        };
    };
    fromPartial: {
        createBalancerPool(value: MsgCreateBalancerPool): {
            typeUrl: string;
            value: MsgCreateBalancerPool;
        };
    };
};
