import { TelescopeGeneratedType } from "../../../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgCreateStableswapPool, MsgStableSwapAdjustScalingFactors } from "./tx";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        createStableswapPool(value: MsgCreateStableswapPool): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        stableSwapAdjustScalingFactors(value: MsgStableSwapAdjustScalingFactors): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        createStableswapPool(value: MsgCreateStableswapPool): {
            typeUrl: string;
            value: MsgCreateStableswapPool;
        };
        stableSwapAdjustScalingFactors(value: MsgStableSwapAdjustScalingFactors): {
            typeUrl: string;
            value: MsgStableSwapAdjustScalingFactors;
        };
    };
    toJSON: {
        createStableswapPool(value: MsgCreateStableswapPool): {
            typeUrl: string;
            value: {
                sender: string;
                poolParams?: {
                    swapFee: string;
                    exitFee: string;
                };
                initialPoolLiquidity: {
                    denom: string;
                    amount: string;
                }[];
                scalingFactors: string[];
                futurePoolGovernor: string;
                scalingFactorController: string;
            };
        };
        stableSwapAdjustScalingFactors(value: MsgStableSwapAdjustScalingFactors): {
            typeUrl: string;
            value: {
                sender: string;
                poolId: string;
                scalingFactors: string[];
            };
        };
    };
    fromJSON: {
        createStableswapPool(value: any): {
            typeUrl: string;
            value: MsgCreateStableswapPool;
        };
        stableSwapAdjustScalingFactors(value: any): {
            typeUrl: string;
            value: MsgStableSwapAdjustScalingFactors;
        };
    };
    fromPartial: {
        createStableswapPool(value: MsgCreateStableswapPool): {
            typeUrl: string;
            value: MsgCreateStableswapPool;
        };
        stableSwapAdjustScalingFactors(value: MsgStableSwapAdjustScalingFactors): {
            typeUrl: string;
            value: MsgStableSwapAdjustScalingFactors;
        };
    };
};
