import { DeliverTxResponse, StdFee, TxRpc } from "../../../types";
import { MsgJoinPool, MsgExitPool, MsgSwapExactAmountIn, MsgSwapExactAmountOut, MsgJoinSwapExternAmountIn, MsgJoinSwapShareAmountOut, MsgExitSwapExternAmountOut, MsgExitSwapShareAmountIn } from "./tx";
export interface Msg {
    joinPool(signerAddress: string, message: MsgJoinPool, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    exitPool(signerAddress: string, message: MsgExitPool, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    swapExactAmountIn(signerAddress: string, message: MsgSwapExactAmountIn, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    swapExactAmountOut(signerAddress: string, message: MsgSwapExactAmountOut, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    joinSwapExternAmountIn(signerAddress: string, message: MsgJoinSwapExternAmountIn, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    joinSwapShareAmountOut(signerAddress: string, message: MsgJoinSwapShareAmountOut, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    exitSwapExternAmountOut(signerAddress: string, message: MsgExitSwapExternAmountOut, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
    exitSwapShareAmountIn(signerAddress: string, message: MsgExitSwapShareAmountIn, fee: number | StdFee | "auto", memo?: string): Promise<DeliverTxResponse>;
}
export declare class MsgClientImpl implements Msg {
    private readonly rpc;
    constructor(rpc: TxRpc);
    joinPool: (signerAddress: string, message: MsgJoinPool, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    exitPool: (signerAddress: string, message: MsgExitPool, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    swapExactAmountIn: (signerAddress: string, message: MsgSwapExactAmountIn, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    swapExactAmountOut: (signerAddress: string, message: MsgSwapExactAmountOut, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    joinSwapExternAmountIn: (signerAddress: string, message: MsgJoinSwapExternAmountIn, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    joinSwapShareAmountOut: (signerAddress: string, message: MsgJoinSwapShareAmountOut, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    exitSwapExternAmountOut: (signerAddress: string, message: MsgExitSwapExternAmountOut, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
    exitSwapShareAmountIn: (signerAddress: string, message: MsgExitSwapShareAmountIn, fee?: number | StdFee | "auto", memo?: string) => Promise<DeliverTxResponse>;
}
export declare const createClientImpl: (rpc: TxRpc) => MsgClientImpl;
