import { BinaryReader, BinaryWriter } from "../../binary";
import { isSet } from "../../helpers";
export const protobufPackage = "osmosis.incentives";
function createBaseParams() {
    return {
        distrEpochIdentifier: ""
    };
}
export const Params = {
    typeUrl: "/osmosis.incentives.Params",
    aminoType: "osmosis/incentives/params",
    is(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.distrEpochIdentifier === "string");
    },
    isSDK(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.distr_epoch_identifier === "string");
    },
    isAmino(o) {
        return o && (o.$typeUrl === Params.typeUrl || typeof o.distr_epoch_identifier === "string");
    },
    encode(message, writer = BinaryWriter.create()) {
        if (message.distrEpochIdentifier !== undefined) {
            writer.uint32(10).string(message.distrEpochIdentifier);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof BinaryReader ? input : new BinaryReader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseParams();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.distrEpochIdentifier = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        const obj = createBaseParams();
        if (isSet(object.distrEpochIdentifier))
            obj.distrEpochIdentifier = String(object.distrEpochIdentifier);
        return obj;
    },
    toJSON(message) {
        const obj = {};
        message.distrEpochIdentifier !== undefined && (obj.distrEpochIdentifier = message.distrEpochIdentifier);
        return obj;
    },
    fromPartial(object) {
        const message = createBaseParams();
        message.distrEpochIdentifier = object.distrEpochIdentifier ?? "";
        return message;
    },
    fromSDK(object) {
        return {
            distrEpochIdentifier: object?.distr_epoch_identifier
        };
    },
    fromSDKJSON(object) {
        return {
            distr_epoch_identifier: isSet(object.distr_epoch_identifier) ? String(object.distr_epoch_identifier) : ""
        };
    },
    toSDK(message) {
        const obj = {};
        obj.distr_epoch_identifier = message.distrEpochIdentifier;
        return obj;
    },
    fromAmino(object) {
        const message = createBaseParams();
        if (object.distr_epoch_identifier !== undefined && object.distr_epoch_identifier !== null) {
            message.distrEpochIdentifier = object.distr_epoch_identifier;
        }
        return message;
    },
    toAmino(message) {
        const obj = {};
        obj.distr_epoch_identifier = message.distrEpochIdentifier === "" ? undefined : message.distrEpochIdentifier;
        return obj;
    },
    fromAminoMsg(object) {
        return Params.fromAmino(object.value);
    },
    toAminoMsg(message) {
        return {
            type: "osmosis/incentives/params",
            value: Params.toAmino(message)
        };
    },
    fromProtoMsg(message) {
        return Params.decode(message.value);
    },
    toProto(message) {
        return Params.encode(message).finish();
    },
    toProtoMsg(message) {
        return {
            typeUrl: "/osmosis.incentives.Params",
            value: Params.encode(message).finish()
        };
    },
    registerTypeUrl() { }
};
