import { TelescopeGeneratedType } from "../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgCreateGauge, MsgAddToGauge } from "./tx";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        createGauge(value: MsgCreateGauge): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        addToGauge(value: MsgAddToGauge): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        createGauge(value: MsgCreateGauge): {
            typeUrl: string;
            value: MsgCreateGauge;
        };
        addToGauge(value: MsgAddToGauge): {
            typeUrl: string;
            value: MsgAddToGauge;
        };
    };
    toJSON: {
        createGauge(value: MsgCreateGauge): {
            typeUrl: string;
            value: {
                isPerpetual: boolean;
                owner: string;
                distributeTo: {
                    lockQueryType: import("../lockup/lock").LockQueryType;
                    denom: string;
                    duration: {
                        seconds: string;
                        nanos: number;
                    };
                    timestamp: string;
                };
                coins: {
                    denom: string;
                    amount: string;
                }[];
                startTime: string;
                numEpochsPaidOver: string;
            };
        };
        addToGauge(value: MsgAddToGauge): {
            typeUrl: string;
            value: {
                owner: string;
                gaugeId: string;
                rewards: {
                    denom: string;
                    amount: string;
                }[];
            };
        };
    };
    fromJSON: {
        createGauge(value: any): {
            typeUrl: string;
            value: MsgCreateGauge;
        };
        addToGauge(value: any): {
            typeUrl: string;
            value: MsgAddToGauge;
        };
    };
    fromPartial: {
        createGauge(value: MsgCreateGauge): {
            typeUrl: string;
            value: MsgCreateGauge;
        };
        addToGauge(value: MsgAddToGauge): {
            typeUrl: string;
            value: MsgAddToGauge;
        };
    };
};
