import { MsgCreateGauge, MsgAddToGauge } from "./tx";
export const registry = [["/osmosis.incentives.MsgCreateGauge", MsgCreateGauge], ["/osmosis.incentives.MsgAddToGauge", MsgAddToGauge]];
export const load = (protoRegistry) => {
    registry.forEach(([typeUrl, mod]) => {
        protoRegistry.register(typeUrl, mod);
    });
};
export const MessageComposer = {
    encoded: {
        createGauge(value) {
            return {
                typeUrl: "/osmosis.incentives.MsgCreateGauge",
                value: MsgCreateGauge.encode(value).finish()
            };
        },
        addToGauge(value) {
            return {
                typeUrl: "/osmosis.incentives.MsgAddToGauge",
                value: MsgAddToGauge.encode(value).finish()
            };
        }
    },
    withTypeUrl: {
        createGauge(value) {
            return {
                typeUrl: "/osmosis.incentives.MsgCreateGauge",
                value
            };
        },
        addToGauge(value) {
            return {
                typeUrl: "/osmosis.incentives.MsgAddToGauge",
                value
            };
        }
    },
    toJSON: {
        createGauge(value) {
            return {
                typeUrl: "/osmosis.incentives.MsgCreateGauge",
                value: MsgCreateGauge.toJSON(value)
            };
        },
        addToGauge(value) {
            return {
                typeUrl: "/osmosis.incentives.MsgAddToGauge",
                value: MsgAddToGauge.toJSON(value)
            };
        }
    },
    fromJSON: {
        createGauge(value) {
            return {
                typeUrl: "/osmosis.incentives.MsgCreateGauge",
                value: MsgCreateGauge.fromJSON(value)
            };
        },
        addToGauge(value) {
            return {
                typeUrl: "/osmosis.incentives.MsgAddToGauge",
                value: MsgAddToGauge.fromJSON(value)
            };
        }
    },
    fromPartial: {
        createGauge(value) {
            return {
                typeUrl: "/osmosis.incentives.MsgCreateGauge",
                value: MsgCreateGauge.fromPartial(value)
            };
        },
        addToGauge(value) {
            return {
                typeUrl: "/osmosis.incentives.MsgAddToGauge",
                value: MsgAddToGauge.fromPartial(value)
            };
        }
    }
};
