import { TelescopeGeneratedType } from "../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgLockTokens, MsgBeginUnlockingAll, MsgBeginUnlocking, MsgExtendLockup, MsgForceUnlock } from "./tx";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        lockTokens(value: MsgLockTokens): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        beginUnlockingAll(value: MsgBeginUnlockingAll): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        beginUnlocking(value: MsgBeginUnlocking): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        extendLockup(value: MsgExtendLockup): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        forceUnlock(value: MsgForceUnlock): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        lockTokens(value: MsgLockTokens): {
            typeUrl: string;
            value: MsgLockTokens;
        };
        beginUnlockingAll(value: MsgBeginUnlockingAll): {
            typeUrl: string;
            value: MsgBeginUnlockingAll;
        };
        beginUnlocking(value: MsgBeginUnlocking): {
            typeUrl: string;
            value: MsgBeginUnlocking;
        };
        extendLockup(value: MsgExtendLockup): {
            typeUrl: string;
            value: MsgExtendLockup;
        };
        forceUnlock(value: MsgForceUnlock): {
            typeUrl: string;
            value: MsgForceUnlock;
        };
    };
    toJSON: {
        lockTokens(value: MsgLockTokens): {
            typeUrl: string;
            value: {
                owner: string;
                duration: {
                    seconds: string;
                    nanos: number;
                };
                coins: {
                    denom: string;
                    amount: string;
                }[];
            };
        };
        beginUnlockingAll(value: MsgBeginUnlockingAll): {
            typeUrl: string;
            value: {
                owner: string;
            };
        };
        beginUnlocking(value: MsgBeginUnlocking): {
            typeUrl: string;
            value: {
                owner: string;
                iD: string;
                coins: {
                    denom: string;
                    amount: string;
                }[];
            };
        };
        extendLockup(value: MsgExtendLockup): {
            typeUrl: string;
            value: {
                owner: string;
                iD: string;
                duration: {
                    seconds: string;
                    nanos: number;
                };
            };
        };
        forceUnlock(value: MsgForceUnlock): {
            typeUrl: string;
            value: {
                owner: string;
                iD: string;
                coins: {
                    denom: string;
                    amount: string;
                }[];
            };
        };
    };
    fromJSON: {
        lockTokens(value: any): {
            typeUrl: string;
            value: MsgLockTokens;
        };
        beginUnlockingAll(value: any): {
            typeUrl: string;
            value: MsgBeginUnlockingAll;
        };
        beginUnlocking(value: any): {
            typeUrl: string;
            value: MsgBeginUnlocking;
        };
        extendLockup(value: any): {
            typeUrl: string;
            value: MsgExtendLockup;
        };
        forceUnlock(value: any): {
            typeUrl: string;
            value: MsgForceUnlock;
        };
    };
    fromPartial: {
        lockTokens(value: MsgLockTokens): {
            typeUrl: string;
            value: MsgLockTokens;
        };
        beginUnlockingAll(value: MsgBeginUnlockingAll): {
            typeUrl: string;
            value: MsgBeginUnlockingAll;
        };
        beginUnlocking(value: MsgBeginUnlocking): {
            typeUrl: string;
            value: MsgBeginUnlocking;
        };
        extendLockup(value: MsgExtendLockup): {
            typeUrl: string;
            value: MsgExtendLockup;
        };
        forceUnlock(value: MsgForceUnlock): {
            typeUrl: string;
            value: MsgForceUnlock;
        };
    };
};
