import { MsgLockTokens, MsgBeginUnlockingAll, MsgBeginUnlocking, MsgExtendLockup, MsgForceUnlock } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* LockTokens lock tokens */
    lockTokens = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgLockTokens.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* BeginUnlockingAll begin unlocking all tokens */
    beginUnlockingAll = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgBeginUnlockingAll.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* MsgBeginUnlocking begins unlocking tokens by lock ID */
    beginUnlocking = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgBeginUnlocking.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* MsgEditLockup edits the existing lockups by lock ID */
    extendLockup = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgExtendLockup.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* ForceUnlock */
    forceUnlock = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgForceUnlock.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
