import { QueryGaugeIdsResponse, QueryDistrInfoResponse, QueryParamsResponse, QueryLockableDurationsResponse, QueryIncentivizedPoolsResponse, QueryExternalIncentiveGaugesResponse } from "./query";
export class LCDQueryClient {
    req;
    constructor({ requestClient }) {
        this.req = requestClient;
    }
    /* GaugeIds takes the pool id and returns the matching gauge ids and durations */
    gaugeIds = async (params) => {
        const endpoint = `osmosis/pool-incentives/v1beta1/gauge-ids/${params.poolId}`;
        return QueryGaugeIdsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* DistrInfo returns the pool's matching gauge ids and weights. */
    distrInfo = async (_params = {}) => {
        const endpoint = `osmosis/pool-incentives/v1beta1/distr_info`;
        return QueryDistrInfoResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* Params returns pool incentives params. */
    params = async (_params = {}) => {
        const endpoint = `osmosis/pool-incentives/v1beta1/params`;
        return QueryParamsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* LockableDurations returns lock durations for pools. */
    lockableDurations = async (_params = {}) => {
        const endpoint = `osmosis/pool-incentives/v1beta1/lockable_durations`;
        return QueryLockableDurationsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* IncentivizedPools returns currently incentivized pools */
    incentivizedPools = async (_params = {}) => {
        const endpoint = `osmosis/pool-incentives/v1beta1/incentivized_pools`;
        return QueryIncentivizedPoolsResponse.fromSDKJSON(await this.req.get(endpoint));
    };
    /* ExternalIncentiveGauges returns external incentive gauges. */
    externalIncentiveGauges = async (_params = {}) => {
        const endpoint = `osmosis/pool-incentives/v1beta1/external_incentive_gauges`;
        return QueryExternalIncentiveGaugesResponse.fromSDKJSON(await this.req.get(endpoint));
    };
}
