import { MsgSuperfluidDelegate, MsgSuperfluidUndelegate, MsgSuperfluidUnbondLock, MsgLockAndSuperfluidDelegate, MsgUnPoolWhitelistedPool } from "./tx";
export class MsgClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* Execute superfluid delegation for a lockup */
    superfluidDelegate = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgSuperfluidDelegate.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* Execute superfluid undelegation for a lockup */
    superfluidUndelegate = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgSuperfluidUndelegate.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* For a given lock that is being superfluidly undelegated,
     also unbond the underlying lock. */
    superfluidUnbondLock = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgSuperfluidUnbondLock.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* Execute lockup lock and superfluid delegation in a single msg */
    lockAndSuperfluidDelegate = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgLockAndSuperfluidDelegate.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
    /* UnPoolWhitelistedPool */
    unPoolWhitelistedPool = async (signerAddress, message, fee = "auto", memo = "") => {
        const data = [{
                typeUrl: MsgUnPoolWhitelistedPool.typeUrl,
                value: message
            }];
        return this.rpc.signAndBroadcast(signerAddress, data, fee, memo);
    };
}
export const createClientImpl = (rpc) => {
    return new MsgClientImpl(rpc);
};
