import { TelescopeGeneratedType } from "../../../types";
import { Registry } from "@cosmjs/proto-signing";
import { MsgCreateDenom, MsgMint, MsgBurn, MsgChangeAdmin, MsgSetDenomMetadata } from "./tx";
export declare const registry: ReadonlyArray<[string, TelescopeGeneratedType<any, any, any>]>;
export declare const load: (protoRegistry: Registry) => void;
export declare const MessageComposer: {
    encoded: {
        createDenom(value: MsgCreateDenom): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        mint(value: MsgMint): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        burn(value: MsgBurn): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        changeAdmin(value: MsgChangeAdmin): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
        setDenomMetadata(value: MsgSetDenomMetadata): {
            typeUrl: string;
            value: Uint8Array<ArrayBufferLike>;
        };
    };
    withTypeUrl: {
        createDenom(value: MsgCreateDenom): {
            typeUrl: string;
            value: MsgCreateDenom;
        };
        mint(value: MsgMint): {
            typeUrl: string;
            value: MsgMint;
        };
        burn(value: MsgBurn): {
            typeUrl: string;
            value: MsgBurn;
        };
        changeAdmin(value: MsgChangeAdmin): {
            typeUrl: string;
            value: MsgChangeAdmin;
        };
        setDenomMetadata(value: MsgSetDenomMetadata): {
            typeUrl: string;
            value: MsgSetDenomMetadata;
        };
    };
    toJSON: {
        createDenom(value: MsgCreateDenom): {
            typeUrl: string;
            value: {
                sender: string;
                subdenom: string;
            };
        };
        mint(value: MsgMint): {
            typeUrl: string;
            value: {
                sender: string;
                amount: {
                    denom: string;
                    amount: string;
                };
            };
        };
        burn(value: MsgBurn): {
            typeUrl: string;
            value: {
                sender: string;
                amount: {
                    denom: string;
                    amount: string;
                };
            };
        };
        changeAdmin(value: MsgChangeAdmin): {
            typeUrl: string;
            value: {
                sender: string;
                denom: string;
                newAdmin: string;
            };
        };
        setDenomMetadata(value: MsgSetDenomMetadata): {
            typeUrl: string;
            value: {
                sender: string;
                metadata: {
                    description: string;
                    denomUnits: {
                        denom: string;
                        exponent: number;
                        aliases: string[];
                    }[];
                    base: string;
                    display: string;
                    name: string;
                    symbol: string;
                    uri: string;
                    uriHash: string;
                };
            };
        };
    };
    fromJSON: {
        createDenom(value: any): {
            typeUrl: string;
            value: MsgCreateDenom;
        };
        mint(value: any): {
            typeUrl: string;
            value: MsgMint;
        };
        burn(value: any): {
            typeUrl: string;
            value: MsgBurn;
        };
        changeAdmin(value: any): {
            typeUrl: string;
            value: MsgChangeAdmin;
        };
        setDenomMetadata(value: any): {
            typeUrl: string;
            value: MsgSetDenomMetadata;
        };
    };
    fromPartial: {
        createDenom(value: MsgCreateDenom): {
            typeUrl: string;
            value: MsgCreateDenom;
        };
        mint(value: MsgMint): {
            typeUrl: string;
            value: MsgMint;
        };
        burn(value: MsgBurn): {
            typeUrl: string;
            value: MsgBurn;
        };
        changeAdmin(value: MsgChangeAdmin): {
            typeUrl: string;
            value: MsgChangeAdmin;
        };
        setDenomMetadata(value: MsgSetDenomMetadata): {
            typeUrl: string;
            value: MsgSetDenomMetadata;
        };
    };
};
