import { TxRpc } from "../../../types";
import { ParamsRequest, ParamsResponse, ArithmeticTwapRequest, ArithmeticTwapResponse, ArithmeticTwapToNowRequest, ArithmeticTwapToNowResponse } from "./query";
export interface Query {
    params(request?: ParamsRequest): Promise<ParamsResponse>;
    arithmeticTwap(request: ArithmeticTwapRequest): Promise<ArithmeticTwapResponse>;
    arithmeticTwapToNow(request: ArithmeticTwapToNowRequest): Promise<ArithmeticTwapToNowResponse>;
}
export declare class QueryClientImpl implements Query {
    private readonly rpc;
    constructor(rpc: TxRpc);
    params: (request?: ParamsRequest) => Promise<ParamsResponse>;
    arithmeticTwap: (request: ArithmeticTwapRequest) => Promise<ArithmeticTwapResponse>;
    arithmeticTwapToNow: (request: ArithmeticTwapToNowRequest) => Promise<ArithmeticTwapToNowResponse>;
}
export declare const createClientImpl: (rpc: TxRpc) => QueryClientImpl;
