import { TxRpc } from "../../types";
import { RequestEcho, ResponseEcho, RequestFlush, ResponseFlush, RequestInfo, ResponseInfo, RequestSetOption, ResponseSetOption, RequestDeliverTx, ResponseDeliverTx, RequestCheckTx, ResponseCheckTx, RequestQuery, ResponseQuery, RequestCommit, ResponseCommit, RequestInitChain, ResponseInitChain, RequestBeginBlock, ResponseBeginBlock, RequestEndBlock, ResponseEndBlock, RequestListSnapshots, ResponseListSnapshots, RequestOfferSnapshot, ResponseOfferSnapshot, RequestLoadSnapshotChunk, ResponseLoadSnapshotChunk, RequestApplySnapshotChunk, ResponseApplySnapshotChunk } from "./types";
export interface ABCIApplication {
    echo(request: RequestEcho): Promise<ResponseEcho>;
    flush(request?: RequestFlush): Promise<ResponseFlush>;
    info(request: RequestInfo): Promise<ResponseInfo>;
    setOption(request: RequestSetOption): Promise<ResponseSetOption>;
    deliverTx(request: RequestDeliverTx): Promise<ResponseDeliverTx>;
    checkTx(request: RequestCheckTx): Promise<ResponseCheckTx>;
    query(request: RequestQuery): Promise<ResponseQuery>;
    commit(request?: RequestCommit): Promise<ResponseCommit>;
    initChain(request: RequestInitChain): Promise<ResponseInitChain>;
    beginBlock(request: RequestBeginBlock): Promise<ResponseBeginBlock>;
    endBlock(request: RequestEndBlock): Promise<ResponseEndBlock>;
    listSnapshots(request?: RequestListSnapshots): Promise<ResponseListSnapshots>;
    offerSnapshot(request: RequestOfferSnapshot): Promise<ResponseOfferSnapshot>;
    loadSnapshotChunk(request: RequestLoadSnapshotChunk): Promise<ResponseLoadSnapshotChunk>;
    applySnapshotChunk(request: RequestApplySnapshotChunk): Promise<ResponseApplySnapshotChunk>;
}
export declare class ABCIApplicationClientImpl implements ABCIApplication {
    private readonly rpc;
    constructor(rpc: TxRpc);
    echo: (request: RequestEcho) => Promise<ResponseEcho>;
    flush: (request?: RequestFlush) => Promise<ResponseFlush>;
    info: (request: RequestInfo) => Promise<ResponseInfo>;
    setOption: (request: RequestSetOption) => Promise<ResponseSetOption>;
    deliverTx: (request: RequestDeliverTx) => Promise<ResponseDeliverTx>;
    checkTx: (request: RequestCheckTx) => Promise<ResponseCheckTx>;
    query: (request: RequestQuery) => Promise<ResponseQuery>;
    commit: (request?: RequestCommit) => Promise<ResponseCommit>;
    initChain: (request: RequestInitChain) => Promise<ResponseInitChain>;
    beginBlock: (request: RequestBeginBlock) => Promise<ResponseBeginBlock>;
    endBlock: (request: RequestEndBlock) => Promise<ResponseEndBlock>;
    listSnapshots: (request?: RequestListSnapshots) => Promise<ResponseListSnapshots>;
    offerSnapshot: (request: RequestOfferSnapshot) => Promise<ResponseOfferSnapshot>;
    loadSnapshotChunk: (request: RequestLoadSnapshotChunk) => Promise<ResponseLoadSnapshotChunk>;
    applySnapshotChunk: (request: RequestApplySnapshotChunk) => Promise<ResponseApplySnapshotChunk>;
}
export declare const createClientImpl: (rpc: TxRpc) => ABCIApplicationClientImpl;
