import { BinaryReader } from "../../binary";
import { RequestEcho, ResponseEcho, RequestFlush, ResponseFlush, RequestInfo, ResponseInfo, RequestSetOption, ResponseSetOption, RequestDeliverTx, ResponseDeliverTx, RequestCheckTx, ResponseCheckTx, RequestQuery, ResponseQuery, RequestCommit, ResponseCommit, RequestInitChain, ResponseInitChain, RequestBeginBlock, ResponseBeginBlock, RequestEndBlock, ResponseEndBlock, RequestListSnapshots, ResponseListSnapshots, RequestOfferSnapshot, ResponseOfferSnapshot, RequestLoadSnapshotChunk, ResponseLoadSnapshotChunk, RequestApplySnapshotChunk, ResponseApplySnapshotChunk } from "./types";
export class ABCIApplicationClientImpl {
    rpc;
    constructor(rpc) {
        this.rpc = rpc;
    }
    /* Echo */
    echo = async (request) => {
        const data = RequestEcho.encode(request).finish();
        const promise = this.rpc.request("tendermint.abci.ABCIApplication", "Echo", data);
        return promise.then(data => ResponseEcho.decode(new BinaryReader(data)));
    };
    /* Flush */
    flush = async (request = {}) => {
        const data = RequestFlush.encode(request).finish();
        const promise = this.rpc.request("tendermint.abci.ABCIApplication", "Flush", data);
        return promise.then(data => ResponseFlush.decode(new BinaryReader(data)));
    };
    /* Info */
    info = async (request) => {
        const data = RequestInfo.encode(request).finish();
        const promise = this.rpc.request("tendermint.abci.ABCIApplication", "Info", data);
        return promise.then(data => ResponseInfo.decode(new BinaryReader(data)));
    };
    /* SetOption */
    setOption = async (request) => {
        const data = RequestSetOption.encode(request).finish();
        const promise = this.rpc.request("tendermint.abci.ABCIApplication", "SetOption", data);
        return promise.then(data => ResponseSetOption.decode(new BinaryReader(data)));
    };
    /* DeliverTx */
    deliverTx = async (request) => {
        const data = RequestDeliverTx.encode(request).finish();
        const promise = this.rpc.request("tendermint.abci.ABCIApplication", "DeliverTx", data);
        return promise.then(data => ResponseDeliverTx.decode(new BinaryReader(data)));
    };
    /* CheckTx */
    checkTx = async (request) => {
        const data = RequestCheckTx.encode(request).finish();
        const promise = this.rpc.request("tendermint.abci.ABCIApplication", "CheckTx", data);
        return promise.then(data => ResponseCheckTx.decode(new BinaryReader(data)));
    };
    /* Query */
    query = async (request) => {
        const data = RequestQuery.encode(request).finish();
        const promise = this.rpc.request("tendermint.abci.ABCIApplication", "Query", data);
        return promise.then(data => ResponseQuery.decode(new BinaryReader(data)));
    };
    /* Commit */
    commit = async (request = {}) => {
        const data = RequestCommit.encode(request).finish();
        const promise = this.rpc.request("tendermint.abci.ABCIApplication", "Commit", data);
        return promise.then(data => ResponseCommit.decode(new BinaryReader(data)));
    };
    /* InitChain */
    initChain = async (request) => {
        const data = RequestInitChain.encode(request).finish();
        const promise = this.rpc.request("tendermint.abci.ABCIApplication", "InitChain", data);
        return promise.then(data => ResponseInitChain.decode(new BinaryReader(data)));
    };
    /* BeginBlock */
    beginBlock = async (request) => {
        const data = RequestBeginBlock.encode(request).finish();
        const promise = this.rpc.request("tendermint.abci.ABCIApplication", "BeginBlock", data);
        return promise.then(data => ResponseBeginBlock.decode(new BinaryReader(data)));
    };
    /* EndBlock */
    endBlock = async (request) => {
        const data = RequestEndBlock.encode(request).finish();
        const promise = this.rpc.request("tendermint.abci.ABCIApplication", "EndBlock", data);
        return promise.then(data => ResponseEndBlock.decode(new BinaryReader(data)));
    };
    /* ListSnapshots */
    listSnapshots = async (request = {}) => {
        const data = RequestListSnapshots.encode(request).finish();
        const promise = this.rpc.request("tendermint.abci.ABCIApplication", "ListSnapshots", data);
        return promise.then(data => ResponseListSnapshots.decode(new BinaryReader(data)));
    };
    /* OfferSnapshot */
    offerSnapshot = async (request) => {
        const data = RequestOfferSnapshot.encode(request).finish();
        const promise = this.rpc.request("tendermint.abci.ABCIApplication", "OfferSnapshot", data);
        return promise.then(data => ResponseOfferSnapshot.decode(new BinaryReader(data)));
    };
    /* LoadSnapshotChunk */
    loadSnapshotChunk = async (request) => {
        const data = RequestLoadSnapshotChunk.encode(request).finish();
        const promise = this.rpc.request("tendermint.abci.ABCIApplication", "LoadSnapshotChunk", data);
        return promise.then(data => ResponseLoadSnapshotChunk.decode(new BinaryReader(data)));
    };
    /* ApplySnapshotChunk */
    applySnapshotChunk = async (request) => {
        const data = RequestApplySnapshotChunk.encode(request).finish();
        const promise = this.rpc.request("tendermint.abci.ABCIApplication", "ApplySnapshotChunk", data);
        return promise.then(data => ResponseApplySnapshotChunk.decode(new BinaryReader(data)));
    };
}
export const createClientImpl = (rpc) => {
    return new ABCIApplicationClientImpl(rpc);
};
