import * as _305 from "./abci/types";
import * as _306 from "./crypto/keys";
import * as _307 from "./crypto/proof";
import * as _308 from "./libs/bits/types";
import * as _309 from "./p2p/types";
import * as _310 from "./types/block";
import * as _311 from "./types/evidence";
import * as _312 from "./types/params";
import * as _313 from "./types/types";
import * as _314 from "./types/validator";
import * as _315 from "./version/types";
import * as _537 from "./abci/types.rpc.ABCIApplication";
export declare namespace tendermint {
    const abci: {
        ABCIApplicationClientImpl: typeof _537.ABCIApplicationClientImpl;
        createClientImpl: (rpc: import("..").TxRpc) => _537.ABCIApplicationClientImpl;
        checkTxTypeFromJSON(object: any): _305.CheckTxType;
        checkTxTypeToJSON(object: _305.CheckTxType): string;
        responseOfferSnapshot_ResultFromJSON(object: any): _305.ResponseOfferSnapshot_Result;
        responseOfferSnapshot_ResultToJSON(object: _305.ResponseOfferSnapshot_Result): string;
        responseApplySnapshotChunk_ResultFromJSON(object: any): _305.ResponseApplySnapshotChunk_Result;
        responseApplySnapshotChunk_ResultToJSON(object: _305.ResponseApplySnapshotChunk_Result): string;
        evidenceTypeFromJSON(object: any): _305.EvidenceType;
        evidenceTypeToJSON(object: _305.EvidenceType): string;
        protobufPackage: "tendermint.abci";
        CheckTxType: typeof _305.CheckTxType;
        CheckTxTypeSDKType: typeof _305.CheckTxType;
        CheckTxTypeAmino: typeof _305.CheckTxType;
        ResponseOfferSnapshot_Result: typeof _305.ResponseOfferSnapshot_Result;
        ResponseOfferSnapshot_ResultSDKType: typeof _305.ResponseOfferSnapshot_Result;
        ResponseOfferSnapshot_ResultAmino: typeof _305.ResponseOfferSnapshot_Result;
        ResponseApplySnapshotChunk_Result: typeof _305.ResponseApplySnapshotChunk_Result;
        ResponseApplySnapshotChunk_ResultSDKType: typeof _305.ResponseApplySnapshotChunk_Result;
        ResponseApplySnapshotChunk_ResultAmino: typeof _305.ResponseApplySnapshotChunk_Result;
        EvidenceType: typeof _305.EvidenceType;
        EvidenceTypeSDKType: typeof _305.EvidenceType;
        EvidenceTypeAmino: typeof _305.EvidenceType;
        Request: {
            typeUrl: string;
            is(o: any): o is _305.Request;
            isSDK(o: any): o is _305.RequestSDKType;
            isAmino(o: any): o is _305.RequestAmino;
            encode(message: _305.Request, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.Request;
            fromJSON(object: any): _305.Request;
            toJSON(message: _305.Request): import("..").JsonSafe<_305.Request>;
            fromPartial(object: import("../helpers").DeepPartial<_305.Request>): _305.Request;
            fromSDK(object: _305.RequestSDKType): _305.Request;
            fromSDKJSON(object: any): _305.RequestSDKType;
            toSDK(message: _305.Request): _305.RequestSDKType;
            fromAmino(object: _305.RequestAmino): _305.Request;
            toAmino(message: _305.Request): _305.RequestAmino;
            fromAminoMsg(object: _305.RequestAminoMsg): _305.Request;
            fromProtoMsg(message: _305.RequestProtoMsg): _305.Request;
            toProto(message: _305.Request): Uint8Array;
            toProtoMsg(message: _305.Request): _305.RequestProtoMsg;
            registerTypeUrl(): void;
        };
        RequestEcho: {
            typeUrl: string;
            is(o: any): o is _305.RequestEcho;
            isSDK(o: any): o is _305.RequestEchoSDKType;
            isAmino(o: any): o is _305.RequestEchoAmino;
            encode(message: _305.RequestEcho, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.RequestEcho;
            fromJSON(object: any): _305.RequestEcho;
            toJSON(message: _305.RequestEcho): import("..").JsonSafe<_305.RequestEcho>;
            fromPartial(object: import("../helpers").DeepPartial<_305.RequestEcho>): _305.RequestEcho;
            fromSDK(object: _305.RequestEchoSDKType): _305.RequestEcho;
            fromSDKJSON(object: any): _305.RequestEchoSDKType;
            toSDK(message: _305.RequestEcho): _305.RequestEchoSDKType;
            fromAmino(object: _305.RequestEchoAmino): _305.RequestEcho;
            toAmino(message: _305.RequestEcho): _305.RequestEchoAmino;
            fromAminoMsg(object: _305.RequestEchoAminoMsg): _305.RequestEcho;
            fromProtoMsg(message: _305.RequestEchoProtoMsg): _305.RequestEcho;
            toProto(message: _305.RequestEcho): Uint8Array;
            toProtoMsg(message: _305.RequestEcho): _305.RequestEchoProtoMsg;
            registerTypeUrl(): void;
        };
        RequestFlush: {
            typeUrl: string;
            is(o: any): o is _305.RequestFlush;
            isSDK(o: any): o is _305.RequestFlushSDKType;
            isAmino(o: any): o is _305.RequestFlushAmino;
            encode(_: _305.RequestFlush, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.RequestFlush;
            fromJSON(_: any): _305.RequestFlush;
            toJSON(_: _305.RequestFlush): import("..").JsonSafe<_305.RequestFlush>;
            fromPartial(_: import("../helpers").DeepPartial<_305.RequestFlush>): _305.RequestFlush;
            fromSDK(_: _305.RequestFlushSDKType): _305.RequestFlush;
            fromSDKJSON(_: any): _305.RequestFlushSDKType;
            toSDK(_: _305.RequestFlush): _305.RequestFlushSDKType;
            fromAmino(_: _305.RequestFlushAmino): _305.RequestFlush;
            toAmino(_: _305.RequestFlush): _305.RequestFlushAmino;
            fromAminoMsg(object: _305.RequestFlushAminoMsg): _305.RequestFlush;
            fromProtoMsg(message: _305.RequestFlushProtoMsg): _305.RequestFlush;
            toProto(message: _305.RequestFlush): Uint8Array;
            toProtoMsg(message: _305.RequestFlush): _305.RequestFlushProtoMsg;
            registerTypeUrl(): void;
        };
        RequestInfo: {
            typeUrl: string;
            is(o: any): o is _305.RequestInfo;
            isSDK(o: any): o is _305.RequestInfoSDKType;
            isAmino(o: any): o is _305.RequestInfoAmino;
            encode(message: _305.RequestInfo, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.RequestInfo;
            fromJSON(object: any): _305.RequestInfo;
            toJSON(message: _305.RequestInfo): import("..").JsonSafe<_305.RequestInfo>;
            fromPartial(object: import("../helpers").DeepPartial<_305.RequestInfo>): _305.RequestInfo;
            fromSDK(object: _305.RequestInfoSDKType): _305.RequestInfo;
            fromSDKJSON(object: any): _305.RequestInfoSDKType;
            toSDK(message: _305.RequestInfo): _305.RequestInfoSDKType;
            fromAmino(object: _305.RequestInfoAmino): _305.RequestInfo;
            toAmino(message: _305.RequestInfo): _305.RequestInfoAmino;
            fromAminoMsg(object: _305.RequestInfoAminoMsg): _305.RequestInfo;
            fromProtoMsg(message: _305.RequestInfoProtoMsg): _305.RequestInfo;
            toProto(message: _305.RequestInfo): Uint8Array;
            toProtoMsg(message: _305.RequestInfo): _305.RequestInfoProtoMsg;
            registerTypeUrl(): void;
        };
        RequestSetOption: {
            typeUrl: string;
            is(o: any): o is _305.RequestSetOption;
            isSDK(o: any): o is _305.RequestSetOptionSDKType;
            isAmino(o: any): o is _305.RequestSetOptionAmino;
            encode(message: _305.RequestSetOption, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.RequestSetOption;
            fromJSON(object: any): _305.RequestSetOption;
            toJSON(message: _305.RequestSetOption): import("..").JsonSafe<_305.RequestSetOption>;
            fromPartial(object: import("../helpers").DeepPartial<_305.RequestSetOption>): _305.RequestSetOption;
            fromSDK(object: _305.RequestSetOptionSDKType): _305.RequestSetOption;
            fromSDKJSON(object: any): _305.RequestSetOptionSDKType;
            toSDK(message: _305.RequestSetOption): _305.RequestSetOptionSDKType;
            fromAmino(object: _305.RequestSetOptionAmino): _305.RequestSetOption;
            toAmino(message: _305.RequestSetOption): _305.RequestSetOptionAmino;
            fromAminoMsg(object: _305.RequestSetOptionAminoMsg): _305.RequestSetOption;
            fromProtoMsg(message: _305.RequestSetOptionProtoMsg): _305.RequestSetOption;
            toProto(message: _305.RequestSetOption): Uint8Array;
            toProtoMsg(message: _305.RequestSetOption): _305.RequestSetOptionProtoMsg;
            registerTypeUrl(): void;
        };
        RequestInitChain: {
            typeUrl: string;
            is(o: any): o is _305.RequestInitChain;
            isSDK(o: any): o is _305.RequestInitChainSDKType;
            isAmino(o: any): o is _305.RequestInitChainAmino;
            encode(message: _305.RequestInitChain, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.RequestInitChain;
            fromJSON(object: any): _305.RequestInitChain;
            toJSON(message: _305.RequestInitChain): import("..").JsonSafe<_305.RequestInitChain>;
            fromPartial(object: import("../helpers").DeepPartial<_305.RequestInitChain>): _305.RequestInitChain;
            fromSDK(object: _305.RequestInitChainSDKType): _305.RequestInitChain;
            fromSDKJSON(object: any): _305.RequestInitChainSDKType;
            toSDK(message: _305.RequestInitChain): _305.RequestInitChainSDKType;
            fromAmino(object: _305.RequestInitChainAmino): _305.RequestInitChain;
            toAmino(message: _305.RequestInitChain): _305.RequestInitChainAmino;
            fromAminoMsg(object: _305.RequestInitChainAminoMsg): _305.RequestInitChain;
            fromProtoMsg(message: _305.RequestInitChainProtoMsg): _305.RequestInitChain;
            toProto(message: _305.RequestInitChain): Uint8Array;
            toProtoMsg(message: _305.RequestInitChain): _305.RequestInitChainProtoMsg;
            registerTypeUrl(): void;
        };
        RequestQuery: {
            typeUrl: string;
            is(o: any): o is _305.RequestQuery;
            isSDK(o: any): o is _305.RequestQuerySDKType;
            isAmino(o: any): o is _305.RequestQueryAmino;
            encode(message: _305.RequestQuery, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.RequestQuery;
            fromJSON(object: any): _305.RequestQuery;
            toJSON(message: _305.RequestQuery): import("..").JsonSafe<_305.RequestQuery>;
            fromPartial(object: import("../helpers").DeepPartial<_305.RequestQuery>): _305.RequestQuery;
            fromSDK(object: _305.RequestQuerySDKType): _305.RequestQuery;
            fromSDKJSON(object: any): _305.RequestQuerySDKType;
            toSDK(message: _305.RequestQuery): _305.RequestQuerySDKType;
            fromAmino(object: _305.RequestQueryAmino): _305.RequestQuery;
            toAmino(message: _305.RequestQuery): _305.RequestQueryAmino;
            fromAminoMsg(object: _305.RequestQueryAminoMsg): _305.RequestQuery;
            fromProtoMsg(message: _305.RequestQueryProtoMsg): _305.RequestQuery;
            toProto(message: _305.RequestQuery): Uint8Array;
            toProtoMsg(message: _305.RequestQuery): _305.RequestQueryProtoMsg;
            registerTypeUrl(): void;
        };
        RequestBeginBlock: {
            typeUrl: string;
            is(o: any): o is _305.RequestBeginBlock;
            isSDK(o: any): o is _305.RequestBeginBlockSDKType;
            isAmino(o: any): o is _305.RequestBeginBlockAmino;
            encode(message: _305.RequestBeginBlock, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.RequestBeginBlock;
            fromJSON(object: any): _305.RequestBeginBlock;
            toJSON(message: _305.RequestBeginBlock): import("..").JsonSafe<_305.RequestBeginBlock>;
            fromPartial(object: import("../helpers").DeepPartial<_305.RequestBeginBlock>): _305.RequestBeginBlock;
            fromSDK(object: _305.RequestBeginBlockSDKType): _305.RequestBeginBlock;
            fromSDKJSON(object: any): _305.RequestBeginBlockSDKType;
            toSDK(message: _305.RequestBeginBlock): _305.RequestBeginBlockSDKType;
            fromAmino(object: _305.RequestBeginBlockAmino): _305.RequestBeginBlock;
            toAmino(message: _305.RequestBeginBlock): _305.RequestBeginBlockAmino;
            fromAminoMsg(object: _305.RequestBeginBlockAminoMsg): _305.RequestBeginBlock;
            fromProtoMsg(message: _305.RequestBeginBlockProtoMsg): _305.RequestBeginBlock;
            toProto(message: _305.RequestBeginBlock): Uint8Array;
            toProtoMsg(message: _305.RequestBeginBlock): _305.RequestBeginBlockProtoMsg;
            registerTypeUrl(): void;
        };
        RequestCheckTx: {
            typeUrl: string;
            is(o: any): o is _305.RequestCheckTx;
            isSDK(o: any): o is _305.RequestCheckTxSDKType;
            isAmino(o: any): o is _305.RequestCheckTxAmino;
            encode(message: _305.RequestCheckTx, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.RequestCheckTx;
            fromJSON(object: any): _305.RequestCheckTx;
            toJSON(message: _305.RequestCheckTx): import("..").JsonSafe<_305.RequestCheckTx>;
            fromPartial(object: import("../helpers").DeepPartial<_305.RequestCheckTx>): _305.RequestCheckTx;
            fromSDK(object: _305.RequestCheckTxSDKType): _305.RequestCheckTx;
            fromSDKJSON(object: any): _305.RequestCheckTxSDKType;
            toSDK(message: _305.RequestCheckTx): _305.RequestCheckTxSDKType;
            fromAmino(object: _305.RequestCheckTxAmino): _305.RequestCheckTx;
            toAmino(message: _305.RequestCheckTx): _305.RequestCheckTxAmino;
            fromAminoMsg(object: _305.RequestCheckTxAminoMsg): _305.RequestCheckTx;
            fromProtoMsg(message: _305.RequestCheckTxProtoMsg): _305.RequestCheckTx;
            toProto(message: _305.RequestCheckTx): Uint8Array;
            toProtoMsg(message: _305.RequestCheckTx): _305.RequestCheckTxProtoMsg;
            registerTypeUrl(): void;
        };
        RequestDeliverTx: {
            typeUrl: string;
            is(o: any): o is _305.RequestDeliverTx;
            isSDK(o: any): o is _305.RequestDeliverTxSDKType;
            isAmino(o: any): o is _305.RequestDeliverTxAmino;
            encode(message: _305.RequestDeliverTx, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.RequestDeliverTx;
            fromJSON(object: any): _305.RequestDeliverTx;
            toJSON(message: _305.RequestDeliverTx): import("..").JsonSafe<_305.RequestDeliverTx>;
            fromPartial(object: import("../helpers").DeepPartial<_305.RequestDeliverTx>): _305.RequestDeliverTx;
            fromSDK(object: _305.RequestDeliverTxSDKType): _305.RequestDeliverTx;
            fromSDKJSON(object: any): _305.RequestDeliverTxSDKType;
            toSDK(message: _305.RequestDeliverTx): _305.RequestDeliverTxSDKType;
            fromAmino(object: _305.RequestDeliverTxAmino): _305.RequestDeliverTx;
            toAmino(message: _305.RequestDeliverTx): _305.RequestDeliverTxAmino;
            fromAminoMsg(object: _305.RequestDeliverTxAminoMsg): _305.RequestDeliverTx;
            fromProtoMsg(message: _305.RequestDeliverTxProtoMsg): _305.RequestDeliverTx;
            toProto(message: _305.RequestDeliverTx): Uint8Array;
            toProtoMsg(message: _305.RequestDeliverTx): _305.RequestDeliverTxProtoMsg;
            registerTypeUrl(): void;
        };
        RequestEndBlock: {
            typeUrl: string;
            is(o: any): o is _305.RequestEndBlock;
            isSDK(o: any): o is _305.RequestEndBlockSDKType;
            isAmino(o: any): o is _305.RequestEndBlockAmino;
            encode(message: _305.RequestEndBlock, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.RequestEndBlock;
            fromJSON(object: any): _305.RequestEndBlock;
            toJSON(message: _305.RequestEndBlock): import("..").JsonSafe<_305.RequestEndBlock>;
            fromPartial(object: import("../helpers").DeepPartial<_305.RequestEndBlock>): _305.RequestEndBlock;
            fromSDK(object: _305.RequestEndBlockSDKType): _305.RequestEndBlock;
            fromSDKJSON(object: any): _305.RequestEndBlockSDKType;
            toSDK(message: _305.RequestEndBlock): _305.RequestEndBlockSDKType;
            fromAmino(object: _305.RequestEndBlockAmino): _305.RequestEndBlock;
            toAmino(message: _305.RequestEndBlock): _305.RequestEndBlockAmino;
            fromAminoMsg(object: _305.RequestEndBlockAminoMsg): _305.RequestEndBlock;
            fromProtoMsg(message: _305.RequestEndBlockProtoMsg): _305.RequestEndBlock;
            toProto(message: _305.RequestEndBlock): Uint8Array;
            toProtoMsg(message: _305.RequestEndBlock): _305.RequestEndBlockProtoMsg;
            registerTypeUrl(): void;
        };
        RequestCommit: {
            typeUrl: string;
            is(o: any): o is _305.RequestCommit;
            isSDK(o: any): o is _305.RequestCommitSDKType;
            isAmino(o: any): o is _305.RequestCommitAmino;
            encode(_: _305.RequestCommit, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.RequestCommit;
            fromJSON(_: any): _305.RequestCommit;
            toJSON(_: _305.RequestCommit): import("..").JsonSafe<_305.RequestCommit>;
            fromPartial(_: import("../helpers").DeepPartial<_305.RequestCommit>): _305.RequestCommit;
            fromSDK(_: _305.RequestCommitSDKType): _305.RequestCommit;
            fromSDKJSON(_: any): _305.RequestCommitSDKType;
            toSDK(_: _305.RequestCommit): _305.RequestCommitSDKType;
            fromAmino(_: _305.RequestCommitAmino): _305.RequestCommit;
            toAmino(_: _305.RequestCommit): _305.RequestCommitAmino;
            fromAminoMsg(object: _305.RequestCommitAminoMsg): _305.RequestCommit;
            fromProtoMsg(message: _305.RequestCommitProtoMsg): _305.RequestCommit;
            toProto(message: _305.RequestCommit): Uint8Array;
            toProtoMsg(message: _305.RequestCommit): _305.RequestCommitProtoMsg;
            registerTypeUrl(): void;
        };
        RequestListSnapshots: {
            typeUrl: string;
            is(o: any): o is _305.RequestListSnapshots;
            isSDK(o: any): o is _305.RequestListSnapshotsSDKType;
            isAmino(o: any): o is _305.RequestListSnapshotsAmino;
            encode(_: _305.RequestListSnapshots, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.RequestListSnapshots;
            fromJSON(_: any): _305.RequestListSnapshots;
            toJSON(_: _305.RequestListSnapshots): import("..").JsonSafe<_305.RequestListSnapshots>;
            fromPartial(_: import("../helpers").DeepPartial<_305.RequestListSnapshots>): _305.RequestListSnapshots;
            fromSDK(_: _305.RequestListSnapshotsSDKType): _305.RequestListSnapshots;
            fromSDKJSON(_: any): _305.RequestListSnapshotsSDKType;
            toSDK(_: _305.RequestListSnapshots): _305.RequestListSnapshotsSDKType;
            fromAmino(_: _305.RequestListSnapshotsAmino): _305.RequestListSnapshots;
            toAmino(_: _305.RequestListSnapshots): _305.RequestListSnapshotsAmino;
            fromAminoMsg(object: _305.RequestListSnapshotsAminoMsg): _305.RequestListSnapshots;
            fromProtoMsg(message: _305.RequestListSnapshotsProtoMsg): _305.RequestListSnapshots;
            toProto(message: _305.RequestListSnapshots): Uint8Array;
            toProtoMsg(message: _305.RequestListSnapshots): _305.RequestListSnapshotsProtoMsg;
            registerTypeUrl(): void;
        };
        RequestOfferSnapshot: {
            typeUrl: string;
            is(o: any): o is _305.RequestOfferSnapshot;
            isSDK(o: any): o is _305.RequestOfferSnapshotSDKType;
            isAmino(o: any): o is _305.RequestOfferSnapshotAmino;
            encode(message: _305.RequestOfferSnapshot, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.RequestOfferSnapshot;
            fromJSON(object: any): _305.RequestOfferSnapshot;
            toJSON(message: _305.RequestOfferSnapshot): import("..").JsonSafe<_305.RequestOfferSnapshot>;
            fromPartial(object: import("../helpers").DeepPartial<_305.RequestOfferSnapshot>): _305.RequestOfferSnapshot;
            fromSDK(object: _305.RequestOfferSnapshotSDKType): _305.RequestOfferSnapshot;
            fromSDKJSON(object: any): _305.RequestOfferSnapshotSDKType;
            toSDK(message: _305.RequestOfferSnapshot): _305.RequestOfferSnapshotSDKType;
            fromAmino(object: _305.RequestOfferSnapshotAmino): _305.RequestOfferSnapshot;
            toAmino(message: _305.RequestOfferSnapshot): _305.RequestOfferSnapshotAmino;
            fromAminoMsg(object: _305.RequestOfferSnapshotAminoMsg): _305.RequestOfferSnapshot;
            fromProtoMsg(message: _305.RequestOfferSnapshotProtoMsg): _305.RequestOfferSnapshot;
            toProto(message: _305.RequestOfferSnapshot): Uint8Array;
            toProtoMsg(message: _305.RequestOfferSnapshot): _305.RequestOfferSnapshotProtoMsg;
            registerTypeUrl(): void;
        };
        RequestLoadSnapshotChunk: {
            typeUrl: string;
            is(o: any): o is _305.RequestLoadSnapshotChunk;
            isSDK(o: any): o is _305.RequestLoadSnapshotChunkSDKType;
            isAmino(o: any): o is _305.RequestLoadSnapshotChunkAmino;
            encode(message: _305.RequestLoadSnapshotChunk, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.RequestLoadSnapshotChunk;
            fromJSON(object: any): _305.RequestLoadSnapshotChunk;
            toJSON(message: _305.RequestLoadSnapshotChunk): import("..").JsonSafe<_305.RequestLoadSnapshotChunk>;
            fromPartial(object: import("../helpers").DeepPartial<_305.RequestLoadSnapshotChunk>): _305.RequestLoadSnapshotChunk;
            fromSDK(object: _305.RequestLoadSnapshotChunkSDKType): _305.RequestLoadSnapshotChunk;
            fromSDKJSON(object: any): _305.RequestLoadSnapshotChunkSDKType;
            toSDK(message: _305.RequestLoadSnapshotChunk): _305.RequestLoadSnapshotChunkSDKType;
            fromAmino(object: _305.RequestLoadSnapshotChunkAmino): _305.RequestLoadSnapshotChunk;
            toAmino(message: _305.RequestLoadSnapshotChunk): _305.RequestLoadSnapshotChunkAmino;
            fromAminoMsg(object: _305.RequestLoadSnapshotChunkAminoMsg): _305.RequestLoadSnapshotChunk;
            fromProtoMsg(message: _305.RequestLoadSnapshotChunkProtoMsg): _305.RequestLoadSnapshotChunk;
            toProto(message: _305.RequestLoadSnapshotChunk): Uint8Array;
            toProtoMsg(message: _305.RequestLoadSnapshotChunk): _305.RequestLoadSnapshotChunkProtoMsg;
            registerTypeUrl(): void;
        };
        RequestApplySnapshotChunk: {
            typeUrl: string;
            is(o: any): o is _305.RequestApplySnapshotChunk;
            isSDK(o: any): o is _305.RequestApplySnapshotChunkSDKType;
            isAmino(o: any): o is _305.RequestApplySnapshotChunkAmino;
            encode(message: _305.RequestApplySnapshotChunk, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.RequestApplySnapshotChunk;
            fromJSON(object: any): _305.RequestApplySnapshotChunk;
            toJSON(message: _305.RequestApplySnapshotChunk): import("..").JsonSafe<_305.RequestApplySnapshotChunk>;
            fromPartial(object: import("../helpers").DeepPartial<_305.RequestApplySnapshotChunk>): _305.RequestApplySnapshotChunk;
            fromSDK(object: _305.RequestApplySnapshotChunkSDKType): _305.RequestApplySnapshotChunk;
            fromSDKJSON(object: any): _305.RequestApplySnapshotChunkSDKType;
            toSDK(message: _305.RequestApplySnapshotChunk): _305.RequestApplySnapshotChunkSDKType;
            fromAmino(object: _305.RequestApplySnapshotChunkAmino): _305.RequestApplySnapshotChunk;
            toAmino(message: _305.RequestApplySnapshotChunk): _305.RequestApplySnapshotChunkAmino;
            fromAminoMsg(object: _305.RequestApplySnapshotChunkAminoMsg): _305.RequestApplySnapshotChunk;
            fromProtoMsg(message: _305.RequestApplySnapshotChunkProtoMsg): _305.RequestApplySnapshotChunk;
            toProto(message: _305.RequestApplySnapshotChunk): Uint8Array;
            toProtoMsg(message: _305.RequestApplySnapshotChunk): _305.RequestApplySnapshotChunkProtoMsg;
            registerTypeUrl(): void;
        };
        Response: {
            typeUrl: string;
            is(o: any): o is _305.Response;
            isSDK(o: any): o is _305.ResponseSDKType;
            isAmino(o: any): o is _305.ResponseAmino;
            encode(message: _305.Response, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.Response;
            fromJSON(object: any): _305.Response;
            toJSON(message: _305.Response): import("..").JsonSafe<_305.Response>;
            fromPartial(object: import("../helpers").DeepPartial<_305.Response>): _305.Response;
            fromSDK(object: _305.ResponseSDKType): _305.Response;
            fromSDKJSON(object: any): _305.ResponseSDKType;
            toSDK(message: _305.Response): _305.ResponseSDKType;
            fromAmino(object: _305.ResponseAmino): _305.Response;
            toAmino(message: _305.Response): _305.ResponseAmino;
            fromAminoMsg(object: _305.ResponseAminoMsg): _305.Response;
            fromProtoMsg(message: _305.ResponseProtoMsg): _305.Response;
            toProto(message: _305.Response): Uint8Array;
            toProtoMsg(message: _305.Response): _305.ResponseProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseException: {
            typeUrl: string;
            is(o: any): o is _305.ResponseException;
            isSDK(o: any): o is _305.ResponseExceptionSDKType;
            isAmino(o: any): o is _305.ResponseExceptionAmino;
            encode(message: _305.ResponseException, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseException;
            fromJSON(object: any): _305.ResponseException;
            toJSON(message: _305.ResponseException): import("..").JsonSafe<_305.ResponseException>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ResponseException>): _305.ResponseException;
            fromSDK(object: _305.ResponseExceptionSDKType): _305.ResponseException;
            fromSDKJSON(object: any): _305.ResponseExceptionSDKType;
            toSDK(message: _305.ResponseException): _305.ResponseExceptionSDKType;
            fromAmino(object: _305.ResponseExceptionAmino): _305.ResponseException;
            toAmino(message: _305.ResponseException): _305.ResponseExceptionAmino;
            fromAminoMsg(object: _305.ResponseExceptionAminoMsg): _305.ResponseException;
            fromProtoMsg(message: _305.ResponseExceptionProtoMsg): _305.ResponseException;
            toProto(message: _305.ResponseException): Uint8Array;
            toProtoMsg(message: _305.ResponseException): _305.ResponseExceptionProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseEcho: {
            typeUrl: string;
            is(o: any): o is _305.ResponseEcho;
            isSDK(o: any): o is _305.ResponseEchoSDKType;
            isAmino(o: any): o is _305.ResponseEchoAmino;
            encode(message: _305.ResponseEcho, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseEcho;
            fromJSON(object: any): _305.ResponseEcho;
            toJSON(message: _305.ResponseEcho): import("..").JsonSafe<_305.ResponseEcho>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ResponseEcho>): _305.ResponseEcho;
            fromSDK(object: _305.ResponseEchoSDKType): _305.ResponseEcho;
            fromSDKJSON(object: any): _305.ResponseEchoSDKType;
            toSDK(message: _305.ResponseEcho): _305.ResponseEchoSDKType;
            fromAmino(object: _305.ResponseEchoAmino): _305.ResponseEcho;
            toAmino(message: _305.ResponseEcho): _305.ResponseEchoAmino;
            fromAminoMsg(object: _305.ResponseEchoAminoMsg): _305.ResponseEcho;
            fromProtoMsg(message: _305.ResponseEchoProtoMsg): _305.ResponseEcho;
            toProto(message: _305.ResponseEcho): Uint8Array;
            toProtoMsg(message: _305.ResponseEcho): _305.ResponseEchoProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseFlush: {
            typeUrl: string;
            is(o: any): o is _305.ResponseFlush;
            isSDK(o: any): o is _305.ResponseFlushSDKType;
            isAmino(o: any): o is _305.ResponseFlushAmino;
            encode(_: _305.ResponseFlush, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseFlush;
            fromJSON(_: any): _305.ResponseFlush;
            toJSON(_: _305.ResponseFlush): import("..").JsonSafe<_305.ResponseFlush>;
            fromPartial(_: import("../helpers").DeepPartial<_305.ResponseFlush>): _305.ResponseFlush;
            fromSDK(_: _305.ResponseFlushSDKType): _305.ResponseFlush;
            fromSDKJSON(_: any): _305.ResponseFlushSDKType;
            toSDK(_: _305.ResponseFlush): _305.ResponseFlushSDKType;
            fromAmino(_: _305.ResponseFlushAmino): _305.ResponseFlush;
            toAmino(_: _305.ResponseFlush): _305.ResponseFlushAmino;
            fromAminoMsg(object: _305.ResponseFlushAminoMsg): _305.ResponseFlush;
            fromProtoMsg(message: _305.ResponseFlushProtoMsg): _305.ResponseFlush;
            toProto(message: _305.ResponseFlush): Uint8Array;
            toProtoMsg(message: _305.ResponseFlush): _305.ResponseFlushProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseInfo: {
            typeUrl: string;
            is(o: any): o is _305.ResponseInfo;
            isSDK(o: any): o is _305.ResponseInfoSDKType;
            isAmino(o: any): o is _305.ResponseInfoAmino;
            encode(message: _305.ResponseInfo, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseInfo;
            fromJSON(object: any): _305.ResponseInfo;
            toJSON(message: _305.ResponseInfo): import("..").JsonSafe<_305.ResponseInfo>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ResponseInfo>): _305.ResponseInfo;
            fromSDK(object: _305.ResponseInfoSDKType): _305.ResponseInfo;
            fromSDKJSON(object: any): _305.ResponseInfoSDKType;
            toSDK(message: _305.ResponseInfo): _305.ResponseInfoSDKType;
            fromAmino(object: _305.ResponseInfoAmino): _305.ResponseInfo;
            toAmino(message: _305.ResponseInfo): _305.ResponseInfoAmino;
            fromAminoMsg(object: _305.ResponseInfoAminoMsg): _305.ResponseInfo;
            fromProtoMsg(message: _305.ResponseInfoProtoMsg): _305.ResponseInfo;
            toProto(message: _305.ResponseInfo): Uint8Array;
            toProtoMsg(message: _305.ResponseInfo): _305.ResponseInfoProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseSetOption: {
            typeUrl: string;
            is(o: any): o is _305.ResponseSetOption;
            isSDK(o: any): o is _305.ResponseSetOptionSDKType;
            isAmino(o: any): o is _305.ResponseSetOptionAmino;
            encode(message: _305.ResponseSetOption, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseSetOption;
            fromJSON(object: any): _305.ResponseSetOption;
            toJSON(message: _305.ResponseSetOption): import("..").JsonSafe<_305.ResponseSetOption>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ResponseSetOption>): _305.ResponseSetOption;
            fromSDK(object: _305.ResponseSetOptionSDKType): _305.ResponseSetOption;
            fromSDKJSON(object: any): _305.ResponseSetOptionSDKType;
            toSDK(message: _305.ResponseSetOption): _305.ResponseSetOptionSDKType;
            fromAmino(object: _305.ResponseSetOptionAmino): _305.ResponseSetOption;
            toAmino(message: _305.ResponseSetOption): _305.ResponseSetOptionAmino;
            fromAminoMsg(object: _305.ResponseSetOptionAminoMsg): _305.ResponseSetOption;
            fromProtoMsg(message: _305.ResponseSetOptionProtoMsg): _305.ResponseSetOption;
            toProto(message: _305.ResponseSetOption): Uint8Array;
            toProtoMsg(message: _305.ResponseSetOption): _305.ResponseSetOptionProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseInitChain: {
            typeUrl: string;
            is(o: any): o is _305.ResponseInitChain;
            isSDK(o: any): o is _305.ResponseInitChainSDKType;
            isAmino(o: any): o is _305.ResponseInitChainAmino;
            encode(message: _305.ResponseInitChain, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseInitChain;
            fromJSON(object: any): _305.ResponseInitChain;
            toJSON(message: _305.ResponseInitChain): import("..").JsonSafe<_305.ResponseInitChain>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ResponseInitChain>): _305.ResponseInitChain;
            fromSDK(object: _305.ResponseInitChainSDKType): _305.ResponseInitChain;
            fromSDKJSON(object: any): _305.ResponseInitChainSDKType;
            toSDK(message: _305.ResponseInitChain): _305.ResponseInitChainSDKType;
            fromAmino(object: _305.ResponseInitChainAmino): _305.ResponseInitChain;
            toAmino(message: _305.ResponseInitChain): _305.ResponseInitChainAmino;
            fromAminoMsg(object: _305.ResponseInitChainAminoMsg): _305.ResponseInitChain;
            fromProtoMsg(message: _305.ResponseInitChainProtoMsg): _305.ResponseInitChain;
            toProto(message: _305.ResponseInitChain): Uint8Array;
            toProtoMsg(message: _305.ResponseInitChain): _305.ResponseInitChainProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseQuery: {
            typeUrl: string;
            is(o: any): o is _305.ResponseQuery;
            isSDK(o: any): o is _305.ResponseQuerySDKType;
            isAmino(o: any): o is _305.ResponseQueryAmino;
            encode(message: _305.ResponseQuery, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseQuery;
            fromJSON(object: any): _305.ResponseQuery;
            toJSON(message: _305.ResponseQuery): import("..").JsonSafe<_305.ResponseQuery>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ResponseQuery>): _305.ResponseQuery;
            fromSDK(object: _305.ResponseQuerySDKType): _305.ResponseQuery;
            fromSDKJSON(object: any): _305.ResponseQuerySDKType;
            toSDK(message: _305.ResponseQuery): _305.ResponseQuerySDKType;
            fromAmino(object: _305.ResponseQueryAmino): _305.ResponseQuery;
            toAmino(message: _305.ResponseQuery): _305.ResponseQueryAmino;
            fromAminoMsg(object: _305.ResponseQueryAminoMsg): _305.ResponseQuery;
            fromProtoMsg(message: _305.ResponseQueryProtoMsg): _305.ResponseQuery;
            toProto(message: _305.ResponseQuery): Uint8Array;
            toProtoMsg(message: _305.ResponseQuery): _305.ResponseQueryProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseBeginBlock: {
            typeUrl: string;
            is(o: any): o is _305.ResponseBeginBlock;
            isSDK(o: any): o is _305.ResponseBeginBlockSDKType;
            isAmino(o: any): o is _305.ResponseBeginBlockAmino;
            encode(message: _305.ResponseBeginBlock, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseBeginBlock;
            fromJSON(object: any): _305.ResponseBeginBlock;
            toJSON(message: _305.ResponseBeginBlock): import("..").JsonSafe<_305.ResponseBeginBlock>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ResponseBeginBlock>): _305.ResponseBeginBlock;
            fromSDK(object: _305.ResponseBeginBlockSDKType): _305.ResponseBeginBlock;
            fromSDKJSON(object: any): _305.ResponseBeginBlockSDKType;
            toSDK(message: _305.ResponseBeginBlock): _305.ResponseBeginBlockSDKType;
            fromAmino(object: _305.ResponseBeginBlockAmino): _305.ResponseBeginBlock;
            toAmino(message: _305.ResponseBeginBlock): _305.ResponseBeginBlockAmino;
            fromAminoMsg(object: _305.ResponseBeginBlockAminoMsg): _305.ResponseBeginBlock;
            fromProtoMsg(message: _305.ResponseBeginBlockProtoMsg): _305.ResponseBeginBlock;
            toProto(message: _305.ResponseBeginBlock): Uint8Array;
            toProtoMsg(message: _305.ResponseBeginBlock): _305.ResponseBeginBlockProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseCheckTx: {
            typeUrl: string;
            is(o: any): o is _305.ResponseCheckTx;
            isSDK(o: any): o is _305.ResponseCheckTxSDKType;
            isAmino(o: any): o is _305.ResponseCheckTxAmino;
            encode(message: _305.ResponseCheckTx, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseCheckTx;
            fromJSON(object: any): _305.ResponseCheckTx;
            toJSON(message: _305.ResponseCheckTx): import("..").JsonSafe<_305.ResponseCheckTx>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ResponseCheckTx>): _305.ResponseCheckTx;
            fromSDK(object: _305.ResponseCheckTxSDKType): _305.ResponseCheckTx;
            fromSDKJSON(object: any): _305.ResponseCheckTxSDKType;
            toSDK(message: _305.ResponseCheckTx): _305.ResponseCheckTxSDKType;
            fromAmino(object: _305.ResponseCheckTxAmino): _305.ResponseCheckTx;
            toAmino(message: _305.ResponseCheckTx): _305.ResponseCheckTxAmino;
            fromAminoMsg(object: _305.ResponseCheckTxAminoMsg): _305.ResponseCheckTx;
            fromProtoMsg(message: _305.ResponseCheckTxProtoMsg): _305.ResponseCheckTx;
            toProto(message: _305.ResponseCheckTx): Uint8Array;
            toProtoMsg(message: _305.ResponseCheckTx): _305.ResponseCheckTxProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseDeliverTx: {
            typeUrl: string;
            is(o: any): o is _305.ResponseDeliverTx;
            isSDK(o: any): o is _305.ResponseDeliverTxSDKType;
            isAmino(o: any): o is _305.ResponseDeliverTxAmino;
            encode(message: _305.ResponseDeliverTx, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseDeliverTx;
            fromJSON(object: any): _305.ResponseDeliverTx;
            toJSON(message: _305.ResponseDeliverTx): import("..").JsonSafe<_305.ResponseDeliverTx>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ResponseDeliverTx>): _305.ResponseDeliverTx;
            fromSDK(object: _305.ResponseDeliverTxSDKType): _305.ResponseDeliverTx;
            fromSDKJSON(object: any): _305.ResponseDeliverTxSDKType;
            toSDK(message: _305.ResponseDeliverTx): _305.ResponseDeliverTxSDKType;
            fromAmino(object: _305.ResponseDeliverTxAmino): _305.ResponseDeliverTx;
            toAmino(message: _305.ResponseDeliverTx): _305.ResponseDeliverTxAmino;
            fromAminoMsg(object: _305.ResponseDeliverTxAminoMsg): _305.ResponseDeliverTx;
            fromProtoMsg(message: _305.ResponseDeliverTxProtoMsg): _305.ResponseDeliverTx;
            toProto(message: _305.ResponseDeliverTx): Uint8Array;
            toProtoMsg(message: _305.ResponseDeliverTx): _305.ResponseDeliverTxProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseEndBlock: {
            typeUrl: string;
            is(o: any): o is _305.ResponseEndBlock;
            isSDK(o: any): o is _305.ResponseEndBlockSDKType;
            isAmino(o: any): o is _305.ResponseEndBlockAmino;
            encode(message: _305.ResponseEndBlock, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseEndBlock;
            fromJSON(object: any): _305.ResponseEndBlock;
            toJSON(message: _305.ResponseEndBlock): import("..").JsonSafe<_305.ResponseEndBlock>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ResponseEndBlock>): _305.ResponseEndBlock;
            fromSDK(object: _305.ResponseEndBlockSDKType): _305.ResponseEndBlock;
            fromSDKJSON(object: any): _305.ResponseEndBlockSDKType;
            toSDK(message: _305.ResponseEndBlock): _305.ResponseEndBlockSDKType;
            fromAmino(object: _305.ResponseEndBlockAmino): _305.ResponseEndBlock;
            toAmino(message: _305.ResponseEndBlock): _305.ResponseEndBlockAmino;
            fromAminoMsg(object: _305.ResponseEndBlockAminoMsg): _305.ResponseEndBlock;
            fromProtoMsg(message: _305.ResponseEndBlockProtoMsg): _305.ResponseEndBlock;
            toProto(message: _305.ResponseEndBlock): Uint8Array;
            toProtoMsg(message: _305.ResponseEndBlock): _305.ResponseEndBlockProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseCommit: {
            typeUrl: string;
            is(o: any): o is _305.ResponseCommit;
            isSDK(o: any): o is _305.ResponseCommitSDKType;
            isAmino(o: any): o is _305.ResponseCommitAmino;
            encode(message: _305.ResponseCommit, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseCommit;
            fromJSON(object: any): _305.ResponseCommit;
            toJSON(message: _305.ResponseCommit): import("..").JsonSafe<_305.ResponseCommit>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ResponseCommit>): _305.ResponseCommit;
            fromSDK(object: _305.ResponseCommitSDKType): _305.ResponseCommit;
            fromSDKJSON(object: any): _305.ResponseCommitSDKType;
            toSDK(message: _305.ResponseCommit): _305.ResponseCommitSDKType;
            fromAmino(object: _305.ResponseCommitAmino): _305.ResponseCommit;
            toAmino(message: _305.ResponseCommit): _305.ResponseCommitAmino;
            fromAminoMsg(object: _305.ResponseCommitAminoMsg): _305.ResponseCommit;
            fromProtoMsg(message: _305.ResponseCommitProtoMsg): _305.ResponseCommit;
            toProto(message: _305.ResponseCommit): Uint8Array;
            toProtoMsg(message: _305.ResponseCommit): _305.ResponseCommitProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseListSnapshots: {
            typeUrl: string;
            is(o: any): o is _305.ResponseListSnapshots;
            isSDK(o: any): o is _305.ResponseListSnapshotsSDKType;
            isAmino(o: any): o is _305.ResponseListSnapshotsAmino;
            encode(message: _305.ResponseListSnapshots, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseListSnapshots;
            fromJSON(object: any): _305.ResponseListSnapshots;
            toJSON(message: _305.ResponseListSnapshots): import("..").JsonSafe<_305.ResponseListSnapshots>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ResponseListSnapshots>): _305.ResponseListSnapshots;
            fromSDK(object: _305.ResponseListSnapshotsSDKType): _305.ResponseListSnapshots;
            fromSDKJSON(object: any): _305.ResponseListSnapshotsSDKType;
            toSDK(message: _305.ResponseListSnapshots): _305.ResponseListSnapshotsSDKType;
            fromAmino(object: _305.ResponseListSnapshotsAmino): _305.ResponseListSnapshots;
            toAmino(message: _305.ResponseListSnapshots): _305.ResponseListSnapshotsAmino;
            fromAminoMsg(object: _305.ResponseListSnapshotsAminoMsg): _305.ResponseListSnapshots;
            fromProtoMsg(message: _305.ResponseListSnapshotsProtoMsg): _305.ResponseListSnapshots;
            toProto(message: _305.ResponseListSnapshots): Uint8Array;
            toProtoMsg(message: _305.ResponseListSnapshots): _305.ResponseListSnapshotsProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseOfferSnapshot: {
            typeUrl: string;
            is(o: any): o is _305.ResponseOfferSnapshot;
            isSDK(o: any): o is _305.ResponseOfferSnapshotSDKType;
            isAmino(o: any): o is _305.ResponseOfferSnapshotAmino;
            encode(message: _305.ResponseOfferSnapshot, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseOfferSnapshot;
            fromJSON(object: any): _305.ResponseOfferSnapshot;
            toJSON(message: _305.ResponseOfferSnapshot): import("..").JsonSafe<_305.ResponseOfferSnapshot>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ResponseOfferSnapshot>): _305.ResponseOfferSnapshot;
            fromSDK(object: _305.ResponseOfferSnapshotSDKType): _305.ResponseOfferSnapshot;
            fromSDKJSON(object: any): _305.ResponseOfferSnapshotSDKType;
            toSDK(message: _305.ResponseOfferSnapshot): _305.ResponseOfferSnapshotSDKType;
            fromAmino(object: _305.ResponseOfferSnapshotAmino): _305.ResponseOfferSnapshot;
            toAmino(message: _305.ResponseOfferSnapshot): _305.ResponseOfferSnapshotAmino;
            fromAminoMsg(object: _305.ResponseOfferSnapshotAminoMsg): _305.ResponseOfferSnapshot;
            fromProtoMsg(message: _305.ResponseOfferSnapshotProtoMsg): _305.ResponseOfferSnapshot;
            toProto(message: _305.ResponseOfferSnapshot): Uint8Array;
            toProtoMsg(message: _305.ResponseOfferSnapshot): _305.ResponseOfferSnapshotProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseLoadSnapshotChunk: {
            typeUrl: string;
            is(o: any): o is _305.ResponseLoadSnapshotChunk;
            isSDK(o: any): o is _305.ResponseLoadSnapshotChunkSDKType;
            isAmino(o: any): o is _305.ResponseLoadSnapshotChunkAmino;
            encode(message: _305.ResponseLoadSnapshotChunk, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseLoadSnapshotChunk;
            fromJSON(object: any): _305.ResponseLoadSnapshotChunk;
            toJSON(message: _305.ResponseLoadSnapshotChunk): import("..").JsonSafe<_305.ResponseLoadSnapshotChunk>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ResponseLoadSnapshotChunk>): _305.ResponseLoadSnapshotChunk;
            fromSDK(object: _305.ResponseLoadSnapshotChunkSDKType): _305.ResponseLoadSnapshotChunk;
            fromSDKJSON(object: any): _305.ResponseLoadSnapshotChunkSDKType;
            toSDK(message: _305.ResponseLoadSnapshotChunk): _305.ResponseLoadSnapshotChunkSDKType;
            fromAmino(object: _305.ResponseLoadSnapshotChunkAmino): _305.ResponseLoadSnapshotChunk;
            toAmino(message: _305.ResponseLoadSnapshotChunk): _305.ResponseLoadSnapshotChunkAmino;
            fromAminoMsg(object: _305.ResponseLoadSnapshotChunkAminoMsg): _305.ResponseLoadSnapshotChunk;
            fromProtoMsg(message: _305.ResponseLoadSnapshotChunkProtoMsg): _305.ResponseLoadSnapshotChunk;
            toProto(message: _305.ResponseLoadSnapshotChunk): Uint8Array;
            toProtoMsg(message: _305.ResponseLoadSnapshotChunk): _305.ResponseLoadSnapshotChunkProtoMsg;
            registerTypeUrl(): void;
        };
        ResponseApplySnapshotChunk: {
            typeUrl: string;
            is(o: any): o is _305.ResponseApplySnapshotChunk;
            isSDK(o: any): o is _305.ResponseApplySnapshotChunkSDKType;
            isAmino(o: any): o is _305.ResponseApplySnapshotChunkAmino;
            encode(message: _305.ResponseApplySnapshotChunk, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ResponseApplySnapshotChunk;
            fromJSON(object: any): _305.ResponseApplySnapshotChunk;
            toJSON(message: _305.ResponseApplySnapshotChunk): import("..").JsonSafe<_305.ResponseApplySnapshotChunk>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ResponseApplySnapshotChunk>): _305.ResponseApplySnapshotChunk;
            fromSDK(object: _305.ResponseApplySnapshotChunkSDKType): _305.ResponseApplySnapshotChunk;
            fromSDKJSON(object: any): _305.ResponseApplySnapshotChunkSDKType;
            toSDK(message: _305.ResponseApplySnapshotChunk): _305.ResponseApplySnapshotChunkSDKType;
            fromAmino(object: _305.ResponseApplySnapshotChunkAmino): _305.ResponseApplySnapshotChunk;
            toAmino(message: _305.ResponseApplySnapshotChunk): _305.ResponseApplySnapshotChunkAmino;
            fromAminoMsg(object: _305.ResponseApplySnapshotChunkAminoMsg): _305.ResponseApplySnapshotChunk;
            fromProtoMsg(message: _305.ResponseApplySnapshotChunkProtoMsg): _305.ResponseApplySnapshotChunk;
            toProto(message: _305.ResponseApplySnapshotChunk): Uint8Array;
            toProtoMsg(message: _305.ResponseApplySnapshotChunk): _305.ResponseApplySnapshotChunkProtoMsg;
            registerTypeUrl(): void;
        };
        ConsensusParams: {
            typeUrl: string;
            is(o: any): o is _305.ConsensusParams;
            isSDK(o: any): o is _305.ConsensusParamsSDKType;
            isAmino(o: any): o is _305.ConsensusParamsAmino;
            encode(message: _305.ConsensusParams, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ConsensusParams;
            fromJSON(object: any): _305.ConsensusParams;
            toJSON(message: _305.ConsensusParams): import("..").JsonSafe<_305.ConsensusParams>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ConsensusParams>): _305.ConsensusParams;
            fromSDK(object: _305.ConsensusParamsSDKType): _305.ConsensusParams;
            fromSDKJSON(object: any): _305.ConsensusParamsSDKType;
            toSDK(message: _305.ConsensusParams): _305.ConsensusParamsSDKType;
            fromAmino(object: _305.ConsensusParamsAmino): _305.ConsensusParams;
            toAmino(message: _305.ConsensusParams): _305.ConsensusParamsAmino;
            fromAminoMsg(object: _305.ConsensusParamsAminoMsg): _305.ConsensusParams;
            fromProtoMsg(message: _305.ConsensusParamsProtoMsg): _305.ConsensusParams;
            toProto(message: _305.ConsensusParams): Uint8Array;
            toProtoMsg(message: _305.ConsensusParams): _305.ConsensusParamsProtoMsg;
            registerTypeUrl(): void;
        };
        BlockParams: {
            typeUrl: string;
            is(o: any): o is _305.BlockParams;
            isSDK(o: any): o is _305.BlockParamsSDKType;
            isAmino(o: any): o is _305.BlockParamsAmino;
            encode(message: _305.BlockParams, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.BlockParams;
            fromJSON(object: any): _305.BlockParams;
            toJSON(message: _305.BlockParams): import("..").JsonSafe<_305.BlockParams>;
            fromPartial(object: import("../helpers").DeepPartial<_305.BlockParams>): _305.BlockParams;
            fromSDK(object: _305.BlockParamsSDKType): _305.BlockParams;
            fromSDKJSON(object: any): _305.BlockParamsSDKType;
            toSDK(message: _305.BlockParams): _305.BlockParamsSDKType;
            fromAmino(object: _305.BlockParamsAmino): _305.BlockParams;
            toAmino(message: _305.BlockParams): _305.BlockParamsAmino;
            fromAminoMsg(object: _305.BlockParamsAminoMsg): _305.BlockParams;
            fromProtoMsg(message: _305.BlockParamsProtoMsg): _305.BlockParams;
            toProto(message: _305.BlockParams): Uint8Array;
            toProtoMsg(message: _305.BlockParams): _305.BlockParamsProtoMsg;
            registerTypeUrl(): void;
        };
        LastCommitInfo: {
            typeUrl: string;
            is(o: any): o is _305.LastCommitInfo;
            isSDK(o: any): o is _305.LastCommitInfoSDKType;
            isAmino(o: any): o is _305.LastCommitInfoAmino;
            encode(message: _305.LastCommitInfo, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.LastCommitInfo;
            fromJSON(object: any): _305.LastCommitInfo;
            toJSON(message: _305.LastCommitInfo): import("..").JsonSafe<_305.LastCommitInfo>;
            fromPartial(object: import("../helpers").DeepPartial<_305.LastCommitInfo>): _305.LastCommitInfo;
            fromSDK(object: _305.LastCommitInfoSDKType): _305.LastCommitInfo;
            fromSDKJSON(object: any): _305.LastCommitInfoSDKType;
            toSDK(message: _305.LastCommitInfo): _305.LastCommitInfoSDKType;
            fromAmino(object: _305.LastCommitInfoAmino): _305.LastCommitInfo;
            toAmino(message: _305.LastCommitInfo): _305.LastCommitInfoAmino;
            fromAminoMsg(object: _305.LastCommitInfoAminoMsg): _305.LastCommitInfo;
            fromProtoMsg(message: _305.LastCommitInfoProtoMsg): _305.LastCommitInfo;
            toProto(message: _305.LastCommitInfo): Uint8Array;
            toProtoMsg(message: _305.LastCommitInfo): _305.LastCommitInfoProtoMsg;
            registerTypeUrl(): void;
        };
        Event: {
            typeUrl: string;
            is(o: any): o is _305.Event;
            isSDK(o: any): o is _305.EventSDKType;
            isAmino(o: any): o is _305.EventAmino;
            encode(message: _305.Event, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.Event;
            fromJSON(object: any): _305.Event;
            toJSON(message: _305.Event): import("..").JsonSafe<_305.Event>;
            fromPartial(object: import("../helpers").DeepPartial<_305.Event>): _305.Event;
            fromSDK(object: _305.EventSDKType): _305.Event;
            fromSDKJSON(object: any): _305.EventSDKType;
            toSDK(message: _305.Event): _305.EventSDKType;
            fromAmino(object: _305.EventAmino): _305.Event;
            toAmino(message: _305.Event): _305.EventAmino;
            fromAminoMsg(object: _305.EventAminoMsg): _305.Event;
            fromProtoMsg(message: _305.EventProtoMsg): _305.Event;
            toProto(message: _305.Event): Uint8Array;
            toProtoMsg(message: _305.Event): _305.EventProtoMsg;
            registerTypeUrl(): void;
        };
        EventAttribute: {
            typeUrl: string;
            is(o: any): o is _305.EventAttribute;
            isSDK(o: any): o is _305.EventAttributeSDKType;
            isAmino(o: any): o is _305.EventAttributeAmino;
            encode(message: _305.EventAttribute, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.EventAttribute;
            fromJSON(object: any): _305.EventAttribute;
            toJSON(message: _305.EventAttribute): import("..").JsonSafe<_305.EventAttribute>;
            fromPartial(object: import("../helpers").DeepPartial<_305.EventAttribute>): _305.EventAttribute;
            fromSDK(object: _305.EventAttributeSDKType): _305.EventAttribute;
            fromSDKJSON(object: any): _305.EventAttributeSDKType;
            toSDK(message: _305.EventAttribute): _305.EventAttributeSDKType;
            fromAmino(object: _305.EventAttributeAmino): _305.EventAttribute;
            toAmino(message: _305.EventAttribute): _305.EventAttributeAmino;
            fromAminoMsg(object: _305.EventAttributeAminoMsg): _305.EventAttribute;
            fromProtoMsg(message: _305.EventAttributeProtoMsg): _305.EventAttribute;
            toProto(message: _305.EventAttribute): Uint8Array;
            toProtoMsg(message: _305.EventAttribute): _305.EventAttributeProtoMsg;
            registerTypeUrl(): void;
        };
        TxResult: {
            typeUrl: string;
            is(o: any): o is _305.TxResult;
            isSDK(o: any): o is _305.TxResultSDKType;
            isAmino(o: any): o is _305.TxResultAmino;
            encode(message: _305.TxResult, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.TxResult;
            fromJSON(object: any): _305.TxResult;
            toJSON(message: _305.TxResult): import("..").JsonSafe<_305.TxResult>;
            fromPartial(object: import("../helpers").DeepPartial<_305.TxResult>): _305.TxResult;
            fromSDK(object: _305.TxResultSDKType): _305.TxResult;
            fromSDKJSON(object: any): _305.TxResultSDKType;
            toSDK(message: _305.TxResult): _305.TxResultSDKType;
            fromAmino(object: _305.TxResultAmino): _305.TxResult;
            toAmino(message: _305.TxResult): _305.TxResultAmino;
            fromAminoMsg(object: _305.TxResultAminoMsg): _305.TxResult;
            fromProtoMsg(message: _305.TxResultProtoMsg): _305.TxResult;
            toProto(message: _305.TxResult): Uint8Array;
            toProtoMsg(message: _305.TxResult): _305.TxResultProtoMsg;
            registerTypeUrl(): void;
        };
        Validator: {
            typeUrl: string;
            is(o: any): o is _305.Validator;
            isSDK(o: any): o is _305.ValidatorSDKType;
            isAmino(o: any): o is _305.ValidatorAmino;
            encode(message: _305.Validator, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.Validator;
            fromJSON(object: any): _305.Validator;
            toJSON(message: _305.Validator): import("..").JsonSafe<_305.Validator>;
            fromPartial(object: import("../helpers").DeepPartial<_305.Validator>): _305.Validator;
            fromSDK(object: _305.ValidatorSDKType): _305.Validator;
            fromSDKJSON(object: any): _305.ValidatorSDKType;
            toSDK(message: _305.Validator): _305.ValidatorSDKType;
            fromAmino(object: _305.ValidatorAmino): _305.Validator;
            toAmino(message: _305.Validator): _305.ValidatorAmino;
            fromAminoMsg(object: _305.ValidatorAminoMsg): _305.Validator;
            fromProtoMsg(message: _305.ValidatorProtoMsg): _305.Validator;
            toProto(message: _305.Validator): Uint8Array;
            toProtoMsg(message: _305.Validator): _305.ValidatorProtoMsg;
            registerTypeUrl(): void;
        };
        ValidatorUpdate: {
            typeUrl: string;
            is(o: any): o is _305.ValidatorUpdate;
            isSDK(o: any): o is _305.ValidatorUpdateSDKType;
            isAmino(o: any): o is _305.ValidatorUpdateAmino;
            encode(message: _305.ValidatorUpdate, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.ValidatorUpdate;
            fromJSON(object: any): _305.ValidatorUpdate;
            toJSON(message: _305.ValidatorUpdate): import("..").JsonSafe<_305.ValidatorUpdate>;
            fromPartial(object: import("../helpers").DeepPartial<_305.ValidatorUpdate>): _305.ValidatorUpdate;
            fromSDK(object: _305.ValidatorUpdateSDKType): _305.ValidatorUpdate;
            fromSDKJSON(object: any): _305.ValidatorUpdateSDKType;
            toSDK(message: _305.ValidatorUpdate): _305.ValidatorUpdateSDKType;
            fromAmino(object: _305.ValidatorUpdateAmino): _305.ValidatorUpdate;
            toAmino(message: _305.ValidatorUpdate): _305.ValidatorUpdateAmino;
            fromAminoMsg(object: _305.ValidatorUpdateAminoMsg): _305.ValidatorUpdate;
            fromProtoMsg(message: _305.ValidatorUpdateProtoMsg): _305.ValidatorUpdate;
            toProto(message: _305.ValidatorUpdate): Uint8Array;
            toProtoMsg(message: _305.ValidatorUpdate): _305.ValidatorUpdateProtoMsg;
            registerTypeUrl(): void;
        };
        VoteInfo: {
            typeUrl: string;
            is(o: any): o is _305.VoteInfo;
            isSDK(o: any): o is _305.VoteInfoSDKType;
            isAmino(o: any): o is _305.VoteInfoAmino;
            encode(message: _305.VoteInfo, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.VoteInfo;
            fromJSON(object: any): _305.VoteInfo;
            toJSON(message: _305.VoteInfo): import("..").JsonSafe<_305.VoteInfo>;
            fromPartial(object: import("../helpers").DeepPartial<_305.VoteInfo>): _305.VoteInfo;
            fromSDK(object: _305.VoteInfoSDKType): _305.VoteInfo;
            fromSDKJSON(object: any): _305.VoteInfoSDKType;
            toSDK(message: _305.VoteInfo): _305.VoteInfoSDKType;
            fromAmino(object: _305.VoteInfoAmino): _305.VoteInfo;
            toAmino(message: _305.VoteInfo): _305.VoteInfoAmino;
            fromAminoMsg(object: _305.VoteInfoAminoMsg): _305.VoteInfo;
            fromProtoMsg(message: _305.VoteInfoProtoMsg): _305.VoteInfo;
            toProto(message: _305.VoteInfo): Uint8Array;
            toProtoMsg(message: _305.VoteInfo): _305.VoteInfoProtoMsg;
            registerTypeUrl(): void;
        };
        Evidence: {
            typeUrl: string;
            is(o: any): o is _305.Evidence;
            isSDK(o: any): o is _305.EvidenceSDKType;
            isAmino(o: any): o is _305.EvidenceAmino;
            encode(message: _305.Evidence, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.Evidence;
            fromJSON(object: any): _305.Evidence;
            toJSON(message: _305.Evidence): import("..").JsonSafe<_305.Evidence>;
            fromPartial(object: import("../helpers").DeepPartial<_305.Evidence>): _305.Evidence;
            fromSDK(object: _305.EvidenceSDKType): _305.Evidence;
            fromSDKJSON(object: any): _305.EvidenceSDKType;
            toSDK(message: _305.Evidence): _305.EvidenceSDKType;
            fromAmino(object: _305.EvidenceAmino): _305.Evidence;
            toAmino(message: _305.Evidence): _305.EvidenceAmino;
            fromAminoMsg(object: _305.EvidenceAminoMsg): _305.Evidence;
            fromProtoMsg(message: _305.EvidenceProtoMsg): _305.Evidence;
            toProto(message: _305.Evidence): Uint8Array;
            toProtoMsg(message: _305.Evidence): _305.EvidenceProtoMsg;
            registerTypeUrl(): void;
        };
        Snapshot: {
            typeUrl: string;
            is(o: any): o is _305.Snapshot;
            isSDK(o: any): o is _305.SnapshotSDKType;
            isAmino(o: any): o is _305.SnapshotAmino;
            encode(message: _305.Snapshot, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _305.Snapshot;
            fromJSON(object: any): _305.Snapshot;
            toJSON(message: _305.Snapshot): import("..").JsonSafe<_305.Snapshot>;
            fromPartial(object: import("../helpers").DeepPartial<_305.Snapshot>): _305.Snapshot;
            fromSDK(object: _305.SnapshotSDKType): _305.Snapshot;
            fromSDKJSON(object: any): _305.SnapshotSDKType;
            toSDK(message: _305.Snapshot): _305.SnapshotSDKType;
            fromAmino(object: _305.SnapshotAmino): _305.Snapshot;
            toAmino(message: _305.Snapshot): _305.SnapshotAmino;
            fromAminoMsg(object: _305.SnapshotAminoMsg): _305.Snapshot;
            fromProtoMsg(message: _305.SnapshotProtoMsg): _305.Snapshot;
            toProto(message: _305.Snapshot): Uint8Array;
            toProtoMsg(message: _305.Snapshot): _305.SnapshotProtoMsg;
            registerTypeUrl(): void;
        };
    };
    const crypto: {
        protobufPackage: "tendermint.crypto";
        Proof: {
            typeUrl: string;
            is(o: any): o is _307.Proof;
            isSDK(o: any): o is _307.ProofSDKType;
            isAmino(o: any): o is _307.ProofAmino;
            encode(message: _307.Proof, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _307.Proof;
            fromJSON(object: any): _307.Proof;
            toJSON(message: _307.Proof): import("..").JsonSafe<_307.Proof>;
            fromPartial(object: import("../helpers").DeepPartial<_307.Proof>): _307.Proof;
            fromSDK(object: _307.ProofSDKType): _307.Proof;
            fromSDKJSON(object: any): _307.ProofSDKType;
            toSDK(message: _307.Proof): _307.ProofSDKType;
            fromAmino(object: _307.ProofAmino): _307.Proof;
            toAmino(message: _307.Proof): _307.ProofAmino;
            fromAminoMsg(object: _307.ProofAminoMsg): _307.Proof;
            fromProtoMsg(message: _307.ProofProtoMsg): _307.Proof;
            toProto(message: _307.Proof): Uint8Array;
            toProtoMsg(message: _307.Proof): _307.ProofProtoMsg;
            registerTypeUrl(): void;
        };
        ValueOp: {
            typeUrl: string;
            is(o: any): o is _307.ValueOp;
            isSDK(o: any): o is _307.ValueOpSDKType;
            isAmino(o: any): o is _307.ValueOpAmino;
            encode(message: _307.ValueOp, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _307.ValueOp;
            fromJSON(object: any): _307.ValueOp;
            toJSON(message: _307.ValueOp): import("..").JsonSafe<_307.ValueOp>;
            fromPartial(object: import("../helpers").DeepPartial<_307.ValueOp>): _307.ValueOp;
            fromSDK(object: _307.ValueOpSDKType): _307.ValueOp;
            fromSDKJSON(object: any): _307.ValueOpSDKType;
            toSDK(message: _307.ValueOp): _307.ValueOpSDKType;
            fromAmino(object: _307.ValueOpAmino): _307.ValueOp;
            toAmino(message: _307.ValueOp): _307.ValueOpAmino;
            fromAminoMsg(object: _307.ValueOpAminoMsg): _307.ValueOp;
            fromProtoMsg(message: _307.ValueOpProtoMsg): _307.ValueOp;
            toProto(message: _307.ValueOp): Uint8Array;
            toProtoMsg(message: _307.ValueOp): _307.ValueOpProtoMsg;
            registerTypeUrl(): void;
        };
        DominoOp: {
            typeUrl: string;
            is(o: any): o is _307.DominoOp;
            isSDK(o: any): o is _307.DominoOpSDKType;
            isAmino(o: any): o is _307.DominoOpAmino;
            encode(message: _307.DominoOp, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _307.DominoOp;
            fromJSON(object: any): _307.DominoOp;
            toJSON(message: _307.DominoOp): import("..").JsonSafe<_307.DominoOp>;
            fromPartial(object: import("../helpers").DeepPartial<_307.DominoOp>): _307.DominoOp;
            fromSDK(object: _307.DominoOpSDKType): _307.DominoOp;
            fromSDKJSON(object: any): _307.DominoOpSDKType;
            toSDK(message: _307.DominoOp): _307.DominoOpSDKType;
            fromAmino(object: _307.DominoOpAmino): _307.DominoOp;
            toAmino(message: _307.DominoOp): _307.DominoOpAmino;
            fromAminoMsg(object: _307.DominoOpAminoMsg): _307.DominoOp;
            fromProtoMsg(message: _307.DominoOpProtoMsg): _307.DominoOp;
            toProto(message: _307.DominoOp): Uint8Array;
            toProtoMsg(message: _307.DominoOp): _307.DominoOpProtoMsg;
            registerTypeUrl(): void;
        };
        ProofOp: {
            typeUrl: string;
            is(o: any): o is _307.ProofOp;
            isSDK(o: any): o is _307.ProofOpSDKType;
            isAmino(o: any): o is _307.ProofOpAmino;
            encode(message: _307.ProofOp, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _307.ProofOp;
            fromJSON(object: any): _307.ProofOp;
            toJSON(message: _307.ProofOp): import("..").JsonSafe<_307.ProofOp>;
            fromPartial(object: import("../helpers").DeepPartial<_307.ProofOp>): _307.ProofOp;
            fromSDK(object: _307.ProofOpSDKType): _307.ProofOp;
            fromSDKJSON(object: any): _307.ProofOpSDKType;
            toSDK(message: _307.ProofOp): _307.ProofOpSDKType;
            fromAmino(object: _307.ProofOpAmino): _307.ProofOp;
            toAmino(message: _307.ProofOp): _307.ProofOpAmino;
            fromAminoMsg(object: _307.ProofOpAminoMsg): _307.ProofOp;
            fromProtoMsg(message: _307.ProofOpProtoMsg): _307.ProofOp;
            toProto(message: _307.ProofOp): Uint8Array;
            toProtoMsg(message: _307.ProofOp): _307.ProofOpProtoMsg;
            registerTypeUrl(): void;
        };
        ProofOps: {
            typeUrl: string;
            is(o: any): o is _307.ProofOps;
            isSDK(o: any): o is _307.ProofOpsSDKType;
            isAmino(o: any): o is _307.ProofOpsAmino;
            encode(message: _307.ProofOps, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _307.ProofOps;
            fromJSON(object: any): _307.ProofOps;
            toJSON(message: _307.ProofOps): import("..").JsonSafe<_307.ProofOps>;
            fromPartial(object: import("../helpers").DeepPartial<_307.ProofOps>): _307.ProofOps;
            fromSDK(object: _307.ProofOpsSDKType): _307.ProofOps;
            fromSDKJSON(object: any): _307.ProofOpsSDKType;
            toSDK(message: _307.ProofOps): _307.ProofOpsSDKType;
            fromAmino(object: _307.ProofOpsAmino): _307.ProofOps;
            toAmino(message: _307.ProofOps): _307.ProofOpsAmino;
            fromAminoMsg(object: _307.ProofOpsAminoMsg): _307.ProofOps;
            fromProtoMsg(message: _307.ProofOpsProtoMsg): _307.ProofOps;
            toProto(message: _307.ProofOps): Uint8Array;
            toProtoMsg(message: _307.ProofOps): _307.ProofOpsProtoMsg;
            registerTypeUrl(): void;
        };
        PublicKey: {
            typeUrl: string;
            is(o: any): o is _306.PublicKey;
            isSDK(o: any): o is _306.PublicKeySDKType;
            isAmino(o: any): o is _306.PublicKeyAmino;
            encode(message: _306.PublicKey, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _306.PublicKey;
            fromJSON(object: any): _306.PublicKey;
            toJSON(message: _306.PublicKey): import("..").JsonSafe<_306.PublicKey>;
            fromPartial(object: import("../helpers").DeepPartial<_306.PublicKey>): _306.PublicKey;
            fromSDK(object: _306.PublicKeySDKType): _306.PublicKey;
            fromSDKJSON(object: any): _306.PublicKeySDKType;
            toSDK(message: _306.PublicKey): _306.PublicKeySDKType;
            fromAmino(object: _306.PublicKeyAmino): _306.PublicKey;
            toAmino(message: _306.PublicKey): _306.PublicKeyAmino;
            fromAminoMsg(object: _306.PublicKeyAminoMsg): _306.PublicKey;
            fromProtoMsg(message: _306.PublicKeyProtoMsg): _306.PublicKey;
            toProto(message: _306.PublicKey): Uint8Array;
            toProtoMsg(message: _306.PublicKey): _306.PublicKeyProtoMsg;
            registerTypeUrl(): void;
        };
    };
    namespace libs {
        const bits: {
            protobufPackage: "tendermint.libs.bits";
            BitArray: {
                typeUrl: string;
                is(o: any): o is _308.BitArray;
                isSDK(o: any): o is _308.BitArraySDKType;
                isAmino(o: any): o is _308.BitArrayAmino;
                encode(message: _308.BitArray, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
                decode(input: import("..").BinaryReader | Uint8Array, length?: number): _308.BitArray;
                fromJSON(object: any): _308.BitArray;
                toJSON(message: _308.BitArray): import("..").JsonSafe<_308.BitArray>;
                fromPartial(object: import("../helpers").DeepPartial<_308.BitArray>): _308.BitArray;
                fromSDK(object: _308.BitArraySDKType): _308.BitArray;
                fromSDKJSON(object: any): _308.BitArraySDKType;
                toSDK(message: _308.BitArray): _308.BitArraySDKType;
                fromAmino(object: _308.BitArrayAmino): _308.BitArray;
                toAmino(message: _308.BitArray): _308.BitArrayAmino;
                fromAminoMsg(object: _308.BitArrayAminoMsg): _308.BitArray;
                fromProtoMsg(message: _308.BitArrayProtoMsg): _308.BitArray;
                toProto(message: _308.BitArray): Uint8Array;
                toProtoMsg(message: _308.BitArray): _308.BitArrayProtoMsg;
                registerTypeUrl(): void;
            };
        };
    }
    const p2p: {
        protobufPackage: "tendermint.p2p";
        ProtocolVersion: {
            typeUrl: string;
            is(o: any): o is _309.ProtocolVersion;
            isSDK(o: any): o is _309.ProtocolVersionSDKType;
            isAmino(o: any): o is _309.ProtocolVersionAmino;
            encode(message: _309.ProtocolVersion, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _309.ProtocolVersion;
            fromJSON(object: any): _309.ProtocolVersion;
            toJSON(message: _309.ProtocolVersion): import("..").JsonSafe<_309.ProtocolVersion>;
            fromPartial(object: import("../helpers").DeepPartial<_309.ProtocolVersion>): _309.ProtocolVersion;
            fromSDK(object: _309.ProtocolVersionSDKType): _309.ProtocolVersion;
            fromSDKJSON(object: any): _309.ProtocolVersionSDKType;
            toSDK(message: _309.ProtocolVersion): _309.ProtocolVersionSDKType;
            fromAmino(object: _309.ProtocolVersionAmino): _309.ProtocolVersion;
            toAmino(message: _309.ProtocolVersion): _309.ProtocolVersionAmino;
            fromAminoMsg(object: _309.ProtocolVersionAminoMsg): _309.ProtocolVersion;
            fromProtoMsg(message: _309.ProtocolVersionProtoMsg): _309.ProtocolVersion;
            toProto(message: _309.ProtocolVersion): Uint8Array;
            toProtoMsg(message: _309.ProtocolVersion): _309.ProtocolVersionProtoMsg;
            registerTypeUrl(): void;
        };
        NodeInfo: {
            typeUrl: string;
            is(o: any): o is _309.NodeInfo;
            isSDK(o: any): o is _309.NodeInfoSDKType;
            isAmino(o: any): o is _309.NodeInfoAmino;
            encode(message: _309.NodeInfo, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _309.NodeInfo;
            fromJSON(object: any): _309.NodeInfo;
            toJSON(message: _309.NodeInfo): import("..").JsonSafe<_309.NodeInfo>;
            fromPartial(object: import("../helpers").DeepPartial<_309.NodeInfo>): _309.NodeInfo;
            fromSDK(object: _309.NodeInfoSDKType): _309.NodeInfo;
            fromSDKJSON(object: any): _309.NodeInfoSDKType;
            toSDK(message: _309.NodeInfo): _309.NodeInfoSDKType;
            fromAmino(object: _309.NodeInfoAmino): _309.NodeInfo;
            toAmino(message: _309.NodeInfo): _309.NodeInfoAmino;
            fromAminoMsg(object: _309.NodeInfoAminoMsg): _309.NodeInfo;
            fromProtoMsg(message: _309.NodeInfoProtoMsg): _309.NodeInfo;
            toProto(message: _309.NodeInfo): Uint8Array;
            toProtoMsg(message: _309.NodeInfo): _309.NodeInfoProtoMsg;
            registerTypeUrl(): void;
        };
        NodeInfoOther: {
            typeUrl: string;
            is(o: any): o is _309.NodeInfoOther;
            isSDK(o: any): o is _309.NodeInfoOtherSDKType;
            isAmino(o: any): o is _309.NodeInfoOtherAmino;
            encode(message: _309.NodeInfoOther, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _309.NodeInfoOther;
            fromJSON(object: any): _309.NodeInfoOther;
            toJSON(message: _309.NodeInfoOther): import("..").JsonSafe<_309.NodeInfoOther>;
            fromPartial(object: import("../helpers").DeepPartial<_309.NodeInfoOther>): _309.NodeInfoOther;
            fromSDK(object: _309.NodeInfoOtherSDKType): _309.NodeInfoOther;
            fromSDKJSON(object: any): _309.NodeInfoOtherSDKType;
            toSDK(message: _309.NodeInfoOther): _309.NodeInfoOtherSDKType;
            fromAmino(object: _309.NodeInfoOtherAmino): _309.NodeInfoOther;
            toAmino(message: _309.NodeInfoOther): _309.NodeInfoOtherAmino;
            fromAminoMsg(object: _309.NodeInfoOtherAminoMsg): _309.NodeInfoOther;
            fromProtoMsg(message: _309.NodeInfoOtherProtoMsg): _309.NodeInfoOther;
            toProto(message: _309.NodeInfoOther): Uint8Array;
            toProtoMsg(message: _309.NodeInfoOther): _309.NodeInfoOtherProtoMsg;
            registerTypeUrl(): void;
        };
        PeerInfo: {
            typeUrl: string;
            is(o: any): o is _309.PeerInfo;
            isSDK(o: any): o is _309.PeerInfoSDKType;
            isAmino(o: any): o is _309.PeerInfoAmino;
            encode(message: _309.PeerInfo, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _309.PeerInfo;
            fromJSON(object: any): _309.PeerInfo;
            toJSON(message: _309.PeerInfo): import("..").JsonSafe<_309.PeerInfo>;
            fromPartial(object: import("../helpers").DeepPartial<_309.PeerInfo>): _309.PeerInfo;
            fromSDK(object: _309.PeerInfoSDKType): _309.PeerInfo;
            fromSDKJSON(object: any): _309.PeerInfoSDKType;
            toSDK(message: _309.PeerInfo): _309.PeerInfoSDKType;
            fromAmino(object: _309.PeerInfoAmino): _309.PeerInfo;
            toAmino(message: _309.PeerInfo): _309.PeerInfoAmino;
            fromAminoMsg(object: _309.PeerInfoAminoMsg): _309.PeerInfo;
            fromProtoMsg(message: _309.PeerInfoProtoMsg): _309.PeerInfo;
            toProto(message: _309.PeerInfo): Uint8Array;
            toProtoMsg(message: _309.PeerInfo): _309.PeerInfoProtoMsg;
            registerTypeUrl(): void;
        };
        PeerAddressInfo: {
            typeUrl: string;
            is(o: any): o is _309.PeerAddressInfo;
            isSDK(o: any): o is _309.PeerAddressInfoSDKType;
            isAmino(o: any): o is _309.PeerAddressInfoAmino;
            encode(message: _309.PeerAddressInfo, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _309.PeerAddressInfo;
            fromJSON(object: any): _309.PeerAddressInfo;
            toJSON(message: _309.PeerAddressInfo): import("..").JsonSafe<_309.PeerAddressInfo>;
            fromPartial(object: import("../helpers").DeepPartial<_309.PeerAddressInfo>): _309.PeerAddressInfo;
            fromSDK(object: _309.PeerAddressInfoSDKType): _309.PeerAddressInfo;
            fromSDKJSON(object: any): _309.PeerAddressInfoSDKType;
            toSDK(message: _309.PeerAddressInfo): _309.PeerAddressInfoSDKType;
            fromAmino(object: _309.PeerAddressInfoAmino): _309.PeerAddressInfo;
            toAmino(message: _309.PeerAddressInfo): _309.PeerAddressInfoAmino;
            fromAminoMsg(object: _309.PeerAddressInfoAminoMsg): _309.PeerAddressInfo;
            fromProtoMsg(message: _309.PeerAddressInfoProtoMsg): _309.PeerAddressInfo;
            toProto(message: _309.PeerAddressInfo): Uint8Array;
            toProtoMsg(message: _309.PeerAddressInfo): _309.PeerAddressInfoProtoMsg;
            registerTypeUrl(): void;
        };
    };
    const types: {
        protobufPackage: "tendermint.types";
        ValidatorSet: {
            typeUrl: string;
            is(o: any): o is _314.ValidatorSet;
            isSDK(o: any): o is _314.ValidatorSetSDKType;
            isAmino(o: any): o is _314.ValidatorSetAmino;
            encode(message: _314.ValidatorSet, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _314.ValidatorSet;
            fromJSON(object: any): _314.ValidatorSet;
            toJSON(message: _314.ValidatorSet): import("..").JsonSafe<_314.ValidatorSet>;
            fromPartial(object: import("../helpers").DeepPartial<_314.ValidatorSet>): _314.ValidatorSet;
            fromSDK(object: _314.ValidatorSetSDKType): _314.ValidatorSet;
            fromSDKJSON(object: any): _314.ValidatorSetSDKType;
            toSDK(message: _314.ValidatorSet): _314.ValidatorSetSDKType;
            fromAmino(object: _314.ValidatorSetAmino): _314.ValidatorSet;
            toAmino(message: _314.ValidatorSet): _314.ValidatorSetAmino;
            fromAminoMsg(object: _314.ValidatorSetAminoMsg): _314.ValidatorSet;
            fromProtoMsg(message: _314.ValidatorSetProtoMsg): _314.ValidatorSet;
            toProto(message: _314.ValidatorSet): Uint8Array;
            toProtoMsg(message: _314.ValidatorSet): _314.ValidatorSetProtoMsg;
            registerTypeUrl(): void;
        };
        Validator: {
            typeUrl: string;
            is(o: any): o is _314.Validator;
            isSDK(o: any): o is _314.ValidatorSDKType;
            isAmino(o: any): o is _314.ValidatorAmino;
            encode(message: _314.Validator, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _314.Validator;
            fromJSON(object: any): _314.Validator;
            toJSON(message: _314.Validator): import("..").JsonSafe<_314.Validator>;
            fromPartial(object: import("../helpers").DeepPartial<_314.Validator>): _314.Validator;
            fromSDK(object: _314.ValidatorSDKType): _314.Validator;
            fromSDKJSON(object: any): _314.ValidatorSDKType;
            toSDK(message: _314.Validator): _314.ValidatorSDKType;
            fromAmino(object: _314.ValidatorAmino): _314.Validator;
            toAmino(message: _314.Validator): _314.ValidatorAmino;
            fromAminoMsg(object: _314.ValidatorAminoMsg): _314.Validator;
            fromProtoMsg(message: _314.ValidatorProtoMsg): _314.Validator;
            toProto(message: _314.Validator): Uint8Array;
            toProtoMsg(message: _314.Validator): _314.ValidatorProtoMsg;
            registerTypeUrl(): void;
        };
        SimpleValidator: {
            typeUrl: string;
            is(o: any): o is _314.SimpleValidator;
            isSDK(o: any): o is _314.SimpleValidatorSDKType;
            isAmino(o: any): o is _314.SimpleValidatorAmino;
            encode(message: _314.SimpleValidator, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _314.SimpleValidator;
            fromJSON(object: any): _314.SimpleValidator;
            toJSON(message: _314.SimpleValidator): import("..").JsonSafe<_314.SimpleValidator>;
            fromPartial(object: import("../helpers").DeepPartial<_314.SimpleValidator>): _314.SimpleValidator;
            fromSDK(object: _314.SimpleValidatorSDKType): _314.SimpleValidator;
            fromSDKJSON(object: any): _314.SimpleValidatorSDKType;
            toSDK(message: _314.SimpleValidator): _314.SimpleValidatorSDKType;
            fromAmino(object: _314.SimpleValidatorAmino): _314.SimpleValidator;
            toAmino(message: _314.SimpleValidator): _314.SimpleValidatorAmino;
            fromAminoMsg(object: _314.SimpleValidatorAminoMsg): _314.SimpleValidator;
            fromProtoMsg(message: _314.SimpleValidatorProtoMsg): _314.SimpleValidator;
            toProto(message: _314.SimpleValidator): Uint8Array;
            toProtoMsg(message: _314.SimpleValidator): _314.SimpleValidatorProtoMsg;
            registerTypeUrl(): void;
        };
        blockIDFlagFromJSON(object: any): _313.BlockIDFlag;
        blockIDFlagToJSON(object: _313.BlockIDFlag): string;
        signedMsgTypeFromJSON(object: any): _313.SignedMsgType;
        signedMsgTypeToJSON(object: _313.SignedMsgType): string;
        BlockIDFlag: typeof _313.BlockIDFlag;
        BlockIDFlagSDKType: typeof _313.BlockIDFlag;
        BlockIDFlagAmino: typeof _313.BlockIDFlag;
        SignedMsgType: typeof _313.SignedMsgType;
        SignedMsgTypeSDKType: typeof _313.SignedMsgType;
        SignedMsgTypeAmino: typeof _313.SignedMsgType;
        PartSetHeader: {
            typeUrl: string;
            is(o: any): o is _313.PartSetHeader;
            isSDK(o: any): o is _313.PartSetHeaderSDKType;
            isAmino(o: any): o is _313.PartSetHeaderAmino;
            encode(message: _313.PartSetHeader, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _313.PartSetHeader;
            fromJSON(object: any): _313.PartSetHeader;
            toJSON(message: _313.PartSetHeader): import("..").JsonSafe<_313.PartSetHeader>;
            fromPartial(object: import("../helpers").DeepPartial<_313.PartSetHeader>): _313.PartSetHeader;
            fromSDK(object: _313.PartSetHeaderSDKType): _313.PartSetHeader;
            fromSDKJSON(object: any): _313.PartSetHeaderSDKType;
            toSDK(message: _313.PartSetHeader): _313.PartSetHeaderSDKType;
            fromAmino(object: _313.PartSetHeaderAmino): _313.PartSetHeader;
            toAmino(message: _313.PartSetHeader): _313.PartSetHeaderAmino;
            fromAminoMsg(object: _313.PartSetHeaderAminoMsg): _313.PartSetHeader;
            fromProtoMsg(message: _313.PartSetHeaderProtoMsg): _313.PartSetHeader;
            toProto(message: _313.PartSetHeader): Uint8Array;
            toProtoMsg(message: _313.PartSetHeader): _313.PartSetHeaderProtoMsg;
            registerTypeUrl(): void;
        };
        Part: {
            typeUrl: string;
            is(o: any): o is _313.Part;
            isSDK(o: any): o is _313.PartSDKType;
            isAmino(o: any): o is _313.PartAmino;
            encode(message: _313.Part, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _313.Part;
            fromJSON(object: any): _313.Part;
            toJSON(message: _313.Part): import("..").JsonSafe<_313.Part>;
            fromPartial(object: import("../helpers").DeepPartial<_313.Part>): _313.Part;
            fromSDK(object: _313.PartSDKType): _313.Part;
            fromSDKJSON(object: any): _313.PartSDKType;
            toSDK(message: _313.Part): _313.PartSDKType;
            fromAmino(object: _313.PartAmino): _313.Part;
            toAmino(message: _313.Part): _313.PartAmino;
            fromAminoMsg(object: _313.PartAminoMsg): _313.Part;
            fromProtoMsg(message: _313.PartProtoMsg): _313.Part;
            toProto(message: _313.Part): Uint8Array;
            toProtoMsg(message: _313.Part): _313.PartProtoMsg;
            registerTypeUrl(): void;
        };
        BlockID: {
            typeUrl: string;
            is(o: any): o is _313.BlockID;
            isSDK(o: any): o is _313.BlockIDSDKType;
            isAmino(o: any): o is _313.BlockIDAmino;
            encode(message: _313.BlockID, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _313.BlockID;
            fromJSON(object: any): _313.BlockID;
            toJSON(message: _313.BlockID): import("..").JsonSafe<_313.BlockID>;
            fromPartial(object: import("../helpers").DeepPartial<_313.BlockID>): _313.BlockID;
            fromSDK(object: _313.BlockIDSDKType): _313.BlockID;
            fromSDKJSON(object: any): _313.BlockIDSDKType;
            toSDK(message: _313.BlockID): _313.BlockIDSDKType;
            fromAmino(object: _313.BlockIDAmino): _313.BlockID;
            toAmino(message: _313.BlockID): _313.BlockIDAmino;
            fromAminoMsg(object: _313.BlockIDAminoMsg): _313.BlockID;
            fromProtoMsg(message: _313.BlockIDProtoMsg): _313.BlockID;
            toProto(message: _313.BlockID): Uint8Array;
            toProtoMsg(message: _313.BlockID): _313.BlockIDProtoMsg;
            registerTypeUrl(): void;
        };
        Header: {
            typeUrl: string;
            is(o: any): o is _313.Header;
            isSDK(o: any): o is _313.HeaderSDKType;
            isAmino(o: any): o is _313.HeaderAmino;
            encode(message: _313.Header, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _313.Header;
            fromJSON(object: any): _313.Header;
            toJSON(message: _313.Header): import("..").JsonSafe<_313.Header>;
            fromPartial(object: import("../helpers").DeepPartial<_313.Header>): _313.Header;
            fromSDK(object: _313.HeaderSDKType): _313.Header;
            fromSDKJSON(object: any): _313.HeaderSDKType;
            toSDK(message: _313.Header): _313.HeaderSDKType;
            fromAmino(object: _313.HeaderAmino): _313.Header;
            toAmino(message: _313.Header): _313.HeaderAmino;
            fromAminoMsg(object: _313.HeaderAminoMsg): _313.Header;
            fromProtoMsg(message: _313.HeaderProtoMsg): _313.Header;
            toProto(message: _313.Header): Uint8Array;
            toProtoMsg(message: _313.Header): _313.HeaderProtoMsg;
            registerTypeUrl(): void;
        };
        Data: {
            typeUrl: string;
            is(o: any): o is _313.Data;
            isSDK(o: any): o is _313.DataSDKType;
            isAmino(o: any): o is _313.DataAmino;
            encode(message: _313.Data, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _313.Data;
            fromJSON(object: any): _313.Data;
            toJSON(message: _313.Data): import("..").JsonSafe<_313.Data>;
            fromPartial(object: import("../helpers").DeepPartial<_313.Data>): _313.Data;
            fromSDK(object: _313.DataSDKType): _313.Data;
            fromSDKJSON(object: any): _313.DataSDKType;
            toSDK(message: _313.Data): _313.DataSDKType;
            fromAmino(object: _313.DataAmino): _313.Data;
            toAmino(message: _313.Data): _313.DataAmino;
            fromAminoMsg(object: _313.DataAminoMsg): _313.Data;
            fromProtoMsg(message: _313.DataProtoMsg): _313.Data;
            toProto(message: _313.Data): Uint8Array;
            toProtoMsg(message: _313.Data): _313.DataProtoMsg;
            registerTypeUrl(): void;
        };
        Vote: {
            typeUrl: string;
            is(o: any): o is _313.Vote;
            isSDK(o: any): o is _313.VoteSDKType;
            isAmino(o: any): o is _313.VoteAmino;
            encode(message: _313.Vote, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _313.Vote;
            fromJSON(object: any): _313.Vote;
            toJSON(message: _313.Vote): import("..").JsonSafe<_313.Vote>;
            fromPartial(object: import("../helpers").DeepPartial<_313.Vote>): _313.Vote;
            fromSDK(object: _313.VoteSDKType): _313.Vote;
            fromSDKJSON(object: any): _313.VoteSDKType;
            toSDK(message: _313.Vote): _313.VoteSDKType;
            fromAmino(object: _313.VoteAmino): _313.Vote;
            toAmino(message: _313.Vote): _313.VoteAmino;
            fromAminoMsg(object: _313.VoteAminoMsg): _313.Vote;
            fromProtoMsg(message: _313.VoteProtoMsg): _313.Vote;
            toProto(message: _313.Vote): Uint8Array;
            toProtoMsg(message: _313.Vote): _313.VoteProtoMsg;
            registerTypeUrl(): void;
        };
        Commit: {
            typeUrl: string;
            is(o: any): o is _313.Commit;
            isSDK(o: any): o is _313.CommitSDKType;
            isAmino(o: any): o is _313.CommitAmino;
            encode(message: _313.Commit, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _313.Commit;
            fromJSON(object: any): _313.Commit;
            toJSON(message: _313.Commit): import("..").JsonSafe<_313.Commit>;
            fromPartial(object: import("../helpers").DeepPartial<_313.Commit>): _313.Commit;
            fromSDK(object: _313.CommitSDKType): _313.Commit;
            fromSDKJSON(object: any): _313.CommitSDKType;
            toSDK(message: _313.Commit): _313.CommitSDKType;
            fromAmino(object: _313.CommitAmino): _313.Commit;
            toAmino(message: _313.Commit): _313.CommitAmino;
            fromAminoMsg(object: _313.CommitAminoMsg): _313.Commit;
            fromProtoMsg(message: _313.CommitProtoMsg): _313.Commit;
            toProto(message: _313.Commit): Uint8Array;
            toProtoMsg(message: _313.Commit): _313.CommitProtoMsg;
            registerTypeUrl(): void;
        };
        CommitSig: {
            typeUrl: string;
            is(o: any): o is _313.CommitSig;
            isSDK(o: any): o is _313.CommitSigSDKType;
            isAmino(o: any): o is _313.CommitSigAmino;
            encode(message: _313.CommitSig, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _313.CommitSig;
            fromJSON(object: any): _313.CommitSig;
            toJSON(message: _313.CommitSig): import("..").JsonSafe<_313.CommitSig>;
            fromPartial(object: import("../helpers").DeepPartial<_313.CommitSig>): _313.CommitSig;
            fromSDK(object: _313.CommitSigSDKType): _313.CommitSig;
            fromSDKJSON(object: any): _313.CommitSigSDKType;
            toSDK(message: _313.CommitSig): _313.CommitSigSDKType;
            fromAmino(object: _313.CommitSigAmino): _313.CommitSig;
            toAmino(message: _313.CommitSig): _313.CommitSigAmino;
            fromAminoMsg(object: _313.CommitSigAminoMsg): _313.CommitSig;
            fromProtoMsg(message: _313.CommitSigProtoMsg): _313.CommitSig;
            toProto(message: _313.CommitSig): Uint8Array;
            toProtoMsg(message: _313.CommitSig): _313.CommitSigProtoMsg;
            registerTypeUrl(): void;
        };
        Proposal: {
            typeUrl: string;
            is(o: any): o is _313.Proposal;
            isSDK(o: any): o is _313.ProposalSDKType;
            isAmino(o: any): o is _313.ProposalAmino;
            encode(message: _313.Proposal, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _313.Proposal;
            fromJSON(object: any): _313.Proposal;
            toJSON(message: _313.Proposal): import("..").JsonSafe<_313.Proposal>;
            fromPartial(object: import("../helpers").DeepPartial<_313.Proposal>): _313.Proposal;
            fromSDK(object: _313.ProposalSDKType): _313.Proposal;
            fromSDKJSON(object: any): _313.ProposalSDKType;
            toSDK(message: _313.Proposal): _313.ProposalSDKType;
            fromAmino(object: _313.ProposalAmino): _313.Proposal;
            toAmino(message: _313.Proposal): _313.ProposalAmino;
            fromAminoMsg(object: _313.ProposalAminoMsg): _313.Proposal;
            fromProtoMsg(message: _313.ProposalProtoMsg): _313.Proposal;
            toProto(message: _313.Proposal): Uint8Array;
            toProtoMsg(message: _313.Proposal): _313.ProposalProtoMsg;
            registerTypeUrl(): void;
        };
        SignedHeader: {
            typeUrl: string;
            is(o: any): o is _313.SignedHeader;
            isSDK(o: any): o is _313.SignedHeaderSDKType;
            isAmino(o: any): o is _313.SignedHeaderAmino;
            encode(message: _313.SignedHeader, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _313.SignedHeader;
            fromJSON(object: any): _313.SignedHeader;
            toJSON(message: _313.SignedHeader): import("..").JsonSafe<_313.SignedHeader>;
            fromPartial(object: import("../helpers").DeepPartial<_313.SignedHeader>): _313.SignedHeader;
            fromSDK(object: _313.SignedHeaderSDKType): _313.SignedHeader;
            fromSDKJSON(object: any): _313.SignedHeaderSDKType;
            toSDK(message: _313.SignedHeader): _313.SignedHeaderSDKType;
            fromAmino(object: _313.SignedHeaderAmino): _313.SignedHeader;
            toAmino(message: _313.SignedHeader): _313.SignedHeaderAmino;
            fromAminoMsg(object: _313.SignedHeaderAminoMsg): _313.SignedHeader;
            fromProtoMsg(message: _313.SignedHeaderProtoMsg): _313.SignedHeader;
            toProto(message: _313.SignedHeader): Uint8Array;
            toProtoMsg(message: _313.SignedHeader): _313.SignedHeaderProtoMsg;
            registerTypeUrl(): void;
        };
        LightBlock: {
            typeUrl: string;
            is(o: any): o is _313.LightBlock;
            isSDK(o: any): o is _313.LightBlockSDKType;
            isAmino(o: any): o is _313.LightBlockAmino;
            encode(message: _313.LightBlock, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _313.LightBlock;
            fromJSON(object: any): _313.LightBlock;
            toJSON(message: _313.LightBlock): import("..").JsonSafe<_313.LightBlock>;
            fromPartial(object: import("../helpers").DeepPartial<_313.LightBlock>): _313.LightBlock;
            fromSDK(object: _313.LightBlockSDKType): _313.LightBlock;
            fromSDKJSON(object: any): _313.LightBlockSDKType;
            toSDK(message: _313.LightBlock): _313.LightBlockSDKType;
            fromAmino(object: _313.LightBlockAmino): _313.LightBlock;
            toAmino(message: _313.LightBlock): _313.LightBlockAmino;
            fromAminoMsg(object: _313.LightBlockAminoMsg): _313.LightBlock;
            fromProtoMsg(message: _313.LightBlockProtoMsg): _313.LightBlock;
            toProto(message: _313.LightBlock): Uint8Array;
            toProtoMsg(message: _313.LightBlock): _313.LightBlockProtoMsg;
            registerTypeUrl(): void;
        };
        BlockMeta: {
            typeUrl: string;
            is(o: any): o is _313.BlockMeta;
            isSDK(o: any): o is _313.BlockMetaSDKType;
            isAmino(o: any): o is _313.BlockMetaAmino;
            encode(message: _313.BlockMeta, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _313.BlockMeta;
            fromJSON(object: any): _313.BlockMeta;
            toJSON(message: _313.BlockMeta): import("..").JsonSafe<_313.BlockMeta>;
            fromPartial(object: import("../helpers").DeepPartial<_313.BlockMeta>): _313.BlockMeta;
            fromSDK(object: _313.BlockMetaSDKType): _313.BlockMeta;
            fromSDKJSON(object: any): _313.BlockMetaSDKType;
            toSDK(message: _313.BlockMeta): _313.BlockMetaSDKType;
            fromAmino(object: _313.BlockMetaAmino): _313.BlockMeta;
            toAmino(message: _313.BlockMeta): _313.BlockMetaAmino;
            fromAminoMsg(object: _313.BlockMetaAminoMsg): _313.BlockMeta;
            fromProtoMsg(message: _313.BlockMetaProtoMsg): _313.BlockMeta;
            toProto(message: _313.BlockMeta): Uint8Array;
            toProtoMsg(message: _313.BlockMeta): _313.BlockMetaProtoMsg;
            registerTypeUrl(): void;
        };
        TxProof: {
            typeUrl: string;
            is(o: any): o is _313.TxProof;
            isSDK(o: any): o is _313.TxProofSDKType;
            isAmino(o: any): o is _313.TxProofAmino;
            encode(message: _313.TxProof, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _313.TxProof;
            fromJSON(object: any): _313.TxProof;
            toJSON(message: _313.TxProof): import("..").JsonSafe<_313.TxProof>;
            fromPartial(object: import("../helpers").DeepPartial<_313.TxProof>): _313.TxProof;
            fromSDK(object: _313.TxProofSDKType): _313.TxProof;
            fromSDKJSON(object: any): _313.TxProofSDKType;
            toSDK(message: _313.TxProof): _313.TxProofSDKType;
            fromAmino(object: _313.TxProofAmino): _313.TxProof;
            toAmino(message: _313.TxProof): _313.TxProofAmino;
            fromAminoMsg(object: _313.TxProofAminoMsg): _313.TxProof;
            fromProtoMsg(message: _313.TxProofProtoMsg): _313.TxProof;
            toProto(message: _313.TxProof): Uint8Array;
            toProtoMsg(message: _313.TxProof): _313.TxProofProtoMsg;
            registerTypeUrl(): void;
        };
        ConsensusParams: {
            typeUrl: string;
            is(o: any): o is _312.ConsensusParams;
            isSDK(o: any): o is _312.ConsensusParamsSDKType;
            isAmino(o: any): o is _312.ConsensusParamsAmino;
            encode(message: _312.ConsensusParams, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _312.ConsensusParams;
            fromJSON(object: any): _312.ConsensusParams;
            toJSON(message: _312.ConsensusParams): import("..").JsonSafe<_312.ConsensusParams>;
            fromPartial(object: import("../helpers").DeepPartial<_312.ConsensusParams>): _312.ConsensusParams;
            fromSDK(object: _312.ConsensusParamsSDKType): _312.ConsensusParams;
            fromSDKJSON(object: any): _312.ConsensusParamsSDKType;
            toSDK(message: _312.ConsensusParams): _312.ConsensusParamsSDKType;
            fromAmino(object: _312.ConsensusParamsAmino): _312.ConsensusParams;
            toAmino(message: _312.ConsensusParams): _312.ConsensusParamsAmino;
            fromAminoMsg(object: _312.ConsensusParamsAminoMsg): _312.ConsensusParams;
            fromProtoMsg(message: _312.ConsensusParamsProtoMsg): _312.ConsensusParams;
            toProto(message: _312.ConsensusParams): Uint8Array;
            toProtoMsg(message: _312.ConsensusParams): _312.ConsensusParamsProtoMsg;
            registerTypeUrl(): void;
        };
        BlockParams: {
            typeUrl: string;
            is(o: any): o is _312.BlockParams;
            isSDK(o: any): o is _312.BlockParamsSDKType;
            isAmino(o: any): o is _312.BlockParamsAmino;
            encode(message: _312.BlockParams, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _312.BlockParams;
            fromJSON(object: any): _312.BlockParams;
            toJSON(message: _312.BlockParams): import("..").JsonSafe<_312.BlockParams>;
            fromPartial(object: import("../helpers").DeepPartial<_312.BlockParams>): _312.BlockParams;
            fromSDK(object: _312.BlockParamsSDKType): _312.BlockParams;
            fromSDKJSON(object: any): _312.BlockParamsSDKType;
            toSDK(message: _312.BlockParams): _312.BlockParamsSDKType;
            fromAmino(object: _312.BlockParamsAmino): _312.BlockParams;
            toAmino(message: _312.BlockParams): _312.BlockParamsAmino;
            fromAminoMsg(object: _312.BlockParamsAminoMsg): _312.BlockParams;
            fromProtoMsg(message: _312.BlockParamsProtoMsg): _312.BlockParams;
            toProto(message: _312.BlockParams): Uint8Array;
            toProtoMsg(message: _312.BlockParams): _312.BlockParamsProtoMsg;
            registerTypeUrl(): void;
        };
        EvidenceParams: {
            typeUrl: string;
            is(o: any): o is _312.EvidenceParams;
            isSDK(o: any): o is _312.EvidenceParamsSDKType;
            isAmino(o: any): o is _312.EvidenceParamsAmino;
            encode(message: _312.EvidenceParams, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _312.EvidenceParams;
            fromJSON(object: any): _312.EvidenceParams;
            toJSON(message: _312.EvidenceParams): import("..").JsonSafe<_312.EvidenceParams>;
            fromPartial(object: import("../helpers").DeepPartial<_312.EvidenceParams>): _312.EvidenceParams;
            fromSDK(object: _312.EvidenceParamsSDKType): _312.EvidenceParams;
            fromSDKJSON(object: any): _312.EvidenceParamsSDKType;
            toSDK(message: _312.EvidenceParams): _312.EvidenceParamsSDKType;
            fromAmino(object: _312.EvidenceParamsAmino): _312.EvidenceParams;
            toAmino(message: _312.EvidenceParams): _312.EvidenceParamsAmino;
            fromAminoMsg(object: _312.EvidenceParamsAminoMsg): _312.EvidenceParams;
            fromProtoMsg(message: _312.EvidenceParamsProtoMsg): _312.EvidenceParams;
            toProto(message: _312.EvidenceParams): Uint8Array;
            toProtoMsg(message: _312.EvidenceParams): _312.EvidenceParamsProtoMsg;
            registerTypeUrl(): void;
        };
        ValidatorParams: {
            typeUrl: string;
            is(o: any): o is _312.ValidatorParams;
            isSDK(o: any): o is _312.ValidatorParamsSDKType;
            isAmino(o: any): o is _312.ValidatorParamsAmino;
            encode(message: _312.ValidatorParams, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _312.ValidatorParams;
            fromJSON(object: any): _312.ValidatorParams;
            toJSON(message: _312.ValidatorParams): import("..").JsonSafe<_312.ValidatorParams>;
            fromPartial(object: import("../helpers").DeepPartial<_312.ValidatorParams>): _312.ValidatorParams;
            fromSDK(object: _312.ValidatorParamsSDKType): _312.ValidatorParams;
            fromSDKJSON(object: any): _312.ValidatorParamsSDKType;
            toSDK(message: _312.ValidatorParams): _312.ValidatorParamsSDKType;
            fromAmino(object: _312.ValidatorParamsAmino): _312.ValidatorParams;
            toAmino(message: _312.ValidatorParams): _312.ValidatorParamsAmino;
            fromAminoMsg(object: _312.ValidatorParamsAminoMsg): _312.ValidatorParams;
            fromProtoMsg(message: _312.ValidatorParamsProtoMsg): _312.ValidatorParams;
            toProto(message: _312.ValidatorParams): Uint8Array;
            toProtoMsg(message: _312.ValidatorParams): _312.ValidatorParamsProtoMsg;
            registerTypeUrl(): void;
        };
        VersionParams: {
            typeUrl: string;
            is(o: any): o is _312.VersionParams;
            isSDK(o: any): o is _312.VersionParamsSDKType;
            isAmino(o: any): o is _312.VersionParamsAmino;
            encode(message: _312.VersionParams, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _312.VersionParams;
            fromJSON(object: any): _312.VersionParams;
            toJSON(message: _312.VersionParams): import("..").JsonSafe<_312.VersionParams>;
            fromPartial(object: import("../helpers").DeepPartial<_312.VersionParams>): _312.VersionParams;
            fromSDK(object: _312.VersionParamsSDKType): _312.VersionParams;
            fromSDKJSON(object: any): _312.VersionParamsSDKType;
            toSDK(message: _312.VersionParams): _312.VersionParamsSDKType;
            fromAmino(object: _312.VersionParamsAmino): _312.VersionParams;
            toAmino(message: _312.VersionParams): _312.VersionParamsAmino;
            fromAminoMsg(object: _312.VersionParamsAminoMsg): _312.VersionParams;
            fromProtoMsg(message: _312.VersionParamsProtoMsg): _312.VersionParams;
            toProto(message: _312.VersionParams): Uint8Array;
            toProtoMsg(message: _312.VersionParams): _312.VersionParamsProtoMsg;
            registerTypeUrl(): void;
        };
        HashedParams: {
            typeUrl: string;
            is(o: any): o is _312.HashedParams;
            isSDK(o: any): o is _312.HashedParamsSDKType;
            isAmino(o: any): o is _312.HashedParamsAmino;
            encode(message: _312.HashedParams, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _312.HashedParams;
            fromJSON(object: any): _312.HashedParams;
            toJSON(message: _312.HashedParams): import("..").JsonSafe<_312.HashedParams>;
            fromPartial(object: import("../helpers").DeepPartial<_312.HashedParams>): _312.HashedParams;
            fromSDK(object: _312.HashedParamsSDKType): _312.HashedParams;
            fromSDKJSON(object: any): _312.HashedParamsSDKType;
            toSDK(message: _312.HashedParams): _312.HashedParamsSDKType;
            fromAmino(object: _312.HashedParamsAmino): _312.HashedParams;
            toAmino(message: _312.HashedParams): _312.HashedParamsAmino;
            fromAminoMsg(object: _312.HashedParamsAminoMsg): _312.HashedParams;
            fromProtoMsg(message: _312.HashedParamsProtoMsg): _312.HashedParams;
            toProto(message: _312.HashedParams): Uint8Array;
            toProtoMsg(message: _312.HashedParams): _312.HashedParamsProtoMsg;
            registerTypeUrl(): void;
        };
        Evidence: {
            typeUrl: string;
            is(o: any): o is _311.Evidence;
            isSDK(o: any): o is _311.EvidenceSDKType;
            isAmino(o: any): o is _311.EvidenceAmino;
            encode(message: _311.Evidence, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _311.Evidence;
            fromJSON(object: any): _311.Evidence;
            toJSON(message: _311.Evidence): import("..").JsonSafe<_311.Evidence>;
            fromPartial(object: import("../helpers").DeepPartial<_311.Evidence>): _311.Evidence;
            fromSDK(object: _311.EvidenceSDKType): _311.Evidence;
            fromSDKJSON(object: any): _311.EvidenceSDKType;
            toSDK(message: _311.Evidence): _311.EvidenceSDKType;
            fromAmino(object: _311.EvidenceAmino): _311.Evidence;
            toAmino(message: _311.Evidence): _311.EvidenceAmino;
            fromAminoMsg(object: _311.EvidenceAminoMsg): _311.Evidence;
            fromProtoMsg(message: _311.EvidenceProtoMsg): _311.Evidence;
            toProto(message: _311.Evidence): Uint8Array;
            toProtoMsg(message: _311.Evidence): _311.EvidenceProtoMsg;
            registerTypeUrl(): void;
        };
        DuplicateVoteEvidence: {
            typeUrl: string;
            is(o: any): o is _311.DuplicateVoteEvidence;
            isSDK(o: any): o is _311.DuplicateVoteEvidenceSDKType;
            isAmino(o: any): o is _311.DuplicateVoteEvidenceAmino;
            encode(message: _311.DuplicateVoteEvidence, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _311.DuplicateVoteEvidence;
            fromJSON(object: any): _311.DuplicateVoteEvidence;
            toJSON(message: _311.DuplicateVoteEvidence): import("..").JsonSafe<_311.DuplicateVoteEvidence>;
            fromPartial(object: import("../helpers").DeepPartial<_311.DuplicateVoteEvidence>): _311.DuplicateVoteEvidence;
            fromSDK(object: _311.DuplicateVoteEvidenceSDKType): _311.DuplicateVoteEvidence;
            fromSDKJSON(object: any): _311.DuplicateVoteEvidenceSDKType;
            toSDK(message: _311.DuplicateVoteEvidence): _311.DuplicateVoteEvidenceSDKType;
            fromAmino(object: _311.DuplicateVoteEvidenceAmino): _311.DuplicateVoteEvidence;
            toAmino(message: _311.DuplicateVoteEvidence): _311.DuplicateVoteEvidenceAmino;
            fromAminoMsg(object: _311.DuplicateVoteEvidenceAminoMsg): _311.DuplicateVoteEvidence;
            fromProtoMsg(message: _311.DuplicateVoteEvidenceProtoMsg): _311.DuplicateVoteEvidence;
            toProto(message: _311.DuplicateVoteEvidence): Uint8Array;
            toProtoMsg(message: _311.DuplicateVoteEvidence): _311.DuplicateVoteEvidenceProtoMsg;
            registerTypeUrl(): void;
        };
        LightClientAttackEvidence: {
            typeUrl: string;
            is(o: any): o is _311.LightClientAttackEvidence;
            isSDK(o: any): o is _311.LightClientAttackEvidenceSDKType;
            isAmino(o: any): o is _311.LightClientAttackEvidenceAmino;
            encode(message: _311.LightClientAttackEvidence, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _311.LightClientAttackEvidence;
            fromJSON(object: any): _311.LightClientAttackEvidence;
            toJSON(message: _311.LightClientAttackEvidence): import("..").JsonSafe<_311.LightClientAttackEvidence>;
            fromPartial(object: import("../helpers").DeepPartial<_311.LightClientAttackEvidence>): _311.LightClientAttackEvidence;
            fromSDK(object: _311.LightClientAttackEvidenceSDKType): _311.LightClientAttackEvidence;
            fromSDKJSON(object: any): _311.LightClientAttackEvidenceSDKType;
            toSDK(message: _311.LightClientAttackEvidence): _311.LightClientAttackEvidenceSDKType;
            fromAmino(object: _311.LightClientAttackEvidenceAmino): _311.LightClientAttackEvidence;
            toAmino(message: _311.LightClientAttackEvidence): _311.LightClientAttackEvidenceAmino;
            fromAminoMsg(object: _311.LightClientAttackEvidenceAminoMsg): _311.LightClientAttackEvidence;
            fromProtoMsg(message: _311.LightClientAttackEvidenceProtoMsg): _311.LightClientAttackEvidence;
            toProto(message: _311.LightClientAttackEvidence): Uint8Array;
            toProtoMsg(message: _311.LightClientAttackEvidence): _311.LightClientAttackEvidenceProtoMsg;
            registerTypeUrl(): void;
        };
        EvidenceList: {
            typeUrl: string;
            is(o: any): o is _311.EvidenceList;
            isSDK(o: any): o is _311.EvidenceListSDKType;
            isAmino(o: any): o is _311.EvidenceListAmino;
            encode(message: _311.EvidenceList, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _311.EvidenceList;
            fromJSON(object: any): _311.EvidenceList;
            toJSON(message: _311.EvidenceList): import("..").JsonSafe<_311.EvidenceList>;
            fromPartial(object: import("../helpers").DeepPartial<_311.EvidenceList>): _311.EvidenceList;
            fromSDK(object: _311.EvidenceListSDKType): _311.EvidenceList;
            fromSDKJSON(object: any): _311.EvidenceListSDKType;
            toSDK(message: _311.EvidenceList): _311.EvidenceListSDKType;
            fromAmino(object: _311.EvidenceListAmino): _311.EvidenceList;
            toAmino(message: _311.EvidenceList): _311.EvidenceListAmino;
            fromAminoMsg(object: _311.EvidenceListAminoMsg): _311.EvidenceList;
            fromProtoMsg(message: _311.EvidenceListProtoMsg): _311.EvidenceList;
            toProto(message: _311.EvidenceList): Uint8Array;
            toProtoMsg(message: _311.EvidenceList): _311.EvidenceListProtoMsg;
            registerTypeUrl(): void;
        };
        Block: {
            typeUrl: string;
            is(o: any): o is _310.Block;
            isSDK(o: any): o is _310.BlockSDKType;
            isAmino(o: any): o is _310.BlockAmino;
            encode(message: _310.Block, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _310.Block;
            fromJSON(object: any): _310.Block;
            toJSON(message: _310.Block): import("..").JsonSafe<_310.Block>;
            fromPartial(object: import("../helpers").DeepPartial<_310.Block>): _310.Block;
            fromSDK(object: _310.BlockSDKType): _310.Block;
            fromSDKJSON(object: any): _310.BlockSDKType;
            toSDK(message: _310.Block): _310.BlockSDKType;
            fromAmino(object: _310.BlockAmino): _310.Block;
            toAmino(message: _310.Block): _310.BlockAmino;
            fromAminoMsg(object: _310.BlockAminoMsg): _310.Block;
            fromProtoMsg(message: _310.BlockProtoMsg): _310.Block;
            toProto(message: _310.Block): Uint8Array;
            toProtoMsg(message: _310.Block): _310.BlockProtoMsg;
            registerTypeUrl(): void;
        };
    };
    const version: {
        protobufPackage: "tendermint.version";
        App: {
            typeUrl: string;
            is(o: any): o is _315.App;
            isSDK(o: any): o is _315.AppSDKType;
            isAmino(o: any): o is _315.AppAmino;
            encode(message: _315.App, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _315.App;
            fromJSON(object: any): _315.App;
            toJSON(message: _315.App): import("..").JsonSafe<_315.App>;
            fromPartial(object: import("../helpers").DeepPartial<_315.App>): _315.App;
            fromSDK(object: _315.AppSDKType): _315.App;
            fromSDKJSON(object: any): _315.AppSDKType;
            toSDK(message: _315.App): _315.AppSDKType;
            fromAmino(object: _315.AppAmino): _315.App;
            toAmino(message: _315.App): _315.AppAmino;
            fromAminoMsg(object: _315.AppAminoMsg): _315.App;
            fromProtoMsg(message: _315.AppProtoMsg): _315.App;
            toProto(message: _315.App): Uint8Array;
            toProtoMsg(message: _315.App): _315.AppProtoMsg;
            registerTypeUrl(): void;
        };
        Consensus: {
            typeUrl: string;
            is(o: any): o is _315.Consensus;
            isSDK(o: any): o is _315.ConsensusSDKType;
            isAmino(o: any): o is _315.ConsensusAmino;
            encode(message: _315.Consensus, writer?: import("..").BinaryWriter): import("..").BinaryWriter;
            decode(input: import("..").BinaryReader | Uint8Array, length?: number): _315.Consensus;
            fromJSON(object: any): _315.Consensus;
            toJSON(message: _315.Consensus): import("..").JsonSafe<_315.Consensus>;
            fromPartial(object: import("../helpers").DeepPartial<_315.Consensus>): _315.Consensus;
            fromSDK(object: _315.ConsensusSDKType): _315.Consensus;
            fromSDKJSON(object: any): _315.ConsensusSDKType;
            toSDK(message: _315.Consensus): _315.ConsensusSDKType;
            fromAmino(object: _315.ConsensusAmino): _315.Consensus;
            toAmino(message: _315.Consensus): _315.ConsensusAmino;
            fromAminoMsg(object: _315.ConsensusAminoMsg): _315.Consensus;
            fromProtoMsg(message: _315.ConsensusProtoMsg): _315.Consensus;
            toProto(message: _315.Consensus): Uint8Array;
            toProtoMsg(message: _315.Consensus): _315.ConsensusProtoMsg;
            registerTypeUrl(): void;
        };
    };
    const ClientFactory: {
        createRPCQueryClient: ({ rpc }: {
            rpc: import("../helpers").Rpc;
        }) => Promise<{
            cosmos: {
                app: {
                    v1alpha1: import("../cosmos/app/v1alpha1/query.rpc.Query").QueryClientImpl;
                };
                auth: {
                    v1beta1: import("../cosmos/auth/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                authz: {
                    v1beta1: import("../cosmos/authz/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                bank: {
                    v1beta1: import("../cosmos/bank/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                base: {
                    reflection: {
                        v1beta1: import("../cosmos/base/reflection/v1beta1/reflection.rpc.ReflectionService").ReflectionServiceClientImpl;
                        v2alpha1: import("../cosmos/base/reflection/v2alpha1/reflection.rpc.ReflectionService").ReflectionServiceClientImpl;
                    };
                    tendermint: {
                        v1beta1: import("../cosmos/base/tendermint/v1beta1/query.rpc.Service").ServiceClientImpl;
                    };
                };
                distribution: {
                    v1beta1: import("../cosmos/distribution/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                evidence: {
                    v1beta1: import("../cosmos/evidence/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                feegrant: {
                    v1beta1: import("../cosmos/feegrant/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                gov: {
                    v1: import("../cosmos/gov/v1/query.rpc.Query").QueryClientImpl;
                    v1beta1: import("../cosmos/gov/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                group: {
                    v1: import("../cosmos/group/v1/query.rpc.Query").QueryClientImpl;
                };
                mint: {
                    v1beta1: import("../cosmos/mint/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                nft: {
                    v1beta1: import("../cosmos/nft/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                params: {
                    v1beta1: import("../cosmos/params/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                slashing: {
                    v1beta1: import("../cosmos/slashing/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                staking: {
                    v1beta1: import("../cosmos/staking/v1beta1/query.rpc.Query").QueryClientImpl;
                };
                tx: {
                    v1beta1: import("../cosmos/tx/v1beta1/service.rpc.Service").ServiceClientImpl;
                };
                upgrade: {
                    v1beta1: import("../cosmos/upgrade/v1beta1/query.rpc.Query").QueryClientImpl;
                };
            };
            tendermint: {
                abci: _537.ABCIApplicationClientImpl;
            };
        }>;
        createLCDClient: ({ restEndpoint }: {
            restEndpoint: string;
        }) => Promise<{
            cosmos: {
                auth: {
                    v1beta1: import("../cosmos/auth/v1beta1/query.lcd").LCDQueryClient;
                };
                authz: {
                    v1beta1: import("../cosmos/authz/v1beta1/query.lcd").LCDQueryClient;
                };
                bank: {
                    v1beta1: import("../cosmos/bank/v1beta1/query.lcd").LCDQueryClient;
                };
                base: {
                    reflection: {
                        v1beta1: import("../cosmos/base/reflection/v1beta1/reflection.lcd").LCDQueryClient;
                        v2alpha1: import("../cosmos/base/reflection/v2alpha1/reflection.lcd").LCDQueryClient;
                    };
                    tendermint: {
                        v1beta1: import("../cosmos/base/tendermint/v1beta1/query.lcd").LCDQueryClient;
                    };
                };
                distribution: {
                    v1beta1: import("../cosmos/distribution/v1beta1/query.lcd").LCDQueryClient;
                };
                evidence: {
                    v1beta1: import("../cosmos/evidence/v1beta1/query.lcd").LCDQueryClient;
                };
                feegrant: {
                    v1beta1: import("../cosmos/feegrant/v1beta1/query.lcd").LCDQueryClient;
                };
                gov: {
                    v1: import("../cosmos/gov/v1/query.lcd").LCDQueryClient;
                    v1beta1: import("../cosmos/gov/v1beta1/query.lcd").LCDQueryClient;
                };
                group: {
                    v1: import("../cosmos/group/v1/query.lcd").LCDQueryClient;
                };
                mint: {
                    v1beta1: import("../cosmos/mint/v1beta1/query.lcd").LCDQueryClient;
                };
                nft: {
                    v1beta1: import("../cosmos/nft/v1beta1/query.lcd").LCDQueryClient;
                };
                params: {
                    v1beta1: import("../cosmos/params/v1beta1/query.lcd").LCDQueryClient;
                };
                slashing: {
                    v1beta1: import("../cosmos/slashing/v1beta1/query.lcd").LCDQueryClient;
                };
                staking: {
                    v1beta1: import("../cosmos/staking/v1beta1/query.lcd").LCDQueryClient;
                };
                tx: {
                    v1beta1: import("../cosmos/tx/v1beta1/service.lcd").LCDQueryClient;
                };
                upgrade: {
                    v1beta1: import("../cosmos/upgrade/v1beta1/query.lcd").LCDQueryClient;
                };
            };
        }>;
    };
}
